/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 *
 */


#include <alias.h>
#include <confvars.h>
#include <varnamel.h>
#include <lists.h>
#include <wildcard.h>
#include <routine.h>
#include <vdiutil.h>
#include <portvdi.h>
#include <mtappl.h>
#include <mtutils.h>

LOCAL List aliasGroups;

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

LOCAL _VOID Alias_Free(_VOID *entry)
{
	SFREE(entry);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID Alias_DeleteList(_BOOL killCarrier)
{
	Lists_DeleteSimpleList(&aliasGroups, Alias_Free, killCarrier);
}


/*** ---------------------------------------------------------------------- ***/

/*es mu ja nicht sein, da man 500 mal hintereinander die gleiche Variable sucht*/
GLOBAL _BOOL Alias_ShowAlias(CONST _UBYTE *groupName, _BOOL test)
{
	_UBYTE *entry;
	
	_BOOL aliasNames=TRUE;
	if(test)
		ConfVars_GetConfDefBool(cShowAliasNames, &aliasNames, FALSE);
	if (!aliasNames)
		return FALSE;
	Lists_ResetList(&aliasGroups);
	while ((entry = Lists_NextEntry(&aliasGroups)) != NULL)
	{
		if (*entry != '!')
		{
			if (WildCards_MatchName(groupName, entry, TRUE))
			{
				Lists_ResetList(&aliasGroups);
				while ((entry = Lists_NextEntry(&aliasGroups)) != NULL)
				{
					if (*entry == '!')
						if (WildCards_MatchName(groupName, entry + 1, TRUE))
							return FALSE;
				}
				return TRUE;
			}
		}
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

/*DYJ 5.26c */
GLOBAL _VOID Alias_Setnames(group *groups, GROUPNR numGroups)
{
	GROUPNR i;
	group *gr;
	_BOOL aliasNames=TRUE;
	ConfVars_GetConfDefBool(cShowAliasNames, &aliasNames, FALSE);

	for (i = 0, gr = groups; i < numGroups; i++, gr++)
	{
		if (gr->alias != NULL && aliasNames && Alias_ShowAlias(gr->name,FALSE))
			gr->display_name = gr->alias;
		else
			gr->display_name = gr->name;
	}
}


/*** ---------------------------------------------------------------------- ***/

GLOBAL List *Alias_GetList(_VOID)
{
	return &aliasGroups;
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

GLOBAL _BOOL Alias_Init(_VOID)
{
	_WORD i;
	_UBYTE varName[128];
	_UBYTE group[256];
	_UBYTE *pattern;
	
	i = 0;
	Lists_CreateList(&aliasGroups, "Alias_Init: list");
	for (;;)
	{
		make_varname(varName, sizeof(varName), cShowAliasName, i);
		if (!ConfVars_GetConfigString(varName, group, sizeof(group)))
			break;
		pattern = STRDUP(group, "Alias_Init");
		if (pattern == NULL)
			return FALSE;
		if (!Lists_AppendEntry(&aliasGroups, pattern))
		{
			SFREE(pattern);
			return FALSE;
		}
		i++;
	}
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID Alias_Exit(_VOID)
{
	Alias_DeleteList(TRUE);
}
