/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */


#include <arcass.h>
#include <osbind.h>
#include <magicsys.h>
#include <atari.h>

LOCAL outProcType outProc;
LOCAL _VOID (*saveProc)(_VOID);
LOCAL _LONG (*savenstat2)(_VOID);
LOCAL _LONG (*savenstat5)(_VOID);
LOCAL _LONG (*savein2)(_VOID);
LOCAL _LONG (*savein5)(_VOID);
LOCAL _LONG (*savestat2)(_VOID);
LOCAL _LONG (*savestat5)(_VOID);
LOCAL _LONG __CDECL (*saveout2)(_WORD dev, _WORD c);
LOCAL _LONG __CDECL (*saveout5)(_WORD dev, _WORD c);

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

/*
 * Es liegt nie ein Zeichen an. 
 * als Long wegen $%&@ HSMODEM1
 */
LOCAL _LONG newnstat(_VOID)
{
	return 0;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _LONG newin(_VOID)
{
	return 0;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _LONG newstat(_VOID)
{
	return -1;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _LONG __CDECL newout(_WORD dev, _WORD c)
{
	UNUSED(dev);
#ifdef __GNUC__
	__asm__ volatile ("\
	movew sp@(6),%0"
	: "=g"(c)		/* outputs */
	:				/* no inputs */
	);
#endif
	outProc(c);
	return 1;
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

/* BIOS-Traphandler fuer TOS 1.00 */

#ifdef __PUREC__

LOCAL _VOID *getusp(_VOID) 0x4e68;		/* move.l usp,a0 */
LOCAL _VOID movem1(_VOID) 0x48e7;
LOCAL _VOID movem2(_VOID) 0x60c0;		/* movem.l d1-d2/a0-a1,-(a7) */
LOCAL _VOID getsp1(_VOID) 0x41ef;
LOCAL _UWORD *getsp2(_VOID) 0x0014;		/* lea 20(a7),a0 */
#define getsp() (movem1(), movem2(), getsp1(), getsp2())
LOCAL _VOID rte3(_VOID) 0x245f;			/* move.l (a7)+,a2 */
LOCAL _VOID rte1(_VOID) 0x4cdf;
LOCAL _VOID rte2(_VOID) 0x0306;			/* movem.l (a7)+,d1-d2/a0-a1 */
LOCAL _VOID rte5(_LONG ret) 0x4e73;		/* rte */
LOCAL _VOID pascal rte6(_VOID *) 0x4e71;/* move.l a0,-(a7) */
LOCAL _VOID rte7(_VOID) 0x4e75;			/* rts */
#define rte(ret) (rte1(), rte2(), rte3(), rte5(ret))
#define rts(ret) (rte1(), rte2(), rte3(), rte6(ret), rte7())


LOCAL _VOID TrapProc(_VOID)
{
	_UWORD *args;
	_UWORD *sp;
	
	sp = getsp();
	if (*sp & 0x2000)
	{
		args = sp + 3;
		if (*((_WORD *)0x59e) != 0)
			args++;
	} else
	{
		args = getusp();
	}
	switch (args[0])
	{
	case 1:	/* Bconstat */
		if (args[1] == 2 || args[1] == 5)
		{
			rte(0);
		}
		break;
	case 2:	/* Bconin */
		if (args[1] == 2 || args[1] == 5)
		{
			rte(0);
		}
		break;
	case 3:	/* Bconout */
		if (args[1] == 2 || args[1] == 5)
		{
			outProc(args[2]);
			rte(0);
		}
		break;
	case 8:	/* Bcostat */
		if (args[1] == 2 || args[1] == 5)
		{
			rte(-1);
		}
		break;
	}
	rts(saveProc);
}
#endif /* __PUREC__ */


#ifdef __GNUC__
#ifdef atarist

static __inline__ _UWORD *getusp(void)
{
	register _UWORD *sp;
	
	__asm__ volatile ("\
	movl usp,%0 "
	: "=r"(sp)		/* outputs */
	:				/* no inputs */
	);
	return sp;
}

static __inline__ _UWORD *getsp(void)
{
	register _UWORD *sp;
	
	__asm__ volatile ("\
	movl sp,%0 "
	: "=r"(sp)		/* outputs */
	:				/* no inputs */
	);
	return sp;
}

static __inline__ void rte(_LONG ret)
{
	register _LONG _ret __asm__("d0");
	
	__asm__ volatile("movl %1,%0; rte" : "=r"(_ret) : "g"(ret));
}


static __inline__ void rts(_VOID (*func)(_VOID))
{
	register _LONG _func __asm__("a0");
	
	__asm__ volatile("movl %1,%0; movl %0,sp@-; rts" : "=r"(_func) : "g"(func));
}

LOCAL _VOID TrapProc(_VOID)
{
	_UWORD *args;
	
	args = getsp();
	if (*args & 0x2000)
	{
		args += 3;
		if (*((_WORD *)0x59e) != 0)
			args++;
	} else
	{
		args = getusp();
	}
	switch (args[0])
	{
	case 1:	/* Bconstat */
		if (args[1] == 2 || args[1] == 5)
		{
			rte(0);
		}
		break;
	case 2:	/* Bconin */
		if (args[1] == 2 || args[1] == 5)
		{
			rte(0);
		}
		break;
	case 3:	/* Bconout */
		if (args[1] == 2 || args[1] == 5)
		{
			outProc(args[2]);
			rte(0);
		}
		break;
	case 8:	/* Bcostat */
		if (args[1] == 2 || args[1] == 5)
		{
			rte(-1);
		}
		break;
	}
	rts(saveProc);
}
#else
LOCAL _VOID TrapProc(_VOID)
{
}
#endif
#endif /* __GNUC__ */

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

LOCAL _VOID noOutput(_UBYTE c)
{
	UNUSED(c);
}

/*** ---------------------------------------------------------------------- ***/

/* Setzt die Ausgabeprozedur fuer die Ausgabeumlenkung
 */
GLOBAL _VOID ARCAss_SetOutputProc(outProcType p)
{
	outProc = p;
}

/*** ---------------------------------------------------------------------- ***/

/* Loescht eine ggf. gesetzte Ausgabeprozedur
 */
GLOBAL _VOID ARCAss_ClearOutputProc(_VOID)
{
	outProc = noOutput;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _LONG install_xcon(_VOID)
{
	_LONG (*(*xconstat))(_VOID);
	_LONG (*(*xconin))(_VOID);
	_LONG (*(*xcostat))(_VOID);
	_LONG (__CDECL *(*xconout))(_WORD dev, _WORD c);

	xconstat = (_LONG (*(*))(_VOID))0x51e;
	savenstat2 = xconstat[2];
	savenstat5 = xconstat[5];
	xconstat[2] = newnstat;
	xconstat[5] = newnstat;
	xconin = (_LONG (*(*))(_VOID))0x53e;
	savein2 = xconin[2];
	savein5 = xconin[5];
	xconin[2] = newin;
	xconin[5] = newin;
	xcostat = (_LONG (*(*))(_VOID))0x55e;
	savestat2 = xcostat[2];
	savestat5 = xcostat[5];
	xcostat[2] = newstat;
	xcostat[5] = newstat;
	xconout = (_LONG __CDECL (*(*))(_WORD dev, _WORD c))0x57e;
	saveout2 = xconout[2];
	saveout5 = xconout[5];
	xconout[2] = newout;
	xconout[5] = newout;
	return 0;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _BOOL ARCAss_SetTrap(_VOID)
{
	if (CanDoSuper())
	{
		ARCAss_ClearOutputProc();
		/* TOS 1.00? */
		if (TosVersion() == 0x100)
		{
			/* ja, BIOS-Trap installieren */
			saveProc = Setexc(45, TrapProc);
		} else
		{
			/* Installation in xcon-Vektoren */
			Supexec(install_xcon);
		}
		return TRUE;
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _LONG deinstall_xcon(_VOID)
{
	_LONG (*(*xconstat))(_VOID);
	_LONG (*(*xconin))(_VOID);
	_LONG (*(*xcostat))(_VOID);
	_LONG __CDECL (*(*xconout))(_WORD dev, _WORD c);
	
	xconstat = (_LONG (*(*))(_VOID))0x51e;
	xconstat[2] = savenstat2;
	xconstat[5] = savenstat5;
	xconin = (_LONG (*(*))(_VOID))0x53e;
	xconin[2] = savein2;
	xconin[5] = savein5;
	xcostat = (_LONG (*(*))(_VOID))0x55e;
	xcostat[2] = savestat2;
	xcostat[5] = savestat5;
	xconout = (_LONG __CDECL (*(*))(_WORD dev, _WORD c))0x57e;
	xconout[2] = saveout2;
	xconout[5] = saveout5;
	return 0;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID ARCAss_RestoreTrap(_VOID)
{
	ARCAss_ClearOutputProc();
	/* habe wir uns im BIOS-Trap installiert? */
	if (saveProc != FUNK_NULL)
	{
		/* ja, BIOS-Trap deinstallieren */
		(_VOID)Setexc(45, saveProc);
		saveProc = FUNK_NULL;
	} else if (CanDoSuper())
	{
		/* De-Installation aus xcon-Vektoren */
		Supexec(deinstall_xcon);
	}
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

#ifdef MAIN

#define CBUFSIZE 256

LOCAL size_t buffill;
LOCAL _UBYTE buffer[CBUFSIZE];

LOCAL _VOID catch(_UBYTE c)
{
	if (buffill < CBUFSIZE)
		buffer[buffill++] = c;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _UWORD TosVersion(_VOID)
{
	return 0x102;
}

/*** ---------------------------------------------------------------------- ***/

int main(void)
{
	ARCAss_SetTrap();
	ARCAss_SetOutputProc(catch);
	printf("Hello world\n");
	fflush(stdout);
	ARCAss_RestoreTrap();
	printf("found %lu characters: %s\n", (_ULONG)buffill, buffer);
	fflush(stdout);
	getchar();
	return 0;
}

#endif /* MAIN */
