/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */


/* 21.05.1999 Markus Hoffmann @ DU (MH)
 * - Per Variable 'SmallFunctionWindow' kann ein platzsparendes kleines Funktions-
 *   fenster eingestellt werden.
 * 30.05.1999 (MH)
 * - In der Datei KONFIG.INF, die sich im CAT-Verzeichnis befinden muss, koennen 
 *   bis zu acht CAT.INF-Dateien definiert werden, die dann bei 'Konfiguration laden' 
 *   in einem Popup erscheinen. In der ersten Zeile steht die Beschreibung (max. 16
 *   Zeichen), in der nchsten dann der Pfad und Dateiname.
 */

/* Wie in der CatPL gefordert sind alle nderungen ab der Version 4.13 wie
Folgt gekennzeichnet: */
/*DYJ 4.13x Start*/
/*DYJ  Ende; alt:
*/

/* Dabei sind DYJ meine Inizialien, 4.13 ist die Version in der es neu war
und das 'x' bedeutet, da es Teil des 24. Fixes (x ist der 24. Buchstabe)
der 4.13 war. So kann man leicht nach 4.13x suchen und alle dazugehrigen
nderungen finden. Zwischen Start und Stop befindet sich der neue Code,
hinter 'alt' der alte.
Auerdem gibt es noch eine Beschreibung jedes Fixes mit Datum wie weiter unten.
Damit das ganze auf Dauer nicht zu unbersichtlich wird bleiben diese ausfhrlichen
Kommentare nur etwa 2 Versionen drin, danach bleibt nur noch der Hauptkommentar und 
eine Markierung der Routinen in denen nderungen sind. 
Da nderungen im RSC nicht derart markiert werden knnen sind sie im jeweiligen 
Hauptkommentar mit RSC-NEU markiert

Die Hauptkomentare aller Versionen vor 5.00 habe ich in der Version 5.39 gelscht.
Sie sind gesammelt auf meiner HP unter:
<http://www.dimitri-junker.de/software/cat/chg_4x.txt>
verfgbar.
 *
 * 15.2.03 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.20zh'
 * RSC-NEU: In GRSTEUER und EDITCTRL einige CICONS berarbeitet, sie waren in der SW-Version
 *	falsch
 *
 * 17.2.03 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.21a'
 *	RSC-NEU-ENGL: Ekkehard Flessa hatte bereits im letzten Jahr ein 
 *	mehrsprachiges (deutsch/englisch) RSC erstellt. Dies werde 
 *	ich in Zukunft nutzen und mit und mit auch die restlichen 
 *	Texte bersetzen. 
 *
 * 17.2.03 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.21b'
 *
 *	RSC-NEU-ENGL: Ich habe angefangen die Texte der Alerts ins RSC zu 
 *	bernehmen. Dies wird aber sicher noch in den Folgenden Versionen 
 *	weitergehen. Um leicht alle nderungen zu finden werden alle hier 
 *	mit dem	RSC-NEU-ENGL markiert werden.
 *
 * 8.3.03 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.22a'
 *	Weiteres bersetzen
 *	RSC-NEU-ENGL: In REPLY war noch ein Abbsender im englischen
 *
 * 15.3.03 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.22f'
 *	Steuerung der Sprachversion durch Files oder Environmentvariablen
 *	berarbeitet, u.a. wird das Sprachfile jetzt bevorzugt in den
 *	HOME-Ordner abgelegt.
 *
 * 18.3.03 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.23e'
 *	Weiteres bersetzen
 *	RSC-NEU-ENGL: viel
 *
 * 24.3.03 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.23h'
 *	Da die meisten Desktops Anwendungen nur auf Endungen anmelden
 *	knnen kann man dem Mailto: jetzt eine Dummy Endung .cm2 verpassen,
 *	diese wird dann ignoriert, ebenso kann man vor das mailto: irgendwas
 *	Pfadartiges schreiben.
 *
 * 8.4.03 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.25b'
 *	Noch ein Fehler bei dem Abschneiden des .cm2
 *
 * 12.4.03 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.26d'
 *	Es kommt irgendwie vor, da die Parameter des mailto: mit
 *	%40 an Stelle des @ ankommen. Dies wird jetzt erkannt.
 *
 * 21.4.03 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.27b'
 *	Mll entsorgt
 *
 * 11.5.03 Gerhard Stoll (GS) gekennzeichnet mit 'GS 5.28a'
 * Noch einige neue Linktypen definiert
 *
 * 21.9.03 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.30j'
 *	Cat schreibt jetzt die Catpos.inf zweimal. Zustzlich ist die Kopie
 *	im Datenbank-Verzeichnis. Wird Cat mit einem cat.inf als Parameter
 *	gestartet, so nimmt es die catpos.inf aus dem zugehrigen Datenbank-
 *	Ordner.
 *
 * 30.10.03 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.32e'
 *	Cat reagiert jetzt auf AP_RESCHG genau so wie auf AP_TERM
 *
 * 6.11.03 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.32f'
 *	Cat kann den Mailtext jetzt als HTML exportieren. Dabei wird
 *	der Originaltext verwendet, also ggf. mit allen Unicode Zeichen.
 *
 * 30.4.04 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.36c'
 *	3 neue Menpunkte um CatPutz aus Cat aufzurufen
 * RSC-NEU: ME_PUTZ_A, ME_PUTZ_G und ME_PUTZ_L im Men
 */

#include <catvers.h>
#include <msginfil.h>
#include <infofile.h>
#include <infodlg.h>
#include <mtpaths.h>
#include <userinfo.h>
#include <doitk.h>
#include <vdiutil.h>
#include <vdistand.h>
#include <catfiles.h>
#include <convertd.h>
#include <protokol.h>
#include <xacc.h>
#include <vaproto.h>
#include <menu_key.h>
#include <shellcal.h>
#include <mte.h>
#include <catgloba.h>
#include <catkeys.h>
#include <adr.h>
#include <maustaus.h>
#include <catmain.h>
#include <alias.h>

#include <clip.h>
#include <confvars.h>
#include <varname2.h>
#include <varname3.h>
#include <varname5.h>
#include <varnamel.h>
#include <grin.h>
#include <grintool.h>
#include <parser.h>
#include <listhelp.h>
#include <fontsele.h>
#include <wdwmanag.h>
#include <msgwindo.h>
#include <msglist.h>
#include <cathelp.h>
#include <zcalccrc.h>
#include <printer.h>
#include <mtedit2.h>
#include <catbutto.h>
#include <editor.h>
#include <editglob.h>
#include <zsearchd.h>
#include <treelist.h>
#include <catopts.h>
#include <catopts2.h>
#include <catutil.h>
#include <wiedervo.h>
#include <wiederv2.h>
#include <gruppena.h>

#include <mtappl.h>
#include <mtutils.h>
#include <mtdials.h>
#include <mtdir.h>
#include <mtpopups.h>
#include <mttextfi.h>
#include <mtrsc.h>
#include <mtaesmen.h>
#include <magicstr.h>
#include <magiccoo.h>
#include <filename.h>
#include <strconv.h>
#include <fslx.h>

#include <mintutil.h>
#include <ro_mem.h>
#include <routinec.h>
#include <routines.h>
#include <file_io.h>
#include <debug.h>
#include <signal_.h>		/* Achtung: auf keinen Fall das Orginal-Pure-C signal.h nehmen!!! */

#include <basepage.h>
#include <atari.h>

#define _sysbase	(0x4f2l)

GLOBAL _UBYTE ProgramName[] = CAT_PROGNAME;
GLOBAL _BOOL PrgHasDataBase=TRUE;
GLOBAL _UBYTE HomePath[PATH_MAX];
GLOBAL _UBYTE LOG_TITLE[]="Log-Datei f\201r Einf\201geprotokoll von CAT ";
GLOBAL _UBYTE LOG_END[]="Einf\201gen beendet.";
GLOBAL _UBYTE LOG_FNAME[]=CATLOG_FILENAME;
GLOBAL _UBYTE LOG_FHDRNAME[]=CATHDLOG_FILENAME;

#define CFGName     "printer.cfg"

LOCAL _WORD moX, moY;
LOCAL _UWORD moButton;
LOCAL _WORD kReturn;
LOCAL _UWORD moKState;
LOCAL _WORD bReturn;
LOCAL _UWORD lastEvent;
LOCAL _UWORD event;
LOCAL _WORD mess[8];
LOCAL _UBYTE scan;
LOCAL _UBYTE ch;
LOCAL GRECT mrect;
LOCAL _BOOL startTerm;
LOCAL _UBYTE startPutzCmd[128]="";	/*DYJ 5.36c */
LOCAL _BOOL termStarted;
LOCAL _BOOL mouse;
LOCAL _BOOL dontSwitchOffMouse;   /* Nur nicht die Maus ausschalten */
LOCAL _BOOL EndOfPrg;
LOCAL _BOOL fastExit;
LOCAL _WORD chPid;
LOCAL _WORD termPid;

LOCAL _DTA catDTA;
LOCAL _UBYTE catName[PATH_MAX];
LOCAL _BOOL configFileDa;
LOCAL _BOOL fromTerm;
LOCAL _BOOL fromPutz;	/*DYJ 5.36c */


LOCAL _WORD filterNumber;

LOCAL _WORD AnzErr=0;

/* Fuer die FlagBox */
LOCAL MSGBITS setBits = 0;
LOCAL MSGBITS clearBits = 0;
LOCAL DialAction lastAction = ChangeMsg;


typedef struct {
	_BOOL makeInfile;
	_BOOL startTerminal;
	_BOOL decodeOutfile;
	_BOOL quitProg;
	_BOOL batch;
	CONST _UBYTE *inf;
	_UBYTE mailto[256];
	_UBYTE subject[256];
} COMMAND_ARGS;



/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

/* Kleiner Stack fuer Keyboard-Events */
#define maxKeys 16
typedef struct {
	_UWORD kstate;
	_UBYTE scan;
	_UBYTE ch;
} kbdEvent;
LOCAL kbdEvent keyStack[maxKeys];
LOCAL _WORD keyWrite, keyRead;

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID PopKey(_UWORD *kstate, _UBYTE *scan, _UBYTE *ch)
{
	if (keyRead != keyWrite)
	{
		*kstate = keyStack[keyRead].kstate;
		*scan = keyStack[keyRead].scan;
		*ch = keyStack[keyRead].ch;
		keyRead = (keyRead + 1) % maxKeys;
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID PushKey(_UWORD kstate, _UBYTE scan, _UBYTE ch)
{
	keyStack[keyWrite].kstate = kstate;
	keyStack[keyWrite].scan = scan;
	keyStack[keyWrite].ch = ch;
	keyWrite = (keyWrite + 1) % maxKeys;
	if (keyWrite == keyRead)
	{
		/* hat keyRead eingeholt, einmal rum!
		 * keyRead auf naechsten setzen
		 */
		keyRead = (keyWrite + 1) % maxKeys;
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL PendingKey(_VOID)
{
	return keyRead != keyWrite;
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

LOCAL _VOID DoAbout(_VOID)
{
	OBJECT *about;

	about = TreeAddr[ABOUT];
	VDIStandards_SetSpec(about, DATE, NO_CONST(CatDate));
	VDIStandards_SetSpec(about, VERSION, NO_CONST(CatVersion));
	if (VDIUtil_FormHandle(about) == AINFO)
		CatHelp_DoHelp(CatHelp_catinfo);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID ClearScreen(_VOID)
{
	Cconout(0x1b);
	Cconout('E');
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID ClearBuffer(_UWORD e, _BOOL force, _UWORD ks, _UBYTE sc, _UBYTE ch)
{
	_WORD kReturn;
	_WORD message[8];
	_WORD dummy;
	_UWORD udummy;
	_UWORD kstate;
	_UBYTE scan;

	if (e & MU_KEYBD)
	{
		do
		{
			e = evnt_multi(MU_KEYBD | MU_TIMER,
				0, 0, 0,
				0, 0, 0, 0, 0,
				0, 0, 0, 0, 0,
				message,
				0, 0,
				&dummy, &dummy, &udummy, &kstate, &kReturn, &dummy);
			scan = (kReturn >> 8) & 0xff;
			ch = kReturn & 0xff;
		} while ((e & MU_KEYBD) && (force || (ks == kstate && scan == sc)));
		if (e & MU_KEYBD)
			PushKey(kstate, scan, ch);
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID ProcessFilter(HWND wdw, _BOOL withDial)
{
	_UBYTE cmd[256];

	if ((withDial && CatOpts2_doFilter(&filterNumber, cmd, sizeof(cmd))) ||
		(!withDial && CatOpts2_doPopupFilter(&filterNumber, cmd, sizeof(cmd))))
	{
		switch (filterNumber)
		{
		case 0:
			Editor_BlockRot(wdw);
			break;
		case 1:
			Editor_BlockRot18(wdw);
			break;
		case 2:
			Editor_BlockSwap(wdw);
			break;
		case 3:
			Editor_BlockUp(wdw);
			break;
		case 4:
			Editor_BlockDown(wdw);
			break;
		case 5:
			Editor_BlockCapitals(wdw);
			break;
		case 6:
			Editor_BlockMirror(wdw);
			break;
		case 7:
			Editor_BlockDecode(wdw);
			break;
		case 8:
			Editor_BlockMime(wdw);
			break;
		default:
			if (*cmd != '\0')
				CatUtil_PipeEditBlock(wdw, cmd);
			break;
		}
	}
}

/*** ---------------------------------------------------------------------- ***/

/*DYJ 5.21b */	/*DYJ 5.23e */
LOCAL _VOID DoShell(_VOID)
{
	_UBYTE shellCommand[256];
	OBJECT *system;

	system = TreeAddr[SYSTEM];
	SetObjcStringAdr(system, SYSTITLE, Rsc_WrkString(sysStrOne), strLen(Rsc_WrkString(sysStrOne)) + 1);
	ObjcString(system, SYSSTR, shellCommand, sizeof(shellCommand));
	if (VDIUtil_FormHandle(system) != SYSABRUC)
	{
		ObjcString(system, SYSSTR, shellCommand, sizeof(shellCommand));
		if (!multiTask)
		{
			MouseOff();
			ClearScreen();
			data_WritePos();
			Wind_Update(END_UPDATE);
		}
		ShellCall_CallShell(shellCommand, FALSE);
		if (!multiTask)
			Wind_Update(BEG_UPDATE);
		data_ReadPos();
		if (!multiTask)
		{
			Cconws("\r\n");
			Cconws(MausTauschrsc_WrkString(STR_PRESS_KEY));
			ClearBuffer(MU_KEYBD, TRUE, 0, 0, 0);
			evnt_keybd(); /* !!! klappt nicht wenn keine Fenster mehr offen sind */
			Cconws("\033f");        /* Cursor ausschalten */
			MouseArrow();
			Form_dial(FMD_FINISH, &deskSize, &deskSize);
			menu_bar(TreeAddr[MENU], 1);
		}
	} else
	{
		SetObjcString(system, SYSSTR, shellCommand);
	}
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

LOCAL _VOID ChangeIt(_VOID)
{
	if (BMess)
	{
		CatButtons_Wiggle(MESSAGES, FALSE);
	} else
	{
		CatButtons_Wiggle(STICHWOR, FALSE);
	}
	CatButtons_Select_Messages(BMess);
	CatButtons_DrawButton(STICHWOR);
	CatButtons_DrawButton(MESSAGES);
	VDIStandards_CheckItem(TreeAddr[MENU], TREADMSG, !BMess);
}

/*** ---------------------------------------------------------------------- ***/
/*DYJ 5.21b */
LOCAL _VOID HandlePers(_WORD item)
{
	_UBYTE str[256];
	group_line Betreff;

	if (!MTPaths_DatabaseLocked())
		return;
	*str = '\0';
	if (adr_SelectName(ADR_NORMAL,str, sizeof(str)))
	{
		*Betreff = '\0';
		if (grinTools_BetreffHolen(-1, Betreff, sizeof(Betreff), MausTauschrsc_WrkString(STR_PERS_KEYWORD), str, MausTauschrsc_WrkString(wgStr), BH_LEER))
		{
			CatButtons_Normal(item);
			Messages_NewPersMsg(str, "", Betreff);
		} else
		{
			CatButtons_Normal(item);
		}
	} else
	{
		CatButtons_Normal(item);
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL MSGNR getIdNumber(OneGroupHandle ptr, CONST _UBYTE *id)
{
	return data_NumberOfID(ptr, id);
}

/*** ---------------------------------------------------------------------- ***/
LOCAL MSGNR getDateNumber(OneGroupHandle ptr, CONST _UBYTE *id)
{
	return data_NumberOfDate(ptr, ConvertDate_StrToDate(id));

}
/*** ---------------------------------------------------------------------- ***/
/*DYJ 5.21b */
LOCAL _VOID CatButtons_ButtonHandler(_WORD obj)
{
	_UBYTE str[256];
	group_line Gruppe;
	group_line Betreff;
	CAT_GROUP_NUMBER ca;
	MSGNR start;
	groupSelectMode sMode;
	grin_openMode mode;

	*Gruppe = '\0';
	*Betreff = '\0';

	switch (obj)
	{
	case NEWMESS:
		CatButtons_Wiggle(NEWMESS, FALSE);
		/* HandlePublic */
		if (!MTPaths_DatabaseLocked())
			return;
		ListHelp_SetLastGroup(Gruppe);
		if (!ListHelp_SelectGroup(Gruppe, sizeof(Gruppe), &ca, TRUE, FALSE, FALSE, gsmWrite))
		{
			CatButtons_Normal(NEWMESS);
			return;
		}
		if (!GroupSelect_isPrivate(ca))
		{
			if (Gruppe[0] == '\0')
				strCpy(Gruppe, Rsc_WrkString(GRP_PUBLIC));
			if (grinTools_BetreffHolen(-1, Betreff, sizeof(Betreff), MausTauschrsc_WrkString(STR_PUBLIC_KEYWORD), Gruppe, MausTauschrsc_WrkString(wgStr), BH_LEER))
			{
				CatButtons_Normal(NEWMESS);
				Messages_NewMessage(Gruppe, Betreff);
			} else
			{
				CatButtons_Normal(NEWMESS);
			}
		} else
		{
			HandlePers(NEWMESS);
		}
		break;

	case NEWPERS:
		CatButtons_Wiggle(NEWPERS, FALSE);
		HandlePers(NEWPERS);
		break;

	case READPOS:
	case READALL:
	case READNEW:
	case READNUM:
	case READDATE:
	case READUNREAD:
		CatButtons_Wiggle(obj, FALSE);
		if (!MTPaths_DatabaseLocked())
			return;
		/* Lesemodus bestimmen */
		switch (obj)
		{
			case READPOS: sMode = gsmReadLastPos; break;
			case READALL: sMode = gsmReadBegin; break;
			case READNEW: sMode = gsmReadNew; break;
			case READNUM: sMode = gsmReadId; break;
			case READDATE: sMode = gsmReadDate; break;
			case READUNREAD: sMode = gsmReadUnread; break;
			default: sMode = gsmOther; break;
		}

		if (ListHelp_SelectGroup(Gruppe, sizeof(Gruppe), &ca, FALSE, FALSE, FALSE, sMode))
		{
			switch (sMode)
			{
			case gsmReadId:
				if (CatOpts2_NrHolen(str, sizeof(str)))
				{
					if (BMess)
						grin_grinOpenWithProc(ca, getIdNumber, str, grin_grinNextMess, 0, mOther);
					else
						msgList_listOpenWithProc(ca, getIdNumber, str, -1, mOther);
				}
				CatButtons_Normal(obj);
				return;
			case gsmReadDate:
				if (CatOpts2_DatumHolen(FALSE, str, sizeof(str)))
				{
					if (BMess)
						grin_grinOpenWithProc(ca, getDateNumber, str, grin_grinNextMess, 0, mOther);
					else
						msgList_listOpenWithProc(ca, getDateNumber, str, -1, mOther);
				}
				CatButtons_Normal(obj);
				return;
			case gsmReadLastPos:
				start = data_lastReadMsgOfGroup(ca);
				mode = mLastPos;
				break;
			case gsmReadBegin:
				start = 0;
				mode = mFromBeginning;
				break;
			case gsmReadNew:
				start = data_FirstNewMsg(ca);
				mode = mFirstNew;
				break;
			case gsmReadUnread:
				start = data_unreadMsgPos(ca);
				mode = mUnread;
				break;
			default:
				start = dataSys_empty;
				mode = mUnread;
				break;
			}
			CatButtons_Normal(obj);
			if (BMess)
				grin_grinOpenMessage(ca, start, grin_grinNextMess, 0, mode);
			else
				msgList_listOpen(ca, start, -1, mode);
		} else
		{
			CatButtons_Normal(obj);
		}
		break;

	case STICHWOR:
	case MESSAGES:
		if (BMess != (obj == MESSAGES))
		{
			BMess = (obj == MESSAGES);
			ChangeIt();
			ConfVars_SetConfigBool(cShowMessages, BMess);
		}
		break;

	case CATINFNA:
	case CATINFN0:
	case CATINFN1:
		obj = CATINFNA;
		CatButtons_Wiggle(obj, TRUE);
		ReadInfoFile(TRUE, FALSE);
		CatButtons_Normal(obj);
		break;
	}
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/
/*DYJ 5.21b */
LOCAL _VOID StartIt(_VOID)
{
	_WORD i;

	_UBYTE scrap[PATH_MAX],prgEnd[FILENAME_MAX]="*.prg";
	if (ConfVars_GetConfigString(cDefStartPrg, scrap, sizeof(scrap)))
	{
		mtDir_SplitPath(scrap, prgPath, prgName, prgEnd);
		if (prgEnd[0] != '\0')
			Insert("*.", prgEnd, sizeof(prgEnd), 0);
		else
			strCpy(prgEnd, "*.prg");
	}
	
	if (mtDir_FselGet(prgPath, prgName, prgEnd, MausTauschrsc_WrkString(FS_START_PROGRAM), FALSE))
	{
		i = StartPrg(prgPath, prgName, "", TRUE, TRUE, &chPid);
		if ((i == 0x4711 && mtAlerts_AlertRSC(1, AL_LOAD_INF) == 1) ||
			i == 0x4712)
		{
			ReadInfoFile(TRUE, FALSE);
		} else if (i == 0x4713)
		{
			/* Return from CatPutz */
			ReadInfoFile(FALSE, TRUE);
		} else if (i != 0)
		{
			F_ErrorAlert(i);
		}
	}
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

LOCAL _VOID CallInfo(_VOID)
{
	_UBYTE path[PATH_MAX];
	_UBYTE name[PATH_MAX];
	_UBYTE ext[PATH_MAX];
	_UBYTE callStr[256];

	if (InfoDlg_doInfoList(TRUE, callStr, sizeof(callStr)))
	{
		mtDir_SplitPath(callStr, path, name, ext);
		MTEdit2_OpenEditWindow(path, name, FALSE, UserBLK.InfofilesReadOnly);
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL CreateInfile(_VOID)
{
	Messages_MsgAskForSave();
	if (MsgInfile_MakeInFile())
	{
		Messages_ReloadEditors();
		return TRUE;
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/
/*DYJ 5.21b */	/*DYJ 5.20t */	/*DYJ 5.20ze */	/*DYJ 5.21i */
GLOBAL _BOOL DecodeOutfile(_BOOL standardOutfile)
{
	_BOOL val;
	_BOOL ret=TRUE,of_ok=TRUE;
	_WORD impOH,outfOk;
	_UBYTE 	path[PATH_MAX]="",name[PATH_MAX]="",*pImport_path,*pOutfile_name,*pArchive_name,*pArc_name,*ext;

	grin_grinCloseAll();
	msgList_listCloseAll();
	treeList_treeCloseAll();
	msgList_listFreeAll();
	WdwManager_HandlePendingEvents();
	/* ConvertOutfile() */
	if(standardOutfile)
	{
		pImport_path=ImportPath;
		pArchive_name=archiveName;
		pOutfile_name=OUTFILE_NAME;
		pArc_name=ARCName;
	}
	else
	{
		if (!mtDir_FselGet(path, name, ALL_FILE_MASK, MausTauschrsc_WrkString(FS_OUTFILE2), FALSE))
			return FALSE;
		ext=strrChr(name,'.');
		if(!strCaseCmp(ext,".txt"))
		{
			pImport_path=path;
			pArchive_name=name;
			pOutfile_name=name;
			pArc_name="";
		}
		else
		{
			MTE_infoRSC(AL_NO_OUTFILE);
			return FALSE;
		}
	}	

	if ((outfOk=Parser_OutfileEinsortieren(pImport_path, pOutfile_name, pArchive_name, pArc_name, OM_OUTFILE))==2)
	{
		GroupSelect_SaveChangedGroupList();
	}
	else
		ret=of_ok=FALSE;
	ConfVars_GetConfDefInt(cImpOutfHdr, &impOH,2);
	if(impOH==1 && !outfOk)
		impOH=0;
	if (impOH && Parser_OutfileEinsortieren(ImportPath, OUTF_HDR_NAME, "", "", OM_OUTFHDR)==2)
		GroupSelect_SaveChangedGroupList();
	else
		ret=FALSE;
	if(of_ok)
	{
		if (!batchProcess && UserBLK.MakeInfileAfterImport)
			CreateInfile();
		if (ConfVars_GetConfigBool(cShowLogAfterImport, &val) && val && !batchProcess)
		{
			MTEdit2_OpenEditWindow(DataPath, LASTLOG_FILENAME, FALSE, UserBLK.InfofilesReadOnly);
		}
	}
	return ret;
}

/*** ---------------------------------------------------------------------- ***/



/*** ------------------------------------------------------------------------ ***/
/*	LOCAL _VOID convCbC(_UBYTE *ziel,_UBYTE *quell,size_t destsize)				*/
/*	Ersetzt im Quellstring '$C' durch die Vorvorwahl des aktuell gnstigsten	*/
/*	CbC Providers																*/
/*	Parameter:	ziel:	dorthin wandeln											*/
/*				quell:	Quelle ggf. mit $C										*/
/*				destsize:Lnge des ziel-Strings									*/
/*	Ergebnis:	keines															*/		
/*	29.10.01 von Dimitri Junker	DYJ 4.30p										*/
/*** ------------------------------------------------------------------------ ***/
LOCAL _VOID convCbC(_UBYTE *ziel,_UBYTE *quell,size_t destsize)
{
	_WORD i,von,bis,days;
	_UBYTE vvWahl[20];
	tWeekday akt_wday;
	Date dt;
	Time ti;
	_BOOL ok;

	dt = ConvertDate_UnpackDate(Tgetdate());
	akt_wday = ConvertDate_WeekDay(&dt);
	for (i = 0; i <= MAX_CBC_REG; i++)
	{
		ok=FALSE;
		days=CatOpts2_GetCbC(i,&von,&bis,vvWahl,sizeof(vvWahl));
		switch(days)
		{
			case SONNTAG:
			case MONTAG:
			case DIENSTAG:
			case MITTWOCH:
			case DONNERSTAG:
			case FREITAG:
			case SAMMSTAG:
				if(akt_wday==(days-SONNTAG))
					ok=TRUE;
				break;
			case WOCHENTAG:
				if(akt_wday!=Sunday && akt_wday!=Saturday )
					ok=TRUE;
				break;
			case SASOFT:
				ok=ConvertDate_Holiday(&dt);
			case WOCHENENDE:
				if(akt_wday==Sunday || akt_wday==Saturday )
					ok=TRUE;
				break;
			case SOFT:
				ok=akt_wday==Sunday;
			case FEIERTAG:
				ok|=ConvertDate_Holiday(&dt);
				break;
			case TAEGL:
				ok=TRUE;
			case CBC_UNBENUTZT:
				break;
		}
		if(ok)
		{
			ti = ConvertDate_UnpackTime(Tgettime());
			if(ti.hour<von || ti.hour>bis)
				ok=FALSE;
			else
				break;
		}
	}
	strCpy(ziel,quell);
	CatGlobal_ReplaceStr(ziel, destsize, "$C", vvWahl);   /* CbC-Nummer */

}
/*** ------------------------------------------------------------------------ ***/
/*	_BOOL StartPutz(_UBYTE *putzCmd)											*/
/*	Bereitet den Start von CatPutz vor											*/
/*	Parameter:	putzCmd: zustzlicher Teil der Kommandozeile oder NULL			*/
/*					bei NULL bleibt die Kommandozeile erhalten					*/
/*					sonst wird am Ende noch -r angefgt							*/
/*	Ergebnis:	OK?																*/		
/*	26.4.04 von Dimitri Junker	DYJ 5.36c										*/
/*** ------------------------------------------------------------------------ ***/
LOCAL _BOOL StartPutz(_UBYTE *putzCmd)
{
	if (SaveAllPositions)
	{
		EndOfPrg = CatUtil_WriteSavePos(FALSE, FALSE);
	} else
	{
		grin_grinCloseAll();		/* Die grin-Fenster muessen unbedingt vor denen
									 * von msgList geschlossen werden
									 */
		msgList_listCloseAll();
		treeList_treeCloseAll();
		msgList_listFreeAll();
		CatButtons_CloseButton(TRUE);
		EndOfPrg = WdwManager_CloseAllWindows(FALSE);
	}
	if (!EndOfPrg)
		return FALSE;
	if(putzCmd)
	{
		strBcpy(startPutzCmd, putzCmd);
		strBcat(startPutzCmd," -r");
	}
	return TRUE;
}
/*** ---------------------------------------------------------------------- ***/
/*DYJ 5.20ze */
GLOBAL _BOOL StartTerminal(_BOOL inBatch)
{
	_WORD res;
	_UBYTE cmd[PATH_MAX*6];
	if (!batchProcess && UserBLK.MakeInfileBeforeTerminal)
	{
		if (!CreateInfile())
			return FALSE;
	}
	if (!batchProcess && UserBLK.DeleteBeforeTerm)
	{
		if(*ARCName)
			CatFiles_DeleteFile(ImportPath, archiveName);
		CatFiles_DeleteFile(ImportPath, OUTFILE_NAME);
	}
	if (UserBLK.TerminalAsOverlay)
	{
		if (SaveAllPositions)
		{
			EndOfPrg = CatUtil_WriteSavePos(FALSE, FALSE);
		} else
		{
			grin_grinCloseAll();		/* Die grin-Fenster muessen unbedingt vor denen
										 * von msgList geschlossen werden
										 */
			msgList_listCloseAll();
			treeList_treeCloseAll();
			msgList_listFreeAll();
			CatButtons_CloseButton(TRUE);
			EndOfPrg = WdwManager_CloseAllWindows(FALSE);
		}
		if (!EndOfPrg)
			return FALSE;
		startTerm = TRUE;
		return TRUE;
	}
	convCbC(cmd,TerminalCmd,sizeof(cmd));
	res = StartPrg(TerminalPath, TerminalName, cmd, TRUE, !inBatch, &chPid);
	if (res < 0 && !batchProcess)
		F_ErrorAlert(res);
	termPid = chPid;
	if (res == 0 && (multiTOS || magIx))
	{
		termStarted = !inBatch;
	} else
	{
		termStarted = FALSE;
	}
	if (!batchProcess && (!(multiTOS || magIx) || inBatch) && res == 0)
	{
		/* Bei MultiTOS auf Event CHEXIT warten */
		if (UserBLK.ImportAfterTermPrg)
			DecodeOutfile(TRUE);
	}
	return res == 0;
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

LOCAL CONST _UBYTE *putChar(CONST _UBYTE *from, _UBYTE **str, size_t *strsize)
{
	if (*from != '\0')
	{
		if (strChr(" @\"'()", *from) == NULL)
		{
			if (*strsize)
			{
				*(*str)++ = ucase(*from);
				(*strsize)--;
			}
			from++;
		}
	}
	return from;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID GetInitials(HWND botWdw, _UBYTE *str, size_t strsize)
{
	_UBYTE from[256];
	CONST _UBYTE *p;

	strsize -= 2;		/* -1 fuer '>', -1 fuer EOS */
	if (UserBLK.InitialQuote)
	{
		grin_ActualName(botWdw, from, sizeof(from));
		if (*from != '\0')
		{
			p = from;
			do
			{
				/* Immer noch nicht schoen, aber besser als vorher */
				while (*p != '\0' && strChr(" _-\"()", *p) != NULL)
					++p;
				if (p == from || strChr("<\"'(", p[-1]) == NULL)
				{
					p = putChar(p, &str, &strsize);
				}
				while (*p != '\0' && strChr(" _-@", *p) == NULL)
					++p;
			} while (*p != '\0' && *p != '@' && strsize);
		}
	}
	*str++ = '>';
	if (UserBLK.BlkAftQuote)
		*str++ = ' ';
	*str = '\0';
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID QuoteBlock(HWND wdw, _BOOL withShift)
{
	HWND botWdw;
	_UBYTE *buf;
	_ULONG bufLen;
	_UBYTE pre[8];

	/* Erstmal falsche Fenster abfangen */
	if (grin_grinWindowTop(wdw) || !Editor_IsEditTop(wdw))
		return;

	/* Kein zweites Fenster offen? */
	if (!WdwManager_GetSecondWdw(&botWdw))
		return;

	/* Das untere Fenster ist kein MessageWindow? Geht nicht! */
	if (!grin_grinWindowTop(botWdw))
	{
		/* Pruefen, ob nur ein MessageWindow offen ist */
		if (!grin_grinOnlyOneWind(&botWdw))
			return;
	}
	/* Kein Block markiert? Zurueck! */
	if (!Editor_BlockIsMarked(botWdw))
		return;
	if (!Editor_GetBlock(botWdw, FALSE, withShift, &buf, &bufLen))
		return;
	/* Jetzt noch Initialien holen */
	GetInitials(botWdw, pre, sizeof(pre));
	/* Und jetzt Block einsetzen */
	Editor_QuoteSomething(wdw, pre, buf, (EDCOLUMN)bufLen, 75);		/* !!! 75? */
	SFREE(buf);
}
/*** ------------------------------------------------------------------------ ***/
/*	_BOOL stopSearch(_VOID)														*/
/*	Prft ob per Tastatur abgebrochen wird										*/
/*	Parameter:	keine															*/
/*	Ergebnis:	keines															*/		
/*	2.1.02 aus grin.c bernommen	DYJ 4.32c									*/
/*** ------------------------------------------------------------------------ ***/
LOCAL _BOOL stopSearch(_VOID)
{
	_UBYTE ch, scan;
	_UWORD kstate;
	
	if (VDIUtil_isKey(&kstate, &scan, &ch))
		return ch == 0x1b;
	return FALSE;
}
/*** ------------------------------------------------------------------------ ***/
/*	GLOBAL _VOID LinkBlock(HWND wdw)											*/
/*	Fhrt einen Link aus														*/
/*	Parameter:	wdw:	das Fenster in dem der Block markiert ist				*/
/*	Ergebnis:	keines															*/		
/*	4.9.00 von Dimitri Junker	DYJ 4.18										*/
/*** ------------------------------------------------------------------------ ***/
GLOBAL _VOID LinkBlock(HWND wdw)
{
	_UBYTE *buf,*link,*end;
	_ULONG bufLen;
	_WORD type,avModus,av_id;
	CAT_GROUP_NUMBER group;
	group_line gruppenName="";
	HWND messWin;

	/* Kein Block markiert? Zurueck! */
	if (!Editor_BlockIsMarked(wdw))
		return;
	if (!Editor_GetBlock(wdw, FALSE, FALSE, &buf, &bufLen))
		return;
	type=EditGlobals_LinkType(buf,&link);
	end=strPbrk(link,">\"");
	if(end)
		*end='\0';
	switch(type)
	{
		case NoLNK:
			mtAlerts_AlertRSC(1, AL_NOT_A_LINK);
			break;
		case Http:
		case Ftp:
/* GS 5.28a Start */
		case Telnet:
		case Gopher:
		case Wais:
/* GS 5.28a Ende */
			ConfVars_GetConfDefInt(cAvModus, &avModus, 2);
			if(avModus && (av_id = FindAVServerFor(AV_STARTPROG))>= 0)
			{
				/* Link an AV-Server senden */
				SPEC_DEBUG_OUT((EO_DEBUG, "Link an AV-Server senden: %s", link));
				Protokoll_SendPath(AV_STARTPROG,av_id, link, NULL);
			}
			else
				mtAlerts_AlertRSC(1, AL_NO_AV);
			break;
		case EmailI:
		case EmailM:
			grinTools_NewMessage(link,"");
			break;
		case EmailOrIdM:
		case EmailOrIdI:
			if(mtAlerts_AlertRSC(1, AL_EMAIL_OR_ID)==2)
			{
				grinTools_NewMessage(link,"");
				break;
			}
		case MausId:
		case MessId:
			grin_ActualGroupNr(wdw, &group);
			do
			{
				if(group!=NO_GROUP)
					messWin=grin_grinOpenWithProc(group, getIdNumber, link, grin_grinNextMess, 0, mOtherNoErrMsg);
				if(messWin==-1)
				{
					CAT_GROUP_NUMBER gNr, gAnz;
					oneHandlePtr handle;
					_BOOL found;
					if (ListHelp_SelectGroup(gruppenName, sizeof(gruppenName), &gNr, FALSE, TRUE, TRUE, gsmGroupCom))
					{
						found = FALSE;
						/* Wenn hier jetzt doch eine Gruppenangabe zur Verfuegung steht, dann */
						/* muss nur die Gruppe in <gruppenName> gespeichert werden und dann funktioniert */
						/* folgender Aufruf: */
						if (gruppenName[0] != '\0')
						{
							if ((handle = handlePool_GetOneDatahandle(gNr)) != NULL)
							{
								found=(messWin=grin_grinOpenWithProc(gNr, getIdNumber, link, grin_grinNextMess, 0, mOther)>-1);
								handlePool_FreeOneDataHandle(handle);
							}
						} else
						{
							gNr = 0;
							gAnz = GroupSelect_CountCatGroups();
							while (gNr < gAnz && !found && !stopSearch())
							{
								if ((handle = handlePool_GetOneDatahandle(gNr)) != NULL)
								{
									found=(messWin=grin_grinOpenWithProc(gNr, getIdNumber, link, grin_grinNextMess, 0, mOtherNoErrMsg)>-1);
									handlePool_FreeOneDataHandle(handle);
								}
								++gNr;
								CatGlobal_busyMouse();
							}
							MouseArrow();
							if (!found)
							{
								MTE_infoRSC(AL_NO_FOUND);
								break;
							}
						}
						if (!found)
							CatGlobal_Bing(cBingNoGroup);         /* Bing */
					}
					else
						break;
				}
			}while(messWin==-1);
	}
	SFREE(buf);
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

LOCAL _VOID doHelp(HWND wdw, _UWORD kstate)
{
	_UBYTE *buf;
	_ULONG bufLen;
	tHelp topic;

	if (grin_grinWindowTop(wdw))
		topic = CatHelp_grin;
	else if (Editor_IsEditTop(wdw))
		topic = CatHelp_editor;
	else if (MsgWindow_msgWindowTop(wdw))
		topic = CatHelp_manager;
	else if (msgList_listWindowTop(wdw))
		topic = CatHelp_msglist;
	else if (treeList_treeWindowTop(wdw))
		topic = CatHelp_treelist;
	else
		topic = CatHelp_general;
	if (CatGlobal_WithShift(kstate))
	{
		if (!mouse)
		{
			MouseOn();
			mouse = TRUE;
		}
		if (Editor_IsEditTop(wdw) && Editor_BlockIsMarked(wdw))
		{
			if (Editor_GetBlock(wdw, FALSE, FALSE, &buf, &bufLen))
			{
				Protokoll_SendHelp(buf);
				SFREE(buf);
			} else
			{
				CatHelp_DoHelpExtern(topic);
			}
		} else
		{
			CatHelp_DoHelpExtern(topic);
		}
		dontSwitchOffMouse = TRUE;
	} else
	{
		CatHelp_DoHelp(topic);
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID WriteInfoline(HWND wdw, _UWORD kstate)
{
	HWND botWdw;
/*DYJ 5.30l Start*/
	CONST _UBYTE *infoline,*infolineM=NULL;
/*DYJ  Ende; alt:	
	CONST _UBYTE *infoline;
*/

	/* Erstmal falsche Fenster abfangen */
	if (grin_grinWindowTop(wdw) || !Editor_IsEditTop(wdw))
		return;
	/* Erstmal noch Infozeile ueberpruefen */
/*DYJ 5.30l Start*/
	if(CatGlobal_WithShift(kstate))
		infoline=UserBLK.ReferenceLine2;
	else
	{
		infoline=UserBLK.ReferenceLine1;
		infolineM=UserBLK.ReferenceLine1M;
		if (!CatOpts_CheckInfoline(infolineM))
			return;
	}
/*DYJ  Ende; alt:	
	infoline = CatGlobal_WithShift(kstate) ? UserBLK.ReferenceLine2 : UserBLK.ReferenceLine1;
*/
	if (!CatOpts_CheckInfoline(infoline))
		return;
	if (Messages_MsgEditorTop(wdw) &&
		Messages_MsgIsPrivate(wdw))
	{
		/* Und jetzt Zeile basteln und in Editor */
/*DYJ 5.30l Start*/
		Messages_Infoline(wdw, infoline,infolineM);
/*DYJ  Ende; alt:	
		Messages_Infoline(wdw, infoline);
*/
	} else if (
		/* Kein zweites Fenster offen? */
		WdwManager_GetSecondWdw(&botWdw) &&
		/* Das untere Fenster ist kein MessageWindow? Geht nicht! */
		(grin_grinWindowTop(botWdw) ||
		/* Pruefen, ob nur ein MessageWindow offen ist */
		 grin_grinOnlyOneWind(&botWdw)))
	{
		/* Und jetzt Zeile basteln und in Editor */
/*DYJ 5.30l Start*/
		grin_grinInfoline(botWdw, wdw, infoline,infolineM);
/*DYJ  Ende; alt:	
		grin_grinInfoline(botWdw, wdw, infoline);
*/
	}
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

/* Nur fuer nicht-MultiTOS geeignet */
GLOBAL _VOID FullScreenRedraw(_VOID)
{
	GRECT rec;

	rec.g_x = 0;
	rec.g_y = 0;
	rec.g_w = MaxWidth;
	rec.g_h = MaxHeight;
	Form_dial(FMD_FINISH, &rec, &rec);
	menu_bar(TreeAddr[MENU], 1);
}

/*** ---------------------------------------------------------------------- ***/
/*DYJ 5.21b */
LOCAL _VOID ChangeFlags(HWND ownTopWdw)
{
	DialActionSet actSet;
	_WORD intval;
	if (grin_grinWindowTop(ownTopWdw))
	{
		actSet = ChangeMsg | ChangeTree | ChangeTreeDown;
		ConfVars_GetConfDefInt(cFlagSelection, &intval, 0);
		lastAction = (DialAction)intval;
	}
	else
		lastAction=actSet = ChangeSelected; /* Es gibt sowieso nur eine Wahl*/

	ConfVars_GetConfDefInt(cFlagSetValue, &intval, 0);
	setBits = (MSGBITS)intval;
	ConfVars_GetConfDefInt(cFlagClearValue, &intval, 0);
	clearBits = (MSGBITS)intval;
	if (ZSearchDial_FlagDial(actSet, &setBits, &clearBits, &lastAction))
	{
		if(setBits&bDelMaus && (mtAlerts_AlertSichLRSC(1,2, AL_KILL_MSG) == 1))
		{
			if (msgList_listWindowTop(ownTopWdw))
				msgList_listSendState(ownTopWdw, 'X');
			else if (treeList_treeWindowTop(ownTopWdw))
				treeList_treeSendState(ownTopWdw, 'X');
		}
		setBits&=~bDelMaus;
		switch (lastAction)
		{
		case ChangeMsg:
			grin_newStatus(ownTopWdw, clearBits, setBits);
			break;
		case ChangeTree:
			grin_changeTree(ownTopWdw, clearBits, setBits, TRUE);
			break;
		case ChangeTreeDown:
			grin_changeTree(ownTopWdw, clearBits, setBits, FALSE);
			break;
		case ChangeSelected:
			if (msgList_listWindowTop(ownTopWdw))
				msgList_listSetFlags(ownTopWdw, setBits, clearBits);
			else if (treeList_treeWindowTop(ownTopWdw))
				treeList_treeSetFlags(ownTopWdw, setBits, clearBits);
			break;
		}
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID SelectFont(HWND ownTopWdw, _UWORD kstate)
{
	HVDI hdl;

	UNUSED(kstate);
	WdwManager_GetTopWindow(&ownTopWdw, &hdl);
	if (hdl > 0)
	{
		if (grin_grinWindowTop(ownTopWdw))
		{
			grin_SelectFont(ownTopWdw);
		} else if (Editor_IsEditTop(ownTopWdw))
		{
			Editor_SelectFont(ownTopWdw);
		} else if (msgList_listWindowTop(ownTopWdw))
		{
			msgList_SelectFont(ownTopWdw);
		} else if (MsgWindow_msgWindowTop(ownTopWdw))
		{
			MsgWindow_SelectFont(ownTopWdw);
		} else if (treeList_treeWindowTop(ownTopWdw))
		{
			treeList_SelectFont(ownTopWdw);
		}
	}
}

/*** ---------------------------------------------------------------------- ***/
/*DYJ 5.20ze */	/*DYJ 5.21b */	/*DYJ 5.21i */	/*DYJ 5.22f */	/*DYJ 5.23e */
LOCAL _VOID MenuMessageHandler(_WORD item, _WORD title, _UWORD kstate)
{
	HWND ownTopWdw;
	_BOOL saveBlock;

	if (!mouse)
	{
		MouseOn();
		mouse = TRUE;
	}
	ownTopWdw = WdwManager_GetOwnTopWindow();

	switch (item)
	{
	case TABOUT:
		DoAbout();
		break;

	/*
	 * Datei-Menu
	 */
	case EDITFILE:
	case TMERGE:
		handleFSelMessage(item == TMERGE, ownTopWdw);
		break;

	case EDITMESS:
		if (MTPaths_DatabaseLocked())
			MsgWindow_msgOpen(TRUE);
		break;

	case TCLOSE:
		if (!WdwManager_WindowIsIcon(theTopWindow))
			WdwManager_CloseWindow(theTopWindow, FALSE);
		break;

	case TSAVE:
		if (Editor_IsEditTop(ownTopWdw))
			Editor_EditSave(ownTopWdw, NULL, NULL, FALSE,FALSE);
		break;

	case SAVEAS:
		if (msgList_listWindowTop(ownTopWdw))
		{
			msgList_listSaveAs(ownTopWdw, CatGlobal_WithCtrl(kstate));
		}
		else if(treeList_treeWindowTop(ownTopWdw))
		{
			treeList_treeSaveAs(ownTopWdw, CatGlobal_WithCtrl(kstate));
		} else
		{
			CONST _UBYTE *message;

			if (Editor_IsEditTop(ownTopWdw) &&	Editor_BlockIsMarked(ownTopWdw) &&
				mtAlerts_Alert(1, Rsc_WrkString(AL_BLOCK_SAVE)) == 1)
			{
				message = MausTauschrsc_WrkString(FS_SAVE_BLOCK_AS);
				saveBlock=TRUE;
			}
			else
			{
				message = Rsc_WrkString(FS_SAVE_AS);
				saveBlock=FALSE;
			}
			if (mtDir_FselGet(SavePath, SaveName, ALL_FILE_MASK, message, FALSE))
				if (Editor_IsEditTop(ownTopWdw))
					Editor_EditSave(ownTopWdw, SavePath, SaveName, TRUE,saveBlock);
		}
		break;
/*DYJ 5.32f Start*/
	case TEXP:
		exportText(ownTopWdw);
		break;

/*DYJ  Ende; */
	case TPRINT:
		printFile(ownTopWdw);
		break;

	case MSTARTIT:
		StartIt();
		break;

	case CALLSHEL:
		DoShell();
		break;

	case MAUSINFO:
		if (MTPaths_DatabaseLocked())
			CallInfo();
		break;

	case LOADINF:
		ReadInfoFile(TRUE, FALSE);
		break;

	case TQUIT:
		if (!UserBLK.SillyChecks || batchProcess || mtAlerts_AlertRSC(1, AL_QUIT) == 1)
		{
			if (SaveAllPositions)
			{
				EndOfPrg = CatUtil_WriteSavePos(FALSE, TRUE);
			} else
			{
				grin_grinCloseAll();
				msgList_listCloseAll();
				treeList_treeCloseAll();
				msgList_listFreeAll();
				CatButtons_CloseButton(TRUE);
				EndOfPrg = WdwManager_CloseAllWindows(FALSE);
			}
			if (EndOfPrg)
				return;
		}
		break;

	/*
	 * Bearbeiten-Menu
	 */
	case TUNDO:
		if (grin_grinWindowTop(ownTopWdw))
			grin_UndoPos(ownTopWdw);
		else if (Editor_IsEditTop(ownTopWdw))
			Editor_DoUndo(ownTopWdw);
		break;

	case TCUT:
		cutWdw(ownTopWdw, CatGlobal_WithShift(kstate), TRUE);
		break;

	case TCOPY:
		copyWdw(ownTopWdw, CatGlobal_WithShift(kstate));
		break;

	case TPASTE:
		Editor_EditPaste(ownTopWdw);
		break;

	case TSELALL:
		selectAll(ownTopWdw);
		break;

	case BLOCKROT:
		ProcessFilter(ownTopWdw, TRUE);
		break;

	case BLKPROT:
		Editor_BlockProtect(ownTopWdw);
		break;

	case BLKUPROT:
		Editor_BlockUnProtect(ownTopWdw);
		break;

	case WRITEBLO:
		QuoteBlock(ownTopWdw, CatGlobal_WithShift(kstate));
		break;

	case INFOLINE:
		WriteInfoline(ownTopWdw, kstate);
		break;

	case FINDREPL:
		CatOpts_DoSearch();
		break;

	case TTSAGAIN:
		CatOpts_DoSearchAgain(kstate);
		break;

	case BREPL:
		CatOpts_DoReplace(ownTopWdw);
		break;

	case TCHFLAG:
		ChangeFlags(ownTopWdw);
		break;
/*DYJ 5.36c Start*/
	case ME_PUTZ_A:
		if (MTPaths_DatabaseLocked())
			StartPutz(" -q -apc");
		break;
	case ME_PUTZ_M:
		if (MTPaths_DatabaseLocked())
			StartPutz("");
		break;
	case ME_PUTZ_G:
		if (MTPaths_DatabaseLocked())
		{
			_UBYTE cmd[128]=" -q -l";
			CAT_GROUP_NUMBER nr;
			if (ListHelp_SelectGroup(cmd+6, sizeof(cmd)-6, &nr, FALSE, TRUE, FALSE, gsmPutz))
				StartPutz(cmd);
		}
		break;
/*DYJ  Ende; */

	/*
	 * Nachrichten-Menu
	 */
	case TNEUE:
		CatButtons_ButtonHandler(READNEW);
		break;

	case TUNREAD:
		CatButtons_ButtonHandler(READUNREAD);
		break;

	case TLASTPOS:
		CatButtons_ButtonHandler(READPOS);
		break;

	case TANFANG:
		CatButtons_ButtonHandler(READALL);
		break;

	case TDATUM:
		CatButtons_ButtonHandler(READDATE);
		break;

	case TNUMMER:
		CatButtons_ButtonHandler(READNUM);
		break;

	case TREADMSG:
		CatButtons_ButtonHandler(BMess ? STICHWOR : MESSAGES);
		break;

	case TNEWALLG:
		CatButtons_ButtonHandler(NEWMESS);
		break;

	case TNEWPERS:
		CatButtons_ButtonHandler(NEWPERS);
		break;

	case TRESUB:
		WiederVorlage_SelectResub(WVL);
		break;
		
	case TCMTS:
		WiederVorlage_SelectResub(CMTS);		/* MH */
		break;

	case TSEARCH:
		if (grin_grinWindowTop(ownTopWdw))
			grin_SearchMenu(ownTopWdw);
		else if (msgList_listWindowTop(ownTopWdw))
			msgList_listSearch(ownTopWdw);
		break;

	case TMSAGAIN:
		grin_DoSearch(ownTopWdw, !CatGlobal_WithShift(kstate));
		break;

	case TSUCHNB:
		grin_grinNextNotWorked(ownTopWdw, CatGlobal_WithShift(kstate));
		break;

	/*
	 * Fenstermenu
	 */
	case CYCLEWIN:
		WdwManager_TopNextWindow();
		break;

	case FULLWIN:
		WdwManager_FullWindow(ownTopWdw);
		break;

	case CLOSEALL:
		grin_grinCloseAll();
		msgList_listCloseAll();
		treeList_treeCloseAll();
		buttonWindowLocked = TRUE;
		WdwManager_CloseAllWindows(FALSE);
		buttonWindowLocked = FALSE;
		break;

	case TBUTTONW:
		CatButtons_DisplayButton(FALSE);
		break;

	case WSTACKED:
		WdwManager_ArrangeWindows(STACKED);
		break;

	case WNEBEN:
		WdwManager_ArrangeWindows(BYSIDE);
		break;

	case WSTAFFEL:
		WdwManager_ArrangeWindows(OVERLAP);
		break;

	case WTILED:
		WdwManager_ArrangeWindows(TILED);
		break;

	/*
	 * Tausch-Menu
	 */
	case MAKEEIN:	/* Infile erstellen */
		if (MTPaths_DatabaseLocked())
			if (!UserBLK.SillyChecks || batchProcess || mtAlerts_AlertRSC(1, AL_MAKE_INFILE) == 1)
				CreateInfile();
		break;

	case DECODE:	/* Outfile einfuegen */
		if (MTPaths_DatabaseLocked())
		{
			{
				_BOOL withShift;
				withShift=CatGlobal_WithShift(kstate);
				if (withShift|| !UserBLK.SillyChecks || batchProcess || mtAlerts_AlertRSC(1, AL_INS_OUTFILE) == 1)
					DecodeOutfile(!withShift);
			}
		}
		break;

	case TTERMINAL:	/* Terminalprogramm starten */
		if (MTPaths_DatabaseLocked())
			StartTerminal(FALSE);
		break;

	case ABRUFEIN:	/* Infile konfigurieren */
		if (MTPaths_DatabaseLocked())
			CatOpts_DoAbruf();
		break;

	case INFOSEIN:	/* Infofiles einstellen */
		if (MTPaths_DatabaseLocked())
			CatOpts_DoInfos();
		break;

	case TCALLITK:	/* Tauschkommandos */
		if (MTPaths_DatabaseLocked())
			DoITK_SelectCmd();
		break;

	case MGETUSER:	/* User an-/abstellen */
		if (MTPaths_DatabaseLocked())
			CatOpts2_DoUserSelect();
		break;

	case TGRAUSWA:	/* Gruppen bestellen */
		if (MTPaths_DatabaseLocked())
			GruppenAuswahl_DoGroupSelect();
		break;
	case TE_ALIAS:	/* Eigene Alias-Namen */
		if (MTPaths_DatabaseLocked())
			E_Alias_Config();
		break;
	case TG_ALIAS:	/* Gruppen Alias-Namen */
		if (MTPaths_DatabaseLocked())
			Alias_Config();
		break;
	
	/*
	 * Optionen-Menu
	 */
	case OLANGUAGE:	/* Sprache */
	{
		_WORD strNr=-1;
		TEXTFILENO tf;
		_UBYTE *lang,cld[PATH_MAX];
		_UBYTE *home;
		switch(mtAlerts_AlertRSC(1, AL_LANGUAGE))
		{
			case 1: /*Deutsch*/
				strNr=AL_DEUTSCH;
				lang=LANGUAGE_DE;
				break;
			case 2: /*Englisch*/
				strNr=AL_ENGLISH;
				lang=LANGUAGE_EN;
				break;
		}
		if ((home = getenv("HOME")) != NULL && *home != '\0')
			strCpy(cld,home);
		else
			strCpy(cld,HomePath);

		F_Path_Append(cld, CAT_LANG_FILE);

		if (mtTextfiles_OpenTextfile(cld, WRITE, 512, &tf) == GERR_OK)
		{
			mtTextfiles_WriteLine(tf, lang);
			mtTextfiles_CloseTextfile(&tf);
		}
		mtAlerts_AlertRSC(1,strNr);
		break;
	}
	case AOPTIONS:	/* allgemeine Einstellungen */
		CatOpts_DoOption();
		break;

	case TOPTIONS:	/* Tausch-Einstellungen */
		CatOpts_DoTausch();
		break;

	case APRINTER:	/* Drucker */
		CatOpts_doPrinter();
		break;

	case OLISTE:	/* Stichwortliste */
		CatOpts_doList();
		break;

	case AKONFIG:	/* Konfiguration */
		CatOpts_doConfig(0,0);
		break;

	case OHLPPRG:	/* Hilfsprogramme */
		CatOpts2_doHilfsPrg();
		break;
	
	case OIOFILT:	/* IO-Filter */
		CatOpts2_doIOFilter();
		break;
/*DYJ 5.32b Start*/
	case OCBC:	/* CbC-Vorvorwahl*/
		CatOpts2_doCbC();
		break;
	case OPMF:	/* PM-Filter */
		CatOpts2_doPMFilter();
		break;
/*DYJ  Ende; alt:	
	case OCBC_PMF:	/* CbC-Vorvorwahl oder PM-Filter */
		if(UserBLK.isInternet)
			CatOpts2_doPMFilter();
		else
			CatOpts2_doCbC();
		break;
*/
	
	case ODIALOG_SIZES:	/* Dialog-Boxen */
		MausTauschrsc_DialogSizes();
		break;
	
	case OSHORTCUTS:	/* Tastenkuerzel */
		MausTauschrsc_Shortcuts();
		break;
	
	case OSOUNDS:	/* Klaenge */
		CatOpts2_EditSounds();
		break;
	
	case AFORMATS:	/* Formate fuer Info- und Stichwortzeilen */
		CatOpts_doFormat();
		break;

	case OFLOSKEL:	/* Floskeltasten */
		CatOpts2_doFloskel();
		break;

	case OGROUPS:	/* Lesereihenfolge fuer Gruppen aendern */
		{
			group_line gruppe;
			CAT_GROUP_NUMBER nr;

			ListHelp_SelectGroup(gruppe, sizeof(gruppe), &nr, FALSE, TRUE, FALSE, gsmModify);
		}
		break;

	case EFONT:		/* Zeichensatz */
		SelectFont(ownTopWdw, kstate);
		break;

	case OCOLOR:	/* Farben */
		CatOpts_doColor(ownTopWdw);
		break;

	case OEDITOR:	/* Allgemeine Editor-Einstellungen */
		CatOpts_doEditor(ownTopWdw);
		break;

	case OPSAVE:	/* Optionen sichern */
		if (!UserBLK.SillyChecks || batchProcess || mtAlerts_AlertRSC(1, AL_SAVE_CNF) == 1)
			UserInformation_WriteUserBlock();
		break;
	}
	menu_tnormal(TreeAddr[MENU], title, 1);
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

/*DYJ 5.20ze */
LOCAL _BOOL HandleCommandArgs(COMMAND_ARGS *args)
{
	batchProcess = TRUE;
	if (args->makeInfile)
		MsgInfile_MakeInFile();
	if (args->startTerminal)
		StartTerminal(TRUE);
	if (args->decodeOutfile && !UserBLK.TerminalAsOverlay)
		DecodeOutfile(TRUE);
	if (args->quitProg)
		EndOfPrg = TRUE;
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

/*DYJ 5.23h *//*DYJ 5.25a */
LOCAL _BOOL DecodeCommandArgs(int argc, CONST _UBYTE **argv, COMMAND_ARGS *args)
{
	_UBYTE *ptr;
	CONST _UBYTE *arg,*mailto;
	_BOOL batch;
	CONST _UBYTE *subject;
	size_t len;
	
	args->makeInfile = FALSE;
	args->startTerminal = FALSE;
	args->decodeOutfile = FALSE;
	args->quitProg = FALSE;
	args->inf = NULL;
	args->batch = FALSE;
	args->mailto[0] = '\0';
	args->subject[0] = '\0';
	batch = FALSE;
	while (--argc)
	{
		if (*(arg = *++argv) == '-')
		{
			while (*++arg != '\0')
			{
				switch (*arg)
				{
					case 'i':
					case 'I': args->makeInfile = TRUE; break;
					case 't':
					case 'T': args->startTerminal = TRUE; break;
					case 'o':
					case 'O': args->decodeOutfile = TRUE; break;
					case 'q':
					case 'Q': args->quitProg = TRUE; break;
				}
			}
			batch = TRUE;
		} else if ((mailto=strCaseStr(arg, "mailto:")) != NULL)
		{
			arg =mailto+ 7;
			subject = strChr(arg, '?');
			if (subject != NULL && strnCaseCmp(subject, "?subject=", 9) == 0)
			{
				strBcpy(args->subject, subject + 9);
				len = subject - arg;
			} else
			{
				len = strLen(arg);
			}
			if (len >= sizeof(args->mailto))
				len = sizeof(args->mailto) - 1;
			strMcpy(args->mailto, len + 1, arg);
		} else if (args->inf == NULL)
		{
			args->inf = arg;
		} else
		{
			/* mehr als ein Parameter geht nicht,
			   muesste eigentlich Fehlermeldung geben */
		}
	}
	ptr=strrChr(args->mailto,'.');
	if(!strCaseCmp(ptr,".cm2"))
		*ptr='\0';
	ptr=strrChr(args->subject,'.');
	if(!strCaseCmp(ptr,".cm2"))
		*ptr='\0';
	return batch;
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/
/*DYJ 5.21b */
LOCAL _VOID clickHandler(_WORD x, _WORD y, _UWORD Button, _WORD Clicks, _UWORD kstate)
{
	HWND wdw;
	_WORD res;
	_UBYTE popStr[80];

	if ((Button & MOB_RIGHT) && !(Button & MOB_LEFT))
	{
		wdw = WdwManager_ClickInWindow(x, y);
		if (wdw >= 0)
		{
			if (Editor_IsEditTop(wdw) &&
				Editor_ClickIsInBlock(wdw, x, y) &&
				Clicks == 1)
			{
				if (grin_grinWindowTop(wdw))
				{
					strBcpy(popStr, MausTauschrsc_WrkString(FS_COPY_FILT_LNK));
					/* Testen, ob Topwindow Editorfenster ist */
					if (!grin_grinWindowTop(theTopWindow) && Editor_IsEditTop(theTopWindow))
					{
						/* Quoten ist auch moeglich */
						strBcat(popStr, MausTauschrsc_WrkString(FS_QUOTE));
					}
					res = mtPopups_PosPopup(x, y, popStr, "");
					switch (res)
					{
						case 0: Editor_EditCopy(wdw); break;
						case 1: ProcessFilter(wdw, FALSE); break;
						case 2: LinkBlock(wdw); break;
						case 3: QuoteBlock(theTopWindow, CatGlobal_WithShift(kstate)); break;
					}
				} else
				{
					/* Normaler Editor ist Top */
					strBcpy(popStr, MausTauschrsc_WrkString(FS_BLOCK_POP));
					res = mtPopups_PosPopup(x, y, popStr, "");
					switch (res)
					{
						case 0: Editor_EditPaste(wdw); break;
						case 1: Editor_EditCut(wdw, TRUE); break;
						case 2: Editor_EditCopy(wdw); break;
						case 3: ProcessFilter(wdw, FALSE); break;
						case 4: Editor_BlockProtect(wdw); break;
						case 5: Editor_BlockUnProtect(wdw); break;
					}
				}
			}
		}
	} else
	{
		CatButtons_ButtonHandler(CatButtons_ClickIsInButton(x, y));
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL keyHandler(_UBYTE scan, _UBYTE ch, _UWORD moKState)
{
	_WORD num;
	_UBYTE val[512];
	_UBYTE varName[40];
	_BOOL done;
	HWND topWindow;
	HWND sndWindow;
	_WORD feature=-1;

	UNUSED(ch);
	topWindow = WdwManager_GetOwnTopWindow();
	done = FALSE;
	switch (scan)
	{
	case KEY_F1: case KEY_F2: case KEY_F3: case KEY_F4: case KEY_F5:
	case KEY_F6: case KEY_F7: case KEY_F8: case KEY_F9: case KEY_F10:
	case KEY_SHIFTF1: case KEY_SHIFTF2: case KEY_SHIFTF3: case KEY_SHIFTF4: case KEY_SHIFTF5:
	case KEY_SHIFTF6: case KEY_SHIFTF7: case KEY_SHIFTF8: case KEY_SHIFTF9: case KEY_SHIFTF10:
		done = TRUE;
		if (!mouse)
		{
			MouseOn();
			mouse = TRUE;
		}
		if (!(CatGlobal_WithShift(moKState) ||
			  CatGlobal_WithCtrl(moKState) ||
			  CatGlobal_WithAlt(moKState)))
		{
			/* eigentlich ueberfluessig, laueft mittlerweile ueber die Menuefunktionen */
			switch (scan)
			{
				/* Funktionstasten, also ButtonHandler aufrufen! */
				case KEY_F1: CatButtons_ButtonHandler(READNEW); break;
				case KEY_F2: CatButtons_ButtonHandler(READUNREAD); break;
				case KEY_F3: CatButtons_ButtonHandler(READPOS); break;
				case KEY_F4: CatButtons_ButtonHandler(READALL); break;
				case KEY_F5: CatButtons_ButtonHandler(READDATE); break;
				case KEY_F6: CatButtons_ButtonHandler(READNUM); break;
				case KEY_F7: CatButtons_DisplayButton(FALSE); break;
				case KEY_F8: CatButtons_ButtonHandler(BMess ? STICHWOR : MESSAGES); break;
				case KEY_F9: CatButtons_ButtonHandler(NEWMESS); break;
				case KEY_F10: CatButtons_ButtonHandler(NEWPERS); break;
				default: done = FALSE; break;
			}
		} else if (!CatGlobal_WithCtrl(moKState) &&
			CatGlobal_WithShift(moKState) &&
			!CatGlobal_WithAlt(moKState) &&
			scan >= KEY_SHIFTF1)
		{
			if (Editor_IsEditTop(topWindow) && (lastEvent & MU_TIMER))
			{
				/* mit Shift! */
				num = scan - KEY_SHIFTF1 + 1;
				make_varname(varName, sizeof(varName), cShiftF, num);
				if (ConfVars_GetConfigString(varName, val, sizeof(val)))
					Editor_PutLine(topWindow, val, strLen(val));
			}
		} else if (CatGlobal_WithCtrl(moKState) &&
			!CatGlobal_WithShift(moKState) &&
			!CatGlobal_WithAlt(moKState) &&
			scan <= KEY_F10)
		{
			if (Editor_IsEditTop(topWindow) && (lastEvent & MU_TIMER))
			{
				/* mit Control! */
				num = scan - KEY_F1 + 1;
				make_varname(varName, sizeof(varName), cControlF, num);
				if (ConfVars_GetConfigString(varName, val, sizeof(val)))
					Editor_PutLine(topWindow, val, strLen(val));
			}
		} else if (mayUseHidden && CatGlobal_WithAlt(moKState))
		{
			switch (scan)
			{
			case KEY_F1:
				/* Alt-F1:
				 * Alle folgenden Nachrichten auf Gelesen setzen und zur naechsten Gruppe
				 */
				feature=0;
				break;
			case KEY_F2:
				/* Alt-F2:
				 * Alle Ungelesenen auf Gelesen setzen und zur naechsten Gruppe
				 */
				feature=1;
				break;
			case KEY_F3:
				/* Alt-F3:
				 * Zur naechsten Gruppe
				 */
				feature=2;
				break;
			case KEY_F4:
				/* Alt-F4: Fenster schliessen
				 */
				WdwManager_CloseWindow(topWindow, FALSE);
				break;
			case KEY_F10:
				/* Alt-F10: Nachricht an SNAPSHOT schicken
				 */
				{
					HWND wdw;
					
					wdw = WdwManager_GetOwnTopWindow();
					if (wdw < 0)
						wdw = CatButtons_WinHandle;			/* ist nicht in der Window-Queue! */
					WdwManager_Snapshot(wdw);
				}
				break;
			default:
				done = FALSE;
				break;
			}
			if(feature>-1)
			{
				if(!grin_hiddenFeature(topWindow, feature, moKState))
				{
					if (mayUseHidden>1 && WdwManager_GetSecondWdw(&sndWindow))
						grin_hiddenFeature(sndWindow, feature, moKState);
				}
			}
	 	}
	 	break;

	/* Handling fuer ALT-0..9 fuer Message-Abruf! */
	case KEY_help:
		doHelp(topWindow, moKState);
		done = TRUE;
		break;
	}
	return done;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL OnlyWildcards(CONST _UBYTE *name)
{
	while (*name != '\0')
	{
		if (strChr("*?.", *name) == NULL)
			return FALSE;
		name++;
	}
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL progStart(CONST _WORD *message, _UBYTE *pName, _UBYTE *pCmd)
{
	_UBYTE path[PATH_MAX];
	_UBYTE name[PATH_MAX];

	UNUSED(message);
	if (pName != NULL)
	{
		strBcpy(path, pName);
		F_Path_Dirname(path);
		strBcpy(name, F_Path_Basename(pName));
		return StartPrg(path, name, pCmd ? pCmd : (CONST _UBYTE *)"", TRUE, TRUE, &chPid) == 0;
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL openWind(CONST _WORD *message, _UBYTE *pName, _UBYTE *pCmd)
{
	/* AV_OPENWIND: Editor mit Datei oeffnen */
	UNUSED(message);
	if (pCmd == NULL || OnlyWildcards(pCmd))
	{
		if (pName != NULL)
			strBcpy(openPath, pName);
		*openSel = '\0';
		if (handleFSelMessage(FALSE, WdwManager_GetOwnTopWindow()))
			return TRUE;
	} else
	{
		MTEdit2_OpenEditWindow(pName, pCmd, FALSE, FALSE);
		return TRUE;
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL vaStart(CONST _WORD *message, CONST _UBYTE *pCmd)
{
	_UBYTE name[PATH_MAX];
	COMMAND_ARGS args;
	CONST _UBYTE *argv[2];
	
	UNUSED(message);
	/* VA_START: pCmd enthaelt Kommandozeile */
	if (pCmd != NULL && *pCmd != '\0')
	{
		/* Jetzt Kommandozeile auswerten:
		 * entweder ist ein Dateiname enthalten oder sie faengt mit
		 * - an und ist eine Kommandoliste
		 */
		argv[0] = "";
		argv[1] = pCmd;
		if (DecodeCommandArgs(2, argv, &args))
		{
			HandleCommandArgs(&args);
			batchProcess = FALSE;
		} else if (args.inf != NULL)
		{
			/* Ist wohl ein Dateiname, also INF laden */
			mtDir_SplitPath(args.inf, infPath, infName, name);
			ReadInfoFile(FALSE, FALSE);
		} else if (args.mailto[0] != '\0')
		{
			grinTools_NewMessage(args.mailto, args.subject);
		}
	} else
	{
		/* Leere Kommandozeile, Fenster toppen */
		CatButtons_DisplayButton(FALSE);
	}
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/
/*DYJ 5.20ze */	/*DYJ 5.21b */
LOCAL _BOOL msgHandler(CONST _WORD *pBuff, _UWORD kstate)
{
	_BOOL done;

	done = Protokoll_Check_Message(pBuff);
	switch (pBuff[0])
	{
	case MN_SELECTED:
		event &= ~MU_BUTTON; /* keine Buttons */
		MenuMessageHandler(pBuff[4], pBuff[3], kstate);
		break;

	case AP_TERM:
/*DYJ 5.32e Start*/
	case AP_RESCHG:
		SPEC_DEBUG_OUT((EO_TRACE, "AP_TERM/AP_RESCHG:%d",pBuff[0]));
/*DYJ  Ende; alt:	
		SPEC_DEBUG_OUT((EO_TRACE, "AP_TERM"));
*/
		if (SaveAllPositions)
			CatUtil_WriteSavePos(TRUE, TRUE);
		fastExit = TRUE;
		EndOfPrg = TRUE;
		WinDialExit=TRUE;
		break;

	case CH_EXIT:
		/* Tochterprozess beendet */
		SPEC_DEBUG_OUT((EO_TRACE, "CH_EXIT: ID=%d; Ret=%d", pBuff[3],pBuff[4]));
		if (termPid > 0 && pBuff[3] == termPid)
		{
			/* Terminalprogramm beendet */
			termPid = -1;
			if (pBuff[4] == 0)
			{
				_WORD wait;

				wait = 0;
				if (ConfVars_GetConfigInt(cWaitAfterTerm, &wait))
				{
					Wind_Update(END_UPDATE);
					EventTimer((_LONG)wait * 1000L);
					Wind_Update(BEG_UPDATE);
				}
				/* Nur bei Exitcode 0 */
				if (UserBLK.ImportAfterTermPrg &&
					(!UserBLK.SillyChecks || batchProcess ||
					 mtAlerts_AlertRSC(1, AL_INS_OUTFILE_NOW) == 1))
				{
					DecodeOutfile(TRUE);
				}
			}
			if (!batchProcess && !EndOfPrg && termStarted)
			{
				WiederVorlage_CheckForResub();
				termStarted = FALSE;
			}
		}
		else
			CatOpts_doConfig(pBuff[3],pBuff[4]);
		break;

	case SC_CHANGED:
		/* Clipboardinhalt hat sich geaendert */
		Clip_ScrapIsDirty();
		break;

	default:
		done = FALSE;
		break;
	}
	return done;
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

LOCAL _BOOL crash;
LOCAL _WORD loglevel;
LOCAL _WORD tracelevel;
LOCAL FILE *logfile;
LOCAL _UBYTE logfile_name[PATH_MAX];
LOCAL ERROROUT_FUNC old_error;

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID LogOpen(_VOID)
{
	_UBYTE backup[PATH_MAX];
	
	if (getenv("CAT_LOGLEVEL") != NULL)
		loglevel = StrToInt(getenv("CAT_LOGLEVEL"), NULL, NULL);
	else
		loglevel = 3;
	tracelevel = -1;
#if SPEC_DEBUG
	is_DEBUGGING=(loglevel==4);
#endif
	if (loglevel >= 0)
	{
		F_Path_Get_Program(logfile_name, "catdebug.log");
		F_Path_Get_Program(backup, "catdebug.bak");
		F_File_Delete(backup);
		F_Path_Rename(logfile_name, backup);
		SPEC_DEBUG_OUT((EO_DEBUG, "*** starting"));
		SPEC_DEBUG_OUT((EO_DEBUG, "Cat Version: "CatVersion" vom "CatDate));
	}
}

/*** ---------------------------------------------------------------------- ***/
/*DYJ 5.21b */
LOCAL _VOID LogClose(_VOID)
{
	_UBYTE msg[300];
	SPEC_DEBUG_OUT((EO_DEBUG, "*** exiting"));
	if(AnzErr)
	{
		sprintf(msg,MausTauschrsc_WrkString(ERR_CAT_FAT),AnzErr,logfile_name);

		form_alert(1, msg);
	}
	ErrorOut_SetFunk(old_error);
	loglevel = -1;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID cleanup(_VOID)
{
	MouseOn();
	ResetMenuline();
	CatButtons_CloseButton(TRUE);
	if (SaveAllPositions && crash)
	{
		CatUtil_WriteSavePos(fastExit, TRUE);
	} else
	{
		grin_grinCloseAll();
		msgList_listCloseAll();
		treeList_treeCloseAll();
		WdwManager_CloseAllWindows(fastExit);
	}
	msgList_listFreeAll();
	data_WritePos();       /* Positionstabelle zurueckschreiben */
	if (UserBLK.AutoSaveOptions)
		UserInformation_WriteUserBlock(); /* Userinfo schreiben               */
	if (UserBLK.MakeInfileAtEnd)
		MsgInfile_MakeInFile();
	GroupSelect_SaveChangedGroupList();
	Protokoll_SendTerminate(TRUE);
/*DYJ 5.36c Start*/
	if (!startTerm && !*startPutzCmd && minTos14 && !neoDeskBugFix)
/*DYJ  Ende; alt:	
	if (!startTerm && minTos14 && !neoDeskBugFix)
*/
	{
		shel_write(0, 1, 0, "", ""); /* Dann den ShelWrite zuruecknehmen */
	}
	if (crash)
		Parser_EmergencyClose(); /* catlog.txt schliessen */
	ConfVars_CloseConfig();                   /* catuser.req schliessen, falls offen */
#if DEBUG_ALLOC
	/*
	 * noch den restlichen Speicher freigeben
	 */
	if (!crash)
	{
		/* ClrRsrc(); */
		grin_grinExit();
		msgList_ExitMsgList();
		MsgWindow_ExitMessageManager();
		Messages_ExitMessages();
		ConfVars_DeleteAllVars();
		Alias_Exit();
		Printer_FreeCFGFile();
		Infofiles_Exit();
		GroupSelect_Exit();
		WiederVorlage_Exit();
		adr_ClearList(ADR_NORMAL);
		adr_ClearList(ADR_ALIAS);
		data_CloseBase();
		MausTauschrsc_RscFree();
	} else
#else
	{
		mem_test_ignore();
	}
#endif
	MTPaths_Exit();
	Wind_Update(END_UPDATE);
}

/*** ---------------------------------------------------------------------- ***/

/* Hier kommt jetzt der Crash-Handler
 * Wird automatisch bei Terminierung des Programms aufgerufen
 */
/*** ---------------------------------------------------------------------- ***/
LOCAL _BOOL error_func(CONST _UBYTE *prg, EO_MODUS modus, _WORD nr, CONST _UBYTE *modestr, CONST _UBYTE *str)
{
	_WORD level;
	_UBYTE date[100];
	_WORD count, i;
	CONST _UBYTE *p;

	UNUSED(prg);
	UNUSED(nr);

	switch (modus)
	{
	case EO_INFO:
		modestr = "INFO  ";
		level = 1;
		break;
	case EO_DEBUG:
		modestr = "DEBUG ";
		level = 2;
		break;
	case EO_TRACE:
		modestr = "TRACE ";
		level = 3;
		break;
	case EO_ERROR:
		modestr = "*** Error: ";
		level = 0;
		break;
	case EO_FATAL:
	default:
		modestr = "*** Fatal: ";
		level = 0;
		break;
	case EO_EXIT:
		LogClose();
		return FALSE;
	case EO_INIT:
		LogOpen();
		return FALSE;
	}
	if(!level)
		AnzErr++;
	T_Strlftime(PtrSize(date), "%d.%m.%y %H:%M:%S", T_Systime());

	if (level <= tracelevel)
	{
		count = fprintf(stderr, "%s: %s", prg, modestr);
		for (p = str; *p != '\0'; p++)
		{
			putc(*p, stderr);
			if (*p == '\n')
			{
				for (i = 0; i < count; i++)
					putc(' ', stderr);
			}
		}
		putc('\n', stderr);
	}

	if (loglevel >= 0 && level <= loglevel)
	{
		if (logfile == NULL)
		{
			_WORD try = 5;
			
			while (logfile == NULL && try > 0)
			{
				logfile = fopen(logfile_name, "a");
				if (logfile != NULL)
					break;
				EventTimer(500);
				try--;
			}
			if (logfile == NULL)
			{
				ErrorOut_SetFunk(FUNK_NULL);
				loglevel = -1;
				ErrorOut(EO_FATAL, "can't create log file `%s', further logging disabled", logfile_name);
			}
		}
		if (logfile != NULL)
		{
			count = fprintf(logfile, "%-8.8s: %s %s", prg, date, modestr);
			for (; *str; str++)
			{
				putc(*str, logfile);
				if (*str == '\n')
				{
					for (i = 0; i < count; i++)
						putc(' ', logfile);
				}
			}
			putc('\n', logfile);
			fclose(logfile);
			logfile = NULL;
		}
	}
	return modus == EO_ERROR || modus == EO_FATAL;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID __CDECL sigHandler(_LONG sig)
{
	/* Sofort raus hier wenn wir schon mal hier waren */
	Psignal(SIGQUIT, SIG_IGN);
	Psignal(SIGTERM, SIG_IGN);
	Psignal(SIGPIPE, SIG_IGN);
	Psignal(SIGXCPU, SIG_IGN);
	Psignal(SIGHUP, SIG_IGN);
	Psignal(SIGSEGV, SIG_IGN);
	Psignal(SIGBUS, SIG_IGN);
	if (crash)
	{
		Wind_Update(END_UPDATE);
		Psigreturn();
		Pterm(3);
	}
	SPEC_DEBUG_OUT((EO_FATAL, "terminated by signal %ld", sig));
	fastExit = TRUE;
	EndOfPrg = TRUE;
	switch ((int)sig)
	{
	case SIGBUS:
	case SIGSEGV:
		crash = TRUE;
		break;
	}
	cleanup();
	mem_test_ignore();
	Psigreturn();
	ApplTerm(3);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID installSignalHandler(_VOID)
{
	/* Folgende Signale werden abgefangen und ignoriert:
	 * SIGHUP, SIGINT, SIGSYS,
	 */
	Psigblock((1L << SIGHUP) | (1L << SIGINT) | (1L << SIGSYS));
	/* Folgende Signale werden mit Programmterminierung befolgt:
	 * SIGQUIT, SIGPIPE, SIGTERM, SIGXCPU
	 * Dabei ist es mir egal, ob die Installation geklappt hat oder nicht.
	 */
#ifdef SIGQUIT
	Psignal(SIGQUIT, (_LONG)sigHandler);
#endif
#ifdef SIGTERM
	Psignal(SIGTERM, (_LONG)sigHandler);
#endif
#ifdef SIGPIPE
	Psignal(SIGPIPE, (_LONG)sigHandler);
#endif
#ifdef SIGXCPU
	Psignal(SIGXCPU, (_LONG)sigHandler);
#endif
#ifdef SIGHUP
	Psignal(SIGHUP, (_LONG)sigHandler);
#endif
#ifdef SIGSEGV
	Psignal(SIGSEGV, (_LONG)sigHandler);
#endif
#ifdef SIGBUS
	Psignal(SIGBUS, (_LONG)sigHandler);
#endif
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

LOCAL _BOOL globalKeyHandler(_WORD kReturn, _UBYTE ch, _UBYTE scan, _UWORD moKState)
{
	_BOOL done;

	/*
	 * UNDO wird hier nicht behandelt, weil es sonst nicht an die Fensterprozeduren
	 * weitergereicht wird
	 */
	if (scan != 0x61 &&
		/* (CatGlobal_WithCtrl(moKState) || CatGlobal_WithAlt(moKState)) && */
		MenuKey_Test(TreeAddr[MENU], kReturn, moKState, MenuMessageHandler, !mouse))
	{
		mouse = TRUE; /* Wird dann in MenuSearch gemacht */
		return TRUE;
	}
	done = keyHandler(scan, ch, moKState);
	if (mouse && !(CatGlobal_WithCtrl(moKState) || CatGlobal_WithAlt(moKState)) &&
		!WdwManager_ModalWindowTop())
	{
		if (dontSwitchOffMouse)
		{
			dontSwitchOffMouse = FALSE;
		} else
		{
			MouseOff();
			mouse = FALSE;
		}
	}
	return done;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID handleEvents(_VOID)
{
	HWND wdw;
	HVDI vdi;

	ClearBuffer(event, FALSE, moKState, scan, ch);

	/* Tastencodes mit Shift gehen immer zuerst an das Fenster! */
	WdwManager_HandleEvent(&event, mess, moButton, moKState, ch, scan, kReturn, moX, moY, bReturn);

	if (event & MU_M1)
	{
		if (!mouse)
		{
			MouseOn();
			mouse = TRUE;
		}
	}

	if (event & MU_BUTTON) /* Button */
	{
		clickHandler(moX, moY, moButton, bReturn, moKState);
	}

	if (!mouse)
	{
		/* Feststellen, ob das Fenster uns gehoert */
		WdwManager_GetTopWindow(&wdw, &vdi);
		if (vdi <= 0)
		{
			/* Fenster einer anderen Applikation ist oben, Maus anschalten */
			MouseOn();
			mouse = TRUE;
		}
	}
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

LOCAL _VOID release_left_button(_VOID)
{
	_WORD message[8];
	_WORD dummy;
	_UWORD udummy;

	/* Warten auf loslassen oder waitingTime */
	evnt_multi(MU_BUTTON | MU_TIMER,
		0, 3, 0,
		0, 0, 0, 0, 0,
		0, 0, 0, 0, 0,
		message,
		UserBLK.WaitingTime, 0,
		&dummy, &dummy, &udummy, &udummy, &dummy, &dummy);
}

/*** ---------------------------------------------------------------------- ***/
LOCAL _VOID read_catpos_inf(COMMAND_ARGS *args)
{
	_UBYTE path[PATH_MAX];
	_UBYTE suff[PATH_MAX];
	_BOOL found;

	ConfVars_ConfigConfigModule(TRUE);

	/* Jetzt temporaeren Pfad holen */
	/* Hier muessen wir nachsehen, ob im TMP-Dir ein CATPOS.INF
	 * existiert. Wenn ja, dann nehmen wir das. Wenn nein, dann
	 * versuchen wir es nochmal mit dem Applikationpath
	 */
	found = FALSE;
/*DYJ 5.30j Start*/
	if(args->inf && *args->inf)
	{
		MTPaths_ReadInf(path, suff, FALSE, FALSE, args->inf);
		strCpy(path,DataPath);
		F_Path_Append(path, tmpInf);
	}
	else
	{
		if ( CatFiles_GetHomeDir(path))
		{
			F_Path_Append(path, tmpInf);
			found = CatFiles_Exists(path);
		}
		if (!found && CatFiles_GetTmpDir(path))
		{
			F_Path_Append(path, tmpInf);
			found = CatFiles_Exists(path);
		}
		if (!found)
		{
			CatGlobal_ApplPath(path);
			F_Path_Append(path, tmpInf);
			/* found = CatFiles_Exists(path); */
		}
	}
/*DYJ  Ende; alt:	
	if (CatFiles_GetHomeDir(path))
	{
		F_Path_Append(path, tmpInf);
		found = CatFiles_Exists(path);
	}
	if (!found && CatFiles_GetTmpDir(path))
	{
		F_Path_Append(path, tmpInf);
		found = CatFiles_Exists(path);
	}
	if (!found)
	{
		CatGlobal_ApplPath(path);
		F_Path_Append(path, tmpInf);
		/* found = CatFiles_Exists(path); */
	}
*/
	/* CATPOS.INF lesen */
	if (ConfVars_ReadConfigFile(path))
	{
		configFileDa = TRUE;
		F_File_Delete(path);
		fromTerm = ConfVars_GetConfigString(cOverlayTerminal, TerminalName, sizeof(TerminalName));
		ConfVars_GetConfDefBool(cOverlayPutz,&fromPutz,FALSE );
		if (ConfVars_GetConfigString(cLastCatInf, lastInfName, sizeof(lastInfName)))
			mtDir_SplitPath(lastInfName, infPath, infName, suff);
		if (fromTerm)
		{
			ConfVars_GetConfDefBool(cDecodeAfterTerminal, &args->decodeOutfile, FALSE);
			ConfVars_GetConfDefBool(cQuitAfterTerminal, &args->quitProg, FALSE);
			ConfVars_GetConfDefBool(cBatchProcess, &args->batch, FALSE);
		}
	} else
	{
		fromTerm = FALSE;
		fromPutz = FALSE;	/*DYJ 5.36c */
		configFileDa = FALSE;
	}

	/* Und wieder auf normale Einstellung */
	ConfVars_ConfigConfigModule(FALSE);
}
/*** ------------------------------------------------------------------------ ***/
/*	_VOID start_putz_at_exit(_UBYTE *cmd)										*/
/*	Startet CatPutz																*/
/*	Parameter:	cmd: nicht Standardteil der Kommandozeile						*/
/*	Ergebnis:	keines															*/		
/*	26.4.04 von Dimitri Junker	DYJ 5.36c										*/
/*** ------------------------------------------------------------------------ ***/
LOCAL _VOID start_putz_at_exit(_UBYTE *cmd)
{
	_UBYTE putzName[PATH_MAX];
	_UBYTE infname[PATH_MAX];
	_BOOL boolVal,addCatPath=TRUE;
	_UBYTE cmdline[128];
	/* Falls ntig Gruppenname abfragen solange es noch eine Gruppenliste gibt*/
	/* Putzprogramm mittels ShelWrite starten */
	if(!ConfVars_GetConfigString(cCatPutzPath, putzName,sizeof(putzName)))
	{
		CatGlobal_ApplPath(putzName);
		F_Path_Append(putzName, "CATPUTZ.PRG");
		addCatPath=FALSE;
	}
	while(!CatFiles_Exists(putzName))
	{
		_UBYTE pEnd[FILENAME_MAX]="*.prg",pPath[PATH_MAX], pName[FILENAME_MAX];
		mtDir_SplitPath(putzName, pPath, pName, pEnd);
		if (pEnd[0] != '\0')
			Insert("*.", pEnd, sizeof(pEnd), 0);
		else
			strCpy(pEnd, "*.prg");
		if (mtDir_FselGet(pPath, pName, pEnd, MausTauschrsc_WrkString(FS_START_PROGRAM), FALSE))
		{
			strBcpy(putzName,pPath);
			F_Path_Append(putzName, pName);
			ConfVars_SetConfigString(cCatPutzPath, putzName);
			addCatPath=TRUE;
		}
		else
		{
			ConfVars_DeleteConfigVar(cCatPutzPath);
			return;
		}
	}
	
	/* Dateinamen zusammensetzen in altem Konfigbereich */
	CatUtil_GetPosPath(infname);
	F_Path_Append(infname, tmpInf);
	/* Variable setzen und rausschreiben */
	ConfVars_GetConfDefBool(cApplicationNameInWindow, &boolVal, TRUE);
	ConfVars_ConfigConfigModule(TRUE);
	ConfVars_SetConfigBool(cApplicationNameInWindow, boolVal);
	ConfVars_SetConfigBool(cOverlayPutz, TRUE);
	ConfVars_SetConfigString(cLastCatInf, lastInfName);
	ConfVars_SetConfigBool(cBatchProcess, FALSE);
	isTmp = TRUE;
	ConfVars_WriteConfigFile(infname, UserInformation_writeInfo);
	ConfVars_DeleteAllVars();
	ConfVars_ConfigConfigModule(FALSE);

	/* Parameterzeile basteln */
	/* Platz fuer Laenge! */
	strMcpy(cmdline + 1, sizeof(cmdline) - 1, lastInfName);
	strMcat(cmdline + 1, sizeof(cmdline) - 1, cmd);
	if(addCatPath)
	{
		_UBYTE pPath[PATH_MAX], pName[FILENAME_MAX];
		CatGlobal_ApplPath(pPath);
		CatGlobal_ApplName(pName);
		F_Path_Append(pPath, pName);
		strMcat(cmdline + 1, sizeof(cmdline) - 1, pPath);
	}
	cmdline[0] = (_UBYTE)strLen(cmdline + 1);
	/* Und los geht's */
	shel_write(1, 1, 0, putzName, cmdline);
	SPEC_DEBUG_OUT((EO_DEBUG, "shel_write at exit (%s, %s)", putzName, cmdline + 1));
}

/*** ---------------------------------------------------------------------- ***/
LOCAL _VOID start_terminal_at_exit(_BOOL decodeOutfile, _BOOL quitProg, _BOOL batch)
{
	_UBYTE termName[PATH_MAX];
	_UBYTE infname[PATH_MAX];
	_BOOL boolVal;
	_UBYTE cmdline[128];
	_UBYTE cmd[PATH_MAX*6];

	/* Terminalprogramm mittels ShelWrite starten */
	strBcpy(termName, TerminalPath);
	F_Path_Append(termName, TerminalName);

	/* Dateinamen zusammensetzen in altem Konfigbereich */
	CatUtil_GetPosPath(infname);
	F_Path_Append(infname, tmpInf);
	/* Variable setzen und rausschreiben */
	ConfVars_GetConfDefBool(cApplicationNameInWindow, &boolVal, TRUE);
	ConfVars_ConfigConfigModule(TRUE);
	ConfVars_SetConfigBool(cApplicationNameInWindow, boolVal);
	ConfVars_SetConfigString(cOverlayTerminal, termName);
	ConfVars_SetConfigString(cLastCatInf, lastInfName);
	ConfVars_SetConfigBool(cDecodeAfterTerminal, decodeOutfile);
	ConfVars_SetConfigBool(cQuitAfterTerminal, quitProg);
	ConfVars_SetConfigBool(cBatchProcess, batch);
	isTmp = TRUE;
	ConfVars_WriteConfigFile(infname, UserInformation_writeInfo);
	ConfVars_DeleteAllVars();
	ConfVars_ConfigConfigModule(FALSE);

	/* Parameterzeile basteln */
	/* Platz fuer Laenge! */
	convCbC(cmd,TerminalCmd,sizeof(cmd));
	strMcpy(cmdline + 1, sizeof(cmdline) - 1, cmd);
	strMcat(cmdline + 1, sizeof(cmdline) - 1, "/");
	strMcat(cmdline + 1, sizeof(cmdline) - 1, catName);
	cmdline[0] = (_UBYTE)strLen(cmdline + 1);
	/* Und los geht's */
	F_Path_Set(TerminalPath);
	shel_write(1, 1, 0, termName, cmdline);
	SPEC_DEBUG_OUT((EO_DEBUG, "shel_write at exit (%s, %s)", termName, cmdline + 1));
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID init_appl_name(_VOID)
{
	_UBYTE name[PATH_MAX];

	WinDials_SetApplicationName(ProgramName);
	CatGlobal_SetAppl(ProgramName);
	CatGlobal_GetApplPath(catName);
	CatGlobal_ApplName(name);
	F_Path_Append(catName, name);
}

/*** ---------------------------------------------------------------------- ***/
/*DYJ 5.21b */
LOCAL _VOID checkUsername(_VOID)
{
	_UBYTE line[256];
	TEXTFILENO tf;
	_UBYTE fname[PATH_MAX];
	
	if (!batchProcess && !EndOfPrg && strChr(userAddr, '@') == NULL)
	{
		/*
		 * noch alter Username (nur Mauskuerzel) eingetragen
		 * mal einen dezenten Hinweis geben
		 */
		MTE_infoRSC(AL_MAUSID);
		strBcpy(fname, prgPath);
		F_Path_Append(fname, "catkey.dat");
		if (mtTextfiles_OpenTextfile(fname, READ, 512, &tf) == GERR_OK)
		{
			mtTextfiles_ReadLine(tf, line, sizeof(line));
			mtTextfiles_CloseTextfile(&tf);
			strBcat(line, " @ ");
			strBcat(line, userAddr);
			ConfVars_SetConfigString(cMausId, line);
		}
		CatOpts_DoOption();
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL KeyMsg(CONST _WORD *pBuff, _WORD kReturn, _UWORD moKState)
{
	_UBYTE ch, scan;
	_UWORD evt;
	_BOOL done;
	
	done = FALSE;
	if (MenuKey_Test(TreeAddr[MENU], kReturn, moKState, MenuMessageHandler, !mouse))
	{
		mouse = TRUE;
		event &= ~MU_KEYBD; /* kein Keyboard */
		done = TRUE;
	} else
	{
		/* Event-Handler aufrufen mit MU_KEYBD */
		evt = MU_KEYBD;
		scan = (kReturn >> 8) & 0xff;
		ch = kReturn & 0xff;
		done = WdwManager_HandleEvent(&evt, pBuff, 0, moKState, ch, scan, kReturn, 0, 0, 0);
	}
	/* Anderer Tastendruck wird evtl. uebergemangelt.. */
	return done;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL TextMsg(CONST _WORD *message, _UBYTE *pName)
{
	HWND wdw;
	
	UNUSED(message);
	wdw = WdwManager_GetOwnTopWindow();
	if (Editor_IsEditTop(wdw))
	{
		return pName != NULL && Editor_PutLine(wdw, pName, strLen(pName));
	}
	return FALSE;
}
/*------------------------------------------------------------------*/
/*	long get_act_pd()												*/
/*																	*/
/*	Gibt die Basepage des aktuellen Proz. zurck					*/
/*																	*/
/*	Parameter:	keiner												*/
/*	Rckgabe :Die Funktion liefert als Ergebnis den Pointer, 		*/
/*		allerdings als long, wegen Supexec						 	*/
/*	(c) by Dimitri Junker 1996										*/
/*	nach Profibuch S.185											*/
/*	Besonderheit: mu per Supexec aufgerufen werden					*/
/*	DYJ 4.16 														*/
/*------------------------------------------------------------------*/
long get_act_pd(void)
{	BASEPAGE *bp;
	OSHEADER *os;
	
	os=*(OSHEADER **)_sysbase;
	os=os->os_beg;
	if(os->os_version<0x102)
	{
		if((os->os_conf>>1)==4)		/*Pal-Modus wegshiften*/
			return(0x873c);				/*spanisches TOS 1.0*/
		else
			return(0x602c);
	}
	bp=(BASEPAGE *)*os->p_run;
	return((long)bp);
}
/*** ------------------------------------------------------------------------ ***/
/*	_VOID unQuoteProz(_UBYTE *quell)											*/
/*	Ersetzt %xy durch das Zeichen mit dem Hex-Code xy							*/
/*	Parameter:	zu ndernder String												*/
/*	Ergebnis:	keines															*/		
/*	12.4.03 von Dimitri Junker	DYJ 5.26d										*/
/*** ------------------------------------------------------------------------ ***/
LOCAL _VOID unQuoteProz(_UBYTE *quell)
{
	_WORD val;
	_BOOL fertig=FALSE;
	_UBYTE *ziel=quell;
	if(quell)
	{
		while(!fertig)
		{
			switch(*quell)
			{
				case '%':
					if(quell[1]>='0')
					{
						sscanf(quell+1,"%2x",&val);
						*(ziel++) = val;
						quell+=3;
					}
					else
						quell++;
					break;
				case 0:
					fertig=TRUE;
				default:
					*(ziel++) = *(quell++);
			}
		}
	}
}
/*** ---------------------------------------------------------------------- ***/
/*DYJ 5.20ze */	/*DYJ 5.21b */	/*DYJ 5.21i */	/*DYJ 5.26d */
/*DYJ 5.27b */
#include <time.h>
#include <edittool.h>

int main(int argc, CONST char **argv)
{
	_WORD dummy;
	_WORD exit_code;
	COMMAND_ARGS args;
	_BOOL batch;
	EVENT e;
	EVNT ev;
	_BOOL noNiceLines;
	
	Fsetdta(&catDTA);
	keyWrite = 0;
	keyRead  = 0;
	termPid  = -1;
	termStarted = FALSE;
	chPid = -1;
	filterNumber = 0;
	altKeyPressed = FALSE;
	exit_code = 0;
	old_error = ErrorOut_SetFunk(error_func);
	ApplInit();
	installSignalHandler();
	CatGlobal_Init();
#if SPEC_DEBUG
	{
		_WORD i;
		
		for (i = 0; i < argc; i++)
			ErrorOut(EO_DEBUG, "argv(%d): %s", i, argv[i] ? argv[i] : "(null)");
		if(CanDoSuper())
		{
			ErrorOut(EO_DEBUG, "Basepage: %lX",(long)_BasPag);
			ErrorOut(EO_DEBUG, "Text: %lX",(long)_BasPag->p_tbase);
		}
	}
#endif
	SystemTimer();
	mtDials_Init();
	ConfVars_Init();
	WdwManager_Init();
	
	mtDials_DialConfig(UseConfig, FALSE);

	crash = FALSE;
	infPath[0] = '\0';
	infName[0] = '\0';
	/* CatchProcessTerm(rHdl, crashHandler, stck); */

	MouseBusy();

	/* Hier jetzt noch Name von CAT ermitteln */
	init_appl_name();

	if (multiTOS || (magIx && magIxVer >= 0x300))
	{
		/* MultiTOS */
		menu_register(gl_apid, CAT_MENUNAME);
	}
	menu_register(-1, ProgramName);
	
	{
		_WORD level, dummy;

		/* Und auch Bescheid sagen, dass wir AP_TERM verstehen */
		if ((appl_xgetinfo(APG_SHELLW, &level, &dummy, &dummy, &dummy) && ((level & 0xff) >= 9)) ||
			(magIxVer >= 0x300))
		{
			shel_write(9, 1, 1, NULL, NULL);
		}
	}

	/* feststellen, ob wir vom Terminalprogramm aus
	 * aufgerufen wurden
	 */
	/* Erste Ueberpruefung auf Alternate-Taste */
	CheckWithAlt(&altKeyPressed);

	batch = DecodeCommandArgs(argc, (CONST _UBYTE **)argv, &args);
	
	/* Jetzt CATPOS.INF lesen, falls da */
	read_catpos_inf(&args);
	
	/* Erstmal Aufloesung testen */
	if (!MausTauschrsc_RscInit())
	{
		MouseArrow();
		exit_code = 1;
	}
	else if (MaxWidth / CharWidth < 80)
	{
		MouseArrow();
		mtAlerts_Alert(1, Rsc_WrkString(AL_RESOLUTION));
		exit_code = 1;
	} else
	{
/*DYJ 5.36c Start*/
		if (!cat_init(FALSE, fromTerm|fromPutz, args.inf))
/*DYJ  Ende; alt:	
		if (!cat_init(FALSE, fromTerm, args.inf))
*/
		{
			exit_code = 1;
		} else
		{
			/* Ende Init-Prozeduren */
	
			/* crash wird zurueckgesetzt bei normalem Ende */
			crash = TRUE;
	
			strBcpy(openPath, MessagePath);
			openSel[0] = '\0';
	
			strBcpy(SavePath, MessagePath);
			CatGlobal_ApplPath(prgPath);
	
			EndOfPrg = FALSE;
	
			/* Menubar bei Windowmanager anmelden */
			WdwManager_InstallGlobalMenu(TreeAddr[MENU], msgHandler);
		
			/* Keyboardhandler bei Windowmanager anmelden */
			WdwManager_InstallGlobalKeyProc(globalKeyHandler);
		
			/* Hier jetzt die XACC-Initialisierung fuer MTOS */
			Xacc_Register_Key(KeyMsg);
			Xacc_Register_Text(TextMsg);
			VaProto_Register_Sendkey(KeyMsg);
			VaProto_Register_Startprog(progStart);
			VaProto_Register_Openwind(openWind);
			VaProto_Register_Start(vaStart);
			Protokoll_ProtoInit();
			
			WdwManager_HandlePendingEvents();    /* koennte auch reichen fuer Watchdog!! */
			Wind_Update(BEG_UPDATE); /* wg. sofort wieder aus.. */
	
			ConfVars_GetConfDefBool(cSaveAllPositions, &SaveAllPositions, FALSE);
			ConfVars_SetConfigBool(cSaveAllPositions, SaveAllPositions);
			*startPutzCmd='\0';	/*DYJ 5.36c */
			startTerm = FALSE;
			fastExit = FALSE;   /* Gibt an, ob ohne Rueckfrage beendet werden soll (Aufloesungswechsel unter MultiTOS) */
	
			if (!batch)
			{
				HlpPrg_RunPrg();
				CatGlobal_Bing(cBingProgramStart);
				
				startTerm = UserBLK.StartTermAtStart && !fromTerm;
				/* Dritte und letzte Ueberpruefung auf Alternate-Taste */
				CheckWithAlt(&altKeyPressed);
				if (altKeyPressed)
				{
					/*
					 * Hack fuer Debug-Zwecke: unter PD bekommen
					 * wir immer den Pfad von PD oder PC beim shel_read
					 */
					_UBYTE name[PATH_MAX];
					
					ApplName(name);
					if (strCaseStr(name, "PC") == NULL &&
						strCaseStr(name, "PD") == NULL)
/*DYJ 5.36c Start*/
					{
						startTerm = !startTerm;
						*startPutzCmd = '\0';
					}
/*DYJ  Ende; alt:	
						startTerm = !startTerm;
*/
				}
				if (startTerm && !fromTerm)
				{
					/* wieder loeschen, kann in StartTerminal neu gesetzt
					 * werden fuer Overlaystart!
					 */
					startTerm = FALSE;
					StartTerminal(FALSE);
/*DYJ 5.36c Start*/
				} else if (*startPutzCmd && !fromPutz)
				{
					StartPutz(NULL);
/*DYJ  Ende; */
				} else
				{
					/* is' doch schon..?
					 * Ne, ist nicht, kann ja auch fromTerm sein!
					 */
					startTerm = FALSE;
					*startPutzCmd = '\0';	/*DYJ 5.36c */
				}
	
				if (!EndOfPrg &&
					((UserBLK.ImportAtStart && (!startTerm || (startTerm && !UserBLK.ImportAfterTermPrg))) ||
					 (fromTerm && (UserBLK.ImportAfterTermPrg || (UserBLK.TerminalAsOverlay && args.decodeOutfile)))))
				{
					if (fromTerm && args.batch)
						batchProcess = TRUE;
					DecodeOutfile(TRUE);
					if (fromTerm && args.quitProg)
						EndOfPrg = TRUE;
				}
			} else
			{
				HandleCommandArgs(&args);
			}
	
			if (batchProcess && EndOfPrg && SaveAllPositions)
			{
				CatUtil_WriteSavePos(fastExit, TRUE);
			}
			
			if (!EndOfPrg)
				CatButtons_DisplayButton(TRUE);

			if (configFileDa)
			{
				ConfVars_ConfigConfigModule(TRUE);

				/* Alles wieder restaurieren */
				if (!EndOfPrg)
				{
					MsgWindow_msgRestorePos();
					grin_grinRestorePos();
					msgList_listRestorePos();
					Editor_EditRestorePos(TRUE);
				}
				ConfVars_DeleteAllVars();
				ConfVars_ConfigConfigModule(FALSE);
			}

			if (!EndOfPrg)
			{
				Wind_Update(END_UPDATE);
				WdwManager_HandlePendingEvents();    /* koennte auch reichen fuer Watchdog!! */
				Wind_Update(BEG_UPDATE);
				ConfVars_GetConfDefBool(cNoNiceLines, &noNiceLines, FALSE);
				if(!noNiceLines)
					InitMenuline(TreeAddr[MENU]);
				DrawMenuline(TreeAddr[MENU]);    /* show our menubar          */
	
				MouseArrow();
				mouse = TRUE;
				mrect.g_x = 0;
				mrect.g_y = 0;
				mrect.g_w = 1;
				mrect.g_h = 1;
			}
	
			/* Prozedur-Handler in WdwManager installieren */
			WdwManager_SetHandleNewTop(VDIStandards_enableNewTop);
			event = 0;
			
			if (args.mailto[0] != '\0')
			{
				unQuoteProz(args.mailto);
				if (args.subject[0] != '\0')
					unQuoteProz(args.subject);
				grinTools_NewMessage(args.mailto, args.subject);
			}
			
			if (!batchProcess && !EndOfPrg && !termStarted)
			{
				WiederVorlage_CheckForResub();
			}
			
			batchProcess = FALSE;
			crash = FALSE;
			checkUsername();

			while (!EndOfPrg)
			{
				VDIStandards_enableMenuItems(theTopWindow);
				Wind_Update(END_UPDATE);
	
				MouseState(&dummy, &mouse);
	
				if (PendingKey())
				{
					event = MU_KEYBD;
					PopKey(&moKState, &scan, &ch);
				} else
				{
					lastEvent = event;
	
					/* Rechte und Linke Maustaste abfragen */
					/* Geht in jeder TOS-Version und ist nun dokumentiert */

					e.ev_mflags = MU_KEYBD | MU_BUTTON | MU_MESAG | MU_TIMER;
					if (!mouse)
						e.ev_mflags |= MU_M1;
					e.ev_mwich = 0;
					e.ev_mbclicks = 256 | 3;
					e.ev_bmask = 3;
					e.ev_mbstate = 0;
					e.ev_mm1flags = 1;
					e.ev_mm1x = mrect.g_x;
					e.ev_mm1y = mrect.g_y;
					e.ev_mm1width = mrect.g_w;
					e.ev_mm1height = mrect.g_h;
					e.ev_mm2flags = 0;
					e.ev_mm2x = 0;
					e.ev_mm2y = 0;
					e.ev_mm2width = 0;
					e.ev_mm2height = 0;
					e.ev_mtlocount = 350;
					e.ev_mthicount = 0;
	
					if (fnts_func != NULL)
						fnts_func(TRUE, &e);
					if (e.ev_mwich == 0)
					{
						e.ev_mwich = evnt_multi(e.ev_mflags, e.ev_mbclicks, e.ev_bmask, e.ev_mbstate,
							e.ev_mm1flags, e.ev_mm1x, e.ev_mm1y, e.ev_mm1width, e.ev_mm1height,
							e.ev_mm2flags, e.ev_mm2x, e.ev_mm2y, e.ev_mm2width, e.ev_mm2height,
							e.ev_mmgpbuf,
							e.ev_mtlocount, e.ev_mthicount,
							&e.ev_mmox, &e.ev_mmoy, &e.ev_mmobutton, &e.ev_mmokstate, &e.ev_mkreturn, &e.ev_mbreturn);
					}
	
					event = e.ev_mwich;
					moX = e.ev_mmox;
					moY = e.ev_mmoy;
					moButton = e.ev_mmobutton;
					moKState = e.ev_mmokstate;
					kReturn = e.ev_mkreturn;
					bReturn = e.ev_mbreturn;
					mess[0] = e.ev_mmgpbuf[0];
					mess[1] = e.ev_mmgpbuf[1];
					mess[2] = e.ev_mmgpbuf[2];
					mess[3] = e.ev_mmgpbuf[3];
					mess[4] = e.ev_mmgpbuf[4];
					mess[5] = e.ev_mmgpbuf[5];
					mess[6] = e.ev_mmgpbuf[6];
					mess[7] = e.ev_mmgpbuf[7];
					
					scan = (kReturn >> 8) & 0xff;
					ch = kReturn & 0xff;
	
					mrect.g_x = moX;
					mrect.g_y = moY;

					if (fnts_func != FUNK_NULL)
					{
						ev.mwhich = event;
						ev.mox = moX;
						ev.moy = moY;
						ev.button = moButton;
						ev.state = moKState;
						ev.key = kReturn;
						ev.clicks = bReturn;
						ev.message[0] = mess[0];
						ev.message[1] = mess[1];
						ev.message[2] = mess[2];
						ev.message[3] = mess[3];
						ev.message[4] = mess[4];
						ev.message[5] = mess[5];
						ev.message[6] = mess[6];
						ev.message[7] = mess[7];
						fnts_func(FALSE, &ev);
						event = (event & ~MU_KEYBD) | (ev.mwhich & MU_KEYBD);
					}
				}
	
				Wind_Update(BEG_UPDATE);
	
				if (event & MU_BUTTON)
				{
					if (!mouse)
					{
						MouseOn();
						mouse = TRUE;
					}
					if (moButton & MOB_LEFT)
					{
						/* Nicht warten, wenn man die rechte Taste gedrueckt hat. */
						/* Sonst kann man Fenster im Hintergrund nicht mehr korrekt bedienen. */
						release_left_button();
					}
				}
				handleEvents();
			}
	
			crash = FALSE;
			if (startTerm && !fastExit)
			{
				start_terminal_at_exit(args.decodeOutfile, args.quitProg, batch);
			}
/*DYJ 5.36c Start*/
			if (*startPutzCmd && !fastExit)
				start_putz_at_exit(startPutzCmd);
/*DYJ  Ende; */
			Wind_Update(END_UPDATE);
		}
	}
	/* wird im crashhandler wieder ausgeschaltet */
	Wind_Update(BEG_UPDATE);
	cleanup();
	HlpPrg_TermPrg();
	ApplTerm(exit_code);

	return exit_code;
}
