/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */


/*
 * 21.05.1999 Markus Hoffmann @ DU (MH)
 * - Per Variable 'SmallFunctionWindow' kann ein platzsparendes kleines Funktions-
 *   fenster eingestellt werden.
 */
#include <catbutto.h>
#include <userinfo.h>
#include <maustaus.h>
#include <mte.h>
#include <wdwmanag.h>
#include <catgloba.h>
#include <confvars.h>
#include <varname1.h>
#include <varnamel.h>
#include <mtpaths.h>
#include <editfunc.h>
#include <catvers.h>

#include <mtappl.h>
#include <mtutils.h>
#include <mtdir.h>
#include <cat.h>

#include <routinec.h>
#include <file_io.h>


GLOBAL HWND CatButtons_WinHandle = -1;
GLOBAL _BOOL buttonWindowLocked = FALSE;

#define GADGETS (NAME | CLOSER | MOVER)

LOCAL OBJECT *ButtonWin;
LOCAL _BOOL wdwTopped = FALSE;
LOCAL _BOOL isHidden = FALSE;
LOCAL _BOOL globalExit = FALSE;
LOCAL _WORD wiggle;

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

LOCAL _BOOL clickInButton(HWND wdw, _VOID *special, _WORD mx, _WORD my, _UWORD kstate, _UWORD buttons, _WORD clicks)
{
	UNUSED(wdw);
	UNUSED(special);
	UNUSED(mx);
	UNUSED(my);
	UNUSED(kstate);
	UNUSED(buttons);
	UNUSED(clicks);
	/* Hier FALSE zurueckgeben, da das in CAT.M behandelt wird */
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL kProc(HWND wdw, _VOID *special, _WORD taste, _UBYTE key, _UBYTE scan, _UWORD kstate)
{
	UNUSED(wdw);
	UNUSED(special);
	UNUSED(taste);
	UNUSED(key);
	UNUSED(scan);
	UNUSED(kstate);
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL closeButton(HWND wdw,HVDI vdiH, _VOID *special, _BOOL force)
{
	UNUSED(wdw);
	UNUSED(vdiH);
	UNUSED(special);
	if (!isHidden && buttonWindowLocked && !force)
		return FALSE;
	CatButtons_WinHandle = -1;
	ConfVars_SetConfigBool(cButtonWindowOpen, globalExit);
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID hideButton(HWND wdw, _VOID *special, _BOOL hide)
{
	UNUSED(special);
	if (wdw == CatButtons_WinHandle)
		isHidden = hide;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL timerButton(HWND wdw, _VOID *special)
{
	UNUSED(special);
	if (wdw == CatButtons_WinHandle)
		if (wdwTopped)
		{
			wdwTopped = FALSE;
			WdwManager_WindowIsClosed(wdw);
		}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL topButton(HWND wdw, _VOID *special)
{
	UNUSED(wdw);
	UNUSED(special);
	wdwTopped = TRUE;
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID untopButton(HWND wdw, _VOID *special)
{
	UNUSED(special);
	WdwManager_WindowIsClosed(wdw);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID setWork(HWND wdw, _VOID *special, CONST LGRECT *doc, _BOOL slided)
{
	UNUSED(wdw);
	UNUSED(special);
	UNUSED(doc);
	UNUSED(slided);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID getRect(HWND wdw, HVDI vdiH, _VOID *special, GRECT *work)
{
	UNUSED(wdw);
	UNUSED(vdiH);
	UNUSED(special);
	UNUSED(work);
	WdwManager_GetWdwSize(wdw, &UserBLK.buttonW);
	ConfVars_SetConfigRect(cButtonWindowPos, &UserBLK.buttonW);
	ButtonWin[ROOT].ob_x = work->g_x;
	ButtonWin[ROOT].ob_y = work->g_y;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID redrawButton(HWND wdw, HVDI vdi, _VOID *special, CONST GRECT *clip)
{
	UNUSED(wdw);
	UNUSED(vdi);
	UNUSED(special);
	SetObjcString(ButtonWin, CATINFNA, F_Path_Basename(lastInfName));
	Objc_draw(ButtonWin, ROOT, MAX_DEPTH, clip);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID updateButton(HWND wdw, _VOID *special, _BOOL begin)
{
	UNUSED(wdw);
	UNUSED(special);
	if (begin)
	{
		Wind_Update(BEG_UPDATE);
		MouseOff();
	} else
	{
		MouseOn();
		Wind_Update(END_UPDATE);
	}
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

GLOBAL _BOOL CatButtons_IsButtonTop(HWND handle)
{
	return handle == CatButtons_WinHandle;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID setLook(_WORD ob)
{
	EnableObjFlags(ButtonWin, ob, EXIT, tos3DLook);
	EnableObjFlags(ButtonWin, ob, TOUCHEXIT, !tos3DLook);
}

/*** ---------------------------------------------------------------------- ***/

/*DYJ 5.21b */
GLOBAL _BOOL CatButtons_DisplayButton(_BOOL init)
{
	_BOOL boolVal;
	_WORD newY;
	HWND wdw;
	HVDI vdi;
	_UBYTE name[80];
	_BOOL addVersion;
	
	if (CatButtons_WinHandle < 0)
	{
		if (init)
		{
			ConfVars_GetConfDefBool(cButtonWindowOpen, &boolVal, TRUE);
			if (!boolVal)
				return FALSE;
		}
		if (UserBLK.buttonW.g_x >= MaxWidth || UserBLK.buttonW.g_y >= MaxHeight)
			UserBLK.buttonW.g_y = 0;
		if (UserBLK.buttonW.g_y == 0)
		{
			UserBLK.buttonW = deskSize;
			newY = UserBLK.buttonW.g_y;
		} else
		{
			newY = -1;
		}
		Wind_calc(WC_WORK, GADGETS, &UserBLK.buttonW, &UserBLK.buttonW);
		UserBLK.buttonW.g_w = ButtonWin[ROOT].ob_width;
		UserBLK.buttonW.g_h = ButtonWin[ROOT].ob_height;
		Wind_calc(WC_BORDER, GADGETS, &UserBLK.buttonW, &UserBLK.buttonW);
		if (newY > 0)
			UserBLK.buttonW.g_y = newY;
		strBcpy(name, ProgramName);
		EditFuncs_AllUp(name);
		/* Folgendes nach EditFuncs_AllUp, sonst sieht's bescheiden aus */
		ConfVars_GetConfDefBool(cAddVersionToFuncWin, &addVersion, FALSE);
		if (addVersion)
			strBcat(name, " " CatVersion " ");
		if (WdwManager_OpenWindow(clickInButton,
			kProc, timerButton,
			&UserBLK.buttonW, &UserBLK.buttonW, GADGETS,
			FALSE, "", name, FUNK_NULL,
			closeButton, redrawButton, topButton,
			untopButton,
			updateButton, setWork, getRect,
			hideButton, 0, NULL,
			FALSE,
			TRUE,
			TRUE,
			FALSE,
			FALSE,
			&CatButtons_WinHandle,
			&vdi))
		{
			isHidden = FALSE;
			/* Buttons an 3D-Look anpassen */
			setLook(READNEW);
			setLook(READUNREAD);
			setLook(READPOS);
			setLook(READALL);
			setLook(READDATE);
			setLook(READNUM);
			setLook(NEWMESS);
			setLook(NEWPERS);
			/* Ok, Fenster ist offen */
			ConfVars_SetConfigBool(cButtonWindowOpen, TRUE);
			WdwManager_GetWdwWork(CatButtons_WinHandle, &UserBLK.buttonW);
			ButtonWin[ROOT].ob_x = UserBLK.buttonW.g_x;
			ButtonWin[ROOT].ob_y = UserBLK.buttonW.g_y;
			WdwManager_GetWdwSize(CatButtons_WinHandle, &UserBLK.buttonW);
			ConfVars_SetConfigRect(cButtonWindowPos, &UserBLK.buttonW);
			/* Wieder rausnehmen aus WindowQueue */
			WdwManager_WindowIsClosed(CatButtons_WinHandle);
		} else
		{
			mtAlerts_AlertRSC(1, AL_NO_WIN);
			ConfVars_SetConfigBool(cButtonWindowOpen, FALSE);
			return FALSE;
		}
	} else
	{
		WdwManager_GetTopWindow(&wdw, &vdi);
		if (wdw == CatButtons_WinHandle)
		{
			WdwManager_TopNextWindow();
		} else
		{
			WdwManager_TopWindow(CatButtons_WinHandle);
			/* Wieder rausnehmen aus WindowQueue */
			WdwManager_WindowIsClosed(CatButtons_WinHandle);
		}
	}
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _BOOL CatButtons_CloseButton(_BOOL exit)
{
	if (CatButtons_WinHandle > 0)
	{
		globalExit = exit;
		WdwManager_CloseWindow(CatButtons_WinHandle, FALSE);
		ConfVars_SetConfigBool(cButtonWindowOpen, exit);
		return TRUE;
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _WORD CatButtons_ClickIsInButton(_WORD Wx, _WORD Wy)
{
	HWND wdw;

	if (CatButtons_WinHandle > 0)
	{
		wdw = WdwManager_ClickInWindow(Wx, Wy);
		if (CatButtons_WinHandle == wdw)
			return objc_find(ButtonWin, ROOT, MAX_DEPTH, Wx, Wy);
	}
	return NIL;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID CatButtons_DrawButton(_WORD which)
{
	GRECT r;

	if (CatButtons_WinHandle >= 0)
	{
		CalcArea(ButtonWin, which, &r);
		WdwManager_RedrawWdw(CatButtons_WinHandle, &r);
	}
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID CatButtons_Select_Messages(_BOOL select)
{
	EnableObjState(ButtonWin, MESSAGES, SELECTED, select);
	EnableObjState(ButtonWin, STICHWOR, SELECTED, !select);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID CatButtons_Normal(_WORD obj)
{
	DelObjState(ButtonWin, obj, SELECTED);
	WdwManager_HandlePendingEvents();
	/* Sieht sonst ein bisschen merkwuerdig aus, wenn der Redraw erst danach kommt */
	CatButtons_DrawButton(obj);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID CatButtons_Wiggle(_WORD obj, _BOOL simple)
{
	_WORD i;
	
	SetObjState(ButtonWin, obj, SELECTED);
	CatButtons_DrawButton(obj);
	if (!tos3DLook && !simple && wiggle > 0)
	{
		for (i = 0; i < wiggle; i++)
		{
			evnt_timer(75, 0);
			DelObjState(ButtonWin, obj, SELECTED);
			CatButtons_DrawButton(obj);
			evnt_timer(75, 0);
			SetObjState(ButtonWin, obj, SELECTED);
			CatButtons_DrawButton(obj);
		}
	}
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID CatButtons_InitButtonWindow(_VOID)
{
	_BOOL small;

	ConfVars_GetConfDefBool(cSmallFunctionWindow, &small, FALSE);	/* (MH) */
	/* Kleines Funktionsfenster eingestellt? (MH) */
	if (small)
		ButtonWin  = TreeAddr[SMALLDESK];
	else
		ButtonWin  = TreeAddr[DESK];
	if (!tos3DLook)
	{
		DelObjFlags(ButtonWin, MESSAGES, EXIT);
		DelObjFlags(ButtonWin, STICHWOR, EXIT);
	}
	ConfVars_GetConfDefInt(cWiggle, &wiggle, 1);
}
