/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 *
 * 1.9.03 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.30b'
 *	Unter MagicPC werden jetzt auch Windows-Verknpfungen 
 *	bercksichtigt. Natrlich nur wenn WIN_LNK nicht installiert ist
 */


#include <datasys.h>
#include <catfiles.h>
#include <mtalerts.h>
#include <cattypes.h>
#include <filesys.h>
#include <strconv.h>
#ifndef __MINTBIND_H__
#include <mintbind.h>
#endif
#include <file_io.h>
#include <dir_io.h>
#include <routinec.h>
#include <routines.h>
#include <s_endian.h>
#include <portab.h>
#include <CONVERTD.h>
#include <varnamel.h>
#include <confvars.h>
#include <mtrsc.h>
#include <mtappl.h>		/*DYJ 5.30b */


#include <catlib.h>

#define ENV_Tmp         "TMP"
#define ENV_Tempdir     "TMPDIR"      /* Temporaeres Verzeichnis */
#define ENV_Home        "HOME"	
#define MAX_LW		26	/*DYJ 5.30b */

void intel(void *feld,long anz);	/* s. delink.s*/	/*DYJ 5.30b */
int getDrivePath(int lw,char *buf,long len);	/* s. delink.s*/	/*DYJ 5.30b */
/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/
/*** ------------------------------------------------------------------------ ***/
/*	int cv_WIN2MPC(char *ziel,long lenZ,const char *quell)						*/
/*	Wandelt einen Pfadnamen vom Windows-Filesystem in das von MPC				*/
/*	Parameter:	ziel:	hierher den MPC-Pfad schreiben							*/
/*				lenZ: 	Lnge von ziel											*/
/*				quell:	Windowspfad												*/
/*	Ergebnis:	Fehler?	s. ERR_UL_SIZE etc										*/
/*	aus win_lnk bernommen														*/
/*	13.9.03 von Dimitri Junker	DYJ 5.30b										*/
/*** ------------------------------------------------------------------------ ***/
_BOOL cv_WIN2MPC(char *ziel,long lenZ,const char *quell)
{
	int i;
	_BOOL ok=FALSE;
	for(i=0;i<MAX_LW;i++)
	{
		size_t len;
		if(getDrivePath(i,ziel,lenZ)>1)
		{
			len=strLen(ziel);
			if(!strnCaseCmp(ziel,quell,len))
			{
				if((3+strLen(&quell[len]))<=lenZ)
				{
					sprintf(ziel,"%c:%s",(char)(i+'A'),&quell[len]);
					ok=TRUE;
				}
				break;
			}
		}
	}
	return(ok);
}
/*** ------------------------------------------------------------------------ ***/
/*	_BOOL CatFiles_delink(_UBYTE *origPfad,size_t len,_UBYTE *lnkPfad)			*/
/*	Versucht ein WINOWS-LNK File zu analysieren und daraus den Originalpfad zu	*/
/*	ermitteln.																	*/
/*	Parameter:	origPfad:	Da soll das Ergebnis hin							*/
/*				len:        Lnge von origPfad									*/
/*				lnkPfad:	Das LNK-File										*/
/*	Ergebnis:	TRUE wenn erfolgreich.											*/		
/*	1.9.03 von Dimitri Junker	DYJ 5.30b										*/
/*** ------------------------------------------------------------------------ ***/
LOCAL _BOOL CatFiles_delink(_UBYTE *origPfad,size_t len,_UBYTE *lnkPfad)
{
	FILE *lnkfi;
	_WORD l0,l1,l2,l3,i,flag;
	_UBYTE block3[500],*path;
	_BOOL ret=FALSE;
	
	lnkfi=fopen(lnkPfad,"rb");
	if(lnkfi)
	{
		fread(&l0,sizeof(_WORD),1,lnkfi);
		intel(&l0,1);					/* immer 0x4c	*/
		if(l0>1)
			fseek(lnkfi,l0-2,SEEK_CUR);		/* Block 0 berspr*/
		fread(&l1,sizeof(_WORD),1,lnkfi);
		intel(&l1,1);
		if(l1>1)
			fseek(lnkfi,l1-2,SEEK_CUR);		/* Block 1 berspr*/
		fread(&l2,sizeof(_WORD),1,lnkfi);
		intel(&l2,1);
		if(l2>1)							/* immer 0 ? */
			fseek(lnkfi,l2-2,SEEK_CUR);		/* Block 2 berspr*/
		/* interessanter Block	*/
		fread(&l3,sizeof(_WORD),1,lnkfi);
		intel(&l3,1);
		path=NULL;
		if(l3>3)
		{	fread(block3,1,l3-2,lnkfi);
			flag=0;
			for(i=l3-3;i;i--)
			{
				if(!block3[i])
				{
					if(flag==0 && block3[i-1]=='$')
						strCpy(&block3[i-1],":\\");
					if(flag==1)
					{
						if(block3[i-1]=='$')
						{	block3[i]='\\';
							block3[i-1]=':';
							flag=2;
						}
						else
							flag=3;
					}
					if(flag==3)
					{	path=&block3[i+1];
						break;
					}
				}
				else
					flag|=1;
			}
		}
		if(path)
		{	
			if(!strnCmp(path,"\\\\",2))
				path=strChr(&path[3],'\\')+1;
		}
		if(path)
			ret=cv_WIN2MPC(origPfad,len,path);
		else
			ret=FALSE;
		fclose(lnkfi);
		
	}
	return ret;
}

/*** ------------------------------------------------------------------------ ***/
/*	_WORD CatFiles_shel_find( _UBYTE *sh_fpbuff,size_t len )					*/
/*	shel_find Version die auch Windows-Verknpfungen bercksichtigt				*/
/*	Parameter:	sh_fpbuff	Filenamen											*/
/*				len: dessen Lnge												*/
/*	Ergebnis:	NULL -> nicht gefunden											*/		
/*	1.9.03 von Dimitri Junker	DYJ 5.30b										*/
/*** ------------------------------------------------------------------------ ***/
GLOBAL _WORD CatFiles_shel_find( _UBYTE *sh_fpbuff,size_t len )
{
	_WORD ret;
	if((ret=shel_find(sh_fpbuff))==0 && magicPC)
	{
		_UBYTE lnkName[PATH_MAX];
		strCpy(lnkName, sh_fpbuff);
		strCat(lnkName,".lnk");
		if((ret=shel_find(lnkName))!=0)
		{
			if(!CatFiles_delink(sh_fpbuff,len,lnkName))
				ret=0;
		}
	}
	return ret;
	
}
/*** ------------------------------------------------------------------------ ***/
GLOBAL FILENO CatFiles_OpenFile(CONST _UBYTE *filename, openMode mode)
{
	_LONG res;
	FILENO handle;
	_UWORD MODE;

	switch (mode)
	{
	case CatFiles_readFile:
		MODE = FO_READ;
		break;
	case CatFiles_writeFile:
		MODE = FO_WRITE;
		break;
	case CatFiles_readWrite:
		MODE = FO_RW;
		break;
	default:
		return -1;
	}

	res = Fopen(filename, MODE);
	if (res == -33 && mode != CatFiles_readFile) /*!ERROR*/
	{
		res = Fcreate(filename, 0);
		if (mode == CatFiles_readWrite && FILENO_OK(res))
		{
			(void)Fclose((_WORD)res);
			res = Fopen(filename, MODE);
		}
	}
/*DYJ 5.30b Start*/
	else if (res == -33 && UseCatDelink)
	{
		_UBYTE lnkName[PATH_MAX],origName[PATH_MAX];
		strCpy(lnkName, filename);
		strCat(lnkName,".lnk");
		if(CatFiles_delink(origName,sizeof(origName),lnkName))
			res = Fopen(origName, MODE);
	}
/*DYJ  Ende; */
	handle = TO_FILENO((_WORD)res);
	return handle;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL FILENO CatFiles_CreateFile(CONST _UBYTE *name)
{
	return TO_FILENO((_WORD)Fcreate(name, 0));
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL F_ERROR CatFiles_WriteFile(_UBYTE c, FILENO handle)
{
	_LONG count;
	F_ERROR error;
	
	error = NoError;
	count = Fwrite(handle, 1, &c);
	if (count < 0)
		error = (_WORD)count;
	else if (count != 1)
		error = notAllWritten;
	return error;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL F_ERROR CatFiles_WriteMuch(_ULONG howMuch, FILENO handle, CONST _VOID *where)
{
	_LONG count;
	F_ERROR error;
	
	error = NoError;
	count = Fwrite(handle, howMuch, where);
	if (count < 0)
		error = (_WORD)count;
	else if (count != howMuch)
		error = notAllWritten;
	return error;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL F_ERROR CatFiles_ReadFile(_UBYTE *c, FILENO handle)
{
	_LONG count;
	F_ERROR error;
	
	error = NoError;
	count = Fread(handle, 1, c);
	if (count < 0)
		error = (_WORD)count;
	else if (count != 1)
		error = notAllRead;
	return error;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL F_ERROR CatFiles_ReadMuch(_ULONG howMuch, FILENO handle, _VOID *where)
{
	_LONG count;
	F_ERROR error;
	
	error = NoError;
	count = Fread(handle, howMuch, where);
	if (count < 0)
		error = (_WORD)count;
	else if (count != howMuch)
		error = notAllRead;
	return error;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL F_ERROR CatFiles_FilePos(FILENO handle, _ULONG *size)
{
	_ULONG pos;
	F_ERROR error;
	
	error = NoError;
	pos = Fseek(0L, handle, 1);
	if (pos >= 0xfffff000UL)
		error = (_WORD)(_LONG)pos;
	*size = pos;
	return error;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID CatFiles_Seek(_LONG pos, FILENO handle, SeekMode what)
{
	Fseek(pos, handle, (_WORD)what);
/* Hier fragt sowieso keiner, ausserdem ist mir nicht klar, wie man unterscheiden kann,
   ob ein Fehler im unteren Wort steht, ohne dass es zu Fehlinterpretationen kommen kann.
   Was ist mit Seek auf CARDINAL(-37), das ist doch ohne weiteres Moeglich.. grr
  IF err < 0 THEN FileError = CAST(INTEGER,pos) END;
*/
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL F_ERROR CatFiles_CloseFile(FILENO handle)
{
	return Fclose(handle);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL F_ERROR CatFiles_DeleteFile(CONST _UBYTE *path, CONST _UBYTE *name)
{
	_UBYTE file[PATH_MAX];

	strCpy(file, path);
	F_Path_Append(file, name);
	return F_File_Delete(file);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _BOOL CatFiles_RenameFile(CONST _UBYTE *path, CONST _UBYTE *name, CONST _UBYTE *path2, CONST _UBYTE *name2)
{
	_UBYTE old[PATH_MAX];
	_UBYTE new[PATH_MAX];

	strCpy(old, path);
	F_Path_Append(old, name);
	strCpy(new, path2);
	F_Path_Append(new, name2);
	return F_Path_Rename(old, new) == GERR_OK;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _ULONG CatFiles_FileSizeAndDate(CONST _UBYTE *fname, _BOOL *exists, _UWORD *date, _UWORD *time)
{
	F_STAT st;

	if (F_Getinfo(fname, &st, TRUE) == GERR_OK)
	{
		*exists = TRUE;
		T_SysToDostime(st.st_mtime, date, time);
		return st.st_size;
	}
	*exists = FALSE;
	return 0;
}
/*** ---------------------------------------------------------------------- ***/

GLOBAL _ULONG CatFiles_FileSize(CONST _UBYTE *fname, _BOOL *exists)
{
	_UWORD d;

	return CatFiles_FileSizeAndDate(fname, exists, &d, &d);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _BOOL CatFiles_Exists(CONST _UBYTE *fname)
{
	_BOOL exists;

	CatFiles_FileSize(fname, &exists);
/*DYJ 5.30b Start*/
	if (!exists && UseCatDelink)
	{
		_UBYTE lnkName[PATH_MAX],origName[PATH_MAX];
		strCpy(lnkName, fname);
		strCat(lnkName,".lnk");
		if(CatFiles_delink(origName,sizeof(origName),lnkName))
			CatFiles_FileSize(origName, &exists);
	}
/*DYJ  Ende; */
	return exists;
}
/*** ------------------------------------------------------------------------ ***/
/*	_BOOL CatFiles_FolderExist(CONST _UBYTE *pfad)								*/
/*	prft ob ein Ordner existiert												*/
/*	Parameter:	pfad:	na was wohl?											*/
/*	Ergebnis:	TRUE wenn vorhanden												*/		
/*	12.2.03 von Dimitri Junker	DYJ 5.20zd										*/
/*	war bisher in mime.c als folderExist										*/
/*	20.12.01 von Dimitri Junker	DYJ 4.31h										*/
/*	abgeleitet aus der gleichnamigen Fkt aus clip.c								*/
/*** ------------------------------------------------------------------------ ***/
GLOBAL _BOOL CatFiles_FolderExist(CONST _UBYTE *pfad)
{
	F_STAT st;
	_UWORD l;
	_UBYTE name[PATH_MAX];
	
	l=(_UWORD)strLen(pfad);
	strBcpy(name, pfad);
	if (l > 0 && name[l-1] == '\\')
		name[--l] = '\0';
	if (l == 0)
		return FALSE;
	if (F_Getinfo(name, &st, TRUE) == GERR_OK && st.st_is_directory)
		return TRUE;
	return FALSE;
}
/*** ---------------------------------------------------------------------- ***/

GLOBAL F_ERROR CatFiles_ReadDbHeader(FILENO handle, FileHeaderType *dbHdr)
{
	F_ERROR error;
	
	error = CatFiles_ReadMuch(dbHeaderLength, handle, dbHdr);
	if (error == NoError)
	{
		dbHdr->CatMagic = n2hl(dbHdr->CatMagic);
		dbHdr->Version = n2hs(dbHdr->Version);
		dbHdr->VersionMagic = n2hs(dbHdr->VersionMagic);
	}
	return error;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _BOOL CatFiles_GetTmpDir(_UBYTE *path)
{
	_UBYTE *env;

	if ((env = getenv(ENV_Tmp)) != NULL && *env != '\0')
	{
		strMcpy(path, PATH_MAX, env);
		/* ggf. Backslash anhaengen */
		F_Path_Append(path, "");
		return TRUE;
	}
	if ((env = getenv(ENV_Tempdir)) != NULL && *env != '\0')
	{
		strMcpy(path, PATH_MAX, env);
		/* ggf. Backslash anhaengen */
		F_Path_Append(path, "");
		return TRUE;
	}
	return FALSE;
}
/*** ------------------------------------------------------------------------ ***/
/*	GLOBAL _BOOL CatFiles_GetHomeDir(_UBYTE *path)								*/
/*	gibt das HOME-Verzeichnis zurck							*/
/*	Parameter:	path:	Zielvariable															*/
/*	Ergebnis:	Eistierte HOME?															*/		
/*	28.6.02 von Dimitri Junker	DYJ 4.40a										*/
/*** ------------------------------------------------------------------------ ***/
GLOBAL _BOOL CatFiles_GetHomeDir(_UBYTE *path)
{
	_UBYTE *env;

	if ((env = getenv(ENV_Home)) != NULL && *env != '\0')
	{
		strMcpy(path, PATH_MAX, env);
		/* ggf. Backslash anhaengen */
		F_Path_Append(path, "");
		return TRUE;
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID CatFiles_Init(_VOID)
{
	F_SetErrorMsg(notAllWritten, ERR_CAT_NAW);
	F_SetErrorMsg(notAllRead, ERR_CAT_NAR);
	F_SetErrorMsg(crcError, ERR_CAT_CRC);
}
/*** ------------------------------------------------------------------------ ***/
/*	GLOBAL F_ERROR CatFiles_copy(FILENO ziel,FILENO quell,_ULONG len)			*/
/*	Kopiert Bytes von einem File ins andere										*/
/*	Parameter:	ziel,quell:	na was wohl											*/
/*				len:	Anz Bytes												*/
/*	Ergebnis:	0:OK sonst Fehler												*/		
/*	20.9.00 von Dimitri Junker	DYJ 4.18q										*/
/*** ------------------------------------------------------------------------ ***/
GLOBAL F_ERROR CatFiles_copy(FILENO ziel,FILENO quell,_ULONG len)
{
	F_ERROR error;
	_UBYTE buf[1024];
	_ULONG cpyBytes;
	while(len)
	{
		if(len>1024)
			cpyBytes=1024;
		else
			cpyBytes=len;
		error=CatFiles_ReadMuch(cpyBytes, quell, buf);
		if(error!=NoError)
			break;
		error=CatFiles_WriteMuch(cpyBytes, ziel, buf);
		if(error!=NoError)
			break;
		len-=cpyBytes;
	}
	return error;
}


/*** ------------------------------------------------------------------------ ***/
/*	GF_ERROR CatFiles_copyFile(CONST _UBYTE *ziel,CONST _UBYTE *quell)			*/
/*	Kopiert ganze Files															*/
/*	Parameter:	ziel,quell:	na was wohl											*/
/*	Ergebnis:	0:OK sonst Fehler												*/		
/*	20.11.01 von Dimitri Junker	DYJ 4.30zw										*/
/*** ------------------------------------------------------------------------ ***/
/*DYJ 5.21b *//*DYJ 5.24j */
GLOBAL F_ERROR CatFiles_copyFile(CONST _UBYTE *ziel,CONST _UBYTE *quell)
{
	FILENO quellF,zielF;
	size_t len;
	_BOOL exists;
	F_ERROR ret;
	
	CatFiles_FileSize(ziel,&exists);
	if(exists)
	{
		if(!strCaseCmp(ziel,quell))
			return NoError;
		else if(mtAlerts_Alert(2, Rsc_WrkString(AL_OVERWRITE))==2)
			return notAllWritten;
	}

	
	len=CatFiles_FileSize(quell,&exists);
	if(!exists || !len)
	{
		mtAlerts_Alert(1, Rsc_WrkString(AL_NOTHING));
		return NotFound;
	}
	quellF=CatFiles_OpenFile(quell, CatFiles_readFile);
	if(quellF<0)
	{
		mtAlerts_Alert(1, Rsc_WrkString(AL_QUELL));
		return notAllWritten;
	}
	zielF=CatFiles_OpenFile(ziel, CatFiles_writeFile);
	if(zielF<0)
	{
		mtAlerts_Alert(1, Rsc_WrkString(AL_ZIEL));
		CatFiles_CloseFile(quellF);
		return notAllWritten;
	}
	ret=CatFiles_copy(zielF,quellF,len);
	CatFiles_CloseFile(quellF);
	CatFiles_CloseFile(zielF);
	if(ret!=NoError)
		mtAlerts_Alert(1, Rsc_WrkString(AL_COPY));
	return ret;
}
/*** ------------------------------------------------------------------------ ***/
/*	CatFiles_BackupFile(CONST _UBYTE *zielPfad,CONST _UBYTE *quellPfad,CONST _UBYTE *quellName)		*/
/*	Erzeugt ein Backup eines Files. Der Filename besteht i.W. aus dem Datum		*/
/*	und ggf. der Uhrzeit des Files. Die Endung wird beibehalten					*/
/*	Parameter:	zielPfad:	Da soll das Backupfile hin							*/
/*				quellPfad,quellName:	Das Quellfile							*/
/*	Ergebnis:	Fehlercode wie bei CatFiles_copyFile							*/		
/*	12.2.03 von Dimitri Junker	DYJ 5.20zd										*/
/*** ------------------------------------------------------------------------ ***/
GLOBAL F_ERROR CatFiles_BackupFile(CONST _UBYTE *zielPfad,CONST _UBYTE *quellPfad,CONST _UBYTE *quellName)
{
	_WORD i;
	_BOOL exists,use_8_3;
	_UBYTE quell[PATH_MAX],ziel[PATH_MAX],zielName[FILENAME_MAX],*ext,*endePfad;
	_UWORD date,time;

	strCpy(quell,quellPfad);
	F_Path_Append(quell,quellName);
	CatFiles_FileSizeAndDate(quell, &exists, &date, &time);

	/* Jetzt Datum bauen */
	ConvertDate_MakeFreeDate(date, time, zielName, sizeof(zielName));


	ConfVars_GetConfDefBool(cUseTosNames,&use_8_3,FALSE);
	if(!use_8_3)
		use_8_3=F_Path_MaxFlen(zielPfad)<19;
	if(use_8_3)
	{
		zielName[8]='\0';
		strCpy(zielName,zielName+2);
	}
	ext=strChr(quellName,'.');
	
	/*	1.Versuch Datum(+Zeit) */
	strCpy(ziel,zielPfad);
	F_Path_Append(ziel,zielName);
	endePfad=strChr(ziel,'\0');
	strCat(ziel,ext);
	if(CatFiles_Exists(ziel))
	{
	/*	2.Versuch Datum(+Zeit) mit angehngter Zahl*/
		if(use_8_3)
		{
			for(i=1;i<100;i++)
			{
				sprintf(endePfad,"%02d%s",i,ext);
				if(!CatFiles_Exists(ziel))
					break;
			}
		}
		else
		{
			i=0;
			do
			{
				i++;
				sprintf(endePfad,"_%02d%s",i,ext);
			}while(CatFiles_Exists(ziel));
		}
	}
	CatFiles_FolderExist(zielPfad);
		F_Path_Create(zielPfad);
	return CatFiles_copyFile(ziel,quell);
}

