/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */


#include <catgloba.h>
#include <mtappl.h>
#include <magicstr.h>
#include <mtutils.h>
#include <mtdir.h>
#ifndef __MINTBIND_H__
#include <mintbind.h>
#endif

#include <confvars.h>
#include <varnamel.h>

#include <ro_mem.h>
#include <file_io.h>
#include <dir_io.h>
#include <filename.h>
#include <routinec.h>
#include <routines.h>
#include <debug.h>
#include <sound.h>

/*** ---------------------------------------------------------------------- ***/




GLOBAL _UBYTE SavePath[PATH_MAX];
GLOBAL _UBYTE SaveName[PATH_MAX];
GLOBAL _UBYTE OpenName[PATH_MAX];
GLOBAL _UBYTE infPath[PATH_MAX];
GLOBAL _UBYTE infName[PATH_MAX];
GLOBAL _UBYTE prgPath[PATH_MAX];
GLOBAL _UBYTE prgName[PATH_MAX];
GLOBAL String255 userAddr;
GLOBAL String255 userRName;

/* Positionen sichern? */
GLOBAL _BOOL SaveAllPositions;

/* Nur zum Lesen! */
GLOBAL _BOOL minTos14;		/* mindestens TOS 1.4 vorhanden */
GLOBAL _BOOL tos3DLook;		/* Hat das AES eine aktive 3D-Darstellung */
GLOBAL _BOOL isMiNTDomain;	/* Wir befinden uns in der Mint-Domain */

LOCAL _UBYTE applName[PATH_MAX];
LOCAL _UBYTE apName[40];


/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

/* Setzt den Benutzernamen auf den in den Configvariablen
 * eingestellten Wert
 */
GLOBAL _VOID CatGlobal_GetUser(_VOID)
{
	ConfVars_GetConfDefStr(cMausId, userAddr, sizeof(userAddr), "");
	ConfVars_GetConfDefStr(cUserName, userRName, sizeof(userRName), "");
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

/* Gibt zurueck, ob eine der Shifttasten gedrueckt wurde */
GLOBAL _BOOL CatGlobal_WithShift(_UWORD kstate)
{
	return (kstate & (K_LSHIFT | K_RSHIFT)) != 0;
}

/*** ---------------------------------------------------------------------- ***/

/* Gibt zurueck, ob Ctrl gedrueckt wurde */
GLOBAL _BOOL CatGlobal_WithCtrl(_UWORD kstate)
{
	return (kstate & K_CTRL) != 0;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _BOOL CatGlobal_WithAlt(_UWORD kstate)
{
	return (kstate & K_ALT) != 0;
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

LOCAL MFORM mouseData1 = {
	7, 7, 1, WHITE, BLACK,
   	/* mask data */
	{ 960,4080,8184,16380,32766,32766,0xffff,0xffff,
      0xffff,0xffff,32766,32766,16380,8184,4080,960 },
    /* mouse data */
	{ 0,960,3888,7944,16132,16132,32514,32514,
      16638,16638,8444,8444,4344,3312,960,0 }
};


LOCAL MFORM mouseData2 = {
	7, 7, 1, WHITE, BLACK,
	/* mask data */
	{ 960,4080,8184,16380,32766,32766,0xffff,0xffff,
	  0xffff,0xffff,32766,32766,16380,8184,4080,960 },
	/* mouse data */
	{ 0,960,4080,8184,12276,10212,17346,16770,
	  16770,17346,10212,12276,8184,4080,960,0 }
};

LOCAL MFORM mouseData3 = {
	7, 7, 1, WHITE, BLACK,
	/* mask data */
	{ 960,4080,8184,16380,32766,32766,0xffff,0xffff,
	  0xffff,0xffff,32766,32766,16380,8184,4080,960 },
	/* mouse data */
	{ 0,960,3312,4344,8444,8444,16638,16638,
	  32514,32514,16132,16132,7944,3888,960,0 }
};

LOCAL MFORM mouseData4 = {
	7, 7, 1, WHITE, BLACK,
	/* mask data */
	/* mask data */
	{ 960,4080,8184,16380,32766,32766,0xffff,0xffff,
	  0xffff,0xffff,32766,32766,16380,8184,4080,960 },
	/* mouse data */
	{ 0,960,3120,4104,14364,15420,32382,32766,
	  32766,32382,15420,14364,4104,3120,960,0 }
};


#define mouseForms 4

LOCAL MFORM *mouseArray[mouseForms] = {
	&mouseData1,
	&mouseData2,
	&mouseData3,
	&mouseData4
};
LOCAL _WORD mouseIndex = 0;

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID CatGlobal_busyMouse(_VOID)
{
	MFORM *mf;

	mf = mouseArray[mouseIndex++];
	if (mouseIndex >= mouseForms)
		mouseIndex = 0;
	UserMouse((_WORD *)mf);
	MouseUser();
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID CatGlobal_ReplaceStr(_UBYTE *str, size_t strsize, CONST _UBYTE *s1, CONST _UBYTE *s2)
{
	size_t p, s1Len;

	s1Len = strLen(s1);
	p = Pos(s1, str, 0, FALSE);
	while (p != POS_NOT_FOUND)
	{
		Delete(str, p, s1Len);
		Insert(s2, str, strsize, p);
		p = Pos(s1, str, p, FALSE);
	}
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID CatGlobal_ReplaceChar(_UBYTE *str, _UBYTE c1, _UBYTE c2)
{
	_UBYTE *p;

	p = str;
	if (c2 == '\0')
	{
		while ((p = strChr(p, c1)) != NULL)
			strCpy(p, p + 1);
	} else
	{
		while ((p = strChr(p, c1)) != NULL)
			*p++ = c2;
	}
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID CatGlobal_MakeStr(CONST _UBYTE *source, _UBYTE *dest, size_t destsize)
{
	size_t l, z;
	_UBYTE cut[6];
	_UBYTE ap[2];

	l = strLen(dest);
	Copy(dest, l-3, 3, cut, sizeof(cut));
	strMcpy(dest, destsize, "  ");
	strMcat(dest, destsize, source);
	z = strLen(dest);
	strBcpy(ap, " ");
	while (z <= l-4)
	{
		strMcat(dest, destsize, ap);
		++z;
	}
	strMcat(dest, destsize, cut);
}

/*** ---------------------------------------------------------------------- ***/

/* Save Funktion */
GLOBAL _BOOL CatGlobal_CreateBackup(CONST _UBYTE *fname)
{
	_UBYTE newName[PATH_MAX];
	_UBYTE path[PATH_MAX];
	_UBYTE name[PATH_MAX];
	_UBYTE *ext;
	F_STAT st;

	SplitPath(fname, path, name);
	ext = strrChr(name, '.');
	if (ext == NULL)
		strBcat(name, ".bak");
	else if (strCaseCmp(ext, ".BAK") == 0)
		strCpy(ext, ".baz");
	else
		strCpy(ext, ".bak");
	/* neuen Namen zusammensetzen */
	strCpy(newName, path);
	F_Path_Append(newName, name);
	/* Feststellen, ob Datei schon existiert */
	if (F_Getinfo(newName, &st, TRUE) == GERR_OK)
	{
		/* Wenn Directory, dann Abbruch */
		if (st.st_is_directory)
			return FALSE;
		if (F_File_Delete(newName) != GERR_OK)
			return FALSE;
	}
	return F_Path_Rename(fname, newName) == GERR_OK;
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

GLOBAL _VOID CatGlobal_Bing(CONST _UBYTE *name)
{

	_WORD avModus;
	ConfVars_GetConfDefInt(cAvModus, &avModus, 2);
	Sound_Play(name,avModus);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID CatGlobal_SetStrings(OBJECT *tree, _WORD from, _WORD to, CONST _UBYTE *string)
{
	_WORD i, entryLen, obIdx, dummy;
	_UBYTE str[80];
	_WORD l;

	/* Alle Textfelder loeschen */
	for (i = from; i <= to; i++)
		SetObjcString(tree, i, "");
	i = 0;
	obIdx = from;
	l = (_WORD)strLen(string);
	while (i < l && obIdx <= to)
	{
		ObjcStrLen(tree, obIdx, &entryLen, &dummy);
		if (entryLen > 4)
			entryLen -= 4;
		Copy(string, i, entryLen-1, str, sizeof(str));
		SetObjcString(tree, obIdx, str);
		++obIdx;
		i += entryLen - 1;
	}
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID CatGlobal_GetStrings(OBJECT *tree, _WORD from, _WORD to, _UBYTE *string, size_t strsize)
{
	_WORD i;
	_UBYTE str[80];

	*string = '\0';
	for (i = from; i <= to; i++)
	{
		ObjcString(tree, i, str, sizeof(str));
		strMcat(string, strsize, str);
	}
}

/*** ---------------------------------------------------------------------- ***/

/* Setzt den Namen der Applikation fuer interne Zwecke
 * Der Name muss ohne Extension angegeben werden.
 */

GLOBAL _VOID CatGlobal_SetAppl(CONST _UBYTE *str)
{
	strBcpy(apName, str);
	if (*apName != '\0' && apName[strLen(apName) - 1] != '.')
		strBcat(apName, ".");
}

/*** ---------------------------------------------------------------------- ***/

/* liefert den Pfad der Applikation, initialisiert dabei die interne
 * Variable. Vorher muss einmal SetAppl aufgerufen werden
 */

GLOBAL _VOID CatGlobal_GetApplPath(_UBYTE *path)
{
	_UBYTE p[PATH_MAX];
	_WORD res;

	/* Erstmal ShelRead aufrufen */
	shel_read(p, HomePath);
	SplitPath(p, HomePath, applName);
	/* Jetzt testen, ob applName in Ordnung ist.
	 */
	if (Pos(apName, applName, 0, FALSE) == POS_NOT_FOUND)
	{
		/* Stimmt wohl nicht! Dann stimmt gar nichts, Pfad und
		 * Laufwerk rausfinden und dann mit ShelFind nach apName
		 * mit verschiedenen Extensions suchen
		 */
		strBcpy(p, apName);
		strBcat(p, "PRG");
		if ((res = shel_find(p)) == 0)
		{
			strBcpy(p, apName);
			strBcat(p, "APP");
			if ((res = shel_find(p)) == 0)
			{
				/* Zweimal nicht gefunden. Jetzt sehen wir alt aus!
				 * Wir holen dann den HomePath als aktuellen Pfad
				 */
				res = 1;
				*p = '\0';
			}
		}
		if (res != 0)
		{
			SplitPath(p, HomePath, applName);
			if (*HomePath == '\0')
			{
				F_Path_Get(HomePath);
			}
		}
	}

	/* Jetzt testen wir den Pfad, ob der vollstaendig ist */
	F_Path_Fullname(HomePath);
	F_Path_Append(HomePath, "");
	strMcpy(path, PATH_MAX, HomePath);
}

/*** ---------------------------------------------------------------------- ***/

/* liefert den Pfad der Applikation
 */
GLOBAL _VOID CatGlobal_ApplPath(_UBYTE *path)
{
	strMcpy(path, PATH_MAX, HomePath);
}

/*** ---------------------------------------------------------------------- ***/

/* liefert den Namen der Applikation
 */
GLOBAL _VOID CatGlobal_ApplName(_UBYTE *name)
{
	strCpy(name, applName);
}

/*** ---------------------------------------------------------------------- ***/

/* konjugiert ein Wort nach Singular oder Plural
 */
GLOBAL _VOID CatGlobal_Konjugiere(CONST _UBYTE *str1, CONST _UBYTE *single, CONST _UBYTE *plural, _ULONG count, _UBYTE *out, size_t strsize)
{
	strMcpy(out, strsize, str1);
	if (count == 1)
		strMcat(out, strsize, single);
	else
		strMcat(out, strsize, plural);
}

/*** ---------------------------------------------------------------------- ***/

/* Erzeugt aus einem Benutzernamen ggf. einen auf maxLen
 * verkuerzten Namen, der sinnvoll abgekuerzt ist
 */
GLOBAL _VOID CatGlobal_KurzName(CONST _UBYTE *name, _UBYTE *ziel, size_t maxLen)
{
	_WORD i;
	_UBYTE tmpStr[1024];
	_UBYTE *p, *n;

	strBcpy(tmpStr, name);
	if (strLen(tmpStr) >= maxLen)
	{
		/* Erstmal Vornamen abkuerzen */
		p = strChr(tmpStr, ' ');
		if (p != NULL)
		{
			n = strChr(tmpStr, '@');
			if (n != NULL && n-2 < p)
			{
				/* Hinter dem @ abschneiden, da kein richtiger Vorname */
				*n = '\0';
			} else
			{
				/* Vornamen verkuerzen */
				Delete(tmpStr, 1, p - tmpStr - 1);
				Insert(".", tmpStr, maxLen, 1);
			}
		}
	}
	if (strLen(tmpStr) >= maxLen)
	{
		/* Immer noch zu lang, hinten ... anhaengen */
		if (maxLen > 4)
			for (i = 0; i < 3; i++)
				tmpStr[maxLen - i - 2] = '.';
		tmpStr[maxLen - 1] = '\0';
	}
	strCpy(ziel, tmpStr);
}

/*** ---------------------------------------------------------------------- ***/

/* Init-Teil vom Modul */

GLOBAL _VOID CatGlobal_Init(_VOID)
{
	_WORD mg3dMode, frame;
	
	/* Jetzt noch die TOS-Versionsvariablen initialisieren */
	SPEC_DEBUG_OUT((EO_DEBUG, "Initializing to MiNT Domain"));
	(_VOID)Pdomain(1);
	isMiNTDomain = Pdomain(-1) > 0;
	SPEC_DEBUG_OUT((EO_DEBUG, "MiNTDomain now: %d", isMiNTDomain));
	/* Mindestens TOS 1.4 vorhanden? */
	minTos14 = gl_ap_version >= 0x140;

	tos3DLook = multiTOS;
	if (!multiTOS && magIx)
	{
		if (magIxVer > 0x200)
		{
			/* ObjcSysvar, ob 3D-Look unter MagIx eingeschaltet ist */
			if (objc_sysvar(0, 10, 0, 0, &mg3dMode, &frame) > 0)
			{
				tos3DLook = mg3dMode != 0;
			}
		}
	}
	SPEC_DEBUG_OUT((EO_DEBUG, "tos3DLook: %d", tos3DLook));
	SPEC_DEBUG_OUT((EO_DEBUG, "*** end of system info"));
}
/*** ---------------------------------------------------------------------- ***/

