/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 *
 * 12.05.00 Dimitri Junker (DYJ)
 *	Zufallstreffer: Hier wurde Flag und State verwechselt
 */


/*
 * 31.7.03 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.29d'
 *	Nach einer Kritik der ST-Computer den Default von 
 *	AlertsInWindow auf TRUE gesetzt
 *
 * 30.9.03 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.30o'
 *	Die Fehlermeldung, da die Kommandozeile fr das Terminalprogramm
 *	leer ist kann jetzt abgestellt werden.
 *
 * 26.5.04 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.37a'
 *	HTML-Export berarbeitet
 */
#include <catmain.h>
#include <wdwmanag.h>
#include <grin.h>
#include <grintool.h>
#include <editor.h>
#include <catgloba.h>
#include <routinec.h>
#include <routines.h>
#include <msglist.h>
#include <catbutto.h>
#include <mtdir.h>
#include <clip.h>
#include <treelist.h>
#include <doitk.h>
#include <msgwindo.h>
#include <confvars.h>
#include <varname2.h>
#include <varnamel.h>
#include <varname4.h>
#include <catutil.h>
#include <protokol.h>
#include <mtedit2.h>
#include <filename.h>
#include <mtappl.h>
#include <debug.h>
#include <mtpaths.h>
#include <maustaus.h>
#include <catvers.h>
#include <mtdials.h>
#include <printer.h>
#include <wiedervo.h>
#include <userinfo.h>
#include <alias.h>
#include <vdistand.h>
#include <adr.h>
#include <catopts.h>
#include <catopts2.h>
#include <shellcal.h>
#include <zsearchd.h>
#include <listhelp.h>
#include <magiccoo.h>
#include <magicstr.h>
#include <infofile.h>
#include <keyboard.h>
#include <mtpopups.h>
#include <iofilter.h>
#include <hlp_prg.h>
#include <vaproto.h>
#include <mte.h>
#include <mime.h>
#include <execv.h>
#include <parser.h>
#include <mtrsc.h>


LOCAL _WORD	HprgIds[MAX_HLP_PRG];

#ifndef __MINTBIND_H__
#include <mintbind.h>
#endif

GLOBAL _UBYTE openPath[PATH_MAX];
GLOBAL _UBYTE openSel[PATH_MAX];
GLOBAL _BOOL BMess;
GLOBAL _BOOL neoDeskBugFix;
GLOBAL _WORD mayUseHidden;
GLOBAL _BOOL altKeyPressed;

LOCAL _BOOL isKonfigPopup;

#define MAX_KONF	8
 
LOCAL _UBYTE KonfigFiles[MAX_KONF][PATH_MAX];

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

GLOBAL _BOOL selectAll(HWND wdw)
{
	if (Editor_IsEditTop(wdw))
		Editor_MarkAll(wdw);
	else if (msgList_listWindowTop(wdw))
		msgList_listSelectAll(wdw, TRUE);
	else if (treeList_treeWindowTop(wdw))
		treeList_treeSelectAll(wdw);
	else if (MsgWindow_msgWindowTop(wdw))
		MsgWindow_msgSelectAll(wdw);
	else
		return FALSE;
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _BOOL deSelectAll(HWND wdw)
{
	if (Editor_IsEditTop(wdw))
	{
		Editor_EditClear(wdw);
	} else if (msgList_listWindowTop(wdw))
	{
		MsgListBase_deselectEntries(MsgListBase_FindWind(wdw));
	} else if (treeList_treeWindowTop(wdw))
	{
		treeList_deselectEntries(wdw);
	} else if (MsgWindow_msgWindowTop(wdw))
	{
		MsgWindow_deselectEntries(wdw);
		MsgWindow_MsgDeselectAll();
	} else
	{
		return FALSE;
	}
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL ExternalPrint(HWND wdw,_BOOL prBlock)
{
	_UBYTE path[PATH_MAX];
	_UBYTE name[PATH_MAX];
	_BOOL printed;
	_UBYTE cmdLine[256];
	_UBYTE ideaPath[PATH_MAX];
	_UBYTE ideaName[PATH_MAX];
	_UBYTE ideaParm[256];
	_WORD chPid;
	
	/* temporaere Datei erstellen */
	CatUtil_makeTmpName(path, name);
	/* Text in Datei schreiben */
	Editor_EditSave(wdw, path, name, FALSE,prBlock);
	/* Jetzt externes Druckprogramm aufrufen */
	printed = Protokoll_SendPrintFile(path, name, Editor_GetMode(wdw, effMode));

	/* Wenn nicht ueber Protokoll gedruckt, dann Idealist starten
	 * mit Kommandozeile
	 */
	if (!printed)
	{
		if (ConfVars_GetConfigString(cExternalPrintProg, ideaPath, sizeof(ideaPath)))
		{
			SplitPath(ideaPath, ideaPath, ideaName);
			strCpy(cmdLine, "-BDE");
			if (Editor_GetMode(wdw, effMode))
				strCat(cmdLine, "+");
			else
				strCat(cmdLine, "-");
			if (ConfVars_GetConfigString(cExternalPrintParm, ideaParm, sizeof(ideaParm)) && *ideaParm != '\0')
			{
				strCat(cmdLine, " ");
				strBcat(cmdLine, ideaParm);
			}
			strBcat(cmdLine, " ");
			F_Path_Append(path, name);
			strBcat(cmdLine, path);
			printed = StartPrg(ideaPath, ideaName, cmdLine, TRUE, TRUE, &chPid) >= 0;
		}
	}
	if (!printed)
	{
		/* temporaere Datei wieder loeschen */
		CatFiles_DeleteFile(path, name);
	}
	return printed;
}

/*** ------------------------------------------------------------------------ ***/
/*	_BOOL initHtmlFile(TEXTFILENO *tfn,TEXTFILENO *tfnExp)						*/
/*	Initialisierung zum HTML-Export												*/
/*	Parameter:	tfn: Rckgabe Zielfile											*/
/*				tfnExp:	Rckgabe Musterfole										*/
/*	Ergebnis:	OK?															*/		
/*	13.11.03 von Dimitri Junker	DYJ 5.32f										*/
/*** ------------------------------------------------------------------------ ***/
/*DYJ 5.21b */
/*DYJ 5.37a Start*/
LOCAL _BOOL initHtmlFile(TEXTFILENO *tfn,TEXTFILENO *tfnExp)
/*DYJ  Ende; alt:	
LOCAL _BOOL initHtmlFile(TEXTFILENO *tfn)
*/
{
	_UBYTE path[PATH_MAX],name[PATH_MAX]="mail.htm",fullName[PATH_MAX];
	_ULONG size;
	_BOOL exists;
	_BOOL ret=FALSE;
	*tfnExp=NULL;
	F_Path_Get(path);
	if (mtDir_FselGet(path, name, "*.htm", Rsc_WrkString(FS_SAVE_AS), FALSE))
	{
		Textmode fileOpenMode = WRITE;
		strBcpy(fullName, path);
		F_Path_Append(fullName, name);

		/* Erstmal feststellen, ob die Datei existiert */
		CatFiles_FileSize(fullName, &exists);
		
		if (exists)
		{
			_WORD select = mtAlerts_Alert(2, Rsc_WrkString(AL_OVERWRITE3));
			if (select == 2)
				fileOpenMode = APPEND;
			else if (select == 3)
				return FALSE;
		}
		if (mtTextfiles_OpenTextfile(fullName, fileOpenMode, 512, tfn) == GERR_OK)
		{
/*DYJ 5.37a Start*/
/*DYJ  Ende; alt:	
			TEXTFILENO tfnEx;
*/
			strBcpy(fullName, DataPath);
			F_Path_Append(fullName, exportHtml);
			size = CatFiles_FileSize(fullName, &exists);
/*DYJ 5.37a Start*/
			if (exists && size > 0 && mtTextfiles_OpenTextfile(fullName, READ, 512, tfnExp) == GERR_OK)
			{
				_UBYTE zeile[1000],*ptr;
				_BOOL weiter=TRUE;
				while(!mtTextfiles_EndofText(*tfnExp) && weiter)
				{
					_ULONG pos;
					pos=mtTextfiles_Textpos(*tfnExp);
					mtTextfiles_ReadLine(*tfnExp,zeile,sizeof(zeile));
					mtTextfiles_ReadLn(*tfnExp);
					ptr=(_UBYTE *)strCaseStr(zeile,"<CAT-TXT>");
					if(ptr)
					{
						*ptr='\0';
						weiter=FALSE;
						mtTextfiles_SetTextpos(*tfnExp,pos+strLen(zeile));
					}
					mtTextfiles_WriteLine(*tfn,zeile);
					mtTextfiles_WriteLn(*tfn);
				}
/*DYJ 5.37a Start*/
				ret=TRUE;
/*DYJ  Ende; alt:	
				mtTextfiles_CloseTextfile(&*tfnExp);
*/
			}
/*DYJ  Ende; alt:	
			if (exists && size > 0 && mtTextfiles_OpenTextfile(fullName, READ, 512, &tfnEx) == GERR_OK)
			{
				_UBYTE zeile[1000],*ptr;
				_BOOL weiter=TRUE;
				while(!mtTextfiles_EndofText(tfnEx) && weiter)
				{
					_ULONG pos;
					pos=mtTextfiles_Textpos(tfnEx);
					mtTextfiles_ReadLine(tfnEx,zeile,sizeof(zeile));
					mtTextfiles_ReadLn(tfnEx);
					ptr=(_UBYTE *)strCaseStr(zeile,"<CAT-TXT>");
					if(ptr)
					{
						*ptr='\0';
						weiter=FALSE;
						mtTextfiles_SetTextpos(tfnEx,pos+strLen(zeile));
					}
					mtTextfiles_WriteLine(*tfn,zeile);
					mtTextfiles_WriteLn(*tfn);
				}
				mtTextfiles_CloseTextfile(&tfnEx);
				ret=TRUE;					/*DYJ 5.37a */
			}
*/
			else
			{
				mtTextfiles_WriteLine(*tfn, "<html>");
				mtTextfiles_WriteLn(*tfn);
				mtTextfiles_WriteLine(*tfn, "<head>");
				mtTextfiles_WriteLn(*tfn);
				mtTextfiles_WriteLine(*tfn, "<title>Cat-Mail</title>");
				mtTextfiles_WriteLn(*tfn);
				mtTextfiles_WriteLine(*tfn, "</head>");
				mtTextfiles_WriteLn(*tfn);
				mtTextfiles_WriteLine(*tfn, "<body>");
				mtTextfiles_WriteLn(*tfn);
				mtTextfiles_WriteLine(*tfn, "<pre>");
				ret=TRUE;
			}
		}
	}
	return ret;
}
/*** ------------------------------------------------------------------------ ***/
/*						*/
/*								*/
/*	Parameter:	keine															*/
/*	Ergebnis:	keines															*/		
/*	6.11.03 von Dimitri Junker	DYJ 5.32f										*/
/*** ------------------------------------------------------------------------ ***/
GLOBAL _VOID exportText(HWND wdw)
{
	size_t sizeT,sizeM;
	_UBYTE *txt,*mime,tmpStr[16];
	sizeT = grin_ActOrgTextSize(wdw);
	sizeM = grin_ActMimeSize(wdw);
	txt = MALLOC(sizeT+sizeM + 2, "exportText");
	if (txt != NULL)
	{
		_UBYTE charsetName[256];
/*DYJ 5.37a Start*/
		TEXTFILENO tfn,tfnEx;
/*DYJ  Ende; alt:	
		TEXTFILENO tfn;
*/
		_BOOL sWritten=FALSE;
		short *unicode;
		grin_ActualOrgText(wdw, txt, sizeT);
		txt[sizeT] = '\0';
		mime=txt+sizeT+1;
		grin_ActualMime(wdw, mime, sizeM);
		mime[sizeM] = '\0';
		if(!grin_getContent(charsetName,mime, "charset="))
		{
			if(UserBLK.isInternet)
				strCpy(charsetName,"iso-8859-1");
			else
				strCpy(charsetName,"ATARI");
		}

		if(strCaseStr(charsetName,"utf-8"))
		{
/*DYJ 5.37a Start*/
			if(initHtmlFile(&tfn,&tfnEx))
/*DYJ  Ende; alt:	
			if(initHtmlFile(&tfn))
*/
			{
				size_t i;
				_WORD rest=0;
				_LONG unicode=0;
				sWritten=TRUE;
				for(i=0;i<sizeT;i++)
				{
					switch(txt[i]&0xf0)
					{
						case 0x80:	/*Folgebyte*/
						case 0x90:
						case 0xA0:
						case 0xB0:
							unicode<<=6;
							unicode|=(txt[i]&0x3f);
							--rest;
							if(!rest)
							{
								sprintf(tmpStr,"&#%ld;",unicode);
								mtTextfiles_WriteLine(tfn,tmpStr);
							}
							break;
						case 0xC0:	/*11bit*/
						case 0xD0:
							unicode=txt[i] & 0x1f;
							rest=1;
							break;
				
						case 0xE0:	/*16bit*/
							unicode=txt[i] & 0xf;
							rest=2;
							break;
				
						case 0xF0:	/* 21bit*/
							unicode=txt[i] & 0x7;
							rest=3;
							break;
						default:	/*7Bit*/
							mtTextfiles_WriteChar(tfn,txt[i]);
							break;
					}
				}
			}
		}
		else
			unicode=Mime_txt2Unicode(txt,charsetName,sizeT);
		if(unicode)
		{
/*DYJ 5.37a Start*/
			if(initHtmlFile(&tfn,&tfnEx))
			{
				int i;
				_BOOL useBR=FALSE,weiter=TRUE;
				_UBYTE zeile[1000],*ptr,tab[110]="";
				short *aktUni=unicode;
				sWritten=TRUE;

				while(!mtTextfiles_EndofText(tfnEx) && weiter)
				{
					_ULONG pos;
					pos=mtTextfiles_Textpos(tfnEx);
					mtTextfiles_ReadLine(tfnEx,zeile,sizeof(zeile));
					mtTextfiles_ReadLn(tfnEx);
					ptr=(_UBYTE *)strCaseStr(zeile,"</CAT-TXT>");
					if(ptr)
					{
						ptr[9]='\0';
						weiter=FALSE;
						mtTextfiles_SetTextpos(tfnEx,pos+strLen(zeile)+1);
					}
					ptr=(_UBYTE *)strCaseStr(zeile,"<TAB>");
					if(ptr)
					{
						strBcpy(tab,ptr+5);
						ptr=(_UBYTE *)strCaseStr(zeile,"</TAB>");
						if(ptr)
							*ptr='\0';
						else
							*tab='\0';
					}
					if(strCaseStr(zeile,"<br>")!=NULL)
						useBR=TRUE;
				}

				for(i=0;i<sizeT;i++)
				{
					if(*aktUni==10 && useBR)
					{
						mtTextfiles_WriteLine(tfn,"<br>");
						mtTextfiles_WriteLn(tfn);
					}
					if(*aktUni==9 && *tab)
						mtTextfiles_WriteLine(tfn,tab);
					else if(*aktUni<128)
						mtTextfiles_WriteChar(tfn,(_UBYTE)*aktUni);
					else
					{
						sprintf(tmpStr,"&#%d;",*aktUni);
						mtTextfiles_WriteLine(tfn,tmpStr);
					}
					aktUni++;
				}
			}
		}
		if(sWritten && tfnEx)
		{
			_UBYTE zeile[1000];
			while(!mtTextfiles_EndofText(tfnEx))
			{
				mtTextfiles_ReadLine(tfnEx,zeile,sizeof(zeile));
				mtTextfiles_ReadLn(tfnEx);
				mtTextfiles_WriteLine(tfn,zeile);
				mtTextfiles_WriteLn(tfn);
			}
			mtTextfiles_CloseTextfile(&tfn);
		}
		else if(sWritten)
/*DYJ  Ende; alt:	
			if(initHtmlFile(&tfn))
			{
				short *aktUni=unicode;
				sWritten=TRUE;
				do
				{
					if(*aktUni<128)
						mtTextfiles_WriteChar(tfn,(_UBYTE)*aktUni);
					else
					{
						sprintf(tmpStr,"&#%d;",*aktUni);
						mtTextfiles_WriteLine(tfn,tmpStr);
					}
				}while(*(aktUni++));
			}
			SFREE(unicode);
		}
		SFREE(txt);
		if(sWritten)
*/
		{
			mtTextfiles_WriteLine(tfn, "</pre>");
			mtTextfiles_WriteLn(tfn);
			mtTextfiles_WriteLine(tfn, "</body>");
			mtTextfiles_WriteLn(tfn);
			mtTextfiles_WriteLine(tfn, "</html>");
			mtTextfiles_WriteLn(tfn);
			mtTextfiles_CloseTextfile(&tfn);
		}
/*DYJ 5.37a Start*/
		if(tfnEx)
			mtTextfiles_CloseTextfile(&tfnEx);
/*DYJ  Ende; */
	}
}

/*** ---------------------------------------------------------------------- ***/

/*DYJ 5.21b */	/*DYJ 5.23e */
GLOBAL _VOID printFile(HWND wdw)
{
	if (Editor_IsEditTop(wdw))
	{
		_BOOL val;

		_BOOL prBlock,askCancel=TRUE;
		_WORD select;
		
		prBlock=Editor_BlockIsMarked(wdw);
		if (prBlock)
		{
			select = mtAlerts_Alert(1, Rsc_WrkString(AL_BLOCK_PRINT));
			if(select==3)
				return;
			prBlock=(select!=2);
			askCancel=FALSE;
		}
		ConfVars_GetConfDefBool(cExternalPrint, &val, FALSE);
		if (val)
		{
			if (!ExternalPrint(wdw,prBlock))
				Editor_EditPrint(wdw, prBlock,askCancel);
		} else
		{
			Editor_EditPrint(wdw, prBlock,askCancel);
		}
	}
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _BOOL cutWdw(HWND wdw, _BOOL append, _BOOL toClip)
{
	if (toClip && !append)
		Clip_ScrapClear("", "");
	return Editor_EditCut(wdw, toClip);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _BOOL copyWdw(HWND wdw, _BOOL append)
{
	if (Editor_IsEditTop(wdw))
	{
		if (!append)
			Clip_ScrapClear("", "");
		return Editor_EditCopy(wdw);
	} else if (msgList_listWindowTop(wdw))
	{
		return msgList_listCopy(wdw, append);
	}
	return FALSE;
}
/*** ---------------------------------------------------------------------- ***/



/*** ---------------------------------------------------------------------- ***/

/*DYJ 5.20t */	/*DYJ 5.21b */	/*DYJ 5.23e */

GLOBAL _BOOL handleFSelMessage(_BOOL merge, HWND ownTopWdw)
{
	CONST _UBYTE *message;

	if (merge)
		message = MausTauschrsc_WrkString(FS_MERGE_FILE);
	else
		message = Rsc_WrkString(FS_LOAD_FILE);

	if (mtDir_FselGet(openPath, openSel, ALL_FILE_MASK, message, FALSE))
	{
		if (merge)
			Editor_EditMerge(ownTopWdw, openPath, openSel);
		else
		{
			_UBYTE *ext;
			_BOOL loadAsMail=FALSE;
			ext=strrChr(openSel,'.');
			if(ext && !strCmp(ext,".822") && MTPaths_DatabaseLocked())
				loadAsMail=mtAlerts_AlertRSC(1,AL_LD_MAIL)==1;
			if(loadAsMail)
			{
				_UBYTE file[PATH_MAX];
				CAT_GROUP_NUMBER ca;
				strBcpy(file, openPath);
				F_Path_Append(file, openSel);
				Parser_OutfileEinsortieren(openPath, openSel, "", "", OM_822);
				if (GroupSelect_GroupNumber("tmp.822", &ca))
					grin_grinOpenMessage(ca, data_lastReadMsgOfGroup(ca), grin_grinNextMess, 0, mUnread);
			}
			else
				MTEdit2_OpenEditWindow(openPath, openSel, FALSE, FALSE);
		}
		return TRUE;
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID KillWinds(_VOID)
{
	_WORD prev;
	_WORD w, dummy;
	_BOOL clearBackGround;

	prev = 0;
	for (;;)
	{
		wind_get(0, WF_TOP, &w, &dummy, &dummy, &dummy);
		/* Ende, wenn das Desktop-Fenster erreicht wurde oder */
		/* wenn ein Fenster nicht geschlossen werden konnte   */
		if (w == 0 || w == prev)
			break;
		wind_close(w);
		wind_delete(w);
		if (WdwManager_IsInQueue(w))
			WdwManager_WindowIsClosed(w);
		prev = w;
	}
	ConfVars_GetConfDefBool(cClearBackground, &clearBackGround, TRUE);
	if (minTos14 && clearBackGround)
	{
		Wind_New();
	}
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _WORD StartPrg(CONST _UBYTE *Path, CONST _UBYTE *Name, CONST _UBYTE *cmd, _BOOL BWin, _BOOL doParallel, _WORD *chPid)
{
	_UBYTE fullpath[PATH_MAX];
	_UBYTE *suff;
	_WORD sh_wdoex=1,ap_gout1,ap_gout2,ap_gout3,ap_gout4;
	_UBYTE arg[1024];
	_WORD res;
	_BOOL buttonWinWasOpen;
	
	_BOOL useARGV;
	useARGV=(strLen(cmd)>126 || strChr(cmd,'\''));
	/* Laenge der Kommandozeile in Byte Nummer 0 */
	strMcpy(arg + 1, sizeof(arg) - 1, cmd);
	arg[0] = (_UBYTE)strLen(arg+1);
	strBcpy(fullpath, Path);
	F_Path_Append(fullpath, Name);
	suff=strChr(Name,'.');
	if(suff)
	{
		suff++;
		if(!strCaseCmp(suff,"ACC"))
		{
			appl_xgetinfo ( 10, &ap_gout1,&ap_gout2,&ap_gout3,&ap_gout4 );
			if(ap_gout1>2)
				sh_wdoex=3;
		}
	}
	if (!multiTask || multiGEM || !doParallel)
	{
		/* Alle eigenen Fenster schliessen */
		if (!CatUtil_WriteSavePos(FALSE, TRUE))
			return 0;

		buttonWinWasOpen = FALSE;
		if (BWin)
			buttonWinWasOpen = CatButtons_CloseButton(FALSE);

		/* Watchdog Bescheid geben */
		Protokoll_SendTerminate(FALSE);

		menu_bar(TreeAddr[MENU], 0);
		F_Path_Set(Path);

		Wind_Update(END_UPDATE);
		if (!multiTask)	 /* kein MultiTOS/MultiGEM */
		{
			/* hier demnaechst noch die Menuezeile ersetzen */
			KillWinds();
			appl_exit(); /* AC_CLOSE an ACCs senden */
		}

		if (F_Path_Set(Path) &&
			/* Zur Sicherheit die Positionstabelle speichern */
			data_WritePos() &&
			/* Gruppenliste zurueckschreiben, falls geaendert */
			GroupSelect_SaveChangedGroupList())
		{
			if (!multiTask)
				MTPaths_Exit();
			if(useARGV)
				res = (_WORD)ExecV_Pexec(0, fullpath, arg, NULL,TRUE);
			else
				res = (_WORD)Pexec(0 /* Load&Go */, fullpath, arg, NULL);
			SPEC_DEBUG_OUT((EO_DEBUG, "Pexec single (%s, %s) : %d", fullpath, arg + 1, res));
			if (!multiTask)
			{
				KillWinds();
				MTPaths_LockDatabase();
			}
			data_ReadPos();
			SPEC_DEBUG_OUT((EO_DEBUG, "after readPos"));
			MouseArrow();
		} else
		{
			res = -1;
		}

		if (!multiTask)	 /* kein MultiTOS/MultiGEM */
		{
			appl_init();
		}

		Wind_Update(BEG_UPDATE);

		Form_dial(FMD_FINISH, &deskSize, &deskSize);
		if (BWin && buttonWinWasOpen)
			CatButtons_DisplayButton(FALSE);

		/* temporaeren Pfad holen bevor Konfigbereich gewechselt wird! */
		CatUtil_GetPosPath(fullpath);
		F_Path_Append(fullpath, tmpInf);
		/* Konfigbereich wechseln */
		ConfVars_ConfigConfigModule(TRUE);
		SPEC_DEBUG_OUT((EO_DEBUG, "reading catpos.inf"));
		if (ConfVars_ReadConfigFile(fullpath))
		{
			/* Alles wieder restaurieren */
			SPEC_DEBUG_OUT((EO_DEBUG, "msgrestorepos"));
			MsgWindow_msgRestorePos();
			SPEC_DEBUG_OUT((EO_DEBUG, "grinrestorepos"));
			grin_grinRestorePos();
			SPEC_DEBUG_OUT((EO_DEBUG, "listrestorepos"));
			msgList_listRestorePos();
			SPEC_DEBUG_OUT((EO_DEBUG, "editrestorepos"));
			Editor_EditRestorePos(TRUE);
			SPEC_DEBUG_OUT((EO_DEBUG, "deleting catpos.inf"));
			F_File_Delete(fullpath);
			CatGlobal_ApplPath(fullpath);			/* ??? warum ApplPath? */
		}
		/* Variablen wieder loeschen */
		SPEC_DEBUG_OUT((EO_DEBUG, "Deletevars"));
		ConfVars_DeleteAllVars();
		/* Und wieder auf normale Einstellung */
		ConfVars_ConfigConfigModule(FALSE);
		SPEC_DEBUG_OUT((EO_DEBUG, "SetColor"));
		CatGlobal_GetUser();

		WdwManager_HandlePendingEvents();

		menu_bar(TreeAddr[MENU], 1);
		MouseArrow();
	}
	else
	{
		F_Path_Set(Path);
		Wind_Update(END_UPDATE);
		if(useARGV && magIxVer>=0x300)
		{
			/* Mag!X, parallel starten */
			_UBYTE *argv;
			size_t len;
			len=ExecV_lenQu2Argv(cmd,TRUE)+strLen(fullpath)+20;
			if(len>sizeof(arg))
				argv=SYSMALLOC(len,MEM_NOERR,"StartPrg:argv");
			else
				argv=arg;
			if(argv)
			{
				ExecV_Qu2Argv(argv,fullpath,cmd,TRUE);
				*chPid = shel_write(sh_wdoex, 1, 100, fullpath, argv);
			}
			SPEC_DEBUG_OUT((EO_DEBUG, "shel_write MagC (%s, %s) : %d", fullpath, arg + 1, *chPid));
			if(argv!=arg)
				SFREE(argv);
		}
		else if (multiTOS && !magIx)
		{
			/* AES >== 4.0, parallel starten */
			if(sh_wdoex==1)
				sh_wdoex--;
			if(!useARGV || (*chPid = (_WORD)ExecV_Shelw(fullpath, arg))<0)
				*chPid = shel_write(sh_wdoex, 1, 1, fullpath, arg);
			SPEC_DEBUG_OUT((EO_DEBUG, "shel_write MTOS (%s, %s) : %d", fullpath, arg + 1, *chPid));
		}
		else
		{
			/* Mag!X, parallel starten */
			*chPid = shel_write(sh_wdoex, 1, 100, fullpath, arg);
			SPEC_DEBUG_OUT((EO_DEBUG, "shel_write MagC (%s, %s) : %d", fullpath, arg + 1, *chPid));
		}
		if (*chPid == 0)
			res = -1;
		else
			res = 0;
		Wind_Update(BEG_UPDATE);
	}
	return res;
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

LOCAL GRECT lbsr, lbr;
LOCAL OBJECT *lbox;


LOCAL _VOID InitLoadingBox(CONST _UBYTE *s)
{
	lbox = TreeAddr[LOADBOX];
	SetObjcString(lbox, LVER, CatVersion);
	mtDials_DialCenter(lbox, CSCREEN, 0, 0, &lbr);
	lbsr.g_x = 0;
	lbsr.g_y = 0;
	lbsr.g_w = 10;
	lbsr.g_h = 10;
	Wind_Update(BEG_UPDATE);
	Form_dial(FMD_START, &lbsr, &lbr);
	Form_dial(FMD_GROW, &lbsr, &lbr);
	SetObjcString(lbox, INITTEXT, s);
	Objc_draw(lbox, ROOT, MAX_DEPTH, &lbr);
}

/*** ---------------------------------------------------------------------- ***/

/*DYJ 5.21b */
LOCAL _BOOL TellLoadingBox(_WORD nr)
{
	GRECT r;

	SetObjcString(lbox, INITTEXT, MausTauschrsc_WrkString(nr));
	CalcArea(lbox, INITTEXT, &r);
	Objc_draw(lbox, ROOT, MAX_DEPTH, &r);
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID FreeLoadingBox(_VOID)
{
	Form_dial(FMD_SHRINK, &lbsr, &lbr);
	Form_dial(FMD_FINISH, &lbsr, &lbr);
	Wind_Update(END_UPDATE);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID TellSorting(_VOID)
{
	TellLoadingBox(cInitNames);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL loadPrinterCFG(_VOID)
{
	_UBYTE cfgFile[PATH_MAX];

	if (ConfVars_GetConfigString(cPrintCFGFile, cfgFile, sizeof(cfgFile)))
	{
		TellLoadingBox(cInitPrint);
		Printer_LoadCFGFile(cfgFile);
	}
	return TRUE;
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

GLOBAL _VOID CheckWithAlt(_BOOL *pressed)
{
	_BOOL wasPressed;
	_WORD moX, moY;
	_UWORD moButton;
	_UWORD moKState;

	wasPressed = *pressed;
	graf_mkstate(&moX, &moY, &moButton, &moKState);
	if (moKState & K_ALT)
		*pressed = TRUE;
	if (*pressed && !wasPressed)
	{
		/* Bimmeln */
		CatGlobal_Bing(cBingTerminalStart);
	}
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

/*DYJ 5.23e */
LOCAL _BOOL InitRsc(_VOID)
{
	_UWORD z;
	_UWORD bp;
	OBJECT *colPopup;
	shellType shell;

	colPopup  = TreeAddrLib[COLPOPUP];

	if (!ZSearchDial_InitMenuStr())
		return FALSE;

	shell = ShellCall_IsShell();
	if (shell == noShell)
		SetObjState(TreeAddr[MENU], CALLSHEL, DISABLED);

	SetObjcString(TreeAddr[CAT_ICON], THE_ICON, CAT_PROGNAME " " CatVersion);

	if (Bitplanes < 4)
	{
		maxColors = 1 << Bitplanes;
		bp = maxColors * 2;
		for (z = bp + 1; z <= 32; z++)
		{
			DelObjFlags(colPopup, z, SELECTABLE);
			EnableObjState(colPopup, z, DISABLED, TRUE);
		}
	} else
	{
		maxColors = 16;
	}
	CatButtons_InitButtonWindow();
	
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL dummyProc(_VOID)
{
	_BOOL mint;
	
	TellLoadingBox(cInitConfig);

	/* Hier auch noch die Namenslisten und Gruppenlisten freigeben! */
	ConfVars_DeleteAllVars();
	ConfVars_CloseConfig();
	Printer_FreeCFGFile();
	WiederVorlage_Exit();
	msgList_ExitMsgList();
	Alias_Exit();
	
	/* Erstmal zuruecksetzen auf TOS-Domain */
	(_VOID) Pdomain(0);

	UserInformation_ReadUserBlock();
/*DYJ 5.32b Start*/
/*DYJ  Ende; alt:	
	if(UserBLK.isInternet)
		SetObjcString(TreeAddr[MENU], OCBC_PMF, MENU_PMF);
	else
		SetObjcString(TreeAddr[MENU], OCBC_PMF, MENU_CBC);
*/
	CatOpts2_InitSounds();
	Alias_Init();
	
	/* Pruefen, ob wir in der Mint-Domain laufen sollen */
	ConfVars_GetConfDefBool(cMiNTDomain, &mint, TRUE);
	if (mint)
	{
		SPEC_DEBUG_OUT((EO_DEBUG, "Setting MiNT Domain"));
		(_VOID) Pdomain(1);
	} else
	{
		SPEC_DEBUG_OUT((EO_DEBUG, "Setting TOS Domain"));
		(_VOID) Pdomain(0);
	}
	isMiNTDomain = Pdomain(-1) > 0;
	SPEC_DEBUG_OUT((EO_DEBUG, "MiNTDomain now: %d", isMiNTDomain));
	
	return VDIStandards_InitVDIStandards();
}

/*** ---------------------------------------------------------------------- ***/

/* Initialisiert das Konfigurations-Popup, indem die KONFIG.INF gelesen wird (MH) */
/*DYJ 5.21b */
LOCAL _VOID InitKonfigPopup(_VOID)
{
	_UBYTE path[PATH_MAX];
	_UBYTE scrap[PATH_MAX];
	_UBYTE cmd[19];
	OBJECT *popup;
	TEXTFILENO konf;
	_WORD i;
	
	popup = TreeAddr[KONFBOX];
	isKonfigPopup = FALSE;
	
	for (i = 0; i < MAX_KONF; i++)
	{
		EnableObjState(popup, KONF_LOW + i, DISABLED, TRUE);
		EnableObjFlags(popup, KONF_LOW + i, SELECTABLE, FALSE);
		SetObjcString(popup, KONF_LOW + i, MausTauschrsc_WrkString(KONF_NOT_AVAILABLE));
		MemSetZero(&KonfigFiles[i], sizeof(KonfigFiles[i]));
	}
	
	CatGlobal_ApplPath(path);
	F_Path_Append(path, confInfName);
	
	if (mtTextfiles_OpenTextfile(path, READ, 512, &konf) == GERR_OK)
	{
		i = 0;
		
		while (!mtTextfiles_EndofText(konf) && i < MAX_KONF)
		{
			mtTextfiles_ReadLine(konf, scrap, sizeof(scrap));
			mtTextfiles_ReadLn(konf);
			
			if (scrap[0] != '\0')
			{
				strBcpy(cmd, " ");
				strMcat(cmd, sizeof(cmd) - 1, scrap);
				strBcat(cmd, " ");
				
				if (!mtTextfiles_EndofText(konf))
				{
					mtTextfiles_ReadLine(konf, scrap, sizeof(scrap));
					mtTextfiles_ReadLn(konf);
					
					if (scrap[0] != '\0')
					{
						EnableObjState(popup, KONF_LOW + i, DISABLED, FALSE);
						EnableObjFlags(popup, KONF_LOW + i, SELECTABLE, TRUE);
						SetObjcString(popup, KONF_LOW + i, cmd);
						strBcpy(KonfigFiles[i], scrap);
						
					    i++;
					    isKonfigPopup = TRUE;
				    }
			    }
		    }
		}
		mtTextfiles_CloseTextfile(&konf);
	}
}

/*** ---------------------------------------------------------------------- ***/

/*DYJ 5.21b */	/*DYJ 5.21p */	/*DYJ 5.29d */
GLOBAL _BOOL cat_init(_BOOL dbChanged, _BOOL noCommand, CONST _UBYTE *inf_from_argv)
{
	_UBYTE scrap[PATH_MAX];
	_BOOL boolVal;
	_BOOL done;
	
	InitLoadingBox(MausTauschrsc_WrkString(cInitInf));
	CatFiles_Init();
	if (MTPaths_ReadInf(infPath, infName, noCommand, TRUE, inf_from_argv) &&
		dummyProc() &&
		TellLoadingBox(cInitGrin) &&
		EditType_Init() &&
		grin_grinInit() &&
		TellLoadingBox(cInitGroups) &&
		GroupSelect_ReadGroupList() &&
		/* Wiedervorlageliste lesen */
		WiederVorlage_ReadResubList(WVL) &&  /* zum Pruefen oeffnen (MH) */
		TellLoadingBox(cInitData) &&
		data_InitDataBase() &&
		adr_ReadNames(ADR_NORMAL) &&
		adr_ReadNames(ADR_ALIAS) &&
		loadPrinterCFG() &&
		TellLoadingBox(cInitMsgMan) &&
		MsgWindow_InitMessageManager() &&
		TellLoadingBox(cInitRsc) &&
		InitRsc() &&
		TellLoadingBox(cInitClip) &&
/*DYJ 5.36a Start*/
		Mime_init() &&
/*DYJ  Ende; alt:	
		Mime_init &&
*/
		Clip_GetScrap(scrap))
	{
		if(!*AttachmentPath)
		{
			MTE_infoRSC(AL_ATTACH);
			CatOpts_doConfig(0,0);
		}
/*DYJ 5.30o Start*/
		ConfVars_GetConfDefBool(cAllowEmptyCmd, &boolVal, FALSE);
		if(!*TerminalCmd && !boolVal)
		{
			if(mtAlerts_AlertRSC(1,AL_TERMCMD)==1)
				CatOpts_doConfig(0,0);
			else
				ConfVars_SetConfigBool(cAllowEmptyCmd,TRUE);
		}				
/*DYJ  Ende; alt:	
		if(!*TerminalCmd)
		{
			MTE_infoRSC(AL_TERMCMD);
			CatOpts_doConfig(0,0);
		}
*/
		/* Pruefen, wie die Alerts aussehen sollen */
		ConfVars_GetConfDefBool(cAlertsInWindow, &boolVal, TRUE);
		WinDials_AlertsInWindow(boolVal);

		/* Zweite Ueberpruefung auf Alternate-Taste */
		if (!dbChanged)
			CheckWithAlt(&altKeyPressed);

		WdwManager_EnableIconify(TRUE);
		WdwManager_SetWindowIcon(TreeAddr[CAT_ICON]);
		MausTauschrsc_MenuInit();
		
		/* kann bei den folgenden etwas schieflaufen ?? */
		TellLoadingBox(cInitDials);
		ListHelp_Init();
		grinTools_Init();
		CatGlobal_GetUser();

		if (magicPC)
		{
			ConfVars_GetConfDefBool(cMagicPCKeyTranslation, &boolVal, TRUE);
			SetMagicPCKeyTranslation(boolVal);
		}

		adr_SortList(ADR_NORMAL,TellSorting);
		adr_SortList(ADR_ALIAS,TellSorting);

		/* Feststellen, ob der NeoDeskBugFix aktiv sein soll */
		ConfVars_GetConfDefBool(cNeoDeskBugFix, &neoDeskBugFix, FALSE);

		TellLoadingBox(cInitInfos);
		Infofiles_LoadInfoInf(dbChanged, FALSE);
		if (ConfVars_GetConfigBool(cRequestPmails, &boolVal) ||
			ConfVars_GetConfigBool(cRequestGrpMsgs, &boolVal) ||
			!Infofiles_Available(ITK_SHORT_NAME, TRUE))
			DoITK_TransformCommands(TRUE);

		/* Setzen des Zeilenaufbaus fuer die Stichwortliste */
		TellLoadingBox(cInitList);
		msgList_InitMsgList();

		TellLoadingBox(cInitButton);
		ConfVars_GetConfDefBool(cShowMessages, &BMess, TRUE);
		CatButtons_Select_Messages(BMess);
		VDIStandards_CheckItem(TreeAddr[MENU], TREADMSG, !BMess);
		if(ConfVars_GetConfigBool("HiddenFeatures", &mayUseHidden))
		{
			ConfVars_DeleteConfigVar("HiddenFeatures");
			ConfVars_SetConfigInt(cHiddenFeatureMode, mayUseHidden ? 1 : 0);
		}
		ConfVars_GetConfDefInt(cHiddenFeatureMode, &mayUseHidden, 0);


		/* Konfigurations-Popup initialisieren (MH) */
		TellLoadingBox(cInitKonf);
		InitKonfigPopup();
		
		done = TRUE;
	} else
	{
		done = FALSE;
	}
	FreeLoadingBox();
	return done;
}

/*** ---------------------------------------------------------------------- ***/
/*Hier werden jetzt die alten Hilfsprogramme beendet und die neuen gestartet*/
/*DYJ 5.21b */
GLOBAL _BOOL ReadInfoFile(_BOOL doFsel, _BOOL groupsDeleted)
{
	_UBYTE scrap[PATH_MAX];
	_UBYTE path[PATH_MAX];
	_WORD i;
	_WORD x, y;
	_UWORD udummy;
	OBJECT *popup;
	
	popup = TreeAddr[KONFBOX];
	if (doFsel)
	{
		/* Popup davorschalten (MH) */
		if (isKonfigPopup)
		{
			graf_mkstate(&x, &y, &udummy, &udummy);
			i = mtPopups_TreePopup(popup, x, y, 0);
			
			if (i < 0)
				return FALSE;
			
			if (i >= KONF_LOW && i <= KONF_HIGH)
				mtDir_SplitPath(KonfigFiles[i - 1], infPath, infName, path);
		}
		
		if (!isKonfigPopup || i == KONFSEL)
		{
			mtDir_SplitPath(infName, path, path, scrap);
			if (scrap[0] != '\0')
				Insert("*.", scrap, sizeof(scrap), 0);
			else
				strCpy(scrap, "*.inf");
			
			if (!mtDir_FselGet(infPath, infName, scrap, MausTauschrsc_WrkString(FS_LOAD_INF), FALSE))
				return FALSE;
		}
	}
	
	CatButtons_CloseButton(FALSE);
	grin_grinCloseAll();
	msgList_listCloseAll();
	treeList_treeCloseAll();
	msgList_listFreeAll();
	Infofiles_Exit();
	if (!WdwManager_CloseAllWindows(FALSE))
		return FALSE;
	data_WritePos();       /* Positionstabelle zurueckschreiben */
	if (!groupsDeleted)
		if (!GroupSelect_SaveChangedGroupList()) /* Gruppenliste zurueckschreiben, falls geaendert */
			return FALSE;
	MouseBusy();
	HlpPrg_TermPrg();
	if (cat_init(TRUE, TRUE, NULL))
	{
		HlpPrg_RunPrg();
		CatButtons_DisplayButton(TRUE);
		MouseArrow();
		WiederVorlage_CheckForResub();
		return TRUE;
	}
	MouseArrow();
	return FALSE;
}

/*** ------------------------------------------------------------------------ ***/
/*	GLOBAL _BOOL HlpPrg_RunPrg(_VOID)										*/
/*	Fhrt die Hilfsprogramme aus												*/
/*	Abgeleitet von IoFilter_IoFilterPastOutfile									*/
/*	Parameter:	nr: -1: alle starten, sonst nur das angegebene					*/
/*	Ergebnis:	keines															*/		
/*	30.3.00 von Dimitri Junker	DYJ 4.14;	DYJ 4.17									*/
/*** ------------------------------------------------------------------------ ***/
/*DYJ 5.21b */
GLOBAL _VOID HlpPrg_RunPrg(_VOID)
{
	hlpPrgStruct hprg;
	_WORD i,action;
	_UBYTE cmdLine[256];
	_UBYTE varname[256];
	_UBYTE hprgPath[PATH_MAX];
	_UBYTE hprgName[PATH_MAX];
	_WORD app_id;
	_WORD av_id,quote_id,avModus;
	if(multiTask)
	{
		for (i = 0; i < MAX_HLP_PRG; i++)
		{
			/* alle Hilfsprogramme durchgehen
			 */
			HprgIds[i]=-1;
			make_varname(varname, sizeof(varname), cHlpPrgProg, i + 1);
			if (ConfVars_GetConfigString(varname, hprg.hprgPath, sizeof(hprg.hprgPath)))
			{
				/* Hilfsprogramm ist vorhanden, auslesen */
				HlpPrg_ReadPrg(&hprg, i + 1);
				
				/* Jetzt nachsehen, ob wir das Hilfsprogramm auch benutzen 
				 * muessen 
				 */
				if (hprg.activ)
				{
					action=hprg.mulStart;	/* bei Mehrfachstart:0:nichts,1:Fragen,2:Parameter senden,3:starten*/
					if(action!=3)	/* dann prfen ob schon vorhanden	*/
					{
						app_id=appl_locate(hprg.hprgPath,FALSE);
						if(app_id==-1)		/* Noch nicht vorhanden ->Starten	*/
							action=3;
					}
					SplitPath(hprg.hprgPath, hprgPath, hprgName);
					if(action==1)
					{
						sprintf(cmdLine, MausTauschrsc_WrkString(AL_RES_HP), hprgName);
						action=mtAlerts_Alert(1,cmdLine)+1;
					}
					if(action==2 || action==3)
					{
						/* Kommandozeile zusammenbauen */
						if(action==3)
						{
							buildCmdLine(hprg.Cmd, cmdLine, sizeof(cmdLine),DO_QUOTE);
							/* Hilfsprogramm aufrufen */
							SPEC_DEBUG_OUT((EO_DEBUG, "Hilfsprogramm starten: %s %s", hprg.hprgPath, cmdLine + 1));
		
							if(StartPrg(hprgPath, hprgName, cmdLine, TRUE, TRUE, &HprgIds[i])<0)
								HprgIds[i]=-1;
						}
						else
						{
							ConfVars_GetConfDefInt(cAvModus, &avModus, 2);
							if(avModus && (av_id = FindAVServerFor(AV_STARTPROG))>= 0)
							{
								if(avModus==2)
									quote_id=av_id;
								else
									quote_id=DONT_QUOTE;
								buildCmdLine(hprg.Cmd, cmdLine, sizeof(cmdLine),quote_id);
								/* Hilfsprogramm Parameter ber AV-Server senden */
								SPEC_DEBUG_OUT((EO_DEBUG, "Parameter an Hilfsprogramm ber AV-Server: %s %s", hprg.hprgPath, cmdLine + 1));
								Protokoll_SendPath(AV_STARTPROG,av_id, hprg.hprgPath, cmdLine);
							}
							else
							{
								buildCmdLine(hprg.Cmd, cmdLine, sizeof(cmdLine),app_id);
								/* Hilfsprogramm Parameter senden */
								SPEC_DEBUG_OUT((EO_DEBUG, "Parameter an Hilfsprogramm: %s %s", hprg.hprgPath, cmdLine + 1));
								Protokoll_SendPath(VA_START,app_id, cmdLine, NULL);
							}
						}
					}
				}
			}
		}
	}
}
/*** ------------------------------------------------------------------------ ***/
/*	GLOBAL _BOOL HlpPrg_TermPrg(_VOID)											*/
/*	Beendet die Hilfsprogramme die lt. Flag beendet werden sollen				*/
/*	Parameter:	keine															*/
/*	Ergebnis:	keines															*/		
/*	30.3.00 von Dimitri Junker		DYJ 4.14									*/
/*** ------------------------------------------------------------------------ ***/
GLOBAL _VOID HlpPrg_TermPrg(_VOID)
{
	hlpPrgStruct hprg;
	_WORD i,j;
	_UBYTE varname[256],*p;
	_WORD msg[8]={AP_TERM,0,0,0,0,AP_TERM,0,0},app_id;
	_WORD apMode, apType, hatSearch,dummy;
	_UBYTE apNameF[80],apNameS[9];
	msg[1]=gl_apid;
	
	if(multiTask)
	{
		for (i = 0; i < MAX_HLP_PRG; i++)
		{
			/* alle Hilfsprogramme durchgehen
			 */
			make_varname(varname, sizeof(varname), cHlpPrgProg, i + 1);
			if (ConfVars_GetConfigString(varname, hprg.hprgPath, sizeof(hprg.hprgPath)))
			{
				/* Hilfsprogramm ist vorhanden, auslesen */
				HlpPrg_ReadPrg(&hprg, i + 1);
				
				/* Jetzt nachsehen, ob wir das Hilfsprogramm auch beenden 
				 * muessen 
				 */
				if (hprg.term && HprgIds[i]>-1)
				{
					/* AP_TERM an Hilfsprogramm senden */

					app_id=appl_locate(hprg.hprgPath,FALSE);
					if(app_id<0)
						app_id=-1;			/* PRG luft nicht*/
					else
					{
						if(app_id!=HprgIds[i])		/* dann auf die harte Tour, luft ggf. mehrmals	*/
						{
							appl_xgetinfo(APG_GLOBAL1, &dummy, &dummy, &hatSearch, &dummy);
							if(hatSearch)
							{
								apMode = APS_FIRST;
								while (appl_search(apMode, apNameF, &apType, &app_id))
								{
									apMode = APS_NEXT;
									if(app_id==HprgIds[i])
									{
										p = F_Path_Basename(hprg.hprgPath);
										for (j = 0; j < 8 && p[j] != '\0' && p[j] != '.'; j++)
										{
											apNameS[j] = ucase(p[j]);
										}
										for (; j < 8; j++)
											apNameS[j] = ' ';
										apNameS[8] = '\0';
										if(strCmp(apNameS,apNameF))
											app_id=-1;			/* war's wohl nicht*/
									}
								}
							}
							else
								app_id=-2;	/* Bei Wunsch kann man ggf. eine Warnung herausgeben*/
						}
					}
					switch(app_id)
					{
						case -2:
							SPEC_DEBUG_OUT((EO_DEBUG, "Hilfsprogramm: %s kann zum Beenden nicht eindeutig identifiziert werden", hprg.hprgPath));
						case -1:
							break;
						default:
							SPEC_DEBUG_OUT((EO_DEBUG, "Hilfsprogramm: %s beenden", hprg.hprgPath));
							appl_write(app_id, 16, msg);
					}
				}
			}
		}
	}
}

