/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 *
 * 24.11.02 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.17n'
 *	In den allgemeinen Einstellungen kann man jetzt auch ein
 *	allgemeiner Reply2 setzen
 *	RSC-NEU: REP2TIT, REP2IN: neu
 *
 * 29.11.02 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.19e'
 *	Einige Config-Variablen fr Internetmodus deaktiviert:
 *	StatusMessagesInInfile=FALSE
 *	AutomaticSplit=FALSE
 *	SplitSize=0
 *	GroupSelectSortType=name
 *
 * 7.3.03 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.21o'
 *	RSC-NEU: PATH_CNF aus den cat.rsc und install.rsc in die 
 *	catlib.rsc verschoben.
 *
 * 14.3.03 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.22d'
 *	Farbdialoge berarbeitet
 *
 * 6.4.03 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.24h'
 *	Die nderungen in Optionen/Farbe wurden teils erst beim nchsten
 *	Start wirksam
 *
 * 15.10.03 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.32c'
 *	Fehler bei der Verwaltung der Infozeilenformate behoben
 *
 * 3.04 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.34h'
 *	Hat man bei den Formatstrings (Optionen/Formate) einen Fehler
 *	gemacht verrt Cat einem jetzt in welcher der Zeilen.
 */


#include <catopts.h>
#include <cattypes.h>
#include <catgloba.h>
#include <wdwmanag.h>
#include <maustaus.h>
#include <mte.h>
#include <editor.h>
#include <grin.h>
#include <printer.h>
#include <cathelp.h>
#include <edittype.h>
#include <vdiutil.h>
#include <confvars.h>
#include <varname1.h>
#include <varname3.h>
#include <varname5.h>
#include <varnamel.h>
#include <varn_edi.h>
#include <infodlg.h>
#include <userinfo.h>
#include <mtpaths.h>
#include <msgwindo.h>
#include <msglist.h>
#include <treelist.h>
#include <protokol.h>
#include <vaproto.h>
#include <windials.h>
#include <edittool.h>

#include <mtutils.h>
#include <mtdials.h>
#include <mtdir.h>
#include <mtpopups.h>
#include <mtappl.h>
#include <mttextfi.h>
#include <magicstr.h>
#include <portvdi.h>

#include <strconv.h>
#include <ro_mem.h>
#include <routinec.h>
#include <routines.h>
#include <file_io.h>
#include <catutil.h>
#include <catmain.h>
#include <tos.h>
#include <mtrsc.h>
#include <catlib.h>
/* Konstantendefinitionen */


#define CFG_NONAME "noname.cfg"

#define hs   "ST-GUIDE"

/* Globale Variablen */

GLOBAL _UWORD maxColors;

/* Such- und Ersetzeinstellungen  */
LOCAL struct {
	_BOOL isSet;
	_BOOL doIt;
	_BOOL ignoreCase;
	_BOOL askBack;
	_BOOL onlyWord;
	HWND theSearchWdw;
	searchDir direction;
	searchCount count;
	searchPos pos;
	_WORD number;
	_UBYTE searchStr[256];
	_UBYTE replaceStr[256];
} searchOpts, replaceOpts;

	_UBYTE Tmp_CatInf[PATH_MAX]="";
	_WORD TermPid=0;

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

/*
 * Request Help via PC_HELP Protokoll
 * wird bei markiertem Block und Shift-Help fuer externe Hilfe verwendet
 */
GLOBAL _VOID Protokoll_SendHelp(CONST _UBYTE *str)
{
	_UBYTE helpServer[10];

	ConfVars_GetConfDefStr(cHelpServer, helpServer, sizeof(helpServer), hs);
	VaProto_SendHelp(str, helpServer);
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

/* Ruft NewDial auf und zentriert ggf. den Dialog danach */
_BOOL CatOpts_InitDial(OBJECT *tree)
{
	GRECT r;

	if (!mtDials_NewDial(tree))
		return FALSE;
	mtDials_DialCenter(tree, CSCREEN, 0, 0, &r);
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

_BOOL CatOpts_GetItem(OBJECT *dial, _WORD item)
{
	return GetObjState(dial, item, SELECTED);
}

/*** ---------------------------------------------------------------------- ***/

_VOID CatOpts_SetItem(OBJECT *dial, _WORD item, _BOOL b)
{
	EnableObjState(dial, item, SELECTED, b);
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/
/*DYJ 5.21b */	/*DYJ 5.23e */
LOCAL _BOOL searchButton(OBJECT *tree, _VOID *env, _WORD button, _WORD mx, _WORD my, _UWORD kstate, _WORD clicks)
{
	_UBYTE allChar[2], oneChar[2];
	GRECT r;

	UNUSED(env);
	UNUSED(mx);
	UNUSED(my);
	UNUSED(kstate);
	UNUSED(clicks);
	if(button==-1)
		return FALSE;
	button &= 0x7fff;
	DelObjState(tree, button, SELECTED);
	if (button == SROK)
	{
		ObjcString(tree, SQALL, allChar, sizeof(allChar));
		ObjcString(tree, SQONE, oneChar, sizeof(oneChar));
		if (allChar[0] == oneChar[0] || allChar[0] == '\0' || oneChar[0] == '\0')
		{
			MTE_info(Rsc_WrkString(AL_WRONG_WILD));
			WinDials_WinDialDraw(tree, button, MAX_DEPTH, &r, FALSE);
			return FALSE;
		}
		/* String auslesen */
		ObjcString(tree, SSUCHSTR, searchOpts.searchStr, sizeof(searchOpts.searchStr));
		/* Jetzt Suchstring ueberpruefen, ob nur Wildcards drin sind */
		if (strLen(searchOpts.searchStr) == 0)
		{
			/* Leerer String geht auch */
			return TRUE;
		}
		/* Jetzt der eigentliche Test */
		while ((searchOpts.searchStr[0] == allChar[0] || searchOpts.searchStr[0] == oneChar[0]) &&
			searchOpts.searchStr[0] != '\0')
		{
			strCpy(searchOpts.searchStr, searchOpts.searchStr + 1);
			if (searchOpts.searchStr[0] == '\0')
			{
				MTE_info(Rsc_WrkString(MTE_noSearchStr));
				WinDials_WinDialDraw(tree, button, MAX_DEPTH, &r, FALSE);
			}
		}
		if (searchOpts.searchStr != '\0')
			return TRUE;
	} else if (button == FINDHELP)
	{
		CatHelp_DoHelp(CatHelp_textsearch);
	} else
	{
		return TRUE;
	}
	WinDials_WinDialDraw(tree, button, MAX_DEPTH, &r, FALSE);
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/
/*DYJ 5.21b */	/*DYJ 5.23e */
LOCAL _VOID searchGetSetValues(OBJECT *tree, _VOID *env, _BOOL set, _WORD exit)
{
	_UBYTE allChar[2], oneChar[2];

	UNUSED(env);
	if (set)
	{
		Editor_GetWildChars(oneChar, allChar);
		SetObjcString(tree, SQALL, allChar);
		SetObjcString(tree, SQONE, oneChar);
		SetObjcString(tree, SSUCHSTR, searchOpts.searchStr);
	} else
	{
		exit &= 0x7fff;
		DelObjState(tree, exit, SELECTED);
		if (exit == SROK)
		{
			searchOpts.isSet = TRUE;
			/* Strings auslesen */
			searchOpts.ignoreCase = CatOpts_GetItem(tree, SCASE);
			searchOpts.onlyWord   = CatOpts_GetItem(tree, SWORD);
			/* Startposition suchen */
			if (CatOpts_GetItem(tree, SFROMTOP))
				searchOpts.pos = fromStart;
			else if (CatOpts_GetItem(tree, SFROMCUR))
				searchOpts.pos = fromPos;
			/* Anzahl feststellen */
			searchOpts.count = searchOne;
			/* letzte Parameter */
			ObjcString(tree, SQALL, allChar, sizeof(allChar));
			ObjcString(tree, SQONE, oneChar, sizeof(oneChar));
			if (allChar[0] == oneChar[0] || allChar[0] == '\0' || oneChar[0] == '\0')
				MTE_info(Rsc_WrkString(AL_WRONG_WILD));
			else
				Editor_SetWildChars(oneChar[0], allChar[0]);
			ObjcString(tree, SSUCHSTR, searchOpts.searchStr, sizeof(searchOpts.searchStr));
			if (Editor_IsEditTop(searchOpts.theSearchWdw))
			{
				searchOpts.doIt = TRUE;
				/*
				Editor_Search(searchOpts.theSearchWdw,
					searchOpts.searchStr,
					searchOpts.pos,
					searchOpts.direction,
					searchOpts.count,
					1,
					searchOpts.ignoreCase,
					searchOpts.onlyWord,
					FALSE,
					cBingNothingFound);
				*/
			}
		}
	}
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID CatOpts_DoSearch(_VOID)
{
	OBJECT *ersetzBox;

	ersetzBox = TreeAddr[FINDBOX];
	if (Editor_IsEditTop(ownTopWindow))
	{
		searchOpts.theSearchWdw = ownTopWindow;
		searchOpts.doIt = FALSE;
		if (!WinDials_OpenWinDial(ersetzBox, TRUE,
			searchGetSetValues,
			searchGetSetValues,
			searchButton,
			WinDials_defDraw,
			NULL,
			NULL))
		{
			return;
		}
		WinDials_WinDialHandleEvents();
		if (searchOpts.doIt)
		{
			WdwManager_HandlePendingEvents();
			Editor_Search(searchOpts.theSearchWdw,
				searchOpts.searchStr,
				searchOpts.pos,
				searchOpts.direction,
				searchOpts.count,
				1,
				searchOpts.ignoreCase,
				searchOpts.onlyWord,
				FALSE,
				cBingNothingFound);
		}
	}
}

/*** ---------------------------------------------------------------------- ***/

_VOID CatOpts_DoSearchAgain(_UWORD kstate)
{
	searchDir sDir;

	if (Editor_IsEditTop(ownTopWindow))
	{
		searchOpts.pos = fromPos;
		if (CatGlobal_WithShift(kstate))
		{
			if (searchOpts.direction == sdir_forward)
				sDir = sdir_backward;
			else
				sDir = sdir_forward;
		} else
		{
			sDir = searchOpts.direction;
		}
		Editor_Search(ownTopWindow,
			searchOpts.searchStr,
			searchOpts.pos,
			sDir,
			searchOpts.count,
			1,
			searchOpts.ignoreCase,
			searchOpts.onlyWord,
			TRUE,
			cBingNothingFound);
	}
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/
/*DYJ 5.21b */
LOCAL _BOOL replaceButton(OBJECT *tree, _VOID *env, _WORD button, _WORD mx, _WORD my, _UWORD kstate, _WORD clicks)
{
	_UBYTE allChar[2], oneChar[2];
	GRECT r;

	UNUSED(env);
	UNUSED(mx);
	UNUSED(my);
	UNUSED(kstate);
	UNUSED(clicks);

	button &= 0x7fff;
	switch (button)
	{
	case RGESAMT:
	case REINMAL:
		SetObjState(tree, RCOUNT, DISABLED);
		DelObjFlags(tree, RCOUNT, EDITABLE);
		WinDials_WinDialDraw(tree, RCOUNT, 0, &r, FALSE);
		return FALSE;

	case RNMAL:
		DelObjState(tree, RCOUNT, DISABLED);
		SetObjFlags(tree, RCOUNT, EDITABLE);
		WinDials_WinDialDraw(tree, RCOUNT, 0, &r, FALSE);
		return FALSE;

	case RROK:
	case RRQUIT:
		DelObjState(tree, button, SELECTED);
		if (button == RROK)
		{
			ObjcString(tree, RRQALL, allChar, sizeof(allChar));
			ObjcString(tree, RRQONE, oneChar, sizeof(oneChar));
			if (allChar[0] == oneChar[0] || allChar[0] == '\0' || oneChar[0] == '\0')
			{
				MTE_info(Rsc_WrkString(AL_WRONG_WILD));
				WinDials_WinDialDraw(tree, button, MAX_DEPTH, &r, FALSE);
				return FALSE;
			}
			/* String auslesen */
			ObjcString(tree, RSUCHSTR, replaceOpts.searchStr, sizeof(replaceOpts.searchStr));
			/* Jetzt Suchstring ueberpruefen, ob nur Wildcards drin sind */
			if (*replaceOpts.searchStr == '\0')
			{
				/* Leerer String geht auch */
				return TRUE;
			}
			/* Jetzt der eigentliche Test */
			while ((replaceOpts.searchStr[0] == allChar[0] || replaceOpts.searchStr[0] == oneChar[0]) &&
				*replaceOpts.searchStr != '\0')
			{
				strCpy(replaceOpts.searchStr, replaceOpts.searchStr + 1);
				if (*replaceOpts.searchStr == '\0')
				{
					MTE_info(Rsc_WrkString(MTE_noSearchStr));
					WinDials_WinDialDraw(tree, button, MAX_DEPTH, &r, FALSE);
				}
			}
			if (*replaceOpts.searchStr != '\0')
				return TRUE;
		} else
		{
			return TRUE;
		}
		WinDials_WinDialDraw(tree, button, MAX_DEPTH, &r, FALSE);
		break;

	case REPLHELP:
		DelObjState(tree, button, SELECTED);
		CatHelp_DoHelp(CatHelp_textrepl);
		WinDials_WinDialDraw(tree, button, MAX_DEPTH, &r, FALSE);
		break;
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/
/*DYJ 5.21b */	/*DYJ 5.23e */
LOCAL _VOID replaceGetSetValues(OBJECT *tree, _VOID *env, _BOOL set, _WORD exit)
{
	_UBYTE allChar[2], oneChar[2];
	_UBYTE numStr[10];
	_UBYTE *text;
	_ULONG len;

	UNUSED(env);
	if (set)
	{
		if (Editor_BlockIsMarked(replaceOpts.theSearchWdw))
		{
			if (Editor_GetBlock(replaceOpts.theSearchWdw, FALSE, FALSE, &text, &len) && text != NULL)
			{
				strBcpy(replaceOpts.searchStr, text);
				SFREE(text);
			}
		}
		Editor_GetWildChars(oneChar, allChar);
		SetObjcString(tree, RRQALL, allChar);
		SetObjcString(tree, RRQONE, oneChar);
		SetObjcString(tree, RSUCHSTR, replaceOpts.searchStr);
		SetObjcString(tree, RREPLSTR, replaceOpts.replaceStr);
		if (CatOpts_GetItem(tree, RNMAL))
		{
			DelObjState(tree, RCOUNT, DISABLED);
			SetObjFlags(tree, RCOUNT, EDITABLE);
		} else
		{
			SetObjState(tree, RCOUNT, DISABLED);
			DelObjFlags(tree, RCOUNT, EDITABLE);
		}
	} else
	{
		exit &= 0x7fff;
		DelObjState(tree, exit, SELECTED);
		if (exit == RROK)
		{
			replaceOpts.isSet = TRUE;
			/* Strings auslesen */
			replaceOpts.ignoreCase = CatOpts_GetItem(tree, RCASE);
			replaceOpts.onlyWord   = CatOpts_GetItem(tree, RWORD);
			/* Startposition suchen */
			if (CatOpts_GetItem(tree, RFROMTOP))
				replaceOpts.pos = fromStart;
			else
				replaceOpts.pos = fromPos;
			/* Suchrichtung feststellen */
			replaceOpts.direction = sdir_forward;
			/* Anzahl feststellen */
			if (CatOpts_GetItem(tree, REINMAL))
			{
				replaceOpts.count = searchOne;
			} else if (CatOpts_GetItem(tree, RGESAMT))
			{
				replaceOpts.count = searchAll;
			} else
			{
				replaceOpts.count = searchNum;
				ObjcString(tree, RCOUNT, numStr, sizeof(numStr));
				replaceOpts.number = StrToInt(numStr, NULL, NULL);
			}
			/* letzte Parameter */
			replaceOpts.askBack = CatOpts_GetItem(tree, RASKBACK);
			/* Jetzt noch feststellen, ob Suchen oder Ersetzen */
			ObjcString(tree, RSUCHSTR, replaceOpts.searchStr, sizeof(replaceOpts.searchStr));
			ObjcString(tree, RREPLSTR, replaceOpts.replaceStr, sizeof(replaceOpts.replaceStr));
			ObjcString(tree, RRQALL, allChar, sizeof(allChar));
			ObjcString(tree, RRQONE, oneChar, sizeof(oneChar));
			if (allChar[0] == oneChar[0] || allChar[0] == '\0' || oneChar[0] == '\0')
				MTE_info(Rsc_WrkString(AL_WRONG_WILD));
			else
				Editor_SetWildChars(oneChar[0], allChar[0]);
			if (EditTools_CheckWildAssign(replaceOpts.searchStr, replaceOpts.replaceStr))
				replaceOpts.doIt = TRUE;
			else
				MTE_info(Rsc_WrkString(AL_WRONG_REPLACE));
		}
	}
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID CatOpts_DoReplace(HWND win)
{
	OBJECT *form;

	form = TreeAddr[ERSETZEN];
	if (Editor_IsEditTop(win))
	{
		replaceOpts.theSearchWdw = win;
		replaceOpts.doIt = FALSE;
		if (!WinDials_OpenWinDial(form, TRUE,
			replaceGetSetValues,
			replaceGetSetValues,
			replaceButton,
			WinDials_defDraw,
			NULL,
			NULL))
		{
			return;
		}
		WinDials_WinDialHandleEvents();
		if (replaceOpts.doIt)
		{
			WdwManager_HandlePendingEvents();
			Editor_SearchAndReplace(replaceOpts.theSearchWdw,
				replaceOpts.searchStr,
				replaceOpts.replaceStr,
				replaceOpts.pos,
				replaceOpts.direction,
				replaceOpts.count,
				replaceOpts.number,
				replaceOpts.ignoreCase,
				replaceOpts.onlyWord,
				replaceOpts.askBack,
				FALSE);
		}
	}
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/
/*DYJ 5.21b */
LOCAL _BOOL tauschButton(OBJECT *tree, _VOID *env, _WORD button, _WORD mx, _WORD my, _UWORD kstate, _WORD clicks)
{
	_WORD res;
	_LONG size;
	GRECT r;
	
	UNUSED(env);
	UNUSED(mx);
	UNUSED(my);
	UNUSED(kstate);
	UNUSED(clicks);
	if(button==-1)
		return FALSE;
	res = button & 0x7fff;
	DelObjState(tree, res, SELECTED);
	if (res == TCHELP)
	{
		CatHelp_DoHelp(CatHelp_tauschconf);
	} else
	{
		VDIUtil_GetLongIntStr(tree, OSPLITSIZ, &size);
		if (res == CONF2OK && size && size < 1024)
			MTE_infoRSC(AL_SPLITSIZE);
		else
		return TRUE;
	}
	WinDials_WinDialDraw(tree, res, 1, &r, FALSE);
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID tauschGetSetValues(OBJECT *tree, _VOID *env, _BOOL set, _WORD exit)
{
	_BOOL val;

	UNUSED(env);
	if (set)
	{
		CatOpts_SetItem(tree, IEBOX,    UserBLK.MakeInfileAfterImport);
		CatOpts_SetItem(tree, IENDEBOX, UserBLK.MakeInfileAtEnd);
		CatOpts_SetItem(tree, ODBOX_NE, UserBLK.DeleteAfterImport);
		CatOpts_SetItem(tree, ODBOX_VT, UserBLK.DeleteBeforeTerm);

		CatOpts_SetItem(tree, OSBOX,    UserBLK.ImportAtStart);
		CatOpts_SetItem(tree, OTBOX,    UserBLK.ImportAfterTermPrg);
		CatOpts_SetItem(tree, OPBOX,    UserBLK.StartTermAtStart);
		CatOpts_SetItem(tree, TERMOVER, UserBLK.TerminalAsOverlay);
		CatOpts_SetItem(tree, VSBOX,    UserBLK.MakeInfileBeforeTerminal);
		ConfVars_GetConfDefBool(cShowLogAfterImport, &val, FALSE);
		CatOpts_SetItem(tree, OAUTOLOG, val);
		EnableObjState(tree, OAUTOSPL, DISABLED, UserBLK.isInternet);	/*DYJ 5.19e */
		EnableObjState(tree, OSPLITSIZ, DISABLED, UserBLK.isInternet);	/*DYJ 5.19e */
		EnableObjFlags(tree, OSPLITSIZ, EDITABLE, !UserBLK.isInternet);	/*DYJ 5.19e */
		WinDials_WinEditChanged(tree, -1);		/*DYJ 5.19e */
		CatOpts_SetItem(tree, OAUTOSPL, UserBLK.AutomaticSplit);
		CatOpts_SetItem(tree, OABSATZ, UserBLK.endlessLines);
		CatOpts_SetItem(tree, OMESSDAT, UserBLK.MessageDateInInfile);
		VDIUtil_SetLongIntStr(tree, OSPLITSIZ, UserBLK.splitSize);
	} else
	{
		if (exit == CONF2OK)
		{
			UserBLK.MakeInfileAfterImport    = CatOpts_GetItem(tree, IEBOX);
			UserBLK.MakeInfileAtEnd          = CatOpts_GetItem(tree, IENDEBOX);
			UserBLK.DeleteAfterImport        = CatOpts_GetItem(tree, ODBOX_NE);
			UserBLK.DeleteBeforeTerm         = CatOpts_GetItem(tree, ODBOX_VT);	
			UserBLK.ImportAtStart            = CatOpts_GetItem(tree, OSBOX);
			UserBLK.ImportAfterTermPrg       = CatOpts_GetItem(tree, OTBOX);
			UserBLK.StartTermAtStart         = CatOpts_GetItem(tree, OPBOX);
			UserBLK.TerminalAsOverlay        = CatOpts_GetItem(tree, TERMOVER);
			UserBLK.MakeInfileBeforeTerminal = CatOpts_GetItem(tree, VSBOX);
			UserBLK.AutomaticSplit           = CatOpts_GetItem(tree, OAUTOSPL);
			UserBLK.endlessLines             = CatOpts_GetItem(tree, OABSATZ);
			UserBLK.MessageDateInInfile      = CatOpts_GetItem(tree, OMESSDAT);
			val = CatOpts_GetItem(tree, OAUTOLOG);
			ConfVars_SetConfigBool(cShowLogAfterImport, val);
			ConfVars_SetConfigBool(cAutomaticSplit, UserBLK.AutomaticSplit);
			ConfVars_SetConfigBool(cSendParagraphs, UserBLK.endlessLines);
			ConfVars_SetConfigBool(cMakeInfileAfterImport, UserBLK.MakeInfileAfterImport);
			ConfVars_SetConfigBool(cMakeInfileAtEnd, UserBLK.MakeInfileAtEnd);
			ConfVars_SetConfigBool(cDeleteAfterImport, UserBLK.DeleteAfterImport);
			ConfVars_SetConfigBool(cDeleteBeforeTerm, UserBLK.DeleteBeforeTerm);
			ConfVars_SetConfigBool(cImportAtStart, UserBLK.ImportAtStart);
			ConfVars_SetConfigBool(cImportAfterTermPrg, UserBLK.ImportAfterTermPrg);
			ConfVars_SetConfigBool(cStartTermAtStart, UserBLK.StartTermAtStart);
			ConfVars_SetConfigBool(cTerminalAsOverlay, UserBLK.TerminalAsOverlay);
			ConfVars_SetConfigBool(cMakeInfileBeforeTerminal, UserBLK.MakeInfileBeforeTerminal);
			ConfVars_SetConfigBool(cMessageDateInInfile, UserBLK.MessageDateInInfile);
			VDIUtil_GetLongIntStr(tree, OSPLITSIZ, &UserBLK.splitSize);
			ConfVars_SetConfigLongInt(cSplitSize, UserBLK.splitSize);
		}
	}
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID CatOpts_DoTausch(_VOID)
{
	OBJECT *form;
	
	form = TreeAddr[TAUSCH_CNF];
	WinDials_OpenWinDial(form, FALSE,
		tauschGetSetValues,
		tauschGetSetValues,
		tauschButton,
		WinDials_defDraw,
		NULL,
		NULL);
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

/*DYJ 5.23e */
GLOBAL _BOOL CatOpts_CheckInfoline(CONST _UBYTE *infoline)
{
	_BOOL inStr;
	_BOOL inBrackets;
	size_t z;
#define okSet "ABFUDTGHMSVNRIW:,;.-<>!? #|"
	/* Neu: S fuer Sex (Anrede)
	 * V fuer Vorname
	 * N fuer Nachname
	 * F fuer FuzzyDate
	 * und auch neu: B fuer Betreff (MH)
	 */
#define formatSet "ADTHRS"

	if (*infoline == '\0')
		return FALSE;
	inStr = FALSE;
	inBrackets = FALSE;
	z = 0;
	while (*infoline != '\0')
	{
		if (inStr)
		{
			if (*infoline == '"' || *infoline == '\'') 
				inStr = !inStr;
		} else if (inBrackets)
		{
			if (*infoline == ')')
				inBrackets = FALSE;
		} else
		{
			if (strChr(okSet, ucase(*infoline)) == NULL)
			{
				if (*infoline == '"' || *infoline == '\'')
					inStr = !inStr;
				else if (*infoline == '(' && z > 0 && strChr(formatSet, infoline[-1]) != NULL)
					inBrackets = TRUE;
				else
					return FALSE;
			}
		}
		++z;
		infoline++;
	}
	return !inStr;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL optionButton(OBJECT *tree, _VOID *env, _WORD button, _WORD mx, _WORD my, _UWORD kstate, _WORD clicks)
{
	GRECT r;
	
	UNUSED(env);
	UNUSED(mx);
	UNUSED(my);
	UNUSED(kstate);
	UNUSED(clicks);
	if(button==-1)
		return FALSE;
	button &= 0x7fff;
	DelObjState(tree, button, SELECTED);
	if (button == OPHELP)
		CatHelp_DoHelp(CatHelp_allgconf);
	else
		return TRUE;
	WinDials_WinDialDraw(tree, button, 1, &r, FALSE);
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/
/*DYJ 5.17n */
LOCAL _VOID optionGetSetValues(OBJECT *tree, _VOID *env, _BOOL set, _WORD exit)
{
	_UBYTE UserRName[256];
	_UBYTE UserAddr[256];
	_BOOL realTabs;
	_BOOL val;
	_UBYTE helpServer[10];
	
	UNUSED(env);
	if (set)
	{
		ConfVars_GetConfDefBool(cHardTabs, &realTabs, FALSE);
		CatOpts_SetItem(tree, UBOX,     UserBLK.Umbruch);
		CatOpts_SetItem(tree, SAVEBOX,  UserBLK.AutoSaveOptions);
		CatOpts_SetItem(tree, LBOX,     UserBLK.ConvertDiaresis);
		CatOpts_SetItem(tree, UNDOBOX,  UserBLK.AutoUndo);
		CatOpts_SetItem(tree, MGBOX,    UserBLK.ignoreRead);
		CatOpts_SetItem(tree, MFBOX,    UserBLK.ignoreFiltered);
		CatOpts_SetItem(tree, INITIALQ, UserBLK.InitialQuote);
		CatOpts_SetItem(tree, SECURITY, UserBLK.SillyChecks);
		CatOpts_SetItem(tree, REDIRARC, UserBLK.RedirectPacker);
		CatOpts_SetItem(tree, ESHOWCR,  UserBLK.ShowLineEnds);
		CatOpts_SetItem(tree, OSAVEPOS, SaveAllPositions);
		CatOpts_SetItem(tree, EREALTAB, realTabs);
		CatOpts_SetItem(tree, EINFORO , UserBLK.InfofilesReadOnly);
		
		ConfVars_GetConfDefBool(cSortGroups, &val, TRUE);
		CatOpts_SetItem(tree, ESORTGR, val);
		ConfVars_GetConfDefBool(cSortNames, &val, TRUE);
		CatOpts_SetItem(tree, ESORTNAM, val);
		ConfVars_GetConfDefBool(cDisplayEffects, &val, TRUE);
		CatOpts_SetItem(tree, ESHEFF, val);
		ConfVars_GetConfDefBool(cExternHelp, &val, FALSE);
		CatOpts_SetItem(tree, OEXTHELP, val);
		ConfVars_GetConfDefBool(cViewWrap, &val, TRUE);
		CatOpts_SetItem(tree, VIEWWRAP, val);
		
		ConfVars_GetConfDefStr(cMausId, UserAddr, sizeof(UserAddr), "");
		ConfVars_GetConfDefStr(cUserName, UserRName, sizeof(UserRName), "");
		ConfVars_GetConfDefStr(cHelpServer, helpServer, sizeof(helpServer), hs);
		
		VDIUtil_SetIntStr(tree, WAITTIME, UserBLK.WaitingTime);
		VDIUtil_SetIntStr(tree, EDLEFTM, UserBLK.RightMargin);
		VDIUtil_SetIntStr(tree, OTABSIZE, UserBLK.TabSize);
		
		SetObjcString(tree, UFLGTXT1, UserBLK.UserString1);
		SetObjcString(tree, UFLGTXT2, UserBLK.UserString2);
		SetObjcString(tree, EHLPPROT, helpServer);
		SetObjcString(tree, EUSERADDR, UserAddr);
		SetObjcString(tree, EUSERRNAM, UserRName);
		EnableObjFlags(tree, REP2TIT, HIDETREE, !UserBLK.isInternet);
		EnableObjFlags(tree, REP2IN, HIDETREE, !UserBLK.isInternet);
		if(UserBLK.isInternet)
		{
			_UBYTE replyTo[256];
			ConfVars_GetConfDefStr(cDefReplyTo, replyTo, sizeof(replyTo),"");
			SetObjcString(tree, REP2IN, replyTo);
		}
	} else
	{
		if ((exit & 0x7fff) == OPOK)
		{
			UserBLK.Umbruch           = CatOpts_GetItem(tree, UBOX);
			UserBLK.AutoSaveOptions   = CatOpts_GetItem(tree, SAVEBOX);
			UserBLK.ConvertDiaresis   = CatOpts_GetItem(tree, LBOX);
			UserBLK.AutoUndo          = CatOpts_GetItem(tree, UNDOBOX);
			UserBLK.ignoreRead        = CatOpts_GetItem(tree, MGBOX);
			UserBLK.ignoreFiltered    = CatOpts_GetItem(tree, MFBOX);
			UserBLK.InitialQuote      = CatOpts_GetItem(tree, INITIALQ);
			UserBLK.SillyChecks       = CatOpts_GetItem(tree, SECURITY);
			UserBLK.RedirectPacker    = CatOpts_GetItem(tree, REDIRARC);
			UserBLK.ShowLineEnds      = CatOpts_GetItem(tree, ESHOWCR);
			SaveAllPositions          = CatOpts_GetItem(tree, OSAVEPOS);
			realTabs                  = CatOpts_GetItem(tree, EREALTAB);
			UserBLK.InfofilesReadOnly = CatOpts_GetItem(tree, EINFORO);
			
			VDIUtil_GetIntStr(tree, WAITTIME, &UserBLK.WaitingTime);
			VDIUtil_GetIntStr(tree, EDLEFTM, &UserBLK.RightMargin);
			if (UserBLK.RightMargin < 10)
				UserBLK.RightMargin = 10;
			VDIUtil_GetIntStr(tree, OTABSIZE, &UserBLK.TabSize);
			ObjcString(tree, UFLGTXT1, UserBLK.UserString1, sizeof(UserBLK.UserString1));
			ObjcString(tree, UFLGTXT2, UserBLK.UserString2, sizeof(UserBLK.UserString2));
			ObjcString(tree, EHLPPROT, helpServer, sizeof(helpServer));
			ObjcString(tree, EUSERADDR, UserAddr, sizeof(UserAddr));
			ObjcString(tree, EUSERRNAM, UserRName, sizeof(UserRName));
			if(UserBLK.isInternet)
			{
				_UBYTE replyTo[256];
				ObjcString(tree, REP2IN, replyTo, sizeof(replyTo));
				if(*replyTo)
					ConfVars_SetConfigString(cDefReplyTo, replyTo);
				else
					ConfVars_DeleteConfigVar(cDefReplyTo);
			}
			strBcpy(userAddr, UserAddr);
			strBcpy(userRName, UserRName);
			
			ConfVars_SetConfigBool(cWordWrap, UserBLK.Umbruch);
			ConfVars_SetConfigBool(cAutoSaveOptions, UserBLK.AutoSaveOptions);
			ConfVars_SetConfigBool(cConvertDiaresis, UserBLK.ConvertDiaresis);
			ConfVars_SetConfigBool(cAutoUndo, UserBLK.AutoUndo);
			ConfVars_SetConfigBool(cIgnoreRead, UserBLK.ignoreRead);
			ConfVars_SetConfigBool(cIgnoreFiltered, UserBLK.ignoreFiltered);
			ConfVars_SetConfigBool(cInitialQuote, UserBLK.InitialQuote);
			ConfVars_SetConfigBool(cSillyChecks, UserBLK.SillyChecks);
			ConfVars_SetConfigBool(cRedirectPacker, UserBLK.RedirectPacker);
			ConfVars_SetConfigBool(cShowLineEnds, UserBLK.ShowLineEnds);
			ConfVars_SetConfigBool(cSaveAllPositions, SaveAllPositions);
			ConfVars_SetConfigBool(cHardTabs, realTabs);
			ConfVars_SetConfigBool(cInfofilesReadOnly, UserBLK.InfofilesReadOnly);
			
			ConfVars_SetConfigBool(cSortNames, GetObjState(tree, ESORTNAM, SELECTED));
			ConfVars_SetConfigBool(cSortGroups, GetObjState(tree, ESORTGR, SELECTED));
			ConfVars_SetConfigBool(cDisplayEffects, GetObjState(tree, ESHEFF, SELECTED));
			ConfVars_SetConfigBool(cExternHelp, GetObjState(tree, OEXTHELP, SELECTED));
			ConfVars_SetConfigBool(cViewWrap, GetObjState(tree, VIEWWRAP, SELECTED));
			
			/* Jetzt noch Integer und String-Vars schreiben */
			ConfVars_SetConfigInt(cWaitingTime, UserBLK.WaitingTime);
			ConfVars_SetConfigInt(cRightMargin, UserBLK.RightMargin);
			ConfVars_SetConfigInt(cTabSize, UserBLK.TabSize);
			ConfVars_SetConfigString(cUserString1, UserBLK.UserString1);
			ConfVars_SetConfigString(cUserString2, UserBLK.UserString2);
			ConfVars_SetConfigString(cHelpServer, helpServer);
			ConfVars_SetConfigString(cMausId, userAddr);
			ConfVars_SetConfigString(cUserName, userRName);
			ConfVars_SetConfigInt(cMimeTextMode, UserBLK.MimeTextMode);	/*DYJ 5.33b */
			}
	}
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID CatOpts_DoOption(_VOID)
{
	OBJECT *option;

	option = TreeAddr[ALLG_CNF];
	WinDials_OpenWinDial(option, FALSE,
		optionGetSetValues,
		optionGetSetValues,
		optionButton,
		WinDials_defDraw,
		NULL,
		NULL);
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/
/*DYJ 5.21b */
LOCAL _BOOL abrufButton(OBJECT *tree, _VOID *env, _WORD button, _WORD mx, _WORD my, _UWORD kstate, _WORD clicks)
{
	GRECT r;
	_BOOL ok;
	
	UNUSED(env);
	UNUSED(mx);
	UNUSED(my);
	UNUSED(kstate);
	UNUSED(clicks);
	if(button==-1)
		return FALSE;
	button &= 0x7fff;
	DelObjState(tree, button, SELECTED);
	ok = /* CatOpts_GetItem(tree, GETPERS) || CatOpts_GetItem(tree, GETALLG) || */ CatOpts_GetItem(tree, GETINF);
	if (button == GETHELP)
	{
		CatHelp_DoHelp(CatHelp_configInfile);
		ok = FALSE;
	} else if (button != GETCANCE && !ok)
	{
		if (CatOpts_GetItem(tree, MESSTOIN) || CatOpts_GetItem(tree, STATUSIN))
			ok = mtAlerts_AlertRSC(1, AL_WARN_EMPTY_INFILE) == 1;
		else
			mtAlerts_AlertRSC(1, AL_EMPTY_INFILE);
	}
	if (ok || button == GETCANCE)
		return TRUE;
	WinDials_WinDialDraw(tree, button, 1, &r, FALSE);
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID abrufGetSetValues(OBJECT *tree, _VOID *env, _BOOL set, _WORD exit)
{
	UNUSED(env);
	if (set)
	{
		CatOpts_SetItem(tree, GETINF,   UserBLK.RequestInfofiles);
		CatOpts_SetItem(tree, MESSTOIN, UserBLK.MessagesInInfile);
		CatOpts_SetItem(tree, GROUPCHA, UserBLK.GroupChangesInInfile);
		CatOpts_SetItem(tree, STATUSIN, UserBLK.StatusMessagesInInfile);
		EnableObjState(tree, STATUSIN, DISABLED, UserBLK.isInternet);		/*DYJ 5.19e */
	} else
	{
		exit &= 0x7fff;
		if (exit != GETCANCE)
		{
			UserBLK.RequestInfofiles       = CatOpts_GetItem(tree, GETINF);
			UserBLK.MessagesInInfile       = CatOpts_GetItem(tree, MESSTOIN);
			UserBLK.GroupChangesInInfile   = CatOpts_GetItem(tree, GROUPCHA);
			if(!UserBLK.isInternet)		/*DYJ 5.19e */
				UserBLK.StatusMessagesInInfile = CatOpts_GetItem(tree, STATUSIN);
			ConfVars_SetConfigBool(cRequestInfofiles, UserBLK.RequestInfofiles);
			ConfVars_SetConfigBool(cMessagesInInfile, UserBLK.MessagesInInfile);
			ConfVars_SetConfigBool(cGroupChangesInInfile, UserBLK.GroupChangesInInfile);
			ConfVars_SetConfigBool(cStatusMessagesInInfile, UserBLK.StatusMessagesInInfile);
		}
	}
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID CatOpts_DoAbruf(_VOID)
{
	OBJECT *abruf;
	
	abruf = TreeAddr[ABRUF];
	WinDials_OpenWinDial(abruf, FALSE,
		abrufGetSetValues,
		abrufGetSetValues,
		abrufButton,
		WinDials_defDraw,
		NULL,
		NULL);
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

GLOBAL _VOID CatOpts_DoInfos(_VOID)
{
	_UBYTE str[256];
	
	*str = '\0';
	InfoDlg_doInfoList(FALSE, str, sizeof(str));
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

typedef struct {
	_UBYTE cfgFile[PATH_MAX];
	_UBYTE cfgPath[PATH_MAX];
	_UBYTE cfgName[PATH_MAX];
	_UBYTE cfgExt[PATH_MAX];
} printerInfo;

/*DYJ 5.21b */	/*DYJ 5.23e */
LOCAL _BOOL printerButton(OBJECT *tree, _VOID *env, _WORD button, _WORD mx, _WORD my, _UWORD kstate, _WORD clicks)
{
	GRECT r;
	OBJECT *prnTypeSel;
	OBJECT *prnStyleSel;
	OBJECT *prnIFSel;
	_WORD x, y;
	_WORD select;
	_BOOL res;
	_UBYTE name[PATH_MAX];
	printerInfo *prInfo;
	tResponse Response;
	
	UNUSED(mx);
	UNUSED(my);
	UNUSED(clicks);
	
	if(button==-1)
		return FALSE;
	button &= 0x7fff;
	prInfo = env;
	prnTypeSel = TreeAddr[SELECTBX];
	prnStyleSel = TreeAddrLib[PSIZEBOX_L];
	prnIFSel  = TreeAddrLib[IFBOX_L];
	switch (button)
	{
	case OPRTSIZ0:
	case OPRTSIZ1:
		objc_offset(tree, OPRTSIZ1, &x, &y);
		select = mtPopups_TreePopup(prnStyleSel, x, y, VDIUtil_GetXState(tree, OPRTSIZ1)) - 1;
		if (select >= 0)
		{
			VDIUtil_SetXState(tree, OPRTSIZ1, select);
			VDIUtil_SetXString(tree, OPRTSIZ1, prnStyleSel, select);
			WinDials_WinDialDraw(tree, OPRTSIZ1, 0, &r, FALSE);
		}
		break;
	
	case OPRTSIZ2:
		select = VDIUtil_GetXState(tree, OPRTSIZ1);
		if(kstate&K_SHIFT)
			select = (select + 2) % 3;
		else
			select = (select + 1) % 3;
		VDIUtil_SetXState(tree, OPRTSIZ1, select);
		VDIUtil_SetXString(tree, OPRTSIZ1, prnStyleSel, select);
		WinDials_WinDialDraw(tree, OPRTSIZ1, 0, &r, FALSE);
		break;
	
	case OPRTOPT0:
	case OPRTOPT:
		objc_offset(tree, button, &x, &y);
		select = mtPopups_TreePopup(prnTypeSel, x, y, VDIUtil_GetXState(tree, OPRTOPT)) - 1;
		if (select >= 0)
		{
			VDIUtil_SetXState(tree, OPRTOPT, select);
			VDIUtil_SetXString(tree, OPRTOPT, prnTypeSel, select);
			WinDials_WinDialDraw(tree, OPRTOPT, 0, &r, FALSE);
		}
		break;
	
	case OPRTOPT2:
		select = VDIUtil_GetXState(tree, OPRTOPT);
		if(kstate&K_SHIFT)
			select = (select + 2) % 4;
		else
			select = (select + 1) % 4;
		VDIUtil_SetXState(tree, OPRTOPT, select);
		VDIUtil_SetXString(tree, OPRTOPT, prnTypeSel, select);
		WinDials_WinDialDraw(tree, OPRTOPT, 0, &r, FALSE);
		break;
	
	case OINTERFC0:
	case OINTERFC1:
		objc_offset(tree, OINTERFC1, &x, &y);
		select = mtPopups_TreePopup(prnIFSel, x, y, VDIUtil_GetXState(tree, OINTERFC1)) - 1;
		if (select >= 0)
		{
			VDIUtil_SetXState(tree, OINTERFC1, select);
			VDIUtil_SetXString(tree, OINTERFC1, prnIFSel, select);
			WinDials_WinDialDraw(tree, OINTERFC1, 0, &r, FALSE);
		}
		break;
		
	case OINTERFC2:
		select = VDIUtil_GetXState(tree, OINTERFC1);
		select = (select + 1) % 2;
		VDIUtil_SetXState(tree, OINTERFC1, select);
		VDIUtil_SetXString(tree, OINTERFC1, prnIFSel, select);
		WinDials_WinDialDraw(tree, OINTERFC1, 0, &r, FALSE);
		break;
		
	case OSELCFG0:
	case OSELCFG:
		button = OSELCFG;
		res = mtDir_FselGet(prInfo->cfgPath, prInfo->cfgName, "*.cfg", Rsc_WrkString(FS_SELECT_CFG), TRUE);
		if (res && prInfo->cfgName[0] != '\0')
		{
			strBcpy(prInfo->cfgFile, prInfo->cfgPath);
			F_Path_Append(prInfo->cfgFile, prInfo->cfgName);
			Response = Printer_LoadCFGFile(prInfo->cfgFile);
			if (Response == Printer_CFGnotFound)
			{
				MTE_info(Rsc_WrkString(AL_CFG_NOT_FOUND));
			} else if (Response == Printer_wrongIdent)
			{
				MTE_info(Rsc_WrkString(AL_CFG_WRONG_IDENT));
			} else if (Response == Printer_done)
			{
				Printer_GetPrnName(name, sizeof(name));
				SetObjcString(tree, OSELCFG, prInfo->cfgName);
				SetObjcString(tree, PRINTNAME, name);
				CalcArea(tree, PRINTNAME, &r);
				WinDials_WinDialDraw(tree, ROOT, MAX_DEPTH, &r, TRUE);
			}
		} else if (res)
		{
			Printer_FreeCFGFile();
			prInfo->cfgFile[0] = '\0';
			Printer_GetPrnName(name, sizeof(name));
			SetObjcString(tree, PRINTNAME, name);
			strBcpy(prInfo->cfgName, CFG_NONAME);
			SetObjcString(tree, OSELCFG, prInfo->cfgName);
			CalcArea(tree, PRINTNAME, &r);
			WinDials_WinDialDraw(tree, ROOT, MAX_DEPTH, &r, TRUE);
		}
		DelObjState(tree, button, SELECTED);
		WinDials_WinDialDraw(tree, button, 0, &r, FALSE);
		break;
	
	case PROK:
	case PRCANCEL:
		DelObjState(tree, button, SELECTED);
		return TRUE;
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

/*DYJ 5.23e */
LOCAL _VOID printerGetSetValues(OBJECT *tree, _VOID *env, _BOOL set, _WORD exit)
{
	OBJECT *prnTypeSel;
	OBJECT *prnStyleSel;
	OBJECT *prnIFSel;
	_BOOL val;
	_WORD intVal;
	_UBYTE name[PATH_MAX];
	printerInfo *prInfo;

	prInfo = env;
	prnTypeSel = TreeAddr[SELECTBX];
	prnStyleSel = TreeAddrLib[PSIZEBOX_L];
	prnIFSel  = TreeAddrLib[IFBOX_L];
	if (set)
	{
		/* Noch Namen des CFG-Files */
		if (ConfVars_GetConfigString(cPrintCFGFile, prInfo->cfgFile, sizeof(prInfo->cfgFile)))
		{
			mtDir_SplitPath(prInfo->cfgFile, prInfo->cfgPath, prInfo->cfgName, prInfo->cfgExt);
		} else
		{
			prInfo->cfgFile[0] = '\0';
			strBcpy(prInfo->cfgName, CFG_NONAME);
			strBcpy(prInfo->cfgPath, DataPath);
		}
		SetObjcString(tree, OSELCFG, prInfo->cfgName);
		
		ConfVars_GetConfDefInt(cPrintLeftMargin, &intVal, 0);
		VDIUtil_SetIntStr(tree, OPRLEFTM, intVal);
		ConfVars_GetConfDefInt(cPrintEmptyLines, &intVal, 0);
		intVal = intVal % 10;  /* Maximal 0 bis 9 */
		VDIUtil_SetIntStr(tree, OPRLINES, intVal);
		ConfVars_GetConfDefBool(cPrintNLQ, &val, FALSE);
		EnableObjState(tree, OPRNNLQ, SELECTED, val);
		ConfVars_GetConfDefBool(cPrintFormFeed, &val, FALSE);
		EnableObjState(tree, OFORMFEED, SELECTED, val);
		Printer_GetPrnName(name, sizeof(name));
		SetObjcString(tree, PRINTNAME, name);
		ConfVars_GetConfDefInt(cPrintHeaderType, &intVal, 0);
		VDIUtil_SetXState(tree, OPRTOPT, intVal);
		VDIUtil_SetXString(tree, OPRTOPT, prnTypeSel, intVal);
		ConfVars_GetConfDefInt(cPrintPort, &intVal, 0);
		VDIUtil_SetXState(tree, OINTERFC1, intVal);
		VDIUtil_SetXString(tree, OINTERFC1, prnIFSel, intVal);
		ConfVars_GetConfDefInt(cPrintStyle, &intVal, 0);
		VDIUtil_SetXState(tree, OPRTSIZ1, intVal);
		VDIUtil_SetXString(tree, OPRTSIZ1, prnStyleSel, intVal);
	} else
	{
		exit &= 0x7fff;
		if (exit == PROK)
		{
			ConfVars_SetConfigInt(cPrintHeaderType, VDIUtil_GetXState(tree, OPRTOPT));
			ConfVars_SetConfigInt(cPrintPort, VDIUtil_GetXState(tree, OINTERFC1));
			ConfVars_SetConfigInt(cPrintStyle, VDIUtil_GetXState (tree, OPRTSIZ1));
			ConfVars_SetConfigBool(cPrintNLQ, GetObjState(tree, OPRNNLQ, SELECTED));
			ConfVars_SetConfigBool(cPrintFormFeed, GetObjState(tree, OFORMFEED, SELECTED));
			VDIUtil_GetIntStr(tree, OPRLEFTM, &intVal);
			ConfVars_SetConfigInt(cPrintLeftMargin, intVal);
			VDIUtil_GetIntStr(tree, OPRLINES, &intVal);
			ConfVars_SetConfigInt(cPrintEmptyLines, intVal);
			if (prInfo->cfgFile[0] != '\0')
				ConfVars_SetConfigString(cPrintCFGFile, prInfo->cfgFile);
		} else
		{
			ConfVars_GetConfDefStr(cPrintCFGFile, prInfo->cfgFile, sizeof(prInfo->cfgFile), "");
			if (prInfo->cfgFile[0] != '\0')
				Printer_LoadCFGFile(prInfo->cfgFile);
		}
		OFREE(prInfo);
	}
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID CatOpts_doPrinter(_VOID)
{
	OBJECT *printConf;
	printerInfo *prInfo;

	printConf = TreeAddr[PRNCONF];
	prInfo = NEW(printerInfo, "CatOpts_doPrinter");
	if (prInfo == NULL)
		return;
	if (!WinDials_OpenWinDial(printConf, FALSE,
		printerGetSetValues,
		printerGetSetValues,
		printerButton,
		WinDials_defDraw,
		NULL,
		prInfo))
	{
		OFREE(prInfo);
	}
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/
LOCAL _BOOL listButton(OBJECT *tree, _VOID *env, _WORD button, _WORD mx, _WORD my, _UWORD kstate, _WORD clicks)
{
	GRECT r;
	OBJECT *sortPop;
	OBJECT *idemPop;
	_WORD x, y;
	_WORD select;
	
	UNUSED(env);
	UNUSED(mx);
	UNUSED(my);
	UNUSED(clicks);

	button &= 0x7fff;
	DelObjState(tree, button, SELECTED);
	sortPop = TreeAddr[LSORTPOP];
	idemPop = TreeAddr[LIDEMPOP];

	switch (button)
	{
	case LCSORT0:
	case LCSORT1:
		button = LCSORT1;
		objc_offset(tree, button, &x, &y);
		select = mtPopups_TreePopup(sortPop, x, y, VDIUtil_GetXState(tree, button)) - 1;
		if (select >= 0)
		{
			VDIUtil_SetXState(tree, button, select);
			VDIUtil_SetXString(tree, button, sortPop, select);
			WinDials_WinDialDraw(tree, button, 0, &r, FALSE);
		}
		break;
		
	case LCSORT2:
		select = VDIUtil_GetXState(tree, LCSORT1);
		if(kstate&K_SHIFT)
			select = (select + 7) % 8;
		else
			select = (select + 1) % 8;
		VDIUtil_SetXState(tree, LCSORT1, select);
		VDIUtil_SetXString(tree, LCSORT1, sortPop, select);
		WinDials_WinDialDraw(tree, LCSORT1, 0, &r, FALSE);
		break;
		
	case LCIDEM0:
	case LCIDEM1:
		button = LCIDEM1;
		objc_offset(tree, button, &x, &y);
		select = mtPopups_TreePopup(idemPop, x, y, VDIUtil_GetXState(tree, button)) - 1;
		if (select >= 0)
		{
			VDIUtil_SetXState(tree, button, select);
			VDIUtil_SetXString(tree, button, idemPop, select);
			WinDials_WinDialDraw(tree, button, 0, &r, FALSE);
		}
		break;
		
	case LCIDEM2:
		select = VDIUtil_GetXState(tree, LCIDEM1);
		if(kstate&K_SHIFT)
			select = (select + 2) % 3;
		else
			select = (select + 1) % 3;
		VDIUtil_SetXState(tree, LCIDEM1, select);
		VDIUtil_SetXString(tree, LCIDEM1, idemPop, select);
		WinDials_WinDialDraw(tree, LCIDEM1, 0, &r, FALSE);
		break;
	case LCHELP:
		CatHelp_DoHelp(CatHelp_listconf);
		WinDials_WinDialDraw(tree, button, 1, &r, FALSE);
		break;
	
	case LCOK:
	case LCQUIT:
		return TRUE;
	}
	return FALSE;
}


/*** ---------------------------------------------------------------------- ***/
LOCAL _VOID listGetSetValues(OBJECT *tree, _VOID *env, _BOOL set, _WORD exit)
{
	OBJECT *sortPop;
	_WORD intVal;
	_BOOL boolVal;
	_WORD x;
	_UBYTE varname[128];
	OBJECT *idemPop;

	UNUSED(env);
	sortPop = TreeAddr[LSORTPOP];
	idemPop = TreeAddr[LIDEMPOP];
	if (set)
	{
		ConfVars_GetConfDefBool(cListDefReverse, &boolVal, FALSE);
		EnableObjState(tree, LCREVERSE, SELECTED, boolVal);
		ConfVars_GetConfDefBool(cListShowSmallList, &boolVal, FALSE);
		EnableObjState(tree, LCSHORT, SELECTED, boolVal);
		ConfVars_GetConfDefBool(cListDontShowFiltered, &boolVal, FALSE);
		EnableObjState(tree, LCFILT, SELECTED, boolVal);
		ConfVars_GetConfDefBool(cListSortIgnoreCase, &boolVal, FALSE);
		EnableObjState(tree, LCCASE, SELECTED, boolVal);
		for (x = 1; x <= 10; x++)
		{
			make_varname(varname, sizeof(varname), cListDefaultSelect, x);
			ConfVars_GetConfDefBool(varname, &boolVal, FALSE);
			EnableObjState(tree, LCKONF1 + x - 1, SELECTED, boolVal);
		}
		ConfVars_GetConfDefInt(cListDefaultSort, &intVal, sNum);
		VDIUtil_SetXState(tree, LCSORT1, intVal);
		VDIUtil_SetXString(tree, LCSORT1, sortPop, intVal);
		ConfVars_GetConfDefInt(cListIdemMode, &intVal, 0);
		VDIUtil_SetXState(tree, LCIDEM1, intVal);
		VDIUtil_SetXString(tree, LCIDEM1, idemPop, intVal);
		ConfVars_GetConfDefStr(cListIdemStr, varname,sizeof(varname),"\"");
		SetObjcString(tree, LC_IDEMS, varname);
	} else
	{
		exit &= 0x7fff;
		if (exit == LCOK)
		{
			/* geaenderte Konfiguration auslesen und speichern */
			boolVal = GetObjState(tree, LCREVERSE, SELECTED);
			ConfVars_SetConfigBool(cListDefReverse, boolVal);
			boolVal = GetObjState(tree, LCSHORT, SELECTED);
			ConfVars_SetConfigBool(cListShowSmallList, boolVal);
			boolVal = GetObjState(tree, LCCASE, SELECTED);
			ConfVars_SetConfigBool(cListSortIgnoreCase, boolVal);
			intVal = VDIUtil_GetXState(tree, LCSORT1);
			ConfVars_SetConfigInt(cListDefaultSort, intVal);
			intVal = VDIUtil_GetXState(tree, LCIDEM1);
			ConfVars_SetConfigInt(cListIdemMode, intVal);
			ObjcString(tree, LC_IDEMS, varname, sizeof(varname));
			ConfVars_SetConfigString(cListIdemStr, varname);
			
			boolVal = GetObjState(tree, LCFILT, SELECTED);
			ConfVars_SetConfigBool(cListDontShowFiltered, boolVal);
			for (x = 1; x <= 10; x++)
			{
				make_varname(varname, sizeof(varname), cListDefaultSelect, x);
				boolVal = GetObjState(tree, LCKONF1 + x - 1, SELECTED);
				ConfVars_SetConfigBool(varname, boolVal);
			}
		}
	}
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID CatOpts_doList(_VOID)
{
	OBJECT *tree;

	tree = TreeAddr[LIST_CNF];
	WinDials_OpenWinDial(tree, FALSE,
		listGetSetValues,
		listGetSetValues,
		listButton,
		WinDials_defDraw,
		NULL,
		NULL);
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

LOCAL _BOOL editButton(OBJECT *tree, _VOID *env, _WORD button, _WORD mx, _WORD my, _UWORD kstate, _WORD clicks)
{
	GRECT r;
	_WORD *exitPtr;
	
	UNUSED(mx);
	UNUSED(my);
	UNUSED(kstate);
	UNUSED(clicks);

	exitPtr = env;
	button &= 0x7fff;
	switch (button)
	{
	case TABOK:
	case TABQUIT:
		DelObjState(tree, button, SELECTED);
		*exitPtr = button;
		return TRUE;
	
	case TABHELP:
		CatHelp_DoHelp(CatHelp_confEdit);
		DelObjState(tree, button, SELECTED);
		WinDials_WinDialDraw(tree, button, 1, &r, FALSE);
		break;
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID DoRealEditor(HWND wdw)
{
	_WORD exit;
	_UBYTE str[20];
	_WORD nr;
	_BOOL redraw;
	_UBYTE varname[128];
	_WORD i;
	OBJECT *tabBox = TreeAddr[TABBOX];
	_BOOL val;
	
	{
		/* Erstmal die Topwindow-Sachen */
		Editor_GetTabSize(wdw, &nr);
		VDIUtil_SetIntStr(tabBox, TATABW0, nr);
		CatOpts_SetItem(tabBox, TAUMBR0, Editor_GetMode(wdw, wrapMode));
		CatOpts_SetItem(tabBox, TABACK0, Editor_GetMode(wdw, autoBackup));
		CatOpts_SetItem(tabBox, TARTAB0, Editor_GetMode(wdw, tabMode));
		Editor_GetMargins(wdw, &nr);
		VDIUtil_SetIntStr(tabBox, TALINEL0, nr);
	}
	/* Und jetzt die ueber die Configstrings */
	for (i = 1; i <= 8; i++)
	{
		make_varname(varname, sizeof(varname), cExtension, i);
		ConfVars_GetConfDefStr(varname, str, sizeof(str), "");
		SetObjcString(tabBox, TAEXT1 + i - 1, str);
		make_varname(varname, sizeof(varname), cExtTabSize, i);
		ConfVars_GetConfDefInt(varname, &nr, 4);
		VDIUtil_SetIntStr(tabBox, TATABW1 + i - 1, nr);
		make_varname(varname, sizeof(varname), cExtHardTabs, i);
		ConfVars_GetConfDefBool(varname, &val, FALSE);
		CatOpts_SetItem(tabBox, TARTAB1 + i - 1, val);
		make_varname(varname, sizeof(varname), cExtWordWrap, i);
		ConfVars_GetConfDefBool (varname, &val, FALSE);
		CatOpts_SetItem(tabBox, TAUMBR1 + i - 1, val);
		make_varname(varname, sizeof(varname), cExtRightMargin, i);
		ConfVars_GetConfDefInt(varname, &nr, 255);
		VDIUtil_SetIntStr(tabBox, TALINEL1 + i - 1, nr);
		make_varname(varname, sizeof(varname), cExtAutoBackup, i);
		ConfVars_GetConfDefBool(varname, &val, FALSE);
		CatOpts_SetItem(tabBox, TABACK1 + i - 1, val);
	}
	
	exit = TABQUIT;
	if (WinDials_OpenWinDial(tabBox, FALSE,
		WinDials_defSet,
		WinDials_defSet,
		editButton,
		WinDials_defDraw,
		NULL,
		&exit))
	{
		WinDials_WinDialHandleEvents();
	}
	
	/* exit = WinDials_WinDialDo(tabBox, 0); */
	
	if (exit == TABOK)
	{
		redraw = FALSE;
		/* Erstmal die Topwindow-Sachen */
		Editor_SetMode(wdw, wrapMode, CatOpts_GetItem(tabBox, TAUMBR0));
		Editor_SetMode(wdw, autoBackup, CatOpts_GetItem(tabBox, TABACK0));
		Editor_SetMode(wdw, tabMode, CatOpts_GetItem(tabBox, TARTAB0));
		if (VDIUtil_GetIntStr(tabBox, TATABW0, &nr))
		{
			Editor_SetTabSize(wdw, nr);
			if (Editor_GetMode(wdw, tabMode))
				redraw = TRUE;
		}
		if (VDIUtil_GetIntStr(tabBox, TALINEL0, &nr))
		{
			Editor_SetMargins(wdw, nr, CatOpts_GetItem(tabBox, TAUMBR0));
			redraw = TRUE;
		}
		if (redraw)
		{
			WdwManager_FullRedrawWdw(wdw);
		}
		
		/* Und jetzt die ueber die Configstrings */
		for (i = 1; i <= 8; i++)
		{
			ObjcString(tabBox, TAEXT1 + i - 1, str, sizeof(str));
			if (str[0] != '\0')
			{
				make_varname(varname, sizeof(varname), cExtension, i);
				ConfVars_SetConfigString(varname, str);
				if (VDIUtil_GetIntStr(tabBox, TATABW1 + i - 1, &nr))
				{
					make_varname(varname, sizeof(varname), cExtTabSize, i);
					ConfVars_SetConfigInt(varname, nr);
				}
				make_varname(varname, sizeof(varname), cExtHardTabs, i);
				ConfVars_SetConfigBool(varname, CatOpts_GetItem(tabBox, TARTAB1 + i - 1));
				make_varname(varname, sizeof(varname), cExtWordWrap, i);
				ConfVars_SetConfigBool(varname, CatOpts_GetItem(tabBox, TAUMBR1 + i - 1));
				if (VDIUtil_GetIntStr(tabBox, TALINEL1 + i - 1, &nr))
				{
					make_varname(varname, sizeof(varname), cExtRightMargin, i);
					ConfVars_SetConfigInt(varname, nr);
				}
				make_varname(varname, sizeof(varname), cExtAutoBackup, i);
				ConfVars_SetConfigBool(varname, CatOpts_GetItem(tabBox, TABACK1 + i - 1));
			} else
			{
				/* Konfiguration loeschen!! */
				make_varname(varname, sizeof(varname), cExtension, i);
				ConfVars_DeleteConfigVar(varname);
				make_varname(varname, sizeof(varname), cExtTabSize, i);
				ConfVars_DeleteConfigVar(varname);
				make_varname(varname, sizeof(varname), cExtHardTabs, i);
				ConfVars_DeleteConfigVar(varname);
				make_varname(varname, sizeof(varname), cExtWordWrap, i);
				ConfVars_DeleteConfigVar(varname);
				make_varname(varname, sizeof(varname), cExtRightMargin, i);
				ConfVars_DeleteConfigVar(varname);
				make_varname(varname, sizeof(varname), cExtAutoBackup, i);
				ConfVars_DeleteConfigVar(varname);
			}
		}
	}
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID CatOpts_doEditor(HWND wdw)
{
	OBJECT *edBox;
	_WORD tabsiz;
	
	if (grin_grinWindowTop(wdw))
	{
		edBox = TreeAddr[GRIN_CNF];
		EnableObjState(edBox, GSHOWEFF, SELECTED, Editor_GetMode(wdw, effMode));
		EnableObjState(edBox, GTABS, SELECTED, Editor_GetMode(wdw, tabMode));
		Editor_GetTabSize(wdw, &tabsiz);
		VDIUtil_SetIntStr(edBox, GTABSIZ, tabsiz);
		if (WinDials_WinDialDo(edBox, 0) == GR_OK)
		{
			Editor_SetMode(wdw, tabMode, CatOpts_GetItem(edBox, GTABS));
			Editor_SetMode(wdw, effMode, CatOpts_GetItem(edBox, GSHOWEFF));
			VDIUtil_GetIntStr(edBox, GTABSIZ, &tabsiz);
			Editor_SetTabSize(wdw, tabsiz);
			WdwManager_FullRedrawWdw(wdw);
		}
	} else if (Editor_IsEditTop(wdw))
	{
		DoRealEditor(wdw);
	}
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

typedef struct {
	HWND wdw;
	_BOOL isMess;
	_BOOL isEdit;
	_BOOL isGrin;
	_BOOL isTree;
	_BOOL isList;
} colorInfo;

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID SetObCol(OBJECT *tree, _WORD obIdx, _WORD col)
{
	OBSPEC_SET_INTERIORCOL(tree[obIdx].ob_spec, col);
}

/*** ---------------------------------------------------------------------- ***/

/*DYJ 5.22d */	/*DYJ 5.23e */
LOCAL _BOOL colorButton(OBJECT *tree, _VOID *env, _WORD button, _WORD mx, _WORD my, _UWORD kstate, _WORD clicks)
{
	GRECT r;
	OBJECT *colPopup, *effPopup;
	_WORD x, y;
	_WORD select;
	_BOOL disableKeine=FALSE;
	
	UNUSED(env);
	UNUSED(mx);
	UNUSED(my);
	UNUSED(kstate);
	UNUSED(clicks);
	if(button==-1)
		return FALSE;
	colPopup  = TreeAddrLib[COLPOPUP];
	effPopup  = TreeAddrLib[EFFPOPUP];
	
	button &= 0x7fff;
	DelObjState(tree, button, SELECTED);
	
	switch (button)
	{
		case COQSTR: button = COQCOL1; break;
		case COTSTR: button = COTCOL1; break;
		case COBSTR: button = COBCOL1; break;
		case COOSTR: button = COOCOL1; break;
	}
	
	switch (button)
	{
	case COTCOL1:
	case COBCOL1:
		disableKeine=TRUE;
	case COQCOL1:
	case COOCOL1:
		if(disableKeine)
		{
			DelObjFlags(colPopup, 33, SELECTABLE);
			DelObjFlags(colPopup, 34, SELECTABLE);
		}
		else
		{
			SetObjFlags(colPopup, 33, SELECTABLE);
			SetObjFlags(colPopup, 34, SELECTABLE);
		}
		EnableObjState(colPopup, 33, DISABLED, disableKeine);
		EnableObjState(colPopup, 34, DISABLED, disableKeine);
		objc_offset(tree, button, &x, &y);
		select = VDIUtil_GetXState(tree, button);
		select = mtPopups_TreePopup(colPopup, x, y, select / 2) - 1;
		select = (select / 2) * 2 + 1;
		if (select > 2 * maxColors &&select<(KEEPCOL*2))
			select = -1;
		if (select >= 0)
		{
			VDIUtil_SetXState(tree, button, select);
			VDIUtil_SetXString(tree, button, colPopup, select);
			if(select/2==KEEPCOL)
				SetObCol(tree, button+1, WHITE);
			else
				SetObCol(tree, button+1, (select / 2));
			WinDials_WinDialDraw(tree, ObjcParent(tree,button), 1, &r, FALSE);
		}
		break;
		
	case COTCOL2:
	case COBCOL2:
		disableKeine=TRUE;
	case COQCOL2:
	case COOCOL2:
		select = VDIUtil_GetXState(tree, button + 1);
		if(kstate&K_SHIFT)
		{
			if(select>32)
				select-=2 *(KEEPCOL- maxColors+1);
			else
			{
				select-=2;
				if(select<0)
				{
					if(disableKeine)
						select +=(2 * maxColors);
					else
						select+=2 *KEEPCOL+2;
				}
			}
			
		}
		else
		{
			if(select>32)
				select-=32;
			else
			{
				select+=2;
				if(select>=(2 * maxColors))
				{
					if(disableKeine)
						select = select % (2 * maxColors);
					else
						select+=2*(KEEPCOL-maxColors);
				}
			}
		}
		VDIUtil_SetXState(tree, button + 1, select);
		VDIUtil_SetXString(tree, button+1, colPopup, select);
		if(select/2==KEEPCOL)
			SetObCol(tree, button+2, WHITE);
		else
			SetObCol(tree, button+2, (select / 2));
		WinDials_WinDialDraw(tree, ObjcParent(tree,button +1), 1, &r, FALSE);
		break;
		
	case COOEFF1:
	case COQEFF1:
		objc_offset(tree, button, &x, &y);
		select = VDIUtil_GetXState(tree, button);
		select = mtPopups_TreePopup(effPopup, x, y, select) - 1;
		if (select >= 0)
		{
			VDIUtil_SetXState(tree, button, select);
			VDIUtil_SetXString(tree, button, effPopup, select);
			WinDials_WinDialDraw(tree, button, 1, &r, FALSE);
		}
		break;
		
	case COOEFF2:
	case COQEFF2:
		select = VDIUtil_GetXState(tree, button + 1);
		select = (select + 1) % 4;
		VDIUtil_SetXState(tree, button + 1, select);
		VDIUtil_SetXString(tree, button + 1, effPopup, select);
		WinDials_WinDialDraw(tree, button + 1, 1, &r, FALSE);
		break;
		
	case COOK:
	case COQUIT:
		return TRUE;
	}
	return FALSE;
}
/*** ---------------------------------------------------------------------- ***/
/*DYJ 5.21b */	/*DYJ 5.23e */
LOCAL _VOID colorGetSetValues(OBJECT *tree, _VOID *env, _BOOL set, _WORD exit)
{
	colorInfo *coInfo;
	_WORD textColor;
	_WORD quoteColor;
	_WORD quoteEffects;
	_WORD ownColor;
	_WORD ownEffects;
	_WORD backgroundColor;
	OBJECT *colPopup, *effPopup;
	_BOOL midDisable;

	exit &= 0x7fff;
	coInfo = env;
	colPopup  = TreeAddrLib[COLPOPUP];
	effPopup  = TreeAddrLib[EFFPOPUP];
	if (set)
	{
		coInfo->isGrin = grin_grinWindowTop(coInfo->wdw);
		coInfo->isEdit = Editor_IsEditTop(coInfo->wdw) && !coInfo->isGrin;
		if (coInfo->isEdit && Editor_GetMode(coInfo->wdw, roMode))
		{
			/*
			 * kann entweder eine eigene Nachricht im Viewmodus, oder
			 * ein read-only Infofile sein. Im Editor werden aber
			 * sowieso dann die Einstellungen der Nachrichtenanzeige
			 * genommen
			 */
			coInfo->isEdit = FALSE;
			coInfo->isGrin = TRUE;
		}
		coInfo->isMess = MsgWindow_msgWindowTop(coInfo->wdw);
		coInfo->isTree = treeList_treeWindowTop(coInfo->wdw);
		/* Jetzt Strings setzen fuer die einzelnen Objekte */
		if (coInfo->isMess)
		{
			SetObjcString(tree, COQSTR, MausTauschrsc_WrkString(FS_HOLD_BACK));
			SetObjcString(tree, COOSTR, MausTauschrsc_WrkString(FS_PERS_MSGS));
		} else if (coInfo->isTree)
		{
			SetObjcString(tree, COQSTR, MausTauschrsc_WrkString(FS_SUBJECT));
			SetObjcString(tree, COOSTR, MausTauschrsc_WrkString(FS_NOT_READ));
		} else
		{
			SetObjcString(tree, COQSTR, MausTauschrsc_WrkString(FS_QUOTE_COL));
			SetObjcString(tree, COOSTR, MausTauschrsc_WrkString(FS_LINK_COL));
		}
		/* Ggf. mittlere Zeile disablen */
		midDisable = coInfo->isEdit /* || coInfo->isMess */ || (coInfo->isTree && Bitplanes == 1);
		EnableObjState(tree, COQSTR,  DISABLED, midDisable);
		EnableObjState(tree, COQCOL1, DISABLED, midDisable);
		EnableObjState(tree, COQCOL2, DISABLED, midDisable);
		EnableObjState(tree, COQEFF1, DISABLED, midDisable);
		EnableObjState(tree, COQEFF2, DISABLED, midDisable);
		EnableObjFlags(tree, COQCOL0, TOUCHEXIT, !midDisable);
		EnableObjFlags(tree, COQCOL1, TOUCHEXIT, !midDisable);
		EnableObjFlags(tree, COQCOL2, TOUCHEXIT, !midDisable);
		EnableObjFlags(tree, COQEFF1, TOUCHEXIT, !midDisable);
		EnableObjFlags(tree, COQEFF2, TOUCHEXIT, !midDisable);
		EnableObjFlags(tree, COOCOLBOX, HIDETREE, !coInfo->isList && !coInfo->isTree && !coInfo->isMess && !coInfo->isGrin);
		EnableObjFlags(tree, COOEFFBOX, HIDETREE, !coInfo->isList && !coInfo->isTree && !coInfo->isMess && !coInfo->isGrin);
		EnableObjFlags(tree, COOSTR,  	HIDETREE, !coInfo->isList && !coInfo->isTree && !coInfo->isMess && !coInfo->isGrin);
		
		/* Jetzt die einzelnen Farben holen und Objekte vorbereiten */
		if (coInfo->isGrin)
		{
			ConfVars_GetConfDefInt(cMsgTextCol, &textColor, BLACK);
			ConfVars_GetConfDefInt(cMsgQuoteCol, &quoteColor, BLACK);
			ConfVars_GetConfDefInt(cMsgQuoteEffect, &quoteEffects, 1);
			ConfVars_GetConfDefInt(cMsgBackCol, &backgroundColor, WHITE);
			ConfVars_GetConfDefInt(cMsgLinkCol, &ownColor, BLUE);
			ConfVars_GetConfDefInt(cMsgLinkEffect, &ownEffects, 1);
		} else if (coInfo->isEdit)
		{
			ConfVars_GetConfDefInt(cEditTextCol, &textColor, BLACK);
			ConfVars_GetConfDefInt(cEditBackCol, &backgroundColor, WHITE);
			quoteColor = BLACK;
			ownColor = BLACK;
			quoteEffects = 1;
			ownEffects = 1;
		} else if (coInfo->isMess)
		{
			ConfVars_GetConfDefInt(cMsgSelectTextCol, &textColor, BLACK);
			ConfVars_GetConfDefInt(cMsgSelectBackCol, &backgroundColor, WHITE);
			ConfVars_GetConfDefInt(cMsgSelectHoldCol, &quoteColor, BLACK);
			ConfVars_GetConfDefInt(cMsgSelectHoldEff, &quoteEffects, 2);
			ConfVars_GetConfDefInt(cMsgSelectPersCol, &ownColor, BLACK);
			ConfVars_GetConfDefInt(cMsgSelectPersEff, &ownEffects, 1);
		} else if (coInfo->isTree)
		{
			ConfVars_GetConfDefInt(cTreeTextCol, &textColor, BLACK);
			ConfVars_GetConfDefInt(cTreeBackCol, &backgroundColor, WHITE);
			ConfVars_GetConfDefInt(cTreeSubjChangeCol, &quoteColor, BLACK);
			ConfVars_GetConfDefInt(cTreeNotReadCol, &ownColor, BLACK);
			ConfVars_GetConfDefInt(cTreeNotReadEffect, &ownEffects, 1);
			quoteEffects = 1;
		}
		/* Jetzt die Objektfarben setzen */
		
		if(quoteColor==KEEPCOL)
			SetObCol(tree, COQCOL0, WHITE);
		else
			SetObCol(tree, COQCOL0, quoteColor);
		VDIUtil_SetXState(tree, COQCOL1, quoteColor * 2 + 1);
		VDIUtil_SetXString(tree, COQCOL1, colPopup, quoteColor * 2 + 1);
		
		SetObCol(tree, COOCOL0, ownColor);
		VDIUtil_SetXState(tree, COOCOL1, ownColor * 2 + 1);
		VDIUtil_SetXString(tree, COOCOL1, colPopup, ownColor * 2 + 1);

		VDIUtil_SetXState(tree, COQEFF1, quoteEffects);
		VDIUtil_SetXString(tree, COQEFF1, effPopup, quoteEffects);
		
		VDIUtil_SetXState(tree, COOEFF1, ownEffects);
		VDIUtil_SetXString(tree, COOEFF1, effPopup, ownEffects);
		
		SetObCol(tree, COTCOL0, textColor);
		SetObCol(tree, COBCOL0, backgroundColor);
		VDIUtil_SetXState(tree, COTCOL1, textColor * 2 + 1);
		VDIUtil_SetXState(tree, COBCOL1, backgroundColor * 2 + 1);
		VDIUtil_SetXString(tree, COTCOL1, colPopup, textColor * 2 + 1);
		VDIUtil_SetXString(tree, COBCOL1, colPopup, backgroundColor * 2 + 1);
	} else
	{
		if (exit == COOK)
		{
			textColor = VDIUtil_GetXState(tree, COTCOL1) / 2;
			quoteColor = VDIUtil_GetXState(tree, COQCOL1) / 2;
			quoteEffects = VDIUtil_GetXState(tree, COQEFF1);
			if (coInfo->isList || coInfo->isTree || coInfo->isMess || coInfo->isGrin)
			{
				ownColor = VDIUtil_GetXState(tree, COOCOL1) / 2;
				ownEffects = VDIUtil_GetXState(tree, COOEFF1);
			}
			backgroundColor = VDIUtil_GetXState(tree, COBCOL1) / 2;
			if (coInfo->isGrin)
			{
				ConfVars_SetConfigInt(cMsgTextCol, textColor);
				ConfVars_SetConfigInt(cMsgQuoteCol, quoteColor);
				ConfVars_SetConfigInt(cMsgQuoteEffect, quoteEffects);
				ConfVars_SetConfigInt(cMsgBackCol, backgroundColor);
				ConfVars_SetConfigInt(cMsgLinkCol, ownColor);
				ConfVars_SetConfigInt(cMsgLinkEffect, ownEffects);
				Editor_RedrawAll();
			} else if (coInfo->isEdit)
			{
				ConfVars_SetConfigInt(cEditTextCol, textColor);
				ConfVars_SetConfigInt(cEditBackCol, backgroundColor);
				Editor_RedrawAll();
			} else if (coInfo->isTree)
			{
				ConfVars_SetConfigInt(cTreeTextCol, textColor);
				ConfVars_SetConfigInt(cTreeBackCol, backgroundColor);
				ConfVars_SetConfigInt(cTreeSubjChangeCol, quoteColor);
				ConfVars_SetConfigInt(cTreeNotReadCol, ownColor);
				ConfVars_SetConfigInt(cTreeNotReadEffect, ownEffects);
				treeList_treeRedrawAll();
			} else if (coInfo->isMess)
			{
				ConfVars_SetConfigInt(cMsgSelectTextCol, textColor);
				ConfVars_SetConfigInt(cMsgSelectBackCol, backgroundColor);
				ConfVars_SetConfigInt(cMsgSelectHoldCol, quoteColor);
				ConfVars_SetConfigInt(cMsgSelectHoldEff, quoteEffects);
				ConfVars_SetConfigInt(cMsgSelectPersCol, ownColor);
				ConfVars_SetConfigInt(cMsgSelectPersEff, ownEffects);
				MsgWindow_RedrawAll();
			}
		}
		OFREE(coInfo);
	}
}


/*** ------------------------------------------------------------------------ ***/
/*	_BOOL color3Button(OBJECT *tree, _VOID *env, _WORD button, _WORD mx, _WORD my, _UWORD kstate, _WORD clicks)		*/
/*	wie colorButton	aber fr eine Farb mehr										*/
/*	6.5.02 von Dimitri Junker	DYJ 4.38j										*/
/*** ------------------------------------------------------------------------ ***/
/*DYJ 5.22d */	/*DYJ 5.23e */
LOCAL _BOOL color3Button(OBJECT *tree, _VOID *env, _WORD button, _WORD mx, _WORD my, _UWORD kstate, _WORD clicks)
{
	GRECT r;
	OBJECT *colPopup, *effPopup;
	_WORD x, y;
	_WORD select;
	_BOOL disableKeine=FALSE;
	
	UNUSED(env);
	UNUSED(mx);
	UNUSED(my);
	UNUSED(kstate);
	UNUSED(clicks);
	if(button==-1)
		return FALSE;
	colPopup  = TreeAddrLib[COLPOPUP];
	effPopup  = TreeAddrLib[EFFPOPUP];
	
	button &= 0x7fff;
	DelObjState(tree, button, SELECTED);
	
	switch (button)
	{
		case CO3USTR: button = CO3UCOL1; break;
		case CO3TSTR: button = CO3TCOL1; break;
		case CO3BSTR: button = CO3BCOL1; break;
		case CO3OSTR: button = CO3OCOL1; break;
		case CO3CSTR: button = CO3CCOL1; break;
	}
	
	switch (button)
	{
	case CO3TCOL1:
	case CO3BCOL1:
		disableKeine=TRUE;
	case CO3UCOL1:
	case CO3OCOL1:
	case CO3CCOL1:
		if(disableKeine)
		{
			DelObjFlags(colPopup, 33, SELECTABLE);
			DelObjFlags(colPopup, 34, SELECTABLE);
		}
		else
		{
			SetObjFlags(colPopup, 33, SELECTABLE);
			SetObjFlags(colPopup, 34, SELECTABLE);
		}
		EnableObjState(colPopup, 33, DISABLED, disableKeine);
		EnableObjState(colPopup, 34, DISABLED, disableKeine);
		objc_offset(tree, button, &x, &y);
		select = VDIUtil_GetXState(tree, button);
		select = mtPopups_TreePopup(colPopup, x, y, select / 2) - 1;
		select = (select / 2) * 2 + 1;
		if (select > 2 * maxColors &&select<(KEEPCOL*2))
			select = -1;
		if (select >= 0)
		{
			VDIUtil_SetXState(tree, button, select);
			VDIUtil_SetXString(tree, button, colPopup, select);
			if(select/2==KEEPCOL)
				SetObCol(tree, button+1, WHITE);
			else
				SetObCol(tree, button+1, (select / 2));
			WinDials_WinDialDraw(tree, ObjcParent(tree,button), 1, &r, FALSE);
		}
		break;
		
	case CO3TCOL2:
	case CO3BCOL2:
		disableKeine=TRUE;
	case CO3UCOL2:
	case CO3OCOL2:
	case CO3CCOL2:
		select = VDIUtil_GetXState(tree, button + 1);
		if(kstate&K_SHIFT)
		{
			if(select>32)
				select-=2 *(KEEPCOL- maxColors+1);
			else
			{
				select-=2;
				if(select<0)
				{
					if(disableKeine)
						select +=(2 * maxColors);
					else
						select+=2 *KEEPCOL+2;
				}
			}
			
		}
		else
		{
			if(select>32)
				select-=32;
			else
			{
				select+=2;
				if(select>=(2 * maxColors))
				{
					if(disableKeine)
						select = select % (2 * maxColors);
					else
						select+=2*(KEEPCOL-maxColors);
				}
			}
		}
		VDIUtil_SetXState(tree, button + 1, select);
		VDIUtil_SetXString(tree, button+1, colPopup, select);
		if(select/2==KEEPCOL)
			SetObCol(tree, button+2, WHITE);
		else
			SetObCol(tree, button+2, (select / 2));
		WinDials_WinDialDraw(tree, ObjcParent(tree,button +1), 1, &r, FALSE);
		break;
		
	case CO3OEFF1:
	case CO3CEFF1:
	case CO3UEFF1:
		objc_offset(tree, button, &x, &y);
		select = VDIUtil_GetXState(tree, button);
		select = mtPopups_TreePopup(effPopup, x, y, select) - 1;
		if (select >= 0)
		{
			VDIUtil_SetXState(tree, button, select);
			VDIUtil_SetXString(tree, button, effPopup, select);
			WinDials_WinDialDraw(tree, button, 1, &r, FALSE);
		}
		break;
		
	case CO3OEFF2:
	case CO3CEFF2:
	case CO3UEFF2:
		select = VDIUtil_GetXState(tree, button + 1);
		select = (select + 1) % 4;
		VDIUtil_SetXState(tree, button + 1, select);
		VDIUtil_SetXString(tree, button + 1, effPopup, select);
		WinDials_WinDialDraw(tree, button + 1, 1, &r, FALSE);
		break;
		
	case COOK:
	case CO3QUIT:
		return TRUE;
	}
	return FALSE;
}


/*** ------------------------------------------------------------------------ ***/
/*	LOCAL _VOID color3GetSetValues(OBJECT *tree, _VOID *env, _BOOL set, _WORD exit)					*/
/*	wie colorGetSetValues	aber fr eine Farb mehr										*/
/*	6.5.02 von Dimitri Junker	DYJ 4.38j										*/
/*** ------------------------------------------------------------------------ ***/
/*DYJ 5.20j */	/*DYJ 5.21b */	/*DYJ 5.23e */	/*DYJ 5.24h */
LOCAL _VOID color3GetSetValues(OBJECT *tree, _VOID *env, _BOOL set, _WORD exit)
{
	colorInfo *coInfo;
	_WORD textColor;
	_WORD	spez1Color,spez2Color,spez3Color;
	_WORD	spez1Effects,spez2Effects,spez3Effects;
	/* sonst nicht einzeln markiert*/
	_WORD backgroundColor;
	OBJECT *colPopup, *effPopup;
	_BOOL midDisable;

	exit &= 0x7fff;
	coInfo = env;
	colPopup  = TreeAddrLib[COLPOPUP];
	effPopup  = TreeAddrLib[EFFPOPUP];
	if (set)
	{
		coInfo->isGrin = grin_grinWindowTop(coInfo->wdw);
		coInfo->isEdit = Editor_IsEditTop(coInfo->wdw) && !coInfo->isGrin;
		coInfo->isList = msgList_listWindowTop(coInfo->wdw);
		/* Jetzt Strings setzen fuer die einzelnen Objekte */
		if (coInfo->isList)
		{
			SetObjcString(tree, CO3USTR, MausTauschrsc_WrkString(FS_NOT_READ));
			SetObjcString(tree, CO3OSTR, MausTauschrsc_WrkString(FS_OWN_MSGS));
			SetObjcString(tree, CO3CSTR, MausTauschrsc_WrkString(FS_C2O_MSGS));
		}
		else
		{
			SetObjcString(tree, CO3USTR, MausTauschrsc_WrkString(FS_LINK_COL));
			SetObjcString(tree, CO3OSTR, MausTauschrsc_WrkString(FS_QUOTE_COL1));
			SetObjcString(tree, CO3CSTR, MausTauschrsc_WrkString(FS_QUOTE_COL2));
		}
		/* Ggf. mittlere Zeile disablen */
		midDisable = FALSE;
		EnableObjState(tree, CO3USTR,  DISABLED, midDisable);
		EnableObjState(tree, CO3UCOL1, DISABLED, midDisable);
		EnableObjState(tree, CO3UCOL2, DISABLED, midDisable);
		EnableObjState(tree, CO3UEFF1, DISABLED, midDisable);
		EnableObjState(tree, CO3UEFF2, DISABLED, midDisable);
		EnableObjFlags(tree, CO3UCOL0, TOUCHEXIT, !midDisable);
		EnableObjFlags(tree, CO3UCOL1, TOUCHEXIT, !midDisable);
		EnableObjFlags(tree, CO3UCOL2, TOUCHEXIT, !midDisable);
		EnableObjFlags(tree, CO3UEFF1, TOUCHEXIT, !midDisable);
		EnableObjFlags(tree, CO3UEFF2, TOUCHEXIT, !midDisable);
		EnableObjFlags(tree, CO3OCOLBOX, HIDETREE, !coInfo->isList && !coInfo->isGrin );
		EnableObjFlags(tree, CO3CCOLBOX, HIDETREE, !coInfo->isList && !coInfo->isGrin);
		EnableObjFlags(tree, CO3OEFFBOX, HIDETREE, !coInfo->isList && !coInfo->isGrin);
		EnableObjFlags(tree, CO3CEFFBOX, HIDETREE, !coInfo->isList && !coInfo->isGrin);
		EnableObjFlags(tree, CO3OSTR,  	HIDETREE, !coInfo->isList && !coInfo->isGrin);
		EnableObjFlags(tree, CO3CSTR,  	HIDETREE, !coInfo->isList && !coInfo->isGrin);
		
		/* Jetzt die einzelnen Farben holen und Objekte vorbereiten */
		if (coInfo->isList)
		{
			ConfVars_GetConfDefInt(cListTextCol, &textColor, BLACK);
			ConfVars_GetConfDefInt(cListNotReadCol, &spez1Color, BLACK);
			ConfVars_GetConfDefInt(cListNotReadEffect, &spez1Effects, 1);
			ConfVars_GetConfDefInt(cListBackCol, &backgroundColor, WHITE);
			ConfVars_GetConfDefInt(cListOwnMessCol, &spez2Color, BLACK);
			ConfVars_GetConfDefInt(cListOwnMessEffect, &spez2Effects, 1);
			ConfVars_GetConfDefInt(cListC2OMessCol, &spez3Color, BLACK);
			ConfVars_GetConfDefInt(cListC2OMessEffect, &spez3Effects, 1);
		} else if (coInfo->isGrin)
		{
			ConfVars_GetConfDefInt(cMsgTextCol, &textColor, BLACK);
			ConfVars_GetConfDefInt(cMsgLinkCol, &spez1Color, BLUE);
			ConfVars_GetConfDefInt(cMsgLinkEffect, &spez1Effects, 1);
			ConfVars_GetConfDefInt(cMsgQuoteCol, &spez2Color, BLACK);
			ConfVars_GetConfDefInt(cMsgQuoteEffect, &spez2Effects, 1);
			ConfVars_GetConfDefInt(cMsgQuoteCol2, &spez3Color, spez2Color);
			ConfVars_GetConfDefInt(cMsgQuoteEffect2, &spez3Effects, spez2Effects);
			ConfVars_GetConfDefInt(cMsgBackCol, &backgroundColor, WHITE);
		}
		/* Jetzt die Objektfarben setzen */
		
		if(spez1Color==KEEPCOL)
			SetObCol(tree, CO3UCOL0, WHITE);
		else
			SetObCol(tree, CO3UCOL0, spez1Color);
		VDIUtil_SetXState(tree, CO3UCOL1, spez1Color * 2 + 1);
		VDIUtil_SetXString(tree, CO3UCOL1, colPopup, spez1Color * 2 + 1);
		
		SetObCol(tree, CO3OCOL0, spez2Color);
		VDIUtil_SetXState(tree, CO3OCOL1, spez2Color * 2 + 1);
		VDIUtil_SetXString(tree, CO3OCOL1, colPopup, spez2Color * 2 + 1);

		SetObCol(tree, CO3CCOL0, spez3Color);
		VDIUtil_SetXState(tree, CO3CCOL1, spez3Color * 2 + 1);
		VDIUtil_SetXString(tree, CO3CCOL1, colPopup, spez3Color * 2 + 1);

		VDIUtil_SetXState(tree, CO3UEFF1, spez1Effects);
		VDIUtil_SetXString(tree, CO3UEFF1, effPopup, spez1Effects);
		
		VDIUtil_SetXState(tree, CO3OEFF1, spez2Effects);
		VDIUtil_SetXString(tree, CO3OEFF1, effPopup, spez2Effects);
		
		VDIUtil_SetXState(tree, CO3CEFF1, spez3Effects);
		VDIUtil_SetXString(tree, CO3CEFF1, effPopup, spez3Effects);
		
		SetObCol(tree, CO3TCOL0, textColor);
		SetObCol(tree, CO3BCOL0, backgroundColor);
		VDIUtil_SetXState(tree, CO3TCOL1, textColor * 2 + 1);
		VDIUtil_SetXState(tree, CO3BCOL1, backgroundColor * 2 + 1);
		VDIUtil_SetXString(tree, CO3TCOL1, colPopup, textColor * 2 + 1);
		VDIUtil_SetXString(tree, CO3BCOL1, colPopup, backgroundColor * 2 + 1);
	} else
	{
		if (exit == CO3OK)
		{
			textColor = VDIUtil_GetXState(tree, CO3TCOL1) / 2;
			spez1Color = VDIUtil_GetXState(tree, CO3UCOL1) / 2;
			spez1Effects = VDIUtil_GetXState(tree, CO3UEFF1);
			if (coInfo->isList || coInfo->isGrin)
			{
				spez2Color = VDIUtil_GetXState(tree, CO3OCOL1) / 2;
				spez3Color = VDIUtil_GetXState(tree, CO3CCOL1) / 2;
				spez2Effects = VDIUtil_GetXState(tree, CO3OEFF1);
				spez3Effects = VDIUtil_GetXState(tree, CO3CEFF1);
			}
			backgroundColor = VDIUtil_GetXState(tree, CO3BCOL1) / 2;
			if (coInfo->isList)
			{
				ConfVars_SetConfigInt(cListTextCol, textColor);
				ConfVars_SetConfigInt(cListBackCol, backgroundColor);
				ConfVars_SetConfigInt(cListNotReadCol, spez1Color);
				ConfVars_SetConfigInt(cListNotReadEffect, spez1Effects);
				ConfVars_SetConfigInt(cListOwnMessCol, spez2Color);
				ConfVars_SetConfigInt(cListOwnMessEffect, spez2Effects);
				ConfVars_SetConfigInt(cListC2OMessCol, spez3Color);
				ConfVars_SetConfigInt(cListC2OMessEffect, spez3Effects);
				msgList_listRedrawAll();
			}else if (coInfo->isGrin)
			{
				ConfVars_SetConfigInt(cMsgTextCol, textColor);
				ConfVars_SetConfigInt(cMsgBackCol, backgroundColor);
				ConfVars_SetConfigInt(cMsgLinkCol, spez1Color);
				ConfVars_SetConfigInt(cMsgLinkEffect, spez1Effects);
				ConfVars_SetConfigInt(cMsgQuoteCol, spez2Color);
				ConfVars_SetConfigInt(cMsgQuoteEffect, spez2Effects);
				ConfVars_SetConfigInt(cMsgQuoteCol2, spez3Color);
				ConfVars_SetConfigInt(cMsgQuoteEffect2, spez3Effects);
				Editor_RedrawAll();
			}
		}
		OFREE(coInfo);
	}
}
/*** ---------------------------------------------------------------------- ***/
/*DYJ 5.20j */	/*DYJ 5.22d */
GLOBAL _VOID CatOpts_doColor(HWND wdw)
{
	OBJECT *colorBox;
	colorInfo *coInfo;

	if (msgList_listWindowTop(wdw) ||
		(Editor_IsEditTop(wdw)&& grin_grinWindowTop(wdw)))
	{
		coInfo = NEW(colorInfo, "CatOpts_doColor");
		if (coInfo == NULL)
			return;
		coInfo->wdw = wdw;
		colorBox = TreeAddr[FARBEN3];
		
		if (!WinDials_OpenWinDial(colorBox, TRUE,
			color3GetSetValues,
			color3GetSetValues,
			color3Button,
			WinDials_defDraw,
			NULL,
			coInfo))
		{
			OFREE(coInfo);
		} else
		{
			WinDials_WinDialHandleEvents();
		}
	}
	else if (Editor_IsEditTop(wdw) ||
		MsgWindow_msgWindowTop(wdw) ||
		treeList_treeWindowTop(wdw))
	{
		coInfo = NEW(colorInfo, "CatOpts_doColor");
		if (coInfo == NULL)
			return;
		coInfo->wdw = wdw;
		colorBox = TreeAddr[FARBEN];
		
		if (!WinDials_OpenWinDial(colorBox, TRUE,
			colorGetSetValues,
			colorGetSetValues,
			colorButton,
			WinDials_defDraw,
			NULL,
			coInfo))
		{
			OFREE(coInfo);
		} else
		{
			WinDials_WinDialHandleEvents();
		}
	}
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

typedef struct {
	_UBYTE arc_path[PATH_MAX];
	_UBYTE enarc_str[PATH_MAX];
	_UBYTE dearc_str[PATH_MAX];
	_UBYTE import_path[PATH_MAX];
	_UBYTE archive_name[PATH_MAX];
	_UBYTE export_path[PATH_MAX];
	_UBYTE message_path[PATH_MAX];
	_UBYTE data_path[PATH_MAX];
	_UBYTE attachment_path[PATH_MAX];
	_UBYTE terminal_path[PATH_MAX];
	_UBYTE terminal_cmd[PATH_MAX*6];
} configInfo;

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID translateOut(configInfo *confInfo, CONST _UBYTE *src, _UBYTE *dest, size_t destsize)
{
	_UBYTE path[PATH_MAX];
	_UBYTE name[PATH_MAX];
	_UBYTE suff[PATH_MAX];
	
	strMcpy(dest, destsize, src);
	mtDir_SplitPath(confInfo->archive_name, path, name, suff);
	strBcpy(name, NAME_INFILE);
	strBcat(name, suff);
	CatGlobal_ReplaceStr(dest, destsize, "$F", name);                    /* Infilename */
	CatGlobal_ReplaceStr(dest, destsize, "$O", confInfo->archive_name);  /* Outfilename */
	CatGlobal_ReplaceStr(dest, destsize, "$I", confInfo->import_path);   /* Importpath */
	CatGlobal_ReplaceStr(dest, destsize, "$E", confInfo->export_path);   /* Exportpath */
	CatGlobal_ReplaceStr(dest, destsize, "$M", confInfo->message_path);  /* Messagepath */
	CatGlobal_ReplaceStr(dest, destsize, "$D", confInfo->data_path); 	 /* Databasepath */
	mtDir_SplitPath(confInfo->terminal_path, path, name, suff);
	CatGlobal_ReplaceStr(dest, destsize, "$T", path);                    /* Terminalpath */
}

/*** ---------------------------------------------------------------------- ***/
LOCAL _VOID translateIn(CONST _UBYTE *src, _UBYTE *dest, size_t destsize)
{
	_UBYTE path[PATH_MAX];
	_UBYTE name[PATH_MAX];
	_UBYTE suff[PATH_MAX];
	
	strMcpy(dest, destsize, src);
	mtDir_SplitPath(archiveName, path, name, suff);
	strBcpy(name, NAME_INFILE);
	strBcat(name, suff);
	CatGlobal_ReplaceStr(dest, destsize, name, "$F");         /* Infilename */
	CatGlobal_ReplaceStr(dest, destsize, archiveName,"$O");   /* Outfilename */
	CatGlobal_ReplaceStr(dest, destsize, ImportPath, "$I");   /* Importpath */
	CatGlobal_ReplaceStr(dest, destsize, ExportPath, "$E");   /* Exportpath */
	CatGlobal_ReplaceStr(dest, destsize, MessagePath, "$M");  /* Messagepath */
	CatGlobal_ReplaceStr(dest, destsize, DataPath, "$D");  	  /* Databasepath */
	CatGlobal_ReplaceStr(dest, destsize, TerminalPath, "$T"); /* Terminalpath */
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID getEdits(OBJECT *tree, configInfo *confInfo)
{
	ObjcString(tree, PSARC, confInfo->enarc_str, sizeof(confInfo->enarc_str));
	ObjcString(tree, PSDEARC, confInfo->dearc_str, sizeof(confInfo->dearc_str));
	ObjcString(tree, PSCOMM, confInfo->terminal_cmd, sizeof(confInfo->terminal_cmd));
}

/*** ------------------------------------------------------------------------ ***/
/*	_VOID write_CatInf(CONST _UBYTE *infpath,CONST _UBYTE *name,configInfo *confInfo,OBJECT *tree)	*/
/*	Schreibt eine Cat.inf, war frher Teil von configButton wurde jetzt aber an */
/*	2 Stellen bentigt.	Die Daten werden aus dem Dialog ausgelesen, in der		*/
/*	Struktur zwischengespeichert und in das File geschrieben.					*/
/*	Parameter:	infpath:	der Zielpfad										*/
/*				name:		und der zugehrige Dateiname						*/
/*				confInfo:	die interne Struktur								*/
/*				tree:		der Dialog der ausgelesen werden soll.				*/
/*	Ergebnis:	keines															*/		
/*	3.10.02 von Dimitri Junker	DYJ 4.43g										*/
/*** ------------------------------------------------------------------------ ***/
/*DYJ 5.21i */
LOCAL _VOID write_CatInf(CONST _UBYTE *infpath,CONST _UBYTE *name,configInfo *confInfo,OBJECT *tree)
{
	TEXTFILENO tf;
	_UBYTE str[256];
	_UBYTE path[PATH_MAX];
	strBcpy(path, infpath);
	F_Path_Append(path, name);
	if (mtTextfiles_OpenTextfile(path, WRITE, 512, &tf) == GERR_OK)
	{
		_UBYTE suff[PATH_MAX],name[PATH_MAX];
		getEdits(tree, confInfo);             /* editable Strings holen */
		if (confInfo->arc_path[0] != '\0')
		{
			mtDir_SplitPath(confInfo->arc_path, path, name, suff);
			mtTextfiles_WriteLine(tf, path); mtTextfiles_WriteLn(tf);                /* Arc-Path */
			mtTextfiles_WriteLine(tf, name); mtTextfiles_WriteLn(tf);                /* Arc-Name */
		} else
		{
			mtTextfiles_WriteLn(tf);
			mtTextfiles_WriteLn(tf);
		}
		translateOut(confInfo, confInfo->enarc_str, str, sizeof(str));
		mtTextfiles_WriteLine(tf, str); mtTextfiles_WriteLn(tf);                 /* arc-Command */
		translateOut(confInfo, confInfo->dearc_str, str, sizeof(str));
		mtTextfiles_WriteLine(tf, str); mtTextfiles_WriteLn(tf);                 /* dearc-Command */
		mtTextfiles_WriteLine(tf, confInfo->archive_name); mtTextfiles_WriteLn(tf);        /* Outfile name */
		mtTextfiles_WriteLn(tf);          /* EditorPath: not supported from dialog */
		mtTextfiles_WriteLn(tf);          /* EditorName: not supported from dialog */
		mtTextfiles_WriteLine(tf, confInfo->message_path); mtTextfiles_WriteLn(tf);        /* Messagepath */
		mtTextfiles_WriteLine(tf, confInfo->import_path); mtTextfiles_WriteLn(tf);         /* Importpath */
		mtTextfiles_WriteLine(tf, confInfo->export_path); mtTextfiles_WriteLn(tf);        /* Exportpath */
		mtTextfiles_WriteLine(tf, confInfo->data_path); mtTextfiles_WriteLn(tf);        /* Databasepath */
		mtDir_SplitPath(confInfo->terminal_path, path, name, suff);
		mtTextfiles_WriteLine(tf, path); mtTextfiles_WriteLn(tf);                /* TerminalPath */
		mtTextfiles_WriteLine(tf, name); mtTextfiles_WriteLn(tf);                /* TerminalName */
		translateOut(confInfo, confInfo->terminal_cmd, str, sizeof(str));
		mtTextfiles_WriteLine(tf, str); mtTextfiles_WriteLn(tf);                 /* Terminalcommand */
		mtTextfiles_WriteLine(tf, confInfo->attachment_path); mtTextfiles_WriteLn(tf);        /* attachmentpath */
		mtTextfiles_CloseTextfile(&tf);
		Protokoll_SendPathUpdate(infpath);
	} else
	{
		sprintf(str, Rsc_WrkString(MTE_noFileWrite), name);
		MTE_info(str);
	}
}
/*** ---------------------------------------------------------------------- ***/
/*DYJ 5.21b */	/*DYJ 5.27d */
LOCAL _BOOL configButton(OBJECT *tree, _VOID *env, _WORD button, _WORD mx, _WORD my, _UWORD kstate, _WORD clicks)
{
	configInfo *confInfo;
	_UBYTE path[PATH_MAX];
	_UBYTE name[PATH_MAX];
	_UBYTE suff[PATH_MAX];
	GRECT r;
	_BOOL res,exists;
	_BOOL hattePacker;


	UNUSED(mx);
	UNUSED(my);
	UNUSED(kstate);
	UNUSED(clicks);
	if(button==-1)
		return FALSE;
	confInfo = env;
	button &= 0x7fff;
	DelObjState(tree, button, SELECTED);
	switch (button)
	{
		/* Pfade holen */
		/* Nur bei PBOUTFIL nur Dateinamen ohne Pfad nehmen,
		 * bei PBPACK oder PBTERM auch noch Dateinamen an Pfad
		 * anhaengen
		 */
	case PBPACK:
		hattePacker=confInfo->arc_path[0]!='\0';
		mtDir_SplitPath(confInfo->arc_path, path, name, suff);
		res = mtDir_FselGet(path, name, ALL_FILE_MASK, MausTauschrsc_WrkString(FS_PACKER), TRUE);
		if (res)
		{
			strBcpy(confInfo->arc_path, path);
			if (name[0] != '\0')
				F_Path_Append(confInfo->arc_path, name);
			else
				confInfo->arc_path[0] = '\0';
		}
		else
		{
			if(strLen(confInfo->arc_path) && mtAlerts_Alert(1, Rsc_WrkString(AL_NO_PACK))==2)
				confInfo->arc_path[0] = '\0';
		}
		SetObjcString(tree, PSPACK, confInfo->arc_path);
		CalcArea(tree, PSPACK, &r);
		WinDials_WinDialDraw(tree, ROOT, MAX_DEPTH, &r, TRUE);
		if(hattePacker!=(confInfo->arc_path[0]!='\0'))
		{
			EnableObjState(tree, PSARC, DISABLED, confInfo->arc_path[0]=='\0');
			CalcArea(tree, PSARC, &r);
			WinDials_WinDialDraw(tree, ROOT, MAX_DEPTH, &r, TRUE);
			EnableObjState(tree, PSDEARC, DISABLED, confInfo->arc_path[0]=='\0');
			CalcArea(tree, PSDEARC, &r);
			WinDials_WinDialDraw(tree, ROOT, MAX_DEPTH, &r, TRUE);
		}
		break;
	
	case PBIMPORT:
		mtDir_SplitPath(confInfo->import_path, path, name, suff);
		res = mtDir_FselGet(path, name, ALL_FILE_MASK, MausTauschrsc_WrkString(FS_IMPORT), TRUE);
		if (res)
		{
			strBcpy(confInfo->import_path, path);
			F_Path_Append(confInfo->import_path, "");
			SetObjcString(tree, PSIMPORT, confInfo->import_path);
			CalcArea(tree, PSIMPORT, &r);
			WinDials_WinDialDraw(tree, ROOT, MAX_DEPTH, &r, TRUE);
		}
		break;
	
	case PBOUTFIL:
		strBcpy(path, confInfo->import_path);
		strBcpy(name, confInfo->archive_name);
		res = mtDir_FselGet(path, name, ALL_FILE_MASK, MausTauschrsc_WrkString(FS_OUTFILE), FALSE);
		if (res)
		{
			strBcpy(confInfo->archive_name, name);
			SetObjcString(tree, PSOUTFIL, confInfo->archive_name);
			CalcArea(tree, PSOUTFIL, &r);
			WinDials_WinDialDraw(tree, ROOT, MAX_DEPTH, &r, TRUE);
		}
		break;
		
	case PBEXPORT:
		mtDir_SplitPath(confInfo->export_path, path, name, suff);
		res = mtDir_FselGet(path, name, ALL_FILE_MASK, MausTauschrsc_WrkString(FS_EXPORT), TRUE);
		if (res)
		{
			strBcpy(confInfo->export_path, path);
			F_Path_Append(confInfo->export_path, "");
			SetObjcString(tree, PSEXPORT, confInfo->export_path);
			CalcArea(tree, PSEXPORT, &r);
			WinDials_WinDialDraw(tree, ROOT, MAX_DEPTH, &r, TRUE);
		}
		break;
		
	case PBMESSAG:
		mtDir_SplitPath(confInfo->message_path, path, name, suff);
		res = mtDir_FselGet(path, name, ALL_FILE_MASK, MausTauschrsc_WrkString(FS_MESSAGES), TRUE);
		if (res)
		{
			strBcpy(confInfo->message_path, path);
			F_Path_Append(confInfo->message_path, "");
			SetObjcString(tree, PSMESSAG, confInfo->message_path);
			CalcArea(tree, PSMESSAG, &r);
			WinDials_WinDialDraw(tree, ROOT, MAX_DEPTH, &r, TRUE);
		}
		break;
		
	case PBDATA:
		mtDir_SplitPath(confInfo->data_path, path, name, suff);
		res = mtDir_FselGet(path, name, ALL_FILE_MASK, MausTauschrsc_WrkString(FS_DATABASE), TRUE);
		if (res)
		{
			strBcpy(confInfo->data_path, path);
			F_Path_Append(confInfo->data_path, "");
			SetObjcString(tree, PSDATA, confInfo->data_path);
			CalcArea(tree, PSDATA, &r);
			WinDials_WinDialDraw(tree, ROOT, MAX_DEPTH, &r, TRUE);
		}
		break;
	case PBATTCH:
		mtDir_SplitPath(confInfo->attachment_path, path, name, suff);
		res = mtDir_FselGet(path, name, ALL_FILE_MASK, MausTauschrsc_WrkString(FS_ATTCHBASE), TRUE);
		if (res)
		{
			strBcpy(confInfo->attachment_path, path);
			F_Path_Append(confInfo->attachment_path, "");
			SetObjcString(tree, PSATTCH, confInfo->attachment_path);
			CalcArea(tree, PSATTCH, &r);
			WinDials_WinDialDraw(tree, ROOT, MAX_DEPTH, &r, TRUE);
		}
		break;
	case PBTERM:
		mtDir_SplitPath(confInfo->terminal_path, path, name, suff);
		res = mtDir_FselGet(path, name, ALL_FILE_MASK, MausTauschrsc_WrkString(FS_TERMINAL), FALSE);
		if (res)
		{
			strBcpy(confInfo->terminal_path, path);
			if (name[0] != '\0')
				F_Path_Append(confInfo->terminal_path, name);
			else
				confInfo->arc_path[0] = '\0';
			SetObjcString(tree, PSTERM, confInfo->terminal_path);
			CalcArea(tree, PSTERM, &r);
			WinDials_WinDialDraw(tree, ROOT, MAX_DEPTH, &r, TRUE);
		}
		break;
	case PBCMD:
		if((strCaseStr(confInfo->terminal_path,"in2cat") &&
			CatFiles_FileSize(confInfo->terminal_path, &exists)>120000l) ||
			mtAlerts_Alert(1, Rsc_WrkString(AL_NO_I2C))==1)
		{
			CatUtil_makeTmpName(Tmp_CatInf,name);
			write_CatInf(Tmp_CatInf,name,confInfo,tree);
			F_Path_Append(Tmp_CatInf, name);
			mtDir_SplitPath(confInfo->terminal_path, path, name, suff);
			StartPrg(path, name, Tmp_CatInf, TRUE,TRUE, &TermPid);
			return TRUE;
		}
		break;
	
	case PATHHELP:
		CatHelp_DoHelp(CatHelp_paths);
		break;
	
	case PATHSAVE:
		/* CAT.INF schreiben, Fileselektor, um Name zu erfragen */
		mtDir_SplitPath(infName, path, name, suff);
		strBcpy(path, infPath);
		if (suff[0] != '\0')
			Insert("*.", suff, sizeof(suff), 0);
		else
			strBcpy(suff, "*.inf");
		res = mtDir_FselGet(path, name, suff, MausTauschrsc_WrkString(FS_SAVE_CAT_INF), FALSE);
		if (res)
		{
			write_CatInf(path,name,confInfo,tree);
		}
		break;
		
	case PATHOK:
	case PATHQUIT:
		return TRUE;
	}
	WinDials_WinDialDraw(tree, button, 1, &r, FALSE);
	return FALSE;
}
/*** ------------------------------------------------------------------------ ***/
/*	_BOOL ReadString(TEXTFILENO CATINF, _UBYTE *str, size_t strsize)			*/
/*	Liest eine Zeile aus einem Textfile, ohne den Zeilenumbruch					*/
/*	Kopie der gleichnamigen Funktion aus mtpaths.c								*/
/*	Parameter:	CATINF:	Textfile												*/
/*				str,strsize:	Ziel und dessen Gre							*/
/*	Ergebnis:	Ok(Fileende)													*/		
/*	4.10.02 	DYJ 4.43g														*/
/*** ------------------------------------------------------------------------ ***/
LOCAL _BOOL ReadString(TEXTFILENO CATINF, _UBYTE *str, size_t strsize)
{
	if (mtTextfiles_EndofText(CATINF))
		return FALSE;
	mtTextfiles_ReadLine(CATINF, str, strsize);
	mtTextfiles_ReadLn(CATINF);
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID configGetSetValues(OBJECT *tree, _VOID *env, _BOOL set, _WORD exit)
{
	configInfo *confInfo;
	_UBYTE suff[PATH_MAX];
	_BOOL ok=FALSE;
	confInfo = env;
	exit &= 0x7fff;

	if(set && *Tmp_CatInf)
	{
		TEXTFILENO CATINF;
		if (mtTextfiles_OpenTextfile(Tmp_CatInf, READ, 512, &CATINF) == GERR_OK)
		{
			_UBYTE sARCName[PATH_MAX];
			_UBYTE senarcStr[256];
			_UBYTE sdearcStr[256];
			_UBYTE sEditorPath[PATH_MAX];	/*Nicht mehr verwendet*/
			_UBYTE sTerminalName[PATH_MAX];
			_UBYTE sTerminalCmd[PATH_MAX*6];

			if (ReadString(CATINF, confInfo->arc_path, sizeof(confInfo->arc_path)) &&
				ReadString(CATINF, sARCName, sizeof(sARCName)) &&
				ReadString(CATINF, senarcStr, sizeof(senarcStr)) &&
				ReadString(CATINF, sdearcStr, sizeof(sdearcStr)) &&
				ReadString(CATINF, confInfo->archive_name, sizeof(confInfo->archive_name)) &&
				ReadString(CATINF, sEditorPath, sizeof(sEditorPath)) &&
				ReadString(CATINF, sEditorPath, sizeof(sEditorPath)) &&
				ReadString(CATINF, confInfo->message_path, sizeof(confInfo->message_path)) &&
				ReadString(CATINF, confInfo->import_path, sizeof(confInfo->import_path)) &&
				ReadString(CATINF, confInfo->export_path, sizeof(confInfo->export_path)) &&
				ReadString(CATINF, confInfo->data_path, sizeof(confInfo->data_path)) &&
				ReadString(CATINF, confInfo->terminal_path, sizeof(confInfo->terminal_path)) &&
				ReadString(CATINF, sTerminalName, sizeof(sTerminalName)) &&
				ReadString(CATINF, sTerminalCmd, sizeof(sTerminalCmd)) &&
				ReadString(CATINF, confInfo->attachment_path, sizeof(confInfo->attachment_path)))
			{
				F_Path_Append(confInfo->arc_path, sARCName);
				translateIn(senarcStr, confInfo->enarc_str, sizeof(confInfo->enarc_str));
				translateIn(sdearcStr, confInfo->dearc_str, sizeof(confInfo->dearc_str));
				F_Path_Append(confInfo->terminal_path, sTerminalName);
				translateIn(sTerminalCmd, confInfo->terminal_cmd, sizeof(confInfo->terminal_cmd));
				ok=TRUE;
			}
			mtTextfiles_CloseTextfile(&CATINF);
			if(CatFiles_Exists(Tmp_CatInf))
			{
				Fdelete(Tmp_CatInf);
				*Tmp_CatInf='\0';
			}
		}
	}
	if (set && !ok)
	{
		/* Strings setzen */
		strBcpy(confInfo->arc_path, ARCPath);
		F_Path_Append(confInfo->arc_path, ARCName);
		
		translateIn(enarcStr, confInfo->enarc_str, sizeof(confInfo->enarc_str));
		translateIn(dearcStr, confInfo->dearc_str, sizeof(confInfo->dearc_str));
		
		strBcpy(confInfo->import_path, ImportPath);
		strBcpy(confInfo->archive_name, archiveName);
		strBcpy(confInfo->export_path, ExportPath);
		strBcpy(confInfo->message_path, MessagePath);
		strBcpy(confInfo->data_path, DataPath);
		strBcpy(confInfo->attachment_path, AttachmentPath);
		strBcpy(confInfo->terminal_path, TerminalPath);
		F_Path_Append(confInfo->terminal_path, TerminalName);
		translateIn(TerminalCmd, confInfo->terminal_cmd, sizeof(confInfo->terminal_cmd));
	}
	if(set)
	{
		SetObjcString(tree, PSPACK,  confInfo->arc_path);
		SetObjcString(tree, PSARC,   confInfo->enarc_str);
		SetObjcString(tree, PSDEARC, confInfo->dearc_str);
		SetObjcString(tree, PSIMPORT,confInfo->import_path);
		SetObjcString(tree, PSOUTFIL,confInfo->archive_name);
		SetObjcString(tree, PSEXPORT,confInfo->export_path);
		SetObjcString(tree, PSMESSAG,confInfo->message_path);
		SetObjcString(tree, PSDATA,  confInfo->data_path);
		SetObjcString(tree, PSATTCH,  confInfo->attachment_path);
		SetObjcString(tree, PSTERM,  confInfo->terminal_path);
		SetObjcString(tree, PSCOMM,  confInfo->terminal_cmd);

		EnableObjState(tree, PSARC, DISABLED, confInfo->arc_path[0]=='\0');
		EnableObjState(tree, PSDEARC, DISABLED, confInfo->arc_path[0]=='\0');
	} else
	{
		if (exit == PATHOK)
		{
			getEdits(tree, confInfo);                   /* editables holen */
			/* Strings uebernehmen */
			if (confInfo->arc_path[0] != '\0')
			{
				mtDir_SplitPath(confInfo->arc_path, ARCPath, ARCName, suff);
			} else
			{
				ARCPath[0] = '\0';
				ARCName[0] = '\0';
			}
			translateOut(confInfo, confInfo->enarc_str, enarcStr, sizeof(enarcStr));
			translateOut(confInfo, confInfo->dearc_str, dearcStr, sizeof(dearcStr));
			strBcpy(ImportPath, confInfo->import_path);
			strBcpy(archiveName, confInfo->archive_name);
			strBcpy(ExportPath, confInfo->export_path);
			strBcpy(MessagePath, confInfo->message_path);
			strBcpy(DataPath, confInfo->data_path);
			strBcpy(AttachmentPath, confInfo->attachment_path);
			mtDir_SplitPath(confInfo->terminal_path, TerminalPath, TerminalName, suff);
			UserInformation_chkTerm();
			translateOut(confInfo, confInfo->terminal_cmd, TerminalCmd, sizeof(TerminalCmd));
/*DYJ 5.32b Start*/
/*DYJ  Ende; alt:	
			if(UserBLK.isInternet)
				SetObjcString(TreeAddr[MENU], OCBC_PMF, MENU_PMF);
			else
				SetObjcString(TreeAddr[MENU], OCBC_PMF, MENU_CBC);
*/
		}
		OFREE(confInfo);
	}
}

/*** ---------------------------------------------------------------------- ***/

/*DYJ 5.21b */	/*DYJ 5.21o */
GLOBAL _VOID CatOpts_doConfig(_WORD pid,_WORD ret)
{
	OBJECT *tree;
	configInfo *confInfo;
	if(pid)
	{
		if(pid!=TermPid)
			return;
		else if(ret)
		{
			if(CatFiles_Exists(Tmp_CatInf))
				Fdelete(Tmp_CatInf);
			*Tmp_CatInf='\0';
			return;
		}
	}
	else if(TermPid)
	{
		if(	mtAlerts_AlertRSC(1, AL_NO_I2C_EXIT)==1)
		{
			if(CatFiles_Exists(Tmp_CatInf))
				Fdelete(Tmp_CatInf);
			*Tmp_CatInf='\0';
		}
		else
			return;
	}
	TermPid=0;
	tree = TreeAddrLib[PATH_CNF];
	confInfo = NEW(configInfo, "CatOpts_DoConfig");
	if (confInfo == NULL)
		return;
	if (!WinDials_OpenWinDial(tree, FALSE,
		configGetSetValues,
		configGetSetValues,
		configButton,
		WinDials_defDraw,
		NULL,
		confInfo))
	{
		OFREE(confInfo);
	}
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

typedef struct {
	_UBYTE txtArray[6][256];
	_WORD oldEntry;
} formatInfo;

/*DYJ 5.30l Start*/
#if FOINFO1+1 != FOINFO1M
#error "FOINFO1M falsch"
#endif
#if FOINFO1M+1 != FOINFO2
#error "FOINFO2 falsch"
#endif
#if FOINFO2+1 != FOPRIVATE
#error "FOPRIVATE falsch"
#endif
#if FOPRIVATE+1 != FOGLOBAL
#error "FOGLOBAL falsch"
#endif
#if FOGLOBAL+1 != FOWWV
#error "FOWWV falsch"
#endif

/*DYJ  Ende; alt:	
#if FOINFO1+1 != FOINFO2
#error "FOINFO2 falsch"
#endif
#if FOINFO1+2 != FOPRIVATE
#error "FOPRIVATE falsch"
#endif
#if FOINFO1+3 != FOGLOBAL
#error "FOGLOBAL falsch"
#endif
#if FOINFO1+4 != FOWWV
#error "FOWWV falsch"
#endif
*/


/*** ---------------------------------------------------------------------- ***/
/*DYJ 5.21b */
LOCAL _BOOL formatButton(OBJECT *tree, _VOID *env, _WORD button, _WORD mx, _WORD my, _UWORD kstate, _WORD clicks)
{
	formatInfo *formInfo;
	GRECT r;
	_BOOL ok;
	
	UNUSED(mx);
	UNUSED(my);
	UNUSED(kstate);
	UNUSED(clicks);

	formInfo = env;
	button &= 0x7fff;
	switch (button)
	{
	case FOINFO1:
	case FOINFO1M:		/*DYJ 5.30l */
	case FOINFO2:
	case FOPRIVATE:
	case FOGLOBAL:
	case FOWWV:
	{
/*DYJ 5.34h Start*/
		_UBYTE fStr[512];
		ObjcString(tree, FOTXT1, fStr, sizeof(fStr));
		if(formInfo->oldEntry==FOPRIVATE || formInfo->oldEntry==FOGLOBAL)
			ok=msgList_CheckListLine(fStr);
		else
			ok=CatOpts_CheckInfoline(fStr);
		if(ok)
		{
			strBcpy(formInfo->txtArray[formInfo->oldEntry - FOINFO1],fStr);
			SetObjcString(tree, FOTXT1, formInfo->txtArray[button - FOINFO1]);
			formInfo->oldEntry = button;
			WinDials_WinDialDraw(tree, FOBOX, 2, &r, FALSE);
		}
		else
		{
			if(mtAlerts_AlertRSC(1,AL_INCORRECT_FORMAT)==2)
			{
				switch(formInfo->oldEntry)
				{
				case FOINFO1:
				case FOINFO1M:
					strBcpy(fStr,Rsc_WrkString(DEF_REFLINE1));
					break;
				case FOINFO2:
					strBcpy(fStr,"'In Msg 'M, U' wrote:'");
					break;
				case FOPRIVATE:
					strBcpy(fStr,cPrivateMsgListElemsDefault);
					break;
				case FOGLOBAL:
					strBcpy(fStr,cGrpMsgListElemsDefault);
					break;
				case FOWWV:
					strBcpy(fStr,Rsc_WrkString(DEF_WWV));
					break;
				}
				SetObjcString(tree, FOTXT1, fStr);
				WinDials_WinDialDraw(tree, FOBOX, 2, &r, FALSE);
			}
			DelObjState(tree, button, SELECTED);
			SetObjState(tree, formInfo->oldEntry, SELECTED);
			WinDials_WinDialDraw(tree, button, 1, &r, FALSE);
			WinDials_WinDialDraw(tree, formInfo->oldEntry, 1, &r, FALSE);
		} 
		break;
	}
/*DYJ  Ende; alt:	
		ObjcString(tree, FOTXT1, formInfo->txtArray[formInfo->oldEntry - FOINFO1], sizeof(formInfo->txtArray[FOINFO1-FOINFO1]));
		SetObjcString(tree, FOTXT1, formInfo->txtArray[button - FOINFO1]);
		formInfo->oldEntry = button;
		WinDials_WinDialDraw(tree, FOBOX, 2, &r, FALSE);
		break;
*/
	
	case FOOK:
		
/*DYJ 5.30l Start*/
		ObjcString(tree, FOTXT1, formInfo->txtArray[formInfo->oldEntry - FOINFO1], sizeof(formInfo->txtArray[FOINFO1-FOINFO1]));
		ok = CatOpts_CheckInfoline(formInfo->txtArray[FOINFO1-FOINFO1]) && CatOpts_CheckInfoline(formInfo->txtArray[FOINFO2-FOINFO1])
			&& CatOpts_CheckInfoline(formInfo->txtArray[FOINFO1M-FOINFO1]) && CatOpts_CheckInfoline(formInfo->txtArray[FOWWV-FOINFO1]);
/*DYJ  Ende; alt:	
		ObjcString(tree, FOTXT1, formInfo->txtArrayN[formInfo->oldEntry - FOINFO1], sizeof(formInfo->txtArray[0]));
		ok = CatOpts_CheckInfoline(formInfo->txtArray[0]) && CatOpts_CheckInfoline(formInfo->txtArrayN[1])
			&& CatOpts_CheckInfoline(formInfo->txtArray[4]);
*/

		DelObjState(tree, button, SELECTED);
		if (!ok)
		{
			MTE_infoRSC(AL_INCORRECT_INFOLINE);
			WinDials_WinDialDraw(tree, button, 1, &r, FALSE);
		} else
		{
/*DYJ 5.30l Start*/
			ok = msgList_CheckListLine(formInfo->txtArray[FOPRIVATE-FOINFO1]) && msgList_CheckListLine(formInfo->txtArray[FOGLOBAL-FOINFO1]);
/*DYJ  Ende; alt:	
			ok = msgList_CheckListLine(formInfo->txtArray[2]) && msgList_CheckListLine(formInfo->txtArray[3]);
*/
			if (!ok)
			{
				MTE_infoRSC(AL_INCORRECT_LISTLINE);
				WinDials_WinDialDraw(tree, button, 1, &r, FALSE);
			} else
			{
				return TRUE;
			}
		}
		break;
		
	case FOQUIT:
		DelObjState(tree, button, SELECTED);
		return TRUE;
	
	case FOHELP:
		CatHelp_DoHelp(CatHelp_formats);
		DelObjState(tree, button, SELECTED);
		WinDials_WinDialDraw(tree, button, 1, &r, FALSE);
		break;
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/
LOCAL _VOID formatGetSetValues(OBJECT *tree, _VOID *env, _BOOL set, _WORD exit)
{
	_WORD i;
	_BOOL found;
	formatInfo *formInfo;

	formInfo = env;
	exit &= 0x7fff;
	if (set)
	{
		/* Textarray fuellen */
		strBcpy(formInfo->txtArray[FOINFO1-FOINFO1], UserBLK.ReferenceLine1);
/*DYJ 5.30l Start*/
		strBcpy(formInfo->txtArray[FOINFO2-FOINFO1], UserBLK.ReferenceLine2);
		strBcpy(formInfo->txtArray[FOINFO1M-FOINFO1], UserBLK.ReferenceLine1M);
		strBcpy(formInfo->txtArray[FOWWV-FOINFO1], UserBLK.WWVerkettung);
		ConfVars_GetConfDefStr(cPrivateMsgListElems, formInfo->txtArray[FOPRIVATE-FOINFO1], sizeof(formInfo->txtArray[FOPRIVATE-FOINFO1]), cPrivateMsgListElemsDefault);
		ConfVars_GetConfDefStr(cGrpMsgListElems, formInfo->txtArray[FOGLOBAL-FOINFO1], sizeof(formInfo->txtArray[FOGLOBAL-FOINFO1]), cGrpMsgListElemsDefault);
/*DYJ  Ende; alt:	
		strBcpy(formInfo->txtArrayN[1], UserBLK.ReferenceLine2);
		strBcpy(formInfo->txtArray[4], UserBLK.WWVerkettung);
		ConfVars_GetConfDefStr(cPrivateMsgListElems, formInfo->txtArray[2], sizeof(formInfo->txtArray[2]), cPrivateMsgListElemsDefault);
		ConfVars_GetConfDefStr(cGrpMsgListElems, formInfo->txtArray[3], sizeof(formInfo->txtArray[3]), cGrpMsgListElemsDefault);
*/
		/* Selektierten Eintrag feststellen */
		i = FOINFO1;
		found = FALSE;
		while (!found && i <= FOWWV)
		{
			found = GetObjState(tree, i, SELECTED);
			if (!found)
				++i;
		}
		if (!found)
		{
			i = FOINFO1;
			SetObjState(tree, i, SELECTED);
		}
		formInfo->oldEntry = i;
		SetObjcString(tree, FOTXT1, formInfo->txtArray[i - FOINFO1]);
	} else
	{
		if (exit == FOOK)
		{
/*DYJ 5.30l Start*/
			strBcpy(UserBLK.ReferenceLine1, formInfo->txtArray[FOINFO1-FOINFO1]);
			strBcpy(UserBLK.ReferenceLine2, formInfo->txtArray[FOINFO2-FOINFO1]);
			strBcpy(UserBLK.ReferenceLine1M, formInfo->txtArray[FOINFO1M-FOINFO1]);
			strBcpy(UserBLK.WWVerkettung, formInfo->txtArray[FOWWV-FOINFO1]);
			ConfVars_SetConfigString(cReferenceLine1, formInfo->txtArray[FOINFO1-FOINFO1]);
			ConfVars_SetConfigString(cReferenceLine2, formInfo->txtArray[FOINFO2-FOINFO1]);
			ConfVars_SetConfigString(cReferenceLine1M, formInfo->txtArray[FOINFO1M-FOINFO1]);
/*DYJ 5.32c Start*/
			ConfVars_SetConfigString(cWWVerkettung, formInfo->txtArray[FOWWV-FOINFO1]);
/*DYJ  Ende; alt:	
			ConfVars_SetConfigString(cWWVerkettung, formInfo->txtArray[FOGLOBAL-FOINFO1]);
*/
			ConfVars_SetConfigString(cPrivateMsgListElems, formInfo->txtArray[FOPRIVATE-FOINFO1]);
			ConfVars_SetConfigString(cGrpMsgListElems, formInfo->txtArray[FOGLOBAL-FOINFO1]);
			msgList_SetListLine(formInfo->txtArray[FOPRIVATE-FOINFO1], TRUE);
			msgList_SetListLine(formInfo->txtArray[FOGLOBAL-FOINFO1], FALSE);
/*DYJ  Ende; alt:	
			strBcpy(UserBLK.ReferenceLine1, formInfo->txtArray[0]);
			strBcpy(UserBLK.ReferenceLine2, formInfo->txtArrayN[1]);
			strBcpy(UserBLK.WWVerkettung, formInfo->txtArray[4]);
			ConfVars_SetConfigString(cReferenceLine1, formInfo->txtArray[0]);
			ConfVars_SetConfigString(cReferenceLine2, formInfo->txtArrayN[1]);
			ConfVars_SetConfigString(cWWVerkettung, formInfo->txtArray[4]);
			ConfVars_SetConfigString(cPrivateMsgListElems, formInfo->txtArray[2]);
			ConfVars_SetConfigString(cGrpMsgListElems, formInfo->txtArray[3]);
			msgList_SetListLine(formInfo->txtArray[2], TRUE);
			msgList_SetListLine(formInfo->txtArray[3], FALSE);
*/
			msgList_listRedrawAll();
		}
		OFREE(formInfo);
	}
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID CatOpts_doFormat(_VOID)
{
	OBJECT *tree;
	formatInfo *formInfo;

	tree = TreeAddr[FORM_CNF];
	formInfo = NEW(formatInfo, "CatOpts_doFormat");
	if (formInfo == NULL)
		return;
	if (!WinDials_OpenWinDial(tree, FALSE,
		formatGetSetValues,
		formatGetSetValues,
		formatButton,
		WinDials_defDraw,
		NULL,
		formInfo))
	{
		OFREE(formInfo);
	}
}

