/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 *
 * 2.2.03 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.20n'
 *	Fehler im Formular zur PM-Filterdefinition verbessert
 *
 * 11.2.03 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.20za'
 *	Im Popup war Platz fr 25 Zeichen, es wurden aber nur 20 benutzt
 */


#include <catopts2.h>
#include <catopts.h>
#include <cattypes.h>
#include <catgloba.h>
#include <wdwmanag.h>
#include <maustaus.h>
#include <mte.h>
#include <editor.h>
#include <grin.h>
#include <printer.h>
#include <cathelp.h>
#include <edittype.h>
#include <vdiutil.h>
#include <confvars.h>
#include <varname2.h>
#include <varnamel.h>
#include <varname4.h>
#include <infodlg.h>
#include <mtpaths.h>
#include <msgwindo.h>
#include <msglist.h>
#include <treelist.h>
#include <protokol.h>
#include <windials.h>
#include <iofilter.h>
#include <pmfilter.h>
#include <groupsel.h>
#include <zsearchd.h>

#include <hlp_prg.h>

#include <shellcal.h>
#include <listhelp.h>
#include <listdl.h>

#include <mtutils.h>
#include <mtdials.h>
#include <mtdir.h>
#include <mtpopups.h>
#include <mtappl.h>
#include <mttextfi.h>
#include <magicstr.h>

#include <strconv.h>
#include <ro_mem.h>
#include <routinec.h>
#include <routines.h>
#include <file_io.h>
#include <sound.h>
#include <mtrsc.h>

#define MAX_FLOSKEL_LEN 512

#define CR 0x0d
#define LF 0x0a

typedef struct
{
#if IO_FILTER_STRLEN>PM_FILTER_STRLEN
	_UBYTE	typName[IO_FILTER_STRLEN+5];
#else
	_UBYTE	typName[IO_FILTER_STRLEN+5];
#endif
	_WORD	nummer;
}FILTER_TN;

#if MAX_IO_FILTER>MAX_PM_FILTER
	FILTER_TN FilterTN[MAX_IO_FILTER],*FilterPTN[MAX_IO_FILTER];
#else
	FILTER_TN FilterTN[MAX_PM_FILTER],*FilterPTN[MAX_PM_FILTER];
#endif





#if(CBCDAY1_00+1!=CBCDAY2_00)
#error "CBCDAY2_00 sortieren!"
#endif
#if(CBCDAY1_01+1!=CBCDAY2_01)
#error "CBCDAY2_01 sortieren!"
#endif
#if(CBCDAY1_02+1!=CBCDAY2_02)
#error "CBCDAY2_02 sortieren!"
#endif
#if(CBCDAY1_03+1!=CBCDAY2_03)
#error "CBCDAY2_03 sortieren!"
#endif
#if(CBCDAY1_04+1!=CBCDAY2_04)
#error "CBCDAY2_04 sortieren!"
#endif
#if(CBCDAY1_05+1!=CBCDAY2_05)
#error "CBCDAY2_05 sortieren!"
#endif
#if(CBCDAY1_06+1!=CBCDAY2_06)
#error "CBCDAY2_06 sortieren!"
#endif

#if(CBCVON1_00+1!=CBCVON2_00)
#error "CBCVON2_00 sortieren!"
#endif
#if(CBCVON1_01+1!=CBCVON2_01)
#error "CBCVON2_01 sortieren!"
#endif
#if(CBCVON1_02+1!=CBCVON2_02)
#error "CBCVON2_02 sortieren!"
#endif
#if(CBCVON1_03+1!=CBCVON2_03)
#error "CBCVON2_03 sortieren!"
#endif
#if(CBCVON1_04+1!=CBCVON2_04)
#error "CBCVON2_04 sortieren!"
#endif
#if(CBCVON1_05+1!=CBCVON2_05)
#error "CBCVON2_05 sortieren!"
#endif
#if(CBCVON1_06+1!=CBCVON2_06)
#error "CBCVON2_06 sortieren!"
#endif

#if(CBCBIS1_00+1!=CBCBIS2_00)
#error "CBCBIS2_00 sortieren!"
#endif
#if(CBCBIS1_01+1!=CBCBIS2_01)
#error "CBCBIS2_01 sortieren!"
#endif
#if(CBCBIS1_02+1!=CBCBIS2_02)
#error "CBCBIS2_02 sortieren!"
#endif
#if(CBCBIS1_03+1!=CBCBIS2_03)
#error "CBCBIS2_03 sortieren!"
#endif
#if(CBCBIS1_04+1!=CBCBIS2_04)
#error "CBCBIS2_04 sortieren!"
#endif
#if(CBCBIS1_05+1!=CBCBIS2_05)
#error "CBCBIS2_05 sortieren!"
#endif
#if(CBCBIS1_06+1!=CBCBIS2_06)
#error "CBCBIS2_06 sortieren!"
#endif

#if(CBCVON1_00+3!=CBCBIS1_00)
#error "CBCBIS1_00 sortieren!"
#endif
#if(CBCVON1_01+3!=CBCBIS1_01)
#error "CBCBIS1_01 sortieren!"
#endif
#if(CBCVON1_02+3!=CBCBIS1_02)
#error "CBCBIS1_02 sortieren!"
#endif
#if(CBCVON1_03+3!=CBCBIS1_03)
#error "CBCBIS1_03 sortieren!"
#endif
#if(CBCVON1_04+3!=CBCBIS1_04)
#error "CBCBIS1_04 sortieren!"
#endif
#if(CBCVON1_05+3!=CBCBIS1_05)
#error "CBCBIS1_05 sortieren!"
#endif
#if(CBCVON1_06+3!=CBCBIS1_06)
#error "CBCBIS1_06 sortieren!"
#endif

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

typedef struct {
	_UBYTE txtArray[20][MAX_FLOSKEL_LEN];
	_WORD oldEntry;
	_BOOL oldControl;
	HWND theWdw;
} floskelInfo;

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID SetEntry(OBJECT *tree, floskelInfo *floskel, _WORD idx, _BOOL isControl)
{
	_UBYTE str[MAX_FLOSKEL_LEN];
	_WORD strIdx;
	_UBYTE *p;
	
	strIdx = idx - FL_F1;
	if (isControl)
		strIdx += 10;
	/* Suchen nach einzelnen LFs und ersetzen davon */
	strBcpy(str, floskel->txtArray[strIdx]);
	p = str;
	while ((p = strChr(p, LF)) != NULL)
	{
		strCpy(p, p + 1);
	}
	CatGlobal_SetStrings(tree, FLLINE1, FLLINE6, str);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID GetEntry(OBJECT *tree, floskelInfo *floskel, _WORD idx, _BOOL isControl)
{
	_UBYTE str[MAX_FLOSKEL_LEN];
	_WORD strIdx;
	_UBYTE *p;
	
	strIdx = idx - FL_F1;
	if (isControl)
		strIdx += 10;
	CatGlobal_GetStrings(tree, FLLINE1, FLLINE6, str, sizeof(str));
	/* Suchen nach einzelnen CRs und diese ersetzen durch CR/LF */
	p = str;
	while ((p = strChr(p, CR)) != NULL)
	{
		if (p[1] != LF)
			strInsertChar(LF, p + 1, str + sizeof(str) - p - 1);
		++p;
	}
	/* Suchen nach einzelnen LFs und ersetzen davon */
	p = str;
	while ((p = strChr(p, LF)) != NULL)
	{
		if (p == str || p[-1] != CR)
			strInsertChar(CR, p, str + sizeof(str) - p);
		++p;
	}
	/* Jetzt nur noch in Textarray sichern */
	strBcpy(floskel->txtArray[strIdx], str);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL floskelButton(OBJECT *tree, _VOID *env, _WORD button, _WORD mx, _WORD my, _UWORD kstate, _WORD clicks)
{
	GRECT r;
	floskelInfo *floskel;
	_BOOL isControl;
	_UBYTE *strPtr;
	_ULONG strLen;
	
	UNUSED(mx);
	UNUSED(my);
	UNUSED(kstate);
	UNUSED(clicks);

	floskel = env;
	button &= 0x7fff;
	switch (button)
	{
	case FL_F1:
	case FL_F2:
	case FL_F3:
	case FL_F4:
	case FL_F5:
	case FL_F6:
	case FL_F7:
	case FL_F8:
	case FL_F9:
	case FL_F10:
		GetEntry(tree, floskel, floskel->oldEntry, floskel->oldControl);
		isControl = GetObjState(tree, FL_CONTRL, SELECTED);
		SetEntry(tree, floskel, button, isControl);
		floskel->oldControl = isControl;
		floskel->oldEntry   = button;
		WinDials_WinDialDraw(tree, FLBOX, MAX_DEPTH, &r, FALSE);
		break;
	
	case FL_SHIFT:
	case FL_CONTRL:
		GetEntry(tree, floskel, floskel->oldEntry, floskel->oldControl);
		isControl = GetObjState(tree, FL_CONTRL, SELECTED);
		SetEntry(tree, floskel, floskel->oldEntry, isControl);
		floskel->oldControl = isControl;
		WinDials_WinDialDraw(tree, FLBOX, MAX_DEPTH, &r, FALSE);
		break;
	
	case FLBLOCK:
		if (Editor_GetBlock(floskel->theWdw, FALSE, TRUE, &strPtr, &strLen))
		{
			if (strLen > MAX_FLOSKEL_LEN)
				strPtr[MAX_FLOSKEL_LEN-1] = '\0';
			CatGlobal_SetStrings(tree, FLLINE1, FLLINE6, strPtr);
			GetEntry(tree, floskel, floskel->oldEntry, floskel->oldControl);
			SetEntry(tree, floskel, floskel->oldEntry, floskel->oldControl);
			WinDials_WinDialDraw(tree, FLBOX, MAX_DEPTH, &r, FALSE);
			SFREE(strPtr);
			DelObjState(tree, button, SELECTED);
			WinDials_WinDialDraw(tree, button, MAX_DEPTH, &r, FALSE);
		}
		break;
		
	case FLOK:
	case FLCANCEL:
		DelObjState(tree, button, SELECTED);
		GetEntry(tree, floskel, floskel->oldEntry, floskel->oldControl);
		return TRUE;
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID floskelGetSetValues(OBJECT *tree, _VOID *env, _BOOL set, _WORD exit)
{
	floskelInfo *floskel;
	_WORD i;
	_BOOL found;
	_BOOL isControl;
	_UBYTE str[MAX_FLOSKEL_LEN];
	_UBYTE varName[128];
	
	floskel = env;
	exit &= 0x7fff;
	if (set)
	{
		for (i = 0; i < 10; i++)
		{
			make_varname(varName, sizeof(varName), cShiftF, i + 1);
			ConfVars_GetConfDefStr(varName, floskel->txtArray[i], MAX_FLOSKEL_LEN, "");
		}
		EnableObjState(tree, FLBLOCK, DISABLED,
			!(Editor_IsEditTop(floskel->theWdw) &&
			Editor_BlockIsMarked(floskel->theWdw)));
		for (i = 0; i < 10; i++)
		{
			make_varname(varName, sizeof(varName), cControlF, i + 1);
			ConfVars_GetConfDefStr(varName, floskel->txtArray[10 + i], MAX_FLOSKEL_LEN, "");
		}
		/* Selektierten Eintrag feststellen */
		i = FL_F1;
		found = FALSE;
		while (!found && i <= FL_F10)
		{
			found = GetObjState(tree, i, SELECTED);
			if (!found)
				++i;
		}
		isControl = GetObjState(tree, FL_CONTRL, SELECTED);
		SetEntry(tree, floskel, i, isControl);
		floskel->oldEntry = i;
		floskel->oldControl = isControl;
	} else
	{
		if (exit == FLOK)
		{
			/* Strings abspeichern */
			for (i = 0; i < 10; i++)
			{
				make_varname(varName, sizeof(varName), cShiftF, i + 1);
				if (ConfVars_GetConfigString(varName, str, sizeof(str)) ||
					floskel->txtArray[i][0] != '\0')
				{
					ConfVars_SetConfigString(varName, floskel->txtArray[i]);
				}
			}
			for (i = 0; i < 10; i++)
			{
				make_varname(varName, sizeof(varName), cControlF, i + 1);
				if (ConfVars_GetConfigString(varName, str, sizeof(str)) ||
					floskel->txtArray[i + 10][0] != '\0')
				{
					ConfVars_SetConfigString(varName, floskel->txtArray[i + 10]);
				}
			}
		}
		OFREE(floskel);
	}
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID CatOpts2_doFloskel(_VOID)
{
	OBJECT *floskelBox;
	floskelInfo *floskel;

	/* vorbereiten */
	floskelBox = TreeAddr[FLOSKELN];
	floskel = NEW(floskelInfo, "CatOpts2_doFloskel");
	if (floskel == NULL)
		return;
	floskel->theWdw = ownTopWindow;
	if (!WinDials_OpenWinDial(floskelBox, FALSE,
		floskelGetSetValues,
		floskelGetSetValues,
		floskelButton,
		WinDials_defDraw,
		NULL,
		floskel))
	{
		OFREE(floskel);
	}
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

typedef struct {
	ioFilterStruct filter[MAX_IO_FILTER];
	_WORD select;
	_WORD oldSelect;
} ioInfStruct;

typedef struct {
	hlpPrgStruct hlp_prg[MAX_HLP_PRG];
	_WORD select;
	_WORD oldSelect;
} hpInfStruct;

typedef struct {
	pmFilterStruct filter[MAX_PM_FILTER];
	_WORD select;
	_WORD oldSelect;
} pmInfStruct;

/*** ---------------------------------------------------------------------- ***/

/*DYJ 5.21b */
LOCAL _VOID setItems(OBJECT *tree, OBJECT *pop, CONST ioFilterStruct *filter)
{
	_WORD intVal;
	_UBYTE pass[2]="0";
	_UBYTE *type;
	switch(filter->filtType)
	{
		case ForMsg:
			intVal = 1;
			type=MausTauschrsc_WrkString(FS_FOR_MESSAGES);
			break;
		case PastOutfile:
			intVal = 2;
			type=MausTauschrsc_WrkString(FS_FOR_OUTFILE);
			break;
		default:
			intVal = 0;
			type=MausTauschrsc_WrkString(FS_FOR_INFILE);
	}
	VDIUtil_SetXState(tree, IOFILTTYPE1, intVal);
	VDIUtil_SetXString(tree, IOFILTTYPE1, pop, intVal);
	EnableObjFlags(tree, IOINFILE, HIDETREE, (filter->filtType& ForIO)==0);
	EnableObjFlags(tree, IOOUTFILE, HIDETREE, (filter->filtType& ForIO)==0);
	EnableObjState(tree, IOINFILE, SELECTED, filter->filtType&ForInfile);
	EnableObjState(tree, IOOUTFILE, SELECTED, filter->filtType&ForOutfile);
	EnableObjFlags(tree, FILTCMD2, HIDETREE,  (filter->filtType& ForIO)==0);
	EnableObjFlags(tree, FILTCMD2, EDITABLE, filter->filtType& ForIO);
	EnableObjFlags(tree, IOFILTCMD2, HIDETREE,  (filter->filtType& ForIO)==0);
	if((filter->filtType& ForIO)==0 && WinDials_GetCursObj(tree)==FILTCMD2)
		WinDials_WinEditChanged(tree, FILTCMD1);
	if(filter->pass>-1 && filter->pass<10)
		*pass='0'+filter->pass;
	SetObjcString(tree, IODURCHL, pass);
	EnableObjState(tree, IOBREAK, SELECTED, filter->stopAtErr);
	SetObjcString(tree, IOFILTCMD, type);
	SetObjcString(tree, IOFILTNAME, filter->filtName);
	SetObjcString(tree, FILTCMD1, filter->inCmd);
	SetObjcString(tree, FILTCMD2, filter->outCmd);
	if (filter->progName[0] != '\0')
		SetObjcString(tree, IOFILTSEL, F_Path_Basename(filter->progName));
	else
		SetObjcString(tree, IOFILTSEL, MausTauschrsc_WrkString(FS_EMPTY));
}
/*** ------------------------------------------------------------------------ ***/
/*	_VOID pmSetItems(OBJECT *tree, OBJECT *pop, CONST pmFilterStruct *filter)	*/
/*	wie das vorige, aber fr PM-Filter											*/
/*	26.11.01 von Dimitri Junker	DYJ 4.30zk										*/
/*** ------------------------------------------------------------------------ ***/
/*DYJ 5.20n */
LOCAL _VOID pmSetItems(OBJECT *tree, OBJECT *pop, CONST pmFilterStruct *filter)
{
	_UBYTE pass[2]="0";
	_WORD intVal;
	switch(filter->pmfType)
	{
		case ForSend:
			intVal = 0;
			break;
		case ForRec:
			intVal = 1;
			break;
		case ForBoth:
			intVal = 2;
			break;
		case ForSubj:
			intVal = 3;
			break;
		case ForID:
			intVal = 4;
			break;
/*DYJ 5.35e Start*/
		case ForRTO:
			intVal = 5;
			break;
/*DYJ  Ende; */
	}

	VDIUtil_SetXState(tree, PMFILTTYPE1, intVal);
	VDIUtil_SetXString(tree, PMFILTTYPE1, pop, intVal);
	EnableObjState(tree, PMFILTDEL, SELECTED, filter->pmfAktType==PMA_DELETE);
	EnableObjState(tree, PMFILTGR, SELECTED, filter->pmfAktType==PMA_GROUP);
	EnableObjState(tree, PMFILTFL, SELECTED, filter->pmfAktType==PMA_FLAGS);
	EnableObjFlags(tree, PMFILTGRTXT, HIDETREE,  filter->pmfAktType!=PMA_GROUP);
	EnableObjFlags(tree, PMFILTFLTXT, HIDETREE,  filter->pmfAktType!=PMA_FLAGS);
	EnableObjFlags(tree, PMFILTGRUPPE, HIDETREE,  filter->pmfAktType==PMA_DELETE);
	if(filter->prio>-1 && filter->prio<10)
		*pass='0'+filter->prio;
	SetObjcString(tree, PMPRIOR, pass);
	SetObjcString(tree, PMFILTSUCH, filter->suchStr);
	SetObjcString(tree, PMFILTNAME, filter->filtName);
	if(filter->pmfAktType==PMA_GROUP)
		SetObjcString(tree, PMFILTGRUPPE, filter->gruppe);
	else if(filter->pmfAktType==PMA_FLAGS)
		SetObjcString(tree, PMFILTGRUPPE, filter->flags);

}

/*** ------------------------------------------------------------------------ ***/
/*	LOCAL FILT_TYPES getFiltType(OBJECT *tree)									*/
/*	Ermittelt den Filtertyp aus den Angaben im Formular.						*/
/*	Parameter:	tree: der Baum															*/
/*	Ergebnis:	der Typ															*/		
/*	8.11.00 von Dimitri Junker	DYJ 4.18										*/
/*** ------------------------------------------------------------------------ ***/
LOCAL FILT_TYPES getFiltType(OBJECT *tree)
{
	_WORD intVal;
	FILT_TYPES type;
	intVal = VDIUtil_GetXState(tree, IOFILTTYPE1);
	switch(intVal)
	{
		case 0:
			if(GetObjState(tree, IOINFILE, SELECTED))
			{
				type=ForInfile;
				if(GetObjState(tree, IOOUTFILE, SELECTED))
					type|=ForOutfile;
			}
			else
				type=ForOutfile;
			break;
		case 1:
			type=ForMsg;
			break;
		case 2:
			type=PastOutfile;
			break;
	}
	return type;
}
/*** ------------------------------------------------------------------------ ***/
/*	FILT_TYPES getPmFiltType(OBJECT *tree)										*/
/*	wie das vorige, aber fr PM-Filter											*/
/*	26.11.01 von Dimitri Junker	DYJ 4.30zk										*/
/*** ------------------------------------------------------------------------ ***/
LOCAL FILT_TYPES getPmFiltType(OBJECT *tree)
{
	_WORD intVal;
	FILT_TYPES type;
	intVal = VDIUtil_GetXState(tree, PMFILTTYPE1);
	switch(intVal)
	{
		case 0:
			type=ForSend;
			break;
		case 1:
			type=ForRec;
			break;
		case 2:
			type=ForBoth;
			break;
		case 3:
			type=ForSubj;
			break;
		case 4:
			type=ForID;
			break;
/*DYJ 5.35e Start*/
		case 5:
			type=ForRTO;
			break;
/*DYJ  Ende; */
	}
	return type;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID getItems(OBJECT *tree, ioFilterStruct *filter)
{
	_UBYTE pass[2];
	filter->filtType=getFiltType(tree);
	ObjcString(tree, IODURCHL, pass, sizeof(pass));
	filter->pass=*pass-'0';
	filter->stopAtErr = GetObjState(tree, IOBREAK, SELECTED);
	ObjcString(tree, FILTCMD1, filter->inCmd, sizeof(filter->inCmd));
	ObjcString(tree, FILTCMD2, filter->outCmd, sizeof(filter->outCmd));
	ObjcString(tree, IOFILTNAME, filter->filtName, sizeof(filter->filtName));
}
/*** ------------------------------------------------------------------------ ***/
/*	VOID pmGetItems(OBJECT *tree, pmFilterStruct *filter)						*/
/*	wie das vorige, aber fr PM-Filter											*/
/*	26.11.01 von Dimitri Junker	DYJ 4.30zk										*/
/*** ------------------------------------------------------------------------ ***/
LOCAL _VOID pmGetItems(OBJECT *tree, pmFilterStruct *filter)
{
	_UBYTE prio[2];
	filter->pmfType=getPmFiltType(tree);
	ObjcString(tree, PMPRIOR, prio, sizeof(prio));
	filter->prio=*prio-'0';
	ObjcString(tree, PMFILTSUCH, filter->suchStr, sizeof(filter->suchStr));
	if(GetObjState(tree, PMFILTDEL, SELECTED))
		filter->pmfAktType=PMA_DELETE;
	else if(GetObjState(tree, PMFILTGR, SELECTED))
	{
		filter->pmfAktType=PMA_GROUP;
		ObjcString(tree, PMFILTGRUPPE, filter->gruppe, sizeof(filter->gruppe));
	}
	else
	{
		filter->pmfAktType=PMA_FLAGS;
		ObjcString(tree, PMFILTGRUPPE, filter->flags, sizeof(filter->flags));
	}
	ObjcString(tree, PMFILTNAME, filter->filtName, sizeof(filter->filtName));
}

/*** ------------------------------------------------------------------------ ***/
/*	LOCAL _VOID setFiltTypName(ioFilterStruct *filters,_WORD nr,OBJECT *tree)	*/
/*	Erzeugt die Stings aus der Abk. fr den Filtertyp, die Ziffer fr den Pass	*/
/*	und den eigentlichen Filternamen											*/
/*	Parameter:	filters:	ein Feld mit den Filterinfos						*/
/*				nr:			die Nummer des zu behandelnden Filters				*/
/*				tree:		falls!=NULL soll auch der Eintrag im Formular 		*/
/*							tree gesetzt werden									*/
/*	Ergebnis:	keines															*/		
/*	8.11.00 von Dimitri Junker	DYJ 4.18										*/
/*** ------------------------------------------------------------------------ ***/
/*DYJ 5.21b */
LOCAL _VOID setFiltTypName(ioFilterStruct *filters,_WORD nr,OBJECT *tree)
{
	_UBYTE path[PATH_MAX];
	_UBYTE ext[PATH_MAX];
	_UBYTE name[PATH_MAX];
	FilterTN[nr].typName[0]=' ';
	switch(filters[nr].filtType)
	{
		case ForMsg:
			FilterTN[nr].typName[1]='M';
			FilterTN[nr].typName[2]='e';
			break;
		case PastOutfile:
			FilterTN[nr].typName[1]='n';
			FilterTN[nr].typName[2]='E';
			break;
		case ForIO:
			FilterTN[nr].typName[1]='I';
			FilterTN[nr].typName[2]='O';
			break;
		case ForInfile:
			FilterTN[nr].typName[1]='I';
			FilterTN[nr].typName[2]=' ';
			break;
		case ForOutfile:
			FilterTN[nr].typName[1]=' ';
			FilterTN[nr].typName[2]='O';
			break;
	}
	FilterTN[nr].typName[3]='0'+filters[nr].pass;
	FilterTN[nr].typName[4]=' ';
	if (filters[nr].filtName[0] == '\0')
	{
		if(*filters[nr].progName)
		{
			mtDir_SplitPath(filters[nr].progName, path, name, ext);
			name[IO_FILTER_STRLEN-1]='\0';
			strMcpy(FilterTN[nr].typName+5,IO_FILTER_STRLEN, name);
		}
		else
			strMcpy(FilterTN[nr].typName,IO_FILTER_STRLEN+5, MausTauschrsc_WrkString(FS_NOT_INSTALLED));
	}
	else
		strMcpy(FilterTN[nr].typName+5,IO_FILTER_STRLEN, filters[nr].filtName);
	if(tree)
		SetObjcString(tree, IOFILTPOP1, FilterTN[nr].typName);
}
/*** ------------------------------------------------------------------------ ***/
/*	LOCAL _VOID setPmFiltTypName(ioFilterStruct *filters,_WORD nr,OBJECT *tree)	*/
/*	Erzeugt die Stings aus der Abk. fr den Filtertyp, die Ziffer fr den Pass	*/
/*	und den eigentlichen Filternamen											*/
/*	Parameter:	filters:	ein Feld mit den Filterinfos						*/
/*				nr:			die Nummer des zu behandelnden Filters				*/
/*				tree:		falls!=NULL soll auch der Eintrag im Formular 		*/
/*							tree gesetzt werden									*/
/*	Ergebnis:	keines															*/		
/*	26.11.00 von Dimitri Junker	DYJ 4.30zk										*/
/*** ------------------------------------------------------------------------ ***/
/*DYJ 5.20za */	/*DYJ 5.21b */
LOCAL _VOID setPmFiltTypName(pmFilterStruct *filters,_WORD nr,OBJECT *tree)
{
	if (filters[nr].suchStr[0] == '\0')
		strMcpy(FilterTN[nr].typName,IO_FILTER_STRLEN+5, MausTauschrsc_WrkString(FS_NOT_INSTALLED));
	else
	{
		FilterTN[nr].typName[0]=' ';
		FilterTN[nr].typName[1]='0'+filters[nr].prio;
		switch(filters[nr].pmfType)
		{
			case ForSend:
				FilterTN[nr].typName[2]='A';
				FilterTN[nr].typName[3]='b';
				break;
			case ForRec:
				FilterTN[nr].typName[2]='E';
				FilterTN[nr].typName[3]='m';
				break;
			case ForBoth:
				FilterTN[nr].typName[2]='S';
				FilterTN[nr].typName[3]='E';
				break;
			case ForSubj:
				FilterTN[nr].typName[2]='B';
				FilterTN[nr].typName[3]='e';
				break;
			case ForID:
				FilterTN[nr].typName[2]='I';
				FilterTN[nr].typName[3]='D';
				break;
/*DYJ 5.35e Start*/
			case ForRTO:
				FilterTN[nr].typName[2]='R';
				FilterTN[nr].typName[3]='T';
				break;
/*DYJ  Ende; */
		}
		FilterTN[nr].typName[4]='=';
		FilterTN[nr].typName[5]='\0';
		if (filters[nr].filtName[0] == '\0')
			strMcat(FilterTN[nr].typName,PM_FILTER_STRLEN+5,filters[nr].suchStr);
		else
			strMcat(FilterTN[nr].typName,PM_FILTER_STRLEN+5, filters[nr].filtName);
		if(tree)
			SetObjcString(tree, PMFILTPOP1, FilterTN[nr].typName);
	}
}

/*** ------------------------------------------------------------------------ ***/
/*	_WORD cmpFilter(const void*f1,const void*f2)								*/
/*	Vergleicht 2 Filter nach folgenden Kriterien (nach Prioritt geordnet)		*/
/*	Prioritt,Filterart, Filternummer											*/
/*	Parameter:	f1,f2: die beiden Filter										*/
/*	Ergebnis:	wie strcmp														*/		
/*	8.11.00 von Dimitri Junker	DYJ 4.18										*/
/*** ------------------------------------------------------------------------ ***/
LOCAL _WORD cmpFilter(const void*f1,const void*f2)
{
	FILTER_TN *filt[2];
	_UBYTE str[2][4];
	_WORD i;
	filt[0]=*(FILTER_TN **)f1;
	filt[1]=*(FILTER_TN **)f2;
	for(i=0;i<2;i++)
	{
		if(filt[i]->typName[1]==' ')
		{
			if(filt[i]->typName[2]=='O')
				str[i][0]='I';
			else
				str[i][0]='z';			/* Dann ist es leer ->ans Ende*/
		}
		else
			str[i][0]=filt[i]->typName[1];
		str[i][1]=filt[i]->typName[3];
		str[i][2]=filt[i]->nummer+'0';
		str[i][3]='\0';
	}
	return strCmp(str[0],str[1]);
}
/*** ------------------------------------------------------------------------ ***/
/*	LOCAL _WORD selFilter(OBJECT *tree,_WORD how)								*/
/*	Selektiert auf eine von 4 Arten einen Filter								*/
/*	Parameter:	tree:	das Formular											*/
/*				how= 0:		das nchste aus der sortierten Liste				*/
/*					 1,2,3:	das vorige aus der sortierten Liste					*/
/*					 4:		per Popup aus der sortierten Liste					*/
/*					 5,6,7:	per Popup aus der unsortierten Liste				*/
/*				forObj	entweder IOFILTPOP1 wenn IO-Filter oder PMFILTPOP1		*/
/*	Ergebnis:	keines															*/
/*	8.11.00 von Dimitri Junker	DYJ 4.18										*/
/*** ------------------------------------------------------------------------ ***/
LOCAL _WORD selFilter(OBJECT *tree,_WORD how,_WORD forObj)
{
	_WORD selS,selU;
	_WORD x, y, w, h,i;
	_WORD maxFilter;
	if(forObj==IOFILTPOP1)
		maxFilter=MAX_IO_FILTER;
	else
		maxFilter=MAX_PM_FILTER;
	selU=VDIUtil_GetXState(tree, forObj);
	if(how<5)
	{
		qsort(FilterPTN,maxFilter,sizeof(*FilterPTN),cmpFilter);
		for(selS=0;selS<maxFilter;selS++)
		{
			if(FilterPTN[selS]->nummer==selU)
				break;
		}
	}
	else
	{
		for(i=0;i<maxFilter;i++)
			FilterPTN[i]=&FilterTN[i];
		selS=selU;
	}
	switch(how)
	{
		case 0:
			selS=(selS + 1) % maxFilter;
			break;
		case K_RSHIFT:
		case K_LSHIFT:
		case K_SHIFT:
			selS=(selS+ maxFilter - 1) % maxFilter;
			break;
		default:
			objc_offset(tree, forObj, &x, &y);
			w = tree[forObj].ob_width;
			h = tree[forObj].ob_height * 10;
			selS = ListDl_ListboxPopup(x, y + tree[forObj].ob_height, w, h,(_UBYTE **) FilterPTN,maxFilter, selS);
	}
/*DYJ  Ende; alt:	
LOCAL _WORD selFilter(OBJECT *tree,_WORD how)
{
	_WORD selS,selU;
	_WORD x, y, w, h,i;
	selU=VDIUtil_GetXState(tree, IOFILTPOP1);
	if(how<5)
	{
		qsort(FilterPTN,MAX_IO_FILTER,sizeof(*FilterPTN),cmpFilter);
		for(selS=0;selS<MAX_IO_FILTER;selS++)
		{
			if(FilterPTN[selS]->nummer==selU)
				break;
		}
	}
	else
	{
		for(i=0;i<MAX_IO_FILTER;i++)
			FilterPTN[i]=&FilterTN[i];
		selS=selU;
	}
	switch(how)
	{
		case 0:
			selS=(selS + 1) % MAX_IO_FILTER;
			break;
		case K_RSHIFT:
		case K_LSHIFT:
		case K_SHIFT:
			selS=(selS+ MAX_IO_FILTER - 1) % MAX_IO_FILTER;
			break;
		default:
			objc_offset(tree, IOFILTPOP1, &x, &y);
			w = tree[IOFILTPOP1].ob_width;
			h = tree[IOFILTPOP1].ob_height * 10;
			selS = ListDl_ListboxPopup(x, y + tree[IOFILTPOP1].ob_height, w, h,(_UBYTE **) FilterPTN,MAX_IO_FILTER, selS);
	}
*/
	if(selS>-1)
		return FilterPTN[selS]->nummer;
	else
		return -1;
}
/*** ---------------------------------------------------------------------- ***/

/*DYJ 5.21b */
LOCAL _BOOL filterButton(OBJECT *tree, _VOID *env, _WORD button, _WORD mx, _WORD my, _UWORD kstate, _WORD clicks)
{
	GRECT r;
	ioInfStruct *ioInfo;
	_WORD typeSel;
	_WORD x, y;
	_UBYTE path[PATH_MAX];
	_UBYTE name[PATH_MAX];
	_UBYTE ext[PATH_MAX];
	OBJECT *filtType;
	_BOOL res;
	UNUSED(mx);
	UNUSED(my);
	UNUSED(clicks);

	ioInfo = env;
	filtType  = TreeAddr[IOTYPE];
	/* Button auswerten */
	button &= 0x7fff;
	switch (button)
	{
	case IOFILTOK:
	case IOFILTQUIT:
		if (button == IOFILTOK)
			getItems(tree, &ioInfo->filter[ioInfo->select]);
		DelObjState(tree, button, SELECTED);
		return TRUE;
	
	case IOFILTHELP:
		CatHelp_DoHelp(CatHelp_iofilter);
		DelObjState(tree, button, SELECTED);
		WinDials_WinDialDraw(tree, button, 1, &r, FALSE);
		break;
		
	case IOFILTPOP0:
	case IOFILTPOP1:
		getItems(tree, &ioInfo->filter[ioInfo->oldSelect]);
		setFiltTypName(ioInfo->filter,ioInfo->oldSelect,NULL);
		ioInfo->select = selFilter(tree,4|(kstate& K_SHIFT),IOFILTPOP1);
		if (ioInfo->select >= 0)
		{
			VDIUtil_SetXState(tree, IOFILTPOP1, ioInfo->select);
			SetObjcString(tree, IOFILTPOP1, FilterTN[ioInfo->select].typName);
			setItems(tree, filtType, &ioInfo->filter[ioInfo->select]);
			WinDials_WinDialDraw(tree, ROOT, MAX_DEPTH, &r, FALSE);
			ioInfo->oldSelect = ioInfo->select;
		} else
		{
			ioInfo->select = ioInfo->oldSelect;
		}
		break;
	case IOFILTPOP2:
		getItems(tree, &ioInfo->filter[ioInfo->oldSelect]);
		ioInfo->select = selFilter(tree,kstate& K_SHIFT,IOFILTPOP1);
		VDIUtil_SetXState(tree, IOFILTPOP1, ioInfo->select);
		setFiltTypName(ioInfo->filter,ioInfo->oldSelect,NULL);
		SetObjcString(tree, IOFILTPOP1, FilterTN[ioInfo->select].typName);
		setItems(tree, filtType, &ioInfo->filter[ioInfo->select]);
		ioInfo->oldSelect = ioInfo->select;
		WinDials_WinDialDraw(tree, ROOT, MAX_DEPTH, &r, FALSE);
		break;
		
	case IOFILTSEL0:
	case IOFILTSEL:
		/* Neues Programm auswaehlen */
		if (ioInfo->filter[ioInfo->oldSelect].progName[0] != '\0')
		{
			mtDir_SplitPath(ioInfo->filter[ioInfo->oldSelect].progName, path, name, ext);
		} else
		{
			CatGlobal_ApplPath(path);
			*name = '\0';
		}
		res = mtDir_FselGet(path, name, ALL_FILE_MASK, MausTauschrsc_WrkString(FS_SELECT_FILTER), TRUE);
		/* mtDials_DialForm(tree, DENABLE, &r, &r);  */
		if (res)
		{
			if (name[0] != '\0')
			{
				strBcpy(ioInfo->filter[ioInfo->oldSelect].progName, path);
				F_Path_Append(ioInfo->filter[ioInfo->oldSelect].progName, name);
				SetObjcString(tree, IOFILTSEL, name);
				strInsertChar(' ', name, sizeof(name));
				strMcpy(FilterTN[ioInfo->oldSelect].typName+4,IO_FILTER_STRLEN,name);
				ioInfo->filter[ioInfo->oldSelect].pass = 5;
			} else
			{
				ioInfo->filter[ioInfo->oldSelect].progName[0] = '\0';
				strMcpy(FilterTN[ioInfo->oldSelect].typName,IO_FILTER_STRLEN+5,MausTauschrsc_WrkString(FS_NOT_INSTALLED));
				ioInfo->filter[ioInfo->oldSelect].pass = 0;
				setItems(tree, filtType, &ioInfo->filter[ioInfo->oldSelect]);
			}
			SetObjcString(tree, IOFILTPOP1, FilterTN[ioInfo->select].typName);
			WinDials_WinDialDraw(tree, IOFILTPOP1, 1, &r, FALSE);
			WinDials_WinDialDraw(tree, IOFILTSEL, 1, &r, FALSE);
		}
		DelObjState(tree, button, SELECTED);
		WinDials_WinDialDraw(tree, button, 1, &r, FALSE);
		break;
	
	case IOFILTTYPE0:
	case IOFILTTYPE1:
		objc_offset(tree, IOFILTTYPE1, &x, &y);
		typeSel = mtPopups_TreePopup(filtType, x, y, VDIUtil_GetXState(tree, IOFILTTYPE1)) - 1;
		if (typeSel >= 0)
		{
			VDIUtil_SetXState(tree, IOFILTTYPE1, typeSel);
			ioInfo->filter[ioInfo->oldSelect].filtType=getFiltType(tree);
			setItems(tree, filtType, &ioInfo->filter[ioInfo->oldSelect]);
			setFiltTypName(ioInfo->filter,ioInfo->oldSelect,tree);
			WinDials_WinDialDraw(tree, IOFILTPOP1, 1, &r, FALSE);
			CalcArea(tree, IOFILTBACK, &r);
			WinDials_WinDialDraw(tree, ROOT, MAX_DEPTH, &r, TRUE);
		}
		break;
		
	case IOFILTTYPE2:
		typeSel = VDIUtil_GetXState(tree, IOFILTTYPE1);
		if(kstate& K_SHIFT)
			typeSel = (typeSel + 2) % 3;
		else
			typeSel = (typeSel + 1) % 3;
		VDIUtil_SetXState(tree, IOFILTTYPE1, typeSel);
		ioInfo->filter[ioInfo->oldSelect].filtType=getFiltType(tree);
		setItems(tree, filtType, &ioInfo->filter[ioInfo->oldSelect]);
		/*
		VDIUtil_SetXString(tree, IOFILTTYPE1, filtType, typeSel);
		*/
		setFiltTypName(ioInfo->filter,ioInfo->oldSelect,tree);
		WinDials_WinDialDraw(tree, IOFILTPOP1, 1, &r, FALSE);
		CalcArea(tree, IOFILTBACK, &r);
		WinDials_WinDialDraw(tree, ROOT, MAX_DEPTH, &r, TRUE);
		break;
	case IOINFILE:
	case IOOUTFILE:
		if(GetObjState(tree, IOINFILE, SELECTED))
		{
			if(GetObjState(tree, IOOUTFILE, SELECTED))
				ioInfo->filter[ioInfo->oldSelect].filtType=ForIO;
			else
				ioInfo->filter[ioInfo->oldSelect].filtType=ForInfile;
		}
		else
		{
			if(GetObjState(tree, IOOUTFILE, SELECTED))
				ioInfo->filter[ioInfo->oldSelect].filtType=ForOutfile;
			else
			{
				if(button==IOINFILE)	/* Das wurde wohl gerade gelscht ->anderes setzen	*/
				{
					ioInfo->filter[ioInfo->oldSelect].filtType=ForOutfile;
					SetObjState(tree, IOOUTFILE, SELECTED);
				}
				else
				{
					ioInfo->filter[ioInfo->oldSelect].filtType=ForInfile;
					SetObjState(tree, IOINFILE, SELECTED);
				}
			}
		}
		setFiltTypName(ioInfo->filter,ioInfo->oldSelect,tree);
		WinDials_WinDialDraw(tree, IOFILTPOP1, 1, &r, FALSE);
		CalcArea(tree, IOFILTBACK, &r);
		WinDials_WinDialDraw(tree, ROOT, MAX_DEPTH, &r, TRUE);
		break;
	}
	return FALSE;
}
/*** ------------------------------------------------------------------------ ***/
/*	_BOOL selGroup(OBJECT *tree,CONST pmFilterStruct *filter)					*/
/*	Whlt die Gruppe aus in die die PM verschoben werden soll					*/
/*	Parameter:	tree:	Das Objekt												*/
/*				filter:	der alte Zustand										*/
/*	Ergebnis:	OK?																*/		
/*	2.12.01 von Dimitri Junker	DYJ 4.30zk										*/
/*** ------------------------------------------------------------------------ ***/

LOCAL _BOOL selGroup(OBJECT *tree,CONST pmFilterStruct *filter)
{
	CAT_GROUP_NUMBER newGroup;

	if (ListHelp_SelectGroup(filter->gruppe, sizeof(filter->gruppe), &newGroup, TRUE, FALSE, FALSE, gsmPMFilt))
	{
		SetObjcString(tree, PMFILTGRUPPE, filter->gruppe);
		return TRUE;
	}
	return FALSE;
}
/*** ------------------------------------------------------------------------ ***/
/*	_VOID CheckFlag(_UBYTE ch, MSGBITS bit, MSGBITS *setBits, MSGBITS *clearBits)	*/
/*	Prft ob das Flag klein oder gro ist und setzt entspr. setBit oder clearBit*/
/*	Parameter:	ch:		der Buchstabe											*/
/*				bit:	zu setzendes Bit										*/
/*				setBits,clearBits:	dort Bit setzen								*/
/*	Ergebnis:	keines															*/		
/*	3.8.02 von Dimitri Junker	DYJ 4.41m										*/
/*** ------------------------------------------------------------------------ ***/
LOCAL _VOID CheckFlag(_UBYTE ch, MSGBITS bit, MSGBITS *setBits, MSGBITS *clearBits)
{
	if (ch == ucase(ch))
		*setBits |= bit;
	else
		*clearBits |=bit;
}

/*** ------------------------------------------------------------------------ ***/
/*	_VOID CatOpts2_CheckFlagLine(CONST _UBYTE *str, MSGBITS *setBits, MSGBITS *clearBits)*/
/*	wandelt eine Flagline in setBits und clearBits								*/
/*	Parameter:	str:	die Flagline											*/
/*				setBits,clearBits:	dort Bits setzen							*/
/*	Ergebnis:	keines															*/		
/*	3.8.02 von Dimitri Junker	DYJ 4.41m										*/
/*** ------------------------------------------------------------------------ ***/
/*DYJ 5.38b Start*/
GLOBAL _VOID CatOpts2_CheckFlagLine(CONST _UBYTE *str, MSGBITS *setBits, MSGBITS *clearBits)
/*DYJ  Ende; alt:	
LOCAL _VOID CheckFlagLine(CONST _UBYTE *str, MSGBITS *setBits, MSGBITS *clearBits)
*/
{
	*setBits=*clearBits=0;
	while (*str >= ' ') /* ??? */
	{
		switch (ucase(*str))
		{
			case 'B': CheckFlag(*str, bAntworten, setBits,clearBits); break;
			case 'C': CheckFlag(*str, bUser1, setBits,clearBits); break;
			case 'T': CheckFlag(*str, bTeilloeschung, setBits,clearBits); break;
			case 'I': CheckFlag(*str, bInteressant, setBits,clearBits); break;
			case 'L': CheckFlag(*str, bGelesen, setBits,clearBits); break;
			case 'K': CheckFlag(*str, bKommentieren, setBits,clearBits); break;
			case 'F': CheckFlag(*str, bFiltered, setBits,clearBits); break;
			case 'X': CheckFlag(*str, bUser2, setBits,clearBits); break;
			case 'V': CheckFlag(*str, bVererben, setBits,clearBits); break;
			case 'D': CheckFlag(*str, bTotalloeschung, setBits,clearBits); break;
			case 'O': CheckFlag(*str, bOwnMessage, setBits,clearBits); break;
		}
		str++;
	}
}
/*** ------------------------------------------------------------------------ ***/
/*	_UBYTE *SetFlag( _UBYTE flagChar,_UBYTE *str, MSGBITS bit, MSGBITS setBits,MSGBITS clearBits)	*/
/*	Fgt einen Buchstaben an die Flagline an									*/
/*	Parameter:	flagChar:	Grobuchstabe, der ggf an die Flagline angefgt werden soll*/
/*				str:		Ende der Flagline									*/
/*				bit:		zu testendes Bit									*/
/*				setBits,clearBits												*/
/*	Ergebnis:	neues Ende der Flagline											*/		
/*	3.8.02 von Dimitri Junker	DYJ 4.41m										*/
/*** ------------------------------------------------------------------------ ***/
LOCAL _UBYTE *SetFlag( _UBYTE flagChar,_UBYTE *str, MSGBITS bit, MSGBITS setBits,MSGBITS clearBits)
{
	if(bit&setBits)
		*(str++)=flagChar;
	else if(bit&clearBits)
		*(str++)=lcase(flagChar);
	return str;
}
/*** ------------------------------------------------------------------------ ***/
/*	_VOID SetFlagLine(_UBYTE *str, MSGBITS setBits, MSGBITS clearBits)			*/
/*	bastelt eine Flagline entsprechend der setBits und clearBits zusammen		*/
/*	Parameter:	str:	die Flagline											*/
/*				setBits,clearBits												*/
/*	Ergebnis:	keines															*/		
/*	3.8.02 von Dimitri Junker	DYJ 4.41m										*/
/*** ------------------------------------------------------------------------ ***/
LOCAL _VOID SetFlagLine(_UBYTE *str, MSGBITS setBits, MSGBITS clearBits)
{
	str=SetFlag( 'B',str, bAntworten, setBits,clearBits);
	str=SetFlag( 'C',str, bUser1, setBits,clearBits);
	str=SetFlag( 'T',str, bTeilloeschung, setBits,clearBits);
	str=SetFlag( 'I',str, bInteressant, setBits,clearBits);
	str=SetFlag( 'L',str, bGelesen, setBits,clearBits);
	str=SetFlag( 'K',str, bKommentieren, setBits,clearBits);
	str=SetFlag( 'F',str, bFiltered, setBits,clearBits);
	str=SetFlag( 'X',str, bUser2, setBits,clearBits);
	str=SetFlag( 'V',str, bVererben, setBits,clearBits);
	str=SetFlag( 'D',str, bTotalloeschung, setBits,clearBits);
	str=SetFlag( 'O',str, bOwnMessage, setBits,clearBits);
}
/*** ------------------------------------------------------------------------ ***/
/*	_BOOL selFlags(OBJECT *tree,CONST pmFilterStruct *filter)					*/
/*	Stellt Flag-Formular dar und wertet es aus									*/
/*	Parameter:	tree:	PM-Formular												*/
/*				filter:	der aktuelle PM-Filter									*/
/*	Ergebnis:	erfolgreich?													*/		
/*	3.8.02 von Dimitri Junker	DYJ 4.41m										*/
/*** ------------------------------------------------------------------------ ***/
LOCAL _BOOL selFlags(OBJECT *tree,CONST pmFilterStruct *filter)
{
	DialActionSet actSet=ChangeSelected;
	DialAction action=ChangeSelected;
	MSGBITS setBits, clearBits;
/*DYJ 5.38b Start*/
	CatOpts2_CheckFlagLine(filter->flags, &setBits, &clearBits);
/*DYJ  Ende; alt:	
	CheckFlagLine(filter->flags, &setBits, &clearBits);
*/
	if (ZSearchDial_FlagDial(actSet, &setBits, &clearBits, &action))
	{
		SetFlagLine(filter->flags, setBits, clearBits);
		SetObjcString(tree, PMFILTGRUPPE, filter->flags);
		return TRUE;
	}
	return FALSE;
}

/*** ------------------------------------------------------------------------ ***/
/*	_BOOL pmFilterButton(OBJECT *tree, _VOID *env, _WORD button, _WORD mx, _WORD my, _UWORD kstate, _WORD clicks)	*/
/*	wie das vorige, aber fr PM-Filter											*/
/*	26.11.01 von Dimitri Junker	DYJ 4.30zk										*/
/*** ------------------------------------------------------------------------ ***/
/*DYJ 5.20n */
LOCAL _BOOL pmFilterButton(OBJECT *tree, _VOID *env, _WORD button, _WORD mx, _WORD my, _UWORD kstate, _WORD clicks)
{
	GRECT r;
	pmInfStruct *pmInfo;
	_WORD typeSel;
	_WORD x, y;
	OBJECT *filtType;
	UNUSED(mx);
	UNUSED(my);
	UNUSED(clicks);

	pmInfo = env;
	filtType  = TreeAddr[PMTYPE];
	/* Button auswerten */
	button &= 0x7fff;
	switch (button)
	{
	case PMFILTOK:
	case PMFILTQUIT:
		if (button == PMFILTOK)
			pmGetItems(tree, &pmInfo->filter[pmInfo->select]);
		DelObjState(tree, button, SELECTED);
		return TRUE;
	
	case PMFILTHELP:
		CatHelp_DoHelp(CatHelp_pmfilter);
		DelObjState(tree, button, SELECTED);
		WinDials_WinDialDraw(tree, button, 1, &r, FALSE);
		break;
		
	case PMFILTPOP0:
	case PMFILTPOP1:
		pmGetItems(tree, &pmInfo->filter[pmInfo->oldSelect]);
		setPmFiltTypName(pmInfo->filter,pmInfo->oldSelect,NULL);
		pmInfo->select = selFilter(tree,4|(kstate& K_SHIFT),PMFILTPOP1);
		if (pmInfo->select >= 0)
		{
			VDIUtil_SetXState(tree, PMFILTPOP1, pmInfo->select);
			SetObjcString(tree, PMFILTPOP1, FilterTN[pmInfo->select].typName);
			pmSetItems(tree, filtType, &pmInfo->filter[pmInfo->select]);
			WinDials_WinDialDraw(tree, ROOT, MAX_DEPTH, &r, FALSE);
			pmInfo->oldSelect = pmInfo->select;
		} else
		{
			pmInfo->select = pmInfo->oldSelect;
		}
		break;
	case PMFILTPOP2:
		pmGetItems(tree, &pmInfo->filter[pmInfo->oldSelect]);
		pmInfo->select = selFilter(tree,kstate& K_SHIFT,PMFILTPOP1);
		VDIUtil_SetXState(tree, PMFILTPOP1, pmInfo->select);
		setPmFiltTypName(pmInfo->filter,pmInfo->oldSelect,NULL);
		SetObjcString(tree, PMFILTPOP1, FilterTN[pmInfo->select].typName);
		pmSetItems(tree, filtType, &pmInfo->filter[pmInfo->select]);
		pmInfo->oldSelect = pmInfo->select;
		WinDials_WinDialDraw(tree, ROOT, MAX_DEPTH, &r, FALSE);
		break;
		
	case PMFILTTYPE0:
	case PMFILTTYPE1:
		objc_offset(tree, PMFILTTYPE1, &x, &y);
		typeSel = mtPopups_TreePopup(filtType, x, y, VDIUtil_GetXState(tree, PMFILTTYPE1)) - 1;
		if (typeSel >= 0)
		{
			VDIUtil_SetXState(tree, PMFILTTYPE1, typeSel);
			pmInfo->filter[pmInfo->oldSelect].pmfType=getPmFiltType(tree);
			pmSetItems(tree, filtType, &pmInfo->filter[pmInfo->oldSelect]);
			setPmFiltTypName(pmInfo->filter,pmInfo->oldSelect,tree);
			WinDials_WinDialDraw(tree, PMFILTPOP1, 1, &r, FALSE);
			CalcArea(tree, PMFILTBACK, &r);
			WinDials_WinDialDraw(tree, ROOT, MAX_DEPTH, &r, TRUE);
		}
		break;
		
	case PMFILTTYPE2:
		typeSel = VDIUtil_GetXState(tree, PMFILTTYPE1);
		if(kstate& K_SHIFT)
/*DYJ 5.35e Start*/
			typeSel = (typeSel + 5) % 6;
		else
			typeSel = (typeSel + 1) % 6;
/*DYJ  Ende; alt:	
			typeSel = (typeSel + 4) % 5;
		else
			typeSel = (typeSel + 1) % 5;
*/
		VDIUtil_SetXState(tree, PMFILTTYPE1, typeSel);
		pmInfo->filter[pmInfo->oldSelect].pmfType=getPmFiltType(tree);
		pmSetItems(tree, filtType, &pmInfo->filter[pmInfo->oldSelect]);
		/*
		VDIUtil_SetXString(tree, PMFILTTYPE1, filtType, typeSel);
		*/
		setPmFiltTypName(pmInfo->filter,pmInfo->oldSelect,tree);
		WinDials_WinDialDraw(tree, PMFILTPOP1, 1, &r, FALSE);
		CalcArea(tree, PMFILTBACK, &r);
		WinDials_WinDialDraw(tree, ROOT, MAX_DEPTH, &r, TRUE);
		break;
	case PMFILTGR:
		SetObjcString(tree, PMFILTGRUPPE, pmInfo->filter[pmInfo->oldSelect].gruppe);
		pmInfo->filter[pmInfo->oldSelect].pmfAktType=PMA_GROUP;
		EnableObjFlags(tree, PMFILTGRTXT, HIDETREE, FALSE);
		EnableObjFlags(tree, PMFILTFLTXT, HIDETREE, TRUE);
		EnableObjFlags(tree, PMFILTGRUPPE, HIDETREE, FALSE);
		CalcArea(tree, PMFILTBACK, &r);
		WinDials_WinDialDraw(tree, ROOT, MAX_DEPTH, &r, TRUE);
		break;
	case PMFILTFL:
		SetObjcString(tree, PMFILTGRUPPE, pmInfo->filter[pmInfo->oldSelect].flags);
		pmInfo->filter[pmInfo->oldSelect].pmfAktType=PMA_FLAGS;
		EnableObjFlags(tree, PMFILTGRTXT, HIDETREE, TRUE);
		EnableObjFlags(tree, PMFILTFLTXT, HIDETREE, FALSE);
		EnableObjFlags(tree, PMFILTGRUPPE, HIDETREE, FALSE);
		CalcArea(tree, PMFILTBACK, &r);
		WinDials_WinDialDraw(tree, ROOT, MAX_DEPTH, &r, TRUE);
		break;
	case PMFILTDEL:
		pmInfo->filter[pmInfo->oldSelect].pmfAktType=PMA_DELETE;
		EnableObjFlags(tree, PMFILTGRTXT, HIDETREE, TRUE);
		EnableObjFlags(tree, PMFILTFLTXT, HIDETREE, TRUE);
		EnableObjFlags(tree, PMFILTGRUPPE, HIDETREE, TRUE);
		CalcArea(tree, PMFILTBACK, &r);
		WinDials_WinDialDraw(tree, ROOT, MAX_DEPTH, &r, TRUE);
		break;
	case PMFILTGRUPPE: /* Zielgruppe auswaehlen und setzen */
		if(pmInfo->filter[pmInfo->oldSelect].pmfAktType==PMA_GROUP)
			selGroup(tree, &pmInfo->filter[pmInfo->oldSelect]);
		else
			selFlags(tree, &pmInfo->filter[pmInfo->oldSelect]);
		CalcArea(tree, PMFILTGRUPPE, &r);
		DelObjState(tree, button, SELECTED);
		WinDials_WinDialDraw(tree, ROOT, MAX_DEPTH, &r, TRUE);
		break;

	}
	return FALSE;
}
/*** ------------------------------------------------------------------------ ***/
/*	LOCAL _BOOL cbcButton(OBJECT *tree, _VOID *env, _WORD button, _WORD mx, _WORD my, _UWORD kstate, _WORD clicks)	*/
/*	Reagiert auf Aktionen im CBC-Dialog											*/
/*	Parameter:	tree:	das Formular											*/
/*				env, mx, my, und clicks: unbenutzt								*/
/*				button:	gedrckter Knopf										*/
/*				kstate:	Umschalttasten											*/
/*	Ergebnis:	TRUE wenn Formular geschlossen werden soll						*/		
/*	29.10.01 von Dimitri Junker	DYJ 4.30p										*/
/*** ------------------------------------------------------------------------ ***/
/*DYJ 5.21b */
LOCAL _BOOL cbcButton(OBJECT *tree, _VOID *env, _WORD button, _WORD mx, _WORD my, _UWORD kstate, _WORD clicks)
{
	GRECT r;
	_WORD typeSel,ab=0;
	_WORD x, y,select,i;
	_BOOL ret=TRUE;
	_UBYTE *zeitenV[]={" 00h00"," 01h00"," 02h00"," 03h00"," 04h00"," 05h00"," 06h00"," 07h00"," 08h00"," 09h00",
					   " 10h00"," 11h00"," 12h00"," 13h00"," 14h00"," 15h00"," 16h00"," 17h00"," 18h00"," 19h00",
					   " 20h00"," 21h00"," 22h00"," 23h00"};
	_UBYTE *zeitenB[]={" 00h59"," 01h59"," 02h59"," 03h59"," 04h59"," 05h59"," 06h59"," 07h59"," 08h59"," 09h59",
					   " 10h59"," 11h59"," 12h59"," 13h59"," 14h59"," 15h59"," 16h59"," 17h59"," 18h59"," 19h59",
					   " 20h59"," 21h59"," 22h59"," 23h59"},**zeiten=zeitenV;
	int cbcday1[]={CBCDAY1_00,CBCDAY1_01,CBCDAY1_02,CBCDAY1_03,CBCDAY1_04,CBCDAY1_05,CBCDAY1_06};
	int cbcvon1[]={CBCVON1_00,CBCVON1_01,CBCVON1_02,CBCVON1_03,CBCVON1_04,CBCVON1_05,CBCVON1_06};
	int cbcbis1[]={CBCBIS1_00,CBCBIS1_01,CBCBIS1_02,CBCBIS1_03,CBCBIS1_04,CBCBIS1_05,CBCBIS1_06};
	OBJECT *telDays;
	UNUSED(mx);
	UNUSED(my);
	UNUSED(clicks);
	UNUSED(env);

	telDays  = TreeAddr[CBC_DAYS];
	/* Button auswerten */
	button &= 0x7fff;
	switch (button)
	{
	case CBCREGOK:
		for (i = 0; i < MAX_CBC_REG; i++)
		{
			if(VDIUtil_GetXState(tree, cbcday1[i])!=CBC_UNBENUTZT &&
				VDIUtil_GetXState(tree, cbcvon1[i])>VDIUtil_GetXState(tree, cbcbis1[i]))
			{
				ret=FALSE;
				MTE_infoRSC(AL_NEG_TIME);
				break;
			}
		}
	case CBCREGQUIT:
		DelObjState(tree, button, SELECTED);
		return ret;
	
	case CBCREGHELP:
		CatHelp_DoHelp(CatHelp_cbcregel);
		DelObjState(tree, button, SELECTED);
		WinDials_WinDialDraw(tree, button, 1, &r, FALSE);
		break;
		
	case CBCDAY1_00:
	case CBCDAY1_01:
	case CBCDAY1_02:
	case CBCDAY1_03:
	case CBCDAY1_04:
	case CBCDAY1_05:
	case CBCDAY1_06:
		objc_offset(tree, button, &x, &y);
		select = mtPopups_TreePopup(telDays, x, y, VDIUtil_GetXState(tree, button)) - 1;
		if (select >= 0)
		{
			VDIUtil_SetXState(tree, button, select);
			VDIUtil_SetXString(tree, button, telDays, select);
			WinDials_WinDialDraw(tree, button, 0, &r, FALSE);
		}
		break;
	case CBCDAY2_00:
	case CBCDAY2_01:
	case CBCDAY2_02:
	case CBCDAY2_03:
	case CBCDAY2_04:
	case CBCDAY2_05:
	case CBCDAY2_06:
		select = VDIUtil_GetXState(tree, button-1);
		if(kstate&K_SHIFT)
			select = (select + 13) % 14;
		else
			select = (select + 1) % 14;
		VDIUtil_SetXState(tree, button-1, select);
		VDIUtil_SetXString(tree, button-1, telDays, select);
		WinDials_WinDialDraw(tree, button-1, 0, &r, FALSE);
		break;
	case CBCBIS1_00:
	case CBCBIS1_01:
	case CBCBIS1_02:
	case CBCBIS1_03:
	case CBCBIS1_04:
	case CBCBIS1_05:
	case CBCBIS1_06:
		zeiten=zeitenB;
		ab = VDIUtil_GetXState(tree, button-3);
	case CBCVON1_00:
	case CBCVON1_01:
	case CBCVON1_02:
	case CBCVON1_03:
	case CBCVON1_04:
	case CBCVON1_05:
	case CBCVON1_06:
		objc_offset(tree, button, &x, &y);
		{
			_WORD w, h;
			
			w = tree[button].ob_width;
			h = tree[button].ob_height * 10;
			typeSel = ListDl_ListboxPopup(x, y + tree[button].ob_height, w, h, &zeiten[ab], 24-ab, Max(0,VDIUtil_GetXState(tree, button)-ab))+ab;
		}
		if (typeSel >= 0)
		{
			VDIUtil_SetXState(tree, button, typeSel);
			SetObjcString(tree, button, zeiten[typeSel]+1);
			DelObjState(tree, button,CROSSED);
			WinDials_WinDialDraw(tree, button, 1, &r, FALSE);
			if(zeiten==zeitenV)
			{
				if(typeSel>VDIUtil_GetXState(tree, button+3))
					SetObjState(tree, button+3,CROSSED);
				else
					DelObjState(tree, button+3,CROSSED);
				WinDials_WinDialDraw(tree, button+3, 1, &r, FALSE);
			}
		}
		break;
	case CBCBIS2_00:
	case CBCBIS2_01:
	case CBCBIS2_02:
	case CBCBIS2_03:
	case CBCBIS2_04:
	case CBCBIS2_05:
	case CBCBIS2_06:
		zeiten=zeitenB;
		ab = VDIUtil_GetXState(tree, button-4);
	case CBCVON2_00:
	case CBCVON2_01:
	case CBCVON2_02:
	case CBCVON2_03:
	case CBCVON2_04:
	case CBCVON2_05:
	case CBCVON2_06:
		typeSel = Max(VDIUtil_GetXState(tree, button-1),ab);
		if(kstate&K_SHIFT)
			typeSel = ab+(typeSel+23-ab-ab)%(24-ab);
		else
			typeSel = ab+(typeSel+1-ab)%(24-ab);
		VDIUtil_SetXState(tree, button-1, typeSel);
		SetObjcString(tree, button-1, zeiten[typeSel]+1);
		DelObjState(tree, button-1,CROSSED);
		WinDials_WinDialDraw(tree, button-1, 1, &r, FALSE);
		if(zeiten==zeitenV)
		{
			if(typeSel>VDIUtil_GetXState(tree, button+2))
				SetObjState(tree, button+2,CROSSED);
			else
				DelObjState(tree, button+2,CROSSED);
			WinDials_WinDialDraw(tree, button+2, 1, &r, FALSE);
		}
		break;
	}
	return FALSE;
}
/*** ---------------------------------------------------------------------- ***/
/*DYJ 5.21b */
LOCAL _VOID filterGetSetValues(OBJECT *tree, _VOID *env, _BOOL set, _WORD exit)
{
	ioInfStruct *ioInfo;
	_WORD i;
	OBJECT *filtType;
	_UBYTE varname[128];
	ioInfo = env;
	filtType = TreeAddr[IOTYPE];
	exit &= 0x7fff;
	if (set)
	{
		/* Strings einsetzen */
		for (i = 0; i < MAX_IO_FILTER; i++)
		{
			/* Array fuellen
			 */
			make_varname(varname, sizeof(varname), cIoFilterProgram, i + 1);
			if (ConfVars_GetConfigString(varname, ioInfo->filter[i].progName, sizeof(ioInfo->filter[i].progName)))
			{
				IoFilter_ReadFilter(&ioInfo->filter[i], i + 1);
				setFiltTypName(ioInfo->filter,i,NULL);
			} else
			{
				ioInfo->filter[i].filtType = PastOutfile;	/* egal irgendwas*/
				ioInfo->filter[i].pass  = 0;
				ioInfo->filter[i].stopAtErr = FALSE;
				strMcpy(FilterTN[i].typName,IO_FILTER_STRLEN+5,MausTauschrsc_WrkString(FS_NOT_INSTALLED));
			}
		}
		ioInfo->select = 0;
		ioInfo->oldSelect = ioInfo->select;
		setItems(tree, filtType, &ioInfo->filter[ioInfo->select]);
		/* vorbereiten */
		VDIUtil_SetXState(tree, IOFILTPOP1, ioInfo->select);
		SetObjcString(tree, IOFILTPOP1, FilterTN[ioInfo->select].typName);
	} else
	{
		if (exit == IOFILTOK)
		{
			for (i = 0; i < MAX_IO_FILTER; i++)
				IoFilter_WriteFilter(&ioInfo->filter[i], i + 1);
		}
		OFREE(ioInfo);
	}
}
/*** ------------------------------------------------------------------------ ***/
/*	_VOID pmFilterGetSetValues(OBJECT *tree, _VOID *env, _BOOL set, _WORD exit)	*/
/*	wie das vorige, aber fr PM-Filter											*/
/*	26.11.01 von Dimitri Junker	DYJ 4.30zk										*/
/*** ------------------------------------------------------------------------ ***/
/*DYJ 5.21b */
LOCAL _VOID pmFilterGetSetValues(OBJECT *tree, _VOID *env, _BOOL set, _WORD exit)
{
	pmInfStruct *pmInfo;
	_WORD i;
	OBJECT *filtType;
	_UBYTE varname[128];
	pmInfo = env;
	filtType = TreeAddr[PMTYPE];
	exit &= 0x7fff;
	if (set)
	{
		/* Strings einsetzen */
		for (i = 0; i < MAX_PM_FILTER; i++)
		{
			/* Array fuellen
			 */
			make_varname(varname, sizeof(varname), cPmFilterSuchStr, i + 1);
			if (ConfVars_GetConfigString(varname, pmInfo->filter[i].suchStr,sizeof(pmInfo->filter[i].suchStr)))
			{
				PmFilter_ReadFilter(&pmInfo->filter[i], i + 1);
				setPmFiltTypName(pmInfo->filter,i,NULL);
			} else
			{
				pmInfo->filter[i].pmfType = ForSend;	/* egal irgendwas*/
				pmInfo->filter[i].prio  = 0;
				strMcpy(FilterTN[i].typName,PM_FILTER_STRLEN+5,MausTauschrsc_WrkString(FS_NOT_INSTALLED));
			}
		}
		pmInfo->select = 0;
		pmInfo->oldSelect = pmInfo->select;
		pmSetItems(tree, filtType, &pmInfo->filter[pmInfo->select]);
		/* vorbereiten */
		VDIUtil_SetXState(tree, PMFILTPOP1, pmInfo->select);
		SetObjcString(tree, PMFILTPOP1, FilterTN[pmInfo->select].typName);
	} else
	{
		if (exit == PMFILTOK)
		{
			for (i = 0; i < MAX_PM_FILTER; i++)
				PmFilter_WriteFilter(&pmInfo->filter[i], i + 1);
		}
		OFREE(pmInfo);
	}
}
/*** ------------------------------------------------------------------------ ***/
/*	GLOBAL _WORD CatOpts2_GetCbC(_WORD nummer,_WORD *von,_WORD *bis,_UBYTE *vvWahl,size_t size)	*/
/*	Liest die CBC Optionen														*/
/*	Parameter:	nummer:	Nummer der zu lesenden Regel,							*/
/*,				von:	Hier wird die Startzeit zurckgegeben					*/
/*				bis:	Hier wird die Endzeit zurckgegeben						*/
/*				vvWahl:	Hier wird die Vorvorwahl zurckgegeben					*/
/*				size:	Lnge von vvWahl										*/
/*	Ergebnis:	Tage fr die die Regel gilt.									*/		
/*	29.10.01 von Dimitri Junker	DYJ 4.30p										*/
/*** ------------------------------------------------------------------------ ***/
GLOBAL _WORD CatOpts2_GetCbC(_WORD nummer,_WORD *von,_WORD *bis,_UBYTE *vvWahl,size_t size)
{
	_UBYTE varname[128];
	_WORD days;
	if(nummer >=0 && nummer<MAX_CBC_REG)
	{
		make_varname(varname, sizeof(varname), cCbcDays, nummer + 1);
		ConfVars_GetConfDefInt(varname, &days,CBC_UNBENUTZT);
		
		make_varname(varname, sizeof(varname), cCbcFrom, nummer + 1);
		ConfVars_GetConfDefInt(varname, von,0);

		make_varname(varname, sizeof(varname), cCbcUntil, nummer + 1);
		ConfVars_GetConfDefInt(varname, bis,23);

		make_varname(varname, sizeof(varname), cCbcNumber, nummer + 1);
		ConfVars_GetConfDefStr(varname, vvWahl, size,"");
	}
	else if(nummer==MAX_CBC_REG)
	{
		days=TAEGL;
		*von=0;
		*bis=24;
		ConfVars_GetConfDefStr(cCbcNumberDef, vvWahl, size,"");
	}
	else
	{
		days=CBC_UNBENUTZT;
		*von=0;
		*bis=24;
		*vvWahl='\0';
	}
	return days;

}
/*** ------------------------------------------------------------------------ ***/
/*	LOCAL _VOID cbcGetSetValues(OBJECT *tree, _VOID *env, _BOOL set, _WORD exit)*/
/*	Setzt bzw. liest die Daten ins/aus dem Formular								*/
/*	Parameter:	tree:	das Formular											*/
/*				env:	unbenutzt, ist NULL										*/
/*				set:	Setzen oder lesen?										*/
/*				exit:	Objekt mit dem das Formular verlassen wurde				*/
/*	Ergebnis:	keines															*/		
/*	29.10.01 von Dimitri Junker	DYJ 4.30p										*/
/*** ------------------------------------------------------------------------ ***/
LOCAL _VOID cbcGetSetValues(OBJECT *tree, _VOID *env, _BOOL set, _WORD exit)
{
	_WORD i,intVal,von,bis,days;
	OBJECT *cbcDayPop;
	_UBYTE varname[128],vvWahl[20];
	int cbcday1[]={CBCDAY1_00,CBCDAY1_01,CBCDAY1_02,CBCDAY1_03,CBCDAY1_04,CBCDAY1_05,CBCDAY1_06};
	int cbcvon1[]={CBCVON1_00,CBCVON1_01,CBCVON1_02,CBCVON1_03,CBCVON1_04,CBCVON1_05,CBCVON1_06};
	int cbcbis1[]={CBCBIS1_00,CBCBIS1_01,CBCBIS1_02,CBCBIS1_03,CBCBIS1_04,CBCBIS1_05,CBCBIS1_06};
	int cbcvvw1[]={VVWAHL_00,VVWAHL_01,VVWAHL_02,VVWAHL_03,VVWAHL_04,VVWAHL_05,VVWAHL_06,VVWAHL_07};


	UNUSED(env);
	cbcDayPop = TreeAddr[CBC_DAYS];
	exit &= 0x7fff;
	if (set)
	{
		/* Strings einsetzen */
		for (i = 0; i < MAX_CBC_REG; i++)
		{
			days=CatOpts2_GetCbC(i,&von,&bis,vvWahl,sizeof(vvWahl));
			VDIUtil_SetXState(tree, cbcday1[i], days);
			VDIUtil_SetXString(tree, cbcday1[i], cbcDayPop, days);
			
			VDIUtil_SetXState(tree, cbcvon1[i], von);
			sprintf(varname,"%.2dh00",von);
			SetObjcString(tree, cbcvon1[i], varname);

			VDIUtil_SetXState(tree, cbcbis1[i], bis);
			sprintf(varname,"%.2dh59",bis);
			SetObjcString(tree, cbcbis1[i], varname);

			SetObjcString(tree, cbcvvw1[i], vvWahl);
		}
		CatOpts2_GetCbC(MAX_CBC_REG,&von,&bis,vvWahl,sizeof(vvWahl));
		SetObjcString(tree, cbcvvw1[MAX_CBC_REG], vvWahl);
	}
	else if (exit == CBCREGOK)
	{
		for (i = 0; i < MAX_CBC_REG; i++)
		{
			make_varname(varname, sizeof(varname), cCbcDays, i + 1);
			intVal=VDIUtil_GetXState(tree, cbcday1[i]);
			if(intVal!=CBC_UNBENUTZT)
			{
				ConfVars_SetConfigInt(varname, VDIUtil_GetXState(tree, cbcday1[i]));

				make_varname(varname, sizeof(varname), cCbcFrom, i + 1);
				ConfVars_SetConfigInt(varname,VDIUtil_GetXState(tree, cbcvon1[i]));
	
				make_varname(varname, sizeof(varname), cCbcUntil, i + 1);
				ConfVars_SetConfigInt(varname,VDIUtil_GetXState(tree, cbcbis1[i]));

				make_varname(varname, sizeof(varname), cCbcNumber, i + 1);
				ObjcString(tree, cbcvvw1[i], vvWahl,sizeof(vvWahl));
				ConfVars_SetConfigString(varname, vvWahl);
			}
			else
			{
				ConfVars_DeleteConfigVar(varname);
				make_varname(varname, sizeof(varname), cCbcFrom, i + 1);
				ConfVars_DeleteConfigVar(varname);
	
				make_varname(varname, sizeof(varname), cCbcUntil, i + 1);
				ConfVars_DeleteConfigVar(varname);

				make_varname(varname, sizeof(varname), cCbcNumber, i + 1);
				ConfVars_DeleteConfigVar(varname);
			}
		}
		ObjcString(tree, cbcvvw1[MAX_CBC_REG], vvWahl,sizeof(vvWahl));
		ConfVars_SetConfigString(cCbcNumberDef, vvWahl);
	}
}

/*** ------------------------------------------------------------------------ ***/
/*	LOCAL _VOID getItemsHprg(OBJECT *tree, hlpPrgStruct *hprg)					*/
/*	Setz/Liest Eingaben des Hilfsprogramm-Formulars	aus Formular				*/
/*	Abgeleitet von getItems														*/
/*	Parameter:	tree:	das Formular											*/
/*				hprg:	die Ziel-Struktur										*/
/*	Ergebnis:	keines															*/		
/*	30.3.00 von Dimitri Junker	DYJ 4.14										*/
/*** ------------------------------------------------------------------------ ***/
LOCAL _VOID getItemsHprg(OBJECT *tree, hlpPrgStruct *hprg)
{
	
	hprg->mulStart =VDIUtil_GetXState(tree, HPM_START1);
	hprg->activ = GetObjState(tree, HPACTIVE, SELECTED);
	hprg->term = GetObjState(tree, HPTERM, SELECTED);
	ObjcString(tree, HPRGCMD1, hprg->Cmd, sizeof(hprg->Cmd));
	ObjcString(tree, HPRGNAME, hprg->hprgName, sizeof(hprg->hprgName));
}
/*** ---------------------------------------------------------------------- ***/
/*** ------------------------------------------------------------------------ ***/
/*	LOCAL _VOID setItemsHp(OBJECT *tree, OBJECT *pop, CONST ioFilterStruct *filter)	*/
/*	Setz Felder des Hilfsprogramm-Formulars					*/
/*	Abgeleitet von setItems														*/
/*	Parameter:	tree:	das Formular											*/
/*				hprg:	die Ziel-Struktur										*/
/*	Ergebnis:	keines															*/		
/*	1.4.00 von Dimitri Junker	DYJ 4.14										*/
/*** ------------------------------------------------------------------------ ***/
/*DYJ 5.21b */
LOCAL _VOID setItemsHp(OBJECT *tree, OBJECT *pop, CONST hlpPrgStruct *hprg)
{
	VDIUtil_SetXState(tree, HPM_START1, hprg->mulStart);
	VDIUtil_SetXString(tree, HPM_START1, pop, hprg->mulStart);
	EnableObjState(tree, HPACTIVE, SELECTED, hprg->activ);
	EnableObjState(tree, HPTERM, SELECTED, hprg->term);
	SetObjcString(tree, HPRGNAME, hprg->hprgName);
	SetObjcString(tree, HPRGCMD1, hprg->Cmd);
	if (hprg->hprgPath[0] != '\0')
		SetObjcString(tree, HPRGSEL, F_Path_Basename(hprg->hprgPath));
	else
		SetObjcString(tree, HPRGSEL, MausTauschrsc_WrkString(FS_EMPTY));
}

/*** ------------------------------------------------------------------------ ***/
/*	LOCAL _BOOL hprgButton(OBJECT *tree, _VOID *env, _WORD button, _WORD mx, _WORD my, _UWORD kstate, _WORD clicks)					*/
/*	Verwaltet die Buttons des Hilfsprogramm-Formulars							*/
/*	Abgeleitet von filterButton													*/
/*	Parameter:	tree:	das Formular											*/
/*				env:	hpInfStruct												*/
/*	 			button:	gedrckter Knopf										*/
/*				mx,my,kstate,clicks: unbenutzt									*/
/*	Ergebnis:	keines															*/		
/*	30.3.00 von Dimitri Junker	DYJ 4.14; DYJ 4.18							*/
/*** ------------------------------------------------------------------------ ***/
/*DYJ 5.21b */
LOCAL _BOOL hprgButton(OBJECT *tree, _VOID *env, _WORD button, _WORD mx, _WORD my, _UWORD kstate, _WORD clicks)
{
	GRECT r;
	hpInfStruct *hpInfo;
	_WORD x, y,mulStart;
	_UBYTE path[PATH_MAX];
	_UBYTE name[PATH_MAX];
	_UBYTE ext[PATH_MAX];
	OBJECT *hprgSel,*mulStPop;
	_BOOL res;
	
	UNUSED(mx);
	UNUSED(my);
	UNUSED(clicks);

	hpInfo = env;
	hprgSel = TreeAddr[HLP_PRGS];
	mulStPop  = TreeAddr[M_START];
	/* Button auswerten */
	button &= 0x7fff;
	switch (button)
	{
	case HPRGOK:
	case HPRGQUIT:
		if (button == HPRGOK)
			getItemsHprg(tree, &hpInfo->hlp_prg[hpInfo->select]);
		DelObjState(tree, button, SELECTED);
		return TRUE;
	
	case HPRGHELP:
		CatHelp_DoHelp(CatHelp_hlpPrgs);
		DelObjState(tree, button, SELECTED);
		WinDials_WinDialDraw(tree, button, 1, &r, FALSE);
		break;
		
	case HPRGPOP0:
	case HPRGPOP1:
		getItemsHprg(tree, &hpInfo->hlp_prg[hpInfo->oldSelect]);
		objc_offset(tree, HPRGPOP1, &x, &y);
		hpInfo->select = mtPopups_TreePopup(hprgSel, x, y, VDIUtil_GetXState(tree, HPRGPOP1)) - 1;
		if (hpInfo->select >= 0)
		{
			VDIUtil_SetXState(tree, HPRGPOP1, hpInfo->select);
			VDIUtil_SetXString(tree, HPRGPOP1, hprgSel, hpInfo->select);
			setItemsHp(tree,mulStPop, &hpInfo->hlp_prg[hpInfo->select]);
			WinDials_WinDialDraw(tree, ROOT, MAX_DEPTH, &r, FALSE);
			hpInfo->oldSelect = hpInfo->select;
		} else
		{
			hpInfo->select = hpInfo->oldSelect;
		}
		break;
	
	case HPRGPOP2:
		getItemsHprg(tree, &hpInfo->hlp_prg[hpInfo->oldSelect]);
		hpInfo->select = VDIUtil_GetXState(tree, HPRGPOP1);
		if(kstate&K_SHIFT)
			hpInfo->select = (hpInfo->select + MAX_HLP_PRG-1) % MAX_HLP_PRG;
		else
			hpInfo->select = (hpInfo->select + 1) % MAX_HLP_PRG;
		VDIUtil_SetXState(tree, HPRGPOP1, hpInfo->select);
		VDIUtil_SetXString(tree, HPRGPOP1, hprgSel, hpInfo->select);
		setItemsHp(tree, mulStPop, &hpInfo->hlp_prg[hpInfo->select]);
		hpInfo->oldSelect = hpInfo->select;
		WinDials_WinDialDraw(tree, ROOT, MAX_DEPTH, &r, FALSE);
		break;
		
	case HPRGSEL0:
	case HPRGSEL:
		/* Neues Programm auswaehlen */
		if (hpInfo->hlp_prg[hpInfo->oldSelect].hprgPath[0] != '\0')
		{
			mtDir_SplitPath(hpInfo->hlp_prg[hpInfo->oldSelect].hprgPath, path, name, ext);
		} else
		{
			CatGlobal_ApplPath(path);
			*name = '\0';
		}
		res = mtDir_FselGet(path, name, ALL_FILE_MASK, MausTauschrsc_WrkString(FS_SELECT_FILTER), TRUE);
		/* mtDials_DialForm(tree, DENABLE, &r, &r);  */
		if (res)
		{
			if (name[0] != '\0')
			{
				strBcpy(hpInfo->hlp_prg[hpInfo->oldSelect].hprgPath, path);
				F_Path_Append(hpInfo->hlp_prg[hpInfo->oldSelect].hprgPath, name);
				SetObjcString(tree, HPRGSEL, name);
				strInsertChar(' ', name, sizeof(name));
				SetObjcString(hprgSel, hpInfo->oldSelect + 1, name);
				hpInfo->hlp_prg[hpInfo->oldSelect].activ = TRUE;
			} else
			{
				hpInfo->hlp_prg[hpInfo->oldSelect].hprgPath[0] = '\0';
				SetObjcString(hprgSel, hpInfo->oldSelect + 1, MausTauschrsc_WrkString(FS_NOT_INSTALLED)+4);
				hpInfo->hlp_prg[hpInfo->oldSelect].activ = FALSE;
				setItemsHp(tree,mulStPop, &hpInfo->hlp_prg[hpInfo->oldSelect]);
			}
			VDIUtil_SetXString(tree, HPRGPOP1, hprgSel, hpInfo->select);
			WinDials_WinDialDraw(tree, HPRGPOP1, 1, &r, FALSE);
			WinDials_WinDialDraw(tree, HPRGSEL, 1, &r, FALSE);
		}
		DelObjState(tree, button, SELECTED);
		WinDials_WinDialDraw(tree, button, 1, &r, FALSE);
		break;
	case HPM_START0:
	case HPM_START1:
		objc_offset(tree, HPM_START1, &x, &y);
		mulStart = mtPopups_TreePopup(mulStPop, x, y, VDIUtil_GetXState(tree, HPM_START1)) - 1;
		if (mulStart >= 0)
		{
			VDIUtil_SetXState(tree, HPRGPOP1, mulStart);
			hpInfo->hlp_prg[hpInfo->oldSelect].mulStart = mulStart;
			setItemsHp(tree, mulStPop, &hpInfo->hlp_prg[hpInfo->oldSelect]);
			WinDials_WinDialDraw(tree, HPM_START1, 1, &r, FALSE);
		}
		break;
		
	case HPM_START2:
		mulStart = VDIUtil_GetXState(tree, HPM_START1);
		if(kstate&K_SHIFT)
			mulStart = (mulStart + 3) % 4;
		else
			mulStart = (mulStart + 1) % 4;
		hpInfo->hlp_prg[hpInfo->oldSelect].mulStart = mulStart;
		setItemsHp(tree, mulStPop, &hpInfo->hlp_prg[hpInfo->oldSelect]);
		/*
		VDIUtil_SetXString(tree, HPM_START1, mulStPop, mulStart);
		*/
		WinDials_WinDialDraw(tree, HPM_START1, 1, &r, FALSE);
		break;
	
	}
	return FALSE;
}

/*** ------------------------------------------------------------------------ ***/
/*	GLOCAL _VOID hprgGetSetValues(OBJECT *tree, _VOID *env, _BOOL set, _WORD exit)	*/
/*	Setz/Liest Eingaben des Hilfsprogramm-Formulars								*/
/*	Abgeleitet von filterGetSetValues											*/
/*	Parameter:	tree:	das Formular											*/
/*				env:	hpInfStruct												*/
/*				set:	setzen oder lesen										*/
/*				exit:	Formular beenden?										*/
/*	Ergebnis:	keines															*/		
/*	30.3.00 von Dimitri Junker		DYJ 4.14									*/
/*** ------------------------------------------------------------------------ ***/
/*DYJ 5.21b */
LOCAL _VOID hprgGetSetValues(OBJECT *tree, _VOID *env, _BOOL set, _WORD exit)
{
	hpInfStruct *hpInfo;
	_WORD i;
	OBJECT *hPrgSel,*mulStPop;
	_UBYTE varname[128];
	_UBYTE path[PATH_MAX];
	_UBYTE name[PATH_MAX];
	_UBYTE ext[PATH_MAX];
	
	hpInfo = env;
	hPrgSel = TreeAddr[HLP_PRGS];
	mulStPop  = TreeAddr[M_START];
	exit &= 0x7fff;
	if (set)
	{
		/* Strings einsetzen */
		for (i = 0; i < MAX_HLP_PRG; i++)
		{
			/* Array fuellen
			 */
			make_varname(varname, sizeof(varname), cHlpPrgProg, i + 1);
			if (ConfVars_GetConfigString(varname, hpInfo->hlp_prg[i].hprgPath, sizeof(hpInfo->hlp_prg[i].hprgPath)))
			{
				HlpPrg_ReadPrg(&hpInfo->hlp_prg[i], i + 1);
				if (hpInfo->hlp_prg[i].hprgName[0] == '\0')
					mtDir_SplitPath(hpInfo->hlp_prg[i].hprgPath, path, name, ext);
				else
					strBcpy(name, hpInfo->hlp_prg[i].hprgName);
				strInsertChar(' ', name, sizeof(name));
				SetObjcString(hPrgSel, i + 1, name);
			} else
			{
				hpInfo->hlp_prg[i].activ  = FALSE;
				hpInfo->hlp_prg[i].term  = FALSE;
				hpInfo->hlp_prg[i].mulStart  = 0;
				SetObjcString(hPrgSel, i + 1, MausTauschrsc_WrkString(FS_NOT_INSTALLED)+4);
			}
		}
		hpInfo->select = 0;
		hpInfo->oldSelect = hpInfo->select;
		setItemsHp(tree,mulStPop, &hpInfo->hlp_prg[hpInfo->select]);
		/* vorbereiten */
		VDIUtil_SetXState(tree, HPRGPOP1, hpInfo->select);
		VDIUtil_SetXString(tree, HPRGPOP1, hPrgSel, hpInfo->select);
	} else
	{
		if (exit == HPRGOK)
		{
			for (i = 0; i < MAX_HLP_PRG; i++)
				HlpPrg_WritePrg(&hpInfo->hlp_prg[i], i + 1);
		}
		OFREE(hpInfo);
	}
}
/*** ------------------------------------------------------------------------ ***/
/*	GLOBAL _VOID CatOpts2_doHilfsPrg(_VOID)										*/
/*	Setzt Cat-Hilfsprogramme. Natrlich nur unter Multitasking mglich.			*/
/*	Abgeleitet von:CatOpts2_doIOFilter											*/
/*	Parameter:	keine															*/
/*	Ergebnis:	keines															*/		
/*	30.3.00 von Dimitri Junker		DYJ 4.14									*/
/*** ------------------------------------------------------------------------ ***/

GLOBAL _VOID CatOpts2_doHilfsPrg(_VOID)
{
	OBJECT *hprgBox;
	hpInfStruct *hpInfo;
	
	hpInfo = NEW(hpInfStruct, "CatOpts2_doHilfsPrg");
	if (hpInfo == NULL)
		return;
	hprgBox = TreeAddr[HLP_PRG];
	MemSetZeroStruct(*hpInfo);
	if (!WinDials_OpenWinDial(hprgBox, FALSE,
		hprgGetSetValues,
		hprgGetSetValues,
		hprgButton,
		WinDials_defDraw,
		NULL,
		hpInfo))
	{
		OFREE(hpInfo);
	}
}
/*** ------------------------------------------------------------------------ ***/
/*	GLOBAL _VOID CatOpts2_doCbC(_VOID)											*/
/*	Optionen Dialog fr Call by Call Provider									*/
/*	Parameter:	keine															*/
/*	Ergebnis:	keines															*/		
/*	29.10.01 von Dimitri Junker	DYJ 4.30p										*/
/*** ------------------------------------------------------------------------ ***/

GLOBAL _VOID CatOpts2_doCbC(_VOID)
{
	OBJECT *cbcConf;
	
	cbcConf = TreeAddr[CBC_CNF];
	WinDials_OpenWinDial(cbcConf, FALSE,
		cbcGetSetValues,
		cbcGetSetValues,
		cbcButton,
		WinDials_defDraw,
		NULL,
		NULL);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID CatOpts2_doIOFilter(_VOID)
{
	OBJECT *filterBox;
	ioInfStruct *ioInfo;
	_WORD i;
	for(i=0;i<MAX_IO_FILTER;i++)
	{
		FilterPTN[i]=&FilterTN[i];
		FilterTN[i].typName[0]='\0';
		FilterTN[i].nummer=i;
	}
	
	ioInfo = NEW(ioInfStruct, "CatOpts2_doIOFilter");
	if (ioInfo == NULL)
		return;
	filterBox = TreeAddr[FILEFILT];
	MemSetZeroStruct(*ioInfo);
	if (!WinDials_OpenWinDial(filterBox, FALSE,
		filterGetSetValues,
		filterGetSetValues,
		filterButton,
		WinDials_defDraw,
		NULL,
		ioInfo))
	{
		OFREE(ioInfo);
	}
}
/*** ------------------------------------------------------------------------ ***/
/*	_VOID CatOpts2_doPMFilter(_VOID)											*/
/*	wie das vorige, aber fr PM-Filter											*/
/*	26.11.01 von Dimitri Junker	DYJ 4.30zk										*/
/*** ------------------------------------------------------------------------ ***/
GLOBAL _VOID CatOpts2_doPMFilter(_VOID)
{
	OBJECT *filterBox;
	pmInfStruct *pmInfo;
	_WORD i;
	for(i=0;i<MAX_PM_FILTER;i++)
	{
		FilterPTN[i]=&FilterTN[i];
		FilterTN[i].typName[0]='\0';
		FilterTN[i].nummer=i;
	}
	
	pmInfo = NEW(pmInfStruct, "CatOpts2_doPMFilter");
	if (pmInfo == NULL)
		return;
	filterBox = TreeAddr[PM_FILT];
	MemSetZeroStruct(*pmInfo);
	if (!WinDials_OpenWinDial(filterBox, FALSE,
		pmFilterGetSetValues,
		pmFilterGetSetValues,
		pmFilterButton,
		WinDials_defDraw,
		NULL,
		pmInfo))
	{
		OFREE(pmInfo);
	}
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

#define FILT_EXT (FILTSEL_HIGH_EXT - FILTSEL_LOW_EXT + 1)
#define FILT_MAX  FILTSEL_HIGH_EXT

typedef struct {
	_WORD filterNumber;
	_UBYTE cmd[256];
	_UBYTE name[256];
	_WORD exitBut;
	OBJECT *filtSel;
} blockInfo;

/*** ---------------------------------------------------------------------- ***/
/*DYJ 5.21b */	/*DYJ 5.23e */
LOCAL _VOID BuildFilterPopup(_WORD filterNumber, OBJECT **pfiltSel, _BOOL forDial)
{
	_WORD i;
	_UBYTE varname[128];
	_UBYTE cmd[256];
	_UBYTE name[256];
	OBJECT *filterBox;
	OBJECT *filtSel;
	_BOOL isDa;
	_BOOL nameDa;
	
	filterBox = TreeAddr[FILTBOX];
	filtSel = *pfiltSel = TreeAddr[FILTSEL];
	SetObjcString(filterBox, FBCOMM, "");
	SetObjcString(filterBox, FBNAME, "");
	for (i = FILTSEL_LOW_EXT; i <= FILTSEL_HIGH_EXT; i++)
	{
		make_varname(varname, sizeof(varname), cBlockFilter, i - FILTSEL_LOW_EXT + 1);
		isDa = ConfVars_GetConfigString(varname, cmd, sizeof(cmd));
		make_varname(varname, sizeof(varname), cBlockFilterName, i - FILTSEL_LOW_EXT + 1);
		nameDa = ConfVars_GetConfigString(varname, name, sizeof(name));
		if (isDa)
		{
			if (!nameDa)
				strBcpy(name, cmd);
			if (i - 1 == filterNumber)
			{
				/* String setzen */
				SetObjcString(filterBox, FBCOMM, cmd);
				/* Name setzen */
				SetObjcString(filterBox, FBNAME, name);
			}
			strInsertChar(' ', cmd, sizeof(cmd));
			strInsertChar(' ', name, sizeof(name));
		} else
		{
			/* Extern X anlegen */
			sprintf(cmd, Rsc_WrkString(FS_EXTERN), i - FILTSEL_LOW_EXT + 1);
			sprintf(name, Rsc_WrkString(FS_EXTERN), i - FILTSEL_LOW_EXT + 1);
		}
		EnableObjState(filtSel, i, DISABLED, !isDa && !forDial);
		EnableObjFlags(filtSel, i, SELECTABLE, isDa || forDial);
		SetObjcString(filtSel, i, name);
	}
	if (ShellCall_IsShell() == noShell)
	{
		for (i = FILTSEL_LOW_EXT; i <= FILTSEL_HIGH_EXT; i++)
		{
			SetObjState(filtSel, i, DISABLED);
			DelObjFlags(filtSel, i, SELECTABLE);
		}
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL blockButton(OBJECT *tree, _VOID *env, _WORD button, _WORD mx, _WORD my, _UWORD kstate, _WORD clicks)
{
	GRECT r;
	blockInfo *infoPtr;
	_WORD x, y;
	_WORD select;
	_UBYTE varname[128];
	
	UNUSED(mx);
	UNUSED(my);
	UNUSED(clicks);

	infoPtr = env;
	button &= 0x7fff;
	switch (button)
	{
	case FBOK:
	case FBQUIT:
		DelObjState(tree, button, SELECTED);
		return TRUE;
	
	case FBHELP:
		CatHelp_DoHelp(CatHelp_filter);
		DelObjState(tree, button, SELECTED);
		WinDials_WinDialDraw(tree, button, 1, &r, FALSE);
		break;
		
	case FBFILT0:
	case FBFILT1:
		objc_offset(tree, FBFILT1, &x, &y);
		select = mtPopups_TreePopup(infoPtr->filtSel, x, y, VDIUtil_GetXState(tree, FBFILT1)) - 1;
		if (ShellCall_IsShell() == noShell && select >= (FILTSEL_LOW_EXT - 1))
			select = -1;
		if (select >= 0)
		{
			VDIUtil_SetXState(tree, FBFILT1, select);
			VDIUtil_SetXString(tree, FBFILT1, infoPtr->filtSel, select);
			if (select >= FILTSEL_LOW_EXT - 1)
			{
				make_varname(varname, sizeof(varname), cBlockFilter, select - FILTSEL_LOW_EXT + 2);
				ConfVars_GetConfDefStr(varname, infoPtr->cmd, sizeof(infoPtr->cmd), "");
				SetObjcString(tree, FBCOMM, infoPtr->cmd);
				make_varname(varname, sizeof(varname), cBlockFilterName, select - FILTSEL_LOW_EXT + 2);
				ConfVars_GetConfDefStr(varname, infoPtr->name, sizeof(infoPtr->name), "");
				SetObjcString(tree, FBNAME, infoPtr->name);
			} else
			{
				SetObjcString(tree, FBCOMM, "");
				SetObjcString(tree, FBNAME, "");
			}
			WinDials_WinDialDraw(tree, FBCOMM, 0, &r, FALSE);
			WinDials_WinDialDraw(tree, FBNAME, 0, &r, FALSE);
			WinDials_WinDialDraw(tree, FBFILT1, 0, &r, FALSE);
		}
		break;
		
	case FBFILT2:
		select = VDIUtil_GetXState(tree, FBFILT1);
		if (ShellCall_IsShell() != noShell)
		{
			if(kstate&K_SHIFT)
				select = (select + FILT_MAX-1) % FILT_MAX;
			else
				select = (select + 1) % FILT_MAX;
		}
		else
		{
			if(kstate&K_SHIFT)
				select = (select + FILT_MAX - FILT_EXT-1) % (FILT_MAX - FILT_EXT);
			else
				select = (select + 1) % (FILT_MAX - FILT_EXT);
		}
		VDIUtil_SetXState(tree, FBFILT1, select);
		VDIUtil_SetXString(tree, FBFILT1, infoPtr->filtSel, select);
		if (select >= FILTSEL_LOW_EXT - 1)
		{
			make_varname(varname, sizeof(varname), cBlockFilter, select - FILTSEL_LOW_EXT + 2);
			ConfVars_GetConfDefStr(varname, infoPtr->cmd, sizeof(infoPtr->cmd), "");
			SetObjcString(tree, FBCOMM, infoPtr->cmd);
			make_varname(varname, sizeof(varname), cBlockFilterName, select - FILTSEL_LOW_EXT + 2);
			ConfVars_GetConfDefStr(varname, infoPtr->name, sizeof(infoPtr->name), "");
			SetObjcString(tree, FBNAME, infoPtr->name);
		} else
		{
			SetObjcString(tree, FBCOMM, "");
			SetObjcString(tree, FBNAME, "");
		}
		WinDials_WinDialDraw(tree, FBCOMM, 0, &r, FALSE);
		WinDials_WinDialDraw(tree, FBNAME, 0, &r, FALSE);
		WinDials_WinDialDraw(tree, FBFILT1, 0, &r, FALSE);
		break;
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID blockGetSetValues(OBJECT *tree, _VOID *env, _BOOL set, _WORD exit)
{
	blockInfo *infoPtr;
	_UBYTE varname[128];
	_UBYTE varname2[128];

	infoPtr = env;
	infoPtr->exitBut = exit & 0x7fff;
	if (set)
	{
		BuildFilterPopup(infoPtr->filterNumber, &infoPtr->filtSel, TRUE);
		/* vorbereiten */
		VDIUtil_SetXState(tree, FBFILT1, infoPtr->filterNumber);
		VDIUtil_SetXString(tree, FBFILT1, infoPtr->filtSel, infoPtr->filterNumber);
	} else
	{
		if (infoPtr->exitBut == FBOK)
		{
			infoPtr->filterNumber = VDIUtil_GetXState(tree, FBFILT1);
			if (infoPtr->filterNumber >= FILTSEL_LOW_EXT - 1)
			{
				/* String auslesen */
				ObjcString(tree, FBCOMM, infoPtr->cmd, sizeof(infoPtr->cmd));
				strleft(infoPtr->cmd);
				strdelRightSpace(infoPtr->cmd);
				ObjcString(tree, FBNAME, infoPtr->name, sizeof(infoPtr->name));
				strleft(infoPtr->name);
				strdelRightSpace(infoPtr->name);
				make_varname(varname, sizeof(varname), cBlockFilter, infoPtr->filterNumber - FILTSEL_LOW_EXT + 2);
				make_varname(varname2, sizeof(varname2), cBlockFilterName, infoPtr->filterNumber - FILTSEL_LOW_EXT + 2);
				if (infoPtr->cmd[0] != '\0')
				{
					ConfVars_SetConfigString(varname, infoPtr->cmd);
					ConfVars_SetConfigString(varname2, infoPtr->name);
				} else
				{
					ConfVars_DeleteConfigVar(varname);
					ConfVars_DeleteConfigVar(varname2);
				}
			}
		}
	}
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _BOOL CatOpts2_doFilter(_WORD *filterNumber, _UBYTE *cmd, size_t strsize)
{
	OBJECT *filterBox;
	blockInfo *infoPtr;
	_BOOL result;

	if (*filterNumber < 0)
		*filterNumber = 0;
	filterBox = TreeAddr[FILTBOX];
	infoPtr = NEW(blockInfo, "CatOpts2_doFilter");
	if (infoPtr == NULL)
		return FALSE;
	strBcpy(infoPtr->cmd, cmd);
	infoPtr->filterNumber = *filterNumber;
	
	if (!WinDials_OpenWinDial(filterBox, TRUE,
		blockGetSetValues,
		blockGetSetValues,
		blockButton,
		WinDials_defDraw,
		NULL,
		infoPtr))
	{
		OFREE(infoPtr);
		return FALSE;
	}
	/* Da wir die Ergebnisse brauchen, muessen wir hier die Eventroutine
	 * aufrufen
	 */
	WinDials_WinDialHandleEvents();
	
	*filterNumber = infoPtr->filterNumber;
	strMcpy(cmd, strsize, infoPtr->cmd);
	
	result = infoPtr->exitBut == FBOK;
	
	OFREE(infoPtr);
	
	return result;
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

GLOBAL _BOOL CatOpts2_doPopupFilter(_WORD *filterNumber, _UBYTE *cmd, size_t strsize)
{
	OBJECT *filtSel;
	_WORD x, y;
	_UBYTE varname[128];
	_WORD fNumber;
	_UWORD udummy;
	
	if (*filterNumber < 0)
		*filterNumber = 0;
	BuildFilterPopup(*filterNumber, &filtSel, FALSE);
	graf_mkstate(&x, &y, &udummy, &udummy);
	fNumber = mtPopups_TreePopup(filtSel, x, y, 0) - 1;
	if (fNumber >= 0)
		*filterNumber = fNumber;
	if (fNumber >= FILTSEL_LOW_EXT - 1)
	{
		/* String auslesen */
		make_varname(varname, sizeof(varname), cBlockFilter, fNumber - FILTSEL_LOW_EXT + 2);
		if (ConfVars_GetConfigString(varname, cmd, strsize))
			return TRUE;
		return FALSE;
	}
	return fNumber >= 0;
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

GLOBAL _BOOL CatOpts2_NrHolen(_UBYTE *Nr, size_t strsize)
{
	_WORD exit;
	_UBYTE str[256];
	OBJECT *whichNr;

	whichNr = TreeAddr[WHICHNR];
	ObjcString(whichNr, NRSTRING, str, sizeof(str));
	exit = WinDials_WinDialDo(whichNr, 0);
	if (exit != NROK)
	{
		SetObjcString(whichNr, NRSTRING, str);
		return FALSE;
	}
	ObjcString(whichNr, NRSTRING, Nr, strsize);
	return TRUE;
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/
/*DYJ 5.21b */
GLOBAL _BOOL CatOpts2_DatumHolen(_BOOL forWv, _UBYTE *Nr, size_t strsize)
{
	_WORD exit;
	_UBYTE str[20];
	_UBYTE saveStr[20];
	_BOOL ok;
	OBJECT *dateein;

	dateein = TreeAddr[DATUMEIN];
	if (forWv)
		SetObjcString(dateein, DTITLE, MausTauschrsc_WrkString(FS_WV_TITLE));
	else
		SetObjcString(dateein, DTITLE, MausTauschrsc_WrkString(FS_ABRUF_TITLE));
	ObjcString(dateein, DDATE, saveStr, sizeof(saveStr));
	do
	{
		ok = FALSE;
		exit = WinDials_WinDialDo(dateein, 0);
		if (exit == DATEOK)
		{
			ObjcString(dateein, DDATE, str, sizeof(str));
			ok = ConvertDate_DateOk(str);
			if (!ok)
				MTE_infoRSC(AL_UNKNOWN_DATE);
		}
	} while (exit == DATEOK && !ok);
	if (exit != DATEOK)
	{
		SetObjcString(dateein, DDATE, saveStr);
		return FALSE;
	}
	ObjcString(dateein, DDATE, Nr, strsize);
	return TRUE;
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

/*DYJ 5.21b */
LOCAL _BOOL GetUser(_BOOL *on, _UBYTE *name, size_t namesize)
{
	_UBYTE oldName[256];
	_WORD j;
	CAT_GROUP_NUMBER cGroup;
	OBJECT *gruppen;
	OBJECT *getuser;
	HWND grinWdw;
	_UBYTE *p;
	
	gruppen = TreeAddr[GRUPPEN];
	getuser = TreeAddr[GETUSER];
	grin_GetGrinTopWdw(&grinWdw);
	grin_ActualFrom(grinWdw, oldName, sizeof(oldName));
	grin_ActualGroupNr(grinWdw, &cGroup);
	EnableObjState(getuser, USERON, SELECTED, GroupSelect_isPrivate(cGroup));
	EnableObjState(getuser, USEROFF, SELECTED, !GroupSelect_isPrivate(cGroup));
	SetObjcString(getuser, GUSERSTR, oldName);
	do
	{
		j = WinDials_WinDialDo(getuser, 0);
		ObjcString(getuser, GUSERSTR, name, namesize);
		if (j != USERABRU && name[0] == '\0')
			MTE_infoRSC(AL_EMPTY_ENAME);
	} while (j != USERABRU && name[0] == '\0');
	if (j != USERABRU)
	{
		ObjcString(getuser, GUSERSTR, name, namesize);
		*on = GetObjState(getuser, USERON, SELECTED);
		grin_ActualReceiver(grinWdw, oldName, sizeof(oldName));
		if (strnCaseCmp(oldName, "CHEF", 4) == 0)
		{
			strCpy(oldName, oldName + 4);
			strleft(oldName);
			p = strChr(oldName, '@');
			if (p != NULL)
				*p = '\0';
			strdelRightSpace(oldName);
			SetObjcString(gruppen, NEWGROUP, oldName);
			ListHelp_SetLastGroup(oldName);
		}
		return TRUE;
	}
	SetObjcString(getuser, GUSERSTR, oldName);
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

/*DYJ 5.21b */
GLOBAL _VOID CatOpts2_DoUserSelect(_VOID)
{
	_UBYTE name[256];
	_BOOL on;
	_UBYTE grStr[256];
	FILENO out;
	CAT_GROUP_NUMBER Nr;
	_UBYTE fname[PATH_MAX];
	
	grStr[0] = '\0';
	name[0] = '\0';
	if (GetUser(&on, name, sizeof(name)) &&
		ListHelp_SelectGroup(grStr, sizeof(grStr), &Nr, TRUE, FALSE, FALSE, gsmUser) &&
		strCaseCmp(grStr, Rsc_WrkString(GRP_PRIVATE)) != 0)
	{
		strBcpy(fname, MessagePath);
		F_Path_Append(fname, grSelect);
		out = CatFiles_OpenFile(fname, CatFiles_writeFile);
		if (out < 0)
		{
			MTE_infoRSC(MTE_changeNoSave);
		} else
		{
			CatFiles_Seek(0, out, CatFiles_end);
			CatFiles_WriteMuch(sizeof(":GU")-1, out, ":GU");
			CatFiles_WriteMuch(strLen(name), out, name);
			CatFiles_WriteFile(on ? '>' : '<', out);
			CatFiles_WriteMuch(strLen(grStr), out, grStr);
			CatFiles_WriteFile(CR, out);
			CatFiles_WriteFile(LF, out);
			CatFiles_CloseFile(out);
			Protokoll_SendPathUpdate(MessagePath);
		}
	}
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

LOCAL struct _sound {
	CONST _UBYTE *event;
	_WORD type;
	CONST _UBYTE *val;
} sounds[] = {
	{ cBingError, SOUND_INTERN, "1" },
	{ cBingNoUndo, SOUND_DEFAULT, "" },
	{ cBingComToOwnMessage, SOUND_DEFAULT, "" },
	{ cBingFlagsNoWork, SOUND_DEFAULT, "" },
	{ cBingAutoNextGroup, SOUND_INTERN, "1" },
	{ cBingNoGroup, SOUND_INTERN, "7" },
	{ cBingNoMessageFound, SOUND_DEFAULT, "" },
	{ cBingTextNotFound, SOUND_INTERN, "7" },
	{ cBingNothingFound, SOUND_INTERN, "7" },
	{ cBingLineTooLong, SOUND_DEFAULT, "" },
	{ cBingTerminalStart, SOUND_INTERN, "7" },
	{ cBingProgramStart, SOUND_NONE, "" },
	{ cBingNewMails, SOUND_NONE, "" },
	{ cBingNoMails, SOUND_NONE, "" },
	{ cBingEmergencyBrake, SOUND_NONE, "" },
	{ cBingAttachment, SOUND_NONE, "" },
};
#define SOUND_EVENTS ((_WORD)(sizeof(sounds) / sizeof(sounds[0])))

LOCAL CONST _UBYTE *bings[] = {
	" Nichts",
	" Systembeep",
	" Bildschirm invertieren",
	"-",
	" Extern",
	"-",
	" Bong 1",
	" Bong 2",
	" Bong 3",
	" Bong 4",
	" Bong 5",
	" Bong 6",
	" Bong 7",
	" Bounce3",
	" Bounce4",
	" Bounce5",
	" Bounce6",
	" Tingeling",
	" Tingeling2",
	" Ting2",
	" Ding",
	" Ploink",
	" Toing",
	" Bell",
	" Gong",
	" Gong 2",
	" Gong 3",
	" Pieuw",
	" Poing",
	" Zap",
	" Dlink",
	" Jingle",
	" Shot",
	" Explosion1",
	" Explosion2",
	" Laser",
	" Fft",
	" Steam",
	" Thrill",
	" Siren2",
	" Chopper",
	" Surf",
	" Dingdong",
	" Klonk",
	" Bumm",
	" Dudel",
	" Tusch",
	" Pling",
};
#define NUM_BINGS (_WORD)(sizeof(bings) / sizeof(bings[0]))

GLOBAL _VOID CatOpts2_InitSounds(_VOID)
{
	_WORD i;
	_UBYTE varName[128];
	_UBYTE path[PATH_MAX];
	
	Sound_Init();
	for (i = 0; i < SOUND_EVENTS; i++)
	{
		strBcpy(varName, cBingEvent);
		strBcat(varName, ".");
		strBcat(varName, sounds[i].event);
		ConfVars_GetConfDefInt(varName, &sounds[i].type, sounds[i].type);
		strBcpy(varName, cBingEventName);
		strBcat(varName, ".");
		strBcat(varName, sounds[i].event);
		ConfVars_GetConfDefStr(varName, path, sizeof(path), sounds[i].val);
		Sound_Register(sounds[i].event, sounds[i].type, path);
	}
}

/*** ---------------------------------------------------------------------- ***/

typedef struct {
	_WORD select;
	_WORD oldSelect;
	struct {
		_WORD type;
		_UBYTE name[PATH_MAX];
	} sounds[SOUND_EVENTS];
	_UBYTE path[PATH_MAX];
} soundStruct;

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID setSounds(OBJECT *tree, _WORD type, CONST _UBYTE *val)
{
	_WORD intVal;

	switch (type)
	{
	case SOUND_NONE:
		intVal = 0;
		break;
	case SOUND_DEFAULT:
		intVal = 1;
		break;
	case SOUND_FLASH:
		intVal = 2;
		break;
	case SOUND_FILENAME:
		intVal = 4;
		break;
	case SOUND_INTERN:
	default:
		intVal = StrToInt(val, NULL, NULL) + 6 - 1;
		break;
	}
	VDIUtil_SetXState(tree, SOUND_TYPE1, intVal);
	SetObjcString(tree, SOUND_TYPE1, bings[intVal]);
	if (type == SOUND_FILENAME)
	{
		SetObjFlags(tree, SOUND_FILE0, SELECTABLE|TOUCHEXIT);
		SetObjFlags(tree, SOUND_FILE, SELECTABLE|TOUCHEXIT);
		SetObjcString(tree, SOUND_FILE, F_Path_Basename(val));
	} else
	{
		DelObjFlags(tree, SOUND_FILE0, SELECTABLE|TOUCHEXIT);
		DelObjFlags(tree, SOUND_FILE, SELECTABLE|TOUCHEXIT);
		SetObjcString(tree, SOUND_FILE, "");
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID getSounds(OBJECT *tree, _WORD *type, _UBYTE *val)
{
	_WORD intVal;
	
	intVal = VDIUtil_GetXState(tree, SOUND_TYPE1);
	switch (intVal)
	{
	case 0:
		*type = SOUND_NONE;
		break;
	case 1:
		*type = SOUND_DEFAULT;
		break;
	case 2:
		*type = SOUND_FLASH;
		break;
	case 4:
		if (*type != SOUND_FILENAME)
			*val = '\0';
		*type = SOUND_FILENAME;
		break;
	default:
		*type = SOUND_INTERN;
		IntToStr(intVal - 6 + 1, 0, val, PATH_MAX);
		break;
	}
}
 
/*** ---------------------------------------------------------------------- ***/
/*DYJ 5.21b */
LOCAL _BOOL soundButton(OBJECT *tree, _VOID *env, _WORD button, _WORD mx, _WORD my, _UWORD kstate, _WORD clicks)
{
	GRECT r;
	soundStruct *soundInfo;
	_WORD typeSel;
	_WORD x, y;
	_UBYTE path[PATH_MAX];
	_UBYTE name[PATH_MAX];
	_UBYTE ext[PATH_MAX];
	OBJECT *soundSel;
	_BOOL res;
	_WORD avModus;
	
	UNUSED(mx);
	UNUSED(my);
	UNUSED(clicks);

	soundInfo = env;
	soundSel = TreeAddr[SOUND_EVPOPUP];
	/* Button auswerten */
	button &= 0x7fff;
	switch (button)
	{
	case SOUND_OK:
	case SOUND_CANCEL:
		if (button == SOUND_OK)
			getSounds(tree, &soundInfo->sounds[soundInfo->select].type, soundInfo->sounds[soundInfo->oldSelect].name);
		DelObjState(tree, button, SELECTED);
		return TRUE;
	
	case SOUND_HELP:
		CatHelp_DoHelp(CatHelp_sounds);
		DelObjState(tree, button, SELECTED);
		WinDials_WinDialDraw(tree, button, 1, &r, FALSE);
		break;
		
	case SOUND_EVENT0:
	case SOUND_EVENT1:
		getSounds(tree, &soundInfo->sounds[soundInfo->oldSelect].type, soundInfo->sounds[soundInfo->oldSelect].name);
		objc_offset(tree, SOUND_EVENT1, &x, &y);
		soundInfo->select = mtPopups_TreePopup(soundSel, x, y, VDIUtil_GetXState(tree, SOUND_EVENT1)) - 1;
		if (soundInfo->select >= 0)
		{
			VDIUtil_SetXState(tree, SOUND_EVENT1, soundInfo->select);
			VDIUtil_SetXString(tree, SOUND_EVENT1, soundSel, soundInfo->select);
			setSounds(tree, soundInfo->sounds[soundInfo->select].type, soundInfo->sounds[soundInfo->select].name);
			WinDials_WinDialDraw(tree, ROOT, MAX_DEPTH, &r, FALSE);
			soundInfo->oldSelect = soundInfo->select;
		} else
		{
			soundInfo->select = soundInfo->oldSelect;
		}
		break;
	
	case SOUND_EVENT2:
		getSounds(tree, &soundInfo->sounds[soundInfo->oldSelect].type, soundInfo->sounds[soundInfo->oldSelect].name);
		soundInfo->select = VDIUtil_GetXState(tree, SOUND_EVENT1);
		if(kstate&K_SHIFT)
			soundInfo->select = (soundInfo->select + SOUND_EVENTS-1) % SOUND_EVENTS;
		else
			soundInfo->select = (soundInfo->select + 1) % SOUND_EVENTS;
		VDIUtil_SetXState(tree, SOUND_EVENT1, soundInfo->select);
		VDIUtil_SetXString(tree, SOUND_EVENT1, soundSel, soundInfo->select);
		setSounds(tree, soundInfo->sounds[soundInfo->select].type, soundInfo->sounds[soundInfo->select].name);
		soundInfo->oldSelect = soundInfo->select;
		WinDials_WinDialDraw(tree, ROOT, MAX_DEPTH, &r, FALSE);
		break;
		
	case SOUND_FILE0:
	case SOUND_FILE:
		/* Neues Sample auswaehlen */
		if (soundInfo->sounds[soundInfo->oldSelect].name[0] != '\0')
		{
			mtDir_SplitPath(soundInfo->sounds[soundInfo->oldSelect].name, path, name, ext);
		} else
		{
			if (soundInfo->path[0] != '\0')
				strBcpy(path, soundInfo->path);
			else
				CatGlobal_ApplPath(path);
			*name = '\0';
		}
		res = mtDir_FselGet(path, name, ALL_FILE_MASK, MausTauschrsc_WrkString(FS_SELECT_SAMPLE), FALSE);
		if (res)
		{
			strBcpy(soundInfo->path, path);
			strBcpy(soundInfo->sounds[soundInfo->oldSelect].name, path);
			F_Path_Append(soundInfo->sounds[soundInfo->oldSelect].name, name);
			SetObjcString(tree, SOUND_FILE, name);
			WinDials_WinDialDraw(tree, SOUND_FILE, 1, &r, FALSE);
		}
		DelObjState(tree, button, SELECTED);
		WinDials_WinDialDraw(tree, button, 1, &r, FALSE);
		break;
	
	case SOUND_TYPE0:
	case SOUND_TYPE1:
		objc_offset(tree, SOUND_TYPE1, &x, &y);
		{
			_WORD w, h;
			
			w = tree[SOUND_TYPE1].ob_width;
			h = tree[SOUND_TYPE1].ob_height * 10;
			typeSel = ListDl_ListboxPopup(x, y + tree[SOUND_TYPE1].ob_height, w, h, bings, NUM_BINGS, VDIUtil_GetXState(tree, SOUND_TYPE1));
		}
		if (typeSel >= 0)
		{
			VDIUtil_SetXState(tree, SOUND_TYPE1, typeSel);
			getSounds(tree, &soundInfo->sounds[soundInfo->oldSelect].type, soundInfo->sounds[soundInfo->oldSelect].name);
			setSounds(tree, soundInfo->sounds[soundInfo->oldSelect].type, soundInfo->sounds[soundInfo->oldSelect].name);
			WinDials_WinDialDraw(tree, SOUND_TYPE1, 1, &r, FALSE);
			WinDials_WinDialDraw(tree, SOUND_FILE, MAX_DEPTH, &r, FALSE);
		}
		break;
		
	case SOUND_TYPE2:
		typeSel = VDIUtil_GetXState(tree, SOUND_TYPE1);
		do
		{
			if(kstate&K_SHIFT)
				typeSel = (typeSel + NUM_BINGS-1) % NUM_BINGS;
			else
				typeSel = (typeSel + 1) % NUM_BINGS;
		}
		while (bings[typeSel][0] == '-');
		VDIUtil_SetXState(tree, SOUND_TYPE1, typeSel);
		getSounds(tree, &soundInfo->sounds[soundInfo->oldSelect].type, soundInfo->sounds[soundInfo->oldSelect].name);
		setSounds(tree, soundInfo->sounds[soundInfo->oldSelect].type, soundInfo->sounds[soundInfo->oldSelect].name);
		WinDials_WinDialDraw(tree, SOUND_TYPE1, 1, &r, FALSE);
		WinDials_WinDialDraw(tree, SOUND_FILE, MAX_DEPTH, &r, FALSE);
		break;
	
	case SOUND_TEST:
		switch (soundInfo->sounds[soundInfo->oldSelect].type)
		{
		case SOUND_NONE:
			break;
		case SOUND_DEFAULT:
			Sound_Bing();
			break;
		case SOUND_FLASH:
			Sound_Flash();
			break;
		case SOUND_INTERN:
			Sound_Play_Intern(StrToInt(soundInfo->sounds[soundInfo->oldSelect].name, NULL, NULL));
			break;
		case SOUND_FILENAME:
			ConfVars_GetConfDefInt(cAvModus, &avModus, 2);
			Sound_Play_Filename(soundInfo->sounds[soundInfo->oldSelect].name,avModus);
			break;
		}
		DelObjState(tree, button, SELECTED);
		WinDials_WinDialDraw(tree, button, 1, &r, FALSE);
		break;
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID soundGetSetValues(OBJECT *tree, _VOID *env, _BOOL set, _WORD exit)
{
	soundStruct *soundInfo;
	_WORD i;
	OBJECT *soundSel;
	_UBYTE varName[128];
	
	soundInfo = env;
	soundSel = TreeAddr[SOUND_EVPOPUP];
	exit &= 0x7fff;
	if (set)
	{
		/* Strings einsetzen */
		for (i = 0; i < SOUND_EVENTS; i++)
		{
			/* Array fuellen
			 */
			strBcpy(varName, cBingEvent);
			strBcat(varName, ".");
			strBcat(varName, sounds[i].event);
			ConfVars_GetConfDefInt(varName, &soundInfo->sounds[i].type, sounds[i].type);
			strBcpy(varName, cBingEventName);
			strBcat(varName, ".");
			strBcat(varName, sounds[i].event);
			ConfVars_GetConfDefStr(varName, soundInfo->sounds[i].name, PATH_MAX, sounds[i].val);
		}
		soundInfo->select = 0;
		soundInfo->oldSelect = soundInfo->select;
		setSounds(tree, soundInfo->sounds[soundInfo->select].type, soundInfo->sounds[soundInfo->select].name);
		/* vorbereiten */
		VDIUtil_SetXState(tree, SOUND_EVENT1, soundInfo->select);
		VDIUtil_SetXString(tree, SOUND_EVENT1, soundSel, soundInfo->select);
	} else
	{
		if (exit == SOUND_OK)
		{
			for (i = 0; i < SOUND_EVENTS; i++)
			{
				strBcpy(varName, cBingEvent);
				strBcat(varName, ".");
				strBcat(varName, sounds[i].event);
				ConfVars_SetConfigInt(varName, soundInfo->sounds[i].type);
				strBcpy(varName, cBingEventName);
				strBcat(varName, ".");
				strBcat(varName, sounds[i].event);
				ConfVars_SetConfigString(varName, soundInfo->sounds[i].name);
			}
			CatOpts2_InitSounds();
		}
		OFREE(soundInfo);
	}
}
/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID CatOpts2_EditSounds(_VOID)
{
	OBJECT *soundBox;
	soundStruct *soundInfo;
	
	soundInfo = NEW(soundStruct, "CatOpts2_EditSounds");
	if (soundInfo == NULL)
		return;
	soundBox = TreeAddr[SOUND_DIALOG];
	MemSetZeroStruct(*soundInfo);
	if (!WinDials_OpenWinDial(soundBox, FALSE,
		soundGetSetValues,
		soundGetSetValues,
		soundButton,
		WinDials_defDraw,
		NULL,
		soundInfo))
	{
		OFREE(soundInfo);
	}
}
