/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */


#include <execv.h>
#include <magictyp.h>
#include <tos.h>
#include <atari.h>
#include <routines.h>
#include <portaes.h>

GLOBAL _UBYTE *Environment;
/*** ------------------------------------------------------------------------ ***/
/*	size_t ExecV_lenQu2Argv(CONST _UBYTE *cmdln,_BOOL useQuotes)				*/
/*	gibt zurck wie lang die Kommandozeile als ARGV wird						*/
/*	Parameter:	cmdln:	Die Kommandozeile										*/
/*				useQuotes: sind teile gequotet?									*/
/*	Ergebnis:	Lnge															*/		
/*	3.8.02 von Dimitri Junker	DYJ 4.41a										*/
/*** ------------------------------------------------------------------------ ***/
GLOBAL size_t ExecV_lenQu2Argv(CONST _UBYTE *cmdln,_BOOL useQuotes)
{
	size_t cl = 0,D0=1;
	if(useQuotes)
	{
		for (;;)
		{
			_BOOL inQuote=FALSE;
			/* Leerzeichen ueberlesen */
			while (cmdln[D0] == ' ')
				++D0;
			if (cmdln[D0] < ' ')     /* Fertig */
				break;
			while (cmdln[D0] > ' ' || (cmdln[D0] == ' ' && inQuote))              /* Argument */
			{
				if(cmdln[D0]=='\'')
				{
					D0++;
					if(inQuote)
					{
						if(cmdln[D0]=='\'')
							cl++, D0++;
						else
							inQuote=FALSE;
					}
					else
						inQuote=TRUE;
				}
				else
					cl++, D0++;
			}
			cl++;                               /* Platz fuer trennendes 0C/' ' */
		}
	}
	else
	{
		for (;;)
		{
			/* Leerzeichen ueberlesen */
			while (cmdln[D0] == ' ')
				++D0;
			if (cmdln[D0] < ' ')     /* Fertig */
				break;
			while (cmdln[D0] > ' ')              /* Argument */
				cl++, D0++;
			cl++;                               /* Platz fuer trennendes 0C/' ' */
		}
	}
	return cl+1;
}
/*** ------------------------------------------------------------------------ ***/
/*	_VOID ExecV_Qu2Argv(_UBYTE *p,CONST _UBYTE *path,CONST _UBYTE *cmdln,_BOOL useQuotes)	*/
/*	wandelt die Kommandozeile in eine ARGV-Tabelle								*/
/*	Parameter:	p:			das Ziel											*/
/*				path:		Pfad des aufzurufenden Programms					*/
/*				cmdln:		Die Kommandozeile									*/
/*				useQuotes: sind teile gequotet?									*/
/*	Ergebnis:	keines															*/		
/*	3.8.02 von Dimitri Junker	DYJ 4.41a										*/
/*** ------------------------------------------------------------------------ ***/
GLOBAL _VOID ExecV_Qu2Argv(_UBYTE *p,CONST _UBYTE *path,CONST _UBYTE *cmdln,_BOOL useQuotes)
{
	size_t D0=1;
	CONST _UBYTE *ptr;
	if(useQuotes)
	{
		*p++ = 'A';
		*p++ = 'R';
		*p++ = 'G';
		*p++ = 'V';
		*p++ = '=';
		*p++ = '\0';
		ptr = path;
		while ((*p++ = *ptr++) != '\0')
			;
		for (;;)
		{
			_BOOL inQuote=FALSE;
			/* Leerzeichen ueberlesen */
			while (cmdln[D0] == ' ')
				++D0;
			if (cmdln[D0] < ' ')     /* Fertig */
				break;
			while (cmdln[D0] > ' ' || (cmdln[D0] == ' ' && inQuote))              /* Argument */
			{
				if(cmdln[D0]=='\'')
				{
					D0++;
					if(inQuote)
					{
						if(cmdln[D0]=='\'')
							*p++ = cmdln[D0++];
						else
							inQuote=FALSE;
					}
					else
						inQuote=TRUE;
				}
				else
					*p++ = cmdln[D0++];
			}
			*p++ = '\0';
		}
	}
	else
	{
		*p++ = 'A';
		*p++ = 'R';
		*p++ = 'G';
		*p++ = 'V';
		*p++ = '=';
		*p++ = '\0';
		ptr = path;
		while ((*p++ = *ptr++) != '\0')
			;
		for (;;)
		{
			/* Leerzeichen ueberlesen */
			while (cmdln[D0] == ' ')
				++D0;
			if (cmdln[D0] < ' ')     /* Fertig */
				break;
			while (cmdln[D0] > ' ')              /* Argument */
				*p++ = cmdln[D0++];
			*p++ = '\0';
		}
		*p++ = '\0';
	}
}
/*** ------------------------------------------------------------------------ ***/
/*	_UBYTE * mkEnv4ARGV(CONST _UBYTE *path, _UBYTE *cmdln, CONST _UBYTE *Env,_BOOL useQuotes)	*/
/*	Fgt dem Environment die ARGV Information hinzu								*/
/*	Parameter:	path:	Pfad des zu startenden Programms						*/
/*				cmdln:	Die ggf. gequotete Kommandozeile						*/
/*				Env:	Environment String, darf auch NULL sein					*/
/*				useQuotes: Ist cmdln gequotet?									*/
/*	Ergebnis:	Environment String (mu freigegeben werden!)					*/		
/*	18.9.02 von Dimitri Junker	DYJ 4.42r war Teil von ExecV_Pexec				*/
/*** ------------------------------------------------------------------------ ***/
LOCAL _UBYTE * mkEnv4ARGV(CONST _UBYTE *path, _UBYTE *cmdln, CONST _UBYTE *Env,_BOOL useQuotes)
{
	CONST _UBYTE *orig_env;
	CONST _UBYTE *ptr;
	_UBYTE *p;
	CONST _UBYTE *bis;
	size_t el, pl, cl;
	_UBYTE *env;

	if (Env == NULL || *Env == '\0')
	{
		orig_env = GetEnvironment();
	} else
	{
		orig_env = Env;
	}

	ptr = orig_env;
	el = 0;
	while (*ptr != '\0')
	{
		while (*ptr != '\0')
			ptr++, el++;
		ptr++, el++;
	}
	pl = strLen(path) + 1;
	cl=ExecV_lenQu2Argv(cmdln,useQuotes);
	env = Malloc(el + 7 + pl + cl);      /* 7: "ARGV=" */
	Environment = env;
	if (env != NULL)
	{
		p = env;
		ptr = orig_env;
		bis = ptr + el;
		/* Altes Environment kopieren bis auf 
		 * alten ARGV, falls vorhanden
		 */
		while (ptr < bis)
		{
			if (ptr[0] == 'A' &&
				ptr[1] == 'R' &&
				ptr[2] == 'G' &&
				ptr[3] == 'V' &&
				ptr[4] == '=')
			{
				/* sollte sowieso das letzte Element sein,
				 * also brechen wir die Suche hier ganz ab
				 */
				break;
			}
			*p++ = *ptr++;
		}
		ExecV_Qu2Argv(p,path,cmdln,useQuotes);
		cmdln[0] = '\177'; /* ARGV-Kennung */
	}
	if (Env == NULL || *Env == '\0')
		FreeEnvironment(orig_env);
	return(env);
}
GLOBAL _WORD ExecV_Pexec(_UWORD mode, CONST _UBYTE *Path, _UBYTE *CmdLn, CONST _UBYTE *Env,_BOOL useQuotes)
{
	_UBYTE *env;
	_WORD res;
	
	if (*Path == '\0' || *CmdLn == '\0')
		return (_WORD)Pexec(mode, Path, CmdLn, Env);
	env=mkEnv4ARGV(Path,CmdLn,Env,useQuotes);
	res = (_WORD)Pexec(mode, Path, CmdLn, env);
	if (mode == 0 /* LoadnGo */ )
	{
		if (Environment != NULL)
		{
			Mfree(Environment);
			Environment = NULL;
		}
	}
	return res;
}
/*** ------------------------------------------------------------------------ ***/
/*	_WORD ExecV_Shelw(_UBYTE *Path, _UBYTE *CmdLn,_BOOL useQuotes)				*/
/*	Wie ExecV_Pexec aber hier wird statt Pexec shel_write im Extended Mode		*/
/*	benutzt, deshalb erst ab AES 4.0											*/
/*	Parameter:	Path:	Zu startendes Programm									*/
/*				CmdLn:	Kommandozeile, Parameter mit Leerstellen gequotet		*/
/*	Ergebnis:	ID des neuen Prozesses oder <0 bei Fehler						*/		
/*	18.9.02 von Dimitri Junker	DYJ 4.42r										*/
/*** ------------------------------------------------------------------------ ***/
GLOBAL _WORD ExecV_Shelw(_UBYTE *Path, _UBYTE *CmdLn)
{
	_WORD res=-1;
	_WORD ap_gout1,ap_gout2,ap_gout3,ap_gout4;
	SHWPARBLK shwp;
	if(gl_ap_version >= 0x0400)
	{
		appl_getinfo(APG_SHELLW,&ap_gout1,&ap_gout2,&ap_gout3,&ap_gout4);
		if(ap_gout1&0x800)
		{
	        shwp.prgname=Path;
    	    shwp.environment=mkEnv4ARGV(Path,CmdLn,NULL,TRUE);
			if (shwp.environment != NULL)
			{
				res=shel_writeX(0,1,1,&shwp,CmdLn);
				Mfree(shwp.environment);
				shwp.environment = NULL;
			}
				
		}
	}
	return res;
}