/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */


#include <genderte.h>
#include <routines.h>

typedef struct {
	_UBYTE name[4];
	Sex sex;
} nameSex;

typedef struct {
	CONST _UBYTE *name;
	Sex sex;
} exceptSex;

LOCAL CONST nameSex two[] = {
	{ "rk", Sex_male   },
	{ "an", Sex_male   },
	{ "en", Sex_male   },
	{ "al", Sex_male   },
	{ "re", Sex_male   },
	{ "r", Sex_male   },
	{ "ne", Sex_female },
	{ "n", Sex_male   },
	{ "on", Sex_male   },
	{ "ip", Sex_male   },
	{ "us", Sex_male   },
	{ "el", Sex_male   },
	{ "ji", Sex_male   },
	{ "lf", Sex_male   },
	{ "ng", Sex_male   },
	{ "ks", Sex_male   },
	{ "im", Sex_male   },
	{ "in", Sex_male   },
	{ "te", Sex_female }, 
	{ "it", Sex_female }, 
	{ "ni", Sex_female }, 
	{ "li", Sex_female }, 
	{ "ie", Sex_female }, 
	{ "ls", Sex_male   },
	{ "ly", Sex_male   },
	{ "id", Sex_male   },
	{ "ld", Sex_male   },
	{ "ce", Sex_female },
	{ "ze", Sex_female },
	{ "ed", Sex_male   },
	{ "id", Sex_male   },
	{ "rn", Sex_male   },
	{ "ph", Sex_male   },
	{ "rd", Sex_male   },
	{ "tz", Sex_male   },
	{ "rt", Sex_male   },
	{ "st", Sex_male   },
	{ "tl", Sex_female }, 
	{ "ll", Sex_female }, 
	{ "nd", Sex_male   },
	{ "nz", Sex_male   },
	{ "ai", Sex_male   },
	{ "av", Sex_male   },
	{ "af", Sex_male   },
	{ "ut", Sex_male   },
	{ "pf", Sex_male   },
	{ "is", Sex_male   },
	{ "am", Sex_male   },
	{ "ev", Sex_male   },
	{ "ew", Sex_male   },
	{ "dt", Sex_male   },
	{ "ti", Sex_male   },
	{ "ge", Sex_male   },
	{ "ud", Sex_female },
	{ "un", Sex_female },
	{ "pp", Sex_male   },
	{ "di", Sex_male   },
	{ "ck", Sex_male   },
	{ "ad", Sex_male   },
	{ "nn", Sex_male   },
	{ "as", Sex_male   },
	{ "rs", Sex_male   },
	{ "kt", Sex_male   },
	{ "ns", Sex_male   },
	{ "ik", Sex_male   },
	{ "ic", Sex_male   },
	{ "rc", Sex_male   },
	{ "rl", Sex_male   },
	{ "nk", Sex_male   },
	{ "lm", Sex_male   },
	{ "ot", Sex_male   },
	{ "ig", Sex_male   },
	{ "aw", Sex_male   },
	{ "ul", Sex_male   },
	{ "mm", Sex_male   },
	{ "om", Sex_male   },
	{ "ry", Sex_male   },
	{ "we", Sex_male   },
	{ "ny", Sex_male   },
	{ "rg", Sex_male   },
};
#define maxTwo ((_UWORD)(sizeof(two) / sizeof(two[0])))

LOCAL CONST nameSex three[] = {
	{ "ild", Sex_female },
	{ "rut", Sex_female },
	{ "lja", Sex_male   },
	{ "ich", Sex_male   },
	{ "rdt", Sex_male   },
	{ "rit", Sex_male   },
	{ "oud", Sex_male   },
	{ "shi", Sex_male   },
	{ "rid", Sex_female },
	{ "rne", Sex_male   },
	{ "uth", Sex_male   },
	{ "eth", Sex_female },
	{ "nes", Sex_male   },
	{ "hem", Sex_male   },
	{ "ies", Sex_female },
	{ "yes", Sex_male   },
	{ "ree", Sex_male   },
	{ "ike", Sex_male   },
	{ "uez", Sex_male   },
	{ "ali", Sex_male   },
	{ "nee", Sex_female },
	{ "tel", Sex_female },
	{ "got", Sex_female },
};
#define maxThree ((_UWORD)(sizeof(three) / sizeof(three[0])))

LOCAL CONST exceptSex excepts[] = {
	{ "ole", Sex_male},
	{ "Esther", Sex_female },
	{ "Dagmar", Sex_female },
	{ "Rike", Sex_female },
	{ "Ulrike", Sex_female },
	{ "Jennifer", Sex_female },
	{ "Malte", Sex_male},
	{ "Maren", Sex_female },
	{ "Micha", Sex_male},
	{ "Susan", Sex_female },
	{ "Ann", Sex_female },
	{ "Hotte", Sex_male},
	{ "Ines", Sex_female },
	{ "Inez", Sex_female },
	{ "Toni", Sex_male},
	{ "Knud", Sex_male},
	{ "Till", Sex_male},
	{ "Mika", Sex_male},
	{ "Janne", Sex_male},
	{ "Willi", Sex_male},
	{ "Toni", Sex_male},
	{ "Eddi", Sex_male},
	{ "Jose", Sex_male},
	{ "Veli", Sex_male},
	{ "Ulli", Sex_male},
	{ "Edi", Sex_male},
	{ "Sami", Sex_male},
	{ "Ronnie", Sex_male},
	{ "Joe", Sex_male},
	{ "Zoe", Sex_female },
	{ "Ilja", Sex_male},
	{ "Hauke", Sex_male},
	{ "Doris", Sex_female },
	{ "Boris", Sex_male},
	{ "Kirsten", Sex_female },
	{ "Kerstin", Sex_female },
	{ "Kristin", Sex_female },
	{ "S\224nke", Sex_male},
	{ "Soenke", Sex_male},
	{ "Soehnke", Sex_male},
	{ "S\224hnke", Sex_male},
	{ "Almut", Sex_female },
	{ "Allmut", Sex_female },
	{ "Almuth", Sex_female },
	{ "Allmuth", Sex_female },
	{ "Carmen", Sex_female },
	{ "Gianni", Sex_male},
	{ "Altfrid", Sex_male},
	{ "Giovanni", Sex_male},
	{ "Giuseppe", Sex_male},
};
#define maxExc ((_UWORD)(sizeof(excepts) / sizeof(excepts[0])))


/* Liefert zurueck, ob ein Name weiblich oder maennlich ist. 
 */
GLOBAL Sex GenderTest_SexTest(CONST _UBYTE *name)
{
	_UWORD i;
	size_t len;
	_UBYTE lastCh;
	_UBYTE lastTwo[4];
	_UBYTE lastThree[4];
	Sex sex;

	/* Variablen initialisieren */
	sex = Sex_unknown;
	
	len = strLen(name);
	if (len < 2)
		return sex;
	
	lastCh = ucase(name[len-1]);
	lastTwo[2] = '\0';
	lastTwo[1] = lastCh;
	lastTwo[0] = ucase(name[len-2]);
	
	if (len > 2)
	{
		lastThree[3] = '\0';
		lastThree[2] = lastCh;
		lastThree[1] = ucase(name[len-2]);
		lastThree[0] = ucase(name[len-3]);
	}
	
	/* Erstmal einbuchstabige Abfragen */
	switch (lastCh)
	{
		case 'A': sex = Sex_female; break;
		case 'R': sex = Sex_male; break;
		case 'O': sex = Sex_male; break;
		case 'E': sex = Sex_female; break;
		case 'Y': sex = Sex_female; break;
		case 'F': sex = Sex_male; break;
		case 'X': sex = Sex_male; break;
	}
	
	for (i = 0; i < maxTwo; i++)
	{
		if (strCaseCmp(lastTwo, two[i].name) == 0)
		{
			sex = two[i].sex;
			break;
		}
	}
	
	for (i = 0; i < maxThree; i++)
	{
		if (strCaseCmp(lastThree, three[i].name) == 0)
		{
			sex = three[i].sex;
			break;
		}
	}
	
	for (i = 0; i < maxExc; i++)
	{
		if (strCaseCmp(name, excepts[i].name) == 0)
		{
			sex = excepts[i].sex;
			break;
		}
	}
	
	return sex;
}


#ifdef MAIN
int main(int argc, CONST _UBYTE **argv)
{
	CONST _UBYTE *arg;
	Sex sex;

	while (--argc)
	{
		arg = *++argv;
		sex = GenderTest_SexTest(arg);
		printf("%s ist %s\n",
			arg,
			sex == Sex_male ? "m\204nnlich" :	/* :language: */ a
			sex == Sex_female ? "weiblich" :
			"unbekannt");
	}
	return 0;
}
#endif
