/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */



/*
 * 26.1.03 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.20d'
 * 'Beantwortete' man eine eigene Mail, also so, da der Empfnger der Ursprungsmail
 *	eine weitere erhlt, so wurde als Empfngeradresse richtig die des alten Empfngers benutzt,
 *	als Realname des Empfngers allerdings die eigene
 *
 * 17.2.03 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.21c'
 *	Betreffs sind bei der Maus auf 79 Zeichen begrenzt, fr's
 *	Internet gilt das aber nicht.
 *
 * 5.4.04 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.35f'
 *	Man konnte keine PsudoNews in eine Gruppe schreiben wenn der
 *	Server noch nicht eingestellt war und noch keine News in ihr
 *	vorhanden war.
 */

#include <grintool.h>
#include <vdiutil.h>
#include <messages.h>
#include <cattypes.h>
#include <catgloba.h>
#include <wdwmanag.h>
#include <data.h>
#include <grin.h>
#include <maustaus.h>
#include <mte.h>
#include <listhelp.h>
#include <groupsel.h>
#include <adr.h>
#include <infofile.h>

#include <mtutils.h>

#include <routinec.h>
#include <routines.h>
#include <routine.h>
#include <confvars.h>
#include <varname1.h>
#include <userinfo.h>


LOCAL _UBYTE oldComment[256];

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

GLOBAL size_t grinTools_LengthOfRSC(CONST _UBYTE *str)
{
	size_t l;

	l = 0;
	while (*str != '\0')
	{
		switch (*str)
		{
		case 0x84: /* ae */
		case 0x94: /* oe */
		case 0x81: /* ue */
		case 0x8e: /* Ae */
		case 0x99: /* Oe */
		case 0x9a: /* Ue */
		case 0x9e: /* ss */
		case 0xe1: /* ss */
			l++;
			break;
		}
		l++;
		str++;
	}
	return l;
}

/*** ---------------------------------------------------------------------- ***/
/*DYJ 5.21b */
GLOBAL _BOOL grinTools_CheckBetreff(_UBYTE *Betreff)
{
	_BOOL ok;
	group_line tmp;
	_UBYTE *s;
	
	strBcpy(tmp, Betreff);
	CatGlobal_ReplaceChar(tmp, ' ', '\0');
	if (tmp[0] == '\0')
	{
		MTE_infoRSC(AL_EMPTY_WEGEN);
		return FALSE;
	} else
	{
		/* Auf Sonderzeichen untersuchen, insbesondere CR/LF */
		ok = TRUE;
		s = Betreff;
		while (*s != '\0' && ok)
		{
			ok = ((*s)&0xFE)!=0xc;
			s++;
		}
		if (!ok)
		{
			if (mtAlerts_AlertRSC(1, AL_WRONG_WEGEN) == 2)
			{
				s = Betreff;
				while (*s != '\0')
				{
					if (((*s)&0xFE)==0xc)
					{
						/* Zeichen loeschen */
						strCpy(s, s+1);
					} else
					{
						s++;
					}
				}
				return TRUE;
			}
			return FALSE;
		}
	}
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/
/*DYJ 5.20w */
GLOBAL _BOOL grinTools_BetreffHolen(HWND grinWdw, _UBYTE *Betreff, size_t strsize, CONST _UBYTE *optStr, CONST _UBYTE *WGruppe, CONST _UBYTE *preStr, BETR_HOL_MOD bhMode)
{
	_WORD exit;
	_WORD csm;
	_BOOL ok,addRe;
	OBJECT *wegen;

	wegen = TreeAddr[WEGEN];
	switch(bhMode)
	{
		case	BH_ASK_GRIN_RE:
			ConfVars_GetConfDefBool(cAddReToSubject,&addRe,UserBLK.isInternet);
			if(addRe && strsize>4)
			{
				strnCpy(Betreff,"Re: ",strsize);
				grin_ActualSubject(grinWdw, Betreff+4, strsize-4);
				if(strnCaseCmp(Betreff+4,"Re:",3))
					break;
			}
		case	BH_ASK_GRIN:
			grin_ActualSubject(grinWdw, Betreff, strsize);
		case	BH_LEER:
			break;
	}
	SetObjcStringAdr(wegen, WGRUPPE, WGruppe, sizeof(group_line) + 1);
	SetObjcStringAdr(wegen, OPTSTR, optStr, strLen(optStr) + 1);
	SetObjcStringAdr(wegen, PRESTR, preStr, strLen(preStr) + 1);
	ConfVars_GetConfDefInt(cChangeSubjectMode,&csm,UserBLK.isInternet ?3:0);
	if(csm&1)
	{
		_UBYTE *ptr,*elim=Betreff,war[100];
		ConfVars_GetConfDefStr(cChangeSubjAlt2Was,war,sizeof(war),"war:");
		while((elim=strChr(elim+1,'('))!=NULL)
		{
			ptr=elim+1;
			while(*ptr==' ')
				ptr++;
			if(((strnCaseCmp(ptr,"was:",4)==0)||(*war && strnCaseCmp(ptr,war,strLen(war))==0)) && strCmp(strrChr(ptr,')'),")")==0)
				break;
		}
		if(elim)
		{
			do
				elim--;
			while(*elim==' ');
			elim[1]='\0';
		}
	}
				
	SetObjcString(wegen, WEGENSTR, Betreff);
	ok = FALSE;
	do
	{
		exit = VDIUtil_FormHandle(wegen);

		if(csm&2 && *Betreff && strCmp(Betreff,ObjcStringAdr(wegen, WEGENSTR)))
		{
			group_line betreffN;
			ObjcString(wegen, WEGENSTR, betreffN, sizeof(betreffN));
			strBcat(betreffN," (was: ");
			strBcat(betreffN,Betreff);
			strBcat(betreffN,")");
			strMcpy(Betreff,strsize,betreffN);
		}
		else
			ObjcString(wegen, WEGENSTR, Betreff, strsize);

		if (exit != WEGEN_CANCEL)
			ok = grinTools_CheckBetreff(Betreff);
	} while (exit != WEGEN_CANCEL && !ok);
	SetObjcStringAdr(wegen, WGRUPPE, "", 1);
	SetObjcStringAdr(wegen, OPTSTR, "", 1);
	SetObjcStringAdr(wegen, PRESTR, "", 1);
	if (exit == WEGEN_CANCEL)
		return FALSE;
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/
/*DYJ 5.21b */
LOCAL _BOOL CheckWriteAccess(CONST _UBYTE *GrName,_BOOL fup)
{
	if (!GroupSelect_GetWriteAccess(GrName))
	{
		if(fup)
		{
			char txt[256];
			sprintf(txt,MausTauschrsc_WrkString(AL_NO_WRITEACCESS_F),GrName);
			return mtAlerts_Alert(1, txt) == 1;
		}
		else
			return mtAlerts_AlertRSC(1, AL_NO_WRITEACCESS) == 1;
	}
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

/*DYJ 5.21b */
LOCAL _VOID MakeLine(HWND grinWdw, _UBYTE *txt, size_t txtsize)
{
	_UBYTE scrap[1024];
	size_t z;
	grin_WWline(grinWdw, txt, txtsize);
	if(!*txt)
	{

		grin_ActualID(grinWdw, scrap, sizeof(scrap));
		z = strLen(scrap);
		strMcpy(txt, txtsize, z < 66 ? MausTauschrsc_WrkString(FS_COMMENT) : "-");
		strMcat(txt, txtsize, scrap);
		z = strLen(txt);
		if (z > 80)
		{
			txt[75] = '\0';
			strMcat(txt, txtsize, "[..]");
		} else if (z < 65)
		{
			strMcat(txt, txtsize, MausTauschrsc_WrkString(FS_IN_GROUP));
			grin_ActualGroup(grinWdw, scrap, sizeof(scrap));
			GroupSelect_GetNetName(scrap);
			strMcat(txt, txtsize, scrap);
		}
	}
}
/*** ------------------------------------------------------------------------ ***/
/*	_BOOL grintool_getMlServ(CONST CAT_GROUP_NUMBER catNumber,CONST _UBYTE *gName,group_line followup)	*/
/*	versucht aus den letzten Pseudonews einer Gruppe den Server zu ermitteln.	*/
/*	da dies nicht eindeutig ist wird der User gefragt ob's OK ist.				*/
/*	Parameter:	catNumber und gName: die Gruppe als Nummer und Name				*/
/*				followup: fr Rckgabe											*/
/*	Ergebnis:	OK?														*/		
/*	4.3.04 von Dimitri Junker	DYJ 5.34d										*/
/*** ------------------------------------------------------------------------ ***/
GLOBAL _BOOL grintool_getMlServ(CONST CAT_GROUP_NUMBER catNumber,CONST _UBYTE *gName,group_line followup)
{
	MSGNR msgMax,msg;
	_BOOL ret=FALSE;
	oneHandleElement *handle;
	*followup='\0';
/*DYJ 5.35f Start*/
	if ((msgMax=data_LastMsgOfGroup(catNumber)) != dataSys_empty &&
		(handle = handlePool_GetOneDatahandle(catNumber)) != NULL)
	{
		for(msg=msgMax;msg>msgMax-5 && msg>=0;msg--)
		{
			MessageType mess;
			data_ReadHeader(handle->Zugriff, msg, &mess,FALSE);
			if(*(mess.replyTo))
			{
				strCpy(followup,mess.replyTo);
				break;
			}
			if(*(mess.sender))
			{
				strCpy(followup,mess.sender);
				break;
			}
		}
	}
	if(adr_SelectName(ADR_MLIST,followup, sizeof(group_line)))
	{
		GroupSelect_SetGrpParN(gName,followup,LS_FOLLOWUP_LINE);
		ret=TRUE;
	}
/*DYJ  Ende; alt:	
	if ((msgMax=data_LastMsgOfGroup(catNumber)) == dataSys_empty)
		return FALSE;
	if ((handle = handlePool_GetOneDatahandle(catNumber)) != NULL)
	{
		for(msg=msgMax;msg>msgMax-5;msg--)
		{
			MessageType mess;
			data_ReadHeader(handle->Zugriff, msg, &mess,FALSE);
			if(*(mess.replyTo))
			{
				strCpy(followup,mess.replyTo);
				break;
			}
			if(*(mess.sender))
			{
				strCpy(followup,mess.sender);
				break;
			}
		}
		if(*followup && adr_SelectName(ADR_MLIST,followup, sizeof(group_line)))
		{
/*DYJ 5.35c Start*/
			GroupSelect_SetGrpParN(gName,followup,LS_FOLLOWUP_LINE);
/*DYJ  Ende; alt:	
			GroupSelect_SetFollowUpN(gName,followup);
*/
			ret=TRUE;
		}
	}
*/
	

	return ret;
}

/*** ---------------------------------------------------------------------- ***/
/*DYJ 5.16q */	/*DYJ 5.19g */	/*DYJ 5.20w */	/*DYJ 5.21b */
LOCAL _VOID HandleCommentResult(HWND grinWdw, ActionType result)
{
	group_line Betreff;
	group_line Gr;
	group_line mid;
	group_line receiver;
	group_line replyto;
	group_line realName;
	group_line sender;
	group_line txt;
	group_line refId;
	group_line orgGroup;
	group_line from;
	CONST _UBYTE *fromP;
	_UBYTE references[1024]="";
	_BOOL aar;
	group_line followup;

	tDistribution dist;
	_BOOL otherReceiver;
	_BOOL isSysop;
	_WORD res;
	_WORD but;
	CAT_GROUP_NUMBER group_nr;
	OBJECT *reply;
	_BOOL hasFUP=FALSE,isPseudoOM=FALSE;	/*DYJ 5.34d */
	
	/* Erstmal Kram holen, den wir eventuell brauchen */
	grin_ActualGroup(grinWdw, orgGroup, sizeof(orgGroup));
	grin_ActualID(grinWdw, refId, sizeof(refId));
	grin_ActualMId(grinWdw, mid, sizeof(mid));
	grin_ActualDist(grinWdw, &dist);
	grin_ActualFrom(grinWdw, receiver, sizeof(receiver));
	grin_ActualReplyto(grinWdw, replyto, sizeof(replyto));
	grin_ActualName(grinWdw, realName, sizeof(realName));
	grin_ActualSender(grinWdw, sender, sizeof(sender));
	grin_ActualFollowup(grinWdw, followup, sizeof(followup));
	if((result == Action_comment||result == Action_otherGroup))
	{
		grin_ActualRef(grinWdw, references, sizeof(references));
		if((strLen(references)+strLen(refId)+4)>sizeof(references))	/*References krzen*/
			*references='\0';
		if(!(*references))	/*Falls das alte references zu lang ist, oder leer(z.B. Cat<5) dann nur refId*/
		{
			grin_ActualRefId(grinWdw, references+1, sizeof(references)-2);
			if(references[1])
			{
				*references='<';
				strCat(references,">");
			}
		}
		if(*references && *refId)
			strCat(references," ");
		if(refId)
		{
			strMcat(references,sizeof(references),"<");
			strMcat(references,sizeof(references),refId);
			strMcat(references,sizeof(references),">");
		}
	}

/*DYJ 5.34d Start*/
	if (grin_EAdrCmp(receiver, sender) == 0)
		*sender = '\0';
	if (grin_EAdrCmp(receiver, replyto) == 0)
		*replyto = '\0';
	hasFUP=GroupSelect_GetFollowUp(orgGroup, Gr);
	if (GroupSelect_GroupNumber(orgGroup, &group_nr))
		isPseudoOM=GroupSelect_isPseudoOM(group_nr);
	if(isPseudoOM&&!hasFUP)
		hasFUP=grintool_getMlServ(group_nr,orgGroup,Gr);
	if(hasFUP)
	{
		if (grin_EAdrCmp(Gr, sender) == 0)
			*sender = '\0';
		if (grin_EAdrCmp(Gr, replyto) == 0)
			*replyto = '\0';
	}
/*DYJ  Ende; alt:	
	if (strCaseCmp(receiver, sender) == 0)
		*sender = '\0';
	if (strCaseCmp(receiver, replyto) == 0)
		*replyto = '\0';
*/
	otherReceiver = FALSE;
	isSysop = Infofiles_IsInfoFile(ISB_SHORT_NAME, TRUE);
	
	/* Wenn Follow-Up = "Poster" ist, dann soll eine PM daraus werden */
	if( result==Action_comment && strCaseCmp(followup, "POSTER")==0 )
	{
		if( mtAlerts_AlertRSC(2, AL_FOLLOW_PM)==1 )
			result=Action_answer;
		else
		{
			/* Follow-Up lschen, Gruppe "Poster" macht keinen Sinn... */
			*followup='\0';
		}
	}
	if (result == Action_comment)
	{
		strBcpy(txt, refId);
		txt[40] = '\0';
		if (txt[39] != '\0')
			txt[39] = '\003';		/* TODO */
		if (grinTools_BetreffHolen(grinWdw, Betreff, sizeof(Betreff), MausTauschrsc_WrkString(FS_KEY_COMMENT), txt, MausTauschrsc_WrkString(FS_WEGEN), BH_ASK_GRIN_RE))
		{
			grin_grinNewState(grinWdw, 'K');
			res = 1;
/*DYJ 5.34d Start*/
			if(hasFUP && strChr(Gr,'@'))
				res=0;
			else if(hasFUP && CheckWriteAccess(Gr,TRUE))
/*DYJ  Ende; alt:	
			if (GroupSelect_GetFollowUp(orgGroup, Gr) && CheckWriteAccess(Gr,TRUE))
*/
			{
				if(isSysop)
				{
					if(*followup && strSortCmp(followup,Gr) && CheckWriteAccess(followup,TRUE))		/* Dann haben wir 3 Mglichkeiten: Original, F'Up und G-F'up*/ 
					{
						switch(mtAlerts_AlertRSC(2, AL_SYSOP_FUP3))
						{
							case 2:		/*Msg-F'Up*/
								strMcpy(Gr, sizeof(Gr), followup);
							case 3:		/*Gruppen-F'Up*/
								res=2;
							case 1:		/*Original*/
								break;
						}
					}
					else											/* Dann haben wir 2 Mglichkeiten: Original und G-F'up*/ 
						res=mtAlerts_AlertRSC(2, AL_SYSOP_FUP);
				}
				else
				{
					res=2;				/* Original geht nicht da mindestens G-F'up beachtet werden mu*/
					if(*followup && strSortCmp(followup,Gr) && CheckWriteAccess(followup,TRUE))		/* Dann haben wir 2 Mglichkeiten: F'Up und G-F'up*/ 
					{
						if(mtAlerts_AlertRSC(1, AL_SYSOP_FUP2)==1)
							strMcpy(Gr, sizeof(Gr), followup);
					}
				}
			}
			else
			{
				if(*followup && CheckWriteAccess(followup,TRUE))		/* Dann haben wir 2 Mglichkeiten: Original und F'Up*/ 
				{
					res=mtAlerts_AlertRSC(2, AL_SYSOP_FUP);
					if(res==2)
						strMcpy(Gr, sizeof(Gr), followup);
				}
			}
			if (res == 1)
			{
				/* ja, ignorieren */
				if (CheckWriteAccess(orgGroup,FALSE))
					Messages_NewKom(refId, Betreff, orgGroup, mid, receiver, realName, dist,references);
/*DYJ 5.34d Start*/
			}else if (!res)
			{
				Messages_NewPseudoKom(refId,userAddr,Betreff,orgGroup, Gr,mid,realName);
/*DYJ  Ende; */
			} else
			{
				/* nein, Followup beachten */
				MakeLine(grinWdw, txt, sizeof(txt));
				Messages_NewKomMessage(orgGroup, Gr, Betreff, refId, txt, mid, receiver, realName,references);
			}
		}
	} else if (result == Action_answer)
	{
		/* Get receiver */
		if (sender[0] != '\0' || replyto[0] != '\0')
		{
			/* Dialogbox fuer From, Sender und Receiver anzeigen (MH) */	
			reply = TreeAddr[REPLY];
			SetObjcString(reply, EDABS, receiver);
			
			if (sender[0] != '\0')
			{
				SetObjcString(reply, EDSENDER, sender);
				DelObjFlags(reply, RESENDER, HIDETREE);
			} else
			{
				SetObjcString(reply, EDSENDER, "");
				SetObjFlags(reply, RESENDER, HIDETREE);
			}
			
			if (replyto[0] != '\0')
			{
				SetObjcString(reply, EDREPLY, replyto);
				DelObjFlags(reply, REREPLY, HIDETREE);
			} else
			{
				SetObjcString(reply, EDREPLY, "");
				SetObjFlags(reply, REREPLY, HIDETREE);
			}
			
			but = VDIUtil_FormHandle(reply);
			switch (but)
			{
			case RESENDER:
				strBcpy(receiver, sender);
				otherReceiver = TRUE;
				break;
				
			case REREPLY:
				strBcpy(receiver, replyto);
				otherReceiver = TRUE;
				break;
							
			case RECANCEL:
				return;
			
			default:
				break;
			}
		}
		grin_ActualGroupNr(grinWdw, &group_nr);
		if (GroupSelect_isPrivate(group_nr))
		{
			switch(grin_ActualIsOwn(grinWdw))
			{
				case MSG_EIGENE:
					grin_ActualReceiver(grinWdw, receiver, sizeof(receiver));
					*realName='\0';		/*DYJ 5.20d */
					break;
				case MSG_INTERN:
					ConfVars_GetConfDefBool(cAskRepAlias,&aar,TRUE);
					if(aar)
					{
						group_line from;
						/* Dialogbox fuer From und TO anzeigen */	
						reply = TreeAddr[REPLY_I];
						SetObjcString(reply, EDIABS, receiver);
						grin_ActualReceiver(grinWdw, from, sizeof(from));
						SetObjcString(reply, EDIEMPF, from);
						but = VDIUtil_FormHandle(reply);
						switch (but)
						{
						case REIEMPF:
							strBcpy(receiver, from);
							otherReceiver = TRUE;
							break;
							
						case REICANCEL:
							return;
						
						default:
							break;
						}
					}
			}
				
		}
		if (GroupSelect_isPrivate(group_nr) && !otherReceiver)
		{
			strBcpy(txt, refId);
			txt[40] = '\0';
			if (txt[39] != '\0')
				txt[39] = '\003'; /* TODO */
			if (grinTools_BetreffHolen(grinWdw, Betreff, sizeof(Betreff), MausTauschrsc_WrkString(FS_KEY_ANSWER), txt, MausTauschrsc_WrkString(FS_WEGEN), BH_ASK_GRIN))
			{
				size_t len;
				_UBYTE *receiverOwn=NULL,*receiverOther=NULL,*ptr;
				_BOOL hasMultRec=FALSE;
				if (grin_ActualIsOwn(grinWdw)==MSG_FREMD)
					grin_grinNewState(grinWdw, 'B');
				ConfVars_GetConfDefBool(cAnswerAsReceiver,&aar,FALSE);
				len=grin_ActualAllReceiverLen(grinWdw);
				if(len)
					receiverOther=SYSMALLOC(++len,MEM_NOERR,"HandleCommentResult");
				if(receiverOther)
				{
					grin_ActualAllReceiver(grinWdw, receiverOther, len);
					hasMultRec=strChr(receiverOther,',')!=NULL;
					receiverOwn=(_UBYTE *)adr_exist(ADR_EIGENE,receiverOther);
					if(aar)
					{
						if(receiverOwn)
						{
							strBcpy(from,receiverOwn);
							ptr=strChr(from,',');
							if(ptr)
								*ptr='\0';
						}
						else
							from[0]='\0';
						fromP=from;
					}
					else
						fromP=userAddr;
					while(receiverOwn)
					{
						ptr=strChr(receiverOwn,',');
						if(ptr)
						{
							if(*(++ptr)==' ')
								ptr++;
							strCpy(receiverOwn,ptr);
							receiverOwn=(_UBYTE *)adr_exist(ADR_EIGENE,receiverOwn);
						}
						else
						{
							*receiverOwn='\0';
							break;
						}
					}
					if(!hasMultRec || mtAlerts_AlertRSC(1, AL_RUNDSCHR)==2)
						*receiverOther='\0';
				}
				Messages_NewAnswer(refId,fromP, Betreff,orgGroup, receiver, mid, realName,receiverOther);
				if(receiverOther)
					SFREE(receiverOther);
			}
		} else
		{
			if (receiver[0] == '\0')
			{
				MTE_infoRSC(AL_NO_ANONYM);
				return;
			}
			if (grinTools_BetreffHolen(grinWdw, Betreff, sizeof(Betreff), MausTauschrsc_WrkString(FS_KEY_PERSANSWER), receiver, MausTauschrsc_WrkString(FS_WEGEN), BH_ASK_GRIN))
			{
				MakeLine(grinWdw, txt, sizeof(Betreff));
				Messages_NewAnsMessage(receiver, realName, orgGroup, Betreff, refId,txt, mid);
				grin_grinNewState(grinWdw, 'B');
				if (otherReceiver)
				{
					if (group_nr == dataSys_private)
					{
						/* Statusmeldung 'Gelesen' erzeugen, da Antwort als Crosskommentar
						 * an jemand anderen geht und die MAUS das dann nicht rafft!
						 */
						Messages_SendState(refId, 'G');
					}
				}
			}
		}
	} else if (result == Action_otherGroup)
	{
		if (ListHelp_SelectGroup(Gr, sizeof(Gr), &group_nr, TRUE, TRUE, FALSE, gsmWrite))
		{
			*receiver = '\0';
			if (group_nr != dataSys_private)
			{
				if (grinTools_BetreffHolen(grinWdw, Betreff, sizeof(Betreff), MausTauschrsc_WrkString(FS_KEY_OTHERGROUP), Gr, MausTauschrsc_WrkString(FS_WEGEN), BH_ASK_GRIN_RE))
				{
					MakeLine(grinWdw, txt, sizeof(txt));
					OpenName[0] = 'G';
					grin_ActualFrom(grinWdw, receiver, sizeof(receiver));
					Messages_NewKomMessage(orgGroup, Gr, Betreff, refId, txt, mid, receiver, realName,references);
				}
			} else if (adr_SelectName(ADR_NORMAL,receiver, sizeof(receiver)) &&
				grinTools_BetreffHolen(grinWdw, Betreff, sizeof(Betreff), MausTauschrsc_WrkString(FS_KEY_PERSANSWER), receiver, MausTauschrsc_WrkString(FS_WEGEN), BH_ASK_GRIN))
			{
				/* Gruppe == dataSys_private */
				MakeLine(grinWdw, txt, sizeof(txt));
				OpenName[0] = 'G';
				Messages_NewAnsMessage(receiver, realName, orgGroup, Betreff, refId, txt, mid);
			}
		}
	}
}

/*** ---------------------------------------------------------------------- ***/
/*DYJ 5.21b */	/*DYJ 5.21c */
GLOBAL _BOOL grinTools_GetCommentLine(_UBYTE *str, size_t strsize, _BOOL copy)
{
	_UBYTE scrap[256];
	_WORD but;
	_BOOL ok;
	OBJECT *system;

	system = TreeAddr[SYSTEM];
	if (copy)
		SetObjcStringAdr(system, SYSTITLE, MausTauschrsc_WrkString(FS_COPY_COMMENT), strLen(MausTauschrsc_WrkString(FS_COPY_COMMENT)) + 1);
	else
		SetObjcStringAdr(system, SYSTITLE, MausTauschrsc_WrkString(FS_PASS_COMMENT), strLen(MausTauschrsc_WrkString(FS_PASS_COMMENT)) + 1);
	ObjcString(system, SYSSTR, scrap, sizeof(scrap));
	SetObjcString(system, SYSSTR, oldComment);
	do
	{
		but = VDIUtil_FormHandle(system);
		if (but != SYSABRUC)
		{
			ObjcString(system, SYSSTR, str, strsize);
			ok = ((strLen(str) <= 79 ||UserBLK.isInternet));
			if (!ok)
				MTE_infoRSC(MTE_longCopy);
		} else
		{
			ok = TRUE;
		}
	} while (!ok);
	SetObjcString(system, SYSSTR, scrap);
	if (but != SYSABRUC)
	{
		strBcpy(oldComment, str);
		return TRUE;
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID HandleCopyResult(HWND grinWdw, ActionType result)
{
	_UBYTE Kommentar[256];
	group_line name;
	_UBYTE scrap[1024];
	
	*name = '\0';
	if (grinTools_GetCommentLine(Kommentar, sizeof(Kommentar), result == Action_copy) &&
		adr_SelectName(ADR_NORMAL,name, sizeof(name)))
	{
		grin_ActualID(grinWdw, scrap, sizeof(scrap));
		Messages_CopyOrForwardMessage(scrap, name, "", Kommentar, result == Action_copy);
	}
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID grinTools_Handle(HWND grinWdw, ActionType what)
{
	if (what == Action_comment || what == Action_answer || what == Action_otherGroup)
		HandleCommentResult(grinWdw, what);
	else if (what == Action_copy || what == Action_pass)
		HandleCopyResult(grinWdw, what);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _BOOL grinTools_NewMessage(CONST _UBYTE *an, CONST _UBYTE *betreff)
{
	group_line Gruppe;
	group_line Wegen;
	CAT_GROUP_NUMBER ca;

	*Gruppe = '\0';
	*Wegen = '\0';
	if (an != NULL)
	{
		strBcpy(Gruppe, an);
		if (strChr(Gruppe, '@') != NULL)
		{
			/* persoenliche Nachricht */
			ca = dataSys_private;
		} else
		{
			if (!GroupSelect_GroupNumber(Gruppe, &ca))
				return FALSE;
		}
	} else
	{
		if (!ListHelp_SelectGroup(Gruppe, sizeof(Gruppe), &ca, TRUE, FALSE, FALSE, gsmWrite))
			return FALSE;
		if (ca == dataSys_private)
		{
			*Gruppe = '\0';
			if (!adr_SelectName(ADR_NORMAL,Gruppe, sizeof(Gruppe)))
				return FALSE;
		}
	}

	if (betreff != NULL && *betreff != '\0')
	{
		strBcpy(Wegen, betreff);
	} else
	{
		if (ca == dataSys_private)
		{
			if (!grinTools_BetreffHolen(-1, Wegen, sizeof(Wegen), "Stichwort f\201r neue pers\224nliche Nachricht an:", Gruppe, "Wegen:",BH_LEER ))
				return FALSE;
		} else
		{
			if (!grinTools_BetreffHolen(-1, Wegen, sizeof(Wegen), "Stichwort f\201r neue Mitteilung in Gruppe:", Gruppe, "Wegen:", BH_LEER))
				return FALSE;
		}
	}

	if (ca == dataSys_private)
		Messages_NewPersMsg(Gruppe, "", Wegen);
	else
		Messages_NewMessage(Gruppe, Wegen);
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID grinTools_Init(_VOID)
{
	/* nix mehr zu tun hier, die Objektbume holen wir uns selber */
}
