/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde von Dimitri Junker aus IOFILTER.C
 * abgeleitet (am 30.3.00) DYJ 4.14
 */

#include <iofilter.h>
#include <arcstart.h>
#include <hlp_prg.h>
#include <confvars.h>
#include <varname2.h>
#include <catlog.h>
#include <debug.h>

/*** ---------------------------------------------------------------------- ***/
/*** ------------------------------------------------------------------------ ***/
/*	GLOBAL _VOID HlpPrg_ReadPrg(hlpPrgStruct *hprg, _WORD num)				*/
/*	Liest Optionen zu Hilfsprogrammen											*/
/*	Abgeleitet von IoFilter_ReadFilter											*/
/*	Parameter:	hprg:	die Zielstruktur										*/
/*				num:	Nummer des Hilfsprogramms								*/
/*	Ergebnis:	keines															*/		
/*	30.3.00 von Dimitri Junker													*/
/*** ------------------------------------------------------------------------ ***/

GLOBAL _VOID HlpPrg_ReadPrg(hlpPrgStruct *hprg, _WORD num)
{
	_UBYTE varname[256];
	
	/* Hilfsprogramm ist vorhanden, auslesen */
	make_varname(varname, sizeof(varname), cHlpPrgCmd, num);
	ConfVars_GetConfDefStr(varname, hprg->Cmd, sizeof(hprg->Cmd), "");
	make_varname(varname, sizeof(varname), cHlpPrgActive, num);
	ConfVars_GetConfDefBool(varname, &hprg->activ, TRUE);
	make_varname(varname, sizeof(varname), cHlpPrgTerm, num);
	ConfVars_GetConfDefBool(varname, &hprg->term, TRUE);
	make_varname(varname, sizeof(varname), cHlpPrgMStart, num);
	ConfVars_GetConfDefInt(varname, &hprg->mulStart, 0);
	/* Jetzt Programmnamen extrahieren */
	make_varname(varname, sizeof(varname), cHlpPrgName, num);
	ConfVars_GetConfDefStr(varname, hprg->hprgName, sizeof(hprg->hprgName), "");
}

/*** ------------------------------------------------------------------------ ***/
/*	LOCAL _VOID getItemsHprg(OBJECT *tree, hlpPrgStruct *hprg)					*/
/*	Setz/Liest Eingaben des Hilfsprogramm-Formulars	aus Formular				*/
/*	Abgeleitet von getItems														*/
/*	Parameter:	tree:	das Formular											*/
/*				hprg:	die Ziel-Struktur										*/
/*				num:	Nummer des Hilfsprogramms								*/
/*	Ergebnis:	keines															*/		
/*	30.3.00 von Dimitri Junker													*/
/*** ------------------------------------------------------------------------ ***/
GLOBAL _VOID HlpPrg_WritePrg(CONST hlpPrgStruct *hprg, _WORD num)
{
	_UBYTE varname[256];
	
	if (hprg->hprgPath[0] != '\0')
	{
		make_varname(varname, sizeof(varname), cHlpPrgProg, num);
		ConfVars_SetConfigString(varname, hprg->hprgPath);
		make_varname(varname, sizeof(varname), cHlpPrgCmd, num);
		ConfVars_SetConfigString(varname, hprg->Cmd);
		make_varname(varname, sizeof(varname), cHlpPrgActive, num);
		ConfVars_SetConfigBool(varname, hprg->activ);
		make_varname(varname, sizeof(varname), cHlpPrgTerm, num);
		ConfVars_SetConfigBool(varname, hprg->term);
		make_varname(varname, sizeof(varname), cHlpPrgMStart, num);
		ConfVars_SetConfigInt(varname, hprg->mulStart);
		make_varname(varname, sizeof(varname), cHlpPrgName, num);
		ConfVars_SetConfigString(varname, hprg->hprgName);
	} else
	{
		/* Configvariablen loeschen! */
		make_varname(varname, sizeof(varname), cHlpPrgProg, num);
		ConfVars_DeleteConfigVar(varname);
		make_varname(varname, sizeof(varname), cHlpPrgCmd, num);
		ConfVars_DeleteConfigVar(varname);
		make_varname(varname, sizeof(varname), cHlpPrgActive, num);
		ConfVars_DeleteConfigVar(varname);
		make_varname(varname, sizeof(varname), cHlpPrgTerm, num);
		ConfVars_DeleteConfigVar(varname);
		make_varname(varname, sizeof(varname), cHlpPrgMStart, num);
		ConfVars_DeleteConfigVar(varname);
		make_varname(varname, sizeof(varname), cHlpPrgName, num);
		ConfVars_DeleteConfigVar(varname);
	}
}



/*DYJ  Ende; */
