#ifndef __CAT_CATHELP_H__
#define __CAT_CATHELP_H__
/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */



#ifndef __PORTAB_H__
#include <portab.h>
#endif
#ifndef __CAT_LISTS_H__
#include <lists.h>
#endif


typedef enum {
	CatHelp_general,
	CatHelp_catinfo,
	CatHelp_editor,
	CatHelp_grin,
	CatHelp_manager,
	CatHelp_msglist,
	CatHelp_treelist,
	CatHelp_formats,
	CatHelp_paths,
	CatHelp_allgconf,
	CatHelp_tauschconf,
	CatHelp_listconf,
	CatHelp_searchdial,
	CatHelp_smallsearch,
	CatHelp_filter,
	CatHelp_groupsel,
	CatHelp_groupRead,
	CatHelp_groupWrite,
	CatHelp_groupUser,
	CatHelp_infoRead,
	CatHelp_infoEdit,
	CatHelp_oversize,
	CatHelp_selectGroup,
	CatHelp_reghelp,
	CatHelp_wvhelp,
	CatHelp_cmtshelp,			/* (MH) */
	CatHelp_textsearch,
	CatHelp_textrepl,
	CatHelp_changemsg,
	CatHelp_itkhelp,
	CatHelp_macrohelp,			/* (MH) */
	CatHelp_configInfile,
	CatHelp_confEdit,
	CatHelp_iofilter,
	CatHelp_dialogSize,
	CatHelp_hotkeys,
	CatHelp_sounds,
	CatHelp_hlpPrgs,
	CatHelp_alias,
	CatHelp_followup,
	CatHelp_cbcregel,
	CatHelp_pmfilter,
	CatHelp_savemsg,
	CatHelp_anzahl				/* dies mu der letzte Eintrag bleiben!!!  */
} tHelp;


_VOID CatHelp_DoHelp(tHelp topic);
_VOID CatHelp_DoHelpExtern(tHelp topic);

_VOID CatHelp_DoInternalHelp(List *helpList);
/* Es wird eine Liste uebergeben, die in der Hilfedialogbox
 * angezeigt wird. Die Liste besteht aus Zeigern auf einzelne
 * Strings, wobei jeder String nicht laenger als 65 Zeichen sein
 * darf. Die Liste wird am Ende automatisch dealloziert,
 * ist also nicht mehr benutzbar
 */


#endif /* __CAT_CATHELP_H__ */
