#ifndef __CAT_CATKEYS_H__
#define __CAT_CATKEYS_H__
/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */




/* Definition der Tasten-Codes: */

#define KEY_nul             '\0'   /* ASCII-Nul, kein Zeichen */
#define KEY_backspace       '\b'   /* rueckwaerts loeschen */
#define KEY_tab             '\t'   /* in 8er-Positionen einruecken */
#define KEY_delete          '\177'   /* Zeichen vorwaerts loeschen */
#define KEY_SHIFTdelete     '\037'
/* eigentlich Control-Delete!!!
                           Wort vorwaerts loeschen */
#define KEY_cursleft        0x4b   /* Scan-Code, Zeichen nach links */
#define KEY_cursright       0x4d   /* Scan-Code, Zeichen nach rechts */
#define KEY_ctrlleft        0x73   /* Scan-Code, Anfang der Zeile */
#define KEY_ctrlright       0x74   /* Scan-Code, Ende der Zeile */
#define KEY_cursup          0x48   /* Scan-Code, Zeile nach oben */
#define KEY_cursdown        0x50   /* Scan-Code, Zeile nach unten */
#define KEY_clear           0x47
/* Scan-Code, Zeile loeschen,
                         mit SHIFT zum linken Zeilenr. loesch. */
#define KEY_SHIFTClear      0x77
/* Scan-Code, eigentlich Control-Delete!!!
                         Block loeschen und puffern */
#define KEY_insert          0x52
/* Scan-Code, Ueberschreiben Ein/Aus,
                         mit SHIFT Einruecken Ein/Aus */
#define KEY_help            0x62   /* Scan-Code, Hilfstafel rufen */
#define KEY_undo            0x61
/* Scan-Code, geloeschte Zeile wieder
                         einfuegen */
#define KEY_F1              0x3b   /* Scan-Code */
#define KEY_F2              0x3c
#define KEY_F3              0x3d
#define KEY_F4              0x3e
#define KEY_F5              0x3f
#define KEY_F6              0x40
#define KEY_F7              0x41
#define KEY_F8              0x42
#define KEY_F9              0x43
#define KEY_F10             0x44
#define KEY_SHIFTF1         0x54
#define KEY_SHIFTF2         0x55
#define KEY_SHIFTF3         0x56
#define KEY_SHIFTF4         0x57
#define KEY_SHIFTF5         0x58
#define KEY_SHIFTF6         0x59
#define KEY_SHIFTF7         0x5a
#define KEY_SHIFTF8         0x5b
#define KEY_SHIFTF9         0x5c
#define KEY_SHIFTF10        0x5d

#define KEY_hasinsert       FALSE
#define KEY_hasdelete       FALSE

#define KEY_insCh           '\0'
#define KEY_delCh           '\0'
#define KEY_ESC             '\033'
#define KEY_LF              '\n'
#define KEY_CR              '\015'
#define KEY_BS              '\b'
#define KEY_TAB             '\t'
#define KEY_DEL             '\177'
#define KEY_ctrlY           '\031'
#define KEY_ctrlJ           '\n'
#define KEY_ctrlK           '\013'
#define KEY_ctrlSpace       0x39   /* Scancode */


#endif /* __CAT_CATKEYS_H__ */
