#ifndef __CAT_CATOPTS_H__
#define __CAT_CATOPTS_H__
/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */



#ifndef __PORTAB_H__
#include <portab.h>
#endif
#ifndef __PORTAES_H__
#include <portaes.h>
#endif


/* Die maximale Anzahl an Farben, die es gibt. Wird in CAT.M
 * in InitRsc gesetzt.
 */
extern _UWORD maxColors;


_BOOL CatOpts_InitDial(OBJECT *tree);
/* Initialisiert einen Dialog: NewDial und DialCenter
 */

_BOOL CatOpts_GetItem(OBJECT *dial, _WORD item);
/* Fragt ab, ob ein Button selektiert ist
 */

_VOID CatOpts_SetItem(OBJECT *dial, _WORD item, _BOOL b);
/* Setzt einen Button auf Selected oder nicht, je nach Wert von b
 */

_VOID CatOpts_DoSearch(_VOID);
/* Der Suchdialog fuer die Textsuche
 */

_VOID CatOpts_DoSearchAgain(_UWORD kstate);
/* Es wird nochmal gesucht
 */

_VOID CatOpts_DoReplace(HWND win);
/* Suchen und Ersetzen
 */


_VOID CatOpts_DoTausch(_VOID);
/* Die Tauschkonfiguration
 */

_BOOL CatOpts_CheckInfoline(CONST _UBYTE *infoline);
/* Testet UserBLK.infoline */
/* Prueft, ob eine Infozeile korrekt ist
 */

_VOID CatOpts_DoOption(_VOID);
/* Der Allgemeine Konfigurationsdialog
 */

_VOID CatOpts_DoAbruf(_VOID);
/* Infile einstellen
 */

_VOID CatOpts_DoInfos(_VOID);
/* Infofiles konfigurieren
 */

_VOID CatOpts_doPrinter(_VOID);
/* Druckereinstellungen konfigurieren
 */

_VOID CatOpts_doList(_VOID);
/* Konfiguriert die Stichwortliste
 */

_VOID CatOpts_doEditor(HWND wdw);
/* Konfiguriert den aktuellen Editor
 */

_VOID CatOpts_doColor(HWND wdw);
/* Setzt die Farben fuer das aktuelle Fenster
 */

_VOID CatOpts_doConfig(_WORD pid,_WORD ret);
/* Der Konfigurationsdialog fuer CAT.INF
 */

_VOID CatOpts_doFormat(_VOID);
/* Die Formate-Dialogbox
 */

#endif /* __CAT_CATOPTS_H__ */
