#ifndef __CAT_PROTO_H__
#define __CAT_PROTO_H__
/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */



#ifndef __PORTAB_H__
#include <portab.h>
#endif

/*## Cat-Protokoll ################################################*/

#define CatMsg         0x8000
#define ExtCatMsg      0x8001

#define Cat2FiltMsg    0x8002			/* Fuer Laberfilter-Anbindung */
#define CatProtoMsg    0x8003			/* Neues CAT-Protokoll */

/* Sub-Opcodes fuer CatMsg */

/* 0 bis 2 sind fuer Watchdog */
enum {	CatAsk=3,		CatAccept,		CatForget,		CatGreetings,
		CatTerminate,	CatFiltered,	
		WdwManager,		CatWinInfo,		CatWhatsIn,		CatPosition,
		CatNewMess,		CatInform,		CatWinDirty };

#define CatProtoVersion   1				/* Das ist Version Nummer 1 */

_VOID Catproto_SendNewMsgInWdw(_VOID);
/* Angemeldeten ACCs mitteilen, das eine neue Nachricht im
 * obersten Anzeigefenster ist
 */



#endif /* __CAT_PROTO_H__ */
