#ifndef __CAT_GRIN_H__
#define __CAT_GRIN_H__
/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */



#ifndef __PORTAB_H__
#include <portab.h>
#endif

#ifndef __CAT_DATA2_H__
#include <data.h>
#endif
#ifndef __CAT_CONVERTDATE_H__
#include <convertd.h>
#endif
#ifndef __RO_TIME_H__
#include <ro_time.h>
#endif
#ifndef __CAT_WDWMANAGER_H__
#include <wdwmanag.h>
#endif

typedef enum {
	mFromBeginning,
	mFirstNew,
	mUnread,
	mLastPos,
	mOther,
	mOtherNoErrMsg,
} grin_openMode;

#ifndef __CAT_MSGLISTBASE_H__
#include <msglistb.h>
#endif

enum{MSG_FREMD,MSG_SCHIZO,MSG_INTERN,MSG_EIGENE,MSG_ALIAS};

typedef MSGNR (*grinNextMessProc)(MSGNR which, _BOOL nextOrPrev, _BOOL withShift, LISTHANDLE listHandle, _VOID /* oneWindow */ *windowPtr);
typedef MSGNR (*getNumberProc)(OneGroupHandle dataHandle, CONST _UBYTE *ID);


#define GRIN_WINDOW_PROTO 0


_BOOL grin_grinInit(_VOID);
_VOID grin_grinExit(_VOID);


/* Einiges Initialisieren, gemeckert wird selbst */


HWND grin_grinOpenMessage(CAT_GROUP_NUMBER gruppe, MSGNR which, grinNextMessProc nextMess, LISTHANDLE listHandle, grin_openMode mode);
/* Ein Messagefenster der <gruppe> mit der Msg-nr. <which> oeffnen
 * Liefert als Ergebnis das Handle des geoeffneten Fensters zurueck.
 */

HWND grin_grinOpenWithProc(CAT_GROUP_NUMBER gruppe, getNumberProc whichNumber, CONST _UBYTE *ID, grinNextMessProc nextMess, LISTHANDLE listHandle, grin_openMode mode);
/* Ein Messagefenster der gruppe <gruppe> an der Stelle oeffnen, die von
 * der uebergebenen Prozedur zurueckgeliefert wird.
 * Liefert als Ergebnis das Handle des geoeffneten Fensters zurueck
 * (im Fehlerfall -1)
 */

_VOID grin_grinClose(HWND wdw);
/* Oberstes Fenster schliessen -> KANN NOCH RAUSFLIEGEN */

_VOID grin_grinSavePos(_VOID);
/* Sichert die Positionen aller grin-Fenster */

_VOID grin_grinRestorePos(_VOID);
/* Restauriert die Positionen, wenn moeglich */

_VOID grin_grinCloseAll(_VOID);
/* Alle Fenster schliessen */

_BOOL grin_grinSwitchTo(HWND win, MSGNR which, grinNextMessProc nextMess, LISTHANDLE listHandle, _BOOL doNotTop);
/* Schaltet in der aktuellen Gruppe zu der Nachricht which um.
 * doNotTop= TRUE: Das Fenster wird NICHT automatisch getoppt
 */
_BOOL grin_grinSwitchToMess(HWND win, CAT_GROUP_NUMBER group, getNumberProc whichNumber, CONST _UBYTE *ID);
/* Neue Msg in ein Fenster setzen
 */

_VOID grin_UndoPos(HWND win);
/* Springt zur letzten Nachricht */


_BOOL grin_grinSetListWdw(HWND win, grinNextMessProc nextMess, LISTHANDLE listHandle);
/* exported */
/* Exportiert fuer die Msgliste
 * Setzt fuer Fenster win das Stichwortfenster
 */

_BOOL grin_grinWindowTop(HWND win);
/* Ist ein Fenster Anzeigefenster das oberste? */

/* Auskunftprozeduren */
_VOID grin_ActualSubject(HWND win, _UBYTE *subject, size_t strsize);
_VOID grin_ActualID(HWND win, _UBYTE *ID, size_t strsize);
_VOID grin_ActualMId(HWND win, _UBYTE *ID, size_t strsize);
_VOID grin_ActualFrom(HWND win, _UBYTE *sender, size_t strsize);
_VOID grin_ActualReceiver(HWND win, _UBYTE *receiver, size_t strsize);
_VOID grin_ActualAllReceiver(HWND win, _UBYTE *receiver, size_t strsize);
_VOID grin_ActualGroup(HWND win, _UBYTE *group, size_t strsize);
_VOID grin_ActualGroupNr(HWND win, CAT_GROUP_NUMBER *nr);
_VOID grin_ActualDist(HWND win, tDistribution *dist);
_VOID grin_ActualName(HWND win, _UBYTE *name, size_t strsize);
_VOID grin_ActualReplyto(HWND win, _UBYTE *sender, size_t strsize);

/* Neue Auskunftsprozeduren */
_VOID grin_ActualRefId(HWND win, _UBYTE *id, size_t strsize);
_VOID grin_ActualRId(HWND win, _UBYTE *id, size_t strsize);
_VOID grin_ActualSender(HWND win, _UBYTE *sender, size_t strsize);
size_t grin_ActualAllReceiverLen(HWND win);		/*DYJ 5.19g */
_VOID grin_ActualWdwName(HWND win, _UBYTE *name, size_t strsize);
_VOID grin_ActualFollowup(HWND win, _UBYTE *id, size_t strsize);
_VOID grin_ActualDate(HWND win, F_TIME *time);
_VOID grin_ActualStatusDate(HWND win, F_TIME *time);
_VOID grin_ActualText(HWND win, _UBYTE *txtBuf, size_t strsize,_BOOL full);
_VOID grin_ActualMime(HWND win, _UBYTE *mime, size_t strsize);
_VOID grin_ActualGate(HWND win, _UBYTE *gate, size_t strsize);
_VOID grin_ActualBox(HWND win, _UBYTE *box, size_t strsize);
_VOID grin_ActualStatus(HWND win, _UBYTE *status, size_t strsize);
_VOID grin_ActualRef(HWND win, _UBYTE *references, size_t strsize);
_WORD grin_ActualIsOwn(HWND win);

_WORD grin_MsgIsOwn(MessageType *mess);
_WORD grin_EAdrCmp(CONST _UBYTE *str1, CONST _UBYTE *str2);		/*DYJ 5.34d */
_VOID grin_ActualOrgText(HWND win, _UBYTE *txtBuf, size_t strsize);
_VOID grin_ActualInternalId(HWND win, _ULONG *Id);

/* Groessenabfragen */
_ULONG grin_ActSubjectSize(HWND win);
_ULONG grin_ActIdSize(HWND win);
_ULONG grin_ActMIdSize(HWND win);
_ULONG grin_ActFromSize(HWND win);
_ULONG grin_ActSenderSize(HWND win);
_ULONG grin_ActWdwNameSize(HWND win);
_ULONG grin_ActReceiverSize(HWND win);
_ULONG grin_ActGroupSize(HWND win);
_ULONG grin_ActNameSize(HWND win);
_ULONG grin_ActReplyToSize(HWND win);
_ULONG grin_ActRefIdSize(HWND win);
_ULONG grin_ActRIdSize(HWND win);
_ULONG grin_ActFollowupSize(HWND win);
_ULONG grin_ActDistSize(HWND win);
_ULONG grin_ActStatusSize(HWND win);
_ULONG grin_ActDateSize(HWND win);
_ULONG grin_ActStatusDateSize(HWND win);
_ULONG grin_ActTextSize(HWND win,_BOOL full);
_ULONG grin_ActMimeSize(HWND win);
_ULONG grin_ActGateSize(HWND win);
_ULONG grin_ActBoxSize(HWND win);
_ULONG grin_ActIsOwnSize(HWND win);
_ULONG grin_ActOrgTextSize(HWND win);
_ULONG grin_ActInternalIdSize(HWND win);


_VOID grin_InvertStatus(HWND topWin, MSGBITS whichState);
/* Invertiert den angegebenen Status, entsprechende Konstanten
 * sind in data.d zu finden */

_VOID grin_newStatus(HWND topWin, MSGBITS clear, MSGBITS set);

_VOID grin_grinNewState(HWND TopWin, _UBYTE newState);

_VOID grin_grinResetState(CONST _UBYTE *id);
/* Den Status einer persoenlichen Msg zuruecksetzen, wenn eine noch nicht abgeschickte */
/* Antwort dazu geloescht wird. */

_VOID grin_grinChangeFlags(CAT_GROUP_NUMBER group, MSGNR msgNum, MSGBITS newBits);
/* die Stichwortliste oder Baumanzeige teilt grin mit, dass sich bei einer Nachricht
 * die Flags geaendert haben
 */
_VOID grin_grinChangeUngel(CAT_GROUP_NUMBER group);
/* die Stichwortliste oder Baumanzeige teilt grin mit, dass sich bei einer Gruppe
 * die Anzahl ungelesener Messages geaendert hat
 */

_VOID grin_SearchMenu(HWND topWin);
_VOID grin_DoSearch(HWND topWin, _BOOL forward);

_BOOL grin_grinWithEffects(HWND wdw);
/* Gibt zurueck, ob momentan Effekte angezeigt werden oder nicht
 */

_VOID grin_grinSetAlternativeFont(HWND wdw, _WORD font, _WORD fontSize);
/* Setzt den alternativen (monospaced) Font fuer das Anzeigefenster */

_VOID grin_GetWdwFont(HWND wdw, _WORD *font, _WORD *fontSize);
/* Holt den eingestellten Font */

_VOID grin_SelectFont(HWND wdw);

_VOID grin_GetAlternativeFont(_WORD *font, _WORD *fontSize);
/* Holt den alternativen Font */

_VOID grin_grinSetFont(HWND wdw, _WORD font, _WORD fontSize);
/* Setzt den Font fuer das Anzeigefenster */

_VOID grin_grinNextNotWorked(HWND topWin, _BOOL withShift);
/* Springt zur naechsten nicht bearbeiteten Msg bei den persoenlichen Msgs */

MSGNR grin_grinNextMess(MSGNR which, _BOOL nextOrPrev, _BOOL withShift, LISTHANDLE listHdl, _VOID *winp);
/* Default-Prozedur fuer naechste/letzte Message */

/*DYJ 5.30l Start*/
_VOID grin_grinInfoline(HWND msgWin, HWND editWin, CONST _UBYTE *infoline, CONST _UBYTE *infolineM);
/*DYJ  Ende; alt:	
_VOID grin_grinInfoline(HWND msgWin, HWND editWin, CONST _UBYTE *infoline);
*/
/* Neue Infoline-Prozedur */

/*DYJ 5.30l Start*/
_VOID grin_Infoline(HWND editWin, CONST MessageType *mess, CONST _UBYTE *infoline, CONST _UBYTE *infolineM);
/*DYJ  Ende; alt:	
_VOID grin_Infoline(HWND editWin, CONST MessageType *mess, CONST _UBYTE *infoline);
*/

/* --- Fuer die Protokollunterstuetzung --- */

#if GRIN_WINDOW_PROTO

_VOID grin_getAllWinds(HWND *adr, _WORD maxAnz, _WORD *anz);
/* Schreibt alle offenen Anzeigefenster in den Speicher ab <adr>    */
/* Maximal <max> viele. Rueckgabewert der geschriebenen in <anz>.    */
/* Sind es mehr als max, so ist dies die Anzahl der offenen Fenster */

MSGNR grin_getPos(HWND win, _WORD pos, _VOID *adr);
/* Positionen zu einem Fenster abrufen: */
/* 0 Neue, 1 letzte Position, 2 ab Datum, 3 ab Nummer, 4 erste ungelesene */
/* bei 2 und 3 wird in adr die Adresse eines Strings uebergeben.           */

_BOOL grin_switchMess(HWND win, MSGNR mess, CAT_GROUP_NUMBER group);
/* Neue Msg in ein Fenster setzen; Fuer das Protokoll */

_BOOL grin_getInfo(HWND win, MessageType *adr, _LONG amount);
/* Die Infos zu diesem Fenster abholen. Geliefert wird:                             */
/* ab <adr> steht ein data.MessageType. Direkt dahinter die Infostrings und         */
/* dahinter noch der eigentliche MsgText. Gibt zurueck, ob es geklappt hat oder ob   */
/* das Fenster nicht mehr da ist bzw. die Information nicht gepasst hat.             */

#endif /* GRIN_WINDOW_PROTO */

_BOOL grin_getBasicInfo(HWND win, CAT_GROUP_NUMBER *group, MSGNR *mess, _ULONG *storageAmount);
/* Feststellen, welche Msg welcher Gruppe im uebergebenen Fenster dargestellt wird.  */
/* In StorageAmount wird zurueckgegeben, wieviel Speicher mal benoetigt, um die       */
/* Informationen, die zu dieser Msg gehoeren, zu speichern.                          */

/* --- Ende der Protokollprozeduren --- */

_VOID grin_changeTree(HWND win, MSGBITS clear, MSGBITS set, _BOOL all);
/* Baum mit durchlaufen, dabei die Flags clear loeschen und set setzen   */
/* all - ganzer Baum, sonst nur runter                                  */

_VOID grin_setCoO(OneGroupHandle handle, MSGNR msgNum, _BOOL set);
/* setzt/lscht das Flag 'Kommentar auf eigene' bei allen Kindern einer Msg*/

_BOOL grin_grinOnlyOneWind(HWND *wdw);
/* Wenn nur ein grin-Window offen ist, bekommt man TRUE zurueck und
 * das wdw-Handle auch direkt
 */
_VOID grin_GetGrinTopWdw(HWND *wdw);
/* Liefert das oberste Anzeigefenster zurueck */

_VOID Decode_StatusBits(MSGBITS bits, _UBYTE *info, _BOOL forList);
/* Erzeugt eine Infozeile mit den Statusbits */

_BOOL grin_getContent(String255 content,CONST _UBYTE *mime, CONST _UBYTE *prefix);	/*DYJ 5.32f */

/* Etwas fuer Dirk */
_BOOL grin_hiddenFeature(HWND wdw, _WORD feature, _UWORD moKstate);

_VOID grin_WWline(HWND wdw, _UBYTE *txt, size_t txtsize);

#endif /* __CAT_GRIN_H__ */
