#ifndef __CAT_HANDLEPOOL_H__
#define __CAT_HANDLEPOOL_H__
/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */



#ifndef __PORTAB_H__
#include <portab.h>
#endif
#ifndef __CAT_LISTS_H__
#include <lists.h>
#endif
#ifndef __CAT_TYPES_H__
#include <cattypes.h>
#endif
#ifndef __CAT_DATA2_H__
#include <data.h>
#endif

/*-- Allgemeine Listenverwaltung ---------------*/

_VOID *handlePool_BlankToList(_ULONG size, List *list);
/* Ein Listenelement an die angegebene Liste anhaengen */

_VOID handlePool_FreeOnePtr(_VOID *ptr, List *list);

_BOOL handlePool_FindEntry(_VOID *data, _BOOL (*condProc)(_VOID *, _VOID *), List *list, _VOID **ptr);


/*-- Spezielle Datenbankhandleliste ------------*/

/* Die Handles fuer den lesenden Zugriff auf die Datenbank: */
/* Es duerfen auch noch Flags geaendert werden, nicht aber   */
/* Nachrichten mittels dieser Handles angehaengt werden     */

typedef struct oneHandleElement {
	CAT_GROUP_NUMBER group;   /* Gruppennummer */
	_UWORD open;   /* Anzahl der offenen Fenster dazu */
	OneGroupHandle Zugriff;   /* Zugriffshandle */
} oneHandleElement, *oneHandlePtr;


oneHandleElement *handlePool_SearchDataHandle(CAT_GROUP_NUMBER gruppe);
/* Handle-Liste nach einem Eintrag der Gruppe <gruppe> durchsuchen */

oneHandleElement *handlePool_GetOneDatahandle(CAT_GROUP_NUMBER gruppe);
/* Erst die bestehende Liste nach schon offenen Handles durchsuchen,
 * falls dort nicht gefunden, versuchen ein neues zu oeffnen
 */

_VOID handlePool_FreeOneDataHandle(oneHandleElement *handle);
/* Nachsehen, ob er noch benoetigt wird, sonst aus der Liste entfernen */

_BOOL handlePool_InitPool(_VOID);
/* Wird in grin.grinInit aufgerufen, Fehler auch dort angemeckert und braucht */
/* nicht weiter beachtet zu werden */

_VOID handlePool_ExitPool(_VOID);

_BOOL handlePool_isOneGroupOpen(_VOID);
/* Fragt nach, ob _irgendeine_ Gruppe noch geoeffnet ist. Insbesondere fuer   */
/* parser.i -> Gruppe offen: Einfuegen abbrechen und CAT beenden             */


#endif /* __CAT_HANDLEPOOL_H__ */
