#ifndef __CAT_IOFILTER_H__
#define __CAT_IOFILTER_H__
/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */




#ifndef __CAT_CATTYPES_H__
#include <cattypes.h>
#endif

#define MAX_IO_FILTER 100
#define IO_FILTER_STRLEN 21
typedef enum _FILT_TYPES {ForMsg,ForInfile,ForOutfile,ForIO,PastOutfile} FILT_TYPES;

typedef struct ioFilterStruct {
	_UBYTE progName[PATH_MAX];
	String255 inCmd;
	String255 outCmd;
	_UBYTE filtName[IO_FILTER_STRLEN];
	_WORD  pass;
	_BOOL stopAtErr;
	FILT_TYPES filtType;
} ioFilterStruct;


_VOID IoFilter_ReadFilter(ioFilterStruct *filter, _WORD num);
/* Liest die Daten zu Filter num aus den Configvariablen
 * aus
 */

_VOID IoFilter_WriteFilter(CONST ioFilterStruct *filter, _WORD num);
/* Schreibt die Daten zu Filter num in die Configvariablen
 */

_BOOL IoFilter_IoFilterMessage(_BOOL *isError);
/* Ruft die definierten Filter auf, die vor dem erstellen von
 * Infile.txt benutzt werden sollen
 * TRUE: Es wurde mindestens ein Filter aufgerufen
 */

_BOOL IoFilter_IoFilterInfile(_VOID);
/* Ruft die definierten Filter auf, die auf dem Infile arbeiten
 * TRUE: Alles ohne Probleme abgelaufen.
 * FALSE: Erstellung des Infiles abbrechen
 */

_BOOL IoFilter_IoFilterOutfile(_VOID);
/* Ruft die definierten Filter auf, die auf dem Outfile arbeiten
 * TRUE: Alles ohne Probleme abgelaufen.
 * FALSE: Einfuegen des Outfiles abbrechen
 */

_BOOL IoFilter_IoFilterPastOutfile(_VOID);
/* Ruft die definierten Filter auf, die nach dem Einfuegen arbeiten
 */
GLOBAL _VOID buildCmdLine(CONST _UBYTE *inCmd, _UBYTE *cmdLine, size_t len,_WORD id);
/*Bastelt Kommandozeile zusammen.
*/


#endif /* __CAT_IOFILTER_H__ */
