#ifndef __CAT_ITKMACRO_H__
#define __CAT_ITKMACRO_H__
/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */



#ifndef __PORTAB_H__
#include <portab.h>
#endif
#ifndef __PORTAES_H__
#include <portaes.h>
#endif
#ifndef __CAT_LISTS_H__
#include <lists.h>
#endif
#ifndef __CAT_LISTDL_H__
#include <listdl.h>
#endif
#ifndef __CAT_DOITK_H__ 
#include <doitk.h>
#endif


typedef struct _macro MACRO;
typedef struct _OneMacro OneMacro;

#ifdef __ITK_IMPLEMENTATION__

struct _macro {
	List *MacroList;
	OBJECT *MacroBox;
	OneCommand *MacroEntry;
	HWND MacroWindow;
	_UBYTE MacroName[256];
	specialButHdler specials[5];
	_BOOL new;
	_BOOL listChanged;
	_WORD globalLength;
	_WORD exitBut;
	_VOID *lastMacro;
	ITK *itk;
};

struct _OneMacro
{
	_WORD command;
	_WORD version;
	_UBYTE *cmdName;
	OneCommand *pCommand;
	_UBYTE defSetup[256];
	_UBYTE resSetup[256];
	_BOOL opened;
	_WORD selected;
	_WORD aktStep;
	_WORD totalSteps;
};

#else

struct _macro { int dummy; };
struct _OneMacro { int dummy; };

#endif


_VOID Macro_RedrawList(MACRO *macro);

_VOID Macro_RenumberSteps(List *macroList);

_VOID Macro_UpdateButtons(_VOID *entry, _VOID *env);

_BOOL Macro_ConfigMacro(_VOID *command, _VOID *itk, _VOID **sMacro);

#endif /* __CAT_ITKMACRO_H__ */
