#ifndef __CAT_LISTHELP_H__
#define __CAT_LISTHELP_H__
/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */



#ifndef __PORTAB_H__
#include <portab.h>
#endif
#ifndef __PORTAES_H__
#include <portaes.h>
#endif
#ifndef __CAT_TYPES_H__
#include <cattypes.h>
#endif


typedef enum _groupSelectMode {
	gsmReadBegin,		/* Ab Anfang lesen */
	gsmReadNew,			/* Neue Nachrichten lesen */
	gsmReadUnread,		/* Ungelesene lesen */
	gsmReadLastPos,		/* Ab letzter Position lesen */
	gsmReadDate,		/* Ab Datum lesen */
	gsmReadId,			/* Ab ID lesen */
	gsmWrite,			/* Neue Nachricht in Gruppe schreiben */
	gsmUser,			/* Gruppenname fuer einen Benutzer auswaehlen, fuer MT-Kommandos */
	gsmGroupCom,		/* GUEK schreiben */
	gsmModify,			/* Liste aendern */
	gsmOther,			/* Gruppe auswaehlen fuer ITK-Kommando */
	gsmChief,			/* Gruppe fuer Gruppenchef auswaehlen */
	gsmProgteil,		/* Gruppen mit Programmteil auswaehlen (MH) */
	gsmUsername,  		/* Namen aus ITU holen (MH) */
	gsmFollowup,		/* Followup setzen		*/
	gsmPMFilt,			/* Gruppe fr PM-Filter*/
	gsmPutz,			/* Gruppe zum Lschen per CatPutz*/	/*DYJ 5.36c */
	
	gsmNumModes			/* War bisher etwas tiefer*/
} groupSelectMode;

/* Hilfsprozeduren, die bei den Listdialogen benutzt werden */


_VOID *ListHelp_nextEntry(_VOID *list);

_VOID *ListHelp_prevEntry(_VOID *list);

_VOID ListHelp_resetList(_VOID *list);

/* Die eigentlichen Nutzprozeduren */

_VOID ListHelp_SetLastGroup(CONST _UBYTE *name);
/* Setzt den Gruppennamen, der beim naechsten Aufruf in der
 * Gruppenbox angezeigt wird
 */

_BOOL ListHelp_SelectGroup(_UBYTE *gruppe, size_t strsize, CAT_GROUP_NUMBER *Nr, _BOOL nG, _BOOL clearEdit, _BOOL forSearch, groupSelectMode mode);

_VOID ListHelp_Init(_VOID);
/* Objektbaeume fuer die Gruppenauswahl- und die Adressenauswahlbox */

#endif /* __CAT_LISTHELP_H__ */
