#ifndef __CAT_MESSAGES_H__
#define __CAT_MESSAGES_H__
/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */




#ifndef __PORTAB_H__
#include <portab.h>
#endif

#ifndef __CAT_DATA_H__
#include <data.h>
#endif

#ifndef __CAT_CATTYPES_H__
#include <cattypes.h>
#endif


/* Erst mal ein paar Strings */

#define msgDistr        "Distr.: "
#define msgDNone        "keine"
#define msgDLokal       "(lokal)"
#define msgDMausNet     "(MausNet)"
#define msgDNet         "(Net)"

extern CONST _UBYTE *CONST msgDistribs[];


typedef enum {
	msg_comment,		/* Kommentar zu oeffentlicher Nachricht */
	msg_answer,			/* Antwort auf private Nachricht */
	msg_mail,			/* neue oeffentliche Nachricht */
	msg_private,		/* neue private Nachricht */
	msg_groupcomment,	/* Gruppenuebergreifender Kommentar */
	msg_copyOwn,		/* Kopie einer neuen privaten Nachricht */
	msg_copyOther,		/* Kopie einer oeffentlichen Nachricht */
	msg_forward,		/* Weitergeleitete Nachricht */
	msg_persanswer,		/* Persoenliche Antwort auf oeffentliche Nachricht */
	msg_pseudoKom,		/* Kommentar auf Pseudonews	*/
	msg_pseudoNews		/* Pseudonews	*/
} msg_type;
typedef enum {
	line_date,
	line_receiver,
	line_orgGroup,
	line_group,
	line_refId,
	line_topic,
	line_rId,
	line_rName
} line_type;

/*DYJ Start Teils wurde zur Nummerierung der Messages MSGNR 
	teils _WORD benutzt, dies habe ich einheitlich auf MESSNR umgesetzt
	dies ist nicht einzeln markiert*/
typedef _WORD MESSNR;
/*DYJ  Ende; */

typedef struct shortInfo {
	_WORD /* msg_type */ msgType;
	MESSNR number;
	_WORD copyCount;
	MESSNR refNum;
	_BOOL sendMsg;
	_BOOL toDelete;
	_WORD /* tDistribution */ dist;
	_ULONG size;
	_BOOL noRefLine;
	_UWORD cDate;
	_UWORD cTime;
	_WORD /* tDistribution */ orgDist;
	_ULONG reserved1;
	_ULONG reserved2;
} PACKED shortInfo;

typedef struct _msgInfo {
	shortInfo info;
	_BOOL new;
	_BOOL hdrRead;
	_BOOL isSend;
	_BOOL selected;
	_UBYTE *date;
	_UBYTE *receiver;
	_UBYTE *orgGroup;
	_UBYTE *group;
	_UBYTE *refId;
	_UBYTE *topic;
	_UBYTE *rId;
	_UBYTE *realName;
	_UBYTE *replyTo;
	_UBYTE *sender;
	_UBYTE *followupTo;
	_UBYTE *attachment;
	_UBYTE *Absender;
	_UBYTE *ref;
	_UBYTE *cc;
	_UBYTE *bcc;
	_UBYTE *eZeitX;
/*	
	_UBYTE *retPath;
	_UBYTE *keyw;
	_UBYTE *resent;
	_UBYTE *trace;
	_UBYTE *received;
	_UBYTE *path;
	_UBYTE *mailer;
	_UBYTE *org;*/
} msgInfo, *msgInfoPtr;



extern msgInfo *msgArray;
extern MESSNR messages;
extern MESSNR maxMess;


_VOID Messages_Number2Name(MESSNR number, _UBYTE *str, size_t strsize);
/* Wandelt eine Msgnummer in einen Nachrichtendateinamen um
 */

_ULONG Messages_FileSize(CONST _UBYTE *path, CONST _UBYTE *name, _UWORD *date, _UWORD *time);
/* Holt die Dateigroesse und Erstellungsdatum und -uhrzeit einer Datei
 */

_WORD Messages_FindMessage(MESSNR number);
/* Liefert den internen Index der Nachricht mit der Nummer number
 */
/* Liefert Konfigurationsvariablen des Typs stamm.Gruppe
*/
_BOOL Messages_GetGroupInf(CONST _UBYTE *stamm,CONST _UBYTE *gruppe, _UBYTE *val, size_t valsize);

_VOID Messages_NewMessage(CONST _UBYTE *Gruppe, CONST _UBYTE *Wegen);
/* Eine neue Message anlegen und danach editieren */

_VOID Messages_NewKomMessage(CONST _UBYTE *fromGroup, CONST _UBYTE *Group,
	CONST _UBYTE *Wegen, CONST _UBYTE *RefId, CONST _UBYTE *txt,
	CONST _UBYTE *mId, CONST _UBYTE *To, CONST _UBYTE *RealName, CONST _UBYTE *References);
/* Einen Kommentar zu einer Gruppennachricht in
 * eine andere Gruppe schicken.
 */

_VOID Messages_NewAnsMessage(CONST _UBYTE *an, CONST _UBYTE *realName,
	CONST _UBYTE *fromGroup, CONST _UBYTE *Wegen, CONST _UBYTE *RefId, CONST _UBYTE *txt, CONST _UBYTE *mId);
/* Einen Kommentar zu einer Gruppennachricht an jemand
 * persoenlich schicken.
 */

_VOID Messages_UpdateFileSize(_WORD number);
/* Erzwingt ein Update der Nachrichtengroesse der Nachricht mit
 * der Nummer number
 * Wird nach NewRegMsg benoetigt.
 */

_VOID Messages_NewPersMsg(CONST _UBYTE *Empfaenger, CONST _UBYTE *RealName, CONST _UBYTE *Wegen);
/* Eine neue persoenliche Nachricht an jemand schicken
 */

_VOID Messages_NewKom(CONST _UBYTE *Nr, CONST _UBYTE *Wegen, CONST _UBYTE *gruppe, _UBYTE *mId,
	CONST _UBYTE *To, CONST _UBYTE *RealName, tDistribution oldDist, CONST _UBYTE *References);
/* Einen Kommentar erzeugen
 */
 _VOID Messages_NewPseudoKom(CONST _UBYTE *Nr, CONST _UBYTE *Absender, CONST _UBYTE *Wegen, CONST _UBYTE *gruppe, CONST _UBYTE *an, CONST _UBYTE *mId, CONST _UBYTE *RealName);	/*DYJ 5.34d */

_VOID Messages_NewAnswer(CONST _UBYTE *Nr, CONST _UBYTE *from, CONST _UBYTE *Wegen, CONST _UBYTE *gruppe, CONST _UBYTE *an, CONST _UBYTE *mId, CONST _UBYTE *RealName,CONST _UBYTE *Cc);
/* Eine Antwort erzeugen
 */

_VOID Messages_SendState(CONST _UBYTE *Nr, _UBYTE NewState);
/* Erstellt eine Statusnachricht fuer die persoenlichen Nachrichten,
 * die man empfangen hat
 */

_VOID Messages_CopyOrForwardMessage(CONST _UBYTE *Nr, CONST _UBYTE *To, CONST _UBYTE *RealName, CONST _UBYTE *comment, _BOOL copy);
/* Erstellt eine Statusmeldung fuer eine Kopie oder eine
 * Weiterleitung
 */

_VOID Messages_CopyOwnMessage(CONST _UBYTE *MailId, CONST _UBYTE *from, CONST _UBYTE *To, CONST _UBYTE *RealName, CONST _UBYTE *Comment, _WORD minNum);
/* Erstellt eine Kopie einer eigenen Nachricht
 */

_BOOL Messages_IsPrivateMessage(_UBYTE *internalId, size_t strsize);
/* Gibt zurueck, ob die Message eine private oder eine
 * oeffentliche Nachricht ist. Der Parser muss das beim Abarbeiten
 * des Logfiles wissen, um evtl. private Nachrichten noch
 * einfuegen zu koennen.
 */

_BOOL Messages_MsgHasCopys(CONST _UBYTE *internalId);
/* Gibt zurueck, ob die Nachricht Kopien hat oder nicht.
 * Wenn es keine private Nachricht ist, dann wird immer FALSE
 * zurueckgegeben
 */

_BOOL Messages_ChangeMessage(CONST _UBYTE *internalId);
/* Wenn die Nachricht ein Kommentar oder eine Antwort ist,
 * dann wird daraus eine entsprechende Nachricht mit Wildwestverkettung
 * erzeugt, damit die Maus die beim naechsten Mal annimmt.
 */

_BOOL Messages_MakeGroupcom(CONST _UBYTE *internalId);
/* Wenn die Nachricht ein Kommentar auf eine eigene Nachricht ist,
 * dann wird daraus eine entsprechende Nachricht als GK
 * erzeugt, damit die Maus die beim naechsten Mal annimmt.
 */

GLOBAL _BOOL Messages_GetHdrInfos(CONST _UBYTE *internalId,msgInfo *msg);
/* Gibt an den Parser die noetigen Informationen zurueck,
 * um eine persoenliche Nachricht einzufuegen
 */

_VOID Messages_GetMsgFileName(_UBYTE *name, size_t namesize);
/* Gibt an den Parser den Dateinamen zurueck,
 * unter dem die Nachricht gespeichert wurde,
 * ohne Extension
 */

_VOID Messages_SortMessages(_VOID);
/* Sortiert die Nachrichten intern richtig
 */

_VOID Messages_WriteHdrInfo(msgInfo *msg);
/* Schreibt die Headerinformationen der Nachricht in die .HDR-Datei
 */

_BOOL Messages_ReadHdrInfo(msgInfo *msg, _BOOL externalRef);
/* Liest die Headerinformationen aus der MSGxxx.HDR-Datei ein
 * ExternalRef: msg ist keine Referenz auf dem msgArray.
 */

_VOID Messages_ReadMessageInfo(_VOID);
/* Liest die MSGINFO.DAT ein
 */

_VOID Messages_ReReadMessageInfo(_VOID);
/* Liest die MSGINFO.DAT erneut ein
 */

_VOID Messages_WriteMessageInfo(_BOOL doRedrawWdw);
/* Schreibt die MSGINFO.DAT ein
 */

_VOID Messages_MakeMausId(CONST msgInfo *msg, _UBYTE *str, size_t strsize);
/* Erzeugt eine ID, wie sie an die Maus geschickt wird.
 * Format:
 * CM###ddddd, ### ist die interne Messagenummer,
 * ddddd ist das Datum und die Zeit im 36er System
 */

_BOOL Messages_CreateMessage(
	_WORD minNum,
	CONST _UBYTE *From,
	CONST _UBYTE *To,
	CONST _UBYTE *OrgGroup,
	CONST _UBYTE *Group,
	CONST _UBYTE *RefId,
	CONST _UBYTE *Topic,
	CONST _UBYTE *RealName,
	CONST _UBYTE *Cc,			/*DYJ 5.19g */
	msg_type type,
	MESSNR copyTo,
	CONST _UBYTE *crossLine,
	CONST _UBYTE *oldMId,
	tDistribution oldDist,
	_BOOL openEditor,
	MESSNR *messIdx,
	CONST _UBYTE *References
	);
/* Erzeugt eine neue Nachricht, Oberfunktion fuer alle neuen Nachrichten
 * Sollte nicht benutzt werden, nur fuer interne Benutzung
 */

_VOID Messages_deleteMessage(CONST _UBYTE *internalId, _BOOL killEdit, _BOOL changeState);
/* Loescht eine Nachricht, schliesst ggf. die Editoren und ggf. Status von
 * persoenlicher Nachricht zurueckstellen
 */

_VOID Messages_DeleteMessage(CONST _UBYTE *internalId);


/* Nachricht mit dieser internen Id loeschen. Ruft selber deleteMessage auf
 */

typedef enum {
	itReceiver,
	itOrgGroup,
	itGroup,
	itRid,
	itTopic,
	itMid,
	itRName,
	itReplyTo,
	itSender,
	itFollowup,
	itAttachment,
	itRef,
	itFrom,
	itCc,
	itBcc,
	itEZeitX,
	itRetPath,
	itKeyw,
	itResent,
	itTrace,
	itReceived,
	itPath,
	itMailer,
	itOrg,
	
} msgInfoType;


_VOID Messages_MsgEditGetInfos(HWND wdw, msgInfoType info, _UBYTE *str, size_t strsize);
/* Gibt die gewuenschten Infos zu dem Message-Editor wdw. Wenn die Information
 * nicht vorhanden ist, dann wird ein leerer String geliefert
 */

_BOOL Messages_MsgIsPrivate(HWND wdw);
/* Gibt zurueck ob die Nachricht im Fenster eine neue
 * persoenliche ist
 */

/*DYJ 5.30l Start*/
_VOID Messages_Infoline(HWND wdw, CONST _UBYTE *infoline, CONST _UBYTE *infolineM);
/*DYJ  Ende; alt:	
_VOID Messages_Infoline(HWND wdw, CONST _UBYTE *infoline);
*/

_BOOL Messages_MsgEditorTop(HWND wdw);
/* Liefert zurueck, ob gerade ein Message-Editor das Topwindow ist,
 * also ein Editor, der diesem Modul bekannt ist
 */

_VOID Messages_openReference(_WORD idx);
/* Oeffnet die Referenznachricht
 */

_VOID Messages_OpenEditor(msgInfo *msg, _BOOL new, _WORD num, _ULONG offset, _WORD forView);
/* Oeffnet einen CAT-Editor mit einer Nachricht drin
 */

_VOID Messages_UpdateEditors(CONST msgInfo *msg);
/* Aktualisiert die mit der Nachricht verbundenen Infozeilen der Editoren
 */

_VOID Messages_SaveEditPos(MESSNR *max);
/* Sichert die Positionen der Editoren
 * Gibt die Anzahl der gesicherten Positionen zurueck
 */

_BOOL Messages_CloseAllEditors(_BOOL force);
/* Schliesst alle Nachrichteneditoren
 */

_VOID Messages_MsgAskForSave(_VOID);
/* Fragt fuer alle offenen Editorfenster mit Nachrichten und
 * veraenderten Texten nach, ob diese noch gesichert werden sollen.
 * Sollte vor dem Erstellen des Infles aufgerufen werden.
 */

_VOID Messages_ReloadEditors(_VOID);
/* Aktualisiert nach dem Erstellen des Infiles alle
 * offenen Editorfenster
 */

_VOID Messages_InitMessages(_VOID);
/* Modul initialisieren. Kann auch wiederholt aufgerufen werden,
 * dann werden die Strukturen neu initialisiert
 */

_VOID Messages_ExitMessages(_VOID);


#endif /* __CAT_MESSAGES_H__ */
