#ifndef __CAT_MSGWINDOW_H__
#define __CAT_MSGWINDOW_H__
/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */



#ifndef __PORTAB_H__
#include <portab.h>
#endif

#ifndef __CAT_MESSAGES_H__
#include <messages.h>
#endif

#ifndef __CAT_WDWMANAGER_H__
#include <wdwmanag.h>
#endif


_VOID MsgWindow_msgOpen(_BOOL errorMsg);
/* Bringt das Fenster mit der Nachrichtenuebersicht
 * in den Vordergrund bzw. oeffnet es, falls noch nicht
 * offen. Die Nachricht muss dann im Fenster ausgewaehlt
 * werden.
 */

_VOID MsgWindow_msgClose(HWND wdw);
/* Schliesst das Fenster mit der Nachrichtenuebersicht wieder
 */

_BOOL MsgWindow_msgWindowTop(HWND wdw);
/* Gibt zurueck, ob das Fenster mit der Uebersicht oben ist
 */

_VOID MsgWindow_msgSetFont(HWND wdw, _WORD font, _WORD fontSize);
/* Setzt den Font fuer die Uebersicht
 */

_VOID MsgWindow_SelectFont(HWND wdw);

_VOID MsgWindow_msgSelectAll(HWND wdw);
/* Selektiert alle Nachrichten in der Nachrichtenliste
 */

_VOID MsgWindow_deselectEntries(HWND wdw);
/* Deselektiert alle Nachrichten in der Nachrichtenliste
 */

_VOID MsgWindow_msgSavePos(_VOID);
/* Sichert die Position des Messagefensters und der
 * zugehoerigen Editoren
 */

_VOID MsgWindow_msgRestorePos(_VOID);
/* Restauriert die Positionen des Messagefensters
 * und der zugehoerigen Editoren
 */

_VOID MsgWindow_msgUpdateInfo(_VOID);
/* Die MSGINFO.DAT wird neu eingelesen.
 */

_BOOL MsgWindow_msgCloseAll(_BOOL force);
/* Schliesst das Uebersichtsfenster und alle dazugehoerigen
 * Editorfenster. Nur wichtig, falls die Positionen
 * gesichert und restauriert werden sollen.
 */

_VOID MsgWindow_RedrawAll(_VOID);
/* Zeichnet alle Fenster neu
 */

_BOOL MsgWindow_changeHdr(msgInfo *message);
/* Ruft den Dialog auf, um den Nachrichtenheader zu aendern.
 * TRUE: Daten geaendert
 */

_VOID MsgWindow_MsgSetList(msgInfo *list, _BOOL doRedrawWdw);
/* Setzt die Liste fuer das Fenster
 */

_VOID MsgWindow_MsgSetMaxPos(MESSNR maxPos, _BOOL doRedrawWdw);
/* Setzt die Maximalposition fuer die Liste
 */

_VOID MsgWindow_MsgCloseIfOpen(_VOID);
/* Schliesst das Fenster, falls es offen ist
 */

_VOID MsgWindow_MsgUpdateButtons(_VOID);
/* Aktualisiert die Buttons im Anzeigefenster passend zur Selektion
 */

_VOID MsgWindow_MsgRedrawEntry(_WORD idx);
/* Erzwingt das Neuzeichnen des Eintrags mit der Nummer idx
 * im Fenster
 */

_VOID MsgWindow_MsgDeselectAll(_VOID);
/* Setzt den Selectindex auf -1 und erzwingt ggf. einen Redraw
 */

_BOOL MsgWindow_InitMessageManager(_VOID);
/* Initialisiert das Modul und einige wichtige Daten
 * Ruft intern auch die Initialisierung vom Modul Messages auf
 */

_VOID MsgWindow_ExitMessageManager(_VOID);



#endif /* __CAT_MSGWINDOW_H__ */
