#ifndef __CAT_PMFILTER_H__
#define __CAT_PMFILTER_H__
/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 *
 * 2.4.04 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.35d'
 *	Einige Umbenennungen vorgenommen um leichter suchen zu knnen
 */




#ifndef __CAT_CATTYPES_H__
#include <cattypes.h>
#endif
#define MAX_PM_FILTER 100
#define PM_FILTER_STRLEN 21

/*DYJ 5.35e Start*/
typedef enum _PMFILT_TYPES {ForSend,ForRec,ForBoth,ForSubj,ForID,ForRTO} PMFILT_TYPES;
/*DYJ  Ende; alt:	
typedef enum _PMFILT_TYPES {ForSend,ForRec,ForBoth,ForSubj,ForID} PMFILT_TYPES;
*/

/*DYJ 5.35d Start die folgenden Umbenennung nicht einzeln gekennzeichnet*/
typedef enum _PMFILT_AKTION {PMA_DELETE,PMA_GROUP,PMA_FLAGS,PMA_ANZ,
	PMAZ_ML,PMAZ_ID,PMAZ_RTO,PMAZ_SUB,PMAZ_SEND,PMAZ_REC,
	PMAB_INIT,PMAB_LINE,PMAB_LINE_MAUS,PMAB_FREE} PMFILT_AKTION;
/*DYJ  Ende; alt:	

/*DYJ 5.32b Start*/
/*DYJ 5.34d Start*/
typedef enum _PMFILT_AKTION {PMA_ML=-13,PMA_ID=-11,PMA_SUB=-8,PMA_SEND=-5,PMA_LINE_MAUS,PMA_REC,
/*DYJ  Ende; alt:	
typedef enum _PMFILT_AKTION {PMA_ID=-11,PMA_SUB=-8,PMA_SEND=-5,PMA_LINE_MAUS,PMA_REC,
*/
	PMA_INIT,PMA_LINE,PMA_DELETE,PMA_GROUP,PMA_FLAGS,PMA_ANZ,PMA_FREE} PMFILT_AKTION;
/*DYJ  Ende; alt:	
typedef enum _PMFILT_AKTION {PMA_ID=-11,PMA_SUB=-8,PMA_SEND=-5,PMA_REC=-3,PMA_INIT,PMA_LINE,PMA_DELETE,PMA_GROUP,PMA_FLAGS,PMA_ANZ,PMA_FREE} PMFILT_AKTION;
*/
*/
typedef struct pmFilterStruct {
	_UBYTE suchStr[60];
	_UBYTE gruppe[64];
	_UBYTE flags[20];
	_UBYTE filtName[PM_FILTER_STRLEN];
	_WORD  prio;
/*DYJ 5.35d Start die folgenden Umbenennung nicht einzeln gekennzeichnet*/
	PMFILT_TYPES pmfType;
	PMFILT_AKTION pmfAktType;
/*DYJ  Ende; alt:	
	PMFILT_TYPES filtType;
	PMFILT_AKTION filtAktTyp;
*/
} pmFilterStruct;

_VOID PmFilter_ReadFilter(pmFilterStruct *filter, _WORD num);
/* Liest die Daten zu Filter num aus den Configvariablen
 * aus
 */

_VOID PmFilter_WriteFilter(CONST pmFilterStruct *filter, _WORD num);
/* Schreibt die Daten zu Filter num in die Configvariablen
 */

_BOOL PmFilter_PmFilterMessage(_BOOL *isError);
/* Ruft die definierten Filter auf
 * TRUE: Es wurde mindestens ein Filter aufgerufen
 */
/*DYJ 5.35d Start*/
_BOOL PmFilter_DoFilter(_UBYTE *str,_WORD len, PMFILT_AKTION mode);
/*DYJ  Ende; alt:	
_BOOL PmFilter_DoFilter(_UBYTE *str,_WORD len, _WORD mode);
*/
#endif /* __CAT_PMFILTER_H__ */
