#ifndef __CAT_TREELIST_H__
#define __CAT_TREELIST_H__
/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */



#ifndef __PORTAB_H__
#include <portab.h>
#endif
#ifndef __CAT_TYPES_H__
#include <cattypes.h>
#endif
#ifndef __CAT_DATASYS_H__
#include <datasys.h>
#endif
/* -------------------------------------------------------------------- */
/*		typedefs														*/
/* -------------------------------------------------------------------- */

/* Kommentarbaeume graphisch dargestellt fuer CAT
 */

_VOID treeList_treeOpen(CAT_GROUP_NUMBER gruppe, MSGNR which, HWND grinWdw);
/* Oeffnet ein Fenster mit einen Kommentarbaum
 */

_VOID treeList_treeClose(HWND wdw);
/* Schliesst ein Fenster mit einem Kommentarbaum
 */

_VOID treeList_treeCloseAll(_VOID);
/* Schliesst alle Fenster des Moduls
 */

_VOID treeList_treeRedrawAll(_VOID);
/* Zeichnet alle Fenster des Moduls neu
 */

_BOOL treeList_treeWindowTop(HWND wdw);
/* Ist ein Kommentarbaumfenster oben? */

_VOID treeList_treeSetFont(HWND wdw, _WORD font, _WORD fontSize);
/* Setzt den Font fuer das Kommentarbaumfenster */

_VOID treeList_SelectFont(HWND wdw);

_VOID treeList_treeSetFlags(HWND wdw, MSGBITS setBits, MSGBITS clearBits);
/* Fuer alle selektierten Nachrichten
 * ein paar Flags setzen oder loeschen
 */

_VOID treeList_treeSendState(HWND wdw, _UBYTE newState);
/*	Verschickt State-Nachrichten fr alle selektierten */

_VOID treeList_treeChangeFlags(CAT_GROUP_NUMBER group, MSGNR msgNum, MSGBITS newBits);
/* grin teilt der Baumanzeige mit, dass sich bei einer Nachricht
 * die Flags geaendert haben
 */

_VOID treeList_treeSelectAll(HWND wdw);
/* Alle Nachrichten in dem Fenster werden selektiert
 */

_VOID treeList_deselectEntries(HWND wdw);
/* Alle Nachrichten in dem Fenster werden deselektiert
 */

_BOOL treeList_listSomethingSelected(HWND wdw);
/* Prfen ob etwas selektiert ist*/
_BOOL treeList_treeSaveAs(HWND wdw, _BOOL asStatus);
/* speichern als */

/* -------------------------------------------------------------------- */
/*       Makros. & Konstanten                                           */
/* -------------------------------------------------------------------- */

enum {smListe=1,smOutfile,smText ,smDecode,smDBase,smData, smStatus};

/* -------------------------------------------------------------------- */
/*		Globale Variablen												*/
/* -------------------------------------------------------------------- */
extern _WORD lastSaveMode;

#endif
/* __CAT_TREELIST_H__ */
