#ifndef __CAT_WATCHDOG_H__
#define __CAT_WATCHDOG_H__
/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */



#ifndef __PORTAB_H__
#include <portab.h>
#endif
#ifndef __CAT_DATA_H__
#include <data.h>
#endif

typedef enum {
	watchdog_accept,
	watchdog_filter,
	watchdog_forget
} filtResult;


filtResult WatchDog_CheckThis(CONST PtrRecord *msg);
/* Ueberprueft eine Message und gibt das entsprechende
 * Ergebnis zurueck. Wenn der interne Watchdog ausgeschaltet ist,
 * wird immer accept zurueckgegeben.
 * Erlaeuterung der Ergebnisse:
 * accept: Nachricht einfuegen und anzeigen.
 * filter: Nachricht einfuegen, aber nicht anzeigen (Flag setzen)
 * forget: Nachricht nicht einfuegen
 */

_VOID WatchDog_GetFiltList(CONST _UBYTE *name);

/* Beim WatchDog abmelden */

typedef enum {
	pCatAccept,
	pCatForget,
	pCatFiltered
} watchType;


/* Soll diese Nachricht durchkommen, Frage von Datenbank an installierten WatchDog */
watchType WatchDog_AcceptThis(PtrRecord *mess);

/* Ist der WatchDog angemeldet und aktiv? */
_VOID WatchDog_isWatchDog(_BOOL *installed, _BOOL *active);

_VOID WatchDog_SendTerminate(_VOID);

_VOID WatchDog_Init(_VOID);


#endif /* __CAT_WATCHDOG_H__ */
