#ifndef __CAT_WIEDERVORLAGE_H__
#define __CAT_WIEDERVORLAGE_H__
/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */



#ifndef __PORTAB_H__
#include <portab.h>
#endif
#ifndef __DATA_H__
#include <data.h>
#endif
#include <wiederv2.h>



_BOOL WiederVorlage_SaveResubList(_WORD modus);
/* Liste der Eintraege mit Wiedervorlage sichern
 */

_BOOL WiederVorlage_ReadResubList(_WORD modus);

/* Liste der Eintraege mit Wiedervorlage laden
 */
 
_ULONG WiederVorlage_ResubListSize(_VOID);
/* Gibt die Laenge der Wiedervorlage als
   String zurueck
*/

_VOID WiederVorlage_GetResubList(_UBYTE *ptr);
/* Schreibt die kompletten Daten der Wiedervorlage
   in einen String. Die noetige Laenge kann mit
   WiederVorlage_ResubListSize erfragt werden
*/

_VOID WiederVorlage_SelectResub(_WORD modus);
/* Liste der Eintraege mit Wiedervorlage bearbeiten
 */

GLOBAL _VOID WiederVorlage_AddResub(CONST _UBYTE *group, CONST _UBYTE *msgId, CONST _UBYTE *from, CONST _UBYTE *topic, CATDATE tDate,_UBYTE *eZeitX);
/* Wiedervorlage hinzufuegen
 */

_VOID WiederVorlage_CheckForResub(_VOID);
/* Nachpruefen, ob etwas zur Wiedervorlage vorliegt
 */

_VOID WiederVorlage_CloseCmts(_VOID);
/* Schliesst die COMMENTS.DAT
 */
 
_VOID WiederVorlage_InitCmts(_VOID);
/* Setzt das Geoeffnet-Flag auf FALSE
 */

_BOOL WiederVorlage_WriteCmts(PtrRecord *data);
/* Schreibt einen Eintrag in die COMMENTS.DAT 
 */

_BOOL WiederVorlage_CleanUpCmts(_ULONG *count);
/* comments.dat aufraeumen, indem alte Eintraege geloescht werden
 */

_VOID WiederVorlage_Exit(_VOID);

#endif /* __CAT_WIEDERVORLAGE_H__ */
