/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */


#include <infodlg.h>
#include <stddef.h>
#include <mtpaths.h>
#include <mte.h>
#include <maustaus.h>
#include <vdiutil.h>
#include <catgloba.h>
#include <convertd.h>
#include <cathelp.h>
#include <cattypes.h>
#include <infofile.h>
#include <listdl.h>
#include <confvars.h>
#include <varnamel.h>
#include <catfiles.h>

#include <mtutils.h>
#include <mtpopups.h>
#include <mtappl.h>
#include <mttextfi.h>
#include <mtdir.h>
#include <portvdi.h>

#include <routinec.h>
#include <routines.h>
#include <ro_time.h>
#include <file_io.h>
#include <dir_io.h>
#include <strconv.h>


/* Fuer Listdialoge, Environmentinfo */

typedef struct {
	_BOOL open;
	_BOOL new;
	_BOOL changed;
	_WORD exitBut;
} infoBlock;

LOCAL OBJECT *gruppen;
LOCAL _UBYTE lastFile[PATH_MAX];
LOCAL _WORD maxListWidth;
LOCAL _WORD maxShortname;
LOCAL _BOOL listChanged;

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

LOCAL _VOID infToStr(_VOID *entry, _VOID *env, _UBYTE *str, size_t strsize)
{
	infEntry *inf;
	
	UNUSED(env);
	inf = entry;
	if (inf == NULL || (inf->i.res & ITI_TITLE))
	{
		*str = '\0';
	} else
	{
		strMcpy(str, strsize, inf->i.mausShort);
		strMcat(str, strsize,  " ");
		strMcat(str, strsize, inf->i.mausName);
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL selInfEntry(_VOID *entry, _VOID *env, _WORD line)
{
	infEntry *inf;
	_UBYTE infStr[256];
	GRECT r;
	infoBlock *info;
	
	info = env;
	inf = entry;
	if (inf != NULL)
	{
		inf->i.selected = !inf->i.selected;
		if (inf->i.selected && line >= 0)
		{
			if (inf->i.res & ITI_TITLE)	/* Wenn Titel, dann nicht in Autolocator */
			{
				infStr[0] = '\0';
				ListDl_SetDcButton(gruppen, GOK);
			} else
			{
				infToStr(entry, NULL, infStr, sizeof(infStr));
				if (!info->open)
					ListDl_SetDcButton(gruppen, GCHANGE);
				else
					ListDl_SetDcButton(gruppen, GOK);
			}
			SetObjcString(gruppen, NEWGROUP, infStr);
			WinDials_WinDialDraw(gruppen, NEWGROUP, 0, &r, FALSE);
		}
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL isSelected(_VOID *entry, _VOID *env)
{
	infEntry *inf;
	infoBlock *e;
	
	inf = entry;
	e = env;
	if (e != NULL && inf != NULL && e->open)
	{
		/* Ist fuer's oeffnen */
		if (inf->i.selected)
		{
			/* Pruefen */
			inf->i.selected = !inf->i.isMaus || inf->i.avail;
		}
	}
	return inf != NULL && inf->i.selected;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL isEnabled(_VOID *entry, _VOID *env)
{
	infEntry *inf;
	infoBlock *e;
	
	inf = entry;
	e = env;
	if (e != NULL && inf != NULL && e->open)
	{
		return !inf->i.isMaus || inf->i.avail;
	}
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID enableFsel(OBJECT *infBox, _BOOL ordered, _BOOL enable, _BOOL draw)
{
	GRECT r;
	
	EnableObjState(infBox, ICFILE, DISABLED, enable);
	EnableObjState(infBox, ICORDER, DISABLED, !enable);
	EnableObjState(infBox, ICORDER, SELECTED, ordered);
	EnableObjFlags(infBox, ICFILE, TOUCHEXIT, !enable);
	EnableObjFlags(infBox, ICORDER, TOUCHEXIT, enable);
	if (draw)
	{
		WinDials_WinDialDraw(infBox, ICFILE, 0, &r, FALSE);
		WinDials_WinDialDraw(infBox, ICORDER, 0, &r, FALSE);
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID enablePopup(OBJECT *infBox, _BOOL enable, _BOOL draw, _WORD select)
{
	GRECT r;
	
	EnableObjState(infBox, ICDAYS, DISABLED, !enable);
	EnableObjState(infBox, ICINT1, DISABLED, !enable);
	EnableObjState(infBox, ICINT2, DISABLED, !enable);
	EnableObjState(infBox, ICDAY1, DISABLED, !enable);
	EnableObjState(infBox, ICDAY2, DISABLED, !enable);
	EnableObjFlags(infBox, ICINT1, TOUCHEXIT, enable);
	EnableObjFlags(infBox, ICINT2, TOUCHEXIT, enable);
	EnableObjFlags(infBox, ICDAY1, TOUCHEXIT, enable);
	EnableObjFlags(infBox, ICDAY2, TOUCHEXIT, enable);
	EnableObjFlags(infBox, ICDAYS, EDITABLE, enable && select == (ORDERBOX_FREE - 1));
	if (draw)
	{
		CalcArea(infBox, ICDAY0, &r);
		r.g_w += 2;
		r.g_h += 2;
		WinDials_WinDialDraw(infBox, ROOT, MAX_DEPTH, &r, TRUE);
		WinDials_WinDialDraw(infBox, ICINT1, 1, &r, FALSE);
		WinDials_WinDialDraw(infBox, ICINT2, 1, &r, FALSE);
	}
}

/*** ---------------------------------------------------------------------- ***/

typedef struct _changeInfo {
	_BOOL editOld;
	OBJECT *infPop;
	OBJECT *dayPop;
	infEntry inf;
	_WORD select;
	_WORD wday;
	_BOOL wasMouse;
	_UBYTE fname[PATH_MAX];
	_WORD exitBut;
} changeInfo;

LOCAL CONST _UBYTE days[6][3] = { "-1", " 0", " 1", " 7", "14", ""};

LOCAL _VOID SetFileName(OBJECT *tree, _WORD obj, CONST _UBYTE *fname)
{
	_UBYTE copy[PATH_MAX];
	_WORD maxLen;
	_WORD len;
	_WORD dummy;
	CONST _UBYTE *p, *first, *start;
	
	ObjcStrLen(tree, obj, &maxLen, &dummy);
	len = (_WORD)strLen(fname);
	if (len > maxLen)
	{
		p = strChr(fname, '\\');
		if (p == NULL)
			p = strChr(fname, '/');
		if (p != NULL)
		{
			/* Pfade am Anfang herauskuerzen */
			first = p + 1;
			do
			{
				/* naechsten Slash suchen */
				start = p + 1;
				p = strChr(start, '\\');
				if (p == NULL)
					p = strChr(start, '/');
			} while (p != NULL && (len - (p - first) + 3) > maxLen);
			if (p == NULL)
			{
				SetObjcString(tree, obj, fname);
			} else
			{
				len = (_WORD)(first - fname + 1);
				if (len >= sizeof(copy))
					len = (_WORD)sizeof(copy) - 1;
				strMcpy(copy, len, fname);
				strMcat(copy, sizeof(copy), "...");
				strMcat(copy, sizeof(copy), p);
				SetObjcString(tree, obj, copy);
			}
		} else
		{
			SetObjcString(tree, obj, fname);
		}
	} else
	{
		SetObjcString(tree, obj, fname);
	}
}

/*** ---------------------------------------------------------------------- ***/
/*DYJ 5.21b */
LOCAL _BOOL changeButton(OBJECT *tree, _VOID *env, _WORD button, _WORD mx, _WORD my, _UWORD kstate, _WORD clicks)
{
	changeInfo *info;
	_WORD x, y;
	_UBYTE path[PATH_MAX];
	_UBYTE name[PATH_MAX];
	_WORD res;
	GRECT r;
	
	UNUSED(mx);
	UNUSED(my);
	UNUSED(clicks);
	info = env;
	button &= 0x7fff;
	switch (button)
	{
	case ICMAUS:
		info->inf.i.isMaus = !info->inf.i.isMaus;
		CalcArea(tree, button, &r);
		EnableObjState(tree, button, SELECTED, info->inf.i.isMaus);
		WinDials_WinDialDraw(tree, button, 1, &r, FALSE);
		if (info->inf.i.isMaus)
		{
			ObjcString(tree, ICSHORT, info->fname, sizeof(info->fname));
			strLwr(info->fname);
			strBcat(info->fname, textExt);
			SetObjcString(tree, ICFILE, info->fname);
		} else
		{
			info->inf.i.ordered = FALSE;
			enablePopup(tree, info->inf.i.ordered, TRUE, info->select);
			EnableObjState(tree, ICSOFORT, SELECTED, FALSE);
		}
		enableFsel(tree, info->inf.i.ordered, info->inf.i.isMaus, TRUE);
		EnableObjFlags(tree, ICSOFORT, SELECTABLE, info->inf.i.isMaus);
		EnableObjState(tree, ICSOFORT, DISABLED,  !info->inf.i.isMaus);
		WinDials_WinDialDraw(tree, ICSOFORT, 1, &r, FALSE);
		break;
	
	case ICORDER:
		info->inf.i.ordered = !info->inf.i.ordered;
		CalcArea(tree, button, &r);
		EnableObjState(tree, button, SELECTED, info->inf.i.ordered);
		WinDials_WinDialDraw(tree, button, 1, &r, FALSE);
		enablePopup(tree, info->inf.i.ordered, TRUE, info->select);
		break;
		
	case ICINT1:
		objc_offset(tree, button, &x, &y);
		info->select = mtPopups_TreePopup(info->infPop, x, y, VDIUtil_GetXState(tree, button)) - 1;
		if (info->select >= 0)
		{
			VDIUtil_SetXState(tree, button, info->select);
			if (info->select < ORDERBOX_WDAY - 1)
			{
				SetObjcString(tree, ICDAYS, days[info->select]);
				EnableObjFlags(tree, ICDAYS, EDITABLE, info->select == ORDERBOX_FREE - 1);
				EnableObjFlags(tree, ICDAYS, HIDETREE, FALSE);
				EnableObjFlags(tree, ICDAY0, HIDETREE, TRUE);
				info->inf.i.res &= ~ITI_ORDERED_WDAY;
			} else
			{
				EnableObjFlags(tree, ICDAYS, HIDETREE, TRUE);
				EnableObjFlags(tree, ICDAY0, HIDETREE, FALSE);
				info->inf.i.res |= ITI_ORDERED_WDAY;
			}
			VDIUtil_SetXString(tree, ICINT1, info->infPop, info->select);
			WinDials_WinDialDraw(tree, ICINT1, 0, &r, FALSE);
			CalcArea(tree, ICDAY0, &r);
			r.g_w += 2;
			r.g_h += 2;
			WinDials_WinDialDraw(tree, ROOT, MAX_DEPTH, &r, TRUE);
		}
		break;
		
	case ICINT2:
		info->select = VDIUtil_GetXState(tree, ICINT1);
		if(kstate&K_SHIFT)
			info->select = (info->select + 6) % 7;
		else
			info->select = (info->select + 1) % 7;
		VDIUtil_SetXState(tree, ICINT1, info->select);
		if (info->select < ORDERBOX_WDAY - 1)
		{
			SetObjcString(tree, ICDAYS, days[info->select]);
			EnableObjFlags(tree, ICDAYS, EDITABLE, info->select == ORDERBOX_FREE - 1);
			EnableObjFlags(tree, ICDAYS, HIDETREE, FALSE);
			EnableObjFlags(tree, ICDAY0, HIDETREE, TRUE);
			info->inf.i.res &= ~ITI_ORDERED_WDAY;
		} else
		{
			EnableObjFlags(tree, ICDAYS, HIDETREE, TRUE);		/* Wochentage sichtbar */
			EnableObjFlags(tree, ICDAY0, HIDETREE, FALSE);
			info->inf.i.res |= ITI_ORDERED_WDAY;
		}
		EnableObjFlags(tree, ICDAYS, EDITABLE, info->select == ORDERBOX_FREE-1);
		VDIUtil_SetXString(tree, ICINT1, info->infPop, info->select);
		WinDials_WinDialDraw(tree, ICINT1, 0, &r, FALSE);
		CalcArea(tree, ICDAY0, &r);
		r.g_w += 2;
		r.g_h += 2;
		WinDials_WinDialDraw(tree, ROOT, MAX_DEPTH, &r, TRUE);
		break;
		
	case ICDAY1:
		objc_offset(tree, button, &x, &y);
		info->wday = mtPopups_TreePopup(info->dayPop, x, y, VDIUtil_GetXState(tree, button)) - 1;
		if (info->wday >= 0)
		{
			VDIUtil_SetXState(tree, button, info->wday);
			VDIUtil_SetXString(tree, ICDAY1, info->dayPop, info->wday);
			WinDials_WinDialDraw(tree, ICDAY1, 0, &r, FALSE);
		}
		break;
	
	case ICDAY2:
		info->wday = VDIUtil_GetXState(tree, ICDAY1);
		if(kstate&K_SHIFT)
			info->wday = (info->wday + 6) % 7;
		else
			info->wday = (info->wday + 1) % 7;
		VDIUtil_SetXState(tree, ICDAY1, info->wday);
		VDIUtil_SetXString(tree, ICDAY1, info->dayPop, info->wday);
		WinDials_WinDialDraw(tree, ICDAY1, 0, &r, FALSE);
		break;
		
	case ICFILE:
		strBcpy(path, DataPath);
		*name = '\0';
		res = mtDir_FselGet(path, name,ALL_FILE_MASK, MausTauschrsc_WrkString(FS_SELECT_INFOFILE), FALSE);
		if (res)
		{
			strBcpy(info->fname, path);
			F_Path_Append(info->fname, name);
			SetFileName(tree, ICFILE, info->fname);
			DelObjState(tree, button, SELECTED);
			WinDials_WinDialDraw(tree, ICFILE, 0, &r, FALSE);
		}
		DelObjState(tree, button, SELECTED);
		WinDials_WinDialDraw(tree, button, 0, &r, FALSE);
		break;
		
	case ICHELP:
		DelObjState(tree, button, SELECTED);
		CatHelp_DoHelp(CatHelp_infoEdit);
		WinDials_WinDialDraw(tree, button, 0, &r, FALSE);
		break;
	
	case ICOK:
	case ICQUIT:
		DelObjState(tree, button, SELECTED);
		return TRUE;
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

/*DYJ 5.21b */
LOCAL _VOID changeGetSetValues(OBJECT *tree, _VOID *env, _BOOL set, _WORD exit)
{
	changeInfo *info;

	info = env;
	exit &= 0x7fff;
	if (set)
	{
		if (info->editOld)
		{
			SetObjcString(tree, ICTITEL, MausTauschrsc_WrkString(FS_ORDER_INFOFILES));
			SetObjcString(tree, ICSHORT, info->inf.i.mausShort);
			SetObjcString(tree, ICINFO, info->inf.i.mausName);
			CatGlobal_ReplaceStr(info->inf.i.filename, sizeof(info->inf.i.filename), "$D", DataPath);
			SetFileName(tree, ICFILE, info->inf.i.filename);
			if (info->inf.i.res & ITI_ORDERED_WDAY)
			{
				if (info->inf.i.orderIntervall < 0 || info->inf.i.orderIntervall > 6)
					info->wday = 0;
				else
					info->wday = info->inf.i.orderIntervall;
				
				if (info->wday == 0)	/* Wochentag umrechnen */
					info->wday = 6;
				else
					info->wday--;
			}
			else
				info->wday = 0;

		} else
		{
			info->inf.i.ordered = FALSE;
			info->inf.i.isMaus = FALSE;
			info->inf.i.orderIntervall = 0;
			info->inf.i.res &= ~ITI_ORDERED_WDAY;	/* (MH) */
			info->wday = 0;
			SetObjcString(tree, ICTITEL, MausTauschrsc_WrkString(FS_DEFINE_INFOFILES));
			SetObjcString(tree, ICSHORT, "");
			SetObjcString(tree, ICINFO, "");
			SetObjcString(tree, ICFILE, "");
		}
		if (info->inf.i.res & ITI_ORDERED_WDAY)
		{
			info->select = 6;
			EnableObjFlags(tree, ICDAYS, HIDETREE, TRUE);
			EnableObjFlags(tree, ICDAY0, HIDETREE, FALSE);
		} else
		{
			switch (info->inf.i.orderIntervall)
			{
				case ORDER_ONCE: info->select = 0; break;
				case ORDER_ALWAYS: info->select = 1; break;
				case 1: info->select = 2; break;
				case 7: info->select = 3; break;
				case 14: info->select = 4; break;
				default: info->select = 5; break;
			}
			EnableObjFlags(tree, ICDAYS, HIDETREE, FALSE);
			EnableObjFlags(tree, ICDAY0, HIDETREE, TRUE);
		}
		EnableObjFlags(tree, ICDAYS, EDITABLE, info->select == (ORDERBOX_FREE-1));
		VDIUtil_SetIntStr(tree, ICDAYS, info->inf.i.orderIntervall);
		VDIUtil_SetXState(tree, ICINT1, info->select);
		VDIUtil_SetXString(tree, ICINT1, info->infPop, info->select);
		VDIUtil_SetXState(tree, ICDAY1, info->wday);
		VDIUtil_SetXString(tree, ICDAY1, info->dayPop, info->wday);
		EnableObjState(tree, ICMAUS, SELECTED, info->inf.i.isMaus);
		EnableObjState(tree, ICSOFORT, DISABLED, !info->inf.i.isMaus);
		EnableObjState(tree, ICSOFORT, SELECTED, info->inf.i.res & ITI_ORDERED_NOW);
		enableFsel(tree, info->inf.i.ordered, info->inf.i.isMaus, FALSE);
		enablePopup(tree, info->inf.i.ordered, FALSE, info->select);
		info->wasMouse = info->inf.i.isMaus;
		strBcpy(info->fname, info->inf.i.filename);
	} else
	{
		info->exitBut = exit;
		if (exit == ICOK)
		{
			if (info->inf.i.res & ITI_ORDERED_WDAY)						/* (MH) */
			{
				if (info->wday >= 6)
					info->inf.i.orderIntervall = 0;
				else
					info->inf.i.orderIntervall = info->wday + 1;
			} else
			{
				VDIUtil_GetIntStr(tree, ICDAYS, &info->inf.i.orderIntervall);
			}
			ObjcString(tree, ICSHORT, info->inf.i.mausShort, sizeof(info->inf.i.mausShort));
			ObjcString(tree, ICINFO, info->inf.i.mausName, sizeof(info->inf.i.mausName));
			strBcpy(info->inf.i.filename, info->fname);
			CatGlobal_ReplaceStr(info->inf.i.filename, sizeof(info->inf.i.filename), DataPath, "$D");
			if (!info->inf.i.isMaus)
			{
				info->inf.i.avail = TRUE;
			} else
			{
				if (!info->wasMouse)
					info->inf.i.avail = FALSE;
			}
			if (GetObjState(tree, ICSOFORT, SELECTED))	/* (MH) */
				info->inf.i.res |= ITI_ORDERED_NOW;
			else
				info->inf.i.res &= ~ITI_ORDERED_NOW;
			listChanged = TRUE;
		}
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL doChangeInf(_BOOL editOld, infEntry *inf)
{
	OBJECT *infBox;
	_WORD but;
	changeInfo *info;

	infBox = TreeAddr[INF_CONF];
	info = NEW(changeInfo, "dochangeInf");
	if (info == NULL)
		return FALSE;
	info->infPop = TreeAddr[ORDERBOX];
	info->dayPop = TreeAddr[DAYBOX];
	info->editOld = editOld;
	info->inf = *inf;
	if (WinDials_OpenWinDial (infBox, TRUE,
		changeGetSetValues,
		changeGetSetValues,
		changeButton,
		WinDials_defDraw,
		NULL,
		info))
	{
		WinDials_WinDialHandleEvents();
		but = info->exitBut;
		if (but == ICOK)
		{
			*inf = info->inf;
			inf->i.res = (inf->i.res & ~ITI_GROUP_MASK) | Infofiles_GetInfoGroupNumber(inf);	/* (MH) */
		}
	} else
	{
		but = -1;
	}
	OFREE(info);
	return but == ICOK;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL findSel(_VOID *e, _VOID *i)
{
	infEntry *entry;
	
	UNUSED(i);
	entry = e;
	return entry->i.selected;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL infEntry *edToList(_BOOL new, CONST infEntry *edEntry, _BOOL *draw)
{
	size_t bSize;
	infEntry *entry;
	_BOOL ok;
	
	bSize = INF_ALLOC_SIZE(edEntry->i.filename);
	entry = NEW(infEntry, "edToList");
	if (entry == NULL)
		return NULL;
	MemCpy(entry, edEntry, bSize);
	if (!new)
	{
		ok = Lists_InsertEntry(&infList, entry);
	} else
	{
		entry->i.selected = FALSE;
		ok = Lists_AppendEntry(&infList, entry);
	}
	if (!ok)
	{
		FREE(entry, bSize);
		if (new)
			*draw = FALSE;
	} else
	{
		Infofiles_SortList(&infList);
	}
	return entry;
}

/*** ---------------------------------------------------------------------- ***/

/*DYJ 5.30f Start*/
LOCAL _VOID chgEntry(_WORD obj, _VOID *env, LISTINFO info, _BOOL *draw, _BOOL *exit,_LONG *lstSel)
/*DYJ  Ende; alt:	
LOCAL _VOID chgEntry(_WORD obj, _VOID *env, LISTINFO info, _BOOL *draw, _BOOL *exit)
*/
{
	infEntry *entry;
	infEntry edEntry;
	size_t bSize;
	GRECT r;
	infoBlock *mode;
	
	UNUSED(info);
	*lstSel=-1;	/*DYJ 5.30f */
	mode = env;
	*exit = FALSE;
	Lists_ResetList(&infList);
	MemSetZeroStruct(edEntry);
	if (Lists_ScanEntries(&infList, Lists_forward, findSel, NULL))
	{
		entry = Lists_CurrentEntry(&infList);
		bSize = INF_ALLOC_SIZE(entry->i.filename);
		MemCpy(&edEntry, entry, bSize);
		*draw = doChangeInf(TRUE, &edEntry);
		if (*draw)
		{
			mode->changed = TRUE;
			/* Entry nochmal suchen */
			Lists_ResetList(&infList);
			if (Lists_ScanEntries(&infList, Lists_forward, findSel, NULL))
			{
				Lists_RemoveEntry(&infList, mem_free);
				edToList(FALSE, &edEntry, draw);
			}
		}
	} else
	{
		*draw = doChangeInf(FALSE, &edEntry);
		if (*draw)
		{
			mode->changed = TRUE;
			edToList(TRUE, &edEntry, draw);
		}
	}
	DelObjState(gruppen, obj, SELECTED);
	WinDials_WinDialDraw(gruppen, obj, 1, &r, FALSE);
}

/*** ---------------------------------------------------------------------- ***/
/*DYJ 5.21b */
/*DYJ 5.30f Start*/
LOCAL _VOID killEntry(_WORD obj, _VOID *env, LISTINFO info, _BOOL *draw, _BOOL *exit,_LONG *lstSel)
/*DYJ  Ende; alt:	
LOCAL _VOID killEntry(_WORD obj, _VOID *env, LISTINFO info, _BOOL *draw, _BOOL *exit)
*/
{
	GRECT r;
	_UBYTE fname[PATH_MAX];
	infoBlock *mode;
	infEntry *entry;
	_WORD result; 
	
	UNUSED(info);
	*lstSel=-1;	/*DYJ 5.30f */
	mode = env;
	*exit = FALSE;
	Lists_ResetList(&infList);
	*draw = Lists_ScanEntries(&infList, Lists_forward, findSel, NULL);
	if (*draw)
	{
		/* Abfragen, ob auch Datei selbst geloescht werden soll (MH) */
		result = mtAlerts_AlertRSC(3, AL_INFO_DELETE);	
		if (result != 1 && result != 2)
		{
			DelObjState(gruppen, obj, SELECTED);
			WinDials_WinDialDraw(gruppen, obj, 1, &r, FALSE);
			return;
		}
		if (result == 1)
		{
			entry = Lists_CurrentEntry(&infList);
			if (Infofiles_BuildName(entry, fname))
			{
				F_File_Delete(fname);
			}
		}
		mode->changed = TRUE;
		Lists_RemoveEntry(&infList, mem_free);
		Infofiles_SortList(&infList);
	}
	/* Editfeld loeschen */
	SetObjcString(gruppen, NEWGROUP, "");
	WinDials_WinDialDraw(gruppen, NEWGROUP, 1, &r, FALSE);
	DelObjState(gruppen, obj, SELECTED);
	WinDials_WinDialDraw(gruppen, obj, 1, &r, FALSE);
}

/*** ---------------------------------------------------------------------- ***/
/*DYJ 5.21b */
/* Raeumt die INFO.INF auf, indem getestet wird, welche Dateien vorhanden sind (MH) */
/*DYJ 5.30f Start*/
LOCAL _VOID updateInfo(_WORD obj, _VOID *env, LISTINFO info, _BOOL *draw, _BOOL *exit,_LONG *lstSel)
/*DYJ  Ende; alt:	
LOCAL _VOID updateInfo(_WORD obj, _VOID *env, LISTINFO info, _BOOL *draw, _BOOL *exit)
*/
{
	GRECT r;
	infEntry *pInf;
	_UBYTE fname[PATH_MAX];
	_UBYTE name[PATH_MAX];
	F_STAT st;
	infoBlock *mode;
	
	UNUSED(info);
	*lstSel=-1;	/*DYJ 5.30f */
	*exit = FALSE;
	*draw = FALSE;
	if (mtAlerts_AlertRSC(1, AL_INFO_UPDATE) != 1)
	{
		DelObjState(gruppen, obj, SELECTED);
		WinDials_WinDialDraw(gruppen, obj, 1, &r, FALSE);
		return;
	}
	
	MouseBusy();	
	Lists_ResetList(&infList);
	while ((pInf = Lists_NextEntry(&infList)) != NULL)
	{
		if (!(pInf->i.res & ITI_TITLE) && pInf->i.isMaus)
		{
			strBcpy(fname, DataPath);
			strBcpy(name, pInf->i.filename);
			strLwr(name);
			F_Path_Append(fname, name);
			if (F_Getinfo(fname, &st, TRUE) == GERR_OK && st.st_size > 0)
			{
				pInf->i.avail = TRUE;
			} else
			{
				if ((pInf->i.res & ITI_GROUP_MASK) != ITI_INFOFILE_O)
				{
					/* nicht verfuegbar */
					pInf->i.new = FALSE;
					pInf->i.avail = FALSE;
				} else
				{
					/* OUT-Block nicht da, Eintrag loeschen */
					Lists_RemoveEntry(&infList, mem_free);
				}
			}
		}
	}
	mode = env;
	mode->changed = TRUE;
	Infofiles_SortList(&infList);
	MouseArrow();
	/* Editfeld loeschen */
	SetObjcString(gruppen, NEWGROUP, "");
	DelObjState(gruppen, obj, SELECTED);
	WinDials_WinDialDraw(gruppen, obj, 1, &r, FALSE);
	WinDials_WinDialDraw(gruppen, NEWGROUP, 1, &r, FALSE);
	*draw = TRUE;
}

/*** ---------------------------------------------------------------------- ***/

/*DYJ 5.30f Start*/
LOCAL _VOID helpButton(_WORD obj, _VOID *env, LISTINFO info, _BOOL *draw, _BOOL *exit,_LONG *lstSel)
/*DYJ  Ende; alt:	
LOCAL _VOID helpButton(_WORD obj, _VOID *env, LISTINFO info, _BOOL *draw, _BOOL *exit)
*/
{
	infoBlock *modePtr;
	tHelp topic;
	GRECT r;
	
	UNUSED(lstSel);	/*DYJ 5.30f */
	UNUSED(info);
	modePtr = env;
	if (modePtr->open)
		topic = CatHelp_infoRead;
	else
		topic = CatHelp_infoEdit;
	CatHelp_DoHelp(topic);
	DelObjState(gruppen, obj, SELECTED);
	WinDials_WinDialDraw(gruppen, obj, 1, &r, FALSE);
	*draw = FALSE;
	*exit = FALSE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID updateButton(_VOID *entry, _VOID *env)
{
	_BOOL oneSel;
	infEntry *info;
	_BOOL isNeeded;
	GRECT r;
	infoBlock *mode;
	
	UNUSED(entry);
	mode = env;
	Lists_ResetList(&infList);
	oneSel = Lists_ScanEntries(&infList, Lists_forward, findSel, NULL);
	info = Lists_CurrentEntry(&infList);
	if (oneSel)
	{
		if (!mode->open)
		{
			if (mode->new)
			{
				DelObjFlags(gruppen, GCHANGE, HIDETREE);
				SetObjFlags(gruppen, GNEW, HIDETREE);
				WinDials_WinDialDraw(gruppen, GCHANGE, 0, &r, FALSE);
				mode->new = FALSE;
			}
		}
		isNeeded = info != NULL && ((info->i.res & ITI_TITLE) || (info->i.isMaus && Infofiles_IsNeededInfo(info->i.mausShort))); /* (MH) */
		if (GetObjState(gruppen, GDELETE, DISABLED) != isNeeded)
		{
			EnableObjState(gruppen, GDELETE, DISABLED, isNeeded);
			WinDials_WinDialDraw(gruppen, GDELETE, 0, &r, FALSE);
		}
		if (GetObjState(gruppen, GCHANGE, DISABLED) != isNeeded)
		{
			EnableObjState(gruppen, GCHANGE, DISABLED, isNeeded);
			EnableObjState(gruppen, GNEW, DISABLED, isNeeded);
			WinDials_WinDialDraw(gruppen, GCHANGE, 0, &r, FALSE);
		}
	} else
	{
		if (!mode->open)
		{
			if (!mode->new)
			{
				DelObjFlags(gruppen, GNEW, HIDETREE);
				DelObjState(gruppen, GNEW, DISABLED);
				SetObjFlags(gruppen, GCHANGE, HIDETREE);
				WinDials_WinDialDraw(gruppen, GNEW, 0, &r, FALSE);
				mode->new = TRUE;
			}
		}
		if (!GetObjState(gruppen, GDELETE, DISABLED))
		{
			SetObjState(gruppen, GDELETE, DISABLED);
			WinDials_WinDialDraw(gruppen, GDELETE, 0, &r, FALSE);
		}
	}
}

/*** ---------------------------------------------------------------------- ***/

/* Zum naechsten sichtbaren Eintrag springen (MH) */
LOCAL _VOID *nextEntry(_VOID *list)
{
	infEntry *pInf;
	List *lp;
	
	lp = list;	
	while ((pInf = Lists_NextEntry(lp)) != NULL)
	{
		if (pInf->i.res & ITI_ENTRY_VISIBLE)
			return pInf;
	}
	return NULL;
}

/*** ---------------------------------------------------------------------- ***/

/* Zum vorherigen sichtbaren Eintrag springen (MH) */
LOCAL _VOID *prevEntry(_VOID *list)
{
	infEntry *pInf;
	List *lp;
	
	lp = list;	
	while ((pInf = Lists_PrevEntry(lp)) != NULL)
	{
		if (pInf->i.res & ITI_ENTRY_VISIBLE)
			return pInf;
	}
	return NULL;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID resetList(_VOID *list)
{
	Lists_ResetList(list);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID CalcWidth(_VOID)
{
	infEntry *info;
	_WORD maxLength;
	GRECT r;
	_WORD extent[8];
	_WORD w;
	
	/* Maximale Breite eines Listeneintrages herausfinden */
	maxLength = 0;
	maxShortname = 0;
	Lists_ResetList(&infList);
	while ((info = nextEntry(&infList)) != NULL)
	{
		vqt_extent(PrivateWS, info->i.mausShort, extent);
		w = extent[2] - extent[0];
		if (w > maxShortname)
			maxShortname = w;
		vqt_extent(PrivateWS, info->i.mausName, extent);
		w = extent[2] - extent[0];
		if (w > maxLength)
			maxLength = w;
	}
	/* 17: 3 Zeichen vorne inkl. Haekchen,
	 *     1 Zeichen nach mausShort,
	 *     2 Zeichen Intervall
	 *     1 Trennzeichen
	 *     8 Zeichen Datum
	 *     1 Trennzeichen
	 *     1 Zeichen nach Infotext
	 */
	maxListWidth = maxLength + maxShortname + 17 * CharWidth;
	CalcArea(gruppen, GROUPBOX, &r);			/* (MH) */
	if (maxListWidth < r.g_w)
		maxListWidth = r.g_w;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID countEntries(_VOID *l, _LONG *ll, _WORD *ww)
{
	List *lp;
	
	lp = l;
	if (listChanged)
	{
		CalcWidth();
		listChanged = FALSE;
	}
	*ww = maxListWidth;
	/* Nur sichtbare Eintraege zaehlen (MH) */
	*ll = 0;
	Lists_ResetList(lp);
	while (nextEntry(lp) != NULL)
		++(*ll);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID drawInfEntry(_VOID *entry, _VOID *env, _WORD x, _WORD y, _WORD offset, CONST GRECT *clip)
{
	infEntry *inf;
	infoBlock *info;
	_UWORD eff;
	_WORD fillcol;
	GRECT fill;
	_BOOL isSel;
	_WORD pxy[4];
	_UBYTE numStr[10];
	_UWORD d;
	SYSTIME date;
	_UBYTE s2[20];
	LOCAL CONST _UBYTE wochentage[7][3] = { "So", "Mo", "Di", "Mi", "Do", "Fr", "Sa" };

	/* Wir zeichnen jetzt hier die Eintraege selber, da bei einigen
	 * das ja angeblich abstuerzt
	 */

	UNUSED(offset);
	
	inf = entry;
	info = env;
	fill.g_x = x;
	fill.g_y = y;
	fill.g_w = fill.g_x + maxListWidth - 1;
	fill.g_h = fill.g_y + CharHeight - 1;
	pxy[0] = clip->g_x;
	pxy[1] = clip->g_y;
	pxy[2] = clip->g_x + clip->g_w - 1;
	pxy[3] = clip->g_y + clip->g_h - 1;
	
	vs_clip(PrivateWS, TRUE, pxy);
	vswr_mode(PrivateWS, MD_REPLACE);
	fillcol = WHITE;
	isSel = FALSE;
	if (inf != NULL && isSelected(entry, env))
	{
		fillcol = BLACK;
		isSel = TRUE;
	}
	MouseOff();
	vsf_color(PrivateWS, fillcol);
	vr_recfl(PrivateWS, (_WORD *)&fill);
	if (inf != NULL)
	{
		eff = TXT_NORMAL;
		if (!isEnabled(entry, env))
			eff |= TXT_LIGHT;
		if ((inf->i.res & ITI_TITLE) || (info->open && inf->i.new))	/* (MH) */
			eff |= TXT_THICKENED;
		if (isSel)
			vswr_mode(PrivateWS, MD_XOR);
		vst_effects(PrivateWS, eff);

		if (inf->i.res & ITI_TITLE)
		{
			v_gtext(PrivateWS, x, y, inf->i.mausName);
		} else
		{
			if (inf->i.res & ITI_ORDERED_NOW)
				v_gtext(PrivateWS, x + CharWidth, y, "+");			/* Entsprechend markieren (MH) */
			else if (inf->i.ordered)
				v_gtext(PrivateWS, x + CharWidth, y, "\010");		/* Check-Haken */
			x += 3 * CharWidth;
			
			v_gtext(PrivateWS, x, y, inf->i.mausShort);
			x += maxShortname + 1 * CharWidth;
			
			if (inf->i.isMaus)
			{
				if ((inf->i.res & ITI_GROUP_MASK) != ITI_INFOFILE_O)
				{
					if (inf->i.res & ITI_ORDERED_WDAY)	/* Wochentagskuerzel einsetzen (MH) */
					{
						v_gtext(PrivateWS, x, y, wochentage[inf->i.orderIntervall]);
					} else
					{
						IntToStr(inf->i.orderIntervall, 2, numStr, sizeof(numStr));
						v_gtext(PrivateWS, x, y, numStr);
					}
				}
			}
			x += 3 * CharWidth;
			
			if (inf->i.isMaus)
			{
				if (inf->i.avail)
				{
					d = ConvertDate_NumInDate(inf->i.lastOrdered);
					date = T_DosToSystime(d, 12 << 11);
					T_Strlftime(s2, sizeof(s2), "%d.%m.%y", date);
					v_gtext(PrivateWS, x, y, s2);
				}
			}
			x += 9 * CharWidth;
			
			v_gtext(PrivateWS, x, y, inf->i.mausName);
		}
		
		vst_effects(PrivateWS, 0);
		vswr_mode(PrivateWS, MD_REPLACE);
	}
	vs_clip(PrivateWS, FALSE, pxy);
	MouseOn();
}

/*** ---------------------------------------------------------------------- ***/

/* Versteckt/zeigt einen Eintrag (MH) */
LOCAL _VOID showHideEntry(infEntry *pInf, _BOOL visible)
{
	_UBYTE var_name[128];
	
	if (pInf->i.res & ITI_TITLE)
	{
		if (visible)
			pInf->i.res |= ITI_GROUP_VISIBLE;
		else
			pInf->i.res &= ~ITI_GROUP_VISIBLE;
		pInf->i.res |= ITI_ENTRY_VISIBLE;
		
		make_varname(var_name, sizeof(var_name), cInfoGroupVisible, (pInf->i.res & ITI_GROUP_MASK) >> ITI_GROUP_SHIFT);
		ConfVars_SetConfigBool(var_name, visible);
	} else
	{
		pInf->i.res &= ~ITI_GROUP_VISIBLE;
		if (visible)
			pInf->i.res |= ITI_ENTRY_VISIBLE;
		else
			pInf->i.res &= ~ITI_ENTRY_VISIBLE;
	}
}

/*** ---------------------------------------------------------------------- ***/

/* Versteckt/zeigt alle Gruppen (MH) */
LOCAL _VOID showHideAllGroups(List *liste, _BOOL visible)
{
	List *l;
	infEntry *pInf;
	
	l = liste;
	Lists_ResetList(l);
	while ((pInf = Lists_NextEntry(l)) != NULL)
		showHideEntry(pInf, visible);
	CalcWidth();
}

/*** ---------------------------------------------------------------------- ***/

/* Versteckt/zeigt eine Gruppe (MH) */
LOCAL _VOID showHideOneGroup(List *liste, _WORD group, _BOOL visible)
{
	List *l;
	infEntry *pInf;
	
	l = liste;
	Lists_ResetList(l);
	while ((pInf = Lists_NextEntry(l)) != NULL)
	{
		if (group == (pInf->i.res & ITI_GROUP_MASK))
			showHideEntry(pInf, visible);
	}
	CalcWidth();
}	

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID setAndGetInfoValues(OBJECT *tree, _VOID *env, _BOOL set, _WORD exitBut)
{
	infoBlock *iPtr;
	
	UNUSED(tree);
	if (set)
	{
	} else
	{
		iPtr = env;
		iPtr->exitBut = exitBut;
	}
}

/*** ---------------------------------------------------------------------- ***/

/* Exitbutton testen (MH) */
LOCAL _BOOL infoCheckExit(OBJECT *tree, _VOID *env, _WORD button, _VOID *lastSel, _UWORD kstate)
{
	GRECT r;
	infEntry *pInf;

	UNUSED (env);
	pInf = lastSel;
	button &= 0x7fff;
	DelObjState(tree, button, SELECTED);
	switch (button)
	{
	case GCANCEL:
		return TRUE;
	case GOK:
	    Lists_ResetList(&infList);
		if (Lists_ScanEntries(&infList, Lists_forward, findSel, NULL))
		{
			pInf = Lists_CurrentEntry(&infList);
			/* Gruppen einklappen/ausfahren */
			if (pInf->i.res & ITI_TITLE)
			{
				if (CatGlobal_WithShift(kstate))	
				{
					/* Alle Gruppen zeigen/verstecken */
					showHideAllGroups(&infList, !(pInf->i.res & ITI_GROUP_VISIBLE));
					WinDials_WinDialDraw(tree, GROUPBACK, 1, &r, FALSE);
				} else
				{
					/* Eine Gruppe zeigen/verstecken */
					showHideOneGroup(&infList, pInf->i.res & ITI_GROUP_MASK, !(pInf->i.res & ITI_GROUP_VISIBLE));
					WinDials_WinDialDraw(tree, GROUPBACK, 1, &r, FALSE);
				}
				WinDials_WinDialDraw(tree, button, 0, &r, FALSE);
				return FALSE;
			}
		}
	}
	WinDials_WinDialDraw(tree, button, 0, &r, FALSE);
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/
/*DYJ 5.21b */
GLOBAL _BOOL InfoDlg_doInfoList(_BOOL open, _UBYTE *fname, size_t namesize)
{
	specialButHdler specials[4];
	infEntry *info;
	infoBlock env;
	_WORD exit;
	_WORD dcBut;
	_BOOL oneSel;
	ldHandler dialHandler;

	UNUSED(namesize); /* ASSERT(namesize >= PATH_MAX) */
	
	vsf_interior(PrivateWS, FIS_SOLID);
	vsf_style(PrivateWS, IP_SOLID);
	vsf_color(PrivateWS, WHITE);
	env.open = open;
	env.new = TRUE;
	env.changed = FALSE;
	
	Infofiles_LoadInfoInf(FALSE, FALSE);
	gruppen = TreeAddr[GRUPPEN];
	MausTauschrsc_AdjustDialogSize(gruppen, GRUPPEN);

	/* Strings umsetzen */
	if (open)
	{
		SetObjcString(gruppen, GTITEL, MausTauschrsc_WrkString(FS_OPEN_INFOFILE));
		SetObjcString(gruppen, GSORT, MausTauschrsc_WrkString(FS_UPDATE));
		EnableObjFlags(gruppen, GSORT, HIDETREE, FALSE);
		EnableObjFlags(gruppen, GSORT, EXIT, TRUE);
	} else
	{
		SetObjcString(gruppen, GTITEL, MausTauschrsc_WrkString(FS_CONFIGURE_INFOFILES));
		EnableObjFlags(gruppen, GSORT, HIDETREE, TRUE);
	}
	EnableObjState(gruppen, GOK, DISABLED, FALSE);
	EnableObjFlags(gruppen, GOK, DEFAULT, TRUE);
	EnableObjFlags(gruppen, GRCFULL, HIDETREE, TRUE);
	EnableObjFlags(gruppen, GRCEMPTY, HIDETREE, TRUE);
	EnableObjFlags(gruppen, GBALL, HIDETREE, TRUE);
	EnableObjFlags(gruppen, GCHANGE, HIDETREE, env.new);
	EnableObjFlags(gruppen, GNEW, HIDETREE, open || !env.new);
	EnableObjFlags(gruppen, GDELETE, HIDETREE, open);
	EnableObjState(gruppen, GCHANGE, DISABLED, FALSE);
	EnableObjState(gruppen, GNEW, DISABLED, FALSE);
	EnableObjFlags(gruppen, GCUT, HIDETREE, TRUE);
	
	/* String-Pointer bestimmen */
	SetObjcString(gruppen, NEWGROUP, lastFile);
	/* specials bestimmen */
	if (!open)
	{
		specials[0].objc = GCHANGE;
		specials[0].proc = chgEntry;
		specials[1].objc = GNEW;
		specials[1].proc = chgEntry;
		specials[2].objc = GDELETE;
		specials[2].proc = killEntry;
	} else
	{
		specials[0].objc = GSORT;
		specials[0].proc = updateInfo;
		specials[1].objc = -1000;
		specials[1].proc = chgEntry;
		specials[2].objc = -1000;
		specials[2].proc = chgEntry;
	}
	specials[3].objc = GHELP;
	specials[3].proc = helpButton;
	
	if (open)
		dcBut = GOK;
	else
		dcBut = GCHANGE;
	
	/* Maximale Breite eines Listeneintrages herausfinden */
	CalcWidth();
	listChanged = FALSE;
	
	/* WindowDialog vorbereiten */
	ListDl_BuildLdHandler(&infList,
		resetList,
		nextEntry,
		prevEntry,
		countEntries,
		isEnabled,
		selInfEntry,
		infToStr,
		isSelected,
		drawInfEntry,
		FUNK_NULL,
		0, CharHeight,
		CharWidth, maxListWidth,
		&dialHandler);
	/* ListWinDialog oeffnen */
	if (ListDl_WinListDial(gruppen, ldSelect | ldArrows | ldDoubleExit | ldAutolocate | ldModal,
		&dialHandler,
		GROUPBOX,
		GROUPBACK,
		GOK,
		GCANCEL,
		&env,
		dcBut,
		NEWGROUP,
		updateButton,
		specials,
		4,
		infoCheckExit,
		setAndGetInfoValues,
		setAndGetInfoValues,
		(_VOID **)&info))
	{
		exit = env.exitBut;
	} else
	{
		return FALSE;
	}
	
	Lists_ResetList(&infList);
	oneSel = Lists_ScanEntries(&infList, Lists_forward, findSel, NULL);
	if (oneSel && !(info->i.res & ITI_TITLE))
		ObjcString(gruppen, NEWGROUP, lastFile, sizeof(lastFile));
	SetObjcString(gruppen, GSORT, MausTauschrsc_WrkString(FS_SORT));
	if (open)
	{
		if (oneSel && !Infofiles_BuildName(info, fname))
		{
			env.changed = TRUE;
			/* Wenn Ok angewaehlt, dann Fehlermeldung */
			if (exit == GOK)
				MTE_infoRSC(AL_NO_INFFILE);
			/* Und Abbruch zurueckgeben */
			exit = GCANCEL;
		}
	}
	if (exit == GOK)
	{
		if (env.changed)
			Infofiles_SaveInfoInf();
	} else
	{
		if (env.changed)
			Infofiles_LoadInfoInf(FALSE, FALSE);
	}
	return exit == GOK && oneSel;
}
