/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 *
 * 17.11.02 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.17c'
 *	Noch eine 4.* eliminiert und Cat.Rsc nicht mehr suchen
 */


/* Modul:               DB-Conv                                 */
/* Autor:               Dirk Steins                             */
/* erstellt am:         15.2.93                                 */
/* letzte Aenderung am: 16.02.93                                */
/* Version:             0.11                                    */
/* Interne Version:     V#002                                   */
/* Kommentar:           Datenbankkonvertierer und Installations-*/
/*                      programm zu CAT 3.x und CAT 4.x         */


/*==============================================================*/
/* Datum    Version     Aenderung                               */
/*==============================================================*/
/*                                                              */
/* 15.2.93  0.1         Modul erstellt aus CatPutz, Konvert     */
/*                      der Database geht. Es fehlt noch die    */
/*                      Konvertierung der Zusatzdateien.        */
/* 16.2.93  0.11        Konvertierung der GRUPPEN.POS eingebaut */
/*                                                              */
/*                                                              */
/*==============================================================*/

#include <instrsc.h>
#include <datasys.h>
#include <catfiles.h>
#include <menu_key.h>

#include <mtdir.h>
#include <tos.h>
#ifndef __MINTBIND_H__
#include <mintbind.h>
#endif

#include <mtappl.h>
#include <mttextfi.h>
#include <mtalerts.h>
#include <mtdials.h>

#include <lists.h>
#include <strconv.h>

#include <file_io.h>
#include <dir_io.h>
#include <ro_mem.h>
#include <routinec.h>
#include <routines.h>	/*DYJ 5.20w */
#include <s_endian.h>
#include <debug.h>
#include <mtrsc.h>	/*DYJ 5.21i */
#include <INSTALL.h>

#define whatText "@(#) CAT-Install " CatVersion ", Copyright (c) 1996 Dirk Steins"

GLOBAL _UBYTE ProgramName[] = "Install";
GLOBAL _BOOL PrgHasDataBase=FALSE;		/*DYJ 5.26a */

LOCAL _UBYTE newCatPath[PATH_MAX];
LOCAL _UBYTE dataBasePath[PATH_MAX];
LOCAL _UBYTE messagePath[PATH_MAX];
LOCAL _UBYTE applpath[PATH_MAX];

LOCAL _WORD loglevel;
LOCAL _WORD tracelevel;
LOCAL ERROROUT_FUNC old_error;
LOCAL FILE *logfile;

LOCAL _UBYTE logfile_name[PATH_MAX];

LOCAL _BOOL quitProg;

#define arcName "cat40.dat"
#define expName "cat40.zfx"

/* Magics fuer Header */
#define msgCatMagic     0x4341544DL		/* "CATM"                    */
#define msgVersion      2				/* Versionsnummer der MsgManager.i */
#define oldVersionMagic 0x0150			/* altes Versionsmagic             */
#define msgVersionMagic 0x0160			/* Versionsmagic                   */


typedef struct shortInfo
{
	_WORD /* msg_type */ msgType;
	_WORD number;
	_WORD copyCount;
	_WORD refNum;
	_BOOL sendMsg;
	_BOOL toDelete;
	 _WORD /* tDistribution */ dist;
	_ULONG size;
	_BOOL noRefLine;
	_UWORD cDate;
	_UWORD cTime;
	/* Ab hier neu */
	 _WORD /* tDistribution */ orgDist;
	_ULONG reserved1;
	_ULONG reserved2;
} PACKED shortInfo;



/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

/*** ---------------------------------------------------------------------- ***/

#if 0
LOCAL _VOID numAlert(_WORD num, CONST _UBYTE *s)
{
	_UBYTE alt[512];
	_UBYTE *p;
	_UBYTE numstr[10];

	strBcpy(alt, s);
	p = strChr(alt, '&');	/*DYJ 5.20w */
	if (p != NULL)
	{
		*p = '\0';
		IntToStr(num, 0, numstr, sizeof(numstr));
		strBcat(alt, numstr);
		strBcat(alt, s + (p + 1 - alt));
	}
	mtAlerts_Alert(1, alt);
}
#endif


/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL selectFile(CONST _UBYTE *title, CONST _UBYTE *mask, _UBYTE *fName)
{
	_UBYTE name[PATH_MAX];
	_BOOL success;
	_UBYTE targetPath[PATH_MAX];

	strBcpy(targetPath, fName);
	if (mask != NULL && *mask != '\0')
		F_Path_Append(targetPath, mask);
	else
		F_Path_Append(targetPath, ALL_FILE_MASK);
	*name = '\0';
	success = mtDir_GetDir(targetPath, name, title);
	F_Path_Dirname(targetPath);
	if (!success)
		return FALSE;
	F_Path_Set(targetPath);
	strMcpy(fName, PATH_MAX, targetPath);
	F_Path_Append(fName, name);
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL getFile(CONST _UBYTE *title, TEXTFILENO *f, CONST _UBYTE *mask, _UBYTE *fname)
{
	MouseArrow();
	if (selectFile(title, mask, fname))
	{
		if (mtTextfiles_OpenTextfile(fname, READ, 512, f) != GERR_OK)
			return FALSE;
		return TRUE;
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL ConvMsgInfo(_VOID)
{
	FILENO msgHdl;
	_ULONG size;
	_UWORD mess;
	shortInfo *shortArray;
	_UWORD i;
	FileHeaderType dbHdr;
	_UBYTE fname[PATH_MAX];

	/* MSGINFO.DAT einlesen, und pruefen */
	strBcpy(fname, messagePath);
	F_Path_Append(fname, msgInfoName);
	msgHdl = CatFiles_OpenFile(fname, CatFiles_readFile);
	if (!FILENO_OK(msgHdl))						/* File not found */
	{
		/* Nichts zum konvertieren da */
		return TRUE;
	} else
	{
		CatFiles_Seek(0, msgHdl, CatFiles_end);
		CatFiles_FilePos(msgHdl, &size);
		/* Erstmal den Header lesen und testen */
		CatFiles_Seek(0, msgHdl, CatFiles_start);

		/* Jetzt erst mal Header einlesen */
		CatFiles_Seek(0, msgHdl, CatFiles_start);
		if (CatFiles_ReadDbHeader(msgHdl, &dbHdr) != NoError)
		{
			CatFiles_CloseFile(msgHdl);
			return FALSE;
		}
		/* Jetzt ueberpruefen des Headers */
		if (dbHdr.CatMagic != msgCatMagic ||
			dbHdr.Version != msgVersion ||
			dbHdr.VersionMagic != oldVersionMagic)
		{
			/* Entweder falsche oder nicht die alte Version,
			 * nichts konvertieren
			 */
			CatFiles_CloseFile(msgHdl);
			if (dbHdr.VersionMagic != msgVersionMagic)
			{
				mtAlerts_Alert(1, Inst_WrkString(oldMsgVersion));	/*DYJ 5.21b */
				return FALSE;
			}
			return TRUE;
		}
		mess = (_UWORD) ((size - dbHeaderLength) / (sizeof(shortInfo) - 10));
		shortArray = M0ALLOC(mess * sizeof(shortInfo), "ConvMsgInfo");
		if (shortArray == NULL)
		{
			CatFiles_CloseFile(msgHdl);
			return FALSE;
		}
		/* Jetzt jedes Info einzeln einlesen und an die richtige Stelle setzen
		 */
		for (i = 0; i < mess; i++)
		{
			CatFiles_ReadMuch(sizeof(shortInfo) - 10, msgHdl, &shortArray[i]);
		}
		/* Und jetzt den ganzen Kram mit neuer Versionsnummer rausschreiben */
		dbHdr.CatMagic = h2nl(msgCatMagic);
		dbHdr.Version = h2ns(msgVersion);
		dbHdr.VersionMagic = h2ns(msgVersionMagic);
		CatFiles_Seek(0, msgHdl, CatFiles_start);
		CatFiles_WriteMuch(dbHeaderLength, msgHdl, &dbHdr);
		CatFiles_WriteMuch(mess * sizeof(shortInfo), msgHdl, shortArray);
		CatFiles_CloseFile(msgHdl);
		SFREE(shortArray);
	}
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

/*DYJ 5.24j */
LOCAL _BOOL copyFile(CONST _UBYTE *from, CONST _UBYTE *to, CONST _UBYTE *name)
{
	FILENO s, d;
	_UBYTE *mbuf;
	_ULONG slen;
	_ULONG blen;
	_ULONG pos;
	_BOOL exists;

	SPEC_DEBUG_OUT((EO_TRACE, "copying %s to %s", from, to));
	if(!strCaseCmp(from,to))
		return TRUE;
	slen = CatFiles_FileSize(from, &exists);
	if (slen == 0 || !exists || (s = CatFiles_OpenFile(from, CatFiles_readFile)) < 0)
	{
		InfoAlert(noFile1, name, noFile2);
		return FALSE;
	}
	mbuf = NULL;
	blen = slen;
	while (mbuf == NULL && blen > 0)
	{
		mbuf = SYSMALLOC(blen, MEM_NOERR, "copy");
		if (mbuf != NULL)
			break;
		blen >>= 1;
	}
	if (mbuf == NULL)
	{
		err_memory(slen);
		CatFiles_CloseFile(s);
		return FALSE;
	}
	d = CatFiles_CreateFile(to);
	if (d < 0)
	{
		FREE(mbuf, blen);
		CatFiles_CloseFile(s);
		InfoAlert(createFile1, name, createFile2);
		return FALSE;
	}
	pos = 0;
	while (pos + blen <= slen)
	{
		CatFiles_ReadMuch(blen, s, mbuf);
		CatFiles_WriteMuch(blen, d, mbuf);
		pos += blen;
	}
	if (pos < slen)
	{
		CatFiles_ReadMuch(slen - pos, s, mbuf);
		CatFiles_WriteMuch(slen - pos, d, mbuf);
	}
	CatFiles_CloseFile(d);
	CatFiles_CloseFile(s);
	SFREE(mbuf);
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

/*DYJ 5.21b */
LOCAL _BOOL copyData(CONST _UBYTE *fromPath, CONST _UBYTE *toPath, CONST _UBYTE *name)
{
	_UBYTE from[PATH_MAX];
	_UBYTE to[PATH_MAX];

	strBcpy(from, fromPath);
	F_Path_Append(from, "data");
	F_Path_Append(from, name);
	strBcpy(to, toPath);
	F_Path_Append(to, name);
	return copyFile(from, to, name);
}
/*DYJ 5.21b */
LOCAL _BOOL copy(CONST _UBYTE *fromPath, CONST _UBYTE *toPath, CONST _UBYTE *name)
{
	_UBYTE from[PATH_MAX];
	_UBYTE to[PATH_MAX];

	strBcpy(from, fromPath);
	F_Path_Append(from, name);
	strBcpy(to, toPath);
	F_Path_Append(to, name);
	return copyFile(from, to, name);
}


/*** ---------------------------------------------------------------------- ***/

/*DYJ 5.17c */	/*DYJ 5.21i */	/*DYJ 5.22f */	/*DYJ 5.29j */
/*DYJ 5.21i */
LOCAL _BOOL ExtractArchive(_VOID)
{
	/* if (!F_Path_Equal(applpath, newCatPath)) */
	{
		if (!copyData(applpath, newCatPath, "CAT.PRG") ||	/*DYJ 5.34l */
		    !copyData(applpath, newCatPath, "CAT_DE.RSC") ||	/*DYJ 5.34l */
		    !copyData(applpath, newCatPath, "CAT_EN.RSC") ||	/*DYJ 5.34l */
		    !copy(applpath, newCatPath, "CATl_DE.RSC") ||	/*DYJ 5.34l */
		    !copy(applpath, newCatPath, "CATl_EN.RSC") ||	/*DYJ 5.34l */
		    !copyData(applpath, newCatPath, "CAT_DE.HLP") ||	/*DYJ 5.34l */
		    !copyData(applpath, newCatPath, "CAT_EN.HLP"))	/*DYJ 5.34l */
		    return FALSE;
		else
		{
			_UBYTE langPath[PATH_MAX];
			TEXTFILENO tf;
			
			_UBYTE *home;
			if(WriteCat_Lang)
			{
				if ((home = getenv("HOME")) != NULL && *home != '\0')
					strCpy(langPath,home);
				else
					strBcpy(langPath, newCatPath);
				F_Path_Append(langPath, CAT_LANG_FILE);
				if (mtTextfiles_OpenTextfile(langPath, WRITE, 512, &tf) == GERR_OK)
				{
					switch(Rsc_lang())
					{
						case L_GERMAN:
							mtTextfiles_WriteLine(tf, LANGUAGE_DE);
							break;
						case L_ENGLISH:
							mtTextfiles_WriteLine(tf, LANGUAGE_EN);
							break;
						case L_FRENCH:
							mtTextfiles_WriteLine(tf, LANGUAGE_FR);
							break;
					}
					mtTextfiles_CloseTextfile(&tf);
				}
			}
		}
	}
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

/* Lesen von CAT.INF
 * Zeile 11:    Database-Pfad
 */
LOCAL _BOOL readCatInf(TEXTFILENO f)
{
	_WORD i;

	dataBasePath[0] = '\0';
	for (i = 0; i < 7; i++)
		mtTextfiles_ReadLn(f);
	mtTextfiles_ReadLine(f, messagePath, sizeof(messagePath));
	mtTextfiles_ReadLn(f);
	mtTextfiles_ReadLn(f);
	mtTextfiles_ReadLn(f);
	mtTextfiles_ReadLine(f, dataBasePath, sizeof(dataBasePath));
	mtTextfiles_CloseTextfile(&f);
	if (dataBasePath[0] == '\0')
	{
		mtAlerts_Alert(1, Inst_WrkString(alt3));	/*DYJ 5.21b */
		return FALSE;
	}
	F_Path_Set(dataBasePath);
	MouseArrow();
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL readOldInf(_UBYTE *oldCatinf)
{
	TEXTFILENO f;

	strCpy(oldCatinf, newCatPath);	/*DYJ 5.20w */
	if (!getFile("CAT.INF laden", &f, "*.inf", oldCatinf))
	{
		return FALSE;
	}
	/* Gruppenliste loeschen */
	if (!readCatInf(f))
		return FALSE;
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

/*DYJ 5.21o Start*/
LOCAL _BOOL init(_VOID)
{
	if (InitResource())
		return TRUE;
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

/*DYJ 5.21b */
LOCAL _VOID install_cat(_VOID)
{
	_WORD res;
	_BOOL instNew;
	_UBYTE name[PATH_MAX];
	_UBYTE path[PATH_MAX];
	_BOOL ok;
	_UBYTE oldCatinf[PATH_MAX];

	/* Erstmal erfragen, ob CAT neu installiert werden soll
	 * oder ob eine alte Datenbank uebernommen werden soll
	 */
	res = mtAlerts_Alert(1, Inst_WrkString(alt4));	/*DYJ 5.21b */
	if (res != 3 && res > 0)
	{
		instNew = res == 1;
		/* Jetzt den Installationspfad rausfinden */
		strBcpy(path, applpath);

		if (!GetAndCreatePath(path, name, SEL_IN))
		{
			res = mtAlerts_Alert(1, Inst_WrkString(alt5));	/*DYJ 5.21b */
		} else
		{
			/* Pfad ist nun vorhanden und steht in path */
			strBcpy(newCatPath, path);
	
			/* Jetzt erst CAT.INF lesen */
			if (instNew || readOldInf(oldCatinf))
			{
				/* Wenn nur installiert werden soll, dann sind wir fast fertig! */
				if (instNew)
				{
					ok = doConfig(newCatPath, dataBasePath);		/* CAT.INF erstellen */
					/* So, jetzt erstmal CAT auspacken lassen */
					if (ok)
						ok = ExtractArchive();
				} else
				{
					/* So, jetzt erstmal CAT auspacken lassen */
					ok = ExtractArchive();
					/* MsgInfo.DAT konvertieren */
					if (ok)
						ok = ConvMsgInfo();
					/* CAT.INF kopieren */
					if (ok)
					{
						strBcpy(path, newCatPath);
						strBcpy(name, F_Path_Basename(oldCatinf));
						F_Path_Append(path, name);
						if (!F_Path_Equal(oldCatinf, path))
							ok = copyFile(oldCatinf, path, name);
					}
				}
				
				if (ok)
					mtAlerts_Alert(1, Inst_WrkString(alt6));	/*DYJ 5.21b */
			}
		}
	}
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

/*-------------- Menu Handling -----------------------------*/

LOCAL _VOID menuManager(_WORD item, _WORD menuIndex, _UWORD kstate)
{
	UNUSED(kstate);
	switch (item)
	{
	case FMINSTA:
		install_cat();
		break;
	case FKOMMATA:
		if(*newCatPath)
			doKommata(newCatPath,catinf);
		else
		{
			_UBYTE path[PATH_MAX],name[FILENAME_MAX];
			strCpy(path,applpath);	/*DYJ 5.20w */
			strCpy(name,"cat.inf");	/*DYJ 5.20w */
			if( mtDir_FselGet(path, name, "*.inf", "Cat.inf ausw\204hlen", FALSE))
				doKommata(path,name);
		}

		break;
	case FMQUIT:
		quitProg = TRUE;
		break;
	case ABOUTOBJ:
		doInfo();
		break;
	}
	menu_tnormal(menu, menuIndex, 1);
}
/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID LogClose(_VOID)
{
	SPEC_DEBUG_OUT((EO_DEBUG, "*** exiting"));
	ErrorOut_SetFunk(old_error);
	loglevel = -1;
}
LOCAL _VOID LogOpen(_VOID)
{
	_UBYTE backup[PATH_MAX];
	
	if (getenv("CAT_LOGLEVEL") != NULL)
		loglevel = StrToInt(getenv("CAT_LOGLEVEL"), NULL, NULL);
	else
		loglevel = 3;
	tracelevel = -1;
#if SPEC_DEBUG
	is_DEBUGGING=(loglevel==4);
#endif
	if (loglevel >= 0)
	{
		F_Path_Get_Program(logfile_name, "inst_deb.log");
		F_Path_Get_Program(backup, "inst_deb.bak");
		F_File_Delete(backup);
		F_Path_Rename(logfile_name, backup);
		SPEC_DEBUG_OUT((EO_DEBUG, "*** starting"));
	}
}

LOCAL _BOOL error_func(CONST _UBYTE *prg, EO_MODUS modus, _WORD nr, CONST _UBYTE *modestr, CONST _UBYTE *str)
{
	_WORD level;
	_UBYTE date[100];
	_WORD count, i;
	CONST _UBYTE *p;

	UNUSED(prg);
	UNUSED(nr);

	switch (modus)
	{
	case EO_INFO:
		modestr = "INFO  ";
		level = 1;
		break;
	case EO_DEBUG:
		modestr = "DEBUG ";
		level = 2;
		break;
	case EO_TRACE:
		modestr = "TRACE ";
		level = 3;
		break;
	case EO_ERROR:
		modestr = "*** Error: ";
		level = 0;
		break;
	case EO_FATAL:
	default:
		modestr = "*** Fatal: ";
		level = 0;
		break;
	case EO_EXIT:
		LogClose();
		return FALSE;
	case EO_INIT:
		LogOpen();
		return FALSE;
	}

	T_Strlftime(PtrSize(date), "%d.%m.%y %H:%M:%S", T_Systime());

	if (level <= tracelevel)
	{
		count = fprintf(stderr, "%s: %s", prg, modestr);
		for (p = str; *p != '\0'; p++)
		{
			putc(*p, stderr);
			if (*p == '\n')
			{
				for (i = 0; i < count; i++)
					putc(' ', stderr);
			}
		}
		putc('\n', stderr);
	}

	if (loglevel >= 0 && level <= loglevel)
	{
		if (logfile == NULL)
		{
			_WORD try = 5;
			
			while (logfile == NULL && try > 0)
			{
				logfile = fopen(logfile_name, "a");
				if (logfile != NULL)
					break;
				EventTimer(500);
				try--;
			}
			if (logfile == NULL)
			{
				ErrorOut_SetFunk(FUNK_NULL);
				loglevel = -1;
				ErrorOut(EO_FATAL, "can't create log file `%s', further logging disabled", logfile_name);
			}
		}
		if (logfile != NULL)
		{
			count = fprintf(logfile, "%-8.8s: %s %s", prg, date, modestr);
			for (; *str; str++)
			{
				putc(*str, logfile);
				if (*str == '\n')
				{
					for (i = 0; i < count; i++)
						putc(' ', logfile);
				}
			}
			putc('\n', logfile);
			fclose(logfile);
			logfile = NULL;
		}
	}
	return modus == EO_ERROR || modus == EO_FATAL;
}

/*** ---------------------------------------------------------------------- ***/

int main(void)
{
	_WORD message[8];
	_UWORD event;
	_WORD dummy;
	_UWORD udummy;
	_UWORD kstate;
	_WORD kReturn;
	_WORD exitCode;

	exitCode = 0;

	old_error = ErrorOut_SetFunk(error_func);
	if (getenv("CAT_LOGLEVEL") != NULL)
		loglevel = StrToInt(getenv("CAT_LOGLEVEL"), NULL, NULL);
	else
		loglevel = 3;
#if SPEC_DEBUG
	is_DEBUGGING=(loglevel==4);
#endif
	ApplInit();

	(_VOID)Pdomain(1);
	
	ApplPath(applpath);
	SPEC_DEBUG_OUT((EO_DEBUG, "applpath:in INSTALL:%s", applpath));	/*tmpapplpath*/
	mtDials_Init();
	if (!init())
	{
		exitCode = 1;
	} else
	{
		MouseArrow();
		menu_bar(menu, 1);
		quitProg = FALSE;
		do
		{
			event = evnt_multi(MU_MESAG | MU_KEYBD,
				0, 0, 0,
				0, 0, 0, 0, 0,
				0, 0, 0, 0, 0,
				message,
				0, 0,
				&dummy, &dummy, &udummy, &kstate, &kReturn, &dummy);
			Wind_Update(BEG_UPDATE);
			if (event & MU_MESAG)
			{
				switch (message[0])
				{
				case MN_SELECTED:
					menuManager(message[4], message[3], kstate);
					MouseArrow();
					break;
				case AP_TERM:
					quitProg = TRUE;
					break;
				}
			}
			if (event & MU_KEYBD)
			{
				MenuKey_Test(menu, kReturn, kstate, menuManager, FALSE);
			}
			Wind_Update(END_UPDATE);
		} while (!quitProg);
		menu_bar(menu, 0);
		ClrRsrc();
		RscFreeLib();	/*DYJ 5.36j */
	}
	ApplTerm(exitCode);
	return exitCode;
}
