/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */


#define ITK_STANDALONE
#include "doitk.c"
#include <groupsel.h>
#include <mtrsc.h>
#include <debug.h>


GLOBAL _UBYTE ProgramName[] = "ITKCmds";
GLOBAL _BOOL PrgHasDataBase=TRUE;		/*DYJ 5.26a */
GLOBAL _UBYTE HomePath[PATH_MAX];

	
int main(int argc, char **argv)
{
	CONST _UBYTE *inf_from_argv;
	
#if SPEC_DEBUG
	is_DEBUGGING = FALSE;
#endif
	ApplInit();
	CatGlobal_Init();
	mtDials_Init();
	ConfVars_Init();
	WdwManager_Init();
	
	mtDials_DialConfig(UseConfig, FALSE);

	infPath[0] = '\0';
	infName[0] = '\0';
	inf_from_argv = NULL;
	if (argc > 1)
		inf_from_argv = argv[1];
	if (ConfVars_Init() &&
		MausTauschrsc_RscInit() &&
		MTPaths_ReadInf(infPath, infName, FALSE, TRUE, inf_from_argv) &&
		UserInformation_ReadUserBlock() &&
		data_InitDataBase() &&
/*DYJ 4.15c Start*/
		adr_ReadNames(ADR_NORMAL) &&
/*DYJ  Ende; alt:
		adr_ReadNames() &&
*/		GroupSelect_ReadGroupList())
	{
		Infofiles_LoadInfoInf(FALSE, FALSE);
		ListHelp_Init();
		if (DoITK_SelectCmd())
		{
			do
			{
				WinDials_WinDialHandleEvents();
			} while (WdwManager_GetOwnTopWindow() >= 0);
		}
	}
	WdwManager_CloseAllWindows(TRUE);
#if DEBUG_ALLOC
	/*
	 * noch den restlichen Speicher freigeben
	 */
	MausTauschrsc_RscFree();
	ConfVars_DeleteAllVars();
	Infofiles_Exit();
	GroupSelect_Exit();
	adr_ClearList();
	data_CloseBase();
#else
	mem_test_ignore();
#endif
	ApplTerm(0);
	return 0;
}
