/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */


/* 06.06.98 Markus Hoffmann @ DU (MH)
 * - Neues Modul 'Makro definieren' fertiggestellt. In diesem Dialog wird ein Makro 
 *   zusammengestellt und bearbeitet. Die einzelne Makroschritte koennen umsortiert,
 *   entfernt und mit einem Defaultwert versehen werden. Klick auf den Default-Button
 *   mit gedrueckter Shift-Taste entfernt den Defaultwert. Gruppen-, Chefgruppen und
 *   Userangaben werden jedoch spaeter beim Makroablauf nicht als Default angezeigt,
 *   sondern muessen dort explizit angegeben werden. Beim Einstellen eines Defaults
 *   wird aber ein Dummystring voreingestellt.
 */

#define __ITK_IMPLEMENTATION__
 
#include <itkmacro.h>
#include <doitk.h>
#include <catgloba.h>
#include <cattypes.h>
#include <infofile.h>
#include <mte.h>
#include <maustaus.h>
#include <listdl.h>
#include <listhelp.h>
#include <grin.h>
#include <wdwmanag.h>
#include <convertd.h>
#include <mtpaths.h>
#include <catutil.h>
#include <confvars.h>
#include <userinfo.h>
#include <cathelp.h>
#include <quicksor.h>
#include <protokol.h>
#include <adr.h>

#include <mttextfi.h>
#include <mtappl.h>
#include <mtutils.h>
#include <mtdials.h>
#include <magicstr.h>
#include <portvdi.h>

#include <strconv.h>

#include <set.h>
#include <ro_mem.h>
#include <routinec.h>
#include <routines.h>
#include <file_io.h>


/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

GLOBAL _VOID Macro_RenumberSteps(List *macroList)
{
	OneMacro *pMacro;
	_WORD total, step;
	
	total = (_WORD)Lists_NoOfEntries(macroList);
	Lists_ResetList(macroList);
	step = 1;
	while ((pMacro = Lists_NextEntry(macroList)) != NULL)
	{
		pMacro->aktStep = step++;
		pMacro->totalSteps = total;
	}
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

/* Userinterface */

LOCAL _VOID lineToStr(_VOID *entry, _VOID *env, _UBYTE *str, size_t strsize)
{
	OneMacro *pMacro;

	UNUSED(env);
	pMacro = entry;
	if (pMacro == NULL)
		*str = '\0';
	else
		strMcpy(str, strsize, pMacro->cmdName);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID CalcWidth(MACRO *macro)
{
	OneMacro *pMacro;
	GRECT r;
	_WORD extent[8];
	_WORD w;
	
	/* Maximale Breite eines Listeneintrages herausfinden */
	macro->globalLength = 0;
	Lists_ResetList(macro->MacroList);
	while ((pMacro = Lists_NextEntry(macro->MacroList)) != NULL)
	{
		vqt_extent(PrivateWS, pMacro->cmdName, extent);
		w = extent[2] - extent[0];
		if (w > macro->globalLength)
			macro->globalLength = w;
	}
	macro->globalLength += 3 * CharWidth;
	CalcArea(macro->MacroBox, MBOX, &r);
	if (macro->globalLength < r.g_w)
		macro->globalLength = r.g_w;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL selEntry(_VOID *entry, _VOID *env, _WORD line)
{
	OneMacro *pMacro;

	UNUSED(env);
	UNUSED(line);
	pMacro = entry;
	if (pMacro != NULL)
		pMacro->selected = !pMacro->selected;
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL isSelected(_VOID *entry, _VOID *env)
{
	OneMacro *pMacro;

	UNUSED(env);
	pMacro = entry;
	if (pMacro == NULL)
		return FALSE;
	return pMacro->selected;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL isEnabled(_VOID *entry, _VOID *env)
{
	UNUSED(entry);
	UNUSED(env);
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID *nextEntry(_VOID *list)
{
	return Lists_NextEntry(list);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID *prevEntry(_VOID *list)
{
	return Lists_PrevEntry(list);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID resetList(_VOID *list)
{
	Lists_ResetList(list);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID countEntries(_VOID *l, _LONG *ll, _WORD *ww)
{
	List *lp;
	MACRO *macro;
	
	lp = l;
	macro = lp->user;
	if (macro->listChanged)
	{
		CalcWidth(macro);
		macro->listChanged = FALSE;
	}
	*ww = macro->globalLength;
	*ll = Lists_NoOfEntries(lp);
}
/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID *getSelected(List *list)
{
	OneMacro *pMacro;
	
	Lists_ResetList(list);
	while ((pMacro = Lists_NextEntry(list)) != NULL)
	{
		if (pMacro->selected)
			return pMacro;
	}
	return NULL;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL OBJECT *tr;
LOCAL OBJECT mTree[1];
LOCAL TEDINFO mTed;
LOCAL _UBYTE mText[256];

LOCAL _VOID drawMacroEntry(_VOID *entry, _VOID *env, _WORD x, _WORD y, _WORD offset, CONST GRECT *clip)
{
	OneMacro *pMacro;
	MACRO *macro;
	_UBYTE str[512];

	UNUSED(offset);
	macro = env;
	tr[ROOT].ob_x = x;
	tr[ROOT].ob_y = y;
	tr[LISTENTRY].ob_width = macro->globalLength;
	if (entry != NULL)
	{
		/* Jetzt hier den String fuer den Gruppennamen zusammenbauen */
		pMacro = entry;
		if (pMacro->defSetup[0] != '\0')
			strMcpy(str, sizeof(str), "D ");
		else
			strMcpy(str, sizeof(str), "  ");
		strMcat(str, sizeof(str), pMacro->cmdName);
		SetObjcStringAdr(tr, LISTENTRY, str, sizeof(str));
		EnableObjState(tr, LISTENTRY, SELECTED, isSelected(entry, env));
	} else
	{
		SetObjcStringAdr(tr, LISTENTRY, "", 1);
		EnableObjState(tr, 0, SELECTED, FALSE);
	}
	Objc_draw(tr, ROOT, MAX_DEPTH, clip);
	SetObjcStringAdr(tr, LISTENTRY, "", 1);
}

/*** ---------------------------------------------------------------------- ***/
/*DYJ 5.21b */
LOCAL _BOOL macroCheckExit(OBJECT *tree, _VOID *env, _WORD button, _VOID *lastSel, _UWORD kstate)
{
	GRECT r;
	OneCommand *pCmd;
	MACRO *macro;
	ITK *itk;
	List *temp;
	_UBYTE *str;
	
	UNUSED(tree);
	UNUSED(kstate);
	UNUSED(lastSel);
	
	macro = env;
	itk = macro->itk;
	pCmd = macro->MacroEntry;
	button &= 0x7fff;
	DelObjState(tree, button, SELECTED);
	switch (button)
	{
	case MCANCEL:
		Lists_DeleteSimpleList(macro->MacroList, mem_free, TRUE);
		ListMan_SetDragDropProc(itk->CmdBox, FUNK_NULL);
		itk->configModus = FALSE;
		itk->changed = FALSE;
		DoITK_UpdateButtons(NULL, itk);
		if (macro->new)
			OFREE(pCmd);
		OFREE(macro->MacroList);
		OFREE(macro);
		return TRUE;
	case MOK:
		if (Lists_ListEmpty(macro->MacroList))
		{
			MTE_infoRSC(AL_NO_COMMAND);
			break;
		}
		str = ObjcStringAdr(macro->MacroBox, MACRONAME);
		if (str[0] == '\0')
		{
			MTE_infoRSC(AL_NO_NAME);
			break;
		}
		if (strCmp(str, macro->MacroName) != 0)
			itk->changed = TRUE;
		strMcpy(pCmd->cmdName, sizeof(pCmd->cmdName), str);		/* Makroname eintragen */
		temp = pCmd->itkMacro;									/* Listadresse sichern */
		pCmd->itkMacro = macro->MacroList;						/* Neue Liste uebernehmen */
		if (temp != NULL)
		{
			Lists_DeleteSimpleList(temp, mem_free, TRUE);		/* Alte Liste loeschen */
			OFREE(temp);
		}
		if (macro->new)
			Lists_AppendEntry(itk->itkCmds, pCmd);				/* Eintrag an Liste haengen */
		DoITK_InitMacroList(itk->itkCmds);						/* Makroliste initialisieren */
		DoITK_SortITK(itk);										
		ListMan_SetDragDropProc(itk->CmdBox, FUNK_NULL);
		itk->configModus = FALSE;
		itk->listChanged = TRUE;
		DoITK_RedrawList(itk);
		DoITK_UpdateButtons(NULL, itk);
		/* OFREE(macro->MacroList); */
		OFREE(macro);
		return TRUE;
	case CHELP:
		CatHelp_DoHelp(CatHelp_macrohelp);
		break;
	}
	WinDials_WinDialDraw(tree, button, 0, &r, FALSE);
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID checkAndDraw(OBJECT *tree, _WORD obj, _BOOL cond)
{
	GRECT r;
	
	if (GetObjState(tree, obj, DISABLED) == cond)
	{
		EnableObjState(tree, obj, DISABLED, !cond);
		WinDials_WinDialDraw(tree, obj, 0, &r, FALSE);
	}
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID Macro_UpdateButtons(_VOID *entry, _VOID *env)
{
	_BOOL oneSel;
	MACRO *macro;

	UNUSED(entry);
	macro = env;
	Lists_ResetList(macro->MacroList);
	oneSel = Lists_ScanEntries(macro->MacroList, Lists_forward, isSelected, NULL);
	if (oneSel)
	{
		checkAndDraw(macro->MacroBox, MOBEN,    !Lists_FirstEntry(macro->MacroList));
		checkAndDraw(macro->MacroBox, MUNTEN,   !Lists_LastEntry(macro->MacroList));
		checkAndDraw(macro->MacroBox, MDELETE,  TRUE);
		checkAndDraw(macro->MacroBox, MDEFAULT, TRUE);
	} else
	{
		checkAndDraw(macro->MacroBox, MOBEN,    FALSE);
		checkAndDraw(macro->MacroBox, MUNTEN,   FALSE);
		checkAndDraw(macro->MacroBox, MDELETE,  FALSE);
		checkAndDraw(macro->MacroBox, MDEFAULT, FALSE);
	}	
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID Macro_RedrawList(MACRO *macro)
{
	WinDials_WinDialDraw(macro->MacroBox, MBACK, MAX_DEPTH, NULL, FALSE);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID setAndGetMacroValues(OBJECT *tree, _VOID *env, _BOOL set, _WORD exitBut)
{
	MACRO *macro;

	UNUSED(tree);
	if (!set)
	{
		macro = env;
		if (exitBut == MOK && macro->lastMacro != NULL)
		{
			/* TODO */
		}
	}
}

/*** ---------------------------------------------------------------------- ***/

/*DYJ 5.30f Start*/
LOCAL _VOID doMacroHelp(_WORD obj, _VOID *env, LISTINFO info, _BOOL *draw, _BOOL *exit,_LONG *lstSel)
/*DYJ  Ende; alt:	
LOCAL _VOID doMacroHelp(_WORD obj, _VOID *env, LISTINFO info, _BOOL *draw, _BOOL *exit)
*/
{
	GRECT r;
	MACRO *macro;
	
	UNUSED(lstSel);		/*DYJ 5.30f */
	UNUSED(info);
	macro = env;
	CatHelp_DoHelp(CatHelp_macrohelp);
	EnableObjState(macro->MacroBox, obj, SELECTED, FALSE);
	WinDials_WinDialDraw(macro->MacroBox, obj, 1, &r, FALSE);
	*draw = FALSE;
	*exit = FALSE;
}

/*** ---------------------------------------------------------------------- ***/

/*DYJ 5.30f Start*/
LOCAL _VOID moveUp(_WORD obj, _VOID *env, LISTINFO info, _BOOL *draw, _BOOL *exit,_LONG *lstSel)
/*DYJ  Ende; alt:	
LOCAL _VOID moveUp(_WORD obj, _VOID *env, LISTINFO info, _BOOL *draw, _BOOL *exit)
*/
{
	GRECT r;
	ITK *itk;
	MACRO *macro;
	OneMacro *pMacro;
	
	macro = env;
	itk = macro->itk;
	pMacro = getSelected(macro->MacroList);
	Lists_RemoveEntry(macro->MacroList, FUNK_NULL);
	Lists_PrevEntry(macro->MacroList);
	Lists_InsertEntry(macro->MacroList, pMacro);
	*lstSel=-1;	/*DYJ 5.30f */
	Macro_RenumberSteps(macro->MacroList);
	EnableObjState(macro->MacroBox, obj, SELECTED, FALSE);
	WinDials_WinDialDraw(macro->MacroBox, obj, 1, &r, FALSE);
	ListMan_ListScroll2Selection(info, FALSE);
	itk->changed = TRUE;
	*draw = TRUE;
	*exit = FALSE;
}

/*** ---------------------------------------------------------------------- ***/

/*DYJ 5.30f Start*/
LOCAL _VOID moveDown(_WORD obj, _VOID *env, LISTINFO info, _BOOL *draw, _BOOL *exit,_LONG *lstSel)
/*DYJ  Ende; alt:	
LOCAL _VOID moveDown(_WORD obj, _VOID *env, LISTINFO info, _BOOL *draw, _BOOL *exit)
*/
{
	GRECT r;
	ITK *itk;
	MACRO *macro;
	OneMacro *pMacro;
	
	macro = env;
	itk = macro->itk;
	pMacro = getSelected(macro->MacroList);
	Lists_RemoveEntry(macro->MacroList, FUNK_NULL);
	Lists_NextEntry(macro->MacroList);
	Lists_InsertEntry(macro->MacroList, pMacro);
	*lstSel=-1;	/*DYJ 5.30f */
	Macro_RenumberSteps(macro->MacroList);
	EnableObjState(macro->MacroBox, obj, SELECTED, FALSE);
	WinDials_WinDialDraw(macro->MacroBox, obj, 1, &r, FALSE);
	ListMan_ListScroll2Selection(info, FALSE);
	itk->changed = TRUE;
	*draw = TRUE;
	*exit = FALSE;
}

/*** ---------------------------------------------------------------------- ***/
/*DYJ 5.21b */
/*DYJ 5.30f Start*/
LOCAL _VOID deleteStep(_WORD obj, _VOID *env, LISTINFO info, _BOOL *draw, _BOOL *exit,_LONG *lstSel)
/*DYJ  Ende; alt:	
LOCAL _VOID deleteStep(_WORD obj, _VOID *env, LISTINFO info, _BOOL *draw, _BOOL *exit)
*/
{
	GRECT r;
	ITK *itk;
	MACRO *macro;
	_WORD select;
	
	UNUSED(info);
	*draw = FALSE;
	macro = env;
	itk = macro->itk;
	select = mtAlerts_AlertRSC(2, AL_DELETE_STEP);
	if (select == 1)
	{
		getSelected(macro->MacroList);	/* Zeiger auf sel. Eintrag setzen */
		Lists_RemoveEntry(macro->MacroList, mem_free);
		*lstSel=-1;	/*DYJ 5.30f */
		Macro_RenumberSteps(macro->MacroList);
		itk->changed = TRUE;
		macro->listChanged = TRUE;
		*draw = TRUE;
	}
	EnableObjState(macro->MacroBox, obj, SELECTED, FALSE);
	WinDials_WinDialDraw(macro->MacroBox, obj, 1, &r, FALSE);
	*exit = FALSE;
}

/*** ---------------------------------------------------------------------- ***/
/*DYJ 5.21b */
/*DYJ 5.30f Start*/
LOCAL _VOID setDefault(_WORD obj, _VOID *env, LISTINFO info, _BOOL *draw, _BOOL *exit,_LONG *lstSel)
/*DYJ  Ende; alt:	
LOCAL _VOID setDefault(_WORD obj, _VOID *env, LISTINFO info, _BOOL *draw, _BOOL *exit)
*/
{
	GRECT r;
	ITK *itk;
	MACRO *macro;
	OneMacro *pMacro;
	OneCommand *pCmd;
	_WORD version, select, dummy;
	_UWORD udummy, kstate;
	_UBYTE prevDefault[256];
	
	UNUSED(lstSel);	/*DYJ 5.30f */
	UNUSED(info);
	*draw = FALSE;
	macro = env;
	itk = macro->itk;
	pMacro = getSelected(macro->MacroList);
	strMcpy(prevDefault, sizeof(prevDefault), pMacro->defSetup);
	graf_mkstate(&dummy, &dummy, &udummy, &kstate);
	Lists_ResetList(itk->itkCmds);
	if (DoITK_GetCmdVersion(itk->itkCmds, pMacro->command, &pCmd, &version) && 
		pMacro->version == version)
	{
		if (CatGlobal_WithShift(kstate) && pMacro->defSetup[0] != '\0')
		{	
			select = mtAlerts_AlertRSC(2, AL_DELETE_DEFAULT);
			if (select == 1)
			{
				MemSetZeroStruct(pMacro->defSetup);
				MemSetZeroStruct(pMacro->resSetup);
				if (strCmp(pMacro->defSetup, prevDefault) != 0)
				{
					itk->changed = TRUE;
					*draw = TRUE;
				}
			}
		} else
		{
			if (DoITK_HandleCommand(pCmd, pMacro))
			{
				if (strCmp(pMacro->defSetup, prevDefault) != 0)
				{
					itk->changed = TRUE;
					if (prevDefault[0] == '\0')
						*draw = TRUE;
				}
			}
		}
	}
	EnableObjState(macro->MacroBox, obj, SELECTED, FALSE);
	WinDials_WinDialDraw(macro->MacroBox, obj, 1, &r, FALSE);
	*exit = FALSE;
}

/*** ---------------------------------------------------------------------- ***/
/*DYJ 5.21b */
GLOBAL _BOOL Macro_ConfigMacro(_VOID *command, _VOID *itk, _VOID **sMacro)
{
	GRECT r;
	ldHandler dialHandler;
	List *tempList;
	OneMacro *pMacro, *tMacro;
	OneCommand *pCmd;
	MACRO *macro;
	
	macro = NEW(MACRO, "SelectMacro");
	if (macro == NULL)
		return FALSE;
	MemSetZeroStruct(*macro);
	macro->itk = itk;
	macro->listChanged = FALSE;
	
	/* temporaere Liste erzeugen */
	tempList = NEW(List, "tempMacroList");
	if (tempList == NULL ||	!Lists_CreateList(tempList, "CreateTempList"))
	{
		Lists_DeleteSimpleList(tempList, mem_free, TRUE);
		return FALSE;
	}
	pCmd = command;
	if (pCmd != NULL && pCmd->itkMacro != NULL)
	{
		/* Makroliste in die temporaere Liste kopieren */
		Lists_ResetList(pCmd->itkMacro);
		while ((pMacro = Lists_NextEntry(pCmd->itkMacro)) != NULL)
		{
			tMacro = NEW(OneMacro, "CreateTempMacro");
			if (tMacro == NULL)
			{	
				Lists_DeleteSimpleList(tempList, mem_free, TRUE);
				return FALSE;
			}
			*tMacro = *pMacro;
			if (!Lists_AppendEntry(tempList, tMacro))
			{	
				Lists_DeleteSimpleList(tempList, mem_free, TRUE);
				return FALSE;
			}
		}
		macro->new = FALSE;
		strMcpy(macro->MacroName, sizeof(macro->MacroName), pCmd->cmdName);
	} else
	{
		/* neuen Eintrag fuer Kommandoliste erzeugen */
		pCmd = NEW(OneCommand, "CreateMacroEntry");
		if (pCmd == NULL)
		{
			Lists_DeleteSimpleList(tempList, mem_free, TRUE);
			return FALSE;
		}
		MemSetZeroStruct(*pCmd);
		strBcpy(pCmd->cmdGroup, MausTauschrsc_WrkString(MACRO_GROUP));
		pCmd->macro = TRUE;
		pCmd->groupVisible = TRUE;
		pCmd->entryVisible = TRUE;
		pCmd->itk = itk;
		macro->new = TRUE;
	}
	macro->MacroEntry = pCmd;			/* Adresse des Eintrags sichern */
	macro->MacroList = tempList;		/* Adresse der temporaeren Liste sichern */
	macro->MacroList->user = macro;		

	/* Objektadresse holen */
	macro->MacroBox = TreeAddr[MACROBOX];
	SetObjcString(macro->MacroBox, MACRONAME, pCmd->cmdName);
	macro->specials[0].objc = MHELP;
	macro->specials[0].proc = doMacroHelp;
	macro->specials[1].objc = MOBEN;
	macro->specials[1].proc = moveUp;
	macro->specials[2].objc = MUNTEN;
	macro->specials[2].proc = moveDown;
	macro->specials[3].objc = MDELETE;
	macro->specials[3].proc = deleteStep;
	macro->specials[4].objc = MDEFAULT;
	macro->specials[4].proc = setDefault;

	/* Jetzt das Object zusammenbauen */
	CalcArea(macro->MacroBox, MBOX, &r);
	CalcWidth(macro);
	
	/* Objectadresse holen */
	tr = TreeAddr[LISTTXT];
	MemCpy(mTree, tr, sizeof(OBJECT));
	MemCpy(&mTed, tr[LISTENTRY].ob_spec.tedinfo, sizeof(TEDINFO));
	mTree[0].ob_spec.tedinfo = &mTed;
	mTree[0].ob_spec.tedinfo->te_ptext = mText;
	tr = mTree;
	EnableObjState(tr, 0, SELECTED, FALSE);
	EnableObjState(tr, 0, DISABLED, FALSE);

	/* WindowDialog vorbereiten */
	ListDl_BuildLdHandler(macro->MacroList,
		resetList,
		nextEntry,
		prevEntry,
		countEntries,
		isEnabled,
		selEntry,
		lineToStr,
		isSelected,
		drawMacroEntry,
		FUNK_NULL,
		0, CharHeight,
		CharWidth, macro->globalLength,
		&dialHandler);

	/* ListWinDialog oeffnen */
	if (!ListDl_WinListDial(macro->MacroBox,
		ldArrows | ldSelect | ldDoubleExit,
		&dialHandler,
		MBOX,
		MBACK,
		MOK,		/* okBut */
		MCANCEL,	/* cancelBut */
		macro,		/* env */
		MDEFAULT,	/* doubleClickButton */
		-1,			/* autoEdit */
		Macro_UpdateButtons,
		macro->specials,
		5,
		macroCheckExit,
		setAndGetMacroValues,
		setAndGetMacroValues,
		&macro->lastMacro))
	{
		OFREE(macro);
		Lists_DeleteSimpleList(tempList, mem_free, TRUE);
		*sMacro = NULL;
		return FALSE;
	}
	macro->MacroWindow = WinDials_IsWinDial(macro->MacroBox);
	*sMacro = macro;
	return TRUE;
}
