/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 *
 * 13.10.02 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.16b'
 *	CAT.RSC nicht mehr laden
 *
 * 11.9.03 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.30i'
 *	War die catl_*.rsc nicht vorhanden erschien eine leere Alertbox
 *
 * 8.04 Gerhard Stoll (GS) gekennzeichnet mit 'GS 5.39b'
 *	Fehlermeldung bei falschem RSC
 */


#include <maustaus.h>
#include <catgloba.h>
#include <confvars.h>
#include <varname1.h>
#include <vdiutil.h>
#include <cathelp.h>
#include <catmenu.h>
#include <windials.h>
#include <keycode.h>

#include <mtappl.h>
#include <mtutils.h>
#include <mtxobjec.h>
#include <mtrsc.h>
#include <mtpopups.h>
#include <mtdials.h>

#include <portvdi.h>
#include <ro_mem.h>
#include <file_io.h>
#include <routines.h>
#include <catlib.h>


GLOBAL OBJECT **TreeAddr;


LOCAL RESOURCE theRSC;



/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

typedef struct _dialog_size {
	_WORD treeNum;
	_WORD configNum;
	_WORD boxIndex;
	_WORD boxBack;
	_WORD lines;
	_WORD popVindex1;
	_WORD popVindex2;
	_WORD popVindex;
	_WORD popHindex1;
	_WORD popHindex2;
	_WORD popHindex;
	_WORD orgWidth;
	_WORD orgHeight;
} dialogSize;

LOCAL dialogSize dialogSizes[] = {
	{ GRUPPEN,  1, GROUPBOX, GROUPBACK, 1, DSIZE_GRUPPEN1, DSIZE_GRUPPEN2, DSIZE_GRUPPENV, DSIZE_GRUPPEN3, DSIZE_GRUPPEN4, DSIZE_GRUPPENH },
	{ ADR,      2, ADRBOX,   ADRBACK,   2, DSIZE_ADR1,     DSIZE_ADR2,     DSIZE_ADRV,     DSIZE_ADR3,     DSIZE_ADR4,     DSIZE_ADRH },
	{ GROUPS,   3, GRORDBOX, GRORDBACK, 1, DSIZE_GROUPS1,  DSIZE_GROUPS2,  DSIZE_GROUPSV,  DSIZE_GROUPS3,  DSIZE_GROUPS4,  DSIZE_GROUPSH },
	{ CMDBOX,   4, CCMDBOX,  CCMDBACK,  1, DSIZE_ITK1,     DSIZE_ITK2,     DSIZE_ITKV,     DSIZE_ITK3,     DSIZE_ITK4,     DSIZE_ITKH },
	{ WVFORM,   5, WVBOX,    WVBACK,    2, DSIZE_WVFORM1,  DSIZE_WVFORM2,  DSIZE_WVFORMV,  DSIZE_WVFORM3,  DSIZE_WVFORM4,  DSIZE_WVFORMH },
	{ HELPBOX, 99, HHELPBOX, HHELPBACK, 1, DSIZE_HELPBOX1, DSIZE_HELPBOX2, DSIZE_HELPBOXV, DSIZE_HELPBOX3, DSIZE_HELPBOX4, DSIZE_HELPBOXH },
	{ -1 }
};

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID AdjustDialogSize(OBJECT *tree, _WORD type, _WORD size, _WORD minsize, _WORD lines, _WORD boxIndex, _WORD boxBack, _BOOL vertical)
{
	_WORD fac;
	_WORD max;
	_WORD min;
	GRECT root;
	_WORD diff;
	_WORD idx;
	
	if (vertical)
	{
		fac = CharHeight;
		max = deskSize.g_h;
	} else
	{
		fac = CharWidth;
		max = deskSize.g_w;
	}
	switch (type)
	{
	case 0:			/* nix veraendern, so lassen wie er ist */
		size = minsize;
		break;
	case 1:			/* size gibt einen Prozentwert an */
		size = (_WORD)(((_LONG)size * max) / 100);
		break;
	case 2:			/* size gibt die Anzahl der Zeichen an */
		size = size * fac;
		break;
	case 3:			/* size gibt die Anzahl der Pixel an */
		break;
	default:		/* Fehler! */
		return;
	}
	if (size < minsize)
		size = minsize;
	if (size > max)
		size = max;
	size = (size / fac) * fac; /* runden */
	ObjcArea(tree, ROOT, &root);
	if (vertical)
	{
		diff = size - root.g_h;
		fac *= lines;
		diff = ((tree[boxIndex].ob_height + diff) / fac) * fac - tree[boxIndex].ob_height;
		min = tree[boxBack].ob_y;
		idx = tree[ROOT].ob_head;
		while (idx != ROOT)
		{
			if (tree[idx].ob_y >= min && idx != boxBack)
				tree[idx].ob_y += diff;
			idx = tree[idx].ob_next;
		}
		tree[boxIndex].ob_height += diff;
		tree[boxBack].ob_height += diff;
		tree[ROOT].ob_height += diff;
	} else
	{
		diff = size - root.g_w;
		min = tree[boxBack].ob_x;
		idx = tree[ROOT].ob_head;
		while (idx != ROOT)
		{
			if (tree[idx].ob_x > min && idx != boxBack)
				tree[idx].ob_x += diff;
			idx = tree[idx].ob_next;
		}
		tree[boxIndex].ob_width += diff;
		tree[boxBack].ob_width += diff;
		tree[ROOT].ob_width += diff;
	}
}

/*** ---------------------------------------------------------------------- ***/

/*
 * Dialog an Bildschirmgroesse anpassen
 */
GLOBAL _VOID MausTauschrsc_AdjustDialogSize(OBJECT *tree, _WORD treeNum)
{
	CONST dialogSize *size;
	_UBYTE varname[256];
	_WORD type, val;
	
	/*
	 * erst mal suchen ob der zu konfigurieren ist
	 */
	size = dialogSizes;
	while (size->treeNum >= 0)
	{
		if (treeNum == size->treeNum)
			break;
		size++;
	}
	if (size->treeNum < 0)
		return;
	/*
	 * jetzt mal schauen ob der auch konfiguriert werden soll
	 */
	make_varname(varname, sizeof(varname), cDialogVertical, size->configNum);
	if (ConfVars_GetConfigInt(varname, &type))
	{
		make_varname(varname, sizeof(varname), cDialogVerticalSize, size->configNum);
		if (ConfVars_GetConfigInt(varname, &val))
			AdjustDialogSize(tree, type, val, size->orgHeight, size->lines, size->boxIndex, size->boxBack, TRUE);
	}
	make_varname(varname, sizeof(varname), cDialogHorizontal, size->configNum);
	if (ConfVars_GetConfigInt(varname, &type))
	{
		make_varname(varname, sizeof(varname), cDialogHorizontalSize, size->configNum);
		if (ConfVars_GetConfigInt(varname, &val))
			AdjustDialogSize(tree, type, val, size->orgWidth, size->lines, size->boxIndex, size->boxBack, FALSE);
	}
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

typedef struct _dsize {
	_WORD verticalType[100];
	_WORD verticalSize[100];
	_WORD horizontalType[100];
	_WORD horizontalSize[100];
	OBJECT *tree;
	OBJECT *popup;
} DSIZE;

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID dialogGetSetValues(OBJECT *tree, _VOID *env, _BOOL set, _WORD exit)
{
	DSIZE *size;
	CONST dialogSize *sizes;
	_UBYTE varname[256];
	
	size = env;
	if (set)
	{
		sizes = dialogSizes;
		while (sizes->treeNum >= 0)
		{
			make_varname(varname, sizeof(varname), cDialogVertical, sizes->configNum);
			ConfVars_GetConfDefInt(varname, &size->verticalType[sizes->configNum], 0);
			make_varname(varname, sizeof(varname), cDialogVerticalSize, sizes->configNum);
			ConfVars_GetConfDefInt(varname, &size->verticalSize[sizes->configNum], 0);
			make_varname(varname, sizeof(varname), cDialogHorizontal, sizes->configNum);
			ConfVars_GetConfDefInt(varname, &size->horizontalType[sizes->configNum], 0);
			make_varname(varname, sizeof(varname), cDialogHorizontalSize, sizes->configNum);
			ConfVars_GetConfDefInt(varname, &size->horizontalSize[sizes->configNum], 0);
			
			VDIUtil_SetXState(tree, sizes->popVindex1, size->verticalType[sizes->configNum]);
			VDIUtil_SetXString(tree, sizes->popVindex1, size->popup, size->verticalType[sizes->configNum]);
			VDIUtil_SetIntStr(tree, sizes->popVindex, size->verticalSize[sizes->configNum]);
			VDIUtil_SetXState(tree, sizes->popHindex1, size->horizontalType[sizes->configNum]);
			VDIUtil_SetXString(tree, sizes->popHindex1, size->popup, size->horizontalType[sizes->configNum]);
			VDIUtil_SetIntStr(tree, sizes->popHindex, size->horizontalSize[sizes->configNum]);
			sizes++;
		}
	} else
	{
		if (exit == DSIZE_OK)
		{
			sizes = dialogSizes;
			while (sizes->treeNum >= 0)
			{
				make_varname(varname, sizeof(varname), cDialogVertical, sizes->configNum);
				ConfVars_SetConfigInt(varname, size->verticalType[sizes->configNum]);
				VDIUtil_GetIntStr(tree, sizes->popVindex, &size->verticalSize[sizes->configNum]);
				make_varname(varname, sizeof(varname), cDialogVerticalSize, sizes->configNum);
				ConfVars_SetConfigInt(varname, size->verticalSize[sizes->configNum]);
				make_varname(varname, sizeof(varname), cDialogHorizontal, sizes->configNum);
				ConfVars_SetConfigInt(varname, size->horizontalType[sizes->configNum]);
				VDIUtil_GetIntStr(tree, sizes->popHindex, &size->horizontalSize[sizes->configNum]);
				make_varname(varname, sizeof(varname), cDialogHorizontalSize, sizes->configNum);
				ConfVars_SetConfigInt(varname, size->horizontalSize[sizes->configNum]);
				sizes++;
			}
		}
		OFREE(size);
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL dialogButton(OBJECT *tree, _VOID *env, _WORD button, _WORD mx, _WORD my, _UWORD kstate, _WORD clicks)
{
	DSIZE *size;
	CONST dialogSize *sizes;
	GRECT r;
	_WORD x, y;
	_WORD select;
	
	UNUSED(mx);
	UNUSED(my);
	UNUSED(clicks);
	
	size = env;
	if(button==-1)
		return FALSE;
	button &= 0x7fff;
	DelObjState(tree, button, SELECTED);
	switch (button)
	{
	case DSIZE_OK:
	case DSIZE_CANCEL:
		return TRUE;
	case DSIZE_HELP:
		CatHelp_DoHelp(CatHelp_dialogSize);
		break;
	default:
		sizes = dialogSizes;
		while (sizes->treeNum >= 0)
		{
			if (button == sizes->popVindex1)
			{
				objc_offset(tree, sizes->popVindex1, &x, &y);
				select = mtPopups_TreePopup(size->popup, x, y, VDIUtil_GetXState(tree, sizes->popVindex1)) - 1;
				if (select >= 0)
				{
					VDIUtil_SetXState(tree, sizes->popVindex1, select);
					size->verticalType[sizes->configNum] = select;
					VDIUtil_SetXString(tree, sizes->popVindex1, size->popup, select);
					WinDials_WinDialDraw(tree, sizes->popVindex1, 0, &r, FALSE);
				}
			} else if (button == sizes->popVindex2)
			{
				select = VDIUtil_GetXState(tree, sizes->popVindex1);
				if(kstate&K_SHIFT)
					select = (select + 3) % 4;
				else
					select = (select + 1) % 4;
				VDIUtil_SetXState(tree, sizes->popVindex1, select);
				size->verticalType[sizes->configNum] = select;
				VDIUtil_SetXString(tree, sizes->popVindex1, size->popup, select);
				WinDials_WinDialDraw(tree, sizes->popVindex1, 0, &r, FALSE);
			} else if (button == sizes->popHindex1)
			{
				objc_offset(tree, sizes->popHindex1, &x, &y);
				select = mtPopups_TreePopup(size->popup, x, y, VDIUtil_GetXState(tree, sizes->popHindex1)) - 1;
				if (select >= 0)
				{
					VDIUtil_SetXState(tree, sizes->popHindex1, select);
					size->horizontalType[sizes->configNum] = select;
					VDIUtil_SetXString(tree, sizes->popHindex1, size->popup, select);
					WinDials_WinDialDraw(tree, sizes->popHindex1, 0, &r, FALSE);
				}
			} else if (button == sizes->popHindex2)
			{
				select = VDIUtil_GetXState(tree, sizes->popHindex1);
				if(kstate&K_SHIFT)
					select = (select + 3) % 4;
				else
					select = (select + 1) % 4;
				VDIUtil_SetXState(tree, sizes->popHindex1, select);
				size->horizontalType[sizes->configNum] = select;
				VDIUtil_SetXString(tree, sizes->popHindex1, size->popup, select);
				WinDials_WinDialDraw(tree, sizes->popHindex1, 0, &r, FALSE);
			}
			sizes++;
		}
		break;
	}
	WinDials_WinDialDraw(tree, button, MAX_DEPTH, &r, FALSE);
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID MausTauschrsc_DialogSizes(_VOID)
{
	OBJECT *dial;
	OBJECT *popup;
	DSIZE *size;
	
	dial = TreeAddr[DIALOG_SIZES];
	popup = TreeAddr[DSIZE_POPUP];
	size = NEW(DSIZE, "MausTauschrsc_DialogSizes");
	if (size == NULL)
		return;
	size->tree = dial;
	size->popup = popup;
	if (!WinDials_OpenWinDial(dial, FALSE,
		dialogGetSetValues,
		dialogGetSetValues,
		dialogButton,
		WinDials_defDraw,
		NULL,
		size))
	{
		OFREE(size);
	}
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

LOCAL MENU_KEY_ENTRY defaultMenuTable[] = {
	{   1, TABOUT, 0 },
	{   2, EDITFILE, KEY_ALT  | 'O' },
	{   3, EDITMESS, KEY_CTRL | 'O' },
	{   4, TMERGE,   KEY_CTRL | 'N' },
	{   5, TCLOSE,   KEY_CTRL | 'U' },
	{   6, TSAVE,    KEY_CTRL | 'S' },
	{   7, SAVEAS,   KEY_CTRL | 'M' },
	{   8, TPRINT,   KEY_CTRL | 'P' },
	{   9, MSTARTIT, KEY_ALT  | 'X' },
	{  10, CALLSHEL, KEY_CTRL | 'Z' },
	{  11, MAUSINFO, KEY_CTRL | 'L' },
	{  12, LOADINF,  KEY_ALT  | 'L' },
	{  13, TQUIT,    KEY_CTRL | 'Q' },
	{  14, TUNDO,    KEY_UNDO },
	{  15, TCUT,     KEY_CTRL | 'X' },
	{  16, TCOPY,    KEY_CTRL | 'C' },
	{  17, TPASTE,   KEY_CTRL | 'V' },
	{  18, TSELALL,  KEY_CTRL | 'A' },
	{  19, BLOCKROT, KEY_CTRL | 'B' },
	{  20, BLKPROT,  KEY_CTRL | 'D' },
	{  21, WRITEBLO, KEY_ALT  | 'Q' },
	{  22, INFOLINE, KEY_ALT  | 'N' },
	{  23, FINDREPL, KEY_CTRL | 'F' },
	{  24, TTSAGAIN, KEY_CTRL | 'G' },
	{  25, BREPL,    KEY_CTRL | 'R' },
	{  26, TCHFLAG,  KEY_ALT  | 'Y' },
	{  27, TNEUE,    KEY_F1 },
	{  28, TUNREAD,  KEY_F2 },
	{  29, TLASTPOS, KEY_F3 },
	{  30, TANFANG,  KEY_F4 },
	{  31, TDATUM,   KEY_F5 },
	{  32, TNUMMER,  KEY_F6 },
	{  33, TREADMSG, KEY_F8 },
	{  34, TNEWALLG, KEY_F9 },
	{  35, TNEWPERS, KEY_F10 },
	{  36, TRESUB,   KEY_ALT | 'R' },
	{  37, TSEARCH,  KEY_ALT | 'F' },
	{  38, TMSAGAIN, KEY_ALT | 'G' },
	{  39, TSUCHNB,  KEY_CTRL | 'H' },
	{  40, CYCLEWIN, KEY_CTRL | 'W' },
	{  41, FULLWIN,  KEY_ALT  | 'A' },
	{  42, CLOSEALL, 0 },
	{  43, TBUTTONW, KEY_F7 },
	{  44, WSTACKED, KEY_CTRL | 0x9e },
	{  45, WNEBEN,   KEY_CTRL | '\'' },
	{  46, WSTAFFEL, 0 },
	{  47, WTILED,   KEY_CTRL | '#' },
	{  48, MAKEEIN,  KEY_CTRL | 'I' },
	{  49, DECODE,   KEY_CTRL | 'E' },
	{  50, TTERMINAL,KEY_CTRL | 'T' },
	{  51, ABRUFEIN, 0 },
	{  52, INFOSEIN, 0 },
	{  53, TCALLITK, KEY_ALT | 'K' },
	{  54, MGETUSER, KEY_ALT | 'U' },
	{  55, TGRAUSWA, KEY_ALT | 'W' },
	{  56, AOPTIONS, KEY_ALT | 'E' },
	{  57, TOPTIONS, KEY_ALT | 'H' },
	{  58, APRINTER, KEY_ALT | 'P' },
	{  59, OGROUPS,  0 },
	{  60, OLISTE,   KEY_ALT | 'T' },
	{  61, OFLOSKEL, 0 },
	{  62, AFORMATS, 0 },
	{  63, AKONFIG,  0 },
	{  64, OIOFILT,  0 },
	{  65, ODIALOG_SIZES, 0 },
	{  66, OSHORTCUTS, 0 },
	{  67, EFONT,    KEY_ALT | 'Z' },
	{  68, OCOLOR,   0 },
	{  69, OEDITOR,  0 },
	{  70, OPSAVE,   KEY_ALT | 'S' },
	{  71, TCMTS,    0 /* KEY_CTRL | 'K' */ },
	{  72, TG_ALIAS,   0 },
	{  73, TE_ALIAS,   0 },
	{  74, OHLPPRG,   0 },
	{  75, BLKUPROT,   0 },
/*DYJ 5.32b Start*/
	{  76, OCBC,   0 },
	{  77, OPMF,   0 },
	{  78, OLANGUAGE,   0 },
/*DYJ  Ende; alt:	
	{  75, OCBC_PMF,   0 },
	{  75, OLANGUAGE,   0 },				/*DYJ 5.21i */
*/
};
#define NUM_MENU_ENTRIES ((_WORD)(sizeof(defaultMenuTable) / sizeof(defaultMenuTable[0])))


/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID menuDoHelp(_VOID)
{
	CatHelp_DoHelp(CatHelp_hotkeys);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID MausTauschrsc_Shortcuts(_VOID)
{
	Menu_Editkeys(TreeAddr[MENU], defaultMenuTable, NUM_MENU_ENTRIES, menuDoHelp);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID MausTauschrsc_MenuInit(_VOID)
{
	OBJECT *menu;
	
	menu = TreeAddr[MENU];
	Menu_Loadkeys(menu, defaultMenuTable, NUM_MENU_ENTRIES);
	Menu_Setkeys(menu, defaultMenuTable, NUM_MENU_ENTRIES, FALSE);
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

/* image und icon-konvertierung */

LOCAL _VOID vdiFix(MFDB *pfd, _VOID *theAddr, _WORD wb, _WORD h)
{
	pfd->fd_wdwidth = (wb + 1) / 2;
	pfd->fd_w = wb * 8;
	pfd->fd_h = h;
	pfd->fd_nplanes = 1;
	pfd->fd_stand = TRUE;
	pfd->fd_addr = theAddr;
	pfd->fd_r1 = 0;
	pfd->fd_r2 = 0;
	pfd->fd_r3 = 0;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID vdiTrans(_VOID *source, _WORD sourceWb, _VOID *dest, _WORD destWb, _WORD h, HVDI handle)
{
	MFDB src, dst;

	vdiFix(&src, source, sourceWb, h);
	src.fd_stand = TRUE;
	vdiFix(&dst, dest, destWb, h);
	dst.fd_stand = FALSE;
	vr_trnfm(handle, &src, &dst);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID transBitBlk(BITBLK *spec, HVDI handle)
{
	_VOID *addr;

	addr = spec->bi_pdata;
	if (addr != (_VOID *)-1)
		vdiTrans(addr, spec->bi_wb, addr, spec->bi_wb, spec->bi_hl, handle);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID MaskImg(_VOID *adr, _UWORD byteLen, _UWORD height)
{
	_UBYTE *ptr;
	_UWORD i, k;

	if (adr == (_VOID *)-1 || adr == NULL)
		return;
	ptr = adr;
	byteLen = (byteLen + 1) & ~1;
	for (i = 0; i < height; i++)
	{
		/* Zeilenweise durchgehen */
		for (k = 0; k < byteLen; k++)
		{
			if (!(i & 1))
				ptr[i * byteLen + k] = ptr[i * byteLen + k] & 0x55;
			else
				ptr[i * byteLen + k] = ptr[i * byteLen + k] & 0xaa;
		}
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID MaskImage(OBJECT *tree, _WORD ob)
{
	BITBLK *image;

	image = GetObSpec(tree, ob)->bitblk;
	MaskImg(image->bi_pdata, image->bi_wb, image->bi_hl);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID FixData(_VOID *adr, _UWORD byteLen, _UWORD height, _UWORD targetHeight)
{
	_UBYTE *ptr;
	_UWORD i, j, k;
	_UWORD step;

	if (targetHeight >= height ||
		adr == (_VOID *)-1 ||
		adr == NULL)
		return;

	step = (targetHeight / (height - targetHeight));
	byteLen = (byteLen + 1) & ~1;
	j = 0;
	ptr = adr;
	for (i = 0; i < targetHeight; i++)
	{
		/* Zeilenweise durchgehen */
		for (k = 0; k < byteLen; k++)
			ptr[i * byteLen + k] = ptr[j * byteLen + k];
		++j;
		if ((j % step) == 0)
		{
			/* Zeile verodern und nochmal j erhoehen */
			for (k = 0; k < byteLen; k++)
			{
				ptr[i * byteLen + k] = ptr[i * byteLen + k] | ptr[j * byteLen + k];
				/*
				ptr[i * byteLen + k] = ptr[j * byteLen + k];
				*/
			}
			++j;
		}
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID FixImage(OBJECT *tree, _WORD ob)
{
	BITBLK *image;

	image = GetObSpec(tree, ob)->bitblk;
	FixData(image->bi_pdata, image->bi_wb, image->bi_hl, tree[ob].ob_height);
	image->bi_hl = tree[ob].ob_height;
	tree[ob].ob_width = image->bi_wb * 8;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID FixIcon(OBJECT *tree, _WORD ob)
{
	ICONBLK *image;
	_WORD wb;

	image = GetObSpec(tree, ob)->iconblk;
	wb = (image->ib_wicon + 7) / 8;
	FixData(image->ib_pmask, wb, image->ib_hicon, tree[ob].ob_height);
	FixData(image->ib_pdata, wb, image->ib_hicon, tree[ob].ob_height);
	if (image->ib_hicon > tree[ob].ob_height)
	{
		/* Positionen des Textes und Zeichens fixen */
		wb = (tree[ob].ob_height / (image->ib_hicon- tree[ob].ob_height)) + 1;
		image->ib_ychar -= image->ib_ychar / wb;
		image->ib_ytext -= image->ib_ytext / wb;
	}
	/* Groesse fixen */
	image->ib_hicon = tree[ob].ob_height;
	tree[ob].ob_width = image->ib_wicon;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID TransGImage(OBJECT *tree, _WORD obj, HVDI handle, _BOOL fixSize)
{
	_WORD type;
	_WORD wb, hl;
	OBSPEC *spec;
	ICONBLK *ptrIcn;
	_VOID *tAddr;
	
	spec = GetObSpec(tree, obj);
	if (spec == (_VOID *)-1 || spec == NULL)
		return;
	type = GetObtype(tree, obj);
	fixSize = fixSize && !GetObjFlags(tree, obj, 0x2000 /* cCoords */);
	switch (type & 0xff)
	{
	case G_IMAGE:
		transBitBlk(spec->bitblk, handle);
		if (CharHeight >= 8 && CharHeight < 16 && fixSize)
			FixImage(tree, obj);
		break;
	case G_ICON:
		ptrIcn = spec->iconblk;
		hl = ptrIcn->ib_hicon;
		wb = (ptrIcn->ib_wicon + 7) / 8;
		tAddr = ptrIcn->ib_pdata;
		if (tAddr != (_VOID *)-1)
			vdiTrans(tAddr, wb, tAddr, wb, hl, handle);
		tAddr = ptrIcn->ib_pmask;
		if (tAddr != (_VOID *)-1)
			vdiTrans(tAddr, wb, tAddr, wb, hl, handle);
		if (CharHeight >= 8 && CharHeight < 16 && fixSize)
			FixIcon(tree, obj);
		break;
	}
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

/*** ---------------------------------------------------------------------- ***/

typedef struct _tImgInfo {
	_WORD trIdx;
	_WORD obIdx;
	_BOOL fixSize;
} tImgInfo;

LOCAL tImgInfo cImgTable[] = {
	{ ABOUT, THECAT0, FALSE },
	{ ABOUT, THECAT1, FALSE },
	{ ABOUT, THECAT2, FALSE },
	{ GRUPPEN, GRCFULL, TRUE },
	{ GRUPPEN, GRCEMPTY, TRUE },
	{ GRSTEUER, WUPMESS, TRUE },
	{ GRSTEUER, WDOWNMESS, TRUE },
	{ GRSTEUER, WRIGHTMESS, TRUE },
	{ GRSTEUER, WLEFTMESS, TRUE },
	{ GRSTEUER, RETURN, TRUE },
	{ GRSTEUER, WACTION, TRUE },
	{ GRSTEUER, WINFO, TRUE },
	{ GRSTEUER, WTREE, TRUE },
	{ GRSTEUER, WLIST, TRUE },
	{ GRSTEUER, WPICT, TRUE },
	{ GRSTEUER, WPOP, TRUE },
	{ GRSTEUER, VERTEILER, TRUE },			/*DYJ 5.19g */
	{ MSGCTRL, CTRLEDIT, FALSE },
	{ MSGCTRL, CTRLKOMM, FALSE },
	{ MSGCTRL, CTRLVIEW, FALSE },
	{ MSGCTRL, CTRLDEL, FALSE },
	{ MSGCTRL, CTRLCOPY, FALSE },
	{ MSGCTRL, CTRLHDR, FALSE },
	{ MSGCTRL, CTRLBACK, FALSE },
	{ EDITCTRL, EC_BACK, FALSE },
	{ EDITCTRL, EC_EDIT, FALSE },
	{ EDITCTRL, EC_POP, FALSE },
	{ EDITCTRL, EC_INS, FALSE },
	{ CAT_ICON, THE_ICON, FALSE },
	{ LOADBOX, LOADIMG0, TRUE },
	{ LOADBOX, LOADIMG1, TRUE },
	{ LOADBOX, LOADIMG2, TRUE },
};

#define cImgCount (_WORD)(sizeof(cImgTable) / sizeof(cImgTable[0]))

/*** ---------------------------------------------------------------------- ***/

/*DYJ 5.16b */	/*DYJ 5.21i */	/*DYJ 5.22f */	/*DYJ 5.29j */
GLOBAL _BOOL MausTauschrsc_RscInit(_VOID)
{
	_WORD workIn[16];
	_WORD workOut[57];
	_WORD vdiHandle;
	_WORD j;
	_UBYTE scrap[PATH_MAX];
	_UBYTE rsrcname[PATH_MAX];
	_WORD dummy;
	
	if (theRSC == NULL)
	{
		_UBYTE nameEnd[20];

		CatGlobal_ApplPath(scrap);
		Rsc_EnvLang(scrap,nameEnd);
		strCat(nameEnd,RSC_EXT);

		strCpy(rsrcname, CATL_RSC_BASE);
		strCat(rsrcname,nameEnd);

		if(!Rsc_RscInit(scrap,rsrcname))
		{
/*DYJ 5.30i Start*/
			sprintf(scrap,"[3][%%P|Konnte %s nicht laden|Could'nt load %s][OK]",rsrcname,rsrcname);
/*DYJ  Ende; alt:	
			sprintf(scrap,"[3][%P|Konnte %s nicht laden|Could'nt load %s][OK]",rsrcname,rsrcname);
*/
			mtAlerts_Alert(1,scrap);
			return FALSE;
		}

		strCpy(rsrcname, CAT_BASE);
		strCat(rsrcname,nameEnd);

		if ((theRSC = RscLoad(rsrcname)) == NULL)
		{
			F_Path_Append(scrap, rsrcname);
			theRSC = RscLoad(rsrcname);
		}
	}
	if (theRSC == NULL)
	{
		sprintf(scrap,Rsc_WrkString(AL_NO_RSC),rsrcname);
		mtAlerts_Alert(1,scrap );
		return FALSE;
	}
/* GS 5.39b Start: */
	strCpy (scrap, MausTauschrsc_WrkString(_RSM_CRC_) );
	if ( strCmp (scrap, _RSM_CRC_STRING_ ) != 0 )
	{
		mtAlerts_SetIconColor(RED);
		sprintf(scrap, "[3][CRC-Error in RSC File:|%s][[Exit]",rsrcname);
		mtAlerts_Alert(1,scrap );
		mtAlerts_SetIconColor(BLACK);
		return FALSE;
	}
/* Ende */
	
	TreeAddr = RscGetTrees(theRSC);
	
	MemSetZeroArray(workIn);
	workIn[0]  = 1; /* Bildschirmtreiber, aktuelle Aufloesung */
	workIn[1]  = 1; /* Linientyp durchgehend                  */
	workIn[2]  = 0; /* Linienfarbe                            */
	workIn[3]  = 0; /* Markertyp                              */
	workIn[4]  = 0; /* Markerfarbe                            */
	workIn[5]  = 1; /* Textstil - System                      */
	workIn[6]  = 1; /* Textfarbe                              */
	workIn[7]  = 1; /* Fuelltyp weiss                         */
	workIn[8]  = 1; /* Fuellmusterindex                       */
	workIn[9]  = 0; /* Fuellfarbe                             */
	workIn[10] = 2; /* Geraetespezifische Koordinaten         */
	vdiHandle = graf_handle(&dummy, &dummy, &dummy, &dummy);
	v_opnvwk(workIn, &vdiHandle, workOut);
	if (vdiHandle > 0)
	{
		for (j = 0; j < cImgCount; j++)
		{
			TransGImage(TreeAddr[cImgTable[j].trIdx], cImgTable[j].obIdx, vdiHandle, cImgTable[j].fixSize);
		}
		if (Bitplanes == 1)
		{
			MaskImage(TreeAddr[ABOUT], THECAT0);
			MaskImage(TreeAddr[LOADBOX], LOADIMG2);
		}

		v_clsvwk(vdiHandle);
	}
	
	{
		dialogSize *size;
	
		size = dialogSizes;
		while (size->treeNum >= 0)
		{
			size->orgHeight = TreeAddr[size->treeNum][ROOT].ob_height;
			size->orgWidth = TreeAddr[size->treeNum][ROOT].ob_width;
			size++;
		}
	}
	
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

/*DYJ 5.27a */
GLOBAL _VOID MausTauschrsc_RscFree(_VOID)
{
#if DEBUG_ALLOC
	RscFreeLib();
	if (theRSC != NULL)
	{
		RscFree(theRSC);
		theRSC = NULL;
		TreeAddr = NULL;
	}
#endif
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL OBJECT *MausTauschrsc_WrkTree(_WORD treeNr)
{
	return TreeAddr[treeNr];
}

/*** ---------------------------------------------------------------------- ***/

/*DYJ 5.21i */
GLOBAL _UBYTE *MausTauschrsc_WrkString(_WORD nr)
{
	static _UBYTE dummy[30];
	_UBYTE *ret;
	ret=*((_UBYTE **)RscGaddr(theRSC, R_FRSTR, nr));
	if(!ret)
	{
		ret=dummy;
		sprintf(ret,"[3][NO RSC;Nr:%d][OK]",nr);
	}
	return ret;
}
