/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */


 
/*
  * 2.11.02 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.16i'
 *	Beim Anfgen des 2. Anhangs wurde ein ungltiger Pfad voreingestelt.
 *
 * 20.10.02 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.16f'
 *	Anhang hinzufgen berarbeitet
 *
 * 10.11.02 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.16q'
 *	Beantwortete man eine Nachricht aus einer PM-Pseudogruppe, konnte
 *	Cat die Ausgangsnachricht nicht finden
 *
 * 1.12.02 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.19g'
 *	Beim Beantworten einer Internet-Mail die noch andere Adressaten hatte bietet Cat
 *	jetzt an, diesen auch eine Kopie (cc) der Antwort zu senden.
 *
 * 4.12.02 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.19i'
 *	Verschickte man eine Nachricht mit Kopieen ber SMTP, so meldet In2Cat das Versenden
 *	einer Mail, Cat erwartete aber eine Benachrichtigung pro Kopie. Also wurde das
 *	Original zum Lschen vorgemerkt und die Kopien blieben aktiv. Jetzt lscht
 *	Cat in diesem Fall automatisch auch die Kopien.
 *
 * 17.2.03 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.21d'
 *	Die Anzahl Kopieen sind bei der Maus auf 10 begrenzt, fr's
 *	Internet gilt das aber nicht.
*/
#include <messages.h>
#include <catvers.h>
#include <arcstart.h>
#include <catfiles.h>
#include <cattypes.h>
#include <mte.h>
#include <mtedit2.h>
#include <editor.h>
#include <fontsele.h>
#include <wdwmanag.h>
#include <vdiutil.h>
#include <confvars.h>
#include <varname1.h>
#include <varn_ede.h>
#include <catgloba.h>
#include <edittype.h>
#include <editglob.h>
#include <maustaus.h>
#include <grintool.h>
#include <listhelp.h>
#include <grin.h>
#include <data.h>
#include <quicksor.h>
#include <infofile.h>
#include <groupsel.h>
#include <protokol.h>
#include <mtpaths.h>
#include <convertd.h>
#include <msgwindo.h>
#include <userinfo.h>
#include <groupcom.h>

#include <mttextfi.h>
#include <mtappl.h>
#include <mtutils.h>
#include <mtdials.h>
#include <mtpopups.h>
#include <tos.h>

#include <keyboard.h>
#include <ro_mem.h>
#include <set.h>
#include <routinec.h>
#include <routines.h>
#include <strconv.h>
#include <s_endian.h>
#include <editfunc.h>
#include <vaproto.h>
#include <mtdir.h>
#include <mime.h>
#include <cat.h>
#include <mtrsc.h>
#include <adr.h>	/*DYJ 5.34db */

GLOBAL CONST _UBYTE *CONST msgDistribs[] = {
	msgDNone,
	msgDLokal,
	msgDMausNet,
	msgDNet
};

GLOBAL msgInfo *msgArray;
GLOBAL MESSNR messages;
GLOBAL MESSNR maxMess;


LOCAL SET usedNumbers;

#define MSG_MIN 1
#define MSG_MAX 999
#define MSG_NONE 0


#define msgFileName "msg"

/* Magics fuer Header */
#define msgCatMagic     0x4341544DL /* "CATM"                    */
#define msgVersion      2           /* Versionsnummer der MsgManager.i */

#define msgVersionMagic 0x0160      /* Versionsmagic                   */

#define dateL     0x0001
#define receiverL 0x0002
#define orgGroupL 0x0004
#define groupL    0x0008
#define refIdL    0x0010
#define topicL    0x0020
#define rIdL      0x0040
#define rNameL    0x0080
#define fromL	  0x0100
#define refL	  0x0200
#define ccL		  0x0400		/*DYJ 5.19g */

#define CR '\r'
#define LF '\n'
/*=======================================================================*/
/* Funktionen und Typen fuer das Editorfenster                            */
/*=======================================================================*/

typedef struct _boxHandleRec boxHandleRec, *boxHandler;
struct _boxHandleRec {
	HWND wdw;
	MESSNR number;        /* Messagenummer! */
	GRECT r;
	_UBYTE infoStr[256];
	OBJECT *tree;
	_BOOL dontUpdate;
	boxHandler next;
};

LOCAL boxHandler boxList;

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

/* Messagenummer-Verwaltung: Es wird in dem Set festgehalten, welche Nummern
 * schon vergeben wurden und welche nicht. FindNumber gibt die niedrigste freie
 * Nummer zurueck, ClearNumber loescht die uebergebene Nummer aus dem Set
 */

LOCAL _WORD FindNumber(_WORD min)
{
	_WORD i;
	
	min = Min(min, MSG_MIN);
	for (i = min; i <= MSG_MAX; i++)
		if (!setin(usedNumbers, i))
		{
			setincl(usedNumbers, i);
			return i;
		}
	return MSG_NONE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID ClearNumber(_WORD num)
{
	setexcl(usedNumbers, num);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _WORD Messages_FindMessage(MESSNR number)
{
	_WORD i;
	
	for (i = 0; i < messages; i++)
		if (msgArray[i].info.number == number)
			return i;
	return -1;
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

/* Ein paar Hilfsroutinen */

/* Uebergeben wird die Nummer, gibt zurueck 'MSGxxx'
 * Die Extension muss dann noch angehaengt werden.
 */
GLOBAL _VOID Messages_Number2Name(MESSNR number, _UBYTE *str, size_t strsize)
{
	_UBYTE numStr[4];
	
	strMcpy(str, strsize, msgFileName);
	NumToStr(number, 10, 3, '0', numStr, sizeof(numStr));
	strMcat(str, strsize, numStr);
}

/*** ---------------------------------------------------------------------- ***/

/* Erzeugt ein Datum fuer IDs,. 24 Bit lang und damit
 * 5 Zeichen im 36er System.
 * Das Format sieht wie folgt aus:
 * Bit  0..5:  Minute (6 Bits)
 * Bit  6..10: Stunde (5 Bits)
 * Bit 11..15: Tag    (5 Bits)
 * Bit 16..19: Monat  (4 Bits)
 * Bit 20..23: (Jahr seit 1980) MOD 16 (4 Bits)
 */
LOCAL CATDATE MakeMyDate(_UWORD date, _UWORD time)
{
	F_TIME t;
	_ULONG year;
	
	T_Localtime(T_DosToSystime(date, time), &t);
	year = (t.tm_year - 1980) % 16;
	/* Nun das neue Datum einpacken */
	return (((((((year << 4) + t.tm_mon + 1) << 5) + t.tm_mday + 1) << 5) + t.tm_hour) << 6) + t.tm_min;
}

/*** ---------------------------------------------------------------------- ***/

/* Erzeugt eine ID, wie sie an die Maus geschickt wird.
 * Format:
 * CM###ddddd, ### ist die interne Messagenummer,
 * ddddd ist das Datum und die Zeit im 36er System
 */
GLOBAL _VOID Messages_MakeMausId(CONST msgInfo *msg, _UBYTE *str, size_t strsize)
{
	CATDATE myDate;
	
	strMcpy(str, strsize, "CM");
	if (strsize > 2)
		NumToStr(msg->info.number, 10, 3, '0', str + 2, strsize - 2);
	/* Nun wird aus den GEMDOS-Daten ein eigenes Datum erzeugt, da die Maus
	 * nur IDs mit 10 Stellen annimmt, ich aber mindestens 13 braeuchte :-((
	 * Daher habe ich ein eigenes Format eingebaut, das nicht alle
	 * Informationen enthaelt, aber genau genug ist und 24 Bit belegt.
	 */
	myDate = MakeMyDate(msg->info.cDate, msg->info.cTime);
	if (strsize > 5)
		LNumToStr(myDate, 36, 5, '0', str + 5, strsize - 5);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _ULONG Messages_FileSize(CONST _UBYTE *path, CONST _UBYTE *name, _UWORD *date, _UWORD *time)
{
	_UBYTE fname[PATH_MAX];
	_BOOL exists;
	
	strBcpy(fname, path);
	F_Path_Append(fname, name);
	return CatFiles_FileSizeAndDate(fname, &exists, date, time);
}

/*** ---------------------------------------------------------------------- ***/

/* Noch altes Format, Dateidatum der Messagedatei nehmen */
LOCAL _VOID FixDate(MESSNR idx)
{
	_UBYTE tmpName[PATH_MAX];
	
	Messages_Number2Name(msgArray[idx].info.number, tmpName, sizeof(tmpName));
	strBcat(tmpName, textExt);
	Messages_FileSize(MessagePath, tmpName, &msgArray[idx].info.cDate, &msgArray[idx].info.cTime);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL hasNumbers(CONST _UBYTE *internalId)
{
	return
		internalId[2] >= '0' && internalId[2] <= '9' &&
		internalId[3] >= '0' && internalId[3] <= '9' &&
		internalId[4] >= '0' && internalId[4] <= '9';
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL isMessage(CONST _UBYTE *internalId)
{
	return
		(lcase(internalId[0]) == (_UBYTE)msgFileName[0] &&
		 lcase(internalId[1]) == (_UBYTE)msgFileName[1] &&
		 lcase(internalId[2]) == (_UBYTE)msgFileName[2]) ||
		(internalId[0] == 'C' &&
		 internalId[1] == 'M' &&
		 hasNumbers(internalId));
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _WORD GetMessIdx(CONST _UBYTE *internalId)
{
	_WORD number;
	_UBYTE numStr[8];
	_BOOL is_long;
	_WORD idx;
	CATDATE cLong, xLong;
	
	is_long = FALSE;
	if (hasNumbers(internalId))
	{
		strMcpy(numStr, 4, internalId + 2);
		number = StrToCard(numStr, NULL, NULL);
		is_long = TRUE;
	} else
	{
		number = StrToInt(internalId + 3, NULL, NULL);
	}
	idx = Messages_FindMessage(number);
	if (is_long && idx >= 0)
	{
		/* Nun bei langem Format auch noch Datum und Zeit pruefen */
		strMcpy(numStr, 6, internalId + 5);
		xLong = StrToLNum(numStr, 36, NULL, NULL);
		cLong = MakeMyDate(msgArray[idx].info.cDate, msgArray[idx].info.cTime);
		if (xLong != cLong)
			return -1;
	}
	return idx;
}


/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

/* Alloziert ein neues Messagearray und kopiert das alte hinein.
 * FALSE: Nicht genug Speicher!
 */
LOCAL _BOOL MakeNewMsgArray(_BOOL force, MESSNR new)
{
	MESSNR newMax;
	msgInfo *newArray;
	
	if (messages == maxMess - 1 || force)
	{
		if (force)
			newMax = new + 20;
		else
			newMax = maxMess + 20;
		newArray = M0ALLOC(newMax * sizeof(msgInfo), "MakeNewMsgArray");
		if (newArray == NULL)
			return FALSE;
		if (msgArray != NULL)
		{
			MemCpy(newArray, msgArray, maxMess * sizeof(msgInfo));
			FREE(msgArray, maxMess * sizeof(msgInfo));
		}
		msgArray = newArray;
		maxMess = newMax;
		MsgWindow_MsgSetList(msgArray, FALSE);
	}
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID FreeMsgStrings(msgInfo *msg)
{
	if (msg->date != NULL)
	{
		SFREE(msg->date);
		msg->date = NULL;
	}
	if (msg->receiver != NULL)
	{
		SFREE(msg->receiver);
		msg->receiver = NULL;
	}
	if (msg->orgGroup != NULL)
	{
		SFREE(msg->orgGroup);
		msg->orgGroup = NULL;
	}
	if (msg->group != NULL)
	{
		SFREE(msg->group);
		msg->group = NULL;
	}
	if (msg->refId != NULL)
	{
		SFREE(msg->refId);
		msg->refId = NULL;
	}
	if (msg->topic != NULL)
	{
		SFREE(msg->topic);
		msg->topic = NULL;
	}
	if (msg->rId != NULL)
	{
		SFREE(msg->rId);
		msg->rId = NULL;
	}
	if (msg->realName != NULL)
	{
		SFREE(msg->realName);
		msg->realName = NULL;
	}
	if (msg->replyTo != NULL)
	{
		SFREE(msg->replyTo);
		msg->replyTo = NULL;
	}
	if (msg->sender != NULL)
	{
		SFREE(msg->sender);
		msg->sender = NULL;
	}
	if (msg->followupTo != NULL)
	{
		SFREE(msg->followupTo);
		msg->followupTo = NULL;
	}
	if (msg->attachment != NULL)
	{
		SFREE(msg->attachment);
		msg->attachment = NULL;
	}

	if (msg->ref != NULL)
	{
		SFREE(msg->ref);
		msg->ref = NULL;
	}

	if (msg->Absender != NULL)
	{
		SFREE(msg->Absender);
		msg->Absender = NULL;
	}
	if (msg->cc != NULL)
	{
		SFREE(msg->cc);
		msg->cc = NULL;
	}
	if (msg->bcc != NULL)
	{
		SFREE(msg->bcc);
		msg->bcc = NULL;
	}
	if (msg->eZeitX != NULL)
	{
		SFREE(msg->eZeitX);
		msg->eZeitX = NULL;
	}
/*
	if (msg->retPath != NULL)
	{
		SFREE(msg->retPath);
		msg->retPath = NULL;
	}
	if (msg->keyw != NULL)
	{
		SFREE(msg->keyw);
		msg->keyw = NULL;
	}
	if (msg->resent != NULL)
	{
		SFREE(msg->resent);
		msg->resent = NULL;
	}
	if (msg->trace != NULL)
	{
		SFREE(msg->trace);
		msg->trace = NULL;
	}
	if (msg->received != NULL)
	{
		SFREE(msg->received);
		msg->received = NULL;
	}
	if (msg->path != NULL)
	{
		SFREE(msg->path);
		msg->path = NULL;
	}
	if (msg->mailer != NULL)
	{
		SFREE(msg->mailer);
		msg->mailer = NULL;
	}
/*DYJ  Ende; */
	if (msg->org != NULL)
	{
		SFREE(msg->org);
		msg->org = NULL;
	}
*/
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID FreeMsgArrayStrings(_VOID)
{
	_WORD i;

	for (i = 0; i < messages; i++)
		FreeMsgStrings(&msgArray[i]);
}

/*** ---------------------------------------------------------------------- ***/

/* Diese Prozedur liest das Infoarray von der
 * Platte und zaehlt auch am Anfang die Messages
 */
/*DYJ 5.21b */
GLOBAL _VOID Messages_ReadMessageInfo(_VOID)
{
	FILENO msgHdl;
	_ULONG size;
	MESSNR mess;
	MESSNR i;
	shortInfo *shortArray;
	FileHeaderType dbHdr;
	_BOOL readMessages;
	_UBYTE fname[PATH_MAX];
	F_ERROR error;
	
	/* Datei oeffnen */
	mess = 0;
	readMessages = FALSE;
	size = 0;
	shortArray = NULL;
	strBcpy(fname, MessagePath);
	F_Path_Append(fname, msgInfoName);
	msgHdl = CatFiles_OpenFile(fname, CatFiles_readFile);
	if (msgHdl == -33)       /* File not found */ /*!ERROR*/
	{
		messages = 0;
		MakeNewMsgArray(TRUE, messages);
	} else
	{
		if (!FILENO_OK(msgHdl))
		{
			F_ErrorAlert(msgHdl);
			return;
		}
		CatFiles_Seek(0L, msgHdl, CatFiles_end);
		CatFiles_FilePos(msgHdl, &size);
		if (size < dbHeaderLength)
		{
			messages = 0;
			MakeNewMsgArray(TRUE, mess);
			readMessages = FALSE;
		} else
		{
			mess = (MESSNR)((size - dbHeaderLength) / sizeof(shortInfo));
			if (mess > 0)
			{
				shortArray = MALLOC(size - dbHeaderLength, "Messages_ReadMessageInfo");
				if (shortArray == NULL)
				{
					CatFiles_CloseFile(msgHdl);
					return;
				}
				if (!MakeNewMsgArray(TRUE, mess))
				{
					SFREE(shortArray);
					CatFiles_CloseFile(msgHdl);
					return;
				}
			} else
			{
				CatFiles_CloseFile(msgHdl);
				MakeNewMsgArray(TRUE, mess);
			}
			readMessages = mess > 0;
		}
	}
	
	if (readMessages)
	{
		/* Jetzt erst mal Header einlesen */
		CatFiles_Seek(0L, msgHdl, CatFiles_start);
		error = CatFiles_ReadDbHeader(msgHdl, &dbHdr);
		if (error != NoError)
		{
			F_ErrorAlert(error);
			CatFiles_CloseFile(msgHdl);
			SFREE(shortArray);
			return;
		}
		
		/* Jetzt ueberpruefen des Headers */
		if (dbHdr.CatMagic != msgCatMagic ||
			dbHdr.Version  != msgVersion ||
			dbHdr.VersionMagic != msgVersionMagic)
		{
			MTE_infoRSC(AL_OLD_MSG_VERSION);
			CatFiles_CloseFile(msgHdl);
			SFREE(shortArray);
			return;
		}
		
		/* Alles einlesen in shortArray */
		error = CatFiles_ReadMuch(size - dbHeaderLength, msgHdl, shortArray);
		if (error != NoError)
		{
			F_ErrorAlert(error);
			CatFiles_CloseFile(msgHdl);
			SFREE(shortArray);
			return;
		}
		/* und File schliessen */
		CatFiles_CloseFile(msgHdl);
		
		/* alten Speicher freigeben */
		FreeMsgArrayStrings();
		
		/* Messageinfo loeschen */
		MemSetZero(msgArray, (mess) * sizeof(msgInfo));
		for (i = 0; i < mess; i++)
		{
			msgArray[i].info.msgType   = n2hs(shortArray[i].msgType);
			msgArray[i].info.number    = n2hs(shortArray[i].number);
			msgArray[i].info.copyCount = n2hs(shortArray[i].copyCount);
			msgArray[i].info.refNum    = n2hs(shortArray[i].refNum);
			msgArray[i].info.sendMsg   = n2hs(shortArray[i].sendMsg);
			msgArray[i].info.toDelete  = n2hs(shortArray[i].toDelete);
			msgArray[i].info.dist      = n2hs(shortArray[i].dist);
			msgArray[i].info.size      = n2hl(shortArray[i].size);
			msgArray[i].info.noRefLine = n2hs(shortArray[i].noRefLine);
			msgArray[i].info.cDate     = n2hs(shortArray[i].cDate);
			msgArray[i].info.cTime     = n2hs(shortArray[i].cTime);
			msgArray[i].info.orgDist   = n2hs(shortArray[i].orgDist);
			msgArray[i].info.reserved1 = n2hl(shortArray[i].reserved1);
			msgArray[i].info.reserved2 = n2hl(shortArray[i].reserved2);
			msgArray[i].hdrRead = FALSE;
			msgArray[i].selected = FALSE;
			msgArray[i].isSend   = FALSE;
			if (msgArray[i].info.cDate == 0)
				FixDate(i);
			setincl(usedNumbers, msgArray[i].info.number);
		}
		/* shortarray freigeben */
		SFREE(shortArray);
		
		messages = mess;
		MsgWindow_MsgSetMaxPos(messages, TRUE);
	}
}

/*** ---------------------------------------------------------------------- ***/

/* Diese Prozedur schreibt das Info-Array
 * fuer die Messages weg
 */
GLOBAL _VOID Messages_WriteMessageInfo(_BOOL doRedrawWdw)
{
	shortInfo *shortArray;
	_WORD i;
	FILENO msgHdl;
	FileHeaderType dbHdr;
	_UBYTE fname[PATH_MAX];
	F_ERROR error;
	
	strBcpy(fname, MessagePath);
	F_Path_Append(fname, msgInfoName);
	if (messages == 0)
	{
		F_File_Delete(fname);
		MsgWindow_MsgCloseIfOpen();
		Protokoll_SendPathUpdate(MessagePath);
		return;
	}
	shortArray = MALLOC(messages * sizeof(shortInfo), "Messages_WriteMessageInfo");
	if (shortArray == NULL)
		return;
	for (i = 0; i < messages; i++)
	{
		shortArray[i].msgType   = h2ns(msgArray[i].info.msgType);
		shortArray[i].number    = h2ns(msgArray[i].info.number);
		shortArray[i].copyCount = h2ns(msgArray[i].info.copyCount);
		shortArray[i].refNum    = h2ns(msgArray[i].info.refNum);
		shortArray[i].sendMsg   = h2ns(msgArray[i].info.sendMsg);
		shortArray[i].toDelete  = h2ns(msgArray[i].info.toDelete);
		shortArray[i].dist      = h2ns(msgArray[i].info.dist);
		shortArray[i].size      = h2nl(msgArray[i].info.size);
		shortArray[i].noRefLine = h2ns(msgArray[i].info.noRefLine);
		shortArray[i].cDate     = h2ns(msgArray[i].info.cDate);
		shortArray[i].cTime     = h2ns(msgArray[i].info.cTime);
		shortArray[i].orgDist   = h2ns(msgArray[i].info.orgDist);
		shortArray[i].reserved1 = h2nl(msgArray[i].info.reserved1);
		shortArray[i].reserved2 = h2nl(msgArray[i].info.reserved2);
	}
	msgHdl = CatFiles_CreateFile(fname);
	if (msgHdl < 0)
	{
		F_ErrorAlert(msgHdl);
		SFREE(shortArray);
	}
	dbHdr.CatMagic = h2nl(msgCatMagic);
	dbHdr.Version  = h2ns(msgVersion);
	dbHdr.VersionMagic = h2ns(msgVersionMagic);
	error = CatFiles_WriteMuch(dbHeaderLength, msgHdl, &dbHdr);
	if (error != NoError)
	{
		F_ErrorAlert(error);
		SFREE(shortArray);
		CatFiles_CloseFile(msgHdl);
		return;
	}
	error = CatFiles_WriteMuch(messages * sizeof(shortInfo), msgHdl, shortArray);
	if (error != NoError)
		F_ErrorAlert(error);
	SFREE(shortArray);
	CatFiles_CloseFile(msgHdl);
	Protokoll_SendPathUpdate(MessagePath);
	MsgWindow_MsgSetList(msgArray, FALSE);
	MsgWindow_MsgSetMaxPos(messages, doRedrawWdw);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID DeleteMsgArray(_VOID)
{
	/* alten Speicher freigeben */
	if (msgArray != NULL)
	{
		FreeMsgArrayStrings();
		SFREE(msgArray);
		msgArray = NULL;
	}
	messages = 0;
	maxMess = 0;
	setclr(usedNumbers);
}

/*** ---------------------------------------------------------------------- ***/

/* Liest die MSGINFO.DAT erneut ein
 */
GLOBAL _VOID Messages_ReReadMessageInfo(_VOID)
{
	DeleteMsgArray();
	Messages_ReadMessageInfo();
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

/* Header-File I/O */
LOCAL _BOOL ReadHdrLine(_UBYTE **line, TEXTFILENO hdrHdl)
{
	_UBYTE aLine[1024];

	mtTextfiles_ReadLine(hdrHdl, aLine, sizeof(aLine));
	mtTextfiles_ReadLn(hdrHdl);
	if (*line != NULL)
		SFREE(*line);
	*line = STRDUP(aLine, "ReadHdrLine");
	return *line != NULL;
}

/*** ---------------------------------------------------------------------- ***/

/* Liest die Header-Zeilen aus der Datei MSGxxx.HDR ein
 */
GLOBAL _BOOL Messages_ReadHdrInfo(msgInfo *msg, _BOOL externalRef)
{
	_UBYTE hdrName[PATH_MAX];
	_UBYTE name[PATH_MAX];
	TEXTFILENO hdrHdl;
	_WORD idx;
	_BOOL exists;
	
	if (msg->hdrRead)
		return TRUE;
	/* Filenamen basteln */
	Messages_Number2Name(msg->info.number, name, sizeof(name));
	strBcat(name, headerExt);
	strBcpy(hdrName, MessagePath);
	F_Path_Append(hdrName, name);
	/* File oeffnen */
	if (mtTextfiles_OpenTextfile(hdrName, READ, 512, &hdrHdl) == GERR_OK)
	{
		/* Jetzt die einzelnen Zeilen lesen */
		if (!ReadHdrLine(&msg->date, hdrHdl) ||
			!ReadHdrLine(&msg->receiver, hdrHdl) ||
			!ReadHdrLine(&msg->orgGroup, hdrHdl) ||
			!ReadHdrLine(&msg->group, hdrHdl) ||
			!ReadHdrLine(&msg->refId, hdrHdl) ||
			!ReadHdrLine(&msg->topic, hdrHdl) ||
			!ReadHdrLine(&msg->rId, hdrHdl) ||
			!ReadHdrLine(&msg->realName, hdrHdl) ||
			!ReadHdrLine(&msg->replyTo, hdrHdl) ||
			!ReadHdrLine(&msg->sender, hdrHdl) ||
			!ReadHdrLine(&msg->followupTo, hdrHdl) ||
			!ReadHdrLine(&msg->attachment, hdrHdl) ||
			!ReadHdrLine(&msg->ref, hdrHdl) ||
			!ReadHdrLine(&msg->Absender, hdrHdl) ||
			!ReadHdrLine(&msg->cc, hdrHdl) ||
			!ReadHdrLine(&msg->bcc, hdrHdl) ||
			!ReadHdrLine(&msg->eZeitX, hdrHdl)
/*
			!ReadHdrLine(&msg->retPath, hdrHdl) ||
			!ReadHdrLine(&msg->keyw, hdrHdl) ||
			!ReadHdrLine(&msg->resent, hdrHdl) ||
			!ReadHdrLine(&msg->trace, hdrHdl) ||
			!ReadHdrLine(&msg->received, hdrHdl) ||
			!ReadHdrLine(&msg->path, hdrHdl) ||
			!ReadHdrLine(&msg->mailer, hdrHdl) ||
			!ReadHdrLine(&msg->org, hdrHdl)
*/
		)
		{
			/* Out of Memory */
			mtTextfiles_CloseTextfile(&hdrHdl);
			idx = Messages_FindMessage(msg->info.number);
			if (idx >= 0)
				msgArray[idx] = *msg;
			return FALSE;
		}
		/* File wieder schliessen */
		mtTextfiles_CloseTextfile(&hdrHdl);
		msg->hdrRead = TRUE;
		if (externalRef)
		{
			idx = Messages_FindMessage(msg->info.number);
			if (idx >= 0)
				msgArray[idx] = *msg;
		}
		return TRUE;
	} else
	{
		/* pruefen, ob die Datei wirklich existiert. Wenn nicht, dann muss
		 * die Message geloescht werden!
		 */
		if (CatFiles_FileSize(hdrName, &exists) == 0)
		{
			/* File nicht da oder leer, weg damit! */
		}
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID WriteHdrLine(CONST _UBYTE *line, TEXTFILENO hdrHdl)
{
	if (line != NULL)
		mtTextfiles_WriteLine(hdrHdl, line);
	mtTextfiles_WriteLn(hdrHdl);
}

/*** ---------------------------------------------------------------------- ***/

/* Schreibt die Header-Zeilen in die Datei MSGxxx.HDR
 */
GLOBAL _VOID Messages_WriteHdrInfo(msgInfo *msg)
{
	_UBYTE hdrName[PATH_MAX];
	_UBYTE name[PATH_MAX];
	TEXTFILENO hdrHdl;

	/* Filenamen basteln */
	Messages_Number2Name(msg->info.number, name, sizeof(name));
	strBcat(name, headerExt);
	strBcpy(hdrName, MessagePath);
	F_Path_Append(hdrName, name);
	/* File oeffnen */
	if (mtTextfiles_OpenTextfile(hdrName, WRITE, 512, &hdrHdl) == GERR_OK)
	{
		WriteHdrLine(msg->date, hdrHdl);
		WriteHdrLine(msg->receiver, hdrHdl);
		WriteHdrLine(msg->orgGroup, hdrHdl);
		WriteHdrLine(msg->group, hdrHdl);
		WriteHdrLine(msg->refId, hdrHdl);
		WriteHdrLine(msg->topic, hdrHdl);
		WriteHdrLine(msg->rId, hdrHdl);
		WriteHdrLine(msg->realName, hdrHdl);
		WriteHdrLine(msg->replyTo, hdrHdl);
		WriteHdrLine(msg->sender, hdrHdl);
		WriteHdrLine(msg->followupTo, hdrHdl);
		WriteHdrLine(msg->attachment, hdrHdl);
		WriteHdrLine(msg->ref, hdrHdl);
		WriteHdrLine(msg->Absender, hdrHdl);
		WriteHdrLine(msg->cc, hdrHdl);
		WriteHdrLine(msg->bcc, hdrHdl);
		WriteHdrLine(msg->eZeitX, hdrHdl);
/*
		WriteHdrLine(msg->retPath, hdrHdl);
		WriteHdrLine(msg->keyw, hdrHdl);
		WriteHdrLine(msg->resent, hdrHdl);
		WriteHdrLine(msg->trace, hdrHdl);
		WriteHdrLine(msg->received, hdrHdl);
		WriteHdrLine(msg->path, hdrHdl);
		WriteHdrLine(msg->mailer, hdrHdl);
		WriteHdrLine(msg->org, hdrHdl);
*/
		/* File wieder schliessen */
		mtTextfiles_CloseTextfile(&hdrHdl);
		/* Protokoll_SendPathUpdate(MessagePath); */
	}
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

/* Verwaltung der einzelnen Editboxen */

LOCAL boxHandler CreateHandler(_VOID)
{
	boxHandler bx;
	
	bx = NEW(boxHandleRec, "Messages: CreateHandler");
	if (bx != NULL)
	{
		MemSetZeroStruct(*bx);
		bx->next = boxList;
		boxList = bx;
		bx->dontUpdate = FALSE;
		bx->wdw = -1;
	}
	return bx;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL boxHandler globBx;

LOCAL boxHandler FindHandler(HWND wdw)
{
	boxHandler bx;
	
	for (bx = boxList; bx != NULL; bx = bx->next)
		if (bx->wdw == wdw)
			return bx;
	return globBx;
}

/*** ---------------------------------------------------------------------- ***/
/*DYJ 5.21b */
LOCAL _VOID MakeInfoStr(CONST msgInfo *msg, _UBYTE *str, size_t strsize)
{
	*str = '\0';
	if (msg->info.msgType == msg_mail ||
		msg->info.msgType == msg_comment ||
		msg->info.msgType == msg_groupcomment)
	{
		/* Gruppe hinzufuegen */
		if (msg->group != NULL && msg->group[0] != '\0')
		{
			strMcat(str, strsize, MausTauschrsc_WrkString(HEAD_GR));
			strMcat(str, strsize, " ");
			strMcat(str, strsize, msg->group);
			strMcat(str, strsize, "  ");
		}
	} else
	{
		if (msg->receiver != NULL && msg->receiver[0] != '\0')
		{
			strMcat(str, strsize, MausTauschrsc_WrkString(HEAD_AN));
			strMcat(str, strsize, " ");
			strMcat(str, strsize, msg->receiver);
			strMcat(str, strsize, "  ");
		}
	}
	if (msg->topic != NULL && msg->topic[0] != '\0')
	{
		strMcat(str, strsize, MausTauschrsc_WrkString(HEAD_WG));
			strMcat(str, strsize, " ");
		strMcat(str, strsize, msg->topic);
	}
	if (strLen(str) > 80)
	{
		str[79] = '\003';
		str[80] = '\0';
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID UpdateBoxInfo(boxHandler box, CONST msgInfo *msg)
{
	MakeInfoStr(msg, box->infoStr, sizeof(box->infoStr));
	SetObjcStringAdr(box->tree, EC_TEXT, box->infoStr, sizeof(box->infoStr));
	SetObjcString(box->tree, EC_DIST, msgDistribs[msg->info.dist]);
	EnableObjState(box->tree, EC_HOLD, SELECTED,!msg->info.sendMsg);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL boxHandler MakeBoxInfo(CONST msgInfo *msg)
{
	boxHandler box;
	
	if ((box = CreateHandler()) != NULL)
	{
		box->dontUpdate = FALSE;
		/* Baum zuweisen */
		box->tree = TreeAddr[EDITCTRL];
		box->number = msg->info.number;
		UpdateBoxInfo(box, msg);
	}
	return box;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID getRect(HWND wdw, CONST GRECT *wdwRect, GRECT *userRect, GRECT *editWork)
{
	boxHandler bx;
	
	bx = FindHandler(wdw);
	if (bx != NULL)
	{
		*userRect = *wdwRect;
		userRect->g_h = bx->tree[0].ob_height;
		bx->r = *userRect;
		editWork->g_x = userRect->g_x;
		editWork->g_y = userRect->g_y + userRect->g_h + 1;
		editWork->g_w = userRect->g_w;
		editWork->g_h = wdwRect->g_h - userRect->g_h - 1;
	} else
	{
		userRect->g_x = wdwRect->g_x;
		userRect->g_x = wdwRect->g_y;
		userRect->g_x = 0;
		userRect->g_x = 0;
		*editWork = *wdwRect;
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID AdaptPos(OBJECT *tree, CONST GRECT *r)
{
	tree[ROOT].ob_x = r->g_x;
	tree[ROOT].ob_y = r->g_y;
	tree[ROOT].ob_width = r->g_w;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID SetTree(boxHandler bx)
{
	_WORD idx;
	msg_type mt;
	_WORD ro_state;
	_UBYTE zahl[3]="0";
	/* Koordinaten und Inhalt anpassen */
	AdaptPos(bx->tree, &bx->r);
	SetObjcStringAdr(bx->tree, EC_TEXT, bx->infoStr, sizeof(bx->infoStr));
	if(UserBLK.isInternet)
		bx->tree[EC_TEXT].ob_x = bx->tree[EC_POP].ob_x;
	else
		bx->tree[EC_TEXT].ob_x = 2*bx->tree[EC_DIST].ob_x+bx->tree[EC_DIST].ob_width-bx->tree[EC_POP].ob_x-bx->tree[EC_POP].ob_width;
	bx->tree[EC_TEXT].ob_width = bx->r.g_w - bx->tree[EC_TEXT].ob_y + bx->tree[0].ob_x;
	idx = Messages_FindMessage(bx->number);
	if (idx >= 0)
	{
		mt = msgArray[idx].info.msgType;
		ro_state = Editor_GetModeRW(bx->wdw);
/*DYJ 5.34d Start*/
		EnableObjState(bx->tree, EC_BACK, DISABLED, !(mt == msg_comment || mt == msg_answer|| mt == msg_pseudoKom || mt == msg_groupcomment || mt == msg_persanswer));
/*DYJ  Ende; alt:	
		EnableObjState(bx->tree, EC_BACK, DISABLED, !(mt == msg_comment || mt == msg_answer || mt == msg_groupcomment || mt == msg_persanswer));
*/
		EnableObjState(bx->tree, EC_POP, DISABLED, !(mt == msg_mail || mt == msg_comment || mt == msg_groupcomment));
		EnableObjState(bx->tree, EC_HOLD, SELECTED,!msgArray[idx].info.sendMsg);
		EnableObjState(bx->tree, EC_WRITE, SELECTED,ro_state==MODE_RW);
		EnableObjState(bx->tree, EC_WRITE, DISABLED,ro_state==MODE_RO);
		if(msgArray[idx].attachment && msgArray[idx].attachment[0]>0)
			itoa(msgArray[idx].attachment[0]-'0',zahl,10);
		SetObjcString(bx->tree, EC_ATTA_N, zahl);
		EnableObjFlags(bx->tree, EC_POP, HIDETREE, UserBLK.isInternet);
		EnableObjFlags(bx->tree, EC_DIST, HIDETREE, UserBLK.isInternet);
		EnableObjState(bx->tree, EC_INS, DISABLED,ro_state);
		SetObjcString(bx->tree, EC_DIST, msgDistribs[msgArray[idx].info.dist]);
	} else
	{
		SetObjcString(bx->tree, EC_DIST, "");
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID drawUserBox(HWND wdw, HVDI vdiHdl, CONST GRECT *wdwWork, CONST GRECT *clip, _WORD textCol, _WORD backCol)
{
	boxHandler bx;
	GRECT tr;

	UNUSED(vdiHdl);
	UNUSED(wdwWork);
	bx = FindHandler(wdw);
	if (bx != NULL)
	{
		SetTree(bx);
		VDIUtil_SetTreeColor(bx->tree, textCol, backCol);
		ObjcArea(bx->tree, ROOT, &tr);
		if (clip->g_y + clip->g_h == tr.g_y + tr.g_h &&
			-clip->g_h == ObjcFrame(bx->tree, ROOT))
		{
			tr = *clip;
			tr.g_y -= 1;
			tr.g_h += 2;
			Objc_draw(bx->tree, ROOT, MAX_DEPTH, &tr);
		} else
		{
			Objc_draw(bx->tree, ROOT, MAX_DEPTH, clip);
		}
	}
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

LOCAL MSGNR getIdNumber(OneGroupHandle ptr, CONST _UBYTE *ID)
{
	return data_NumberOfID(ptr, ID);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID Messages_openReference(_WORD idx)
{
	CONST _UBYTE *str;
	CAT_GROUP_NUMBER gr;
	msgInfo msg;
	_BOOL isPrivate;

	msg = msgArray[idx];
	if (!Messages_ReadHdrInfo(&msg, TRUE))
		return;
	if (msg.orgGroup == NULL || msg.orgGroup[0] == '\0')
	{
		gr = dataSys_private;
		isPrivate = TRUE;
	} else
	{
		isPrivate = FALSE;
	}
	str = msg.refId;
	if (str != NULL && isMessage(str) && strChr(str, '@') == NULL)
	{
		/* Ist ein Kommentar auf eine interne Message! */
		idx = GetMessIdx(str);
		if (idx >= 0)
			Messages_OpenEditor(&msgArray[idx], FALSE, -1, 0, MODE_RW);
	} else if (isPrivate || GroupSelect_GroupNumber(msg.orgGroup, &gr))
	{
		grin_grinOpenWithProc(gr, getIdNumber, str ? str : (CONST _UBYTE *)"", grin_grinNextMess, NULL, mOther);
	}
}
/*** ------------------------------------------------------------------------ ***/
/*	_VOID setEditorChanged(HWND wdw)											*/
/*	Markiert ein Editorfenster als gendert										*/
/*	Parameter:	wdw: Editorfenster												*/
/*	Ergebnis:	keines															*/		
/*	7.1.02 von Dimitri Junker	DYJ 4.34a										*/
/*** ------------------------------------------------------------------------ ***/
LOCAL _VOID setEditorChanged(HWND wdw)
{
	EDITOR *ed;
	ed = EditFuncs_FindEditor(wdw);
	if (ed != NULL)
		ed->changed=TRUE;
}

/*** ---------------------------------------------------------------------- ***/

/*DYJ 5.16i */	/*DYJ 5.21b */
LOCAL _VOID handleObject(boxHandler bx, _WORD idx, _WORD ob)
{
	OBJECT *pop;
	GRECT r;
	_WORD select;
	_BOOL ro_state;
	static _UBYTE qPfad[PATH_MAX]="";

	pop = TreeAddr[DISTRIBX];
	if (ob >= 0 && ob <= EC_POP &&
		!GetObjState(bx->tree, ob, DISABLED) &&
		GetObjFlags(bx->tree, ob, SELECTABLE))
	{
		SetObjState(bx->tree, ob, SELECTED);
		CalcArea(bx->tree, ob, &r);
		WdwManager_RedrawWdw(bx->wdw, &r);
		Bounce();
		switch (ob)
		{
		case EC_BACK:
			Messages_openReference(idx);
			break;
		case EC_EDIT:
			if (Messages_ReadHdrInfo(&msgArray[idx], FALSE))
			{
				if (MsgWindow_changeHdr(&msgArray[idx]))
				{
					Messages_WriteMessageInfo(FALSE);
					Messages_UpdateEditors(&msgArray[idx]);
					MsgWindow_MsgUpdateButtons();
					MsgWindow_MsgRedrawEntry(idx);
				}
			}
			break;
		case EC_POP:
			CalcArea(bx->tree, EC_POP, &r);
			select = mtPopups_TreePopup(pop, r.g_x, r.g_y, msgArray[idx].info.dist);
			if (select > 0)
			{
				msgArray[idx].info.dist = (tDistribution)(select - 1);
				Messages_WriteMessageInfo(FALSE);
				SetObjcString(bx->tree, EC_DIST, msgDistribs[msgArray[idx].info.dist]);
				WdwManager_RedrawWdw(bx->wdw, &bx->r);
				MsgWindow_MsgRedrawEntry(idx);
			}
			break;

		case EC_INS:
			if(!Editor_GetMode(bx->wdw, roMode))
				Editor_InsChr(bx->wdw);
			break;
		case EC_HOLD:
			msgArray[idx].info.sendMsg =!msgArray[idx].info.sendMsg;
			MsgWindow_MsgUpdateButtons();
			Messages_UpdateEditors(&msgArray[idx]);		/* (MH) */
			MsgWindow_MsgRedrawEntry(idx);
			break;
			
		case EC_ATTA_I:
		{
			_UBYTE nummer[PATH_MAX]="",file[PATH_MAX]="",suff[PATH_MAX]="",name[PATH_MAX]="",*anhTs,tmpStr[1000],*nxt;
			_WORD anhNr,i;
			_LONG dummy;
			strCpy(tmpStr,MausTauschrsc_WrkString(FS_ANHANG1));
			CalcArea(bx->tree, ob, &r);
			if(msgArray[idx].attachment && msgArray[idx].attachment[0]>'0')		/*Anhnge vorhanden?*/
			{
				anhTs=msgArray[idx].attachment+4;
				while(*anhTs && strLen(tmpStr)<sizeof(tmpStr)-30)
				{
					anhTs=Mime_ParseAnhStr(anhTs,nummer,name,&dummy);
					sprintf(strChr(tmpStr,'\0')," | %-20.20s",name);
				}
				select = mtPopups_PosPopup(r.g_x, r.g_y, tmpStr, NULL);
			}
			else
				select=0;
			switch(select)
			{
				case 0:		/* Anhang hinzufgen*/
					strBcpy(suff, "*.*");
					if(!qPfad[0])
						ConfVars_GetConfDefStr(cAttachSrcPath, qPfad, sizeof(qPfad), "");
					if (mtDir_FselGet(qPfad, file, suff, MausTauschrsc_WrkString(FS_LOAD_ANHANG), FALSE))
					{
						F_Path_Append(qPfad, file);
						VaProto_Quote(name,sizeof(name),file,DO_QUOTE);
						if(msgArray[idx].attachment && msgArray[idx].attachment[0]>'0')
						{
							strCpy(tmpStr,msgArray[idx].attachment);
							sprintf(nummer," ;%d =",(_WORD)(tmpStr[2]-'0'));
							strCat(tmpStr,nummer);
							SFREE(msgArray[idx].attachment);
							msgArray[idx].attachment=NULL;
						}
						else
							strCpy(tmpStr,"00:0 =");
						strMcat(tmpStr,sizeof(tmpStr),name);
						msgArray[idx].attachment= STRDUP(tmpStr, "messages: handleObject: attachment");
						msgArray[idx].attachment[0]++;
						/* Filenamen basteln */
						Messages_Number2Name(msgArray[idx].info.number, name, sizeof(name));
						sprintf(nummer,"_A.%03d",(_WORD)(tmpStr[2]-'0'));
						strBcat(name, nummer);
						strBcpy(file, MessagePath);
						F_Path_Append(file, name);
						CatFiles_copyFile(file,qPfad);
						F_Path_Dirname(qPfad);
						msgArray[idx].attachment[2]++;
						setEditorChanged(bx->wdw);
					}
					break;
				case 1:		/* Kodierung ndern*/
					msgArray[idx].attachment[1]=mtAlerts_AlertRSC(1, ATTACH_CODE)==1?'M':'U';
					setEditorChanged(bx->wdw);
					break;
				case -1:	/* Abbruch*/
				case 2: 	/* Trennlinie*/
					break;
				default:	/* bereits vorhandener Anhang*/
					anhNr = select-3;
					anhTs=msgArray[idx].attachment+4;
					for(i=0;i<anhNr;i++)
						anhTs=Mime_ParseAnhStr(anhTs,nummer,name,&dummy);
					anhNr=atoi(nummer);
					/* Filenamen basteln */
					Messages_Number2Name(msgArray[idx].info.number, name, sizeof(name));
					sprintf(nummer,"_A.%03d",anhNr);
					strBcat(name, nummer);
					strBcpy(file, MessagePath);
					F_Path_Append(file, name);

					select=mtPopups_PosPopup(r.g_x, r.g_y, MausTauschrsc_WrkString(FS_ANHANG2), NULL);
					switch(select)
					{
						case 0:	/* ffnen*/
						{
							_UBYTE path[PATH_MAX], name[PATH_MAX], suff[PATH_MAX];
							mtDir_SplitPath(file, path, name, suff);
							MTEdit2_OpenEditWindow(path, name, FALSE, FALSE);
							break;
						}
						case 1:	/* lschen*/
							if(msgArray[idx].attachment[0]>'1')
							{
								nxt=Mime_ParseAnhStr(anhTs,nummer,name,&dummy);
								if(*nxt)
									strCpy(anhTs,nxt);
								else
									anhTs[0]='\0';
								msgArray[idx].attachment[0]--;
							}
							else
							{
								SFREE(msgArray[idx].attachment);
								msgArray[idx].attachment=NULL;
							}
							Fdelete(file);
							setEditorChanged(bx->wdw);
							break;
					}
			}
			if(msgArray[idx].attachment && msgArray[idx].attachment[0]>'0')
				itoa(msgArray[idx].attachment[0]-'0',tmpStr,10);
			else
				strCpy(tmpStr,"0");
			SetObjcString(bx->tree, EC_ATTA_N, tmpStr);
			CalcArea(bx->tree, EC_ATTA_N, &r);
			WdwManager_RedrawWdw(bx->wdw, &r);
				break;
		}
		case EC_WRITE:
			Editor_ToggleMode(bx->wdw, roMode);
			ro_state = Editor_GetMode(bx->wdw, roMode);
			Editor_SetMode(bx->wdw, roMode, ro_state);
			Editor_SetMode(bx->wdw, effMode, ro_state);
			WdwManager_FullRedrawWdw(bx->wdw);
			break;
		}
		if (bx != NULL)
		{
			DelObjState(bx->tree, ob, SELECTED);
			CalcArea(bx->tree, ob, &r);
			WdwManager_RedrawWdw(bx->wdw, &r);
		}
	}
}

/*** ---------------------------------------------------------------------- ***/

/* Hier die Handler fuer die Box mit den Kommentar-Infos */
LOCAL _VOID ClickInInfo(HWND wdw, HVDI vdiHdl, _WORD mx, _WORD my, _UWORD kstate, CONST GRECT *work)
{
	boxHandler bx;
	_WORD idx;
	_WORD ob;

	UNUSED(vdiHdl);
	UNUSED(kstate);
	UNUSED(work);
	bx = FindHandler(wdw);
	if (bx != NULL)
	{
		idx = Messages_FindMessage(bx->number);
		if (idx >= 0)
		{
			SetTree(bx);
			ob = objc_find(bx->tree, ROOT, MAX_DEPTH, mx, my);
			handleObject(bx, idx, ob);
		}
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL handleKey(HWND wdw, _UBYTE *scan, _UBYTE *c, _UWORD *kstate, _BOOL *moreChars)
{
	boxHandler bx;
	_WORD idx;
	_BOOL withAlt;

	bx = FindHandler(wdw);
	if (bx != NULL)
	{
		idx = Messages_FindMessage(bx->number);
		if (idx >= 0)
		{
			*moreChars = FALSE;
			/* Jetzt habe ich den richtigen ASCII-Code */
			withAlt = CatGlobal_WithAlt(*kstate);
			if ((withAlt && *c == '\0') || CatGlobal_WithCtrl(*kstate))
			{
				/* Jetzt Tastencodes richtig holen, das AES erzaehlt da nur Muell */
				*c = CharCode(*scan, *kstate);
			}
			switch (ucase(*c))
			{
			case 'C':
				if (withAlt)
				{
					handleObject(bx, idx, EC_EDIT);
					return TRUE;
				}
				break;
			case 'D':
				if (withAlt)
				{
					handleObject(bx, idx, EC_POP);
					return TRUE;
				}
				break;
			case '-':
				if (CatGlobal_WithCtrl(*kstate))
				{
					handleObject(bx, idx, EC_BACK);
					return TRUE;
				}
				break;
			case 'Z':
				if (withAlt && CatGlobal_WithShift(*kstate))
				{
					/* Zurueckstellung umaendern */
					if (Messages_ReadHdrInfo(&msgArray[idx], FALSE))
					{
						msgArray[idx].info.sendMsg = !msgArray[idx].info.sendMsg;
						Messages_WriteMessageInfo(FALSE);
						MsgWindow_MsgUpdateButtons();
						Messages_UpdateEditors(&msgArray[idx]);	/* (MH) */
						MsgWindow_MsgRedrawEntry(idx);
					}
					return TRUE;
				}
			case 'E':
				/* Effekte togglen (MH) */
				if (withAlt && CatGlobal_WithShift(*kstate))
				{
					handleObject(bx, idx, EC_WRITE);
					return TRUE;
				}
				break;
			}
		}
	}
	return MTEdit2_ChangeThisChar(wdw, scan, c, kstate, moreChars);
}

/*** ------------------------------------------------------------------------ ***/
/*	LOCAL _VOID	Messages_ChangeDate(msgInfo *msg,_UWORD cDtNeu,_UWORD cTiNeu)	*/
/*	ndert info.cDate und info.cTime einer Message.								*/
/*	Dadurch ndert sich dadurch ggf. ihre temporre MausID.						*/
/*	Da diese aber bereits als RefID verwendet worden sein kann mssen alle		*/
/*	RefIDs geprft und ggf angepat werden.								*/
/*	Parameter:	msg:	Message die sich gendert hat mit alten Zeiten			*/
/*				cDtNeu:	neues Datum												*/
/*				cTiNeu:	neue Zeit												*/
/*	Ergebnis:	keines															*/		
/*	30.3.00 von Dimitri Junker	DYJ 4.14										*/
/*** ------------------------------------------------------------------------ ***/
LOCAL _VOID	Messages_ChangeDate(msgInfo *msg,_UWORD cDtNeu,_UWORD cTiNeu)
{
	group_line refNameAlt,refNameNeu;
	_WORD idx;
	
	Messages_MakeMausId(msg, refNameAlt, sizeof(refNameAlt));
	msg->info.cDate = cDtNeu;
	msg->info.cTime = cTiNeu;
	Messages_MakeMausId(msg, refNameNeu, sizeof(refNameNeu));
	for (idx = 0; idx < messages; idx++)
	{
		if (Messages_ReadHdrInfo(&msgArray[idx], FALSE))
		{
			if(msgArray[idx].refId!=NULL && !strCmp(msgArray[idx].refId,refNameAlt))
			{
				strCpy(msgArray[idx].refId,refNameNeu);
				Messages_WriteHdrInfo(&msgArray[idx]);
			}
		}
	}
}
	

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL userClose(HWND wdw)
{
	boxHandler bx, boxi;
	_WORD idx;
	_UBYTE msgName[PATH_MAX];
	_ULONG size;
	_UWORD cDt, cTi;

	/* boxHandler wieder aus Liste entfernen und freigeben */
	bx = FindHandler(wdw);
	if (bx != NULL)
	{
		/* Erstmal nachsehen, ob Text geaendert bei neuem Text! */
		idx = Messages_FindMessage(bx->number);
		if (idx >= 0 && !bx->dontUpdate)
		{
			/* Testen, ob Groesse veraendert! */
			Messages_Number2Name(bx->number, msgName, sizeof(msgName));
			strBcat(msgName, textExt);
			size = Messages_FileSize(MessagePath, msgName, &cDt, &cTi);
			/* Jetzt Datum bauen */
			/* Achtung: Dieser Aufruf geht davon aus, dass der String
			 * immer vorhanden und passend gross ist. Diese Annahme ist zulaessig,
			 * da jede Nachricht eine E-Zeile verpasst bekommt und auch
			 * die Laenge der E-Zeile feststeht. Ausserdem wird beim Einlesen grosszuegig
			 * alloziert.
			 */
			/* Hier gibt es einen Buserror, wenn der Pointer noch nicht
			 * alloziert ist
			 */
			Messages_ReadHdrInfo(&msgArray[idx], FALSE);
			if (msgArray[idx].date != NULL)
			{
				ConvertDate_MakeFreeDate(cDt, cTi, msgArray[idx].date, strLen(msgArray[idx].date) + 1);
			}
			/* Groesse, Datum und Zeit immer aktualisieren (MH) */
			if (size != msgArray[idx].info.size  ||
			    (!msgArray[idx].new &&
			     (cDt  != msgArray[idx].info.cDate ||
			      cTi  != msgArray[idx].info.cTime)))
			{
				msgArray[idx].info.size = size;
				Messages_ChangeDate(&msgArray[idx],cDt,cTi);
				msgArray[idx].new = FALSE;
				Messages_WriteMessageInfo(FALSE);
				Messages_WriteHdrInfo(&msgArray[idx]);
			} else if (msgArray[idx].new)
			{
				/* Nachsehen, ob noch andere Fenster mit der Nachricht
				 * offen sind. Wenn nicht, dann Nachricht loeschen
				 */
				boxi = boxList;
				while (boxi != NULL && (boxi->number != bx->number || boxi == bx))
					boxi = boxi->next;
				if (boxi == NULL)
					Messages_deleteMessage(msgName, FALSE, TRUE);
			} else
			{
				Messages_WriteHdrInfo(&msgArray[idx]);
			}
		}
		if (boxList != bx)
		{
			/* Auf Listenanfang gehen */
			boxi = boxList;
			/* Handler suchen in Liste */
			while (boxi != NULL && boxi->next != bx)
				boxi = boxi->next;
			boxi->next = bx->next;
		} else
		{
			boxList = bx->next;
		}
		OFREE(bx);
	}
	return TRUE;
}
/*** ------------------------------------------------------------------------ ***/
/*	LOCAL _BOOL msgIsEdited(_WORD messIdx)										*/
/*	Ermittelt, ob eine Message zum Schreiben geffnet ist						*/
/*	Parameter:	messIdx:	Messagenummer										*/
/*	Ergebnis:	TRUE falls offen												*/		
/*	22.12.00 von Dimitri Junker	DYJ 4.22l										*/
/*** ------------------------------------------------------------------------ ***/
LOCAL _BOOL msgIsEdited(_WORD messIdx)
{
	EDITOR *ed;
	boxHandler bx;
	/* Nachsehen, ob zu der Nachricht ein Editor offen ist
	 * Wenn ja, Modus prfen
	 */
	bx = boxList;
	while (bx != NULL)
	{
		if (bx->number == messIdx)
		{
			ed = EditFuncs_FindEditor(bx->wdw);
			if (ed != NULL && ed->readOnly!=MODE_RO)
				return TRUE;
		}
		bx = bx->next;
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID Messages_OpenEditor(msgInfo *msg, _BOOL new, _WORD num, _ULONG offset, _WORD modeRW)
{
	_UBYTE txtName[PATH_MAX];
	boxHandler bx;
	_BOOL auto_indent;
	
	if (msg->info.msgType != msg_forward &&
		msg->info.msgType != msg_copyOther &&
		msg->info.msgType != msg_copyOwn)
	{
		/* Erstmal Headerinformationen einlesen */
		if (!Messages_ReadHdrInfo(msg, TRUE))
			return;
		/* Jetzt Editor aufrufen */
		Messages_Number2Name(msg->info.number, txtName, sizeof(txtName));
		strBcat(txtName, textExt);
		strBcpy(OpenName, txtName);
		
		if ((bx = MakeBoxInfo(msg)) != NULL)
		{
			globBx = bx;
			if (Editor_OpenEditor(MessagePath, txtName, NULL,
				FALSE,				/* New */
				TRUE,				/* useUserProc */
				ClickInInfo, getRect, drawUserBox, userClose,
				handleKey, FUNK_NULL, FUNK_NULL, FUNK_NULL,
				UserBLK.RightMargin,/* right */
				FALSE,				/* showInfo */
				UserBLK.Umbruch,	/* wrap */
				num,
				&bx->wdw))
			{
				Editor_SetTabSize(bx->wdw, UserBLK.TabSize);
				ConfVars_GetConfDefBool(cEditAutoIndentDefault, &auto_indent, TRUE);
				Editor_SetMode(bx->wdw, indentMode, auto_indent);
				if (new)
					Editor_EditSetOffset(bx->wdw, offset);
				Editor_SetRW(bx->wdw, MODE_RO);	/* sonst ist die nchste Zeile witzlos*/
				if(msgIsEdited(msg->info.number))
					modeRW=MODE_RO;
				else
					Editor_SetRW(bx->wdw, modeRW);
				if (modeRW!=MODE_RW)
				{
					Editor_SetMode(bx->wdw, msgMode, TRUE);
					Editor_SetMode(bx->wdw, effMode, TRUE);
				}
			} else
			{
				globBx = NULL;
				userClose(-1); /* direkt wieder loeschen! */
			}
			globBx = NULL;
		}
	}
}


/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

LOCAL _BOOL freeMsg(msgInfo *msg)
{
	FreeMsgStrings(msg);
	--messages;
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL CopyLine(_UBYTE **x, CONST _UBYTE *str)
{
	if (str == NULL)
		return FALSE;
	*x = STRDUP(str, "Messages: CopyLine");
	if (*x == NULL || **x == '\0')
		return FALSE;
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

/*DYJ 5.16r */	/*DYJ 5.19g */	/*DYJ 5.21b */	/*DYJ 5.21d */
GLOBAL _BOOL Messages_CreateMessage(
	_WORD minNum,
	CONST _UBYTE *From,
	CONST _UBYTE *To,
	CONST _UBYTE *OrgGroup,
	CONST _UBYTE *Group,
	CONST _UBYTE *RefId,
	CONST _UBYTE *Topic,
	CONST _UBYTE *RealName,
	CONST _UBYTE *Cc,			/*DYJ 5.19g */
	msg_type type,
	MESSNR copyTo,
	CONST _UBYTE *crossLine,
	CONST _UBYTE *oldMId,
	tDistribution oldDist,
	_BOOL openEditor,
	MESSNR *messIdx,
	CONST _UBYTE *References
	)
{
	msgInfo msg;
	_UBYTE txtName[PATH_MAX];
	TEXTFILENO txtHdl;
	_ULONG offset;
	_WORD idx;
	_UBYTE tmpName[PATH_MAX];
	group_line mataGroup;
	ITEMBITS linesAvail;
	_BOOL dontSetDist;
	group_line followupTo;
	group_line replyTo="";
	
	if (!MakeNewMsgArray(FALSE, 0))
		return FALSE;
	msg = msgArray[messages];
	*messIdx = messages;
	++messages;
	msg.date = NULL;
	msg.receiver = NULL;
	msg.orgGroup = NULL;
	msg.group = NULL;
	msg.refId = NULL;
	msg.topic = NULL;
	msg.rId = NULL;
	msg.realName = NULL;
	msg.replyTo = NULL;
	msg.sender = NULL;
	msg.Absender = NULL;
	msg.followupTo = NULL;
	msg.cc=NULL;			/*DYJ 5.19g */
	msg.date = MALLOC(20, "Message_CreateMessage: date");
	if (msg.date == NULL)
		return freeMsg(&msg);
	/* E-Zeile festlegen */
	ConvertDate_MakeDate(msg.date, 20);
	/* Jetzt die Zeilen kopieren und merken, was ich habe */
	linesAvail = dateL;
	if (CopyLine(&msg.refId, RefId))
		linesAvail |= refIdL;
	if (CopyLine(&msg.Absender, From))
		linesAvail |= fromL;
	else if(CopyLine(&msg.Absender,userAddr))
		linesAvail |= fromL;
	if (CopyLine(&msg.ref, References))
		linesAvail |= refL;
	if (CopyLine(&msg.receiver, To))
		linesAvail |= receiverL;
	if (CopyLine(&msg.topic, Topic))
		linesAvail |= topicL;
	if (CopyLine(&msg.orgGroup, OrgGroup))
		linesAvail |= orgGroupL;
	if (CopyLine(&msg.group, Group))
		linesAvail |= groupL;
	if (CopyLine(&msg.rId, oldMId))
		linesAvail |= rIdL;
	if (CopyLine(&msg.realName, RealName))
		linesAvail |= rNameL;
	if (CopyLine(&msg.cc, Cc))
		linesAvail |= ccL;
		
	if (linesAvail & groupL)
	{
		if (GroupSelect_GetFollowUp(msg.group, followupTo))
			CopyLine(&msg.followupTo, followupTo);
	}
	
	/* Jetzt die anderen Infos erzeugen */
	msg.info.refNum = 0;
	msg.info.reserved1=0;
	if (!(linesAvail & refIdL))
	{
		switch (type)
		{
		case msg_persanswer:
		case msg_answer:
		case msg_pseudoKom:	/*DYJ 5.34d */
		case msg_forward:
			if(mtAlerts_AlertRSC(1, Al_NOANSW)==1)
				type=msg_private;
			else
				return freeMsg(&msg);
			break;
		case msg_groupcomment:
		case msg_copyOther:
		case msg_comment:
			if(mtAlerts_AlertRSC(1, Al_NOCOMM)==1)
				type=msg_mail;
			else
				return freeMsg(&msg);
			break;
		}
	}
	if((linesAvail & groupL)!=0 && Messages_GetGroupInf(cNewsDefReplyTo,msg.group, replyTo, sizeof(replyTo)))
		CopyLine(&msg.replyTo, replyTo);
	else
	{
		if(ConfVars_GetConfigString(cDefReplyTo, replyTo, sizeof(replyTo)))
			CopyLine(&msg.replyTo, replyTo);
	}
	switch (type)
	{
	case msg_persanswer:
	case msg_groupcomment:
	case msg_comment:
		if ((!(linesAvail & groupL) && type != msg_persanswer) ||
			(!(linesAvail & orgGroupL) && type != msg_comment))
		{
			return freeMsg(&msg);
		}
	case msg_answer:
	case msg_pseudoKom:	/*DYJ 5.34d */
		if ( !(linesAvail & topicL))
			return freeMsg(&msg);
	case msg_forward:
	case msg_copyOther:
/*DYJ 5.34d Start*/
		if ((type == msg_answer || type == msg_persanswer || type == msg_pseudoKom ||
/*DYJ  Ende; alt:	
		if ((type == msg_answer || type == msg_persanswer ||
*/
			 type == msg_forward || type == msg_copyOther) &&
			!(linesAvail & receiverL))
		{
			return freeMsg(&msg);
		}
		break;
		
	case msg_mail:		/* neue oeffentliche Nachricht */
		if (!(linesAvail & groupL) || !(linesAvail & topicL))
			return freeMsg(&msg);
		break;
	
	case msg_copyOwn:	/* Kopie einer neuen privaten Nachricht */
	case msg_private:	/* neue private Nachricht     */
	case msg_pseudoNews:		/*DYJ 5.34d */
		/* Abweichung: Im Stichwort wird der Kommentar fuer den Empfaenger festgehalten! */
		if (!(linesAvail & receiverL))
			return freeMsg(&msg);
/*DYJ 5.34d Start*/
		if ((type == msg_private||type == msg_pseudoNews) && !(linesAvail & topicL))
/*DYJ  Ende; alt:	
		if (type == msg_private && !(linesAvail & topicL))
*/
			return freeMsg(&msg);
		if (type == msg_copyOwn)
		{
			msg.info.refNum = copyTo;
			idx = Messages_FindMessage(copyTo);
			if (idx >= 0)
			{
				if(UserBLK.isInternet)
					msg.info.reserved1=mtAlerts_AlertRSC(1, AL_TO_CC_BCC);
				else if (msgArray[idx].info.copyCount >= 10)
				{
					MTE_infoRSC(MTE_maxCopyAlert);
					return freeMsg(&msg);
				}
				++msgArray[idx].info.copyCount;
				if (msg.refId != NULL)
					SFREE(msg.refId);
				if (!CopyLine(&msg.refId, RefId))
					return freeMsg(&msg);
			}
		}
		break;
	}
	/* Jetzt sind alle noetigen Headerzeilen festgesetzt,
	 * also jetzt die Headerdatei schreiben
	 */
	msg.info.number = FindNumber(minNum);
	if (msg.info.number == MSG_NONE)
	{
		MTE_infoRSC(AL_TOO_MUCH_MESSAGES);
		return freeMsg(&msg);
	}
	msg.info.msgType = type;
	msg.info.sendMsg = TRUE;
	/*
	 * geaendert, damit die Distribution erhalten bleibt,
	 * falls die kommentierte Nachricht in der Maus nicht
	 * mehr vorhanden ist; ausserdem sieht man dadurch auch
	 * schon im Editor, wie die Distribution gesetzt ist
	 */
	ConfVars_GetConfDefBool(cDontSetDistribution, &dontSetDist, FALSE);
	if (dontSetDist)
		msg.info.dist = distNone;
	else
		msg.info.dist = oldDist;
	msg.info.orgDist = oldDist;
	msg.info.copyCount = 0;
	msg.info.toDelete = FALSE;
	msg.info.noRefLine = FALSE;
	msg.info.size = 0;
	msg.new = TRUE;
	msg.selected = FALSE;
	msg.hdrRead = FALSE;
	msg.isSend = FALSE;
	T_SysToDostime(T_Systime(), &msg.info.cDate, &msg.info.cTime);
	/* Reserved-Felder Nullen */
	msg.info.reserved2 = 0;
	msgArray[messages-1] = msg;
	/* Jetzt ist wirklich alles fertig */
	Messages_WriteHdrInfo(&msg);
	if (type != msg_copyOwn && type != msg_copyOther && type != msg_forward && openEditor)
	{
		/* Jetzt Textfile erzeugen */
		Messages_Number2Name(msg.info.number, tmpName, sizeof(tmpName));
		strBcat(tmpName, textExt);
		strBcpy(txtName, MessagePath);
		F_Path_Append(txtName, tmpName);
		if (mtTextfiles_OpenTextfile(txtName, WRITE, 120, &txtHdl) == GERR_OK)
		{
			if (crossLine != NULL && crossLine[0] != '\0')
			{
				mtTextfiles_WriteLine(txtHdl, crossLine);
				mtTextfiles_WriteLn(txtHdl);
				mtTextfiles_WriteLn(txtHdl);
			}
			mtTextfiles_WriteLn(txtHdl);
			offset = mtTextfiles_Textpos(txtHdl);
			ConfVars_GetConfDefStr(cMausTauschGroupName, mataGroup, sizeof(mataGroup), "Maus.Tausch.CAT");
			if (type == msg_comment || type == msg_groupcomment || type == msg_mail)
			{
				if (msg.group != NULL && strCaseCmp(msg.group, mataGroup) == 0)
				{
					mtTextfiles_WriteLn(txtHdl);
					mtTextfiles_WriteLine(txtHdl, "-- ");
					mtTextfiles_WriteLn(txtHdl);
					mtTextfiles_WriteLine(txtHdl, CAT_PROGNAME " " CatVersion);
					if (ConfVars_GetConfigString(cMausTauschVersionName, mataGroup, sizeof(mataGroup)) &&
						mataGroup[0] != '\0')
					{
						mtTextfiles_WriteLine(txtHdl, " ");
						mtTextfiles_WriteLine(txtHdl, mataGroup);
					}
					mtTextfiles_WriteLine(txtHdl, " vom " CatDate);
					mtTextfiles_WriteLn(txtHdl);
				}
			}
			msg.info.size = mtTextfiles_Textpos(txtHdl);
			msgArray[messages-1] = msg;
			mtTextfiles_CloseTextfile(&txtHdl);
		} else
		{
			MTE_infoRSC(AL_CANT_CREATE_FILE);
			ClearNumber(msg.info.number);
			return freeMsg(&msg);
		}
		/* Jetzt existieren HDR und TXT, nur noch MessageInfo wegschreiben */
		Messages_WriteMessageInfo(TRUE);
		msg = msgArray[messages-1];
		Messages_OpenEditor(&msg, TRUE, -1, offset, MODE_RW);
	} else
	{
		Messages_WriteMessageInfo(TRUE);
	}
	return TRUE;
}

/*** ------------------------------------------------------------------------ ***/
/*	_VOID Messages_GetGroupInf(CONST _UBYTE *stamm,CONST _UBYTE *gruppe, _UBYTE *val, size_t valsize)	*/
/*	Liefert Konfigurationsvariablen des Typs stamm.Gruppe						*/
/*	Parameter:	keine															*/
/*	Ergebnis:	keines															*/		
/*	8.11.02 von Dimitri Junker	DYJ 5.16n										*/
/*** ------------------------------------------------------------------------ ***/
/*DYJ 5.20w */
GLOBAL _BOOL Messages_GetGroupInf(CONST _UBYTE *stamm,CONST _UBYTE *gruppe, _UBYTE *val, size_t valsize)
{
	_UBYTE varname[512],*ptr,*ptrLst;
	_BOOL first=TRUE,ret=TRUE;
	strMcpy(varname, sizeof(varname), stamm);
	ptrLst=strChr(varname,'\0');
	strMcpy(ptrLst, sizeof(varname), ".");
	strMcat(ptrLst, sizeof(varname), gruppe);
	*val='\0';
	while(!ConfVars_GetConfigString(varname, val, valsize))
	{
		if(first)
		{
			strMcat(varname, sizeof(varname), "*");
			first=FALSE;
		}
		else
		{
			ptr=strrChr(varname,'.');
			if(ptr==ptrLst)
				*ptr='\0';
			else if(ptr)
				strCpy(ptr,"*");
			else
			{
				ret=FALSE;
				break;
			}
		}
	}
	return ret;
}
/*** ---------------------------------------------------------------------- ***/

/* Eine neue Message anlegen und danach editieren */
/*DYJ 5.16n */	/*DYJ 5.19g */
GLOBAL _VOID Messages_NewMessage(CONST _UBYTE *Gruppe, CONST _UBYTE *Wegen)
{
	MESSNR messIdx;
	_UBYTE absender[256]="";
/*DYJ 5.34d Start*/
	CAT_GROUP_NUMBER z;
	group_line followupTo;
	if (GroupSelect_GroupNumber(Gruppe, &z)&&GroupSelect_isPseudoOM(z))
	{
		if((GroupSelect_GetFollowUp(Gruppe,followupTo)||grintool_getMlServ(z,Gruppe,followupTo))&&
			strChr(followupTo,'@'))
			Messages_CreateMessage(1,"", followupTo, "", "", "", Wegen, "", "", msg_pseudoNews, 0, "", "", distNone, TRUE, &messIdx,"");
	}
	else
	{
		Messages_GetGroupInf(cNewsDefAddr,Gruppe, absender, sizeof(absender));
		Messages_CreateMessage(1,absender, "", "", Gruppe, "", Wegen, "", "", msg_mail, 0, "", "", distNone, TRUE, &messIdx,"");
	}
/*DYJ  Ende; alt:	
	Messages_GetGroupInf(cNewsDefAddr,Gruppe, absender, sizeof(absender));
	
	Messages_CreateMessage(1,absender, "", "", Gruppe, "", Wegen, "", "", msg_mail, 0, "", "", distNone, TRUE, &messIdx,"");
*/
}

/*** ---------------------------------------------------------------------- ***/

/* Einen Kommentar zu einer Gruppennachricht in
 * eine andere Gruppe schicken.
 */
/*DYJ 5.16n */	/*DYJ 5.19g */
GLOBAL _VOID Messages_NewKomMessage(CONST _UBYTE *fromGroup, CONST _UBYTE *Group,
	CONST _UBYTE *Wegen, CONST _UBYTE *RefId, CONST _UBYTE *txt,
	CONST _UBYTE *mId, CONST _UBYTE *To, CONST _UBYTE *RealName, CONST _UBYTE *References)
{
	MESSNR messIdx;
	_UBYTE absender[256]="";
	Messages_GetGroupInf(cNewsDefAddr,Group, absender, sizeof(absender));
	
	Messages_CreateMessage(1,absender, To, fromGroup, Group, RefId, Wegen, RealName, "", msg_groupcomment, 0, txt, mId, distNone, TRUE, &messIdx,References);
}

/*** ---------------------------------------------------------------------- ***/

/* Einen Kommentar zu einer Gruppennachricht an jemand
 * persoenlich schicken.
 */
/*DYJ 5.19g */
GLOBAL _VOID Messages_NewAnsMessage(CONST _UBYTE *an, CONST _UBYTE *realName,
	CONST _UBYTE *fromGroup, CONST _UBYTE *Wegen, CONST _UBYTE *RefId, CONST _UBYTE *txt, CONST _UBYTE *mId)
{
	MESSNR messIdx;
	Messages_CreateMessage(1,"", an, fromGroup, "", RefId, Wegen, realName, "", msg_persanswer, 0, txt, mId, distNone, TRUE, &messIdx,"");
}

/*** ---------------------------------------------------------------------- ***/

/* Eine neue persoenliche Nachricht an jemand schicken
 */
/*DYJ 5.19g */
GLOBAL _VOID Messages_NewPersMsg(CONST _UBYTE *Empfaenger, CONST _UBYTE *RealName, CONST _UBYTE *Wegen)
{
	MESSNR messIdx;
	Messages_CreateMessage(1,"", Empfaenger, "", "", "", Wegen, RealName, "", msg_private, 0, "", "", distNone, TRUE, &messIdx,"");
}

/*** ---------------------------------------------------------------------- ***/

#define cRegReceiver "Dirk Steins @ K2"
#define cRegRealName "Dirk Steins"
#define cRegTopic    "Registrierung CAT 3.0x"

GLOBAL _VOID Messages_UpdateFileSize(_WORD number)
{
	_WORD idx;
	msgInfo msg;
	_UBYTE txtName[PATH_MAX];
	_UWORD dummy;
	
	idx = Messages_FindMessage(number);
	if (idx >= 0)
	{
		msg = msgArray[idx];
		Messages_Number2Name(msg.info.number, txtName, sizeof(txtName));
		strBcat(txtName, textExt),
		msg.info.size = Messages_FileSize(MessagePath, txtName, &dummy, &dummy);
		msg.new = FALSE;
		msgArray[idx] = msg;
		Messages_WriteMessageInfo(FALSE);
	}
}

/*** ---------------------------------------------------------------------- ***/

/* Einen Kommentar erzeugen
 */
/*DYJ 5.16n */	/*DYJ 5.19g */
GLOBAL _VOID Messages_NewKom(CONST _UBYTE *Nr, CONST _UBYTE *Wegen, CONST _UBYTE *gruppe, _UBYTE *mId,
	CONST _UBYTE *To, CONST _UBYTE *RealName, tDistribution oldDist, CONST _UBYTE *References)
{
	MESSNR messIdx;
	_UBYTE absender[256]="";
	Messages_GetGroupInf(cNewsDefAddr,gruppe, absender, sizeof(absender));
	Messages_CreateMessage(1,absender, To, gruppe, gruppe, Nr, Wegen, RealName, "",msg_comment, 0, "", mId, oldDist, TRUE, &messIdx,References);

	
}
/*** ---------------------------------------------------------------------- ***/

/*** ------------------------------------------------------------------------ ***/
/*	_VOID Messages_NewPseudoKom(CONST _UBYTE *Nr, CONST _UBYTE *Absender, CONST _UBYTE *Wegen, CONST _UBYTE *gruppe, CONST _UBYTE *an, CONST _UBYTE *mId, CONST _UBYTE *RealName)	*/
/*	Einen Kommentar auf PseudoNews erzeugen 									*/
/*	Parameter:	viele															*/
/*	Ergebnis:	keines															*/		
/*	4.3.04 von Dimitri Junker	DYJ 5.34d										*/
/*** ------------------------------------------------------------------------ ***/
GLOBAL _VOID Messages_NewPseudoKom(CONST _UBYTE *Nr, CONST _UBYTE *Absender, CONST _UBYTE *Wegen, CONST _UBYTE *gruppe, CONST _UBYTE *an, CONST _UBYTE *mId, CONST _UBYTE *RealName)
{
	MESSNR messIdx;
	Messages_CreateMessage(1,Absender, an, gruppe, "", Nr, Wegen, RealName, "", msg_pseudoKom, 0, "", mId, distNone, TRUE, &messIdx,"");
}

/*** ---------------------------------------------------------------------- ***/

/* Eine Antwort erzeugen
 */
/*DYJ 5.16q */	/*DYJ 5.19g */
GLOBAL _VOID Messages_NewAnswer(CONST _UBYTE *Nr, CONST _UBYTE *Absender, CONST _UBYTE *Wegen, CONST _UBYTE *gruppe, CONST _UBYTE *an, CONST _UBYTE *mId, CONST _UBYTE *RealName,CONST _UBYTE *Cc)
{
	MESSNR messIdx;
	Messages_CreateMessage(1,Absender, an, gruppe, "", Nr, Wegen, RealName, Cc, msg_answer, 0, "", mId, distNone, TRUE, &messIdx,"");
}

/*** ---------------------------------------------------------------------- ***/

/*DYJ 5.19g */
GLOBAL _VOID Messages_CopyOrForwardMessage(CONST _UBYTE *Nr, CONST _UBYTE *To, CONST _UBYTE *RealName, CONST _UBYTE *comment, _BOOL copy)
{
	MESSNR messIdx;
	Messages_CreateMessage(1,"", To, "", "", Nr, comment, RealName, "", copy ? msg_copyOther : msg_forward, 0, "", "", distNone, FALSE, &messIdx,"");
}

/*** ---------------------------------------------------------------------- ***/

/*DYJ 5.19g */
GLOBAL _VOID Messages_CopyOwnMessage(CONST _UBYTE *mailId, CONST _UBYTE *Absender, CONST _UBYTE *To, CONST _UBYTE *RealName, CONST _UBYTE *Comment, _WORD minNum)
{
	MESSNR number;
	MESSNR messIdx;
	
	/* Nachsehen, ob die ersten drei Zeichen
	 * gleich msgFileName sind
	 */
	if (mailId[0] == (_UBYTE)msgFileName[0] &&
		mailId[1] == (_UBYTE)msgFileName[1] &&
		mailId[2] == (_UBYTE)msgFileName[2])
	{
		/* Ok, ist wirklich eine Message */
		number = StrToInt(mailId + 3, NULL, NULL);
	
		Messages_CreateMessage(minNum, Absender, To, "", "", mailId, Comment, RealName, "", msg_copyOwn, number, "", "", distNone, FALSE, &messIdx,"");
	} else
	{
		/* ?????? */
	}
}

/*** ---------------------------------------------------------------------- ***/

/* Wenn die Nachricht ein Kommentar oder eine Antwort ist,
 * dann wird daraus eine entsprechende Nachricht mit Wildwestverkettung
 * erzeugt, damit die Maus die beim naechsten Mal annimmt.
 */
GLOBAL _BOOL Messages_ChangeMessage(CONST _UBYTE *internalId)
{
	_WORD messIdx;
	msgInfo mess;

	if (isMessage(internalId))
	{
		messIdx = GetMessIdx(internalId);
		if (messIdx < 0)
			return FALSE;
		mess = msgArray[messIdx];
		if (mess.info.noRefLine)
			return FALSE;
		mess.info.noRefLine = TRUE;
		if (mess.info.dist == distNone && mess.info.orgDist != distNet)
		{
			/* Nur in dem Fall alte Distribution uebernehmen */
			mess.info.dist = mess.info.orgDist;
		}
		msgArray[messIdx] = mess;
		Messages_WriteMessageInfo(FALSE);
		return TRUE;
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

/* Wenn die Nachricht ein Kommentar auf eine eigene Nachricht ist,
 * dann wird daraus eine entsprechende Nachricht als GK
 * erzeugt, damit die Maus die beim naechsten Mal annimmt.
 */
/*DYJ 5.21b */
GLOBAL _BOOL Messages_MakeGroupcom(CONST _UBYTE *internalId)
{
	_WORD messIdx;
	msgInfo mess;
	_UBYTE msgName[PATH_MAX];
	_UBYTE orgName[PATH_MAX];
	_UBYTE tmpName[PATH_MAX];
	TEXTFILENO txt;
	TEXTFILENO tmp;
	_UBYTE scrap[4096];
	_UBYTE *savePos, saveChar;
	_UBYTE *id;
	_BOOL exists;
	
	if (isMessage(internalId))
	{
		messIdx = GetMessIdx(internalId);
		if (messIdx < 0)
			return FALSE;
		mess = msgArray[messIdx];
		if (mess.info.msgType == msg_answer ||
			mess.info.msgType == msg_pseudoKom ||		/*DYJ 5.34d */
			mess.info.msgType == msg_pseudoNews ||		/*DYJ 5.34d */
			mess.info.msgType == msg_private ||
			mess.info.msgType == msg_persanswer)
		{
			if (!Messages_ReadHdrInfo(&mess, FALSE))
				return FALSE;
			if (mess.refId == NULL || *mess.refId == '\0')
			{
				FreeMsgStrings(&mess);
				return FALSE;
			}
			if (mess.info.dist == distNone && mess.info.orgDist != distNet)
			{
				/* Nur in dem Fall alte Distribution uebernehmen */
				mess.info.dist = mess.info.orgDist;
			}
			Messages_Number2Name(mess.info.number, msgName, sizeof(msgName));
			strBcat(msgName, textExt);
			strBcpy(orgName, MessagePath);
			F_Path_Append(orgName, msgName);
			if (mtTextfiles_OpenTextfile(orgName, READ, 0, &txt) != GERR_OK)
			{
				FreeMsgStrings(&mess);
				return FALSE;
			}
			mtTextfiles_ReadLine(txt, scrap, sizeof(scrap));
			mtTextfiles_ReadLn(txt);
			if (GroupComment_PrepareID(scrap, &id, &saveChar, &savePos))
			{
				/* Dann ist sie wohl schon mal behandelt worden */
				mtTextfiles_CloseTextfile(&txt);
				FreeMsgStrings(&mess);
				return FALSE;
			}
			Messages_Number2Name(mess.info.number, msgName, sizeof(msgName));
			strBcat(msgName, ".$$$");
			strBcpy(tmpName, MessagePath);
			F_Path_Append(tmpName, msgName);
			if (mtTextfiles_OpenTextfile(tmpName, WRITE, 0, &tmp) != GERR_OK)
			{
				mtTextfiles_CloseTextfile(&txt);
				FreeMsgStrings(&mess);
				return FALSE;
			}
/* :language: */
			mtTextfiles_WriteLine(tmp, "Kommentar zu ");
			mtTextfiles_WriteLine(tmp, mess.refId);
			mtTextfiles_WriteLine(tmp, " in der Gruppe ");
			if (mess.orgGroup != NULL && *mess.orgGroup != '\0')
				mtTextfiles_WriteLine(tmp, mess.orgGroup);
			else
				mtTextfiles_WriteLine(tmp, Rsc_WrkString(GRP_PRIVATE));
			mtTextfiles_WriteLn(tmp);
			mtTextfiles_WriteLn(tmp);
			do
			{
				mtTextfiles_WriteLine(tmp, scrap);
				mtTextfiles_WriteLn(tmp);
				mtTextfiles_ReadLine(txt, scrap, sizeof(scrap));
				mtTextfiles_ReadLn(txt);
			} while (!mtTextfiles_EndofText(txt));
			mtTextfiles_CloseTextfile(&txt);
			mtTextfiles_CloseTextfile(&tmp);
			
			F_File_Delete(orgName);
			if (F_Path_Rename(tmpName, orgName) != GERR_OK)
			{
				FreeMsgStrings(&mess);
				return FALSE;
			}
			
			mess.info.size = CatFiles_FileSize(orgName, &exists);
			msgArray[messIdx] = mess;
			Messages_WriteMessageInfo(FALSE);
			return TRUE;
		}
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

/*DYJ 5.19i */	/*DYJ 5.21b */
GLOBAL _VOID Messages_deleteMessage(CONST _UBYTE *internalId, _BOOL killEdit, _BOOL changeState)
{
	_WORD messIdx;
	_UBYTE msgName[PATH_MAX];
	_WORD j;
	MESSNR messNum;
	MESSNR parentNum, parentIdx;
	_BOOL deleteParent;
	boxHandler bx;
	_UBYTE nummer[10],*ext;
	/* Nachsehen, ob die ersten drei Zeichen
	 * gleich msgFileName sind
	 */
	if (isMessage(internalId))
	{
		StoreMouse();
		CatGlobal_busyMouse();
		/* Ok, ist wirklich eine Message */
		deleteParent = FALSE;
		parentNum = 0;
		messIdx = GetMessIdx(internalId);
		if (messIdx < 0)
			return;
		if (killEdit)
		{
			messNum = msgArray[messIdx].info.number;
			/* Nachsehen, ob zu der Nachricht ein Editor offen ist
			 * Wenn ja, nochmal nachfragen
			 */
			bx = boxList;
			while (bx != NULL)
			{
				if (bx->number == messNum)
				{
					if (mtAlerts_AlertRSC(1, AL_DEL_EDIT) == 2)
					{
						RestoreMouse();
						return;
					}
				}
				bx = bx->next;
			}
		}
		if (msgArray[messIdx].info.copyCount > 0)
		{
			for (j = 0; j < messages; j++)
			{
				if (msgArray[j].info.msgType == msg_copyOwn &&
					msgArray[j].info.refNum == msgArray[messIdx].info.number &&
					msgArray[j].info.reserved1)
					{
						Messages_Number2Name(msgArray[j].info.number, msgName, sizeof(msgName));
						Messages_deleteMessage(msgName, TRUE, changeState);
					}
			}
		}
		msgArray[messIdx].info.toDelete = TRUE;
		if (msgArray[messIdx].info.copyCount > 0)
		{
			Messages_WriteMessageInfo(TRUE);
			RestoreMouse();
			return;
		}
		FreeMsgStrings(&msgArray[messIdx]);
		msgArray[messIdx].hdrRead = FALSE;
		if (msgArray[messIdx].info.msgType == msg_copyOwn)
		{
			parentIdx = Messages_FindMessage(msgArray[messIdx].info.refNum);
			if (parentIdx >= 0)
			{
				deleteParent = msgArray[parentIdx].info.toDelete;
				--msgArray[parentIdx].info.copyCount;
				parentNum = msgArray[messIdx].info.refNum;
			}
		}
/*DYJ 5.34d Start*/
		if ((msgArray[messIdx].info.msgType == msg_answer||
			 msgArray[messIdx].info.msgType == msg_pseudoKom) && changeState)
/*DYJ  Ende; alt:	
		if (msgArray[messIdx].info.msgType == msg_answer && changeState)
*/
		{
			/* Beantwortete Nachricht zurueckstellen, falls nicht
			 * schon eine Antwort vorhanden ist
			 */
			Messages_ReadHdrInfo(&msgArray[messIdx], FALSE);
			grin_grinResetState(msgArray[messIdx].refId);
			FreeMsgStrings(&msgArray[messIdx]);
		}
		/* Nachricht aus msgArray loeschen durch runterkopieren
		 * der anderen Nachrichten
		 */
		messNum = msgArray[messIdx].info.number;
		/* Filenamen basteln */
		Messages_Number2Name(messNum, msgName, sizeof(msgName));
		ext=strChr(msgName,'\0');
		Messages_ReadHdrInfo(&msgArray[messIdx], FALSE);
		if(msgArray[messIdx].attachment)
		{
			for(j=0;j<msgArray[messIdx].attachment[2]-'0';j++)
			{
				sprintf(nummer,"_A.%03d",j);
				strBcat(msgName, nummer);
				CatFiles_DeleteFile(MessagePath, msgName);
				*ext='\0';
			}
		}
		FreeMsgStrings(&msgArray[messIdx]);		/*DYJ 5.19n */
		--messages;
		for (j = messIdx; j < messages; j++)
			msgArray[j] = msgArray[j+1];
/*		steht schon da */
		strBcat(msgName, textExt);
		CatFiles_DeleteFile(MessagePath, msgName);
		CatGlobal_busyMouse();
		*ext='\0';
		strBcat(msgName, headerExt);
		CatFiles_DeleteFile(MessagePath, msgName);
		CatGlobal_busyMouse();
		ClearNumber(messNum);
		Messages_WriteMessageInfo(TRUE);
		if (deleteParent)
		{
			Messages_Number2Name(parentNum, msgName, sizeof(msgName));
			Messages_deleteMessage(msgName, TRUE, changeState);
		}
		if (killEdit)
		{
			/* Nachsehen, ob zu der Nachricht ein Editor offen ist
			 * Wenn ja, dann Fenster ohne Rueckfrage schliessen!
			 */
			bx = boxList;
			while (bx != NULL)
			{
				if (bx->number == messNum)
				{
					/* Force auf TRUE sorgt dafuer, das keine Nachfrage kommt */
					Editor_CloseEditor(bx->wdw, TRUE);
					bx = boxList;
				} else
				{
					bx = bx->next;
				}
			}
		}
		RestoreMouse();
	}
}

/*** ---------------------------------------------------------------------- ***/

/* Die hier wird nur von externen Modulen aufgerufen, d.h.
 * vom Parser nach dem Einfuegen.
 * Und dann muss ich den Status nicht zuruecksetzen,
 * falls es eine Antwort ist.
 */

GLOBAL _VOID Messages_DeleteMessage(CONST _UBYTE *internalId)
{
	Messages_deleteMessage(internalId, TRUE, FALSE);
}

/*** ---------------------------------------------------------------------- ***/

/* Gibt zurueck, ob die Nachricht Kopien hat oder nicht.
 * Wenn es keine private Nachricht ist, dann wird immer FALSE
 * zurueckgegeben
 */
GLOBAL _BOOL Messages_MsgHasCopys(CONST _UBYTE *internalId)
{
	if (isMessage(internalId) && GetMessIdx(internalId) >= 0)
		return msgArray[GetMessIdx(internalId)].info.copyCount > 0;
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

/* Gibt zurueck, ob die Message eine private oder eine
 * oeffentliche Nachricht ist. Der Parser muss das beim Abarbeiten
 * des Logfiles wissen, um evtl. private Nachrichten noch
 * einfuegen zu koennen.
 */
GLOBAL _BOOL Messages_IsPrivateMessage(_UBYTE *internalId, size_t strsize)
{
	_WORD messIdx;
	_UBYTE msgName[PATH_MAX];
	_WORD i;
	msgInfo msg;
	_BOOL checkCopys;

	checkCopys = TRUE;
	if (isMessage(internalId) && (messIdx = GetMessIdx(internalId)) >= 0)
	{
		if (!msgArray[messIdx].info.toDelete)
		{
			return msgArray[messIdx].info.msgType == msg_answer ||
				msgArray[messIdx].info.msgType == msg_private ||
				msgArray[messIdx].info.msgType == msg_persanswer;
		} else
		{
			checkCopys = TRUE;
		}
	}
	if (checkCopys)
	{
		/* Tscha, jetzt muss ich checken, ob das eine RefId ist */
		for (i = 0; i < messages; i++)
		{
			msg = msgArray[i];
			if (msg.info.msgType == msg_copyOther ||
				msg.info.msgType == msg_forward ||
				msg.info.msgType == msg_copyOwn)
			{
				if (!Messages_ReadHdrInfo(&msg, TRUE))
					return FALSE;
				if (msg.refId != NULL && strCmp(msg.refId, internalId) == 0)
				{
					/* Direkt mal loeschen!! */
					/* Spaeter mal aendern! */
					Messages_Number2Name(msg.info.number, msgName, sizeof(msgName));
					strMcpy(internalId, strsize, msgName);
					return msg.info.msgType == msg_copyOwn;
				}
			}
		}
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

/* Gibt an den Parser die noetigen Informationen zurueck,
 * um eine persoenliche Nachricht einzufuegen
 */


GLOBAL _BOOL Messages_GetHdrInfos(CONST _UBYTE *internalId,msgInfo *msg)
{
	_WORD messIdx;
	MemSetZeroStruct(*msg);
	if (isMessage(internalId))
	{
		messIdx = GetMessIdx(internalId);
		*msg = msgArray[messIdx];
		if (Messages_ReadHdrInfo(msg, TRUE))
		{
			if (msg->info.msgType == msg_copyOwn)
			{
				if (msg->refId != NULL)
				{
					messIdx = GetMessIdx(msg->refId);
					if (messIdx >= 0)
					{
						*msg = msgArray[messIdx];
						Messages_ReadHdrInfo(msg, TRUE);
					}
				}
			}
		}
		return TRUE;
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

/* Gibt an den Parser den Dateinamen zurueck,
 * unter dem die Nachricht gespeichert wurde,
 * ohne Extension
 */
GLOBAL _VOID Messages_GetMsgFileName(_UBYTE *name, size_t namesize)
{
	_WORD messIdx;

	if (isMessage(name))
	{
		messIdx = GetMessIdx(name);
		Messages_Number2Name(msgArray[messIdx].info.number, name, namesize);
	}
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

LOCAL _VOID LineOut(TEXTFILENO file, CONST _UBYTE *ch, CONST _UBYTE *str)
{
	if (ch != NULL && ch[0] != '\0')
		mtTextfiles_WriteLine(file, ch);
	if (str != NULL)
		mtTextfiles_WriteLine(file, str);
	mtTextfiles_WriteLn(file);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID Messages_SendState(CONST _UBYTE *Nr, _UBYTE NewState)
{
	TEXTFILENO stateHdl;
	_UBYTE stateName[PATH_MAX];
	_UBYTE state[2];
	
	if(!Nr)
		return;

	strBcpy(stateName, MessagePath);
	F_Path_Append(stateName, statusInf);
	if (mtTextfiles_OpenTextfile(stateName, APPEND, 512, &stateHdl) == GERR_OK ||
		mtTextfiles_OpenTextfile(stateName, WRITE, 512, &stateHdl) == GERR_OK)
	{
		LineOut(stateHdl, "#", Nr);
		state[0] = NewState;
		state[1] = '\0';
		LineOut(stateHdl, "B", state);
		mtTextfiles_CloseTextfile(&stateHdl);
		Protokoll_SendPathUpdate(MessagePath);
	} else
	{
		/* ???? */
	}
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

LOCAL _BOOL msgComp(CONST _VOID *e1, CONST _VOID *e2, _VOID *private)
{
	CONST msgInfo *p1;
	CONST msgInfo *p2;
	
	UNUSED(private);
	p1 = (CONST msgInfo *)e1;
	p2 = (CONST msgInfo *)e2;
	return p1->info.number < p2->info.number;
}

/*** ---------------------------------------------------------------------- ***/

/* sortiert das Message-Array*/
GLOBAL _VOID Messages_SortMessages(_VOID)
{
	if (messages > 1)
	{
		QuickSort_sortIt(0, messages-1, msgArray, msgComp, sizeof(msgInfo), QuickSort_noBreak, NULL);
		/* Liste wieder zurueckuebernehmen */
		MsgWindow_MsgSetList(msgArray, TRUE);
		Messages_WriteMessageInfo(TRUE);
	}
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID Messages_UpdateEditors(CONST msgInfo *msg)
{
	boxHandler bx;

	for (bx = boxList; bx != NULL; bx = bx->next)
	{
		if (bx->number == msg->info.number)
		{
			UpdateBoxInfo(bx, msg);
			WdwManager_RedrawWdw(bx->wdw, &bx->r);
		}
	}
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

/* Ein paar Auskunftsfunktionen */

/* Liefert zurueck, ob gerade ein Message-Editor das Topwindow ist,
 * also ein Editor, der diesem Modul bekannt ist
 */
GLOBAL _BOOL Messages_MsgEditorTop(HWND wdw)
{
	return FindHandler(wdw) != NULL;
}

/*** ---------------------------------------------------------------------- ***/

/* Gibt die gewuenschten Infos zu dem Message-Editor wdw. Wenn die Information
 * nicht vorhanden ist, dann wird ein leerer String geliefert
 */
GLOBAL _VOID Messages_MsgEditGetInfos(HWND wdw, msgInfoType info, _UBYTE *str, size_t strsize)
{
	boxHandler bx;
	_UBYTE *ptr;
	_WORD idx;
	
	*str = '\0';
	bx = FindHandler(wdw);
	if (bx != NULL)
	{
		idx = Messages_FindMessage(bx->number);
		if (idx >= 0)
		{
			if (Messages_ReadHdrInfo(&msgArray[idx], FALSE))
			{
				switch (info)
				{
					case itReceiver: ptr = msgArray[idx].receiver; break;
					case itOrgGroup: ptr = msgArray[idx].orgGroup; break;
					case itGroup: ptr = msgArray[idx].group; break;
					case itRid: ptr = msgArray[idx].refId; break;
					case itTopic: ptr = msgArray[idx].topic; break;
					case itMid: ptr = msgArray[idx].rId; break;
					case itRName: ptr = msgArray[idx].realName; break;
					case itReplyTo: ptr = msgArray[idx].replyTo; break;
					case itSender: ptr = msgArray[idx].sender; break;
					case itFollowup: ptr = msgArray[idx].followupTo; break;
					case itAttachment: ptr = msgArray[idx].attachment; break;
					case itFrom: ptr = msgArray[idx].Absender; break;
					case itRef: ptr = msgArray[idx].ref; break;
					case itCc: ptr = msgArray[idx].cc; break;
					case itBcc: ptr = msgArray[idx].bcc; break;
					case itEZeitX: ptr = msgArray[idx].eZeitX; break;
/*
					case itRetPath: ptr = msgArray[idx].retPath; break;
					case itKeyw: ptr = msgArray[idx].keyw; break;
					case itResent: ptr = msgArray[idx].resent; break;
					case itTrace: ptr = msgArray[idx].trace; break;
					case itReceived: ptr = msgArray[idx].received; break;
					case itPath: ptr = msgArray[idx].path; break;
					case itMailer: ptr = msgArray[idx].mailer; break;
					case itOrg: ptr = msgArray[idx].org; break;
*/
					default: ptr = NULL; break;
				}
				if (ptr != NULL)
					strMcpy(str, strsize, ptr);
			}
		}
	}
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _BOOL Messages_MsgIsPrivate(HWND wdw)
{
	boxHandler bx;
	_WORD idx;

	bx = FindHandler(wdw);
	if (bx != NULL)
	{
		idx = Messages_FindMessage(bx->number);
		if (idx >= 0)
		{
			if (!Messages_ReadHdrInfo(&msgArray[idx], FALSE))
				return FALSE;
/*DYJ 5.34d Start*/
			if (msgArray[idx].info.msgType == msg_private||msgArray[idx].info.msgType == msg_pseudoNews)
/*DYJ  Ende; alt:	
			if (msgArray[idx].info.msgType == msg_private)
*/
				return TRUE;
		}
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

/*DYJ 5.00b */
LOCAL _VOID Long2DateStr(CATDATE date,_UBYTE *zeitX, _UBYTE *str, size_t strsize)
{
	F_TIME t;
	DateType datestr;
	
	ConvertDate_CatDate2Datim(date,zeitX, &t);
	T_Strftime(datestr, sizeof(datestr), "%101a, %d.%m.%y %H:%M", &t);
	strMcpy(str, strsize, datestr);
}

/*** ---------------------------------------------------------------------- ***/

/*DYJ 5.00b */	/*DYJ 5.23k */
/*DYJ 5.30l Start*/
GLOBAL _VOID Messages_Infoline(HWND wdw, CONST _UBYTE *infoline, CONST _UBYTE *infolineM)
/*DYJ  Ende; alt:	
GLOBAL _VOID Messages_Infoline(HWND wdw, CONST _UBYTE *infoline)
*/
{
	boxHandler bx;
	_WORD idx;
	MessageType mess;
	MemSetZeroStruct(mess);
	
	bx = FindHandler(wdw);
	if (bx != NULL)
	{
		idx = Messages_FindMessage(bx->number);
		if (idx >= 0)
		{
			if (!Messages_ReadHdrInfo(&msgArray[idx], FALSE))
				return;
/*DYJ 5.34d Start*/
			if (msgArray[idx].info.msgType == msg_private||msgArray[idx].info.msgType == msg_pseudoNews)
/*DYJ  Ende; alt:	
			if (msgArray[idx].info.msgType == msg_private)
*/
			{
				MemSetZeroStruct(mess);
				mess.tauschDate = data_mDateStr2Long(msgArray[idx].date, 0);
				Long2DateStr(MessDate(mess), mess.Datum, sizeof(mess.Datum));
				mess.statusDate = mess.tauschDate;
				Long2DateStr(mess.statusDate,NULL, mess.StatusDatum, sizeof(mess.StatusDatum));
				mess.Gruppe = dataSys_private;
				mess.Absender = msgArray[idx].receiver;
/*DYJ 5.30l Start*/
				grin_Infoline(wdw, &mess, infoline,infolineM);
/*DYJ  Ende; alt:	
				grin_Infoline(wdw, &mess, infoline);
*/
			}
		}
	}
}

/*** ---------------------------------------------------------------------- ***/

/* Sichert die Positionen der Editoren
 * Gibt die Anzahl der gesicherten Positionen zurueck
 */
GLOBAL _VOID Messages_SaveEditPos(MESSNR *max)
{
	boxHandler bx;
	_UBYTE varName[128];
	MESSNR num;
	
	*max = -1;
	for (bx = boxList; bx != NULL; bx = bx->next)
	{
		make_varname(varName, sizeof(varName), cMsgSelectEdit, bx->number);
		num = Editor_GetEditNumber(bx->wdw);
		if (bx->number > *max)
			*max = bx->number;
		ConfVars_SetConfigInt(varName, num);
		Editor_EditSaveWdwPos(bx->wdw);
	}
}

/*** ---------------------------------------------------------------------- ***/

/* Schliesst alle Nachrichteneditoren
 */
GLOBAL _BOOL Messages_CloseAllEditors(_BOOL force)
{
	boxHandler bx;
	
	do
	{
		bx = boxList;
		if (bx != NULL)
			if (!Editor_CloseEditor(bx->wdw, force))
				return FALSE;
	} while (bx != NULL);
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID Messages_ReloadEditors(_VOID)
{
	boxHandler bx;

	for (bx = boxList; bx != NULL; bx = bx->next)
		Editor_EditReloadText(bx->wdw);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID Messages_MsgAskForSave(_VOID)
{
	boxHandler bx;

	for (bx = boxList; bx != NULL; bx = bx->next)
		Editor_AskForSave(bx->wdw, FALSE);
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

/* MsgArray allozieren und msgFile einlesen */
GLOBAL _VOID Messages_InitMessages(_VOID)
{
	Messages_ReReadMessageInfo();
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID Messages_ExitMessages(_VOID)
{
	DeleteMsgArray();
}
