/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 *
 * 6.11.02 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.16j'
 *	Bei in-reply-to und references fehlten die <>
 *
 * 8.11.02 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.16k'
 *	Cat teilt In2Cat jetzt mit wieviele PMs und Ms zu senden sind.
 *
 * 13.11.02 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.17a'
 *	bei News trgt sich Cat jetzt als X-Newsreader ein statt als X-Mailer
 *
 * 15.11.02 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.17b'
 *	Cat meldete In2Cat als Gesammtzahl der zu versendenden Mails/News auch
 *	die, die zurckgestellt sind.
 *
 * 24.11.02 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.17l'
 *	nderung 5.16j war wohl etwas zu voreilig. Die <> fehlen nur
 *	manchmal
 *
 * 30.11.02 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.19f'
 *	Bei der Ausgabe langer Zeilen ins Internet-Infile gab es einen
 *	Fehler mit dem Folding.
 *
 * 1.2.03 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.20m'
 *	Man kann jetzt zustzliche Headerzeilen und/oder Textzeilen an
 *	(alle Mail, nur PMs oder nur Ms) anhngen lassen
 *
 * 10.2.03 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.20x'
 *	Bei Followup-To fehlte der Doppelpunkt
 *
 * 18.2.03 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.21f'
 *	Bei den neuen MSG Dateien zum Anhngen von zustzlichen
 *	Header oder Textzeilen wurden Leerzeilen ignoriert.
 *
 * 21.2.03 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.21g'
 *	Aus irgendwelchen Grnden kam es vor, da Cat bei Mails die
 *	Adresse als Realname speicherte. Antwortete man auf so eine
 *	Mail, erhielt die eine TO: Zeile der Art: To:abc@def <abc@def>
 *	leider ist dies nicht zulssig.
 *
 * 26.7.03 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.29c'
 *	berlange Header-Zeilen msen bei SMTP per Folding in mehrere Zeilen
 *	aufgeteilt werden. Dies scheint aber nicht fr die Envelope Zeilen zu gelten.
 * Also habe ich es da wieder rausgeschmissen.
 *
 * 21.3.04 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.34m'
 *	Cat whlt jetzt je nach Versandart (Maus/Internet) einen der 
 *	folgenden Zeichenstze: Atari, ISO-8859-1, ISO-8859-15 oder UTF-8
 *	aus.
 *
 * 28.3.04 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.35a'
 *	Hat eine Maus-Mail eine M-Zeile, so mu danach eine :- Zeile
 *	folgen.
 *
 * 14.4.04 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.36a' 
 *	Beim Versand von Mails an Umlautdomains (IDN) wird die Adresse im
 *	Envelope nach Punycode kodiert. Ob das reicht und was mit den Adressen im
 *	Header passiert ist noch unklar. Dies ist also 
 *
 * 23.9.04 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.39a'
 *	ZS_ATARI!=ATARI Da hatte ich 2 Konstanten verwechselt.
 *	Dadurch teilweise Versand im falschen Format.
 *
 * 29.11.04 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.39e'
 *	wie erwartet reichte 5.36a nicht. Da der Rest der Welt aber
 *	langsamer war konnte ich es erst jetzt testen ;-).
 *	Ich habe also jetzt die Wandlung auch fr den Header eingebaut.
 */
 


#include <msginfil.h>
#include <catvers.h>
#include <parser.h>
#include <time.h>
#include <mime.h>
#include <adr.h>
#include <mtrsc.h>
#include <stringp.h>		/*DYJ 5.36a */
#include <punycode.h>		/*DYJ 5.36a */

/*==============================================================*
 * Modul:               CAT-Infilehandler, dritte Version       *
 * Autor:               Dirk Steins                             *
 * erstellt am:         29.10.1992                              *
 * letzte Aenderung am: 26.12.1992                              *
 * Version:             0.7                                     *
 * Interne Version:     V#0007                                  *
 *==============================================================*

  Dieses Modul erstellt neue Nachrichten, managt diese und verwaltet die neuen
  Nummern und erstellt auch das Infile.
  Es wird fuer jede Nachricht ein Typ festgelegt, und in den HDR-Dateien zu jeder
  Message werden alle Informationen festgehalten, so dass jederzeit eine Aenderung
  in einen anderen Messagetyp moeglich ist.
  Die Infos im Speicher zu den Messages werden in einem dynamischen Array fest-
  gehalten, das passend alloziert wird.
  Die Header-Dateien bestehen aus 7 Textzeilen, die folgende Informationen
  enthalten:

        Eingabedatum im MausTausch-Format                               (E-Zeile)
        Empfaenger (fuer Persoenliche Nachrichten)                         (A-Zeile)
        Ursprungsgruppe (Leer fuer Antworten auf pers. Nachrichten)
        Zielgruppe (Leer fuer persoenliche Nachrichten)                   (G-Zeile)
        Referenznummer (kommentierte ID)                                (- Zeile)
        Stichwort                                                       (W-Zeile)
        Original-ID der kommentierten Nachricht (MId)                   (R-Zeile)

  Wenn der Typ der Nachrichten nicht geaendert wird, dann koennen einige Zeilen
  auch leer sein. Immer gefuellt ist nur die Datumszeile!

  Beim Erstellen des Infiles werden evtl. vorhandene Tabulatoren in den
  Messages in Leerzeichen gewandelt.
  Ob Endloszeilen an die Maus geschickt werden oder nicht, ist einstellbar.

 *----------------------------------------------------------------------------
 * Datum    Vers. Autor Aenderung (Arbeitsbericht)
 *----------------------------------------------------------------------------
 * 29.10.92 0001  DS    Erste Version
 * 02.11.92 0002  DS    Laeuft recht stabil, Fenster ist auch schon da,
 *                      editieren geht auch schon.
 * 02.11.92 0003  DS    Fenster funktioniert, Buttons im Fenster auch,
 *                      alle Features implementiert!
 * 10.11.92 0004  DS    Bugs korrigiert. Distribution eingebaut.
 *                      Erweiterungen fuer Maus 9 eingebaut: D-Zeile
 * 26.12.92 0006  DS    Distribution auch ueber Popup im Editor und ueber Buttons
 *                      einstellbar.
 * 10.03.93 0007  DS    Datum wird in ID fuer die Maus mit eincodiert und auch
 *                      beim identifizieren ueberprueft.
 * 15.07.95 0008  DS    Modul aufgespalten in drei Module fuer Port auf HM2
 *                      Dieser Part erstellt nur noch das Infile. Der Zugriff
 *                      auf die Strukturen und Daten erfolgt ueber ein anderes
 *                      Modul
 *
 *
 *----------------------------------------------------------------------------
 */

#include <arcstart.h>
#include <catfiles.h>
#include <mte.h>
#include <mtedit2.h>
#include <fontsele.h>
#include <wdwmanag.h>
#include <vdistand.h>
#include <confvars.h>
#include <varname4.h>
#include <varnamel.h>
#include <catgloba.h>
#include <edittype.h>
#include <maustaus.h>
#include <grintool.h>
#include <listhelp.h>
#include <grin.h>
#include <data.h>
#include <quicksor.h>
#include <infofile.h>
#include <groupsel.h>
#include <iofilter.h>
#include <protokol.h>
#include <mtpaths.h>
#include <convertd.h>
#include <userinfo.h>
#include <messages.h>
#include <msgwindo.h>

#include <mttextfi.h>
#include <mtappl.h>
#include <mtutils.h>
#include <mtdials.h>
#include <mtpopups.h>

#ifndef __MINTBIND_H__
#include <mintbind.h>
#endif

#include <routines.h>
#include <routinec.h>
#include <routine.h>
#include <strconv.h>
#include <limits.h>
#include <dir_io.h>
#include <debug.h>
#include <maustaus.h>


#define saveSize  40   /* Sicherheitsgrenze beim Splitten von Nachrichten */
#define devGroup  "Maus.Tausch.CAT.Dev"

#define NO_SUBJECT "(no Subject)"

#define LF 0x0a
#define CR 0x0d


/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

LOCAL INLINE _BOOL is_space(_UBYTE ch)
{
	return
		ch == ' ' ||
		ch == 0x09 ||
		ch == 0x0a ||
		ch == 0x0b ||
		ch == 0x0c ||
		ch == 0x0d;
}

/*** ---------------------------------------------------------------------- ***/


LOCAL _BOOL TrickyOpen(CONST _UBYTE *path, CONST _UBYTE *name, Textmode mode, _LONG buff, TEXTFILENO *f)
{
	_UBYTE fname[PATH_MAX];
	
	strBcpy(fname, path);
	F_Path_Append(fname, name);
	return
		mtTextfiles_OpenTextfile(fname, mode, buff, f) == GERR_OK
		/* Bei Buffergroesse == 0 wird ein 32 kB buffer genommen, das klappt dann
		 * noch weniger, daher nehmen wir jetzt einen 512 Byte Buffer, die sollten
		 * immer frei sein
		 */
		;
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

typedef struct {
	_UBYTE str[4096];
	_UBYTE outStr[4096];
	TEXTFILENO source;
	TEXTFILENO tmpFile;
	_UBYTE ch;
	_ULONG bCount;
	_UBYTE msgName[PATH_MAX];
} splitInfo;

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID makeTmpName(_WORD msgNum, _UWORD number, _UBYTE *tmpName)
{
	_UBYTE numExtension[10];

	NumToStr(number, 36, 3, '0', numExtension, sizeof(numExtension));
	Messages_Number2Name(msgNum, tmpName, PATH_MAX);
	strMcat(tmpName, PATH_MAX, ".");
	strMcat(tmpName, PATH_MAX, numExtension);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID readSourceLine(splitInfo *info)
{
	mtTextfiles_ReadLine(info->source, info->str, sizeof(info->str));
	info->ch = mtTextfiles_ReadChar(info->source);        /* Liest Ende-Zeichen */
	if (info->ch == CR)
		mtTextfiles_ReadLn(info->source);
	Str_ConvertTabs(info->str, info->outStr, sizeof(info->outStr), UserBLK.TabSize);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID writeTargetLine(splitInfo *info)
{
	info->bCount += strLen(info->outStr);
	mtTextfiles_WriteLine(info->tmpFile, info->str);   /* str schreiben, nicht die ohne Tabs! */
	if (info->ch == CR || mtTextfiles_EndofText(info->source)) /* CR da oder EndOfText */
	{
		mtTextfiles_WriteLn(info->tmpFile);        /* CR/LF schreiben */
		info->bCount += 2;                      /* Zwei Bytes geschrieben */
	} else
	{
		mtTextfiles_WriteChar(info->tmpFile, LF); /* LF schreiben */
		info->bCount += 1;
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID updateMsgSize(splitInfo *info, msgInfo *msg)
{
	_WORD idx2;
	_UWORD dummy;
	
	msg->info.size = Messages_FileSize(MessagePath, info->msgName, &dummy, &dummy);
	msg->new = FALSE;
	idx2 = Messages_FindMessage(msg->info.number);
	if (idx2 >= 0)
		msgArray[idx2] = *msg;
}

/*** ---------------------------------------------------------------------- ***/

/* Haengt einen String (x/y) an den Betreff an */

LOCAL _VOID buildSubject(CONST _UBYTE *inTopic, _UBYTE *outTopic, size_t strsize, _UWORD part, _UWORD pNumber)
{
	_UBYTE numStr[80];

	strMcpy(outTopic, strsize, inTopic);
	strMcat(outTopic, strsize, " (");
	CardToStr(part, 0, numStr, sizeof(numStr));
	strMcat(outTopic, strsize, numStr);
	strMcat(outTopic, strsize, "/");
	CardToStr(pNumber, 0, numStr, sizeof(numStr));
	strMcat(outTopic, strsize, numStr);
	strMcat(outTopic, strsize, ")");
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID updateSubject(msgInfo *msg, CONST _UBYTE *subj)
{
	_UBYTE *topic;
	
	topic = STRDUP(subj, "updateSubject");
	if (topic != NULL)
	{
		if (msg->topic != NULL)
			SFREE(msg->topic);
		msg->topic = topic;
		Messages_WriteHdrInfo(msg);
	}
}

/*** ---------------------------------------------------------------------- ***/

/* Das wird jetzt wirklich Arbeit: Eine Message
 * an der richtigen Stelle aufsplitten
 */
/* Vorgehensweise: Damit die Nachrichten alle hintereinander eingefuegt
 * werden, muessen die auch hintereinander im Messagearray stehen.
 * Die Nummern muessen aber nicht aufeinanderfolgend sein!
 * Deshalb wird die Originalnachricht an das Ende des Messagearrays kopiert
 * bzw. der Eintrag ausgetauscht, und dann werden weitere
 * Nachrichten hinten dran gehaengt.
 */

/*DYJ 5.19g */	/*DYJ 5.21b */
LOCAL _VOID splitMessage(_WORD *idx, msgInfo *msg)
{
	msgInfo tmp;
	group_line orgGroup;
	_UBYTE tmpName[PATH_MAX];
	MESSNR msgNum;
	_UWORD i, pNumber;
	group_line refName;
	msg_type newType;
	_BOOL orgHasCopies;
	msgInfo orgMsg;
	splitInfo *info;
	MESSNR messIdx;
	
	/* Erst mal im Messagearray tauschen */
	if (!Messages_ReadHdrInfo(msg, TRUE))
		return;
	tmp = msgArray[messages - 1];
	msgArray[messages - 1] = *msg;
	msgArray[*idx] = tmp;
	orgHasCopies = msg->info.copyCount > 0;
	orgMsg = *msg;
	--(*idx);
	
	if ((info = NEW(splitInfo, "splitMessage")) == NULL)
		return;
	/* Jetzt Namen zusammensetzen */
	Messages_Number2Name(msg->info.number, info->msgName, sizeof(info->msgName));
	strBcat(info->msgName, textExt);
	/* Jetzt wird die Originalnachricht in Files unterteilt,
	 * die eine durchnummerierte Extension haben, also .001, .002 etc.
	 */
	pNumber = 1;
	if (TrickyOpen(MessagePath, info->msgName, READ, 16384, &info->source))
	{
		/* Damit es nicht so schnell zu einem Ueberlauf der Extension kommt,
		 * wird diese im 36er-System kodiert.
		 */
		makeTmpName(msg->info.number, pNumber, tmpName);
		if (!TrickyOpen(MessagePath, tmpName, WRITE, 16384, &info->tmpFile))
		{
			/* Fehlermeldung ausgeben und abbrechen, alle tmp-Files wieder loeschen */
			MTE_infoRSC(AL_NO_TMP_SPLITFILE);
			mtTextfiles_CloseTextfile(&info->source);
			OFREE(info);
			return;
		}
		info->bCount = 0;
		while (!mtTextfiles_EndofText(info->source))
		{
			readSourceLine(info);
			while (!mtTextfiles_EndofText(info->source) && 
				(!UserBLK.splitSize || info->bCount + strLen(info->outStr) + saveSize < UserBLK.splitSize))
			{
				writeTargetLine(info);
				readSourceLine(info);
			}
			if (!UserBLK.splitSize || info->bCount + strLen(info->outStr) + saveSize < UserBLK.splitSize)
			{
				/* noch rausschreiben */
				writeTargetLine(info);
			} else
			{
				/* Groesse ueberschritten! Also tmpFile schliessen und neues anlegen! */
				mtTextfiles_CloseTextfile(&info->tmpFile);
				++pNumber;
				if (pNumber == 46656U) /* 36 * 36 * 36 */
				{
					/* Damit wuerde die dritte Stelle in der Extension
					 * ueberschritten und ein Ueberlauf auftreten.
					 * Dieser Fall ist aber sehr unwahrscheinlich, da
					 * man dazu eine Message von ca. 560 MB schreiben muesste!
					 * Vorher ist wahrscheinlich die Platte voll oder Fehler
					 * sind aufgetreten.
					 */
					/* HALT */
					goto abort;
				}
				makeTmpName(msg->info.number, pNumber, tmpName);
				if (!TrickyOpen(MessagePath, tmpName, WRITE, 16384, &info->tmpFile))
				{
				abort:
					/* Fehlermeldung ausgeben und abbrechen, alle tmp-Files wieder loeschen */
					MTE_infoRSC(AL_NO_TMP_SPLITFILE);
					for (i = 1; i < pNumber; i++)
					{
						makeTmpName(msg->info.number, i, tmpName);
						CatFiles_DeleteFile(MessagePath, tmpName);
					}
					mtTextfiles_CloseTextfile(&info->source);
					OFREE(info);
					return;
				}
				/* noch rausschreiben */
				info->bCount = 0;
				writeTargetLine(info);
			}
		}
		/* jetzt haben wir die Nachricht verteilt in pNumber temporaere Files */
		mtTextfiles_CloseTextfile(&info->tmpFile);
		mtTextfiles_CloseTextfile(&info->source);
	} else
	{
		/* Fehlermeldung */
		MTE_infoRSC(AL_NO_MSG_SPLITFILE);
		OFREE(info);
		return;
	}
	
	/*
	 * Jetzt werden die Dateien umbenannt und viele neue Kommentare angelegt
	 */
	CatFiles_DeleteFile(MessagePath, info->msgName);
	i = 1;
	makeTmpName(msg->info.number, 1, tmpName);
	CatFiles_RenameFile(MessagePath, tmpName, MessagePath, info->msgName);
	++i;
	msgNum = msg->info.number;
	if (msg->topic != NULL)
		strBcpy(info->str, msg->topic);
	else
		strBcpy(info->str, NO_SUBJECT);
	buildSubject(info->str, info->outStr, sizeof(info->outStr), 1, pNumber);
	updateSubject(msg, info->outStr);
	updateMsgSize(info, msg);
	Messages_UpdateEditors(msg);
/*DYJ 5.34d Start*/
	if (msg->info.msgType == msg_answer || msg->info.msgType == msg_persanswer ||
		msg->info.msgType == msg_private|| msg->info.msgType == msg_pseudoKom ||
		msg->info.msgType == msg_pseudoNews)
/*DYJ  Ende; alt:	
	if (msg->info.msgType == msg_answer || msg->info.msgType == msg_persanswer || msg->info.msgType == msg_private)
*/
	{
		/* persoenliche Nachricht gleichen Typs anlegen */
		newType = msg->info.msgType;
	} else
	{
		/* Kommentar auf eigene Nachricht anlegen */
		newType = msg_comment;
	}
	while (i <= pNumber)
	{
		if (!Messages_ReadHdrInfo(msg, TRUE))
		{
			OFREE(info);
			return;
		}
/*DYJ 5.34d Start*/
		if (msg->info.msgType != msg_answer && msg->info.msgType != msg_pseudoKom) 
/*DYJ  Ende; alt:	
		if (msg->info.msgType != msg_answer)
*/
			Messages_MakeMausId(msg, refName, sizeof(refName));
		else if (msg->refId != NULL)
			strBcpy(refName, msg->refId);
		else
			refName[0] = '\0';
		if (msg->orgGroup != NULL && msg->orgGroup[0] != '\0')
			strBcpy(orgGroup, msg->orgGroup);
		else if (msg->group != NULL)
			strBcpy(orgGroup, msg->group);
		else
			orgGroup[0] = '\0';
		buildSubject(info->str, info->outStr, sizeof(info->outStr), i, pNumber);
		
		if (Messages_CreateMessage(msg->info.number,msg->Absender, msg->receiver, orgGroup, msg->group, refName, info->outStr,
			msg->realName, "", newType, 0, "", "", msg->info.dist, FALSE, &messIdx,msg->ref))
		{
			*msg = msgArray[messIdx];
			Messages_Number2Name(msg->info.number, info->msgName, sizeof(info->msgName));
			strBcat(info->msgName, textExt);
			makeTmpName(msgNum, i, tmpName);
			CatFiles_RenameFile(MessagePath, tmpName, MessagePath, info->msgName);
			updateMsgSize(info, msg);
			if (orgHasCopies)
			{
				_WORD count, tmpCount;
				_WORD j;
				
				for (count = 1; count <= orgMsg.info.copyCount; count++)
				{
					/* Kopie Nr. j suchen und dann zur gerade erstellten wieder
					 * eine Kopie anlegen mit den gleichen Daten
					 */
					for (j = 0; j < messages; j++)
					{
						tmpCount = 1;
						if (msgArray[j].info.msgType == msg_copyOwn  &&
							msgArray[j].info.refNum == orgMsg.info.number &&
							msgArray[j].info.sendMsg)
						{
							if (tmpCount == count)
							{
								/* Richtige Kopie gefunden, Kopie zu msg anlegen */
								if (!Messages_ReadHdrInfo(&msgArray[j], FALSE))
								{
									OFREE(info);
									return;
								}
								Messages_Number2Name(msg->info.number, info->msgName, sizeof(info->msgName));
								if (msgArray[j].topic != NULL)
									strBcpy(info->str, msgArray[j].topic);
								else
									strBcpy(info->str, NO_SUBJECT);
								buildSubject(info->str, info->outStr, sizeof(info->outStr), i, pNumber);
								Messages_CopyOwnMessage(info->msgName, msgArray[j].Absender, msgArray[j].receiver, 
														msgArray[j].realName, info->outStr, j);
								if (i == pNumber)
								{
									/* Kommentare der Originalkopien auch anpassen
									 */
									if (msgArray[j].topic != NULL)
										strBcpy(info->str, msgArray[j].topic);
									else
										strBcpy(info->str, NO_SUBJECT);
									buildSubject(info->str, info->outStr, sizeof(info->outStr), 1, pNumber);
									updateSubject(&msgArray[j], info->outStr);
								}
							} else
							{
								++tmpCount;
								UNUSED(tmpCount); /* ??? */
							}
						}
					}
				}
			}
			/* Jetzt erst i updaten, da wir ansonsten evtl. eine falsche
			 * Nummer ins Stichwort schreiben
			 */
			++i;
		} else
		{
			OFREE(info);
			return;
		}
	}
	OFREE(info);
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

LOCAL _VOID LineOut(TEXTFILENO file, CONST _UBYTE *ch, CONST _UBYTE *str)
{
	if (str != NULL)
	{
		mtTextfiles_WriteLine(file, ch);
		if (ch[0] != '\0' || str[0] != '\0')			/* nur konstant, kann nicht NULL sein */
		{
			mtTextfiles_WriteLine(file, str);
			mtTextfiles_WriteLn(file);
		}
	}
}
#define HZEILE_MAX	76
/*** ------------------------------------------------------------------------ ***/
/*	_VOID LineOutInH(TEXTFILENO file,_WORD anz,...)								*/
/*	wie die vorige, aber mit beliebiger Anzahl Strings, und sie werden auf		*/
/*	HZEILE_MAX Zeichen umgebrochen, die Folgezeile beginnt dann mit einem 		*/
/*	Whitespace.	Wird als anz ein negativer Wert bergeben, so wird die Zeile	*/
/*	nicht abgeschlossen. Ist anz=0 wird nur abgeschlossen						*/
/*	Parameter:	file:	Das Zielfile											*/
/*				anz:	Anzahl Teilstrings										*/
/*				...:	anz Teilstrings (_UBYTE *)								*/
/*	Ergebnis:	keines															*/		
/*	23.11.01 von Dimitri Junker	DYJ 4.30t										*/
/*** ------------------------------------------------------------------------ ***/
/*DYJ 5.19f */
LOCAL _VOID LineOutInH(TEXTFILENO file,_WORD anz,...)
{
	va_list ptr;
	_UBYTE *str,*lz,*tab,*ende,endZ;
	static _UBYTE zeile[HZEILE_MAX+10]="";
	static _WORD rest=HZEILE_MAX;
	_WORD i;
	_BOOL mitEOL=TRUE;
	va_start(ptr,anz);
	if(anz<0)
	{
		anz*=-1;
		mitEOL=FALSE;
	}
	for(i=0;i<anz;i++)
	{
		str=va_arg(ptr,_UBYTE *);
		do
		{
			if(strLen(str)>rest)
			{
				strMcat(zeile,HZEILE_MAX+1,str);
				lz=strrChr(zeile,' ');
				if(lz==zeile)
					lz=NULL;
				tab=strrChr(zeile,'\t');
				if(tab==zeile)
					tab=NULL;
				ende= (lz>tab)?lz:tab;
				if(!ende)
					ende=strChr(zeile,'\0');
				endZ=*ende;
				*ende='\0';
				mtTextfiles_WriteLine(file, zeile);
				mtTextfiles_WriteLn(file);
				if(endZ)
				{
					*ende=endZ;
					strCpy(zeile,ende);
				}
				else
					strCpy(zeile," ");
				str+=rest;
				rest=HZEILE_MAX-(_WORD)strLen(zeile);
			}
			else
			{
				strCat(zeile,str);
				rest-=(_WORD)strLen(str);
				str=NULL;
			}
		}while(str);
	}
	va_end(ptr);
	if(mitEOL)
	{
		mtTextfiles_WriteLine(file, zeile);
		*zeile='\0';
		mtTextfiles_WriteLn(file);
		rest=HZEILE_MAX;
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID CmdOut(TEXTFILENO file, CONST _UBYTE *ch, CONST _UBYTE *str, _BOOL *firstCmd)
{
	if (*firstCmd)
	{
		LineOut(file, "", "#CMD");
		*firstCmd = FALSE;
	}
	LineOut(file, ch, str);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _ULONG CalcPercent(_ULONG val, _ULONG mul, _ULONG div)
{
	if (val < (ULONG_MAX / mul))
		return (val * mul) / div;
	return (val / div) * mul;
}

/*** ---------------------------------------------------------------------- ***/

/*DYJ 4.15: max2GB: Soll maximal 2*10E+9 zurckgegeben werden? 
	und _ULONG->DOUBLE*/

LOCAL _VOID GetFreeSpace(_UBYTE *num, size_t strsize,_BOOL max2GB)
{
	DiskINFO dInfo;
	_DOUBLE mFree, iFree;
	_BOOL packed;
	_BOOL sameDrive;

	D_Info(DataPath, &dInfo);
	mFree = dInfo.free_size;
	SPEC_DEBUG_OUT((EO_DEBUG, "Space on database path: %lf", mFree));
	sameDrive = D_SameDevice(DataPath, ImportPath);
	if (!sameDrive)
	{
		D_Info(ImportPath, &dInfo);
		iFree = dInfo.free_size;
		SPEC_DEBUG_OUT((EO_DEBUG, "Space on import path %lf", iFree));
	} else
	{
		iFree = mFree; /* damit der Compiler zufrieden ist */
	}
	packed = ARCName[0] != '\0';
	/* Jetzt haben wir vier Faelle:
	 * 1. gepackt und gleiches Laufwerk            : min ((xarc*.30)+xarc+xarc*1.2)  xarc == free / 2.5 ==>>> arc == 12% free!
	 * 2. gepackt und unterschiedliche Laufwerke   : min (80% mDrv, (xarc*.3) + xarc) xarc == free / 1.3
	 * 3. ungepackt und gleiches Laufwerk          : 80% von min (iDrv, mDrv) / 2       ==>> (free / 2.5)
	 * 4. ungepackt und unterschiedliche Laufwerke : min (90% iDrv, 80% mDrv)
	 */
	if (packed)
	{
		if (sameDrive)
		{
			/* Nur 12% insgesamt fuer Archiv verfuegbar */
			mFree*=2./7.;  /* (mFree * 2) DIV 7; */
		} else
		{
			/* Minimum von 80% Databaselaufwerk, 23% Importlaufwerk */
/*DYJ warum 10/15 23% sein sollen ist mir schleierhaft*/
			mFree*=.8;  
			iFree*=10./15.; 
			if (iFree < mFree)
				mFree = iFree;
		}
	} else
	{
		if (sameDrive)
		{
			/* 80% von freier Platz/2 */
			mFree*=2./5.;  /* (mFree * 2) DIV 7; */
		} else
		{
			/* Minimum von 90% Importlaufwerk, 80% Databaselaufwerk */
/*DYJ warum 10/15 23% sein sollen ist mir schleierhaft*/
			mFree*=.8;  
			iFree*=.9; 
			if (iFree < mFree)
				mFree = iFree;
		}
	}
	if(max2GB && mFree>2000000000.)		/* Wer wei ob die Maus hier nicht einen signed 32Bit INT verwendet?*/
		mFree=2000000000.;
	FixToStr(mFree, 0,0, num, strsize);
	SPEC_DEBUG_OUT((EO_DEBUG, "Free space: %s", num));
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID SetHeaderLine(_UBYTE **line, CONST _UBYTE *str)
{
	_UBYTE *oldPtr;

	oldPtr = *line;
	*line = STRDUP(str, "SetHeaderLine");
	if (*line == NULL)
	{
		if (oldPtr != NULL && strLen(str) <= strLen(oldPtr))
		{
			*line = oldPtr;
			strCpy(oldPtr, str);
			oldPtr = NULL;
		}
	}
	if (oldPtr != NULL)
		SFREE(oldPtr);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID HandleEvents(_VOID)
{
	_UWORD evnt, event;
	_WORD message[8];
	_UBYTE key, scan;
	_UWORD buts, kstate;
	_WORD taste, mx, my, clicks;
	_BOOL doExit;
	
	if (multiTask)
	{
		/* Hier bei MultiTasking noch eine kleiner EventMulti und ein paar
		 * Events verarbeiten
		 */
		do
		{
			evnt = evnt_multi(MU_MESAG | MU_TIMER,
				0, 0, 0,
				0, 0, 0, 0, 0,
				0, 0, 0, 0, 0,
				message,
				0, 0,
				&mx, &my, &buts, &kstate, &taste, &clicks);
			/* Den Timerevent brauchen wir nicht */
			event = evnt;
			event &= ~MU_TIMER;
			doExit = event == 0;
			scan = (taste >> 8) & 0xff;
			key = taste & 0xff;
			WdwManager_HandleEvent(&evnt, message, buts, kstate, key, scan, taste, mx, my, clicks);
		} while (!doExit);
	}
}

 /*** ---------------------------------------------------------------------- ***/
 
/*** --- Routine von Frank Roeske @ LU2 --- ***/
/* Diese Routine haengt ein evtl. vorhandenes UPL.TXT, das     */
/* sich im MESSAGE-Ordner befinden muss direkt vor das Ende des*/
/* INFILEs.                                                    */
/* Das Ganze ist fr die "neue" Maus von Andreas Mayer @ ZW    */
/* gedacht, die Uploads mittels #UPL-Bloecken erlaubt (die von */
/* DirToTIC (von Frank Roeske @ LU2 <eg>) erstellt werden      */
/* koennen.                                                    */
LOCAL _VOID AppendUPL(TEXTFILENO INFILE, CONST _UBYTE *path)
{
	TEXTFILENO UPL;
	
	if (TrickyOpen(path, UPL_FILENAME, READ, 1024, &UPL))
	{
		/* das Oeffnen hat geklappert ... */
	
/*DYJ 5.34m Start*/
		Mime_TransferQP(UPL, INFILE, '\0',ZS_ATARI);
/*DYJ  Ende; alt:	
		Mime_TransferQP(UPL, INFILE, '\0');
*/
		mtTextfiles_CloseTextfile(&UPL);
	}
}
/*** ------------------------------------------------------------------------ ***/
/*	 _VOID addFile(TEXTFILENO inHandle,_UBYTE *fName)							*/
/*	fgt File an Infile an, dabei werden Variablen der Form %a ersetzt			*/
/*	derzeit definierte Variablen: keine (also nur %%)							*/
/*	Parameter:	inHandle:	Handle des Infiles									*/
/*				fName:		anzuhngendes File									*/
/*	Ergebnis:	keines															*/		
/*	1.2.03 von Dimitri Junker	DYJ 5.20m										*/
/*** ------------------------------------------------------------------------ ***/
/*DYJ 5.21f */
LOCAL _VOID addFile(TEXTFILENO inHandle,_UBYTE *fName)
{
	_UBYTE str[4096],*proz;
	TEXTFILENO xHandle;
	if (TrickyOpen(MessagePath, fName, READ, 16348, &xHandle))
	{
		do
		{
			mtTextfiles_ReadLine(xHandle, str, sizeof(str));
			mtTextfiles_ReadLn(xHandle);     /* Liest Ende-Zeichen der Zeile */
			proz=str;
			while((proz=strChr(proz,'%'))!=NULL)
			{
				if(proz[1]=='%')
					strCpy(proz,proz+1);
				proz++;
			}
			mtTextfiles_WriteLine(inHandle, str);
			mtTextfiles_WriteLn(inHandle);
		} while (!mtTextfiles_EndofText(xHandle));
		mtTextfiles_CloseTextfile(&xHandle);
	}
}
/*** ------------------------------------------------------------------------ ***/
/*	_VOID writeHeaderXorFooter(TEXTFILENO inHandle,_BOOL isHeader,_BOOL isPM)	*/
/*	Fgt zustzliche Headerzeilen bzw Footer ans Infile an						*/
/*	Parameter:	inHandle:	Handle des Infile									*/
/*				isHeader:	X-Zeile fr Header oder Footer						*/
/*				isPM:		PM oder OM											*/
/*	Ergebnis:	keines															*/		
/*	1.2.03 von Dimitri Junker	DYJ 5.20m										*/
/*** ------------------------------------------------------------------------ ***/
LOCAL _VOID writeHeaderXorFooter(TEXTFILENO inHandle,_BOOL isHeader,_BOOL isPM)
{
	_UBYTE msgName[PATH_MAX]="msg",ext[10];
	if(isPM)
		strCpy(ext, "_pm");
	else
		strCpy(ext, "_om");

	if(isHeader)
		strBcat(ext, headerExt);
	else
		strBcat(ext, textExt);

	strBcat(msgName, ext+3);
	addFile(inHandle,msgName);

	msgName[3]='\0';
	strBcat(msgName, ext);
	addFile(inHandle,msgName);
}
/*** ------------------------------------------------------------------------ ***/
/*	_UBYTE *punycodeAdr(_UBYTE *str)											*/
/*	kodiert eine Adresse nach Punycode/nameprep									*/
/*	Parameter:	str:	die Adresse												*/
/*	Ergebnis:	die gewandelte Adresse, mu wieder freigegeben werden.															*/		
/*	14.4.04 von Dimitri Junker	DYJ 5.36a										*/
/*** ------------------------------------------------------------------------ ***/
LOCAL _UBYTE *punycodeAdr(_UBYTE *str)
{
	_UBYTE *ptr,*ret=NULL;
	_BOOL ok=TRUE;
/* 1. Domainteil extrahieren*/
	ptr=strChr(str,'@');
	if(ptr)
	{
/* 2. Nameprep*/
		_UBYTE *utf=NULL;
		size_t utfLen;
		ptr++;
		utf=stringprep_locale_to_utf8(ptr);
		utfLen=strLen(utf)+1;
		if(utf && stringprep (utf, utfLen, 0, stringprep_nameprep)==STRINGPREP_OK)
		{
/* 3. ungltige Zeichen? suchen, dies Funktioniert obwohl der String UTF-8 codiert ist! 
	Es wird ausgenutzt, das bei den erlaubten Zeichen diese identisch zu ihrer UTF-8 Kodierung sind.*/
			_WORD fstSZeichen;
			while((fstSZeichen=(_WORD)strSpn(utf,"abcdefghijklmnopqrstuvwxyz0123456789-."))!=strLen(utf))
			{
/* Einzelne Domain-Label mit Sonderzeichen extrahieren*/
				_UBYTE dLabel[70]="xn--",save,*start,*end;
				size_t output_length;
				uint32_t *ucs4;
				ssize_t ucs4len;
				save=utf[fstSZeichen];
				utf[fstSZeichen]='\0';
				start=strrChr(utf,'.');
				if(start)
				{
					*start='\0';
					start++;
				}
				else
					start=utf;
				utf[fstSZeichen]=save;
				end=strChr(start,'.');
				if(end)
					*end='\0';
				ucs4 = stringprep_utf8_to_ucs4 (start, -1, &ucs4len);
				output_length=63;
		 		if(ucs4 && punycode_encode (ucs4len, ucs4, NULL,
					&output_length, dLabel+4)==PUNYCODE_SUCCESS)
				{
					_UBYTE *utf2;
					utf2=SYSMALLOC(strLen(utf)+output_length+strLen(end)+10,MEM_NOERR | MEM_SHARABLE,"CatGlobal_Punycode");
					if(utf2)
					{
						if(start==utf)
							*utf2='\0';
						else
						{
							strCpy(utf2,utf);
							strCat(utf2,".");
						}
						strCat(utf2,dLabel);
						if(end)
						{
							*end='.';
							strCat(utf2,end);
						}
						free(utf);
						utf=utf2;
					}
					else
					{
						ok=FALSE;
						break;
					}
				}
				else
				{
					ok=FALSE;
					break;
				}
			}
			if(ok)
			{
				ret=SYSMALLOC(strcSpn(str,"@")+strLen(utf)+2,MEM_NOERR | MEM_SHARABLE,"CatGlobal_Punycode");
				if(ret)
				{
					strCpy(ret,str);
					ptr=strChr(ret,'@');
					strCpy(ptr+1,utf);
				}
			}
		}
		if(utf)
			free(utf);
	}
	if(!ret)
	{
		ret=SYSMALLOC(strLen(str)+1,MEM_NOERR | MEM_SHARABLE,"CatGlobal_Punycode");
		if(ret)
			strCpy(ret,str);
	}
	return ret;
}
/*** ------------------------------------------------------------------------ ***/
/*	_VOID writeHeaderMaus(msgInfo *pMsg,TEXTFILENO INFILE,TEXTFILENO txtFile)	*/
/*	Schreibt einen Message-Header in ein Maus-Infile. War ursprnglich Teil von	*/
/*	MsgInfile_MakeInFile bei der Erzeugung einer extra Funktioni wurden folgende*/
/*	nderungen ntig: msg->pMsg; ( also auch z.B. msg.refId -> pMsg->refId)		*/
/*	Parameter:	pMsg: die Quelle												*/
/*				INFILE: das Infile												*/
/*				txtFile:Mailtext, zur berprfung welcher Zeichensatz verwendet */
/*						werden soll												*/
/*	Ergebnis:	keines												*/		
/*	18.9.01 von Dimitri Junker	DYJ 4.30t										*/
/*** ------------------------------------------------------------------------ ***/
/*DYJ 5.34m Start*/
_VOID writeHeaderMaus(msgInfo *pMsg,TEXTFILENO INFILE,_WORD zeichens)
/*DYJ  Ende; alt:	
_BOOL writeHeaderMaus(msgInfo *pMsg,TEXTFILENO INFILE)
*/
{
	_UBYTE tmpName[PATH_MAX];
	_UBYTE msgName[PATH_MAX];
	_UWORD cDt, cTi;
	_UBYTE alt[512];
	_WORD j;
	_BOOL isPM=TRUE;
	_UBYTE *punyC;	/*DYJ 5.39e */
	/* Zuerst wird die Message-ID geschrieben */
	Messages_Number2Name(pMsg->info.number, msgName, sizeof(msgName));
	SPEC_DEBUG_OUT((EO_TRACE, "Message: %s", msgName));
	/* Jetzt Id fuer Maus erstellen */
	Messages_MakeMausId(pMsg, tmpName, sizeof(tmpName));
	/* So, und jetzt ab ins Infile damit */
	LineOut(INFILE, "#", tmpName);
	/* Jetzt kommen die weiteren Infos */
	switch (pMsg->info.msgType)
	{
	case msg_groupcomment:
	case msg_mail:
		LineOut(INFILE, "G", pMsg->group);
		isPM=FALSE;
		break;
/*DYJ 5.36a Start*/
	case msg_answer:
	case msg_pseudoKom:	/*DYJ 5.34d */
		if (!pMsg->info.noRefLine)
/*DYJ 5.39e Start*/
		{
			punyC=punycodeAdr(pMsg->refId);
			LineOut(INFILE, "-", punyC);
			free(punyC);
		}
	case msg_persanswer:
	case msg_private:
	case msg_pseudoNews:
	{
		punyC=punycodeAdr(pMsg->receiver);
		LineOut(INFILE, "A", punyC);
		free(punyC);
/*DYJ  Ende; alt:	
			LineOut(INFILE, "-", pMsg->refId);
	case msg_persanswer:
	case msg_private:
	case msg_pseudoNews:
	{
		_UBYTE *pc=punycodeAdr(pMsg->receiver);
		LineOut(INFILE, "A", pc);
		free(pc);
*/
		break;
	}
/*DYJ  Ende; alt:	
	case msg_persanswer:
	case msg_private:
	case msg_pseudoNews:	/*DYJ 5.34d */
		LineOut(INFILE, "A", pMsg->receiver);
		break;
	case msg_answer:
	case msg_pseudoKom:	/*DYJ 5.34d */
		if (!pMsg->info.noRefLine)
		{
			LineOut(INFILE, "-", pMsg->refId);
			LineOut(INFILE, "A", pMsg->receiver);
		} else
		{
			LineOut(INFILE, "A", pMsg->receiver);
		}
		break;
*/
	case msg_comment:
		if (!pMsg->info.noRefLine)
		{
/*DYJ 5.39e Start*/
			punyC=punycodeAdr(pMsg->refId);
			LineOut(INFILE, "-", punyC);
			free(punyC);
/*DYJ  Ende; alt:	
			LineOut(INFILE, "-", pMsg->refId);
*/
			LineOut(INFILE, "G", pMsg->group);
		} else
		{
			LineOut(INFILE, "G", pMsg->group);
		}
		isPM=FALSE;
		break;
	}
	if (pMsg->topic != NULL && pMsg->topic[0] != '\0')
	{
		LineOut(INFILE, "W", pMsg->topic);
	}
	if (UserBLK.MessageDateInInfile)
	{
		/* Datum der Nachricht nehmen */
		Messages_Number2Name(pMsg->info.number, msgName, sizeof(msgName));
		strBcat(msgName, textExt);
		Messages_FileSize(MessagePath, msgName, &cDt, &cTi);
		/* Die Infos haben wir oben schon geholt */
		/* Jetzt Datum bauen */
		ConvertDate_MakeFreeDate(cDt, cTi, alt, sizeof(alt));
		/* E-Zeile in Header sichern */
		SetHeaderLine(&pMsg->date, alt);
		Messages_WriteHdrInfo(pMsg);
		/* und ausgeben in Infile */
		LineOut(INFILE, "E", alt);
	} else
	{
		ConvertDate_MakeDate(alt, sizeof(alt));
		/* E-Zeile in Header sichern */
		SetHeaderLine(&pMsg->date, alt);
		/*
		strCpy(pMsg->date, alt);
		*/
		Messages_WriteHdrInfo(pMsg);
		/* und ausgeben in Infile */
		LineOut(INFILE, "E", alt);
	}
	/* Reference-ID */
/*DYJ 5.39e Start*/
	if (pMsg->rId != NULL && pMsg->rId[0] != '\0')
		punyC=punycodeAdr(pMsg->rId);
	else if (pMsg->info.msgType == msg_groupcomment && pMsg->refId != NULL)
	{
		/* Ein Gruppenkommentar bekommt auch dann eine R-Zeile,
		 * wenn gar keine I-Zeile da war. Dann nehmen wir die normale Id!
		 */
		punyC=punycodeAdr(pMsg->refId);
	}
	LineOut(INFILE, "R", punyC);
	free(punyC);
/*DYJ  Ende; alt:	
	if (pMsg->rId != NULL && pMsg->rId[0] != '\0')
	{
#if 0					/* RId bekommt keine <> mehr drumherum */
		if (pMsg->rId[0] != '<')
		{
			strCpy(tmpName, "<");
			strBcat(tmpName, pMsg->rId);
			strBcat(tmpName, ">");
			LineOut(INFILE, "R", tmpName);
		} else
#endif
		{
			LineOut(INFILE, "R", pMsg->rId);
		}
	}
	else if (pMsg->info.msgType == msg_groupcomment && pMsg->refId != NULL)
	{
		/* Ein Gruppenkommentar bekommt auch dann eine R-Zeile,
		 * wenn gar keine I-Zeile da war. Dann nehmen wir die normale Id!
		 */
#if 0					/* RId bekommt keine <> mehr drumherum */
		if (pMsg->refId[0] != '<')
		{
			strBcpy(tmpName = "<");
			strBcat(tmpName, pMsg->refId);
			strBcat(tmpName, ">");
			LineOut(INFILE, "R", tmpName);
		} else
#endif
		{
			LineOut(INFILE, "R", pMsg->refId);
		}
	}
*/
	/* Maus 9.0: Distribution ausgeben */
	if (pMsg->info.dist != distNone &&
		(pMsg->info.msgType == msg_mail ||
		 pMsg->info.msgType == msg_comment ||
		 pMsg->info.msgType == msg_groupcomment))
	{
		_UBYTE dist[2];
		
		dist[0] = "KLMN"[pMsg->info.dist];
		dist[1] = '\0';
		LineOut(INFILE, "D", dist);
	}
	if (pMsg->replyTo != NULL && pMsg->replyTo[0] != '\0')
	{
/*DYJ 5.39e Start*/
		punyC=punycodeAdr(pMsg->replyTo);
		LineOut(INFILE, "T", punyC);
		free(punyC);
/*DYJ  Ende; alt:	
		LineOut(INFILE, "T", pMsg->replyTo);
*/
	}
	if (pMsg->sender != NULL && pMsg->sender[0] != '\0')
	{
/*DYJ 5.39e Start*/
		punyC=punycodeAdr(pMsg->sender);
		LineOut(INFILE, "S", punyC);
		free(punyC);
/*DYJ  Ende; alt:	
		LineOut(INFILE, "S", pMsg->sender);
*/
	}
	if (pMsg->followupTo != NULL && pMsg->followupTo[0] != '\0')
	{
/*DYJ 5.39e Start*/
		punyC=punycodeAdr(pMsg->followupTo);
		LineOut(INFILE, "F", punyC);
		free(punyC);
/*DYJ  Ende; alt:	
		LineOut(INFILE, "F", pMsg->followupTo);
*/
	}
	/* Jetzt Kopien von eigenen Nachrichten suchen */
	for (j = 0; j < messages; j++)
	{
		if (msgArray[j].info.msgType == msg_copyOwn &&
			msgArray[j].info.refNum == pMsg->info.number &&
			msgArray[j].info.sendMsg &&
			!msgArray[j].isSend)
		{
			if (Messages_ReadHdrInfo(&msgArray[j], TRUE))
			{
				LineOut(INFILE, "K", msgArray[j].receiver);
				if (msgArray[j].topic != NULL && msgArray[j].topic[0] != '\0')
				{
					LineOut(INFILE, ">", msgArray[j].topic);
				}
				msgArray[j].isSend = TRUE;
			}
		}
	}
/*DYJ 5.34m Start*/
/*DYJ 5.38a Start*/
	if(zeichens==WINDOWS1252 && CP1252Mode==2)
		LineOut(INFILE,"M1.0; Content-Type: text/plain; charset=",cMIME_Iso[ISO8859_1]);
/*DYJ 5.39a Start*/
	else if(zeichens!=US_ASCII && zeichens!=ZS_ATARI)
/*DYJ  Ende; alt:	
	else if(zeichens!=US_ASCII && zeichens!=ATARI)
*/
/*DYJ  Ende; alt:	
	if(zeichens!=US_ASCII && zeichens!=ATARI)
*/
		LineOut(INFILE,"M1.0; Content-Type: text/plain; charset=",cMIME_Iso[zeichens]);
/*DYJ  Ende*/	
	writeHeaderXorFooter(INFILE,TRUE,isPM);
/*DYJ 5.35a Start*/
/*DYJ 5.39a Start*/
	if(zeichens!=US_ASCII && zeichens!=ZS_ATARI)
/*DYJ  Ende; alt:	
	if(zeichens!=US_ASCII && zeichens!=ATARI)
*/
		LineOut(INFILE, ":-", "");
/*DYJ  Ende*/	
	/* billige Wildwestverkettung */
	if (pMsg->info.noRefLine &&
		pMsg->refId != NULL &&
		pMsg->refId[0] != '\0')
	{
		LineOut(INFILE, ":-", pMsg->refId);
		LineOut(INFILE, ":", "");
	}
/*DYJ 5.34m Start*/
/*DYJ  Ende; alt:	
	return TRUE;
*/
	
}

/*** ------------------------------------------------------------------------ ***/
/*	_VOID wRCPT(_UBYTE *to,TEXTFILENO INFILE)									*/
/*	RCPT To: Zeile erzeugen														*/
/*	Parameter:	to:		Zeile mit ggf mehreren Empfngern durch Komma getrennt	*/
/*				INFILE:	Dorthin schreiben										*/
/*	Ergebnis:	keines															*/		
/*	18.9.01 von Dimitri Junker	DYJ 4.30t										*/
/*** ------------------------------------------------------------------------ ***/
/*DYJ 5.19g */	/*DYJ 5.29c */
_VOID wRCPT(_UBYTE *to,TEXTFILENO INFILE)
{
/*DYJ 5.36a Start*/
	_UBYTE *akt,*nxt,*pc,*ptr;
/*DYJ  Ende; alt:	
	_UBYTE *akt,*nxt;
*/
	if(!to || !(*to))
		return;
	nxt=to;
	do
	{
		akt=nxt;
		nxt=strChr(akt,',');
		if(nxt)
			*nxt='\0';
/*DYJ 5.36a Start*/
		if((ptr=strChr(akt,'<'))==NULL)
			pc=punycodeAdr(akt);
		else
		{
			_UBYTE *ptr2;
			ptr2=strChr(ptr,'>');
			if(ptr2)
				*ptr2='\0';
			pc=punycodeAdr(ptr+1);
			if(ptr2)
				*ptr2='>';
		}
		mtTextfiles_WriteLine(INFILE, "RCPT To:<");
		LineOut(INFILE,pc,">");
		free(pc);
/*DYJ  Ende; alt:	
		if(strChr(akt,'<'))
			LineOut(INFILE, "RCPT To:", akt);
		else
		{
			mtTextfiles_WriteLine(INFILE, "RCPT To:<");
			LineOut(INFILE,akt,">");
		}
*/
		if(nxt)
		{
			*nxt=',';
			if((*(++nxt))==' ')		/*DYJ 5.19g */
				nxt++;
		}
	}while(nxt);
}
/*** ------------------------------------------------------------------------ ***/
/*	_VOID wAdrLst(_UBYTE *addrs,TEXTFILENO INFILE)								*/
/*	Parameter von To, CC, BCC erzeugen											*/
/*	Parameter:	addrs:		Zeile mit ggf mehreren Adressen durch Komma getrennt*/
/*				INFILE:	Dorthin schreiben										*/
/*	Ergebnis:	keines															*/		
/*	26.3.03 von Dimitri Junker	DYJ 5.23i										*/
/*** ------------------------------------------------------------------------ ***/
_VOID wAdrLst(_UBYTE *addrs,TEXTFILENO INFILE)
{
/*DYJ 5.39e Start*/
	_UBYTE *akt,*nxt,*pc,*ptr;
/*DYJ  Ende; alt:	
	_UBYTE *akt,*nxt;
*/
	if(!addrs || !(*addrs))
		return;
	nxt=addrs;
	do
	{
		akt=nxt;
		nxt=strChr(akt,',');
		if(nxt)
			*nxt='\0';


/*DYJ 5.39e Start*/
		if((ptr=strChr(akt,'<'))==NULL)
			pc=punycodeAdr(akt);
		else
		{
			_UBYTE *ptr2;
			ptr2=strChr(ptr,'>');
			if(ptr2)
				*ptr2='\0';
			pc=punycodeAdr(ptr+1);
			if(ptr2)
				*ptr2='>';
		}
		LineOutInH(INFILE,-3,"<",pc,">");
		free(pc);
/*DYJ  Ende; alt:	
		if(strChr(akt,'<'))
			LineOutInH(INFILE, -1, akt);
		else
			LineOutInH(INFILE,-3, "<", akt,">");
*/
		if(nxt)
		{
			*nxt=',';
			if((*(++nxt))==' ')
				nxt++;
		}
		if(nxt)
			LineOutInH(INFILE,-1,", ");
	}while(nxt);
	LineOutInH(INFILE,0);
}

/*** ------------------------------------------------------------------------ ***/
/*	_VOID writeHeaderIN(msgInfo *pMsg,TEXTFILENO INFILE,String127 bound,_WORD zeichens)	*/
/*	Schreibt einen Message-Header in ein IN-Infile. Abgeleitet von 				*/
/*	writeHeaderMaus																*/
/*	Parameter:	pMsg: die Quelle												*/
/*				INFILE: das Infile												*/
/*				bound:	falls bentigt wird hier eine boundary-Markierung		*/
/*						reingeschrieben 								*/
/*				zeichens:der Zeichensatz der fr den Export verwendet werden soll */
/*	Ergebnis:	keines												*/		
/*	18.9.01 von Dimitri Junker	DYJ 4.30t										*/
/*** ------------------------------------------------------------------------ ***/
/*DYJ 5.16j */	/*DYJ 5.17a */	/*DYJ 5.17l */	/*DYJ 5.19f */
/*DYJ 5.19g */	/*DYJ 5.20x */	/*DYJ 5.23i */	/*DYJ 5.20m */
/*DYJ 5.29c */
/*DYJ 5.34m Start*/
LOCAL _VOID writeHeaderIN(msgInfo *pMsg,TEXTFILENO INFILE,String127 bound,_WORD zeichens)
{
	_BOOL hatAnhang=FALSE;
/*DYJ  Ende; alt:	
LOCAL _BOOL writeHeaderIN(msgInfo *pMsg,TEXTFILENO INFILE,String127 bound)
{
*/
	_UBYTE msgName[PATH_MAX];
	_UBYTE tmpName[PATH_MAX];
	_UBYTE *punyC;	/*DYJ 5.39e */
	_UWORD cDt, cTi;
	_UBYTE alt[512];
	_WORD i;
	_UBYTE nameAbs[2][256],*realNamePtr=NULL;
	_BOOL isPM=TRUE;
	i=0;
	if (pMsg->Absender != NULL && pMsg->Absender[0] != '\0')
	{
		do	/*Anstelle des Realname kann auch eine Adresse stehen, die anstelle der anderen benutzt werden soll*/
		{
			if(adr_getRealNameOfAlias(nameAbs[i],sizeof(nameAbs[i]),pMsg->Absender))
			{
				if(strChr(nameAbs[i],'@'))
				{
					pMsg->Absender=nameAbs[i];
					i=1-i;
				}
				else
					realNamePtr=nameAbs[i];
			}
			else
				realNamePtr=userRName;
		}while(!realNamePtr);
	}

	/* Jetzt Id fuer Maus erstellen */
	Messages_Number2Name(pMsg->info.number, msgName, sizeof(msgName));
	SPEC_DEBUG_OUT((EO_TRACE, "Message: %s", msgName));
	/* Jetzt Id fuer in2cat erstellen */
	Messages_MakeMausId(pMsg, tmpName, sizeof(tmpName));
	/* So, und jetzt ab ins Infile damit */
	
	LineOutInH(INFILE,2, "#",tmpName);

/*DYJ 5.39e Start*/
	if (pMsg->Absender != NULL && pMsg->Absender[0] != '\0')
		punyC=punycodeAdr(pMsg->Absender);
	else
		punyC=punycodeAdr(userAddr);
/*DYJ  Ende; */


	switch (pMsg->info.msgType)
	{
	case msg_groupcomment:
	case msg_mail:
	case msg_comment:
		LineOutInH(INFILE,2, "iCatGroup: ", pMsg->group);
		isPM=FALSE;
		break;
	case msg_persanswer:
	case msg_private:
	case msg_answer:
/*DYJ 5.34d Start*/
	case msg_pseudoNews:
	case msg_pseudoKom:
		if(pMsg->info.msgType==msg_pseudoKom||pMsg->info.msgType==msg_pseudoNews)
			LineOutInH(INFILE,1, "iCatPMPseudo");
		else
			LineOutInH(INFILE,1, "iCatPM");
/*DYJ  Ende; alt:	
		LineOutInH(INFILE,1, "iCatPM");
*/
		mtTextfiles_WriteLine(INFILE, "MAIL From:<");
/*DYJ 5.39e Start*/
		LineOut(INFILE, punyC,">");
/*DYJ  Ende; alt:	
		if (pMsg->Absender != NULL && pMsg->Absender[0] != '\0')
			LineOut(INFILE,pMsg->Absender,">");
		else
			LineOut(INFILE, userAddr,">");
*/
		wRCPT(pMsg->receiver,INFILE);
		wRCPT(pMsg->cc,INFILE);
		wRCPT(pMsg->bcc,INFILE);

		mtTextfiles_WriteLn(INFILE);
		break;
	}
/*DYJ 5.39e Start*/
	if (pMsg->Absender != NULL && pMsg->Absender[0] != '\0')
	{
		if(realNamePtr && *realNamePtr)
			LineOutInH(INFILE,5,"From: ", Mime_CodeWord(alt,sizeof(alt),realNamePtr)," <", punyC,">");
		else
			LineOutInH(INFILE,3, "From: <", punyC,">");
	}
	else
	{
		if(*userRName)
			LineOutInH(INFILE,5,"From: ", Mime_CodeWord(alt,sizeof(alt),userRName)," <", punyC,">");
		else
			LineOutInH(INFILE,3, "From: <", punyC,">");
	}
	free(punyC);
/*DYJ  Ende; alt:	
	if (pMsg->Absender != NULL && pMsg->Absender[0] != '\0')
	{
		if(realNamePtr && *realNamePtr)
			LineOutInH(INFILE,5,"From: ", Mime_CodeWord(alt,sizeof(alt),realNamePtr)," <", pMsg->Absender,">");
		else
			LineOutInH(INFILE,3, "From: <", pMsg->Absender,">");
	}
	else
	{
		if(*userRName)
			LineOutInH(INFILE,5,"From: ", Mime_CodeWord(alt,sizeof(alt),userRName)," <", userAddr,">");
		else
			LineOutInH(INFILE,3, "From: <", userAddr,">");
	}
*/
	/* Jetzt kommen die weiteren Infos */
	switch (pMsg->info.msgType)
	{
	case msg_persanswer:
	case msg_private:
	case msg_answer:
	case msg_pseudoNews:	/*DYJ 5.34d */
	case msg_pseudoKom:	/*DYJ 5.34d */
		if(pMsg->realName && *pMsg->realName && strChr(pMsg->realName,'@')==NULL)
			LineOutInH(INFILE,-3,"To: ", Mime_CodeWord(alt,sizeof(alt),pMsg->realName)," ");
		else
			LineOutInH(INFILE,-1, "To: ");
		wAdrLst(pMsg->receiver,INFILE);
		if(pMsg->cc && *pMsg->cc)
		{
			LineOutInH(INFILE,-1, "Cc: ");
			wAdrLst(pMsg->cc,INFILE);
		}
		if(pMsg->bcc && *pMsg->bcc)
			LineOutInH(INFILE,1, "Bcc: ");
/*DYJ 5.34d Start*/
/*DYJ 5.39c Start*/
		if ((pMsg->info.msgType==msg_answer||pMsg->info.msgType==msg_pseudoKom) && !pMsg->info.noRefLine && strCmp(pMsg->refId,UnknID))
/*DYJ  Ende; alt:	
		if ((pMsg->info.msgType==msg_answer||pMsg->info.msgType==msg_pseudoKom) && !pMsg->info.noRefLine)
*/
/*DYJ  Ende; alt:	
		if (pMsg->info.msgType==msg_answer && !pMsg->info.noRefLine)
*/
/*DYJ 5.39e Start*/
		{
			punyC=punycodeAdr(pMsg->refId);
			if(strChr(pMsg->refId,'<'))
				LineOutInH(INFILE,2, "In-Reply-To: ", punyC);
			else
				LineOutInH(INFILE,3, "In-Reply-To: <", punyC,">");
			free(punyC);
		}
/*DYJ  Ende; alt:	
			if(strChr(pMsg->refId,'<'))
				LineOutInH(INFILE,2, "In-Reply-To: ", pMsg->refId);
			else
				LineOutInH(INFILE,3, "In-Reply-To: <", pMsg->refId,">");
*/
		LineOutInH(INFILE,4, "X-Mailer: ",CAT_PROGNAME," ",Mime_CodeWord(alt,sizeof(alt),CatVersion));
		
		break;
	case msg_comment:
	case msg_groupcomment:
/*DYJ 5.39e Start*/
		punyC=punycodeAdr(pMsg->ref);
		if(strChr(pMsg->ref,'<'))
			LineOutInH(INFILE,2, "References: ", pMsg->ref);
		else
			LineOutInH(INFILE,3, "References: <", pMsg->ref,">");
		free(punyC);
/*DYJ  Ende; alt:	
		if(strChr(pMsg->ref,'<'))
			LineOutInH(INFILE,2, "References: ", pMsg->ref);
		else
			LineOutInH(INFILE,3, "References: <", pMsg->ref,">");
*/
	case msg_mail:
		LineOutInH(INFILE,2, "Newsgroups: ", pMsg->group);
		if (pMsg->followupTo != NULL && pMsg->followupTo[0] != '\0')
		{
			LineOutInH(INFILE,2, "Followup-To:", pMsg->followupTo);
		}
		LineOutInH(INFILE,4, "X-Newsreader: ",CAT_PROGNAME," ",Mime_CodeWord(alt,sizeof(alt),CatVersion));
		break;
	}
	if (pMsg->topic != NULL && pMsg->topic[0] != '\0')
		LineOutInH(INFILE,2, "Subject: ", Mime_CodeWord(alt,sizeof(alt),pMsg->topic));
	if (UserBLK.MessageDateInInfile)
	{
		/* Datum der Nachricht nehmen */
		Messages_Number2Name(pMsg->info.number, msgName, sizeof(msgName));
		strBcat(msgName, textExt);
		Messages_FileSize(MessagePath, msgName, &cDt, &cTi);
		/* Die Infos haben wir oben schon geholt */
	} else
	{
		cDt=Tgetdate();
		cTi=Tgettime();
	}
	/* Jetzt Datum bauen */
	ConvertDate_MakeInDate(cDt, cTi, alt, sizeof(alt));
	ConvertDate_MakeFreeDate(Tgetdate(), Tgettime(), tmpName, sizeof(tmpName));
	/* DATE-Zeile in Header sichern */
	SetHeaderLine(&pMsg->date, tmpName);
	Messages_WriteHdrInfo(pMsg);
	/* und ausgeben in Infile */
	LineOutInH(INFILE,2, "Date: ", alt);

/*DYJ 5.39e Start*/
	if (pMsg->replyTo != NULL && pMsg->replyTo[0] != '\0')
	{
		punyC=punycodeAdr(pMsg->replyTo);
		LineOutInH(INFILE,2, "Reply-to: ", punyC);
		free(punyC);
	}
	if (pMsg->sender != NULL && pMsg->sender[0] != '\0')
	{
		punyC=punycodeAdr(pMsg->sender);
		LineOutInH(INFILE,2, "Sender: ", punyC);
		free(punyC);
	}
/*DYJ  Ende; alt:	
	if (pMsg->replyTo != NULL && pMsg->replyTo[0] != '\0')
	{
		LineOutInH(INFILE,2, "Reply-to: ", pMsg->replyTo);
	}
	if (pMsg->sender != NULL && pMsg->sender[0] != '\0')
	{
		LineOutInH(INFILE,2, "Sender: ", pMsg->sender);
	}
*/
	writeHeaderXorFooter(INFILE,TRUE,isPM);
	LineOutInH(INFILE,1, "MIME-Version: 1.0");
	if (pMsg->attachment != NULL && pMsg->attachment[0]> '0')
	{
		LineOutInH(INFILE,1,"Content-Type: multipart/mixed;");
		sprintf(bound,"------------cat%s%s%s%s",
			ltoa(Gettime(),tmpName,36),		/*Datum+Uhrzeit*/
			ltoa(clock(),tmpName+10,36),						/*Laufzeit des Rechners*/
			ltoa((_LONG)bound,tmpName+20,36),					/*Speicheradresse*/
			ltoa((_LONG)Malloc(-1),tmpName+30,36));			/*freier Speicher*/
		LineOutInH(INFILE,3," boundary=\"",bound,"\"");
		mtTextfiles_WriteLn(INFILE);
		LineOutInH(INFILE,1,"Dies ist eine mehrteilige Nachricht im MIME-Format.");
		LineOutInH(INFILE,2,"--",bound);
		hatAnhang=TRUE;	/*DYJ 5.34m */
	}
/*DYJ 5.34m Start*/
	if(zeichens!=US_ASCII ||hatAnhang)
	{
/*DYJ 5.38a Start*/
		if(zeichens==WINDOWS1252 && CP1252Mode==2)
			LineOut(INFILE,"M1.0; Content-Type: text/plain; charset=",cMIME_Iso[ISO8859_1]);
		else
			LineOutInH(INFILE,2,"Content-Type: text/plain; charset=",cMIME_Iso[zeichens]);
/*DYJ  Ende; alt:	
		LineOutInH(INFILE,2,"Content-Type: text/plain; charset=",cMIME_Iso[zeichens]);
*/
		LineOutInH(INFILE,1,"Content-Transfer-Encoding: quoted-printable");
	}
	mtTextfiles_WriteLn(INFILE);
/*DYJ  Ende; alt:	
	LineOutInH(INFILE,1,"Content-Type: text/plain; charset=iso-8859-1");
	LineOutInH(INFILE,1,"Content-Transfer-Encoding: quoted-printable");
	mtTextfiles_WriteLn(INFILE);
	return TRUE;
*/
}
/*** ---------------------------------------------------------------------- ***/

/*DYJ 5.16k */	/*DYJ 5.17b */ /*DYJ 5.20m */	/*DYJ 5.21b */
/*DYJ 5.21i */	/*DYJ 5.23i */
GLOBAL _BOOL MsgInfile_MakeInFile(_VOID)
{
	TEXTFILENO InHandle;
	TEXTFILENO INFILE;
	_WORD res;
	_WORD i;
	_UBYTE numStr[256];
	msgInfo msg;
	_UBYTE alt[512];
	_UBYTE tmpName[PATH_MAX];
	_UBYTE msgName[PATH_MAX];
	String127 bound="";
	_ULONG msg_Size;
	_BOOL isDa;
	_UWORD cDt, cTi;
	_WORD itkCmdMax;
	_UBYTE *itkCmdVal;
	_BOOL firstCmd;
/*DYJ 5.34m Start*/
/*DYJ  Ende; alt:	
	_BOOL ok;
*/
	
	SPEC_DEBUG_OUT((EO_DEBUG, "creating infile"));
	Wind_Update(END_UPDATE);
	/* Pre-Messages Filter aufrufen */
	isDa = FALSE;
	if (IoFilter_IoFilterMessage(&isDa))
	{
		Messages_ReReadMessageInfo();
	} else if (isDa)
	{
		/* Fehler aufgetreten */
		Wind_Update(BEG_UPDATE);
		MouseArrow();
		return FALSE;
	}
	HandleEvents();

	/* Jetzt Infile.txt erstellen */
	if (!TrickyOpen(ARCName[0] == '\0' ? ExportPath : MessagePath, INFILE_NAME, WRITE, 16384, &INFILE))
	{
		MouseArrow();
		sprintf(tmpName, Rsc_WrkString(MTE_noFileWrite), INFILE_NAME);
		MTE_info(tmpName);
		Wind_Update(BEG_UPDATE);
		return FALSE;
	}
	
	CatGlobal_busyMouse();
	HandleEvents();
	
	Wind_Update(BEG_UPDATE);
	VDIStandards_enableOrDisableMenu(TRUE);
	Wind_Update(END_UPDATE);

	
	firstCmd = TRUE;
		
	if (UserBLK.GroupChangesInInfile)  /* zuerst die Gruppenummeldungen */
	{
		isDa = GroupSelect_GetGroupChange(numStr, GFIRST);
		SPEC_DEBUG_OUT((EO_TRACE, "%sgroup changes", isDa ? "" : "no "));
		while (isDa)
		{
			CmdOut(INFILE, ":G", numStr, &firstCmd);
			isDa = GroupSelect_GetGroupChange(numStr, GNEXT);
		}
		/* So, und das hier muss trotzdem da bleiben, da man sonst keine User mehr
		 * eintragen kann!
		 */
		if (TrickyOpen(MessagePath, grSelect, READ, 2048, &InHandle))
		{
			CmdOut(INFILE, "", "", &firstCmd);
/*DYJ 5.34m Start*/
			Mime_TransferQP(InHandle, INFILE, '\0',ISO8859_1);
/*DYJ  Ende; alt:	
			Mime_TransferQP(InHandle, INFILE, '\0');
*/
			mtTextfiles_CloseTextfile(&InHandle);
		}
	}
	
	if (UserBLK.RequestInfofiles)
	{
		Infofiles_LoadInfoInf(FALSE, FALSE);
		isDa = Infofiles_GetInfoCrc(numStr, IFIRST);
		SPEC_DEBUG_OUT((EO_TRACE, "%sinfofiles", isDa ? "" : "no "));
		while (isDa)
		{
			CmdOut(INFILE, ":", numStr, &firstCmd);
			isDa = Infofiles_GetInfoCrc(numStr, INEXT);
		}
	}
	
	if (ConfVars_GetConfigInt(cMTCmdMaxIdent, &itkCmdMax))
	{
		itkCmdVal = MALLOC(1024, "MakeInfile: itkCmdVal");
		if (itkCmdVal != NULL)
		{
			for (i = 0; i <= itkCmdMax; i++)
			{
				make_varname(tmpName, sizeof(tmpName), cMTCmd, i);
				if (ConfVars_GetConfigString(tmpName, itkCmdVal, 1024) &&
					*itkCmdVal != '\0')
				{
					/* Kommando vorhanden */
					/* Kommandoversion wird nicht abgefragt und verglichen, da ITK
					 * momentan nicht im Speicher
					 */
					if (i == 8)
					{
						/* Maximallaenge einstellen */
						if (strCmp(itkCmdVal, "M0") == 0 ||
							strCmp(itkCmdVal, "M+0") == 0)
						{
							GetFreeSpace(numStr, sizeof(numStr),TRUE);
							CmdOut(INFILE, ":M", numStr, &firstCmd);
						} else if (itkCmdVal[1] != '\0')
						{
							CmdOut(INFILE, ":", itkCmdVal, &firstCmd);
						}
					} else
					{
						CmdOut(INFILE, ":", itkCmdVal, &firstCmd);
					}
				}
			}
			SFREE(itkCmdVal);
		}
	}
	if(UserBLK.isInternet)
	{
		int anzPm=0,anzOm=0;
		char txt[100];
		for (i = 0; i < messages; i++)
		{
			if(msgArray[i].info.sendMsg)
			{
				switch (msgArray[i].info.msgType)
				{
					case msg_groupcomment:
					case msg_mail:
					case msg_comment:
						anzOm++;
						break;
					case msg_persanswer:
					case msg_private:
					case msg_answer:
					case msg_pseudoKom:	/*DYJ 5.34d */
					case msg_pseudoNews:	/*DYJ 5.34d */
						anzPm++;
						break;
				}
			}
		}
		sprintf(txt,"I2A %d,%d",anzPm,anzOm);
		CmdOut(INFILE, ":", txt, &firstCmd);
		
	}

	
	if (TrickyOpen(MessagePath, userCmdFile, READ, 2048, &InHandle))
	{
		CmdOut(INFILE, "", "", &firstCmd);
/*DYJ 5.34m Start*/
		Mime_TransferQP(InHandle, INFILE, '\0',ISO8859_1);
/*DYJ  Ende; alt:	
		Mime_TransferQP(InHandle, INFILE, '\0');
*/
		mtTextfiles_CloseTextfile(&InHandle);
	}

	HandleEvents();
	for (i = 0; i < messages; i++)
	{
		msgArray[i].isSend = FALSE;
		msgArray[i].selected = FALSE;
	}
	MsgWindow_MsgDeselectAll();
	
	if (UserBLK.StatusMessagesInInfile)
	{
		SPEC_DEBUG_OUT((EO_TRACE, "status infos"));
		/* zuerst die Statusmeldungen */
		if (TrickyOpen(MessagePath, statusInf, READ, 2048, &InHandle))
		{
/*DYJ 5.34m Start*/
			Mime_TransferQP(InHandle, INFILE, '\0',ISO8859_1);
/*DYJ  Ende; alt:	
			Mime_TransferQP(InHandle, INFILE, '\0');
*/
			mtTextfiles_CloseTextfile(&InHandle);
		}
		
		/* Jetzt die Statusmeldungen fuer kopierte oder weitergeleitete Messages */
		for (i = 0; i < messages; i++)
		{
			CatGlobal_busyMouse();
			msg = msgArray[i];
			if (msg.info.sendMsg &&
				!msg.info.toDelete &&
				(msg.info.msgType == msg_copyOther ||
				 msg.info.msgType == msg_forward))
			{
				if (Messages_ReadHdrInfo(&msg, TRUE))
				{
					LineOut(INFILE, "#", msg.refId);
					mtTextfiles_WriteChar(INFILE, 'B');
					if (msg.info.msgType == msg_forward)
						mtTextfiles_WriteChar(INFILE, 'W');
					else
						mtTextfiles_WriteChar(INFILE, 'K');
					mtTextfiles_WriteLn(INFILE);
					LineOut(INFILE, "K", msg.receiver);
					if (msg.topic != NULL && msg.topic[0] != '\0')
					{
						LineOut(INFILE, ">", msg.topic);
					}
					msg.isSend = TRUE;
					msgArray[i] = msg;
				}
			}
		}
	}
	
	if (UserBLK.MessagesInInfile)
	{
		/* Jetzt die einzelnen Messages der Reihe nach transferieren.
		 * Wenn eine zu gross werden wuerde (Grenze: 14 kB, da Tabs!),
		 * dann wird nachgefragt, ob die Nachricht automatisch
		 * gesplittet werden soll, andernfalls wird die nicht versandt!
		 */
		SPEC_DEBUG_OUT((EO_TRACE, "messages"));
		i = 0;
		while (i < messages)
		{
			msg = msgArray[i];
			if (msg.info.sendMsg &&
				!msg.info.toDelete &&
				!msg.isSend &&
				msg.info.msgType != msg_copyOwn)
			{
				CatGlobal_busyMouse();
				/* bei Mausmails hier vor dem Splitten die Anhnge hinzufgen, bei Internetmails erst
					spter wenn die Boundary ermittelt ist	*/
				/* UU-kodierte Anhnge immer hier hinzufgen*/
				if(Messages_ReadHdrInfo(&msg, TRUE))
				{
					if((msg.attachment         && *msg.attachment)&&
					   (msg.attachment[1]=='U' || !UserBLK.isInternet))
					{
						TEXTFILENO f;
						Messages_Number2Name(msg.info.number, msgName, sizeof(msgName));
						strBcpy(tmpName, MessagePath);
						F_Path_Append(tmpName, msgName);
						strCpy(msgName,tmpName);
						strBcat(tmpName, textExt);
						if (mtTextfiles_OpenTextfile(tmpName, APPEND, 16384, &f) == GERR_OK)
						{
							mtTextfiles_WriteLn(f);
							Mime_WriteAttachments(f,NULL,msgName,msg.attachment,3);
							mtTextfiles_CloseTextfile(&f);
							msg.attachment[0]='0';
						}
					}
				}
				/* Erst mal testen, ob die Mail zu gross wuerde */
				Messages_Number2Name(msg.info.number, msgName, sizeof(msgName));
				strBcat(msgName, textExt);
				msg_Size = Messages_FileSize(MessagePath, msgName, &cDt, &cTi);
				if (UserBLK.splitSize > 0 && msg_Size > UserBLK.splitSize)
				{
					if (UserBLK.AutomaticSplit)
					{
						res = 1;
					} else
					{
						if (!batchProcess)
						{
							Messages_Number2Name(msg.info.number, tmpName, sizeof(tmpName));
							sprintf(alt, MausTauschrsc_WrkString(AL_SPLIT_LONG_MSG), tmpName);
							res = MTE_info(alt);
						} else
						{
							res = 2;
						}
					}
					if (res == 1)
					{
						splitMessage(&i, &msg);
					} else
					{
						msg.info.sendMsg = FALSE;
						msgArray[i] = msg;
					}
					HandleEvents();
				}
			}
			++i;
		}
		Messages_SortMessages();
		
		/* Und jetzt die Messages alle ins Infile packen */
		for (i = 0; i < messages; i++)
		{
			msg = msgArray[i];
			if (msg.info.msgType == msg_copyOwn && UserBLK.isInternet)
			{
				/* Keine Kopien nach Mausmanier mehr fr's Internet! Abbruch und Fehlermeldung! */
				mtTextfiles_CloseTextfile(&INFILE);
				/* Menu wieder anschalten */
				Wind_Update(BEG_UPDATE);
				VDIStandards_enableOrDisableMenu(FALSE);
				MouseArrow();
				MTE_infoRSC(Al_NOMausCpy);
				return FALSE;
			}
			else if (msg.info.sendMsg &&
				!msg.isSend &&
				msg.info.msgType != msg_copyOwn)
			{
				CatGlobal_busyMouse();
				HandleEvents();
				/* Headerinfo schreiben */
				if (Messages_ReadHdrInfo(&msg, TRUE))
				{
/*DYJ 5.34m Start*/
					/* Jetzt Messagetext oeffnen */
					Messages_Number2Name(msg.info.number, msgName, sizeof(msgName));
					strBcat(msgName, textExt);
					if (TrickyOpen(MessagePath, msgName, READ, 16348, &InHandle))
					{
						_WORD zeichens;
						if(UserBLK.isInternet)
						{
							zeichens=Mime_FindFilt4Send(InHandle);
							writeHeaderIN(&msg,INFILE,bound,zeichens);
							Mime_TransferQP(InHandle, INFILE, '.',zeichens);
						}
						else
						{
							_WORD mcm;
							ConfVars_GetConfDefInt(cMausCharsetMode, &mcm,0);
							if(mcm)
								zeichens=Mime_FindFilt4Send(InHandle);
							else
/*DYJ 5.39a Start*/
								zeichens=ZS_ATARI;
/*DYJ  Ende; alt:	
								zeichens=ATARI;
*/
							writeHeaderMaus(&msg,INFILE,zeichens);
							Mime_TransferQP(InHandle, INFILE, ':',zeichens);
						}
						mtTextfiles_CloseTextfile(&InHandle);
/*DYJ  Ende; alt:	
					if(UserBLK.isInternet)
						ok=writeHeaderIN(&msg,INFILE,bound);
					else
						ok=writeHeaderMaus(&msg,INFILE);
					/* Jetzt Messagetext oeffnen */
					Messages_Number2Name(msg.info.number, msgName, sizeof(msgName));
					strBcat(msgName, textExt);
					if (ok && TrickyOpen(MessagePath, msgName, READ, 16348, &InHandle))
					{
						if(UserBLK.isInternet)
							Mime_TransferQP(InHandle, INFILE, '.');
						else
							Mime_TransferQP(InHandle, INFILE, ':');
						mtTextfiles_CloseTextfile(&InHandle);
*/
						if (msg.info.msgType == msg_comment ||
							msg.info.msgType == msg_groupcomment ||
							msg.info.msgType == msg_mail)
						{
							if (msg.group != NULL &&
								strSortCmp(msg.group, devGroup) == 0)
							{
								if(UserBLK.isInternet)
								{
									LineOut(INFILE,"-- ","");
									mtTextfiles_WriteLine(INFILE, CAT_PROGNAME " " CatVersion);
								}
								else
								{
									LineOut(INFILE, ":", "-- ");
									mtTextfiles_WriteLine(INFILE, ":" CAT_PROGNAME " " CatVersion);
								}
								if (ConfVars_GetConfigString("MausTauschVersionName", numStr, sizeof(numStr)) &&
									numStr[0] != '\0')
								{
									mtTextfiles_WriteLine(INFILE, " ");
									mtTextfiles_WriteLine(INFILE, numStr);
								}
								mtTextfiles_WriteLine(INFILE, " vom " CatDate);
								mtTextfiles_WriteLn(INFILE);
							}
							writeHeaderXorFooter(INFILE,FALSE,FALSE);
						}
						else
							writeHeaderXorFooter(INFILE,FALSE,TRUE);
						if(UserBLK.isInternet)
						{
							Messages_Number2Name(msg.info.number, msgName, sizeof(msgName));
							strBcpy(tmpName, MessagePath);
							F_Path_Append(tmpName, msgName);
							Mime_WriteAttachments(INFILE,bound,tmpName,msg.attachment,1);
							LineOut(INFILE, ".", "");
						}
						msg.isSend = TRUE;
					} else
					{
						/* Header schon geschrieben! Abbruch und Fehlermeldung! */
						mtTextfiles_CloseTextfile(&INFILE);
						/* Menu wieder anschalten */
						Wind_Update(BEG_UPDATE);
						VDIStandards_enableOrDisableMenu(FALSE);
						MouseArrow();
						sprintf(alt, MausTauschrsc_WrkString(AL_ERROR_WITH_INFILE), msgName);
						MTE_info(alt);
						return FALSE;
					}

				} else
				{
					/* Fehlermeldung bringen! */
					Messages_Number2Name(msg.info.number, msgName, sizeof(msgName));
					strBcat(msgName, headerExt);
					sprintf(alt, MausTauschrsc_WrkString(AL_ERROR_WITH_INFILE), msgName);
					MTE_info(alt);
				}
				msgArray[i] = msg;
			}
		}
		
	}
	
	/* >> Aenderung von Frank Roeske <<                            */
	/* Datum: 06.04.1998, 01:40                                    */
	/* Aufruf der Routine AppendUPL(INFILE, PfadZumUPLTXT)         */
	if(!UserBLK.isInternet)	/*DYJ 5.34m */
		AppendUPL(INFILE, MessagePath);
	
	mtTextfiles_WriteChar(INFILE, '#');
	mtTextfiles_WriteLn(INFILE);
	mtTextfiles_CloseTextfile(&INFILE);

	HandleEvents();
	
	/*
	 * Jetzt vor dem Einpacken eventuelle andere Filter aufrufen
	 */
	if (!IoFilter_IoFilterInfile())
	{
		MouseArrow();
		/* Menu wieder anschalten */
		Wind_Update(BEG_UPDATE);
		VDIStandards_enableOrDisableMenu(FALSE);
		return FALSE;
	}
	HandleEvents();
	
	if (ARCName[0] != '\0')
	{
		SPEC_DEBUG_OUT((EO_DEBUG, "packing infile"));
		res = ARCStarter_Archive();
		SPEC_DEBUG_OUT((EO_DEBUG, "Returncode: %d", res));
		EventTimer(400L);
		if (res != 0)
		{
			/* Menu wieder anschalten */
			Wind_Update(BEG_UPDATE);
			VDIStandards_enableOrDisableMenu(FALSE);
			if (!batchProcess)
			{
				MouseArrow();
				MTE_numAlert(res, MausTauschrsc_WrkString(AL_PEXEC_ERROR));
			}
			return FALSE;
		}
	}
	/* Menu wieder anschalten */
	Wind_Update(BEG_UPDATE);
	VDIStandards_enableOrDisableMenu(FALSE);
	Protokoll_SendPathUpdate(MessagePath);
	Protokoll_SendPathUpdate(ExportPath);
	MouseArrow();
	return TRUE;
}
