/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 *
 * 16.3.03 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.23b'
 *	Speichern unter kann jetzt auch in Datenbankfiles speichern (*.par +*.dat)
 *
 * 28.3.03 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.23k'
 *	defekte Nachrichten konnten in der SWL zu einer unendichen Anzeige
 *	der Fehlermeldung fhren.
 *
 * 6.10.03 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.31a'
 *	Beim Einfgen sebst erzeugter Outfiles wurden teils Headerzeilen
 *	verstmmelt.
 *
 */


#include <msglist.h>
#include <catvers.h>
#include <data.h>
#include <edittype.h>
#include <mte.h>
#include <vdiutil.h>
#include <cattypes.h>
#include <handlepo.h>
#include <confvars.h>
#include <varname1.h>
#include <varn_ede.h>
#include <wdwmanag.h>
#include <catgloba.h>
#include <fontsele.h>
#include <catfiles.h>
#include <quicksor.h>
#include <grin.h>
#include <grintool.h>
#include <zsearchd.h>
#include <groupsel.h>
#include <clip.h>
#include <searchhe.h>
#include <convertd.h>
#include <uudecode.h>
#include <protokol.h>
#include <msglistb.h>
#include <treelist.h>
#include <grin.h>

#include <mtappl.h>
#include <mtarea.h>
#include <mtutils.h>
#include <mtpopups.h>
#include <mttextfi.h>
#include <mtxobjec.h>
#include <mtdir.h>

#include <rectfunc.h>
#include <routinec.h>
#include <routines.h>
#include <strconv.h>
#include <file_io.h>
#include <keyboard.h>
#include <userinfo.h>
#include <messages.h>

#include <tos.h>
#include <time.h>
#include <mime.h>
#include <windials.h>
#include <maustaus.h>
#include <cathelp.h>
#include <mtrsc.h>
#include <s_endian.h>
#include <ZCALCCRC.H>

typedef struct {
	_BOOL isAttach;
	_BOOL isStatus;
	_WORD isType;
	_WORD exitBut;
	_BOOL askStatus;
	_BOOL allowDB;
} grChangeInfo;


#define CR '\r'
#define LF '\n'

LOCAL partArrayDesc privateParts;
LOCAL partArrayDesc globalParts;

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

/* ---------------------- Font-Funktionen ----------------------- */

/* Setzt den Font fuer das Stichwortlistenfenster */

LOCAL _VOID iListSetFont(HWND wdw, _WORD fnt, _WORD fntSize, _BOOL redraw)
{
	GRECT r;
	listWindow *ptr;
	_UBYTE varName[256];
	
	if ((ptr = MsgListBase_FindWind(wdw)) != NULL)
	{
		ptr->font = fnt;
		ptr->fontSize = fntSize;
		FontSelect_SetFont(ptr->vdi, &ptr->font, &ptr->fontSize, TRUE, &ptr->monoSpaced, &ptr->isFSM, &ptr->charWidth, &ptr->charHeight);
		ptr->maxWidth = ptr->partArray.width * ptr->charWidth;
		/* Jetzt ist der Font gesetzt. Jetzt noch Window snappen und dann neu
		 * zeichnen lassen
		 */
		make_varname(varName, sizeof(varName), cListFont, ptr->number);
		ConfVars_SetConfigInt(varName, ptr->font);
		make_varname(varName, sizeof(varName), cListFontSize, ptr->number);
		ConfVars_SetConfigInt(varName, ptr->fontSize);
		WdwManager_SetDocumentParms(ptr->wdw, 1, ptr->charHeight + msglist_lineDist);
		WdwManager_GetWdwSize(wdw, &r);
		WdwManager_SetWdwSize(wdw, &r);
		r = ptr->listWork;
		r.g_x += msglist_pixOffset;
		if (redraw)
			WdwManager_RedrawWdw(wdw, &r);
	}
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

/*-------------- exportierte Funktionen -----------------------*/

typedef struct  {
	listWindow *ptr;
	_BOOL setReadFlag;
} unselInfo;

LOCAL _BOOL unselTree(OneGroupHandle handle, MSGNR msgIdx, pBlock *mess, _VOID *private)
{
	MSGNR i;
	listWindow *ptr;
	unselInfo *info;
	
	info = private;
	ptr = info->ptr;
	if (info->setReadFlag)
	{
		mess->bits |= bGelesen;
		if (data_SetBits(handle, msgIdx, mess->bits) != NoError)
			return FALSE;
	}
	/* First try normal list */
	if (msgIdx < ptr->maxPos && ptr->list[msgIdx].msgNum == msgIdx)
	{
		i = msgIdx;
	} else
	{
		/* Not found, search from end */
		i = ptr->maxPos;
		for (;;)
		{
			if (i == 0)
				return TRUE;
			--i;
			if (ptr->list[i].msgNum == msgIdx)
				break;
		}
	}
	ptr->list[i].flags &= ~(msglist_Selected | msglist_inTree);
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

/* Entfernt den Baum mit der Nachricht msgNum aus der Liste im Fenster
 * wdw, falls das grinWdw uebereinstimmt
 */

GLOBAL _VOID msgList_listRemoveTree(LISTHANDLE hdl, HWND grinWdw, MSGNR msgNum, _BOOL setReadFlag)
{
	listWindow *ptr;
	MSGNR idx;
	unselInfo info;
	
	if ((ptr = MsgListBase_FindHandle(hdl)) != NULL)
	{
		if (grinWdw != ptr->grinWindow)
			return;
		if (MsgListBase_findMsgIdx(ptr, msgNum, &idx))
		{
			/* Erstmal Baum deselektieren */
			info.ptr = ptr;
			info.setReadFlag = setReadFlag;
			
			data_WalkTree(ptr->grHandle->Zugriff, msgNum, TRUE, unselTree, &info);
			/* Die aktuelle darf nicht entfernt werden, da sonst
			 * listNextMess nicht funktioniert
			 */
			ptr->list[idx].flags |= msglist_Selected;
			/* Und jetzt Liste verkleinern */
			if (!MsgListBase_shrinkList(ptr, FALSE, TRUE))
				WdwManager_FullRedrawWdw(ptr->wdw);
		}
	}
}

/*** ---------------------------------------------------------------------- ***/

/* grin teilt der Stichwortliste mit, dass sich bei einer Nachricht
 * die Flags geaendert haben
 */

typedef struct _listChangeInfo {
	CAT_GROUP_NUMBER group;
	MSGNR msgNum;
	MSGBITS newBits;
} listChangeInfo;

LOCAL _BOOL iListChangeFlags(_VOID *e, _VOID *i)
{
	listChangeInfo *info;
	listWindow *ptr;
	MSGNR idx;
	
	info = i;
	ptr = e;
	if (ptr->grHandle->group == info->group)
	{
		if (MsgListBase_findMsgIdx(ptr, info->msgNum, &idx))
		{
			if (info->newBits & bGelesen)
				ptr->list[idx].flags &= ~msglist_notRead;
			else
				ptr->list[idx].flags |= msglist_notRead;
			/* Eintrag muss komplett neu gezeichnet werden */
			ptr->list[idx].flags |= msglist_doRedraw;
		}
	}
	return FALSE;
}
GLOBAL _VOID msgList_listChangeFlags(CAT_GROUP_NUMBER group, MSGNR msgNum, MSGBITS newBits)
{
	listChangeInfo info;
	
	info.group = group;
	info.msgNum = msgNum;
	info.newBits = newBits;
	Lists_ResetList(&MsgList_windows);
	Lists_ScanEntries(&MsgList_windows, Lists_forward, iListChangeFlags, &info);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL msgList_ChangeFont(HWND wdw, _WORD font, _WORD fontSize, _BOOL isMono)
{
	UNUSED(isMono);
	msgList_listSetFont(wdw, font, fontSize);
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL msgList_ChangeColor(HWND wdw, _WORD color)
{
	UNUSED(wdw);
	ConfVars_SetConfigInt(cListTextCol, color);
	msgList_listRedrawAll();
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID msgList_GetSettings(listWindow *ptr)
{
	_WORD listNotReadEff;
	_WORD listOwnEff;
	_WORD listC2OEff;
	_BOOL wasTmp;

	wasTmp = ConfVars_ConfigConfigModule(FALSE);
	ConfVars_GetConfDefInt(cListTextCol, &ptr->listTextCol, BLACK);
	ConfVars_GetConfDefInt(cListBackCol, &ptr->listBackCol, WHITE);
	ConfVars_GetConfDefInt(cListNotReadCol, &ptr->listNotReadCol, BLACK);
	ConfVars_GetConfDefInt(cListOwnMessCol, &ptr->listOwnCol, BLACK);
	ConfVars_GetConfDefInt(cListC2OMessCol, &ptr->listC2OCol, BLACK);
	ConfVars_GetConfDefInt(cListNotReadEffect, &listNotReadEff, 1);
	ConfVars_GetConfDefInt(cListOwnMessEffect, &listOwnEff, 1);
	ConfVars_GetConfDefInt(cListC2OMessEffect, &listC2OEff, 1);

	switch (listNotReadEff)
	{
		default:
		case 0: ptr->quoteEff = TXT_NORMAL; break;
		case 1: ptr->quoteEff = TXT_THICKENED; break;
		case 2: ptr->quoteEff = TXT_SKEWED; break;
		case 3: ptr->quoteEff = TXT_LIGHT; break;
	}
	switch (listOwnEff)
	{
		default:
		case 0: ptr->ownEff = TXT_NORMAL; break;
		case 1: ptr->ownEff = TXT_THICKENED; break;
		case 2: ptr->ownEff = TXT_SKEWED; break;
		case 3: ptr->ownEff = TXT_LIGHT; break;
	}
	switch (listC2OEff)
	{
		default:
		case 0: ptr->c2oEff = TXT_NORMAL; break;
		case 1: ptr->c2oEff = TXT_THICKENED; break;
		case 2: ptr->c2oEff = TXT_SKEWED; break;
		case 3: ptr->c2oEff = TXT_LIGHT; break;
	}
	if (Bitplanes == 1)
	{
		ptr->listNotReadCol = ptr->listTextCol;
		ptr->listOwnCol = ptr->listTextCol;
		ptr->listC2OCol = ptr->listTextCol;
		if (ptr->listTextCol != WHITE)
			ptr->listBackCol = WHITE;
		else
			ptr->listBackCol = BLACK;
	}
	
	if (GroupSelect_isPrivate(ptr->grHandle->group))
		ptr->partArray = privateParts;
	else
		ptr->partArray = globalParts;
	ConfVars_ConfigConfigModule(wasTmp);
}

/*** ---------------------------------------------------------------------- ***/

/* Ein Stichwortlistenfenster wird geoeffnet */
/*DYJ 5.21b */
GLOBAL _VOID msgList_listOpenWithProc(CAT_GROUP_NUMBER gruppe, getNumberProc whichNr, CONST _UBYTE *ID, HWND grinWdw, grin_openMode mode)
{
	listWindow *ptr;
	oneHandlePtr handlePtr;
	_UBYTE varName[128];
	_UWORD comps;
	MSGNR i;
	MSGNR which;
	_BOOL openNew;
	_WORD num;
	SearchRecordType saveVar;
	_BOOL doRedraw;
	_BOOL bool;
	_WORD sort;
	LGRECT doc;
	_BOOL reverse;
	_BOOL ListMarkBackground;
	_WORD bits,dummy;
	_WORD idemMode;
	ConfVars_GetConfDefInt(cListIdemMode, &idemMode,0);
/*DYJ  Ende; */
	
	if ((ptr = MsgListBase_FindGroup(gruppe)) != NULL)
	{
		if (ptr->wdw >= 0)
		{
			/* Gruppe schon als Stichwortfenster offen */
			WdwManager_TopWindow(ptr->wdw);
			openNew = FALSE;
		} else
		{
			openNew = TRUE;
		}
	} else
	{
		openNew = FALSE;
	}
	
	if (ptr == NULL || openNew)
	{
		/* Gruppe oeffnen und Stichwortliste anzeigen */
		if (ptr == NULL)
			if ((ptr = handlePool_BlankToList(sizeof(listWindow), &MsgList_windows)) == NULL)
				return;
		
		handlePtr = ptr->grHandle;
		if (!openNew && (handlePtr = handlePool_GetOneDatahandle(gruppe)) == NULL)
		{
			handlePool_FreeOnePtr(ptr, &MsgList_windows);
		} else
		{
			ptr->wdw = -1;
			which = whichNr(handlePtr->Zugriff, ID);
			ptr->grHandle = handlePtr;
			ptr->grinWindow = grinWdw;
			/* Fensternummer dieses Moduls herausfinden */
			ptr->number = MsgListBase_FindNum();
			make_varname(varName, sizeof(varName), cListWindowPos, ptr->number);
			if (!ConfVars_GetConfigRect(varName, &ptr->listWork))
			{
				if (ptr->number > 0)
				{
					num = ptr->number - 1;
					make_varname(varName, sizeof(varName), cListWindowPos, num);
				}
				ConfVars_GetConfDefRect(varName, &ptr->listWork, &deskSize);
				if (!rc_equal(&ptr->listWork, &deskSize))
				{
					ptr->listWork.g_x += 2 * CharWidth;
					ptr->listWork.g_y += CharHeight;
				}
				make_varname(varName, sizeof(varName), cListWindowPos, ptr->number);
				ConfVars_SetConfigRect(varName, &ptr->listWork);
			}
			ConfVars_GetConfDefInt(cListLeftOffset, &msglist_pixOffset, msglist_pixOffset);
			msglist_pixOffset = Max(0, msglist_pixOffset);
			ConfVars_GetConfDefInt(cListLineDist, &msglist_lineDist, msglist_lineDist);
			msglist_lineDist = Max(0, msglist_lineDist);
			/* Fensterkomponenten setzen */
			comps = NAME | CLOSER | FULLER | MOVER | SIZER | UPARROW | DNARROW | VSLIDE | LFARROW | RTARROW | HSLIDE;
			/* Infozeile brauchen wir nicht */
			
			if (!openNew)
			{
				MsgListBase_MakeTitle(gruppe, ptr->grName, sizeof(ptr->grName));
				ptr->maxPos = data_LastMsgOfGroup(gruppe);
				if (ptr->maxPos == dataSys_empty)
				{
					handlePool_FreeOneDataHandle(handlePtr);
					handlePool_FreeOnePtr(ptr, &MsgList_windows);
					MsgListBase_ClearNum(ptr->number);
					return;
				}
				++ptr->maxPos;
				if (which >= ptr->maxPos)
					which = ptr->maxPos - 1;
				ptr->usedByGrin = 0;
				/* Jetzt "Liste" aufbauen */
				ptr->wholeList = MALLOC(ptr->maxPos * sizeof(listEntry), "listOpenWithProc: wholeList");
				ptr->list = ptr->wholeList;
			}
			if (ptr->wholeList == NULL)
			{
				handlePool_FreeOneDataHandle(handlePtr);
				handlePool_FreeOnePtr(ptr, &MsgList_windows);
				MsgListBase_ClearNum(ptr->number);
			} else
			{
				if (!openNew)
				{
					/* Liste fuellen */
					for (i = 0; i < ptr->maxPos; i++)
					{
						ptr->wholeList[i].msgNum = i;
						ptr->wholeList[i].flags = 0;
						ptr->wholeList[i].i.treeNum = 0;
					}
				}
				ptr->charHeight  = 1;
				ptr->charWidth   = 8;
				ptr->font = -1;
				ptr->fontSize = 10;
				
				msgList_GetSettings(ptr);
				
				/* Fenster oeffnen */
				if (WdwManager_OpenWindow(
					MsgListBase_clickInListWindow,
					MsgListBase_handleListKey,
					MsgListBase_handleListTimer,
					&deskSize,
					&ptr->listWork,
					comps,
					TRUE,
					"", ptr->grName,
					MsgListBase_snapListWdw,
					MsgListBase_closeListWindow,
					MsgListBase_drawListWdw,
					MsgListBase_topListWdw,
					MsgListBase_untopListWdw,
					MsgListBase_updateListWdw,
					MsgListBase_setListWork,
					MsgListBase_getListScroll,
					MsgListBase_hideListWdw,
					msglist_pixOffset,
					ptr,
					FALSE, TRUE, TRUE, TRUE,
					idemMode!=0,
					&ptr->wdw, &ptr->vdi))
				{
					WdwManager_ClearWdw(ptr->wdw,ptr->listBackCol);
					ConfVars_GetConfDefBool(cListMarkBackground, &ListMarkBackground, FALSE);
					if (ListMarkBackground)
					{
						if (appl_xgetinfo(APG_WINDOWS, &bits, &dummy, &dummy, &dummy) == 1 &&
							(bits & 0x20))
						{
							wind_set(ptr->wdw, WF_BEVENT, 1, 0, 0, 0);
						}
					}
					/* Als DDServer installieren */
					WdwManager_WdwInstallDDServer(ptr->wdw, MsgListBase_listGetHeader, MsgListBase_listReadData);
					ptr->isHidden = FALSE;
					WdwManager_AcceptFont(ptr->wdw, msgList_ChangeFont);
					WdwManager_AcceptColor(ptr->wdw, msgList_ChangeColor);
					/* grin Bescheid sagen */
					grin_grinSetListWdw(ptr->grinWindow, grin_grinNextMess, ptr);
					/* Kein Cursor am Anfang */
					ptr->cursPos = -1;
					/* Font aus Configvariablen lesen und setzen */
					make_varname(varName, sizeof(varName), cListFont, ptr->number);
					if (!ConfVars_GetConfigInt(varName, &ptr->font))
					{
						num = Max(ptr->number - 1, 0);
						make_varname(varName, sizeof(varName), cListFont, num);
						ConfVars_GetConfDefInt(varName, &ptr->font, 1);
						make_varname(varName, sizeof(varName), cListFontSize, num);
						ConfVars_GetConfDefInt(varName, &ptr->fontSize, 10);
						
						make_varname(varName, sizeof(varName), cListFont, ptr->number);
						ConfVars_SetConfigInt(varName, ptr->font);
						make_varname(varName, sizeof(varName), cListFontSize, ptr->number);
						ConfVars_SetConfigInt(varName, ptr->fontSize);
					} else
					{
						make_varname(varName, sizeof(varName), cListFontSize, ptr->number);
						ConfVars_GetConfDefInt(varName, &ptr->fontSize, 10);
					}
					MsgListBase_findMsgIdx(ptr, which, &ptr->startPos);
					ptr->leftOffset = 0;
					ptr->maxWidth   = 0;
					
					/* Modus merken */
					ptr->unreadOrNew = (mode == mFirstNew) || (mode == mUnread);
					ptr->openMode = mode;
					ptr->isLocked = FALSE;
					doRedraw = FALSE;

					/* Fonts laden */
					FontSelect_LoadFonts(ptr->vdi);
					/* Font setzen */
					iListSetFont(ptr->wdw, ptr->font, ptr->fontSize, FALSE);
					/* Jetzt noch ein paar andere VDI-Variablen setzen */
					vsf_style(ptr->vdi, IP_SOLID);
					vsf_interior(ptr->vdi, FIS_SOLID);
					vsf_color(ptr->vdi, ptr->listBackCol);
					/* Schreibmodus setzen */
					vswr_mode(ptr->vdi, MD_REPLACE);
					
					/* Jetzt eventuell Liste verkleinern */
					ConfVars_GetConfDefBool(cListShowSmallList, &bool, FALSE);
					if (ptr->unreadOrNew && bool)
					{
						/* Liste verkleinern */
						MsgListBase_shrinkToEnd(ptr, FALSE);
						/* doRedraw = TRUE; */
					}
					/* Jetzt eventuell gefilterte rausnehmen */
					ConfVars_GetConfDefBool(cListDontShowFiltered, &bool, FALSE);
/*DYJ 5.38e Start*/
					MsgListBase_sethideFilt(bool);
					if(bool)
/*DYJ  Ende; alt:	
					if (ptr->unreadOrNew && bool)
*/
					{
						/* Gefilterte selektieren und dann Liste verkleinern */
						MsgListBase_listSelectFiltered(ptr->wdw, TRUE, FALSE);
						MsgListBase_shrinkList(ptr, TRUE, FALSE);
					}
					
					/* Jetzt mal nachsehen, ob wir auch sortieren muessen */
					ConfVars_GetConfDefInt(cListDefaultSort, &sort, sNum);
					ConfVars_GetConfDefBool(cListDefReverse, &reverse, FALSE);
					if (ptr->unreadOrNew && ((sortType)sort != sNum || reverse))
					{
						MsgListBase_setSort((sortType)sort,!reverse);
						ptr->isLocked = TRUE;
						MsgListBase_doSort(ptr, (sortType)sort,!reverse, FALSE);
						doRedraw = TRUE;
						ptr->isLocked = FALSE;
					}
					else
						MsgListLstSort=sNum;
					if (ptr->unreadOrNew)
					{
						saveVar = suchVar;
						for (i = 1; i <= 10; i++)
						{
							make_varname(varName, sizeof(varName), cListDefaultSelect, i);
							ConfVars_GetConfDefBool(varName, &bool, FALSE);
							if (bool)
							{
								ptr->isLocked = TRUE;
								/* Ok, steht auf TRUE, also selektieren */
								if (SearchHelp_getKonf(i - 1, &suchVar) &&
									SearchHelp_ValidateKonf(&suchVar))
								{
									MsgListBase_doMark(ptr, FALSE);
									doRedraw = TRUE;
								}
								ptr->isLocked = FALSE;
							}
						}
						suchVar = saveVar;
					}
					
					/* Noch ein bisschen was fuer die Window-Library */
					doc.x = ptr->leftOffset;
					doc.y = ptr->startPos;
					doc.w = ptr->maxWidth;
					doc.h = ptr->maxPos - 1;
					WdwManager_SetNewDocument(ptr->wdw, &doc, FALSE);
					if (doRedraw)
						WdwManager_FullRedrawWdw(ptr->wdw);
				} else
				{
					handlePool_FreeOneDataHandle(handlePtr);
					handlePool_FreeOnePtr(ptr, &MsgList_windows);
					MsgListBase_ClearNum(ptr->number);
					MTE_infoRSC(AL_NO_MSG_WINDOW);
				}
			}
		}
	}
}

/*** ---------------------------------------------------------------------- ***/

/* Ein Stichwortlistenfenster wird geoeffnet,
 * die Nummer wird ueber eine Prozedur ermittelt
 */
LOCAL MSGNR openStandard(OneGroupHandle ptr, CONST _UBYTE *ID)
{
	UNUSED(ptr);
	return *((MSGNR *)ID); /* hmpf */
}

GLOBAL _VOID msgList_listOpen(CAT_GROUP_NUMBER gruppe, MSGNR which, HWND grinWindow, grin_openMode mode)
{
	msgList_listOpenWithProc(gruppe, openStandard, (CONST _UBYTE *)&which, grinWindow, mode);
}

/*** ---------------------------------------------------------------------- ***/

/* Ein Stichwortlistenfenster wird geschlossen */
GLOBAL _VOID msgList_listClose(HWND wdw)
{
	if (MsgListBase_FindWind(wdw) != NULL)
		WdwManager_CloseWindow(wdw, TRUE);
}

/*** ---------------------------------------------------------------------- ***/

/* Alle Nachrichten in dem Fenster werden selektiert */
GLOBAL _VOID msgList_listSelectAll(HWND wdw, _BOOL withRedraw)
{
	listWindow *ptr;
	MSGNR i;

	if ((ptr = MsgListBase_FindWind(wdw)) != NULL)
	{
		CatGlobal_busyMouse();
		for (i = 0; i < ptr->maxPos; i++)
		{
			ptr->list[i].flags |= msglist_Selected;
			if ((i % 75) == 0) 
				CatGlobal_busyMouse();
		}
		MouseArrow();
		/* Und jetzt vorsichtshalber Redraw ausloesen */
		if (withRedraw)
			WdwManager_FullRedrawWdw(wdw);
	}
}

/*** ---------------------------------------------------------------------- ***/

/* Alle neuen Nachrichten in dem Fenster werden selektiert */
GLOBAL _VOID msgList_listSelectNew(HWND wdw)
{
	listWindow *ptr;
	MSGNR i;
	MSGNR start;
	
	if ((ptr = MsgListBase_FindWind(wdw)) != NULL)
	{
		CatGlobal_busyMouse();
		start = data_FirstNewMsg(ptr->grHandle->group);
		/* Jetzt die erste Message finden, deren Nummer > start ist */
		for (i = 0; i < ptr->maxPos; i++)
		{
			if (ptr->list[i].msgNum >= start)
				ptr->list[i].flags |= msglist_Selected;
			if ((i % 75) == 0) 
				CatGlobal_busyMouse();
		}
		MouseArrow();
		/* Und jetzt vorsichtshalber Redraw ausloesen */
		WdwManager_FullRedrawWdw(wdw);
	}
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

/*-- Ausgabefunktionen -------------------------------------------------*/

/*DYJ 5.23k */
LOCAL _VOID listSaveStatus(listWindow *ptr, TEXTFILENO f)
{
	MSGNR firstSel, msgNum, idx;
	MessageType mess;
	F_ERROR error;
	
	MemSetZeroStruct(mess);
	if (MsgListBase_hasSelectedEntries(ptr, &firstSel))
	{
		msgNum = ptr->list[firstSel].msgNum;
		idx = firstSel;
		while (msgNum < dataSys_notSaved)
		{
			/* Header der Message lesen */
			error = data_ReadHeader(ptr->grHandle->Zugriff, msgNum, &mess,TRUE);
			if (error == NoError)
			{
				if(mess.MailID)
				{
					/* MsgId ausgeben */
					mtTextfiles_WriteLine(f, "#");
					mtTextfiles_WriteLine(f, mess.MailID);
					mtTextfiles_WriteLn(f);
					/* Status ausgeben */
					mtTextfiles_WriteLine(f, "BG");
					mtTextfiles_WriteLn(f);
				}
				data_freeMessage(&mess);
			}
			/* Naechste selektierte finden */
			++idx;
			while (idx < ptr->maxPos && !(ptr->list[idx].flags & msglist_Selected))
				++idx;
			if (idx < ptr->maxPos)
				msgNum = ptr->list[idx].msgNum;
			else
				msgNum = dataSys_empty;
		}
	}
}

/*** ---------------------------------------------------------------------- ***/

/*DYJ 5.00a */	/*DYJ 5.23k */
LOCAL _VOID listSaveList(listWindow *ptr, TEXTFILENO f)
{
	MSGNR firstSel, msgNum, idx;
	MessageType mess;
	_WORD j;
	_UBYTE line[1024];
	F_ERROR error;
	MemSetZeroStruct(mess);
	
	if (MsgListBase_hasSelectedEntries(ptr, &firstSel))
	{
		msgNum = ptr->list[firstSel].msgNum;
		idx = firstSel;
		while (msgNum < dataSys_notSaved)
		{
			/* Header der Message lesen */
			error = data_ReadHeader(ptr->grHandle->Zugriff, msgNum, &mess,TRUE);
			if (error != NoError)
			{
				mess.MailID = NULL;
				mess.Betreff = NULL;
				mess.Absender = NULL;
				mess.Empfaenger = NULL;
				mess.mid = NULL;
				mess.rid = NULL;
				mess.box = NULL;
				mess.name = NULL;
				mess.mime = NULL;
				mess.gate = NULL;
				mess.followupTo = NULL;
				mess.replyTo = NULL;
				mess.sender = NULL;
				mess.gate = NULL;
				mess.InfoStrings = NULL;
				mess.attachment = NULL;
				mess.cc = NULL;
				mess.bcc = NULL;
				mess.eZeitX = NULL;
				mess.ref = NULL;
				mess.retPath = NULL;
				mess.keyw = NULL;
				mess.resent = NULL;
				mess.trace = NULL;
				mess.received = NULL;
				mess.path = NULL;
				mess.mailer = NULL;
				mess.unknown = NULL;
			}
			for (j = 0; j < ptr->partArray.lines; j++)
			{
				MsgListBase_GetLinePart(ptr, msgNum, &mess, line, sizeof(line), &ptr->partArray.parts[j]);
				strFillRight(line, sizeof(line), ptr->partArray.parts[j].w);
				mtTextfiles_WriteLine(f, line);
				mtTextfiles_WriteChar(f, ' ');
			}
			mtTextfiles_WriteLn(f);
			data_freeMessage(&mess);
			/* Naechste selektierte finden */
			++idx;
			while (idx < ptr->maxPos && !(ptr->list[idx].flags & msglist_Selected))
				++idx;
			if (idx < ptr->maxPos)
				msgNum = ptr->list[idx].msgNum;
			else
				msgNum = dataSys_empty;
		}
	}
}
/*** ---------------------------------------------------------------------- ***/
/*DYJ 5.19b */	/*DYJ 5.20w */	/*DYJ 5.20zb */	/*DYJ 5.21b */ /*DYJ 5.20zc */
/*DYJ 5.23k */
LOCAL _VOID listSaveOutfile(listWindow *ptr, TEXTFILENO f, _BOOL append,_BOOL addAttach)
{
	MSGNR firstSel, msgNum, idx;
	MessageType mess;
	group_line groupName;
/*DYJ 5.31a Start*/
	_UBYTE dateLine[256],mimeLine[256];
/*DYJ  Ende; alt:	
	_UBYTE dateLine[256];
*/
	_ULONG fPos;
	F_ERROR error;
	F_TIME fTime;
	String127 bound="";
	_UBYTE *nxt,*zeile;
	MemSetZeroStruct(mess);
	
	if (MsgListBase_hasSelectedEntries(ptr, &firstSel))
	{
		if (append)
		{
			/* #+CR+LF am Dateiende entfernen */
			fPos = mtTextfiles_Textpos(f);
			/* Ein Test ist hier nicht noetig, append wird nur
			 * gesetzt, wenn es moeglich ist
			 */
			mtTextfiles_SetTextpos(f, fPos-3);
		}
		else
		{
			time_t timet;
			char datum[30];
			/* Outfile-Header ausgeben */
			data_LineOut(f, "#","HEAD");
			data_LineOut(f, ":T",CatDate);
			data_LineOut(f, ":V",CatVersion);
			data_LineOut(f, ":B",CAT_PROGNAME);
			time(&timet);
			strftime(datum,sizeof(datum),"%Y%m%d%H%M\n",localtime(&timet));
			data_LineOut(f, ":D",datum);
			if(*userRName)
				data_LineOut(f, ":U", userRName);
			else
				data_LineOut(f, ":U", userAddr);
			data_LineOut(f, ":S","G");
			data_LineOut(f, ":Z","ATARI");
		}
		/* Gruppennamen rausfinden */
		if (ptr->grHandle->group == dataSys_private)
			*groupName = '\0';
		else
		{
			if (GroupSelect_isPrivate(ptr->grHandle->group) &&
				mtAlerts_AlertRSC(1, AL_PSGP)==2)
				*groupName = '\0';
			else
				GroupSelect_GroupName(ptr->grHandle->group, groupName, sizeof(groupName));
		}
		msgNum = ptr->list[firstSel].msgNum;
		idx = firstSel;
		while (msgNum < dataSys_notSaved)
		{
			/* Message lesen */
			error = data_ReadMessage(ptr->grHandle->Zugriff, msgNum, &mess);
			if (error == NoError)
			{
				/* Header ausgeben */
				data_LineOut(f, "#", mess.MailID);
				if (!(*groupName) && mess.EigeneNachricht &&
					(mess.Absender == NULL || mess.Absender[0] == '\0'))
				{
					data_LineOut(f, "V", userAddr);
				} else
				{
					data_LineOut(f, "V", mess.Absender);
				}
				data_LineOut(f, "W", mess.Betreff);
				data_LineOut(f, "A", mess.Empfaenger);
				data_LineOut(f, "G", groupName);
				/* Datum noch holen */
				data_buildDate(MessDate(mess), dateLine, sizeof(dateLine));
				data_LineOut(f, "E", dateLine);
				data_LineOut(f, "-", mess.KommentierteID);
				/* Jetzt noch den Usenet-Krempel */
				data_LineOut(f, "N", mess.name);
				data_LineOut(f, "I", mess.mid);
				data_LineOut(f, "R", mess.rid);
				data_LineOut(f, "O", mess.box);
				if(Mime_CntAtt(mess.attachment,TRUE)<1)
					addAttach=FALSE;
/*DYJ 5.31a Start*/
				if(addAttach)
				{
					sprintf(bound,"------------cat%s%s%s%s",
						ltoa(Gettime(),mimeLine,36),		/*Datum+Uhrzeit*/
						ltoa(clock(),mimeLine+10,36),						/*Laufzeit des Rechners*/
						ltoa((_LONG)bound,mimeLine+20,36),					/*Speicheradresse*/
						ltoa((_LONG)Malloc(-1),mimeLine+30,36));			/*freier Speicher*/
					sprintf(mimeLine,"1.0; Content-Type: multipart/mixed;	boundary=\"%s\"",bound);
					data_LineOut(f, "M", mimeLine);
				}
				else
				{
					data_LineOut(f, "M", mess.mime);
					strCpy(mimeLine,mess.mime);
				}
/*DYJ  Ende; alt:	
				if(addAttach)
				{
					sprintf(bound,"------------cat%s%s%s%s",
						ltoa(Gettime(),dateLine,36),		/*Datum+Uhrzeit*/
						ltoa(clock(),dateLine+10,36),						/*Laufzeit des Rechners*/
						ltoa((_LONG)bound,dateLine+20,36),					/*Speicheradresse*/
						ltoa((_LONG)Malloc(-1),dateLine+30,36));			/*freier Speicher*/
					sprintf(dateLine,"1.0; Content-Type: multipart/mixed;	boundary=\"%s\"",bound);
					data_LineOut(f, "M", dateLine);
				}
				else
					data_LineOut(f, "M", mess.mime);
*/
				data_LineOut(f, "F", mess.followupTo);
				data_LineOut(f, "S", mess.sender);
				data_LineOut(f, "T", mess.replyTo);
				data_LineOut(f, "Y", mess.gate);
				/* Distribution rauspusten */
				if (mess.distribution != distNone)
				{
					dateLine[0] = "KLMN"[mess.distribution];
					dateLine[1] = '\0';
					data_LineOut(f, "D", dateLine);
				}
				/* Bei der persoenlichen Gruppe muss eine Statuszeile ausgegeben werden
				 */
				if (!(*groupName))
				{
					data_buildDate(mess.statusDate,NULL, dateLine+1, sizeof(dateLine)-1);
					dateLine[0] = mess.Status;
					data_LineOut(f, "B", dateLine);
				}
				/* Jetzt noch die Statuszeile */
				data_buildFlagLine(mess.StatusBits, dateLine);
				data_LineOut(f, "s", dateLine);
				data_LineOut(f, ">cc : ", mess.cc);
				if(mess.bcc!=Bcc_unbek)
					data_LineOut(f, ">bcc : ", mess.bcc);
				else
					data_LineOut(f, "",">bcc :");
				data_LineOut(f, ">References : ", mess.ref);
				data_LineOut(f, ">Return-Path : ", mess.retPath);
				data_LineOut(f, ">Resent- : ", mess.resent);
				data_LineOut(f, ">Received : ", mess.received);
				data_LineOut(f, ">Keywords : ", mess.keyw);
				data_LineOut(f, ">Path : ", mess.path);
				data_LineOut(f, ">X-Mailer : ", mess.mailer);
				data_LineOut(f, ">Trace : ", mess.trace);
				ConvertDate_CatDate2Datim(MessDate(mess), &fTime);
				T_Strftime(dateLine, sizeof(dateLine), "%0a, %d %0b %Y %H:%M:%S %Z", &fTime);
				data_LineOut(f, ">Date : ", dateLine);
				data_LineOut(f, ">MIME : ", mimeLine);	/*DYJ 5.31a */
				data_LineOut(f,"", ">");
				nxt=mess.unknown;
				while(nxt && *nxt)
				{
					zeile=nxt;
					nxt+=strcSpn(zeile,"\n\r");	
					if(*nxt)
					{
						nxt='\0';
						nxt++;
						nxt+=strSpn(nxt,"\n\r \t");
					}
					data_LineOut(f, ">",zeile);
				}
				/* Und jetzt koennen wir den Text ausgeben */
				if(addAttach)
				{
/*DYJ 5.30q Start*/
					data_LineOut(f, "",":-");
					data_LineOut(f, "",":This is a multi-part message in MIME format...");
					data_LineOut(f, "",":");
					
/*DYJ  Ende; */
					data_LineOut(f, ":--",bound);
					data_LineOut(f, ":", mess.mime+strSpn(mess.mime,"0123456789;. "));
					data_LineOut(f,"", ":");
				}
				data_messageOut(f, &mess, ":");
				/* Speicher freigeben */
				data_freeMessage(&mess);
				if(addAttach)
				{
					_UBYTE pfad[PATH_MAX];
					F_TIME ft;
					ConvertDate_CatDate2Datim(MessDate(mess),&ft);
					Mime_AnhangOrdner(pfad,ft.tm_year,ft.tm_mon+1, Mime_ModAtt(mess.attachment));
					Mime_WriteAttachments(f,bound,pfad,mess.attachment,2); 
				}
			}
			/* Naechste selektierte finden */
			++idx;
			while (idx < ptr->maxPos && !(ptr->list[idx].flags & msglist_Selected))
				++idx;
			if (idx < ptr->maxPos)
				msgNum = ptr->list[idx].msgNum;
			else
				msgNum = dataSys_empty;
		}
		/* Jetzt noch das Logfile schreiben */
		data_LineOut(f, "#", "LOG");
		data_LineOut(f, ":!V", CatDate);
		data_LineOut(f, ":!CAT ", CatVersion);
		if(*userRName)
			data_LineOut(f, ":!Database von ", userRName);
		else
			data_LineOut(f, ":!Database von ", userAddr);
		mtTextfiles_WriteLine(f, "#");
		mtTextfiles_WriteLn(f);
	}
}
/*** ------------------------------------------------------------------------ ***/
/*	_VOID	listSaveDBase(listWindow *ptr,Textmode fileOpenMode,_UBYTE *fnamePar,_UBYTE *fnameDat)	*/
/*	Speichert markierte Nachrichten in Datenbankfiles							*/
/*	Parameter:	ptr:		Das Listfenster										*/
/*				fileOpenMode:	anfgen oder berschreiben						*/
/*				fnamePar:		Filename des PAR-Files							*/
/*				fnameDat:		Filename des DAT-Files							*/
/*	Ergebnis:	keines															*/		
/*	16.3.03 von Dimitri Junker	DYJ 5.23b										*/
/*** ------------------------------------------------------------------------ ***/
#define BLOCK_CRC(ptr) \
	ZCalcCrc_CalcCrcArray((CONST _UBYTE *)(ptr) + sizeof(CRC16), sizeof(*(ptr)) - sizeof(CRC16))
LOCAL _VOID	listSaveDBase(listWindow *ptr,Textmode fileOpenMode,_UBYTE *fnamePar,_UBYTE *fnameDat)
{
	MSGNR firstSel, msgNum, idx;
	F_ERROR error=NoError;
	FILENO parHandle,datHandle;
	if (MsgListBase_hasSelectedEntries(ptr, &firstSel))
	{
		if(fileOpenMode == APPEND)
		{
			parHandle = CatFiles_OpenFile(fnamePar, CatFiles_readWrite);
			datHandle = CatFiles_OpenFile(fnameDat, CatFiles_readWrite);
			if (!FILENO_OK(parHandle) || !FILENO_OK(datHandle))
				return;
			CatFiles_Seek(0, parHandle, CatFiles_end);
			CatFiles_Seek(0, datHandle, CatFiles_end);
		}
		else
		{
			FileHeaderType head;
			F_File_Delete(fnamePar);
			F_File_Delete(fnameDat);
			parHandle = CatFiles_OpenFile(fnamePar, CatFiles_writeFile);
			datHandle = CatFiles_OpenFile(fnameDat, CatFiles_writeFile);
			if (!FILENO_OK(parHandle) || !FILENO_OK(datHandle))
				return;
			head.CatMagic = h2nl(dbCatMagic);
			head.Version = h2ns(dbVersion);
			head.VersionMagic = h2ns(dbVersionMagic);
			error = CatFiles_WriteMuch(dbHeaderLength, parHandle, &head);
		}
		msgNum = ptr->list[firstSel].msgNum;
		idx = firstSel;
		while (msgNum < dataSys_notSaved && error==NoError)
		{
			pBlock s, *blockPtr,cpyBlk;
			blockPtr = &s;
			/* Message lesen */
			data_ReadBlock(ptr->grHandle->Zugriff, msgNum,&blockPtr);
			cpyBlk=*blockPtr;
			CatFiles_FilePos(datHandle,&(cpyBlk.Start));
			cpyBlk.crc=BLOCK_CRC(&cpyBlk);
			error = CatFiles_WriteMuch(sizeof(pBlock), parHandle, &cpyBlk);
			if(error==NoError)
				error= data_CpyFromDat(ptr->grHandle->Zugriff, blockPtr->Start, blockPtr->hLength+blockPtr->Length+sizeof(dupeInfoType), datHandle);
			/* Naechste selektierte finden */
			++idx;
			while (idx < ptr->maxPos && !(ptr->list[idx].flags & msglist_Selected))
				++idx;
			if (idx < ptr->maxPos)
				msgNum = ptr->list[idx].msgNum;
			else
				msgNum = dataSys_empty;
		}
		CatFiles_CloseFile(parHandle);
		CatFiles_CloseFile(datHandle);
	}
}

/*** ------------------------------------------------------------------------ ***/
/*	_VOID lineOut(TEXTFILENO file, _WORD strNr, CONST _UBYTE *str)				*/
/*	Eine abgewandelte Version von data_LineOut hier wird kein String, sondern	*/
/*	Die Nummer des Strings im RSC bergeben										*/
/*	Parameter:	file:	darein schreiben										*/
/*				strNr:	Stringnummer im RSC										*/
/*				str:	2. String												*/
/*	Ergebnis:	keines															*/		
/*	26.2.03 von Dimitri Junker	DYJ 5.21b										*/
/*** ------------------------------------------------------------------------ ***/
LOCAL _VOID lineOut(TEXTFILENO file, _WORD strNr, CONST _UBYTE *str)
{
	if(strNr<0)
	{
		_UBYTE tmpLine[30];
		strBcpy(tmpLine,MausTauschrsc_WrkString(-strNr));
		strBcat(tmpLine," ");
		data_LineOut(file, tmpLine, str);
	}
	else
		data_LineOut(file, MausTauschrsc_WrkString(strNr), str);
}
/*** ---------------------------------------------------------------------- ***/
/*DYJ 5.00a */ /*DYJ 5.20w */	/*DYJ 5.20zb */	/*DYJ 5.21b */
/*DYJ 5.23k */
LOCAL _VOID listSaveText(listWindow *ptr, TEXTFILENO f, _BOOL dataMode,_BOOL addAttach)
{
	MSGNR firstSel, msgNum, idx;
	MessageType mess;
	group_line groupName;
	_UBYTE tmpLine[1024];
	_WORD emptyLines, i;
	F_ERROR error;
	String127 bound="";
	MemSetZeroStruct(mess);
	
	if (MsgListBase_hasSelectedEntries(ptr, &firstSel))
	{
		ConfVars_GetConfDefInt(cPrintEmptyLines, &emptyLines, 0);
		/* Gruppennamen rausfinden */
		GroupSelect_GroupDisplayName(ptr->grHandle->group, groupName, sizeof(groupName));
		msgNum = ptr->list[firstSel].msgNum;
		idx = firstSel;
		while (msgNum < dataSys_notSaved)
		{
			/* Message lesen */
			error = data_ReadMessage(ptr->grHandle->Zugriff, msgNum, &mess);
			if (error == NoError && mess.Text != NULL && mess.InfoStrings != NULL)
			{
				if (!dataMode)
				{
					/* Header ausgeben */
					data_LineOut(f, "ID  : ", mess.MailID);
					lineOut(f, -msgGroup, groupName);
					data_LineOut(f, "Followup-To: ", mess.followupTo);
					lineOut(f, FS_COMMENT, mess.KommentierteID);
					if (mess.Absender != NULL)
					{
						strBcpy(tmpLine, mess.Absender);
						strBcat(tmpLine, " (");
						strBcat(tmpLine, mess.Datum);
						strBcat(tmpLine, ")");
						lineOut(f, -HEAD_VON, tmpLine);
					}
					lineOut(f, -HEAD_NAME, mess.name);
					data_LineOut(f, "Sender: ", mess.sender);
					data_LineOut(f, "Reply-To: ", mess.replyTo);
					lineOut(f, -HEAD_WG, mess.Betreff);
					if (mess.Empfaenger != NULL)
					{
						strBcpy(tmpLine, mess.Empfaenger);
						if (GroupSelect_isPrivate(mess.Gruppe) && mess.EigeneNachricht)
						{
							strBcat(tmpLine, " (");
							strBcat(tmpLine, mess.Datum);
							strBcat(tmpLine, ")");
						}
						lineOut(f, -msgAn, tmpLine);
					}
					/* Jetzt noch den Usenet-Krempel */
					data_LineOut(f, "Box : ", mess.box);
					data_LineOut(f, "MId : ", mess.mid);
					data_LineOut(f, "RId : ", mess.rid);
					data_LineOut(f, "Gate: ", mess.gate);

					if(Mime_CntAtt(mess.attachment,TRUE)<1)
						addAttach=FALSE;
					if(addAttach)
					{
						sprintf(bound,"------------cat%s%s%s%s",
							ltoa(Gettime(),tmpLine,36),		/*Datum+Uhrzeit*/
							ltoa(clock(),tmpLine+10,36),						/*Laufzeit des Rechners*/
							ltoa((_LONG)bound,tmpLine+20,36),					/*Speicheradresse*/
							ltoa((_LONG)Malloc(-1),tmpLine+30,36));			/*freier Speicher*/
						sprintf(tmpLine,"1.0; Content-Type: multipart/mixed;	boundary=\"%s\"",bound);
						data_LineOut(f, "MIME: ", tmpLine);
					}
					else
						data_LineOut(f, "MIME: ", mess.mime);
					mtTextfiles_WriteLn(f);
				}
				
				data_LineOut(f, "cc : ", mess.cc);
				data_LineOut(f, "bcc : ", mess.bcc);
				data_LineOut(f, "References : ", mess.ref);
				data_LineOut(f, "Return-Path : ", mess.retPath);
				data_LineOut(f, "Resent- : ", mess.resent);
				data_LineOut(f, "Received : ", mess.received);
				data_LineOut(f, "Keywords : ", mess.keyw);
				data_LineOut(f, "Path : ", mess.path);
				data_LineOut(f, "X-Mailer : ", mess.mailer);
				data_LineOut(f, "Trace : ", mess.trace);
				data_LineOut(f, "", mess.unknown);
				/* Und jetzt koennen wir den Text ausgeben */
				if(addAttach)
				{
					data_LineOut(f, "--",bound);
					data_LineOut(f, "", mess.mime+strSpn(mess.mime,"0123456789;. "));
				}
				mtTextfiles_WriteLn(f);
				/* Und jetzt koennen wir den Text ausgeben */
				data_messageOut(f, &mess, "");
				
				if (!dataMode)
				{
					/* Jetzt noch ein paar Trennzeilen */
					for (i = 0; i < emptyLines; i++)
						mtTextfiles_WriteLn(f);
				}
				
				/* Speicher freigeben */
				data_freeMessage(&mess);
				if(addAttach)
				{
					_UBYTE pfad[PATH_MAX];
					F_TIME ft;
					ConvertDate_CatDate2Datim(MessDate(mess),&ft);
					Mime_AnhangOrdner(pfad,ft.tm_year,ft.tm_mon+1, Mime_ModAtt(mess.attachment));
					Mime_WriteAttachments(f,bound,pfad,mess.attachment,0); 
				}
			}
			/* Naechste selektierte finden */
			++idx;
			while (idx < ptr->maxPos && !(ptr->list[idx].flags & msglist_Selected))
				++idx;
			if (idx < ptr->maxPos)
				msgNum = ptr->list[idx].msgNum;
			else
				msgNum = dataSys_empty;
		}
	}
}

/*** ---------------------------------------------------------------------- ***/

/*DYJ 5.21b */	/*DYJ 5.23k */
LOCAL _VOID listSaveDecode(listWindow *ptr)
{
	MSGNR firstSel, msgNum, idx;
	MessageType mess;
	_UBYTE *text, *chPtr;
	size_t textIdx;
	_UBYTE saveCh;
	F_ERROR error;
	MemSetZeroStruct(mess);
	
	if (MsgListBase_hasSelectedEntries(ptr, &firstSel))
	{
		CatGlobal_busyMouse();
		UUDecode_BeginDecode();
		msgNum = ptr->list[firstSel].msgNum;
		idx = firstSel;
		while (msgNum < dataSys_notSaved)
		{
			CatGlobal_busyMouse();
			/* Message lesen */
			error = data_ReadMessage(ptr->grHandle->Zugriff, msgNum, &mess);
			if (error == NoError && mess.Text != NULL && mess.InfoStrings != NULL)
			{
				textIdx = 0;
				chPtr = mess.Text;
				while (textIdx < mess.textLen)
				{
					/* Startadresse festlegen */
					text = chPtr;
					/* Zeilenende suchen */
					while (textIdx < mess.textLen && *chPtr != CR && *chPtr != LF)
					{
						++textIdx;
						++chPtr;
					}
					saveCh = *chPtr;
					*chPtr = '\0';
					if ((error = UUDecode_DecodeLine(text)) != GERR_OK)
					{
						if (error == -1)
							MTE_infoRSC(AL_UUDECODE_ERROR);
						else
							F_ErrorAlert(error);
						data_freeMessage(&mess);
						UUDecode_EndDecode();
						MouseArrow();
						return;
					}
					*chPtr = saveCh;
					++textIdx;
					++chPtr;
					/* Naechsten Zeilenanfang finden */
					while (textIdx < mess.textLen && (*chPtr == CR || *chPtr == LF))
					{
						++textIdx;
						++chPtr;
					}
				}
				/* Speicher freigeben */
				data_freeMessage(&mess);
			}
			/* Naechste selektierte finden */
			++idx;
			while (idx < ptr->maxPos && !(ptr->list[idx].flags & msglist_Selected))
				++idx;
			if (idx < ptr->maxPos)
				msgNum = ptr->list[idx].msgNum;
			else
				msgNum = dataSys_empty;
		}
		UUDecode_EndDecode();
		MouseArrow();
	}
}

/*** ---------------------------------------------------------------------- ***/

/*DYJ 5.22c */	/*DYJ 5.21b */	/*DYJ 5.23b */
LOCAL _VOID listSave(listWindow *ptr, CONST _UBYTE *path, CONST _UBYTE *name, _WORD saveMode, _BOOL askOverwrite, _BOOL append,_BOOL addAttach)
{
	_UBYTE fname[PATH_MAX],fname2[PATH_MAX],*ext;
	_BOOL exists,exists2;
	Textmode fileOpenMode;
	TEXTFILENO out;
	_BOOL isOutfile;
	_ULONG fPos;
	_WORD i;
	_WORD select;
	_UBYTE tmp[4];
	F_ERROR err;
	
	/* Dateinamen basteln */
	strBcpy(fname, path);
	F_Path_Append(fname, name);
	/* Erstmal feststellen, ob die Datei existiert */
	fPos = CatFiles_FileSize(fname, &exists);
	if(saveMode==smDBase)
	{
		strCpy(fname2,fname);
		ext=strrChr(fname2,'.');
		if(ext)
			strCpy(ext,".dat");
		else
			return;
		CatFiles_FileSize(fname2, &exists2);
		exists|=exists2;
	}

	fileOpenMode = WRITE;
	if (exists)
	{
		if (askOverwrite)
		{
			select = mtAlerts_Alert(2, Rsc_WrkString(AL_OVERWRITE3));
			if (select == 2)
				fileOpenMode = APPEND;
			else if (select == 1)
				fileOpenMode = WRITE;
			else
				return;
		} else
		{
			if (append)
				fileOpenMode = APPEND;
			else
				fileOpenMode = WRITE;
		}
	}
	if(saveMode==smDBase)
	{
		listSaveDBase(ptr,fileOpenMode,fname,fname2);
	}
	else
	{
		isOutfile = FALSE;
		if (fileOpenMode == APPEND)
		{
			/* Erstmal kurz die letzten drei Byte lesen */
			if (mtTextfiles_OpenTextfile(fname, READ, 0, &out) == GERR_OK)
			{
				/* In fPos steht schon die Groesse */
				if (fPos >= 3)
				{
					mtTextfiles_SetTextpos(out, fPos - 3);
					for (i = 0; i < 3; i++)
						tmp[i] = mtTextfiles_ReadChar(out);
					tmp[3] = '\0';
					/* Jetzt Test auf #+CR+LF */
					if (strCmp(tmp, "#\r\n") == 0)
						isOutfile = TRUE;
				}
				mtTextfiles_CloseTextfile(&out);
			}
		}
		
		/* So, jetzt die Datei oeffnen */
		if ((err = mtTextfiles_OpenTextfile(fname, fileOpenMode, 0, &out)) == GERR_OK)
		{
			MouseBusy();
			switch (saveMode)
			{
				case smListe :   listSaveList(ptr, out); break;
				case smOutfile:  listSaveOutfile(ptr, out, isOutfile,addAttach); break;
				case smText  :   listSaveText(ptr, out, FALSE,addAttach); break;
				case smData  :   listSaveText(ptr, out, TRUE,addAttach); break;
				case smStatus:   listSaveStatus(ptr, out); break;
			}
			mtTextfiles_CloseTextfile(&out);
			MouseArrow();
		} else
		{
			F_ErrorAlert(err);
		}
	}
}

/*** ------------------------------------------------------------------------ ***/
/*	saveasButton(OBJECT *tree, _VOID *env, _WORD button, _WORD mx, _WORD my, _UWORD kstate, _WORD clicks)	*/
/*	Die Reaktionen auf Aktionen im save as Formular								*/
/*	12.12.01 von Dimitri Junker	DYJ 4.30zr										*/
/*** ------------------------------------------------------------------------ ***/
/*DYJ 5.23b */
LOCAL _BOOL saveasButton(OBJECT *tree, _VOID *env, _WORD button, _WORD mx, _WORD my, _UWORD kstate, _WORD clicks)
{
	OBJECT *pop;
	_WORD x, y;
	GRECT r;
	_WORD select=-1;
	_WORD anzTyp=4;
	grChangeInfo *chInfo;
	
	UNUSED(mx);
	UNUSED(my);
	UNUSED(clicks);

	chInfo=env;
	if(button==-1)
		return FALSE;
	button &= 0x7fff;
	if(chInfo->allowDB)
	{
		pop = TreeAddr[MSTYPEBOX_DB];
		anzTyp=5;
	}
	else
		pop = TreeAddr[MSTYPEBOX];
	if (button == MSTYPE0)
		button = MSTYPE1;
	DelObjState(tree, button, SELECTED);
	switch (button)
	{
	case MSHELP:
		CatHelp_DoHelp(CatHelp_savemsg);
		CalcArea(tree, button, &r);
		WinDials_WinDialDraw(tree, ROOT, MAX_DEPTH, &r, TRUE);
		break;
	
	case MSQUIT:
	case MSOK:
		return TRUE;
	
	case MSTYPE1:
		if (!GetObjState(tree, button, DISABLED))
		{
			objc_offset(tree, button, &x, &y);
			select = mtPopups_TreePopup(pop, x, y, VDIUtil_GetXState(tree, button)) - 1;
			if (select >= 0)
			{
				VDIUtil_SetXState(tree, button, select);
				VDIUtil_SetXString(tree, button, pop, select);
				WinDials_WinDialDraw(tree, button, 0, &r, FALSE);
			}
		}
		break;
		
	case MSTYPE2:
		select = VDIUtil_GetXState(tree, MSTYPE1);
		if(kstate&K_SHIFT)
			select = (select + anzTyp -1) % anzTyp;
		else
			select = (select + 1) % anzTyp;
		VDIUtil_SetXState(tree, MSTYPE1, select);
		VDIUtil_SetXString(tree, MSTYPE1, pop, select);
		WinDials_WinDialDraw(tree, MSTYPE1, 0, &r, FALSE);
		break;
	
	}
	if(select>-1)
	{
		select+=smListe;
		EnableObjFlags(tree, MSATTACH, HIDETREE, select!=smOutfile && select!=smText);
		EnableObjFlags(tree, MSTATUS, HIDETREE, select!=smListe || chInfo->askStatus==FALSE);
		CalcArea(tree, MSATTACH, &r);
		WinDials_WinDialDraw(tree, ROOT, MAX_DEPTH, &r, TRUE);
	}
	
	return FALSE;
}


/*** ------------------------------------------------------------------------ ***/
/*	saveasGetSetValues(OBJECT *tree, _VOID *env, _BOOL set, _WORD exit)			*/
/*	Das bliche setzen und Auswerten von Formularen								*/
/*	12.12.01 von Dimitri Junker	DYJ 4.30zr										*/
/*** ------------------------------------------------------------------------ ***/
/*DYJ 5.23b */
LOCAL _VOID saveasGetSetValues(OBJECT *tree, _VOID *env, _BOOL set, _WORD exit)
{
	grChangeInfo *chInfo;
	OBJECT *pop;
	
	chInfo = env;
	exit &= 0x7fff;
	chInfo->exitBut = exit;
	pop = TreeAddr[MSTYPEBOX_DB];
	if (set)
	{
		chInfo->isType =(lastSaveMode&0xff);
		VDIUtil_SetXState(tree, MSTYPE1, chInfo->isType-smListe);
		VDIUtil_SetXString(tree, MSTYPE1, pop, chInfo->isType-smListe);
		
		chInfo->isAttach=(lastSaveMode&0x100)!=0;
		EnableObjState(tree, MSATTACH, SELECTED, chInfo->isAttach);
		EnableObjFlags(tree, MSATTACH, HIDETREE, chInfo->isType!=smOutfile && chInfo->isType!=smText);

		chInfo->isStatus=(lastSaveMode&0x200)!=0;
		EnableObjState(tree, MSTATUS, SELECTED, chInfo->isStatus);
		EnableObjFlags(tree, MSTATUS, HIDETREE, chInfo->isType!=smListe|| chInfo->askStatus==FALSE);


	} else
	{
		if (exit == MSOK)
		{
			chInfo->isType = VDIUtil_GetXState(tree, MSTYPE1)+smListe;
			chInfo->isAttach = GetObjState(tree, MSATTACH, SELECTED);
			chInfo->isStatus = GetObjState(tree, MSATTACH, SELECTED);
			lastSaveMode=chInfo->isType;
			if(chInfo->isAttach)
				lastSaveMode+=0x100;
			if(chInfo->isStatus)
				lastSaveMode+=0x200;
		}
	}
}

/*** ------------------------------------------------------------------------ ***/
/*	saveasForm(_BOOL askStatus,_BOOL *addAttach,_BOOL allowDB)					*/
/*	Auswahlbox fr save as														*/
/*	Parameter:	askStatus:	fragen ob es als Status gesichert werden soll?		*/
/*				addAttach:	Anhnge mitsichern (Rckgabe)						*/
/*				allowDB:	Auch speichern als Datebnbankfile mglich?			*/
/*	Ergebnis:	Fileart															*/		
/*	12.12.01 von Dimitri Junker	DYJ 4.30zr										*/
/*** ------------------------------------------------------------------------ ***/

/*DYJ 5.23b */
LOCAL _WORD saveasForm(_BOOL askStatus,_BOOL *addAttach,_BOOL allowDB)
{
	OBJECT *tree;
	grChangeInfo *cInfo;
	_WORD ret=-1;

	tree = TreeAddr[MSGSAVE];
	cInfo = NEW(grChangeInfo, "MsgWindow_saveasHdr");
	if (cInfo == NULL)
		return FALSE;
	cInfo->askStatus=askStatus;
	cInfo->allowDB=allowDB;

	if (WinDials_OpenWinDial(tree, TRUE,
		saveasGetSetValues,
		saveasGetSetValues,
		saveasButton,
		WinDials_defDraw,
		NULL,
		cInfo))
	{
		WinDials_WinDialHandleEvents();
		if(cInfo->exitBut==MSOK)
		{
			ret = cInfo->isType;
			if(ret==smListe && cInfo->isStatus && cInfo->askStatus)
				ret=smStatus;
			else
				*addAttach = cInfo->isAttach;
		}
	}
	OFREE(cInfo);
	return ret;
}

/*** ---------------------------------------------------------------------- ***/
/* Speichert die selektierten Nachrichten in einer Datei */
/*DYJ 5.21b */	/*DYJ 5.23b */
GLOBAL _BOOL msgList_listSaveAs(HWND wdw, _BOOL asStatus)
{
	listWindow *p;
	_WORD saveMode;
	MSGNR firstSel;
	_BOOL addAttach;
	
	if ((p = MsgListBase_FindWind(wdw)) != NULL)
	{
		if (MsgListBase_hasSelectedEntries(p, &firstSel))
		{
			saveMode = saveasForm(asStatus,&addAttach,TRUE);
			if (saveMode <0)
				return FALSE;
			if (saveMode == smDecode)
			{
				listSaveDecode(p);
			} else if(saveMode == smDBase)
			{
				/* Jetzt Datei auswaehlen */
				if (!mtDir_FselGet(SavePath, SaveName, "*.par", MausTauschrsc_WrkString(FS_MESSAGES_SAVEAS), FALSE))
					return FALSE;
				/* Ok, Name ist ausgewaehlt */
				listSave(p, SavePath, SaveName, saveMode, TRUE, FALSE,addAttach);
				Protokoll_SendPathUpdate(SavePath);
			} else
			{
				/* Jetzt Datei auswaehlen */
				if (!mtDir_FselGet(SavePath, SaveName, "*.txt", MausTauschrsc_WrkString(FS_MESSAGES_SAVEAS), FALSE))
					return FALSE;
				/* Ok, Name ist ausgewaehlt */
				listSave(p, SavePath, SaveName, saveMode, TRUE, FALSE,addAttach);
				Protokoll_SendPathUpdate(SavePath);
			}
		}
		return TRUE;
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

/* Alle selektierten Nachrichten werden exportiert */
/*DYJ 5.23b */
GLOBAL _BOOL msgList_listCopy(HWND wdw, _BOOL append)
{
	listWindow *p;
	_UBYTE path[PATH_MAX];
	_WORD saveMode;
	MSGNR firstSel;
	_BOOL addAttach;
	
	if ((p = MsgListBase_FindWind(wdw)) != NULL)
	{
		if (MsgListBase_hasSelectedEntries(p, &firstSel))
		{
			if (!Clip_GetScrap(path))
				return FALSE;
			saveMode = saveasForm(FALSE,&addAttach,FALSE);
			if (saveMode <0)
				return FALSE;
			if (append)
				Clip_ScrapClear("", SCRAP_TXT);
			else
				Clip_ScrapClear("", "");
			if (saveMode == smDecode)
			{
				listSaveDecode(p);
			} else
			{
				listSave(p, path, SCRAP_TXT, saveMode, FALSE, append,addAttach);
				Clip_ScrapWritten(SCF_TEXT, ".TXT");
			}
		}
		return TRUE;
	}
	return FALSE;
}
/*** ---------------------------------------------------------------------- ***/

/* Gibt zurueck, ob in der Stichwortliste Nachrichten markiert
 * sind
 */
GLOBAL _BOOL msgList_listSomethingSelected(HWND wdw)
{
	listWindow *p;
	MSGNR firstSel;
	
	if ((p = MsgListBase_FindWind(wdw)) != NULL)
		return MsgListBase_hasSelectedEntries(p, &firstSel);
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

/* Fuer alle selektierten Nachrichten
 * ein paar Flags setzen oder loeschen
 */
GLOBAL _VOID msgList_listSetFlags(HWND wdw, MSGBITS setBits, MSGBITS clearBits)
{
	listWindow *p;
	MSGBITS bits, newBits;
	MSGNR counter, i;
	F_ERROR error;
	_WORD readChg=0;
	MSGBITS maske=bGelesen;
	MSGNR count;
	if(UserBLK.ignoreFiltered)
		maske|=bFiltered;
	
	if ((p = MsgListBase_FindWind(wdw)) != NULL)
	{
		count = data_unreadMsgCount(p->grHandle->group);
		CatGlobal_busyMouse();
		counter = 0;
		for (i = 0; i < p->maxPos; i++)
		{
			if (p->list[i].flags & msglist_Selected)
			{
				error = data_ReadState(p->grHandle->Zugriff, p->list[i].msgNum, &bits);
				if (error == NoError)
				{
					/* Neue Flags berechnen */
					newBits = (bits & ~clearBits) | setBits;
					/* Flags setzen */
					if((bits & maske) && !(newBits & maske))
						readChg=3;
					else
					{
						if(!(bits & maske) && (newBits & maske))
						{
							count--;
							readChg|=1;
						}
					}
					error = data_SetBits(p->grHandle->Zugriff, p->list[i].msgNum, newBits);
					if (error == NoError)
					{
						/* Und auch den Nachrichtenfenstern und der Baumanzeige Bescheid sagen */
						treeList_treeChangeFlags(p->grHandle->group, p->list[i].msgNum, newBits);
						grin_grinChangeFlags(p->grHandle->group, p->list[i].msgNum, newBits);
					}
					++counter;
					if ((counter % 50) == 0)
						CatGlobal_busyMouse();
					if(((bits^newBits)&bOwnMessage)!=0)
						grin_setCoO(p->grHandle->Zugriff, p->list[i].msgNum, newBits&bOwnMessage);
				}
			}
		}
		if(readChg==3)
			data_forceUnreadRefresh(p->grHandle->Zugriff);
		else
			data_SetUnreadMsgCount(p->grHandle->group, count);
		if(readChg)
			grin_grinChangeUngel(p->grHandle->group);
		MouseArrow();
		/* Und jetzt vorsichtshalber Redraw ausloesen */
		WdwManager_FullRedrawWdw(wdw);
	}
}
/*** ------------------------------------------------------------------------ ***/
/*	_VOID msgList_listSendState(HWND wdw, _UBYTE newState)						*/
/*	Verschickt State-Nachrichten fr alle selektierten 							*/
/*	Parameter:	wdw:		List-Fenster										*/
/*				newState:	z.B. 'X'											*/
/*	Ergebnis:	keines															*/		
/*	9.12.01 von Dimitri Junker	DYJ 4.30zo										*/
/*** ------------------------------------------------------------------------ ***/
/*DYJ 5.23k */
GLOBAL _VOID msgList_listSendState(HWND wdw, _UBYTE newState)
{
	listWindow *p;
	MSGNR  i;
	MessageType mess;
	MemSetZeroStruct(mess);
	
	if ((p = MsgListBase_FindWind(wdw)) != NULL)
	{
		CatGlobal_busyMouse();
		for (i = 0; i < p->maxPos; i++)
		{
			if (p->list[i].flags & msglist_Selected)
			{
				if (data_ReadHeader(p->grHandle->Zugriff, p->list[i].msgNum, &mess,TRUE) == NoError)
					Messages_SendState(mess.MailID, newState);
			}
		}
		MouseArrow();
		/* Und jetzt vorsichtshalber Redraw ausloesen */
		WdwManager_FullRedrawWdw(wdw);
	}
}
/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID msgList_listSavePos(_VOID)
{
	listWindow *lauf;
	_UBYTE varName[256];
	GRECT full;

	Lists_ResetList(&MsgList_windows);
	while ((lauf = Lists_NextEntry(&MsgList_windows)) != NULL)
	{
		if (lauf->wdw >= 0)
		{
			make_varname(varName, sizeof(varName), cListGroup, lauf->number);
			ConfVars_SetConfigLongInt(varName, (_ULONG)lauf->grHandle->group);
			make_varname(varName, sizeof(varName), cListStart, lauf->number);
			ConfVars_SetConfigLongInt(varName, (_ULONG)lauf->startPos);
			
			make_varname(varName, sizeof(varName), cListWindowPos, lauf->number);
			WdwManager_GetWdwSize(lauf->wdw, &full); /* Groesse des Fensters abfragen */
			ConfVars_SetConfigRect(varName, &full);
			make_varname(varName, sizeof(varName), cListFont, lauf->number);
			ConfVars_SetConfigInt(varName, lauf->font);
			make_varname(varName, sizeof(varName), cListFontSize, lauf->number);
			ConfVars_SetConfigInt(varName, lauf->fontSize);
		}
	}
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID msgList_listRestorePos(_VOID)
{
	_UBYTE varName[256];
	_WORD number;
	CAT_GROUP_NUMBER gruppe;
	MSGNR mailNr;
	_LONG val;
	
	for (number = 0; number < 256; number++)
	{
		make_varname(varName, sizeof(varName), cListGroup, number);
		if (ConfVars_GetConfigLongInt(varName, &val))
		{
			gruppe = (CAT_GROUP_NUMBER)val;
			make_varname(varName, sizeof(varName), cListStart, number);
			if (ConfVars_GetConfigLongInt(varName, &val))
			{
				mailNr = (MSGNR)val;
				msglist_globalNumber = number;
				msgList_listOpen(gruppe, mailNr, -1, mOther);
			}
		}
	}
	msglist_globalNumber = -1;
}

/*** ---------------------------------------------------------------------- ***/

/* Alle Stichwortlistenfenster werden geschlossen */
GLOBAL _VOID msgList_listCloseAll(_VOID)
{
	listWindow *lauf;

	Lists_ResetList(&MsgList_windows);
	while ((lauf = Lists_NextEntry(&MsgList_windows)) != NULL)
		msgList_listClose(lauf->wdw);
}

/*** ---------------------------------------------------------------------- ***/

/* Alle Stichwortlistenfenster werden neu gezeichnet */
GLOBAL _VOID msgList_listRedrawAll(_VOID)
{
	listWindow *ptr;
	LGRECT doc;

	Lists_ResetList(&MsgList_windows);
	while ((ptr = Lists_NextEntry(&MsgList_windows)) != NULL)
	{
		msgList_GetSettings(ptr);
		ptr->maxWidth = ptr->partArray.width * ptr->charWidth;
		doc.x = ptr->leftOffset;
		doc.y = ptr->startPos;
		doc.w = ptr->maxWidth;
		doc.h = ptr->maxPos - 1;
		WdwManager_SetNewDocument(ptr->wdw, &doc, TRUE);
		WdwManager_FullRedrawWdw(ptr->wdw);
	}
}

/*** ---------------------------------------------------------------------- ***/

/* Schliesst alle Stichwortlistenfenster und gibt auch alle Handles wieder
 * frei
 */
GLOBAL _VOID msgList_listFreeAll(_VOID)
{
	listWindow *lauf;

	msgList_listCloseAll();
	Lists_ResetList(&MsgList_windows);
	while ((lauf = Lists_NextEntry(&MsgList_windows)) != NULL)
	{
		if (lauf->usedByGrin > 0)
		{
			MsgListBase_freeList(lauf);
			handlePool_FreeOneDataHandle(lauf->grHandle);
			handlePool_FreeOnePtr(lauf, &MsgList_windows);
			Lists_ResetList(&MsgList_windows);
		}
	}
}

/*** ---------------------------------------------------------------------- ***/

/* Ist ein Stichwortlistenfenster oben? */
GLOBAL _BOOL msgList_listWindowTop(HWND wdw)
{
	return MsgListBase_FindWind(wdw) != NULL;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID msgList_listSetFont(HWND wdw, _WORD font, _WORD fontSize)
{
	iListSetFont(wdw, font, fontSize, TRUE);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID msgList_SelectFont(HWND wdw)
{
	listWindow *ptr;
	
	ptr = MsgListBase_FindWind(wdw);
	if (ptr != NULL)
	{
		VDIUtil_SelectFont(ptr->vdi, ptr->wdw, FALSE, ptr->font, ptr->fontSize);
	}
}

/*** ---------------------------------------------------------------------- ***/

/* Ein Stichwortlistenfenster wird ueber das assoziierte Handle
 * geschlossen, wird von grin aufgerufen, wenn ein Fenster mit
 * geschlossen wird, an das eine Stichwortliste gelinkt ist
 */
GLOBAL _VOID msgList_listCloseByHandle(LISTHANDLE hdl)
{
	listWindow *ptr;
	
	if ((ptr = MsgListBase_FindHandle(hdl)) != NULL)
	{
		if (ptr->wdw >= 0)
			WdwManager_CloseWindow(ptr->wdw, TRUE);
	}
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID msgList_listUnlockWdw(LISTHANDLE hdl)
{
	listWindow *ptr;
	
	if ((ptr = MsgListBase_FindHandle(hdl)) != NULL)
	{
		if (ptr->usedByGrin > 0)
			--ptr->usedByGrin;
		if (ptr->wdw >= 0)
			return;
		if (ptr->usedByGrin == 0)
		{
			MsgListBase_freeList(ptr);
			handlePool_FreeOneDataHandle(ptr->grHandle);
			handlePool_FreeOnePtr(ptr, &MsgList_windows);
		}
	}
}

/*** ---------------------------------------------------------------------- ***/

/* Ein Stichwortliste intern aufbauen ohne Fenster */
LOCAL _BOOL openGroup(CAT_GROUP_NUMBER gruppe, MSGNR which, listWindow **pptr, grin_openMode mode)
{
	oneHandlePtr handlePtr;
	MSGNR i;
	_UBYTE varName[128];
	_BOOL doRedraw;
	_BOOL bool;
	_WORD sort;
	_BOOL reverse;
	SearchRecordType saveVar;
	listWindow *ptr;
	
	/* Gruppe oeffnen und Stichwortliste anzeigen */
	if ((ptr = *pptr = handlePool_BlankToList(sizeof(listWindow), &MsgList_windows)) == NULL)
		return FALSE;
	if ((handlePtr = handlePool_GetOneDatahandle(gruppe)) == NULL)
	{
		handlePool_FreeOnePtr(ptr, &MsgList_windows);
		return FALSE;
	}
	ptr->wdw = -1;
	ptr->grHandle = handlePtr;
	ptr->grinWindow = -1;
	MsgListBase_MakeTitle(gruppe, ptr->grName, sizeof(ptr->grName));
	ptr->maxPos = data_LastMsgOfGroup(gruppe);
	if (ptr->maxPos == dataSys_empty)
	{
		handlePool_FreeOneDataHandle(handlePtr);
		handlePool_FreeOnePtr(ptr, &MsgList_windows);
		return FALSE;
	}
	++ptr->maxPos;
	if (which >= ptr->maxPos)
		which = ptr->maxPos - 1;
	ptr->usedByGrin = 0;
	
	/* Jetzt "Liste" aufbauen */
	if ((ptr->wholeList = MALLOC(ptr->maxPos * sizeof(listEntry), "openGroup: wholeList")) == NULL)
	{
		handlePool_FreeOneDataHandle(handlePtr);
		handlePool_FreeOnePtr(ptr, &MsgList_windows);
		return FALSE;
	}
	ptr->list = ptr->wholeList;
	/* Liste fuellen */
	for (i = 0; i < ptr->maxPos; i++)
	{
		ptr->wholeList[i].msgNum = i;
		ptr->wholeList[i].flags = 0;
		ptr->wholeList[i].i.treeNum = 0;
	}
	if (GroupSelect_isPrivate(gruppe))
		ptr->partArray = privateParts;
	else
		ptr->partArray = globalParts;
	ptr->startPos = which;
	ptr->maxWidth = 0;
	ptr->isLocked = FALSE;
	doRedraw = FALSE;
	ptr->unreadOrNew = mode == mFirstNew || mode == mUnread;
	ptr->openMode = mode;
	/* Jetzt eventuell verkleinern */
	if (ptr->unreadOrNew)
	{
		ConfVars_GetConfDefBool(cListShowSmallList, &bool, FALSE);
		if (bool)
		{
			/* Liste verkleinern */
			MsgListBase_shrinkToEnd(ptr, FALSE);
			/* doRedraw = TRUE; */
		}
		/* Jetzt eventuell gefilterte rausnehmen */
		ConfVars_GetConfDefBool(cListDontShowFiltered, &bool, FALSE);
		if (bool)
		{
			/* Gefilterte selektieren und dann Liste verkleinern */
			MsgListBase_listSelectFiltered(ptr->wdw, TRUE, FALSE);
			MsgListBase_shrinkList(ptr, TRUE, FALSE);
			/* doRedraw = TRUE; */
		}
		/* Eventuellen Autoselect durchfuehren */
		saveVar = suchVar;
		for (i = 1; i <= 10; i++)
		{
			make_varname(varName, sizeof(varName), cListDefaultSelect, i);
			ConfVars_GetConfDefBool(varName, &bool, FALSE);
			if (bool)
			{
				/* Ok, steht auf TRUE, also selektieren */
				ptr->isLocked = TRUE;
				if (SearchHelp_getKonf(i - 1, &suchVar) && SearchHelp_ValidateKonf(&suchVar))
				{
					MsgListBase_doMark(ptr, FALSE);
					doRedraw = TRUE;
				}
				ptr->isLocked = FALSE;
			}
		}
		suchVar = saveVar;
		/* Jetzt mal nachsehen, ob wir auch sortieren muessen */
		ConfVars_GetConfDefInt(cListDefaultSort, &sort, sNum);
		ConfVars_GetConfDefBool(cListDefReverse, &reverse, FALSE);
		if ((sortType)sort != sNum || reverse)
		{
			MsgListBase_setSort((sortType)sort,!reverse);
			ptr->isLocked = TRUE;
			MsgListBase_doSort(ptr, (sortType)sort,!reverse, FALSE);
			doRedraw = TRUE;
			ptr->isLocked = FALSE;
		}
	}
	if (doRedraw)
		WdwManager_FullRedrawWdw(ptr->wdw);
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _BOOL msgList_listChangeGroup(LISTHANDLE hdl, HWND grinWdw, MSGNR mess, CAT_GROUP_NUMBER newGroup, grin_openMode mode)
{
	listWindow *newPtr, *ptr;
	LGRECT doc;
	
	if ((ptr = MsgListBase_FindHandle(hdl)) == NULL)
		return FALSE;
	if (grinWdw != ptr->grinWindow)
		return FALSE;
	if (ptr->wdw < 0 || !openGroup(newGroup, mess, &newPtr, mode))
	{
		msgList_listUnlockWdw(hdl);  /* muss gemacht werden */
		return FALSE; /* Gruppe konnte nicht geoeffnet werden */
	}
	msgList_listUnlockWdw(hdl);
	if (ptr->usedByGrin == 0)
	{
		/* Speicher freigeben und Gruppe schliessen */
		MsgListBase_freeList(ptr);
		handlePool_FreeOneDataHandle(ptr->grHandle);
		/* Jetzt neue Variablen ueberkopieren */
		ptr->wholeList = newPtr->wholeList;
		ptr->list     = newPtr->list;
		ptr->grHandle = newPtr->grHandle;
		strCpy(ptr->grName, newPtr->grName);
		ptr->maxPos   = newPtr->maxPos;
		ptr->startPos = newPtr->startPos;
		ptr->maxWidth = newPtr->maxWidth;
		ptr->partArray = newPtr->partArray;
		/* neuen Ptr wieder freigeben */
		handlePool_FreeOnePtr(newPtr, &MsgList_windows);
		newPtr = ptr;
	} else
	{
		/* Alte Gruppe ist mehrfach belegt, geht nicht. Neue wieder schliessen und
		 * alles freigeben
		 */
		MsgListBase_freeList(newPtr);
		handlePool_FreeOneDataHandle(newPtr->grHandle);
		handlePool_FreeOnePtr(newPtr, &MsgList_windows);
		return FALSE;
	}
	/* Nun auch dem Windowmanager ueber die neuen Sachen informieren */
	/* grinWdw setzen */
	newPtr->grinWindow = grinWdw;
	/* Titel umsetzen */
	WdwManager_SetWdwTitle(newPtr->wdw, newPtr->grName);
	/* Neue Dokumentparameter setzen */
	newPtr->leftOffset = 0;
	doc.x = newPtr->leftOffset;
	doc.y = newPtr->startPos;
	doc.w = newPtr->maxWidth;
	doc.h = newPtr->maxPos - 1;
	WdwManager_SetNewDocument(newPtr->wdw, &doc, TRUE);
	/* Und jetzt noch grin Bescheid sagen, dass es ein neues Fenster gibt.
	 * Wichtig wegen der NextMessProzedur
	 */
	grin_grinSetListWdw(newPtr->grinWindow, grin_grinNextMess, newPtr);
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

/* Nachrichten werden ueber die Suchfunktion markiert
 */
GLOBAL _VOID msgList_listSearch(HWND wdw)
{
	listWindow *ptr;
	
	if ((ptr = MsgListBase_FindWind(wdw)) != NULL)
		MsgListBase_doMark(ptr, TRUE);
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

/*DYJ 5.27c */
LOCAL _BOOL parseListLine(CONST _UBYTE *listline, partArrayDesc *p)
{
#define okSet "ACDEFHILMRSUW#, "
#define numSet "0123456789"
#define skipSet " ,"
#define formatSet "BDHT"
	_ULONG num;
	_UBYTE ch;
	partNameType pName;
	partFormat fStr;
	_WORD i;
	
	if (listline == NULL || *listline == '\0')
		return FALSE;
	p->lines = 0;
	p->width = 0;
	while (*listline != '\0')
	{
		/* Ersten Eintrag suchen */
		while (*listline != '\0' && strChr(skipSet, *listline) != NULL)
			listline++;
		if (*listline != '\0')
		{
			ch = *listline;
			if (listline[1] != '(')
				return FALSE;
			MemSetZeroArray(fStr);
			listline += 2;
			num = 0;
			while (*listline != '\0' && strChr(numSet, *listline) != NULL)
			{
				num = num * 10 + (*listline - '0');
				listline++;
			}
			if (*listline == '\0' ||
				(*listline != ')' &&
				 *listline != ',' &&
				 strChr(formatSet, ch) == NULL))
			{
				return FALSE;
			}
			if (*listline == ',' && strChr(formatSet, ch) != NULL)
			{
				/* Formatstring lesen */
				++listline;    /* ',' ueberspringen */
				i = 0;
				while (*listline != '\0' && *listline != ')' && i < partFormatLength)
				{
					fStr[i++] = *listline++;
				}
				if (i >= partFormatLength || *listline == '\0')
					return FALSE;
				fStr[i] = '\0';
			}
			++listline;   /* ')' ueberspringen */
			switch (ch)
			{
			case 'A':
				pName = pRealName;
				break;
				
			case 'B':
				pName = pWeekday;
				if (fStr[0] == '\0')
				{
					strBcpy(fStr, "GGGGGGGGGGG");
				} else if (fStr[0] == '#' && fStr[1] != '\0')
				{
					ch = fStr[1];
					MemSet(fStr, ch, sizeof(fStr) - 1);
					fStr[sizeof(fStr)-1] = '\0';
				}
				break;
				
			case 'C':
				pName = pComments;
				break;
				
			case 'D':
				pName = pDatum;
				if (fStr[0] == '\0')
					strBcpy(fStr, "DD.MM.YY");
				break;
			
			case 'E':
				pName = pOwnMess;
				break;
				
			case 'F':
				pName = pFlags;
				break;
				
			case 'H':
				pName = pFuzzytime;
				if (fStr[0] == '\0')
					strBcpy(fStr, "G");
				break;
			
			case 'L':
				pName = pLength;
				break;
				
			case 'M':
				pName = pMailId;
				break;
			
			case 'N':
				pName = pAttachment;
				break;
			case 'I':
				pName = pMId;
				break;
				
			case 'R':
				pName = pRefId;
				break;
			
			case 'S':
				pName = pStatus;
				break;
			
			case 'T':
				pName = pTime;
				if (fStr[0] == '\0')
					strBcpy(fStr, "HH:MM");
				break;
			
			case 'U':
				pName = pUserName;
				break;
			
			case 'W':
				pName = pWegen;
				break;
				
			case '#':
				pName = pCount;
				break;
			case 'V':
				pName = pFrom;
				break;
				
			case 'Z':
				pName = pTo;
				break;
				
			default:
				return FALSE;
			}
			if (num == 0 || num > 1024)
				return FALSE;
			if (p->lines >= maxParts)
				return FALSE;
			p->parts[p->lines].type = pName;
			p->parts[p->lines].w = (_WORD) num;
			strBcpy(p->parts[p->lines].formatStr, fStr);
			++p->lines;
			p->width += (_WORD) num;
		}
	}
	if (p->lines == 0)
		return FALSE;
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

/* Testet, ob die uebergebene Zeile fuer die Stichwortliste in Ordnung ist */

  /* Das Format einer Zeile besteht aus einzelnen Kuerzeln
   * fuer einen Eintrag und darauffolgend in Klammern die Weite dieses Eintrages.
   * Beispiel: D(12),I(10),U(30),W(30),F(2)
   * Erlaubte Zeilenelemente:
   * D: Datum. Das Datum ist maximal 12 Zeichen lang und hat folgende Form:
   *           Mo, 16.11.92
   *    Optional kann man auch einen Formatstring angeben, der folgende Elemente
   *    enthalten darf:
   *     D: Tagesziffer  (d: wird geloescht, wenn nicht auffuellbar)
   *     Y: Jahresziffer (y: wird geloescht, wenn nicht auffuellbar)
   *     M: Monatsziffer (m: wird geloescht, wenn nicht auffuellbar)
   *     G: Monatsbuchstabe Deutsch
   *     F: Monatsbuchstabe Franzoesisch
   *     E: Monatsbuchstabe English
   *     #E (Hinter Ziffern): englische Zahlfortsetzung (1st, 2nd, 3rd, 4th...)
   * T: Zeit. Default-Format fuer die Zeit ist HH:SS, also 06:13.
   *    Optional kann man auch einen Formatstring angeben, der folgendes
   *    enthalten darf:
   *
   *   HH: Stundenzahl ("hh" loescht fuehrende Null)
   *   MM: Minutenzahl ("mm" loescht fuehrende Null)
   *   SS: Sekundenzahl ("ss" loescht fuehrende Null)
   *
   *   #E: AM/PM-Notierung (English) ("e" schreibt "am" bzw. "pm")
   *
   *   Beispiel: Aus 'hh Uhr mm' wird '13 Uhr 5'
   *   Die Angabe von Sekunden in einem Formatstring ist allerdings unsinnig,
   *   da die Zeitangaben zu Mails keine Sekunden enthalten.
   * W: Wochentag. Auch hier kann man einen Formatstring angeben, der die Sprache
   *    spezifiziert, in der der Wochentag ausgegeben wird.
   *
   *     G: Tagesbuchstabe Deutsch
   *     F: Tagesbuchstabe Franzoesisch
   *     E: Tagesbuchstabe English
   *
   *    Es muss fuer die gesamte gewuenschte Laenge ein Formatbuchstabe angegeben
   *    werden.
   *    Wenn das erste Zeichen in der Maske ein != ist, dann wird die
   *    Maske komplett mit dem zweiten Zeichen der Maske gefuellt.
   *    Beispiel: Aus #G wird intern GGGGGGGGGGGGGG
   *
   * I: Message-Id. Im Moment ist diese maximal 10 Zeichen lang, aber ab Maus 9.0
   *                koennen Ids wesentlich laenger werden.
   * R: Reference-Id: Bei Kommentaren oder Antworten die Id der Referenznachricht.
   * U: Username
   * A: Realname (wird ersetzt durch Username, falls nicht vorhanden)
   * W: Stichwort. Vor MAUS 9 maximal 30 Zeichen.
   * F: Flags. Die Flags der Nachrichten, die man in CAT setzen kann.
   *           Reihenfolge wie in der Messageanzeige, also LFITDKB12
   * S: Status. Nur fuer persoenliche Nachrichten, andernfalls wird es ignoriert.
   * C: Kommentare: Anzahl der Kommentare auf die Nachricht, nicht fuer persoenliche Nachrichten.
   * !=: interne Nummer der Message. Maximal 5 Stellen.
   */

GLOBAL _BOOL msgList_CheckListLine(CONST _UBYTE *listline)
{
	partArrayDesc p;

	return parseListLine(listline, &p);
}

/*** ---------------------------------------------------------------------- ***/
	
/* Setzt die Stichwortlistenzeile fuer die private oder andere Gruppen
 * Wenn die Zeile fehlerhaft ist, wird die vorhandene Zeile nicht
 * veraendert.
 */
GLOBAL _VOID msgList_SetListLine(CONST _UBYTE *listline, _BOOL is_private)
{
	partArrayDesc p;

	if (parseListLine(listline, &p))
	{
		if (is_private)
		{
			ConfVars_SetConfigString(cPrivateMsgListElems, listline);
			privateParts = p;
		} else
		{
			ConfVars_SetConfigString(cGrpMsgListElems, listline);
			globalParts = p;
		}
	}
}
