/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */


/*
 * 25.1.03 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.20c'
 *	Fehler beim Sortier-Popup der SWL behoben
 *
 * 1.5.03 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.27c'
 *	Bei der SWL konnte man bisher nur Absender oder Empfnger anzeigen lassen,
 *	wobei Cat entschied welches, jetzt kann man auch speziell eines der beiden
 *	oder beide anzeigen lassen.
 *
 * 25.8.04 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.38e'
 *	SWL: Gefilterte nicht anzeigen berarbeitet.
 */

#include <grin.h>
#include <msglistb.h>
#include <userinfo.h>
#include <edittype.h>
#include <mte.h>
#include <vdistand.h>
#include <vdiutil.h>
#include <maustaus.h>
#include <cattypes.h>
#include <handlepo.h>
#include <confvars.h>
#include <varname1.h>
#include <varname3.h>
#include <varname5.h>
#include <wdwmanag.h>
#include <rectfunc.h>
#include <fontsele.h>
#include <catgloba.h>
#include <catfiles.h>
#include <grintool.h>
#include <quicksor.h>
#include <zsearchd.h>
#include <groupsel.h>
#include <clip.h>
#include <searchhe.h>
#include <convertd.h>
#include <protokol.h>
#include <msglist.h>
#include <catutil.h>

#include <mtappl.h>
#include <mtarea.h>
#include <mtutils.h>
#include <mtdials.h>
#include <mtpopups.h>
#include <mttextfi.h>
#include <mtxobjec.h>

#include <tos.h>
#include <routinec.h>
#include <routines.h>
#include <set.h>
#include <strconv.h>
#include <keyboard.h>
#include <debug.h>
#include <dd.h>
#include <mime.h>

GLOBAL List MsgList_windows;
GLOBAL _WORD msglist_lineDist = 2;
GLOBAL _WORD msglist_pixOffset = 8;
GLOBAL _WORD msglist_globalNumber = -1;
GLOBAL sortType MsgListLstSort;

LOCAL _BOOL extendedCommentMode = TRUE;

/* Objektbaeume */
LOCAL OBJECT *butBox; /* LISTCTL */
LOCAL OBJECT *selPop; /* LSELPOP */
LOCAL OBJECT *removePop; /* LREMVPOP */
LOCAL OBJECT *sortPop; /* LSORTPOP */

LOCAL SET listNums;

LOCAL _BOOL ignoreCase; /* fuer die Sortierung */


/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

/*-------------- Suchfunktionen in Liste -----------------------*/

GLOBAL _BOOL MsgListBase_FindWinCond(_VOID *e, _VOID *i)
{
	return ((listWindow *)e)->wdw == *((HWND *)i);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _BOOL MsgListBase_FindHandleCond(_VOID *e, _VOID *i)
{
	return e == *((LISTHANDLE *)i);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _BOOL MsgListBase_FindGroupCond(_VOID *e, _VOID *i)
{
	return ((listWindow *)e)->grHandle->group == *((CAT_GROUP_NUMBER *)i);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL listWindow *MsgListBase_FindWind(HWND wdw)
{
	_VOID *ptr;
	
	if (!handlePool_FindEntry(&wdw, MsgListBase_FindWinCond, &MsgList_windows, &ptr))
		return NULL;
	return ptr;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL listWindow *MsgListBase_FindHandle(LISTHANDLE hdl)
{
	_VOID *ptr;
	
	if (!handlePool_FindEntry(&hdl, MsgListBase_FindHandleCond, &MsgList_windows, &ptr))
		return NULL;
	return ptr;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL listWindow *MsgListBase_FindGroup(CAT_GROUP_NUMBER gruppe)
{
	_VOID *ptr;
	
	if (!handlePool_FindEntry(&gruppe, MsgListBase_FindGroupCond, &MsgList_windows, &ptr))
		return NULL;
	return ptr;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _WORD MsgListBase_FindNum(_VOID)
{
	_WORD i;

	if (msglist_globalNumber >= 0 && !setin(listNums, msglist_globalNumber))
	{
		setincl(listNums, msglist_globalNumber);
		i = msglist_globalNumber;
		msglist_globalNumber = -1;
		return i;
	}
	for (i = 0; i < SETMAX; i++)
	{
		if (!setin(listNums, i))
		{
			setincl(listNums, i);
			return i;
		}
	}
	return -1;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID MsgListBase_ClearNum(_WORD num)
{
	setexcl(listNums, num);
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

/*-------------- Serviceprozeduren fuer grin (next/prev) -------*/

GLOBAL _BOOL MsgListBase_findMsgIdx(listWindow *ptr, MSGNR which, MSGNR *idx)
{
	MSGNR i;
	
	if (which < ptr->maxPos && ptr->list[which].msgNum == which)
	{
		*idx = which;
		return TRUE;
	}
	for (i = ptr->maxPos; i > 0; )
	{
		--i;
		if (ptr->list[i].msgNum == which)
		{
			*idx = i;
			return TRUE;
		}
	}
	*idx = dataSys_empty;
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL MSGNR MsgListBase_FindNextSelected(listWindow *ptr, MSGNR which)
{
	MSGNR i, idx;
	MSGBITS bits;

	if (MsgListBase_findMsgIdx(ptr, which, &idx))
	{
		for (i = idx+1; i < ptr->maxPos; i++)
		{
			if (ptr->list[i].flags & msglist_Selected)
			{
				if (ptr->unreadOrNew && UserBLK.ignoreRead && !(ptr->list[i].flags & msglist_initRead))
				{
					data_ReadState(ptr->grHandle->Zugriff, ptr->list[i].msgNum, &bits);
					if (!(bits & bGelesen))
						return ptr->list[i].msgNum;
				} else
				{
					return ptr->list[i].msgNum;
				}
			}
		}
	}
	return dataSys_empty;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL MSGNR MsgListBase_FindPrevSelected(listWindow *ptr, MSGNR which)
{
	MSGNR i, idx;
	MSGBITS bits;

	if (MsgListBase_findMsgIdx(ptr, which, &idx) && idx > 0)
	{
		for (i = idx; i > 0; )
		{
			--i;
			if (ptr->list[i].flags & msglist_Selected)
			{
				if (ptr->unreadOrNew && UserBLK.ignoreRead && !(ptr->list[i].flags & msglist_initRead))
				{
					data_ReadState(ptr->grHandle->Zugriff, ptr->list[i].msgNum, &bits);
					if (!(bits & bGelesen))
						return ptr->list[i].msgNum;
				} else
				{
					return ptr->list[i].msgNum;
				}
			}
		}
	}
	return dataSys_empty;
}

/*** ---------------------------------------------------------------------- ***/

/* Deselektierte suchen, fuer Bestimmung von neuer Startpoistion */
LOCAL MSGNR MsgListBase_FindNextDeselected(listWindow *ptr, MSGNR which)
{
	MSGNR i, idx;

	if (MsgListBase_findMsgIdx(ptr, which, &idx))
	{
		for (i = idx+1; i < ptr->maxPos; i++)
		{
			if (!(ptr->list[i].flags & msglist_Selected))
			{
				return ptr->list[i].msgNum;
			}
		}
	}
	return dataSys_empty;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL MSGNR MsgListBase_FindPrevDeselected(listWindow *ptr, MSGNR which)
{
	MSGNR i, idx;

	if (MsgListBase_findMsgIdx(ptr, which, &idx))
	{
		for (i = idx; i > 0; )
		{
			--i;
			if (!(ptr->list[i].flags & msglist_Selected))
			{
				return ptr->list[i].msgNum;
			}
		}
	}
	return dataSys_empty;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL MSGNR MsgListBase_listNextMess(MSGNR which, _BOOL nextJN, _BOOL withShift, LISTHANDLE listHandle, _VOID *listWdw)
{
	listWindow *ptr;

	UNUSED(listWdw);
	if ((ptr = MsgListBase_FindHandle(listHandle)) != NULL)
	{
		if (nextJN)
			return MsgListBase_FindNextSelected(ptr, which);
		else
			return MsgListBase_FindPrevSelected(ptr, which);
	}
	return grin_grinNextMess(which, nextJN, withShift, 0, NULL);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _BOOL MsgListBase_hasSelectedEntries(listWindow *ptr, MSGNR *first)
{
	MSGNR i;
	
	for (i = 0; i < ptr->maxPos; i++)
		if (ptr->list[i].flags & msglist_Selected)
		{
			*first = i;
			return TRUE;
		}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL MSGNR MsgListBase_countSelectedEntries(listWindow *ptr)
{
	MSGNR i, counter;
	
	for (i = 0, counter = 0; i < ptr->maxPos; i++)
		if (ptr->list[i].flags & msglist_Selected)
			++counter;
	return counter;
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

/*-------------- Selektion von Eintraegen ----------------------*/

LOCAL _VOID MsgListBase_redrawEntry(listWindow *ptr, MSGNR entry)
{
	GRECT rect;

	if (entry >= ptr->maxPos)
		return;
	if (entry >= ptr->startPos)
	{
		rect = ptr->listWork;
		rect.g_x += msglist_pixOffset;
		rect.g_y = rect.g_y + (_WORD)(entry - ptr->startPos) * (ptr->charHeight + msglist_lineDist);
		rect.g_h = ptr->charHeight + msglist_lineDist;
		WdwManager_RedrawWdw(ptr->wdw, &rect);
		WdwManager_SetClip(ptr->vdi, &ptr->listWork, TRUE);
	}
	ptr->list[entry].flags &= ~msglist_doRedraw;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID MsgListBase_toggleEntry(listWindow *ptr, MSGNR entry)
{
	if (entry >= ptr->maxPos)
		return;
	MsgListBase_toggleBit(ptr->list[entry].flags, msglist_Selected);
	MsgListBase_redrawEntry(ptr, entry);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID MsgListBase_invertSelection(listWindow *ptr)
{
	MSGNR i;
	
	for (i = 0; i < ptr->maxPos; i++)
		MsgListBase_toggleBit(ptr->list[i].flags, msglist_Selected);
	/* kompletten Redraw ausloesen */
	WdwManager_FullRedrawWdw(ptr->wdw);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID MsgListBase_deselectEntries(listWindow *ptr)
{
	MSGNR i;
	GRECT rect;
	_BOOL first;
	
	rect = ptr->listWork;
	rect.g_x += msglist_pixOffset;
	rect.g_h = ptr->charHeight + msglist_lineDist;
	first = TRUE;
	for (i = 0; i < ptr->maxPos; i++)
	{
		if (ptr->list[i].flags & msglist_Selected)
		{
			ptr->list[i].flags &= ~msglist_Selected;
			if (i >= ptr->startPos && i <= ptr->startPos + (MSGNR)ptr->windLines)
			{
				if (first)
				{
					rect.g_y = ptr->listWork.g_y + (_WORD)(i - ptr->startPos) * (ptr->charHeight + msglist_lineDist);
					first = FALSE;
				} else
				{
					rect.g_h = ptr->listWork.g_y + (_WORD)(i - ptr->startPos + 1) * (ptr->charHeight + msglist_lineDist) - rect.g_y;
				}
			}
		}
	}
    if (!first)
    	WdwManager_RedrawWdw(ptr->wdw, &rect);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID MsgListBase_deselectReadEntries(listWindow *ptr)
{
	MSGNR i;
	GRECT rect;
	_BOOL first;
	MSGBITS bits;
	
	rect = ptr->listWork;
	rect.g_x += msglist_pixOffset;
	rect.g_h = ptr->charHeight + msglist_lineDist;
	first = TRUE;
	for (i = 0; i < ptr->maxPos; i++)
	{
		if (!(ptr->list[i].flags & msglist_firstRead))
		{
			/* Wurde noch gar nicht gelesen, mal schnell den Readstatus
			 * dazu rausfinden
			 */
			data_ReadState(ptr->grHandle->Zugriff, ptr->list[i].msgNum, &bits);
			if (bits & bGelesen)
				ptr->list[i].flags &= ~msglist_notRead;
			else
				ptr->list[i].flags |= msglist_notRead;
		}
		if ((ptr->list[i].flags & msglist_Selected) &&
			!(ptr->list[i].flags & msglist_notRead))
		{
			ptr->list[i].flags &= ~msglist_Selected;
			if (i >= ptr->startPos && i <= ptr->startPos + (MSGNR)ptr->windLines)
			{
				if (first)
				{
					rect.g_y = ptr->listWork.g_y + (_WORD)(i - ptr->startPos) * (ptr->charHeight + msglist_lineDist);
					first = FALSE;
				} else
				{
					rect.g_h = ptr->listWork.g_y + (_WORD)(i - ptr->startPos + 1) * (ptr->charHeight + msglist_lineDist) - rect.g_y;
				}
			}
		}
	}
    if (!first)
    	WdwManager_RedrawWdw(ptr->wdw, &rect);
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

/* --------------------- Cursorbehandlung ------------------*/

#define cursor_visible(ptr) \
	((ptr)->cursPos >= (_LONG)(ptr)->startPos && \
	 (ptr)->cursPos < (_LONG)((ptr)->startPos + (MSGNR)((ptr)->windLines)))

LOCAL _VOID MsgListBase_drawCursor(listWindow *ptr)
{
	_WORD line[5 * 2];
	_WORD fill[4];
	_WORD xOutput, yOutput;
	_UWORD style;

	/* Zeichnet einen gepunkteten Rahmen um die Zeile mit der aktuellen
	 * Cursorposition
	 */
	if (cursor_visible(ptr))
	{
		/* Cursor ist sichtbar, also zeichnen */
		xOutput = ptr->listWork.g_x + msglist_pixOffset - ptr->leftOffset;
		yOutput = ptr->listWork.g_y + (_WORD)(ptr->cursPos - (_LONG)ptr->startPos) * (ptr->charHeight + msglist_lineDist) + (msglist_lineDist / 2);
		line[0] = xOutput;
		line[1] = yOutput;
		line[2] = xOutput + ptr->entryWidth - 1;
		line[3] = yOutput;
		line[4] = xOutput + ptr->entryWidth - 1;
		line[5] = yOutput + ptr->charHeight - 1;
		line[6] = xOutput;
		line[7] = yOutput + ptr->charHeight - 1;
		line[8] = xOutput;
		line[9] = yOutput;
		/* Schreibmodus setzen */
		vswr_mode(ptr->vdi, MD_XOR);
		/* Linientyp setzen */
		vsl_type(ptr->vdi, USERLINE);
		if (ptr->leftOffset & 1)
			style = 0xAAAA;
		else
			style = 0x5555;
		vsl_udsty(ptr->vdi, style);
		vsl_width(ptr->vdi, 1);
		vsl_color(ptr->vdi, BLACK);
		v_pline(ptr->vdi, 5, line);
		/* Jetzt PixOffset am linken Rand ggf. loeschen */
		vswr_mode(ptr->vdi, MD_REPLACE);
		vsf_color(ptr->vdi, ptr->listBackCol);  /* Weiss */
		fill[0] = ptr->listWork.g_x;
		fill[1] = yOutput;
		fill[2] = ptr->listWork.g_x + msglist_pixOffset - 1;
		fill[3] = yOutput + ptr->charHeight - 1;
		vr_recfl(ptr->vdi, fill);
		/* Schreibmodus zuruecksetzen */
		vswr_mode(ptr->vdi, MD_TRANS);
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID MsgListBase_ShowCursor(listWindow *ptr)
{
	GRECT r;
	
	if (cursor_visible(ptr))
	{
		/* Cursor ist sichtbar, also zeichnen */
		/* WindUpdate und Maus ausschalten */
		MsgListBase_updateListWdw(ptr->wdw, ptr, TRUE);
		if (WdwManager_RectList(ptr->wdw, 0, &r))
		{
			do
			{
				/* ClipRechteck setzen */
				WdwManager_SetClip(ptr->vdi, &r, TRUE);
				/* Zeichnen */
				MsgListBase_drawCursor(ptr);
			} while (WdwManager_RectList(ptr->wdw, 1, &r));
		}
		/* WindUpdate wieder aus und Maus anschalten */
		MsgListBase_updateListWdw(ptr->wdw, ptr, FALSE);
	}
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

/*-------------- Funktionen fuer WdwManager --------------------*/

LOCAL _VOID MsgListBase_AdjustTreePos(listWindow *ptr, CONST GRECT *r)
{
	butBox[ROOT].ob_x = r->g_x;
	butBox[ROOT].ob_y = r->g_y;
	butBox[ROOT].ob_width = r->g_w;
	ptr->butWork.g_x = butBox[ROOT].ob_x;
	ptr->butWork.g_y = butBox[ROOT].ob_y;
	ptr->butWork.g_w = butBox[ROOT].ob_width;
	ptr->butWork.g_h = butBox[ROOT].ob_height - ObjcFrame(butBox, ROOT);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID CheckAssign(_UBYTE *str, size_t strsize, CONST _UBYTE *src)
{
	if (src != NULL)
		strMcpy(str, strsize, src);
	else
		strMcpy(str, strsize, "(not available)");
}

/*** ---------------------------------------------------------------------- ***/

/*DYJ 5.20w */	/*DYJ 5.21b */	/*DYJ 5.27c */
GLOBAL _VOID MsgListBase_GetLinePart(listWindow *ptr, MSGNR num, MessageType *mess, _UBYTE *line, size_t strsize, CONST partType *type)
{
	_UBYTE tmpStr[1024];
	size_t maxLen;
	size_t i;
	_UBYTE ch;
	partNameType nametype;
	F_TIME time;
	
	nametype = type->type;
	if (nametype == pRealName && (mess->name == NULL || mess->name[0] == '\0' || mess->EigeneNachricht))
		nametype = pUserName;
	switch (nametype)
	{
	case pRealName:
	case pUserName:
	{
		_WORD msgType;
		msgType=grin_MsgIsOwn(mess);
		if (!GroupSelect_isPrivate(mess->Gruppe) || msgType==MSG_FREMD || msgType==MSG_ALIAS)
		{
			if (nametype == pRealName)
				CheckAssign(tmpStr, sizeof(tmpStr), mess->name);
			else
				CheckAssign(tmpStr, sizeof(tmpStr), mess->Absender);
			line[0] = '\0';
			maxLen = type->w;
		}
		else
		{
			size_t pLen=4;
			line[0] = '\0';
			maxLen = type->w;
			switch(msgType)
			{
				case MSG_SCHIZO:
					strCpy(tmpStr,"<->: ");
					pLen=5;
					break;
				case MSG_INTERN:
					if (nametype == pRealName)
						CheckAssign(tmpStr, sizeof(tmpStr), mess->name);
					else
						CheckAssign(tmpStr, sizeof(tmpStr), mess->Absender);
					maxLen = type->w/2-2;
					if (maxLen > sizeof(tmpStr))
						maxLen = sizeof(tmpStr);
					CatGlobal_KurzName(tmpStr, tmpStr, maxLen);
					strCat(tmpStr," ");
					strMcpy(line, strsize, tmpStr);
					pLen=strLen(line);
					maxLen = type->w-pLen;
					pLen+=5;
				case MSG_EIGENE:
					strCpy(tmpStr,MausTauschrsc_WrkString(HEAD_AN));
					strCat(tmpStr," ");
					break;
			}
			if (maxLen > pLen+1)
				maxLen = pLen+1;
			if (maxLen > strsize)
				maxLen = strsize;
			strMcat(line, maxLen, tmpStr);
			CheckAssign(tmpStr, sizeof(tmpStr), mess->Empfaenger);
			maxLen = type->w;
			if (maxLen >= pLen)
				maxLen -= pLen;
			else
				maxLen = 0;
		}
		maxLen++;
		if (maxLen > sizeof(tmpStr))
			maxLen = sizeof(tmpStr);
		CatGlobal_KurzName(tmpStr, tmpStr, maxLen);
		strMcat(line, strsize, tmpStr);
		break;
	}
	case pFrom:
		CheckAssign(tmpStr, sizeof(tmpStr), mess->Absender);
		line[0] = '\0';
		maxLen = type->w;
		if (maxLen > sizeof(tmpStr))
			maxLen = sizeof(tmpStr);
		CatGlobal_KurzName(tmpStr, tmpStr, maxLen);
		strMcat(line, strsize, tmpStr);
		break;
	case pTo:
		CheckAssign(tmpStr, sizeof(tmpStr), mess->Empfaenger);
		line[0] = '\0';
		maxLen = type->w;
		if (maxLen > sizeof(tmpStr))
			maxLen = sizeof(tmpStr);
		CatGlobal_KurzName(tmpStr, tmpStr, maxLen);
		strMcat(line, strsize, tmpStr);
		break;
	case pMailId:
		CheckAssign(tmpStr, sizeof(tmpStr), mess->MailID);
		maxLen = type->w;
		if (maxLen < sizeof(tmpStr))
			tmpStr[maxLen] = '\0';
		strMcpy(line, strsize, tmpStr);
		break;

	case pAttachment:
	{
		_WORD anzAnh;
		anzAnh=Mime_CntAtt(mess->attachment,TRUE);
		if(anzAnh)
		{
			_BOOL showRelF;
			ConfVars_GetConfDefBool(sShowRelatedFile,&showRelF,FALSE);
			if(anzAnh==1)
				sprintf(tmpStr,MausTauschrsc_WrkString(ATTACH_1));
			else
				sprintf(tmpStr,MausTauschrsc_WrkString(ATTACH_N),anzAnh);
		}
		else
			*tmpStr='\0';
		maxLen = type->w + 1;
		if (maxLen > strsize)
			maxLen = strsize;
		strMcpy(line, maxLen, tmpStr);
		break;
	}
	case pMId:
		CheckAssign(tmpStr, sizeof(tmpStr), mess->mid);
		maxLen = type->w;
		if (maxLen < sizeof(tmpStr))
			tmpStr[maxLen] = '\0';
		strMcpy(line, strsize, tmpStr);
		break;

	case pRefId:
		CheckAssign(tmpStr, sizeof(tmpStr), mess->KommentierteID);
		maxLen = type->w;
		if (maxLen >= sizeof(tmpStr))
			maxLen = sizeof(tmpStr) - 1;
		tmpStr[maxLen] = '\0';
		if (*tmpStr != '\0')
			strInsertChar('-', tmpStr, sizeof(tmpStr));
		tmpStr[maxLen] = '\0';
		strMcpy(line, strsize, tmpStr);
		break;

	case pWegen:
		CheckAssign(tmpStr, sizeof(tmpStr), mess->Betreff);
		if (strLen(tmpStr) > type->w)
		{
			/* Zu lang, hinten ... anhaengen */
			maxLen = type->w;
			if (maxLen >= sizeof(tmpStr))
				maxLen = sizeof(tmpStr) - 1;
			
			for (i = 0; i < 3 && i < maxLen; i++)
				tmpStr[maxLen - i - 1] = '.';
			tmpStr[maxLen] = '\0';
		}
		strMcpy(line, strsize, tmpStr);
		break;
		
	case pStatus:
		if (GroupSelect_isPrivate(ptr->grHandle->group))
			line[0] = mess->Status;
		else if (mess->StatusBits & bGelesen)
			line[0] = 'G';
		else
			line[0] = 'N';
		line[1] = '\0';
		break;
		
	case pDatum:
		ConvertDate_CatDate2Datim(MessDate(*mess), &time);
		maxLen = type->w + 1;
		if (maxLen > strsize)
			maxLen = strsize;
		ConvertDate_DateToText(&time, type->formatStr, line, maxLen);
		break;
	
	case pTime:
		ConvertDate_CatDate2Datim(MessDate(*mess), &time);
		maxLen = type->w + 1;
		if (maxLen > strsize)
			maxLen = strsize;
		ConvertDate_TimeToText(&time, type->formatStr, line, maxLen);
		break;
		
	case pWeekday:
		ConvertDate_CatDate2Datim(MessDate(*mess), &time);
		maxLen = type->w + 1;
		if (maxLen > strsize)
			maxLen = strsize;
		ConvertDate_DayToText(&time, type->formatStr, line, maxLen);
		break;
		
	case pFuzzytime:
		ConvertDate_CatDate2Datim(MessDate(*mess), &time);
		maxLen = type->w + 1;
		if (maxLen > strsize)
			maxLen = strsize;
		ConvertDate_FuzzyTime(&time, type->formatStr, line, maxLen);
		break;
		
	case pComments:
		maxLen = type->w + 1;
		if (maxLen > strsize)
			maxLen = strsize;
		CardToStr(mess->KommentarAnzahl, type->w, line, maxLen);
		break;
		
	case pCount:
		CardToStr(num+1, type->w - 1, tmpStr, sizeof(tmpStr));
		strInsertChar('#', tmpStr, sizeof(tmpStr));
		maxLen = type->w + 1;
		if (maxLen > strsize)
			maxLen = strsize;
		strMcpy(line, maxLen, tmpStr);
		break;
		
	case pOwnMess:
		if ((mess->StatusBits & bOwnMessage) || (mess->StatusBits & bComToOwnMessage))
			ch = '*';
		else
			ch = ' ';
		maxLen = type->w;
		if (maxLen >= strsize)
			maxLen = strsize - 1;
		for (i = 0; i < maxLen; i++)
			line[i] = ch;
		line[maxLen] = '\0';
		break;
		
	case pLength:
		CardToStr(mess->textLen, 5, tmpStr, sizeof(tmpStr));
		strBcat(tmpStr, " Bytes");	/* :language: */
		maxLen = type->w + 1;
		if (maxLen > strsize)
			maxLen = strsize;
		strMcpy(line, maxLen, tmpStr);
		break;
		
	case pFlags:
		Decode_StatusBits(mess->StatusBits, tmpStr, TRUE);
		maxLen = type->w;
		if (maxLen < sizeof(tmpStr))
			tmpStr[maxLen] = '\0';
		strMcpy(line, strsize, tmpStr);
		break;
		
	default:
		*line = '\0';
		break;
	}
}

/*** ---------------------------------------------------------------------- ***/
#define maxParts        12   /* Anzahl der maximalen verschiedenen Zeilenteile */
#define partFormatLength  32   /* maximale Laenge eines Formatstrings */

/* Geht davon aus, dass RectFuncs.ClipRect gesetzt ist und nur Zeilen zu zeichnen sind!
 */
/*DYJ 5.23k */	/*DYJ 5.27c */
LOCAL _VOID msgList_rawRedraw(listWindow *ptr, CONST GRECT *clip)
{
	_WORD i;
	_WORD width;
	_WORD xOutput, yOutput;
	_WORD xOffset;
	_WORD j;
	MSGNR topLine;
	_UBYTE line[1024];
	listEntry entry;
	MessageType mess;
	GRECT myClip;
	_WORD fill[4];
	_BOOL isOwn;
	_BOOL isC2O;
	F_ERROR error;
	_WORD col,eff,oldcol=-1,oldeff=-1;
	_WORD lineLength;
	_WORD offsets[maxParts],linePar=0,idemMode;
	_UBYTE *lines[2],idemStr[10],*aktElem;
	_BOOL chkIdem[maxParts];

	MemSetZeroStruct(mess);
	lineLength=0;
	for (j = 0; j < ptr->partArray.lines; j++)
	{
		offsets[j]=lineLength;
		lineLength+= ptr->partArray.parts[j].w+1;
	}
	if((2*lineLength)>sizeof(line))
		lines[0]=MALLOC(2*lineLength * sizeof(_UBYTE), "msgList_rawRedraw");
	else
		lines[0]=line;
	lines[1]=lines[0]+lineLength;
	ConfVars_GetConfDefInt(cListIdemMode, &idemMode,0);
	ConfVars_GetConfDefStr(cListIdemStr, idemStr,sizeof(idemStr),"\"");
	for (j = 0; j < ptr->partArray.lines; j++)
	{
		strMcpy(&lines[linePar][offsets[j]],ptr->partArray.parts[j].w,"\xff%$");
		if(idemMode)
		{
			switch (ptr->partArray.parts[j].type)
			{
			case pRealName:
			case pUserName:
				chkIdem[j]=(MsgListLstSort==sAddr)||idemMode==2;
				break;
			case pFrom:
				chkIdem[j]=(MsgListLstSort==sAbs)||idemMode==2;
				break;
			case pTo:
				chkIdem[j]=(MsgListLstSort==sEmpf)||idemMode==2;
				break;
			
			case pWegen:
				chkIdem[j]=((MsgListLstSort==sWegen)||(MsgListLstSort==sTree))||idemMode==2;
				break;

			case pDatum:
			case pTime:
			case pWeekday:
			case pFuzzytime:
				chkIdem[j]=(MsgListLstSort==sDate)||idemMode==2;
				break;
				
			case pRefId:
				chkIdem[j]=idemMode==2;
				break;
			default:
				chkIdem[j]=FALSE;
				break;
			}
		}
		else
			chkIdem[j]=FALSE;
	}
	
	topLine = ptr->startPos;
	i = 0;   /* Zeilenzaehler im Fenster */
	/* Nicht im Redrawbereich liegende Zeilen ueberspringen */
	while (topLine < ptr->maxPos && (ptr->listWork.g_y + (i + 1) * (ptr->charHeight + msglist_lineDist)) - 1 < clip->g_y)
	{
		++topLine;
		++i;
	}
	if(i && idemMode)
	{
		entry = ptr->list[topLine-1];
		/* Header der Message lesen */
		error = data_ReadHeader(ptr->grHandle->Zugriff, entry.msgNum, &mess,TRUE);
		if (error == NoError)
		{
			for (j = 0; j < ptr->partArray.lines; j++)
			{
				aktElem=&lines[linePar][offsets[j]];
				MsgListBase_GetLinePart(ptr, entry.msgNum, &mess, aktElem, lineLength-offsets[j], &ptr->partArray.parts[j]);
			}
		}
	}
	xOutput = ptr->listWork.g_x + msglist_pixOffset - ptr->leftOffset;
	yOutput = ptr->listWork.g_y + i * (ptr->charHeight + msglist_lineDist) + (msglist_lineDist / 2);
	/* Eintrag in Liste suchen */
	/* Jetzt zeichnen */
	myClip = *clip;
	vsf_color(ptr->vdi, BLACK);
	vst_color(ptr->vdi, ptr->listTextCol);
	vswr_mode(ptr->vdi, MD_TRANS);
	while (topLine < ptr->maxPos && i <= ptr->listWork.g_h / (ptr->charHeight + msglist_lineDist) &&
		yOutput <= clip->g_h)
	{
		entry = ptr->list[topLine];
		/* Header der Message lesen */
		error = data_ReadHeader(ptr->grHandle->Zugriff, entry.msgNum, &mess,(ptr->list[topLine].flags & msglist_msgCorrupt)==0);
		if (error != NoError)
		{
			ptr->list[topLine].flags |= msglist_msgCorrupt;
			mess.MailID = NULL;
			mess.Betreff = NULL;
			mess.Absender = NULL;
			mess.Empfaenger = NULL;
			mess.mid = NULL;
			mess.rid = NULL;
			mess.box = NULL;
			mess.name = NULL;
			mess.InfoStrings = NULL;
		}
		/* Erstmal Flag in Liste updaten */
		if (mess.StatusBits & bGelesen)
			ptr->list[topLine].flags &= ~msglist_notRead;
		else
			ptr->list[topLine].flags |= msglist_notRead;
		/* Testen, ob Gelesen-Flag veraendert wurde */
		if (((mess.StatusBits & bGelesen) != 0) != ((entry.flags & msglist_notRead) == 0) &&
			(entry.flags & msglist_firstRead))
		{
			/* Eintrag muss komplett neu gezeichnet werden */
			ptr->list[topLine].flags |= msglist_doRedraw;
		}
		ptr->list[topLine].flags |= msglist_firstRead;
		/* Jetzt die einzelnen Zeilenteile ausgeben */
		/* Nicht gelesene werden fett dargestellt */
		isOwn = (mess.StatusBits & bOwnMessage) ||
			(GroupSelect_isPrivate(ptr->grHandle->group) && mess.EigeneNachricht);
		isC2O = (mess.StatusBits & bComToOwnMessage) ;
		col=ptr->listTextCol;
		eff=TXT_NORMAL;
		if (!(mess.StatusBits & bGelesen))
		{
			if(ptr->listNotReadCol!=KEEPCOL)
				col=ptr->listNotReadCol;
			eff|=ptr->quoteEff;
		}
		if (isOwn)
		{
			eff|=ptr->ownEff;
			if(ptr->listOwnCol!=KEEPCOL)
				col=ptr->listOwnCol;
		}
		else if (isC2O)
		{
			eff|=ptr->c2oEff;
			if(ptr->listC2OCol!=KEEPCOL)
				col=ptr->listC2OCol;
		}
		if(col!=oldcol)
		{
			vst_color(ptr->vdi, col);
			oldcol=col;
		}
		if(eff!=oldeff)
		{
			vst_effects(ptr->vdi, eff);
			oldeff=eff;
		}
		xOffset = 0;
		linePar=1-linePar;
		for (j = 0; j < ptr->partArray.lines; j++)
		{
			aktElem=&lines[linePar][offsets[j]];
			MsgListBase_GetLinePart(ptr, entry.msgNum, &mess, aktElem, lineLength-offsets[j], &ptr->partArray.parts[j]);
			width = ptr->partArray.parts[j].w * ptr->charWidth;
			myClip.g_w = Min(clip->g_w, xOutput + xOffset + width);
			if (myClip.g_w >= clip->g_x && xOutput + xOffset <= myClip.g_w)
			{
				/* WdwManager.SetClip (vdi, myClip, FALSE); */
				if(chkIdem[j])
				{
					if(!strCaseCmp(&lines[0][offsets[j]],&lines[1][offsets[j]]))
						aktElem=idemStr;
				}
				VDIUtil_Text(ptr->isFSM, ptr->vdi, xOutput + xOffset, yOutput + ptr->charHeight - 1, aktElem);
			}
			xOffset += width + ptr->charWidth;
		}
		if (entry.flags & msglist_Selected)
		{
			/*
			WdwManager_SetClip(ptr->vdi, clip, FALSE);
			*/
			fill[0] = xOutput;
			fill[1] = yOutput;
			fill[2] = xOutput + xOffset - 1;
			fill[3] = yOutput + ptr->charHeight - 1;
			/* Schreibmodus setzen */
			vswr_mode(ptr->vdi, MD_XOR);
			vr_recfl(ptr->vdi, fill);
			vswr_mode(ptr->vdi, MD_TRANS);
		}
		ptr->entryWidth = xOffset;
		ptr->maxWidth = Max(ptr->maxWidth, xOffset + msglist_pixOffset);
		data_freeMessage(&mess);
		if (ptr->cursPos >= 0 && (_LONG)topLine == ptr->cursPos)
		{
			MsgListBase_drawCursor(ptr);
			vsf_color(ptr->vdi, BLACK);
		}
		++i;
		++topLine;
		yOutput += ptr->charHeight + msglist_lineDist;
	}
	vsf_color(ptr->vdi, ptr->listBackCol);
	vst_effects(ptr->vdi, 0);
	vst_color(ptr->vdi, ptr->listTextCol);

}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID msgList_SetDocument(listWindow *ptr, _BOOL new)
{
	LGRECT doc;

	doc.x = ptr->leftOffset;
	doc.y = ptr->startPos;
	doc.w = ptr->maxWidth;
	doc.h = ptr->maxPos - 1;
	if (new)
		WdwManager_SetNewDocument(ptr->wdw, &doc, FALSE);
	else
		WdwManager_SetWdwDocument(ptr->wdw, &doc);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID MsgListBase_FullRedraw(listWindow *ptr)
{
	/* Neues Document setzen */
	msgList_SetDocument(ptr, TRUE);
	WdwManager_FullRedrawWdw(ptr->wdw);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID MsgListBase_shrinkToEnd(listWindow *ptr, _BOOL doRedraw)
{
	MSGNR i, j;
	_BOOL allocNew;
	listEntry *oldList;
	MSGNR start;
	
	if (ptr->startPos == 0)
		return;
	if (ptr->startPos >= ptr->maxPos)
		return; /* HALT */
	if (ptr->wholeList == ptr->list)
	{
		ptr->list = MALLOC((ptr->maxPos - ptr->startPos) * sizeof(listEntry), "MsgListBase_shrinkToEnd");
		if (ptr->list == NULL)
		{
			ptr->list = ptr->wholeList;
			return;
		}
		allocNew = TRUE;
		oldList = ptr->wholeList;
	} else
	{
		oldList = ptr->list;
		allocNew = FALSE;
	}
	/* Erstmal neue Startposition festlegen */
	start = oldList[ptr->startPos].msgNum;
	/* Und jetzt die Liste verkleinern */
	j = 0;
	for (i = ptr->startPos; i < ptr->maxPos; i++)
	{
		ptr->list[j] = oldList[i];
		++j;
	}
	if (!allocNew)
	{
		/* Speicherbereich verkleinern */
		/* ptr->list = realloc(ptr->list, (ptr->maxPos - ptr->startPos) * sizeof(listEntry)); */
	}
	/* neue maxPos festlegen */
	ptr->maxPos = ptr->maxPos - ptr->startPos;
	MsgListBase_findMsgIdx(ptr, start, &ptr->startPos);
	if (ptr->startPos >= ptr->maxPos)
		ptr->startPos = ptr->maxPos - 1;
	ptr->cursPos = -1;
	if (doRedraw)
		MsgListBase_FullRedraw(ptr);
}

/*** ---------------------------------------------------------------------- ***/

/* removes the selected messages from the list */
/*DYJ 5.21b */
GLOBAL _BOOL MsgListBase_shrinkList(listWindow *ptr, _BOOL removeSel, _BOOL doRedraw)
{
	MSGNR firstSel;
	MSGNR count, i, j;
	_BOOL allocNew;
	listEntry *oldList;
	MSGNR start;
	
	if (MsgListBase_hasSelectedEntries(ptr, &firstSel))
	{
		count = MsgListBase_countSelectedEntries(ptr);
		if (count == 0 || count == ptr->maxPos)
		{
			if (removeSel)
				MTE_infoRSC(AL_EMPTY_LIST);
			return TRUE;
		}
		/* Erstmal neue Startposition festlegen */
		if (!removeSel)
		{
			/* naechste selektierte suchen */
			if (!(ptr->list[ptr->startPos].flags & msglist_Selected))
			{
				start = MsgListBase_FindNextSelected(ptr, ptr->list[ptr->startPos].msgNum);
				if (start >= ptr->maxPos)
					start = MsgListBase_FindPrevSelected(ptr, ptr->list[ptr->startPos].msgNum);
			} else
			{
				start = ptr->list[ptr->startPos].msgNum;
			}
		} else
		{
			if (ptr->list[ptr->startPos].flags & msglist_Selected)
			{
				start = MsgListBase_FindNextDeselected(ptr, ptr->list[ptr->startPos].msgNum);
				if (start > ptr->maxPos)
					start = MsgListBase_FindPrevDeselected(ptr, ptr->list[ptr->startPos].msgNum);
			} else
			{
				start = ptr->list[ptr->startPos].msgNum;
			}
		}
		if (ptr->wholeList == ptr->list)
		{
			if (removeSel)
				ptr->list = MALLOC((ptr->maxPos - count) * sizeof(listEntry), "MsgListBase_shrinkList");
			else
				ptr->list = MALLOC(count * sizeof(listEntry), "MsgListBase_shrinkList");
			if (ptr->list == NULL)
			{
				ptr->list = ptr->wholeList;
				return FALSE;
			}
			allocNew = TRUE;
			oldList = ptr->wholeList;
		} else
		{
			oldList = ptr->list;
			allocNew = FALSE;
		}
		/* Und jetzt die Liste verkleinern */
		j = 0;
		for (i = 0; i < ptr->maxPos; i++)
		{
			if ((removeSel && !(oldList[i].flags & msglist_Selected)) ||
				(!removeSel && (oldList[i].flags & msglist_Selected)))
			{
				ptr->list[j] = oldList[i];
				++j;
			}
		}
		if (!allocNew)
		{
			/* Speicherbereich verkleinern */
			if (removeSel)
			{
				/* ptr->list = realloc(ptr->list, (ptr->maxPos - count) * sizeof(listEntry)); */
			} else
			{
				/* ptr->list = realloc(ptr->list, count * sizeof(listEntry)); */
			}
		}
		if (removeSel)
			ptr->maxPos = ptr->maxPos - count;
		else
			ptr->maxPos = count;
		MsgListBase_findMsgIdx(ptr, start, &ptr->startPos);
		/* startPos = BinOps.LowerCard (startPos, maxPos); */
		if (ptr->startPos > ptr->maxPos)
			ptr->startPos = 0;
		if (ptr->startPos + ptr->windLines > ptr->maxPos)
		{
			if ((MSGNR)ptr->windLines > ptr->maxPos)
				ptr->startPos = 0;
			else
				ptr->startPos = ptr->maxPos - (MSGNR)ptr->windLines;
		}
		ptr->cursPos = -1;
		if (doRedraw)
			MsgListBase_FullRedraw(ptr);
		return TRUE;
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID MsgListBase_showAll(listWindow *ptr)
{
	MSGNR start;

	if (ptr->list != ptr->wholeList)
	{
		start = ptr->list[ptr->startPos].msgNum;
		/* deallocate list */
		SFREE(ptr->list);
		ptr->list = ptr->wholeList;
		ptr->maxPos = data_LastMsgOfGroup(ptr->grHandle->group)+1;
		MsgListBase_findMsgIdx(ptr, start, &ptr->startPos);
/*DYJ 5.38e Start*/
		if(MsgListBase_hideFilt())
		{
			/* Gefilterte selektieren und dann Liste verkleinern */
			MsgListBase_listSelectFiltered(ptr->wdw, TRUE, FALSE);
			MsgListBase_shrinkList(ptr, TRUE, FALSE);
		}
/*DYJ  Ende; */
		if (ptr->startPos >= ptr->maxPos)
			ptr->startPos = ptr->maxPos - 1;
		ptr->cursPos = -1;
		MsgListBase_FullRedraw(ptr);
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL selTree(OneGroupHandle handle, MSGNR msgIdx, pBlock *mess, _VOID *private)
{
	MSGNR i;
	listWindow *ptr;
	
	UNUSED(handle);
	UNUSED(mess);
	/* search for mess */
	ptr = private;
	/* First try normal list */
	if (msgIdx < ptr->maxPos && ptr->list[msgIdx].msgNum == msgIdx)
	{
		ptr->list[msgIdx].flags |= msglist_Selected;
		ptr->list[msgIdx].flags &= ~msglist_inTree;
		return TRUE;
	}
	/* Not found, search from end */
	i = ptr->maxPos;
	for (;;)
	{
		if (i == 0)
			return TRUE;
		--i;
		if (ptr->list[i].msgNum == msgIdx)
		{
			ptr->list[i].flags |= msglist_Selected;
			ptr->list[i].flags &= ~msglist_inTree;
			return TRUE;
		}
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID MsgListBase_selectTree(listWindow *ptr, _BOOL doRedraw)
{
	MSGNR firstSel;
	MSGNR i;

	if (MsgListBase_hasSelectedEntries(ptr, &firstSel))
	{
		/* Fuer alle selektierten Nachrichten das inTree-Flag setzen */
		for (i = firstSel; i < ptr->maxPos; i++)
		{
			if (ptr->list[i].flags & msglist_Selected)
				ptr->list[i].flags |= msglist_inTree;
		}
		for (i = firstSel; i < ptr->maxPos; i++)
		{
			if (ptr->list[i].flags & msglist_inTree)
			{
				/* Alle Nachrichten im Baum selektieren */
				data_WalkTree(ptr->grHandle->Zugriff, ptr->list[i].msgNum, TRUE, selTree, ptr);
			}
		}
		if (doRedraw)
		{
			/* Alles neuzeichnen */
			WdwManager_FullRedrawWdw(ptr->wdw);
		}
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID MsgListBase_selectFromTop(listWindow *ptr)
{
	MSGNR i;

	for (i = ptr->startPos; i < ptr->maxPos; i++)
		ptr->list[i].flags |= msglist_Selected;
	WdwManager_FullRedrawWdw(ptr->wdw);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID MsgListBase_removeTree(listWindow *ptr)
{
	MSGNR firstSel;
	
	if (MsgListBase_hasSelectedEntries(ptr, &firstSel))
	{
		/* ok, ready, set, go */
		MsgListBase_selectTree(ptr, FALSE);
		/* And now remove selected */
		if (!MsgListBase_shrinkList(ptr, TRUE, TRUE))
		{
			/* Redraw wird schon in shrinkList gemacht, wenn TRUE zurueckkommt */
			WdwManager_FullRedrawWdw(ptr->wdw);
		}
	}
}

/*** ---------------------------------------------------------------------- ***/

/* Alle Nachrichten in dem Fenster werden selektiert */
GLOBAL _VOID MsgListBase_listSelectFiltered(HWND wdw, _BOOL doSelect, _BOOL doRedraw)
{
	listWindow *ptr;
	MSGNR i;
	MSGBITS bits;

	if ((ptr = MsgListBase_FindWind(wdw)) != NULL)
	{
		CatGlobal_busyMouse();
		for (i = 0; i < ptr->maxPos; i++)
		{
			data_ReadState(ptr->grHandle->Zugriff, ptr->list[i].msgNum, &bits);
			if (bits & bFiltered)
			{
				if (doSelect)
					ptr->list[i].flags |= msglist_Selected;
				else
					ptr->list[i].flags &= ~msglist_Selected;
			}
			if ((i % 75) == 0)
				CatGlobal_busyMouse();
		}
		MouseArrow();
		if (doRedraw)
		{
			/* Und jetzt vorsichtshalber Redraw ausloesen */
			WdwManager_FullRedrawWdw(wdw);
		}
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID MsgListBase_openSelected(listWindow *ptr, _BOOL doNotTop, _BOOL withCtrl)
{
	MSGNR firstSel;
	_BOOL isOpen;
	grinNextMessProc nextMsg;
	HWND window;
	CAT_GROUP_NUMBER group;	
	MSGNR mess;
	MSGNR i;
	MSGBITS bits;
	_ULONG size;
	
	if (MsgListBase_hasSelectedEntries(ptr, &firstSel))
	{
		if (MsgListBase_countSelectedEntries(ptr) > 1)
		{
			nextMsg = MsgListBase_listNextMess;
			/* Jetzt vorarbeiten fuer Gelesene ignorieren */
			for (i = firstSel; i < ptr->maxPos; i++)
			{
				if (ptr->list[i].flags & msglist_Selected)
				{
					/* Statusbits lesen */
					data_ReadState(ptr->grHandle->Zugriff, ptr->list[i].msgNum, &bits);
					if (bits & bGelesen)
						ptr->list[i].flags |= msglist_initRead;
					else
						ptr->list[i].flags &= ~msglist_initRead;
				} else
				{
					ptr->list[i].flags &= ~msglist_initRead;
				}
			}
		} else
		{
			nextMsg = grin_grinNextMess;
		}
		isOpen = FALSE;
		if (ptr->grinWindow >= 0 && !withCtrl)
		{
			grin_ActualGroupNr(ptr->grinWindow, &group);
			if (grin_grinWindowTop(ptr->grinWindow) && group == ptr->grHandle->group)
			{
				isOpen = grin_grinSwitchTo(ptr->grinWindow, ptr->list[firstSel].msgNum, nextMsg, ptr, doNotTop);
				if (isOpen)
					if (ptr->usedByGrin == 0)
						++ptr->usedByGrin;
			} else
			{
				ptr->grinWindow = -1;
			}
		}
		if (!isOpen)
		{
			++ptr->usedByGrin;
			window = grin_grinOpenMessage(ptr->grHandle->group, ptr->list[firstSel].msgNum, nextMsg, ptr, ptr->openMode);
			/* Nun Anfragen, welches Grinfenster nun top ist */
			if (window >= 0 && grin_grinWindowTop(window) &&
				grin_getBasicInfo(window, &group, &mess, &size) &&
				group == ptr->grHandle->group &&
				mess == ptr->list[firstSel].msgNum)
			{
				ptr->grinWindow = window;
			}
		}
	}
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID MsgListBase_freeList(listWindow *ptr)
{
	if (ptr->list != NULL)
	{
		if (ptr->list != ptr->wholeList)
		{
			SFREE(ptr->list);
			ptr->list = NULL;
		}
		if (ptr->wholeList != NULL)
		{
			SFREE(ptr->wholeList);
			ptr->wholeList = NULL;
		}
	}
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/
/*DYJ 5.21b */
LOCAL _BOOL testBreak(_VOID)
{
	_UBYTE ch, scan;
	_UWORD kstate;
	
	if (VDIUtil_isKey(&kstate, &scan, &ch) && ch == 0x1b)
		return mtAlerts_AlertRSC(1, AL_SORTBREAK) == 2;
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _WORD listsort_strCmp(CONST _UBYTE *s1, CONST _UBYTE *s2)
{
	if (ignoreCase)
		return strSortCmp(s1, s2);
	return strCmp(s1, s2);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _WORD nameCompare(CONST _UBYTE *str1, CONST _UBYTE *str2)
{
	_UBYTE n1[256];
	_UBYTE n2[256];
	_UBYTE v1[256];
	_UBYTE v2[256];
	CONST _UBYTE *p1;
	CONST _UBYTE *p2;
	_UBYTE *x1, *x2;
	_WORD r;
	size_t l1, l2;
	
	/* Erstmal Nachnamen suchen */
	p1 = strChr(str1, ' ');
	if (p1 != NULL)
	{
		l1 = p1 - str1 + 1;
		if (l1 > sizeof(v1))
			l1 = sizeof(v1);
		strMcpy(v1, l1, str1);
		strMcpy(n1, sizeof(n1), p1 + 1);
		/* Noch nach @ suchen und abschneiden! */
		x1 = strChr(n1, '@');
		if (x1 != NULL)
			*x1 = '\0';
	}
	p2 = strChr(str2, ' ');
	if (p2 != NULL)
	{
		l2 = p2 - str2 + 1;
		if (l2 > sizeof(v2))
			l2 = sizeof(v2);
		strMcpy(v2, l2, str2);
		strMcpy(n2, sizeof(n2), p2 + 1);
		/* Noch nach @ suchen und abschneiden! */
		x2 = strChr(n2, '@');
		if (x2 != NULL)
			*x2 = '\0';
	}
	if (p1 != NULL && p2 != NULL)
	{
		/* Und jetzt koennen wir vergleichen */
		r = listsort_strCmp(n1, n2);
		if (r == 0)
			r = listsort_strCmp(v1, v2);
	} else if (p1 != NULL)
	{
		/* Vergleich von Nachnamen mit Namen */
		r = listsort_strCmp(n1, str2);
		if (r == 0)
		{
			/* Vergleich von Vornamen mit Namen */
			r = listsort_strCmp(v1, str2);
		}
	} else if (p2 != NULL)
	{
		/* Vergleich von Nachnamen mit Namen */
		r = listsort_strCmp(str1, n2);
		if (r == 0)
		{
			/* Vergleich von Vornamen mit Namen */
			r = listsort_strCmp(str1, v2);
		}
	} else
	{
		r = listsort_strCmp(str1, str2);
	}
	return r;
}

/*** ---------------------------------------------------------------------- ***/

typedef struct {
	_ULONG cmpCount;
	_BOOL vorw;		
} listsort_info;

LOCAL _BOOL compNum(CONST _VOID *e1, CONST _VOID *e2, _VOID *private)
{
	CONST listEntry *x;
	CONST listEntry *y;
	listsort_info *info;
	
	x = e1;
	y = e2;
	info = private;
	if ((info->cmpCount % 25) == 0)
		CatGlobal_busyMouse();
	++info->cmpCount;
	if(info->vorw)
		return x->msgNum < y->msgNum;
	else
		return x->msgNum > y->msgNum;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL compTree(CONST _VOID *e1, CONST _VOID *e2, _VOID *private)
{
	CONST listEntry *x;
	CONST listEntry *y;
	listsort_info *info;
	
	x = e1;
	y = e2;
	info = private;
	if ((info->cmpCount % 25) == 0)
		CatGlobal_busyMouse();
	++info->cmpCount;
	if(info->vorw)
	{
		if (x->i.treeNum == y->i.treeNum)
			return x->msgNum < y->msgNum;
		return x->i.treeNum < y->i.treeNum;
	}
	else
	{
		if (x->i.treeNum == y->i.treeNum)
			return x->msgNum > y->msgNum;
		return x->i.treeNum > y->i.treeNum;
	}
}

/*** ---------------------------------------------------------------------- ***/

/*DYJ 5.23k */
LOCAL _VOID prepareSizeSort(listWindow *ptr, MSGNR start, MSGNR end)
{
	MessageType mess1;
	MSGNR i;
	MemSetZeroStruct(mess1);
	
	for (i = start; i <= end; i++)
	{
		mess1.InfoStrings = NULL;
		data_ReadHeader(ptr->grHandle->Zugriff, ptr->list[i].msgNum, &mess1,TRUE);
		ptr->list[i].i.treeNum = mess1.textLen;
		data_freeMessage(&mess1);
	}
}

/*** ---------------------------------------------------------------------- ***/

/*DYJ 5.00a */	/*DYJ 5.23k */
LOCAL _VOID prepareDateSort(listWindow *ptr, MSGNR start, MSGNR end)
{
	MessageType mess1;
	MSGNR i;
	MemSetZeroStruct(mess1);
	
	for (i = start; i <= end; i++)
	{
		mess1.InfoStrings = NULL;
		data_ReadMessage(ptr->grHandle->Zugriff, ptr->list[i].msgNum, &mess1);
		if(mess1.eZeitX && *mess1.eZeitX)
			ptr->list[i].i.treeNum =ConvertDate_UTC(MessDate(mess1));
		else
			ptr->list[i].i.treeNum = mess1.tauschDate;
		data_ReadSmallHeader(ptr->grHandle->Zugriff, ptr->list[i].msgNum, &mess1);
		ptr->list[i].i.treeNum = mess1.tauschDate;
		data_freeMessage(&mess1);
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL compName(CONST _VOID *e1, CONST _VOID *e2, _VOID *private)
{
	CONST listEntry *x;
	CONST listEntry *y;
	listsort_info *info;
	_WORD comp;
	
	x = e1;
	y = e2;
	info = private;
	if ((info->cmpCount % 25) == 0)
		CatGlobal_busyMouse();
	++info->cmpCount;
	comp = nameCompare(x->i.strPtr, y->i.strPtr);
	if(info->vorw)
	{
		if (comp == 0)
			return x->msgNum < y->msgNum;
		else
			return comp < 0;
	}
	else
	{
		if (comp == 0)
			return x->msgNum > y->msgNum;
		else
			return comp > 0;
	}
}

/*** ---------------------------------------------------------------------- ***/

/*DYJ 5.27c */	/*DYJ 5.23k */
LOCAL _BOOL prepareNameSort(listWindow *ptr, MSGNR start, MSGNR end,sortType sort)
{
	MessageType mess1;
	MSGNR i;
	group_line str1;
	MemSetZeroStruct(mess1);
	
	for (i = start; i <= end; i++)
	{
		mess1.InfoStrings = NULL;
		mess1.Absender = NULL;
		mess1.Gruppe = NO_GROUP;
		mess1.Empfaenger = NULL;
		data_ReadHeader(ptr->grHandle->Zugriff, ptr->list[i].msgNum, &mess1,TRUE);
		*str1 = '\0';
		if (sort==sEmpf || sort==sAddr && (GroupSelect_isPrivate(mess1.Gruppe) && mess1.EigeneNachricht))
		{
			if (mess1.Empfaenger != NULL)
				strBcpy(str1, mess1.Empfaenger);
		} else
		{
			if (mess1.Absender != NULL)
				strBcpy(str1, mess1.Absender);
		}
		data_freeMessage(&mess1);
		ptr->list[i].i.strPtr = STRDUP(str1, "prepareNameSort");
		if (ptr->list[i].i.strPtr == NULL)
		{
			/* bisher allozierte Strings wieder freigeben */
			while (i > start)
			{
				--i;
				SFREE(ptr->list[i].i.strPtr);
				ptr->list[i].i.strPtr = NULL;
			}
			return FALSE;
		}
	}
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

/*DYJ 5.23k */
LOCAL _BOOL prepareWegenSort(listWindow *ptr, MSGNR start, MSGNR end)
{
	MessageType mess1;
	MSGNR i;
	group_line str1;
	MemSetZeroStruct(mess1);
	
	for (i = start; i <= end; i++)
	{
		mess1.InfoStrings = NULL;
		mess1.Betreff = NULL;
		data_ReadHeader(ptr->grHandle->Zugriff, ptr->list[i].msgNum, &mess1,TRUE);
		*str1 = '\0';
		if (mess1.Betreff != NULL)
			strBcpy(str1, mess1.Betreff);
		data_freeMessage(&mess1);
		ptr->list[i].i.strPtr = STRDUP(str1, "prepareWegenSort");
		if (ptr->list[i].i.strPtr == NULL)
		{
			/* bisher allozierte Strings wieder freigeben */
			while (i > start)
			{
				--i;
				SFREE(ptr->list[i].i.strPtr);
				ptr->list[i].i.strPtr = NULL;
			}
			return FALSE;
		}
	}
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL compWegen(CONST _VOID *e1, CONST _VOID *e2, _VOID *private)
{
	CONST listEntry *x;
	CONST listEntry *y;
	listsort_info *info;
	_WORD comp;
	_BOOL hasRe1, hasRe2;
	
	x = e1;
	y = e2;
	info = private;
	if ((info->cmpCount % 25) == 0)
		CatGlobal_busyMouse();
	++info->cmpCount;
	hasRe1 = FALSE;
	hasRe2 = FALSE;
	if (strnCaseCmp(x->i.strPtr, "RE:", 3) == 0)
	{
		strCpy(x->i.strPtr, x->i.strPtr + 3);
		strleft(x->i.strPtr);
		hasRe1 = TRUE;
	}
	if (strnCaseCmp(y->i.strPtr, "RE:", 3) == 0)
	{
		strCpy(y->i.strPtr, y->i.strPtr + 3);
		strleft(y->i.strPtr);
		hasRe2 = TRUE;
	}
	comp = listsort_strCmp(x->i.strPtr, y->i.strPtr);
	if(info->vorw)
	{
		if (comp == 0)
		{
			if (hasRe1 && !hasRe2)
				return FALSE;
			if (!hasRe1 && hasRe2)
				return TRUE;
			return x->msgNum < y->msgNum;
		}
		else
			return comp < 0;
	}
	else
	{
		if (comp == 0)
		{
			if (hasRe1 && !hasRe2)
				return TRUE;
			if (!hasRe1 && hasRe2)
				return FALSE;
			return x->msgNum > y->msgNum;
		}
		else
			return comp > 0;
	}
}

/*** ---------------------------------------------------------------------- ***/

typedef struct {
	MSGNR start;
	MSGNR end;
	listWindow *ptr;
	_ULONG tree;
} markTreeInfo;

LOCAL _BOOL markTree(OneGroupHandle handle, MSGNR msgIdx, pBlock *mess, _VOID *private)
{
	MSGNR i;
	listWindow *ptr;
	markTreeInfo *info;
	
	UNUSED(handle);
	UNUSED(mess);
	/* search for mess */
	info = private;
	ptr = info->ptr;
	/* First try normal list */
	if (msgIdx < ptr->maxPos && ptr->list[msgIdx].msgNum == msgIdx)
	{
		ptr->list[msgIdx].i.treeNum = info->tree;
		return TRUE;
	}
	/* Not found, search from end */
	i = info->end;
	for (;;)
	{
		if (ptr->list[i].msgNum == msgIdx)
		{
			ptr->list[i].i.treeNum = info->tree;
			break;
		}
		if (i == info->start)
			break;
		--i;
	}
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID prepareTreeSort(listWindow *ptr, MSGNR start, MSGNR end)
{
	MSGNR i;
	markTreeInfo info;
	
	for (i = start; i <= end; i++)
		ptr->list[i].i.treeNum = 0;
	info.tree = 0;
	info.ptr = ptr;
	info.start = start;
	info.end = end;
	for (i = start; i <= end; i++)
	{
		if (ptr->list[i].i.treeNum == 0)
		{
			CatGlobal_busyMouse();
			data_WalkTree(ptr->grHandle->Zugriff, ptr->list[i].msgNum, TRUE, markTree, &info);
			++info.tree;
		}
	}
}

/*** ---------------------------------------------------------------------- ***/

/*DYJ 5.23k */
LOCAL _BOOL prepareIdSort(listWindow *ptr, MSGNR start, MSGNR end)
{
	MessageType mess1;
	MSGNR i;
	group_line str1;
	MemSetZeroStruct(mess1);
	
	for (i = start; i <= end; i++)
	{
		mess1.InfoStrings = NULL;
		mess1.Betreff = NULL;
		data_ReadHeader(ptr->grHandle->Zugriff, ptr->list[i].msgNum, &mess1,TRUE);
		*str1 = '\0';
		if (mess1.MailID != NULL)
			strBcpy(str1, mess1.MailID);
		data_freeMessage(&mess1);
		ptr->list[i].i.strPtr = STRDUP(str1, "prepareWegenSort");
		if (ptr->list[i].i.strPtr == NULL)
		{
			/* bisher allozierte Strings wieder freigeben */
			while (i > start)
			{
				--i;
				SFREE(ptr->list[i].i.strPtr);
				ptr->list[i].i.strPtr = NULL;
			}
			return FALSE;
		}
	}
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL compId(CONST _VOID *e1, CONST _VOID *e2, _VOID *private)
{
	CONST listEntry *x;
	CONST listEntry *y;
	listsort_info *info;
	_WORD comp;
	
	x = e1;
	y = e2;
	info = private;
	if ((info->cmpCount % 25) == 0)
		CatGlobal_busyMouse();
	++info->cmpCount;
	comp = strCaseCmp(x->i.strPtr, y->i.strPtr);
	if(info->vorw)
	{
		if (comp == 0)
			return x->msgNum < y->msgNum;
		else
			return comp < 0;
	}
	else
	{
		if (comp == 0)
			return x->msgNum > y->msgNum;
		else
			return comp > 0;
	}
}

/*** ---------------------------------------------------------------------- ***/

/*DYJ 5.23k */
LOCAL _BOOL prepareLIdSort(listWindow *ptr, MSGNR start, MSGNR end)
{
	MessageType mess1;
	MSGNR i;
	group_line str1;
	MemSetZeroStruct(mess1);
	
	for (i = start; i <= end; i++)
	{
		mess1.InfoStrings = NULL;
		mess1.Betreff = NULL;
		data_ReadHeader(ptr->grHandle->Zugriff, ptr->list[i].msgNum, &mess1,TRUE);
		*str1 = '\0';
		if (mess1.mid != NULL)
			strBcpy(str1, mess1.mid);
		data_freeMessage(&mess1);
		ptr->list[i].i.strPtr = STRDUP(str1, "prepareWegenSort");
		if (ptr->list[i].i.strPtr == NULL)
		{
			/* bisher allozierte Strings wieder freigeben */
			while (i > start)
			{
				--i;
				SFREE(ptr->list[i].i.strPtr);
				ptr->list[i].i.strPtr = NULL;
			}
			return FALSE;
		}
	}
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL compLId(CONST _VOID *e1, CONST _VOID *e2, _VOID *private)
{
	CONST listEntry *x;
	CONST listEntry *y;
	listsort_info *info;
	_WORD comp;
	
	x = e1;
	y = e2;
	info = private;
	if ((info->cmpCount % 25) == 0)
		CatGlobal_busyMouse();
	++info->cmpCount;
	comp = strCaseCmp(x->i.strPtr, y->i.strPtr);
	if(info->vorw)
	{
		if (comp == 0)
			return x->msgNum < y->msgNum;
		else
			return comp < 0;
	}
	else
	{
		if (comp == 0)
			return x->msgNum > y->msgNum;
		else
			return comp > 0;
	}
}

/*** ---------------------------------------------------------------------- ***/

/*DYJ 5.27c */
GLOBAL _VOID MsgListBase_doSort(listWindow *ptr, sortType sort,_BOOL vorw, _BOOL withRedraw)
{
	MSGNR start, end;
	MSGNR i;
	listsort_info info;
	_BOOL freeStrings;
	if(sort==-1)
		sort=MsgListLstSort;
	else
		MsgListLstSort=sort;
	info.vorw=vorw;
	
	start = ptr->startPos;
	end = ptr->maxPos - 1;
	if (start >= dataSys_notSaved || end >= dataSys_notSaved || start >= end)
		return;
	info.cmpCount = 0;
	ConfVars_GetConfDefBool(cListSortIgnoreCase, &ignoreCase, FALSE);
	freeStrings = FALSE;
	switch (sort)
	{
	case sAbs:
	case sEmpf:
	case sAddr:
		if (prepareNameSort(ptr, start, end,sort))
			QuickSort_sortIt(start, end, ptr->list, compName, sizeof(listEntry), testBreak, &info);
		freeStrings = TRUE;
		break;
	case sWegen:
		if (prepareWegenSort(ptr, start, end))
			QuickSort_sortIt(start, end, ptr->list, compWegen, sizeof(listEntry), testBreak, &info);
		freeStrings = TRUE;
		break;
	case sTree:
		prepareTreeSort(ptr, start, end);
		QuickSort_sortIt(start, end, ptr->list, compTree, sizeof(listEntry), testBreak, &info);
		break;
	case sNum:
		QuickSort_sortIt(start, end, ptr->list, compNum, sizeof(listEntry), testBreak, &info);
		break;
	case sSize:
		prepareSizeSort(ptr, start, end);
		QuickSort_sortIt(start, end, ptr->list, compTree, sizeof(listEntry), testBreak, &info);
		break;
	case sDate:
		prepareDateSort(ptr, start, end);
		QuickSort_sortIt(start, end, ptr->list, compTree, sizeof(listEntry), testBreak, &info); 
		break;
	case sId:
		if (prepareIdSort(ptr, start, end))
			QuickSort_sortIt(start, end, ptr->list, compId, sizeof(listEntry), testBreak, &info);
		freeStrings = TRUE;
		break;
	case sLId:
		if (prepareLIdSort(ptr, start, end))
			QuickSort_sortIt(start, end, ptr->list, compLId, sizeof(listEntry), testBreak, &info);
		freeStrings = TRUE;
		break;
	}
	
	/* Allozierten Speicher wieder freigeben */
	if (freeStrings && ptr->list)
	{
		for (i = start; i <= end; i++)
		{
			if (ptr->list[i].i.strPtr != NULL)
			{
				SFREE(ptr->list[i].i.strPtr);
				ptr->list[i].i.strPtr = NULL;
			}
		}
	}
	if (withRedraw)
		WdwManager_FullRedrawWdw(ptr->wdw);
	MouseArrow();
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

#define cFrom  "From: "
#define cTopic "Subject: "
#define cGroup "Group: "
#define cTAB   '\t'
#define CR '\r'
#define LF '\n'

#define maxSendExts  3
#define DDEXT_FLT 0
#define DDEXT_TXT 1
#define DDEXT_CSV 2
LOCAL _UBYTE listExts[maxSendExts][DD_EXTLEN] = { ".FLT", ".TXT", ".CSV" };

#define cFiltName  "CAT Filterinformation"
#define cListName  "CAT Messageliste"

LOCAL _VOID MsgListBase_listGetSelectedSize(listWindow *ptr, _ULONG *size, _WORD currentExt)
{
	MSGNR sels;
	_WORD j;
	
	/* Eine einfache Schleife reicht, in der ich in jeder Zeile die Bytes zaehle */
	*size = 0;
	sels = MsgListBase_countSelectedEntries(ptr);
	if (sels > 0)
	{
		if (currentExt == DDEXT_FLT) /* Filter-Daten */
		{
			/* Wir uebergeben folgendes:
			 * From: Absender, 256 Zeichen
			 * TAB
			 * Topic: Betreff, 256 Zeichen
			 * TAB
			 * Group: Gruppe, 256 Zeichen
			 * TAB
			 * EOS
			 */
			*size = sizeof(cFrom)-1 + sizeof(cTopic)-1 + sizeof(cGroup)-1 + (sizeof(group_line) + 1) * 3 + 1;
			*size = *size * sels;
		} else
		{
			/* Platzbedarf einer Zeile ermitteln */
			for (j = 0; j < ptr->partArray.lines; j++)
			{
				*size += ptr->partArray.parts[j].w + 1;
				if (currentExt == DDEXT_CSV) /* CSV */
					*size += 2; /* Fuer Anfuehrungszeichen */
			}
			*size -= 1;    /* letzter Teil benoetigt kein Trennzeichen mehr */
			*size += 2;    /* Fuer CR/LF */
			/* Jetzt multiplizieren wir das nur noch mit der Anzahl der Zeilen,
			 * und schon haben wir den benoetigten Platz
			 */
			*size = *size * sels;
		}
	}
}

/*** ---------------------------------------------------------------------- ***/

/*DYJ 5.23k */
LOCAL _VOID MsgListBase_listGetSelectedData(listWindow *ptr, _VOID **adr, _WORD currentExt)
{
	_UBYTE *text;
	size_t idx;
	MSGNR i;
	_WORD j;
	MessageType mess;
	_UBYTE line[1024];
	group_line gName;
	F_ERROR error;
	MemSetZeroStruct(mess);
	
	if (ptr->dataSize > 0)
		++ptr->dataSize;
	*adr = MALLOC(ptr->dataSize, "MsgListBase_listGetSelectedData");
	if (*adr == NULL)
		return;
	text = *adr;
	idx = 0;
	/* Eine einfache Schleife reicht, in der ich in jeder Zeile die Bytes zaehle */
	for (i = 0; i < ptr->maxPos; i++)
	{
		if (ptr->list[i].flags & msglist_Selected)
		{
			/* Header der Message lesen */
			error = data_ReadHeader(ptr->grHandle->Zugriff, ptr->list[i].msgNum, &mess,TRUE);
			if (error != NoError)
			{
				mess.MailID = NULL;
				mess.Betreff = NULL;
				mess.Absender = NULL;
				mess.Empfaenger = NULL;
				mess.mid = NULL;
				mess.rid = NULL;
				mess.box = NULL;
				mess.name = NULL;
				mess.InfoStrings = NULL;
			}
			if (currentExt == DDEXT_FLT) /* Filterdaten */
			{
				MemCpy(text + idx, cFrom, sizeof(cFrom) - 1);
				idx += sizeof(cFrom) - 1;
				/* Feld kopieren */
				MemSet(text + idx, ' ', sizeof(group_line));
				if (mess.Absender != NULL)
					MemCpy(text + idx, mess.Absender, strLen(mess.Absender));
				idx += sizeof(group_line);
				text[idx++] = cTAB;

				MemCpy(text + idx, cTopic, sizeof(cTopic) - 1);
				idx += sizeof(cTopic) - 1;
				/* zweites Feld kopieren */
				MemSet(text + idx, ' ', sizeof(group_line));
				if (mess.Betreff != NULL)
					MemCpy(text + idx, mess.Betreff, strLen(mess.Betreff));
				idx += sizeof(group_line);
				text[idx++] = cTAB;

				/* Gruppe anhaengen */
				MemCpy(text + idx, cGroup, sizeof(cGroup) - 1);
				idx += sizeof(cGroup) - 1;
				/* zweites Feld kopieren */
				MemSet(text + idx, ' ', sizeof(group_line));
				GroupSelect_GroupName(mess.Gruppe, gName, sizeof(gName));
				MemCpy(text + idx, gName, strLen(gName));
				idx += sizeof(group_line);
				text[idx++] = cTAB;
				text[idx++] = '\0';
			} else
			{
				/* Zeile aufbauen und Bytes zaehlen */
				for (j = 0; j < ptr->partArray.lines; j++)
				{
					if (currentExt == DDEXT_CSV) /* CSV */
					{
						/* Ein Anfuehrungszeichen schreiben */
						text[idx++] = '"';
					}
					MsgListBase_GetLinePart(ptr, ptr->list[i].msgNum, &mess, line, sizeof(line), &ptr->partArray.parts[j]);
					strFillRight(line, sizeof(line), ptr->partArray.parts[j].w);
					MemCpy(text + idx, line, ptr->partArray.parts[j].w);
					idx += ptr->partArray.parts[j].w;
					if (currentExt == DDEXT_CSV) /* CSV */
					{
						/* Ein Anfuehrungszeichen schreiben */
						text[idx++] = '"';
					}
					/* Eintraege mit Komma trennen */
					if (j < ptr->partArray.lines-1)
					{
						if (currentExt == DDEXT_CSV)
							text[idx] = ',';
						else
							text[idx] = ' ';
						++idx;
					}
				}
				text[idx] = CR;
				text[idx+1] = LF;
				idx += 2;;
			}
			/* Speicher freigeben */
			data_freeMessage(&mess);
		}
	}
	ASSERT(idx < ptr->dataSize);
	text[idx] = '\0';
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _BOOL MsgListBase_listGetHeader(HWND wdw, _VOID *special, _WORD currentExt, _UBYTE *ext, _UBYTE *name, size_t namesize, _ULONG *size)
{
	listWindow *ptr;

	UNUSED(wdw);
	ptr = special;
	if (currentExt >= maxSendExts)
		return FALSE;
	MemCpy(ext, listExts[currentExt], DD_EXTLEN);
	if (currentExt == DDEXT_FLT)
		strMcpy(name, namesize, cFiltName);
	else
		strMcpy(name, namesize, cListName);
	MsgListBase_listGetSelectedSize(ptr, size, currentExt);
	ptr->dataSize = *size;
	return *size > 0;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID MsgListBase_listReadData(HWND wdw, _VOID *special, _VOID **data, _WORD currentExt)
{
	listWindow *ptr;
	
	UNUSED(wdw);
	ptr = special;
	MsgListBase_listGetSelectedData(ptr, data, currentExt);
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

GLOBAL _VOID MsgListBase_doMark(listWindow *ptr, _BOOL withDial)
{
	SearchInfo info;
	_WORD mode;
	MSGNR nr;
	_BOOL break_;
	MSGNR idx;
	
	if (withDial)
	{
		mode = ZSearchDial_DoSearchDial(TRUE);
		if (mode < 0)
			return;
	} else
	{
		mode = SEARCH_FASTAHEAD;
	}
	if (suchVar.searchStr[0][0] == '\0')
		suchVar.searchText = FALSE;
	MemSetZeroStruct(info);
	if (suchVar.statussearch)
		info.what |= inBits;
	if (suchVar.searchText)
		info.what |= inText;
	if (suchVar.change)
		info.what |= changeBits;
	if (mode == SEARCH_FASTBACK)
	{
		info.what |= reverse;
		/* Startmessage suchen */
		info.start = 0;
		for (idx = 0; idx <= ptr->startPos; idx++)
			if (ptr->list[idx].msgNum >= info.start)
				info.start = ptr->list[idx].msgNum;
	} else
	{
		/* Startmessage suchen */
		info.start = dataSys_empty;
		for (idx = ptr->startPos; idx < ptr->maxPos; idx++)
			if (ptr->list[idx].msgNum < info.start)
				info.start = ptr->list[idx].msgNum;
	}
	info.setBits = suchVar.sSetBits;
	info.clearBits = suchVar.sClearedBits;
	info.str = suchVar.searchStr[0];
	info.str2 = suchVar.searchStr[1];
	info.str3 = suchVar.searchStr[2];
	info.str4 = suchVar.searchStr[3];
	info.wo1 = suchVar.wo[0];
	info.wo2 = suchVar.wo[1];
	info.wo3 = suchVar.wo[2];
	info.wo4 = suchVar.wo[3];
	info.verkn1 = suchVar.verkn[0];
	info.verkn2 = suchVar.verkn[1];
	info.verkn3 = suchVar.verkn[2];
	info.gross = suchVar.gross;
	info.toSetBits = suchVar.setBits;
	info.toClearBits = suchVar.clearBits;
	info.break_ = &break_;
	info.handle = ptr->grHandle->Zugriff;

	CatGlobal_busyMouse();
	nr = 1;
	break_ = FALSE;
	while (nr < dataSys_notSaved && !break_ && data_ComplexSearch(&info, &nr))
	{
		if (nr < dataSys_notSaved)
		{
			if (MsgListBase_findMsgIdx(ptr, nr, &idx))
			{
				if (mode == SEARCH_FASTBACK)
				{
					if (idx <= ptr->startPos)
						ptr->list[idx].flags |= msglist_Selected;
				} else
				{
					if (idx >= ptr->startPos)
						ptr->list[idx].flags |= msglist_Selected;
				}
			}
			if (mode != SEARCH_FASTBACK)
			{
				info.start = nr + 1;
			} else
			{
				if (nr > 0)
					info.start = nr - 1;
				else
					nr = dataSys_empty;
			}
		}
	}
	if (withDial)
		WdwManager_FullRedrawWdw(ptr->wdw);
	MouseArrow();
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID MsgListBase_redrawButton(HWND wdw, OBJECT *butBox, _WORD ob)
{
	GRECT r;
	
	CalcArea(butBox, ob, &r);
	WdwManager_RedrawWdw(wdw, &r);
}

/*** ---------------------------------------------------------------------- ***/

/*DYJ 5.21b */
LOCAL _VOID MsgListBase_careForSelected(listWindow *ptr, _BOOL redraw)
{
	MSGNR sels;
	_UBYTE str[128];
	_UBYTE numstr[20];
	
	sels = MsgListBase_countSelectedEntries(ptr);
	*str = '\0';
	if (sels > 0)
	{
		CardToStr(sels, 0, numstr, sizeof(numstr));
		strBcat(str, numstr);
		strBcat(str, MausTauschrsc_WrkString(STR_OF));
	}
	CardToStr(ptr->maxPos, 0, numstr, sizeof(numstr));
	strBcat(str, numstr);
	strBcat(str,MausTauschrsc_WrkString(STR_MESS) );
	if (ptr->maxPos > 1)
		strBcat(str, MausTauschrsc_WrkString(FS_PLURAL1));
	if (sels > 0)
		strBcat(str, MausTauschrsc_WrkString(STR_SEL));
	SetObjcString(butBox, LISTTEXT, str);
	if (redraw)
		MsgListBase_redrawButton(ptr->wdw, butBox, LISTTEXT);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID MsgListBase_drawListWdw(HWND wdw,HVDI vdiH, _VOID *special, CONST GRECT *frame)
{
	GRECT clip;
	listWindow *ptr;
	MSGNR oldMax;
	
	ptr = special;
	if (ptr->isLocked)
		return;
	WdwManager_GetWdwWork(wdw, &clip);
	MsgListBase_AdjustTreePos(ptr, &clip);
	clip = *frame;
	if (rc_intersect(&ptr->butWork, &clip))
	{
		MsgListBase_careForSelected(ptr, FALSE);
		mtDials_DialDraw(butBox, ROOT, MAX_DEPTH, &clip, TRUE);
		MouseOff();
	}
	clip = *frame;
	if (rc_intersect(&ptr->listWork, &clip))
	{
		oldMax = ptr->maxWidth;
		clip = rc_clip(frame, &ptr->listWork);
		clip.g_w = clip.g_x + clip.g_w - 1;
		clip.g_h = clip.g_y + clip.g_h - 1;
	
		vsf_color(vdiH, ptr->listBackCol);
		vr_recfl(vdiH, (_WORD *)&clip);
		if (clip.g_x == ptr->listWork.g_x)
			clip.g_x += msglist_pixOffset;
		clip.g_x = Min(clip.g_x, clip.g_w);
	
		WdwManager_SetClip(vdiH, &clip, FALSE);
	
		msgList_rawRedraw(ptr, &clip);
	
		if (oldMax != (MSGNR)ptr->maxWidth)
			msgList_SetDocument(ptr, FALSE);
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID checkPopups(MSGNR selected)
{
	_BOOL disable = selected == 0;
	
	EnableObjState(selPop, LSELTREE, DISABLED, disable);
	EnableObjState(removePop, LREMSEL, DISABLED, disable);
	EnableObjState(removePop, LREMNSEL, DISABLED, disable);
	EnableObjState(removePop, LREMBAUM, DISABLED, disable);
}

/*** ------------------------------------------------------------------------ ***/
/*	GLOBAL _BOOL MsgListBase_sortVorw(_VOID)									*/
/*	Gibt zurck ob vorwrts sortiert werden soll								*/
/*	Parameter:	keine															*/
/*	Ergebnis:	TRUE: vorwrts													*/		
/*	3.4.00 von Dimitri Junker	DYJ 4.14										*/
/*** ------------------------------------------------------------------------ ***/
/*DYJ 5.20c */
GLOBAL _BOOL MsgListBase_sortVorw(_VOID)
{
	return !GetObjState(sortPop, LSORTREV + 1, CHECKED);
}
/*** ------------------------------------------------------------------------ ***/
/*	GLOBAL _BOOL MsgListBase_hideFilt(_VOID)									*/
/*	Gibt zurck ob gefilterte versteckt werden sollen							*/
/*	Parameter:	keine															*/
/*	Ergebnis:	TRUE: vorwrts													*/		
/*	25.8.04 von Dimitri Junker	DYJ 5.38e										*/
/*** ------------------------------------------------------------------------ ***/
GLOBAL _BOOL MsgListBase_hideFilt(_VOID)
{
	return GetObjState(removePop, LREMFILT, CHECKED);
}
/*** ------------------------------------------------------------------------ ***/
/*	GLOBAL MsgListBase_setSort(sortType sort,_BOOL vorw)								*/
/*	Setzt die Hckchen im Popup abhngig von der gewhlten Sortierung			*/
/*	Parameter:	vorwrts?														*/
/*	Ergebnis:	keines															*/		
/*	12.5.02 von Dimitri Junker	DYJ 4.38o										*/
/*** ------------------------------------------------------------------------ ***/
/*DYJ 5.20c */
GLOBAL _VOID MsgListBase_setSort(sortType sort,_BOOL vorw)
{
	static sortType oldSort=sNum;
	EnableObjState(sortPop, LSORTREV +1, CHECKED,!vorw);
	if(oldSort!=sort && sort>-1)
	{
		DelObjState(sortPop, oldSort +1, CHECKED);
		SetObjState(sortPop, sort +1, CHECKED);
		oldSort=sort;
	}
}
/*** ------------------------------------------------------------------------ ***/
/*	GLOBAL MsgListBase_setSort(sortType sort,_BOOL vorw)						*/
/*	Setzt das Hckchen im Popup bei gefilterte nicht anzeigen					*/
/*	Parameter:	nicht anzeigen?														*/
/*	Ergebnis:	keines															*/		
/*	25.8.04 von Dimitri Junker	DYJ 5.38e										*/
/*** ------------------------------------------------------------------------ ***/
GLOBAL _VOID MsgListBase_sethideFilt(_BOOL hideFilt)
{
	EnableObjState(removePop, LREMFILT, CHECKED,hideFilt);
}
/*** ------------------------------------------------------------------------ ***/
/*	_UWORD _CDECL DrawLine(PARMBLK *p)											*/
/*	Funktion fr die nicelenes													*/
/*	Parameter:	keine															*/
/*	Ergebnis:	keines															*/		
/*	29.8.02 bernommen aus mtaesmen DYJ 4.42j									*/
/*** ------------------------------------------------------------------------ ***/
LOCAL _UWORD _CDECL DrawLine(PARMBLK *p)
{
	_WORD pxy[4];
	
	vsf_color(PrivateWS, BLACK);
	vsf_interior(PrivateWS, FIS_PATTERN);
	vsf_style(PrivateWS, IP_4PATT);
	pxy[0] = p->pb_x;
	pxy[1] = p->pb_y + p->pb_h / 2 - 1;
	pxy[2] = p->pb_x + p->pb_w - 1;
	pxy[3] = pxy[1] + 1;
	v_bar(PrivateWS, pxy);
	vsf_interior(PrivateWS, FIS_SOLID);
	vsf_style(PrivateWS, IP_HOLLOW);
	vsf_color(PrivateWS, WHITE);
	return NORMAL;
}
/*** ---------------------------------------------------------------------- ***/
/*DYJ 5.20c */	/*DYJ 5.21b */	/*DYJ 5.27c */
LOCAL _BOOL MsgListBase_handleButtons(listWindow *ptr, _WORD ob, _UWORD kstate)
{
	_WORD select;
	MSGNR selectCount;
	_WORD x, y;
	_WORD vorw;
	_WORD hideFilt;	/*DYJ 5.38e */
	if (!GetObjState(butBox, ob, DISABLED) && GetObjFlags(butBox, ob, SELECTABLE))
	{
		/* Button selektieren */
		SetObjState(butBox, ob, SELECTED);
		MsgListBase_redrawButton(ptr->wdw, butBox, ob);
		/* Selektierte Nachrichten zaehlen */
		selectCount = MsgListBase_countSelectedEntries(ptr);
		checkPopups(selectCount);
		objc_offset(butBox, ob, &x, &y);
		switch (ob)
		{
		case LISTSEL: /* Selektieren */
			/* Popup en- bzw. disablen */
			/*
			EnableObjState(selPop, LSELTREE, DISABLED, selectCount == 0);
			*/
			select = mtPopups_TreePopup(selPop, x, y, 0);
			switch (select)
			{
				case LSELTREE: MsgListBase_selectTree(ptr, TRUE); break;
				case LSELNEW: msgList_listSelectNew (ptr->wdw); break;
				case LSELALL: msgList_listSelectAll (ptr->wdw, TRUE); break;
				case LSELTOP: MsgListBase_selectFromTop(ptr); break;
				case LSELFIND: MsgListBase_doMark(ptr, TRUE); break;
				case LSELINVT: MsgListBase_invertSelection(ptr); break;
				case LUNSELRD: MsgListBase_deselectReadEntries(ptr); break;
				case LSELDSEL: MsgListBase_deselectEntries(ptr); break;
			}
			break;
			
		case LISTSHRINK: /* Liste verkleinern */
/*DYJ 5.38e Start*/
		{
			_BOOL noNiceLines;
			ConfVars_GetConfDefBool(cNoNiceLines, &noNiceLines, FALSE);
			if(!noNiceLines)
				InstUserdef(removePop, LSLINE, DrawLine, NULL);
		}
/*DYJ  Ende; */
			select = mtPopups_TreePopup(removePop, x, y, 0);
			switch (select)
			{
			case LREMSEL:
				if (!MsgListBase_shrinkList(ptr, TRUE, TRUE))
					WdwManager_FullRedrawWdw(ptr->wdw);
				break;
			case LREMNSEL:
				if (!MsgListBase_shrinkList(ptr, FALSE, TRUE))
					WdwManager_FullRedrawWdw(ptr->wdw);
				break;
			case LREMBAUM:
				MsgListBase_removeTree(ptr);
				break;
			case LREMTOP:
				MsgListBase_shrinkToEnd(ptr, TRUE);
				break;
			case LREMSHOW:
				MsgListBase_showAll(ptr);
				break;
/*DYJ 5.38e Start*/
			case LREMFILT:
				hideFilt=!MsgListBase_hideFilt();
				MsgListBase_sethideFilt(hideFilt);
				if(hideFilt)
				{
					MsgListBase_listSelectFiltered(ptr->wdw, TRUE, FALSE);
					if (!MsgListBase_shrinkList(ptr, TRUE, TRUE))
						WdwManager_FullRedrawWdw(ptr->wdw);
				}
				else
					MsgListBase_showAll(ptr);
				break;
/*DYJ  Ende; */
			}
			break;
		
		case LISTSORT: /* Sortieren */
		{
			_BOOL noNiceLines;
			ConfVars_GetConfDefBool(cNoNiceLines, &noNiceLines, FALSE);
			if(!noNiceLines)
				InstUserdef(sortPop, LSLINE, DrawLine, NULL);
		}
			select = mtPopups_TreePopup(sortPop, x, y, 0) -1;
			vorw=MsgListBase_sortVorw();
			if(select==LSORTREV +1)
			{
				vorw=!vorw;
				MsgListBase_setSort(-1,vorw);
				select=-1;
			}
			else
				MsgListBase_setSort(select,vorw);
			if ((select >= sAddr && select <= sEmpf)||select==0)
				MsgListBase_doSort(ptr, (sortType)select,vorw, TRUE);
			break;
			
		case LISTREAD: /* selektierte lesen */
			Bounce();
			if (selectCount == 0)
			{
				if (mtAlerts_AlertRSC(1, AL_NONE_SEL) == 1)
				{
					msgList_listSelectAll(ptr->wdw, FALSE);
					/* Jetzt noch schnell die gefilterten entfernen */
					MsgListBase_listSelectFiltered(ptr->wdw, FALSE, TRUE);
					/* Und jetzt die noch selektierten lesen */
					MsgListBase_openSelected(ptr, FALSE, (kstate & K_CTRL) != 0);
				}
			} else
			{
				MsgListBase_openSelected(ptr, FALSE, (kstate & K_CTRL) != 0);
			}
			break;
		}
		/* Button deselektieren */
		DelObjState(butBox, ob, SELECTED);
		MsgListBase_redrawButton(ptr->wdw, butBox, ob);
		MsgListBase_careForSelected(ptr, TRUE);
		return TRUE;
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

typedef _WORD oneEntry[10];

LOCAL _VOID drawLines(HVDI vdi, MSGNR visible, oneEntry *pointArray)
{
	MSGNR i;
	
	MouseOff();
	for (i = 0; i < visible; i++)
		v_pline(vdi, 5, &pointArray[i][0]);
	MouseOn();
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID listMoveElems(listWindow *ptr, _WORD x, _WORD y, _UWORD buts, _UWORD kstate)
{
	oneEntry *pointArray;
	MSGNR i;
	MSGNR visible;
	_WORD deltaX, deltaY, oldX, oldY;
	_UWORD style;
	_WORD xOutput, yOutput;
	HWND hdl;
	_ULONG size;
	_VOID *data;
	_WORD apId;
	
	/* Erstmal sichtbare selektierte herausfinden */
	visible = 0;
	for (i = ptr->startPos; i < ptr->maxPos; i++)
		if (ptr->list[i].flags & msglist_Selected)
			++visible;
	
	/* Jetzt Speicher fuer Linien allozieren */
	if (visible == 0)
		return;
	pointArray = MALLOC(visible * sizeof(oneEntry), "ListMoveElems");
	if (pointArray == NULL)
		return;
	/* Jetzt die Koordinaten fuer die selektierten in das Pointarray eintragen */
	visible = 0;
	for (i = ptr->startPos; i < ptr->maxPos; i++)
	{
		if (ptr->list[i].flags & msglist_Selected)
		{
			xOutput = ptr->listWork.g_x + msglist_pixOffset - ptr->leftOffset;
			yOutput = ptr->listWork.g_y + (_WORD)(i - ptr->startPos) * (ptr->charHeight + msglist_lineDist) + (msglist_lineDist / 2);
			pointArray[visible][0] = xOutput;
			pointArray[visible][1] = yOutput;
			pointArray[visible][2] = xOutput + ptr->entryWidth - 1;
			pointArray[visible][3] = yOutput;
			pointArray[visible][4] = xOutput + ptr->entryWidth - 1;
			pointArray[visible][5] = yOutput + ptr->charHeight - 1;
			pointArray[visible][6] = xOutput;
			pointArray[visible][7] = yOutput + ptr->charHeight - 1;
			pointArray[visible][8] = xOutput;
			pointArray[visible][9] = yOutput;
			++visible;
		}
	}

	/* Alte Koordinaten merken */
	oldX = x;
	oldY = y;
	/* Clipping auf Screen setzen */
	Wind_Update(BEG_MCTRL);
	WdwManager_SetClip(ptr->vdi, &deskSize, TRUE);
	/* Schreibmodus setzen */
	vswr_mode(ptr->vdi, MD_XOR);
	/* Linientyp setzen */
	vsl_type(ptr->vdi, USERLINE);
	if (ptr->leftOffset & 1)
		style = 0xAAAA;
	else
		style = 0x5555;
	vsl_udsty(ptr->vdi, style);
	vsl_width(ptr->vdi, 1);
	vsl_color(ptr->vdi, BLACK);
	/* Jetzt die Linie zeichnen */
	MouseHand();
	drawLines(ptr->vdi, visible, pointArray);
	do
	{
		graf_mkstate(&x, &y, &buts, &kstate);
		if (x != oldX || y != oldY)
		{
			/* Linie wieder wegzeichnen an alten Koordinaten */
			drawLines(ptr->vdi, visible, pointArray);
			/* Koordinaten anpassen */
			deltaX = x - oldX;
			deltaY = y - oldY;
			for (i = 0; i < visible; i++)
			{
				pointArray[i][0] += deltaX;
				pointArray[i][1] += deltaY;
				pointArray[i][2] += deltaX;
				pointArray[i][3] += deltaY;
				pointArray[i][4] += deltaX;
				pointArray[i][5] += deltaY;
				pointArray[i][6] += deltaX;
				pointArray[i][7] += deltaY;
				pointArray[i][8] += deltaX;
				pointArray[i][9] += deltaY;
			}
			/* Neue Outline zeichnen */
			drawLines(ptr->vdi, visible, pointArray);
			oldX = x;
			oldY = y;
		}
	} while (buts & MOB_LEFT);
	/* Outline wieder wegzeichnen */
	drawLines(ptr->vdi, visible, pointArray);
	/* Writemode zuruecksetzen */
	vswr_mode(ptr->vdi, MD_REPLACE);
	/* Clipping auf Workbereich setzen */
	WdwManager_SetClip(ptr->vdi, &ptr->listWork, TRUE);
	Wind_Update(END_MCTRL);
	/* Drag und Drop ausfuehren */
	hdl = wind_find(x, y);
	if (hdl != ptr->wdw)
	{
		Wind_Update(END_UPDATE);
		if (!WdwManager_WdwDDServe(ptr->wdw, x, y, kstate))
		{
			/* Das ganze per Message verschicken */
			if (WdwManager_GetApId(hdl, &apId))
			{
				MsgListBase_listGetSelectedSize(ptr, &size, 0);
				ptr->dataSize = size;
				MsgListBase_listGetSelectedData(ptr, &data, 0);
				Protokoll_Send2Filter(apId, (_UWORD)size, data);
			}
		}
		Wind_Update(BEG_UPDATE);
	}
	/* Mauszeiger zuruecksetzen */
	MouseArrow();
	/* Speicher freigeben */
	FREE(pointArray, visible * sizeof(oneEntry));
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID selectArea(listWindow *ptr, _WORD x, _WORD y)
{
	MSGNR firstLine, lastLine, i;
	GRECT r, rect;
	_BOOL first;

	rect.g_x = x;
	rect.g_y = y;
	rect.g_w = 0;
	rect.g_h = 0;
	MouseFinger();
	graf_rubberbox(x, y, -32767, -32767, &rect.g_w, &rect.g_h);
	MouseArrow();
	
	if (rect.g_w < 0)
	{
		rect.g_x += rect.g_w;
		rect.g_w = -rect.g_w;
	}
	if (rect.g_h < 0)
	{
		rect.g_y += rect.g_h;
		rect.g_h = -rect.g_h;
	}
	
	/* clippen */
	rect = rc_clip(&rect, &ptr->listWork);
	rect.g_h = Min(rect.g_h, ptr->listWork.g_y + ptr->listWork.g_h - 1 - rect.g_y);
	
	/* Jetzt testen, ob selektierbarer Bereich geschnitten wurde */
	if ((rect.g_x - ptr->listWork.g_x < msglist_pixOffset && rect.g_x + rect.g_w - ptr->listWork.g_x < msglist_pixOffset) ||
		(rect.g_x - ptr->listWork.g_x > ptr->maxWidth && rect.g_x + rect.g_w - ptr->listWork.g_x > ptr->maxWidth))
	{
		return;
	}
	
	if (rect.g_y >= ptr->listWork.g_y)
		firstLine = (rect.g_y - ptr->listWork.g_y) / (ptr->charHeight + msglist_lineDist);
	else
		firstLine = 0;
	if (rect.g_y + rect.g_h >= ptr->listWork.g_y)
		lastLine  = (rect.g_y + rect.g_h - ptr->listWork.g_y) / (ptr->charHeight + msglist_lineDist);
	else
		lastLine = 0;
	if (rect.g_x - ptr->listWork.g_x > msglist_pixOffset ||
		rect.g_x + rect.g_w - ptr->listWork.g_x > msglist_pixOffset)
	{
		r = ptr->listWork;
		r.g_x += msglist_pixOffset;
		r.g_h = ptr->charHeight + msglist_lineDist;
		first = TRUE;
		for (i = ptr->startPos + firstLine; i <= ptr->startPos + lastLine; i++)
		{
			if (i < ptr->maxPos)
			{
				MsgListBase_toggleBit(ptr->list[i].flags, msglist_Selected);
				if (i >= ptr->startPos && i <= ptr->startPos + (MSGNR)(ptr->windLines))
				{
					/* redraw */
					if (first)
					{
						r.g_y = ptr->listWork.g_y + (_WORD)(i - ptr->startPos) * (ptr->charHeight + msglist_lineDist);
						first = FALSE;
					} else
					{
						r.g_h = ptr->listWork.g_y + (_WORD)(i - ptr->startPos + 1) * (ptr->charHeight + msglist_lineDist) - r.g_y;
					}
				}
			}
		}
		if (!first)
			WdwManager_RedrawWdw(ptr->wdw, &r);
	}
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _BOOL MsgListBase_clickInListWindow(HWND win, _VOID *special, _WORD x, _WORD y, _UWORD kstate, _UWORD buts, _WORD clicks)
{
	_WORD transY;
	listWindow *ptr;
	_BOOL entrySelected;
	_WORD line;
	_UWORD but;
	_WORD ob;
	GRECT clip;
	_UWORD kshift;
	_BOOL isSel;

	UNUSED(win);
	ptr = special;
	/* Hier noch Baumposition anpassen */
	WdwManager_GetWdwWork(ptr->wdw, &clip);
	MsgListBase_AdjustTreePos(ptr, &clip);
	if (rc_inside(x, y, &ptr->butWork))
	{
		ob = objc_find(butBox, ROOT, MAX_DEPTH, x, y);
		if (ob >= LISTSEL && ob <= LISTREAD)
			return MsgListBase_handleButtons(ptr, ob, kstate);
	} else if (rc_inside(x, y, &ptr->listWork))
	{
		MsgListBase_ShowCursor(ptr); /* Cursor ausschalten */
		ptr->cursPos = -1;
		/* Zeile herausfinden */
		line = (y - ptr->listWork.g_y) / (ptr->charHeight + msglist_lineDist);
		transY = (y - ptr->listWork.g_y - (msglist_lineDist / 2));
		entrySelected = (transY >= line * (ptr->charHeight + msglist_lineDist)) &&
			(transY < ((line + 1) * ptr->charHeight + line * msglist_lineDist)) &&
			((x - ptr->listWork.g_x) >= msglist_pixOffset) &&
			((x - ptr->listWork.g_x) <= ptr->maxWidth) &&
			((MSGNR)(line) + ptr->startPos < ptr->maxPos);
		graf_mkstate(&x, &y, &but, &kshift);
		isSel = entrySelected && (ptr->list[(MSGNR)(line) + ptr->startPos].flags & msglist_Selected);
		if (!(isSel && (but & MOB_LEFT)) && !CatGlobal_WithShift(kstate))
			MsgListBase_deselectEntries(ptr);
		if (entrySelected)
		{
			if (!(isSel && (but & MOB_LEFT)))
				MsgListBase_toggleEntry(ptr, (MSGNR)(line) + ptr->startPos);
			if (clicks > 1 || (!(buts & MOB_LEFT) && (buts & MOB_RIGHT)))
			{
				MsgListBase_openSelected(ptr, !(buts & MOB_LEFT) && (buts & MOB_RIGHT), (kstate & K_CTRL) != 0);
			} else
			{
				if (but & MOB_LEFT)
				{
					/* Drag & Drop! */
					listMoveElems(ptr, x, y, buts, kstate);
				}
			}
			/* Warten auf loslassen */
			Bounce();
		} else
		{
			graf_mkstate(&x, &y, &but, &kstate);
			if (but & MOB_LEFT)
			{
				/* Graf-Rubberbox aufrufen */
				selectArea(ptr, x, y);
			}
		}
		MsgListBase_careForSelected(ptr, TRUE);
		return TRUE;
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _BOOL MsgListBase_handleListTimer(HWND wdw, _VOID *special)
{
	listWindow *ptr;
	MSGNR i;
	MSGNR max;
	
	UNUSED(wdw);
	ptr = special;
	if (ptr->startPos < dataSys_notSaved - (MSGNR)(ptr->windLines + 1))
	{
		max = ptr->startPos + ptr->windLines + 1;
		if (max > ptr->maxPos)
			max = ptr->maxPos;
	} else
	{
		max = ptr->maxPos;
	}
	for (i = ptr->startPos; i < max; i++)
		if (ptr->list[i].flags & msglist_doRedraw)
			MsgListBase_redrawEntry(ptr, i);
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _BOOL MsgListBase_handleListKey(HWND wdw, _VOID *special, _WORD taste, _UBYTE ch, _UBYTE scan, _UWORD kstate)
{
	listWindow *ptr;
	Key key;
	_BOOL ctrl, shift, done, selChanged, again, handle;
	_BOOL suppress;
	LGRECT doc;
	SpecialCode specCode;
	ActionType mode;
	GRECT clip;

	UNUSED(scan);
	ptr = special;
	WdwManager_GetWdwWork(wdw, &clip);
	MsgListBase_AdjustTreePos(ptr, &clip);
	selChanged = FALSE;
	GemCharToKey(taste,  kstate, &key);
	ctrl = (kstate & K_CTRL) != 0;
	shift = CatGlobal_WithShift(kstate);
	ConfVars_GetConfDefBool(cListSuppressCursorDown, &suppress, FALSE);
	done = TRUE;
	if (!cursor_visible(ptr))
		ptr->cursPos = -1;
	if (IsSpecial(&key))
	{
		specCode = SpecialKey(&key);
		do
		{
			again = FALSE;
			switch (specCode)
			{
			case left:
				WdwManager_ScrollLeft(wdw, 1);
				break;
			
			case soln:
				WdwManager_PageLeft(wdw);
				break;
			
			case right:
				WdwManager_ScrollRight(wdw, 1);
				break;
			
			case eoln:
				WdwManager_PageRight(wdw);
				break;
			
			case pgUp:
				WdwManager_PageUp(wdw);
				break;
			
			case pgDown:
				WdwManager_PageDown(wdw);
				break;
			
			case up:
				if (ptr->cursPos < 0)
				{
					ptr->cursPos = (_LONG)(ptr->startPos + (MSGNR)ptr->windLines - 1);
				} else
				{
					MsgListBase_ShowCursor(ptr); /* alten wegmachen */
					if (shift)
						ptr->cursPos -= ptr->windLines - 1;
					else
						--ptr->cursPos;
				}
				ptr->cursPos = LMin(ptr->maxPos - 1, ptr->cursPos);
				ptr->cursPos = LMax(0, ptr->cursPos);
				if (cursor_visible(ptr))
				{
					MsgListBase_ShowCursor(ptr);
				} else
				{
					if (shift)
						WdwManager_PageUp(wdw);
					else
						WdwManager_ScrollUp(wdw, 1);
				}
				/* WdwManager_ScrollUp(wdw, 1); */
				break;
			
			case down:
				if (ptr->cursPos < 0)
				{
					ptr->cursPos = ptr->startPos;
				} else
				{
					MsgListBase_ShowCursor(ptr); /* alten wegmachen */
					if (shift)
						ptr->cursPos += ptr->windLines - 1;
					else
						++ptr->cursPos;
				}
				ptr->cursPos = LMin(ptr->cursPos, ptr->maxPos - 1);
				ptr->cursPos = LMax(0, ptr->cursPos);
				if (cursor_visible(ptr))
				{
					MsgListBase_ShowCursor(ptr);
				} else
				{
					if (shift)
						WdwManager_PageDown(wdw);
					else
						WdwManager_ScrollDown(wdw, 1);
				}
				/* WdwManager_ScrollDown(wdw, 1); */
				break;
			
			case altL:
			case return_:
			case enter:
				MsgListBase_handleButtons(ptr, LISTREAD, kstate);
				break;
			
			/* Buttons in Topleiste */
			case alt1:
				MsgListBase_handleButtons(ptr, LISTSEL, kstate);
				break;
			
			case alt2:
				MsgListBase_handleButtons(ptr, LISTSHRINK, kstate);
				break;
				
			case alt3:
				MsgListBase_handleButtons(ptr, LISTSORT, kstate);
				break;
			
			/*
			case return:
			case enter:
				MsgListBase_openSelected(ptr, FALSE, ctrl);
				break;
			*/
			
			case insert:
				if (ptr->cursPos >= 0)
				{
					selChanged = TRUE;
					MsgListBase_toggleEntry(ptr, (MSGNR)ptr->cursPos);
					/* (MH) */
					if (!suppress)
					{
						again = TRUE;
						specCode = down;
					}
				}
				break;
			
			case home:
			case clr:
				if (specCode == home)
				{
					ptr->startPos = 0;
				} else
				{
					if ((MSGNR)ptr->windLines > ptr->maxPos)
						ptr->startPos = 0;
					else
						ptr->startPos = ptr->maxPos - (MSGNR)ptr->windLines;
				}
				msgList_SetDocument(ptr, FALSE);
				break;
			
			default:
				done = FALSE;
				break;
			}
		} while (again);
	} else
	{
		if (ch == ' ')
		{
			WdwManager_GetWdwDocument(wdw, &doc);
			if (doc.y > doc.h - ptr->windLines)
			{
				/* naechste Seite nicht moeglich */
				MsgListBase_openSelected(ptr, FALSE, ctrl);
			} else
			{
				WdwManager_PageDown(wdw);
			}
		} else
		{
			if (extendedCommentMode)
			{
				handle = TRUE;
				switch (ucase(ch))
				{
					case 'B': mode = Action_answer; break;
					case 'G': mode = Action_otherGroup; break;
					case 'K': mode = Action_comment; break;
					default: handle = FALSE; mode = Action_comment; break;
				}
				if (handle && MsgListBase_countSelectedEntries(ptr) == 1)
				{
					/* Nachricht anzeigen und dann grintools mit Action aufrufen */
					MsgListBase_openSelected(ptr, FALSE, FALSE);
					grinTools_Handle(ptr->grinWindow, mode);
				} else
				{
					done = FALSE;
				}
			} else
			{
				done = FALSE;
			}
		}
	}
	if (selChanged)
		MsgListBase_careForSelected(ptr, TRUE);
	return done;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID MsgListBase_getListScroll(HWND wdw, HVDI vdiH, _VOID *special, GRECT *work)
{
	listWindow *ptr;
	_UBYTE varName[256];
	GRECT full;
	_BOOL lstPgF;
	
	UNUSED(vdiH);
	ptr = special;
	MsgListBase_AdjustTreePos(ptr, work);
	work->g_h -= ptr->butWork.g_h;
	work->g_y += ptr->butWork.g_h;
	ptr->windLines = Max(0, (Min(work->g_y + work->g_h - 1, MaxHeight - 1) - work->g_y + 1) / (ptr->charHeight + msglist_lineDist));
	ConfVars_GetConfDefBool(cListLstPgF, &lstPgF,TRUE);
	WdwManager_SetScrollParms(wdw, work->g_w - ptr->charWidth, ptr->windLines - 1, ptr->charWidth, 1,lstPgF);
	ptr->listWork = *work;
	if (ptr->wdw >= 0)
	{
		make_varname(varName, sizeof(varName), cListWindowPos, ptr->number);
		WdwManager_GetWdwSize(ptr->wdw, &full);                /* Groesse des Fensters abfragen */
		ConfVars_SetConfigRect(varName, &full);
	}
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _BOOL MsgListBase_closeListWindow(HWND wdw, HVDI vdiH, _VOID *special, _BOOL force)
{
	listWindow *ptr;
	_UBYTE varName[256];
	GRECT full;

	UNUSED(wdw);
	UNUSED(vdiH);
	ptr = special;
	make_varname(varName, sizeof(varName), cListWindowPos, ptr->number);
	WdwManager_GetWdwSize(ptr->wdw, &full); /* Groesse des Fensters abfragen */
	ConfVars_SetConfigRect(varName, &full);
	make_varname(varName, sizeof(varName), cListFont, ptr->number);
	ConfVars_SetConfigInt(varName, ptr->font);
	make_varname(varName, sizeof(varName), cListFontSize, ptr->number);
	ConfVars_SetConfigInt(varName, ptr->fontSize);
	ConfVars_SetConfigInt(cListLeftOffset, msglist_pixOffset);
	ConfVars_SetConfigInt(cListLineDist, msglist_lineDist);
	MsgListBase_ClearNum(ptr->number);
	FontSelect_UnloadFonts(ptr->vdi);
	if (ptr->usedByGrin == 0 || force)
	{
		MsgListBase_freeList(ptr);
		handlePool_FreeOneDataHandle(ptr->grHandle);
		handlePool_FreeOnePtr(ptr, &MsgList_windows);
	} else
	{
		ptr->wdw = -1;
		ptr->vdi = -1;
	}
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _BOOL MsgListBase_topListWdw(HWND wdw, _VOID *special)
{
	UNUSED(wdw);
	UNUSED(special);
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID MsgListBase_untopListWdw(HWND wdw, _VOID *special)
{
	UNUSED(wdw);
	UNUSED(special);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID MsgListBase_updateListWdw(HWND wdw, _VOID *special, _BOOL update)
{
	UNUSED(wdw);
	UNUSED(special);
	if (update)
	{
		Wind_Update(BEG_UPDATE);
		MouseOff();
	} else
	{
		MouseOn();
		Wind_Update(END_UPDATE);
	}
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID MsgListBase_hideListWdw(HWND wdw, _VOID *special, _BOOL hide)
{
	listWindow *ptr;
	
	UNUSED(wdw);
	ptr = special;
	ptr->isHidden = hide;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID MsgListBase_setListWork(HWND wdw, _VOID *special, CONST LGRECT *doc, _BOOL slided)
{
	listWindow *ptr;
	
	UNUSED(wdw);
	UNUSED(slided);
	ptr = special;
	ptr->leftOffset = (_WORD)(doc->x);
	ptr->startPos   = (MSGNR)doc->y;
	if (!cursor_visible(ptr))
		ptr->cursPos = -1;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID MsgListBase_snapListWdw(HWND wdw, _VOID *special, GRECT *work)
{
#define minWindWidth 80
#define minWindHeight 80
	listWindow *ptr;
	_WORD minWdwH;
	_BOOL lstPgF;

	ptr = special;
	if (ptr->font >= 0)
	{
		MsgListBase_AdjustTreePos(ptr, work);
		work->g_h -= ptr->butWork.g_h;
		minWdwH = minWindHeight - ptr->butWork.g_h;
		++work->g_h;         /* Um Rundungsfehler zu vermeiden */
		work->g_h = (work->g_h / (ptr->charHeight + msglist_lineDist)) * (ptr->charHeight + msglist_lineDist);
		while (work->g_w < minWindWidth)
			work->g_w += ptr->charWidth;
		while (work->g_h < minWdwH)
			work->g_h += ptr->charHeight + msglist_lineDist;
		ptr->windLines = Max(0, (Min(work->g_y + work->g_h - 1, MaxHeight - 1) - work->g_y + 1) / (ptr->charHeight + msglist_lineDist));
		ptr->listWork = *work;
		work->g_h += ptr->butWork.g_h;
		ConfVars_GetConfDefBool(cListLstPgF, &lstPgF,TRUE);
		WdwManager_SetScrollParms(wdw, work->g_w - ptr->charWidth, ptr->windLines - 1, ptr->charWidth, 1,lstPgF);
	}
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

GLOBAL _VOID MsgListBase_MakeTitle(CAT_GROUP_NUMBER gruppe, _UBYTE *title, size_t strsize)
{
	GroupSelect_GroupDisplayName(gruppe, title, strsize);
	insert_box_name(title, strsize);
	insert_app_name(title, strsize);
}

/*** ---------------------------------------------------------------------- ***/

/* Initialisiert die Messageliste */
GLOBAL _VOID msgList_InitMsgList(_VOID)
{
	_UBYTE line[256];
	Lists_CreateList(&MsgList_windows, "msgList_InitMsgList");

	ConfVars_GetConfDefStr(cPrivateMsgListElems, line, sizeof(line), cPrivateMsgListElemsDefault);
	msgList_SetListLine(line, TRUE);
	ConfVars_GetConfDefStr(cGrpMsgListElems, line, sizeof(line), cGrpMsgListElemsDefault);
	msgList_SetListLine(line, FALSE);
	
	butBox = TreeAddr[LISTCTL];
	mtDials_NewDial(butBox);
	selPop = TreeAddr[LSELPOP];
	removePop = TreeAddr[LREMVPOP];
	sortPop = TreeAddr[LSORTPOP];
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID msgList_ExitMsgList(_VOID)
{
	Lists_DeleteList(&MsgList_windows);
	if (butBox != NULL)
		mtDials_DisposeDial(butBox);
}
