/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */


#include <mtpaths.h>
#include <mte.h>
#include <mtappl.h>
#include <mtcomman.h>
#include <mtdir.h>
#include <mtalerts.h>
#include <mttextfi.h>
#include <catgloba.h>
#include <catfiles.h>
#include <mtrsc.h>

#include <tos.h>
#include <file_io.h>
#include <routinec.h>
#include <routines.h>
#include <dir_io.h>

GLOBAL _UBYTE ARCPath[PATH_MAX];		/* Zeile  1 aus CAT.INF: Pfadname fuer Zipper */
GLOBAL _UBYTE ARCName[PATH_MAX];		/* Zeile  2 aus CAT.INF: Programmname fuer Zipper */
GLOBAL _UBYTE enarcStr[PATH_MAX];		/* Zeile  3 aus CAT.INF: Optionen zum einpacken des INFILEs */
GLOBAL _UBYTE dearcStr[PATH_MAX];		/* Zeile  4 aus CAT.INF: Optionen zum auspacken des OUTFILEs */
GLOBAL _UBYTE archiveName[PATH_MAX];	/* Zeile  5 aus CAT.INF: Name des eingepackten OUTFILEs */
										/* Zeile  6 war Pfadname des Editors */
										/* Zeile  7 war Programmname des Editors */
GLOBAL _UBYTE MessagePath[PATH_MAX];	/* Zeile  8 aus CAT.INF: Pfad fuer MESSAGES Verzeichnis */
GLOBAL _UBYTE ImportPath[PATH_MAX];		/* Zeile  9 aus CAT.INF */
GLOBAL _UBYTE ExportPath[PATH_MAX];		/* Zeile 10 aus CAT.INF */
GLOBAL _UBYTE DataPath[PATH_MAX];		/* Zeile 11 aus CAT.INF: Database-Ordner */
GLOBAL _UBYTE TerminalPath[PATH_MAX];	/* Zeile 12 aus CAT.INF: Pfad fuer Terminalprogramm */
GLOBAL _UBYTE TerminalName[PATH_MAX];	/* Zeile 13 aus CAT.INF: Programmname des Terminalprogramms */
GLOBAL _UBYTE TerminalCmd[PATH_MAX*6];	/* Zeile 14 aus CAT.INF: Argumente fuer Terminalprogramm */
GLOBAL _UBYTE AttachmentPath[PATH_MAX];	/* Zeile 15 aus CAT.INF: Pfad fuer Anhang Verzeichnis */
GLOBAL _UBYTE lastInfName[PATH_MAX];

LOCAL FILENO lockf = -1;

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

LOCAL _BOOL ReadString(TEXTFILENO CATINF, _UBYTE *str, size_t strsize)
{
	if (mtTextfiles_EndofText(CATINF))
		return FALSE;
	mtTextfiles_ReadLine(CATINF, str, strsize);
	mtTextfiles_ReadLn(CATINF);
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

	
/*DYJ 5.21b */

LOCAL _BOOL LockDatabase(_UBYTE *lockfile, _BOOL showError)
{
	FILENO lck;
	_BOOL wasLocked;
	_UBYTE lockord[PATH_MAX],*ptr;
	F_STAT st;
	Directory *uProcDir;
	DirectoryEntry *entry;
	_UBYTE locktxt[]="Lockfile fr CAT-Datenbank erzeugt durch:";
	_UBYTE uProc[PATH_MAX]="u:\\proc",*pidEnd,*openedBy,lckbuf[PATH_MAX+70],*openedByTA,*openedByBn;
	_WORD pid;
	SYSTIME gestartet=0l,openedByT;
	_LONG len;


	strCpy(lockord,lockfile);

	wasLocked = FALSE;
	lck = (_WORD)Fopen(lockfile, FO_RW);
	if (lck == -33) /* file not found */
		lck = (_WORD)Fcreate(lockfile, 0);
	if (lck == -36 || (lck == -1 && magicPC)) /* access denied */
	{
		/* koennen wird auch selber gewesen sein */
		if (lockf >= 0)
		{
			Fclose(lockf);
			lockf = -1;
			wasLocked = TRUE;
			lck = (_WORD)Fopen(lockfile, FO_RW);
		}
	}
	if (lck < 0)
	{
		if (wasLocked)
		{
			strBcpy(lockfile, DataPath);
			F_Path_Append(lockfile, catlock);
			lockf = (_WORD)Fopen(lockfile, FO_RW);
			if (lockf == -33) /* file not found */
				lockf = (_WORD)Fcreate(lockfile, 0);
			if (lockf < 0)
			{
				/* hm, jetzt haben wir ein Problem */
			}
		}
		ptr=strrChr(lockord,'\\');
		if(ptr)
		{
			strCpy(ptr+1,".");
			if(F_Getinfo(lockord,&st,TRUE)>-1)
			{
				if((st.st_mode&(S_IWUSR|S_IWGRP|S_IWOTH))==0)	/* darf irgendwer schreiben?*/
				{
					if(mtAlerts_Alert(1, Rsc_WrkString(AL_WA_RO))==1)
					{
						lockf=CAT_LCK_RO;
						return(TRUE);
					}
				}
			}
		}
					
		/* war wohl doch 'n anderer */
		if (showError)
		{
			if (lck == -36 || (lck == -1 && magicPC))
				mtAlerts_Alert(1, Rsc_WrkString(AL_IS_DA));
			else
				F_ErrorAlert(lck);
		}
		return FALSE;
	}
	else
	{
		uProcDir = D_Opendir(uProc);
		if (uProcDir != NULL && (pid=Pgetpid())>0)
		{
			while ((entry = D_Readdir(uProcDir)) != NULL)
			{
				if((pidEnd=strrChr(entry->d_name,'.'))!=NULL)
				{
					++pidEnd;
					if(atoi(pidEnd)==pid)
					{
						F_Path_Append(uProc,entry->d_name);
						gestartet=entry->d_st.st_ctime;
						break;
					}
				}
			}
		}
		if(gestartet)
		{
			if((len=Fseek(0,lck,SEEK_END))>0)
			{
				Fseek(0,lck,SEEK_SET);
				if(len>=sizeof(lckbuf))
					len=sizeof(lckbuf)-1;
				Fread(lck,len,lckbuf);
				openedBy=lckbuf+strLen(locktxt)+1;
				if(!strCmp(locktxt,lckbuf)&& openedBy && *openedBy)
				{
					openedByTA=strChr(openedBy,'\0')+1;
					if(openedByTA)
						openedByT=atol(openedByTA);
					else
						openedByT=0;
					if(openedByT==gestartet && !strCaseCmp(openedBy,uProc)) /* waren wir selber*/
					{
						if (lockf >= 0)	/* damit es unten nicht berschrieben wird*/
							Fclose(lockf);
						lockf=-1;
					}
					else
					{
						D_Rewinddir(uProcDir);
						openedByBn=F_Path_Basename(openedBy);
						while ((entry = D_Readdir(uProcDir)) != NULL)
						{
							if(openedByT==entry->d_st.st_ctime && !strCaseCmp(openedByBn,entry->d_name))
							{
								Fclose(lck);	/* durch fremden noch aktiven Prozess geffnet*/
								if (showError)
									mtAlerts_Alert(1, Rsc_WrkString(AL_IS_DA));
								return FALSE;
							}
						}
						len=0;	/* durch fremden nicht mehr aktiven Prozess geffnet->Info berschreiben*/
					}
				}
				else	/* freigegebenes Lockfile */
					len=0;	/* freigegebenes Lockfile->Info berschreiben*/
			}
			if(!len)
			{
				Fseek(0,lck,SEEK_SET);
				Fwrite(lck,strLen(locktxt)+1,locktxt);
				Fwrite(lck,strLen(uProc)+1,uProc);
				sprintf(uProc,"%lu",gestartet);
				Fwrite(lck,strLen(uProc)+1,uProc);
			}
		}
		if(uProcDir)
			D_Closedir(uProcDir);
	}
	if (lockf >= 0)
	{
		Fseek(0,lck,SEEK_SET);
		*openedBy='\0';
		Fwrite(lck,strLen(locktxt)+1,locktxt);
		Fwrite(lck,1,openedBy);
		Fclose(lockf);
	}
	lockf = lck;
	return TRUE;
}
/*** ---------------------------------------------------------------------- ***/

/*DYJ 5.21b */
GLOBAL _BOOL MTPaths_ReadInf(_UBYTE *path, _UBYTE *name, _BOOL noCommand, _BOOL showError, CONST _UBYTE *inf_from_argv)
{
	TEXTFILENO CATINF;
	_UBYTE currentPath[PATH_MAX];
	_UBYTE sARCPath[PATH_MAX];
	_UBYTE sEditorPath[PATH_MAX];
	_UBYTE sMessagePath[PATH_MAX];
	_UBYTE sImportPath[PATH_MAX];
	_UBYTE sExportPath[PATH_MAX];
	_UBYTE sDataPath[PATH_MAX];
	_UBYTE sTerminalPath[PATH_MAX];
	_UBYTE sARCName[PATH_MAX];
	_UBYTE sarchiveName[PATH_MAX];
	_UBYTE sTerminalName[PATH_MAX];
	_UBYTE senarcStr[256];
	_UBYTE sdearcStr[256];
	_UBYTE sTerminalCmd[PATH_MAX*6];
	_UBYTE openName[PATH_MAX];
	_UBYTE scrap[PATH_MAX];
	_UBYTE lockfile[PATH_MAX];
	_UBYTE sAttachmentPath[PATH_MAX];
#define err() if (showError) mtAlerts_Alert(1, Rsc_WrkString(AL_NO_INF))	
#define err2() if (showError) mtAlerts_Alert(1, Rsc_WrkString(AL_ILLEGAL_INF))

	/* Wenn ein Dateiname uebergeben wird, dann soll der geladen werden.
	 * Wenn auch in der Kommandozeile ein Dateiname steht und noCommand FALSE
	 * ist, dann soll der Dateiname aus der Kommandozeile genommen werden
	 */
	if (!noCommand && inf_from_argv != NULL)
	{
		if (*inf_from_argv != '\0')
		{
			mtDir_SplitPath(inf_from_argv, path, openName, name);
		} else
		{
			strBcpy(openName, name);
		}
	} else
	{
		strBcpy(openName, name);
	}
	if (path[0] == '\0')
	{
		/* Pfad der Applikation nehmen */
		CatGlobal_ApplPath(path);
	}
	if (openName[0] == '\0')
	{
		/* Kein Name uebergeben, Default nehmen */
		strBcpy(openName, catinf);
	}
	
	strBcpy(scrap, path);
	F_Path_Append(scrap, openName);
	if (mtTextfiles_OpenTextfile(scrap, READ, 512, &CATINF) != GERR_OK)
	{
		/* Wenn nicht auf aktuellem Pfad, dann ueber ShelFind probieren */
		strBcpy(scrap, openName);
/*DYJ 5.30b Start*/
		CatFiles_shel_find(scrap,sizeof(scrap));
/*DYJ  Ende; alt:	
		shel_find(scrap);
*/
		if (mtTextfiles_OpenTextfile(scrap, READ, 512, &CATINF) != GERR_OK)
		{
			if (strCmp(openName, catinf) != 0 && !noCommand)
			{
				strBcpy(openName, catinf);
				strBcpy(scrap, path);
				F_Path_Append(scrap, openName);
				if (mtTextfiles_OpenTextfile(scrap, READ, 512, &CATINF) != GERR_OK)
				{
					err();
					return FALSE;
				}
			} else
			{
				err();
				return FALSE;
			}
		}
	}
	if (!ReadString(CATINF, sARCPath, sizeof(sARCPath)) ||
		!ReadString(CATINF, sARCName, sizeof(sARCName)) ||
		!ReadString(CATINF, senarcStr, sizeof(senarcStr)) ||
		!ReadString(CATINF, sdearcStr, sizeof(sdearcStr)) ||
		!ReadString(CATINF, sarchiveName, sizeof(sarchiveName)) ||
		!ReadString(CATINF, sEditorPath, sizeof(sEditorPath)) ||
		!ReadString(CATINF, sEditorPath, sizeof(sEditorPath)) ||
		!ReadString(CATINF, sMessagePath, sizeof(sMessagePath)) ||
		!ReadString(CATINF, sImportPath, sizeof(sImportPath)) ||
		!ReadString(CATINF, sExportPath, sizeof(sExportPath)) ||
		!ReadString(CATINF, sDataPath, sizeof(sDataPath)) ||
		!ReadString(CATINF, sTerminalPath, sizeof(sTerminalPath)) ||
		!ReadString(CATINF, sTerminalName, sizeof(sTerminalName)) ||
		!ReadString(CATINF, sTerminalCmd, sizeof(sTerminalCmd)))
	{
		mtTextfiles_CloseTextfile(&CATINF);
		err2();
		return FALSE;
	}
	F_Path_Get(currentPath);
	*AttachmentPath='\0';
	if(ReadString(CATINF, sAttachmentPath, sizeof(sAttachmentPath)))
	{
		if(F_Path_Set(sAttachmentPath))
			strBcpy(AttachmentPath, sAttachmentPath);
	}
	mtTextfiles_CloseTextfile(&CATINF);
	if (F_Path_Set(sMessagePath) &&
		F_Path_Set(sImportPath) &&
		F_Path_Set(sExportPath) &&
		F_Path_Set(sDataPath))
	{
		F_Path_Set(currentPath);
		
		strBcpy(lockfile, sDataPath);
		F_Path_Append(lockfile, catlock);
		if (!LockDatabase(lockfile, showError))
			return FALSE;
		
		strBcpy(ARCPath, sARCPath);
		strBcpy(ARCName, sARCName);
		strBcpy(enarcStr, senarcStr);
		strBcpy(dearcStr, sdearcStr);
		strBcpy(archiveName, sarchiveName);
		strBcpy(MessagePath, sMessagePath);
		strBcpy(ImportPath, sImportPath);
		strBcpy(ExportPath, sExportPath);
		strBcpy(DataPath, sDataPath);
		strBcpy(TerminalPath, sTerminalPath);
		strBcpy(TerminalName, sTerminalName);
		strBcpy(TerminalCmd, sTerminalCmd);

		strBcpy(lastInfName, scrap);
		strBcpy(infPath, path);
		strBcpy(infName, openName);
		return TRUE;
	}
	F_Path_Set(currentPath);
	if (showError)
		mtAlerts_Alert(1, Rsc_WrkString(AL_NOT_ALL_PATHS));
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _BOOL MTPaths_DatabaseLocked(_VOID)
{
	return (lockf >= 0)||lockf==CAT_LCK_RO;
}
/*** ---------------------------------------------------------------------- ***/

GLOBAL _BOOL MTPaths_DatabaseRonly(_VOID)
{
	return lockf ==-1000;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _BOOL MTPaths_LockDatabase(_VOID)
{
	_UBYTE lockfile[PATH_MAX];
	
	strBcpy(lockfile, DataPath);
	F_Path_Append(lockfile, catlock);
	return LockDatabase(lockfile, TRUE);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID MTPaths_Exit(_VOID)
{
	_UBYTE lockfile[PATH_MAX];

	if (lockf >= 0)
	{
		Fclose(lockf);
		lockf = -1;
		strBcpy(lockfile, DataPath);
		F_Path_Append(lockfile, catlock);
		Fdelete(lockfile);

	}
}


