/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 *
 * 4.12.02 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.19n'
 *	Noch 3 Speicherlcher weniger
 *
 * 3.4.04 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.35e'
 *	PM-Filter jetzt auch fr Reply-To
 */


#include <pmfilter.h>
#include <arcstart.h>
#include <catgloba.h>
#include <cattypes.h>
#include <confvars.h>
#include <varname4.h>
#include <varnamel.h>
#include <catlog.h>
#include <mte.h>
#include <mtpaths.h>
#include <userinfo.h>
#include <catopts.h>

#include <routinec.h>
#include <routines.h>
#include <debug.h>
#include <wdwmanag.h>
#include <protokol.h>
#include <vaproto.h>
#include <ro_mem.h>
#include <catfiles.h>
#include <mime.h>
#include <groupsel.h>		/*DYJ 5.34d */
#include <cat.h>		/*DYJ 5.34d */
#include <adr.h>		/*DYJ 5.34d */
#include <maustaus.h>		/*DYJ 5.34d */

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/


/*** ---------------------------------------------------------------------- ***/
GLOBAL _VOID PmFilter_ReadFilter(pmFilterStruct *filter, _WORD num)
{
	_UBYTE varname[256];
	
	/* Filter ist vorhanden, auslesen */
	make_varname(varname, sizeof(varname), cPmFilterType, num);
	ConfVars_GetConfDefInt(varname,(_WORD*)&filter->pmfType,0);
	make_varname(varname, sizeof(varname), cPmFilterPrio, num);
	ConfVars_GetConfDefInt(varname,&filter->prio,5);
	make_varname(varname, sizeof(varname), cPmFilterName, num);
	ConfVars_GetConfDefStr(varname, filter->filtName, sizeof(filter->filtName), "");
	make_varname(varname, sizeof(varname), cPmFilterAktTyp, num);
	*filter->gruppe=*filter->flags='\0';
	if(!ConfVars_GetConfigInt(varname,(_WORD*)&filter->pmfAktType))
	{
		make_varname(varname, sizeof(varname), cPmFilterGruppe, num);
		ConfVars_GetConfDefStr(varname, filter->gruppe, sizeof(filter->gruppe), "");
		ConfVars_DeleteConfigVar(varname);
		if(*filter->gruppe)
		{
			filter->pmfAktType=PMA_GROUP;
			make_varname(varname, sizeof(varname), cPmFilterAktStr, num);
			ConfVars_SetConfigString(varname, filter->gruppe);
		}
		else
			filter->pmfAktType=PMA_DELETE;
		make_varname(varname, sizeof(varname), cPmFilterAktTyp, num);
		ConfVars_SetConfigInt(varname, filter->pmfAktType);
	}
	else if(filter->pmfAktType!=PMA_DELETE)
	{
		make_varname(varname, sizeof(varname), cPmFilterAktStr, num);
		if(filter->pmfAktType==PMA_GROUP)
			ConfVars_GetConfDefStr(varname, filter->gruppe, sizeof(filter->gruppe), "");
		else
			ConfVars_GetConfDefStr(varname, filter->flags, sizeof(filter->flags), "");
	}
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID PmFilter_WriteFilter(CONST pmFilterStruct *filter, _WORD num)
{
	_UBYTE varname[256];
	
	if (filter->suchStr[0] != '\0')
	{
		make_varname(varname, sizeof(varname), cPmFilterName, num);
		ConfVars_SetConfigString(varname, filter->filtName);
		make_varname(varname, sizeof(varname), cPmFilterPrio, num);
		ConfVars_SetConfigInt(varname, filter->prio);
		make_varname(varname, sizeof(varname), cPmFilterType, num);
		ConfVars_SetConfigInt(varname, filter->pmfType);
		make_varname(varname, sizeof(varname), cPmFilterSuchStr, num);
		ConfVars_SetConfigString(varname, filter->suchStr);
		if(filter->pmfAktType!=PMA_DELETE)
		{
			make_varname(varname, sizeof(varname), cPmFilterAktStr, num);
			if(filter->pmfAktType==PMA_GROUP)
/*DYJ 5.34d Start*/
			{
				CAT_GROUP_NUMBER z;
				group_line followupTo;
				_BOOL isPseudoOM;
				ConfVars_SetConfigString(varname, filter->gruppe);
				/* Prfen ob Gruppe existiert, sonst anlegen*/
				if (!GroupSelect_GroupNumber(filter->gruppe, &z))
				{
					if (!GroupSelect_AppendGroup(filter->gruppe))
						z=NO_GROUP;
					else if (!GroupSelect_GroupNumber(filter->gruppe, &z))
						z=NO_GROUP;
				}
				isPseudoOM=GroupSelect_isPseudoOM(z);
				if(z!=NO_GROUP && !isPseudoOM && !GroupSelect_isPrivate(z))
				{
					_UBYTE al[200];
					sprintf(al,MausTauschrsc_WrkString(AL_PSEUDOGR),filter->gruppe);
					switch(mtAlerts_Alert(1,al))
					{
						case 1:
							GroupSelect_setPseudo(z,TRUE);
							break;
						case 2:
							GroupSelect_setPseudo(z,FALSE);
						case 3:
							break;
					}
				}
				if(isPseudoOM)
				{
					if(!GroupSelect_GetFollowUp(filter->gruppe,followupTo))
						*followupTo='\0';
					if(!strChr(followupTo,'@'))
					{
						_UBYTE ul[1000];
						sprintf(ul,MausTauschrsc_WrkString(AL_POM_FU),filter->gruppe);
						if(mtAlerts_Alert(1,ul)==1&& adr_SelectName(ADR_MLIST,followupTo, sizeof(followupTo)))
/*DYJ 5.35c Start*/
							GroupSelect_SetGrpParN(filter->gruppe,followupTo,LS_FOLLOWUP_LINE);
/*DYJ  Ende; alt:	
							GroupSelect_SetFollowUpN(filter->gruppe,followupTo);
*/
					}
				}
			}
/*DYJ  Ende; alt:	
				ConfVars_SetConfigString(varname, filter->gruppe);
*/
			else
				ConfVars_SetConfigString(varname, filter->flags);
		}
		make_varname(varname, sizeof(varname), cPmFilterAktTyp, num);
		ConfVars_SetConfigInt(varname, filter->pmfAktType);
	} else
	{
		/* Configvariablen loeschen! */
		make_varname(varname, sizeof(varname), cPmFilterName, num);
		ConfVars_DeleteConfigVar(varname);
		make_varname(varname, sizeof(varname), cPmFilterPrio, num);
		ConfVars_DeleteConfigVar(varname);
		make_varname(varname, sizeof(varname), cPmFilterType, num);
		ConfVars_DeleteConfigVar(varname);
		make_varname(varname, sizeof(varname), cPmFilterSuchStr, num);
		ConfVars_DeleteConfigVar(varname);
		make_varname(varname, sizeof(varname), cPmFilterAktStr, num);
		ConfVars_DeleteConfigVar(varname);
		make_varname(varname, sizeof(varname), cPmFilterAktTyp, num);
		ConfVars_DeleteConfigVar(varname);
	}
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

/*** ---------------------------------------------------------------------------- ***/
/*	_BOOL PmFilter_DoFilter(_UBYTE *str,_WORD len, PMFILT_AKTION mode)						*/
/*  Ruft die definierten PM-Filter auf			 									*/
/*	Parameter:	str:	abh. vom Modus												*/
/*				len:	bei Rckgabe (mode>0) Lnge von str							*/
/*				mode:PMAB_INIT: Initialisierung, mu als 1. aufgerufen werden(str unbenutzt)*/
/*					PMAB_LINE:	Zeile (str) analysieren, incl. Schlsselwort		*/
/*					PMAB_LINE_MAUS:	wie zuvor, aber mit Mausheaderzeile				*/
/*					PMAZ_*: wie PMAB_LINE, aber ohne Schlsselwort: * best. Zeilenart*/
/*					PMA_GROUP:Rckgabe der Gruppe in str, len=Lnge von str			*/
/*					PMA_FLAGS:Rckgabe der Flags in str, len=Lnge von str			*/
/*	Ergebnis:	bei INIT:TRUE wenn Filter vorhanden								*/
/*				bei lenMode>0: TRUE wenn gefiltert								*/
/*	20.12.01 von Dimitri Junker	DYJ 4.30zn										*/
/*** ------------------------------------------------------------------------ ***/
/*DYJ 5.19n */
/*DYJ 5.35e Start*/
GLOBAL _BOOL PmFilter_DoFilter(_UBYTE *str,_WORD len, PMFILT_AKTION mode)
{
	_BOOL ret=TRUE;
	static pmFilterStruct *pmFilter;
	_WORD i,strTyp=0;
	_UBYTE varname[40];
	static _UBYTE mlGroup[1024];
	static _WORD anzFilter=0,maxPrio[PMA_ANZ],gefunden[PMA_ANZ],prioMl;
	switch(mode)
	{
		case PMAB_INIT:	/* INIT */
			pmFilter=MALLOC(sizeof(pmFilterStruct)*MAX_PM_FILTER,"PmFilter_DoFilter");
			if(!pmFilter)
				return FALSE;
			ConfVars_GetConfDefInt(cPmFilterMListPrio, &prioMl,10);	/*DYJ 5.34d */
			anzFilter=0;
			for(i=0;i<PMA_ANZ;i++)
			{
				maxPrio[i]=0;
				gefunden[i]=-1;
			}
			for (i = 0; i < MAX_PM_FILTER; i++)
			{
				/* Array fuellen
				 */
				make_varname(varname, sizeof(varname), cPmFilterSuchStr, i + 1);
				if (ConfVars_GetConfigString(varname, pmFilter[anzFilter].suchStr,sizeof(pmFilter[anzFilter].suchStr)))
				{
					PmFilter_ReadFilter(&pmFilter[anzFilter], i + 1);
					anzFilter++;
				}
			}
			ret=anzFilter>0 || prioMl;
			if(ret)
				break;
		case PMAB_FREE:
			SFREE(pmFilter);
			pmFilter=NULL;
			break;
		case PMAB_LINE:
			if(!strnCaseCmp(str,"From:",5))
				strTyp=PMAZ_SEND;
			else if(!strnCaseCmp(str,"Sender:",7))
				strTyp=PMAZ_SEND;
			else if(!strnCaseCmp(str,"To:",3))
				strTyp=PMAZ_REC;
			else if(!strnCaseCmp(str,"CC:",3))
				strTyp=PMAZ_REC;
			else if(!strnCaseCmp(str,"Subject:",8))
				strTyp=PMAZ_SUB;
			else if(!strnCaseCmp(str,"Reply-To:",9))
				strTyp=PMAZ_RTO;
			else if(!strnCaseCmp(str,"Message-ID:",11))
				strTyp=PMAZ_ID;
			else if(!strnCaseCmp(str,"Mailing-List:",13))
				strTyp=PMAZ_ML;
			if(strTyp)
				str=strChr(str,':')+1;
			break;
		case PMAB_LINE_MAUS:
			switch(*str)
			{
				case 'V':
				case 'S':
					strTyp=PMAZ_SEND;
					break;
				case 'A':
					strTyp=PMAZ_REC;
					break;
				case 'W':
					strTyp=PMAZ_SUB;
					break;
				case 'T':
					strTyp=PMAZ_RTO;
					break;
				case 'I':
					strTyp=PMAZ_ID;
					break;
				case '>':
					if(!strnCaseCmp(str+1,"Mailing-List:",13))
						strTyp=PMAZ_ML;
					break;
			}
			str++;
			break;
		case PMAZ_SEND:	/*Absender*/
		case PMAZ_REC:	/*Empfnger*/
		case PMAZ_SUB:	/*Betreff*/
		case PMAZ_ID:	/*ID*/
		case PMAZ_RTO:	/*Reply-To*/
			strTyp=mode;
			break;
		case PMA_GROUP:		/* Rckgabe Gruppe*/
			if(maxPrio[PMA_DELETE]>maxPrio[PMA_GROUP])
			{
				*str='\0';
				break;
			}
			if(gefunden[mode]==anzFilter)
				strMcpy(str,len,mlGroup);
			else if(gefunden[mode]!=-1)
				strMcpy(str,len,pmFilter[gefunden[mode]].gruppe);
			else
				ret=FALSE;
			break;
		case PMA_FLAGS:		/* Rckgabe Flags*/
			if(gefunden[mode]!=-1)
				strMcpy(str,len,pmFilter[gefunden[mode]].flags);
			else
				ret=FALSE;
			break;
	}
	if(strTyp==PMAZ_ML)
	{
		CONST _UBYTE *cPtr;
		gefunden[PMA_GROUP]=anzFilter;
		maxPrio[PMA_GROUP]=prioMl;
		cPtr=strCaseStr(str,"list ");
		if(cPtr && cPtr[-1]<=' ')
		{
			_UBYTE *ptr;
			cPtr=strChr(cPtr+1,' ');
			cPtr+=strSpn(cPtr," ");
			strCpy(mlGroup,cPtr);
			ptr=strChr(mlGroup,';');
			if(ptr)
				*ptr='\0';
			ptr=strChr(mlGroup,'@');
			if(ptr)
				*ptr='.';
		}
	}
	else if(strTyp)
	{
		_UBYTE *encWord,verglStr[1024];
		_BOOL fertig=FALSE;
		
		_WORD cpLen;
		cpLen=(_WORD)strcSpn(str,"\n\r");
		if(cpLen>=sizeof(verglStr))
			strBcpy(verglStr,str);
		else
		{
			strnCpy(verglStr,str,cpLen);
			verglStr[cpLen]='\0';
		}
		encWord=verglStr;
		while((encWord=strStr(encWord,"=?"))!=NULL)
			fertig|=Mime_DecodeWord(encWord++);
		if(!fertig&& UserBLK.isInternet)
		{
			_LONG filter;
			filter=Mime_FindFilt(cMIME_Iso[ISO8859_1],TRUE);
			Mime_WandleIso(verglStr,verglStr, strLen(verglStr),filter,QUOTE_PR_NONE);
		}

		for(i=0;i<anzFilter;i++)
		if( (pmFilter[i].prio>maxPrio[pmFilter[i].pmfAktType])&&
		   ((pmFilter[i].pmfType==ForSend && strTyp==PMAZ_SEND) ||
			(pmFilter[i].pmfType==ForRec  && strTyp==PMAZ_REC) ||
			(pmFilter[i].pmfType==ForBoth && (strTyp==PMAZ_REC || strTyp==PMAZ_SEND)) ||
			(pmFilter[i].pmfType==ForSubj && strTyp==PMAZ_SUB) ||
			(pmFilter[i].pmfType==ForRTO && strTyp==PMAZ_RTO) ||
			(pmFilter[i].pmfType==ForID   && strTyp==PMAZ_ID)))
		{
			if(strCaseStr(verglStr,pmFilter[i].suchStr))
			{
				gefunden[pmFilter[i].pmfAktType]=i;
				maxPrio[pmFilter[i].pmfAktType]=pmFilter[i].prio;
			}
		}
	}
	return ret;
}
/*DYJ  Ende; alt:	
GLOBAL _BOOL PmFilter_DoFilter(_UBYTE *str,_WORD len, _WORD mode)
{
	_BOOL ret=TRUE;
	static pmFilterStruct *pmFilter;
	_WORD i,strTyp=0;
	_UBYTE varname[40];
/*DYJ 5.34d Start*/
	static _UBYTE mlGroup[1024];
	static _WORD anzFilter=0,maxPrio[PMA_ANZ],gefunden[PMA_ANZ],prioMl;
/*DYJ  Ende; alt:	
	static _WORD anzFilter=0,maxPrio[PMA_ANZ],gefunden[PMA_ANZ];
*/
	switch(mode)
	{
		case PMAB_INIT:	/* INIT */
			pmFilter=MALLOC(sizeof(pmFilterStruct)*MAX_PM_FILTER,"PmFilter_DoFilter");
			if(!pmFilter)
				return FALSE;
			ConfVars_GetConfDefInt(cPmFilterMListPrio, &prioMl,10);	/*DYJ 5.34d */
			anzFilter=0;
			for(i=0;i<PMA_ANZ;i++)
			{
				maxPrio[i]=0;
				gefunden[i]=-1;
			}
			for (i = 0; i < MAX_PM_FILTER; i++)
			{
				/* Array fuellen
				 */
				make_varname(varname, sizeof(varname), cPmFilterSuchStr, i + 1);
				if (ConfVars_GetConfigString(varname, pmFilter[anzFilter].suchStr,sizeof(pmFilter[anzFilter].suchStr)))
				{
					PmFilter_ReadFilter(&pmFilter[anzFilter], i + 1);
					anzFilter++;
				}
			}
/*DYJ 5.34d Start*/
			ret=anzFilter>0 || prioMl;
/*DYJ  Ende; alt:	
			ret=anzFilter>0;
*/
			if(ret)
				break;
		case PMAB_FREE:
			SFREE(pmFilter);
			pmFilter=NULL;
			break;
		case PMAB_LINE:
			if(!strnCaseCmp(str,"From:",5))
				strTyp=5;
			else if(!strnCaseCmp(str,"Sender:",7))
			{
				strTyp=5;
				str+=2;
			}
			else if(!strnCaseCmp(str,"To:",3))
				strTyp=3;
			else if(!strnCaseCmp(str,"CC:",3))
				strTyp=3;
			else if(!strnCaseCmp(str,"Subject:",8))
				strTyp=8;
			else if(!strnCaseCmp(str,"Message-ID:",11))
				strTyp=11;
/*DYJ 5.34d Start*/
			else if(!strnCaseCmp(str,"Mailing-List:",13))
				strTyp=13;
			
/*DYJ  Ende; */
			str+=strTyp;
			break;
/*DYJ 5.32b Start*/
		case PMAB_LINE_MAUS:
			switch(*str)
			{
				case 'V':
				case 'S':
					strTyp=5;
					break;
				case 'A':
					strTyp=3;
					break;
				case 'W':
					strTyp=8;
					break;
				case 'I':
					strTyp=11;
					break;
/*DYJ 5.34d Start*/
				case '>':
					if(!strnCaseCmp(str+1,"Mailing-List:",13))
						strTyp=13;
					break;
/*DYJ  Ende; */
			}
			str++;
			break;
/*DYJ  Ende;*/
		case PMA_SEND:	/*Absender*/
		case PMA_REC:	/*Empfnger*/
		case PMA_SUB:	/*Betreff*/
		case PMA_ID:	/*ID*/
			strTyp=-mode;
			break;
		case PMA_GROUP:		/* Rckgabe Gruppe*/
			if(maxPrio[PMA_DELETE]>maxPrio[PMA_GROUP])
			{
				*str='\0';
				break;
			}
/*DYJ 5.34d Start*/
			if(gefunden[mode]==anzFilter)
				strMcpy(str,len,mlGroup);
			else if(gefunden[mode]!=-1)
/*DYJ  Ende; alt:	
			if(gefunden[mode]!=-1)
*/
				strMcpy(str,len,pmFilter[gefunden[mode]].gruppe);
			else
				ret=FALSE;
			break;
		case PMA_FLAGS:		/* Rckgabe Flags*/
			if(gefunden[mode]!=-1)
				strMcpy(str,len,pmFilter[gefunden[mode]].flags);
			else
				ret=FALSE;
			break;
	}
/*DYJ 5.34d Start*/
	if(strTyp==13)
	{
		CONST _UBYTE *cPtr;
		gefunden[PMA_GROUP]=anzFilter;
		maxPrio[PMA_GROUP]=prioMl;
		cPtr=strCaseStr(str,"list ");
		if(cPtr && cPtr[-1]<=' ')
		{
			_UBYTE *ptr;
			cPtr=strChr(cPtr+1,' ');
			cPtr+=strSpn(cPtr," ");
			strCpy(mlGroup,cPtr);
			ptr=strChr(mlGroup,';');
			if(ptr)
				*ptr='\0';
			ptr=strChr(mlGroup,'@');
			if(ptr)
				*ptr='.';
		}
	}
	else if(strTyp)
/*DYJ  Ende; alt:	
	if(strTyp)
*/
	{
		_UBYTE *encWord,verglStr[1024];
		_BOOL fertig=FALSE;
		
/*DYJ 5.32c Start*/
		_WORD cpLen;
		cpLen=(_WORD)strcSpn(str,"\n\r");
		if(cpLen>=sizeof(verglStr))
			strBcpy(verglStr,str);
		else
		{
			strnCpy(verglStr,str,cpLen);
			verglStr[cpLen]='\0';
		}
/*DYJ  Ende; alt:	
		strBcpy(verglStr,str);
*/
		encWord=verglStr;
		while((encWord=strStr(encWord,"=?"))!=NULL)
			fertig|=Mime_DecodeWord(encWord++);
		if(!fertig&& UserBLK.isInternet)
		{
			_LONG filter;
			filter=Mime_FindFilt(cMIME_Iso[ISO8859_1],TRUE);
			Mime_WandleIso(verglStr,verglStr, strLen(verglStr),filter,QUOTE_PR_NONE);
		}

		for(i=0;i<anzFilter;i++)
		if( (pmFilter[i].prio>maxPrio[pmFilter[i].pmfAktType])&&
		   ((pmFilter[i].pmfType==ForSend && strTyp==5) ||
			(pmFilter[i].pmfType==ForRec  && strTyp==3) ||
			(pmFilter[i].pmfType==ForBoth && strTyp!=8) ||
			(pmFilter[i].pmfType==ForSubj && strTyp==8) ||
			(pmFilter[i].pmfType==ForID   && strTyp==11)))
		{
			if(strCaseStr(verglStr,pmFilter[i].suchStr))
			{
				gefunden[pmFilter[i].pmfAktType]=i;
				maxPrio[pmFilter[i].pmfAktType]=pmFilter[i].prio;
			}
		}
	}
	return ret;
}*/



