/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 *
 * 1.3.03 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.21q'
 *	Warnung vor Repair der *.par eingebaut
 */


#include <portaes.h>
#include <mtappl.h>
#include <mtdials.h>
#include <mtalerts.h>
#include <mtaesmen.h>
#include <mtutils.h>
#ifndef __MINTBIND_H__
#include <mintbind.h>
#endif
#include <ro_mem.h>
#include <strconv.h>
#include <routinec.h>
#include <routines.h>
#include <file_io.h>

#include <convertd.h>
#include <wdwmanag.h>
#include <menu_key.h>
#include <datasys.h>
#include <infofile.h>
#include <confvars.h>
#include <varnamel.h>
#include <varname4.h>
#include <mtpaths.h>
#include <catgloba.h>
#include <fslx.h>
#include <mtrsc.h>
#include <windials.h>
#include <data.h>
#include <listhelp.h>
#include <groupsel.h>
#include <mte.h>
#include <listdl.h>
#include <mtpopups.h>
#include <vdiutil.h>
#include <catlog.h>
#include <zcalccrc.h>
#include <catfiles.h>
#include <s_endian.h>
#include <alias.h>

#include <routine.h>
#include <catvers.h>
#include <debug.h>

#include <repair.h>
#include <dir_io.h>
#include <wildcard.h>
#include <mtdir.h>
#include <routines.h>	/*DYJ 5.20w */


GLOBAL _UBYTE ProgramName[] = "REPAIR";
GLOBAL _BOOL PrgHasDataBase=TRUE;		/*DYJ 5.26a */


#define parameterFile    "repair.cfg"
#define RscName          "repair.rsc"
#define CATR_RSC_BASE	"repai_"			/*DYJ 5.23e */

#define REPAIR_VERSION   "Repair V " CatVersion
#define REPAIR_WHATTEXT	 "@(#)" CatVersion " (c) 1998 Thorsten Otto"
#define REPAIR_MENUNAME  "  Repair " CatVersion
GLOBAL _UBYTE LOG_TITLE[]="Log Datei fr Repair ";
GLOBAL _UBYTE LOG_END[]="Repair beendet.";
GLOBAL _UBYTE LOG_FNAME[]="replog.txt";
GLOBAL _UBYTE LOG_FHDRNAME[]="rephdlog.txt";
LOCAL CAT_GROUP_NUMBER SetNewCatNum;

GLOBAL _UBYTE HomePath[PATH_MAX];

#define TAB_IDX(msg,crc)	(((_ULONG)(msg))*2+(crc))

LOCAL _BOOL quitProg;
LOCAL _UBYTE tmpPath[PATH_MAX];
LOCAL RESOURCE theRSC;
LOCAL OBJECT *menu;
LOCAL OBJECT *gruppen;

LOCAL _UBYTE tmpDir[PATH_MAX];
LOCAL _BOOL useTmp;
LOCAL _BOOL tmpLock;

#define cUseTmp        "UseTempPath"
#define cTmpLock       "UseOwnTempPath"
#define cTmpDir        "TmpDir"
#define cIconify       "IconifyEnabled"

/*DYJ 5.21b Start*/
/*DYJ  Ende; alt:	
#define AL_IS_DA       "[3][%P:|CAT oder CatPutz|ist schon gestartet, deshalb|kann CatPutz nicht laufen!][[Abbruch]"
#define AL_OLD_VERSION "[3][%P:|Cat-Datenbank: falsche Version!][[Abbruch]"
#define AL_CMD_ERROR   "[3][%%P:|Fehler in Kommandozeile:|%s|%s][[Abbruch]"
#define noRscAlt       "[5][%P:|Kann das Resource-File|REPAIR.RSC nicht laden][ [Schade.. ]"
#define noLowResAlt    "[4][Die gew\204hlte Aufl\224sung|ist zu niedrig|f\201r Repair!][ [OK ]"

#define AL_RENAME_GROUP_FILES "[3][%P:|Konnte Gruppendateien|nicht umbenennen!|M\224glicherweise ist die|Datenbank jetzt besch\204digt!][[Abbruch]"
#define AL_ERR_DBF "[3][%%P:|Es wurden Fehler gefunden die teils|per Hand korrigiert werden mssen, s.:|%s%s][[Abbruch]"
#define AL_DELETE_WHAT       "[2][%%P:|Die u.g. Gruppen benutzen die gleichen|Files. Welchen Gruppennamen behalten?|1: %s|2: %s][Gruppe[1|Gruppe[2|[Abbruch]"
#define AL_WARN_CATNR       "[1][%P:|Diese Routine ist noch in der Testphase,|wer sie benutzt ohne vorher eine|Sicherheitkopie zu benutzen ist selber|schuld!][[Abbruch|[Weiter]"
#define AL_NO_ORP "[3][%P:|Dieses File ist nicht verwaist. Seine|Adoption wrde zu Familienkomplikationen|fhren. Das wollen wir doch nicht oder?][[Abbruch]"
#define AL_NO_PAR "[3][%P:|Dieses File ist kein gltiges PAR-File|im Datenbankordner.][[Abbruch]"
#define AL_NO_DAT "[3][%P:|Zu diesem PAR-File gibt es kein|passendes DAT-File][[Abbruch]"
#define AL_REP_PAR "[2][%P:|Achtung dies sollte nur die letzte Wahl|sein!Bei dieser Reparatur gehen|Verknpfungen und Flags verloren. Ggf.|schaft es auch Catputz.][[Reparieren|:[Abbruch]"	/*DYJ 5.21i */
*/

/*DYJ 5.35n Start*/
#define CRC_NOT_CHECKED 0xffff
/*DYJ  Ende; alt:	
#define CRC_NOT_CHECKED -1
*/

#define CRC_OK          0
      

typedef struct _oneHandle {
	GROUPNR group;
	FILENO tabHandle;
	FILENO parHandle;
	FILENO datHandle;		/* handles der entsprechenden Dateien */
	FILENO waiHandle;
	
	_ULONG DatSize;
	_ULONG WaiSize;
	MSGNR anz;				/* Anzahl der Nachrichten in dieser Gruppe */
} oneHandle, *OneHandle;

#define fillBytePersonal 0xCC /* Fuellbyte fuer das Alignen der PersonalInfo */


#define errorCount isUpdated

#define BLOCK_CRC(ptr) \
	ZCalcCrc_CalcCrcArray((CONST _UBYTE *)(ptr) + sizeof(CRC16), sizeof(*(ptr)) - sizeof(CRC16))

/******************************************************************************
 *** ---------------------------------------------------------------------- ***
 * Window handling
 *** ---------------------------------------------------------------------- ***
 ******************************************************************************/

LOCAL List grList;

typedef _BOOL (*CHECK_FUNC)(group *gr);

typedef struct {
	_WORD maxLength;
	_WORD globalLength;
	group *group;
	CHECK_FUNC func;
	_WORD sort;
	OBJECT *tree;
	OBJECT *typeSel;
	specialButHdler specials[4];
	_BOOL weiter;
} envRecord;

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL selGrEntry(_VOID *entry, _VOID *env, _WORD line)
{
	group *gr;

	UNUSED(env);
	UNUSED(line);
	gr = entry;
	if (gr == NULL)
		return FALSE;
	gr->selected = !gr->selected;
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID groupToStr(_VOID *entry, _VOID *env, _UBYTE *str, size_t strsize)
{
	group *gr;

	UNUSED(env);
	gr = entry;
	if (gr == NULL)
		*str = '\0';
	else
		strMcpy(str, strsize, gr->name);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID buildGroup(_VOID *entry, _VOID *env, _UBYTE *str, size_t strsize)
{
	group *gr;
	envRecord *rec;
	_UBYTE filename[PATH_MAX];
	_UBYTE num[10];
	
	gr = entry;
	rec = env;
	
	strMcpy(str, strsize, gr->name);
	strFillRight(str, strsize, rec->maxLength + 2);
	if(gr->catNumber <(CAT_GROUP_NUMBER)dataSys_notSaved)
	{
		data_Number2Name(gr->catNumber, filename);
		strMcat(str, strsize, filename);
		strFillRight(str, strsize, rec->maxLength + 12);
	}
	
	if (gr->errorCount == CRC_OK)
	{
		strMcat(str, strsize, "OK");
	} else if (gr->errorCount != CRC_NOT_CHECKED)
	{
		IntToStr(gr->errorCount, 0, num, sizeof(num));
		strMcat(str, strsize, num);
		strMcat(str, strsize, " errors");
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL findSel(_VOID *entry, _VOID *inf)
{
	group *gr = entry;

	UNUSED(inf);
	return gr->selected;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID doUpdateButton(_BOOL redraw)
{
	_BOOL oneSel;
	GRECT r;

	Lists_ResetList(&grList);
	oneSel = Lists_ScanEntries(&grList, Lists_forward, findSel, NULL);
	EnableObjState(gruppen, GOK, DISABLED, !oneSel);
	if (redraw)
	{
		WinDials_WinDialDraw(gruppen, GOK, 0, &r, FALSE);
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID updateButton(_VOID *entry, _VOID *env)
{
	UNUSED(entry);
	UNUSED(env);
	doUpdateButton(TRUE);
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

/* List-Zwischen-Prozeduren */
LOCAL _BOOL groupIsSelected(_VOID *entry, _VOID *env)
{
	group *gr;

	UNUSED(env);
	gr = entry;
	return gr->selected;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID *nextEntry(_VOID *list)
{
	return Lists_NextEntry(list);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID *prevEntry(_VOID *list)
{
	return Lists_PrevEntry(list);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID resetList(_VOID *list)
{
	Lists_ResetList(list);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID countEntries(_VOID *l, _LONG *ll, _WORD *ww)
{
	envRecord *rec;
	
	rec = ((List *)l)->user;
	*ww = rec->globalLength * CharWidth;
	*ll = Lists_NoOfEntries(l);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL isEnabled(_VOID *entry, _VOID *env)
{
	UNUSED(entry);
	UNUSED(env);
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID drawGroupEntry(_VOID *entry, _VOID *env, _WORD x, _WORD y, _WORD offset, CONST GRECT *clip)
{
	OBJECT *tr;
	group *e;
	group_line str;
	envRecord *rec;
	
	UNUSED(offset);
	tr = RscGaddr(theRSC, R_TREE, LISTTXT);
	e = entry;
	rec = env;
	tr[ROOT].ob_x = x;
	tr[ROOT].ob_y = y;
	tr[LISTENTRY].ob_spec.tedinfo->te_txtlen = rec->globalLength + 1;
	tr[LISTENTRY].ob_width = rec->globalLength * CharWidth;
	if (e != NULL)
	{
		/* Jetzt hier den String fuer den Gruppennamen zusammenbauen */
		buildGroup(e, env, str, sizeof(str));
		SetObjcStringAdr(tr, LISTENTRY, str, sizeof(str));
		EnableObjState(tr, ROOT, SELECTED, groupIsSelected(entry, env));
		EnableObjState(tr, ROOT, DISABLED, !isEnabled(entry, env));
	} else
	{
		SetObjcStringAdr(tr, LISTENTRY, "", 1);
		DelObjState(tr, ROOT, SELECTED);
		DelObjState(tr, ROOT, DISABLED);
	}
	Objc_draw(tr, ROOT, MAX_DEPTH, clip);
	SetObjcStringAdr(tr, LISTENTRY, "", 1);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL sortReadnum(CONST _VOID *e1, CONST _VOID *e2, _VOID *private)
{
	CONST group *gr1 = *((CONST group * CONST *)e1);
	CONST group *gr2 = *((CONST group * CONST *)e2);
	
	UNUSED(private);
	return gr1->readNumber < gr2->readNumber;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL sortCatnum(CONST _VOID *e1, CONST _VOID *e2, _VOID *private)
{
	CONST group *gr1 = *((CONST group * CONST *)e1);
	CONST group *gr2 = *((CONST group * CONST *)e2);
	
	UNUSED(private);
	return gr1->catNumber < gr2->catNumber;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL sortName(CONST _VOID *e1, CONST _VOID *e2, _VOID *private)
{
	CONST group *gr1 = *((CONST group * CONST *)e1);
	CONST group *gr2 = *((CONST group * CONST *)e2);
	
	UNUSED(private);
	if (gr1->catNumber == dataSys_private)
		return TRUE;
	if (gr2->catNumber == dataSys_private)
		return FALSE;
	return strSortCmp(gr1->name, gr2->name) < 0;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID SortList(List *grList, _WORD sort)
{
	switch (sort)
	{
		case 0: GroupSelect_SortAnyList(grList, sortReadnum); break;
		case 1: GroupSelect_SortAnyList(grList, sortName); break;
		case 2: GroupSelect_SortAnyList(grList, sortCatnum); break;
	}
}

/*** ---------------------------------------------------------------------- ***/

/*DYJ 5.30f Start*/
LOCAL _VOID checkTab(_WORD obj, _VOID *env, LISTINFO info, _BOOL *draw, _BOOL *exit,_LONG *lstSel)
/*DYJ  Ende; alt:	
LOCAL _VOID checkTab(_WORD obj, _VOID *env, LISTINFO info, _BOOL *draw, _BOOL *exit)
*/
{
	envRecord *rec;
	group *gr;
	_LONG number;
	GRECT r;
	LCarrier pos;

	UNUSED(lstSel);	/*DYJ 5.30f */	
	MouseBusy();
	rec = env;
	Lists_ResetList(&grList);
	number = 0;
	while ((gr = Lists_NextEntry(&grList)) != NULL)
	{
		pos = Lists_GetCurrent(&grList);
		if (gr->selected)
		{
			ListMan_ListScroll2Selection(info, TRUE);
			if (rec->func != FUNK_NULL)
			{
				CatLog_WriteStringNTime("Gruppenwechsel zu ");
				CatLog_WriteLine(gr->name);
				if (!rec->func(gr))
					break;
			} else
			{
				gr->errorCount = CRC_OK;
			}
			if (gr->errorCount == CRC_OK)
			{
				ListMan_ListInvertEntry(info, number);
			} else
			{
				ListMan_ListUpdateEntry(info, number);
			}
		}
		number++;
		Lists_SetCurrent(&grList, pos);
	}
	DelObjState(rec->tree, obj, SELECTED);
	WinDials_WinDialDraw(rec->tree, obj, MAX_DEPTH, &r, FALSE);
	MouseArrow();
	*draw = FALSE;
	*exit = !rec->weiter;
}

/*** ---------------------------------------------------------------------- ***/

/*DYJ 5.30f Start*/
LOCAL _VOID switchSort(_WORD obj, _VOID *env, LISTINFO info, _BOOL *draw, _BOOL *exit,_LONG *lstSel)
/*DYJ  Ende; alt:	
LOCAL _VOID switchSort(_WORD obj, _VOID *env, LISTINFO info, _BOOL *draw, _BOOL *exit)
*/
{
	_WORD x, y;
	_WORD select;
	_WORD sort;
	_WORD but;
	GRECT r;
	envRecord *rec;
	
	UNUSED(info);
	*lstSel=-1;	/*DYJ 5.30f */
	rec = env;
	switch (obj)
	{
	case GRSORT0:
	case GRSORT1:
		but = GRSORT1;
		objc_offset(rec->tree, but, &x, &y);
		select = VDIUtil_GetXState(rec->tree, but);
		select = mtPopups_TreePopup(rec->typeSel, x, y, select) - 1;
		if (select >= 0)
		{
			VDIUtil_SetXState(rec->tree, but, select);
			VDIUtil_SetXString(rec->tree, but, rec->typeSel, select);
			WinDials_WinDialDraw(rec->tree, but, 0, &r, FALSE);
		}
		break;
	case GRSORT2:
		select = VDIUtil_GetXState(rec->tree, GRSORT1);
		select = (select + 1) % 3;
		VDIUtil_SetXState(rec->tree, GRSORT1, select);
		VDIUtil_SetXString(rec->tree, GRSORT1, rec->typeSel, select);
		WinDials_WinDialDraw(rec->tree, GRSORT1, 0, &r, FALSE);
		break;
	}
	sort = VDIUtil_GetXState(rec->tree, GRSORT1);
	ConfVars_SetConfigInt(cGroupSelectSortType, sort);
	rec->sort = sort;
	
	SortList(&grList, rec->sort);
	
	grList.user = env;
	*draw = TRUE;
	*exit = FALSE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID setAndGetGroupValues(OBJECT *tree, _VOID *env, _BOOL set, _WORD exitBut)
{
	envRecord *rec;

	exitBut &= 0x7fff;
	rec = env;
	if (set)
	{
		VDIUtil_SetXState(tree, GRSORT1, rec->sort);
		VDIUtil_SetXString(tree, GRSORT1, rec->typeSel, rec->sort);
		doUpdateButton(FALSE);
	} else
	{
		if (exitBut == GOK)
		{
		}
		OFREE(rec);
		/* Gruppenliste wieder freigeben */
		GroupSelect_DeleteList(&grList);
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL checkGroupExit(OBJECT *tree, _VOID *env, _WORD button, _VOID *group, _UWORD kstate)
{
	envRecord *rec;
	rec = env;
	UNUSED(tree);
	UNUSED(button);
	UNUSED(group);
	UNUSED(kstate);
	if (button == GOK)
	{
		GRECT r;
		
		DelObjState(tree, button, SELECTED);
		WinDials_WinDialDraw(tree, button, MAX_DEPTH, &r, FALSE);
		return !rec->weiter;
	}
	return TRUE;
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/
GLOBAL _VOID Alias_Setnames(group *groups, GROUPNR numGroups)
{
	_WORD i;
	group *gr;
	
	for (i = 0, gr = groups; i < numGroups; i++, gr++)
	{
		gr->display_name = gr->name;
	}
}

/*** ------------------------------------------------------------------------ ***/
/*	LOCAL _BOOL setGrpNr(group *gr)												*/
/*	Setzt die catNumber einer Gruppe um											*/
/*	Parameter:	gr:	die zu ndernde Gruppe										*/
/*	Ergebnis:	immer FALSE ->Abbrechen, eine 2. Gruppe wollen wir nicht.		*/		
/*	12.8.01 von Dimitri Junker	DYJ 4.24l										*/
/*** ------------------------------------------------------------------------ ***/
LOCAL _BOOL setGrpNr(group *gr)
{

	CatLog_WriteStringNTime(gr->name);
	CatLog_WriteString(" erhlt die Gruppennummer: ");
	CatLog_WriteCard(SetNewCatNum);
	CatLog_WriteLn();
	GroupSelect_SetNewCatNumber(gr->name, SetNewCatNum);
	return FALSE;

}
/* Gruppenauswahl...*/
LOCAL _VOID SelectGroup(CHECK_FUNC func)
{
	_WORD maxLength;
	GRECT r;
	envRecord *envRec;
	ldHandler dialHandler;
	_BOOL ok;
	group *gr;
	_WORD anzspecials;
	
	if ((envRec = NEW(envRecord, "SelectGroup")) == NULL)
		return;
	MemSetZeroStruct(*envRec);
	envRec->func = func;
	envRec->tree = RscGaddr(theRSC, R_TREE, GRUPPEN);
	envRec->typeSel = RscGaddr(theRSC, R_TREE, SORTTYPE);
	if(func==setGrpNr)
	{
		envRec->sort=1;
		/* specials bestimmen */
		envRec->specials[0].objc = GOK;
		envRec->specials[0].proc = checkTab;
		anzspecials=1;
		SetObjFlags(envRec->tree, GRSORT0, HIDETREE);
		SetObjFlags(envRec->tree, GRSORT1, HIDETREE);
		SetObjFlags(envRec->tree, GRSORT2, HIDETREE);
		SetObjFlags(envRec->tree, GRSORTBOX, HIDETREE);
		ok = GroupSelect_GetNoReadList(&grList);
		envRec->weiter=FALSE;
		/* Jetzt die Liste anfordern beim Listenmodul */
	}
	else
	{
		envRec->sort=0;
		/* specials bestimmen */
		envRec->specials[0].objc = GRSORT0;
		envRec->specials[0].proc = switchSort;
		envRec->specials[1].objc = GRSORT1;
		envRec->specials[1].proc = switchSort;
		envRec->specials[2].objc = GRSORT2;
		envRec->specials[2].proc = switchSort;
		envRec->specials[3].objc = GOK;
		envRec->specials[3].proc = checkTab;
		anzspecials=4;
		DelObjFlags(envRec->tree, GRSORT0, HIDETREE);
		DelObjFlags(envRec->tree, GRSORT1, HIDETREE);
		DelObjFlags(envRec->tree, GRSORT2, HIDETREE);
		DelObjFlags(envRec->tree, GRSORTBOX, HIDETREE);
		envRec->weiter=TRUE;
		/* Jetzt die Liste anfordern beim Listenmodul */
		ok = GroupSelect_GetReadList(&grList, TRUE, FALSE, FALSE);
	}
	
	if (!ok)
	{
		OFREE(envRec);
		return;
	}
	
	/* Maximale Breite eines Listeneintrages herausfinden */
	maxLength = 0;
	Lists_ResetList(&grList);
	while ((gr = Lists_NextEntry(&grList)) != NULL)
	{
		gr->errorCount = CRC_NOT_CHECKED;
		if (strLen(gr->name) > maxLength)	/*DYJ 5.20w */
			maxLength = (_WORD)strLen(gr->name);	/*DYJ 5.20w */
	}

	/* Jetzt das Object zusammenbauen */
	CalcArea(gruppen, GROUPBOX, &r);
	envRec->globalLength = Max(maxLength, r.g_w / CharWidth) + 2 + 8 + 2 + 11;
	envRec->maxLength = maxLength;
	grList.user = envRec;
	SortList(&grList, envRec->sort);
	
	/* WindowDialog vorbereiten */
	ListDl_BuildLdHandler(&grList,
		resetList,
		nextEntry,
		prevEntry,
		countEntries,
		isEnabled,
		selGrEntry,
		groupToStr,
		groupIsSelected,
		drawGroupEntry,
		FUNK_NULL,
		0, CharHeight,
		8, r.g_w,
		&dialHandler);

	/* ListWinDialog oeffnen */
	ListDl_WinListDial(gruppen,
		ldSelect | ldMultiple | ldArrows | ldModal,
		&dialHandler,
		GROUPBOX,
		GROUPBACK,
		-1,                        /* okBut */
		GCANCEL,                   /* cancelBut */
		envRec,
		GOK,                       /* doubeClickButton */
		-1,                        /* autoEdit */
		updateButton,              /* inLoop */
		envRec->specials,
		anzspecials,
		checkGroupExit,
		setAndGetGroupValues,
		setAndGetGroupValues,
		(_VOID **)&envRec->group);
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

/*
 * Um die DAT-Datei zu testen und die PAR-Datei zu reparieren,
 * koennen wir nicht die Datenbank-Funktionen nehmen da die
 * (mindestens) von einer intakten PAR-Datei ausgehen
 */
 
/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID open_writeLog(CONST _UBYTE *open, _WORD error)
{
	_UBYTE errMsg[256];

	CatLog_WriteLine("- Fehler beim \224ffnen von Dateien -");
	CatLog_WriteString("Kein Zugriff auf ");
	CatLog_WriteString(open);
	CatLog_WriteString(" -> Gemdos-Fehler #");
	CatLog_WriteInt(error);
	CatLog_WriteLn();
	F_GetErrorMsg(error, errMsg, sizeof(errMsg));
	CatLog_WriteString("Fehlermeldung: ");
	CatLog_WriteString(errMsg);
	CatLog_WriteLn();
	CatLog_WriteLine("-Ende der Durchsage -");
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _ULONG FileLength(FILENO file)
{
	return Fseek(0L, file, SEEK_END);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID CloseGroup(OneHandle *handle)
{
	if (*handle != NULL)
	{
		if ((*handle)->datHandle >= 0)
			CatFiles_CloseFile((*handle)->datHandle);
		if ((*handle)->parHandle >= 0)
			CatFiles_CloseFile((*handle)->parHandle);
		if ((*handle)->tabHandle >= 0)
			CatFiles_CloseFile((*handle)->tabHandle);
		if ((*handle)->waiHandle >= 0)
			CatFiles_CloseFile((*handle)->waiHandle);
		OFREE(*handle);
		*handle = NULL;
	}
}

/*** ---------------------------------------------------------------------- ***/

/*
 * DAT-Datei oeffnen
 */
LOCAL _BOOL OpenDat(CAT_GROUP_NUMBER group, OneHandle *pnew)
{
	_UBYTE name[PATH_MAX];
	_UBYTE open[PATH_MAX];
	_UBYTE fname[PATH_MAX];
	OneHandle new;
	
	*pnew = new = NEW(oneHandle, "data_OpenOneGroup: groupHandle");
	if (new == NULL)
		return FALSE;
	MemSetZeroStruct(*new);
	
	new->group = group;
	data_Number2Name(group, name);
	
	/* Dat-Datei oeffnen */
	strCat(strCpy(open, name), datTag);	/*DYJ 5.20w */
	strCpy(fname, DataPath);	/*DYJ 5.20w */
	F_Path_Append(fname, open);
	new->datHandle = CatFiles_OpenFile(fname, CatFiles_readWrite);
	if (!FILENO_OK(new->datHandle))
	{
		sprintf(name, Rsc_WrkString(MTE_noFileAccess), open);	/*DYJ 5.21i */
		MTE_info(name);
		open_writeLog(open, TO_HANDLE(new->datHandle));
		OFREE(new);
		*pnew = NULL;
		return FALSE;
	}
	new->DatSize = FileLength(new->datHandle);
	CatFiles_Seek(0, new->datHandle, CatFiles_start);
	
	new->tabHandle = NO_FILE;
	new->waiHandle = NO_FILE;
	new->parHandle = NO_FILE;
	return TRUE;
}
/*** ------------------------------------------------------------------------ ***/
/*	LOCAL _BOOL OpenWai(CAT_GROUP_NUMBER group, OneHandle *pnew)				*/
/*	WAI-Datei oeffnen														 	*/
/*	Parameter:	group:	Gruppennummer											*/
/*				pnew:	soll gefllt werden										*/
/*	Ergebnis:	OK?															*/		
/*	11.11.00 von Dimitri Junker	DYJ 4.50a										*/
/*** ------------------------------------------------------------------------ ***/
LOCAL _BOOL OpenWai(CAT_GROUP_NUMBER group, OneHandle *pnew)
{
	_UBYTE name[PATH_MAX];
	_UBYTE open[PATH_MAX];
	_UBYTE fname[PATH_MAX];
	_ULONG len;
	_BOOL hatPar;
	OneHandle new;
	
	*pnew = new = NEW(oneHandle, "wai_OpenOneGroup: groupHandle");
	if (new == NULL)
		return FALSE;
	MemSetZeroStruct(*new);
	
	new->group = group;
	data_Number2Name(group, name);
	
	/* Wai-Datei oeffnen */
	strCat(strCpy(open, name), waiTag);	/*DYJ 5.20w */
	strCpy(fname, DataPath);	/*DYJ 5.20w */
	F_Path_Append(fname, open);
	new->waiHandle = CatFiles_OpenFile(fname, CatFiles_readWrite);
	if (!FILENO_OK(new->waiHandle))
	{
		sprintf(name, Rsc_WrkString(MTE_noFileAccess), open);	/*DYJ 5.21i */
		MTE_info(name);
		open_writeLog(open, TO_HANDLE(new->waiHandle));
		OFREE(new);
		*pnew = NULL;
		return FALSE;
	}
	new->WaiSize = FileLength(new->waiHandle);
	CatFiles_Seek(0, new->waiHandle, CatFiles_start);
	
	new->tabHandle = NO_FILE;
	new->datHandle = NO_FILE;
	new->parHandle = NO_FILE;

	/* Lnge der Par-Datei ermitteln um so die Anzahl Messages in der Gruppe zu berechnen */
	strCat(strCpy(open, name), parTag);	/*DYJ 5.20w */
	strCpy(fname, DataPath);	/*DYJ 5.20w */
	F_Path_Append(fname, open);
	len=CatFiles_FileSize(open,&hatPar);
	if(hatPar)
		new->anz = (MSGNR)(len / sizeof(pBlock));
	/* Anzahl an Nachrichten in der Gruppe */

	return hatPar;


}
/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL isOldHeader(CONST FileHeaderType *head)
{
	return head->CatMagic != dbCatMagic ||
		   head->Version != dbVersion ||
		   head->VersionMagic != dbVersionMagic;
}

/*** ---------------------------------------------------------------------- ***/

/*
 * PAR-Datei oeffnen; DAT-Datei muss schon offen sein
 */
LOCAL _BOOL OpenPar(CAT_GROUP_NUMBER group, OneHandle *pnew, _BOOL wannaWrite, _UBYTE *fname)
{
	_UBYTE name[PATH_MAX];
	_UBYTE open[PATH_MAX];
	_ULONG len;
	FileHeaderType head;
	OneHandle new;
	_BOOL wrongHeader;
	F_ERROR error;
	
	new = *pnew;
	data_Number2Name(group, name);
	
	/* Par-Datei oeffnen */
	strCat(strCpy(open, name), wannaWrite ? ".pa" : parTag);	/*DYJ 5.20w */
	strCpy(fname, DataPath);	/*DYJ 5.20w */
	F_Path_Append(fname, open);
	if (wannaWrite)
		F_File_Delete(fname);
	new->parHandle = CatFiles_OpenFile(fname, CatFiles_readWrite);
	if (!FILENO_OK(new->parHandle))
	{
		sprintf(name, Rsc_WrkString(MTE_noFileAccess), open);	/*DYJ 5.21i */
		MTE_info(name);
		open_writeLog(open, TO_HANDLE(new->parHandle));
		CloseGroup(pnew);
		return FALSE;
	}
	
	wrongHeader = FALSE;
	len = FileLength(new->parHandle);
	if (len == 0)	/* Neue Datei, erstmal den Header schreiben */
	{
		if (wannaWrite)
		{
			CatFiles_Seek(0, new->parHandle, CatFiles_start);
			head.CatMagic = h2nl(dbCatMagic);
			head.Version = h2ns(dbVersion);
			head.VersionMagic = h2ns(dbVersionMagic);
			error = CatFiles_WriteMuch(dbHeaderLength, new->parHandle, &head);
		} else
		{
			wrongHeader = TRUE;
			error = NoError;
		}
	} else
	{
		CatFiles_Seek(0, new->parHandle, CatFiles_start);
		error = CatFiles_ReadDbHeader(new->parHandle, &head);
		if (error != NoError || isOldHeader(&head))
		{
			wrongHeader = TRUE;
		} else
		{
			len -= dbHeaderLength;
		}
	}
	if (wrongHeader)
	{
		MTE_info(Rsc_WrkString(AL_OLD_VERSION));	/*DYJ 5.21b */
		CloseGroup(pnew);
		return FALSE;
	}
	new->anz = (MSGNR)(len / sizeof(pBlock));
	/* Anzahl an Nachrichten in der Gruppe */
	if (error != NoError)
	{
		/* Dann ist beim Lesen des Kopfes oder beim Schreiben etwas schiefgelaufen */
		F_ErrorAlert(error);
		open_writeLog(open, error);
		CloseGroup(pnew);
		return FALSE;
	}
	
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

/* Restliche Daten lesen, nur falls bisher alles gut gelesen wurde,
 * d.h. data_error == data_noError
 */
LOCAL _BOOL ReadHeader(OneHandle handle, MessageType *mess, pBlock *blockPtr, _ULONG *datPos)
{
	data_offset *pos;
	pInfoType *p;
	_UWORD cz, zCount;
	size_t hLen;
	data_len idLength;
	_LONG count;
	dupeInfoType dupe;
	_ULONG nextDatPos;
	
	Fseek(-((_LONG)sizeof(dupe)), handle->datHandle, SEEK_CUR);
	if (Fread(handle->datHandle, sizeof(dupe), &dupe) != sizeof(dupe))
	{
		*datPos = 0;
		return FALSE;
	}
	blockPtr->Datum = dupe.Datum;
	blockPtr->items = dupe.items;
	blockPtr->bits = dupe.bits;
	blockPtr->hLength = dupe.hLength;
	blockPtr->idLength = dupe.idLength;
	blockPtr->Length = dupe.Length;
	blockPtr->Start = dupe.Start;
	blockPtr->upMess = dataSys_empty;
	blockPtr->downMess = dataSys_empty;
	blockPtr->rightMess = dataSys_empty;
	blockPtr->leftMess = dataSys_empty;
	blockPtr->KomCount = 0;
	nextDatPos = *datPos;
	*datPos = dupe.Start;
	if (dupe.Start + dupe.hLength + dupe.Length + sizeof(dupe) != nextDatPos)
	{
		return FALSE;
	}
	if (Fseek(blockPtr->Start, handle->datHandle, SEEK_SET) != blockPtr->Start)
		return FALSE;
	
	mess->InfoStrings = MALLOC(blockPtr->hLength + 1, "InfoStrings");
	if (mess->InfoStrings == NULL)
		return FALSE;
	
	count = Fread(handle->datHandle, blockPtr->hLength, mess->InfoStrings);
	if (count != blockPtr->hLength)
	{
		SFREE(mess->InfoStrings);
		return FALSE;
	}
	for (idLength = 0; idLength < count && mess->InfoStrings[idLength] != '\0'; idLength++)
		;
	if (idLength >= count)
	{
		SFREE(mess->InfoStrings);
		return FALSE;
	}
	idLength++;
	if (idLength != blockPtr->idLength)
	{
		SFREE(mess->InfoStrings);
		return FALSE;
	}
	/* wir brauchen noch mindestens:
	   Null-Byte der ID und
	   Anzahl der folgenden Texte und
	   Laenge des Betreffs (immer vorhanden)
	 */
	hLen = idLength;
	if (hLen & 1)
		++hLen;
	if (count < (hLen + 4))
	{
		SFREE(mess->InfoStrings);
		return FALSE;
	}
	pos = (data_offset *)(mess->InfoStrings + hLen);
	/*
	 * mehr als 32 Strings koennen nicht drinstehen
	 * (wegen den Item-Flags in der PAR-Datei)
	 */
	zCount = n2hs(pos[0]);
	if (zCount > 32)
	{
		SFREE(mess->InfoStrings);
		return FALSE;
	}
	if (hLen + (zCount + 1) * sizeof(data_offset) >= count)
	{
		SFREE(mess->InfoStrings);
		return FALSE;
	}
	for (cz = 1; cz <= zCount; cz++)
	{
		if (n2hs(pos[cz]) >= count ||
			*datPos + n2hs(pos[cz]) > nextDatPos)
		{
			SFREE(mess->InfoStrings);
			return FALSE;
		}
	}
	if (handle->group == dataSys_private)
	{
		hLen = blockPtr->hLength - sizeof(pInfoType);
		p = (pInfoType *)(mess->InfoStrings + hLen);
		if (hLen & 1)
		{
			_UBYTE *cp;
			
			cp = (_UBYTE *)p;
			for (cz = (_UWORD)sizeof(pInfoType); cz > 0; --cz)
			{
				cp[cz] = cp[cz - 1];
			}
			p = (pInfoType *)(cp + 1);
		}
		p->LeseDatum = n2hl(p->LeseDatum);
		data_Long2DateStr(p->LeseDatum,NULL, mess->StatusDatum, sizeof(mess->StatusDatum));
		mess->EigeneNachricht = p->locked != '\0';
		mess->Status          = p->Status;
		mess->statusDate      = p->LeseDatum;
	}
	mess->MailID  = mess->InfoStrings;
	mess->Betreff = mess->InfoStrings + n2hs(pos[1]);
	mess->Text = MALLOC(blockPtr->Length, "iReadRest: text");
	if (mess->Text == NULL)
	{
		SFREE(mess->InfoStrings);
		return FALSE;
	}
	if (Fread(handle->datHandle, blockPtr->Length, mess->Text) != blockPtr->Length)
	{
		SFREE(mess->Text);
		SFREE(mess->InfoStrings);
		return FALSE;
	}
	return TRUE;
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

LOCAL _BOOL check_tab_group(group *gr)
{
	OneGroupHandle handle;
	_BOOL abort;
	MSGNR msg;
	pBlock s, *ptr;
	F_ERROR error;
	CAT_GROUP_NUMBER nr;
	CRC16 crc[2];

	MessageType mess;
	
	nr = gr->catNumber;
	if (!data_OpenOneGroup(nr, 0, FALSE, &handle))
		return FALSE;
	gr->errorCount = CRC_OK;
	msg = 0;
	for (;;)
	{
		ptr = &s;
		error = data_ReadBlockCrc(handle, msg, &ptr);
		if (error == NotFound)
			break;
		if (error == NoError)
		{
			if ((error = data_GetCrc(handle, msg, crc)) == NoError)
			{
				mess.InfoStrings = NULL;
/*DYJ 5.23k Start*/
				if ((error = data_ReadHeader(handle, msg, &mess,TRUE)) == NoError)
/*DYJ  Ende; alt:	
				if ((error = data_ReadHeader(handle, msg, &mess)) == NoError)
*/
				{
					if (crc[0] == ZCalcCrc_CalcIdCrc(mess.MailID))
					{
						if (*mess.mid &&crc[1] != ZCalcCrc_CalcIdCrc(mess.mid))
							error = crcError;
					}
					else
					{
						if (crc[1] != ZCalcCrc_CalcIdCrc(mess.MailID) ||
							crc[0] != ZCalcCrc_CalcIdCrc(mess.mid))
							error = crcError;
					}
				}
				if (mess.InfoStrings != NULL)
					SFREE(mess.InfoStrings);
			}
		}
		if (error != NoError)
		{
			gr->errorCount++;
		}
		msg++;
	}
	data_CloseOneWriteGroup(&handle, 0, FALSE, &abort);
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID check_tab(_VOID)
{
	SelectGroup(check_tab_group);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL repair_tab_group(group *gr)
{
	OneGroupHandle handle;
	_BOOL abort;
	MSGNR msg;
	pBlock s, *ptr;
	F_ERROR error;
	CAT_GROUP_NUMBER nr;
	MessageType mess;
	CRC16 crc[2];
	_WORD j;
	
	nr = gr->catNumber;
	if (!data_OpenOneGroup(nr, 0, TRUE, &handle))
		return FALSE;
	gr->errorCount = CRC_OK;
	msg = 0;
	for (;;)
	{
		ptr = &s;
		error = data_ReadBlock(handle, msg, &ptr);
		if (error == NotFound)
			break;
		if (error == NoError)
		{
			error = data_WriteBlockCrc(handle, msg, ptr);
			if (error == NoError)
			{
				mess.InfoStrings = NULL;
/*DYJ 5.23k Start*/
				if ((error = data_ReadHeader(handle, msg, &mess,TRUE)) == NoError)
/*DYJ  Ende; alt:	
				if ((error = data_ReadHeader(handle, msg, &mess)) == NoError)
*/
				{
					crc[0] = ZCalcCrc_CalcIdCrc(mess.MailID);
					if(crc[0]==(CRC16)dataSys_empty)	/* Falls nur eine ID soll sie die erste sein*/
					{
						crc[1]=(CRC16)dataSys_empty;
						j=0;
					}
					else 
						j=1;
					if(ptr->items&itemMId)
						crc[j] = ZCalcCrc_CalcIdCrc(mess.mid);
					else
						crc[j]=(CRC16)dataSys_empty;
					data_PutCrc(handle, msg, crc);
				}
				if (mess.InfoStrings != NULL)
					SFREE(mess.InfoStrings);
			}
		}
		if (error != NotFound && error != NoError)
		{
			gr->errorCount++;
		}
		msg++;
	}
	data_CloseOneWriteGroup(&handle, 0, TRUE, &abort);
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID repair_tab(_VOID)
{
	SelectGroup(repair_tab_group);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL check_par_group(group *gr)
{
	OneGroupHandle handle;
	_BOOL abort;
	MSGNR msg;
	pBlock s, *ptr;
	F_ERROR error;
	CAT_GROUP_NUMBER nr;
	
	nr = gr->catNumber;
	if (!data_OpenOneGroup(nr, 0, FALSE, &handle))
		return FALSE;
	gr->errorCount = CRC_OK;
	msg = 0;
	for (;;)
	{
		ptr = &s;
		error = data_ReadBlockCrc(handle, msg, &ptr);
		if (error == NotFound)
			break;
		if (error == NoError)
		{
			
		}
		if (error != NoError)
		{
			gr->errorCount++;
		}
		msg++;
	}
	data_CloseOneWriteGroup(&handle, 0, FALSE, &abort);
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID check_par(_VOID)
{
	SelectGroup(check_par_group);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL repair_par_group(group *gr)
{
	OneHandle handle;
	MSGNR msg;
	MessageType mess;
	CAT_GROUP_NUMBER nr;
	pBlock s;
	_ULONG datPos;
	_UWORD kstate;
	_UBYTE scan, ch;
	_UBYTE fname[PATH_MAX];
	_UBYTE name[PATH_MAX];
	_UBYTE newfname[PATH_MAX];
	FILENO newPar;
	
	nr = gr->catNumber;
	if (!OpenDat(nr, &handle))
		return FALSE;
	if (OpenPar(nr, &handle, TRUE, fname))
	{
		gr->errorCount = CRC_OK;
		msg = 0;
		datPos = Fseek(handle->DatSize, handle->datHandle, SEEK_SET);
		if (datPos != handle->DatSize)
			return FALSE;
		while (datPos > 0)
		{
			if ((msg % 50) == 0)
				CatGlobal_busyMouse();
			msg++;
			if (ReadHeader(handle, &mess, &s, &datPos))
			{
				SFREE(mess.Text);
				SFREE(mess.InfoStrings);
			} else
			{
				/* !!! besser neuen Start suchen */
				gr->errorCount++;
				s.bits |= bTotalloeschung;
			}
			s.crc = BLOCK_CRC(&s);
			if (Fwrite(handle->parHandle, sizeof(s), &s) != sizeof(s))
			{
				CloseGroup(&handle);
				return FALSE;
			}
			if (VDIUtil_isKey(&kstate, &scan, &ch))
			{
				CloseGroup(&handle);
				return FALSE;
			}
			if (Fseek(datPos, handle->datHandle, SEEK_SET) != datPos)
				break;
		}
		/*
		 * jetzt die temporaere PAR-Datei umkopieren und wieder
		 * in die richtige Reihenfolge bringen
		 */
		data_Number2Name(nr, name);
		strCat(name, parTag);	/*DYJ 5.20w */
		strCpy(newfname, DataPath);	/*DYJ 5.20w */
		F_Path_Append(newfname, name);

		newPar = CatFiles_CreateFile(newfname);
		if (FILENO_OK(newPar))
		{
			FileHeaderType head;
			
			head.CatMagic = h2nl(dbCatMagic);
			head.Version = h2ns(dbVersion);
			head.VersionMagic = h2ns(dbVersionMagic);
			CatFiles_WriteMuch(dbHeaderLength, newPar, &head);
			while (msg)
			{
				Fseek(-((_LONG)sizeof(s)), handle->parHandle, SEEK_CUR);
				Fread(handle->parHandle, sizeof(s), &s);
				Fwrite(newPar, sizeof(s), &s);
				Fseek(-((_LONG)sizeof(s)), handle->parHandle, SEEK_CUR);
				--msg;
				if ((msg % 50) == 0)
					CatGlobal_busyMouse();
			}
			CatFiles_CloseFile(newPar);
			CloseGroup(&handle);
			F_File_Delete(fname);
			return TRUE;
		}
	}
	CloseGroup(&handle);
	return TRUE;
}
/*** ------------------------------------------------------------------------ ***/
/*	_UBYTE *rsc_WrkString(_WORD nr)											*/
/*	Ermittelt einen freien oder Alertstring aus der usere_*.rsc					*/
/*	Parameter:	nr:	die Stringnummer											*/
/*	Ergebnis:	der String														*/		
/*	18.3.03 von Dimitri Junker	DYJ 5.23e										*/
/*** ------------------------------------------------------------------------ ***/
GLOBAL _UBYTE *rsc_WrkString(_WORD nr)
{
	static _UBYTE dummy[30];
	_UBYTE *ret;
	ret=*((_UBYTE **)RscGaddr(theRSC, R_FRSTR, nr));
	if(!ret)
	{
		ret=dummy;
		sprintf(ret,"[3][NO RSC;Nr:L%d][OK]",nr);
	}
	return ret;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID repair_par(_VOID)
{
	if(mtAlerts_Alert(1, rsc_WrkString(AL_REP_PAR))==1)	/*DYJ 5.21q */	/*DYJ 5.23e */
		SelectGroup(repair_par_group);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL check_dat_group(group *gr)
{
	OneHandle handle;
	MSGNR msg;
	MessageType mess;
	CAT_GROUP_NUMBER nr;
	pBlock s;
	_ULONG datPos;
	_UWORD kstate;
	_UBYTE scan, ch;
	
	nr = gr->catNumber;
	if (!OpenDat(nr, &handle))
		return FALSE;
	gr->errorCount = CRC_OK;
	msg = 0;
	datPos = Fseek(handle->DatSize, handle->datHandle, SEEK_SET);
	if (datPos != handle->DatSize)
		return FALSE;
	while (datPos > 0)
	{
		if ((msg % 50) == 0)
			CatGlobal_busyMouse();
		msg++;
		if (ReadHeader(handle, &mess, &s, &datPos))
		{
			SFREE(mess.Text);
			SFREE(mess.InfoStrings);
		} else
		{
			/* !!! besser neuen Start suchen */
			gr->errorCount++;
		}
		if (VDIUtil_isKey(&kstate, &scan, &ch))
		{
			CloseGroup(&handle);
			return FALSE;
		}
		if (Fseek(datPos, handle->datHandle, SEEK_SET) != datPos)
			break;
	}
	CloseGroup(&handle);
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID check_dat(_VOID)
{
	SelectGroup(check_dat_group);
}
/*** ------------------------------------------------------------------------ ***/
/*	LOCAL _BOOL delete_wai_group(group *gr)										*/
/*	Statt das Wai-File zu reparieren kann es gelscht werden, da CAT ein		*/
/*	fehlendes WAI automatisch neu erzeugt										*/
/*	Parameter:	gr:	Die Gruppe															*/
/*	Ergebnis:	gelscht?															*/		
/*	8.11.00 von Dimitri Junker	DYJ 4.50a										*/
/*** ------------------------------------------------------------------------ ***/
LOCAL _BOOL delete_wai_group(group *gr)
{
	_UBYTE name[PATH_MAX];
	_UBYTE del[PATH_MAX];
	_UBYTE fname[PATH_MAX];
	
	if(form_alert(1,"[2][Falls Sie hier das WAI-File lschen|wird es in CAT automatisch neu erzeugt.|Deshalb erbrigt sich eine Reparatur.][Lschen|Behalten]")==2)
		return FALSE;
	else
	{
		data_Number2Name(gr->catNumber, name);
		/* Wai-Datei lschen*/
		strCat(strCpy(del, name), waiTag);	/*DYJ 5.20w */
		strCpy(fname, DataPath);	/*DYJ 5.20w */
		F_Path_Append(fname, del);
		F_File_Delete(del);
		return TRUE;
	}
}

/*** ------------------------------------------------------------------------ ***/
/*	LOCAL _BOOL check_wai_group(group *gr)										*/
/*	Testet ein WAI-File															*/
/*	Parameter:	gr:	Die Gruppe													*/
/*	Ergebnis:	Konnte getestet werden?											*/		
/*	8.11.00 von Dimitri Junker	DYJ 4.50a										*/
/*** ------------------------------------------------------------------------ ***/
LOCAL _BOOL check_wai_group(group *gr)
{
	OneHandle handle;
	MSGNR wai,anzWai;
	CAT_GROUP_NUMBER nr;
	_UWORD kstate;
	_UBYTE scan, ch;
	WAISEN waise;
	
	nr = gr->catNumber;
	if (!OpenWai(nr, &handle))
		return FALSE;
	gr->errorCount = CRC_OK;
	if (Fread(handle->waiHandle, sizeof(anzWai), &anzWai) != sizeof(anzWai))
		return FALSE;
	if(handle->WaiSize<sizeof(anzWai)+anzWai*sizeof(WAISEN))
		return FALSE;
	for(wai = 0;wai<anzWai;wai++)
	{
		if ((wai % 50) == 0)
			CatGlobal_busyMouse();
		if(Fread(handle->waiHandle,sizeof(waise),&waise)!=sizeof(waise))
			return FALSE;
		if(waise.msgNr>=handle->anz || waise.kommentarAnzahl>=handle->anz)
			gr->errorCount++;
		if (VDIUtil_isKey(&kstate, &scan, &ch))
		{
			CloseGroup(&handle);
			return FALSE;
		}
	}
	CloseGroup(&handle);
	return TRUE;
}

LOCAL _VOID check_wai(_VOID)
{
	SelectGroup(check_wai_group);
}
LOCAL _VOID delete_wai(_VOID)
{
	SelectGroup(delete_wai_group);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID repair_dat(_VOID)
{
	mtAlerts_Alert(1, "[3][Not yet implemented][Sh...]");
}
/*** ------------------------------------------------------------------------ ***/
/*						*/
/*								*/
/*	Parameter:	keine															*/
/*	Ergebnis:	keines															*/		
/*	8.8.01 von Dimitri Junker	DYJ 4.24r										*/
/*** ------------------------------------------------------------------------ ***/
LOCAL F_ERROR path_Rename(CONST _UBYTE *old, CONST _UBYTE *new)
{
	F_ERROR err;
	err=F_Path_Rename(old, new);
	
	if (err != GERR_OK)
	{
		CatLog_WriteStringNTime("Das File: ");
		CatLog_WriteLine(old);
		CatLog_WriteString("         konnte nicht in: ");
		CatLog_WriteString(new);
		CatLog_WriteLine(" umbenannt werden.");
	}
	return err;
}
/*** ------------------------------------------------------------------------ ***/
/*	LOCAL _BOOL moveGroup(CAT_GROUP_NUMBER zielNr, GROUPNR quellNr)				*/
/*	verschiebt eine Gruppe von einer catNumber zur anderen						*/
/*	Parameter:	zielNr, quellNr: Quelle und Ziel								*/
/*	Ergebnis:	erfolgreich?													*/		
/*	29.7.01 von Dimitri Junker	DYJ 4.24l										*/
/*** ------------------------------------------------------------------------ ***/
LOCAL _BOOL moveGroup(CAT_GROUP_NUMBER zielNr, CAT_GROUP_NUMBER quellNr)
{
	DB_NAMES dbf;
	DB_NAMES dbf2;
	_UBYTE gname[256];
	
/*	Bei Fehlern in der Datenbank ggf. nicht lschen*/

	if (quellNr > zielNr)
	{
		/* Von der letzten Gruppe die Nummer noch aendern 
		 * und die Dateien umbenennen 
		 */
		GroupSelect_makeFilenames(zielNr, FALSE, &dbf,tmpPath);
		GroupSelect_makeFilenames(quellNr, FALSE, &dbf2,tmpPath);
		/* Jetzt Dateien umbennen */
		if ((path_Rename(dbf2.tabName, dbf.tabName) != GERR_OK) ||
			(path_Rename(dbf2.parName, dbf.parName) != GERR_OK) ||
			(path_Rename(dbf2.waiName, dbf.waiName) != GERR_OK) ||
			(path_Rename(dbf2.datName, dbf.datName) != GERR_OK))
		{
			mtAlerts_Alert(1, rsc_WrkString(AL_RENAME_GROUP_FILES));	/*DYJ 5.23e */
			return FALSE;
		}
		GroupSelect_GroupName(quellNr,gname,sizeof(gname));
		GroupSelect_SetNewCatNumber(gname, zielNr);
		CatLog_WriteStringNTime("Die Gruppe: ");
		CatLog_WriteString(gname);
		CatLog_WriteLine(" bekam eine neue Nummer: ");
		CatLog_WriteString("         Alte Nummer:");
		CatLog_WriteCard(quellNr);
		CatLog_WriteString("; neue Nummer: ");
		CatLog_WriteCard(zielNr);
		CatLog_WriteLine(".");
		CatLog_WriteLine("         Auch die Datenfiles wurden umbenannt. Die Nummer im Filenamen ist jeweils Grupppennummer-1!");
		

	}
	/* Jetzt gruppen.pos noch aendern */
	if (data_ReadPos())
	{
		/* Jetzt ist das geladen, Aenderungen vornehmen */
		data_CopyPos(zielNr,quellNr);
		data_WritePos();
		data_CloseBase();
	}
	
	return TRUE;
}
/*** ------------------------------------------------------------------------ ***/
/*	LOCAL _BOOL delGroup(CAT_GROUP_NUMBER zielNr)								*/
/*	Lscht catNumber und readNumber einer Gruppe, ohne aber die Datenfiles		*/
/*	zu lschen. Sinnvoll bei doppelt vergebenen Nummern.						*/
/*	Parameter:	zielNr:	zu lschende Gruppe										*/
/*	Ergebnis:	erfolgreich?													*/		
/*	29.7.01 von Dimitri Junker	DYJ 4.24l										*/
/*** ------------------------------------------------------------------------ ***/
LOCAL _BOOL delGroup(CAT_GROUP_NUMBER zielNr)
{
	_UBYTE gname[256],gname2[256];	/* Men gleich gleich lang sein*/
	_UBYTE alMsg[300];
	_WORD delNr;
	
	GroupSelect_2GroupNames(zielNr,gname,gname2,sizeof(gname));
	if(*gname2)
	{
		sprintf(alMsg,rsc_WrkString(AL_DELETE_WHAT),gname,gname2);	/*DYJ 5.23e */
		delNr=mtAlerts_Alert(1, alMsg);
	}
	else
		delNr=2;
	switch(delNr)
	{
		case 1:
			GroupSelect_DeleteGroup(gname2);
			CatLog_WriteStringNTime("Die Verbindung der Gruppe: ");
			CatLog_WriteString(gname2);
			CatLog_WriteLine(" zur Datenbank wird abgeschnitten.");
			CatLog_WriteLine("         Es wurden natrlich keine Files gelscht!");
			break;
		case 2:
			GroupSelect_DeleteGroup(gname);
			CatLog_WriteStringNTime("Die Verbindung der Gruppe: ");
			CatLog_WriteString(gname);
			CatLog_WriteLine(" zur Datenbank wird abgeschnitten.");
			CatLog_WriteLine("         Es wurden natrlich keine Files gelscht!");
			break;
		case 3:
			return FALSE;
	}
	
	
	return TRUE;
}
/*** ------------------------------------------------------------------------ ***/
/*	LOCAL GROUPNR catGroupsMax(_VOID)											*/
/*	gibt die hchste vergebene catNumber zurck									*/
/*	Parameter:	keine															*/
/*	Ergebnis:	na was wohl?													*/		
/*	29.7.01 von Dimitri Junker	DYJ 4.24l										*/
/*** ------------------------------------------------------------------------ ***/
LOCAL CAT_GROUP_NUMBER catGroupsMax(_VOID)
{
	CAT_GROUP_NUMBER max;
	GroupSelect_CountCatGroupsMax(&max);
	return max;
}
/*** ------------------------------------------------------------------------ ***/
/*	LOCAL _BOOL chkDbFiles(_VOID)												*/
/*	Prft ob in der Datenbank berflssige oder schreibgeschtzte Files			*/
/*	vorhanden sind.																*/
/*	Parameter:	keine															*/
/*	Ergebnis:	alles OK?															*/		
/*	11.8.01 von Dimitri Junker	DYJ 4.24l										*/
/*** ------------------------------------------------------------------------ ***/
LOCAL _BOOL chkDbFiles(_VOID)
{
	Directory *dir;
	DirectoryEntry *entry;
	_UBYTE name[PATH_MAX],pfad[PATH_MAX];
	_BOOL tstRO,hasOrph=FALSE,hasRo=FALSE;
	FILE *file;
	_UBYTE *nr;
	CAT_GROUP_NUMBER grpNr;
	_UBYTE alMsg[300];

	dir = D_Opendir(DataPath);
	if (dir != NULL)
	{
		while ((entry = D_Readdir(dir)) != NULL)
		{
			strBcpy(name, entry->d_name);
			strLwr(name);
			tstRO=FALSE;
			if (WildCards_NameMatching(name, groupPat))
			{
				tstRO=TRUE;
				for(nr=name;*nr>'9';nr++);
				grpNr=atoi(nr)+1;
				if(!GroupSelect_CntCatNum(grpNr))
				{
					CatLog_WriteStringNTime("In der Datenbank ist folgendes File: ");
					CatLog_WriteLine(name);
					CatLog_WriteString("         obwohl es keine Gruppe mit der Nummer: ");
					CatLog_WriteCard(grpNr);
					CatLog_WriteLine(" gibt.");
					hasOrph=TRUE;
				}
			}
			else if(WildCards_NameMatching(name, privatePat))
				tstRO=TRUE;
			if(tstRO)
			{
				switch((_WORD)(entry->d_st.st_mode&0x92l))	/* wer darf schreiben?*/
				{
					case S_IWUSR|S_IWGRP|S_IWOTH:
						break;						/*alle drfen schreiben, also auch wir*/
					case S_IWUSR:
					case S_IWUSR|S_IWGRP:
					case S_IWUSR|S_IWOTH:
					case S_IWGRP:
					case S_IWGRP|S_IWOTH:
					case S_IWOTH:
						strCpy(pfad, DataPath);		/*einige drfen schreiben, auch wir?*/	/*DYJ 5.20w */
						F_Path_Append(pfad, name);
						file=fopen(pfad,"a");
						if(file)
						{
							fclose(file);			/*wir knnen schreiben	*/
							break;
						}
					case 0:							/*keiner darf schreiben*/
						CatLog_WriteStringNTime("Auf folgendes File: ");
						CatLog_WriteLine(name);
						CatLog_WriteLine("         habe ich keinen Schreibzugriff!");
						hasRo=TRUE;
				}
			}
		}
		D_Closedir(dir);
		if(hasOrph)
		{
			CatLog_WriteLn();
			CatLog_WriteLineNTime("Bitte die berschssigen Files ansehen (am besten die *.dat)");
			CatLog_WriteLineNTime("         um zu ermiteln zu welcher Gruppe sie gehren. und dann");
			CatLog_WriteLineNTime("         entweder adoptieren (Menpunkt in Repair oder lschen.");
			CatLog_WriteLineNTime("         Ggf. irgendwo sichern");
			CatLog_WriteLineNTime("         dann erneut Nummerierung reparieren.");
		}
		if(hasRo)
		{
			CatLog_WriteLn();
			CatLog_WriteLineNTime("Bitte die schreibgeschtzten Files beschreibbar machen");
		}
		if(hasOrph||hasRo)
		{
			CatLog_WriteLn();
			CatLog_WriteLineNTime("Bis dies geschehen ist kann die Datenbank nicht repariert werden.");
			sprintf(alMsg,rsc_WrkString(AL_ERR_DBF),DataPath,LOG_FNAME);	/*DYJ 5.23e */
			mtAlerts_Alert(1, alMsg);
		}
	}
	return !(hasOrph||hasRo);
}

/*** ------------------------------------------------------------------------ ***/
/*	LOCAL _VOID adopt_files(_VOID)												*/
/*	Hier knnen Datenfile (*.PAR+*.DAT) einer Gruppe zugeordnet werden			*/
/*	Parameter:	keine															*/
/*	Ergebnis:	keines															*/		
/*	12.8.01 von Dimitri Junker	DYJ 4.24l										*/
/*** ------------------------------------------------------------------------ ***/
LOCAL _VOID adopt_files(_VOID)
{
	_UBYTE wild[PATH_MAX],file[PATH_MAX],*ptr;
	DB_NAMES dbf;
	CAT_GROUP_NUMBER grpNr=NO_GROUP;
	
	strCpy(wild, DataPath);	/*DYJ 5.20w */
	F_Path_Append(wild,groupPat);
	ptr=strrChr(wild,'.');	/*DYJ 5.20w */
	if(ptr)
		strCpy(ptr,parTag);	/*DYJ 5.20w */
	if (mtDir_GetFile(wild, "Bitte par File auswhlen",file))
	{
		ptr=strrChr(file,'.');	/*DYJ 5.20w */
		if(ptr)
		{
			ptr-=3;
			if(*ptr=='e' || *ptr=='E')
				ptr++;
			grpNr=atoi(ptr)+1;
			if(GroupSelect_CntCatNum(grpNr))
			{
				grpNr=NO_GROUP;
				mtAlerts_Alert(1, rsc_WrkString(AL_NO_ORP));	/*DYJ 5.23e */
			}
			else
			{
				GroupSelect_makeFilenames(grpNr, FALSE, &dbf,tmpPath);
				if(!CatFiles_Exists(dbf.parName))
				{
					grpNr=NO_GROUP;
					mtAlerts_Alert(1, rsc_WrkString(AL_NO_PAR));	/*DYJ 5.23e */
				}
				else if(!CatFiles_Exists(dbf.datName))
				{
					grpNr=NO_GROUP;
					mtAlerts_Alert(1, rsc_WrkString(AL_NO_DAT));	/*DYJ 5.23e */
				}
				else
				{
					SetNewCatNum=grpNr;
					SelectGroup(setGrpNr);
					/* Gruppen.INF sichern */
					GroupSelect_SaveGruppenInf();

					/* Geaenderte Gruppenliste von CAT noch sichern */
					GroupSelect_SaveGroupList();
				}
			}
		}
	}
}
/*** ------------------------------------------------------------------------ ***/
/*	LOCAL _VOID repair_catnr(_VOID)												*/
/*	Versucht die Gruppennummerierung zu reparieren								*/
/*	Parameter:	keine															*/
/*	Ergebnis:	keines															*/		
/*	29.7.01 von Dimitri Junker	DYJ 4.24l										*/
/*** ------------------------------------------------------------------------ ***/
LOCAL _VOID repair_catnr(_VOID)
{
	CAT_GROUP_NUMBER free,max,anz,i,j;
	if(mtAlerts_Alert(2, rsc_WrkString(AL_WARN_CATNR))==2 && chkDbFiles())	/*DYJ 5.23e */
	{
		if(!GroupSelect_tstCatNr())
		{
			/* Sucht Lcken und kopiert dort die Gruppe mit der hchsten Nummer hin.*/
			while((free=GroupSelect_FreeCatNum())<(max=catGroupsMax()))
			{
				CatLog_WriteStringNTime("Es gibt keine Gruppe mit der Nummer: ");
				CatLog_WriteCard(free);
				CatLog_WriteLn();
				if(!moveGroup(free, max))
					return;
			}
			anz=GroupSelect_CountCatGroupsMax(&max);
			if(anz!=max)
			{
				for(i=1;i<=max;i++)
				{
					if((anz=GroupSelect_CntCatNum(i))>1)
					{
						CatLog_WriteStringNTime("Die Gruppennummer: ");
						CatLog_WriteCard(i);
						CatLog_WriteString(" kommt ");
						CatLog_WriteCard(anz);
						CatLog_WriteString(" mal vor.");
						CatLog_WriteLn();
						for(j=1;j<anz;j++)
						{
							if(!delGroup(i))
								return;
						}
					}
				}
							
			}
			/* Gruppen.INF sichern */
			GroupSelect_SaveGruppenInf();

			/* Geaenderte Gruppenliste von CAT noch sichern */
			GroupSelect_SaveGroupList();
		}
		else
			CatLog_WriteLineNTime("Es wurden keine Fehler in der Gruppennummerierung gefunden");
	}
}		

/******************************************************************************
 *** ---------------------------------------------------------------------- ***
 * Menu handling
 *** ---------------------------------------------------------------------- ***
 ******************************************************************************/

LOCAL _WORD DoSimpleBox(OBJECT *form)
{
	if (form == NULL)
		return -1;
	return WinDials_WinDialDo(form, ROOT);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID doInfo(_VOID)
{
	DoSimpleBox(RscGaddr(theRSC, R_TREE, ABOUT_BOX));
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID menuManager(_WORD item, _WORD menuIndex, _UWORD kstate)
{
	UNUSED(kstate);
	switch (item)
	{
	case CHECK_TAB:
		check_tab();
		break;
	case CHECK_PAR:
		check_par();
		break;
	case CHECK_DAT:
		check_dat();
		break;
	case CHECK_WAI:
		check_wai();
		break;
	case DELETE_WAI:
		delete_wai();
		break;
	case REPAIR_TAB:
		repair_tab();
		break;
	case REPAIR_PAR:
		repair_par();
		break;
	case REPAIR_DAT:
		repair_dat();
		break;
	case SORT_CATNR:
		repair_catnr();
		break;
	case ADPT_FLS:
		adopt_files();
		break;
	case FQUIT:
		quitProg = TRUE;
		break;
	case ABOUT:
		doInfo();
		break;
	}
	menu_tnormal(menu, menuIndex, 1);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL msgHandler(CONST _WORD *message, _UWORD kstate)
{
	switch (message[0])
	{
	case MN_SELECTED:
		menuManager(message[4], message[3], kstate);
		break;
	case AP_TERM:
		quitProg = TRUE;
		break;
	}
	return TRUE;
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

LOCAL _VOID GetTempPath(_VOID)
{
	_BOOL tmpAvail;
	CONST _UBYTE *env;
	
	tmpAvail = FALSE;
	env = getenv("TMP");
	if (env != NULL)
	{
		strBcpy(tmpPath, env);
		tmpAvail = F_Path_Set(tmpPath);
	}
	if (!tmpAvail)
	{
		env = getenv("TMPDIR");
		if (env != NULL)
		{
			strBcpy(tmpPath, env);
			tmpAvail = F_Path_Set(tmpPath);
		}
	}
	if (!tmpAvail)
	{
		/* kein tmp-Pfad vorhanden, Db-Path nehmen */
		strBcpy(tmpPath, DataPath);
	}
	if (!useTmp)
		strBcpy(tmpPath, DataPath);
	if (tmpLock)
		strBcpy(tmpPath, tmpDir);
	if (!F_Path_Set(tmpPath))
		strBcpy(tmpPath, DataPath);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID writeInfo(TEXTFILENO inf)
{
	_UBYTE str[80];
	
	mtTextfiles_WriteLine(inf, "# ");
	mtTextfiles_WriteLine(inf, REPAIR_WHATTEXT);
	mtTextfiles_WriteLn(inf);
	mtTextfiles_WriteLine(inf, "# configuration file");
	mtTextfiles_WriteLn(inf);
	T_Strlftime(str, sizeof(str), "# created %0a %d %m %Y, %H:%M:%S", T_Systime());
	mtTextfiles_WriteLine(inf, str);
	mtTextfiles_WriteLn(inf);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID SaveParameter(CONST _UBYTE *dataPath)
{
	_UBYTE infName[PATH_MAX];

	CatGlobal_busyMouse();

	/* Jetzt noch die anderen Parameter */
	ConfVars_SetConfigBool(cUseTmp, useTmp);
	ConfVars_SetConfigBool(cTmpLock, tmpLock);
	ConfVars_SetConfigString(cTmpDir, tmpDir);
	
	strBcpy(infName, dataPath);
	F_Path_Append(infName, parameterFile);
	
	/* Und jetzt schreiben */
	ConfVars_WriteConfigFile(infName, writeInfo);
	
	MouseArrow();
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID LoadParameter(CONST _UBYTE *dataPath)
{
	_UBYTE name[PATH_MAX];
	_BOOL boolVal;
	_BOOL ok;
	
	CatGlobal_busyMouse();
	
	ConfVars_DeleteAllVars();

	strBcpy(name, dataPath);
	F_Path_Append(name, parameterFile);
	
	ok = ConfVars_ReadConfigFile(name);
	if (!ok)
	{
		strBcpy(name, parameterFile);
		ok = F_Path_Get_User(name, parameterFile);
		if (ok)
			ok = ConfVars_ReadConfigFile(name);
	}
	if (!ok)
	{
		F_Path_Get_Work(name, parameterFile);
		ok = ConfVars_ReadConfigFile(name);
	}
	if (!ok)
	{
		MouseArrow();
		return;
	}
	
	/* Pruefen, wie die Alerts aussehen sollen */
	ConfVars_GetConfDefBool(cAlertsInWindow, &boolVal, FALSE);
	WinDials_AlertsInWindow(boolVal);
	
	ConfVars_GetConfDefBool(cUseTmp, &useTmp, useTmp);
	ConfVars_GetConfDefBool(cTmpLock, &tmpLock, tmpLock);
	ConfVars_GetConfDefStr(cTmpDir, tmpDir, sizeof(tmpDir), tmpDir);
	
	/* Pruefen, ob wir in der Mint-Domain laufen sollen */
	ConfVars_GetConfDefBool(cMiNTDomain, &boolVal, TRUE);
	if (boolVal)
	{
		(_VOID)Pdomain(1);
	} else
	{
		(_VOID)Pdomain(0);
	}
	isMiNTDomain = Pdomain(-1) > 0;
	
	MouseArrow();
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL InitResource(CONST _UBYTE *resourceName)
{
	_UWORD screenColumns;
	_UBYTE rscString[PATH_MAX];
	OBJECT *infoBox;
	OBJECT *wdwIcon;
	_UBYTE nameEnd[20];
	
	/* 80-Zeichen Bildschirm wird verlangt! */
	screenColumns = MaxWidth / CharWidth;
	
	if (screenColumns < 80)
	{
/*DYJ 5.23e Start*/
		mtAlerts_Alert(1, Rsc_WrkString(AL_RESOLUTION));
/*DYJ  Ende; alt:	
		mtAlerts_Alert(1, noLowResAlt);
*/
		return FALSE;
	}
	/* Resource laden und Baumaddressen ermitteln */
/*DYJ 5.21i Start*/
	{
/*DYJ 5.22f Start*/
/*DYJ 5.23e Start*/
		_UBYTE scrap[PATH_MAX],rsrcname[PATH_MAX];
/*DYJ  Ende; alt:	
		_UBYTE nameEnd[20],scrap[PATH_MAX],rsrcname[PATH_MAX];
*/

		CatGlobal_ApplPath(scrap);
		Rsc_EnvLang(scrap,nameEnd);
/*DYJ  Ende; alt:	
		_UBYTE *lang,nameEnd[20],scrap[PATH_MAX],rsrcname[PATH_MAX];
		TEXTFILENO tf;

		CatGlobal_ApplPath(scrap);
		if ((lang = getenv("CAT_LANG")) != NULL && *lang != '\0')
			strCpy(nameEnd,lang);
		else if (mtTextfiles_OpenTextfile(CAT_LANG_FILE, READ, 512, &tf) == GERR_OK)
		{
			mtTextfiles_ReadLine(tf, nameEnd, 5);
			mtTextfiles_CloseTextfile(&tf);
		}
		else
			strCpy(nameEnd,LANGUAGE_DE);
*/
		strCat(nameEnd,RSC_EXT);

		strCpy(rsrcname, CATL_RSC_BASE);
		strCat(rsrcname,nameEnd);

		if(!Rsc_RscInit(scrap,rsrcname))
		{
			sprintf(scrap,"[3][%%P|Konnte %s nicht laden|Could'nt load %s][OK]",rsrcname,rsrcname);
			mtAlerts_Alert(1,scrap);
			return FALSE;
		}
	}
/*DYJ  Ende;*/
/*DYJ 5.23e Start*/
	strCpy(rscString, CATR_RSC_BASE);
	strCat(rscString,nameEnd);
	theRSC = RscLoad(rscString);
/*DYJ  Ende; alt:	
	theRSC = RscLoad(resourceName);
*/
	if (theRSC == NULL)
	{
		F_Path_Get_Work(rscString, resourceName);
		theRSC = RscLoad(rscString);
	}
	if (theRSC == NULL)
	{
/*DYJ 5.21i Start*/
		_UBYTE scrap[100];
		mtAlerts_SetIconColor(RED);
		sprintf(scrap,Rsc_WrkString(AL_NO_RSC),resourceName);
		mtAlerts_Alert(1,scrap );
/*DYJ  Ende; alt:	
		mtAlerts_SetIconColor(RED);
		mtAlerts_Alert(1, noRscAlt);
*/
		mtAlerts_SetIconColor(BLACK);
		return FALSE;
	}
	
	CatGlobal_busyMouse();
	
	menu      = RscGaddr(theRSC, R_TREE, MENU);
	gruppen   = RscGaddr(theRSC, R_TREE, GRUPPEN);
	
	/* Versionsnummer einsetzen */
	infoBox = RscGaddr(theRSC, R_TREE, ABOUT_BOX);
	SetObjcString(infoBox, VERSION, CatVersion);
	SetObjcString(infoBox, DATE, CatDate);
	
	wdwIcon = RscGaddr(theRSC, R_TREE, REPAIR_ICON);
	WdwManager_SetWindowIcon(wdwIcon);
	
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID ClrRsrc(_VOID)
{
	RscFreeLib();	/*DYJ 5.27a */
	if (theRSC)
	{
		RscFree(theRSC);
		theRSC = NULL;
	}
}

/*** ---------------------------------------------------------------------- ***/

/* Lesen von CAT.INF
 * Jetzt wird die entsprechende CAT-Funktion benutzt,
 * und auch die Variablen aus CAT.
 * Zeile 11:    Database-Pfad
 */
LOCAL _BOOL InitRepair(CONST _UBYTE *inf_from_argv)
{
	if (!InitResource(RscName))
		return FALSE;
	
	CatGlobal_busyMouse();
	CatGlobal_SetAppl(ProgramName);
	CatGlobal_GetApplPath(infPath);
	/* Jetzt CAT.INF lesen */
	*infName = '\0';
	*infPath = '\0';
	if (!MTPaths_ReadInf(infPath, infName, FALSE, TRUE, inf_from_argv))
		return FALSE;
	/* Jetzt Gruppen initialisieren */
	F_Path_Set(DataPath);
	LoadParameter(DataPath);
	
	/* suchen nach Environment-Variable TMP oder TEMP */
	GetTempPath();
	
	GroupSelect_ReadGroupList();
	
	MouseArrow();
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

int main(int argc, char *const *argv)
{
	GRECT mrect;
	_WORD moX, moY;
	_WORD kReturn;
	_UWORD kstate;
	_UWORD moButton;
	_WORD moClicks;
	_UBYTE key, scan;
	_UWORD event;
	_WORD message[8];
	_WORD exit_code;
	EVENT e;
	EVNT ev;
	CONST _UBYTE *inf_from_argv;
	
#define helpScan 0x62
	
	inf_from_argv = NULL;
	if (argc > 1)
		inf_from_argv = argv[1];
	
	mrect.g_x = 0;
	mrect.g_y = 0;
	mrect.g_w = 1;
	mrect.g_h = 1;
	
#if SPEC_DEBUG
	is_DEBUGGING = FALSE;
#endif
	ApplInit();
	CatGlobal_Init();
	mtDials_Init();
	
	mtAlerts_ConfigAlert(alert_alticon);       /* mtAlerts konfigurieren */
	mtDials_DialConfig(UseConfig, FALSE); /* mtDials konfigurieren */
	MouseArrow();
	
	Wind_Update(BEG_UPDATE);
	ConfVars_Init();
	WdwManager_Init();
	
	quitProg = FALSE;
	
	if (!InitRepair(inf_from_argv))
	{
		exit_code = 1;
	} else
	{
		CatLog_OpenLog(FALSE);
		WdwManager_EnableIconify(TRUE);
		MouseArrow();
		if (multiTOS || (magIx && magIxVer >= 0x300))
		{
			/* MultiTOS */
			menu_register(gl_apid, REPAIR_MENUNAME);
		}
		menu_register(-1, ProgramName);
		
		{
			_WORD level, dummy;
			
			/* Und auch Bescheid sagen, dass wir AP_TERM verstehen */
			if ((appl_xgetinfo(APG_SHELLW, &level, &dummy, &dummy, &dummy) && ((level & 0xff) >= 9)) ||
				(magIxVer >= 0x300))
			{
				shel_write(9, 1, 1, NULL, NULL);
			}
		}
		
		InitMenuline(menu);
		DrawMenuline(menu);
		
		/* Menubar bei Windowmanager anmelden */
		WdwManager_InstallGlobalMenu(menu, msgHandler);
		
		Wind_Update(END_UPDATE);
		WdwManager_HandlePendingEvents();
		Wind_Update(BEG_UPDATE);
		
		while (!quitProg)
		{
			Wind_Update(END_UPDATE);

			e.ev_mflags = MU_KEYBD | MU_BUTTON | MU_MESAG | MU_M1;
			e.ev_mwich = 0;
			e.ev_mbclicks = 2;
			e.ev_bmask = 1;
			e.ev_mbstate = 1;
			e.ev_mm1flags = 1;
			e.ev_mm1x = mrect.g_x;
			e.ev_mm1y = mrect.g_y;
			e.ev_mm1width = mrect.g_w;
			e.ev_mm1height = mrect.g_h;
			e.ev_mm2flags = 0;
			e.ev_mm2x = 0;
			e.ev_mm2y = 0;
			e.ev_mm2width = 0;
			e.ev_mm2height = 0;
			e.ev_mtlocount = 350;
			e.ev_mthicount = 0;

			if (fnts_func != NULL)
				fnts_func(TRUE, &e);
			if (e.ev_mwich == 0)
			{
				e.ev_mwich = evnt_multi(e.ev_mflags, e.ev_mbclicks, e.ev_bmask, e.ev_mbstate,
					e.ev_mm1flags, e.ev_mm1x, e.ev_mm1y, e.ev_mm1width, e.ev_mm1height,
					e.ev_mm2flags, e.ev_mm2x, e.ev_mm2y, e.ev_mm2width, e.ev_mm2height,
					e.ev_mmgpbuf,
					e.ev_mtlocount, e.ev_mthicount,
					&e.ev_mmox, &e.ev_mmoy, &e.ev_mmobutton, &e.ev_mmokstate, &e.ev_mkreturn, &e.ev_mbreturn);
			}

			event = e.ev_mwich;
			moX = e.ev_mmox;
			moY = e.ev_mmoy;
			moButton = e.ev_mmobutton;
			kstate = e.ev_mmokstate;
			kReturn = e.ev_mkreturn;
			moClicks = e.ev_mbreturn;
			message[0] = e.ev_mmgpbuf[0];
			message[1] = e.ev_mmgpbuf[1];
			message[2] = e.ev_mmgpbuf[2];
			message[3] = e.ev_mmgpbuf[3];
			message[4] = e.ev_mmgpbuf[4];
			message[5] = e.ev_mmgpbuf[5];
			message[6] = e.ev_mmgpbuf[6];
			message[7] = e.ev_mmgpbuf[7];
			
			if (fnts_func != FUNK_NULL)
			{
				ev.mwhich = event;
				ev.mox = moX;
				ev.moy = moY;
				ev.button = moButton;
				ev.state = kstate;
				ev.key = kReturn;
				ev.clicks = moClicks;
				ev.message[0] = message[0];
				ev.message[1] = message[1];
				ev.message[2] = message[2];
				ev.message[3] = message[3];
				ev.message[4] = message[4];
				ev.message[5] = message[5];
				ev.message[6] = message[6];
				ev.message[7] = message[7];
				fnts_func(FALSE, &ev);
				event = (event & ~MU_KEYBD) | (ev.mwhich & MU_KEYBD);
			}

			key = kReturn & 0xff;
			scan = (kReturn >> 8) & 0xff;
			Wind_Update(BEG_UPDATE);
			WdwManager_HandleEvent(&event, message, moButton, kstate, key, scan, kReturn, moX, moY, moClicks);
			if (event & MU_KEYBD)
			{
				if (MenuKey_Test(menu, kReturn, kstate, menuManager, FALSE))
				{
				} else if (scan == helpScan)
				{
					/* PutzHelp_DoHelp(PutzHelp_general); */
				}
			}
			mrect.g_x = moX;
			mrect.g_y = moY;
		}
		exit_code = 0;
		SaveParameter(DataPath);
		ResetMenuline();
		CatLog_CloseLog();
	}
	ConfVars_CloseConfig();
#if DEBUG_ALLOC
	ConfVars_DeleteAllVars();
	GroupSelect_Exit();
	data_CloseBase();
#else
	mem_test_ignore();
#endif
	ClrRsrc();
	Wind_Update(END_UPDATE);
	ApplTerm(exit_code);
	return exit_code;
}
/*** ------------------------------------------------------------------------ ***/
/*	Einige DummyFunktionen														*/
/*																				*/
/*	Parameter:	keine															*/
/*	Ergebnis:	keines															*/		
/*	13.1.02 von Dimitri Junker	DYJ 4.3x										*/
/*** ------------------------------------------------------------------------ ***/

CONST _UBYTE *adr_exist(_WORD nor_alias, _UBYTE *name)
{
	UNUSED(nor_alias);
	UNUSED(name);
	return NULL;
}
_VOID showImport_Open(_ULONG absolute,_UBYTE *txt)
{
	UNUSED(absolute);
	UNUSED(txt);
}
_ULONG showImport_Inq(_ULONG *absolute,_UBYTE *txt,size_t sizeTxt)
{
	UNUSED(absolute);
	UNUSED(txt);
	UNUSED(sizeTxt);
	return 0;
}
_VOID showImport_SetNew(_ULONG newValue)
{
	UNUSED(newValue);
}
_VOID showImport_Close(_VOID)
{
}