/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */


#include <shellcal.h>
#include <tos.h>
#include <catgloba.h>
#include <arcstart.h>
#include <routinec.h>

#include <mtappl.h>
#include <magicsys.h>
#include <routines.h>

typedef _WORD __CDECL (*DOSYS)(CONST _UBYTE *str);

#define ENV_Shell       "SHELL"       /* Name der Shell */

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

LOCAL _WORD system_call(CONST _UBYTE *str)
{
	DOSYS doSys;
	
	if (multiTask)
		return -1;
	doSys = (DOSYS)SysGetLVal(0x4f6);
	if (str == NULL)
	{
		if (doSys != NULL)
			return 0;
		return -1;
	}
	if (doSys != NULL)
		return doSys(str);
	return -1;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID ShellCall_CallShell(CONST _UBYTE *str, _BOOL withRedirection)
{
	_WORD res;
	_UBYTE cmd[256];
	_UBYTE cmd2[256];
	_UBYTE *shell;
	_UBYTE *tosrun;
	
	if (system_call(str) == -1)
	{
		if ((shell = getenv(ENV_Shell)) != NULL)
		{
			strBcpy(cmd, " -c \"");
			strBcat(cmd, str);
			strBcat(cmd, "\"");
			cmd[0] = (_UBYTE)strLen(cmd+1);
			if (withRedirection)
			{
				res = ARCStarter_ExecProgram(shell, cmd, 0);
			} else
			{
				if (*str != '\0')
				{
					strBcpy(cmd, " -c \"");
					strBcat(cmd, str);
					strBcat(cmd, "\"");
				} else
				{
					cmd[0] = cmd[1] = '\0';
				}
				/* Keine IO-Redirection! */
				if (multiTOS && (tosrun = getenv("TOSRUN")) != NULL)
				{
					/* TOSRUN auslesen und Shell darin starten */
					strBcpy(cmd2, " ");
					strBcat(cmd2, shell);
					strBcat(cmd2, cmd);
					cmd2[0] = (_UBYTE)strLen(cmd2 + 1);
					res = shel_write(0, 1, 1, tosrun, cmd2);
				} else if (magIx && magIxVer >= 0x200)
				{
					if (cmd[0] != '\0')
						cmd[0] = (_UBYTE)strLen(cmd + 1);
					/* ShelWrite auf TOS-Programm ausfuehren */
					res = shel_write(1, 0, 100, shell, cmd);
				} else
				{
					if (cmd[0] != '\0')
						cmd[0] = (_UBYTE)strLen(cmd + 1);
					res = ARCStarter_ExecProgram(shell, cmd, ARCSTART_NOREDIRECT);
				}
			}
		} else
		{
			Cconws("\r\nEs ist keine Shell verf\201gbar!");
		}
	}
	UNUSED(res);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL shellType ShellCall_IsShell(_VOID)
{
	if (system_call(NULL) >= 0)
		return shellP;
	if (getenv(ENV_Shell) != NULL)
		return shellProg;
	return noShell;
}
