/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 * 29.10.02 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.16g'
 *	Cat2Maus als Terminalprogramm eingetragen
 *
 * 2.04 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.34b'
 *	Einige Defaulwerte von Konfigurationsvariablen gendert
 */


#include <userinfo.h>
#include <catvers.h>
#include <mtpaths.h>
#include <confvars.h>
#include <varnamel.h>
#include <mtalerts.h>
#include <varn_ede.h>
#include <routinec.h>
#include <routines.h>
#include <cattypes.h>
#include <mtrsc.h>
#include <catlib.h>

#include <file_io.h>


GLOBAL _BOOL batchProcess = FALSE;
GLOBAL UserBlockType UserBLK;
GLOBAL _BOOL isTmp;



	/*
	InfoFileTable = infTableType {'IIE','IIB','IIA','IIG','IIH','IIM','IIL',
	'IIT','IIK','INA','INK','INL','ING','INP',
	'IGT','IGS','IGK','IGL','ISB','ISG'};
	*/

/*** ---------------------------------------------------------------------- ***/

/*DYJ 5.19e */	/*DYJ 5.21b */
GLOBAL _BOOL UserInformation_ReadUserBlock(_VOID)
{
	_UBYTE infFileName[PATH_MAX];
	_UBYTE infFilePath[PATH_MAX],*home;
	GRECT defRect;

	defRect.g_x = 0;
	defRect.g_y = 0;
	defRect.g_w = 80;
	defRect.g_h = 120;

	strCpy(infFilePath, DataPath);
	F_Path_Append(infFilePath, userInffileName);
	ConfVars_ReadConfigFile(infFilePath);
	if(ConfVars_GetConfigString(cCatUserHome, infFileName, sizeof(infFileName)))
	{
		if((home=getenv("HOME"))!=NULL)
		{
			strCpy(infFilePath, home);
			F_Path_Append(infFilePath, infFileName);
			ConfVars_ReadConfigFile(infFilePath);
		}
	}
	ConfVars_GetConfDefBool(cMakeInfileAfterImport, &UserBLK.MakeInfileAfterImport, TRUE);
	ConfVars_GetConfDefBool(cMakeInfileAtEnd, &UserBLK.MakeInfileAtEnd, FALSE);
	ConfVars_GetConfDefBool(cWordWrap, &UserBLK.Umbruch, TRUE);
	ConfVars_GetConfDefBool(cDeleteAfterImport, &UserBLK.DeleteAfterImport, FALSE);
/*DYJ 5.34b Start*/
	ConfVars_GetConfDefBool(cDeleteBeforeTerm, &UserBLK.DeleteBeforeTerm, TRUE);
	ConfVars_GetConfDefBool(cAutoSaveOptions, &UserBLK.AutoSaveOptions, FALSE);
	ConfVars_GetConfDefBool(cImportAtStart, &UserBLK.ImportAtStart, FALSE);
	ConfVars_GetConfDefBool(cImportAfterTermPrg, &UserBLK.ImportAfterTermPrg, TRUE);
/*DYJ  Ende; alt:	
	ConfVars_GetConfDefBool(cDeleteBeforeTerm, &UserBLK.DeleteBeforeTerm, FALSE);
	ConfVars_GetConfDefBool(cAutoSaveOptions, &UserBLK.AutoSaveOptions, FALSE);
	ConfVars_GetConfDefBool(cImportAtStart, &UserBLK.ImportAtStart, FALSE);
	ConfVars_GetConfDefBool(cImportAfterTermPrg, &UserBLK.ImportAfterTermPrg, FALSE);
*/
	ConfVars_GetConfDefBool(cStartTermAtStart, &UserBLK.StartTermAtStart, FALSE);
	ConfVars_GetConfDefBool(cMakeInfileBeforeTerminal, &UserBLK.MakeInfileBeforeTerminal, TRUE);
	ConfVars_GetConfDefBool(cTerminalAsOverlay, &UserBLK.TerminalAsOverlay, FALSE);
	ConfVars_GetConfDefBool(cConvertDiaresis, &UserBLK.ConvertDiaresis, FALSE);
	ConfVars_GetConfDefBool(cAutoUndo, &UserBLK.AutoUndo, TRUE);
	ConfVars_GetConfDefBool(cInfofilesReadOnly, &UserBLK.InfofilesReadOnly, FALSE);

/*DYJ 5.34b Start*/
	ConfVars_GetConfDefBool(cIgnoreRead, &UserBLK.ignoreRead, TRUE);
/*DYJ  Ende; alt:	
	ConfVars_GetConfDefBool(cIgnoreRead, &UserBLK.ignoreRead, FALSE);
*/

	ConfVars_GetConfDefRect(cButtonWindowPos, &UserBLK.buttonW, &defRect);

	ConfVars_GetConfDefInt(cRightMargin, &UserBLK.RightMargin, 79);
	ConfVars_GetConfDefInt(cWaitingTime, &UserBLK.WaitingTime, 100);

	ConfVars_GetConfDefStr(cUserString1, UserBLK.UserString1, sizeof(UserBLK.UserString1), Rsc_WrkString(eg));
	ConfVars_GetConfDefStr(cUserString2, UserBLK.UserString2, sizeof(UserBLK.UserString2), Rsc_WrkString(em));
	
	/*
	FOR i = iie TO MAX(infType) DO
	ConfVars_GetConfDefBool(InfoFileTable[i], INF[i], FALSE);
	END;
	*/

	ConfVars_GetConfDefBool(cRequestInfofiles, &UserBLK.RequestInfofiles, TRUE);
	ConfVars_GetConfDefBool(cMessagesInInfile, &UserBLK.MessagesInInfile, TRUE);
	ConfVars_GetConfDefBool(cGroupChangesInInfile, &UserBLK.GroupChangesInInfile, TRUE);
	ConfVars_GetConfDefBool(cStatusMessagesInInfile, &UserBLK.StatusMessagesInInfile, TRUE);
	
	ConfVars_GetConfDefBool(cInitialQuote, &UserBLK.InitialQuote, FALSE);
	ConfVars_GetConfDefBool(cBlkAftQuote, &UserBLK.BlkAftQuote, FALSE);
	ConfVars_GetConfDefBool(cSillyChecks, &UserBLK.SillyChecks, TRUE);

/*DYJ 5.34h Start*/
	ConfVars_GetConfDefStr(cReferenceLine1, UserBLK.ReferenceLine1, sizeof(UserBLK.ReferenceLine1), Rsc_WrkString(DEF_REFLINE1));
	ConfVars_GetConfDefStr(cReferenceLine1M, UserBLK.ReferenceLine1M, sizeof(UserBLK.ReferenceLine1M),UserBLK.ReferenceLine1);
	ConfVars_GetConfDefStr(cReferenceLine2, UserBLK.ReferenceLine2, sizeof(UserBLK.ReferenceLine2), "'In Msg 'M, U' wrote:'");
	ConfVars_GetConfDefStr(cWWVerkettung, UserBLK.WWVerkettung, sizeof(UserBLK.WWVerkettung), Rsc_WrkString(DEF_WWV));
/*DYJ  Ende; alt:	
	ConfVars_GetConfDefStr(cReferenceLine1, UserBLK.ReferenceLine1, sizeof(UserBLK.ReferenceLine1), "U' schrieb am 'A' in der Msg 'M'(Gruppe 'G'):'");	/* :language: */
	ConfVars_GetConfDefStr(cReferenceLine1M, UserBLK.ReferenceLine1M, sizeof(UserBLK.ReferenceLine1M),UserBLK.ReferenceLine1);
	ConfVars_GetConfDefStr(cReferenceLine2, UserBLK.ReferenceLine2, sizeof(UserBLK.ReferenceLine2), "'In Msg 'M, U' wrote:'");
	ConfVars_GetConfDefStr(cWWVerkettung, UserBLK.WWVerkettung, sizeof(UserBLK.WWVerkettung), "'Kommentar zu 'M' in der Gruppe 'G");/* :language: */
*/

	ConfVars_GetConfDefBool(cWatchBox, &UserBLK.watchBox, FALSE);

	ConfVars_GetConfDefBool(cSortGroups, &UserBLK.sortGroups, TRUE);
	ConfVars_GetConfDefBool(cRedirectPacker, &UserBLK.RedirectPacker, TRUE);
	ConfVars_GetConfDefBool(cShowLineEnds, &UserBLK.ShowLineEnds, TRUE);
	ConfVars_GetConfDefBool(cAutomaticSplit, &UserBLK.AutomaticSplit, FALSE);
/*DYJ 5.34b Start*/
	ConfVars_GetConfDefBool(cSendParagraphs, &UserBLK.endlessLines, !UserBLK.isInternet);
/*DYJ  Ende; alt:	
	ConfVars_GetConfDefBool(cSendParagraphs, &UserBLK.endlessLines, TRUE);
*/

	ConfVars_GetConfDefBool(cIgnoreFiltered, &UserBLK.ignoreFiltered, TRUE);
	ConfVars_GetConfDefInt(cMimeTextMode, &UserBLK.MimeTextMode, 2);	/*DYJ 5.33b */

	ConfVars_GetConfDefInt(cTabSize, &UserBLK.TabSize, 4);
	if (UserBLK.TabSize <= 0)
		UserBLK.TabSize = 4;
	ConfVars_GetConfDefLongInt(cSplitSize, &UserBLK.splitSize, 14336);
	if (UserBLK.splitSize < 0)
		UserBLK.splitSize = 14336;

	ConfVars_GetConfDefBool(cMessageDateInInfile, &UserBLK.MessageDateInInfile, TRUE);
	if(PrgHasDataBase)		/*DYJ 5.26a */
	UserInformation_chkTerm();
	UserBLK.StatusMessagesInInfile&=!UserBLK.isInternet;
	UserBLK.AutomaticSplit&=!UserBLK.isInternet;
	if(UserBLK.isInternet)
		UserBLK.splitSize =0;
	return TRUE;
}
/*** ------------------------------------------------------------------------ ***/
/*	_VOID UserInformation_chkTerm(_VOID)										*/
/*	Versucht aus dem Terminalnamen zu ermitteln ob es eine Maus oder Internet	*/
/*	Anwendung ist																*/
/*	Parameter:	keine															*/
/*	Ergebnis:	keines															*/		
/*	21.12.01 von Dimitri Junker	DYJ 4.30r										*/
/*** ------------------------------------------------------------------------ ***/
/*DYJ 5.16g */	/*DYJ 5.21b */
GLOBAL _VOID UserInformation_chkTerm(_VOID)
{
	char* pkt;
	_BOOL delCV=TRUE;
	pkt=strChr(TerminalName,'.');
	if(pkt)
		*pkt='\0';
	if(!strSortCmp(TerminalName,"in2cat"))
		UserBLK.isInternet=TRUE;
	else if(!strSortCmp(TerminalName,"connect"))
		UserBLK.isInternet=FALSE;
	else if(!strSortCmp(TerminalName,"rufus"))
		UserBLK.isInternet=FALSE;
	else if(!strSortCmp(TerminalName,"starcall"))
		UserBLK.isInternet=FALSE;
	else if(!strSortCmp(TerminalName,"cat2maus"))
		UserBLK.isInternet=FALSE;
	else 
	{
		delCV=FALSE;
		if(!ConfVars_GetConfigBool(cIsInternet, &UserBLK.isInternet))
		{
			UserBLK.isInternet=mtAlerts_Alert(1, Rsc_WrkString(AL_MAUS_IN))-1;
			ConfVars_SetConfigBool(cIsInternet, UserBLK.isInternet);
		}
	}
	if(delCV)
		ConfVars_DeleteConfigVar(cIsInternet);
	if(pkt)
		*pkt='.';

}
/*DYJ  Ende;*/

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID UserInformation_writeInfo(TEXTFILENO inf)
{
	_UBYTE tstr[80];
	
	mtTextfiles_WriteLine(inf, "# ");
	mtTextfiles_WriteLine(inf, CAT_WHATTEXT);
	mtTextfiles_WriteLn(inf);
	if (isTmp)
		mtTextfiles_WriteLine(inf, "# temporary configuration file");
	else
		mtTextfiles_WriteLine(inf, "# configuration file");
	mtTextfiles_WriteLn(inf);
	T_Strlftime(tstr, sizeof(tstr), "# created %0a %d %m %Y, %H:%M:%S", T_Systime());
	mtTextfiles_WriteLine(inf, tstr);
	mtTextfiles_WriteLn(inf);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID UserInformation_WriteUserBlock(_VOID)
{
	_UBYTE path[PATH_MAX]="";
	_UBYTE infFileName[PATH_MAX],*home;
	if (MTPaths_DatabaseLocked())
	{
		if(ConfVars_GetConfigString(cCatUserHome, infFileName, sizeof(infFileName)))
		{
			if((home=getenv("HOME"))!=NULL)
			{
				strCpy(path, home);
				F_Path_Append(path, infFileName);
			}
		}
		if(!*path)
		{
			strCpy(path, DataPath);
			F_Path_Append(path, userInffileName);
		}
		isTmp = FALSE;
		ConfVars_WriteConfigFile(path, UserInformation_writeInfo);
	}
}
