/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 *
 * 6.4.03 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.24i'
 *	Einige Menpunkte im Internetmodus deaktiviert
 */


#include <vdistand.h>
#include <mte.h>
#include <wdwmanag.h>
#include <editor.h>
#include <grin.h>
#include <clip.h>
#include <catgloba.h>
#include <msgwindo.h>
#include <msglist.h>
#include <treelist.h>
#include <maustaus.h>

#include <mtdials.h>
#include <mtutils.h>
#include <mtappl.h>
#include <mtxobjec.h>
#include <routines.h>
#include <userinfo.h>

LOCAL OBJECT *menu;

#define FS_EDITOR  "Editor...  "
#define FS_MESSAGE "Anzeige... "

/*** ---------------------------------------------------------------------- ***/

GLOBAL _BOOL VDIStandards_InitVDIStandards(_VOID)
{
	menu = TreeAddr[MENU];
	return TRUE;
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

GLOBAL _VOID VDIStandards_SetSpec(OBJECT *tree, _WORD Item, _VOID *newSpec)
{
	tree[Item].ob_spec.free_string = newSpec;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID EnableItem(OBJECT *tree, _WORD item, _BOOL enable)
{
	if (enable)
	{
		if (GetObjState(tree, item, DISABLED))
			menu_ienable(tree, item, 1);
	} else
	{
		if (!GetObjState(tree, item, DISABLED))
			menu_ienable(tree, item, 0);
	}
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID VDIStandards_CheckItem(OBJECT *tree, _WORD item, _BOOL enable)
{
	if (enable)
	{
		if (!GetObjState(tree, item, CHECKED))
			menu_icheck(tree, item, 1);
	} else
	{
		if (GetObjState(tree, item, CHECKED))
			menu_icheck(tree, item, 0);
	}
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID VDIStandards_StatusEnable(_BOOL yep)
{
	EnableItem(menu, TMSAGAIN, yep);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID SetStr(_UBYTE *str, CONST _UBYTE *s2)
{
	_WORD i, init, max;

	init = 0;
	while (str[init] == ' ')
		++init;
	max = Min((_WORD)strLen(str), (_WORD)(init + strLen(s2)));
	for (i = init; i < max; i++)
		str[i] = s2[i - init];
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID VDIStandards_enableMenuItems(HWND wdw)
{
	_BOOL clipDa;
	_BOOL bl, isTop, isMsg, isEdit, isWriteEdit, isList;
	_BOOL qBlock, infoLine, moreWinds, isSel;
	_BOOL isIcon, isTree, topNext;
	_BOOL bt;
	HWND botWdw;
	_UBYTE mStr[40];

	clipDa = Clip_SomethingInScrap();
	isMsg = grin_grinWindowTop(wdw);
	isList = msgList_listWindowTop(wdw);
	isTree = treeList_treeWindowTop(wdw);
	isEdit = !isMsg && Editor_IsEditTop(wdw);
	isWriteEdit = isEdit && !Editor_GetMode(wdw, roMode);
	isTop = isMsg || isEdit;
	if (isTop)
		bl = Editor_BlockIsMarked(wdw);
	else if (isList)
		bl = msgList_listSomethingSelected(wdw);
	else
		bl = FALSE;
	isSel = MsgWindow_msgWindowTop(wdw);
	bt=(isTree && treeList_listSomethingSelected(wdw));
	moreWinds = WdwManager_GetSecondWdw(&botWdw);
	if (!moreWinds)
		botWdw = -1;
	isIcon = WdwManager_WindowIsIcon(wdw);
	topNext = WdwManager_TopNextPossible();
	infoLine = !isIcon && isWriteEdit &&
		((Messages_MsgEditorTop(wdw) && Messages_MsgIsPrivate(wdw)) ||
		 (moreWinds && (grin_grinWindowTop(botWdw) || grin_grinOnlyOneWind(&botWdw))));
	if (moreWinds)
		qBlock = !isIcon && infoLine && Editor_BlockIsMarked(botWdw);
	else
		qBlock = FALSE;

	EnableItem(menu, TMERGE  , !isIcon && isWriteEdit);
	EnableItem(menu, TCLOSE  , WdwManager_WindowIsCloseable(wdw));
	EnableItem(menu, TSAVE   , !isIcon && isEdit);
	EnableItem(menu, SAVEAS  , !isIcon && (isTop || (isList && bl)||bt));
	EnableItem(menu, TPRINT  , !isIcon && isTop);

	EnableItem(menu, TUNDO   , !isIcon && isTop);
	EnableItem(menu, TSELALL , !isIcon && (isTop || isList || isSel || isTree));
	EnableItem(menu, TCUT    , !isIcon && bl && isWriteEdit);
	EnableItem(menu, TCOPY   , !isIcon && (isTop || (isList && bl)));
	EnableItem(menu, TPASTE  , !isIcon && clipDa && isWriteEdit);
	EnableItem(menu, BLKPROT,  !isIcon && isWriteEdit && bl);
	EnableItem(menu, BLKUPROT, !isIcon && isWriteEdit && bl);
	EnableItem(menu, BLOCKROT, !isIcon && isTop && bl);

	EnableItem(menu, INFOLINE, infoLine);
	EnableItem(menu, WRITEBLO, qBlock);
	EnableItem(menu, TCHFLAG , !isIcon && (isMsg || isList || isTree));
	EnableItem(menu, TSUCHNB , !isIcon && isMsg);

	EnableItem(menu, TMSAGAIN, !isIcon && isMsg);
	EnableItem(menu, TSEARCH , !isIcon && (isMsg || isList));

	EnableItem(menu, FINDREPL, !isIcon && isTop);
	EnableItem(menu, TTSAGAIN, !isIcon && isTop);
	EnableItem(menu, BREPL   , !isIcon && isEdit);

	EnableItem(menu, CYCLEWIN, topNext  );
	EnableItem(menu, WSTACKED, moreWinds);
	EnableItem(menu, WNEBEN  , moreWinds);
	EnableItem(menu, WSTAFFEL, moreWinds);
	EnableItem(menu, WTILED  , moreWinds);
	EnableItem(menu, FULLWIN , WdwManager_WindowIsFullable(wdw));
	EnableItem(menu, EFONT   , !isIcon && (isList || isTop || isSel || isTree));
	EnableItem(menu, OCOLOR  , !isIcon && (isList || isTop || isSel || isTree));
	EnableItem(menu, OEDITOR , !isIcon && isTop);
	EnableItem(menu, TG_ALIAS, !UserBLK.isInternet);
	EnableItem(menu, MGETUSER, !UserBLK.isInternet);
	EnableItem(menu, OCBC   , !UserBLK.isInternet);		/*DYJ 5.32b */

	/* Jetzt String noch anpassen fuer Oeditor */
	if (isTop)
	{
		ObjcString(menu, OEDITOR, mStr, sizeof(mStr));
		if (isEdit)
			SetStr(mStr, FS_EDITOR);
		else if (isMsg)
			SetStr(mStr, FS_MESSAGE);
		menu_text(menu, OEDITOR, mStr);
	}
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID VDIStandards_enableNewTop(HWND wdw)
{
	_BOOL isEdit;

	isEdit = !grin_grinWindowTop(wdw) && Editor_IsEditTop(wdw)
		&& !Editor_GetMode(wdw, roMode);
	EnableItem(menu, TPASTE, isEdit && Clip_ScrapDirty());
	VDIStandards_StatusEnable(grin_grinWindowTop(wdw));
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID VDIStandards_enableOrDisableMenu(_BOOL disable)
{
	WdwManager_DisableMenu(menu, disable);
}
