/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */


#include <vdiutil.h>
#include <mtutils.h>
#include <windials.h>
#include <wdwmanag.h>
#include <fontsele.h>
#ifndef __PORTVDI_H__
#include <portvdi.h>
#endif
#include <convert.h>
#include <strconv.h>
#include <limits.h>
#include <routines.h>

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID VDIUtil_SetObjColor(OBJECT *tree, _WORD ob, _WORD foreground, _WORD background)
{
	foreground &= 0x0f;
	background &= 0x0f;
	switch (tree[ob].ob_type & 0xff)
	{
	case G_BOX:
	case G_IBOX:
	case G_BOXCHAR:	/* Boxinfo-Struktur */
		OBSPEC_SET_FRAMECOL(tree[ob].ob_spec, foreground);
		OBSPEC_SET_TEXTCOL(tree[ob].ob_spec, foreground);
		if (background == WHITE && (tree[ob].ob_flags & FL3DMASK) == FL3DBAK)
			OBSPEC_SET_FILLPATTERN(tree[ob].ob_spec, IP_HOLLOW);
		else
			OBSPEC_SET_FILLPATTERN(tree[ob].ob_spec, IP_SOLID);
		OBSPEC_SET_INTERIORCOL(tree[ob].ob_spec, background);
		OBSPEC_SET_TEXTMODE(tree[ob].ob_spec, FALSE);
		break;
	case G_TEXT:
	case G_FTEXT:
	case G_BOXTEXT:
	case G_FBOXTEXT:	/* TEDInfo-Struktur */
		COLSPEC_SET_TEXTCOL(tree[ob].ob_spec.tedinfo->te_color, foreground);
		COLSPEC_SET_FRAMECOL(tree[ob].ob_spec.tedinfo->te_color, foreground);
		if (background == WHITE && (tree[ob].ob_flags & FL3DMASK) == FL3DBAK)
			COLSPEC_SET_FILLPATTERN(tree[ob].ob_spec.tedinfo->te_color, IP_HOLLOW);
		else
			COLSPEC_SET_FILLPATTERN(tree[ob].ob_spec.tedinfo->te_color, IP_SOLID);
		COLSPEC_SET_INTERIORCOL(tree[ob].ob_spec.tedinfo->te_color, background);
		COLSPEC_SET_TEXTMODE(tree[ob].ob_spec.tedinfo->te_color, FALSE);
		break;
	case G_IMAGE:	/* Image-Struktur */
		tree[ob].ob_spec.bitblk->bi_color = foreground;
		break;
	case G_ICON:	/* Icon-Struktur */
		/* Hintergrundfarbe setzen */
		ICOLSPEC_SET_MASKCOL(tree[ob].ob_spec.iconblk->ib_char, background);
		/* Vordergrundfarbe setzen */
		ICOLSPEC_SET_DATACOL(tree[ob].ob_spec.iconblk->ib_char, foreground);
		break;
	case G_CICON:	/* Icon-Struktur */
		/* Hintergrundfarbe setzen */
		ICOLSPEC_SET_MASKCOL(tree[ob].ob_spec.ciconblk->monoblk.ib_char, background);
		/* Vordergrundfarbe setzen */
		ICOLSPEC_SET_DATACOL(tree[ob].ob_spec.ciconblk->monoblk.ib_char, foreground);
		break;
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID setTreeColor(OBJECT *tree, _WORD startOb, _WORD foreground, _WORD background)
{
	_WORD ob;

	ob = tree[startOb].ob_head;
	if (ob >= 0)
	{
		do
		{
			VDIUtil_SetObjColor(tree, ob, foreground, background);
			if (tree[ob].ob_head > 0)
				setTreeColor(tree, tree[ob].ob_head, foreground, background);
			ob = tree[ob].ob_next;
		} while (ob != startOb);
	}
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID VDIUtil_SetTreeColor(OBJECT *tree, _WORD foreground, _WORD background)
{
	VDIUtil_SetObjColor(tree, ROOT, foreground, background);
	setTreeColor(tree, ROOT, foreground, background);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID VDIUtil_SetLongIntStr(OBJECT *tree, _WORD obj, _LONG val)
{
	_UBYTE str[20];

	ConvInt(val, 0, str, sizeof(str));
	SetObjcString(tree, obj, str);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _BOOL VDIUtil_GetLongIntStr(OBJECT *tree, _WORD obj, _LONG *val)
{
	_UBYTE str[20];
	_BOOL valid;
	
	ObjcString(tree, obj, str, sizeof(str));
	*val = StrToLInt(str, NULL, &valid);
	return valid;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID VDIUtil_SetIntStr(OBJECT *tree, _WORD obj, _WORD val)
{
	_UBYTE str[20];

	ConvInt(val, 0, str, sizeof(str));
	SetObjcString(tree, obj, str);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _BOOL VDIUtil_GetIntStr(OBJECT *tree, _WORD obj, _WORD *val)
{
	_LONG lval;
	_UBYTE str[20];
	_BOOL valid;
	
	ObjcString(tree, obj, str, sizeof(str));
	lval = StrToLInt(str, NULL, &valid);
	if (!valid)
		lval = 0;
	else if (lval > INT_MAX)
		lval = INT_MAX;
	else if (lval < INT_MIN)
		lval = INT_MIN;
	*val = (_WORD)lval;
	return valid;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID VDIUtil_SetXString(OBJECT *tree, _WORD obj, OBJECT *sTree, _WORD idx)
{
	_UBYTE *str;

	str = ObjcStringAdr(sTree, idx + 1);
	SetObjcString(tree, obj, str);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID VDIUtil_SetXStringAdr(OBJECT *tree, _WORD obj, OBJECT *sTree, _WORD idx)
{
	_UBYTE *str;
	_WORD txtlen, tmplen;
	
	str = ObjcStringAdr(sTree, idx + 1);
	ObjcStrLen(tree, idx + 1, &txtlen, &tmplen);
	SetObjcStringAdr(tree, obj, str, txtlen + 1);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID VDIUtil_SetXState(OBJECT *tree, _WORD obj, _WORD xState)
{
	tree[obj].ob_state = (tree[obj].ob_state & 0xff) | (xState << 8);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _WORD VDIUtil_GetXState(OBJECT *tree, _WORD obj)
{
	return (tree[obj].ob_state >> 8) & 0xff;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _WORD VDIUtil_FormHandle(OBJECT *form)
{
	_WORD exit;

	exit = WinDials_WinDialDo(form, ROOT);
	exit &= 0x7fff;
	DelObjState(form, exit, SELECTED);
	return exit;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _BOOL VDIUtil_isKey(_UWORD *kstate, _UBYTE *scan, _UBYTE *ch)
{
	_WORD message[8];
	_UWORD event, evnt;
	_BOOL doExit;
	_WORD moX, moY;
	_UWORD moButton;
	_WORD kReturn;
	_WORD bReturn;

	/* Hier bei MultiTasking noch eine kleiner EventMulti und ein paar
	 * Events verarbeiten
	 */
	for (;;)
	{
		evnt = evnt_multi(MU_MESAG | MU_KEYBD | MU_TIMER,
			0, 0, 0,
			0, 0, 0, 0, 0,
			0, 0, 0, 0, 0,
			message,
			0, 0,
			&moX, &moY, &moButton, kstate, &kReturn, &bReturn);
		/* Den Timerevent brauchen wir nicht */
		event = evnt;
		event &= ~MU_TIMER;
		doExit = event == 0;
		if (evnt & MU_KEYBD)
		{
			*scan = (kReturn >> 8) & 0xff;
			*ch = kReturn & 0xff;
			/* ESC gedrueckt? */
			doExit |= *ch == 0x1b;
		} else
		{
			*scan = 0;
			*ch = 0;
		}
		if (doExit)
			break;
		Wind_Update(BEG_UPDATE);
		WdwManager_HandleEvent(&evnt, message, moButton, *kstate, *ch, *scan, kReturn, moX, moY, bReturn);
		Wind_Update(END_UPDATE);
	}

	return (evnt & MU_KEYBD) != 0;
}


/*** ---------------------------------------------------------------------- ***/

/* VDI Text Funktionen    */

GLOBAL _VOID VDIUtil_Text(_BOOL isFSM, HVDI hdl, _WORD x, _WORD y, CONST _UBYTE *string)
{
	_WORD len, olen;
	_WORD extent[8];
#define MAX_TEXT_LEN 126
	
	if (string[0] != '\0')
	{
		len = (_WORD)strLen(string);
		if (isFSM)
		{
			while (len != 0)
			{
				olen = len;
				if (olen > MAX_TEXT_LEN)
					olen = MAX_TEXT_LEN;
				v_fntext(hdl, x, y, string, olen);
				len -= olen;
				if (len == 0)
					break;
				vqt_f_nextent(hdl, string, olen, extent);
				string += olen;
				x += extent[2] - extent[0];
			}
		} else
		{
			while (len != 0)
			{
				olen = len;
				if (olen > MAX_TEXT_LEN)
					olen = MAX_TEXT_LEN;
				v_gntext(hdl, x, y, string, olen);
				len -= olen;
				if (len == 0)
					break;
				vqt_nextent(hdl, string, olen, extent);
				string += olen;
				x += extent[2] - extent[0];
			}
		}
	}
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID VDIUtil_NText(_BOOL isFSM, HVDI hdl, _WORD x, _WORD y, CONST _UBYTE *string, _WORD len)
{
	_WORD olen;
	_WORD extent[8];
	
	if (isFSM)
	{
		while (len != 0)
		{
			olen = len;
			if (olen > MAX_TEXT_LEN)
				olen = MAX_TEXT_LEN;
			v_fntext(hdl, x, y, string, olen);
			len -= olen;
			if (len == 0)
				break;
			vqt_f_nextent(hdl, string, olen, extent);
			string += olen;
			x += extent[2] - extent[0];
		}
	} else
	{
		while (len != 0)
		{
			olen = len;
			if (olen > MAX_TEXT_LEN)
				olen = MAX_TEXT_LEN;
			v_gntext(hdl, x, y, string, olen);
			len -= olen;
			if (len == 0)
				break;
			vqt_nextent(hdl, string, olen, extent);
			string += olen;
			x += extent[2] - extent[0];
		}
	}
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _WORD VDIUtil_InqTextextend(_BOOL isFSM, HVDI hdl, CONST _UBYTE *string)
{
	_WORD len, olen;
	_WORD width;
	_WORD extent[8];
	
	width = 0;
	if (string[0] != '\0')
	{
		len = (_WORD)strLen(string);
		if (isFSM)
		{
			while (len != 0)
			{
				olen = len;
				if (olen > MAX_TEXT_LEN)
					olen = MAX_TEXT_LEN;
				vqt_f_nextent(hdl, string, olen, extent);
				string += olen;
				width += extent[2] - extent[0];
				len -= olen;
			}
		} else
		{
			while (len != 0)
			{
				olen = len;
				if (olen > MAX_TEXT_LEN)
					olen = MAX_TEXT_LEN;
				vqt_nextent(hdl, string, olen, extent);
				string += olen;
				width += extent[2] - extent[0];
				len -= olen;
			}
		}
	}
	return width;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _WORD VDIUtil_InqNTextextend(_BOOL isFSM, HVDI hdl, CONST _UBYTE *string, _WORD len)
{
	_WORD olen;
	_WORD width;
	_WORD extent[8];
	
	width = 0;
	if (isFSM)
	{
		while (len != 0)
		{
			olen = len;
			if (olen > MAX_TEXT_LEN)
				olen = MAX_TEXT_LEN;
			vqt_f_nextent(hdl, string, olen, extent);
			string += olen;
			width += extent[2] - extent[0];
			len -= olen;
		}
	} else
	{
		while (len != 0)
		{
			olen = len;
			if (olen > MAX_TEXT_LEN)
				olen = MAX_TEXT_LEN;
			vqt_nextent(hdl, string, olen, extent);
			string += olen;
			width += extent[2] - extent[0];
			len -= olen;
		}
	}
	return width;
}

/*** ---------------------------------------------------------------------- ***/

/* Neue Fontauswahl: Ruft die Dialogbox auf und danach die entsprechende
 * Setzroutine fuer das entsprechende Fenster.
 */
GLOBAL _VOID VDIUtil_SelectFont(HVDI handle, HWND wdw, _BOOL onlyMono, _WORD font, _WORD size)
{
	FONT_ACCEPT_FUNC setFont;
	
	if (WdwManager_AcceptsFonts(wdw, &setFont))
		W_Font_Select(handle, font, size, NULL, (onlyMono ? FS_MONOSPACED_ONLY : 0) | FS_APPLY, setFont, wdw);
}

