/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */


#include <wiedervo.h>
#include <wiederv2.h>
#include <cattypes.h>
#include <data.h>
#include <maustaus.h>
#include <mte.h>
#include <groupsel.h>
#include <catgloba.h>
#include <cathelp.h>
#include <catfiles.h>
#include <convertd.h>
#include <mtpaths.h>
#include <catopts2.h>
#include <grin.h>
#include <quicksor.h>
#include <confvars.h>
#include <varname1.h>
#include <windials.h>
#include <listdl.h>

#include <mtappl.h>
#include <mtutils.h>
#include <portvdi.h>
#include <tos.h>

#include <routinec.h>
#include <s_endian.h>

#include <debug.h>
#include <userinfo.h>
#include <routines.h>
#include <mtrsc.h>

/* Magics fuer Header */
#define resubCatMagic     0x43415457L  /* "CATW"                           */
#define resubVersion      1            /* Versionsnummer der Wiedervorlage */
#define resubVersionMagic 0x0100       /* Versionsmagic                    */



LOCAL HWND wvWindow;
LOCAL _VOID *lastSel;

LOCAL OBJECT *resubForm;
LOCAL OBJECT *menuObj;

LOCAL FILENO fCmtsHdl;
LOCAL _BOOL IsCmtsOpen;
LOCAL _BOOL IsFailure;


/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/


/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

/*----------------------------------------------------------------------
 * Userinterface
 *----------------------------------------------------------------------*/

typedef struct {
	specialButHdler specials[4];
} RESUB;

LOCAL _VOID CalcWidth(_VOID)
{
	_WORD maxLength; 
	_ULONG i;
	_UBYTE str[256];
	GRECT r;

	/* Maximale Breite eines Listeneintrages herausfinden */
	maxLength = 0;
	for (i = 0; i < resubs; i++)
	{
		BuildLine1(&resubArray[i], str, sizeof(str));
		maxLength = Max((_WORD)strLen(str), maxLength);
		BuildLine2(&resubArray[i], str, sizeof(str));
		maxLength = Max((_WORD)strLen(str), maxLength);
		resubArray[i].selected = FALSE;
	}
	
	CalcArea(resubForm, WVBOX, &r);
	maxLength = Max(maxLength * CharWidth, r.g_w);
	
	globalLength = maxLength;
}

/*** ---------------------------------------------------------------------- ***/
	
LOCAL _VOID UpdateButtonWV(_VOID *entry, _VOID *env)
{
	_BOOL oneSel;
	_BOOL changed;
	_ULONG i;
	GRECT r;
	
	UNUSED(entry);
	UNUSED(env);
	/* selektieren Eintrag finden */
	i = 0;
	while (i < resubs && !resubArray[i].selected)
		++i;
	oneSel = i < resubs;
	changed = GetObjState(resubForm, WVDEL, DISABLED);
	
	changed = changed != (!oneSel);
	
	if (changed)
	{
		EnableObjState(resubForm, WVDEL, DISABLED, !oneSel);
		EnableObjState(resubForm, WVREAD, DISABLED, !oneSel);
		EnableObjState(resubForm, WVCHANGE, DISABLED, !oneSel);
		WinDials_WinDialDraw(resubForm, WVDEL, 0, &r, FALSE);
		WinDials_WinDialDraw(resubForm, WVREAD, 0, &r, FALSE);
		WinDials_WinDialDraw(resubForm, WVCHANGE, 0, &r, FALSE);
	}
}

/*** ---------------------------------------------------------------------- ***/

/*DYJ 5.30f Start*/
LOCAL _VOID HelpWV(_WORD obj, _VOID *entry, LISTINFO info, _BOOL *draw, _BOOL *exit,_LONG *lstSel)
/*DYJ  Ende; alt:	
LOCAL _VOID HelpWV(_WORD obj, _VOID *entry, LISTINFO info, _BOOL *draw, _BOOL *exit)
*/
{
	GRECT r;
	
	UNUSED(lstSel);	/*DYJ 5.30f */
	UNUSED(entry);
	UNUSED(info);
	
	if (whichType == WVL)					/* (MH) */
	{
		CatHelp_DoHelp(CatHelp_wvhelp);
	} else
	{
		CatHelp_DoHelp(CatHelp_cmtshelp);
	}
	DelObjState(resubForm, obj, SELECTED);
	WinDials_WinDialDraw(resubForm, obj, 0, &r, FALSE);
	*exit = FALSE;
	*draw = FALSE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL MSGNR getIdNumber(OneGroupHandle ptr, CONST _UBYTE *ID)
{
	UNUSED(ID);
	return data_NumberOfID(ptr, resubArray[currIdx].msgId);
}

/*** ---------------------------------------------------------------------- ***/


/*DYJ 5.30f Start*/
LOCAL _VOID OpenWV(_WORD obj, _VOID *entry, LISTINFO info, _BOOL *draw, _BOOL *exit,_LONG *lstSel)
/*DYJ  Ende; alt:	
LOCAL _VOID OpenWV(_WORD obj, _VOID *entry, LISTINFO info, _BOOL *draw, _BOOL *exit)
*/
{
	_BOOL oneSel;
	_ULONG i;
	CAT_GROUP_NUMBER gruppe;
	GRECT r;
	
	UNUSED(lstSel);	/*DYJ 5.30f */
	UNUSED(entry);
	UNUSED(info);
	/* selektierten Eintrag finden */
	i = 0;
	while (i < resubs && !resubArray[i].selected)
		++i;
	oneSel = i < resubs;
	if (oneSel)
	{
		currIdx = i;
		if (GroupSelect_GroupNumber(resubArray[currIdx].group, &gruppe))
		{
			if (wvWindow > 0)
			{
				if (!grin_grinSwitchToMess(wvWindow, gruppe, getIdNumber, resubArray[currIdx].msgId))
				{
					wvWindow = -1;
					wvWindow = grin_grinOpenWithProc(gruppe, getIdNumber, resubArray[currIdx].msgId, grin_grinNextMess, NULL, mOther);
				}
			} else
			{
				wvWindow = grin_grinOpenWithProc(gruppe, getIdNumber, resubArray[currIdx].msgId, grin_grinNextMess, NULL, mOther);
			}
		}
	}
	DelObjState(resubForm, obj, SELECTED);
	WinDials_WinDialDraw(resubForm, obj, 0, &r, FALSE);
	*exit = FALSE;
	*draw = FALSE;
}

/*** ---------------------------------------------------------------------- ***/

/*DYJ 5.30f Start*/
LOCAL _VOID ChangeWV(_WORD obj, _VOID *entry, LISTINFO info, _BOOL *draw, _BOOL *exit,_LONG *lstSel)
/*DYJ  Ende; alt:	
LOCAL _VOID ChangeWV(_WORD obj, _VOID *entry, LISTINFO info, _BOOL *draw, _BOOL *exit)
*/
{
	_UBYTE theDate[40];
	_BOOL oneSel;
	_ULONG i;
	GRECT r;
	
	UNUSED(lstSel);	/*DYJ 5.30f */
	UNUSED(entry);
	UNUSED(info);
	/* selektierten Eintrag finden */
	i = 0;
	while (i < resubs && !resubArray[i].selected)
		++i;
	oneSel = i < resubs;
	*draw = FALSE;
	if (oneSel)
	{
		T_Strlftime(theDate, sizeof(theDate), "%d.%m.%Y", T_DosToSystime(ConvertDate_PackDate(&resubArray[i].resubDate), 0));
		if (CatOpts2_DatumHolen(TRUE, theDate, sizeof(theDate)))
		{
			ConvertDate_TextToDate(theDate, &resubArray[i].resubDate);
			/* !!! mal meckern wenn das nicht gueltig war */
			listModified = TRUE;
			CalcWidth();
			*draw = TRUE;
			SortResubs(whichType);
		}
	}
	DelObjState(resubForm, obj, SELECTED);
	WinDials_WinDialDraw(resubForm, obj, 0, &r, FALSE);
	*exit = FALSE;
}

/*** ---------------------------------------------------------------------- ***/

/*DYJ 5.30f Start*/
LOCAL _VOID HoldCmts(_WORD obj, _VOID *entry, LISTINFO info, _BOOL *draw, _BOOL *exit,_LONG *lstSel)
/*DYJ  Ende; alt:	
LOCAL _VOID HoldCmts(_WORD obj, _VOID *entry, LISTINFO info, _BOOL *draw, _BOOL *exit)
*/
{
	_BOOL oneSel;
	_ULONG i;
	GRECT r;
	
	UNUSED(lstSel);	/*DYJ 5.30f */
	UNUSED(entry);
	UNUSED(info);
	/* selektierten Eintrag finden */
	i = 0;
	while (i < resubs && !resubArray[i].selected)
		++i;
	oneSel = i < resubs;
	if (oneSel)
	{
		if (resubArray[i].resubDate.day   == 0 &&
		    resubArray[i].resubDate.month == 0 &&
		    resubArray[i].resubDate.year  == 0)
		{
			resubArray[i].resubDate.day   = 99;
		    resubArray[i].resubDate.month = 99;
		    resubArray[i].resubDate.year  = 9999;
		} else
		{
			resubArray[i].resubDate.day   = 0;
		    resubArray[i].resubDate.month = 0;
		    resubArray[i].resubDate.year  = 0;
		}
		listModified = TRUE;
	}
	CalcWidth();
	DelObjState(resubForm, obj, SELECTED);
	WinDials_WinDialDraw(resubForm, obj, 0, &r, FALSE);
	*draw = TRUE;
	*exit = FALSE;
}

/*** ---------------------------------------------------------------------- ***/
/*DYJ 5.21b */
/*DYJ 5.30f Start*/
LOCAL _VOID DeleteWV(_WORD obj, _VOID *entry, LISTINFO info, _BOOL *draw, _BOOL *exit,_LONG *lstSel)
/*DYJ  Ende; alt:	
LOCAL _VOID DeleteWV(_WORD obj, _VOID *entry, LISTINFO info, _BOOL *draw, _BOOL *exit)
*/
{
	_BOOL oneSel;
	_ULONG i;
	GRECT r;
	
	UNUSED(entry);
	UNUSED(info);
	*draw = FALSE;
	/* selektierten Eintrag finden */
	i = 0;
	while (i < resubs && !resubArray[i].selected)
		++i;
	oneSel = i < resubs;
	if (oneSel)
	{
		if (mtAlerts_AlertRSC(1, AL_DEL_RESUB) == 1)
		{
			DeleteEntry(i);
			*lstSel=-1;	/*DYJ 5.30f */
			*draw = TRUE;
			CalcWidth();
		}
	}
	DelObjState(resubForm, obj, SELECTED);
	WinDials_WinDialDraw(resubForm, obj, 0, &r, FALSE);
	*exit = FALSE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID drawResubEntry(_VOID *entry, _VOID *env, _WORD x, _WORD y, _WORD offset, CONST GRECT *pclip)
{
	resubRec *e;
	_UBYTE str[256];
	_UWORD eff;
	_WORD fillcol;
	GRECT fill;
	GRECT clip;
	_BOOL isSel;
	
	UNUSED(offset);
	
	e = entry;
	
	fill.g_x = x;
	fill.g_y = y;
	fill.g_w = fill.g_x + globalLength - 1;
	fill.g_h = fill.g_y + 2 * CharHeight - 1;
	
	clip = *pclip;
	clip.g_w = clip.g_x + clip.g_w - 1;
	clip.g_h = clip.g_y + clip.g_h - 1;
	vs_clip(PrivateWS, TRUE, (_WORD *)&clip);
	
	vswr_mode(PrivateWS, MD_REPLACE);
	fillcol = WHITE;
	isSel = FALSE;
	if (e != NULL && isSelected(entry, env))
	{
		fillcol = BLACK;
		isSel = TRUE;
	}
	MouseOff();
	vsf_color(PrivateWS, fillcol);
	vr_recfl(PrivateWS, (_WORD *)&fill);
	if (e != NULL)
	{
		eff = TXT_NORMAL;

		if (whichType == CMTS &&
			e->resubDate.day   == 99 &&			/* HalteFlag gesetzt */
			e->resubDate.month == 99 &&
			e->resubDate.year  == 9999)
		{
			eff |= TXT_LIGHT;
		}
        if (ConvertDate_PackDate(&e->date) == Tgetdate() ||	/*MH 4.14h*/
            ConvertDate_PackDate(&e->resubDate) == Tgetdate())
		{
			eff |= TXT_THICKENED;
		}
		if (isSel)
		{
			vswr_mode(PrivateWS, MD_XOR);
		}
		
		/* Jetzt hier den String fuer den Gruppennamen zusammenbauen */
		BuildLine1(e, str, sizeof(str));
		
		vst_effects(PrivateWS, eff);
		v_gtext(PrivateWS, x, y, str);
		y += CharHeight;
		
		BuildLine2(e, str, sizeof(str));
		v_gtext(PrivateWS, x, y, str);
		
		vst_effects(PrivateWS, 0);
		vswr_mode(PrivateWS, MD_REPLACE);
	}
	vs_clip(PrivateWS, FALSE, (_WORD *)&clip);
	MouseOn();
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID setAndGetResubValues(OBJECT *tree, _VOID *env, _BOOL set, _WORD exitBut)
{
	_ULONG i;

	UNUSED(tree);
	if (set)
	{
		wvWindow = -1;
		for (i = 0; i < resubs; i++)
			resubArray[i].selected = FALSE;
		EnableObjState(resubForm, WVDEL, DISABLED, TRUE);
		EnableObjState(resubForm, WVREAD, DISABLED, TRUE);
		EnableObjState(resubForm, WVCHANGE, DISABLED, TRUE);
	} else
	{
		if (exitBut != WVCANCEL)
		{
			if (listModified)
				WiederVorlage_SaveResubList(whichType);
		} else
		{
			if (listModified)
			{
				/* Aenderungen verwerfen und einfach neu laden */
				WiederVorlage_ReadResubList(whichType);
			}
		}
		SFREE(env);
 
 		EnableObjState(menuObj, TRESUB, DISABLED, FALSE);
 		EnableObjState(menuObj, TCMTS, DISABLED, FALSE);
	}
}

/*** ---------------------------------------------------------------------- ***/
/*DYJ 5.21b */
GLOBAL _VOID WiederVorlage_SelectResub(_WORD modus)
{
	ldHandler dialHandler;
	RESUB *resub;
	
	/* Modullokales Flag setzen, wenn geoeffnet werden soll (MH) */
 	whichType = modus;
 
	/* Liste wieder freigeben und je nach Typ oeffnen (MH) */
	WiederVorlage_ReadResubList(modus);
	SortResubs(modus);
 	
	/* Jetzt das Object zusammenbauen */
 	menuObj = TreeAddr[MENU];
	resubForm = TreeAddr[WVFORM];
	MausTauschrsc_AdjustDialogSize(resubForm, WVFORM);
 	
 	if (whichType == WVL)
 	{
 		EnableObjState(menuObj, TRESUB, DISABLED, FALSE);
 		EnableObjState(menuObj, TCMTS, DISABLED, TRUE);
 		SetObjcString(resubForm, WVTEXT, MausTauschrsc_WrkString(FS_WVL));
 	} else
 	{
 		EnableObjState(menuObj, TRESUB, DISABLED, TRUE);
 		EnableObjState(menuObj, TCMTS, DISABLED, FALSE);
 		SetObjcString(resubForm, WVTEXT, MausTauschrsc_WrkString(FS_CMTS));
 	}
	
	if (WinDials_IsWinDial(resubForm) >= 0)
	{
		/* Fenster toppen und rausgehen */
		WinDials_ActivateWinDial(resubForm);
		return;
	}
	resub = NEW(RESUB, "SelectResub");
	if (resub == NULL)
		return;
	
	CalcWidth();
	
	/* specials bestimmen */
	if (whichType == WVL)
	{
		resub->specials[0].objc = WVCHANGE;
		resub->specials[0].proc = ChangeWV;
 		SetObjcString(resubForm, WVCHANGE, MausTauschrsc_WrkString(BUT_WVL));
	} else
	{
		resub->specials[0].objc = WVCHANGE;
		resub->specials[0].proc = HoldCmts;
 		SetObjcString(resubForm, WVCHANGE, MausTauschrsc_WrkString(BUT_CMTS));
	}
	resub->specials[1].objc = WVDEL;
	resub->specials[1].proc = DeleteWV;
	resub->specials[2].objc = WVHELP;
	resub->specials[2].proc = HelpWV;
	resub->specials[3].objc = WVREAD;
	resub->specials[3].proc = OpenWV;
	
	EnableObjState(resubForm, WVDEL, DISABLED, TRUE);
	EnableObjState(resubForm, WVREAD, DISABLED, TRUE);
	EnableObjState(resubForm, WVCHANGE, DISABLED, TRUE);
	
	/* WindowDialog vorbereiten */
	ListDl_BuildLdHandler(resubArray,
		ResetResubs,
		NextEntry,
		PrevEntry,
		CountEntries,
		isEnabled,
		selEntry,
		resubToStr,
		isSelected,
		drawResubEntry,
		FUNK_NULL,
		0, 2 * CharHeight,
		8, globalLength,
		&dialHandler);
	/* ListWinDialog oeffnen */
	if (ListDl_WinListDial(resubForm, ldSelect | ldArrows | ldDoubleExit,
		&dialHandler,
		WVBOX,
		WVBACK,
		WVOK,
		WVCANCEL,
		resub,
		WVREAD,
		-1,
		UpdateButtonWV,
		resub->specials,
		4,
		ListDl_dummyCheckExit,
		setAndGetResubValues,
		setAndGetResubValues,
		&lastSel))
	{
	}
}

/*** ---------------------------------------------------------------------- ***/

/*DYJ 5.00b */
GLOBAL _VOID WiederVorlage_AddResub(CONST _UBYTE *group, CONST _UBYTE *msgId, CONST _UBYTE *from, CONST _UBYTE *topic, CATDATE tDate,_UBYTE *eZeitX)
{
	Date dt, rsDate;
	GRECT r;
	Time ti;
	_UBYTE theDate[40];
	F_TIME t;
	_UWORD dDt, dTi;
	
	/* Wenn die WV-Datei nicht geoeffnet ist, dann nun oeffnen (MH) */
	if (whichType == CMTS)
	{
		WiederVorlage_ReadResubList(WVL);
		SortResubs(WVL);
	}
	
	/* Datum konvertieren */
	ConvertDate_CatDate2Datim(tDate,eZeitX, &t);
	T_SysToDostime(T_Mktime(&t), &dDt, &dTi);
	dt = ConvertDate_UnpackDate(dDt);
	ti = ConvertDate_UnpackTime(dTi);
	
	theDate[0] = '\0';
	if (CatOpts2_DatumHolen(TRUE, theDate, sizeof(theDate)))
	{
		ConvertDate_TextToDate(theDate, &rsDate);
		if (!MakeNewResubArray(FALSE, 0))
			return;
		/* Jetzt Eintrag setzen */
		if (MakeEntry(&resubArray[resubs], group, msgId, from, topic, &dt, &ti, &rsDate))
		{
			++resubs;
			SortResubs(WVL);
			WiederVorlage_SaveResubList(WVL);	/* Nur fuer die WV gueltig (MH) */
		}
		
		/* Falls der Dialog dargestellt wird, dann updaten (MH) */
		if (WinDials_IsWinDial(resubForm) >= 0 && whichType == WVL)
		{
			CalcArea(resubForm, WVBOX, &r);
			WinDials_WinDialDraw(resubForm, WVBOX, 1, &r, TRUE);
		}
	}
	
	/* Kommentar-Datei wieder einlesen (MH) */
	if (whichType == CMTS)
	{
		WiederVorlage_ReadResubList(CMTS);
		SortResubs(CMTS);
	}
}

/*** ---------------------------------------------------------------------- ***/

/*DYJ 5.21b */
GLOBAL _VOID WiederVorlage_CheckForResub(_VOID)
{
	_UWORD today;
	_UWORD checkDate;
	_ULONG i, count;
	CAT_GROUP_NUMBER gruppe;
	_UBYTE tmp[20]="";
	_UBYTE alertStr[512];
	Date lastDate;
	_UBYTE todayStr[20];
	_BOOL readFromFile;
	_UBYTE fname[PATH_MAX];

	checkDate=today = Tgetdate();
	T_Strlftime(todayStr, sizeof(todayStr), "%d.%m.%Y", T_DosToSystime(today, 0));
	ConfVars_GetConfDefBool(cSaveLastResubDate2File, &readFromFile,!UserBLK.AutoSaveOptions);
	if(readFromFile)
	{
		TEXTFILENO tf;

		strBcpy(fname, DataPath);
		F_Path_Append(fname, resubDateName);
		if (mtTextfiles_OpenTextfile(fname, READ, 512, &tf) == GERR_OK)
		{
			mtTextfiles_ReadLine(tf, tmp, sizeof(tmp));
			mtTextfiles_CloseTextfile(&tf);
		}
		else
			*tmp='\0';
	}
	if (!*tmp && !ConfVars_GetConfigString(cLastResubmissionDate, tmp, sizeof(tmp)))
		*tmp='\0';
	
	if (*tmp)
	{
		if (!strCmp(tmp,todayStr))
			return;
		if (ConvertDate_TextToDate(tmp, &lastDate))
			checkDate = ConvertDate_PackDate(&lastDate);
	}

	if (whichType != WVL)				/* Alte Datei wieder laden */
	{
		WiederVorlage_ReadResubList(WVL);
		SortResubs(WVL);
		whichType = WVL;
	}

	/* Datum abspeichern */
	if(readFromFile)
	{
		TEXTFILENO tf;
		if (mtTextfiles_OpenTextfile(fname, WRITE, 512, &tf) == GERR_OK)
		{
			mtTextfiles_WriteLine(tf, todayStr);
			mtTextfiles_CloseTextfile(&tf);
		}
	}
	ConfVars_SetConfigString(cLastResubmissionDate, todayStr);
	/* Jetzt pruefen */
	count = 0;
	for (i = 0; i < resubs; i++)
	{
		if (ConvertDate_PackDate(&resubArray[i].resubDate) > checkDate &&
			ConvertDate_PackDate(&resubArray[i].resubDate) <=  today)
		{
			if (count == 0)
				currIdx = i;
			++count;
		}
	}
	if (count > 0)
	{
		sprintf(alertStr, MausTauschrsc_WrkString(AL_DO_RESUB),
			MausTauschrsc_WrkString(count == 1 ? FS_SINGULAR1 : FS_PLURAL2),
			count,
			count == 1 ? "" : MausTauschrsc_WrkString(FS_PLURAL1));
		if (mtAlerts_Alert(1, alertStr) == 1)
		{
			/* Selektierten Eintrag oeffnen */
			if (GroupSelect_GroupNumber(resubArray[currIdx].group, &gruppe))
			{
				grin_grinOpenWithProc(gruppe, getIdNumber, resubArray[currIdx].msgId, grin_grinNextMess, 0, mOther);
			}
		}
	}
}


/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

/*----------------------------------------------------------------------
 * Routinen fr Kommentare auf eigene Nachrichten (MH)
 *----------------------------------------------------------------------*/

GLOBAL _VOID WiederVorlage_InitCmts(_VOID)
{
	IsCmtsOpen = FALSE;
	IsFailure = FALSE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL openCmts(_VOID)
{
	_UBYTE fname[PATH_MAX];
	FileHeaderType dbHdr;
	_ULONG size;
	_BOOL exists;
	
	strBcpy(fname, DataPath);
	F_Path_Append(fname, cmtsDataName);

	size = CatFiles_FileSize(fname, &exists);
	if (exists && size > 0)
	{
		SPEC_DEBUG_OUT((EO_DEBUG, "(exists && size > 0) == TRUE"));
		fCmtsHdl = CatFiles_OpenFile(fname, CatFiles_readWrite);
		if (FILENO_OK(fCmtsHdl))
		{
			if (CatFiles_ReadDbHeader(fCmtsHdl, &dbHdr) != NoError)
			{
				CatFiles_CloseFile(fCmtsHdl);
				IsFailure = TRUE;
				return FALSE;
			}
			/* Jetzt Ueberpruefen des Headers */
			if (dbHdr.CatMagic != resubCatMagic ||
				dbHdr.Version  != resubVersion ||
				dbHdr.VersionMagic != resubVersionMagic)
			{
				/* Abbrechen */
				SPEC_DEBUG_OUT((EO_DEBUG, "Invalid header"));
				CatFiles_CloseFile(fCmtsHdl);
				IsFailure = TRUE;
				return FALSE;
			}
			Fseek(0L, fCmtsHdl, SEEK_END);		/* Immer anhaengen */
			IsCmtsOpen = TRUE;
			SPEC_DEBUG_OUT((EO_DEBUG, "IsCmtsOpen = TRUE -> EOR openCmts()"));
			return TRUE;
		}
	} else
	{
		/* Neues Binaerfile schreiben */
		fCmtsHdl = CatFiles_CreateFile(fname);
		if (FILENO_OK(fCmtsHdl))
		{
			SPEC_DEBUG_OUT((EO_DEBUG, "CatFiles_CreateFile(fname) == TRUE"));
			/* Header schreiben */
			dbHdr.CatMagic = h2nl(resubCatMagic);
			dbHdr.Version  = h2ns(resubVersion);
			dbHdr.VersionMagic = h2ns(resubVersionMagic);
			if (CatFiles_WriteMuch(dbHeaderLength, fCmtsHdl, &dbHdr) != NoError)
			{
				SPEC_DEBUG_OUT((EO_DEBUG, "CatFiles_WriteMuch() != NoError"));
				CatFiles_CloseFile(fCmtsHdl);
				IsFailure = TRUE;
				return FALSE;
			}
			IsCmtsOpen = TRUE;
			SPEC_DEBUG_OUT((EO_DEBUG, "openCmts() == TRUE"));
			return TRUE;
		}
	}
	SPEC_DEBUG_OUT((EO_DEBUG, "openCmts() == FALSE"));
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID WiederVorlage_CloseCmts(_VOID)
{
	if (IsCmtsOpen)
	{
		SPEC_DEBUG_OUT((EO_DEBUG, "CatFiles_CloseFile(fCmtsHdl)"));
		CatFiles_CloseFile(fCmtsHdl);
		IsCmtsOpen = FALSE;
	}
}

/*** ---------------------------------------------------------------------- ***/
/*DYJ 5.23e */
GLOBAL _BOOL WiederVorlage_WriteCmts(PtrRecord *data)
{
	resubRec cmtsRec;
	_UWORD today;
	_UWORD now;
	Date dt;
	Time ti;
	Date holdFlag;
	_UBYTE *pGruppe,*pId,*pVon,*pWegen,gruppePers[20],leer[]="";
	strCpy(gruppePers,Rsc_WrkString(GRP_PRIVATE));

	if (IsFailure)			/* Fehler beim Oeffnen der Datei -> gleich wieder raus hier */
	{
		SPEC_DEBUG_OUT((EO_DEBUG, "IsFailure == TRUE"));
		return FALSE;
	}
	
	if (!IsCmtsOpen && !openCmts())
	{
		SPEC_DEBUG_OUT((EO_DEBUG, "!IsCmtsOpen && !openCmts()"));
		return FALSE;
	}
	
	/* Aktuelles Datum/aktuelle Zeit einsetzen */
	today = Tgetdate();
	now = Tgettime();
	dt = ConvertDate_UnpackDate(today);
	ti = ConvertDate_UnpackTime(now);
	holdFlag.day = 0;
	holdFlag.month = 0;
	holdFlag.year = 0;
	
	/* Datensatz schreiben */
	if(data->whatsThere & bGruppe)
		pGruppe=data->pGruppe;
	else
		pGruppe=gruppePers;
	if(data->whatsThere & bId)
		pId=data->pId;
	else
		pId=leer;
	if(data->whatsThere & bVon)
		pVon=data->pVon;
	else
		pVon=leer;
	if(data->whatsThere & bWegen)
		pWegen=data->pWegen;
	else
		pWegen=leer;
	if (MakeEntry(&cmtsRec, pGruppe, pId, pVon, pWegen, &dt, &ti, &holdFlag) &&
		SaveDataEntry(&cmtsRec, fCmtsHdl))
	{
		SFREE(cmtsRec.data);
		return TRUE;
	}
	
	if (cmtsRec.data != NULL)
	{
		SPEC_DEBUG_OUT((EO_DEBUG, "cmtsRec.data != NULL"));
		SFREE(cmtsRec.data);
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/
	
GLOBAL _BOOL WiederVorlage_CleanUpCmts(_ULONG *count)
{
	_ULONG i;
	_WORD HoldDays;
	Date heute;
	_BOOL result;

	*count = 0;

	/* Wenn die CMTS-Datei nicht geoeffnet ist, dann nun oeffnen */
	if (whichType == WVL)
	{
		SPEC_DEBUG_OUT((EO_DEBUG, "whichType == WVL (1)"));
		if (!WiederVorlage_ReadResubList(CMTS))
		{
			return FALSE;
		}
		SortResubs(CMTS);
	}
	
	/* Haltetage holen */
	ConfVars_GetConfDefInt(cCommentEntriesHoldDays, &HoldDays, 1);
	/* Aktuelles Datum ermitteln */
	heute = ConvertDate_UnpackDate(Tgetdate());
	
	for (i = 0; i < resubs; )
	{
	 	/* Tagesdifferenz vergleichen */
		if (ConvertDate_DateToJulian(&heute) - ConvertDate_DateToJulian(&resubArray[i].date) > HoldDays &&
			resubArray[i].resubDate.day   == 0 &&
			resubArray[i].resubDate.month == 0 &&
			resubArray[i].resubDate.year  == 0)
		{
			SPEC_DEBUG_OUT((EO_DEBUG, "DeleteEntry() == TRUE"));
			DeleteEntry(i);
			++(*count);
		} else
		{
			i++;
		}
	}
	
	/* Datei sichern */
	if (!WiederVorlage_SaveResubList(CMTS))
	{
		SPEC_DEBUG_OUT((EO_DEBUG, "WiederVorlage_SaveResubList(CMTS) == FALSE"));
		result = FALSE;
	} else
	{
		SPEC_DEBUG_OUT((EO_DEBUG, "WiederVorlage_SaveResubList(CMTS) == TRUE"));
		result = TRUE;
	}

	if (whichType == WVL)				/* Alte Datei wieder laden */
	{
		SPEC_DEBUG_OUT((EO_DEBUG, "whichType == WVL (2)"));
		WiederVorlage_ReadResubList(WVL);
		SortResubs(WVL);
	}
	
	return result;
}
