/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */


/*
 * 22.9.03 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.30k'
 *	Cat merkte sich bei Flags setzen das 'in Maus lschen' auch wenn
 *	wenn dieser Punkt deaktiviert war.
 *
 * 22.8.04 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.38d'
 *	In der Suchbox konnten Flags per Tastatur gesetzt werden obwohl sie unsichtbar waren.
 */
#include <zsearchd.h>
#include <userinfo.h>
#include <mte.h>
#include <cathelp.h>
#include <vdiutil.h>
#include <searchhe.h>
#include <confvars.h>
#include <varname4.h>
#include <varname5.h>
#include <windials.h>
#include <cattypes.h>
#include <maustaus.h>
#include <catgloba.h>

#include <mtutils.h>
#include <mtdials.h>
#include <mtpopups.h>

#include <routines.h>
#include <debug.h>
#include <mtrsc.h>


LOCAL OBJECT *theForm;		/* SUCHBOX */
LOCAL OBJECT *smallForm;	/* SMALLSUCHBOX */
LOCAL OBJECT *objPtr;		/* SUCHBOX */
LOCAL OBJECT *smallPtr;		/* SMALLSUCHBOX */
LOCAL OBJECT *searchwhere;	/* SEARCHSELECTTEXT */
LOCAL OBJECT *logical;		/* SEARCHSELECTLOGIN */
LOCAL _BOOL moreOptions;
LOCAL _WORD lastKonfig = -1;
LOCAL SearchRecordType scrapKonf;

LOCAL CONST _UBYTE keyArray[SFLGBOT - SFLGTOP + 1] = {
	38,	/* L - Gelesen */
	33, /* F - Gefiltert */
	23, /* I - Interessant */
	20, /* T - Teilloeschung */
	32, /* D - Totalloeschung */
	37, /* K - Kommentieren */
	48, /* B - Beantworten */
	46, /* C - Userflg 1 */
	45, /* X - Userflg 2 */
	47, /* V - Vererben */
	50, /* M - Kommentar */
};
#define NUM_FLAGKEYS ((_WORD)(sizeof(keyArray) / sizeof(keyArray[0])))

LOCAL CONST _UBYTE numArray[MAX_SEARCHKONF] =  { 2, 3, 4, 5, 6, 7, 8, 9, 10, 11 };
#define NUM_KONFKEYS ((_WORD)(sizeof(numArray) / sizeof(numArray[0])))



/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

LOCAL _VOID SetItem(OBJECT *tree, _WORD item, _BOOL b)
{
	EnableObjState(tree, item, SELECTED, b);
}

/*** ---------------------------------------------------------------------- ***/


GLOBAL _BOOL ZSearchDial_InitMenuStr(_VOID)
{
	OBJECT *obj;
	_UBYTE varname[256];
	_UBYTE defname[11],name[11];
	_WORD nr;
	
	if (theForm == NULL)
	{
		ConfVars_GetConfDefBool(cMoreSearchOptions, &moreOptions, FALSE);
		obj = TreeAddr[SUCHBOX];
		obj[SEARCHST1].ob_spec.tedinfo->te_ptext[0] = '@';
		obj[SEARCHST2].ob_spec.tedinfo->te_ptext[0] = '@';
		obj[SEARCHST3].ob_spec.tedinfo->te_ptext[0] = '@';
		obj[SEARCHST4].ob_spec.tedinfo->te_ptext[0] = '@';
		theForm     = obj;
		
		obj = TreeAddr[SMALLSUCHBOX];
		obj[SMSEARCHSTR].ob_spec.tedinfo->te_ptext[0] = '@';
		smallForm   = obj;
		
		searchwhere = TreeAddr[SEARCHSELECTTEXT];
		logical     = TreeAddr[SEARCHSELECTLOGI];
		for(nr=0;nr<10;nr++)
		{
			make_varname(varname, sizeof(varname), cSearchName, nr);
			make_varname(defname, sizeof(defname), "Konf", nr+1);
			ConfVars_GetConfDefStr(varname,name, sizeof(name),defname);
			if(!name)
				strCpy(name,defname);
 			SetObjcString(theForm, SEARCHKONF1+nr, name);
 		}
	
	}
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID SetBits(OBJECT *tree, MSGBITS set, MSGBITS clear, _WORD start, _WORD end)
{
	_WORD z;
	_WORD newState;
	
	ASSERT((end - start + 1) <= NUM_FLAGKEYS);
	for (z = start; z <= end; z++)
	{
		if (set & (((MSGBITS) 1) << (z - start)))
			newState = SETNEW;
		else if (clear & (((MSGBITS) 1) << (z - start)))
			newState = CLEAR;
		else
			newState = NOCHANGE;
		SetThreeState(tree, z, newState);
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID SetThem(OBJECT *tree,
	MSGBITS set1, MSGBITS clear1, MSGBITS set2, MSGBITS clear2,
	_WORD start1, _WORD end1, _WORD start2, _WORD end2)
{
	SetBits(tree, set1, clear1, start1, end1);
	SetBits(tree, set2, clear2, start2, end2);
	/* SetBits(tree, sBit4, sBit5, STFLGTOP, STFLGBOT); */
}

/*** ---------------------------------------------------------------------- ***/

LOCAL MSGBITS GetBits(OBJECT *tree, _WORD start, _WORD end, _WORD state)
{
	_WORD z;
	MSGBITS b;
	
	ASSERT((end - start + 1) <= NUM_FLAGKEYS);
	b = 0;
	for (z = start; z <= end; z++)
	{
		if (GetThreeState(tree, z) == state)
			b |= ((MSGBITS)1) << (z - start);
	}
	return b;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID GetThem(OBJECT *tree,
	MSGBITS *set1, MSGBITS *clear1, MSGBITS *set2, MSGBITS *clear2,
	_WORD start1, _WORD end1, _WORD start2, _WORD end2)
{
	*set1   = GetBits(tree, start1, end1, SETNEW);
	*clear1 = GetBits(tree, start1, end1, CLEAR);
	*set2   = GetBits(tree, start2, end2, SETNEW);
	*clear2 = GetBits(tree, start2, end2, CLEAR);
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

typedef struct {
	SearchRecordType suchVar;
	_BOOL forList;
	_WORD exitBut;
} searchEnv;

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID GetStr(OBJECT *tree, _WORD item, _UBYTE *str, size_t strsize)
{
	ObjcString(tree, item, str, strsize);
	if (*str == '@')
		*str = '\0';
}

#define SetStr(tree, item, str) SetObjcString(tree, item, str)

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL isSelect(OBJECT *tree, _WORD item)
{
	return GetObjState(tree, item, SELECTED);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID Switch(_WORD set, _BOOL b)
{
	GRECT r;
	
	SetItem(theForm, set, b);
	WinDials_WinDialDraw(theForm, set, 0, &r, FALSE);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID SetXXString(OBJECT *tree, _WORD obj, OBJECT *sTree, _WORD idx)
{
	_UBYTE selStr[256];

	ObjcString(sTree, idx + 1, selStr, sizeof(selStr));
	if (selStr[0] != '\0')
		strCpy(selStr, selStr + 1);
	SetObjcString(tree, obj, selStr);
}

/*** ---------------------------------------------------------------------- ***/

/* Ich weiss, bloeder Name.. :-) */
LOCAL _VOID SetYYString(_WORD obj, _WORD wo)
{
	SetXXString(theForm, obj, searchwhere, wo);
}

/*** ---------------------------------------------------------------------- ***/

/* Ich weiss, auch ein bloeder Name.. :-) */
LOCAL _VOID SetZZString(_WORD obj, _WORD verkn)
{
	SetXXString(theForm, obj, logical, verkn);
}

/*** ---------------------------------------------------------------------- ***/

/* Inhalte der Popupfelder gemaess der Eingabeparameter wo0..wo3 und verkn0..verkn2 setzen */
LOCAL _VOID SetPopupStrings(CONST SearchRecordType *suchVar)
{
	SetYYString(WHERE1, suchVar->wo[0]);
	SetYYString(WHERE2, suchVar->wo[1]);
	SetYYString(WHERE3, suchVar->wo[2]);
	SetYYString(WHERE4, suchVar->wo[3]);
	/* Geaendert 17.8.93 by DS: Mit SetXState ist das schoener und kuerzer */
	VDIUtil_SetXState(objPtr, WHERE1, suchVar->wo[0]);
	VDIUtil_SetXState(objPtr, WHERE2, suchVar->wo[1]);
	VDIUtil_SetXState(objPtr, WHERE3, suchVar->wo[2]);
	VDIUtil_SetXState(objPtr, WHERE4, suchVar->wo[3]);
	
	SetZZString(LOGICAL1, suchVar->verkn[0]);
	SetZZString(LOGICAL2, suchVar->verkn[1]);
	SetZZString(LOGICAL3, suchVar->verkn[2]);
	
	VDIUtil_SetXState(objPtr, LOGICAL1, suchVar->verkn[0]);
	VDIUtil_SetXState(objPtr, LOGICAL2, suchVar->verkn[1]);
	VDIUtil_SetXState(objPtr, LOGICAL3, suchVar->verkn[2]);
}

/*** ---------------------------------------------------------------------- ***/

/* Inhalte der Popupfelder gemaess der Eingabeparameter wo0..wo3 und verkn0..verkn2 setzen */
LOCAL _VOID GetPopupStrings(SearchRecordType *suchVar)
{
	/* Auch hier umgestellt auf GetXState, ist kuerzer */
	suchVar->wo[0] = VDIUtil_GetXState(objPtr, WHERE1);
	suchVar->wo[1] = VDIUtil_GetXState(objPtr, WHERE2);
	suchVar->wo[2] = VDIUtil_GetXState(objPtr, WHERE3);
	suchVar->wo[3] = VDIUtil_GetXState(objPtr, WHERE4);
	suchVar->verkn[0] = VDIUtil_GetXState(objPtr, LOGICAL1);
	suchVar->verkn[1] = VDIUtil_GetXState(objPtr, LOGICAL2);
	suchVar->verkn[2] = VDIUtil_GetXState(objPtr, LOGICAL3);
}

/*** ---------------------------------------------------------------------- ***/
/*DYJ 5.21b */
LOCAL _BOOL ValidateSearchOpts(_WORD exit)
{
	_UBYTE str[256];
	MSGBITS sBit1, sBit2, sBit4, sBit5;
	
	/* Nur bei grosser Suchbox: Flageinstellungen ueberpruefen */
	if (moreOptions &&
		(exit == SOK ||
		 exit == SEARCHSTARTBACK ||
		 exit == SEARCHSTARTAHEAD))
	{
		GetThem(theForm, &sBit1, &sBit2, &sBit4, &sBit5, SFLGTOP, SFLGBOT, STFLGTOP, STFLGBOT);
		GetStr(theForm, SEARCHST1, str, sizeof(str));
		if (str[0] == '\0' && !isSelect(theForm, SFORFLAG))
		{
			MTE_infoRSC(AL_EMPTY_SEARCHSTR);	
			return FALSE;
		}
		/* Anzeige und change aus?, nur meckern, falls nicht schon neue Runde verordnet */
		if (!isSelect(theForm, SHOWMESS) && !isSelect(theForm, SSETFLAG))
		{
			MTE_infoRSC(AL_NO_SEARCH_ACTION);
			return FALSE;
		}
		if (!isSelect(theForm, SALLTEXT) && !isSelect(theForm, SFORFLAG))
		{
			MTE_infoRSC(AL_NO_SEARCH_FUNC);
			return FALSE;
		}
		if (isSelect(theForm, SFORFLAG))
		{
			/* leere Suchmaske */
			if ((sBit1 | sBit2) == 0)
			{
				MTE_infoRSC(AL_EMPTY_SEARCHMASK);
				return FALSE;
			}
		}
		if (isSelect(theForm, SSETFLAG))
		{
			/* leere Setzmaske */
			if ((sBit4 | sBit5) == 0)
			{
				MTE_infoRSC(AL_EMPTY_SETMASK);
				return FALSE;
			}
		}
		
		/* Jetzt noch Suchstring pruefen */
		if ((str[0] != '\0' && isSelect(theForm, SALLTEXT)) /* || !moreOptions */)
		{
			/* moreOptions ausgeklammert, da der Teil hier eh nur durchlaufen wird,
			 * wenn moreOptions angeschaltet ist!
			 */
			GetStr(objPtr, SEARCHST1, scrapKonf.searchStr[0], sizeof(scrapKonf.searchStr[0]));
			if (!SearchHelp_IsValidSearch(scrapKonf.searchStr[0]))
			{
				MTE_info(Rsc_WrkString(MTE_noSearchStr));
				return FALSE;
			}
			GetStr(objPtr, SEARCHST2, scrapKonf.searchStr[1], sizeof(scrapKonf.searchStr[2]));
			if (scrapKonf.searchStr[1][0] != '\0' &&
				!SearchHelp_IsValidSearch(scrapKonf.searchStr[1]))
			{
				MTE_info(Rsc_WrkString(MTE_noSearchStr));
				return FALSE;
			}
			GetStr(objPtr, SEARCHST3, scrapKonf.searchStr[2], sizeof(scrapKonf.searchStr[2]));
			if (scrapKonf.searchStr[2][0] != '\0' &&
				!SearchHelp_IsValidSearch(scrapKonf.searchStr[2]))
			{
				MTE_info(Rsc_WrkString(MTE_noSearchStr));
				return FALSE;
			}
			GetStr(objPtr, SEARCHST4, scrapKonf.searchStr[3], sizeof(scrapKonf.searchStr[3]));
			if (scrapKonf.searchStr[3][0] != '\0' &&
				!SearchHelp_IsValidSearch(scrapKonf.searchStr[3]))
			{
				MTE_info(Rsc_WrkString(MTE_noSearchStr));
				return FALSE;
			}
		}
	} else if (!moreOptions &&
		(exit == SMSEARCHOK ||
		 exit == SMFASTBACK ||
		 exit == SMFASTAHEAD))
	{
		GetStr(smallPtr, SMSEARCHSTR, str, sizeof(str));
		/* Bei kleiner Box: Ueberpruefen, ob der Suchstring leer ist */
		if (str[0] == '\0')
		{
			MTE_infoRSC(AL_EMPTY_SEARCHSTR0);
			return FALSE;
		}
		if (str[0] != '\0')
		{
			GetStr(smallPtr, SMSEARCHSTR, scrapKonf.searchStr[0], sizeof(scrapKonf.searchStr[0]));
			/* Jetzt der eigentliche Test */
			if (!SearchHelp_IsValidSearch(scrapKonf.searchStr[0]))
			{
				MTE_info(Rsc_WrkString(MTE_noSearchStr));
				return FALSE;
			}
		}
	}
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID setKonfToBox(CONST SearchRecordType *konf)
{
	/* Box initialisieren */
	SetThem(theForm, konf->sSetBits, konf->sClearedBits, konf->setBits, konf->clearBits,
		SFLGTOP, SFLGBOT, STFLGTOP, STFLGBOT);
	/* Bits setzen */
	
	SetItem(theForm, SHOWMESS, konf->show);
	SetItem(theForm, SFORFLAG, konf->statussearch);
	SetItem(theForm, SSETFLAG, konf->change);
	SetItem(theForm, ASKSET, konf->ask);
	SetItem(theForm, SALLTEXT, konf->searchText);
	SetItem(theForm, SMIGNORE, konf->gross);
	SetItem(theForm, NOGROUPBORDER, konf->groupsearch);
	
	EnableObjFlags(theForm, S_TXT_BOX, HIDETREE, !konf->searchText);
	EnableObjFlags(theForm, SMIGNORE, HIDETREE, !konf->searchText);
	EnableObjFlags(theForm, SEARCHST1, EDITABLE, konf->searchText);
	EnableObjFlags(theForm, SEARCHST2, EDITABLE, konf->searchText);
	EnableObjFlags(theForm, SEARCHST3, EDITABLE, konf->searchText);
	EnableObjFlags(theForm, SEARCHST4, EDITABLE, konf->searchText);
	WinDials_ShowCurs(theForm,konf->searchText);
	if(konf->statussearch==konf->change)
	{
		EnableObjFlags(theForm, S_FLAG_BOX, HIDETREE, !konf->statussearch);
		if(konf->change)
		{
			EnableObjFlags(theForm, S_SUCH_F, HIDETREE, FALSE);
			EnableObjFlags(theForm, S_SET_F, HIDETREE, FALSE);
		}
	}
	else
	{
		EnableObjFlags(theForm, S_FLAG_BOX, HIDETREE,FALSE);
		EnableObjFlags(theForm, S_SUCH_F, HIDETREE, !konf->statussearch);
		EnableObjFlags(theForm, S_SET_F, HIDETREE, !konf->change);
	}
	EnableObjFlags(theForm, ASKSET, HIDETREE, !konf->change);
	SetStr(objPtr, S_NAME, konf->Name);
	
	SetStr(objPtr, SEARCHST1, konf->searchStr[0]);
	SetStr(objPtr, SEARCHST2, konf->searchStr[1]);
	SetStr(objPtr, SEARCHST3, konf->searchStr[2]);
	SetStr(objPtr, SEARCHST4, konf->searchStr[3]);
	SetPopupStrings(konf);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL getKonfFromBox(_WORD exit, SearchRecordType *konf)
{
	if (ValidateSearchOpts(exit))
	{
		GetThem(theForm, &konf->sSetBits, &konf->sClearedBits, &konf->setBits, &konf->clearBits,
			SFLGTOP, SFLGBOT, STFLGTOP, STFLGBOT);
		konf->show         = isSelect(theForm, SHOWMESS);
		konf->gross        = isSelect(theForm, SMIGNORE);
		konf->change       = isSelect(theForm, SSETFLAG);
		konf->statussearch = isSelect(theForm, SFORFLAG);
		konf->ask          = isSelect(theForm, ASKSET);
		konf->searchText   = isSelect(theForm, SALLTEXT);
		konf->groupsearch  = isSelect(theForm, NOGROUPBORDER);
		GetStr(objPtr, SEARCHST1, konf->searchStr[0], sizeof(konf->searchStr[0]));
		GetStr(objPtr, SEARCHST2, konf->searchStr[1], sizeof(konf->searchStr[1]));
		GetStr(objPtr, SEARCHST3, konf->searchStr[2], sizeof(konf->searchStr[2]));
		GetStr(objPtr, SEARCHST4, konf->searchStr[3], sizeof(konf->searchStr[3]));
		GetStr(objPtr, S_NAME, konf->Name, sizeof(konf->Name));
		GetPopupStrings(konf);
		return TRUE;
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID bigBoxGetSetValues(OBJECT *tree, _VOID *env, _BOOL set, _WORD exit)
{
	searchEnv *envPtr;
	_WORD i, z;
	
	envPtr = env;
	if (set)
	{
		/* Einige Buttons zeigen oder verstecken */
		
		EnableObjFlags(tree, SHOWMESS, HIDETREE, envPtr->forList);
		if (envPtr->forList)
			SetObjState(tree, SHOWMESS, SELECTED);
		
		for (i = LOGICAL1; i <= BWHERE4; i++)
		{
			EnableObjState(tree, i, DISABLED, FALSE);
			EnableObjFlags(tree, i, TOUCHEXIT, TRUE);
		}
		/* Sonderbehandlung fuer Strings anschliessend */
		EnableObjFlags(tree, SEARCHST2, EDITABLE, TRUE);
		EnableObjFlags(tree, SEARCHST3, EDITABLE, TRUE);
		EnableObjFlags(tree, SEARCHST4, EDITABLE, TRUE);
		EnableObjFlags(tree, SEARCHST2, TOUCHEXIT, FALSE);
		EnableObjFlags(tree, SEARCHST3, TOUCHEXIT, FALSE);
		EnableObjFlags(tree, SEARCHST4, TOUCHEXIT, FALSE);
		
		/* Der braucht eine Sonderbehandlung */
		EnableObjState(tree, NOGROUPBORDER, DISABLED, envPtr->forList);
		
		/* User-definierte Strings fuer die freien Flags setzen.. */
		SetObjcString(tree, USERFLG1, UserBLK.UserString1);
		SetObjcString(tree, USERFLG2, UserBLK.UserString2);
		
/*DYJ 5.38d Start*/
		/* Userkeys fuer die Flags setzen */
		if(isSelect(theForm, SFORFLAG))
		{
			for (z = SFLGTOP; z <= SFLGBOT; z++)
				mtDials_SetUserkey(tree, z, keyArray[z-SFLGTOP], K_ALT, TRUE, TRUE);
		}
		if(isSelect(theForm, SSETFLAG))
		{
			for (z = STFLGTOP; z <= STFLGBOT; z++)
				mtDials_SetUserkey(tree, z, keyArray[z-STFLGTOP], K_ALT | K_RSHIFT, TRUE, TRUE);
		}
/*DYJ  Ende; alt:	
		/* Userkeys fuer die Flags setzen */
		for (z = SFLGTOP; z <= SFLGBOT; z++)
		{
			mtDials_SetUserkey(tree, z, keyArray[z-SFLGTOP], K_ALT, TRUE, TRUE);
		}
		for (z = STFLGTOP; z <= STFLGBOT; z++)
		{
			mtDials_SetUserkey(tree, z, keyArray[z-STFLGTOP], K_ALT | K_RSHIFT, TRUE, TRUE);
		}
*/
		
		ASSERT((SEARCHKONF1 + MAX_SEARCHKONF) == (SEARCHKONF10 + 1));
		/* Userkeys fuer die Konfigs setzen */
		for (z = SEARCHKONF1; z <= SEARCHKONF10; z++)
		{
			mtDials_SetUserkey(tree, z, numArray[z-SEARCHKONF1], K_ALT, TRUE, TRUE);
		}
	} else
	{
		exit &= 0x7fff;
		envPtr->exitBut = exit;
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL bigBoxButton(OBJECT *tree, _VOID *env, _WORD button, _WORD mx, _WORD my, _UWORD kstate, _WORD clicks)
{
	_WORD exit;
	_WORD x, y;
	_WORD select;
	_BOOL again;
	SearchRecordType scrapkonf;
	GRECT r;
	
	UNUSED(env);
	UNUSED(mx);
	UNUSED(my);
	if(button==-1)
		return FALSE;
	exit = button & 0x7fff;;
	again = TRUE;
	switch (exit)
	{
	case SOK:
	case SABBR:
	case SEARCHSTARTAHEAD:
	case SEARCHSTARTBACK:
	case LESSOPTIONS:
		again = FALSE;
		break;
		
	case SHOWMESS:
		Switch(SHOWMESS, !isSelect(tree, SHOWMESS));
		if (!isSelect(tree, SHOWMESS))
			Switch(ASKSET, FALSE);
		break;
		
	case ASKSET:
		Switch(ASKSET, !isSelect(tree, ASKSET));
		if (!isSelect(tree, SHOWMESS))
			Switch(SHOWMESS, !isSelect(tree, SHOWMESS));
		break;
		
	case LOGICAL1:
	case LOGICAL2:
	case LOGICAL3:
		objc_offset(tree, exit, &x, &y);
		select = VDIUtil_GetXState(tree, exit);
		select = mtPopups_TreePopup(logical, x, y, select) - 1;
		if (select >= 0)
		{
			VDIUtil_SetXState(tree, exit, select);
			SetXXString(tree, exit, logical, select);
			WinDials_WinDialDraw (tree, exit, 0, &r, FALSE);
		}
		break;
		
	case WHERE1:
	case WHERE2:
	case WHERE3:
	case WHERE4:
		objc_offset(tree, exit, &x, &y);
		select = VDIUtil_GetXState(tree, exit);
		select = mtPopups_TreePopup(searchwhere, x, y, select) - 1;
		if (select >= 0)
		{
			VDIUtil_SetXState(tree, exit, select);
			SetXXString(tree, exit, searchwhere, select);
			WinDials_WinDialDraw (tree, exit, 0, &r, FALSE);
		}
		break;
		
	case BLOGICAL1:
	case BLOGICAL2:
	case BLOGICAL3:
		select = VDIUtil_GetXState(tree, exit - 1);
		select = (select + 1) % 2;
		VDIUtil_SetXState(tree, exit - 1, select);
		SetXXString(tree, exit - 1, logical, select);
		WinDials_WinDialDraw(tree, exit-1, 0, &r, FALSE);
		break;
		
	case BWHERE1:
	case BWHERE2:
	case BWHERE3:
	case BWHERE4:
		select = VDIUtil_GetXState(tree, exit - 1);
		if(kstate&K_SHIFT)
			select = (select + 6) % 7;
		else
			select = (select + 1) % 7;
		VDIUtil_SetXState(tree, exit - 1, select);
		SetXXString(tree, exit - 1, searchwhere, select);
		WinDials_WinDialDraw(tree, exit - 1, 0, &r, FALSE);
		break;
		
	case SEARCHHELP:
		CatHelp_DoHelp(CatHelp_searchdial);
		DelObjState(tree, exit, SELECTED);
		WinDials_WinDialDraw(tree, exit, 0, &r, FALSE);
		break;
		
	case SALLTEXT:
		EnableObjFlags(tree, S_TXT_BOX, HIDETREE, !isSelect(theForm, SALLTEXT));
		EnableObjFlags(tree, SMIGNORE, HIDETREE, !isSelect(theForm, SALLTEXT));
		EnableObjFlags(tree, SEARCHST1, EDITABLE, isSelect(theForm, SALLTEXT));
		EnableObjFlags(tree, SEARCHST2, EDITABLE, isSelect(theForm, SALLTEXT));
		EnableObjFlags(tree, SEARCHST3, EDITABLE, isSelect(theForm, SALLTEXT));
		EnableObjFlags(tree, SEARCHST4, EDITABLE, isSelect(theForm, SALLTEXT));
		WinDials_WinEditChanged(tree, -1);
		WinDials_WinDialDraw(tree, ROOT, MAX_DEPTH, &r, FALSE);
		break;
/*DYJ 5.38d Start*/
	case SFORFLAG:
	{
		_BOOL isSet=isSelect(theForm, SFORFLAG);
		_WORD z;
		for (z = SFLGTOP; z <= SFLGBOT; z++)
			mtDials_SetUserkey(tree, z, keyArray[z-SFLGTOP], K_ALT, TRUE, isSet);
	}
	case SSETFLAG:
		if(exit==SSETFLAG)
		{
			_BOOL isSet=isSelect(theForm, SSETFLAG);
			_WORD z;
			for (z = STFLGTOP; z <= STFLGBOT; z++)
				mtDials_SetUserkey(tree, z, keyArray[z-STFLGTOP], K_ALT | K_RSHIFT, TRUE, isSet);
		}		
/*DYJ  Ende; alt:	
	case SFORFLAG:
	case SSETFLAG:
*/

		if(isSelect(theForm, SFORFLAG)==isSelect(theForm, SSETFLAG))
		{
			EnableObjFlags(theForm, S_FLAG_BOX, HIDETREE, !isSelect(theForm, SFORFLAG));
			if(isSelect(theForm, SFORFLAG))
			{
				EnableObjFlags(theForm, S_SUCH_F, HIDETREE, FALSE);
				EnableObjFlags(theForm, S_SET_F, HIDETREE, FALSE);
			}
		}
		else
		{
			EnableObjFlags(theForm, S_FLAG_BOX, HIDETREE,FALSE);
			EnableObjFlags(theForm, S_SUCH_F, HIDETREE, !isSelect(theForm, SFORFLAG));
			EnableObjFlags(theForm, S_SET_F, HIDETREE, !isSelect(theForm, SSETFLAG));
		}
		EnableObjFlags(tree, ASKSET, HIDETREE, !isSelect(theForm, SSETFLAG));
		WinDials_WinDialDraw(tree, ROOT, MAX_DEPTH, &r, FALSE);
		break;
		
	case SEARCHKONF1:
	case SEARCHKONF2:
	case SEARCHKONF3:
	case SEARCHKONF4:
	case SEARCHKONF5:
	case SEARCHKONF6:
	case SEARCHKONF7:
	case SEARCHKONF8:
	case SEARCHKONF9:
	case SEARCHKONF10:
		if (clicks > 1)
		{
			if (getKonfFromBox(exit, &scrapkonf))
			{
				SearchHelp_setKonf(exit - SEARCHKONF1, &scrapkonf);
				if(!(*scrapkonf.Name))
					make_varname(scrapkonf.Name, sizeof(scrapkonf.Name), "Konf", exit - SEARCHKONF1+1);
	 			SetObjcString(tree, exit, scrapkonf.Name);
				WinDials_WinDialDraw(tree, exit, MAX_DEPTH, &r, FALSE);
			}
		} else
		{
			if (SearchHelp_getKonf(exit - SEARCHKONF1, &suchVar))
			{
				setKonfToBox(&suchVar);
				if (lastKonfig != -1)
					DelObjState(tree, lastKonfig, SELECTED);
				lastKonfig = exit;
				SetObjState(tree, exit, SELECTED);
				WinDials_WinDialDraw(tree, ROOT, MAX_DEPTH, &r, FALSE);
			}
		}
		break;
		
	default:
		again = TRUE;
		break;
	}
	return !again;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID setKonfToSmallBox(CONST SearchRecordType *konf)
{
	SetItem(smallForm, SMGROSSEQKLEIN, konf->gross);
	SetStr(smallForm, SMSEARCHSTR, konf->searchStr[0]);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID getKonfFromSmallBox(SearchRecordType *konf)
{
	/* alle Bitsets sind unveraendert */
	konf->show         = TRUE;
	konf->gross        = isSelect(smallForm, SMGROSSEQKLEIN);
	konf->change       = FALSE;
	konf->statussearch = FALSE;
	/* ask ist unveraendert */
	konf->searchText   = TRUE;
	konf->groupsearch  = FALSE; /* keine gruppenuebergreifende Suche */
	GetStr(smallForm, SMSEARCHSTR, konf->searchStr[0], sizeof(konf->searchStr[0]));
	konf->searchStr[1][0] = '\0';
	/* zweiten String ausschalten, damit nur nach dem ersten gesucht wird */
	suchVar.wo[0] = sUEBERALL;
	/* Die restlichen Strings sind unveraendert, dto. Logik und Suchorte */
}

/*** ---------------------------------------------------------------------- ***/

/* Kleine Suchbox bearbeiten */
LOCAL _WORD smallHandle(SearchRecordType *suchVar)
{
	_WORD exit;

	UNUSED(suchVar);
	do
	{
		exit = WinDials_WinDialDo(smallForm, 0);
		exit &= 0x7fff;
		if (exit == SMHELP)
			CatHelp_DoHelp (CatHelp_smallsearch);
	} while (exit == SMHELP);
	return exit;
}

/*** ---------------------------------------------------------------------- ***/

/* grosse Suchbox bearbeiten */
LOCAL _WORD FormHandle(SearchRecordType *suchVar, _BOOL forList)
{
	searchEnv search;

	search.suchVar = *suchVar;
	search.forList = forList;
	
	if (!WinDials_OpenWinDial(theForm, TRUE,
		bigBoxGetSetValues,
		bigBoxGetSetValues,
		bigBoxButton,
		WinDials_defDraw,
		NULL,
		&search))
	{
		return -1;
	}
	
	WinDials_WinDialHandleEvents();
	
	*suchVar = search.suchVar;
	DelObjState(theForm, search.exitBut, SELECTED);
	return search.exitBut;
}

/*** ---------------------------------------------------------------------- ***/

/*
 * Die Vars sind gleichzeitig Eingabeparameter, damit werden die einzelnen
 * Punkte gefuellt, muss dem alten Aussehen entsprechen
 */
GLOBAL _WORD ZSearchDial_SearchDial(SearchRecordType *suchVar, _BOOL forList)
{
	_WORD exit;
	_BOOL again;
	_BOOL OptionSwitch;

	objPtr   = TreeAddr[SUCHBOX];
	smallPtr = TreeAddr[SMALLSUCHBOX];
	
	ConfVars_GetConfDefBool(cMoreSearchOptions, &moreOptions, FALSE);
	
	scrapKonf = *suchVar;
	
	/* Alten Inhalt in die Boxen kopieren */
	setKonfToBox(&scrapKonf);
	setKonfToSmallBox(&scrapKonf);
	
	do
	{
		again        = FALSE;
		OptionSwitch = FALSE;
		
		if (moreOptions)
		{
			exit = FormHandle(&scrapKonf, forList);
			if (exit < 0)
			{
				/* Fehler aufgreten */
				again = FALSE;
			} else if (exit == LESSOPTIONS)
			{
				again         = TRUE;
				moreOptions   = FALSE;
				OptionSwitch  = TRUE;
				ConfVars_SetConfigBool(cMoreSearchOptions, FALSE);
		
				if (getKonfFromBox(exit, &scrapKonf))
					setKonfToSmallBox(&scrapKonf);
			}
		} else
		{
			exit = smallHandle(&scrapKonf);
			if (exit == SMMOREOPTIONS)
			{
				again         = TRUE;
				moreOptions   = TRUE;
				OptionSwitch  = TRUE;
				ConfVars_SetConfigBool(cMoreSearchOptions, TRUE);
				scrapKonf.gross = isSelect(smallForm, SMGROSSEQKLEIN);
				GetStr(smallForm, SMSEARCHSTR, scrapKonf.searchStr[0], sizeof(scrapKonf.searchStr[0]));
				setKonfToBox(&scrapKonf);
			}
		}
		
		if (!OptionSwitch)
			again = !ValidateSearchOpts(exit);
		
	} while (again &&
		(!moreOptions || exit != SABBR) &&
		(moreOptions  || exit != SMSEARCHABBRUCH));
	if (moreOptions)
	{
		if (exit == SABBR)
		{
			return SEARCH_CANCEL;
		} else if (exit == SOK ||
			exit == SEARCHSTARTAHEAD ||
			exit == SEARCHSTARTBACK)
		{
			getKonfFromBox(exit, suchVar);
			if (exit == SEARCHSTARTAHEAD)
				return SEARCH_FASTAHEAD;
			else if (exit == SEARCHSTARTBACK)
				return SEARCH_FASTBACK;
			else
				return SEARCH_OK;
		}
	} else
	{
		if (exit == SMSEARCHABBRUCH)
		{
			return SEARCH_CANCEL;
		} else if (exit == SMSEARCHOK ||
			exit == SMFASTAHEAD ||
			exit == SMFASTBACK)
		{
			getKonfFromSmallBox(suchVar);
			if (exit == SMFASTAHEAD)
				return SEARCH_FASTAHEAD;
			else if (exit == SMFASTBACK)
				return SEARCH_FASTBACK;
			else
				return SEARCH_OK;
		}
	}
	return SEARCH_CANCEL;
}

/*** ---------------------------------------------------------------------- ***/

/*
 * Ruft die Suchbox auf; Rueckgabe < 0 -> User hat Abbruch gedrueckt
 * sonst noch moeglich: SEARCH_FASTAHEAD, SEARCH_ FASTBACK
 */
GLOBAL _WORD ZSearchDial_DoSearchDial(_BOOL forList)
{
	return ZSearchDial_SearchDial(&suchVar, forList);
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

typedef struct {
	DialActionSet possible;
	MSGBITS setBits, clearBits;
	DialAction whatAction;
	_WORD exitBut;
} flagVars;

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL flagButton(OBJECT *tree, _VOID *env, _WORD button, _WORD mx, _WORD my, _UWORD kstate, _WORD clicks)
{
	_WORD res;
	
	UNUSED(env);
	UNUSED(mx);
	UNUSED(my);
	UNUSED(kstate);
	UNUSED(clicks);
	res = button & 0x7fff;
	if (res == SFLAGSOK || res == SABBRUCH)
	{
		DelObjState(tree, res, SELECTED);
		return TRUE;
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID flagGetSetValues(OBJECT *tree, _VOID *env, _BOOL set, _WORD exit)
{
	flagVars *flgPtr;
	_WORD z, obj;

	flgPtr = env;
	if (set)
	{
		MSGBITS	setBits,clearBits;
		if(flgPtr->setBits&0x4000)	/*bOwnMessage an die richtige Stelle schieben*/
			setBits=(flgPtr->setBits&0x3ff)|0x400;
		else
			setBits=flgPtr->setBits;
		if(flgPtr->clearBits&0x4000)	/*bOwnMessage an die richtige Stelle schieben*/
			clearBits=(flgPtr->clearBits&0x3ff)|0x400;
		else
			clearBits=flgPtr->clearBits;
		SetBits(tree, setBits, clearBits, TOPFLAG, BOTFLAG);
		SetObjcString(tree, FUSERFLAG1, UserBLK.UserString1);
		SetObjcString(tree, FUSERFLAG2, UserBLK.UserString2);
		if(flgPtr->setBits&0x400)	/*bOwnMessage an die richtige Stelle schieben*/
			flgPtr->setBits=(flgPtr->setBits&0x3ff)|0x4000;
		EnableObjState(tree, SACTUAL,   DISABLED, !(flgPtr->possible & ChangeMsg));
		EnableObjState(tree, STREEDOWN, DISABLED, !(flgPtr->possible & ChangeTreeDown));
		EnableObjState(tree, STREE,     DISABLED, !(flgPtr->possible & ChangeTree));
		EnableObjState(tree, SSELECTED, DISABLED, !(flgPtr->possible & ChangeSelected));
		
		if (!(flgPtr->possible & flgPtr->whatAction))
		{
			flgPtr->whatAction = ChangeMsg;
			while (!(flgPtr->possible & flgPtr->whatAction) && flgPtr->whatAction < ChangeSelected)
				flgPtr->whatAction <<= 1;
		}
		switch (flgPtr->whatAction)
		{
			default:
			case ChangeMsg       : obj = SACTUAL; break;
			case ChangeTreeDown  : obj = STREEDOWN; break;
			case ChangeTree      : obj = STREE; break;
			case ChangeSelected  : obj = SSELECTED; break;
		}
		SetObjState(tree, obj, SELECTED);
		
		EnableObjFlags(tree, OWNFLAG, HIDETREE, flgPtr->whatAction!=ChangeSelected);
		EnableObjFlags(tree, OWNSTR, HIDETREE, flgPtr->whatAction!=ChangeSelected);
		EnableObjFlags(tree, BOTFLAG, HIDETREE, flgPtr->whatAction!=ChangeSelected);
		if(flgPtr->whatAction==ChangeSelected)
			mtDials_SetUserkey(tree, BOTFLAG, 24, K_ALT, TRUE, TRUE);	/* O fr Eigene*/
		for (z = TOPFLAG; z < BOTFLAG; z++)
		{
			mtDials_SetUserkey(tree, z, keyArray[z-TOPFLAG], K_ALT, TRUE, TRUE);
		}
		EnableObjFlags(tree, DELMFLAG, HIDETREE, UserBLK.isInternet || flgPtr->whatAction!=ChangeSelected);
		EnableObjFlags(tree, DELMSTR, HIDETREE, UserBLK.isInternet || flgPtr->whatAction!=ChangeSelected);
		if(!UserBLK.isInternet && flgPtr->whatAction==ChangeSelected)
		{
			mtDials_SetUserkey(tree, DELMFLAG, 39, K_ALT, TRUE, TRUE);
			SetItem(tree, DELMFLAG, flgPtr->setBits& bDelMaus);
		}
/*DYJ 5.30k Start*/
		else
			SetItem(tree, DELMFLAG, FALSE);
/*DYJ  Ende; */
	} else
	{
		exit &= 0x7fff;
		flgPtr->exitBut = exit;
		if (exit == SFLAGSOK)
		{
			flgPtr->setBits   = GetBits(tree, TOPFLAG, BOTFLAG, SETNEW);
			if(flgPtr->setBits&0x400)	/*bOwnMessage an die richtige Stelle schieben*/
				flgPtr->setBits=(flgPtr->setBits&0x3ff)|0x4000;
			if (isSelect(tree, DELMFLAG))
				flgPtr->setBits|= bDelMaus;
			flgPtr->clearBits = GetBits(tree, TOPFLAG, BOTFLAG, CLEAR);
			if(flgPtr->clearBits&0x400)	/*bOwnMessage an die richtige Stelle schieben*/
				flgPtr->clearBits=(flgPtr->clearBits&0x3ff)|0x4000;
			if (GetObjState(tree, SACTUAL, SELECTED))
			{
				DelObjState(tree, SACTUAL, SELECTED);
				flgPtr->whatAction = ChangeMsg;
			} else if (GetObjState(tree, STREEDOWN, SELECTED))
			{
				DelObjState(tree, STREEDOWN, SELECTED);
				flgPtr->whatAction = ChangeTreeDown;
			} else if (GetObjState(tree, STREE, SELECTED))
			{
				DelObjState(tree, STREE, SELECTED);
				flgPtr->whatAction = ChangeTree;
			} else if (GetObjState(tree, SSELECTED, SELECTED))
			{
				DelObjState(tree, SSELECTED, SELECTED);
				flgPtr->whatAction = ChangeSelected;
			}
		}
		DelObjState(tree, exit, SELECTED);
		
		DelObjState(tree, SACTUAL,   DISABLED);
		DelObjState(tree, STREEDOWN, DISABLED);
		DelObjState(tree, STREE,     DISABLED);
		DelObjState(tree, SSELECTED, DISABLED);
		
		DelObjState(tree, SACTUAL,   SELECTED);
		DelObjState(tree, STREEDOWN, SELECTED);
		DelObjState(tree, STREE,     SELECTED);
		DelObjState(tree, SSELECTED, SELECTED);
	}
}

/*** ---------------------------------------------------------------------- ***/

/*
 * Fuer die Flagaktionen. Gibt zurueck, ob der User ok angewaehlt hat und den Status
 * der Bits sowie die ueber die Radiobuttons gewaehlte Aktion
 */
GLOBAL _BOOL ZSearchDial_FlagDial(DialActionSet possible, MSGBITS *setBits, MSGBITS *clearBits, DialAction *whatAction)
{
	OBJECT *flagBox;
	flagVars flags;

	flags.possible = possible;
	flags.setBits = *setBits;
	flags.clearBits = *clearBits;
	flags.whatAction = *whatAction;
	flagBox = TreeAddr[FLAG2BOX];
	if (!WinDials_OpenWinDial(flagBox, TRUE,
		flagGetSetValues,
		flagGetSetValues,
		flagButton,
		WinDials_defDraw,
		NULL,
		&flags))
	{
		return FALSE;
	}
	WinDials_WinDialHandleEvents();
	if (flags.exitBut == SFLAGSOK)
	{
		*setBits = flags.setBits;
		*clearBits = flags.clearBits;
		*whatAction = flags.whatAction;
		ConfVars_SetConfigInt(cFlagSetValue, *setBits);
		ConfVars_SetConfigInt(cFlagClearValue, *clearBits);
		if(possible!=*whatAction)	/* sonst unsinnig, da in possible nur ein Bit gesetzt*/
			ConfVars_SetConfigInt(cFlagSelection, *whatAction);
	}
	
	return flags.exitBut == SFLAGSOK;
}

