/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */


#include <edittype.h>
#include <editor.h>
#include <mtappl.h>
#include <portvdi.h>

GLOBAL SET TrennSet;
GLOBAL SET UmbruchSet;
GLOBAL SET NormalSet;
GLOBAL SET DelimiterSet;
GLOBAL SET WordEndSet;

GLOBAL _UBYTE theDrawLine[4096];

GLOBAL _UBYTE wildAllChar;   /* Alle Zeichen, Default: '*' */
GLOBAL _UBYTE wildOneChar;   /* Ein Zeichen, Default: '?' */

GLOBAL HVDI cursorHandle;   /* Handle der Workstation des Cursors */

#define CR      0x0d
#define LF      0x0a

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

GLOBAL _BOOL EditType_Init(_VOID)
{
	_WORD i;
	
	wildAllChar = '*';
	wildOneChar = '?';
	if (cursorHandle == 0)
		cursorHandle = OpenWorkstation(Screen, 0, 0, TRUE);
	/* Parameter fuer Cursor einstellen. */
	vswr_mode(cursorHandle, MD_XOR);
	vsl_type(cursorHandle, SOLID);
	vsl_width(cursorHandle, 1);
	vsl_color(cursorHandle, BLACK);
	vsl_ends(cursorHandle, SQUARED, SQUARED);
	/* Fuellparameter setzen */
	vsf_style(cursorHandle, IP_SOLID);
	vsf_interior(cursorHandle, FIS_SOLID);
	vsf_color(cursorHandle, BLACK);
	/* SETs initialisieren */
	setclr(TrennSet);
	setclr(UmbruchSet);
	for (i = 0; i <= ' '; i++)
	{
		setincl(TrennSet, i);
		setincl(UmbruchSet, i);
	}
	setincl(TrennSet, '!');
	setincl(TrennSet, '"');
	setincl(TrennSet, '%');
	setincl(TrennSet, '&');
	setincl(TrennSet, '(');
	setincl(TrennSet, ')');
	setincl(TrennSet, '=');
	setincl(TrennSet, '?');
	setincl(TrennSet, '\'');
	setincl(TrennSet, '`');
	setincl(TrennSet, '#');
	setincl(TrennSet, '^');
	setincl(TrennSet, '@');
	setincl(TrennSet, '\\');
	setincl(TrennSet, '+');
	setincl(TrennSet, '-');
	setincl(TrennSet, '[');
	setincl(TrennSet, ']');
	setincl(TrennSet, '{');
	setincl(TrennSet, '}');
	setincl(TrennSet, '<');
	setincl(TrennSet, '>');
	setincl(TrennSet, ',');
	setincl(TrennSet, ';');
	setincl(TrennSet, '.');
	setincl(TrennSet, ':');
	setincl(TrennSet, '~');
	setincl(TrennSet, '|');
	
	setincl(UmbruchSet, '-');
	setincl(UmbruchSet, '~');
	
	setclr(NormalSet);
	for (i = 'A'; i <= 'Z'; i++)
		setincl(NormalSet, i);
	for (i = 'a'; i <= 'z'; i++)
		setincl(NormalSet, i);
	for (i = '0'; i <= '9'; i++)
		setincl(NormalSet, i);
	setincl(NormalSet, 0x84); /* ae */
	setincl(NormalSet, 0x94); /* oe */
	setincl(NormalSet, 0x81); /* ue */
	setincl(NormalSet, 0x9e); /* ss */
	setincl(NormalSet, 0xe1); /* ss */
	setincl(NormalSet, 0x8e); /* Ae */
	setincl(NormalSet, 0x99); /* Oe */
	setincl(NormalSet, 0x9a); /* Ue */
	setincl(NormalSet, '"');
	setincl(NormalSet, '\'');
	
	setclr(DelimiterSet);
	setincl(DelimiterSet, ' ');
	setincl(DelimiterSet, '-');
	setincl(DelimiterSet, '>');
	setincl(DelimiterSet, '(');
	setincl(DelimiterSet, '[');
	setincl(DelimiterSet, '{');
	setincl(DelimiterSet, '"');
	setincl(DelimiterSet, '\'');
	
	setclr(WordEndSet);
	setincl(WordEndSet, '\0');
	setincl(WordEndSet, CR);
	setincl(WordEndSet, LF);
	setincl(WordEndSet, ' ');
	setincl(WordEndSet, '.');
	setincl(WordEndSet, ',');
	setincl(WordEndSet, ';');
	setincl(WordEndSet, '!');
	setincl(WordEndSet, '-');
	setincl(WordEndSet, '?');
	setincl(WordEndSet, ':');
	setincl(WordEndSet, '"');
	setincl(WordEndSet, '\'');
	setincl(WordEndSet, '}');
	setincl(WordEndSet, ']');
	setincl(WordEndSet, ')');
	
	Editor_Init();
	return TRUE;
}
