#ifndef __EDITDRAW_H__
#define __EDITDRAW_H__
/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */



#ifndef __PORTAB_H__
#include <portab.h>
#endif

#ifndef __EDITTYPES_H__
#include <edittype.h>
#endif

#define UP              0
#define DOWN            1
#define RIGHT           0
#define LEFT            1


_VOID EditDraw_drawLine(EDITOR *ed, _WORD screenLine);

_VOID EditDraw_redrawLine(EDITOR *ed, _BOOL insChar, _BOOL full);

_VOID EditDraw_GetBlockRects(EDITOR *ed, GRECT blockRects[], _WORD *count, EDLINE oldLine, EDCOLUMN oldRow, EDLINE newLine, EDCOLUMN newRow);

_VOID EditDraw_MarkArea(EDITOR *ed, EDLINE oldLine, EDCOLUMN oldRow, EDLINE newLine, EDCOLUMN newRow, _BOOL clipIt);

/* Vorhandener Block wird angezeigt */
_VOID EditDraw_ShowBlockMark(EDITOR *ed, _BOOL clipIt);

/* Alle redraw-Funktionen */
_VOID EditDraw_redrawWdw(HWND wdw, HVDI vdiH, _VOID *special, CONST GRECT *frame);
/* Service-Routine fuer Window-Library */

_VOID EditDraw_redrawLines(EDITOR *ed, _WORD fromLine);

_VOID EditDraw_redrawLineArea(EDITOR *ed, EDLINE fromLine, EDLINE toLine);
/* Hier werden richtige Zeilennummern uebergeben, nicht die Bildschirmzeilen */

/* Scroll-Funktionen */

_VOID EditDraw_scrollRegion(EDITOR *ed, _WORD from, _WORD to, _WORD amount);

/* Blaetterfunktionen */

_VOID EditDraw_CenterCurrline(EDITOR *ed);


#endif /* __EDITDRAW_H__ */
