#ifndef __EDITFUNCS_H__
#define __EDITFUNCS_H__
/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */



#ifndef __PORTAB_H__
#include <portab.h>
#endif
#ifndef __EDITTYPES_H__
#include <edittype.h>
#endif
#ifndef __SET_H__
#include <set.h>
#endif
#ifndef __FILE_IO_H__
#include <file_io.h>
#endif


typedef F_ERROR (*formFunc)(_UBYTE *text);


extern _UWORD rotateFaktor;
extern EDITOR *editList;


EDITOR *EditFuncs_FindEditor(HWND wdw);

_WORD EditFuncs_GetEditNumber(HWND wdw);

EDCOLUMN EditFuncs_findNext(CONST _UBYTE *text, EDCOLUMN fromPos, EDCOLUMN l, SET tSet);

EDCOLUMN EditFuncs_FindNext(EDITOR *ed, _BOOL umbruch, EDCOLUMN l);

EDCOLUMN EditFuncs_findLast(CONST _UBYTE *text, EDCOLUMN fromPos, SET tSet);

EDCOLUMN EditFuncs_FindLast(EDITOR *ed, _BOOL umbruch);

_VOID EditFuncs_CursorDown(EDITOR *ed, _BOOL ctrl);

_VOID EditFuncs_CursorUp(EDITOR *ed, _BOOL ctrl);

_VOID EditFuncs_CursorLeft(EDITOR *ed, _UWORD kstate);

_VOID EditFuncs_CursorRight(EDITOR *ed, _UWORD kstate);

F_ERROR EditFuncs_AllUp(_UBYTE *text);

F_ERROR EditFuncs_AllLower(_UBYTE *text);

F_ERROR EditFuncs_SwapUpperLower(_UBYTE *text);

F_ERROR EditFuncs_Capitalise(_UBYTE *text);

F_ERROR EditFuncs_RotXX(_UBYTE *text);

F_ERROR EditFuncs_Rot18(_UBYTE *text);

F_ERROR EditFuncs_Mirror(_UBYTE *text);

F_ERROR EditFuncs_Protect(_UBYTE *text);

F_ERROR EditFuncs_UnProtect(_UBYTE *text);

F_ERROR EditFuncs_XXDecode(_UBYTE *text);

F_ERROR EditFuncs_MimeDecode(_UBYTE *text);

_VOID EditFuncs_TransformBlock(EDITOR *ed, formFunc trans, _BOOL wholeLines);

_VOID EditFuncs_Home(EDITOR *ed, _BOOL ende);

_VOID EditFuncs_SwapLines(EDITOR *ed, _BOOL withUp);
/* Vertauscht die aktuelle Zeile mit
 * withUp = TRUE der Zeile darueber
 * withUp = FALSE der Zeile darunter
 */

_BOOL EditFuncs_outputText(
	EDITOR *ed,
	EDLINE fromLine, EDCOLUMN fromRow,
	EDLINE toLine, EDCOLUMN toRow,
	FILENO fHdl,
	_BOOL umbruch, _BOOL usePrintMod);


typedef enum {
	memError,
	readError,
	noTextError
} ErrReason;


_BOOL EditFuncs_ReadBuffer(EDITOR *ed, _UBYTE **buf, _ULONG len, _BOOL freeBuffer, ErrReason *err);

_BOOL EditFuncs_ReadEditBuffer(EDITOR *ed, _UBYTE *buf, _ULONG len, _BOOL inLine, CONST _UBYTE *pre);

_BOOL EditFuncs_readText(
	EDITOR *ed, _BOOL fastRead, _ULONG flen,
	FILENO *fHdl, EDCOLUMN right, _UBYTE **readBuf,
	_BOOL inLine, _BOOL fullText);

_VOID EditFuncs_Goto(EDITOR *ed, _LONG line, _WORD row);

_VOID EditFuncs_showError(EDITOR *ed);

_VOID EditFuncs_KillEditor(EDITOR *ed);

EDITOR *EditFuncs_CreateEditor(_VOID);

_VOID EditFuncs_callComp(EDITOR *ed);

_VOID EditFuncs_FreeShortkeyList(_VOID);

_VOID EditFuncs_ReadShortkeyFile(CONST _UBYTE *fname);

_BOOL EditFuncs_InsertShortkey(EDITOR *ed);


/* wird nur bei count = nmal benutzt */
_BOOL EditFuncs_searchAndReplace(
	EDITOR *ed,
	CONST _UBYTE *w,
	CONST _UBYTE *r,
	searchPos pos,
	searchDir direction,
	searchCount count,
	_WORD num,
	_BOOL ignoreCase,
	_BOOL onlyWord,
	_BOOL replace,
	_BOOL ask,
	_BOOL again,
	CONST _UBYTE *bingEvent);


_VOID EditFuncs_Delete(EDITOR *ed, _BOOL ctrl, _BOOL saveLine);

_VOID EditFuncs_Backspace(EDITOR *ed, _BOOL ctrl);

_VOID EditFuncs_DupLine(EDITOR *ed);

_VOID EditFuncs_Tab(EDITOR *ed, _BOOL onlyIndent);

_VOID EditFuncs_InsertCR(EDITOR *ed);

_VOID EditFuncs_Format0(EDITOR *ed, _BOOL forcedJoin);

_VOID EditFuncs_Insert(EDITOR *ed, _UBYTE ch);

_BOOL EditFuncs_cutBlock(EDITOR *ed, _BOOL toClip, _BOOL redraw);

_BOOL EditFuncs_cutEdit(EDITOR *ed, _BOOL fromOuter);

_BOOL EditFuncs_putLineInEditor(EDITOR *ed, _UBYTE *adr, _ULONG len, _BOOL redraw);


#endif /* __EDITFUNCS_H__ */
