#ifndef __EDITGLOBALS_H__
#define __EDITGLOBALS_H__
/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */



#ifndef __PORTAB_H__
#include <portab.h>
#endif
#ifndef __PORTAES_H__
#include <portaes.h>
#endif
#ifndef __EDITTYPES_H__
#include <edittype.h>
#endif




/* Window-Funktionen fuer Darstellung auf Bildschirm */

/* Setzt neues virtuelles Fenster */
_VOID EditGlobals_SetDocument(EDITOR *ed);

/* GrafGrowbox und GrafShrinkbox neu, da das AES bei kleinen Boxgroessen anscheinend Muell macht */

_VOID EditGlobals_GrowAndShrink(EDITOR *ed, CONST GRECT *from);

_WORD EditGlobals_isQuote(EDITOR *ed, CONST _UBYTE *str);
/* Stellt fest, ob eine Textzeile ein Quote ist */

_VOID EditGlobals_GetQuote(EDITOR *ed, CONST _UBYTE *str, _UBYTE *quote, size_t strsize);
/* Holt den Quoteteil aus der Zeile */

_WORD EditGlobals_OutputLine(EDITOR *ed, _WORD x, _WORD y, CONST _UBYTE *line, EDCOLUMN len, _WORD maxWdwWidth);
/* Gibt die Zeile line an der Position x,y im Editor ed aus
 * und gibt die Breite der Zeile zurueck
 */
GLOBAL _WORD EditGlobals_LinkType(const _UBYTE *string,const _UBYTE **link);
/* Gibt zurck um was fr einen Link es sich handelt	*/
/*GS 5.28a Start*/
enum {NoLNK,Http,Ftp,EmailI,EmailM,MausId,MessId,EmailOrIdM,EmailOrIdI,Telnet,Gopher,Wais};
/*DYJ  Ende; alt:	
enum {NoLNK,Http,Ftp,EmailI,EmailM,MausId,MessId,EmailOrIdM,EmailOrIdI};
*/

_VOID EditGlobals_AllocNew(aLineDesc *line, EDCOLUMN newLen);
/* Alloziert ggf. eine neue Zeile, damit der Text die neue Laenge haben
 * kann
 */

/* VDI Text Funktionen    */

_VOID EditGlobals_Text(EDITOR *ed, _WORD x, _WORD y, CONST _UBYTE *string);
_VOID EditGlobals_NText(EDITOR *ed, _WORD x, _WORD y, CONST _UBYTE *string, _WORD len);

_WORD EditGlobals_InqTextextend(EDITOR *ed, CONST _UBYTE *string, _BOOL DisplayEffects, _WORD maxWdwWidth);
_WORD EditGlobals_InqNTextextend(EDITOR *ed, CONST _UBYTE *string, _WORD l, _BOOL DisplayEffects, _WORD maxWdwWidth);

_WORD EditGlobals_GetTextWidth(EDITOR *ed, CONST _UBYTE *string, EDCOLUMN idx, EDCOLUMN len, _WORD maxWdwWidth);
/* Diese Prozedur parst den Text immer. Pos gibt die Position an, bis zu der der
 * String maximal zusammengesetzt wird!
 */

_VOID EditGlobals_FixCursorPos(EDITOR *ed);
/* Passt auf, das der Cursor nie hinter einem CR/LF steht
 */

EDCOLUMN EditGlobals_RowToIndex(CONST _UBYTE *str, EDCOLUMN row, EDCOLUMN TabSize);

/* Cursor-Zeichenfunktionen */

_VOID EditGlobals_ClipWork(EDITOR *ed);

_VOID EditGlobals_growCursor(EDITOR *ed);

_VOID EditGlobals_MouseArrow(_VOID);
_VOID EditGlobals_MouseCursor(_VOID);
_VOID EditGlobals_MouseBusy(_VOID);
_VOID EditGlobals_MouseFinger(_VOID);
_VOID EditGlobals_MouseHand(_VOID);
_VOID EditGlobals_MouseThincross(_VOID);
_VOID EditGlobals_MouseThickcross(_VOID);
_VOID EditGlobals_MouseOutline(_VOID);
_VOID EditGlobals_MouseUser(_VOID);
/* Diese Routinen schalten die Maus mit dem jeweilige Bild EIN */

_BOOL EditGlobals_MouseIsOn(_VOID);
/* Erfragt, ob die Maus an ist oder nicht */


_VOID EditGlobals_UserMouse(MFORM *form);
/* Setzt eine User-Definierte Maus. Sichtbar erst mit MouseUser! */

_VOID EditGlobals_SaveMouse(_VOID);

_VOID EditGlobals_RestoreMouse(_VOID);


_VOID EditGlobals_HideMouse(_VOID);

_VOID EditGlobals_ShowMouse(_BOOL force);

_BOOL EditGlobals_CursorIsOn(EDITOR *ed);

_VOID EditGlobals_HideCursor(EDITOR *ed);

_VOID EditGlobals_ShowCursor(EDITOR *ed);

_VOID EditGlobals_ForceCursor(EDITOR *ed);


#endif /* __EDITGLOBALS_H__ */
