#ifndef __EDITTOOLS_H__
#define __EDITTOOLS_H__
/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */



#ifndef __PORTAB_H__
#include <portab.h>
#endif
#ifndef __EDITTYPES_H__
#include <edittype.h>
#endif


_VOID EditTools_SetInfoLine(EDITOR *ed);

_VOID EditTools_SetEditTitle(EDITOR *ed);

_VOID EditTools_ShowFileChanged(EDITOR *ed);

_VOID EditTools_UpdateCurrLine(EDITOR *ed, EDLINE line);

_VOID EditTools_SetCurrLine(EDITOR *ed, EDLINE line);

_VOID EditTools_SetStartLine(EDITOR *ed, EDLINE line, _BOOL docUpdate);

/* Abfrage-Funktionen */

_VOID EditTools_getCharPos(EDITOR *ed, EDLINE line, EDCOLUMN row, _WORD *x, _WORD *y);

_VOID EditTools_SaveLine(aLinePtr l, EDLINE lNr);

_VOID EditTools_PutInUndoList(aLinePtr line);

_VOID EditTools_SaveOp(EDITOR *ed, undoType op, _BOOL append);

_VOID EditTools_NewBlockToUndoBuffer(EDITOR *ed);

_VOID EditTools_DeleteLine(EDITOR *ed, _BOOL redraw);

_VOID EditTools_FreeUndoBuffer(_VOID);

_VOID EditTools_CheckAndFreeUndo(HWND wdw);

_VOID EditTools_Undo(EDITOR *ed);

_VOID EditTools_SetBlockstart(EDITOR *ed);

_VOID EditTools_SetBlockend(EDITOR *ed);

_VOID EditTools_ClearBlock(EDITOR *ed);

_VOID EditTools_GetClickLineAndRow(EDITOR *ed, _WORD x, _WORD y, EDLINE *clLine, EDCOLUMN *clRow);

_VOID EditTools_TestBlockMarksAndSwap(EDITOR *ed);

EDCOLUMN EditTools_ToWordEnd(EDITOR *ed, EDLINE line, EDCOLUMN row);

EDCOLUMN EditTools_ToWordStart(EDITOR *ed, EDLINE line, EDCOLUMN row);

EDCOLUMN EditTools_ToLineEnd(EDITOR *ed, EDLINE line);

EDCOLUMN EditTools_ToLineStart(EDITOR *ed, EDLINE line);

_VOID EditTools_MarkLine(EDITOR *ed);

_VOID EditTools_MarkWord(EDITOR *ed);

_VOID EditTools_MarkBlock(EDITOR *ed, _WORD ox, _WORD oy, _BOOL init, _BOOL fromTop);

_VOID EditTools_ToBlockmark(EDITOR *ed, _BOOL ende);

_BOOL EditTools_InitSearch(EDITOR *ed, searchDir direction, CONST _UBYTE *search, CONST _UBYTE *repl, _BOOL doRepl);
/* Compiliert das Suchmuster und setzt ein paar Variablen fuer
 * Suchen & Ersetzen mit Wildcards, falls ersetzt werden soll
 */

_VOID EditTools_SearchWord(EDITOR *ed, CONST _UBYTE *w, searchDir direction,
	_BOOL *gefunden, _UBYTE *foundWord, size_t wsize, _BOOL again);

_VOID EditTools_ReplaceWord(EDITOR *ed, CONST _UBYTE *s, CONST _UBYTE *t);

_VOID EditTools_EndSearch(_VOID);
/* Gibt das compilierte Suchmuster wieder frei
 */

_BOOL EditTools_CheckWildAssign(CONST _UBYTE *search, CONST _UBYTE *repl);
/* Prueft die Konsistenz von Wildcards und ihren Gegenstuecken im Such-
 * und Ersetzstring
 */

_BOOL EditTools_PossibleUndo(EDITOR *ed);

_ULONG SystemTimer(_VOID);


#endif /* __EDITTOOLS_H__ */
