#ifndef __EDITUTIL_H__
#define __EDITUTIL_H__
/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */



#ifndef __PORTAB_H__
#include <portab.h>
#endif
#ifndef __EDITTYPES_H__
#include <edittype.h>
#endif
#ifndef __FILE_IO_H__
#include <file_io.h>
#endif


_VOID EditUtil_EditSaveWdwPos(HWND wdw);

_VOID EditUtil_EditSavePos(_VOID);
/* Sichert die Position und den Inhalt aller offenen Editorfenster
 * (nicht ReadOnly-Fenster)
 */

/* Einfuege- und Loeschoperationen */

_VOID EditUtil_IndentBlock(HWND wdw);

/* Hilfsfunktionen fuer OpenEditor und EditMerge */

_BOOL EditUtil_getFileParms(CONST _UBYTE *path, CONST _UBYTE *FileName, _VOID /* List */ *SrcPaths, _BOOL new, _BOOL alerts, aLineDesc *fn, _ULONG *flen, FILENO *fHdl);

#if OLD
_BOOL EditUtil_testMem(_ULONG flen, _ULONG *memSize, _BOOL *fastRead);
_BOOL EditUtil_getReadBuff(_ULONG flen, _UBYTE **readBuf);
#else
_BOOL EditUtil_testMem(_ULONG flen, _BOOL *fastRead, _UBYTE **readBuf);
#endif

_VOID EditUtil_EditPasteFile(HWND wdw, _BOOL isFilter, CONST _UBYTE *path, CONST _UBYTE *name);
/* Fuegt einen Text mit Filename ein
 */

_BOOL EditUtil_SaveText(EDITOR *ed, _BOOL saveas, _BOOL takeName, CONST _UBYTE *fpath, CONST _UBYTE *fname,_BOOL saveBlock);

_VOID EditUtil_PerformDragDrop(EDITOR *ed, _WORD x, _WORD y, _UWORD kstate, _UWORD buts);

_BOOL EditUtil_ClickIsInBlock(HWND wdw, _WORD x, _WORD y);
/* Gibt zurueck, ob die Position x, y im Blockbereich liegt
 */

_VOID EditUtil_MarkMultiple(EDITOR *ed);
/* Markiert multiple Bloecke
 */

_BOOL EditUtil_WrapText(EDITOR *ed, _BOOL force);
/* Text umbrechen
 * TRUE: Text wurde umgebrochen
 */


#endif /* __EDITUTIL_H__ */
