/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */


#include <mtedit2.h>
#include <editor.h>
#include <userinfo.h>
#include <confvars.h>
#include <varn_edi.h>
#include <wildcard.h>


LOCAL _UBYTE nextChar;
LOCAL _UBYTE nextScan;

/*** ---------------------------------------------------------------------- ***/

GLOBAL _BOOL MTEdit2_ChangeThisChar(HWND wdw, _UBYTE *s, _UBYTE *c, _UWORD *kstate, _BOOL *moreChars)
{
	UNUSED(wdw);
	UNUSED(kstate);
	*moreChars = FALSE;
	if (UserBLK.ConvertDiaresis)
	{
		if (nextChar != '\0')
		{
			*c = nextChar;
			*s = nextScan;
			nextChar = '\0';
		} else if (*c == 0x8e) /* Ae */
		{
			*c = 'A';
			*s = 30;
			nextChar = 'e';
			nextScan = 18;
			*moreChars = TRUE;
		} else if (*c == 0x99) /* Oe */
		{
			*c = 'O';
			*s = 24;
			nextChar = 'e';
			nextScan = 18;
			*moreChars = TRUE;
		} else if (*c == 0x9a) /* Ue */
		{
			*c = 'U';
			*s = 22;
			nextChar = 'e';
			nextScan = 18;
			*moreChars = TRUE;
		} else if (*c == 0x84) /* ae */
		{
			*c = 'a';
			*s = 30;
			nextChar = 'e';
			nextScan = 18;
			*moreChars = TRUE;
		} else if (*c == 0x94) /* oe */
		{
			*c = 'o';
			*s = 24;
			nextChar = 'e';
			nextScan = 18;
			*moreChars = TRUE;
		} else if (*c == 0x81) /* ue */
		{
			*c = 'u';
			*s = 22;
			nextChar = 'e';
			nextScan = 18;
			*moreChars = TRUE;
		} else if (*c == 0x9e) /* ss */
		{
			*c = 's';
			*s = 31;
			nextChar = 's';
			nextScan = 31;
			*moreChars = TRUE;
		} else
		{
			nextChar = '\0';
		}
	} else
	{
		nextChar = '\0';
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL HWND MTEdit2_OpenEditWindow(CONST _UBYTE *path, CONST _UBYTE *FileName, _BOOL New, _BOOL ReadOnly)
{
	HWND wdw;
	_WORD i;
	_BOOL found;
	_UBYTE varname[128];
	_UBYTE ext[PATH_MAX];
	_WORD tabs, margin;
	_BOOL rtabs, wrap, doback;
	_BOOL open, indent;

	i = 0;
	found = FALSE;
	while (i <= 8 && !found)
	{
		++i;
		make_varname(varname, sizeof(varname), cExtension, i);
		if (ConfVars_GetConfigString(varname, ext, sizeof(ext)) && ext[0] != '\0')
		{
			found = WildCards_MatchName(FileName, ext, TRUE);
		}
	}
	if (found)
	{
		/* Ein paar Einstellung holen */
		make_varname(varname, sizeof(varname), cExtTabSize, i);
		ConfVars_GetConfDefInt(varname, &tabs, UserBLK.TabSize);
		make_varname(varname, sizeof(varname), cExtHardTabs, i);
		ConfVars_GetConfDefBool(varname, &rtabs, FALSE);
		make_varname(varname, sizeof(varname), cExtWordWrap, i);
		ConfVars_GetConfDefBool(varname, &wrap, FALSE);
		make_varname(varname, sizeof(varname), cExtRightMargin, i);
		ConfVars_GetConfDefInt(varname, &margin, 255);
		make_varname(varname, sizeof(varname), cExtAutoBackup, i);
		ConfVars_GetConfDefBool(varname, &doback, FALSE);
	} else
	{
		tabs = UserBLK.TabSize;
		rtabs = FALSE;
		wrap = FALSE;
		margin = 255;
		doback = FALSE;
	}
	open = Editor_OpenEditor(path, FileName, NULL,
		New, FALSE,
		FUNK_NULL, FUNK_NULL, FUNK_NULL,
		FUNK_NULL, MTEdit2_ChangeThisChar, FUNK_NULL,
		FUNK_NULL, FUNK_NULL,
		margin, !ReadOnly, wrap, -1,
		&wdw);
	if (open)
	{
		Editor_SetMode(wdw, tabMode, rtabs);
		Editor_SetTabSize(wdw, tabs);
		Editor_SetMode(wdw, autoBackup, doback);
		Editor_SetMode(wdw, roMode, ReadOnly);
		ConfVars_GetConfDefBool(cEditAutoIndentDefault, &indent, TRUE);
		Editor_SetMode(wdw, indentMode, indent);
		if (ReadOnly)
		{
			Editor_SetMode(wdw, effMode, TRUE);
			Editor_SetMode(wdw, msgMode, TRUE);
		}
	}
	return wdw;
}
