/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 *
 */


/*==============================================================*
 * Modul:               Fred - der Editor Main Modul            *
 * Autor:               Dirk Steins                             *
 * erstellt am:         4.11.1991                               *
 * letzte Aenderung am: 17.4.1994                               *
 * VERSION:             0.91                                    *
 * Interne VERSION:     V#0089                                  *
 *==============================================================*

 *----------------------------------------------------------------------------
 * Datum      Vers. Autor Aenderung (Arbeitsbericht)
 *----------------------------------------------------------------------------
 * 04.11.91   0.1   DS    Modul erstellt
 *
 * 08.04.92   0.35  DS    umgestellt auf neue Window-Library
 * 18.04.95   0.91  DS    angepasst an CAT_GOLD-Sourcen
 * 05.06.95   0.92  DS    neu compiliert mit aktuelleren Sourcen
 * 01.01.98   0.97  TO    Portiert nach C
 * 13.11.00   1.01  DYJ   neu compiliert mit aktuelleren Sourcen
 *----------------------------------------------------------------------------
 * 23.2.01 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 1.02a' entspr.'DYJ 4.23i' in CAT
 *	war ein Block markiert, wurde nur dieser gedruckt oder gespeichert.
 *	jetzt wird nachgefragt ob nicht doch der gesamte Text gewnscht ist.
 *
 * 20.3.03 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.23f'
 *	Fred erhlt ab sofort die gleiche Versionsnummer wie Cat&Co
 *
 * 10.4.03 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.26a'
 *	Fred fragte ob es fr maus oder Internetnutzung benutzt werden soll,
 *	das war natrlich Unsinn
 *
 * 11.4.03 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.26b'
 *	Einen Menpunkt zur Spracheinstellung eingefgt
 */

#include <portab.h>
#include <portaes.h>
#include <portvdi.h>
#include <tos.h>
#include <mintbind.h>
#include <magiccoo.h>
#include <signal_.h>

#include <mtappl.h>
#include <mtcomman.h>
#include <mtutils.h>
#include <mtdials.h>
#include <mtdir.h>
#include <mtalerts.h>
#include <mtpopups.h>
#include <mttextfi.h>
#include <fontsele.h>
#include <mtrsc.h>
#include <magicstr.h>

#include <strconv.h>
#include <lists.h>
#include <filename.h>
#include <fslx.h>

#include <mintutil.h>

#include <cattypes.h>
#include <editor.h>
#include <catutil.h>
#include <editfunc.h>
#include <edittype.h>
#include <edittool.h>
#include <wdwmanag.h>
#include <catfiles.h>
#include <printer.h>
#include <menu_key.h>
#include <shellcal.h>
#include <catgloba.h>
#include <varname2.h>
#include <varname3.h>
#include <varname5.h>
#include <varnamel.h>
#include <varn_edi.h>
#include <confvars.h>
#include <assfuncs.h>
#include <find2.h>
#include <windials.h>
#include <wildcard.h>
#include <plisthel.h>
#include <xacc.h>
#include <vaproto.h>
#include <seproto.h>
#include <protokol.h>
#include <vdiutil.h>
#include <catopts.h>
#include <userinfo.h>
#include <mtaesmen.h>
#include <keyboard.h>

#include <fred.h>

#include <ro_mem.h>
#include <routinec.h>
#include <routines.h>
#include <routine.h>
#include <debug.h>
#include <catlib.h>		/*DYJ 5.21i */


/*DYJ 5.23f Start*/
#define eddixName          "  Fred" CatVersion
#define whatString         "@(#)Fred " CatVersion ", Copyright (c) 1997 Dirk Steins (Oct 26 1997)"
/*DYJ  Ende; alt:	
#define pVersion           " 1.02 \341"
#define pDate              "24.02.2001"
#define eddixName          "  Fred" pVersion
#define whatString         "@(#)Fred " pVersion ", Copyright (c) 1997 Dirk Steins (Oct 26 1997)"
*/

#define FRED_RSC_BASE		"fred_"	/*DYJ 5.23e */
#define cCfgName           "fred.cfg"

/*DYJ 5.23e Start*/
/*DYJ  Ende; alt:	

#define sysStrOne          "Shell aufrufen"
#define blockSaveAs        "Block sichern als..."
#define saveAs             "Sichern als..."

#define AL_WRONG_WILD      "[2][%P:|Die Wildcardzeichen sind|nicht korrekt!|Bitte korrigieren Sie|Ihre Eingaben!][[OK]"
#define AL_WRONG_REPLACE   "[3][%P:|Die Zuordnung der Wildcards|ist nicht eindeutig!][[Abbruch]"
#define noSearchStr        "[3][%P:|Fehler im Suchmuster!|Suchstrings, die nur aus|Wildcardzeichen bestehen,|sind nicht erlaubt!][[Nochmal]"
#define noRscAlt           "[5][%P:|Kann das Resource-File|FRED.RSC nicht laden][[Schade..]"
#define noLowResAlt        "[4][%P:|Die gew\204hlte Aufl\224sung|ist zu niedrig|f\201r %P!][ [OK ]"

#define AL_CFG_NOT_FOUND   "[3][%P:|CFG-File nicht|gefunden!][[Abbruch]"
#define AL_CFG_WRONG_IDENT "[3][%P:|Diese Datei ist|keine CFG-Datei!][[Abbruch]"
#define AL_BLOCK_PRINT    "[2][%P:|Wollen Sie nur den Block drucken,|oder den gesamten Text?|][[Block|[Text|:[Abbruch]"	/*DYJ 1.02a */
#define AL_BLOCK_SAVE    "[2][%P:|Wollen Sie nur den Block speichern,|oder den gesamten Text?|][[Block|[Text]"	/*DYJ 1.02a */

#define FS_EXTERN          " Extern %d"
#define FS_SELECT_CFG      "CFG-Datei ausw\204hlen"
#define FS_SELECT_MAKEFILE "Makefile ausw\204hlen"
#define FS_LOAD_FILE       "Datei laden"
*/

#define CFG_NONAME         "noname.cfg"



/* Variablennamen fuer CFG-File */
#define cErrorExtension   "ErrorExtension"
#define cErrorMask        "ErrorMask"
#define cHelpLineLayout   "HelpLineLayout"
#define cProjectExtension "ProjectExtension"
#if 0
#define cExtension      "Extension"
#define cExtTabsize     "ExtTabSize"
#define cExtHardTabs    "ExtHardTabs"
#define cExtWordWrap    "ExtWordWrap"
#define cExtRightMargin "ExtRightMargin"
#define cExtAutoBackup  "ExtAutoBackup"
#endif
#define cSourcePath     "SourcePath"
#define cNormalFkey     "NormalF"
#define cAutoSavePrefs  "AutoSavePrefs"
#define cAutoSaveAction "AutoSaveBeforeAction"
#define cShortFile      "LastShortcutFile"

#define maxLineLength    4096
#define maxErrFiles     4

typedef struct _listRecord
{
	HWND wdw;
	_UBYTE fname[PATH_MAX];
} listRecord;

typedef listRecord errorArray[maxErrFiles];


GLOBAL _UBYTE ProgramName[] = "FRED";
GLOBAL _BOOL PrgHasDataBase=FALSE;		/*DYJ 5.26a */

#define hs "ST-GUIDE"


LOCAL _WORD errIndex;
LOCAL errorArray errFiles;



/* Wirklich benutzte Variable: */

LOCAL _UBYTE InSel[PATH_MAX];
LOCAL _UBYTE SaveName[PATH_MAX];

LOCAL _WORD SCAN;
LOCAL _UBYTE CH;
LOCAL _UWORD moButton;
LOCAL _WORD kReturn;
LOCAL _UWORD moKState;
LOCAL _WORD moX, moY;
LOCAL _WORD bReturn;
LOCAL _UWORD event;
LOCAL _UWORD e;
LOCAL _UBYTE scan, ch;
LOCAL _WORD mess[8];

LOCAL _BOOL mouse;

/* Adressen der Objektbaeume */
LOCAL OBJECT *menu;
LOCAL OBJECT *infoBox;
LOCAL OBJECT *aboutBox;
LOCAL OBJECT *lineBox;
LOCAL OBJECT *tabBox;
LOCAL OBJECT *umbruchBox;
LOCAL OBJECT *gotoBox;
LOCAL OBJECT *systemBox;
LOCAL OBJECT *pathBox;
LOCAL OBJECT *fredIcon;
LOCAL OBJECT *shortBox;
LOCAL OBJECT *errorBox;
LOCAL OBJECT *suchBox;

/* PFADE */
LOCAL _UBYTE InPath[PATH_MAX];
LOCAL _UBYTE SavePath[PATH_MAX];

/* Letzter Dateiname: */
LOCAL _UBYTE OpenName[PATH_MAX];

/* Falls TRUE, dann PROGRAMM beenden */
LOCAL _BOOL quitProg;
LOCAL _WORD termCode;					/* Return-Code fuer Shell */

/* Such- und Ersetzeinstellungen  */
LOCAL struct
{
	_BOOL isSet;
	_BOOL doIt;
	_BOOL ignoreCase;
	_BOOL askBack;
	_BOOL onlyWord;
	HWND theSearchWdw;
	searchDir direction;
	searchCount count;
	searchPos pos;
	_WORD number;
	_UBYTE searchStr[256];
	_UBYTE replaceStr[256];
} searchOpts, replaceOpts;


GLOBAL RESOURCE the_rsc;

GLOBAL List SrcPaths;
GLOBAL _UBYTE HomePath[PATH_MAX];

LOCAL shellType shell;					/* CLI type if available */

LOCAL _UBYTE infoName[PATH_MAX];

LOCAL _BOOL autoSavePos;
LOCAL _WORD filterNumber;


/* Fuer Kuerzeldateien */
LOCAL _BOOL shortFileRead;
LOCAL _UBYTE lastShort[PATH_MAX];



#define CR 0x0d
#define LF 0x0a


#define AL_NO_PROJECT "[1][%P:|Keine Shell fr dieses|Kommando gefunden.][.[Abbruch]"


/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

/* Kleiner Stack fuer Keyboard-Events */
#define maxKeys 16
typedef struct
{
	_UWORD kstate;
	_UBYTE scan;
	_UBYTE ch;
} kbdEvent;

LOCAL kbdEvent keyStack[maxKeys];
LOCAL _WORD keyWrite;
LOCAL _WORD keyRead;

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID PopKey(_UWORD *kstate, _UBYTE *scan, _UBYTE *ch)
{
	if (keyRead != keyWrite)
	{
		*kstate = keyStack[keyRead].kstate;
		*scan = keyStack[keyRead].scan;
		*ch = keyStack[keyRead].ch;
		keyRead = (keyRead + 1) % maxKeys;
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID PushKey(_UWORD kstate, _UBYTE scan, _UBYTE ch)
{
	keyStack[keyWrite].kstate = kstate;
	keyStack[keyWrite].scan = scan;
	keyStack[keyWrite].ch = ch;
	keyWrite = (keyWrite + 1) % maxKeys;
	if (keyWrite == keyRead)
	{
		/* hat keyRead eingeholt, einmal rum!
		 * keyRead auf naechsten setzen
		 */
		keyRead = (keyWrite + 1) % maxKeys;
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL PendingKey(_VOID)
{
	return keyRead != keyWrite;
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

LOCAL _VOID PathsToConf(_VOID)
{
	_UBYTE *entry;
	_WORD count;
	_UBYTE varname[128];

	Lists_ResetList(&SrcPaths);
	count = 1;
	while ((entry = Lists_NextEntry(&SrcPaths)) != NULL)
	{
		make_varname(varname, sizeof(varname), cSourcePath, count);
		ConfVars_SetConfigString(varname, entry);
		++count;
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL findName(_VOID *e, _VOID *i)
{
	CONST _UBYTE *entry;
	CONST _UBYTE *str;

	entry = e;
	str = i;
	return strCaseCmp(entry, str) == 0;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID ConfToPaths(_VOID)
{
	_UBYTE *entry;
	_UBYTE path[PATH_MAX];
	_WORD count;
	_UBYTE varname[128];

	Lists_CreateList(&SrcPaths, "ConfToPaths");
	count = 1;
	while (count < 255)
	{
		make_varname(varname, sizeof(varname), cSourcePath, count);
		if (ConfVars_GetConfigString(varname, path, sizeof(path)))
		{
			/* Erstmal sehen, ob der Pfad nicht schon in der Liste ist */
			Lists_ResetList(&SrcPaths);
			if (!Lists_ScanEntries(&SrcPaths, Lists_forward, findName, path))
			{
				entry = STRDUP(path, "ConfToPaths: path");
				if (!Lists_AppendEntry(&SrcPaths, entry))
				{
					SFREE(entry);
					return;
				}
			}
			ConfVars_DeleteConfigVar(varname);
		}
		++count;
	}
}

/*** ---------------------------------------------------------------------- ***/

/* laedt Default-Einstellungen und setzt diese,
 * falls kein INFOFILE vorhanden
 */
LOCAL _VOID LoadPrefs(_VOID)
{
	_UBYTE cfgFile[PATH_MAX];

	/* Jetzt INFOFILE holen
	 * Name: FRED.CFG
	 */
	strBcpy(infoName, HomePath);
	F_Path_Append(infoName, cCfgName);
	ConfVars_ReadConfigFile(infoName);
	ConfToPaths();
	UserInformation_ReadUserBlock();
	if (ConfVars_GetConfigString(cPrintCFGFile, cfgFile, sizeof(cfgFile)))
		Printer_LoadCFGFile(cfgFile);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID fredInfo(TEXTFILENO inf)
{
	_UBYTE tstr[80];

	mtTextfiles_WriteLine(inf, "# ");
	mtTextfiles_WriteLine(inf, whatString);
	mtTextfiles_WriteLn(inf);
	T_Strlftime(tstr, sizeof(tstr), "# created %0a %d %m %Y, %H:%M:%S", T_Systime());
	mtTextfiles_WriteLine(inf, tstr);
	mtTextfiles_WriteLn(inf);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID SavePrefs(_VOID)
{
	CatGlobal_ApplPath(infoName);
	F_Path_Append(infoName, cCfgName);
	Editor_EditSavePos();
	/* PFADE in Variable sichern */
	PathsToConf();
	ConfVars_WriteConfigFile(infoName, fredInfo);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID GetHomePath(_VOID)
{
	_UBYTE applpath[PATH_MAX];

	CatGlobal_SetAppl(ProgramName);
	CatGlobal_GetApplPath(applpath);
	strBcpy(HomePath, applpath);
	/* Aktuellen Pfad holen */
	F_Path_Get(InPath);
	strBcpy(SavePath, InPath);
}
/*** ------------------------------------------------------------------------ ***/
/*	_UBYTE *rsc_WrkString(_WORD nr)												*/
/*	Ermittelt einen freien oder Alertstring aus der fred_*.rsc					*/
/*	Parameter:	nr:	die Stringnummer											*/
/*	Ergebnis:	der String														*/		
/*	20.3.03 von Dimitri Junker	DYJ 5.23e										*/
/*** ------------------------------------------------------------------------ ***/
GLOBAL _UBYTE *rsc_WrkString(_WORD nr)
{
	static _UBYTE dummy[30];
	_UBYTE *ret;
	ret=*((_UBYTE **)RscGaddr(the_rsc, R_FRSTR, nr));
	if(!ret)
	{
		ret=dummy;
		sprintf(ret,"[3][NO RSC;Nr:L%d][OK]",nr);
	}
	return ret;
}

/*** ---------------------------------------------------------------------- ***/

/*DYJ 5.23e Start*/
LOCAL _BOOL InitResource(_VOID)
{
	_UBYTE nameEnd[20],resourceName[PATH_MAX];
/*DYJ  Ende; alt:	
LOCAL _BOOL InitResource(CONST _UBYTE *resourceName)
{
*/
	_UWORD screenColumns;

	GetHomePath();

	/* 80-Zeichen Bildschirm wird verlangt! */
	screenColumns = MaxWidth / CharWidth;

	if (screenColumns < 80)
	{
/*DYJ 5.23e Start*/
		mtAlerts_Alert(1, Rsc_WrkString(AL_RESOLUTION));
/*DYJ  Ende; alt:	
		mtAlerts_Alert(1, noLowResAlt);
*/
		return FALSE;
	}
	/* Resource laden und Baumaddressen ermitteln */
/*DYJ 5.21i Start*/
	{
/*DYJ 5.22f Start*/
/*DYJ 5.23e Start*/
		_UBYTE scrap[PATH_MAX],rsrcname[PATH_MAX];
/*DYJ  Ende; alt:	
		_UBYTE nameEnd[20],scrap[PATH_MAX],rsrcname[PATH_MAX];
*/
		CatGlobal_ApplPath(scrap);
		Rsc_EnvLang(scrap,nameEnd);
/*DYJ  Ende; alt:	
		_UBYTE *lang,nameEnd[20],scrap[PATH_MAX],rsrcname[PATH_MAX];
		TEXTFILENO tf;

		CatGlobal_ApplPath(scrap);
		if ((lang = getenv("CAT_LANG")) != NULL && *lang != '\0')
			strCpy(nameEnd,lang);
		else if (mtTextfiles_OpenTextfile(CAT_LANG_FILE, READ, 512, &tf) == GERR_OK)
		{
			mtTextfiles_ReadLine(tf, nameEnd, 5);
			mtTextfiles_CloseTextfile(&tf);
		}
		else
			strCpy(nameEnd,LANGUAGE_DE);
*/
		strCat(nameEnd,RSC_EXT);

		strCpy(rsrcname, CATL_RSC_BASE);
		strCat(rsrcname,nameEnd);

		if(!Rsc_RscInit(scrap,rsrcname))
		{
			sprintf(scrap,"[3][%%P|Konnte %s nicht laden|Could'nt load %s][OK]",rsrcname,rsrcname);
			mtAlerts_Alert(1,scrap);
			return FALSE;
		}
	}
/*DYJ  Ende;*/
/*DYJ 5.23e Start*/
	strCpy(resourceName, FRED_RSC_BASE);
	strCat(resourceName,nameEnd);
/*DYJ  Ende; */
	the_rsc = RscLoad(resourceName);

#if 0
/* Sollte eigentlich ueberfluessig sein, da rsrcload ein shelfind macht!  */
	if (the_rsc == NULL)
	{
		_BOOL found;
		_UBYTE rscString[PATH_MAX];

		/* Auf den Shellpfaden suchen! */
		Paths_SearchFile(resourceName, &StdPaths, fromStart, &found, rscString);
		if (found)
		{
			the_rsc = RscLoad(rscString);
		}
	}
#endif

	if (the_rsc == NULL)
	{
		the_rsc = RscLoad("fredrsc.rsc");
	}
	if (the_rsc == NULL)
	{
/*DYJ 5.21i Start*/
		_UBYTE scrap[100];
		mtAlerts_SetIconColor(RED);
		sprintf(scrap,Rsc_WrkString(AL_NO_RSC),resourceName);
		mtAlerts_Alert(1,scrap );
		mtAlerts_SetIconColor(BLACK);
/*DYJ  Ende; alt:	
		mtAlerts_SetIconColor(RED);
		mtAlerts_Alert(1, noRscAlt);
*/
		return FALSE;
	}
	LoadPrefs();

	infoBox = RscGaddr(the_rsc, R_TREE, FILEINFO);
	aboutBox = RscGaddr(the_rsc, R_TREE, ABOUTBOX);
	lineBox = RscGaddr(the_rsc, R_TREE, LINEBOX);
	tabBox = RscGaddr(the_rsc, R_TREE, TABBOX);
	umbruchBox = RscGaddr(the_rsc, R_TREE, UMBRUCH);
	gotoBox = RscGaddr(the_rsc, R_TREE, GOTOBOX);
	systemBox = RscGaddr(the_rsc, R_TREE, SYSTEMBX);
	suchBox = RscGaddr(the_rsc, R_TREE, SUCHBOX);
	pathBox = RscGaddr(the_rsc, R_TREE, PFADE);
	fredIcon = RscGaddr(the_rsc, R_TREE, FREDICON);
	shortBox = RscGaddr(the_rsc, R_TREE, SHORTBOX);
	errorBox = RscGaddr(the_rsc, R_TREE, ERRBOX);
	menu = RscGaddr(the_rsc, R_TREE, MENU);

	/* Versionsnummer einsetzen */
/*DYJ 5.23p Start*/
	SetObjcString(aboutBox, VERSION, CatVersion);
	SetObjcString(aboutBox, VDATE, CatDate);
/*DYJ  Ende; alt:	
	SetObjcString(aboutBox, VERSION, pVersion);
	SetObjcString(aboutBox, VDATE, pDate);
*/

	/* Bit Images anpassen */
#if 0
	transObj(aboutBox, EDIXLOGO, VDIHandle);
	transObj(aboutBox, LOGO2, VDIHandle);
#endif

#if 0
	/* Behalten fuer Slider bei Laden/Speichern */
	/* Infoslider anpassen: Fuellmuster auf solid setzen */
	if (Bitplanes > 1)
	{
		OBSPEC_SET_INTERIORCOL(actBox[INFOSLID].ob_spec, RED);
		OBSPEC_SET_FILLPATTERN(actBox[INFOSLID].ob_spec, IP_SOLID);
	}
#endif

	SetObjcStringAdr(systemBox, SYSTITLE, Rsc_WrkString(sysStrOne), sizeof(Rsc_WrkString(sysStrOne)));	/*DYJ 5.23e */
	shell = ShellCall_IsShell();
	if (shell == noShell)
	{
		menu_ienable(menu, CALLSHEL, 0);
	}
	WdwManager_EnableIconify(TRUE);
	WdwManager_SetWindowIcon(fredIcon);
	return TRUE;
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

/* Nur fuer nicht-MultiTOS geeignet */
GLOBAL _VOID FullScreenRedraw(_VOID)
{
	GRECT rec;

	rec.g_x = 0;
	rec.g_y = 0;
	rec.g_w = MaxWidth;
	rec.g_h = MaxHeight;
	Form_dial(FMD_FINISH, &rec, &rec);
	menu_bar(RscGaddr(the_rsc, R_TREE, MENU), 1);
}

/*** ---------------------------------------------------------------------- ***/

#if 0
LOCAL _BOOL InitDial(_WORD treeIdx, OBJECT *tree)
{
	GRECT r;

	tree = RscGaddr(the_rsc, R_TREE, treeIdx);
	if (!mtDials_NewDial(tree))
		return FALSE;
	mtDials_DialCenter(tree, CSCREEN, 0, 0, &r);
	return TRUE;
}
#endif

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL GetItem(OBJECT *dial, _WORD item)
{
	return GetObjState(dial, item, SELECTED);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID SetItem(OBJECT *dial, _WORD item, _BOOL b)
{
	EnableObjState(dial, item, SELECTED, b);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _WORD FormHandle(_WORD treeIdx)
{
	_WORD exit;
	OBJECT *form;

#if 0
	if (!InitDial(treeIdx, form))
		return -1;
	Wind_Update(BEG_UPDATE);
	mtDials_DialForm(form, DSTART, &r, &r);
	mtDials_DialDraw(form, 0, 200, &r, FALSE);
	exit = mtDials_DialDo(form, 0);
	exit &= 0x7fff;
	mtDials_DialForm(form, DFINISH, &r, &r);
	Wind_Update(END_UPDATE);
	DelObjState(form, exit, SELECTED);
	mtDials_DisposeDial(form);
#endif
	form = RscGaddr(the_rsc, R_TREE, treeIdx);
	exit = WinDials_WinDialDo(form, 0);
	exit &= 0x7fff;
	return exit;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL searchButton(OBJECT *tree, _VOID *env, _WORD button, _WORD mx, _WORD my, _UWORD kstate, _WORD clicks)
{
	_UBYTE allChar[2], oneChar[2];
	GRECT r;

	UNUSED(env);
	UNUSED(mx);
	UNUSED(my);
	UNUSED(kstate);
	UNUSED(clicks);
	button &= 0x7fff;
	DelObjState(tree, button, SELECTED);
	if (button == SROK)
	{
		ObjcString(tree, SQALL, allChar, sizeof(allChar));
		ObjcString(tree, SQONE, oneChar, sizeof(oneChar));
		if (allChar[0] == oneChar[0] || allChar[0] == '\0' || oneChar[0] == '\0')
		{
			mtAlerts_Alert(1, Rsc_WrkString(AL_WRONG_WILD));	/*DYJ 5.23e */
			WinDials_WinDialDraw(tree, button, MAX_DEPTH, &r, FALSE);
			return FALSE;
		}
		/* String auslesen */
		ObjcString(tree, SSUCHSTR, searchOpts.searchStr, sizeof(searchOpts.searchStr));
		/* Jetzt Suchstring ueberpruefen, ob nur Wildcards drin sind */
		if (strLen(searchOpts.searchStr) == 0)	/*DYJ 5.20w */
		{
			/* Leerer String geht auch */
			return TRUE;
		}
		/* Jetzt der eigentliche Test */
		while ((searchOpts.searchStr[0] == allChar[0] || searchOpts.searchStr[0] == oneChar[0]) &&
			   searchOpts.searchStr[0] != '\0')
		{
			strCpy(searchOpts.searchStr, searchOpts.searchStr + 1);	/*DYJ 5.20w */
			if (searchOpts.searchStr[0] == '\0')
			{
/*DYJ 5.23e Start*/
				mtAlerts_Alert(1, Rsc_WrkString(MTE_noSearchStr));
/*DYJ  Ende; alt:	
				mtAlerts_Alert(1, noSearchStr);
*/
				WinDials_WinDialDraw(tree, button, MAX_DEPTH, &r, FALSE);
			}
		}
		if (searchOpts.searchStr != '\0')
			return TRUE;
#if 0
	} else if (button == FINDHELP)
	{
		CatHelp_DoHelp(CatHelp_textsearch);
#endif
	} else
	{
		return TRUE;
	}
	WinDials_WinDialDraw(tree, button, MAX_DEPTH, &r, FALSE);
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID searchGetSetValues(OBJECT *tree, _VOID *env, _BOOL set, _WORD exit)
{
	_UBYTE allChar[2], oneChar[2];

	UNUSED(env);
	if (set)
	{
		Editor_GetWildChars(oneChar, allChar);
		SetObjcString(tree, SQALL, allChar);
		SetObjcString(tree, SQONE, oneChar);
		SetObjcString(tree, SSUCHSTR, searchOpts.searchStr);
	} else
	{
		exit &= 0x7fff;
		DelObjState(tree, exit, SELECTED);
		if (exit == SROK)
		{
			searchOpts.isSet = TRUE;
			/* Strings auslesen */
			searchOpts.ignoreCase = GetItem(tree, SCASE);
			searchOpts.onlyWord = GetItem(tree, SWORD);
			/* Startposition suchen */
			if (GetItem(tree, SFROMTOP))
				searchOpts.pos = fromStart;
			else if (GetItem(tree, SFROMCUR))
				searchOpts.pos = fromPos;
			/* Anzahl feststellen */
			searchOpts.count = searchOne;
			/* letzte Parameter */
			ObjcString(tree, SQALL, allChar, sizeof(allChar));
			ObjcString(tree, SQONE, oneChar, sizeof(oneChar));
			if (allChar[0] == oneChar[0] || allChar[0] == '\0' || oneChar[0] == '\0')
				mtAlerts_Alert(1, Rsc_WrkString(AL_WRONG_WILD));	/*DYJ 5.23e */
			else
				Editor_SetWildChars(oneChar[0], allChar[0]);
			ObjcString(tree, SSUCHSTR, searchOpts.searchStr, sizeof(searchOpts.searchStr));
			if (Editor_IsEditTop(searchOpts.theSearchWdw))
			{
				searchOpts.doIt = TRUE;
			}
		}
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID DoSearchDialogue(HWND win)
{
	OBJECT *form;

	form = RscGaddr(the_rsc, R_TREE, SUCHBOX);
	if (Editor_IsEditTop(win))
	{
		searchOpts.theSearchWdw = win;
		searchOpts.doIt = FALSE;
		if (!WinDials_OpenWinDial(form, TRUE,
			searchGetSetValues,
			searchGetSetValues,
			searchButton,
			WinDials_defDraw,
			"",
			NULL))
		{
			return;
		}
		WinDials_WinDialHandleEvents();
		if (searchOpts.doIt)
		{
			WdwManager_HandlePendingEvents();
			Editor_Search(searchOpts.theSearchWdw,
				searchOpts.searchStr,
				searchOpts.pos,
				searchOpts.direction,
				searchOpts.count,
				1,
				searchOpts.ignoreCase,
				searchOpts.onlyWord,
				FALSE,
				cBingNothingFound);
		}
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID SearchAgain(HWND wdw, _UWORD kstate)
{
	searchDir sDir;

	if (Editor_IsEditTop(wdw))
	{
		searchOpts.pos = fromPos;
		if (CatGlobal_WithShift(kstate))
		{
			if (searchOpts.direction == sdir_forward)
			{
				sDir = sdir_backward;
			} else
			{
				sDir = sdir_forward;
			}
		} else
		{
			sDir = searchOpts.direction;
		}
		Editor_Search(wdw,
			searchOpts.searchStr,
			searchOpts.pos,
			sDir,
			searchOpts.count,
			searchOpts.number,
			searchOpts.ignoreCase,
			searchOpts.onlyWord,
			TRUE,
			cBingNothingFound);
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID SearchBlock(HWND wdw, _UWORD kstate)
{
	_UBYTE *text;
	_ULONG len;

	if (Editor_IsEditTop(wdw))
	{
		if (!Editor_BlockIsMarked(wdw))
			Editor_MarkWord(wdw);
		if (Editor_BlockIsMarked(wdw))
		{
			if (Editor_GetBlock(wdw, FALSE, FALSE, &text, &len) && text != NULL)
			{
				strBcpy(searchOpts.searchStr, text);
				SFREE(text);
			}
		} else
		{
			return;
		}
		searchOpts.isSet = TRUE;
		if (CatGlobal_WithShift(kstate))
			searchOpts.pos = fromStart;
		else
			searchOpts.pos = fromPos;
		searchOpts.direction = sdir_forward;
		searchOpts.count = searchOne;
		searchOpts.onlyWord = FALSE;
		Editor_Search(wdw,
			searchOpts.searchStr,
			searchOpts.pos,
			searchOpts.direction,
			searchOpts.count,
			searchOpts.number,
			searchOpts.ignoreCase,
			searchOpts.onlyWord,
			FALSE,
			cBingNothingFound);
	}
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

LOCAL _BOOL replaceButton(OBJECT *tree, _VOID *env, _WORD button, _WORD mx, _WORD my, _UWORD kstate, _WORD clicks)
{
	_UBYTE allChar[2], oneChar[2];
	GRECT r;

	UNUSED(env);
	UNUSED(mx);
	UNUSED(my);
	UNUSED(kstate);
	UNUSED(clicks);

	button &= 0x7fff;
	switch (button)
	{
	case RGESAMT:
	case REINMAL:
		SetObjState(tree, RCOUNT, DISABLED);
		DelObjFlags(tree, RCOUNT, EDITABLE);
		WinDials_WinDialDraw(tree, RCOUNT, 0, &r, FALSE);
		return FALSE;

	case RNMAL:
		DelObjState(tree, RCOUNT, DISABLED);
		SetObjFlags(tree, RCOUNT, EDITABLE);
		WinDials_WinDialDraw(tree, RCOUNT, 0, &r, FALSE);
		return FALSE;

	case RROK:
	case RRQUIT:
		DelObjState(tree, button, SELECTED);
		if (button == RROK)
		{
			ObjcString(tree, RRQALL, allChar, sizeof(allChar));
			ObjcString(tree, RRQONE, oneChar, sizeof(oneChar));
			if (allChar[0] == oneChar[0] || allChar[0] == '\0' || oneChar[0] == '\0')
			{
				mtAlerts_Alert(1, Rsc_WrkString(AL_WRONG_WILD));	/*DYJ 5.23e */
				WinDials_WinDialDraw(tree, button, MAX_DEPTH, &r, FALSE);
				return FALSE;
			}
			/* String auslesen */
			ObjcString(tree, RSUCHSTR, replaceOpts.searchStr, sizeof(replaceOpts.searchStr));
			/* Jetzt Suchstring ueberpruefen, ob nur Wildcards drin sind */
			if (*replaceOpts.searchStr == '\0')
			{
				/* Leerer String geht auch */
				return TRUE;
			}
			/* Jetzt der eigentliche Test */
			while ((replaceOpts.searchStr[0] == allChar[0] || replaceOpts.searchStr[0] == oneChar[0]) &&
				   *replaceOpts.searchStr != '\0')
			{
				strCpy(replaceOpts.searchStr, replaceOpts.searchStr + 1);	/*DYJ 5.20w */
				if (*replaceOpts.searchStr == '\0')
				{
/*DYJ 5.23e Start*/
					mtAlerts_Alert(1, Rsc_WrkString(MTE_noSearchStr));
/*DYJ  Ende; alt:	
					mtAlerts_Alert(1, noSearchStr);
*/
					WinDials_WinDialDraw(tree, button, MAX_DEPTH, &r, FALSE);
				}
			}
			if (*replaceOpts.searchStr != '\0')
				return TRUE;
		} else
		{
			return TRUE;
		}
		WinDials_WinDialDraw(tree, button, MAX_DEPTH, &r, FALSE);
		break;

#if 0
	case REPLHELP:
		DelObjState(tree, button, SELECTED);
		CatHelp_DoHelp(CatHelp_textrepl);
		WinDials_WinDialDraw(tree, button, MAX_DEPTH, &r, FALSE);
		break;
#endif
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID replaceGetSetValues(OBJECT *tree, _VOID *env, _BOOL set, _WORD exit)
{
	_UBYTE allChar[2], oneChar[2];
	_UBYTE numStr[10];
	_UBYTE *text;
	_ULONG len;

	UNUSED(env);
	if (set)
	{
		if (Editor_BlockIsMarked(replaceOpts.theSearchWdw))
		{
			if (Editor_GetBlock(replaceOpts.theSearchWdw, FALSE, FALSE, &text, &len) && text != NULL)
			{
				strBcpy(replaceOpts.searchStr, text);
				SFREE(text);
			}
		}
		Editor_GetWildChars(oneChar, allChar);
		SetObjcString(tree, RRQALL, allChar);
		SetObjcString(tree, RRQONE, oneChar);
		SetObjcString(tree, RSUCHSTR, replaceOpts.searchStr);
		SetObjcString(tree, RREPLSTR, replaceOpts.replaceStr);
		if (GetItem(tree, RNMAL))
		{
			DelObjState(tree, RCOUNT, DISABLED);
			SetObjFlags(tree, RCOUNT, EDITABLE);
		} else
		{
			SetObjState(tree, RCOUNT, DISABLED);
			DelObjFlags(tree, RCOUNT, EDITABLE);
		}
	} else
	{
		exit &= 0x7fff;
		DelObjState(tree, exit, SELECTED);
		if (exit == RROK)
		{
			replaceOpts.isSet = TRUE;
			/* Strings auslesen */
			replaceOpts.ignoreCase = GetItem(tree, RCASE);
			replaceOpts.onlyWord = GetItem(tree, RWORD);
			/* Startposition suchen */
			if (GetItem(tree, RFROMTOP))
				replaceOpts.pos = fromStart;
			else
				replaceOpts.pos = fromPos;
			/* Suchrichtung feststellen */
			replaceOpts.direction = sdir_forward;
			/* Anzahl feststellen */
			if (GetItem(tree, REINMAL))
			{
				replaceOpts.count = searchOne;
			} else if (GetItem(tree, RGESAMT))
			{
				replaceOpts.count = searchAll;
			} else
			{
				replaceOpts.count = searchNum;
				ObjcString(tree, RCOUNT, numStr, sizeof(numStr));
				replaceOpts.number = StrToInt(numStr, NULL, NULL);
			}
			/* letzte Parameter */
			replaceOpts.askBack = GetItem(tree, RASKBACK);
			/* Jetzt noch feststellen, ob Suchen oder Ersetzen */
			ObjcString(tree, RSUCHSTR, replaceOpts.searchStr, sizeof(replaceOpts.searchStr));
			ObjcString(tree, RREPLSTR, replaceOpts.replaceStr, sizeof(replaceOpts.replaceStr));
			ObjcString(tree, RRQALL, allChar, sizeof(allChar));
			ObjcString(tree, RRQONE, oneChar, sizeof(oneChar));
			if (allChar[0] == oneChar[0] || allChar[0] == '\0' || oneChar[0] == '\0')
				mtAlerts_Alert(1, Rsc_WrkString(AL_WRONG_WILD));	/*DYJ 5.23e */
			else
				Editor_SetWildChars(oneChar[0], allChar[0]);
			if (EditTools_CheckWildAssign(replaceOpts.searchStr, replaceOpts.replaceStr))
				replaceOpts.doIt = TRUE;
			else
				mtAlerts_Alert(1, Rsc_WrkString(AL_WRONG_REPLACE));	/*DYJ 5.23e */
		}
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID DoReplaceDialogue(HWND win)
{
	OBJECT *form;

	form = RscGaddr(the_rsc, R_TREE, ERSETZBX);
	if (Editor_IsEditTop(win))
	{
		replaceOpts.theSearchWdw = win;
		replaceOpts.doIt = FALSE;
		if (!WinDials_OpenWinDial(form, TRUE,
			replaceGetSetValues,
			replaceGetSetValues,
			replaceButton,
			WinDials_defDraw,
			NULL,
			NULL))
		{
			return;
		}
		WinDials_WinDialHandleEvents();
		if (replaceOpts.doIt)
		{
			WdwManager_HandlePendingEvents();
			Editor_SearchAndReplace(replaceOpts.theSearchWdw,
				replaceOpts.searchStr,
				replaceOpts.replaceStr,
				replaceOpts.pos,
				replaceOpts.direction,
				replaceOpts.count,
				replaceOpts.number,
				replaceOpts.ignoreCase,
				replaceOpts.onlyWord,
				replaceOpts.askBack,
				FALSE);
		}
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID ReplaceAgain(HWND wdw, _UWORD kstate)
{
	searchDir sDir;

	if (Editor_IsEditTop(wdw))
	{
		replaceOpts.pos = fromPos;
		if (CatGlobal_WithShift(kstate))
		{
			if (replaceOpts.direction == sdir_forward)
				sDir = sdir_backward;
			else
				sDir = sdir_forward;
		} else
		{
			sDir = replaceOpts.direction;
		}
		Editor_SearchAndReplace(wdw,
			replaceOpts.searchStr,
			replaceOpts.replaceStr,
			replaceOpts.pos,
			sDir,
			replaceOpts.count,
			replaceOpts.number,
			replaceOpts.ignoreCase,
			replaceOpts.onlyWord,
			replaceOpts.askBack,
			TRUE);
	}
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

#define FILT_EXT (FILTSEL_HIGH_EXT - FILTSEL_LOW_EXT + 1)
#define FILT_MAX  FILTSEL_HIGH_EXT

typedef struct
{
	_WORD filterNumber;
	_UBYTE cmd[256];
	_WORD exitBut;
	OBJECT *filtSel;
} blockInfo;

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID BuildFilterPopup(_WORD filterNumber, OBJECT ** pfiltSel, _BOOL forDial)
{
	_WORD i;
	_UBYTE varname[128];
	_UBYTE cmd[128];
	OBJECT *filterBox;
	OBJECT *filtSel;
	_BOOL isDa;

	filterBox = RscGaddr(the_rsc, R_TREE, FILTBOX);
	filtSel = *pfiltSel = RscGaddr(the_rsc, R_TREE, FILTSEL);
	SetObjcString(filterBox, FBCOMM, "");
	for (i = FILTSEL_LOW_EXT; i <= FILTSEL_HIGH_EXT; i++)
	{
		make_varname(varname, sizeof(varname), cBlockFilter, i - FILTSEL_LOW_EXT + 1);
		isDa = ConfVars_GetConfigString(varname, cmd, sizeof(cmd));
		if (isDa)
		{
			if (i - 1 == filterNumber)
			{
				/* String setzen */
				SetObjcString(filterBox, FBCOMM, cmd);
			}
			strInsertChar(' ', cmd, sizeof(cmd));
		} else
		{
			/* Extern X anlegen */
			sprintf(cmd, Rsc_WrkString(FS_EXTERN), i - FILTSEL_LOW_EXT + 1);	/*DYJ 5.23e */
		}
		EnableObjState(filtSel, i, DISABLED, !isDa && !forDial);
		EnableObjFlags(filtSel, i, SELECTABLE, isDa || forDial);
		SetObjcString(filtSel, i, cmd);
	}
	if (ShellCall_IsShell() == noShell)
	{
		for (i = FILTSEL_LOW_EXT; i <= FILTSEL_HIGH_EXT; i++)
		{
			SetObjState(filtSel, i, DISABLED);
			DelObjFlags(filtSel, i, SELECTABLE);
		}
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL blockButton(OBJECT *tree, _VOID *env, _WORD button, _WORD mx, _WORD my, _UWORD kstate, _WORD clicks)
{
	GRECT r;
	blockInfo *infoPtr;
	_WORD x, y;
	_WORD select;
	_UBYTE varname[128];

	UNUSED(mx);
	UNUSED(my);
	UNUSED(kstate);
	UNUSED(clicks);

	infoPtr = env;
	button &= 0x7fff;
	switch (button)
	{
	case FBOK:
	case FBQUIT:
		DelObjState(tree, button, SELECTED);
		return TRUE;

#if 0
	case FBHELP:
		CatHelp_DoHelp(CatHelp_filter);
		DelObjState(tree, button, SELECTED);
		WinDials_WinDialDraw(tree, button, 1, &r, FALSE);
		break;
#endif

	case FBFILT0:
	case FBFILT1:
		objc_offset(tree, FBFILT1, &x, &y);
		select = mtPopups_TreePopup(infoPtr->filtSel, x, y, VDIUtil_GetXState(tree, FBFILT1)) - 1;
		if (ShellCall_IsShell() == noShell && select >= FILTSEL_LOW_EXT)
			select = -1;
		if (select >= 0)
		{
			VDIUtil_SetXState(tree, FBFILT1, select);
			VDIUtil_SetXString(tree, FBFILT1, infoPtr->filtSel, select);
			if (select >= FILTSEL_LOW_EXT - 1)
			{
				make_varname(varname, sizeof(varname), cBlockFilter, select - FILTSEL_LOW_EXT + 2);
				ConfVars_GetConfDefStr(varname, infoPtr->cmd, sizeof(infoPtr->cmd), "");
				SetObjcString(tree, FBCOMM, infoPtr->cmd);
			} else
			{
				SetObjcString(tree, FBCOMM, "");
			}
			WinDials_WinDialDraw(tree, FBCOMM, 0, &r, FALSE);
			WinDials_WinDialDraw(tree, FBFILT1, 0, &r, FALSE);
		}
	case FBFILT2:
		select = VDIUtil_GetXState(tree, FBFILT1);
		if (ShellCall_IsShell() != noShell)
			select = (select + 1) % FILT_MAX;
		else
			select = (select + 1) % (FILT_MAX - FILT_EXT);
		VDIUtil_SetXState(tree, FBFILT1, select);
		VDIUtil_SetXString(tree, FBFILT1, infoPtr->filtSel, select);
		if (select >= FILTSEL_LOW_EXT - 1)
		{
			make_varname(varname, sizeof(varname), cBlockFilter, select - FILTSEL_LOW_EXT + 2);
			ConfVars_GetConfDefStr(varname, infoPtr->cmd, sizeof(infoPtr->cmd), "");
			SetObjcString(tree, FBCOMM, infoPtr->cmd);
		} else
		{
			SetObjcString(tree, FBCOMM, "");
		}
		WinDials_WinDialDraw(tree, FBCOMM, 0, &r, FALSE);
		WinDials_WinDialDraw(tree, FBFILT1, 0, &r, FALSE);
		break;
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID blockGetSetValues(OBJECT *tree, _VOID *env, _BOOL set, _WORD exit)
{
	blockInfo *infoPtr;
	_UBYTE varname[128];

	infoPtr = env;
	infoPtr->exitBut = exit & 0x7fff;
	if (set)
	{
		BuildFilterPopup(infoPtr->filterNumber, &infoPtr->filtSel, TRUE);
		/* vorbereiten */
		VDIUtil_SetXState(tree, FBFILT1, infoPtr->filterNumber);
		VDIUtil_SetXString(tree, FBFILT1, infoPtr->filtSel, infoPtr->filterNumber);
	} else
	{
		if (infoPtr->exitBut == FBOK)
		{
			infoPtr->filterNumber = VDIUtil_GetXState(tree, FBFILT1);
			if (infoPtr->filterNumber >= FILTSEL_LOW_EXT - 1)
			{
				/* String auslesen */
				ObjcString(tree, FBCOMM, infoPtr->cmd, sizeof(infoPtr->cmd));
				strleft(infoPtr->cmd);
				strdelRightSpace(infoPtr->cmd);
				make_varname(varname, sizeof(varname), cBlockFilter, infoPtr->filterNumber - FILTSEL_LOW_EXT + 2);
				if (infoPtr->cmd[0] != '\0')
					ConfVars_SetConfigString(varname, infoPtr->cmd);
				else
					ConfVars_DeleteConfigVar(varname);
			}
		}
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL doFilter(_WORD *filterNumber, _UBYTE *cmd, size_t strsize)
{
	OBJECT *filterBox;
	blockInfo *infoPtr;
	_BOOL result;

	if (*filterNumber < 0)
		*filterNumber = 0;
	filterBox = RscGaddr(the_rsc, R_TREE, FILTBOX);
	infoPtr = NEW(blockInfo, "doFilter");
	if (infoPtr == NULL)
		return FALSE;
	strBcpy(infoPtr->cmd, cmd);
	infoPtr->filterNumber = *filterNumber;

	if (!WinDials_OpenWinDial(filterBox, TRUE,
		blockGetSetValues,
		blockGetSetValues,
		blockButton,
		WinDials_defDraw,
		NULL,
		infoPtr))
	{
		OFREE(infoPtr);
		return FALSE;
	}
	/* Da wir die Ergebnisse brauchen, muessen wir hier die Eventroutine
	 * aufrufen
	 */
	WinDials_WinDialHandleEvents();

	*filterNumber = infoPtr->filterNumber;
	strMcpy(cmd, strsize, infoPtr->cmd);

	result = infoPtr->exitBut == FBOK;

	OFREE(infoPtr);

	return result;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL doPopupFilter(_WORD *filterNumber, _UBYTE *cmd, size_t strsize)
{
	OBJECT *filtSel;
	_WORD x, y;
	_UBYTE varname[128];
	_WORD fNumber;
	_UWORD udummy;

	if (*filterNumber < 0)
		*filterNumber = 0;
	BuildFilterPopup(*filterNumber, &filtSel, FALSE);
	graf_mkstate(&x, &y, &udummy, &udummy);
	fNumber = mtPopups_TreePopup(filtSel, x, y, 0) - 1;
	if (fNumber >= 0)
		*filterNumber = fNumber;
	if (fNumber >= FILTSEL_LOW_EXT - 1)
	{
		/* String auslesen */
		make_varname(varname, sizeof(varname), cBlockFilter, fNumber - FILTSEL_LOW_EXT + 2);
		if (ConfVars_GetConfigString(varname, cmd, strsize))
			return TRUE;
		return FALSE;
	}
	return fNumber >= 0;
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

typedef struct
{
	_UBYTE cfgFile[PATH_MAX];
	_UBYTE cfgPath[PATH_MAX];
	_UBYTE cfgName[PATH_MAX];
	_UBYTE cfgExt[PATH_MAX];
} printerInfo;


LOCAL _BOOL printerButton(OBJECT *tree, _VOID *env, _WORD button, _WORD mx, _WORD my, _UWORD kstate, _WORD clicks)
{
	GRECT r;
	OBJECT *prnStyleSel;
	OBJECT *prnIFSel;
	_WORD x, y;
	_WORD select;
	_BOOL res;
	_UBYTE name[PATH_MAX];
	printerInfo *prInfo;
	tResponse Response;

	UNUSED(mx);
	UNUSED(my);
	UNUSED(kstate);
	UNUSED(clicks);

	button &= 0x7fff;
	prInfo = env;
/*DYJ 5.23e Start*/
	prnStyleSel = TreeAddrLib[PSIZEBOX_L];
	prnIFSel  = TreeAddrLib[IFBOX_L];
/*DYJ  Ende; alt:	
	prnStyleSel = RscGaddr(the_rsc, R_TREE, PSIZEBOX);
	prnIFSel = RscGaddr(the_rsc, R_TREE, IFBOX);
*/
	switch (button)
	{
	case OPRTSIZ0:
	case OPRTSIZ1:
		objc_offset(tree, OPRTSIZ1, &x, &y);
		select = mtPopups_TreePopup(prnStyleSel, x, y, VDIUtil_GetXState(tree, OPRTSIZ1)) - 1;
		if (select >= 0)
		{
			VDIUtil_SetXState(tree, OPRTSIZ1, select);
			VDIUtil_SetXString(tree, OPRTSIZ1, prnStyleSel, select);
			WinDials_WinDialDraw(tree, OPRTSIZ1, 0, &r, FALSE);
		}
		break;

	case OPRTSIZ2:
		select = VDIUtil_GetXState(tree, OPRTSIZ1);
		select = (select + 1) % 3;
		VDIUtil_SetXState(tree, OPRTSIZ1, select);
		VDIUtil_SetXString(tree, OPRTSIZ1, prnStyleSel, select);
		WinDials_WinDialDraw(tree, OPRTSIZ1, 0, &r, FALSE);
		break;

	case OINTERFC0:
	case OINTERFC1:
		objc_offset(tree, OINTERFC1, &x, &y);
		select = mtPopups_TreePopup(prnIFSel, x, y, VDIUtil_GetXState(tree, OINTERFC1)) - 1;
		if (select >= 0)
		{
			VDIUtil_SetXState(tree, OINTERFC1, select);
			VDIUtil_SetXString(tree, OINTERFC1, prnIFSel, select);
			WinDials_WinDialDraw(tree, OINTERFC1, 0, &r, FALSE);
		}
		break;

	case OINTERFC2:
		select = VDIUtil_GetXState(tree, OINTERFC1);
		select = (select + 1) % 2;
		VDIUtil_SetXState(tree, OINTERFC1, select);
		VDIUtil_SetXString(tree, OINTERFC1, prnIFSel, select);
		WinDials_WinDialDraw(tree, OINTERFC1, 0, &r, FALSE);
		break;

	case OSELCFG0:
	case OSELCFG:
		button = OSELCFG;
		res = mtDir_FselGet(prInfo->cfgPath, prInfo->cfgName, "*.cfg", Rsc_WrkString(FS_SELECT_CFG), TRUE);	/*DYJ 5.23e */
		if (res && prInfo->cfgName[0] != '\0')
		{
			strBcpy(prInfo->cfgFile, prInfo->cfgPath);
			F_Path_Append(prInfo->cfgFile, prInfo->cfgName);
			Response = Printer_LoadCFGFile(prInfo->cfgFile);
			if (Response == Printer_CFGnotFound)
			{
				mtAlerts_Alert(1, Rsc_WrkString(AL_CFG_NOT_FOUND));	/*DYJ 5.23e */
			} else if (Response == Printer_wrongIdent)
			{
				mtAlerts_Alert(1, Rsc_WrkString(AL_CFG_WRONG_IDENT));	/*DYJ 5.23e */
			} else if (Response == Printer_done)
			{
				Printer_GetPrnName(name, sizeof(name));
				SetObjcString(tree, OSELCFG, prInfo->cfgName);
				SetObjcString(tree, PRINTNAME, name);
				CalcArea(tree, PRINTNAME, &r);
				WinDials_WinDialDraw(tree, ROOT, MAX_DEPTH, &r, TRUE);
			}
		} else if (res)
		{
			Printer_FreeCFGFile();
			prInfo->cfgFile[0] = '\0';
			Printer_GetPrnName(name, sizeof(name));
			SetObjcString(tree, PRINTNAME, name);
			strBcpy(prInfo->cfgName, CFG_NONAME);
			SetObjcString(tree, OSELCFG, prInfo->cfgName);
			CalcArea(tree, PRINTNAME, &r);
			WinDials_WinDialDraw(tree, ROOT, MAX_DEPTH, &r, TRUE);
		}
		DelObjState(tree, button, SELECTED);
		WinDials_WinDialDraw(tree, button, 0, &r, FALSE);
		break;

	case PROK:
	case PRCANCEL:
		DelObjState(tree, button, SELECTED);
		return TRUE;
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID printerGetSetValues(OBJECT *tree, _VOID *env, _BOOL set, _WORD exit)
{
	OBJECT *prnStyleSel;
	OBJECT *prnIFSel;
	_BOOL val;
	_WORD intVal;
	_UBYTE name[PATH_MAX];
	printerInfo *prInfo;

	prInfo = env;
/*DYJ 5.23e Start*/
	prnStyleSel = TreeAddrLib[PSIZEBOX_L];
	prnIFSel  = TreeAddrLib[IFBOX_L];
/*DYJ  Ende; alt:	
	prnStyleSel = RscGaddr(the_rsc, R_TREE, PSIZEBOX);
	prnIFSel = RscGaddr(the_rsc, R_TREE, IFBOX);
*/
	if (set)
	{
		/* Noch Namen des CFG-Files */
		if (ConfVars_GetConfigString(cPrintCFGFile, prInfo->cfgFile, sizeof(prInfo->cfgFile)))
		{
			mtDir_SplitPath(prInfo->cfgFile, prInfo->cfgPath, prInfo->cfgName, prInfo->cfgExt);
		} else
		{
			prInfo->cfgFile[0] = '\0';
			strBcpy(prInfo->cfgName, CFG_NONAME);
			strBcpy(prInfo->cfgPath, HomePath);
		}
		SetObjcString(tree, OSELCFG, prInfo->cfgName);

		ConfVars_GetConfDefInt(cPrintLeftMargin, &intVal, 0);
		VDIUtil_SetIntStr(tree, OPRLEFTM, intVal);
		ConfVars_GetConfDefInt(cPrintEmptyLines, &intVal, 0);
		intVal = intVal % 10;			/* Maximal 0 bis 9 */
		VDIUtil_SetIntStr(tree, OPRLINES, intVal);
		ConfVars_GetConfDefBool(cPrintNLQ, &val, FALSE);
		EnableObjState(tree, OPRNNLQ, SELECTED, val);
		ConfVars_GetConfDefBool(cPrintFormFeed, &val, FALSE);
		EnableObjState(tree, OFORMFEED, SELECTED, val);
		Printer_GetPrnName(name, sizeof(name));
		SetObjcString(tree, PRINTNAME, name);
		ConfVars_GetConfDefInt(cPrintPort, &intVal, 0);
		VDIUtil_SetXState(tree, OINTERFC1, intVal);
		VDIUtil_SetXString(tree, OINTERFC1, prnIFSel, intVal);
		ConfVars_GetConfDefInt(cPrintStyle, &intVal, 0);
		VDIUtil_SetXState(tree, OPRTSIZ1, intVal);
		VDIUtil_SetXString(tree, OPRTSIZ1, prnStyleSel, intVal);
	} else
	{
		exit &= 0x7fff;
		if (exit == PROK)
		{
			ConfVars_SetConfigInt(cPrintPort, VDIUtil_GetXState(tree, OINTERFC1));
			ConfVars_SetConfigInt(cPrintStyle, VDIUtil_GetXState(tree, OPRTSIZ1));
			ConfVars_SetConfigBool(cPrintNLQ, GetObjState(tree, OPRNNLQ, SELECTED));
			ConfVars_SetConfigBool(cPrintFormFeed, GetObjState(tree, OFORMFEED, SELECTED));
			VDIUtil_GetIntStr(tree, OPRLEFTM, &intVal);
			ConfVars_SetConfigInt(cPrintLeftMargin, intVal);
			VDIUtil_GetIntStr(tree, OPRLINES, &intVal);
			ConfVars_SetConfigInt(cPrintEmptyLines, intVal);
			if (prInfo->cfgFile[0] != '\0')
				ConfVars_SetConfigString(cPrintCFGFile, prInfo->cfgFile);
		} else
		{
			ConfVars_GetConfDefStr(cPrintCFGFile, prInfo->cfgFile, sizeof(prInfo->cfgFile), "");
			if (prInfo->cfgFile[0] != '\0')
				Printer_LoadCFGFile(prInfo->cfgFile);
		}
		OFREE(prInfo);
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID doPrinter(_VOID)
{
	OBJECT *printConf;
	printerInfo *prInfo;

	printConf = RscGaddr(the_rsc, R_TREE, PRNCONF);
	prInfo = NEW(printerInfo, "doPrinter");
	if (prInfo == NULL)
		return;
	if (!WinDials_OpenWinDial(printConf, FALSE,
		printerGetSetValues,
		printerGetSetValues,
		printerButton,
		WinDials_defDraw,
		NULL,
		prInfo))
	{
		OFREE(prInfo);
	}
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

LOCAL _VOID makeTmpName(_UBYTE *path, _UBYTE *name)
{
	_UBYTE currentPath[PATH_MAX];
	_UBYTE tname[PATH_MAX];
	_ULONG mtime;

	/* Aktuellen Pfad merken */
	F_Path_Get(currentPath);
	/* TmpDir holen */
	if (!CatFiles_GetTmpDir(path))
	{
		/* tmpDir ist aktuelles Verzeichnis! */
		strMcpy(path, PATH_MAX, currentPath);
	}
	/* Jetzt Pfad richtig abschliessen mit Backslash */
	F_Path_Append(path, "");
	/* Tmp-Pfad setzen */
	F_Path_Set(path);
	/* Dateinamen basteln aus Inhalt des 200 Hz Timers */
	do
	{
		mtime = Random();
		strCpy(tname, "ct");	/*DYJ 5.20w */
		LNumToStr(mtime, 36, 6, '0', tname + 2, sizeof(tname) - 2);
		strBcat(tname, ".asc");
		/* Jetzt testen, ob Datei schon vorhanden */
		strMcpy(name, PATH_MAX, tname);
	} while (CatFiles_Exists(name));
	/* Aktuellen Pfad wiederherstellen */
	F_Path_Set(currentPath);
}

/*** ---------------------------------------------------------------------- ***/

/* In dieser Prozedur werden hauptsaechlich Strings ersetzt
 * Das eigentliche zusammenbauen der Kommandozeile wird von einer
 * Prozedur weiter oben in der Hierarchie erledigt
 * Folgendes wird ersetzt: $B fuer Eingabeblock durch ersten Namen (in),
 * $O fuer Ausgabe des Kommandos durch zweiten Namen
 */
LOCAL _VOID buildCommand(_WORD wdw, CONST _UBYTE *com, CONST _UBYTE *path, CONST _UBYTE *in, CONST _UBYTE *out, _UBYTE *cmd, size_t cmdsize)
{
	_UBYTE tname[PATH_MAX];

	UNUSED(wdw);
	strBcpy(tname, path);
	F_Path_Append(tname, in);
	strMcpy(cmd, cmdsize, com);
	CatGlobal_ReplaceStr(cmd, cmdsize, "$B", tname);
	strBcpy(tname, path);
	F_Path_Append(tname, out);
	CatGlobal_ReplaceStr(cmd, cmdsize, "$O", tname);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID PipeEditBlock(HWND wdw, CONST _UBYTE *command)
{
	_UBYTE path[PATH_MAX];
	_UBYTE tname[PATH_MAX];
	_UBYTE inName[PATH_MAX];
	_UBYTE outName[PATH_MAX];
	_ULONG len;
	_UBYTE cmdLine[256];
	_BOOL exists;

	if (*command == '\0')
		return;

	/* Vorgehensweise: 2*tmpFileName erstellen (in und out)
	 * Kommando mit Redirection an shell absetzen
	 * kommando <in >out
	 */
	makeTmpName(path, inName);
	/* Block aus Editor schreiben */
/*DYJ 1.02a Start*/
	Editor_EditSave(wdw, path, inName, FALSE,TRUE);
/*DYJ  Ende; alt:	
	Editor_EditSave(wdw, path, inName, FALSE);
*/
	/* zweiten tmpnamen basteln */
	makeTmpName(path, outName);
	/* Shellkommando basteln */
	buildCommand(wdw, command, path, inName, outName, cmdLine, sizeof(cmdLine));
	/* Shellkommando aufrufen */
	ShellCall_CallShell(cmdLine, TRUE);
	/* Testen, ob Ausgabe existiert und laenger als 0 Bytes ist */
	strBcpy(tname, path);
	F_Path_Append(tname, outName);
	len = CatFiles_FileSize(tname, &exists);
	if (exists && len > 0)
	{
		/* Ausgabe in Editor einlesen */
		Editor_EditPasteFile(wdw, TRUE, path, outName);
	}
	/* temporaere Files wieder loeschen */
	CatFiles_DeleteFile(path, inName);
	F_File_Delete(tname);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID ProcessFilter(HWND wdw, _BOOL withDial)
{
	_UBYTE cmd[256];

	if ((withDial && doFilter(&filterNumber, cmd, sizeof(cmd))) ||
		(!withDial && doPopupFilter(&filterNumber, cmd, sizeof(cmd))))
	{
		if (filterNumber <= 6)
		{
			switch (filterNumber)
			{
			case 0:
				Editor_BlockRot(wdw);
				break;
			case 1:
				Editor_BlockRot18(wdw);
				break;
			case 2:
				Editor_BlockSwap(wdw);
				break;
			case 3:
				Editor_BlockUp(wdw);
				break;
			case 4:
				Editor_BlockDown(wdw);
				break;
			case 5:
				Editor_BlockCapitals(wdw);
				break;
			case 6:
				Editor_BlockMirror(wdw);
				break;
			}
		} else
		{
			if (cmd[0] != '\0')
			{
				PipeEditBlock(wdw, cmd);
			}
		}
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID GetOrSetMark(_BOOL getIt, HWND wdw)
{
	_WORD exit;

	if (getIt)
		SetObjcString(gotoBox, SETMARK, "Marke anspringen");
	else
		SetObjcString(gotoBox, SETMARK, "Marke setzen");
	exit = FormHandle(GOTOBOX);
	if (exit != MBQUIT)
	{
		if (getIt)
			Editor_ToMark(wdw, exit - MB1);
		else
			Editor_SetMark(wdw, exit - MB1);
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID GetLine(HWND wdw)
{
	_WORD exit;
	_UBYTE str[11];
	EDLINE nr;
	_BOOL valid;

	SetObjcString(lineBox, ZEILENNR, "");
	exit = FormHandle(LINEBOX);
	if (exit == ZEILEOK)
	{
		ObjcString(lineBox, ZEILENNR, str, sizeof(str));
		nr = StrToLInt(str, NULL, &valid);
		if (valid)
			Editor_ToLineNr(wdw, nr);
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID GetTabSize(HWND wdw)
{
	_WORD exit;
	_UBYTE str[PATH_MAX];
	EDCOLUMN nr;
	_BOOL redraw;
	_UBYTE varname[128];
	_WORD i;
	_BOOL isTop;
	_BOOL bool;
	
	/* Box initialisieren */
	isTop = Editor_IsEditTop(wdw);

	EnableObjState(tabBox, TAEXT0, DISABLED, !isTop);
	EnableObjState(tabBox, TATABW0, DISABLED, !isTop);
	EnableObjState(tabBox, TAUMBR0, DISABLED, !isTop);
	EnableObjState(tabBox, TARTAB0, DISABLED, !isTop);
	EnableObjState(tabBox, TABACK0, DISABLED, !isTop);
	EnableObjState(tabBox, TALINEL0, DISABLED, !isTop);
	EnableObjFlags(tabBox, TALINEL0, EDITABLE, isTop);
	EnableObjFlags(tabBox, TATABW0, EDITABLE, isTop);
	if (isTop)
	{
		/* Erstmal die Topwindow-Sachen */
		Editor_GetTabSize(wdw, &nr);
		IntToStr(nr, 0, str, sizeof(str));
		SetObjcString(tabBox, TATABW0, str);
		SetItem(tabBox, TAUMBR0, Editor_GetMode(wdw, wrapMode));
		SetItem(tabBox, TABACK0, Editor_GetMode(wdw, autoBackup));
		SetItem(tabBox, TARTAB0, Editor_GetMode(wdw, tabMode));
		Editor_GetMargins(wdw, &nr);
		IntToStr(nr, 0, str, sizeof(str));
		SetObjcString(tabBox, TALINEL0, str);
	}
	/* Und jetzt die ueber die Configstrings */
	for (i = 1; i <= 8; i++)
	{
		make_varname(varname, sizeof(varname), cExtension, i);
		ConfVars_GetConfDefStr(varname, str, sizeof(str), "");
		SetObjcString(tabBox, TAEXT1 + i - 1, str);
		make_varname(varname, sizeof(varname), cExtTabSize, i);
		ConfVars_GetConfDefInt(varname, &nr, 4);
		IntToStr(nr, 0, str, sizeof(str));
		SetObjcString(tabBox, TATABW1 + i - 1, str);
		make_varname(varname, sizeof(varname), cExtHardTabs, i);
		ConfVars_GetConfDefBool(varname, &bool, FALSE);
		SetItem(tabBox, TARTAB1 + i - 1, bool);
		make_varname(varname, sizeof(varname), cExtWordWrap, i);
		ConfVars_GetConfDefBool(varname, &bool, FALSE);
		SetItem(tabBox, TAUMBR1 + i - 1, bool);
		make_varname(varname, sizeof(varname), cExtRightMargin, i);
		ConfVars_GetConfDefInt(varname, &nr, 255);
		IntToStr(nr, 0, str, sizeof(str));
		SetObjcString(tabBox, TALINEL1 + i - 1, str);
		make_varname(varname, sizeof(varname), cExtAutoBackup, i);
		ConfVars_GetConfDefBool(varname, &bool, FALSE);
		SetItem(tabBox, TABACK1 + i - 1, bool);
	}

	exit = FormHandle(TABBOX);
	if (exit == TABOK)
	{
		redraw = FALSE;
		/* Erstmal die Topwindow-Sachen */
		Editor_SetMode(wdw, wrapMode, GetItem(tabBox, TAUMBR0));
		Editor_SetMode(wdw, autoBackup, GetItem(tabBox, TABACK0));
		Editor_SetMode(wdw, tabMode, GetItem(tabBox, TARTAB0));
		ObjcString(tabBox, TATABW0, str, sizeof(str));
		nr = StrToInt(str, NULL, &bool);
		if (bool)
		{
			Editor_SetTabSize(wdw, nr);
			if (Editor_GetMode(wdw, tabMode))
				redraw = TRUE;
		}
		ObjcString(tabBox, TALINEL0, str, sizeof(str));
		nr = StrToInt(str, NULL, &bool);
		if (bool)
		{
			Editor_SetMargins(wdw, nr, GetItem(tabBox, TAUMBR0));
			redraw = TRUE;
		}
		if (redraw)
			WdwManager_FullRedrawWdw(wdw);

		/* Und jetzt die ueber die Configstrings */
		for (i = 1; i <= 8; i++)
		{
			ObjcString(tabBox, TAEXT1 + i - 1, str, sizeof(str));
			if (str[0] != '\0')
			{
				make_varname(varname, sizeof(varname), cExtension, i);
				ConfVars_SetConfigString(varname, str);
				ObjcString(tabBox, TATABW1 + i - 1, str, sizeof(str));
				nr = StrToInt(str, NULL, &bool);
				if (bool)
				{
					make_varname(varname, sizeof(varname), cExtTabSize, i);
					ConfVars_SetConfigInt(varname, nr);
				}
				make_varname(varname, sizeof(varname), cExtHardTabs, i);
				ConfVars_SetConfigBool(varname, GetItem(tabBox, TARTAB1 + i - 1));
				make_varname(varname, sizeof(varname), cExtWordWrap, i);
				ConfVars_SetConfigBool(varname, GetItem(tabBox, TAUMBR1 + i - 1));
				ObjcString(tabBox, TALINEL1 + i - 1, str, sizeof(str));
				nr = StrToInt(str, NULL, &bool);
				if (bool)
				{
					make_varname(varname, sizeof(varname), cExtRightMargin, i);
					ConfVars_SetConfigInt(varname, nr);
				}
				make_varname(varname, sizeof(varname), cExtAutoBackup, i);
				ConfVars_SetConfigBool(varname, GetItem(tabBox, TABACK1 + i - 1));
			}
		}
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID GetRightMargin(HWND wdw)
{
	_WORD exit;
	_UBYTE str[11];
	EDCOLUMN nr;
	_BOOL umbr;
	_BOOL valid;
	
	SetItem(umbruchBox, UMBRUCHAN, Editor_GetMode(wdw, wrapMode));
	Editor_GetMargins(wdw, &nr);
	IntToStr(nr, 0, str, sizeof(str));
	SetObjcString(umbruchBox, USPALTE, str);
	exit = FormHandle(UMBRUCH);
	if (exit == UMBROK)
	{
		ObjcString(umbruchBox, USPALTE, str, sizeof(str));
		nr = StrToInt(str, NULL, &valid);
		umbr = GetItem(umbruchBox, UMBRUCHAN);
		if (valid || !umbr)
		{
			if (umbr)
				Editor_SetMargins(wdw, nr, umbr);
			else
				Editor_SetMargins(wdw, maxLineLength, umbr);
			WdwManager_FullRedrawWdw(wdw);
		}
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID doShortBox(_VOID)
{
	_WORD exit;
	_UBYTE path[PATH_MAX];
	_UBYTE name[PATH_MAX];

	/* String setzen */
	if (shortFileRead)
		SplitPath(lastShort, path, name);
	else
		*name = '\0';
	SetObjcString(shortBox, SBINFO, name);
	exit = FormHandle(SHORTBOX);
	if (exit == SBKILL)
	{
		Editor_FreeShortkeyList();
		shortFileRead = FALSE;
		ConfVars_DeleteConfigVar(cShortFile);
	} else if (exit == SBLOAD)
	{
		SplitPath(lastShort, path, name);
		if (mtDir_FselGet(path, name, "*.krz", "K\201rzeldatei laden", FALSE))
		{
			strBcpy(lastShort, path);
			F_Path_Append(lastShort, name);
			Editor_ReadShortkeyFile(lastShort);
			ConfVars_SetConfigString(cShortFile, lastShort);
			shortFileRead = TRUE;
		}
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID doFileInfos(HWND wdw)
{
	_ULONG lines, bytes, totalMem;
	_WORD edits;
	_UBYTE fname[PATH_MAX];
	_UBYTE str[20];
	
	if (Editor_FileInfos(wdw, &lines, &bytes, &edits, &totalMem, fname))
	{
		/* Parameter setzen */
		SetObjcString(infoBox, FINAME, fname);
		CardToStr(bytes, 0, str, sizeof(str));
		SetObjcString(infoBox, FISIZE, str);
		CardToStr(totalMem, 0, str, sizeof(str));
		SetObjcString(infoBox, FIUSEDM, str);
		CardToStr(lines, 0, str, sizeof(str));
		SetObjcString(infoBox, FILINES, str);
		IntToStr(edits, 0, str, sizeof(str));
		SetObjcString(infoBox, FIFILES, str);
		CardToStr(mem_max(), 0, str, sizeof(str));
		SetObjcString(infoBox, FIMEM, str);
		/* Box aufrufen */
		FormHandle(FILEINFO);
	}
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

#define MAX_FLOSKEL_LEN 512

typedef struct
{
	_UBYTE txtArray[20][MAX_FLOSKEL_LEN];
	_WORD oldEntry;
	_BOOL oldShift;
	_WORD theWdw;
} floskelInfo;

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID SetEntry(OBJECT *tree, floskelInfo *floskel, _WORD idx, _BOOL isShift)
{
	_UBYTE str[MAX_FLOSKEL_LEN];
	_WORD strIdx;
	_UBYTE *p;

	strIdx = idx - FL_F1;
	if (isShift)
		strIdx += 10;
	/* Suchen nach einzelnen LFs und ersetzen davon */
	strBcpy(str, floskel->txtArray[strIdx]);
	p = str;
	while ((p = strChr(p, LF)) != NULL)	/*DYJ 5.20w */
	{
		strCpy(p, p + 1);	/*DYJ 5.20w */
	}
	CatGlobal_SetStrings(tree, FLLINE1, FLLINE6, str);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID GetEntry(OBJECT *tree, floskelInfo *floskel, _WORD idx, _BOOL isShift)
{
	_UBYTE str[MAX_FLOSKEL_LEN];
	_WORD strIdx;
	_UBYTE *p;

	strIdx = idx - FL_F1;
	if (isShift)
		strIdx += 10;
	CatGlobal_GetStrings(tree, FLLINE1, FLLINE6, str, sizeof(str));
	/* Suchen nach einzelnen CRs und diese ersetzen durch CR/LF */
	p = str;
	while ((p = strChr(p, CR)) != NULL)	/*DYJ 5.20w */
	{
		if (p[1] != LF)
			strInsertChar(LF, p + 1, str + sizeof(str) - p - 1);
	}
	/* Suchen nach einzelnen LFs und ersetzen davon */
	p = str;
	while ((p = strChr(p, LF)) != NULL)	/*DYJ 5.20w */
	{
		if (p == str || p[-1] != CR)
			strInsertChar(CR, p, str + sizeof(str) - p);
	}
	/* Jetzt nur noch in Textarray sichern */
	strBcpy(floskel->txtArray[strIdx], str);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL floskelButton(OBJECT *tree, _VOID *env, _WORD button, _WORD mx, _WORD my, _UWORD kstate, _WORD clicks)
{
	GRECT r;
	floskelInfo *floskel;
	_BOOL isShift;
	_UBYTE *strPtr;
	_ULONG strLen;

	UNUSED(mx);
	UNUSED(my);
	UNUSED(kstate);
	UNUSED(clicks);

	floskel = env;
	button &= 0x7fff;
	switch (button)
	{
	case FL_F1:
	case FL_F2:
	case FL_F3:
	case FL_F4:
	case FL_F5:
	case FL_F6:
	case FL_F7:
	case FL_F8:
	case FL_F9:
	case FL_F10:
		GetEntry(tree, floskel, floskel->oldEntry, floskel->oldShift);
		isShift = GetObjState(tree, FL_SHIFT, SELECTED);
		SetEntry(tree, floskel, button, isShift);
		floskel->oldShift = isShift;
		floskel->oldEntry = button;
		WinDials_WinDialDraw(tree, FLBOX, MAX_DEPTH, &r, FALSE);
		break;

	case FL_SHIFT:
		GetEntry(tree, floskel, floskel->oldEntry, floskel->oldShift);
		isShift = GetObjState(tree, FL_SHIFT, SELECTED);
		SetEntry(tree, floskel, floskel->oldEntry, isShift);
		floskel->oldShift = isShift;
		WinDials_WinDialDraw(tree, FLBOX, MAX_DEPTH, &r, FALSE);
		break;

	case FLBLOCK:
		if (Editor_GetBlock(floskel->theWdw, FALSE, TRUE, &strPtr, &strLen))
		{
			if (strLen > MAX_FLOSKEL_LEN)
				strPtr[MAX_FLOSKEL_LEN - 1] = '\0';
			CatGlobal_SetStrings(tree, FLLINE1, FLLINE6, strPtr);
			GetEntry(tree, floskel, floskel->oldEntry, floskel->oldShift);
			SetEntry(tree, floskel, floskel->oldEntry, floskel->oldShift);
			WinDials_WinDialDraw(tree, FLBOX, MAX_DEPTH, &r, FALSE);
			SFREE(strPtr);
			DelObjState(tree, button, SELECTED);
			WinDials_WinDialDraw(tree, button, MAX_DEPTH, &r, FALSE);
		}
		break;

	case FLOK:
	case FLCANCEL:
		DelObjState(tree, button, SELECTED);
		GetEntry(tree, floskel, floskel->oldEntry, floskel->oldShift);
		return TRUE;
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID floskelGetSetValues(OBJECT *tree, _VOID *env, _BOOL set, _WORD exit)
{
	floskelInfo *floskel;
	_WORD i;
	_BOOL found;
	_BOOL isShift;
	_UBYTE str[MAX_FLOSKEL_LEN];
	_UBYTE varName[128];

	floskel = env;
	exit &= 0x7fff;
	if (set)
	{
		for (i = 0; i < 10; i++)
		{
			make_varname(varName, sizeof(varName), cNormalFkey, i + 1);
			ConfVars_GetConfDefStr(varName, floskel->txtArray[i], MAX_FLOSKEL_LEN, "");
		}
		EnableObjState(tree, FLBLOCK, DISABLED,
					   !(Editor_IsEditTop(floskel->theWdw) &&
						 Editor_BlockIsMarked(floskel->theWdw)));
		for (i = 0; i < 10; i++)
		{
			make_varname(varName, sizeof(varName), cShiftF, i + 1);
			ConfVars_GetConfDefStr(varName, floskel->txtArray[10 + i], MAX_FLOSKEL_LEN, "");
		}
		/* Selektierten Eintrag feststellen */
		i = FL_F1;
		found = FALSE;
		while (!found && i <= FL_F10)
		{
			found = GetObjState(tree, i, SELECTED);
			if (!found)
				++i;
		}
		isShift = GetObjState(tree, FL_SHIFT, SELECTED);
		SetEntry(tree, floskel, i, isShift);
		floskel->oldEntry = i;
		floskel->oldShift = isShift;
	} else
	{
		if (exit == FLOK)
		{
			/* Strings abspeichern */
			for (i = 0; i < 10; i++)
			{
				make_varname(varName, sizeof(varName), cNormalFkey, i + 1);
				if (ConfVars_GetConfigString(varName, str, sizeof(str)) ||
					floskel->txtArray[i][0] != '\0')
				{
					ConfVars_SetConfigString(varName, floskel->txtArray[i]);
				}
			}
			for (i = 0; i < 10; i++)
			{
				make_varname(varName, sizeof(varName), cShiftF, i + 1);
				if (ConfVars_GetConfigString(varName, str, sizeof(str)) ||
					floskel->txtArray[i + 10][0] != '\0')
				{
					ConfVars_SetConfigString(varName, floskel->txtArray[i + 10]);
				}
			}
		}
		OFREE(floskel);
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID doFloskel(_VOID)
{
	OBJECT *floskelBox;
	floskelInfo *floskel;

	/* vorbereiten */
	floskelBox = RscGaddr(the_rsc, R_TREE, FLOSKELN);
	floskel = NEW(floskelInfo, "doFloskel");
	if (floskel == NULL)
		return;
	floskel->theWdw = ownTopWindow;
	if (!WinDials_OpenWinDial(floskelBox, FALSE,
		floskelGetSetValues,
		floskelGetSetValues,
		floskelButton,
		WinDials_defDraw,
		NULL,
		floskel))
	{
		OFREE(floskel);
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID DoAbout(_VOID)
{
	FormHandle(ABOUTBOX);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID doErrorBox(_VOID)
{
	_UBYTE errName[256];
	_UBYTE errMask[256];

	ConfVars_GetConfDefStr(cErrorExtension, errName, sizeof(errName), "");
	ConfVars_GetConfDefStr(cErrorMask, errMask, sizeof(errMask), "");
	SetObjcString(errorBox, EFNAME, errName);
	SetObjcString(errorBox, EMASK, errMask);
	if (FormHandle(ERRBOX) == ERROK)
	{
		ObjcString(errorBox, EFNAME, errName, sizeof(errName));
		ObjcString(errorBox, EMASK, errMask, sizeof(errName));
		ConfVars_SetConfigString(cErrorExtension, errName);
		ConfVars_SetConfigString(cErrorMask, errMask);
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID ClearScreen(_VOID)
{
	Cconout(0x1b);
	Cconout('E');
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID ClearBuffer(_UWORD e, _BOOL force, _UWORD ks, _WORD sc, _UBYTE ch)
{
	_UWORD kstate;
	_WORD scan;
	_WORD message[8];
	_WORD dummy;
	_UWORD udummy;
	_WORD key;

/*DYJ 5.36k Start*/
	if (e & MU_KEYBD)
	{
		do
		{
			e = evnt_multi(MU_KEYBD | MU_TIMER,
				0, 0, 0,
				0, 0, 0, 0, 0,
				0, 0, 0, 0, 0,
				message,
				0, 0,
				&dummy, &dummy, &udummy, &kstate, &key, &dummy);
			scan = (key >> 8) & 0xff;
			ch = key & 0xff;
		} while ((e & MU_KEYBD) && (force || (ks == kstate && scan == sc)));
		if (e & MU_KEYBD)
			PushKey(kstate, scan, ch);
	}
/*DYJ  Ende; alt:	
	_UBYTE ch2;

	UNUSED(ch);
	if (e & MU_KEYBD)
	{
		do
		{
			e = evnt_multi(MU_KEYBD | MU_TIMER,
				0, 0, 0,
				0, 0, 0, 0, 0,
				0, 0, 0, 0, 0,
				message,
				0, 0,
				&dummy, &dummy, &udummy, &kstate, &key, &dummy);
			scan = (key >> 8) & 0xff;
			ch2 = key & 0xff;
		} while ((e & MU_KEYBD) && is_alnum(ch2)
			   && (force || (ks == kstate && scan == sc)));
		if (e & MU_KEYBD)
		{
			PushKey(kstate, scan, ch2);
		}
	}
*/
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _UBYTE shellCommand[256];

LOCAL _VOID DoShell(_VOID)
{
	SetObjcString(systemBox, SYSSTR, shellCommand);
	if (FormHandle(SYSTEMBX) != SYSABRUC)
	{
		ObjcString(systemBox, SYSSTR, shellCommand, sizeof(shellCommand));
		if (shell == shellP)
		{
			MouseOff();
			ClearScreen();
			Wind_Update(END_UPDATE);
		}
		ShellCall_CallShell(shellCommand, FALSE);
		if (shell == shellP)
		{
			Wind_Update(BEG_UPDATE);
			Cconws("\r\n- Taste dr\201cken -");
			ClearBuffer(MU_KEYBD, TRUE, 0, 0, '\0');
			evnt_keybd();

			Cconws("\033f");			/* Cursor ausschalten */
			MouseArrow();

			Form_dial(FMD_FINISH, &deskSize, &deskSize);
			menu_bar(menu, 1);
		}
	} else
	{
		SetObjcString(systemBox, SYSSTR, shellCommand);
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL saveAllChangedFiles(_BOOL ask)
{
	EDITOR *ed;
	_UBYTE path[PATH_MAX];
	_BOOL isSaved;
	_BOOL autoSave;
	
	ConfVars_GetConfDefBool(cAutoSaveAction, &autoSave, TRUE);
	for (ed = editList; ed != NULL; ed = ed->nextEdit)
	{
		if (!Editor_GetCompInfo(ed->wdw, path, &isSaved))
			return FALSE;
		if (!isSaved)
		{
			if (ask && !autoSave && Editor_AskForSave(ed->wdw, TRUE) == FALSE)
				return FALSE;
/*DYJ 1.02a Start*/
			if (!Editor_EditSave(ed->wdw, "", "", FALSE,TRUE))
/*DYJ  Ende; alt:	
			if (!Editor_EditSave(ed->wdw, "", "", FALSE))
*/
				return FALSE;
		}
	}
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID hdlComp(_WORD item, HWND wdw)
{
	_BOOL isSaved;
	_UBYTE path[PATH_MAX];
	_UBYTE name[PATH_MAX];

	switch (item)
	{
	case PCOMPEND:
		if (saveAllChangedFiles(FALSE))
		{
			termCode = 1;
			quitProg = Editor_CloseAllEditors(FALSE);
		}
		break;

	case PCOMPRUN:
		if (saveAllChangedFiles(FALSE))
		{
			termCode = 2;
			quitProg = Editor_CloseAllEditors(FALSE);
		}
		break;

	case PMAKE:
		if (SeProto_Project_Activ(path))
		{
			if (saveAllChangedFiles(TRUE))
				SeProto_SendMake(path);
		} else
		{
			if (saveAllChangedFiles(FALSE))
			{
				termCode = 3;
				quitProg = Editor_CloseAllEditors(FALSE);
			}
		}
		break;

	case PMAKERUN:
		if (saveAllChangedFiles(FALSE))
		{
			termCode = 4;
			quitProg = Editor_CloseAllEditors(FALSE);
		}
		break;

	case PESCOMPILE:
		/* Filenamen von TopWindow erfragen */
		if (Editor_GetCompInfo(wdw, path, &isSaved))
		{
			if (isSaved || Editor_AskForSave(wdw, TRUE))
				SeProto_SendCompile(path);
		}
		break;

	case PESLINK:
		/* Filenamen von TopWindow erfragen */
		if (Editor_GetCompInfo(wdw, path, &isSaved))
		{
			if (isSaved || Editor_AskForSave(wdw, TRUE))
				SeProto_SendLink(path);
		}
		break;

	case PESMAKE:
		if (saveAllChangedFiles(TRUE))
			SeProto_SendMake(NULL);
		break;
	
	case PESMAKEALL:
		if (saveAllChangedFiles(TRUE))
			SeProto_SendMakeall(NULL);
		break;
	
	case PESEXEC:
		if (saveAllChangedFiles(TRUE))
		{
			if (Editor_GetCompInfo(wdw, path, &isSaved))
				SeProto_SendExec(path);
		}
		break;
	
	case PESMAKEEXEC:
		if (saveAllChangedFiles(TRUE))
			SeProto_SendMakeexec(NULL);
		break;
	
	case PMAKEFILE:
		if (SeProto_Project_Activ(path))
		{
			strBcpy(name, F_Path_Basename(path));
			F_Path_Dirname(path);
		} else
		{
			*path = '\0';
			*name = '\0';
		}
		if (mtDir_FselGet(path, name, "*.*", rsc_WrkString(FS_SELECT_MAKEFILE), FALSE))
		{
			F_Path_Append(path, name);
			if (!SeProto_SendProject(path))
				mtAlerts_Alert(1, AL_NO_PROJECT);
		}
		break;
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL OpenEditor(CONST _UBYTE *path, CONST _UBYTE *name, HWND *wdw, _BOOL isErrFile);


LOCAL _BOOL ParseErrLine(CONST _UBYTE *error, CONST _UBYTE *mask,
	_UBYTE *errFile, _UBYTE *errMess, size_t errSize,
	EDLINE *errLine, EDCOLUMN *errRow)
{
	_UBYTE numStr[128];
	_UBYTE *p;
	size_t len;
	_UBYTE c;
	
	/* Initialisierung */
	errFile[0] = '\0';
	errMess[0] = '\0';
	*errLine = -1;
	*errRow = 0;
	if (error == NULL || *error == '\0')
		return FALSE;
	SPEC_DEBUG_OUT((EO_DEBUG, "error: %s", error));
	while (*mask != '\0' && *error != '\0' && *error != CR && *error != LF)
	{
		if (*mask == '$' && mask[1] != '\0' && strChr("FLMR", mask[1]) != NULL)	/*DYJ 5.20w */
		{

#define scanStr(dest, l) \
			p = dest; \
			len = l - 1; \
			while (len > 0 && *error != '\0' && *error != CR && *error != LF && ucase(*error) != c) \
			{ \
				*p++ = *error++; \
				len--; \
			} \
			*p = '\0'; \
			while (*error != '\0' && *error != CR && *error != LF && ucase(*error) != c) \
				error++
	
			mask++;
			c = ucase(mask[1]);
			switch (*mask)
			{
			case 'F':
				scanStr(errFile, PATH_MAX);
				break;
			case 'L':
				scanStr(numStr, sizeof(numStr));
				*errLine = StrToLInt(numStr, NULL, NULL);
				break;
			case 'M':
				scanStr(errMess, errSize);
				break;
			case 'R':
				scanStr(numStr, sizeof(numStr));
				*errRow = StrToInt(numStr, NULL, NULL);
				break;
			}
			mask++;
#undef scanStr
		} else
		{
			if (ucase(*mask) != ucase(*error))
				return FALSE;
			if (*mask == ' ')
			{
				while (*error == ' ')
					error++;
			} else
			{
				++error;
			}
			++mask;
		}
	}
	SPEC_DEBUG_OUT((EO_DEBUG, "file %s, line %ld, msg %s", errFile, *errLine, errMess));
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID handleErrorLine(HWND wdw, CONST _UBYTE *error)
{
	_UBYTE errF[PATH_MAX];
	_UBYTE errMess[256];
	EDLINE errLine;
	EDCOLUMN errRow;
	HWND errWdw;
	_WORD i;
	_UBYTE path[PATH_MAX];
	_UBYTE name[PATH_MAX];
	_UBYTE errMask[256];
	
	ConfVars_GetConfDefStr(cErrorMask, errMask, sizeof(errMask), "");
	i = 0;
	while (i < errIndex && errFiles[i].wdw != wdw)
		++i;
	if (i < errIndex &&
		ParseErrLine(error, errMask, errF, errMess, sizeof(errMess), &errLine, &errRow))
	{
		if (*errF != '\0' && Editor_FileIsEditor(errF, &errWdw))
		{
			WdwManager_TopWindow(errWdw);
			Editor_SetError(errWdw, errLine, errRow, errMess, TRUE);
		} else
		{
			if (*errF != '\0')
			{
				SplitPath(errF, path, name);
				if (OpenEditor(path, name, &errWdw, FALSE))
					Editor_SetError(errWdw, errLine, errRow, errMess, TRUE);
			} else
			{
				/* Kein File spezifiziert, in dem der Fehler auftrat.
				 * Das erstbeste Fenster nehmen
				 */
				errWdw = WdwManager_GetOwnTopWindow();
				if ((errWdw != wdw || WdwManager_GetSecondWdw(&errWdw)) &&
					Editor_IsEditTop(errWdw))
				{
					WdwManager_TopWindow(errWdw);
					Editor_SetError(errWdw, errLine, errRow, errMess, TRUE);
				}
			}
		}
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL hdlClose(HWND wdw)
{
	_WORD i, j;

	i = 0;
	while (i < errIndex && errFiles[i].wdw != wdw)
		++i;
	if (i < errIndex)
	{
		for (j = i + 1; j < errIndex; j++)
		{
			errFiles[j - 1] = errFiles[j];
		}
		--errIndex;
	}
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL OpenEditor(CONST _UBYTE *path, CONST _UBYTE *name, HWND *wdw, _BOOL isErrFile)
{
	_WORD i;
	_BOOL found;
	_UBYTE fname[PATH_MAX];
	_UBYTE varname[128];
	_UBYTE ext[PATH_MAX];
	EDCOLUMN tabs;
	EDCOLUMN margin;
	_BOOL succ;
	_BOOL rtabs;
	_BOOL wrap;
	_BOOL errmode;
	_BOOL doback;

	/* Erstmal nachsehen, ob der Name auf eine der Extensions passt */
	i = 0;
	found = FALSE;
	strBcpy(fname, name);
	strUpr(fname);
	ConfVars_GetConfDefStr(cErrorExtension, ext, sizeof(ext), "*.err");
	if ((WildCards_MatchName(fname, ext, TRUE) && errIndex < maxErrFiles) ||
		isErrFile)
	{
		tabs = 4;
		rtabs = TRUE;
		wrap = FALSE;
		margin = 255;
		doback = FALSE;
		errmode = TRUE;
	} else
	{
		errmode = FALSE;
		while (i <= 8 && !found)
		{
			++i;
			make_varname(varname, sizeof(varname), cExtension, i);
			if (ConfVars_GetConfigString(varname, ext, sizeof(ext)) && ext[0] != '\0')
				found = WildCards_MatchName(fname, ext, TRUE);
		}
		if (found)
		{
			/* Ein paar Einstellung holen */
			make_varname(varname, sizeof(varname), cExtTabSize, i);
			ConfVars_GetConfDefInt(varname, &tabs, 4);
			make_varname(varname, sizeof(varname), cExtHardTabs, i);
			ConfVars_GetConfDefBool(varname, &rtabs, FALSE);
			make_varname(varname, sizeof(varname), cExtWordWrap, i);
			ConfVars_GetConfDefBool(varname, &wrap, FALSE);
			make_varname(varname, sizeof(varname), cExtRightMargin, i);
			ConfVars_GetConfDefInt(varname, &margin, 255);
			make_varname(varname, sizeof(varname), cExtAutoBackup, i);
			ConfVars_GetConfDefBool(varname, &doback, FALSE);
		} else
		{
			tabs = 4;
			rtabs = FALSE;
			wrap = FALSE;
			margin = 255;
			doback = FALSE;
		}
	}
	succ = Editor_OpenEditor(path, name, &SrcPaths,
		FALSE,		/* new */
		FALSE,		/* useUserProc */
		FUNK_NULL,	/* UserProc */
		FUNK_NULL,	/* UserRectProc */
		FUNK_NULL,	/* UserDrawProc */
		hdlClose,
		FUNK_NULL,	/* KeyProc */
		FUNK_NULL,	/* TopProc */
		FUNK_NULL,	/* UntopProc */
		FUNK_NULL,	/* PrePrintProc */
		margin,
		TRUE,		/* showInfo */
		wrap,
		-1,			/* num */
		wdw);
	if (succ)
	{
		Editor_SetMode(*wdw, tabMode, rtabs);
		Editor_SetTabSize(*wdw, tabs);
		Editor_SetMode(*wdw, autoBackup, doback);
		if (errmode)
		{
			Editor_SetListProc(*wdw, handleErrorLine);
			Editor_SetListMode(*wdw);
			if (errIndex < maxErrFiles)
			{
				errFiles[errIndex].wdw = *wdw;
				strBcpy(errFiles[errIndex].fname, path);
				F_Path_Append(errFiles[errIndex].fname, name);
				++errIndex;
			}
		}
	}
	return succ;
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

/*
 * Request Help via PC_HELP Protokoll
 * wird bei markiertem Block und Shift-Help fuer externe Hilfe verwendet
 */
GLOBAL _VOID Protokoll_SendHelp(CONST _UBYTE *str)
{
	_UBYTE helpServer[10];

	ConfVars_GetConfDefStr(cHelpServer, helpServer, sizeof(helpServer), hs);
	VaProto_SendHelp(str, helpServer);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID doHelp(HWND wdw, _UWORD kstate)
{
	_UBYTE *buf;
	_ULONG bufLen;

	UNUSED(kstate);
	if (Editor_IsEditTop(wdw))
	{
		if (!Editor_BlockIsMarked(wdw))
		{
			Editor_MarkWord(wdw);
		}
		if (!Editor_BlockIsMarked(wdw))
		{
			Protokoll_SendHelp("FRED");
		} else
		{
			if (Editor_GetBlock(wdw, FALSE, FALSE, &buf, &bufLen))
			{
				Protokoll_SendHelp(buf);
				SFREE(buf);
			}
		}
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID handleFSelMessage(HWND wdw, _WORD item)
{
	CONST _UBYTE *message;
	HWND edWdw;

	strBcpy(InSel, OpenName);
	if (item == OPEN)
		message = "Datei laden";
	else /* if (item == READFILE) */
		message = "Datei hinzuladen";

	if (mtDir_FselGet(InPath, InSel, ALL_FILE_MASK, message, FALSE))
	{
		strBcpy(OpenName, InSel);
		if (item == OPEN)
		{
			OpenEditor(InPath, InSel, &edWdw, FALSE);
		} else if (item == READFILE)
		{
			Editor_EditMerge(wdw, InPath, InSel);
		}
	}
}
/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID menuMsgHdler(_WORD item, _WORD title, _UWORD kstate)
{
	HWND wdw;
	HWND edWdw;
	CONST _UBYTE *fselTitle;
/*DYJ 1.02a Start*/
	_BOOL saveBlock,prBlock,askCancel=TRUE;
	_WORD select;
/*DYJ  Ende;*/

	wdw = theTopWindow;
	if (!mouse)
	{
		MouseOn();
		mouse = TRUE;
	}
	switch (item)
	{
	case ABOUT:
		DoAbout();
		break;
	case NEWFILE:
		Editor_OpenEditor("", "", &SrcPaths,
			TRUE,		/* new */
			FALSE,		/* useUserProc */
			FUNK_NULL,	/* UserProc */
			FUNK_NULL,	/* UserRectProc */
			FUNK_NULL,	/* UserDrawProc */
			FUNK_NULL,	/* CloseProc */
			FUNK_NULL,	/* KeyProc */
			FUNK_NULL,	/* TopProc */
			FUNK_NULL,	/* UntopProc */
			FUNK_NULL,	/* PrePrintProc */
			maxLineLength, /* right */
			TRUE,		/* showInfo */
			FALSE,		/* wrap */
			-1,			/* num */
			&edWdw);
		break;
	case READFILE:
	case OPEN:
		handleFSelMessage(wdw, item);
		break;
	case INFOFILE:
		doFileInfos(wdw);
		break;
	case CLOSEWDW:
		Editor_CloseEditor(wdw, FALSE);
		break;
	case ABANDON:
		Editor_EditAbandonText(wdw);
		break;
	case SAVEFILE:
/*DYJ 1.02a Start*/
		Editor_EditSave(wdw, "", "", FALSE,FALSE);
/*DYJ  Ende; alt:	
		Editor_EditSave(wdw, "", "", FALSE);
*/
		break;
	case SAVEAS:
/*DYJ 1.02a Start*/
		if (Editor_BlockIsMarked(wdw) &&	mtAlerts_Alert(1, Rsc_WrkString(AL_BLOCK_SAVE)) == 1)	/*DYJ 5.23e */
		{
			fselTitle = rsc_WrkString(blockSaveAs);	/*DYJ 5.23e */
			saveBlock=TRUE;
		}
		else
		{
/*DYJ 5.23e Start*/
			fselTitle = Rsc_WrkString(FS_SAVE_AS);
/*DYJ  Ende; alt:	
			fselTitle = saveAs;
*/
			saveBlock=FALSE;
		}
		if (mtDir_FselGet(SavePath, SaveName, ALL_FILE_MASK, fselTitle, FALSE))
			Editor_EditSave(wdw, SavePath, SaveName, TRUE,saveBlock);
/*DYJ  Ende; alt:	
		if (Editor_BlockIsMarked(wdw))
			fselTitle = blockSaveAs;
		else
			fselTitle = saveAs;
		if (mtDir_FselGet(SavePath, SaveName, ALL_FILE_MASK, fselTitle, FALSE))
		{
			Editor_EditSave(wdw, SavePath, SaveName, TRUE);
		}
*/
		break;
	case CALLSHEL:
		DoShell();
		break;
	case PRINTIT:
/*DYJ 1.02a Start*/
		prBlock=Editor_BlockIsMarked(wdw);
		if (prBlock)
		{
			select = mtAlerts_Alert(1, Rsc_WrkString(AL_BLOCK_PRINT));	/*DYJ 5.23e */
			if(select==3)
				return;
			prBlock=(select!=2);
			askCancel=FALSE;
		}
		Editor_EditPrint(wdw, prBlock,askCancel);
/*DYJ  Ende; alt:	
		Editor_EditPrint(wdw, Editor_BlockIsMarked(wdw));
*/
		break;
	case QUITPROG:
		if (autoSavePos)
			Editor_EditSavePos();
		quitProg = Editor_CloseAllEditors(FALSE);
		break;
	case DOUNDO:
		Editor_DoUndo(wdw);
		break;
	case MARKALL:
		Editor_MarkAll(wdw);
		break;
	case BSTARTBL:
		Editor_SetBlockStart(wdw);
		break;
	case BBLEND:
		Editor_SetBlockEnd(wdw);
		break;
	case BCUT:
		Editor_EditCut(wdw, TRUE);
		break;
	case BCOPY:
		Editor_EditCopy(wdw);
		break;
	case BPASTE:
		Editor_EditPaste(wdw);
		break;
	case BMOVE:
		Editor_IndentBlock(wdw);
		break;
#if 0
	case BSWITCH:
		Editor_BlockSwap(wdw);
		break;
	case BUPPER:
		Editor_BlockUp(wdw);
		break;
	case BLOWER:
		Editor_BlockDown(wdw);
		break;
	case BCAPITAL:
		Editor_BlockCapitals(wdw);
		break;
#endif

	case BFILTER:
		ProcessFilter(wdw, TRUE);
		break;
	case SFIND:
		DoSearchDialogue(wdw);
		break;
	case SAGAIN:
		SearchAgain(wdw, kstate);
		break;
	case SFINDSEL:
		SearchBlock(wdw, kstate);
		break;
	case SREPLACE:
		DoReplaceDialogue(wdw);
		break;
	case SRAGAIN:
		ReplaceAgain(wdw, kstate);
		break;
	case SBLSTART:
		Editor_ToBlockStart(wdw);
		break;
	case SBLEND:
		Editor_ToBlockEnd(wdw);
		break;
	case SSETMARK:
		GetOrSetMark(FALSE, wdw);
		break;
	case STOMARK:
		GetOrSetMark(TRUE, wdw);
		break;
	case STOERR:
		Editor_ShowError(wdw);
		break;
	case STOLINE:
		GetLine(wdw);
		break;
	case NEXTWDW:
		WdwManager_TopNextWindow();
		break;
	case WSTACKED:
		WdwManager_ArrangeWindows(STACKED);
		break;
	case WNEBEN:
		WdwManager_ArrangeWindows(BYSIDE);
		break;
	case WSTAFFEL:
		WdwManager_ArrangeWindows(OVERLAP);
		break;
	case WTILED:
		WdwManager_ArrangeWindows(TILED);
		break;
	case OFONTSEL:
		Editor_SelectFont(wdw);
		break;
/*DYJ 5.26b Start*/
	case OLANGUAGE:	/* Sprache */
	{
		_WORD strNr=-1;
		TEXTFILENO tf;
		_UBYTE *lang,cld[PATH_MAX];
		_UBYTE *home;
		switch(mtAlerts_Alert(1, rsc_WrkString(AL_LANGUAGE)))
		{
			case 1: /*Deutsch*/
				strNr=AL_DEUTSCH;
				lang=LANGUAGE_DE;
				break;
			case 2: /*Englisch*/
				strNr=AL_ENGLISH;
				lang=LANGUAGE_EN;
				break;
		}
		if ((home = getenv("HOME")) != NULL && *home != '\0')
			strCpy(cld,home);
		else
			strCpy(cld,HomePath);
		F_Path_Append(cld, CAT_LANG_FILE);

		if (mtTextfiles_OpenTextfile(cld, WRITE, 512, &tf) == GERR_OK)
		{
			mtTextfiles_WriteLine(tf, lang);
			mtTextfiles_CloseTextfile(&tf);
		}
		mtAlerts_Alert(1,rsc_WrkString(strNr));
		break;
	}
/*DYJ  Ende; */
	case OFKEYS:
		doFloskel();
		break;
	case OTABS:
		GetTabSize(wdw);
		break;
	case OERRFILE:
		doErrorBox();
		break;
	case OTABMODE:
		Editor_ToggleMode(wdw, tabMode);
		WdwManager_FullRedrawWdw(wdw);
		break;
	case OUMBRUCH:
		GetRightMargin(wdw);
		break;
	case OPATHS:
		PListHelp_SelectPaths(pathBox);
		break;
	case OSHORTI:
		doShortBox();
		break;
	case OPRINTER:
		doPrinter();
		break;
	case OINSERT:
		Editor_ToggleMode(wdw, insMode);
		break;
	case OINDENT:
		Editor_ToggleMode(wdw, indentMode);
		break;
	case OAUTOSAV:
		autoSavePos = !autoSavePos;
		ConfVars_SetConfigBool(cAutoSavePrefs, autoSavePos);
		break;
	case OSAVEINS:
		SavePrefs();
		break;
	case PCOMPEND:
	case PCOMPRUN:
	case PMAKE:
	case PMAKERUN:
	case PMAKEFILE:
	case PESCOMPILE:
	case PESLINK:
	case PESMAKE:
	case PESMAKEALL:
	case PESEXEC:
	case PESMAKEEXEC:
		hdlComp(item, wdw);
		break;
	}
	menu_tnormal(menu, title, 1);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID clickHandler(_WORD x, _WORD y, _UWORD Button, _WORD Clicks, _UWORD kstate)
{
	HWND wdw;
	_WORD res;

	UNUSED(kstate);
	if ((Button & MOB_RIGHT) && !(Button & MOB_LEFT))
	{
		wdw = WdwManager_ClickInWindow(x, y);
		if (wdw >= 0)
		{
			if (Editor_IsEditTop(wdw) &&
				!Editor_GetMode(wdw, errorMode) &&
				Editor_ClickIsInBlock(wdw, x, y) &&
				Clicks == 1)
			{
				/* Normaler Editor ist Top */
				res = mtPopups_PosPopup(x, y, " Ausschneiden | Kopieren | Filtern... ", "");
				switch (res)
				{
				case 0:
					Editor_EditCut(wdw, TRUE);
					break;
				case 1:
					Editor_EditCopy(wdw);
					break;
				case 2:
					ProcessFilter(wdw, FALSE);
					break;
				}
			}
		}
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID keyHdler(_UBYTE scan, _UBYTE ch, _UWORD moKState)
{
#define helpScan 0x62
#define escScan 0x01
	HWND wdw;
	_WORD num;
	_UBYTE varName[128];
	_UBYTE val[MAX_FLOSKEL_LEN];

	UNUSED(ch);
	wdw = theTopWindow;
	if (scan >= 0x3b && scan <= 0x44)
	{
		/* F1 bis F10 */
		if (!mouse)
		{
			MouseOn();
			mouse = TRUE;
		}
		if (moKState == 0 && Editor_IsEditTop(wdw))
		{
			num = scan - 0x3b + 1;
			make_varname(varName, sizeof(varName), cNormalFkey, num);
			if (ConfVars_GetConfigString(varName, val, sizeof(val)))
				Editor_PutLine(theTopWindow, val, strLen(val));	/*DYJ 5.20w */
		}
	} else if (scan >= 0x54 && scan <= 0x5d)
	{
		/* Shift-F1 bis F10 */
		if (Editor_IsEditTop(wdw) &&
			!(moKState & K_ALT) &&
			!(moKState & K_CTRL))
		{
			/* mit Shift! */
			num = scan - 0x54 + 1;
			make_varname(varName, sizeof(varName), cShiftF, num);
			if (ConfVars_GetConfigString(varName, val, sizeof(val)))
				Editor_PutLine(theTopWindow, val, strLen(val));	/*DYJ 5.20w */
		}
	} else if (scan == helpScan)
	{
		doHelp(theTopWindow, moKState);
	} else if (moKState & K_CTRL)
	{
		/* Test auf Ctrl-1 bis Ctrl^7 auf dem Ziffernblock */
		switch (scan)
		{
		case 0x6d:					/* Num-1 */
			hdlComp(PESCOMPILE, wdw);
			break;
		case 0x6e:					/* Num-2 */
			hdlComp(PESLINK, wdw);
			break;
		case 0x6f:					/* Num-3 */
			hdlComp(PESMAKE, wdw);
			break;
		case 0x6a:					/* Num-4 */
			hdlComp(PESMAKEALL, wdw);
			break;
		case 0x6b:					/* Num-5 */
			hdlComp(PESEXEC, wdw);
			break;
		case 0x6c:					/* Num-6 */
			hdlComp(PESMAKEEXEC, wdw);
			break;
#if 0
		case 0x67:					/* Num-7 */
			func = SeProto_SendProject;
			break;
#endif
		}
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL OnlyWildcards(CONST _UBYTE *name)
{
	while (*name != '\0')
	{
		if (strChr("*?.", *name) == NULL)	/*DYJ 5.20w */
			return FALSE;
		name++;
	}
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL KeyMsg(CONST _WORD *message, _WORD kReturn, _UWORD moKState)
{
	_UBYTE ch, scan;
	
	UNUSED(message);
	if (MenuKey_Test(menu, kReturn, moKState, menuMsgHdler, !mouse))
	{
		mouse = TRUE;
		event &= ~MU_KEYBD;			/* kein Keyboard */
	} else
	{
		scan = (kReturn >> 8) & 0xff;
		ch = kReturn & 0xff;
		keyHdler(scan, ch, moKState);
	}
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL TextMsg(CONST _WORD *message, _UBYTE *pName)
{
	HWND wdw;
	
	UNUSED(message);
	wdw = WdwManager_GetOwnTopWindow();
	if (Editor_IsEditTop(wdw))
	{
		return pName != NULL && Editor_PutLine(wdw, pName, strLen(pName));	/*DYJ 5.20w */
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL progStart(CONST _WORD *message, _UBYTE *pName, _UBYTE *pCmd)
{
#if 0
	_UBYTE path[PATH_MAX];
	_UBYTE name[PATH_MAX];
	_UBYTE suff[PATH_MAX];

	UNUSED(message);
	SplitPath(pName, path, name);
	if (pCmd != NULL)
	{
		return StartPrg(path, name, pCmd, TRUE) == 0;
	} else
	{
		suff[0] = '\0';
		return StartPrg(path, name, suff, TRUE) == 0;
	}
#else
	UNUSED(message);
	UNUSED(pName);
	UNUSED(pCmd);
	return FALSE;
#endif
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL openWind(CONST _WORD *message, _UBYTE *pName, _UBYTE *pCmd)
{
	HWND errWdw;

	/* AV_OPENWIND: Editor mit Datei oeffnen */
	UNUSED(message);
	if (pCmd == NULL || OnlyWildcards(pCmd))
	{
		if (pName != NULL)
			strBcpy(InPath, pName);
		strBcpy(InSel, "");
		if (mtDir_FselGet(InPath, InSel, ALL_FILE_MASK, Rsc_WrkString(FS_LOAD_FILE), FALSE))	/*DYJ 5.23e */
		{
			strBcpy(OpenName, InSel);
			OpenEditor(InPath, InSel, &errWdw, FALSE);
			return TRUE;
		}
	} else
	{
		OpenEditor(pName, pCmd, &errWdw, FALSE);
		return TRUE;
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL vaStart(CONST _WORD *message, CONST _UBYTE *pCmd)
{
	HWND errWdw;

	UNUSED(message);
	/* VA_START: pCmd enthaelt Kommandozeile */
	if (pCmd != NULL && *pCmd != '\0')
	{
		/* Jetzt Kommandozeile auswerten:
		 * entweder ist ein Dateiname enthalten oder sie faengt mit
		 * - an und ist eine Kommandoliste
		 */
		if (Editor_FileIsEditor(pCmd, &errWdw))
		{
			WdwManager_TopWindow(errWdw);
		} else
		{
			SplitPath(pCmd, InPath, OpenName);
			OpenEditor(InPath, OpenName, &errWdw, FALSE);
		}
	}
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL seOpen(CONST _UBYTE *pCmd, _LONG line, _WORD column)
{
	UNUSED(line);
	UNUSED(column);
	return vaStart(NULL, pCmd);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL seError(SEERRINFO *errorPtr)
{
	_UBYTE eMess[256];
	HWND errWdw;
	_UBYTE path[PATH_MAX];
	_UBYTE name[PATH_MAX];

	if (errorPtr->errMess != NULL)
	{
		strBcpy(eMess, errorPtr->errMess);
	} else
	{
		strBcpy(eMess, "Keine Fehlermeldung erhalten");
	}
	if (errorPtr->errFile != NULL)
	{
		if (Editor_FileIsEditor(errorPtr->errFile, &errWdw))
		{
			WdwManager_TopWindow(errWdw);
			Editor_SetError(errWdw, errorPtr->errLine, errorPtr->errRow - 1, eMess, TRUE);
		} else
		{
			SplitPath(errorPtr->errFile, path, name);
			if (OpenEditor(path, name, &errWdw, FALSE))
			{
				Editor_SetError(errWdw, errorPtr->errLine, errorPtr->errRow - 1, eMess, TRUE);
			}
		}
	}
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL seErrfile(CONST _UBYTE *fnamePtr, CONST _UBYTE *errPtr)
{
	HWND errWdw;
	_UBYTE path[PATH_MAX];
	_UBYTE name[PATH_MAX];

	if (fnamePtr != NULL && *fnamePtr != '\0')
	{
		if (!Editor_FileIsEditor(fnamePtr, &errWdw))
		{
			SplitPath(fnamePtr, path, name);
			OpenEditor(path, name, &errWdw, FALSE);
		}
	}
	if (errPtr != NULL && *errPtr != '\0')
	{
		SplitPath(errPtr, path, name);
		OpenEditor(path, name, &errWdw, TRUE);
	}
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL seClose(CONST _UBYTE *mask, _WORD control)
{
	UNUSED(mask);
	UNUSED(control);
	Editor_CloseAllEditors(TRUE);
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL seProject(CONST _UBYTE *fileName)
{
	_UBYTE menuText[20];
	
	strBcpy(menuText, "  ");
	if (fileName != NULL && *fileName != '\0')
	{
		strBcat(menuText, F_Path_Basename(fileName));
	} else
	{
		strBcat(menuText, "Makefile...");
	}
	menu_text(menu, PMAKEFILE, menuText);
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL seTerminate(_VOID)
{
	/* Wir tun einfach so, als haetten wir ein AP_TERM erhalten */
	quitProg = TRUE;
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL msgHandler(CONST _WORD *pBuff, _UWORD kstate)
{
	_BOOL handled;

	handled = TRUE;
	Protokoll_Check_Message(pBuff);
	switch (pBuff[0])
	{
	case MN_SELECTED:
		event &= ~MU_BUTTON;			/* keine Buttons */
		menuMsgHdler(pBuff[4], pBuff[3], kstate);
		break;
	case AP_TERM:
		quitProg = TRUE;
		break;
	}
	if (quitProg)
	{
		if (autoSavePos)
			Editor_EditSavePos();
		Editor_CloseAllEditors(TRUE);
	}
	return handled;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL SET menuSet;

LOCAL _VOID EnableItem(OBJECT *tree, _WORD item, _BOOL enable)
{
	if (enable)
	{
		if (setin(menuSet, item))
		{
			menu_ienable(tree, item, 1);
			setexcl(menuSet, item);
		}
	} else
	{
		if (!setin(menuSet, item))
		{
			menu_ienable(tree, item, 0);
			setincl(menuSet, item);
		}
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID CheckItem(OBJECT *tree, _WORD item, _BOOL enable)
{
	if (enable)
	{
		menu_icheck(tree, item, 1);
	} else
	{
		menu_icheck(tree, item, 0);
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID enableMenuItems(_VOID)
{
	HWND wdw;
	_BOOL bl;
	_BOOL isTop;
	_BOOL moreWinds;
	_BOOL twoWinds;

	wdw = theTopWindow;
	bl = Editor_BlockIsMarked(wdw);
	isTop = Editor_IsEditTop(wdw);
	moreWinds = WdwManager_TopNextPossible();
	twoWinds = WdwManager_TopNextPossible();

	EnableItem(menu, READFILE, isTop);
	EnableItem(menu, INFOFILE, isTop);
	EnableItem(menu, CLOSEWDW, isTop);
	EnableItem(menu, ABANDON, isTop);
	EnableItem(menu, SAVEFILE, isTop);
	EnableItem(menu, SAVEAS, isTop);
	EnableItem(menu, PRINTIT, isTop);
	EnableItem(menu, DOUNDO, isTop);
	EnableItem(menu, MARKALL, isTop);
	EnableItem(menu, BSTARTBL, isTop);
	EnableItem(menu, BBLEND, isTop);
	EnableItem(menu, BCUT, bl);
	EnableItem(menu, BCOPY, bl);
	EnableItem(menu, BPASTE, isTop);
	EnableItem(menu, BMOVE, bl);
	EnableItem(menu, BFILTER, bl);

	EnableItem(menu, SFIND, isTop);
	EnableItem(menu, SAGAIN, isTop && searchOpts.isSet);
	EnableItem(menu, SREPLACE, isTop);
	EnableItem(menu, SFINDSEL, isTop);
	EnableItem(menu, SRAGAIN, isTop && replaceOpts.isSet);
	EnableItem(menu, SBLSTART, bl);
	EnableItem(menu, SBLEND, bl);
	EnableItem(menu, SSETMARK, isTop);
	EnableItem(menu, STOMARK, isTop);
	EnableItem(menu, STOLINE, isTop);
	EnableItem(menu, STOERR, isTop);
	EnableItem(menu, NEXTWDW, moreWinds);
	EnableItem(menu, WSTACKED, twoWinds);
	EnableItem(menu, WNEBEN, twoWinds);
	EnableItem(menu, WSTAFFEL, twoWinds);
	EnableItem(menu, WTILED, twoWinds);
	EnableItem(menu, OFONTSEL, isTop);
#if 0
	EnableItem(menu, OTABS, isTop);
#endif

	EnableItem(menu, OUMBRUCH, isTop);
	EnableItem(menu, OTABMODE, isTop);
#if 0
	EnableItem(menu, OBACKUP, isTop);
#endif
	EnableItem(menu, OINSERT, isTop);
	EnableItem(menu, OINDENT, isTop);
	if (isTop)
	{
		CheckItem(menu, OTABMODE, Editor_GetMode(wdw, tabMode));
#if 0
		CheckItem(menu, Fredrsc.Obackup, Editor_GetMode(wdw, autoBackup));
#endif
		CheckItem(menu, OINSERT, Editor_GetMode(wdw, insMode));
		CheckItem(menu, OINDENT, Editor_GetMode(wdw, indentMode));
	}
	EnableItem(menu, PCOMPEND, isTop);
	EnableItem(menu, PCOMPRUN, isTop);
	EnableItem(menu, PMAKE, isTop || SeProto_Project_Activ(NULL));
	EnableItem(menu, PMAKERUN, isTop || SeProto_Project_Activ(NULL));

	EnableItem(menu, PESCOMPILE, isTop && SeProto_Activ());
	EnableItem(menu, PESLINK, isTop && SeProto_Activ());
	EnableItem(menu, PESMAKE, SeProto_Project_Activ(NULL));
	EnableItem(menu, PESMAKEALL, SeProto_Project_Activ(NULL));
	EnableItem(menu, PESEXEC, isTop && SeProto_Activ());
	EnableItem(menu, PESMAKEEXEC, SeProto_Project_Activ(NULL));
	EnableItem(menu, PMAKEFILE, SeProto_Activ());

	CheckItem(menu, OAUTOSAV, autoSavePos);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID cleanUp(_VOID)
{
	/* Pfadliste loeschen */
	Lists_DeleteSimpleList(&SrcPaths, mem_free, TRUE);
	MouseOn();
	if (menu != NULL)
	{
		ResetMenuline();
		menu = NULL;
	}
	Editor_CloseAllEditors(FALSE);
	EditFuncs_FreeShortkeyList();
	RscFreeLib();	/*DYJ 5.27a */
	if (the_rsc != NULL)
	{
		RscFree(the_rsc);
		the_rsc = NULL;
	}
	Protokoll_SendTerminate(TRUE);
	ConfVars_DeleteAllVars();
	Printer_FreeCFGFile();
	Wind_Update(END_UPDATE);
}

/*** ---------------------------------------------------------------------- ***/

/* Hier kommt jetzt der Crash-Handler */
/* Wird automatisch bei Terminierung des Programms aufgerufen */
#if 0
LOCAL _VOID crashHandler(_VOID)
{
	cleanUp();
	ApplTerm(termCode);
}
#endif

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL isFilename(CONST _UBYTE *s)
{
	if (strChr(s, '.') != NULL)	/*DYJ 5.20w */
		return TRUE;
	if (strChr(s, '\\') != NULL)	/*DYJ 5.20w */
		return TRUE;
	if (strChr(s, '/') != NULL)	/*DYJ 5.20w */
		return TRUE;
	if (strChr(s, ':') != NULL)	/*DYJ 5.20w */
		return TRUE;
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL isNumber(CONST _UBYTE *s)
{
	_BOOL valid;

	StrToLInt(s, NULL, &valid);
	return valid;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID insert_app_name(_UBYTE *title, size_t strsize)
{
	_BOOL setappname;
	
	ConfVars_GetConfDefBool(cApplicationNameInWindow, &setappname, TRUE);
	if (multiTask && setappname)
		Insert("[Fred] ", title, strsize, 0);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL FindOtherFred(_WORD *otherId)
{
	_UBYTE appName[256];
	_WORD dummy;
	
#if 0
	if (magIx)
	{
		_WORD i;
	
		strCpy(appName, "fred.prg");	/*DYJ 5.20w */
		*otherId = appl_find(appName);
		if (*otherId == gl_apid)
		{
			appName[0] = '?';
			appName[1] = '\0';
			appName[3] = '\0';
			for (i = otherId + 1; i < gl_ap_count; i++)
			{
				appName[2] = i;
				if (appl_find(appName) != 0 &&
					strcmp("FRED.PRG", appName) == 0)
				{
					return TRUE;
				}
			}
		} else
		{
			return TRUE;
		}
	} else
#endif
	{
		/* MultiTOS */
		MemSetZeroArray(appName);
		if (appl_search(APS_FIRST, appName, &dummy, otherId))
		{
			do
			{
				strdelRightSpace(appName);
				if (*otherId != gl_apid && strCaseCmp(appName, "FRED") == 0)
					return TRUE;
				MemSetZeroArray(appName);
			} while (appl_search(APS_NEXT, appName, &dummy, otherId));
		}
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID __CDECL sigHandler(_LONG sig)
{
	UNUSED(sig);
	termCode = 0;
	quitProg = TRUE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID installSignalHandler(_VOID)
{
	/* Folgende Signale werden abgefangen und ignoriert:
	 * SIGHUP, SIGINT, SIGSYS,
	 */
	Psigblock((1L << SIGHUP) | (1L << SIGINT) | (1L << SIGSYS));
	/* Folgende Signale werden mit Programmterminierung befolgt:
	 * SIGQUIT, SIGPIPE, SIGTERM, SIGXCPU
	 * Dabei ist es mir egal, ob die Installation geklappt hat oder nicht.
	 */
	Psignal(SIGTERM, (_LONG)sigHandler);
	Psignal(SIGQUIT, (_LONG)sigHandler);
	Psignal(SIGPIPE, (_LONG)sigHandler);
	Psignal(SIGXCPU, (_LONG)sigHandler);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID handleEvents(_VOID)
{
	_WORD dummy;
	_UWORD udummy;
	
	ClearBuffer(event, FALSE, moKState, SCAN, CH);

	if (event & MU_KEYBD)
	{									/* Keyboard - MenuKommandos */
		if (MenuKey_Test(menu, kReturn, moKState, menuMsgHdler, !mouse))
		{
			mouse = TRUE;				/* Wird dann in MenuSearch gemacht */
			event &= ~MU_KEYBD;			/* kein Keyboard */
		}
	}
	if (event & MU_BUTTON)
	{
		if (!mouse)
		{
			MouseOn();
			mouse = TRUE;
		}
		/* Warten auf loslassen oder waitingTime */
		e = evnt_multi(MU_BUTTON | MU_TIMER,
			0, 3, 0,
			0, 0, 0, 0, 0,
			0, 0, 0, 0, 0,
			mess, 100, 0,
			&dummy, &dummy, &udummy, &udummy, &dummy, &dummy);
	}
	WdwManager_HandleEvent(&event, mess, moButton, moKState, ch, scan, kReturn, moX, moY, bReturn);
	if (event & MU_MESAG)
	{
		msgHandler(mess, moKState);
		event &= ~MU_BUTTON;
		/* nicht gleichzeitig Button und Message! */
	}
	if (event & MU_M1)
	{
		if (!mouse)
		{
			MouseOn();
			mouse = TRUE;
		}
	}
	if (event & MU_BUTTON)
	{									/* Button */
		clickHandler(moX, moY, moButton, bReturn, moKState);
	}
	if (event & MU_KEYBD)
	{									/* Keyboard - kann eigentlich nur noch F-Taste sein */
		keyHdler(scan, ch, moKState);
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID handlePendingEvents(_VOID)
{
	_UWORD etv;
	_WORD dummy;
	_UWORD udummy;

	do
	{
		event = evnt_multi(MU_MESAG | MU_TIMER,
			0, 0, 0,
			0, 0, 0, 0, 0,
			0, 0, 0, 0, 0,
			mess,
			50, 0,
			&dummy, &dummy, &udummy, &udummy, &dummy, &dummy);

		etv = event;
		if (event & MU_MESAG)
		{
			Wind_Update(BEG_UPDATE);
			handleEvents();
			Wind_Update(END_UPDATE);
		}
	} while (etv & MU_MESAG);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID ParseCommandArgs(_WORD argc, CONST _UBYTE **argv)
{
	_BOOL started;
	_BOOL firstNumber;
	_BOOL numberRead;
	CONST _UBYTE *para;
	HWND wdw;
	EDLINE eLine;
	EDCOLUMN eRow;
	_UBYTE eMsg[256];
	_UBYTE fullName[PATH_MAX];
	_UBYTE path[PATH_MAX];
	_UBYTE name[PATH_MAX];
	_WORD i;
	_WORD otherId;
	
	firstNumber = TRUE;
	numberRead = FALSE;
	eLine = 0;
	eRow = 0;
	wdw = -1;
	i = 1;
	eMsg[0] = '\0';
	started = FALSE;
	while (i < argc)
	{
		para = argv[i];
		++i;
		if (isFilename(para))
		{
			strBcpy(fullName, para);
			SplitPath(fullName, path, name);
			if (multiTask && FindOtherFred(&otherId))
			{
				VaProto_SendOpenwind(otherId, path, name);
				Wind_Update(END_UPDATE);
				started = FALSE;
				do
				{
					event = evnt_multi(MU_TIMER | MU_MESAG,
						0, 0, 0,
						0, 0, 0, 0, 0,
						0, 0, 0, 0, 0,
						mess,
						500, 0,
						&moX, &moY, &moButton, &moKState, &kReturn, &bReturn);
					/* Timeout 500 ms */
					if ((event & MU_MESAG) && mess[0] == VA_WINDOPEN)
					{
						started = started || (mess[3] != 0);
					}
				} while (event != MU_TIMER);
				Wind_Update(BEG_UPDATE);
			} else
			{
				started = FALSE;
			}
			if (!started && OpenEditor(path, name, &wdw, FALSE))
			{
				strBcpy(InPath, path);
			}
		} else if (isNumber(para))
		{
			if (firstNumber)
			{
				eLine = StrToLInt(para, NULL, NULL);
				firstNumber = FALSE;
			} else
			{
				eRow = StrToInt(para, NULL, NULL);
				numberRead = TRUE;
			}
		} else
		{
			/* Muss Fehlermeldung sein */
			strBcpy(eMsg, para);
			if (strChr(eMsg, '"') != NULL)	/*DYJ 5.20w */
			{
				/* Stringanfang oder Ende in Parameter */
				while (i < argc)
				{
					strBcat(eMsg, " ");
					para = argv[i];
					++i;
					strBcat(eMsg, para);
					if (strChr(para, '"') != NULL)	/*DYJ 5.20w */
						break;
				}
			}
			if (numberRead && wdw > 0)
			{
				Editor_SetError(wdw, eLine, eRow, eMsg, TRUE);
				firstNumber = TRUE;
				numberRead = FALSE;
			} else if (!firstNumber && wdw > 0)
			{
				Editor_SetError(wdw, eLine, 0, eMsg, TRUE);
				/* allSet = TRUE; */
				firstNumber = TRUE;
			} else if (wdw > 0)
			{
				Editor_SetError(wdw, 1, 0, eMsg, TRUE);
			}
		}
	}
	if (started)
	{
		cleanUp();
		ApplTerm(0);
	}
	if (!firstNumber || numberRead)
	{
		if (numberRead)
		{
			Editor_SetError(wdw, eLine, eRow, eMsg, TRUE);
		} else
		{
			Editor_SetError(wdw, eLine, 0, eMsg, TRUE);
		}
	}
}

/*** ---------------------------------------------------------------------- ***/

int main(int argc, CONST char **argv)
{
	GRECT mrect;
	EVENT e;
	EVNT ev;
	
	(_VOID)Pdomain(1);
	isMiNTDomain = Pdomain(-1) > 0;
	filterNumber = 0;
	shortFileRead = FALSE;
	searchOpts.isSet = FALSE;
	replaceOpts.isSet = FALSE;
	installSignalHandler();
#if 0
	CatchProcessTerm(rHdl, crashHandler, stck);
#endif

#if SPEC_DEBUG
	is_DEBUGGING = FALSE;
#endif
	ApplInit();
	errIndex = 0;

	MouseBusy();
	termCode = 0;
	CatGlobal_Init();
	mtDials_Init();
	ConfVars_Init();
	WdwManager_Init();
	
/*DYJ 5.23e Start*/
	if (InitResource())
/*DYJ  Ende; alt:	
	if (InitResource("fred.rsc"))
*/
	{
		setclr(menuSet);
		ConfVars_GetConfDefBool(cAutoSavePrefs, &autoSavePos, FALSE);

		mtAlerts_ConfigAlert(alert_alticon);
		EditType_Init();
		
		{
			_BOOL boolVal;
			
			/* Pruefen, wie die Alerts aussehen sollen */
			ConfVars_GetConfDefBool(cAlertsInWindow, &boolVal, FALSE);
			WinDials_AlertsInWindow(boolVal);
		}
		
		Wind_Update(BEG_UPDATE);

		if (multiTOS || (magIx && magIxVer >= 0x300))
		{
			/* MultiTOS */
			menu_register(gl_apid, eddixName);
		}
		menu_register(-1, ProgramName);

		{
			_WORD level, dummy;

			/* Und auch Bescheid sagen, dass wir AP_TERM verstehen */
			if ((appl_xgetinfo(APG_SHELLW, &level, &dummy, &dummy, &dummy) && ((level & 0xff) >= 9)) ||
				(magIxVer >= 0x300))
			{
				shel_write(9 /* InformAES */, 1, 1, NULL, NULL);
			}
		}

		InitMenuline(menu);
		DrawMenuline(menu);    /* show our menubar          */

		mtDials_DialConfig(UseConfig, FALSE);

/* ---------------------------------------------------------------------- */

		/* Protokolle initialisieren */
		Xacc_Register_Key(KeyMsg);
		Xacc_Register_Text(TextMsg);
		VaProto_Register_Sendkey(KeyMsg);
		VaProto_Register_Startprog(progStart);
		VaProto_Register_Openwind(openWind);
		VaProto_Register_Start(vaStart);
		SeProto_Register_Open(seOpen);
		SeProto_Register_Error(seError);
		SeProto_Register_Errfile(seErrfile);
		SeProto_Register_Close(seClose);
		SeProto_Register_Terminate(seTerminate);
		SeProto_Register_Project(seProject);
		Protokoll_ProtoInit();

		/* Events behandeln! */
		Wind_Update(END_UPDATE);
		handlePendingEvents();
		Wind_Update(BEG_UPDATE);

		/* Parameter holen und auswerten */
		ParseCommandArgs(argc, (CONST _UBYTE **)argv);

		Editor_EditRestorePos(editList == NULL);

		if (ConfVars_GetConfigString(cShortFile, lastShort, sizeof(lastShort)))
		{
			Editor_ReadShortkeyFile(lastShort);
			shortFileRead = TRUE;
		}

		/* Jetzt koennen wir endlich normal weitermachen */
		if (FindCookie(COOKIE_MagicPC, NULL))
		{
			_BOOL trans;
			
			ConfVars_GetConfDefBool(cMagicPCKeyTranslation, &trans, TRUE);
			if (trans)
				SetMagicPCKeyTranslation(TRUE);
		}

		Wind_Update(END_UPDATE);			/* wg. sofort wieder aus.. */

		handlePendingEvents();				/* Events behandeln! */

		WdwManager_InstallGlobalMenu(menu, msgHandler);

		Wind_Update(BEG_UPDATE);			/* wg. sofort wieder aus.. */

		MouseArrow();
		mouse = TRUE;
		mrect.g_x = 0;
		mrect.g_y = 0;
		mrect.g_w = 1;
		mrect.g_h = 1;

		while (!quitProg)
		{
			enableMenuItems();

			Wind_Update(END_UPDATE);

			if (PendingKey())
			{
				event = MU_KEYBD;
				PopKey(&moKState, &scan, &ch);
			} else
			{
				e.ev_mflags = MU_KEYBD | MU_BUTTON | MU_MESAG | MU_TIMER;
				if (!mouse)
					e.ev_mflags |= MU_M1;
				e.ev_mwich = 0;
				e.ev_mbclicks = 256 | 3;
				e.ev_bmask = 3;
				e.ev_mbstate = 0;
				e.ev_mm1flags = 1;
				e.ev_mm1x = mrect.g_x;
				e.ev_mm1y = mrect.g_y;
				e.ev_mm1width = mrect.g_w;
				e.ev_mm1height = mrect.g_h;
				e.ev_mm2flags = 0;
				e.ev_mm2x = 0;
				e.ev_mm2y = 0;
				e.ev_mm2width = 0;
				e.ev_mm2height = 0;
				e.ev_mtlocount = 350;
				e.ev_mthicount = 0;

				if (fnts_func != NULL)
					fnts_func(TRUE, &e);
				if (e.ev_mwich == 0)
				{
					e.ev_mwich = evnt_multi(e.ev_mflags, e.ev_mbclicks, e.ev_bmask, e.ev_mbstate,
						e.ev_mm1flags, e.ev_mm1x, e.ev_mm1y, e.ev_mm1width, e.ev_mm1height,
						e.ev_mm2flags, e.ev_mm2x, e.ev_mm2y, e.ev_mm2width, e.ev_mm2height,
						e.ev_mmgpbuf,
						e.ev_mtlocount, e.ev_mthicount,
						&e.ev_mmox, &e.ev_mmoy, &e.ev_mmobutton, &e.ev_mmokstate, &e.ev_mkreturn, &e.ev_mbreturn);
				}

				event = e.ev_mwich;
				moX = e.ev_mmox;
				moY = e.ev_mmoy;
				moButton = e.ev_mmobutton;
				moKState = e.ev_mmokstate;
				kReturn = e.ev_mkreturn;
				bReturn = e.ev_mbreturn;
				mess[0] = e.ev_mmgpbuf[0];
				mess[1] = e.ev_mmgpbuf[1];
				mess[2] = e.ev_mmgpbuf[2];
				mess[3] = e.ev_mmgpbuf[3];
				mess[4] = e.ev_mmgpbuf[4];
				mess[5] = e.ev_mmgpbuf[5];
				mess[6] = e.ev_mmgpbuf[6];
				mess[7] = e.ev_mmgpbuf[7];
				
				mrect.g_x = moX;
				mrect.g_y = moY;
				CH = kReturn & 0xff;
				SCAN = (kReturn >> 8) & 0xff;
				ch = CH;
				scan = SCAN;
				
				if (fnts_func != FUNK_NULL)
				{
					ev.mwhich = event;
					ev.mox = moX;
					ev.moy = moY;
					ev.button = moButton;
					ev.state = moKState;
					ev.key = kReturn;
					ev.clicks = bReturn;
					ev.message[0] = mess[0];
					ev.message[1] = mess[1];
					ev.message[2] = mess[2];
					ev.message[3] = mess[3];
					ev.message[4] = mess[4];
					ev.message[5] = mess[5];
					ev.message[6] = mess[6];
					ev.message[7] = mess[7];
					fnts_func(FALSE, &ev);
					event = (event & ~MU_KEYBD) | (ev.mwhich & MU_KEYBD);
				}
			}

			Wind_Update(BEG_UPDATE);

			handleEvents();

		}

		if (autoSavePos)
		{
			SavePrefs();
		}
	}
	cleanUp();
	ApplTerm(termCode);
	return termCode;
}
