/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */


/*==============================================================*
 * Modul:               Protokollmodul fuer Fred                *
 * Autor:               Johannes Goettker-Schnetmann            *
 * Autor:               Dirk Steins                             *
 * Autor:               Thorsten Otto                           *
 * erstellt am:         Juni 1993                               *
 * letzte Aenderung am: 10.01.1998                              *
 * Version:             1.0                                     *
 * Interne Version:     V#0002                                  *
 *==============================================================*

 Dieses Modul macht Fred zu einem Xacc-Hauptprogramm der Stufe 1. Ausserdem 
 werden vom AV/VA-Protokoll die sinnvollen Msgs unterstuetzt.
 
 Entstanden ist dieses Modul aus dem Protokoll-Modul von CAT.

 Die Erlaeuterung des erweiterten Protokolls steht weiter unten. "HelloWatchDog"
 hat jetzt die allgemeinere Bedeutung "CatMsg".
 Insbesondere die Erkennung des WatchDogs soll in einer der naechsten Versionen
 nach Moeglichkeit auf die Methode des erweiterten Protokolls umgestellt werden.

 *----------------------------------------------------------------------------
 * Datum    Vers. Autor  Aenderung (Arbeitsbericht)                           
 *----------------------------------------------------------------------------
 * 01.02.92 0002  JGS    Protokollerweiterung fuer Steueraccs
 * 24.05.93 0003  DS     Erweiterung um MultiTasking-Unterstuetzung
 *                       CAT XACC-Versionsnummer geaendert auf 20H
 *----------------------------------------------------------------------------
 */

#include <protokol.h>
#include <xacc.h>
#include <catgloba.h>
#include <vaproto.h>
#include <seproto.h>

#include <mtappl.h>

#include <ro_mem.h>

#define appName    "FRED    \0" "XDSC\0" "1Texteditor\0" "2ED\0" "XFontAck\0" "\0"

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID Protokoll_ProtoInit(_VOID)
{
	Xacc_Init(appName, sizeof(appName));
	VaProto_Init(appName, sizeof(appName));
	/* SE-Protokoll initialisieren */
	SeProto_Init();
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID Protokoll_SendTerminate(_BOOL terminate)
{
	/* Und unter MultiTOS auch noch ACC_EXIT verschicken an alle
	 * anderen Applikationen, die sich gemeldet haben
	 */
	Xacc_SendTerminate(terminate);
	VaProto_SendTerminate(terminate);
	SeProto_SendTerminate(terminate);
}
