/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */


#ifndef __SEPROTO_H__
#define __SEPROTO_H__

#ifndef __PORTAB_H__
#include <portab.h>
#endif

#if 0
Gruppe: Persoenliche
ID:   P50793@HH
Wg.:  SE-Protokol
Von:  Christian Felsch @ HH (Do, 01.02.96 17:41)
An:   Dirk Steins @ K2
MId:  199602011741.p50793@hh.maus.de


 Hallo Dirk!

In Absprache mit Frank Schramm @ HH2 habe ich folgende Erweiterungen fuer das
SE-Protokol vorzuschlagen:

   SEPROTOVERSION 0x101

   SE_CLOSE
      msg[3,4] = Zeiger auf Name oder Maske der Dateien, die geschlossen
                 werden sollen.
      msg[5]   = Flag
                  0: Datei[en] nur sichern.
                  1: Datei[en] sichern und schliessen.

   SE_PROJECT,
   ES_PROJECT
      msg[3,4] = Zeiger auf Dateiname oder NULL, damit man ein Projekt
                 abmelden kann.


Die PC-Shell von Frank und qed werden diese Erweiterungen benutzen, sind aber
durch die Kontrolle der Protokol-Version selbstverstaendlich kompatibel zur
Version 1.00.
Wir wuerden es beguessen, wenn Du die nderungen in das offizielle SE-Protokol
uebernimmst!

Noch eine andere Frage: sollte ein Programm eigentlich zwingend auf die
Bestaetigung eines Kommandos warten? qed macht das z.Zt. so, dass er nach dem
Abschicken eines SE-Kommandos ein Timerevent einklinkt und eine bestimmte Zeit
auf den SE_ACK wartet. Wenn er nicht kommt, meldet qed das und vergisst die
Shell als Kommunikationspartner.
Das Problem tritt immer dann auf, wenn die Shell gerade beschaeftigt ist (z.B.
mit dem Compiler) und der Editor schickt erneut etwas.

 Chris.


An:   Dirk Steins @ K2
MId:  199607210940.p60841@hh.maus.de
Hierzu gibt es einen Kommentar


 Hallo Dirk!

Dirk Haun und ich denken gerade mal wieder ueber ein paar nderungen und
Erweiterungen am SE-Protokol nach:

Ich habe eine Nachricht definiert, in der ein Array mit den Texten uebergeben
wird, die der Editor in sein SE-Menue eintraegt. Bisher stand bei qed immer
'Compiler', 'Make' usw. Fuer eine TeX-Shell waere es aber schoen, wenn dort
'LaTeX', 'DVI ansehen' usw. stehen wuerde. Ich habe mal testweise folgende neue
Nachricht in qed und meine TeX-Shell eingebaut:

#define SE_MENU    0x4210
 /* Die Shell teilte dem Editor mit, was er fuer die einzelnen Programme
  * in sein Menue eintragen soll.
  * Ein Element darf auch NULL sein.
  * Word 3+4: Ein Zeiger auf die Stuktur mit den Eintraegen.
  * Mit ES_ACK bestaetigt der Editor die Meldung.
  */

typedef struct
{
   _UBYTE *compStr;
   _UBYTE *makeStr;
   _UBYTE *makeAllStr;
   _UBYTE *linkStr;
   _UBYTE *execStr;
   _UBYTE *makeexecStr;
} SEMENUINFO;

Ausserdem waere es sinnvoll, wenn man optional beim SE_OPEN eine Cursorposition
angeben koennte. Die Daten dafuer passen gerade noch in das Array:
 Word 5+6 LONG fuer die Zeilennummer
 Word 7   WORD fuer die Spaltennummer

Was meinst Du zu den beiden Punkten?

#endif


/* SE-Protokoll zur Kommunikation zwischen Shells zur Programmentwicklung
 * und Editoren.
 *
 * Dieses Protokoll dient dazu, unter Multitasking-Systemen die Shell
 * zur Compilierung und aehnlichen Sachen zu veranlassen, und um Fehler-
 * meldungen und/oder Fehlerdateien an den Editor zurueckzugeben.
 *
 * Kommandos bzw. Nachrichten von der Shell zum Editor beginnen
 * mit SE_, Nachrichten vom Editor zur Shell beginnen mit ES_
 *
 * Da teilweise Zeiger auf Speicherbereiche uebergeben werden, ist vom
 * jeweiligen Absender der Nachricht darauf zu achten, dass diese
 * Speicherbereiche vom Empfaenger auch lesbar sind (Memory Protection!).
 * Dafuer sind diese als Readable zu allozieren!
 *
 *
 * Erweiterungen
 *
 * Datum    Version nderungen
 *
 * 30.01.96  1.01   SE_CLOSE fr Dateien/Masken, mit Close-Flag
 *                    msg[5] = 0 -> nur sichern
 *                    msg[5] = 1 -> sichern + schlieen
 *                  ES/SE_PROJEKT mit leerem Argument (NULL)
 *                  Um zur Version 0x100 kompatibel zu sein, sollte
 *                  das Programm die Versionsnummer berprfen!!
 *
 * 13.08.96  1.02   SE_OPEN mit Zeilen- und Spaltennummer
 *                  neue Nachricht SE_MENU
 *
 * 19.11.96  1.03   bei ES_COMPILE kann der Dateiname auch NULL sein
 *
 * 08.01.97  1.04   SE_CLOSE: Flag 2 (schlieen ohne sichern)
 *                  SE_MENU: progName
 *
 * 23.12.97  1.05   ES_SHLCTRL neu, zur Kontrolle der Shell
 *                  Dafr neuer String in SEMENUINFO.
 *
 *
 * Version  Datum        Aenderungen
 * =====================================================================
 *   0.1    10.01.94     Erster Entwurf
 *   0.2    17.01.94     SE_TERMINATE hinzugefuegt
 *   0.3    25.01.94     SE_CLOSE hinzugefuegt.
 *                       SEERRINFO geaendert, SE_ERROR geaendert
 *                       tShellCommands und tEditCommands korrigiert
 *   0.4    21.08.96     Erweitert auf Version SEPROTOVERSION 1.02
 *   0.5    04.03.98     Erweitert auf Version SEPROTOVERSION 1.05
 */

typedef struct _errInfo {
	_UBYTE *errFile;		/* Zeiger auf den Namen der compilierten Datei */
	_UBYTE *errMess;		/* Zeiger auf die Fehlermeldung */
	_WORD errNum;			/* Die Fehlernummer */
	_LONG errLine;			/* Die fehlerhafte Zeile */
	_WORD errRow;			/* Die Spalte mit dem Fehler (oder 0) */
} SEERRINFO;

typedef struct _menuInfo {
	_UBYTE *compStr;
	_UBYTE *makeStr;
	_UBYTE *makeAllStr;
	_UBYTE *linkStr;
	_UBYTE *execStr;
	_UBYTE *makeExecStr;
	_UBYTE *progName;		/* neu ab 0x104 */
	_UBYTE *shellCtrlStr;	/* neu fuer ES_SHLCTRL ab 0x105 */
} SEMENUINFO;

typedef _BOOL (*SeOpen)(CONST _UBYTE *pCmd, _LONG line, _WORD column);
typedef _BOOL (*SeError)(SEERRINFO *error);
typedef _BOOL (*SeErrfile)(CONST _UBYTE *fnamePtr, CONST _UBYTE *errFile);
typedef _BOOL (*SeClose)(CONST _UBYTE *mask, _WORD control);
typedef _BOOL (*SeTerminate)(_VOID);
typedef _BOOL (*SeProject)(CONST _UBYTE *fnamePtr);
typedef _BOOL (*SeMenu)(SEMENUINFO *menuInfo);

_VOID SeProto_Register_Open(SeOpen func);
_VOID SeProto_Register_Error(SeError func);
_VOID SeProto_Register_Errfile(SeErrfile func);
_VOID SeProto_Register_Close(SeClose func);
_VOID SeProto_Register_Menu(SeMenu func);
_VOID SeProto_Register_Project(SeProject func);
_VOID SeProto_Register_Terminate(SeTerminate func);

/* Schickt eine ES-Nachricht an den Teilnehmer */
_BOOL SeProto_SendCompile(CONST _UBYTE *fname);
_BOOL SeProto_SendMakeall(CONST _UBYTE *fname);
_BOOL SeProto_SendMake(CONST _UBYTE *fname);
_BOOL SeProto_SendExec(CONST _UBYTE *fname);
_BOOL SeProto_SendMakeexec(CONST _UBYTE *fname);
_BOOL SeProto_SendLink(CONST _UBYTE *fname);
_BOOL SeProto_SendProject(CONST _UBYTE *fname);

_VOID SeProto_Init(_VOID);
/* Initialisierung fuer SeProto */


_BOOL SeProto_Activ(_VOID);
/* Gibt zurueck, ob das SE-Protokoll aktiv ist
 */

_BOOL SeProto_Project_Activ(_UBYTE *filename);
/* Gibt zurueck, ob ein Projekt aktiv ist
 */

_VOID SeProto_SendTerminate(_BOOL terminate);


#endif /* __SEPROTO_H__ */
