/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */


/*==============================================================*
 * Modul:               Modul zur Verwaltung der Abrufboxen     *
 * Autor:               Dirk Steins                             *
 * erstellt am:         16.10.1993                              *
 * letzte Aenderung am: 16.10.1993                              *
 * Version:             1.0                                     *
 * Interne Version:     V#0001                                  *
 *==============================================================*

 *----------------------------------------------------------------------------
 * Datum    Vers. Autor  Aenderung (Arbeitsbericht)                            
 *----------------------------------------------------------------------------
 *----------------------------------------------------------------------------
 */

#include <plisthel.h>
#include <listdl.h>
#include <mte.h>
#include <confvars.h>
#include <windials.h>
#include <vdiutil.h>

#include <mtappl.h>
#include <mtdials.h>
#include <mtalerts.h>
#include <mtutils.h>
#include <mtrsc.h>
#include <mtdir.h>
#include <w_graf.h>

#include <fred.h>

#include <ro_mem.h>
#include <routinec.h>
#include <routines.h>
#include <strconv.h>
#include <file_io.h>
#include <lists.h>	/*DYJ 1.01 */

typedef struct {
	_UBYTE *entry;
	_BOOL selected;
} pathEntry;

EXTERN List SrcPaths;
EXTERN RESOURCE the_rsc;

LOCAL OBJECT *pathBox;

#define clipInfo        "[1][%P:|Dieses Klemmbrett enth\204lt den zuletzt|von Ihnen gel\224schte Pfad. Momentan|k\224nnen Sie es nicht benutzen,|da es leer ist.][[OK]"

#define AL_DUPLICATE_PATH "[3][%P:|Der Pfad ist schon|in der Pfadliste!][[Abbruch]"

#define FS_TITEL        "Pfad ausw\204hlen"

typedef struct {
	_WORD exitBut;
	specialButHdler specials[6];
	_VOID *lastSel;
	pathEntry *clipEntry;
	_WORD globalLength;
	List pathList;
} pathInfo;

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

LOCAL _VOID *nextEntry(_VOID *list)
{
	return Lists_NextEntry(list);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID *prevEntry(_VOID *list)
{
	return Lists_PrevEntry(list);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID resetList(_VOID *list)
{
	Lists_ResetList(list);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID countEntries(_VOID *l, _LONG *ll, _WORD *ww)
{
	List *lp;
	pathInfo *info;
	
	lp = l;
	info = lp->user;
	*ww = info->globalLength * CharWidth;
	*ll = Lists_NoOfEntries(lp);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL isEnabled(_VOID *entry, _VOID *env)
{
	UNUSED(entry);
	UNUSED(env);
	return TRUE;
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

LOCAL _BOOL selGrEntry(_VOID *entry, _VOID *env, _WORD line)
{
	pathEntry *gr;

	UNUSED(env);
	UNUSED(line);
	gr = entry;
	if (gr == NULL)
		return FALSE;
	gr->selected = !gr->selected;
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID groupToStr(_VOID *entry, _VOID *env, _UBYTE *str, size_t strsize)
{
	pathEntry *gr;
	pathInfo *info;
	
	info = env;
	gr = entry;
	if (gr == NULL)
	{
		*str = '\0';
	} else
	{
		strMcpy(str, strsize, gr->entry);
		info->globalLength = Max(info->globalLength, (_WORD)strLen(str) + 2);	/*DYJ 5.20w */
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL findSel(_VOID *entry, _VOID *inf)
{
	pathEntry *gr = entry;

	UNUSED(inf);
	return gr->selected;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL findName(_VOID *entry, _VOID *inf)
{
	pathEntry *gr = entry;

	return strCaseCmp(gr->entry, inf) == 0;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID disposeEntry(_VOID *e)
{
	pathEntry *entry;
	
	entry = e;
	if (entry != NULL)
	{
		if (entry->entry != NULL)
			SFREE(entry->entry);
		OFREE(entry);
	}
}
	
/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID disposeClipEntry(pathInfo *info)
{
	if (info->clipEntry != NULL)
	{
		disposeEntry(info->clipEntry);
		info->clipEntry = NULL;
	}
}

/*** ---------------------------------------------------------------------- ***/

/*DYJ 5.30f Start*/
LOCAL _VOID cutEntry(_WORD obj, _VOID *env, LISTINFO listinfo, _BOOL *draw, _BOOL *exit,_LONG *lstSel)
/*DYJ  Ende; alt:	
LOCAL _VOID cutEntry(_WORD obj, _VOID *env, LISTINFO listinfo, _BOOL *draw, _BOOL *exit)
*/
{
	GRECT r;
	_BOOL found;
	pathInfo *info;
	
	*lstSel=-1;	/*DYJ 5.30f */
	info = env;
	/* Selektierten Eintrag in der Liste finden und aus der Liste entfernen */
	Lists_ResetList(&info->pathList);
	if ((found = Lists_ScanEntries(&info->pathList, Lists_forward, findSel, NULL)) != FALSE)
	{
		/* Alten Eintrag loeschen */
		disposeClipEntry(info);
		info->clipEntry = Lists_CurrentEntry(&info->pathList);
		Lists_RemoveEntry(&info->pathList, FUNK_NULL);
		ListMan_ListScroll2Selection(listinfo, TRUE);
		/* Nun das neue Icon darstellen */
		DelObjFlags(pathBox, PCLFULL, HIDETREE);
		SetObjFlags(pathBox, PCLEMPTY, HIDETREE);
		CalcArea(pathBox, PCLFULL, &r);
		WinDials_WinDialDraw(pathBox, ROOT, MAX_DEPTH, &r, TRUE);
	}
	DelObjState(pathBox, obj, SELECTED);
	WinDials_WinDialDraw(pathBox, obj, 1, &r, FALSE);
	*draw = found;
	*exit = FALSE;
}

/*** ---------------------------------------------------------------------- ***/

/*DYJ 5.30f Start*/
LOCAL _VOID pasteEntry(_WORD obj, _VOID *env, LISTINFO listinfo, _BOOL *draw, _BOOL *exit,_LONG *lstSel)
/*DYJ  Ende; alt:	
LOCAL _VOID pasteEntry(_WORD obj, _VOID *env, LISTINFO listinfo, _BOOL *draw, _BOOL *exit)
*/
{
	GRECT r, r1, r2;
	_WORD x, y;
	_UWORD kstate, buts;
	_LONG index;
	pathEntry *adr;
	pathInfo *info;
	
	UNUSED(obj);
	*exit = FALSE;
	info = env;
	if (info->clipEntry == NULL)
	{
		*draw = FALSE;
		return;
	}
	ObjcArea(pathBox, PCLFULL, &r1);
	ObjcArea(pathBox, ROOT, &r2);
	graf_mkstate(&x, &y, &buts, &kstate);
	if (buts & MOB_LEFT)
	{
		Graf_dragbox(&r1, &r2, &x, &y);
		graf_mkstate(&x, &y, &buts, &kstate);
		index = ListMan_ListClick(listinfo, x, y, kstate, 0);
		/* Persoenliche bleiben immer vorne: */
		if (index == 0)
			++index;
		if (index > 0)
		{
			adr = ListMan_ListFindEntry(listinfo, index);
			if (adr == NULL)
			{
				Lists_AppendEntry(&info->pathList, info->clipEntry);
			} else
			{
				if (index > 1)
					Lists_PrevEntry(&info->pathList);
				Lists_InsertEntry(&info->pathList, info->clipEntry);
			}
			/* Jetzt mal schnell alle Eintraege deselektieren */
			Lists_ResetList(&info->pathList);
			while ((adr = Lists_NextEntry(&info->pathList)) != NULL)
				adr->selected = FALSE;
			info->clipEntry->selected = FALSE;
			selGrEntry(info->clipEntry, env, 0);
			ListMan_ListScroll2Selection(listinfo, TRUE);
			SetObjFlags(pathBox, PCLFULL, HIDETREE);
			DelObjFlags(pathBox, PCLEMPTY, HIDETREE);
			CalcArea(pathBox, PCLEMPTY, &r);
			WinDials_WinDialDraw(pathBox, ROOT, MAX_DEPTH, &r, TRUE);
			info->clipEntry = NULL;
			*draw = TRUE;
			*lstSel=-1;	/*DYJ 5.30f */
		} else
		{
			*draw = FALSE;
		}
	} else
	{
		*draw = FALSE;
	}
}

/*** ---------------------------------------------------------------------- ***/

/*DYJ 5.30f Start*/
LOCAL _VOID clipEmpty(_WORD obj, _VOID *env, LISTINFO listinfo, _BOOL *draw, _BOOL *exit,_LONG *lstSel)
/*DYJ  Ende; alt:	
LOCAL _VOID clipEmpty(_WORD obj, _VOID *env, LISTINFO listinfo, _BOOL *draw, _BOOL *exit)
*/
{
	UNUSED(obj);
	UNUSED(env);
	UNUSED(lstSel);	/*DYJ 5.30f */
	UNUSED(listinfo);
	MTE_InfoAlert(clipInfo, NULL, NULL);
	*draw = FALSE;
	*exit = FALSE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID updateButton(_VOID *entry, _VOID *env)
{
	_BOOL oneSel;
	GRECT r;
	pathInfo *info;
	
	UNUSED(entry);
	info = env;
	Lists_ResetList(&info->pathList);
	oneSel = Lists_ScanEntries(&info->pathList, Lists_forward, findSel, NULL);
	oneSel = oneSel && (info->clipEntry == NULL);
	if ((oneSel && GetObjState(pathBox, PDELETE, DISABLED)) ||
		(!oneSel && !GetObjState(pathBox, PDELETE, DISABLED)))
	{
		EnableObjState(pathBox, PDELETE, DISABLED, !oneSel);
		WinDials_WinDialDraw(pathBox, PDELETE, 0, &r, FALSE);
		EnableObjState(pathBox, PCHANGE, DISABLED, !oneSel);
		WinDials_WinDialDraw(pathBox, PCHANGE, 0, &r, FALSE);
	}
}

/*** ---------------------------------------------------------------------- ***/

/*DYJ 5.30f Start*/
LOCAL _VOID getSystemPaths(_WORD obj, _VOID *env, LISTINFO listinfo, _BOOL *draw, _BOOL *exit,_LONG *lstSel)
/*DYJ  Ende; alt:	
LOCAL _VOID getSystemPaths(_WORD obj, _VOID *env, LISTINFO listinfo, _BOOL *draw, _BOOL *exit)
*/
{
	CONST _UBYTE *systemPath;
	CONST _UBYTE *p, *p1;
	_UBYTE *path;
	pathEntry *new;
	size_t len;
	GRECT r;
	pathInfo *info;
	
	UNUSED(listinfo);
	info = env;
	*draw = FALSE;
	/* suchen nach Environment-Variable PATH */
	systemPath = getenv("PATH");
	if (systemPath != NULL)
	{
		p = systemPath;
		
		do
		{
			p1 = strChr(p, ',');	/*DYJ 5.20w */
			if (p1 == NULL)
				p1 = strChr(p, ';');	/*DYJ 5.20w */
			if (p1 == NULL)
				p1 = p + strLen(p);	/*DYJ 5.20w */
			if (p1 != p)
			{
				len = p1 - p + 1;
				path = MALLOC(len, "getSystemPaths: path");
				if (path != NULL)
				{
					strMcpy(path, len, p);
					/* Erstmal nachsehen, ob der Pfad eh schon drin ist */
					Lists_ResetList(&info->pathList);
					if (!Lists_ScanEntries(&info->pathList, Lists_forward, findName, path))
					{
						/* Jetzt neuen Eintrag fuer die Liste erzeugen */
						new = NEW(pathEntry, "getSystemPath: Entry");
						if (new != NULL)
						{
							new->entry = path;
							new->selected = FALSE;
							info->globalLength = Max(info->globalLength, (_WORD)(len - 1) + 2);
							/* Neuen Eintrag anlegen */
							if (!Lists_AppendEntry(&info->pathList, new))
							{
								OFREE(new);
								SFREE(path);
							}
							*draw = TRUE;
							*lstSel=-1;	/*DYJ 5.30f */
						} else
						{
							SFREE(path);
						}
					} else
					{
						SFREE(path);
					}
				}
			}
			p = p1;
			if (*p != '\0')
				p++;
		} while (*p != '\0');
	}
	*exit = FALSE;
	DelObjState(pathBox, obj, SELECTED);
	mtDials_DialDraw(pathBox, obj, 1, &r, FALSE);
}

/*** ---------------------------------------------------------------------- ***/

/*** ---------------------------------------------------------------------- ***/

/*DYJ 5.30f Start*/
LOCAL _VOID changeGroup(_WORD obj, _VOID *env, LISTINFO listinfo, _BOOL *draw, _BOOL *exit,_LONG *lstSel)
/*DYJ  Ende; alt:	
LOCAL _VOID changeGroup(_WORD obj, _VOID *env, LISTINFO listinfo, _BOOL *draw, _BOOL *exit)
*/
{
	_UBYTE cPath[PATH_MAX];
	_UBYTE name[PATH_MAX];
	_BOOL oneSel;
	_BOOL ok;
	pathEntry *gr;
	GRECT r;
	pathEntry *new;
	_UBYTE *path;
	pathInfo *info;
	
	UNUSED(listinfo);
	info = env;
	*draw = FALSE;
	Lists_ResetList(&info->pathList);
	oneSel = Lists_ScanEntries(&info->pathList, Lists_forward, findSel, NULL);
	if (oneSel)
	{
		gr = Lists_CurrentEntry(&info->pathList);
		strBcpy(cPath, gr->entry);
	} else
	{
		F_Path_Get(cPath);
	}
	*name = '\0';
	if (mtDir_FselGet(cPath, name, ALL_FILE_MASK, FS_TITEL, TRUE))
	{
		/* Mal nachsehen, ob der Pfad schon da ist */
		Lists_ResetList(&info->pathList);
		ok = Lists_ScanEntries(&info->pathList, Lists_forward, findName, cPath);
		if (ok)
		{
			if ((obj == PCHANGE && !oneSel) || obj == PNEW)
				MTE_info(AL_DUPLICATE_PATH);
		}
		if (!ok) /* nicht vorhanden in Liste */
		{
			/* Neuen Eintrag erzeugen */
			path = STRDUP(cPath, "changeGroup: path");
			if (path != NULL)
			{
				new = NEW(pathEntry, "changeGroup: entry");
				if (new != NULL)
				{
					new->entry = path;
					info->globalLength = Max(info->globalLength, (_WORD)strLen(cPath) + 2);	/*DYJ 5.20w */
					new->selected = FALSE;
					/* Jetzt nach Objekt unterscheiden */
					if (obj == PNEW)
					{
						/* Neuen Eintrag anlegen */
						ok = Lists_AppendEntry(&info->pathList, new);
					} else
					{
						/* vorhandenen Eintrag suchen und ersetzen */
						Lists_ResetList(&info->pathList);
						Lists_ScanEntries(&info->pathList, Lists_forward, findSel, NULL);
						Lists_RemoveEntry(&info->pathList, disposeEntry);
						ok = Lists_InsertEntry(&info->pathList, new);
					}
					if (!ok)
						disposeEntry(new);
					*draw = TRUE;
					*lstSel=-1;	/*DYJ 5.30f */
				} else
				{
					SFREE(path);
				}
			}
		}
	}
	DelObjState(pathBox, obj, SELECTED);
	WinDials_WinDialDraw(pathBox, obj, 1, &r, FALSE);
	*exit = FALSE;
}

/******************************************************************************/
/*------------------------------------------------------------------------*/
/******************************************************************************/

/* List-Zwischen-Prozeduren */

LOCAL _BOOL groupIsSelected(_VOID *entry, _VOID *env)
{
	pathEntry *gr;

	UNUSED(env);
	gr = entry;
	return gr->selected;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID drawGroupEntry(_VOID *entry, _VOID *env, _WORD x, _WORD y, _WORD offset, CONST GRECT *clip)
{
	OBJECT *tr;
	pathEntry *e;
	_UBYTE str[PATH_MAX];
	pathInfo *info;
	
	UNUSED(offset);
	info = env;
	tr = RscGaddr(the_rsc, R_TREE, LISTTXT);
	e = entry;
	tr[ROOT].ob_x = x;
	tr[ROOT].ob_y = y;
	tr[LISTENTRY].ob_width = info->globalLength * CharWidth;
	if (e != NULL)
	{
		/* Jetzt hier den String fuer den Gruppennamen zusammenbauen */
		groupToStr(e, env, str, sizeof(str));
		SetObjcStringAdr(tr, LISTENTRY, str, sizeof(str));
		EnableObjState(tr, ROOT, SELECTED, groupIsSelected(entry, env));
		EnableObjState(tr, ROOT, DISABLED, !isEnabled(entry, env));
	} else
	{
		SetObjcStringAdr(tr, LISTENTRY, "", 1);
		DelObjState(tr, ROOT, SELECTED);
		DelObjState(tr, ROOT, DISABLED);
	}
	Objc_draw(tr, ROOT, MAX_DEPTH, clip);
	SetObjcStringAdr(tr, LISTENTRY, "", 1);
}

/*------------------------------------------------------------------------*/

LOCAL _VOID killPathList(pathInfo *info)
{
	Lists_DeleteSimpleList(&info->pathList, disposeEntry, TRUE);
}

/*------------------------------------------------------------------------*/

LOCAL _VOID setAndGetPathValues(OBJECT *tree, _VOID *env, _BOOL set, _WORD exitBut)
{
	pathInfo *info;
	
	UNUSED(tree);
	info = env;
	if (set)
	{
		EnableObjState(pathBox, PDELETE, DISABLED, TRUE);
		EnableObjState(pathBox, PCHANGE, DISABLED, TRUE);
	} else
	{
		info->exitBut = exitBut;
	}
}

/*------------------------------------------------------------------------*/

/* Pfadeinstellungen vornehmen */
GLOBAL _VOID PListHelp_SelectPaths(OBJECT *tree)
{
	pathEntry *group;
	_WORD maxLength;
	GRECT r;
	_UBYTE *entry;
	_BOOL succ;
	ldHandler pathHandler;
	pathInfo *info;
	
	info = NEW(pathInfo, "SelectPaths");
	if (info == NULL)
		return;
	
	pathBox = tree;
	EnableObjFlags(pathBox, PCLFULL, HIDETREE, TRUE);
	EnableObjFlags(pathBox, PCLEMPTY, HIDETREE, FALSE);
	
	/* specials bestimmen */
	info->specials[0].objc = PDELETE;
	info->specials[0].proc = cutEntry;
	info->specials[1].objc = PCLFULL;
	info->specials[1].proc = pasteEntry;
	info->specials[2].objc = PCLEMPTY;
	info->specials[2].proc = clipEmpty;
	info->specials[3].objc = PNEW;
	info->specials[3].proc = changeGroup;
	info->specials[4].objc = PCHANGE;
	info->specials[4].proc = changeGroup;
	info->specials[5].objc = PPATH;
	info->specials[5].proc = getSystemPaths;
	/* Alten Eintrag loeschen */
	info->clipEntry = NULL;
	
	/* Jetzt die Liste aufbauen */
	if (!Lists_CreateList(&info->pathList, "SelectPaths: pathList"))
	{
		mtDials_DisposeDial(pathBox); 
		OFREE(info);
		return;
	}
	info->pathList.user = info;
	
	succ = TRUE;
	Lists_ResetList(&SrcPaths);
	while (succ && (entry = Lists_NextEntry(&SrcPaths)) != NULL)
	{
		group = NEW(pathEntry, "SelectPaths: entry");
		if (group == NULL)
		{
			succ = FALSE;
		} else
		{
			group->entry = STRDUP(entry, "SelectPaths: path");
			if (group->entry == NULL)
			{
				OFREE(group);
				succ = FALSE;
			} else
			{
				group->selected = FALSE;
				if (!Lists_AppendEntry(&info->pathList, group))
				{
					SFREE(group->entry);
					OFREE(group);
					succ = FALSE;
				}
			}
		}
	}
	
	if (!succ)
	{
		killPathList(info);
		mtDials_DisposeDial(pathBox);
		OFREE(info);
		return;
	}
	
	/* Maximale Breite eines Listeneintrages herausfinden */
	maxLength = 0;
	Lists_ResetList(&info->pathList);
	while ((group = Lists_NextEntry(&info->pathList)) != NULL)
	{
		if ((_WORD)strLen(group->entry) > maxLength)	/*DYJ 5.20w */
			maxLength = (_WORD)strLen(group->entry);	/*DYJ 5.20w */
	}
	++maxLength;   /* damit es besser aussieht :-) */
	
	/* Jetzt das Object zusammenbauen */
	CalcArea(pathBox, PATHBOX, &r);
	maxLength = Max(maxLength, r.g_w / CharWidth);
	
	info->globalLength = maxLength;
	
	/* Handler bauen */
	ListDl_BuildLdHandler(&info->pathList,
		resetList,
		nextEntry,
		prevEntry,
		countEntries,
		isEnabled,
		selGrEntry,
		groupToStr,
		groupIsSelected,
		drawGroupEntry,
		FUNK_NULL,
		0, CharHeight, 
		8, maxLength * CharWidth,
		&pathHandler);
	
	/* ListDialog durchfuehren */
	if (ListDl_WinListDial(pathBox, ldSelect | ldArrows | ldDoubleExit | ldModal,
		&pathHandler,
		PATHBOX,
		PATHBACK,
		POK,
		PCANCEL,
		info,
		POK,
		-1,
		updateButton,
		info->specials,
		6,
		ListDl_dummyCheckExit,
		setAndGetPathValues,
		setAndGetPathValues,
		&info->lastSel))
	{
		group = info->lastSel;
		if (info->exitBut == POK)
		{
			/* Veraenderte Pfadliste speichern */
			/* Erstmal die alte loeschen */
			Lists_DeleteSimpleList(&SrcPaths, mem_free, FALSE);
			Lists_ResetList(&SrcPaths);
			Lists_ResetList(&info->pathList);
			succ = TRUE;
			while (succ && (group = Lists_NextEntry(&info->pathList)) != NULL)
			{
				if (!Lists_AppendEntry(&SrcPaths, group->entry))
					succ = FALSE;
				else
					group->entry = NULL;
			}
		}
	}
	
	/* Interne Pfadliste wieder freigeben */
	killPathList(info);
	disposeClipEntry(info);
	OFREE(info);
}
