#ifndef __CAT_CATFILES_H__
#define __CAT_CATFILES_H__
/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */



#ifndef __PORTAB_H__
#include <portab.h>
#endif
#ifndef __FILE_IO_H__
#include <file_io.h>
#endif

typedef enum {
	CatFiles_start = 0,
	CatFiles_relative = 1,
	CatFiles_end = 2
} SeekMode;
typedef enum {
	CatFiles_readFile,
	CatFiles_writeFile,
	CatFiles_readWrite
} openMode;


/* Zusaetzliche Fehler, die beim GEMDOS nicht direkt angegeben werden */

#define notAllWritten   (-1004)
#define notAllRead      (-1005)
#define crcError        (-1006)
#define NotFound        (-1007)
#define NoError         0


_WORD CatFiles_shel_find( _UBYTE *sh_fpbuff ,size_t len);		/*DYJ 5.30b */

FILENO CatFiles_OpenFile(CONST _UBYTE *filename, openMode mode);

FILENO CatFiles_CreateFile(CONST _UBYTE *filename);

F_ERROR CatFiles_WriteFile(_UBYTE c, FILENO handle);

F_ERROR CatFiles_WriteMuch(_ULONG howMuch, FILENO handle, CONST _VOID *where);

F_ERROR CatFiles_ReadFile(_UBYTE *c, FILENO handle);

F_ERROR CatFiles_ReadMuch(_ULONG howMuch, FILENO handle, _VOID *where);

F_ERROR CatFiles_FilePos(FILENO handle, _ULONG *size);

_VOID CatFiles_Seek(_LONG pos, FILENO handle, SeekMode what);

F_ERROR CatFiles_CloseFile(FILENO handle);

F_ERROR CatFiles_DeleteFile(CONST _UBYTE *path, CONST _UBYTE *name);

_BOOL CatFiles_RenameFile(CONST _UBYTE *path, CONST _UBYTE *name, CONST _UBYTE *path2, CONST _UBYTE *name2);

_ULONG CatFiles_FileSizeAndDate(CONST _UBYTE *fname, _BOOL *exists, _UWORD *date, _UWORD *time);

_ULONG CatFiles_FileSize(CONST _UBYTE *fname, _BOOL *exists);

_BOOL CatFiles_Exists(CONST _UBYTE *fname);

GLOBAL _BOOL CatFiles_FolderExist(CONST _UBYTE *pfad);

#ifdef __CAT_DATASYS_H__
F_ERROR CatFiles_ReadDbHeader(FILENO handle, FileHeaderType *dbHdr);
#endif

_BOOL CatFiles_GetHomeDir(_UBYTE *path);

_BOOL CatFiles_GetTmpDir(_UBYTE *path);

_VOID CatFiles_Init(_VOID);

F_ERROR CatFiles_copy(FILENO ziel,FILENO quell,_ULONG len);

F_ERROR CatFiles_copyFile(CONST _UBYTE *ziel,CONST _UBYTE *quell);

F_ERROR CatFiles_BackupFile(CONST _UBYTE *zielPfad,CONST _UBYTE *quellPfad,CONST _UBYTE *name);
#endif /* __CAT_CATFILES_H__ */
