#ifndef __CAT_TYPES_H__
#define __CAT_TYPES_H__
/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */



#ifndef __PORTAB_H__
#include <portab.h>
#endif

#include <cat_vb.h>

#define CAT_PROGNAME "CAT"

#define CAT_HYPNAME     "cat.hyp"
#define HLP_EXT    		".hlp"
#define CAT_HELPIDX     "cathelp.idx"
#define CAT_LANG_FILE	"cat_lang.dat"
#define CAT_BASE	"cat_"
#define CATI_RSC_BASE	"inst_"
#define CATL_RSC_BASE	"catl_"
#define LANGUAGE_DE	"de"
#define LANGUAGE_EN	"en"
#define LANGUAGE_FR	"fr"
#define RSC_EXT			".rsc"

#define NAME_INFILE     "infile."

#define INFILE_NAME     NAME_INFILE "txt"
#define OUTFILE_NAME    "outfile.txt"
#define OUTF_HDR_NAME   "outf_hdr.txt"

#define catinf          "cat.inf"
#define catlock         "cat.lck"

#define statusInf       "status.inf"
#define grSelect        "grselect.inf"
#define userCmdFile     "catcmds.inf"
#define userInffileName "catuser.inf"

#define UPL_FILENAME    "upl" textExt

#define groupFileName   "catgroup.inf"
#define groupDataName   "catgroup.dat"
#define renameFileName  "ren" textExt

#define msgInfoName     "msginfo.dat"
#define resubDataName   "catresub.dat"
#define resubDateName   "catresub.txt"
#define cmtsDataName    "comments.dat"
#define itkMacroName    "catmacro.inf"
#define confInfName     "konfig.inf"

#define exportHtml     "export.htm"		/*DYJ 5.32f */

#define catGroupInf     "gruppen.inf"
#define catGroupPos     "gruppen.pos"
#define catAdrInf       "adr.inf"
#define catAdrAliInf    "adralias.inf"
#define adrFileName		"useradr.inf"
#define infoInfFile     "info.inf"
#define tmpInf          "catpos.inf"

#define rawGroupname    "gruppe00"
#define rawPrivatename  "private"

#define groupPat        "grupp*.*"
#define privatePat      "private.*"

#define headerExt       ".hdr"
#define textExt         ".txt"

#define tabTag          ".tab"
#define parTag          ".par"
#define datTag          ".dat"
#define waiTag          ".wai"


#define ITG_SHORT_NAME  "ITG"
#define ITI_SHORT_NAME  "ITI"
#define ITK_SHORT_NAME  "ITK"
#define IGK_SHORT_NAME  "IGK"
#define ISB_SHORT_NAME  "ISB"
#define REN_SHORT_NAME  "REN"
#define ITB_SHORT_NAME  "ITB"

#define YGA_SHORT_NAME  "YGA"
#define YGN_SHORT_NAME  "YGN"
#define YGB_SHORT_NAME  "YGB"
#define CAT_SHORT_NAME  "CAT"  /* catlog.txt */
#define LOG_SHORT_NAME  "LOG"
#define ERR_SHORT_NAME  "ERR"
#define HEAD_SHORT_NAME "HEAD"

#define CATLOG_FILENAME "catlog" textExt
#define CATHDLOG_FILENAME "cathdlog" textExt
#define CATERR_FILENAME "protokol" textExt
#define LASTLOG_FILENAME "log" textExt
#define HEAD_FILENAME   "head" textExt

#define ITG_FILENAME    "itg" textExt
#define YGA_FILENAME    "yga" textExt
#define YGB_FILENAME    "ygb" textExt
#define YGN_FILENAME    "ygn" textExt
#define ITI_FILENAME    "iti" textExt
#define ITK_FILENAME    "itk" textExt


#define maus_short_name_equal(s1, s2) (strCaseCmp(s1, s2) == 0)

/* Defaults fuer Stichwortlistenzeilen */
#define cPrivateMsgListElemsDefault "D(12),M(10),U(30),W(30),S(2)"
#define cGrpMsgListElemsDefault     "D(12),M(10),U(30),W(30),C(2),S(2)"


typedef _UBYTE String1023[1024];
typedef _UBYTE *Str1023Ptr;
typedef _UBYTE String255[256];
typedef _UBYTE *Str255Ptr;
typedef _UBYTE String127[128];
typedef _UBYTE *Str127Ptr;
typedef _UBYTE *BigTextPtr;
typedef _UBYTE *LargeTextPtr;
typedef _UBYTE DateType[19]; /* Datum aus der Datenbank */
typedef _UBYTE pathStrType[PATH_MAX]; /* fuer Pfade */
typedef _UBYTE nameStrType[PATH_MAX]; /* fuer Filenamen */
typedef _UBYTE extStrType[PATH_MAX]; /* fuer Extensions */

typedef struct { _WORD x; _WORD y; _WORD w; _WORD h; } xywhType;

typedef struct {
	_WORD major;
	_WORD minor;
	_UBYTE str[40];
} m7VerRecord;


/* Interne Gruppen-Nummer */
typedef _LONG GROUPNR;
#define NO_GROUP 0xffff

/* Interne Message-Nummer */
typedef _ULONG MSGNR;
typedef _ULONG mess_len;

/* Datum/Zeit als Dezimalzahl im Format YYYYMMDDHHMM */
typedef _ULONG MAUSDATE;

/* Datum/Zeit als Dezimalzahl im Format YYMMDDHHMM, Jahr 1990 = 0 */
typedef _ULONG CATDATE;

typedef _UWORD data_offset;
typedef _UWORD data_len;

typedef _UWORD CAT_GROUP_NUMBER;


#endif /* __CAT_TYPES_H__ */
