#ifndef __CAT_CLIP_H__
#define __CAT_CLIP_H__
/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */



#ifndef __PORTAB_H__
#include <portab.h>
#endif

#define SCRAP_TXT  "scrap.txt"
#define SCRAP_CSV  "scrap.csv"
#define SCRAP_MASK "scrap.*"

extern _BOOL scrapEmpty;

_VOID Clip_ScrapClear(CONST _UBYTE *f, CONST _UBYTE *not);
/* leert das Clipboard falls Pfad leer, sonst den uebergebenen Pfad */

_BOOL Clip_GetScrap(_UBYTE *f);
/* Liefert den aktuellen Clipboard-Ordner */

_BOOL Clip_ScrapDirty(_VOID);
/* Ist etwas im Clipboard? */
/* d.h. sieht im Clipboard nach ob ein SCRAP.TXT vorhanden ist */

_VOID Clip_ScrapWritten(_UWORD type, CONST _UBYTE *defExt);
/* Wir haben selber etwas in's Clipboard geschrieben */

_BOOL Clip_SomethingInScrap(_VOID);
/* Sieht intern in einer Variablen nach. Im Zweifelsfall eher
 * ScrapDirty benutzen
 */

_VOID Clip_ScrapIsDirty(_VOID);
/* Sagt dem Modul, dass irgendwas ins Clipboard geschrieben wurde
 */


#endif /* __CAT_CLIP_H__ */
