#ifndef __FSLX_H__
#define __FSLX_H__

/*
 * exportierte Dateiauswahl-Funktionen
 */

#ifndef __PORTAB_H__
#include <portab.h>
#endif
#include <mintbind.h>
#ifndef __PORTVDI_H__
#include <portvdi.h>
#endif
#ifndef __WDLGEVNT_H__
#include <wdlgevnt.h>
#endif


/* Sortiermodi */

#define SORTBYNAME	0
#define SORTBYDATE	1
#define SORTBYSIZE	2
#define SORTBYTYPE	3
#define SORTBYNONE	4

/* Flags fr Dateiauswahl */

#define DOSMODE	1
#define NFOLLOWSLKS	2
#define GETMULTI	8

/* fslx_set_flags */

#define SHOW8P3	1

typedef _WORD (_CDECL *XFSL_FILTER)(_UBYTE *path, _UBYTE *name, XATTR *xa);

typedef struct _fslx_dialog { int dummy; } XFSL_DIALOG;


EXTERN XFSL_DIALOG *fslx_open(
	CONST _UBYTE *title,
	_WORD x, _WORD y,
	_WORD *handle,
	_UBYTE *path, _WORD pathlen,
	_UBYTE *fname, _WORD fnamelen,
	_UBYTE *patterns,
	XFSL_FILTER filter,
	_UBYTE *paths,
	_WORD sort_mode,
	_WORD flags);

EXTERN _WORD fslx_evnt(
	XFSL_DIALOG *fsd,
	EVNT *events,
	_UBYTE *path,
	_UBYTE *fname,
	_WORD *button,
	_WORD *nfiles,
	_WORD *sort_mode,
	_UBYTE **pattern);

EXTERN XFSL_DIALOG *fslx_do(
	CONST _UBYTE *title,
	_UBYTE *path, _WORD pathlen,
	_UBYTE *fname, _WORD fnamelen,
	_UBYTE *patterns,
	XFSL_FILTER filter,
	_UBYTE *paths,
	_WORD *sort_mode,
	_WORD flags,
	_WORD *button,
	_WORD *nfiles,
	_UBYTE **pattern);

EXTERN _VOID (*fslx_func)(EVNT *e);

EXTERN _WORD fslx_getnxtfile(XFSL_DIALOG *fsd, _UBYTE *fname);
EXTERN _WORD fslx_close(XFSL_DIALOG *fsd);
EXTERN _WORD fslx_set_flags(_WORD flags, _WORD *oldval);


typedef	_VOID (_CDECL *UTXT_FN)(_WORD x, _WORD y, _WORD *clip_rect, _LONG id, _LONG pt, _LONG ratio, _UBYTE *string);

typedef struct _fnts_item
{
	struct	_fnts_item	*next;										/* Zeiger auf den naechsten Font oder 0L (Ende der Liste) */
	UTXT_FN		display;											/* Zeiger auf die Anzeige-Funktion fuer applikationseigene Fonts */
	_LONG		id;													/* ID des Fonts, >= 65536 fuer applikationseigene Fonts */
	_WORD		index;												/* Index des Fonts (falls VDI-Font) */
	_UBYTE		mono;												/* Flag fuer aequidistante Fonts */
	_BYTE		outline;											/* Flag fuer Vektorfont */
	_WORD		npts;												/* Anzahl der vordefinierten Punkthoehen */
	_UBYTE		*full_name;											/* Zeiger auf den vollstaendigen Namen */
	_UBYTE		*family_name;										/* Zeiger auf den Familiennamen */
	_UBYTE		*style_name;										/* Zeiger auf den Stilnamen */
	_UBYTE		*pts;												/* Zeiger auf Feld mit Punkthoehen */
	_LONG		reserved[4];										/* reserviert, muessen 0 sein */
} FNTS_ITEM;

/* Definitionen fuer <font_flags> bei fnts_create() */

#define	FNTS_BTMP	1												/* Bitmapfonts anzeigen */
#define	FNTS_OUTL	2												/* Vektorfonts anzeigen */
#define	FNTS_MONO	4												/* aequidistante Fonts anzeigen */
#define	FNTS_PROP	8												/* proportionale Fonts anzeigen */
#define	FNTS_ALL	15

/* Definitionen fuer <dialog_flags> bei fnts_create() */
#define	FNTS_3D		1													/* 3D-Design benutzen */

/* Definitionen fuer <button_flags> bei fnts_open() */
#define	FNTS_SNAME		0x01											/* Checkbox fuer die Namen selektieren */
#define	FNTS_SSTYLE		0x02											/* Checkbox fuer die Stile selektieren */
#define	FNTS_SSIZE		0x04											/* Checkbox fuer die Hoehe selektieren */
#define	FNTS_SRATIO		0x08											/* Checkbox fuer das Verhaeltnis Breite/Hoehe selektieren */

#define	FNTS_CHNAME		0x0100										/* Checkbox fuer die Namen anzeigen */
#define	FNTS_CHSTYLE	0x0200										/* Checkbox fuer die Stile anzeigen */
#define	FNTS_CHSIZE		0x0400										/* Checkbox fuer die Hoehe anzeigen */
#define	FNTS_CHRATIO	0x0800										/* Checkbox fuer das Verhaeltnis Breite/Hoehe anzeigen */
#define	FNTS_RATIO		0x1000										/* Verhaeltnis Breite/Hoehe einstellbar */
#define	FNTS_BSET		0x2000										/* Button "setzen" anwaehlbar */
#define	FNTS_BMARK		0x4000										/* Button "markieren" anwaehlbar */

/* Definitionen fuer <button> bei fnts_evnt() */

#define	FNTS_CANCEL	1													/* "Abbruch" wurde angewaehlt */
#define	FNTS_OK		2													/* "OK" wurde gedrueckt */
#define	FNTS_SET		3													/* "setzen" wurde angewaehlt */
#define	FNTS_MARK	4													/* "markieren" wurde betaetigt */
#define	FNTS_OPT		5													/* der applikationseigene Button wurde ausgewaehlt */

typedef struct _fnt_dialog { int dummy; } FNT_DIALOG;

EXTERN _BOOL (*fnts_func)(_BOOL get_event, _VOID *e);

FNT_DIALOG *fnts_create(_WORD vdi_handle, _WORD no_fonts, _WORD font_flags, _WORD dialog_flags, CONST _UBYTE *sample, CONST _UBYTE *opt_button);
_WORD fnts_delete(FNT_DIALOG *fnt_dialog, _WORD vdi_handle);
_WORD fnts_open(FNT_DIALOG *fnt_dialog, _WORD button_flags, _WORD x, _WORD y, _LONG id, fix31 pt, _LONG ratio);
_WORD fnts_close(FNT_DIALOG *fnt_dialog);

_WORD fnts_get_no_styles(FNT_DIALOG *fnt_dialog, _LONG id);
_LONG fnts_get_style(FNT_DIALOG *fnt_dialog, _LONG id, _WORD index);
_WORD fnts_get_name(FNT_DIALOG *fnt_dialog, _LONG id, _UBYTE *full_name, _UBYTE *family_name, _UBYTE *style_name);
_WORD fnts_get_info(FNT_DIALOG *fnt_dialog, _LONG id, _WORD *mono, _WORD *outline);

_WORD fnts_add(FNT_DIALOG *fnt_dialog, FNTS_ITEM *user_fonts);
_VOID fnts_remove(FNT_DIALOG *fnt_dialog);
_WORD fnts_update(FNT_DIALOG *fnt_dialog, _WORD button_flags, _LONG id, _LONG pt, _LONG ratio);

_WORD fnts_evnt(FNT_DIALOG *fnt_dialog, EVNT *events, _WORD *button, _WORD *check_boxes, _LONG *id, _LONG *pt, _LONG *ratio);
_WORD fnts_do(FNT_DIALOG *fnt_dialog, _WORD button_flags, _LONG id_in, _LONG pt_in, _LONG ratio_in, _WORD *check_boxes, _LONG *id, _LONG *pt, _LONG *ratio);

#endif /* __FSLX_H__ */
