/*****************************************************************************
 *		KEYCODE.H
 *****************************************************************************/

#ifndef __KEYCODE_H__
#define __KEYCODE_H__

#define KEY_ALT   0x8000
#define KEY_CTRL  0x4000
#define KEY_SHIFT 0x2000

#define KEY_BREAK       0401            /* break key (unreliable) */
#define KEY_DOWN        0402            /* The four arrow keys ... */
#define KEY_UP          0403
#define KEY_LEFT        0404
#define KEY_RIGHT       0405            /* ... */
#define KEY_HOME        0406            /* Home key (upward+left arrow) */
#define KEY_BACKSPACE   0407            /* backspace (unreliable) */
#define KEY_F0          0410            /* Function keys.  Space for 64 */
#define KEY_F(n)        (KEY_F0+(n))    /* keys is reserved. */
#define KEY_F1          KEY_F(1)
#define KEY_F2          KEY_F(2)
#define KEY_F3          KEY_F(3)
#define KEY_F4          KEY_F(4)
#define KEY_F5          KEY_F(5)
#define KEY_F6          KEY_F(6)
#define KEY_F7          KEY_F(7)
#define KEY_F8          KEY_F(8)
#define KEY_F9          KEY_F(9)
#define KEY_F10         KEY_F(10)
#define KEY_DL          0510            /* Delete line */
#define KEY_IL          0511            /* Insert line */
#define KEY_DC          0512            /* Delete character */
#define KEY_IC          0513            /* Insert char or enter insert mode */
#define KEY_EIC         0514            /* Exit insert char mode */
#define KEY_CLEAR       0515            /* Clear screen */
#define KEY_EOS         0516            /* Clear to end of screen */
#define KEY_EOL         0517            /* Clear to end of line */
#define KEY_SF          0520            /* Scroll 1 line forward */
#define KEY_SR          0521            /* Scroll 1 line backwards (reverse) */
#define KEY_NPAGE       0522            /* Next page */
#define KEY_PPAGE       0523            /* Previous page */
#define KEY_STAB        0524            /* Set tab */
#define KEY_CTAB        0525            /* Clear tab */
#define KEY_CATAB       0526            /* Clear all tabs */
#define KEY_ENTER       0527            /* Enter or send (unreliable) */
#define KEY_SRESET      0530            /* soft (partial) reset (unreliable) */
#define KEY_RESET       0531            /* reset or hard reset (unreliable) */
#define KEY_PRINT       0532            /* print or copy */
#define KEY_LL          0533            /* home down or bottom (lower left) */

#define KEY_BTAB		0545			/* Back tab key */
#define KEY_BEG			0546			/* beg(inning) key */
#define KEY_CANCEL		0547			/* cancel key */
#define KEY_CLOSE		0550			/* close key */
#define KEY_COMMAND		0551			/* cmd (command) key */
#define KEY_COPY		0552			/* copy key */
#define KEY_CREATE		0553			/* create key */
#define KEY_END			0554			/* end key */
#define KEY_EXIT		0555			/* exit key */
#define KEY_FIND		0556			/* find key */
#define KEY_HELP		0557			/* help key */
#define KEY_MARK		0560			/* mark key */
#define KEY_MESSAGE		0561			/* message key */
#define KEY_MOVE		0562			/* move key */
#define KEY_NEXT		0563			/* next object key */
#define KEY_OPEN		0564			/* open key */
#define KEY_OPTIONS		0565			/* options key */
#define KEY_PREVIOUS	0566			/* previous object key */
#define KEY_REDO		0567			/* redo key */
#define KEY_REFERENCE	0570			/* ref(erence) key */
#define KEY_REFRESH		0571			/* refresh key */
#define KEY_REPLACE		0572			/* replace key */
#define KEY_RESTART		0573			/* restart key */
#define KEY_RESUME		0574			/* resume key */
#define KEY_SAVE		0575			/* save key */
#define KEY_SELECT		0576			/* select key */
#define KEY_UNDO		0577			/* undo key */
#define KEY_START		0600			/* start key */
#define KEY_MENU		0601			/* sent by menu key */
#define KEY_MODE		0602			/* sent by mode key */
#define KEY_DW			0603			/* sent by delete word key */
#define KEY_IW			0604			/* sent by insert word key */
#define KEY_ABORT		0605			/* Abort/Terminate key */
#define KEY_LHELP		0606			/* long help */

#define KEY_KP_HOME		0700			/* Upper left of keypad */
#define KEY_KP_UP       0701
#define KEY_KP_PPAGE	0702			/* Upper right of keypad */
#define KEY_KP_LEFT     0703
#define KEY_KP_CENTER	0704			/* Center of keypad */
#define KEY_KP_RIGHT    0705
#define KEY_KP_END	 	0706			/* Lower left of keypad */
#define KEY_KP_DOWN     0707
#define KEY_KP_NPAGE	0710			/* Lower right of keypad */
#define KEY_KP_IC       0711
#define KEY_KP_DECIMAL  0712
#define KEY_KP_ENTER    0713

#endif /* __KEYCODE_H__ */
