#ifndef __LBOX_H__
#define __LBOX_H__

#ifndef __PORTAES_H__
# include <portaes.h>
#endif
#ifndef __WDLGEVNT_H__
#include <wdlgevnt.h>
#endif
#ifndef __WDLG_H__
#include <wdlg.h>
#endif

typedef struct _list_box { int dummy; } LIST_BOX;

typedef struct _lbox_item LBOX_ITEM;

struct _lbox_item {
	LBOX_ITEM *next;
	_WORD selected;            /* Objekt selektiert? */
	_WORD data1;               /* Daten fuer das Programm */
	_VOID *data2;
	_VOID *data3;
};

	
typedef _VOID (_CDECL *SLCT_ITEM)(LIST_BOX *box, OBJECT *tree, LBOX_ITEM *item, _VOID *user_data, _WORD obj_index, _WORD last_state);
typedef _WORD (_CDECL *SET_ITEM)(LIST_BOX *box, OBJECT *tree, LBOX_ITEM *item, _WORD obj_index, _VOID *user_data, GRECT *rect, _WORD first);

/*
 * Flags fuer lbox_create
 */
#define LBOX_VERT     1   /* Listbox mit vertik. Slider                 */
#define LBOX_AUTO     2   /* Auto-Scrolling                             */
#define LBOX_AUTOSLCT 4   /* automatische Darst. beim Auto-Scrolling    */
#define LBOX_REAL     8   /* Real-Time-Slider                           */
#define LBOX_SNGL    16   /* nur ein anwaehlbarer Eintrag               */
#define LBOX_SHFT    32   /* Mehrfachselektionen mit Shift              */
#define LBOX_TOGGLE  64   /* Status eines Eintrags bei Selekt. wechseln */
#define LBOX_2SLDRS 128   /* Listbox hat hor. und vertikalen Slider     */ 

_VOID lbox_ascroll_to(LIST_BOX *box, _WORD first, GRECT *box_rect, GRECT *slider_rect);
#define lbox_scroll_to lbox_ascroll_to
_VOID lbox_bscroll_to(LIST_BOX *box, _WORD first, GRECT *box_rect, GRECT *slider_rect);
_WORD lbox_cnt_items(LIST_BOX *box);
LIST_BOX *lbox_create(OBJECT *tree,
	SLCT_ITEM slct, SET_ITEM set, LBOX_ITEM *items,
	_WORD visible_a, _WORD first_a, _WORD *ctrl_objs, _WORD *objs,
	_WORD flags, _WORD pause_a, _VOID *user_data, DIALOG *dialog,
	_WORD visible_b, _WORD first_b,
	_WORD entries_b, _WORD pause_b);
_WORD lbox_delete(LIST_BOX *box);
_WORD lbox_do(LIST_BOX *box, _WORD obj);
_VOID lbox_free_items(LIST_BOX *box);
_VOID lbox_free_list(LIST_BOX *box);
_WORD lbox_get_afirst(LIST_BOX *box);
#define lbox_get_first lbox_get_afirst
_WORD lbox_get_avis(LIST_BOX *box);
#define lbox_get_visible lbox_get_avis
_WORD lbox_get_bentries(LIST_BOX *box);
_WORD lbox_get_bfirst(LIST_BOX *box);
_WORD lbox_get_bvis(LIST_BOX *box);
_WORD lbox_get_idx(LBOX_ITEM *items, LBOX_ITEM *search);
LBOX_ITEM *lbox_get_item(LIST_BOX *box, _WORD n);
LBOX_ITEM *lbox_get_items(LIST_BOX *box);
_WORD lbox_get_slct_idx(LIST_BOX *box);
LBOX_ITEM *lbox_get_slct_item(LIST_BOX *box);
OBJECT *lbox_get_tree(LIST_BOX *box);
_VOID *lbox_get_udata(LIST_BOX *box);
_VOID lbox_set_asldr(LIST_BOX *box, _WORD first, GRECT *rect);
#define lbox_set_slider lbox_set_asldr
_VOID lbox_set_bentries(LIST_BOX *box, _WORD entries);
_VOID lbox_set_bsldr(LIST_BOX *box, _WORD first, GRECT *rect);
_VOID lbox_set_items(LIST_BOX *box, LBOX_ITEM *items);
_VOID lbox_update(LIST_BOX *box, GRECT *rect);

#endif /* __LBOX_H__ */
