#ifndef __CAT_MIME_H__
#define __CAT_MIME_H__
/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Der vorliegende Teil wurde geschrieben von Dimitri Junker
 *	Cat@Dimitri_Junker.de
 *	Er entstand fr die Version 4.30/5.00
 */
#include <data.h>
#include <mttextfi.h>


enum {ZS_ATARI=-1,WINDOWS1252,ISO8859_1,ISO8859_2,ISO8859_3,ISO8859_4,
	ISO8859_5,ISO8859_6,ISO8859_7,ISO8859_8,ISO8859_9,ISO8859_15,UTF_8,
	WINDOWS1250,US_ASCII,ISO8859_X,MIME_ANZ_FONTS};
/* Krzel:
WINDOWS1252:W
ISO8859_1-ISO8859_9:1-9
ISO8859_15:F
UTF_8:U
WINDOWS1250:C

auch cMIME_Iso anpassen!!!
*/
#define	FILTER_EXP 0x10000l
#define	FILTER_KEYT 0x20000l
#define	FILTER_KEYT_EXP 0x30000l
#define	FILTER_NONE 0x40000l
#define	FILTER_NO_PREF_KT 0x50000l
#define	FILTER_RELATED 0x60000l
#define	FILTER_DEFAULT 0x80000l

enum {QUOTE_PR_NORM,QUOTE_PR_MAIL,QUOTE_PR_WORD,QUOTE_PR_NONE};


extern _UBYTE cMIME_Iso[][15];
extern _WORD CP1252Mode;	/*DYJ 5.37b */

_WORD Mime_CntAtt(_UBYTE *string,_BOOL cntRelated);
_WORD Mime_ModAtt(_UBYTE *string);
_VOID Mime_ResAtt(_UBYTE *string);
mess_len Mime_LenOrig(_UBYTE *string);

 short *Mime_txt2Unicode(_UBYTE *txt,_UBYTE *charsetName, size_t len);	/*DYJ 5.32f */

_LONG Mime_WandleIso(_UBYTE *ziel,_UBYTE *quell, _LONG len,_LONG filter,_WORD mode);
_UBYTE *Mime_ParseAnhStr(_UBYTE *string,_UBYTE *sName,_UBYTE *oName,_LONG *filter);
_LONG Mime_FindFilt(_UBYTE *name,_BOOL forImport);
F_ERROR Mime_copyFileFilter(CONST _UBYTE *ziel,CONST _UBYTE *quell,_LONG filter);


_ULONG Mime_SplitMultipart(_UBYTE *startAddr,_ULONG laenge,PtrRecord *toData,_WORD multiType,_BOOL *ok);
_BOOL Mime_AnhangPfad(_UBYTE *pfad,_UBYTE *string,PtrRecord *toData,_UBYTE *name,_WORD multiType);
_VOID *Mime_GetMem4Record(PtrRecord *mess,_ULONG len);
_BOOL Mime_AddToMultLines(MultiLines *ml,_UBYTE *adr,stringTypes set);
_VOID Mime_FreeMultilines(PtrRecord *mess);
_BOOL Mime_DecodeWord(_UBYTE *encWord);
_BOOL Mime_DecodePuny(_UBYTE *encPuny);	/*DYJ 5.39e */
_VOID Mime_AnhangOrdner(_UBYTE *pfad,_WORD jahr,_WORD monat,_WORD mode);
_BOOL Mime_BeginDecode(size_t len);
_VOID Mime_EndDecode(_VOID);
F_ERROR Mime_DecodeLine(_UBYTE *line);
_UBYTE * Mime_CodeWord(_UBYTE *ziel,size_t len,_UBYTE *quell);
_VOID Mime_WriteAttachments(TEXTFILENO zielF,_UBYTE *bound,_UBYTE *attPf,_UBYTE *attZeile,_WORD mode);
/*DYJ 5.34m Start*/
_VOID Mime_TransferQP(TEXTFILENO InHandle, TEXTFILENO INFILE, _UBYTE c,_WORD filter);
_WORD Mime_FindFilt4Send(TEXTFILENO txtFile);
/*DYJ  Ende; alt:	
_VOID Mime_TransferQP(TEXTFILENO InHandle, TEXTFILENO INFILE, _UBYTE c);
*/
size_t Mime_unQuote(_UBYTE *ziel,_UBYTE *quell, _LONG len,_WORD mode);
_LONG Mime_DecodeB64(_UBYTE *a0,_LONG d0);
_WORD Mime_multiType(_UBYTE *cType);
/*DYJ 5.36a Start*/
_BOOL Mime_init(_VOID);
/*DYJ  Ende; alt:	
_VOID Mime_init(_VOID);
*/
_VOID Mime_repEuro(_UBYTE *str,size_t len);
_WORD Mime_EuroChar(_VOID);
#endif /* __CAT_MIME_H__ */
