/*****************************************************************************
 * PATH_MAX.H
 *****************************************************************************/

#ifndef __PATH_MAX_H__
#define __PATH_MAX_H__

#ifndef __PORTAB_H__
#  include <portab.h>
#endif

#ifndef PATH_MAX
#  ifdef HAVE_LIMITS_H
#    include <limits.h>
#  endif
#  ifndef PATH_MAX
#    ifdef HAVE_SYS_PARAM_H
#      include <sys/param.h>
#    endif
#    ifdef MAXPATHLEN
#      define PATH_MAX MAXPATHLEN
#    else
#      ifdef _MAX_PATH
#        define PATH_MAX _MAX_PATH
#      else
#        if FILENAME_MAX > 255
#          define PATH_MAX FILENAME_MAX
#        else
#          define PATH_MAX 1024
#        endif
#      endif
#    endif
#  endif
#endif

#endif /* __PATH_MAX_H__ */
