#ifndef __PDLG_H__
#define __PDLG_H__

/*
 * exportierte Druckerdialog-Funktionen
 */

#ifndef __PORTAB_H__
#include <portab.h>
#endif
#ifndef __WDLG_H__
#include <wdlg.h>
#endif

typedef struct _prn_dialog { int dummy; } PRN_DIALOG;
typedef struct _pdlg_sub PDLG_SUB;
typedef struct _media_type MEDIA_TYPE;
typedef struct _media_size MEDIA_SIZE;
typedef struct _prn_tray PRN_TRAY;
typedef struct _prn_mode PRN_MODE;
typedef struct _prn_entry PRN_ENTRY;
typedef struct _dither_mode DITHER_MODE;
typedef struct _prn_settings PRN_SETTINGS;
typedef struct _drv_entry DRV_ENTRY;
typedef struct _drv_info DRV_INFO;

typedef _LONG (_CDECL *PDLG_INIT)(PRN_SETTINGS *settings, PDLG_SUB *sub);
typedef _LONG (_CDECL *PDLG_HNDL)(PRN_SETTINGS *settings, PDLG_SUB *sub, _WORD exit_obj);
typedef _LONG (_CDECL *PDLG_RESET)(PRN_SETTINGS *settings, PDLG_SUB *sub);
typedef _LONG (_CDECL *PRN_SWITCH)(DRV_ENTRY *drivers, PRN_SETTINGS *settings, PRN_ENTRY *old_printer, PRN_ENTRY *new_printer);

struct _drv_entry {
	DRV_ENTRY   *next;
};


struct _media_type {
	MEDIA_TYPE   *next;           /* Zeiger auf Nachfolger     */
	_LONG        type_id;         /* Kennung des Papierformats */
	_UBYTE       name[32];        /* Name des Papierformats    */
};


struct _media_size {
	MEDIA_SIZE   *next;           /* Zeiger auf Nachfolger     */
	_LONG        size_id;         /* Kennung des Papierformats */
	_UBYTE       name[32];        /* Name des Papierformats    */
};


struct _prn_mode {
	PRN_MODE *next;                  /* Zeiger auf Nachfolger             */
	_LONG        mode_id;            /* Modus (Index innerhalb der Datei) */
	_WORD        hdpi;               /* horizontale Aufloesung in dpi     */
	_WORD        vdpi;               /* vertikale Aufloesung in dpi       */
	_LONG        mode_capabilities;  /* Moduseigenschaften                */
	
	_LONG        color_capabilities; /* einstellbare Farbmodi             */
	_LONG        dither_flags;       /* Flags, die angeben, ob der
	                                    korrespondierende Farbmodus mit
	                                    oder ohne Dithern ansprechbar ist */
	
	MEDIA_TYPE  *paper_types;        /* geeignete Papiertypen             */
	_LONG        reserved;           /* reserviert                        */
	_UBYTE       name[32];           /* Modusname                         */
};


struct _prn_tray {
	PRN_TRAY     *next;           /* Zeiger auf Nachfolger       */
	_LONG        tray_id;         /* Nummer des Einzugs/Auswurfs */
	_UBYTE       name[32];        /* Name des Schachts           */
};


struct _dither_mode {
	DITHER_MODE  *next;           /* Zeiger auf Nachfolger     */
	_LONG        length;          /* Strukturlaenge            */
	_LONG        format;          /* Datenformat               */
	_LONG        reserved;        /* reserviert                */
	_LONG        dither_id;       /* Kennung                   */
	_LONG        color_modes;     /* unterstuetzte Farbtiefen  */
	_LONG        reserved1;       /* reserviert                */
	_LONG        reserved2;       /* reserviert                */
	_UBYTE       name[32];        /* Name des Rasterverfahrens */
};


struct _pdlg_sub {
	PDLG_SUB     *next;           /* Zeiger auf Nachfolger           */
	_LONG        length;          /* Strukturlaenge                  */
	_LONG        format;          /* Datenformat                     */
	_LONG        reserved;        /* reserviert                      */
	
	DRV_ENTRY    *drivers;        /* nur fuer interne Dialoge        */
	_WORD        option_flags;    /* verschiedene Flags              */
	_WORD        sub_id;          /* Kennung des Unterdialogs        */
	DIALOG       *dialog;         /* Zeiger auf die Struktur des
	                                 Fensterdialogs oder 0L          */
	
	OBJECT       *tree;           /* Zeiger auf den Objektbaum       */
	_WORD        index_offset;    /* Offset des Unterdialogs         */
	_WORD        reserved1;       /* reserviert                      */
	_LONG        reserved2;       /* reserviert                      */
	_LONG        reserved3;       /* reserviert                      */
	_LONG        reserved4;       /* reserviert                      */
	
	PDLG_INIT    init_dlg;        /* Initialisierungsfunktion        */
	PDLG_HNDL    do_dlg;          /* Behandlungsfunktion             */
	PDLG_RESET   reset_dlg;       /* Zuruecksetzfunktion             */
	_LONG        reserved5;       /* reserviert                      */
	
	OBJECT       *sub_icon;       /* Zeiger auf das Icon der Listbox */
	OBJECT       *sub_tree;       /* Objektbaum des Unterdialogs     */
	_LONG        reserved6;       /* reserviert                      */
	_LONG        reserved7;       /* reserviert                      */
	
	_LONG        private1;        /* dialogeigene Informationen-1    */
	_LONG        private2;        /* dialogeigene Informationen-2    */
	_LONG        private3;        /* dialogeigene Informationen-3    */
	_LONG        private4;        /* dialogeigene Informationen-4    */
};

#define PDLG_CHG_SUB   0x80000000L
#define PDLG_IS_BUTTON 0x40000000L

#define PDLG_PREBUTTON 0x20000000L
#define PDLG_PB_OK     1
#define PDLG_PB_CANCEL 2
#define PDLG_PB_DEVICE 3

#define PDLG_BUT_OK     (PDLG_PREBUTTON | PDLG_PB_OK)
#define PDLG_BUT_CANCEL (PDLG_PREBUTTON | PDLG_PB_CANCEL)
#define PDLG_BUT_DEVICE (PDLG_PREBUTTON | PDLG_PB_DEVICE)

struct _prn_entry {
	PRN_ENTRY    *next;                /* Zeiger auf Nachfolger           */
	_LONG        length;               /* Strukturlaenge                  */
	_LONG        format;               /* Datenformat                     */
	_LONG        reserved;             /* reserviert                      */
	
	_WORD        driver_id;            /* Treiberkennung                  */
	_WORD        driver_type;          /* Treibertyp                      */
	_LONG        printer_id;           /* Druckerkennung                  */
	_LONG        printer_capabilities; /* Druckereigenschaften            */
	_LONG        reserved1;            /* reserviert                      */
	
	_LONG        flags;                /* verschiedene Flags              */
#define PRN_STD_SUBS 0x0001
	PDLG_SUB    *sub_dialogs;          /* Zeiger auf Unterdialoge         */
	PRN_SWITCH  setup_panel;           /* Unterdialog bei Druckerwechsel
	                                      initialisieren                  */
	PRN_SWITCH  close_panel;           /* Unterdialog bei Druckerwechsel
	                                      schliessen                      */
	
	PRN_MODE    *modes;                /* Liste vorhand. Aufloesungen     */
	MEDIA_SIZE  *papers;               /* Liste vorhand. Papierformate    */
	PRN_TRAY    *input_trays;          /* Liste der Einzuege              */
	PRN_TRAY    *output_trays;         /* Liste der Auswuerfe             */
	_UBYTE      name[32];              /* Name des Druckers               */
};


struct _prn_settings {
	_LONG  magic;            /* 'pset'                                 */
	_LONG  length;           /* (+) Strukturlaenge                     */
	_LONG  format;           /* Strukturtyp                            */
	_LONG  reserved;         /* reserviert                             */
	
	_LONG  page_flags;       /* (+) Flags, u.a. gerade/ungerade Seiten */
#define PG_EVEN_PAGES 0x0001 /* nur Seiten mit gerader Nummer ausgeben */
#define PG_ODD_PAGES  0x0002 /* nur Seiten mit ungeraden Nummern ausgeben */
	
	_WORD  first_page;       /* (+) erste zu druckende Seite (min.1)   */
#define PG_MIN_PAGE 1
	_WORD  last_page;        /* (+) dto. letzte Seite (max. 9999)      */
#define PG_MAX_PAGE 9999

	_WORD  no_copies;        /* (+) Anzahl der Kopien                  */
	
	_WORD  orientation;      /* (+) Drehung                            */
#define PG_UNKNOWN   0x0000  /* Ausichtung unbekannt und nicht verstellbar */
#define PG_PORTRAIT  0x0001  /* Seite im Hochformat ausgeben */
#define PG_LANDSCAPE 0x0002  /* Seite im Querformat ausgeben */
	
	_LONG  scale;            /* (+) Skalierung: 0x10000L = 100%        */
	_WORD  driver_id;        /* (+) VDI-Geraetenummer                  */
	_WORD  driver_type;      /* Typ des eingestellten Treibers         */
	_LONG  driver_mode;      /* Flags, u.a. fuer Hintergrunddruck      */
	_LONG  reserved1;        /* reserviert                             */
	_LONG  reserved2;        /* reserviert                             */
	
	_LONG  printer_id;       /* Druckernummer                          */
	_LONG  mode_id;          /* Modusnummer                            */
	_WORD  mode_hdpi;        /* horizontale Aufloesung in dpi          */
	_WORD  mode_vdpi;        /* vertikale Aufloesung in dpi            */
	_LONG  quality_id;       /* Druckmodus (hardwaeremaessige Qualitaet,
	                            z.B. Microweave oder Econofast)        */
	
	_LONG  color_mode;       /* Farbmodus                              */
	_LONG  plane_flags;      /* Flags fuer auszugebende Farbebenen
	                            (z.B. nur cyan)                        */
	_LONG  dither_mode;      /* Rasterverfahren                        */
	_LONG  dither_value;     /* Parameter fuer das Rasterverfahren     */
	
	_LONG  size_id;          /* Papierformat                           */
	_LONG  type_id;          /* Papiertyp (normal, glossy)             */
	_LONG  input_id;         /* Papiereinzug                           */
	_LONG  output_id;        /* Papierauswurf                          */
	
	_LONG  contrast;         /* Kontrast:   0x10000L = normal          */
	_LONG  brightness;       /* Helligkeit: 0x1000L  = normal          */
	_LONG  reserved3;        /* reserviert                             */
	_LONG  reserved4;        /* reserviert                             */
	_LONG  reserved5;        /* reserviert                             */
	_LONG  reserved6;        /* reserviert                             */
	_LONG  reserved7;        /* reserviert                             */
	_LONG  reserved8;        /* reserviert                             */
	_UBYTE device[128];      /* Dateiname fuer den Ausdruck            */
	
#ifdef __PRINTING__
	TPrint   mac_settings;   /* Einstellung des Mac-Druckertreibers    */
#else
	struct
	{
	  _UBYTE inside[120];
	} mac_settings;
#endif
};


struct _drv_info {
	_LONG        magic;           /* 'pdnf'                           */
	_LONG        length;          /* Strukturlaenge                   */
	_LONG        format;          /* Datenformat                      */
	_LONG        reserved;        /* reserviert                       */
	
	_WORD        driver_id;       /* Treibernummer fuers VDI          */
	_WORD        driver_type;     /* Treibertyp                       */
	_LONG        reserved1;       /* reserviert                       */
	_LONG        reserved2;       /* reserviert                       */
	_LONG        reserved3;       /* reserviert                       */
	
	PRN_ENTRY   *printers;        /* zum Treiber gehoerenden Drucker  */
	DITHER_MODE *dither_modes;    /* unterstuetzte Rasterverfahren    */
	_LONG        reserved4;       /* reserviert                       */
	_LONG        reserved5;       /* reserviert                       */
	_LONG        reserved6;       /* reserviert                       */
	_LONG        reserved7;       /* reserviert                       */
	_LONG        reserved8;       /* reserviert                       */
	_LONG        reserved9;       /* reserviert                       */
	_UBYTE       device[128];     /* Ausgabedatei des Druckertreibers */
};


/*
 * Flags fuer pdlg_create()
 */
#define PDLG_3D    0x0001         /* Auswahl im 3D-Look anzeigen      */

/*
 * Flags fuer pdlg_open()
 */
#define PDLG_PREFS         0x0000 /* Einstelldialog anzeigen */
#define PDLG_PRINT         0x0001 /* Druckdialog anzeigen */
#define PDLG_ALWAYS_COPIES 0x0010 /* immer Kopien anbieten */
#define PDLG_ALWAYS_ORIENT 0x0020 /* immer Querformat anbieten */
#define PDLG_ALWAYS_SCALE  0x0040 /* immer Skalierung anbieten */
#define PDLG_EVENODD       0x0100 /* Option fuer gerade und ungerade Seiten anbieten */

/*
 * Buttons fuer pdlg_evnt()
 */
#define PDLG_CANCEL 1
#define PDLG_OK     2


_WORD pdlg_add_printers(PRN_DIALOG *prn_dialog, DRV_INFO *drv_info);
_WORD pdlg_add_sub_dialogs(PRN_DIALOG *prn_dialog, PDLG_SUB *sub_dialog);
_WORD pdlg_close(PRN_DIALOG *prn_dialog, _WORD *x, _WORD *y);
PRN_DIALOG *pdlg_create(_WORD dialog_flags);
_WORD pdlg_delete(PRN_DIALOG *prn_dialog);
_WORD pdlg_dflt_settings(PRN_DIALOG *prn_dialog, PRN_SETTINGS *settings);
_WORD pdlg_do(PRN_DIALOG *prn_dialog, PRN_SETTINGS *settings, CONST _UBYTE *document_name, _WORD option_flags);
_WORD pdlg_evnt(PRN_DIALOG *prn_dialog, PRN_SETTINGS *settings, EVNT *events, _WORD *button);
_WORD pdlg_free_settings(PRN_DIALOG *prn_dialog);
_LONG pdlg_get_setsize(_VOID);
PRN_SETTINGS *pdlg_new_settings(PRN_DIALOG *prn_dialog);
_WORD pdlg_open(PRN_DIALOG *prn_dialog, PRN_SETTINGS *settings, CONST _UBYTE *document_name, _WORD option_flags, _WORD x, _WORD y);
_WORD pdlg_remove_printers(PRN_DIALOG *prn_dialog);
_WORD pdlg_remove_sub_dialogs(PRN_DIALOG *prn_dialog);
_WORD pdlg_update(PRN_DIALOG *prn_dialog, CONST _UBYTE *document_name);
_WORD pdlg_use_settings(PRN_DIALOG *prn_dialog, PRN_SETTINGS *settings);
_WORD pdlg_validate_settings(PRN_DIALOG *prn_dialog, PRN_SETTINGS *settings);


#endif /* __PDLG_H__ */
