#ifndef __PORTVDI_H__
#define __PORTVDI_H__

#ifndef __PORTAB_H__
#  include <portab.h>
#endif


typedef struct
{
    _WORD    contrl[15];
    _WORD    intin[132];
    _WORD    intout[140];
    _WORD    ptsin[145];
    _WORD    ptsout[145];
} VDIPARBLK;

typedef struct
{
    _WORD    *contrl;
    _WORD    *intin;
    _WORD    *ptsin;
    _WORD    *intout;
    _WORD    *ptsout;
} VDIPB;

extern  VDIPB _VdiParBlk;

typedef long fix31;

#define fix31_to_point(a) ((_WORD)((((a) + 32768L) >> 16)))
#define point_to_fix31(a) (((fix31)(a)) << 16)


void vdi( VDIPB *vdipb );


/****** Control definitions *********************************************/

void    v_opnwk( _WORD work_in[16],  _WORD *handle, _WORD work_out[57]);
void    v_clswk( _WORD handle );
void    v_opnvwk( _WORD work_in[11], _WORD *handle, _WORD work_out[57]);
void    v_clsvwk( _WORD handle );
void    v_clrwk( _WORD handle );
void    v_updwk( _WORD handle );
_WORD    vst_load_fonts( _WORD handle, _WORD select );
void    vst_unload_fonts( _WORD handle, _WORD select );
void    vs_clip( _WORD handle, _WORD clip_flag, _WORD *pxyarray );


/****** Output definitions **********************************************/

void    v_pline( _WORD handle, _WORD count, _WORD *pxyarray );
void    v_pmarker( _WORD handle, _WORD count, _WORD *pxyarray );
void    v_gtext( _WORD handle, _WORD x, _WORD y, const char *string );
void    v_gntext( _WORD handle, _WORD x, _WORD y, const char *string, _WORD len );
void    v_fillarea( _WORD handle, _WORD count, _WORD *pxyarray );
void    v_cellarray( _WORD handle, _WORD *pxyarray, _WORD row_length,
                     _WORD el_used, _WORD num_rows, _WORD wrt_mode,
                     _WORD *colarray );
void    v_contourfill( _WORD handle, _WORD x, _WORD y, _WORD index );
void    vr_recfl( _WORD handle, _WORD *pxyarray );
void    v_bar( _WORD handle, _WORD *pxyarray );
void    v_arc( _WORD handle, _WORD x, _WORD y, _WORD radius,
               _WORD begang, _WORD endang );
void    v_pieslice( _WORD handle, _WORD x, _WORD y, _WORD radius,
                    _WORD begang, _WORD endang );
void    v_circle( _WORD handle, _WORD x, _WORD y, _WORD radius );
void    v_ellarc( _WORD handle, _WORD x, _WORD y, _WORD xradius,
                  _WORD yradius, _WORD begang, _WORD endang );
void    v_ellpie( _WORD handle, _WORD x, _WORD y, _WORD xradius,
                  _WORD yradius, _WORD begang, _WORD endang );
void    v_ellipse( _WORD handle, _WORD x, _WORD y, _WORD xradius,
                   _WORD yradius  );
void    v_rbox  ( _WORD handle, _WORD *pxyarray );
void    v_rfbox ( _WORD handle, _WORD *pxyarray );
void    v_justified( _WORD handle, _WORD x, _WORD y, char *string,
                     _WORD length, _WORD word_space,
                     _WORD char_space );


/****** Attribute definitions *****************************************/

#define IP_HOLLOW       0
#define IP_1PATT        1
#define IP_2PATT        2
#define IP_3PATT        3
#define IP_4PATT        4
#define IP_5PATT        5
#define IP_6PATT        6
#define IP_SOLID        7


/* gsx modes */

#define MD_REPLACE      1
#define MD_TRANS        2
#define MD_XOR          3
#define MD_ERASE        4


/* gsx styles */

#define FIS_HOLLOW      0
#define FIS_SOLID       1
#define FIS_PATTERN     2
#define FIS_HATCH       3
#define FIS_USER        4


/* bit blt rules */

#define ALL_WHITE        0
#define S_AND_D          1
#define S_AND_NOTD       2
#define S_ONLY           3
#define NOTS_AND_D       4
#define D_ONLY           5
#define S_XOR_D          6
#define S_OR_D           7
#define NOT_SORD         8
#define NOT_SXORD        9
#define D_INVERT        10
#define NOT_D           11
#define S_OR_NOTD       12
#define NOTS_OR_D       13
#define NOT_SANDD       14
#define ALL_BLACK       15


/* linetypes */

#define SOLID           1
#define LONGDASH        2
#define DOT             3
#define DASHDOT         4
#define DASH            5
#define DASH2DOT        6
#define USERLINE        7

/* line ends */

#define SQUARED          0
#define ARROWED          1
#define ROUNDED          2

/* polymarker types */

#define PM_DOT           1
#define PM_PLUS          2
#define PM_ASTERISK      3
#define PM_SQUARE        4
#define PM_DIAGCROSS     5
#define PM_DIAMOND       6

/* text effects */

#define TXT_NORMAL       0x0000
#define TXT_THICKENED    0x0001
#define TXT_LIGHT        0x0002
#define TXT_SKEWED       0x0004
#define TXT_UNDERLINED   0x0008
#define TXT_OUTLINED     0x0010
#define TXT_SHADOWED     0x0020

/* horizontal text alignment */

#define ALI_LEFT         0
#define ALI_CENTER       1
#define ALI_RIGHT        2

/* vertical text alignment */

#define ALI_BASE         0
#define ALI_HALF         1
#define ALI_ASCENT       2
#define ALI_BOTTOM       3
#define ALI_DESCENT      4
#define ALI_TOP          5

/* input device */

#define DEV_LOCATOR      1
#define DEV_VALUATOR     2
#define DEV_CHOICE       3
#define DEV_STRING       4

/* input mode */

#define MODE_REQUEST     1
#define MODE_SAMPLE      2

/****** Escape library *******************************************************/

#define O_B_BOLDFACE     '0' /* OUT-File definitions for v_alpha_text */
#define O_E_BOLDFACE     '1'
#define O_B_ITALICS      '2'
#define O_E_ITALICS      '3'
#define O_B_UNDERSCORE   '4'
#define O_E_UNDERSCORE   '5'
#define O_B_SUPERSCRIPT  '6'
#define O_E_SUPERSCRIPT  '7'
#define O_B_SUBSCRIPT    '8'
#define O_E_SUBSCRIPT    '9'
#define O_B_NLQ          'A'
#define O_E_NLQ          'B'
#define O_B_EXPANDED     'C'
#define O_E_EXPANDED     'D'
#define O_B_LIGHT        'E'
#define O_E_LIGHT        'F'
#define O_PICA           'W'
#define O_ELITE          'X'
#define O_CONDENSED      'Y'
#define O_PROPORTIONAL   'Z'

#define O_GRAPHICS       "\033\033GEM,%d,%d,%d,%d,%s"

#define MUTE_RETURN     -1 /* definitions for vs_mute */
#define MUTE_ENABLE      0
#define MUTE_DISABLE     1

#define OR_PORTRAIT      0 /* definitions for v_orient */
#define OR_LANDSCAPE     1

#define TRAY_MANUAL     -1 /* definitions for v_tray */
#define TRAY_DEFAULT     0
#define TRAY_FIRSTOPT    1

#define XBIT_FRACT       0 /* definitions for v_xbit_image */
#define XBIT_INTEGER     1

#define XBIT_LEFT        0
#define XBIT_CENTER      1
#define XBIT_RIGHT       2

#define XBIT_TOP         0
#define XBIT_MIDDLE      1
#define XBIT_BOTTOM      2

_WORD    vswr_mode( _WORD handle, _WORD mode );
void    vs_color( _WORD handle, _WORD index, _WORD rgb_in[3] );
_WORD    vsl_type( _WORD handle, _WORD style );
void    vsl_udsty( _WORD handle, _WORD pattern );
_WORD    vsl_width( _WORD handle, _WORD width );
_WORD    vsl_color( _WORD handle, _WORD color_index );
void    vsl_ends( _WORD handle, _WORD beg_style, _WORD end_style );
_WORD    vsm_type( _WORD handle, _WORD symbol );
_WORD    vsm_height( _WORD handle, _WORD height );
_WORD    vsm_color( _WORD handle, _WORD color_index );
_WORD    vst_height( _WORD handle, _WORD height, _WORD *char_width,
                    _WORD *char_height, _WORD *cell_width,
                    _WORD *cell_height );
_WORD    vst_point( _WORD handle, _WORD point, _WORD *char_width,
                    _WORD *char_height, _WORD *cell_width,
                    _WORD *cell_height );
_WORD    vst_rotation( _WORD handle, _WORD angle );
_WORD    vst_font( _WORD handle, _WORD font );
_WORD    vst_color( _WORD handle, _WORD color_index );
_WORD    vst_effects( _WORD handle, _WORD effect );
void    vst_alignment( _WORD handle, _WORD hor_in, _WORD vert_in,
                       _WORD *hor_out, _WORD *vert_out );
_WORD    vsf_interior( _WORD handle, _WORD style );
_WORD    vsf_style( _WORD handle, _WORD style_index );
_WORD    vsf_color( _WORD handle, _WORD color_index );
_WORD    vsf_perimeter( _WORD handle, _WORD per_vis );
void    vsf_udpat( _WORD handle, _WORD *pfill_pat, _WORD planes );


/****** Raster definitions *********************************************/

#ifndef __MFDB
#define __MFDB
typedef struct
{
        void            *fd_addr;
        _WORD             fd_w;
        _WORD             fd_h;
        _WORD             fd_wdwidth;
        _WORD             fd_stand;
        _WORD             fd_nplanes;
        _WORD             fd_r1;
        _WORD             fd_r2;
        _WORD             fd_r3;
} MFDB;
#endif

void    vro_cpyfm( _WORD handle, _WORD vr_mode, _WORD *pxyarray,
                   MFDB *psrcMFDB, MFDB *pdesMFDB );
void    vrt_cpyfm( _WORD handle, _WORD vr_mode, _WORD *pxyarray,
                   MFDB *psrcMFDB, MFDB *pdesMFDB,
                   _WORD *color_index );
void    vr_trnfm( _WORD handle, MFDB *psrcMFDB, MFDB *pdesMFDB );
void    v_get_pixel( _WORD handle, _WORD x, _WORD y, _WORD *pel,
                     _WORD *index );


/****** Input definitions **********************************************/

_WORD    vsin_mode( _WORD handle, _WORD dev_type, _WORD mode );
void    vrq_locator( _WORD handle, _WORD x, _WORD y, _WORD *xout,
                     _WORD *yout, _WORD *term );
_WORD    vsm_locator( _WORD handle, _WORD x, _WORD y, _WORD *xout,
                     _WORD *yout, _WORD *term );
void    vrq_valuator( _WORD handle, _WORD valuator_in,
                      _WORD *valuator_out, _WORD *terminator );
void    vsm_valuator( _WORD handle, _WORD val_in, _WORD *val_out,
                      _WORD *term, _WORD *status );
void    vrq_choice( _WORD handle, _WORD ch_in, _WORD *ch_out );
_WORD    vsm_choice( _WORD handle, _WORD *choice );
void    vrq_string( _WORD handle, _WORD max_length, _WORD echo_mode,
                    _WORD *echo_xy, char *string );
_WORD    vsm_string( _WORD handle, _WORD max_length, _WORD echo_mode,
                    _WORD *echo_xy, char *string );
void    vsc_form( _WORD handle, _WORD *pcur_form );
void    vex_timv( _WORD handle, _WORD (*tim_addr)(void), _WORD (**otim_addr)(void),
                  _WORD *tim_conv );
void    v_show_c( _WORD handle, _WORD reset );
void    v_hide_c( _WORD handle );
void    vq_mouse( _WORD handle, _WORD *pstatus, _WORD *x, _WORD *y );
void    vex_butv( _WORD handle, _WORD (*pusrcode)(void), _WORD (**psavcode)(void) );
void    vex_motv( _WORD handle, _WORD (*pusrcode)(void), _WORD (**psavcode)(void) );
void    vex_curv( _WORD handle, _WORD (*pusrcode)(void), _WORD (**psavcode)(void) );
void    vq_key_s( _WORD handle, _WORD *pstatus );


/****** Inquire definitions *******************************************/

void    vq_extnd( _WORD handle, _WORD owflag, _WORD *work_out );
_WORD    vq_color( _WORD handle, _WORD color_index,
                  _WORD set_flag, _WORD *rgb );
void    vql_attributes( _WORD handle, _WORD *attrib );
void    vqm_attributes( _WORD handle, _WORD *attrib );
void    vqf_attributes( _WORD handle, _WORD *attrib );
void    vqt_attributes( _WORD handle, _WORD *attrib );
void    vqt_extent( _WORD handle, const char *string, _WORD *extent );
void    vqt_nextent( _WORD handle, const char *string, _WORD len, _WORD *extent );
_WORD    vqt_width( _WORD handle, _WORD character,
                   _WORD *cell_width, _WORD *left_delta,
                   _WORD *right_delta );
_WORD    vqt_name( _WORD handle, _WORD element_num, char *name, _WORD *fsm);
void    vq_cellarray( _WORD handle, _WORD *pxyarray,
                      _WORD row_length, _WORD num_rows,
                      _WORD *el_used, _WORD *rows_used,
                      _WORD *status, _WORD *colarray );
void    vqin_mode( _WORD handle, _WORD dew_type, _WORD *input_mode );
void    vqt_fontinfo( _WORD handle, _WORD *minADE, _WORD *maxADE,
                      _WORD *distances, _WORD *maxwidth,
                      _WORD *effects );

/* NVDI >= 3.00 */
_WORD    vqt_fsm_name( _WORD handle, _WORD element_num, char *name, _WORD *fsm, _WORD *font_format, _UWORD *flags );


/****** Escape definitions *********************************************/

void    vq_chcells( _WORD handle, _WORD *rows, _WORD *columns );
void    v_exit_cur( _WORD handle );
void    v_enter_cur( _WORD handle );
void    v_curup( _WORD handle );
void    v_curdown( _WORD handle );
void    v_curright( _WORD handle );
void    v_curleft( _WORD handle );
void    v_curhome( _WORD handle );
void    v_eeos( _WORD handle );
void    v_eeol( _WORD handle );
void    vs_curaddress( _WORD handle, _WORD row, _WORD column );
void    v_curaddress( _WORD handle, _WORD row, _WORD column );
void    v_curtext( _WORD handle, char *string );
void    v_rvon( _WORD handle );
void    v_rvoff( _WORD handle );
void    vq_curaddress( _WORD handle, _WORD *row, _WORD *column );
_WORD    vq_tabstatus( _WORD handle );
void    v_hardcopy( _WORD handle );
void    v_dspcur( _WORD handle, _WORD x, _WORD y );
void    v_rmcur( _WORD handle );
void    v_form_adv( _WORD handle );
void    v_output_window( _WORD handle, _WORD *xyarray );
void    v_clear_disp_list( _WORD handle );
void    v_bit_image( _WORD handle, const char *filename,
                     _WORD aspect, _WORD x_scale, _WORD y_scale,
                     _WORD h_align, _WORD v_align, _WORD *xyarray );
void    vq_scan( _WORD handle, _WORD *g_slice, _WORD *g_page,
                 _WORD *a_slice, _WORD *a_page, _WORD *div_fac);
void    v_alpha_text( _WORD handle, const char *string );
_WORD    vs_palette( _WORD handle, _WORD palette );
void	v_sound( _WORD handle, _WORD frequency, _WORD duration );
_WORD	vs_mute( _WORD handle, _WORD action );
void    vqp_films( _WORD handle, char *film_names );
_WORD    vqp_filmname(_WORD handle, _WORD index, char *name);
void    vqp_state( _WORD handle, _WORD *port, char *film_name,
                   _WORD *lightness, _WORD *interlace,
                   _WORD *planes, _WORD *indexes );
void    vsp_state( _WORD handle, _WORD port, _WORD film_num,
                   _WORD lightness, _WORD interlace, _WORD planes,
                   _WORD *indexes );
void    vsp_save( _WORD handle );
void    vsp_message( _WORD handle );
_WORD    vqp_error( _WORD handle );
void    v_meta_extents( _WORD handle, _WORD min_x, _WORD min_y,
                        _WORD max_x, _WORD max_y );
void    v_write_meta( _WORD handle,
                      _WORD num_intin, _WORD *intin,
                      _WORD num_ptsin, _WORD *ptsin );
void    vm_coords( _WORD handle, _WORD llx, _WORD lly, _WORD urx, _WORD ury );
void    vm_filename( _WORD handle, const char *filename );
void    vm_pagesize( _WORD handle, _WORD pgwidth, _WORD pdheight );
void    v_offset( _WORD handle, _WORD offset );
void    v_fontinit( _WORD handle, _WORD fh_high, _WORD fh_low );
void    v_escape2000( _WORD handle, _WORD times );

void    vt_resolution( _WORD handle, _WORD xres, _WORD yres,
                       _WORD *xset, _WORD *yset );
void    vt_axis( _WORD handle, _WORD xres, _WORD yres,
                 _WORD *xset, _WORD *yset );
void    vt_origin( _WORD handle, _WORD xorigin, _WORD yorigin );
void    vq_tdimensions( _WORD handle, _WORD *xdimension, _WORD *ydimension );
void    vt_alignment( _WORD handle, _WORD dx, _WORD dy );
void    vsp_film( _WORD handle, _WORD index, _WORD lightness );
void    vsc_expose( _WORD handle, _WORD state );


#define GDOS_NONE      0xFFFFFFFEL    /* no GDOS installed           */
#define GDOS_FSM       0x5F46534DL    /* '_FSM' - FSMGDOS installed  */
#define GDOS_FNT       0x5F464E54L    /* '_FNT' - FONTGDOS installed */
#define GDOS_ATARI     0x0007E88AL    /* GDOS 1.1 von Atari Corp.    */
#define GDOS_AMC       0x0007E864L    /* AMCGDos von Arnd Beissner   */
#define GDOS_AMCLIGHT  0x0007E8BAL    /* GEMINI-Spezial-GDos von Arnd Beissner */
#define GDOS_NVDI      0x00000000L    /* NVDI von Bela GmbH */

/* Testet ob ein GDOS geladen ist */
/* Achtung, das ABC-GEM (GEM 2.1) schmiert bei dieser Funktion ab!!! */
_WORD    vq_gdos( void );
_ULONG	vq_vgdos( void );

/****** Bezier definitions *********************************************/

_WORD    v_bez_on( _WORD handle );
void    v_bez_off( _WORD handle );
_WORD    v_bez_con( _WORD handle, _WORD onoff );
void    v_set_app_buff( _WORD handle, _WORD **address, _WORD nparagraphs );
_WORD    v_bez( _WORD handle, _WORD count, _WORD *xyarr,
                char *bezarr, _WORD *extent, _WORD *totpts, _WORD *totmoves );
_WORD    v_bez_fill( _WORD handle, _WORD count, _WORD *xyarr,
                     char *bezarr, _WORD *extent, _WORD *totpts,
                     _WORD *totmoves );
_WORD    v_bez_qual( _WORD handle, _WORD prcnt, _WORD *actual );


/****** FSMGDOS definitions ********************************************/

typedef struct
{
    _WORD    value;
    _WORD    remainder;

}   fsm_int;

typedef struct
{
    fsm_int    x;
    fsm_int    y;

}   fsm_fpoint_t;

typedef struct
{
    fsm_fpoint_t     pt;
    fsm_fpoint_t     cpt;
    fsm_int          sharp;

}   fsm_data_fpoint_t;

typedef struct fsm_component_t
{
    _WORD                       resevered1;
    struct fsm_component_t    *nextComponent;
    unsigned char             numPoints;
    unsigned char             numCurves;
    unsigned char             numContours;
    unsigned char             reserved2[13];
    fsm_data_fpoint_t         *points;
    unsigned char             *startPts;

}   fsm_component_t;


void    vqt_f_extent( _WORD handle, const char *string, _WORD *extent );
void    vqt_f_nextent( _WORD handle, const char *string, _WORD len, _WORD *extent );
void    v_ftext( _WORD handle, _WORD x, _WORD y, const char *string );
void	v_ftext_offset(_WORD handle, _WORD x, _WORD y, const char *sstr, _WORD *offset);
void    v_fntext( _WORD handle, _WORD x, _WORD y, const char *string, _WORD len );
void    v_killoutline( _WORD handle, fsm_component_t *component );
/* void    v_getoutline( _WORD handle, _WORD ch, fsm_component_t **component ); */
void    v_getoutline(_WORD handle, _WORD ch, _WORD *xyarray, char *bezarray, _WORD maxpts, _WORD *count);
void    vst_scratch( _WORD handle, _WORD mode );
void    vst_error( _WORD handle, _WORD mode, _WORD *errorvar );
void    vqt_advance( _WORD handle, _WORD ch, _WORD *advx, _WORD *advy,
                       _WORD *remx, _WORD *remy );
void    vqt_advance32( _WORD handle, _WORD ch, fix31 *advx, fix31 *advy);
_WORD    vst_arbpt( _WORD handle, _WORD point, _WORD *chwd, _WORD *chht,
                   _WORD *cellwd, _WORD *cellht );
fix31   vst_arbpt32( _WORD handle, fix31 point, _WORD *chwd, _WORD *chht,
                   _WORD *cellwd, _WORD *cellht );
void    vqt_devinfo( _WORD handle, _WORD devnum, _WORD *devexits,
                     char *devstr );
_WORD    v_flushcache( _WORD handle );
void    vqt_cachesize( _WORD handle, _WORD which_cache, _LONG *size );
void    vqt_get_tables( _WORD handle, _WORD **gascii, _WORD **sytle );
_WORD    v_loadcache( _WORD handle, char *filename, _WORD mode );
_WORD    v_savecache( _WORD handle, char *filename );
_WORD    vst_setsize( _WORD handle, _WORD point, _WORD *chwd, _WORD *chht,
                     _WORD *cellwd, _WORD *cellht );
fix31   vst_setsize32( _WORD handle, fix31 point, _WORD *chwd, _WORD *chht,
                     _WORD *cellwd, _WORD *cellht );
_WORD    vst_skew( _WORD handle, _WORD skew );
void	v_shtext( _WORD handle, _WORD x, _WORD y, const char *text, _WORD color, _WORD xshadow, _WORD yshadow);
void	vqt_get_table(_WORD handle, _WORD **map);
void	vqt_get_tables( _WORD handle, _WORD **gascii, _WORD **style );
void	vst_charmap(_WORD handle, _WORD mode);
void	vst_kern(_WORD handle, _WORD tmode, _WORD pmode, _WORD *tracks, _WORD *pairs);
void	vqt_fontheader(_WORD handle, char *buffer, char *pathname);
void	vqt_pairkern(_WORD handle, _WORD ch1, _WORD ch2, fix31 *x, fix31 *y);
void	vqt_trackkern(_WORD handle, fix31 *x, fix31 *y);
void	v_getbitmap_info(_WORD handle, _WORD ch, 
        	fix31 *advancex, fix31 *advancey, fix31 *xoffset, fix31 *yoffset,
        	_WORD *width, _WORD *height, _WORD **bitmap);



void	v_opnbm(_WORD *work_in, MFDB *bitmap, _WORD *handle, _WORD *work_out);
void	v_clsbm(_WORD handle);
void	vq_scrninfo(_WORD handle, _WORD *work_out);


#endif /* __PORTVDI_H__ */
