#ifndef __CAT_QUICKSORT_H__
#define __CAT_QUICKSORT_H__
/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */



#ifndef __PORTAB_H__
#include <portab.h>
#endif
#ifndef __CAT_LISTS_H__
#include <lists.h>
#endif


typedef _BOOL (*compProc)(CONST _VOID *e1, CONST _VOID *e2, _VOID *private);

/* Der Vergleichsprozedur werden die Adressen (!!)
 * der zu vergleichenden Elemente uebergeben.
 * Wenn man ein Array OF ADDRESS sortiert, dann muss
 * man doppelt dereferenzieren!!
 */

typedef _BOOL (*breakProc)(_VOID);

/* Diese Prozedur wird waehrend des Sortierens regelmaessig
 * aufgerufen. Wenn diese TRUE zurueckliefert, dann wird
 * das Sortieren abgebrochen
 */


_BOOL QuickSort_noBreak(_VOID);
/* Gibt immer FALSE zurueck, kann als Breakprozedur verwendet werden
 */

_BOOL QuickSort_sortIt(_LONG low, _LONG high, _VOID *ptrelem, compProc comp, _LONG entrySize, breakProc brk, _VOID *private);
/* Generelle Sort-Prozedur.
 * Es wird ein Array of irgendwas sortiert, die Eintraege sind
 * alle entrySize Bytes gross. Fuer die compProc werden die Adressen
 * selber berechnet.
 */

_BOOL QuickSort_ListSort(List *list, compProc comp, breakProc break_);
/* Sortiert eine Liste mittels Zip-Sort (c) by Gerd Castan
 */


#endif /* __CAT_QUICKSORT_H__ */
