/*****************************************************************************
 *	RO_TIME.C
 *	system independant time functions
 *****************************************************************************/

#include <portab.h>
#include <ro_time.h>

/*** ---------------------------------------------------------------------- ***/

/*
 * Function T_DosToSystime() accepts an MSDOS format local date and time and
 * returns seconds since 1.1.1900, GMT
 */

GLOBAL SYSTIME T_DosToSystime(_UWORD date, _UWORD time)
{
	F_TIME t;

	if (date == 0 && time == 0) /* special case! */
		return 0;

	t.tm_year = ((date >> 9) & 0x7f) + 1980;
	t.tm_mon  = ((date >> 5) & 0x0f) - 1;
	t.tm_mday = (date		 & 0x1f) - 1;

	t.tm_hour = (time >> 11) & 0x1f;
	t.tm_min  = (time >> 5) & 0x3f;
	t.tm_sec  = (time & 0x1f) * 2;

	t.tm_yday = 0;
	t.tm_wday = 0;

	return T_Mktime(&t);
}
