/*****************************************************************************
 *	RO_TIME.C
 *	system independant time functions
 *****************************************************************************/

#include <portab.h>
#include <ro_time.h>
#include <routines.h>

/*** ---------------------------------------------------------------------- ***/

GLOBAL _UBYTE *T_DateToString(_UBYTE *string, _UWORD strSize, _UWORD mode, _UBYTE delimiter, SYSTIME tt)
{
	F_TIME t;
	_UWORD ww;
	_UBYTE *str;
	_UBYTE day[3], month[3], year[5];
	_UBYTE delim[2];

	*string = '\0';
	if (strSize < 7)
	{
		/* ErrorOut (EO_ERROR, "DateToString-strSize"); */
		return string;
	}
	if (tt == 0)
	{
		return string;
	}
	strSize -= 7;
	(_VOID) T_Localtime(tt, &t);

	str = day;
	ww = t.tm_mday + 1;
	if (ww >= 10 || (mode & DATE_TS_DAY_ZERO))
		*str++ = (ww / 10) + '0';
	else
		*str++ = ' ';
	*str++ = (ww % 10) + '0';
	*str = '\0';

	str = month;
	ww = t.tm_mon + 1;
	if (ww >= 10 || (mode & DATE_TS_MON_ZERO))
		*str++ = (ww / 10) + '0';
	else
		*str++ = ' ';
	*str++ = (ww % 10) + '0';
	*str = '\0';

	str = year;
	if (mode & DATE_TS_CENTURY)
	{
		if (strSize < 2)
		{
			return string;
		}
		strSize -= 2;
		ww = t.tm_year / 100;
		*str++ = (ww / 10) + '0';
		*str++ = (ww % 10) + '0';
	}
	ww = t.tm_year % 100;
	*str++ = (ww / 10) + '0';
	*str++ = (ww % 10) + '0';
	*str = '\0';

	str = delim;
	if (mode & DATE_TS_PUNCT)
	{
		if (strSize < 2)
		{
			return string;
		}
		*str++ = delimiter;
	}
	*str = '\0';

	str = string;
	switch (mode & DATE_TS_MASK)
	{
	case DATE_TS_DMY:
		strCat(str, day);
		strCat(str, delim);
		strCat(str, month);
		strCat(str, delim);
		strCat(str, year);
		break;
	case DATE_TS_MDY:
		strCat(str, month);
		strCat(str, delim);
		strCat(str, day);
		strCat(str, delim);
		strCat(str, year);
		break;
	case DATE_TS_YMD:
		strCat(str, year);
		strCat(str, delim);
		strCat(str, month);
		strCat(str, delim);
		strCat(str, day);
		break;
	}

	return string;
}



