/*****************************************************************************
 *	RO_TIME.C
 *	system independant time functions
 *****************************************************************************/

#include <portab.h>
#include <ro_time.h>

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID T_SysToDostime(SYSTIME ltime, _UWORD *date, _UWORD *time)
{
	F_TIME tp;

	if (ltime == 0)
	{
		*date = 0;
		*time = 0;
	} else
	{
		T_Localtime(ltime, &tp);
		*date = (tp.tm_mday + 1) |
				((tp.tm_mon + 1) << 5) |
				((tp.tm_year - 1980) << 9);
		*time = (tp.tm_sec >> 1) |
				(tp.tm_min << 5) |
				(tp.tm_hour << 11);
	}
}
