/*****************************************************************************
 *	RO_TIME.C
 *	system independant time functions
 *****************************************************************************/

#include <portab.h>
#include <ro_time.h>
#include <routine.h>
#include <routines.h>

/*** ---------------------------------------------------------------------- ***/

GLOBAL _BOOL   T_StringToTime (CONST _UBYTE *str, SYSTIME * tt)
{
	F_TIME  x;
	SYSTIME val;

	if (strLen (str) < 4)
		return FALSE;
	(_VOID) T_Localtime(T_Systime(), &x);
	x.tm_hour = a_to_i(str, 2);
	str += 2;
	if (*str != '\0' && !is_digit(*str))
		str++;
	x.tm_min = a_to_i(str, 2);
	if (*str != '\0' && !is_digit(*str))
		str++;
	/* TODO: check for am/pm */
	x.tm_sec = a_to_i(str, 2);
	if (!T_TimeOk(&x))
		return FALSE;
	val = T_Mktime(&x) % SECS_PER_DAY;
	*tt = ((*tt / SECS_PER_DAY) * SECS_PER_DAY) + val;
	return TRUE;
}


