/*****************************************************************************
 *	RO_TIME.C
 *	system independant time functions
 *****************************************************************************/

#include <portab.h>
#include <ro_time.h>
#include <routine.h>
#include <routines.h>

/*** ---------------------------------------------------------------------- ***/

GLOBAL _BOOL T_StringToDate(CONST _UBYTE *str, SYSTIME *tt)
{
	F_TIME x;
	SYSTIME val;
	
	if (strLen(str) < 4)
		return FALSE;
	(_VOID) T_Localtime(T_Systime(), &x);
	x.tm_mday = a_to_i(str, 2) - 1;
	str += 2;
	if (*str != '\0' && !is_digit(*str))
		str++;
	x.tm_mon = a_to_i(str, 2) - 1;
	if (*str != '\0' && !is_digit(*str))
		str++;
	if (is_digit(*str))
	{
		x.tm_year = a_to_i(str, 4);
		if (x.tm_year <= 90)
			x.tm_year += 2000;
		else if (x.tm_year <= 99)
			x.tm_year += 1900;
	}
	if (!T_DateOk(&x))
		return FALSE;
	val = T_Mktime(&x) / SECS_PER_DAY;
	*tt = (*tt % SECS_PER_DAY) + val * SECS_PER_DAY;
	return TRUE;
}


