/*****************************************************************************
 *	RO_TIME.C
 *	system independant time functions
 *****************************************************************************/

#include <portab.h>
#include <ro_time.h>

/*** ---------------------------------------------------------------------- ***/

GLOBAL _UBYTE *T_TimeToString (_UBYTE *string, _UWORD strSize, _UWORD mode, _UBYTE delimiter, SYSTIME tt)
{
	F_TIME	t;
	_UWORD	hour;
	_UWORD	ww;
	_UBYTE *str = string;

	*str = '\0';
	if (strSize < 5)
	{
		/* ErrorOut (EO_ERROR, "TimeToString-strSize"); */
		return string;
	}
	if (tt == 0)
	{
		return string;
	}
	(_VOID) T_Localtime (tt, &t);
	strSize -= 5;
	hour = t.tm_hour;
	if (mode & TIME_TS_12H)
	{
		hour %= 12;
		if (hour == 0)
			hour = 12;
	}
	ww = hour / 10;
	if (ww != 0 || (mode & TIME_TS_ZERO))
		*str++ = ww + '0';
	else
		*str++ = ' ';
	*str++ = (hour % 10) + '0';
	if (mode & TIME_TS_PUNCT)
	{
		if (strSize == 0)
		{
			/* ErrorOut (EO_ERROR, "TimeToString-strSize"); */
			*str = '\0';
			return string;
		}
		--strSize;
		*str++ = delimiter;
	}
	*str++ = t.tm_min / 10 + '0';
	*str++ = t.tm_min % 10 + '0';
	if (mode & TIME_TS_SECONDS)
	{
		if (mode & TIME_TS_PUNCT)
		{
			if (strSize == 0)
			{
				/* ErrorOut (EO_ERROR, "TimeToString-strSize"); */
				*str = '\0';
				return string;
			}
			--strSize;
			*str++ = delimiter;
		}
		if (strSize < 2)
		{
			/* ErrorOut (EO_ERROR, "TimeToString-strSize"); */
			*str = '\0';
			return string;
		}
		strSize -= 2;
		*str++ = t.tm_sec / 10 + '0';
		*str++ = t.tm_sec % 10 + '0';
	}
	if (mode & TIME_TS_12H)
	{
		if (strSize < 3)
		{
			/* ErrorOut (EO_ERROR, "TimeToString-strSize"); */
			*str = '\0';
			return string;
		}
		*str++ = ' ';
		*str++ = t.tm_hour >= 12 ? 'p' : 'a';
		*str++ = 'm';
	}
	*str = '\0';
	return string;
}


