/*****************************************************************************
 *		OR_SET.C
 *		set functions
 *****************************************************************************/

#include <portab.h>
#include <set.h>
#include <ro_mem.h>


/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID setcpy(SET set1, CONST SET set2)
{
	MemCpy(set1, set2, sizeof(SET));
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID setall(SET set)
{
	MemSet(set, 0xFF, sizeof(SET));
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID setclr(SET set)
{
	MemSetZero(set, sizeof(SET));
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID setnot(SET set)
{
	_WORD i;

	for (i = 0; i < SETSIZE; i++)
		set[i] = ~set[i];
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID setand(SET set1, CONST SET set2)
{
	_WORD i;

	for (i = 0; i < SETSIZE; i++)
		set1[i] &= set2[i];
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID setor(SET set1, CONST SET set2)
{
	_WORD i;

	for (i = 0; i < SETSIZE; i++)
		set1[i] |= set2[i];
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID setxor(SET set1, CONST SET set2)
{
	_WORD i;

	for (i = 0; i < SETSIZE; i++)
		set1[i] ^= set2[i];
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID setincl(SET set, _WORD elt)
{
	if ((0 <= elt) && (elt < SETMAX))
		set[elt >> 5] |= (1L << (elt & 0x1f));
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID setexcl(SET set, _WORD elt)
{
	if ((0 <= elt) && (elt < SETMAX))
		set[elt >> 5] &= ~(1L << (elt & 0x1f));
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _BOOL setin(CONST SET set, _WORD elt)
{
	if ((0 <= elt) && (elt < SETMAX))
		return (set[elt >> 5] & (1L << (elt & 0x1f))) ? TRUE : FALSE;
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _BOOL setcmp(CONST SET set1, CONST SET set2)
{
	_WORD i;
	_BOOL res;

	res = TRUE;
	if (set2 == NULL)
		for (i = 0; res && (i < SETSIZE); i++)
			res = set1[i] == 0;
	else
		for (i = 0; res && (i < SETSIZE); i++)
			res = set1[i] == set2[i];
	return res;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _WORD setcard(CONST SET set)
{
	_WORD i, j, card;

	for (i = card = 0; i < SETSIZE; i++)
	{
		if (set[i] != 0)
		{
			for (j = 0; j < 32; j++)
			{
				if (set[i] & (1l << j))
					card++;
			}
		}
	}
	return card;
}
