/*****************************************************************************
 * ROUTINE.H
 *****************************************************************************/

#ifndef __ROUTINE_H__
#define __ROUTINE_H__

#ifndef __PORTAB_H__
#  include <portab.h>
#endif
#ifndef __VAR_ARGS_H__
#  include <var_args.h>
#endif

#define PtrSize(aa) (aa), (_UWORD)sizeof(aa)
#define PtrAdrSize(aa) ((_VOID*)&aa), (_UWORD)sizeof(aa)

_VOID FlipWord(_WORD *aa);
_VOID FlipUWord(_UWORD *aa);
_VOID FlipLong(_LONG *start);
_VOID FlipULong(_ULONG *start);

_UBYTE *xtrcpy(_UBYTE *dest, CONST _UBYTE *src);
_UBYTE *xtrcat(_UBYTE *dest, CONST _UBYTE *src);
_UBYTE *vstrcat(_UBYTE *to, size_t size, CONST _UBYTE *first __c_va_alist);
_BOOL replaceChar(_UBYTE *str, _UBYTE from, _UBYTE to);
_BOOL delChar(_UBYTE *str, _UBYTE old);
_BOOL leerStr(CONST _UBYTE *str1);

_UBYTE *LongToStr(_UBYTE *toBuf, size_t size, _LONG wert);
_UBYTE *LongToRstr(_UBYTE *string, size_t size, _LONG zahl);
_UBYTE *LongToRVstr(_UBYTE *string, size_t size, _LONG zahl);
_UBYTE *LongToR0str(_UBYTE *string, size_t size, _LONG zahl);
_UBYTE *make_point(_UBYTE *str, size_t n_komma);

_LONG a_to_l(CONST _UBYTE *str, _WORD len);
_ULONG a_to_ul(CONST _UBYTE *str, _WORD len);
#define a_to_i(str, len) (_WORD)a_to_l(str, len)
_UBYTE *l_to_a(_UBYTE *buf, size_t bufsize, _LONG val, _WORD len);
#define i_to_a(buf, bufsize, val, len) l_to_a(buf, bufsize, (_LONG)(val), len)
_UBYTE *f_to_a(_UBYTE *buf, size_t bufsize, _LONG val, _WORD len, _WORD dez);
_LONG a_to_f(_UBYTE *str, _WORD dez);

_UBYTE *nummer_make(_UBYTE *string, _WORD v_komma, _WORD n_komma);
_UBYTE *LongToWaehrungStr(_UBYTE *string, size_t size, _LONG zahl, _BOOL showWae);


	
_BOOL EleListe(CONST _UBYTE *in, CONST _UBYTE *liste);

_BOOL strmatch(CONST _UBYTE *pattern, CONST _UBYTE *text);

_BOOL is_digit(_UBYTE c);
_BOOL is_alpha(_UBYTE c);
_BOOL is_alnum(_UBYTE c);
_BOOL is_upper(_UBYTE c);
_BOOL is_lower(_UBYTE c);
#define is_cntrl(c) ((c) < 0x20)

size_t Str_ConvertTabs(CONST _UBYTE *source, _UBYTE *dest, size_t destsize, _UWORD TabSize);
/* Expandiert den String zu einem ohne Tabs */

#endif /* __ROUTINE_H__ */
