/*****************************************************************************
 * ROUTINES.H
 *****************************************************************************/

#ifndef __ROUTINES_H__
#define __ROUTINES_H__

#ifndef __PORTAB_H__
#  include <portab.h>
#endif
#ifndef __VAR_ARGS_H__
#  include <var_args.h>
#endif

#define PtrSize(aa) (aa), (_UWORD)sizeof(aa)
#define PtrAdrSize(aa) ((_VOID*)&aa), (_UWORD)sizeof(aa)



_VOID strdelRightSpace(_UBYTE *str);
_VOID strdelSpace(_UBYTE *str);
_VOID strright(_UBYTE *string, size_t leng);
_VOID strleft(_UBYTE *string);
_VOID strFillRight(_UBYTE *string, size_t strsize, size_t leng);
_VOID strzenter(_UBYTE *string, size_t leng);
_VOID strMove(_UBYTE *desti, _UBYTE *source);
_VOID strnMove(_UBYTE *desti, _UBYTE *source, size_t anzahl);
CONST _UBYTE *strTeilCatOrCpy(_UBYTE *to, size_t toMaxBuf, CONST _UBYTE *run);
_UBYTE ucase(_UBYTE t);
_UBYTE lcase(_UBYTE t);
_UWORD scase(_UBYTE t);

CONST _UBYTE *get_uppercase_table(_VOID);
CONST _UBYTE *get_lowercase_table(_VOID);
_UBYTE hextoc(_UBYTE ch);
_UBYTE *strUpr(_UBYTE *work);
_UBYTE *strUprSort(_UBYTE *work);
_UBYTE *strLwr(_UBYTE *work);

_BOOL strReplace(_UBYTE *strTo, size_t sizeTo, CONST _UBYTE *oldstr, CONST _UBYTE *newstr);
_BOOL strReplaceWord(_UBYTE *strTo, size_t sizeTo, CONST _UBYTE *oldstr, CONST _UBYTE *newstr);

size_t  strSpn( const char *s, const char *set );
size_t  strcSpn( const char *s, const char *set );
_WORD strCmp(CONST _UBYTE *str1, CONST _UBYTE *str2);
_WORD strnCmp(CONST _UBYTE *str1, CONST _UBYTE *str2, size_t leng);
_WORD strCaseCmp(CONST _UBYTE *str1, CONST _UBYTE *str2);
_WORD strSortCmp(CONST _UBYTE *str1, CONST _UBYTE *str2);
_WORD strnCaseCmp(CONST _UBYTE *str1, CONST _UBYTE *str2, size_t leng);
CONST _UBYTE *strCaseStr(CONST _UBYTE _HUGE *s, CONST _UBYTE *wanted);
CONST _UBYTE *strCaseWord(CONST _UBYTE _HUGE *s, CONST _UBYTE *wanted);
_UBYTE  *strStr(CONST _UBYTE _HUGE *s, CONST _UBYTE *wanted);
_UBYTE  *strChr( CONST _UBYTE *s, int c );
size_t strCnt( CONST _UBYTE *s, int c );
_UBYTE  *strrChr( CONST _UBYTE *s, int c );
_UBYTE  *strCaseChr( CONST _UBYTE *s, int c );
_UBYTE  *strCpy( _UBYTE *dest, CONST _UBYTE *src );
_UBYTE  *strnCpy( _UBYTE *dest, CONST _UBYTE *src,size_t maxlen );
_UBYTE  *strPbrk( CONST _UBYTE *s1, CONST _UBYTE *s2 );

_VOID strInsertChar(_UBYTE ch, _UBYTE *str, size_t strsize);
size_t  strLen( const char *s );
char *strCat( char *dest, const char *src );


#endif /* __ROUTINES_H__ */
