#ifndef __CAT_SEARCHHELP_H__
#define __CAT_SEARCHHELP_H__
/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */



#ifndef __PORTAB_H__
#include <portab.h>
#endif
#ifndef __CAT_CATTYPES_H__
#include <cattypes.h>
#endif
#ifndef __CAT_DATASYS_H__
#include <datasys.h>
#endif

#define vUND            0
#define vODER           1


#define sUEBERALL       0
#define sTEXT           1
#define sBETREFF        2
#define sTEXTnBETREFF   3
#define sABSENDER       4
#define sEMPFAENGER     5
#define sID             6


/* Achtung, Uebereinstimmung mit der Resourcedatei ist wichtig! */
/* ZSearchDial geht implizit von der richtigen Zuordnung aus!  */

#define suchstringAnz   4   /* Vier Suchstrings gibt es in der Suchbox von CAT */

#define MAX_SEARCHKONF 10

typedef _UBYTE searchStrType[60];
typedef searchStrType searchStrArray[suchstringAnz];
typedef _WORD verknType[suchstringAnz - 1];
typedef _WORD woType[suchstringAnz];


typedef struct SearchRecordType {
	searchStrArray searchStr;
	verknType verkn;   /* = (vUND, vODER); */
	woType wo;
	_BOOL show;
	_BOOL change;
	_BOOL statussearch;
	_BOOL ask;
	_BOOL searchText;
	_BOOL gross;
	_BOOL groupsearch;
	MSGBITS sSetBits;
	MSGBITS sClearedBits;
	MSGBITS setBits;
	MSGBITS clearBits;
	_UBYTE	Name[11];
} SearchRecordType;


extern SearchRecordType suchVar;


/* Das ist jetzt vorlaeufig redundant. Beide Variablen werden gesetzt, auf Dauer */
/* soll aber nur das Record drin bleiben!                                       */

_BOOL SearchHelp_IsValidSearch(CONST _UBYTE *str);
/* Prueft einen Suchstring, ob er gueltig ist.
 * FALSE: Suchstring ist nicht gueltig.
 */

_BOOL SearchHelp_ValidateKonf(SearchRecordType *konf);
/* Prueft die uebergebene Suchkonfiguration auf Gueltigkeit.
 */

_BOOL SearchHelp_getKonf(MSGNR nr, SearchRecordType *konf);
/* Suchkonfiguration <nr> abrufen, FALSE -> nicht gesetzt */
/* moeglich sind im Moment die Nummern 0..9 */

_BOOL SearchHelp_setKonf(_UWORD nr, SearchRecordType *konf);
/* Suchkonfiguration <nr> setzen */
/* Gibt zurueck, ob die Variablen angelegt werden konnten */


#endif /* __CAT_SEARCHHELP_H__ */
