/*****************************************************************************
 *		SOUND.H
 *****************************************************************************/

#ifndef __SOUND_H__
#define __SOUND_H__

#ifndef __PORTAB_H__
#include <portab.h>
#endif

enum {SOUND_NONE,SOUND_DEFAULT,SOUND_FLASH,SOUND_INTERN,SOUND_FILENAME};

_BOOL Sound_Init(_VOID);
/* Initialisierung */

_VOID Sound_Bing(_VOID);
/* Gibt ein Standard-Pling aus */

_VOID Sound_Flash(_VOID);
/* Invertiert den Bildschirm */

_VOID Sound_Play_Intern(_WORD type);
/* Spielt eine von mehreren Melodien ab */

_BOOL Sound_Play_Filename(CONST _UBYTE *filename,_WORD avModus);
/* Spielt eine Sound-Datei ueber externe Programme ab */

_BOOL Sound_Play(CONST _UBYTE *event,_WORD avModus);
/* Spielt den dem Ereignis zugeordneten Sound ab */

_VOID Sound_Stop(_VOID);
/* Stoppt eine laufende Sound-Ausgabe */

_BOOL Sound_Register(CONST _UBYTE *event, _WORD type, CONST _UBYTE *data);
/* Ordnet einem Ereignis einen Sound zu */

_VOID Sound_Unregister(CONST _UBYTE *event);
/* Loescht die zuvor gemachte Zuordnung wieder */


#endif /* __SOUND_H__ */
