/*****************************************************************************
 * S_ENDIAN.H
 *****************************************************************************/

#ifndef __S_ENDIAN_H__
#define __S_ENDIAN_H__

#define BYTE_ORDER_BIG_ENDIAN    4321
#define BYTE_ORDER_LITTLE_ENDIAN 1234
#define BYTE_ORDER_PDP_ENDIAN    3412

#ifndef HOST_BYTE_ORDER
#  ifdef BYTE_ORDER
#    define HOST_BYTE_ORDER BYTE_ORDER
#  else
#    ifdef __BYTE_ORDER
#      define HOST_BYTE_ORDER __BYTE_ORDER
#    else
#      ifdef _BYTE_ORDER
#        define HOST_BYTE_ORDER _BYTE_ORDER
#      endif
#    endif
#  endif
#endif

#ifndef HOST_BYTE_ORDER

#  ifdef __mc68000__
#    define HOST_BYTE_ORDER BYTE_ORDER_BIG_ENDIAN
#  endif
#  ifdef __mc68k__
#    define HOST_BYTE_ORDER BYTE_ORDER_BIG_ENDIAN
#  endif
#  ifdef m68k
#    define HOST_BYTE_ORDER BYTE_ORDER_BIG_ENDIAN
#  endif

#  ifdef __i386__
#    define HOST_BYTE_ORDER BYTE_ORDER_LITTLE_ENDIAN
#  endif
#  ifdef __i486__
#    define HOST_BYTE_ORDER BYTE_ORDER_LITTLE_ENDIAN
#  endif
#  ifdef __i586__
#    define HOST_BYTE_ORDER BYTE_ORDER_LITTLE_ENDIAN
#  endif

#endif

_WORD get_byte_order(_VOID);

_ULONG n2hl(_ULONG val);
_ULONG h2nl(_ULONG val);
_UWORD n2hs(_UWORD val);
_UWORD h2ns(_UWORD val);

#ifndef HOST_BYTE_ORDER
#  define HOST_BYTE_ORDER (get_byte_order())
#  define IfBigEndian if (HOST_BYTE_ORDER == BYTE_ORDER_BIG_ENDIAN)
#  define IfNotBigEndian if (HOST_BYTE_ORDER != BYTE_ORDER_BIG_ENDIAN)
#else
#  if HOST_BYTE_ORDER == BYTE_ORDER_BIG_ENDIAN
#    define n2hl(x) x
#    define h2nl(x) x
#    define n2hs(x) x
#    define h2ns(x) x
#    define IfBigEndian /**/
#    define IfNotBigEndian if (stdout){} else
#  else
#    define IfBigEndian if (stdout){} else
#    define IfNotBigEndian /**/
#  endif
#endif

#endif /* __S_ENDIAN_H__ */
