/*****************************************************************************
 * TOS/DD.C
 *****************************************************************************/

#include <dd.h>
#include <debug.h>
#include <routines.h>

/*****************************************************************************/
/*  Drag&Drop                                                                */
/*****************************************************************************/

#define PIPE_DRAGDROP "U:\\PIPE\\DRAGDROP.AA"
#define PIPE_EXT (sizeof(PIPE_DRAGDROP) - 3)

GLOBAL _WORD dd_parse_args(_UBYTE *str)
{
	_WORD cnt = 0;
	_UBYTE *c = str;
	_BOOL in_quote = FALSE;
	_BOOL in_arg = FALSE;

	while (*c != '\0')
	{
		switch (*c)
		{
		case ' ':
			if (!in_quote)
			{
				*c = '\0';
				while (c[1] == ' ')
					strCpy(c+1, c+2);
				if (in_arg)
					cnt++;
				in_arg = FALSE;
			}
			break;
		case '\'':
			strCpy(c, c + 1);
			if (!in_quote)
			{
				in_quote = TRUE;
				in_arg = TRUE;
			} else
			{
				if (*c != '\'')
				{
					in_quote = FALSE;
					*c = '\0';
					if (in_arg)
						cnt++;
					in_arg = FALSE;
				}
			}
			break;
		default:
			in_arg = TRUE;
			break;
		}
		c++;
	}
	if (in_arg)
	{
		if (in_quote)
			SPEC_DEBUG_OUT((EO_DEBUG, "unterminated quoted argument"));
		cnt++;
	}
	return cnt;
}
