/*****************************************************************************
 * GENERIC/FIO_BUFC.C
 *****************************************************************************/

#include "_file_io.h"
#include <ro_mem.h>
#include <debug.h>

/*** ---------------------------------------------------------------------- ***/

OS_GLOBAL F_ERROR FiBufClose(FILENO fd)
{
	F_ERROR retV;
	FILE_BUF *ff;

	if (!VALID_FILENO(fd))
	{
		ErrorOut(EO_ERROR, "FiBufClose: falsche Dateinummer %ld", (_LONG) TO_HANDLE(fd));
		return GERR_BADF;
	}
	
	if (FiBuf == NULL)
	{
		ErrorOut(EO_ERROR, "FiBufClose: not initialized");
		return GERR_INVAL;
	}
	
	ff = &FiBuf[TO_HANDLE(fd)];

	retV = sysFclose(ff);
	ff->used = FALSE;
	return retV;
}


