/*****************************************************************************
 * GENERIC/FIO_BUFH.C
 *****************************************************************************/

#include "_file_io.h"
#include <ro_mem.h>
#include <debug.h>

/*** ---------------------------------------------------------------------- ***/

OS_GLOBAL F_ERROR FiBufHandle(FILENO fd, DOSFNO *handle)
{
	FILE_BUF *ff;
	F_ERROR err;
	
	if (!VALID_FILENO(fd))
	{
		ErrorOut(EO_ERROR, "FiBufHandle: falsche Dateinummer %ld", (_LONG) TO_HANDLE(fd));
		return GERR_BADF;
	}
	
	if (FiBuf == NULL)
	{
		ErrorOut(EO_ERROR, "FiBufHandle: not initialized");
		return GERR_INVAL;
	}
	
	ff = &FiBuf[TO_HANDLE(fd)];

	if (!ff->used)
		return GERR_BADF;

	if (!ff->open)
	{
		if ((err = FiBufOpen(ff->path, ff->mode, ff->seekPos, handle)) == GERR_OK)
		{
			ff = &FiBuf[TO_HANDLE(fd)]; /* FiBuf may have changed */
			ff->open = TRUE;
			ff->handle = *handle;
			return GERR_OK;
		}
		return err;
	}
	*handle = ff->handle;
	return GERR_OK;
}
