/*****************************************************************************
 * GENERIC/FIO_BUFS.C
 *****************************************************************************/

#include "_file_io.h"
#include <ro_mem.h>
#include <debug.h>
#include <routines.h>

/*** ---------------------------------------------------------------------- ***/

OS_GLOBAL FILENO FiBufSave(DOSFNO handle, CONST _UBYTE *path, _WORD mode)
{
	_WORD   ii;
	FILE_BUF *ff;
	
	if (FiBuf == NULL)
		if (!FInit())
		{
			return GERR_NOMEM;
		}
	
	for (ii = 0; ii < fi_buf_size; ii++)
	{
		if (!((ff = &FiBuf[ii])->used))
		{
			ff->open = TRUE;
			ff->used = TRUE;
			ff->handle = handle;
			ff->mode = mode & (FO_ACCMODE | FO_SHMODE);
			ff->seekPos = 0;
			strCpy(ff->path, path);

			return TO_FILENO(ii);
		}
	}
	ErrorOut (EO_FATAL, "Too many open files.");
	return GERR_NFILE;
}
