#include <file_io.h>
#include <strconv.h>
#include <mtalerts.h>
#include <routinec.h>
#include <mtrsc.h>
#include <catlib.h>
LOCAL struct error_message {
	_WORD number;
	_WORD message;
} errorMessages[] = {
	{ -1, ERR_BIOS_1 },
	{ -2, ERR_BIOS_2 },
	{ -3, ERR_BIOS_3 },
	{ -4, ERR_BIOS_4 },
	{ -5, ERR_BIOS_5 },
	{ -6, ERR_BIOS_6 },
	{ -7, ERR_BIOS_7 },
	{ -8, ERR_BIOS_8 },
	{ -9, ERR_BIOS_9 },
	{ -10, ERR_BIOS_10 },
	{ -11, ERR_BIOS_11 },
	{ -12, ERR_BIOS_12 },
	{ -13, ERR_BIOS_13 },
	{ -14, ERR_BIOS_14 },
	{ -15, ERR_BIOS_15 },
	{ -16, ERR_BIOS_16 },
	{ -17, ERR_BIOS_17 },
	{ -32, ERR_GD_32 },
	{ -33, ERR_GD_33 },
	{ -34, ERR_GD_34 },
	{ -35, ERR_GD_35 },
	{ -36, ERR_GD_36 },
	{ -37, ERR_GD_37 },
	{ -39, ERR_GD_39 },
	{ -40, ERR_GD_40 },

	{ -46, ERR_GD_46 },
	{ -48, ERR_GD_48 },
	{ -49, ERR_GD_49 },

  /* Netzwerk-Fehlercodes */
	{ /* ELOCKED */ -58, ERR_GD_58 },
	{ /* ENSLOCK */ -59, ERR_GD_59 },

	{ -64,   ERR_GD_64 },
	{ -65,   ERR_GD_65 },
	{ -66,   ERR_GD_66 },
	{ -67,   ERR_GD_67 },
	{ -80,   ERR_GD_80 },
	{ -143,  ERR_GD_143},
	{ -200,  ERR_GD_200 },
	{ -1792, ERR_DYJ_1792},
/*
	{ BuffUsed, "Interner Puffer belegt" },
	{ BuffNotUsed, "Interner Puffer leer" },
	{ FileEmpty, "Leere Datei" },
	{ EOF, "\232berraschendes Fileende" },
*/
    { 0, 0 },
    { 0, 0 },
    { 0, 0 },
    { 0, 0 },

    { 0, 0 }
};
#define maxErrors (sizeof(errorMessages) / sizeof(errorMessages[0]))

#define AL_ERROR_ALERT "[3][|%s][[Abbruch]"

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

LOCAL _VOID appendGemdosError(_UBYTE *str, size_t strsize, _WORD nr)
{
	_UBYTE numstr[20];
	
	strMcat(str, strsize, "|Gemdos ");
	IntToStr(nr, 0, numstr, sizeof(numstr));
	strMcat(str, strsize, numstr);
}

/*** ---------------------------------------------------------------------- ***/
/*DYJ 5.21b */
GLOBAL _VOID F_GetErrorMsg(_WORD nr, _UBYTE *str, size_t strsize)
{
	struct error_message *msg;
	size_t n;
	
	msg = errorMessages;
	n = maxErrors;
	while (n && msg->number)
	{
		if (msg->number == nr)
		{
			strMcpy(str, strsize, Rsc_WrkString(msg->message));
			if (nr < 0 && nr > -100)
				appendGemdosError(str, strsize, nr);
			return;
		}
		++msg;
	}
	strMcpy(str, strsize, Rsc_WrkString(ERR_CAT_UNKN));
	appendGemdosError(str, strsize, nr);
}

/*** ---------------------------------------------------------------------- ***/

/*DYJ 5.21b */
GLOBAL _VOID F_SetErrorMsg(_WORD nr, _WORD str)
{
	struct error_message *msg;
	size_t n;
	
	msg = errorMessages;
	n = maxErrors;
	while (n && msg->number)
	{
		if (msg->number == nr)
		{
			msg->message = str;
			return;
		}
		++msg;
		--n;
	}
	if (n > 0)
	{
		msg->number = nr;
		msg->message = str;
	}
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID F_ErrorAlert(F_ERROR nr)
{
	_UBYTE msg[256];
	_UBYTE alt[sizeof(msg) + sizeof(AL_ERROR_ALERT)];

	if (nr != GERR_OK)
	{
		F_GetErrorMsg(nr, msg, sizeof(msg));
		sprintf(alt, AL_ERROR_ALERT, msg);
		mtAlerts_Alert(1, alt);
	}
}

