#include "_file_io.h"
#include <routinec.h>
#include <routines.h>
#include <varnamel.h>
#include <confvars.h>

/*
 * 5.4.03 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.24g'
 *	Enthielt ein Anhangname ungltige Zeichen, werden diese konvertiert,
 *	leider konnte es dabei zu einer Endlosschleife kommen.
 *
 * 8.4.03 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.25b'
 *	Leider war bei der vorigen Korrektur noch ein Fehler drin.
 *	Dadurch wurden bei den Anhangfilenamen jeder 2. Buchstabe
 *	ausgelassen.
 *
 * 24.10.03 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.32d'
 *	".tgz" ist 5 nicht 4 Zeichen lang
 */
/*** ---------------------------------------------------------------------- ***/

GLOBAL _WORD F_Path_CaseMode(CONST _UBYTE *path)
{
	_WORD mode;
	
	mode = (_WORD)Dpathconf((_UBYTE *)path, DP_CASE);
	if (mode == -32)
		mode = DP_CASECONV;
	return mode;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _WORD F_Path_TruncMode(CONST _UBYTE *path)
{
	_WORD mode;
	
	mode = (_WORD)Dpathconf((_UBYTE *)path, DP_TRUNC);
	if (mode == -32)
		mode = DP_DOSTRUNC;
	return mode;
}
/*** ------------------------------------------------------------------------ ***/
/*	_WORD F_Path_MaxFlen(CONST _UBYTE *path)									*/
/*	Gibt die maximale Lnge eines Filenamens zurck								*/
/*	Parameter:	Pfad															*/
/*	Ergebnis:	Lnge															*/		
/*	12.2.03 von Dimitri Junker	DYJ 5.20r										*/
/*** ------------------------------------------------------------------------ ***/
GLOBAL _WORD F_Path_MaxFlen(CONST _UBYTE *path)
{
	_WORD mode;
	
	mode = (_WORD)Dpathconf((_UBYTE *)path, DP_NAMEMAX);
	if (mode == -32)
		mode = 12;
	return mode;
}
/*** ------------------------------------------------------------------------ ***/
/*	_VOID F_Path_DoTrunc(_UBYTE *fName,_UBYTE *name,_UBYTE *ext)				*/
/*	Krzt einen File-Namen und -Endung, auf 8 bzw 3 Zeichen, konvertiert dabei	*/
/*	ungltige Zeichen und ersetzt die Endung .tar.gz durch .tgz	u..			*/
/*	auerdem wird der Name in Name und Endung geteilt							*/
/*	Parameter:	fName:	Fullname, soll geteilt werden							*/
/*				name:	Der Filename											*/
/*				ext:	und seine Endung (mit '.')								*/
/*	Ergebnis:	keines															*/		
/*	14.11.01 von Dimitri Junker	DYJ 4.30zb										*/
/*** ------------------------------------------------------------------------ ***/
/*DYJ 5.20r */
GLOBAL _VOID F_Path_DoTrunc(_UBYTE *fName,_UBYTE *name,_UBYTE *ext)
{
	_WORD i,rest=8;
	_UBYTE varname[512],*quell=name,*ziel,*ptr;
	_UBYTE tab[]="_!_#$%&'()_+,-__0123456789_;<=>_@ABCDEFGHIJKLMNOPQRSTUVWXYZ[_]^_`ABCDEFGHIJKLMNOPQRSTUVWXYZ{_}~";
	_UBYTE lang[][10]={".tar.gz",".tar.bz2",".jpeg",".text",".iges",".ilbm",".pict","tiny",""};
/*DYJ 5.32d Start*/
	_UBYTE kurz[][5]={".tgz",".tbz",".jpg",".txt",".igs",".lbm",".pct",".tny"};
/*DYJ  Ende; alt:	
	_UBYTE kurz[][4]={".tgz",".tbz",".jpg",".txt",".igs",".lbm",".pct",".tny"};
*/
	strCpy(name,fName);
	for(i=0;lang[i][0];i++)
	{
		ptr=(_UBYTE *)strCaseStr(name,lang[i]);
		if(ptr && strLen(ptr)==strLen(lang[i]))
		{
			strCpy(ptr,kurz[i]);
			break;
		}
	}
	ptr=strrChr(name,'.');
	if(ptr)
	{
		strMcpy(varname, sizeof(varname), cTruncExt);
		strMcat(varname, sizeof(varname), ptr);
		*ext='.';
		ext++;
		ConfVars_GetConfDefStr(varname,ext,PATH_MAX-1,ptr+1);
		*ptr='\0';
		if(*ext=='.')
		{
			strCpy(varname,ext+1);
			strCpy(ext,varname);
		}
	}
	for(i=0;i<2;i++)
	{
		ziel=quell;
		while(rest && *quell)
		{
			if(*quell>=' '&&*quell<='~')
			{
				*(ziel++)=tab[*quell-' '];
				rest--;
			}
			quell++;
		}
		*ziel='\0';
		rest=3;
		quell=ext;
	}
}
/*** ------------------------------------------------------------------------ ***/
/*	_UBYTE *F_Path_Copy(_UBYTE *dest,_UBYTE *src)								*/
/*	Kopiert einen String, allerdings werden dabei alle Zeichen <' ' oder grer	*/
/*	'~' ausgelassen und in Filenamen verbotene Zeichen (\ / : * ? " < > | ) 	*/
/*	durch '_' ersetzt.															*/
/*	Parameter:	dest,src:	Quelle und Ziel										*/
/*	Ergebnis:	dest 															*/		
/*	4.2.03 von Dimitri Junker	DYJ 5.20r										*/
/*** ------------------------------------------------------------------------ ***/
GLOBAL _UBYTE *F_Path_Copy(_UBYTE *dest,_UBYTE *src)
{
	_UBYTE tab[]=" !_#$%&'()_+,-._0123456789:;<=>_@ABCDEFGHIJKLMNOPQRSTUVWXYZ[_]^_`abcdefghijklmnopqrstuvwxyz{_}~";
	if(!dest)
		return NULL;
	if(!src)
		*dest='\0';
	else
	{	while(*src)
		{
			if(*src>=' '&&*src<='~')
				*(dest++)=tab[*(src++)-' '];
			else	/*DYJ 5.25b */
				src++;	/*DYJ 5.24g */
		}
		*dest='\0';
	}
	return dest;
}