/*****************************************************************************
 *	TOS/FIO_PCRE.C
 *****************************************************************************/

#include "_file_io.h"
#include <routinec.h>
#include <routine.h>
#include <routines.h>

/*** ---------------------------------------------------------------------- ***/

GLOBAL F_ERROR F_Path_Create(CONST _UBYTE *path)
{
	_UBYTE prefix[PATH_MAX];
	_UBYTE *p, *pend;
	_WORD err;
	
	strBcpy(prefix, path);
	p = prefix;
	if (is_alpha(*p) && p[1] == ':')
		p += 2;
	/* don't try to make the root directory */
	if (*p == '\\' || *p == '/')
		++p;
	do
	{
		pend = strChr(p, '\\');
		if (pend == NULL)
			pend = strChr(p, '/');
		if (pend)
			*pend = '\0';
		err = Dcreate(prefix);
		switch (err)
		{
		case -34: /* ENOTDIR */
			/* error(err, prefix); */
			return sys_errno(err);;
		}
		if (pend)
			*pend++ = '\\';
		p = pend;
	} while (pend != NULL && *pend != '\0');
	return GERR_OK;
}
