#include "_file_io.h"
#include <ro_mem.h>
#include <debug.h>
#include <routines.h>
#include <routine.h>

/*** ---------------------------------------------------------------------- ***/

GLOBAL _BOOL F_Path_Set(CONST _UBYTE *pfad)
{
	_BOOL retV;
	_WORD res;

	SavePD();

	if (pfad == NULL)
	{
		pfad = sys_workpath;
		if (*pfad == '\0')
			F_Path_Get(sys_workpath);
	}
	if (is_alpha(pfad[0]) && pfad[1] == ':')
	{
		Dsetdrv(ucase(*pfad) - 'A');
		SPEC_DEBUG_OUT((EO_TRACE, "F_Path_Set: current drive now %c", Dgetdrv() + 'A'));
		pfad += 2;
		if (*pfad == '\0')
		{
			res = Dsetpath("\\");
			SPEC_DEBUG_OUT((EO_TRACE, "F_Path_Set: Dsetpath(root): res=%d", res));
			retV = res == 0;
			RestorePD();
			return retV;
		}
	}
	if (*pfad == '\0')
	{
		retV = TRUE;
	} else
	{
		res = Dsetpath(pfad);
		SPEC_DEBUG_OUT((EO_TRACE, "F_Path_Set: Dsetpath(%s): res=%d", pfad, res));
		retV = res == 0;
	}

	RestorePD();
	return retV;
}
