#include "_file_io.h"

#define F_STAT 0x4600

/*** ---------------------------------------------------------------------- ***/

GLOBAL F_ERROR F_File_Size(CONST _UBYTE *fname, FILENO fd, _ULONG *size)
{
	XATTR xattr;
	_LONG ret;
	_DTA dta, *olddta;
	F_ERROR err;

	UNUSED(fd);
	if (size != NULL)
		*size = 0;
	if (fname != NULL)
	{
		if ((ret = Fxattr(0, fname, &xattr)) == 0)
		{
			if (size != NULL)
				*size = xattr.size;
			return GERR_OK;
		}
		err = sys_errno((_WORD)ret);
		if (err != GERR_INVFN)
		{
			return err;
		}
		{
		SavePD();
		olddta = Fgetdta();
		Fsetdta(&dta);
		ret = Fsfirst(fname, 0x07);
		Fsetdta(olddta);
		RestorePD();
		}
		if (ret == 0)
		{
			if (size != NULL)
				*size = dta.dta_size;
			return GERR_OK;
		}
		err = sys_errno((_WORD)ret);
		return err;
	}
	return GERR_INVAL;
}


