#include "_file_io.h"

/*** ---------------------------------------------------------------------- ***/

GLOBAL F_ERROR F_File_Write(FILENO fd, CONST _VOID *buf, _LONG wtSize, _LONG *written)
{
	_LONG   size, wsize;
	_WORD   ii = 0;
	F_ERROR err;
	DOSFNO handle;
	
	wsize = 0;
	
	if (wtSize > 0)
	{
		SavePD();
		if ((err = FiBufHandle(fd, &handle)) == GERR_OK)
		{
			while ((size = Fwrite((_WORD)handle, wtSize, buf)) == NETERR)
			{
				if (!NetzwerkDa)
					break;
				ii++;
				if (ii > 5)
				{
					ii = 0;
					break;
				}
				NETWAIT();
			}
			if (size > 0)
				wsize += size;
			if (wsize != wtSize)
			{
				if (size < 0)
					err = sys_errno((_WORD)size);
				else
					err = GERR_INCOMPLETE;
				FiBuf[TO_HANDLE(fd)].seekPos = Fseek(0L, (_WORD)handle, SEEK_CUR);
			} else
			{
				FiBuf[TO_HANDLE(fd)].seekPos += wsize;
			}
		}
		RestorePD();
	} else
	{
		err = GERR_OK;
	}
	
	if (written != NULL)
		*written = wsize;

	return err;
}
