#ifndef __CAT_USERINFORMATION_H__
#define __CAT_USERINFORMATION_H__
/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */



#ifndef __PORTAB_H__
#include <portab.h>
#endif
#ifndef __MAGICTOOL_TEXTFILES_H__
#include <mttextfi.h>
#endif
#ifndef __GRECT
#include <grafbase.h>
#endif

typedef struct UserBlockType {
	_BOOL MakeInfileAfterImport;   /* INFILE erstellen nach */
	_BOOL MakeInfileAtEnd;
	_BOOL Umbruch;
	_BOOL DeleteAfterImport;
	_BOOL DeleteBeforeTerm;
	_BOOL AutoSaveOptions;
	_BOOL ImportAtStart;
	_BOOL ImportAfterTermPrg;
	_BOOL StartTermAtStart;
	_BOOL TerminalAsOverlay;
	_BOOL MakeInfileBeforeTerminal;
	_BOOL ConvertDiaresis;
	_BOOL AutoUndo;
	_BOOL ignoreRead;
	_WORD RightMargin;   /* Raender fuer Editor */
	_WORD WaitingTime;
	_UBYTE UserString1[16];
	_UBYTE UserString2[16];
	_BOOL RequestInfofiles;
	_BOOL MessagesInInfile;
	_BOOL StatusMessagesInInfile;
	_BOOL GroupChangesInInfile;
	_BOOL InitialQuote;
	_BOOL BlkAftQuote;
	_BOOL SillyChecks;
	_UBYTE ReferenceLine1[256];
	_UBYTE ReferenceLine1M[256];	/*DYJ 5.30l */
	_UBYTE ReferenceLine2[256];
	_UBYTE WWVerkettung[256];
	GRECT buttonW;   /* Fensterpositionen */
	_BOOL watchBox;
	_BOOL InfoInSlider;		/* ??? */
	_BOOL sortGroups;
	_BOOL RedirectPacker;
	_BOOL ShowLineEnds;
	_BOOL AutomaticSplit;
	_BOOL endlessLines;
	_WORD TabSize;
	_LONG splitSize;
	_BOOL InfofilesReadOnly;
	_BOOL MessageDateInInfile;
	_BOOL ignoreFiltered;
	_BOOL isInternet;
	_WORD MimeTextMode;	/*DYJ 5.33b */
} UserBlockType;


extern UserBlockType UserBLK;
extern _BOOL batchProcess;
extern _BOOL isTmp;


_VOID UserInformation_writeInfo(TEXTFILENO inf);

_VOID UserInformation_WriteUserBlock(_VOID);

_BOOL UserInformation_ReadUserBlock(_VOID);

_VOID UserInformation_chkTerm(_VOID);

#endif /* __CAT_USERINFORMATION_H__ */
