#ifndef	__VDICOL_H__
#define	__VDICOL_H__

#include <portvdi.h>										/* alte VDI-Funktionen */
#include <prsettng.h>										/* PRN_SETTINGS-Struktur */


#ifndef	__COLORMAP__

#ifndef	VARIABLE_ARRAY_SIZE
#define	VARIABLE_ARRAY_SIZE	1								/* Konstante fuer variabel grosse Felder (muss wegen C++ bzw. Ansi-Strict >= 1 sein) */
#endif

#define	REFS_ARE_PTRS	1

typedef struct
{
	_WORD	red;											/* Rot-Intensitaet in Promille (0-1000) */
	_WORD	green;											/* Gruen-Intensitaet in Promille (0-1000) */
	_WORD	blue;											/* Blau-Intensitaet in Promille (0-1000) */
} RGB1000;


/*----------------------------------------------------------------------------------------*/
/* Konstanten fuer Pixelformate                                                           */
/*----------------------------------------------------------------------------------------*/
#define	PX_1COMP		0x01000000L							/* Pixel besteht aus einer benutzten Komponente: Farbindex */
#define	PX_2COMP		0x02000000L							/* Pixel besteht aus zwei benutzten Komponenten, z.B. AG */
#define	PX_3COMP		0x03000000L							/* Pixel besteht aus drei benutzten Komponenten, z.B. RGB */
#define	PX_4COMP		0x04000000L							/* Pixel besteht aus vier benutzten Komponenten, z.B. CMYK */

#define	PX_REVERSED	0x00800000L								/* Pixel wird in umgekehrter Bytreihenfolge ausgegeben */
#define	PX_xFIRST	0x00400000L								/* unbenutzte Bits liegen vor den benutzen (im Motorola-Format betrachtet) */
#define	PX_kFIRST	0x00200000L								/* K liegt vor CMY (im Motorola-Format betrachtet) */
#define	PX_aFIRST	0x00100000L								/* Alphakanal liegen vor den Farbbits (im Motorola-Format betrachtet) */

#define	PX_PACKED	0x00020000L								/* Bits sind aufeinanderfolgend abgelegt */
#define	PX_PLANES	0x00010000L								/* Bits sind auf mehrere Ebenen verteilt (Reihenfolge: 0, 1, ..., n) */
#define	PX_IPLANES	0x00000000L								/* Bits sind auf mehrere Worte verteilt (Reihenfolge: 0, 1, ..., n) */

#define	PX_USES1	0x00000100L								/* 1 Bit des Pixels wird benutzt */
#define	PX_USES2	0x00000200L								/* 2 Bit des Pixels werden benutzt */
#define	PX_USES3	0x00000300L								/* 3 Bit des Pixels werden benutzt */
#define	PX_USES4	0x00000400L								/* 4 Bit des Pixels werden benutzt */
#define	PX_USES8	0x00000800L								/* 8 Bit des Pixels werden benutzt */
#define	PX_USES15	0x00000f00L								/* 15 Bit des Pixels werden benutzt */
#define	PX_USES16	0x00001000L								/* 16 Bit des Pixels werden benutzt */
#define	PX_USES24	0x00001800L								/* 24 Bit des Pixels werden benutzt */
#define	PX_USES30	0x00001e00L								/* 30 Bit des Pixels werden benutzt */
#define	PX_USES32	0x00002000L								/* 32 Bit des Pixels werden benutzt */
#define	PX_USES48	0x00003000L								/* 48 Bit des Pixels werden benutzt */

#define	PX_1BIT		0x00000001L								/* Pixel besteht aus 1 Bit */
#define	PX_2BIT		0x00000002L								/* Pixel besteht aus 2 Bit */
#define	PX_3BIT		0x00000003L								/* Pixel besteht aus 3 Bit */
#define	PX_4BIT		0x00000004L								/* Pixel besteht aus 4 Bit */
#define	PX_8BIT		0x00000008L								/* Pixel besteht aus 8 Bit */
#define	PX_16BIT	0x00000010L								/* Pixel besteht aus 16 Bit */
#define	PX_24BIT	0x00000018L								/* Pixel besteht aus 24 Bit */
#define	PX_32BIT	0x00000020L								/* Pixel besteht aus 32 Bit */
#define	PX_48BIT	0x00000030L								/* Pixel besteht aus 48 Bit */
#define	PX_64BIT	0x00000040L								/* Pixel besteht aus 64 Bit */

#define	PX_CMPNTS	0x0f000000L								/* Maske fuer Anzahl der Pixelkomponenten */
#define	PX_FLAGS	0x00f00000L								/* Maske fuer diverse Flags */
#define	PX_PACKING	0x00030000L								/* Maske fuer Pixelformat */
#define	PX_USED		0x0000ff00L								/* Maske fuer Anzahl der benutzten Bits */
#define	PX_BITS		0x000000ffL								/* Maske fuer Anzahl der Bits pro Pixel */

/*----------------------------------------------------------------------------------------*/
/* Pixelformate fuer ATARI-Grafik                                                         */
/*----------------------------------------------------------------------------------------*/
#define	PX_ATARI1	( PX_PACKED + PX_1COMP + PX_USES1 + PX_1BIT )
#define	PX_ATARI2	( PX_IPLANES + PX_1COMP + PX_USES2 + PX_2BIT )
#define	PX_ATARI4	( PX_IPLANES + PX_1COMP + PX_USES4 + PX_4BIT )
#define	PX_ATARI8	( PX_IPLANES + PX_1COMP + PX_USES8 + PX_8BIT )
#define	PX_FALCON15	( PX_PACKED + PX_3COMP + PX_USES16 + PX_16BIT )

/*----------------------------------------------------------------------------------------*/
/* Pixelformate fuer Macintosh                                                            */
/*----------------------------------------------------------------------------------------*/
#define PX_MAC1     ( PX_PACKED + PX_1COMP + PX_USES1 + PX_1BIT )
#define PX_MAC4     ( PX_PACKED + PX_1COMP + PX_USES4 + PX_4BIT )
#define PX_MAC8     ( PX_PACKED + PX_1COMP + PX_USES8 + PX_8BIT )
#define PX_MAC15    ( PX_xFIRST + PX_PACKED + PX_3COMP + PX_USES15 + PX_16BIT )
#define PX_MAC32    ( PX_xFIRST + PX_PACKED + PX_3COMP + PX_USES24 + PX_32BIT )

/*----------------------------------------------------------------------------------------*/
/* Pixelformate fuer Grafikkarten														  */
/*----------------------------------------------------------------------------------------*/
#define	PX_VGA1		( PX_PACKED + PX_1COMP + PX_USES1 + PX_1BIT )
#define	PX_VGA4		( PX_PLANES + PX_1COMP + PX_USES4 + PX_4BIT )
#define	PX_VGA8		( PX_PACKED + PX_1COMP + PX_USES8 + PX_8BIT )
#define	PX_VGA15	( PX_REVERSED + PX_xFIRST + PX_PACKED + PX_3COMP + PX_USES15 + PX_16BIT )
#define	PX_VGA16	( PX_REVERSED + PX_PACKED + PX_3COMP + PX_USES16 + PX_16BIT )
#define	PX_VGA24	( PX_REVERSED + PX_PACKED + PX_3COMP + PX_USES24 + PX_24BIT )
#define	PX_VGA32	( PX_REVERSED + PX_xFIRST + PX_PACKED + PX_3COMP + PX_USES24 + PX_32BIT )

#define	PX_MATRIX16	( PX_PACKED + PX_3COMP + PX_USES16 + PX_16BIT )

#define	PX_NOVA32	( PX_PACKED + PX_3COMP + PX_USES24 + PX_32BIT )

/*----------------------------------------------------------------------------------------*/
/* Pixelformate fuer Drucker                                                              */
/*----------------------------------------------------------------------------------------*/
#define PX_PRN1     ( PX_PACKED + PX_1COMP + PX_USES1 + PX_1BIT )
#define PX_PRN8     ( PX_PACKED + PX_1COMP + PX_USES8 + PX_8BIT )
#define PX_PRN32    ( PX_xFIRST + PX_PACKED + PX_3COMP + PX_USES24 + PX_32BIT )

/*----------------------------------------------------------------------------------------*/
/* bevorzugte (schnelle) Pixelformate fuer Bitmaps                                        */
/*----------------------------------------------------------------------------------------*/

#define PX_PREF1    ( PX_PACKED + PX_1COMP + PX_USES1 + PX_1BIT )
#define PX_PREF2    ( PX_PACKED + PX_1COMP + PX_USES2 + PX_2BIT )
#define PX_PREF4    ( PX_PACKED + PX_1COMP + PX_USES4 + PX_4BIT )
#define PX_PREF8    ( PX_PACKED + PX_1COMP + PX_USES8 + PX_8BIT )
#define PX_PREF15   ( PX_xFIRST + PX_PACKED + PX_3COMP + PX_USES15 + PX_16BIT )
#define PX_PREF32   ( PX_xFIRST + PX_PACKED + PX_3COMP + PX_USES24 + PX_32BIT )

/*----------------------------------------------------------------------------------------*/
/* Farbtabellen                                                                           */
/*----------------------------------------------------------------------------------------*/

#define CSPACE_UNKNOWN  0x0000
#define CSPACE_RGB      0x0001

#define CSPACE_1COMPONENT	0x0001
#define SPACE_2COMPONENTS	0x0002
#define CSPACE_3COMPONENTS	0x0003
#define CSPACE_4COMPONENTS	0x0004

typedef struct
{
	_UWORD	reserved;
	_UWORD	red;
	_UWORD	green;
	_UWORD	blue;
} COLOR_RGB;

typedef struct
{
	_UWORD	cyan;
	_UWORD	magenta;
	_UWORD	yellow;
	_UWORD	black;
} COLOR_CMYK;

typedef union
{
	COLOR_RGB	rgb;
	COLOR_CMYK	cmyk;
} COLOR_ENTRY;

#define	COLOR_TAB_MAGIC	CHAR_CONST32('ctab')

typedef struct												/* Farbtabelle */
{
	_LONG	magic;											/* 'ctab' */
	_LONG	length;
	_LONG	format;											/* Format (0) */
	_LONG	reserved;
	
	_LONG	map_id;											/* Kennung der Farbtabelle */
	_LONG	color_space;									/* Farbraum */
	_LONG	flags;											/* interne Flags */
	_LONG	no_colors;										/* Anzahl der Farbeintraege */

	_LONG	reserved1;
	_LONG	reserved2;
	_LONG	reserved3;
	_LONG	reserved4;

	COLOR_ENTRY	colors[VARIABLE_ARRAY_SIZE];
} COLOR_TAB;

#define	sizeof_COLOR_TAB	offsetof( COLOR_TAB, colors )	/* Strukturlaenge ohne variablen Anhang */

/* vordefinierte Tabelle mit 256 Eintraegen */
typedef struct												/* Farbtabelle */
{
	_LONG	magic;											/* 'ctab' */
	_LONG	length;
	_LONG	format;											/* Format (0) */
	_LONG	reserved;
	
	_LONG	map_id;											/* Kennung der Farbtabelle */
	_LONG	color_space;									/* Farbraum */
	_LONG	flags;											/* interne Flags */
	_LONG	no_colors;										/* Anzahl der Farbeintraege */

	_LONG	reserved1;
	_LONG	reserved2;
	_LONG	reserved3;
	_LONG	reserved4;

	COLOR_ENTRY	colors[256];
} COLOR_TAB256;

typedef	void	INVERSE_CTAB;								/* der Aufbau ist nicht von Bedeutung */

/*----------------------------------------------------------------------------------------*/
/* Verweise auf Farbtabellen                                                              */
/*----------------------------------------------------------------------------------------*/

#if	REFS_ARE_PTRS											/* Zeiger verweisen auf Farbtabellen */
typedef COLOR_TAB		*CTAB_PTR;
typedef COLOR_TAB		*CTAB_REF;
typedef INVERSE_CTAB	*ITAB_REF;
#endif


/*----------------------------------------------------------------------------------------*/
/*  Bitmaps                                                                               */
/*----------------------------------------------------------------------------------------*/

#define	CBITMAP_MAGIC	CHAR_CONST32('cbtm')

typedef struct	_gcbitmap									/* Oeffentliche Bitmapbeschreibung (mit Versionsheader) */
{
	_LONG		magic;										/* Strukturkennung 'cbtm' */
	_LONG		length;										/* Strukturlaenge */
	_LONG		format;										/* Strukturformat (0) */
	_LONG		reserved;									/* reserviert (0) */

	_UBYTE		*addr;										/* Adresse der Bitmap */
	_LONG		width;										/* Breite einer Zeile in Bytes */
	_LONG		bits;										/* Bittiefe */
	_ULONG		px_format;									/* Pixelformat */

	_LONG		xmin;										/* minimale diskrete x-Koordinate der Bitmap */
	_LONG		ymin;										/* minimale diskrete y-Koordinate der Bitmap */
	_LONG		xmax;										/* maximale diskrete x-Koordinate der Bitmap + 1 */
	_LONG		ymax;										/* maximale diskrete y-Koordinate der Bitmap + 1 */

	CTAB_REF	ctab;										/* Verweis auf die Farbtabelle oder 0L */
	ITAB_REF	itab;										/* Verweis auf die inverse Farbtabelle oder 0L */
	_LONG		reserved0;									/* reserviert (0) */
	_LONG		reserved1;									/* reserviert (0) */
} GCBITMAP;

#endif /* __COLORMAP__ */


/*----------------------------------------------------------------------------------------*/
/* Transfermodi fuer Bitmaps                                                              */
/*----------------------------------------------------------------------------------------*/

/* Moduskonstanten */
#define	T_NOT				4								/* Konstante fuer Invertierung bei logischen Transfermodi */
#define	T_COLORIZE			16								/* Konstante fuer Einfaerbung */

#define	T_LOGIC_MODE		0
#define	T_DRAW_MODE			32
#define	T_ARITH_MODE		64								/* Konstante fuer Arithmetische Transfermodi */
#define	T_DITHER_MODE		128								/* Konstante fuers Dithern */

/* logische Transfermodi */
#define	T_LOGIC_COPY		T_LOGIC_MODE+0
#define	T_LOGIC_OR			T_LOGIC_MODE+1
#define	T_LOGIC_XOR			T_LOGIC_MODE+2
#define	T_LOGIC_AND			T_LOGIC_MODE+3
#define	T_LOGIC_NOT_COPY	T_LOGIC_MODE+4
#define	T_LOGIC_NOT_OR		T_LOGIC_MODE+5
#define	T_LOGIC_NOT_XOR		T_LOGIC_MODE+6
#define	T_LOGIC_NOT_AND		T_LOGIC_MODE+7

/* Zeichenmodi */
#define	T_REPLACE				T_DRAW_MODE+0
#define	T_TRANSPARENT			T_DRAW_MODE+1
#define	T_HILITE				T_DRAW_MODE+2
#define	T_REVERS_TRANSPARENT	T_DRAW_MODE+3

/* arithmetische Transfermodi */
#define	T_BLEND				T_ARITH_MODE+0
#define	T_ADD				T_ARITH_MODE+1
#define	T_ADD_OVER			T_ARITH_MODE+2
#define	T_SUB				T_ARITH_MODE+3
#define	T_MAX				T_ARITH_MODE+5
#define	T_SUB_OVER			T_ARITH_MODE+6
#define	T_MIN				T_ARITH_MODE+7

/*----------------------------------------------------------------------------------------*/
/* Strukturen                                                                             */
/*----------------------------------------------------------------------------------------*/

typedef struct												/* Punkt fuer 16-Bit-Koordinaten */
{
	_WORD	x;
	_WORD	y;
} POINT16;

typedef struct												/* Punkt fuer 32-Bit-Koordinaten */
{
	_LONG	x;
	_LONG	y;
} POINT;

typedef struct												/* Rechteck fuer 16-Bit-Koordinaten */
{
	_WORD	x1;
	_WORD	y1;
	_WORD	x2;
	_WORD	y2;
} RECT16;

typedef struct												/* Rechteck fuer 32-Bit-Koordinaten */
{
	_LONG	x1;
	_LONG	y1;
	_LONG	x2;
	_LONG	y2;
} RECT32;

typedef struct
{
	_LONG	size;				/* Laenge der Struktur, mu vor vqt_xfntinfo() gesetzt werden */
	_WORD	format;				/* Fontformat, z.B. 4 fuer TrueType */
	_WORD	id;					/* Font-ID, z.B. 6059 */
	_WORD	index;				/* Index */
	_UBYTE	font_name[50];		/* vollstaendiger Fontname, z.B. "Century 725 Italic BT" */
	_UBYTE	family_name[50];	/* Name der Fontfamilie, z.B. "Century725 BT" */
	_UBYTE	style_name[50];		/* Name des Fontstils, z.B. "Italic" */
	_UBYTE	file_name1[200];	/* Name der 1. Fontdatei, z.B. "C:\FONTS\TT1059M_.TTF" */
	_UBYTE	file_name2[200];	/* Name der optionalen 2. Fontdatei */
	_UBYTE	file_name3[200];	/* Name der optionalen 3. Fontdatei */
	_WORD	pt_cnt;				/* Anzahl der Punkthoehen fuer vst_point(), z.B. 10 */
	_WORD	pt_sizes[64];		/* verfuegbare Punkthoehen, z.B. { 8, 9, 10, 11, 12, 14, 18, 24, 36, 48 } */
} XFNT_INFO;

/*----------------------------------------------------------------------------------------*/
/* Funktionsdeklarationen                                                                 */
/*----------------------------------------------------------------------------------------*/

extern _WORD	v_opnprn( _WORD base_handle, PRN_SETTINGS *settings, _WORD *work_out );
extern void		v_opnbm( _WORD *work_in, MFDB *bitmap, _WORD *handle, _WORD *work_out );
extern _WORD	v_resize_bm( _WORD handle, _WORD width, _WORD height, _LONG byte_width, _UBYTE *addr );
extern _WORD	v_open_bm( _WORD base_handle, GCBITMAP *bitmap, 
								  _WORD color_flags, _WORD unit_flags, _WORD pixel_width, _WORD pixel_height );
extern void		v_clsbm( _WORD handle );
#define	v_close_bm( handle )	v_clsbm( handle )
extern void		vq_scrninfo( _WORD handle, _WORD *work_out );
extern _WORD	vq_ext_devinfo( _WORD handle, _WORD id, _WORD *exists, _UBYTE *file_path, _UBYTE *file_name, _UBYTE *name );

extern void	_v_bez( _WORD handle, _WORD count, _WORD *xy, _UBYTE *bezarr,
						  _WORD *extent, _WORD *totpts, _WORD *totmoves );
extern void	_v_bez_fill( _WORD handle, _WORD count, _WORD *xy, _UBYTE *bezarr,
								 _WORD *extent, _WORD *totpts, _WORD *totmoves );

extern void		v_ftext_wide( _WORD handle, _WORD x, _WORD y, _UWORD *string );
extern _WORD	vst_map_mode( _WORD handle, _WORD mode );
extern void		vst_width( _WORD handle, _WORD width, _WORD *char_width, _WORD *char_height,
								  _WORD *cell_width, _WORD *cell_height );
extern void		vst_track_offset( _WORD handle, fix31 offset, _WORD pair_mode, _WORD *tracks, _WORD *pairs );
extern _WORD	vst_name( _WORD handle, _WORD font_format, _UBYTE *font_name, _UBYTE *ret_name );

extern _UWORD	vqt_char_index( _WORD handle, _UWORD src_index, _WORD src_mode, _WORD dst_mode );
extern _WORD	vqt_ext_name( _WORD handle, _WORD index, _UBYTE *name, _UWORD *font_format, _UWORD *flags );
extern _WORD	v_get_outline( _WORD handle, _UWORD index, _WORD x_offset, _WORD y_offset,
										_WORD *pts, _UBYTE *flags, _WORD max_pts );
extern _WORD	vqt_xfntinfo( _WORD handle, _WORD flags, _WORD id, _WORD index, XFNT_INFO *info );
extern void		vqt_extent_wide( _WORD handle, _UWORD *string, _WORD *extent );
extern void		vqt_real_extent( _WORD handle, _WORD x, _WORD y, _UBYTE *string, _WORD *extent );
extern void		vqt_real_extent_wide( _WORD handle, _WORD x, _WORD y, _UWORD *string, _WORD *extent );
extern _WORD	vqt_name_and_id( _WORD handle, _WORD font_format, _UBYTE *font_name, _UBYTE *ret_name );

/* Vordergrundfarbe kompatibel zu GEM/3-Metafiles setzen */
extern void	v_setrgb( _WORD handle, _WORD type, _WORD r, _WORD g, _WORD b );

/* Vordergrundfarbe setzen */
extern _WORD	vst_fg_color( _WORD handle, _LONG color_space, COLOR_ENTRY *fg_color );
extern _WORD	vsf_fg_color( _WORD handle, _LONG color_space, COLOR_ENTRY *fg_color );
extern _WORD	vsl_fg_color( _WORD handle, _LONG color_space, COLOR_ENTRY *fg_color );
extern _WORD	vsm_fg_color( _WORD handle, _LONG color_space, COLOR_ENTRY *fg_color );
extern _WORD	vsr_fg_color( _WORD handle, _LONG color_space, COLOR_ENTRY *fg_color );

/* Hintergrundfarbe setzen */
extern _WORD	vst_bg_color( _WORD handle, _LONG color_space, COLOR_ENTRY *bg_color );
extern _WORD	vsf_bg_color( _WORD handle, _LONG color_space, COLOR_ENTRY *bg_color );
extern _WORD	vsl_bg_color( _WORD handle, _LONG color_space, COLOR_ENTRY *bg_color );
extern _WORD	vsm_bg_color( _WORD handle, _LONG color_space, COLOR_ENTRY *bg_color );
extern _WORD	vsr_bg_color( _WORD handle, _LONG color_space, COLOR_ENTRY *bg_color );


/* Vordergrundfarbe erfragen */
extern _LONG	vqt_fg_color( _WORD handle, COLOR_ENTRY *fg_color );
extern _LONG	vqf_fg_color( _WORD handle, COLOR_ENTRY *fg_color );
extern _LONG	vql_fg_color( _WORD handle, COLOR_ENTRY *fg_color );
extern _LONG	vqm_fg_color( _WORD handle, COLOR_ENTRY *fg_color );
extern _LONG	vqr_fg_color( _WORD handle, COLOR_ENTRY *fg_color );

/* Hintergrundfarbe erfragen */
extern _LONG	vqt_bg_color( _WORD handle, COLOR_ENTRY *bg_color );
extern _LONG	vqf_bg_color( _WORD handle, COLOR_ENTRY *bg_color );
extern _LONG	vql_bg_color( _WORD handle, COLOR_ENTRY *bg_color );
extern _LONG	vqm_bg_color( _WORD handle, COLOR_ENTRY *bg_color );
extern _LONG	vqr_bg_color( _WORD handle, COLOR_ENTRY *bg_color );

/* diverse Modi parametrisieren */
extern _WORD	vs_hilite_color( _WORD handle, _LONG color_space, COLOR_ENTRY *hilite_color );
extern _WORD	vs_min_color( _WORD handle, _LONG color_space, COLOR_ENTRY *min_color );
extern _WORD	vs_max_color( _WORD handle, _LONG color_space, COLOR_ENTRY *max_color );
extern _WORD	vs_weight_color( _WORD handle, _LONG color_space, COLOR_ENTRY *weight_color );

extern _LONG	vq_hilite_color( _WORD handle, COLOR_ENTRY *hilite_color );
extern _LONG	vq_min_color( _WORD handle, COLOR_ENTRY *min_color );
extern _LONG	vq_max_color( _WORD handle, COLOR_ENTRY *max_color );
extern _LONG	vq_weight_color( _WORD handle, COLOR_ENTRY *weight_color );

/* Farben erfragen */
extern _ULONG	v_color2value( _WORD handle, _LONG color_space, COLOR_ENTRY *color );
extern _LONG	v_value2color( _WORD handle, _ULONG value, COLOR_ENTRY *color );
extern _LONG	v_color2nearest( _WORD handle, _LONG color_space, COLOR_ENTRY *color, COLOR_ENTRY *nearest_color );
extern _LONG	vq_px_format( _WORD handle, _ULONG *px_format );


/* Farbtabellen */
extern _WORD	vs_ctab( _WORD handle, COLOR_TAB *ctab );
extern _WORD	vs_ctab_entry( _WORD handle, _WORD index, _LONG color_space, COLOR_ENTRY *color );
extern _WORD	vs_dflt_ctab( _WORD handle );

extern _WORD	vq_ctab( _WORD handle, _LONG ctab_length, COLOR_TAB *ctab );
extern _LONG	vq_ctab_entry( _WORD handle, _WORD index, COLOR_ENTRY *color );
extern _LONG	vq_ctab_id( _WORD handle );
extern _WORD	v_ctab_idx2vdi( _WORD handle, _WORD index );
extern _WORD	v_ctab_vdi2idx( _WORD handle, _WORD vdi_index );
extern _ULONG	v_ctab_idx2value( _WORD handle, _WORD index );
extern _LONG	v_get_ctab_id( _WORD handle );
extern _WORD	vq_dflt_ctab( _WORD handle, _LONG ctab_length, COLOR_TAB *ctab );
extern COLOR_TAB	*v_create_ctab( _WORD handle, _LONG color_space, _ULONG px_format );
extern _WORD	v_delete_ctab( _WORD handle, COLOR_TAB *ctab );

/* inverse Farbtabellen */
extern ITAB_REF	v_create_itab( _WORD handle, COLOR_TAB *ctab, _WORD bits );
extern _WORD	v_delete_itab( _WORD handle, ITAB_REF itab );


/* Bitmapausgabe */
extern void	vr_transfer_bits( _WORD handle, GCBITMAP *src_bm, GCBITMAP *dst_bm,
										RECT16 *src_rect, RECT16 *dst_rect,
										_WORD mode );

/* Clipping von Rechtecken fuer (skalierte) Bitmapausgabe */
extern _WORD	vr_clip_rects_by_src( _WORD handle, RECT16 *src_clip_rect, RECT16 *src_rect, RECT16 *dst_rect, RECT16 *clipped_src_rect, RECT16 *clipped_dst_rect );
extern _WORD	vr_clip_rects_by_dst( _WORD handle, RECT16 *dst_clip_rect, RECT16 *src_rect, RECT16 *dst_rect, RECT16 *clipped_src_rect, RECT16 *clipped_dst_rect );
extern _WORD	vr_clip_rects32_by_dst( _WORD handle, RECT32 *dst_clip_rect, RECT32 *src_rect, RECT32 *dst_rect, RECT32 *clipped_src_rect, RECT32 *clipped_dst_rect );
extern _WORD	vr_clip_rects32_by_src( _WORD handle, RECT32 *src_clip_rect, RECT32 *src_rect, RECT32 *dst_rect, RECT32 *clipped_src_rect, RECT32 *clipped_dst_rect );


/* Schnitt, Gleichheit von Rechtecken */
extern _WORD	v_sect_rects( RECT16 *a, RECT16 *b, RECT16 *dst );
extern _WORD	v_sect_rects32( RECT32 *a, RECT32 *b, RECT32 *dst );
extern void		v_merge_rects( RECT16 *a, RECT16 *b, RECT16 *dst );
extern void		v_merge_rects32( RECT32 *a, RECT32 *b, RECT32 *dst );
extern void		v_move_rect( _WORD dx, _WORD dy, RECT16 *a, RECT16 *dst );
extern void		v_move_rect32( _LONG dx, _LONG dy, RECT32 *a, RECT32 *dst );
extern _WORD	v_equal_rects( RECT16 *a, RECT16 *b );
extern _WORD	v_equal_rects32( RECT32 *a, RECT32 *b );
extern _WORD	v_pt_in_rect( PO_WORD *p, RECT16 *r );
extern _WORD	v_pt_in_rect32( PO_LONG *p, RECT32 *r );


/* Drucker */
extern _WORD	v_orient( _WORD handle, _WORD orientation );
extern _WORD	v_copies( _WORD vdi_handle, _WORD copies );
extern fixed	vq_prn_scaling( _WORD handle );
extern _WORD	vq_margins( _WORD handle, _WORD *top_margin, _WORD *bottom_margin, _WORD *left_margin, _WORD *right_margin, _WORD *hdpi, _WORD *vdpi );
extern _WORD	vs_document_info( _WORD handle, _WORD type, void *s, _WORD wchar );

#endif
