#ifndef __CAT_WIEDERVORLAGEL_H__
#define __CAT_WIEDERVORLAGEL_H__
/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */


#ifndef __PORTAB_H__
#include <portab.h>
#endif
#ifndef __DATA_H__
#include <data.h>
#endif

#include <convertd.h>

enum {	WVL,		/* Aufrufmodus Wiedervorlage */
		CMTS};		/* Aufrufmodus Kommentare auf eigene Mitteilungen */

/* Magics fuer Header */
#define resubCatMagic     0x43415457L  /* "CATW"                           */
#define resubVersion      1            /* Versionsnummer der Wiedervorlage */
#define resubVersionMagic 0x0100       /* Versionsmagic                    */

_BOOL WiederVorlage_SaveResubList(_WORD modus);
/* Liste der Eintraege mit Wiedervorlage sichern
 */


/*----------------*/
typedef struct {
	_UBYTE *group;
	_UBYTE *msgId;
	_UBYTE *from;
	_UBYTE *topic;
	Date date;
	Time time;
	Date resubDate;
	_BOOL selected;
	size_t dataLength;
	_UBYTE *data;
} resubRec;

EXTERN _BOOL listModified;
EXTERN resubRec *resubArray;
EXTERN _ULONG resubs;            /* aktueller Index in Array */
EXTERN _ULONG currIdx;
EXTERN _WORD globalLength;
EXTERN _WORD whichType;



_VOID SortResubs(_WORD modus);
_VOID DeleteEntry(_ULONG idx);
_BOOL isSelected(_VOID *entry, _VOID *env);
_VOID BuildLine1(resubRec *pResub, _UBYTE *str, size_t strsize);
_VOID BuildLine2(resubRec *pResub, _UBYTE *str, size_t strsize);
_VOID freeResubArray(_VOID);
_VOID *PrevEntry(_VOID *l);
_VOID CountEntries(_VOID *l, _LONG *ll, _WORD *ww);
_BOOL isEnabled(_VOID *entry, _VOID *env);
_VOID resubToStr(_VOID *entry, _VOID *env, _UBYTE *str, size_t strsize);
_BOOL selEntry(_VOID *entry, _VOID *env, _WORD line);
_BOOL MakeEntry(resubRec *rs,
	CONST _UBYTE *gName,
	CONST _UBYTE *mId,
	CONST _UBYTE *fromL,
	CONST _UBYTE *topicL,
	CONST Date *dt,
	CONST Time *ti,
	CONST Date *resubDt);
_BOOL MakeNewResubArray(_BOOL force, _ULONG new);
_BOOL SaveDataEntry(resubRec *rs, FILENO fHdl);

CONST _UBYTE *getMsgIDofCurr(_VOID);
_VOID ResetResubs(_VOID *l);
_VOID *NextEntry(_VOID *l);

_UBYTE **WV_getMsgIDs(_LONG *anz);

#endif /* __CAT_WIEDERVORLAGEL_H__ */
