/*****************************************************************************
 *		TOS/XACC.H
 *****************************************************************************/

#ifndef __XACC_H__
#define __XACC_H__

#ifndef __PORTAB_H__
#include <portab.h>
#endif

#define ACC_ID		0x0400
#define ACC_OPEN	0x0401
#define ACC_CLOSE	0x0402
#define ACC_ACC		0x0403
#define ACC_EXIT	0x0404

#define ACC_ACK		0x0500
#define ACC_TEXT	0x0501
#define ACC_KEY		0x0502

#define ACC_META	0x0503
#define ACC_IMG		0x0504

EXTERN _WORD app_version;

typedef _BOOL (*XaccKeyMsg)(CONST _WORD *pBuff, _WORD kReturn, _UWORD moKstate);
typedef _BOOL (*XaccTextMsg)(CONST _WORD *pBuff, _UBYTE *pName);

_VOID Xacc_Init(CONST _UBYTE *appName, size_t len);
_VOID Xacc_SendTerminate(_BOOL terminate);

_VOID Xacc_SendAcknowledge(_WORD apId, _BOOL succ);
/* dem Acc mitteilen, das ACC_TEXT oder ACC_KEY geklappt haben */

_VOID Xacc_SendTextReady(_VOID);
/* not yet implementet, fuer xAcc-Protokoll, senden, sobald der Text uebernommen ist */

_VOID Xacc_Register_Key(XaccKeyMsg func);
_VOID Xacc_Register_Text(XaccTextMsg func);

EXTERN _BOOL xacc_proto_init(_VOID);
EXTERN _WORD xacc_send_text(_UBYTE *text, _WORD mode);
EXTERN _VOID xacc_send_ack(_WORD apid, _WORD ack);

#endif /* __XACC_H__ */
