/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */


#include <fontsele.h>
#include <magictyp.h>
#include <portaes.h>
#include <mtappl.h>
#include <mtalerts.h>
#include <mtrsc.h>
#include <mtutils.h>
#include <mtdials.h>
#include <mtxobjec.h>
#include <convert.h>
#include <strconv.h>
#include <portvdi.h>
#include <rectfunc.h>
#include <listdl.h>
#include <windials.h>
#include <ro_mem.h>
#include <limits.h>
#include <routinec.h>
#include <termproc.h>
#include <routines.h>
#include <catlib.h>
LOCAL _UBYTE RscData[] = {
#include <fontbox.inc>
};
#include <fontbox.h>

_BOOL (*fnts_func)(_BOOL get_event, _VOID *e);

#define SysFontName  "Systemfont"

/* Datenstrukturen: 
 * fontList == Liste der Fontlisten :-)
 * In einem Eintrag Liste der Fonts
 */
struct _fonts;
typedef struct _fonts FontEntry, *Fonts;
struct _fonts {
	tFontinfo info;
	Fonts next;
	Fonts prev;
	_BOOL infoSet;
	_BOOL sel;
};

struct _fontlist;
typedef struct _fontlist FontList, *FONTList;
struct _fontlist {
	Fonts fonts;
	Fonts dummy;
	_WORD numFonts;
	_WORD handle;
	_WORD active;
	_WORD actSize;
	FONTList next;
};

struct _sizeentry;
typedef struct _sizeentry SizeEntry, *SizePtr;
struct _sizeentry {
	_WORD size;
	_BOOL sel;
	SizePtr next;
	SizePtr prev;
};

typedef struct _sizes {
	SizePtr root;
	SizePtr curr;
	_UWORD count;
} Sizes;

typedef struct _fontenv {
	_WORD handle;
	_BOOL monos;
	OBJECT *tree;
	_WORD size;
	_WORD fontWidth;
	_WORD sizeWidth;
	FONTList fl;
} fontEnv;

typedef struct {
	DIAL fontDial;
	DIAL sizeDial;
	ldHandler fontHandler;
	ldHandler sizeHandler;
	Sizes sizeList;
	_WORD oldSize;
	_WORD oldId;
	_WORD fontId;
	_WORD fontSize;
	_WORD exitBut;
	_WORD handle;
	fontEnv env;
	FONTList fl;
	_BOOL terminate;
	_WORD currFont;
} FontSelType, *FONTSEL;


LOCAL FONTList fontList;     /* Die Liste der Fonts */
LOCAL OBJECT *fontBox;       /* Baumadresse fuer FONTBOX_DIALOG */
LOCAL OBJECT *fontText;      /* Baumadresse fuer Anzeigestring */
LOCAL RESOURCE rsc;



#define spaceString "          "
#define demoText    "The quick brown fox jumps over the lazy dog"

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

LOCAL Fonts FindFont(FONTList fl, _WORD font)
{
	Fonts f;
	
	f = fl->fonts;
	while (f != NULL && f->info.id != font)
		f = f->next;
	return f;
}

/*** ---------------------------------------------------------------------- ***/

/* Interne Prozedur fuer SortFonts */
LOCAL Fonts ZipSort(Fonts list, _UWORD nodes)
{
	Fonts list1, list2;
	_UWORD I;
	Fonts result, last1;
	_UWORD nodes2;
	
	if (list == NULL || nodes <= 1)
		return list;
	/* Liste in etwa gleich grosse Teile aufteilen: */
	/* list1 erhaelt nodes DIV 2; list2 den rest */
	list1 = list;
	list2 = list;
	nodes2 = nodes >> 1;
	
	last1 = list2;
	for (I = 0; I < nodes2; I++)
	{
		last1 = list2;
		list2 = list2->next;
	}
	last1->next = NULL;		/* Listen auseinanderschneiden */
	/* list1 und list2 enthalten garantiert mindestens 1 Element */
	
	/* Einzellisten Sortieren */
	list1 = ZipSort(list1, nodes2);
	list2 = ZipSort(list2, nodes - nodes2);
	
	/* Jetzt kommts: */
	/* Erstes Listenelement festlegen: */
	/* Die folgende IF-Bedingung macht das selbe wie die Zeile
	 * >IF Strings.Compare (list2^.info.name, list1^.info.name)=Strings.less THEN
	 * Ist aber statistisch wesentlich schneller.
	 * Die IF-Bedingung benoetigt sonst mehr Rechenzeit als alle anderen
	 * Befehle zusammen.
	 */
	if (list2->info.name[0] < list1->info.name[0] ||
		strCmp(list2->info.name, list1->info.name) < 0)
	{
		list = list2;
		list2 = list2->next;
	} else
	{
		list = list1;
		list1 = list1->next;
	}
	result = last1 = list;
	
	for (;;)
	{
		if (list1 == NULL)
		{
			result->next = list2;
			break;
		}
		if (list2 == NULL)
		{
			result->next = list1;
			break;
		}
		if (list2->info.name[0] < list1->info.name[0] ||
			strCmp(list2->info.name, list1->info.name) < 0)
		{
			result->next = list2;
			list2 = list2->next;
		} else
		{
			result->next = list1;
			list1 = list1->next;
		}
		result = result->next;
	}
	return last1;
}

/*** ---------------------------------------------------------------------- ***/

/* Sortiert die zu handle gehoerigen Fonts nach dem Namen */
LOCAL _VOID SortFonts(FONTList fl)
{
	Fonts font;
	Fonts prev;

	/* Liste als einfach verkettete Liste interpretieren und sortieren: */
	fl->fonts = ZipSort(fl->fonts, fl->numFonts);
	
	/* Zerstoerte Rueckwaertsverkettung restaurieren: */
	font = fl->fonts;
	prev = NULL;
	while (font != NULL)
	{
		font->prev = prev;
		prev = font;
		font = font->next;
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL FONTList GetFontList(_WORD handle)
{
	FONTList fl, f1;
	Fonts font;
	_WORD num;
	_WORD vi;
	_WORD wo[61];
	_WORD fsm;
	
	fl = fontList;
	while (fl != NULL && fl->handle != handle)
		fl = fl->next;
	if (fl == NULL)
	{
		/* Noch keine Fontliste mit diesem Handle vorhanden,
		 * also neu eintragen! 
		 */
		/* Extended Inquire, um die Anzahl der Systemfonts rauszubekommen */
		vq_extnd(handle, 0, wo);
		fl = NEW(FontList, "GetFontList: list");
		if (fl == NULL)
			return NULL;
		MemSetZeroStruct(*fl);
		fl->handle = handle;
		if (VqGdos() == GDOS_NONE)
		{
			num = wo[10] - 1;
		} else
		{
			num = vst_load_fonts(handle, 0);
			if (num > 0)
			{
				/* Systemfonts hinzufuegen */
				num = num + wo[10] - 1; 
			} else if (num == -1)
			{
				/* Laden fehlgeschlagen, Systemfonts nehmen */
				num = wo[10] - 1;
			} else
			{
				/* num < -1 oder num == 0, unbekannt */
				num = 0;
			}
		}
		fl->next = NULL;
		fl->fonts = NULL;
		/* Jetzt an fontListe anhaengen */
		if (fontList == NULL)
		{
			fontList = fl;
		} else
		{
			f1 = fontList;
			while (f1->next != NULL)
				f1 = f1->next;
			f1->next = fl;
		}
		/* Jetzt alle Fonts nacheinander in Liste eintragen, aber ohne Infos! */
		fl->numFonts = 0;
		fl->active = 1;
		if (CharHeight == 8)
			fl->actSize = 9;
		else
			fl->actSize = 10;
		vi = 0;
		for (;;)
		{
			if (vi > num)
				break;
			font = NEW(FontEntry, "GetFontList: Entry");
			if (font == NULL)
				return fl;
			MemSetZeroStruct(*font);
			++fl->numFonts;
			font->info.id = vqt_name(handle, vi+1, font->info.name, &fsm);
			font->info.fsm = fsm;
			if (font->info.id == 1)	/* Sonderbehandlung fuer Systemfont */
				strBcpy(font->info.name, SysFontName);  /* Name des Fonts */
			/* Jetzt an Liste anhaengen */
			font->sel = FALSE;
			font->infoSet = FALSE;
			font->next = NULL;
			if (fl->fonts == NULL)
			{
				fl->fonts = font;
				font->prev = NULL;
				fl->dummy = fl->fonts;
			} else
			{
				fl->dummy->next = font;
				font->prev = fl->dummy;
				fl->dummy = font;
			}
			/* Naechsten Font nehmen */
			++vi;
		}
		SortFonts(fl);
	}
	return fl;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL Fonts GetFont(_WORD handle)
{
	FONTList fl;
	
	fl = GetFontList(handle);
	if (fl != NULL)
		return FindFont(fl, fl->active);
	return NULL;
}

/*** ---------------------------------------------------------------------- ***/

/* Loescht die Fonts wieder aus der Liste */
GLOBAL _VOID FontSelect_UnloadFonts(_WORD handle)
{
	FONTList fl, fl2;

	fl = fontList;
	while (fl != NULL && fl->handle != handle)
		fl = fl->next;
	if (fl == NULL)
		return;
	fl->dummy = fl->fonts;
	while (fl->dummy != NULL)
	{
		fl->dummy = fl->dummy->next;
		OFREE(fl->fonts);
		fl->fonts = fl->dummy;
	}
	vst_unload_fonts(handle, 0);
	/* Aus Liste austragen */
	if (fl == fontList)
	{
		fontList = fl->next;
	} else
	{
		fl2 = fontList;
		while (fl2->next != fl)
			fl2 = fl2->next;
		fl2->next = fl->next;
	}
	OFREE(fl); 
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

/* Hilfsprozeduren fuer das Blaettern in der Liste */

/* Es wird die Fontliste uebergeben, so dass ich auch
 * auf die anderen Variablen zugreifen kann
 */
LOCAL _VOID resetFonts(_VOID *l)
{
	FONTList fl;
	
	fl = l;
	if (fl != NULL)
		fl->dummy = NULL;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID *nextFont(_VOID *l)
{
	FONTList fl;
	
	fl = l;
	if (fl != NULL)
	{
		if (fl->dummy == NULL)
			fl->dummy = fl->fonts;
		else
			fl->dummy = fl->dummy->next;
		return fl->dummy;
	}
	return NULL;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID *prevFont(_VOID *l)
{
	FONTList fl;
	
	fl = l;
	if (fl != NULL)
	{
		if (fl->dummy == NULL)
			fl->dummy = fl->fonts;
		else
			fl->dummy = fl->dummy->prev;
		return fl->dummy;
	}
	return NULL;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID fontCount(_VOID *l, _LONG *ll, _WORD *ww)
{
	FONTList fl;
	
	fl = l;
	*ww = 0;
	*ll = 0;
	if (fl != NULL)
		*ll = fl->numFonts;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL fontEnabled(_VOID *entry, _VOID *env)
{
	Fonts font;
	fontEnv *ptrEnv;

	font = entry;
	ptrEnv = env;
	if (!ptrEnv->monos)
		return TRUE;
	if (font != NULL)
		return font->info.mono;
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL fontIsSelected(_VOID *entry, _VOID *env)
{
	Fonts font;

	UNUSED(env);
	font = entry;
	if (font != NULL)
		return font->sel;
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL fontSelected(_VOID *entry, _VOID *env, _WORD line)
{
	Fonts font;

	UNUSED(env);
	UNUSED(line);
	font = entry;
	if (font != NULL)
	{
		/* Feststellen, ob ein anderer selektiert ist */
		if (!font->sel)
			/* Anderen Font deselektieren! */
			font->sel = TRUE;
		else
			font->sel = FALSE;
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID fontToString(_VOID *entry, _VOID *env, _UBYTE *str, size_t strsize)
{
	Fonts font;
	fontEnv *ptrEnv;
	tFontinfo fInfo;
	
	font = entry;
	ptrEnv = env;
	if (font != NULL)
	{
		FontSelect_FontInfo(ptrEnv->handle, font->info.id, &fInfo);
		strMcpy(str, strsize, fInfo.name);
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID dispose_size_list(Sizes *sizeList)
{
	SizePtr aSize;
	
	while (sizeList->root != NULL)
	{
		aSize = sizeList->root;
		sizeList->root = aSize->next;
		OFREE(aSize);
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _WORD buildSizeList(_WORD font, _WORD handle, _WORD fontSize, Sizes *sizeList)
{
	_WORD lastSize, newSize, size, maxsize;
	tFontinfo fInfo;
	SizePtr aSize;
	_WORD dummy;
	
	dispose_size_list(sizeList);
	sizeList->count = 0;
	FontSelect_FontInfo(handle, font, &fInfo);
	size = fInfo.point;
	maxsize  = fInfo.maxsize;
	if (fontSize == -1)
		fontSize = size;
	if (maxsize < SHRT_MAX)
		lastSize = maxsize + 1;
	else
		lastSize = maxsize;
	vst_font(handle, font);
	for (;;)
	{
		newSize = vst_point(handle, lastSize - 1, &dummy, &dummy, &dummy, &dummy);
		if (newSize == lastSize)
			break;
		aSize = NEW(SizeEntry, "buildSizeList");
		if (aSize == NULL)
			break;
		++sizeList->count;
		aSize->size = newSize;
		aSize->sel = aSize->size == fontSize;
		aSize->prev = NULL;
		if (sizeList->root == NULL)
		{
			sizeList->root = aSize;
			aSize->next = NULL;
		} else
		{
			/* Am Anfang einhaengen */
			aSize->next = sizeList->root;
			sizeList->root->prev = aSize;
			sizeList->root = aSize;
		}
		lastSize = newSize;
	}
	sizeList->curr = sizeList->root;
	vst_point(handle, size, &dummy, &dummy, &dummy, &dummy);
	return size;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID resetSize(_VOID *l)
{
	Sizes *sp = l;
	
	if (sp != NULL)
		sp->curr = NULL;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID *nextSize(_VOID *l)
{
	Sizes *sp = l;
	
	if (sp != NULL)
	{
		if (sp->curr == NULL)
			sp->curr = sp->root;
		else
			sp->curr = sp->curr->next;
		return sp->curr;
	}
	return NULL;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID *prevSize(_VOID *l)
{
	Sizes *sp = l;
	
	if (sp != NULL)
	{
		if (sp->curr == NULL)
			sp->curr = sp->root;
		else
			sp->curr = sp->curr->prev;
		return sp->curr;
	}
	return NULL;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID sizeCount(_VOID *l, _LONG *ll, _WORD *ww)
{
	Sizes *sp = l;
	
	*ww = 0;
	*ll = 0;
	if (sp != NULL)
		*ll = sp->count;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL sizeEnabled(_VOID *entry, _VOID *env)
{
	UNUSED(entry);
	UNUSED(env);
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL sizeIsSelected(_VOID *entry, _VOID *env)
{
	SizePtr size = entry;
	
	UNUSED(env);
	if (size != NULL)
		return size->sel;
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL sizeSelected(_VOID *entry, _VOID *env, _WORD line)
{
	SizePtr size = entry;
	fontEnv *ptrEnv = env;
	
	UNUSED(line);
	if (size != NULL)
	{
		if (!size->sel)
			size->sel = TRUE;
		else
			size->sel = FALSE;
		ptrEnv->size = size->size;
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID sizeToString(_VOID *entry, _VOID *env, _UBYTE *str, size_t strsize)
{
	SizePtr size = entry;
	
	UNUSED(env);
	if (size != NULL)
		IntToStr(size->size, 3, str, strsize);
	else
		*str = '\0';
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID fontDrawEntry(_VOID *entry, _VOID *env, _WORD x, _WORD y, _WORD offset, CONST GRECT *clip)
{
	_UBYTE str[256];
	fontEnv *ptrEnv;
	
	UNUSED(offset);
	*str = '\0';
	ptrEnv = env;
	fontToString(entry, env, str, sizeof(str));
	SetObjcString(fontText, 0, str);
	fontText[0].ob_x = x;
	fontText[0].ob_y = y;
	fontText[0].ob_width = ptrEnv->fontWidth;
	
	if (entry != NULL)
	{
		EnableObjState(fontText, 0, SELECTED, fontIsSelected(entry, env));
		EnableObjState(fontText, 0, DISABLED, !fontEnabled(entry, env));
	} else
	{
		EnableObjState(fontText, 0, SELECTED, FALSE);
		EnableObjState(fontText, 0, DISABLED, FALSE);
	}
	Objc_draw(fontText, ROOT, MAX_DEPTH, clip);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID sizeDrawEntry(_VOID *entry, _VOID *env, _WORD x, _WORD y, _WORD offset, CONST GRECT *clip)
{
	_UBYTE str[256];
	fontEnv *ptrEnv;
	
	UNUSED(offset);
	*str = '\0';
	ptrEnv = env;
	sizeToString(entry, env, str + 1, sizeof(str) - 1);
	str[0] = ' ';
	SetObjcString(fontText, 0, str);
	fontText[0].ob_x = x;
	fontText[0].ob_y = y;
	fontText[0].ob_width = ptrEnv->sizeWidth;
	
	if (entry != NULL)
	{
		EnableObjState(fontText, 0, SELECTED, sizeIsSelected(entry, env));
		EnableObjState(fontText, 0, DISABLED, !sizeEnabled(entry, env));
	} else
	{
		EnableObjState(fontText, 0, SELECTED, FALSE);
		EnableObjState(fontText, 0, DISABLED, FALSE);
	}
	Objc_draw(fontText, ROOT, MAX_DEPTH, clip);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL struct {
	_WORD handle;
	_BOOL fsm;
	_WORD font, size;
	_BOOL orgFsm;
	_WORD orgFont, orgSize;
} userDraw;


LOCAL _UWORD _CDECL drawText(PARMBLK *para)
{
	OBJECT *objctree;
	_WORD parent;
	GRECT clip, draw;
	_WORD dummy;
	
	objctree = para->pb_tree;	/* Beim Aufruf der Draw-Prozedur bekommt
								 * man nur eine Adresse uebergeben 
								 */
	/* Jetzt an den Objectkoordinaten einen String zeichnen */
	parent = ObjcParent(objctree, para->pb_obj);
	ObjcArea(objctree, parent, &clip);
	clip.g_x += 1;
	clip.g_y += 1;
	clip.g_w -= 1;
	clip.g_h -= 1;
	draw.g_x = para->pb_xc;
	draw.g_y = para->pb_yc;
	draw.g_w = para->pb_wc;
	draw.g_h = para->pb_hc;
	draw = rc_clip(&clip, &draw);
	/* Fuer VDI umwandeln */
	AbsRect(&draw);
	AbsRect(&clip);
	vs_clip(userDraw.handle, TRUE, (_WORD *)&draw);
	vr_recfl(userDraw.handle, (_WORD *)&clip);
	
	/* Jetzt Font auswaehlen */
	
	vst_font(userDraw.handle, userDraw.font);
	vswr_mode(userDraw.handle, MD_TRANS);
	vst_effects(userDraw.handle, 0);
	
	vst_alignment(userDraw.handle, 0, 3, &dummy, &dummy);
	if (userDraw.fsm)
	{
		vst_arbpt(userDraw.handle, userDraw.size, &dummy, &dummy, &dummy, &dummy);
		v_ftext(userDraw.handle, clip.g_x, clip.g_h, demoText);
	} else
	{
		vst_point(userDraw.handle, userDraw.size, &dummy, &dummy, &dummy, &dummy);
		v_gtext(userDraw.handle, clip.g_x, clip.g_h, demoText);
	}
	/* Text wieder zuruecksetzen */
	vst_font(userDraw.handle, userDraw.orgFont);
	if (userDraw.orgFsm)
		vst_arbpt(userDraw.handle, userDraw.orgSize, &dummy, &dummy, &dummy, &dummy);
	else
		vst_point(userDraw.handle, userDraw.orgSize, &dummy, &dummy, &dummy, &dummy);
	/* Clipping wieder ausschalten */
	vs_clip(userDraw.handle, FALSE, (_WORD *)&draw);
	return NORMAL;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID fontSetGetValues(OBJECT *tree, _VOID *special, _BOOL set, _WORD exitBut)
{
	FONTSEL d;
	_BOOL vb;
	_WORD vi;
	
	UNUSED(exitBut);
	d = special;
	if (set)
	{
		/* Wird am Anfang aufgerufen */
		/* ldHandler fuer Fontliste aufbauen */
		ListDl_BuildLdHandler(d->fl,  /* Zeiger auf die Liste */
			resetFonts, nextFont, prevFont, fontCount,
			fontEnabled, fontSelected, fontToString,
			fontIsSelected, fontDrawEntry, FUNK_NULL,
			0, CharHeight,
			0, 0, 
			&d->fontHandler);
		
		/* Fontliste initialisieren */
		if (!ListDl_PrepareListDial(fontBox, 
			ldSelect|ldArrows|ldDoubleExit|ldModal,
			&d->fontHandler,
			FONTBOX_NAMEBOX, FONTBOX_NAMEBACK,
			FONTBOX_OK, FONTBOX_CANCEL, 
			&d->env,
			FONTBOX_OK,
			&d->fontDial))
		{
			d->terminate = TRUE;
			return;
		}
		/* Sizeliste erstellen */
		userDraw.orgSize = buildSizeList(d->currFont, d->handle, d->fontSize, &d->sizeList);
		
		/* Sizeliste vorbereiten */
		/* ldHandler fuer Fontliste aufbauen */
		ListDl_BuildLdHandler(&d->sizeList,  /* Zeiger auf die Liste */
			resetSize, nextSize, prevSize, sizeCount,
			sizeEnabled, sizeSelected, sizeToString,
			sizeIsSelected, sizeDrawEntry, FUNK_NULL,
			0, CharHeight,
			0, 0, 
			&d->sizeHandler);
		
		if (!ListDl_PrepareListDial(fontBox, 
			ldSelect|ldArrows|ldDoubleExit|ldAutolocate|ldModal,
			&d->sizeHandler,
			FONTBOX_SIZEBOX, FONTBOX_SIZEBACK,
			FONTBOX_OK, FONTBOX_CANCEL, 
			&d->env,
			FONTBOX_OK,
			&d->sizeDial))
		{
			ListDl_ReleaseListDial(&d->fontDial);
			d->terminate = TRUE;
			return;
		}
	} else
	{
		if (d->exitBut == FONTBOX_OK)
		{
			d->fontId = userDraw.font;
			/* d->fontSize = userDraw.size; */
			FontSelect_SetFont(d->handle, &d->fontId, &d->fontSize, FALSE, &vb, &vb, &vi, &vi);
		} else
		{
			d->fontId = d->oldId;
			d->fontSize = d->oldSize;
			FontSelect_SetFont(d->handle, &d->oldId, &d->oldSize, FALSE, &vb, &vb, &vi, &vi); 
		}
		/* Autolocator wieder ausklinken */
		ListDl_FreeAutoLocator();
		mtDials_RemoveHandler(fontBox);
		/* Userdef wieder freigeben */
		FreeUserdef(fontBox, FONTBOX_EXAMPLE);
		/* ListDials wieder freigeben */
		DelObjState(tree, d->exitBut, SELECTED);
		
		ListDl_ReleaseListDial(&d->sizeDial);
		ListDl_ReleaseListDial(&d->fontDial);
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID fontDraw(OBJECT *tree, _VOID *special, CONST GRECT *clip)
{
	FONTSEL d;
	
	d = special;
	if (d->terminate)
	{
		WinDials_CloseWinDial(tree);
	} else
	{
		ListDl_DrawListDial(d->fontDial, clip);
		ListDl_DrawListDial(d->sizeDial, clip);
	}
}

/*** ---------------------------------------------------------------------- ***/
/*DYJ 5.21b */
LOCAL _BOOL fontButton(OBJECT *tree, _VOID *special, _WORD button, _WORD mx, _WORD my, _UWORD kstate, _WORD clicks)
{
	FONTSEL d;
	DIAL d2;
	_BOOL exit;
	GRECT upperFrame;
	Fonts select;
	SizePtr sizePtr;
	_UBYTE sizeStr[80];
	_VOID *lastElem;

	UNUSED(clicks);
	d = special;

	d2 = ListDl_FindDial(tree, button, FALSE);
	if (d2 != ListDl_NilDIAL())
	{
		if (button == -1) /* Autolocator-Redraw */
			d2 = d->sizeDial;
		lastElem = NULL;
		exit = ListDl_HandleListDial(d2, &button, mx, my, kstate, &lastElem);
		if (lastElem != NULL)
		{
			if (d2 == d->fontDial)
			{
				select = lastElem;
				if (select->info.id != userDraw.font)
				{
					ListDl_ReleaseListDial(&d->sizeDial);
					userDraw.font = select->info.id;
					userDraw.size = buildSizeList(select->info.id, d->handle, -1, &d->sizeList);
					userDraw.fsm = select->info.fsm;
					SetObjcString(fontBox, FONTBOX_ID, IntToStr(select->info.id, 5, sizeStr, sizeof(sizeStr)));
					/* Sizeliste vorbereiten */
					ListDl_PrepareListDial(fontBox, 
						ldSelect|ldArrows|ldDoubleExit|ldAutolocate|ldModal,
						&d->sizeHandler,
						FONTBOX_SIZEBOX, FONTBOX_SIZEBACK,
						FONTBOX_OK, FONTBOX_CANCEL, 
						&d->env,
						FONTBOX_OK,
						&d->sizeDial);
					/* SizeDial neu zeichnen */
					WinDials_WinDialDraw(fontBox, FONTBOX_SIZEBACK, 1, &upperFrame, FALSE);
					WinDials_WinDialDraw(fontBox, FONTBOX_EXAMPLE, 1, &upperFrame, FALSE);
					WinDials_WinDialDraw(fontBox, FONTBOX_ID, 1, &upperFrame, FALSE);
					ListDl_InitAutoLocator(d->sizeDial);
					
					/* EditString noch neu setzen */
					SetObjcString(fontBox, FONTBOX_SIZEEDIT, IntToStr(userDraw.size, 3, sizeStr, sizeof(sizeStr)));
					/* und zeichnen */
					WinDials_WinDialDraw(fontBox, FONTBOX_SIZEEDIT, 0, &upperFrame, FALSE);
				}
			} else if (d2 == d->sizeDial)
			{
				sizePtr = lastElem;
				userDraw.size = sizePtr->size;
				WinDials_WinDialDraw(fontBox, FONTBOX_EXAMPLE, 1, &upperFrame, FALSE);
				WinDials_WinDialDraw(fontBox, FONTBOX_ID, 1, &upperFrame, FALSE);
				/* EditString noch neu setzen */
				SetObjcString(fontBox, FONTBOX_SIZEEDIT, IntToStr(userDraw.size, 3, sizeStr, sizeof(sizeStr)));
				/* und zeichnen */
				WinDials_WinDialDraw(fontBox, FONTBOX_SIZEEDIT, 0, &upperFrame, FALSE);
			}
		}
		if (exit)
		{
			button &= 0x7fff;
			d->exitBut = button;
			if (button == FONTBOX_OK)
			{
				/* Erstmal nachsehen, ob eine Groesse selektiert ist, 
				 * wenn nicht, dann den editString nehmen 
				 */    
				sizePtr = d->sizeList.root;
				while (sizePtr != NULL && !sizePtr->sel)
					sizePtr = sizePtr->next;
				if (sizePtr != NULL)
				{
					d->fontSize = sizePtr->size;
				} else
				{
					ObjcString(fontBox, FONTBOX_SIZEEDIT, sizeStr, sizeof(sizeStr));
					d->fontSize = StrToInt(sizeStr, NULL, NULL);
				}
				if (d->fontSize <= 1)
				{
					mtAlerts_Alert(1, Rsc_WrkString(AL_ILLEGAL_FONTSIZE));
				} else
				{
					return TRUE;
				}
			} else
			{
				return TRUE;
			}
		}
	} else
	{
		button &= 0x7fff;
		if (button == FONTBOX_SHOWEXAM)
		{
			ObjcString(fontBox, FONTBOX_SIZEEDIT, sizeStr, sizeof(sizeStr));
			userDraw.size = StrToInt(sizeStr, NULL, NULL);
			WinDials_WinDialDraw(fontBox, FONTBOX_EXAMPLE, 1, &upperFrame, FALSE);
			WinDials_WinDialDraw(fontBox, FONTBOX_ID, 1, &upperFrame, FALSE);
			DelObjState(fontBox, button, SELECTED);
			WinDials_WinDialDraw(fontBox, button, 0, &upperFrame, FALSE);
		}
	}
	
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID FontSelect_Exit(_VOID)
{
	if (rsc != NULL)
	{
		RscFree(rsc);
		rsc = NULL;
		fontBox = NULL;
		fontText = NULL;
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL FontSelect_Init(_VOID)
{
	if (rsc == NULL)
	{
		if ((rsc = RscReloc(RscData, sizeof(RscData))) == NULL)
			return FALSE;
		fontBox = RscGaddr(rsc, R_TREE, FONTBOX_DIALOG);
		fontText = RscGaddr(rsc, R_TREE, FONTBOX_NAMETEXT);
		InstallTermproc(FontSelect_Exit);
	}
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

/* Fuehrt kompletten Dialog durch. 
 * handle : VDI-Handle der Workstation;
 * monoFonts: Nur monospaced-Fonts sind selectable!
 */

GLOBAL _BOOL FontSelect_DoSelectFont(HVDI handle, _BOOL monoFonts, _WORD fontId, _WORD fontSize, CONST _UBYTE *title, FONT_ACCEPT_FUNC func, HWND win)
{
	tFontinfo fInfo;
	GRECT org;
	_UBYTE sizeStr[40];
	FontSelType fs;
	
	UNUSED(title);
	
	if (!FontSelect_Init())
		return FALSE;
	
	MemSetZeroStruct(fs);
	fs.terminate = FALSE;
	fs.oldId = fontId;
	fs.oldSize = fontSize;
	fs.handle = handle;
	fs.sizeList.root = NULL;
	fs.sizeList.curr = NULL;
	FontSelect_FontActive(handle);
	fs.fl = GetFontList(handle);
	if (fs.fl == NULL)
	{
		return FALSE;
	}
	/* Vorarbeiten */
	fs.env.handle = handle;
	fs.env.monos = monoFonts;
	fs.env.tree = fontBox;
	fs.env.fl   = fs.fl;
	
	/* aktuellen Font feststellen und schon mal selektieren */
	fs.fl->dummy = fs.fl->fonts;
	while (fs.fl->dummy != NULL)
	{
		fs.fl->dummy->sel = FALSE;
		fs.fl->dummy = fs.fl->dummy->next;
	}
	fs.fl->dummy = fs.fl->fonts;
	while (fs.fl->dummy != NULL && fs.fl->dummy->info.id != fontId)
	{
		fs.fl->dummy = fs.fl->dummy->next;
	}
	if (fs.fl->dummy != NULL)
	{
		fs.fl->dummy->sel = TRUE;
		fs.currFont = fs.fl->dummy->info.id; 
	} else
	{
		fs.currFont = 1;
	}
	
	/* Noch etwas mit Objekten rumrechnen */
	CalcArea(fontBox, FONTBOX_NAMEBOX, &org);
	fs.env.fontWidth = org.g_w;
	CalcArea(fontBox, FONTBOX_SIZEBOX, &org);
	fs.env.sizeWidth = org.g_w;
	
	/* Userobject noch vorbereiten */
	mtDials_ObjcExtype(fontBox, FONTBOX_EXAMPLE, 99);  /* Userdef */
	InstUserdef(fontBox, FONTBOX_EXAMPLE, drawText, NULL);
	
	FontSelect_FontInfo(handle, fs.currFont, &fInfo);
	
	userDraw.font    = fInfo.id;
	userDraw.size    = fInfo.point;
	userDraw.fsm     = fInfo.fsm;
	userDraw.orgFont = userDraw.font;
	userDraw.orgSize = userDraw.size;
	userDraw.orgFsm  = FALSE;
	userDraw.handle  = handle;
	
	/* Editable-Text noch setzen */
	SetObjcString(fontBox, FONTBOX_SIZEEDIT, IntToStr(userDraw.size, 3, sizeStr, sizeof(sizeStr)));
	SetObjcString(fontBox, FONTBOX_ID, IntToStr(userDraw.font, 5, sizeStr, sizeof(sizeStr)));
	
	/* WindowDialog oeffnen */
	if (!WinDials_OpenWinDial(fontBox,
		TRUE,
		fontSetGetValues,
		fontSetGetValues,
		fontButton,
		fontDraw, NULL, &fs))
	{
		ListDl_ReleaseListDial(&fs.sizeDial);
		ListDl_ReleaseListDial(&fs.fontDial);
		mtDials_RemoveHandler(fontBox);
		return FALSE;
	}
	
	/* Autolocator installieren */
	ListDl_InitAutoLocator(fs.sizeDial);
	mtDials_InstallHandler(fontBox, ListDl_AutoLocate, CallByHandling, 0, 0, &org, NULL, NULL);
	/* Und direkt einmal initialisieren */
	ListDl_AutoLocate(fontBox, 0, 0, 0, 0, MU_KEYBD, FONTBOX_SIZEEDIT, NULL);
	
	WinDials_WinDialHandleEvents();
	
	if (fs.exitBut == FONTBOX_OK)
	{
		FontSelect_FontInfo(handle, fs.fontId, &fInfo);
		func(win, fInfo.id, fInfo.point, fInfo.mono);
	}
	
	dispose_size_list(&fs.sizeList);
	
	return fs.exitBut == FONTBOX_OK;
}

/*** ---------------------------------------------------------------------- ***/

/* Anzahl der zur Verfuegung stehenden Fonts */
GLOBAL _WORD FontSelect_FontNumber(_WORD handle)
{
	FONTList fl;
	
	fl = GetFontList(handle);
	if (fl != NULL)
		return fl->numFonts;
	return -1;
}

/*** ---------------------------------------------------------------------- ***/

/* Fast wie FontsLoadFonts, nur wird die Fontliste 
 * nicht zurueckgegeben. Die wird intern verwaltet.
 */
GLOBAL _WORD FontSelect_LoadFonts(_WORD handle)
{
	return FontSelect_FontNumber(handle);
}

/*** ---------------------------------------------------------------------- ***/

/* Selektion eines Fonts 
 */
GLOBAL _VOID FontSelect_FontSelect(_WORD handle, _WORD font)
{
	FONTList fl;
	
	fl = GetFontList(handle);
	if (fl != NULL)
		fl->active = vst_font(handle, font);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID FontSelect_FontInfo(_WORD handle, _WORD font, tFontinfo *info)
{
	_WORD attr[16];
	_WORD extend1[8];
	_WORD extend2[8];
	FONTList fl;
	Fonts f;
	_WORD dummy;
	_WORD i;
	
	MemSetZeroStruct(*info);
	fl = GetFontList(handle);
	if (fl != NULL) 
	{
		f = FindFont(fl, font);
		if (f == NULL)
		{
			f = FindFont(fl, fl->active);
			if (f == NULL)
				return;
		}
		info->id = f->info.id;
		if (!f->infoSet)
		{
			/* Font setzen */
			vst_font(handle, font);
			/* Nun Auskunft einholen */
			vqt_attributes(handle, attr); /* Aktuelle Parameter holen */
			f->info.color =  attr[1];
			f->info.rot =    attr[2];
			f->info.halign = attr[3];
			f->info.valign = attr[4];
			f->info.chw =    attr[6];
			f->info.chh =    attr[7];
			f->info.boxw =   attr[8];
			f->info.boxh =   attr[9];
			f->info.point = vst_point(handle, 12, &dummy, &dummy, &dummy, &dummy);
			f->info.font_width = point_to_fix31(f->info.point);
			f->info.effect = vst_effects(handle, f->info.effect);
			if (f->info.id == 1)	/* Sonderbehandlung fuer Systemfont */
			{
				strBcpy(f->info.name, SysFontName);  /* Name des Fonts */
				if (CharHeight == 8)
					f->info.point = 9;
				else
					f->info.point = 10;
			}
			if (f->info.fsm)
			{
				f->info.minsize = 1;
				f->info.maxsize = 32000;
			} else
			{
				f->info.minsize = vst_point(handle, 1, &dummy, &dummy, &dummy, &dummy);
				f->info.maxsize = vst_point(handle, 9999, &dummy, &dummy, &dummy, &dummy);
			}
			/* Annahme, aber leider gibts keine Abfragemoeglichkeit */
			vqt_extent(handle, "MMmmWWww", extend1);
			vqt_extent(handle, "IIiiLLll", extend2);
			i = 0;
			f->info.mono = TRUE;
			while (i < 8 && f->info.mono)
			{
				f->info.mono = extend1[i] == extend2[i];
				++i;
			}
			f->infoSet = TRUE;
			/* Jetzt wieder zuruecksetzen */
			vst_font(handle, fl->active);
			FontSelect_FontSize(handle, fl->actSize, &dummy, &dummy, &dummy, &dummy);
		}
		*info = f->info;
	} else
	{
		vqt_attributes(handle, attr);
		info->id = attr[0];
		if (info->id == 1)
			strBcpy(info->name, SysFontName);
		else
			*info->name = '\0';
		info->color =  attr[1];
		info->rot =    attr[2];
		info->halign = attr[3];
		info->valign = attr[4];
		info->chw =    attr[6];
		info->chh =    attr[7];
		info->boxw =   attr[8];
		info->boxh =   attr[9];
		info->minsize= -1;
		info->maxsize= -1;
		info->fsm =    FALSE;
		if (info->id == 1)
		{
			if (CharHeight == 8)
				info->point = 9;
			else
				info->point = 10;
		}
		info->mono = TRUE;
	}
}

/*** ---------------------------------------------------------------------- ***/

/* Liefert die ID des momentan aktiven Fonts.
 */
GLOBAL _WORD FontSelect_FontActive(_WORD handle)
{
	FONTList fl;
	Fonts f;
	_WORD attr[10];

	vqt_attributes(handle, attr);
	fl = GetFontList(handle);
	if (fl != NULL)
	{
		f = FindFont(fl, attr[0]);
		if (f != NULL)
		{
			/* Bei der Gelgenheit gleich mal Daten auffrischen */
			f->info.chw = attr[6];
			f->info.chh = attr[7];
			f->info.boxw = attr[8];
			f->info.boxh = attr[9];
		}
		fl->active = attr[0];
	}
	return attr[0];
}

/*** ---------------------------------------------------------------------- ***/

/* Bestimmung der Groesse des aktuellen Fonts in POINTS.
 * cw == Zeichenbreite
 * ch == Zeichenhoehe
 * bw == Breite der Zeichenbox
 * bh == Hoehe der Zeichenbox
 */
GLOBAL _WORD FontSelect_FontSize(_WORD handle, _WORD size, _WORD *cw, _WORD *ch, _WORD *bw, _WORD *bh)
{
	FONTList fl;
	Fonts f;
	_WORD dummy;
	tFontinfo info;
	
	fl = GetFontList(handle);
	if (fl != NULL)
	{
		f = FindFont(fl, fl->active);
		if (f != NULL)
		{
			fl->actSize = size;
			if (!f->infoSet)
				FontSelect_FontInfo(handle, fl->active, &info);
			if (f->info.fsm)
			{
				f->info.point = vst_arbpt(handle, size, cw, ch, bw, bh);
				f->info.font_width = point_to_fix31(f->info.point);
				f->info.font_width = vst_setsize32(handle, f->info.font_width, &dummy, &dummy, &dummy, &dummy);
				f->info.skew = vst_skew(handle, f->info.skew);
			} else
			{
				f->info.point = vst_point(handle, size, cw, ch, bw, bh);
			}
			/* Daten erneuern */
			FontSelect_FontActive(handle);
			return f->info.point;
		}
	}
	return -1;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID FontSelect_SetFont(
	_WORD handle,
	_WORD *font,
	_WORD *fontSize, 
	_BOOL getBoldWidth,
	_BOOL *mono,
	_BOOL *fsm,
	_WORD *boxw,
	_WORD *boxh)
{
	_WORD extend[8];
	_WORD cw, ch, bw, bh;
	tFontinfo fInfo;
	_WORD dummy;
	
	FontSelect_FontSelect(handle, *font);
	FontSelect_FontInfo(handle, *font, &fInfo);
	if (mono != NULL)
		*mono = fInfo.mono;
	if (fsm != NULL)
		*fsm = fInfo.fsm;
	*fontSize = FontSelect_FontSize(handle, *fontSize, &cw, &ch, &bw, &bh);
	/* Textalignment setzen */
	vst_alignment(handle, 0, 3, &dummy, &dummy);
	if (getBoldWidth)
		vst_effects(handle, TXT_THICKENED);
	else
		vst_effects(handle, TXT_NORMAL);
	/* Durchschnittliche Zeichenbreite berechnen */
#define QUERY_STR "abcdefghijklmnopqrstuvwxyz abcdefghijklmnopqrstuvwxyz ABCDEFGHIJKLMNOPQRSTUVWXYZ abcdefghijklmnopqrstuvwxyz 1234567890"
	(*(fInfo.fsm ? vqt_f_extent : vqt_extent))(handle, QUERY_STR, extend);
	if (getBoldWidth)
		vst_effects(handle, 0);
	bw = (extend[2] - extend[0]) / (_WORD)(sizeof(QUERY_STR) - 1); /* Zeichenbreite berechnen */
	if (boxw != NULL)
	{
		*boxw = Max(1, bw);
		if (!fInfo.mono)
			*boxw = (*boxw * 6) / 5;
	}
	if (boxh != NULL)
		*boxh = Max(1, bh);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _WORD FontSelect_FontRotate(_WORD handle, _WORD angle)
{
	Fonts f;

	f = GetFont(handle);
	if (f != NULL)
	{
		f->info.rot = vst_rotation(handle, angle);
		return f->info.rot;
	}
	return 0;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID FontSelect_FontWidth(_WORD handle, fix31 width)
{
	Fonts f;
	_WORD dummy;

	f = GetFont(handle);
	if (f != NULL)
		f->info.font_width = vst_setsize32(handle, width, &dummy, &dummy, &dummy, &dummy);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID FontSelect_FontSkew(_WORD handle, _WORD skew)
{
	Fonts f;

	f = GetFont(handle);
	if (f != NULL)
		if (f->info.fsm)
			f->info.skew = vst_skew(handle, skew);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID FontSelect_FontColor(_WORD handle, _WORD color)
{
	Fonts f;

	f = GetFont(handle);
	if (f != NULL)
		f->info.color = vst_color(handle, color);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID FontSelect_FontEffekt(_WORD handle, _UWORD effekt)
{
	Fonts f;

	f = GetFont(handle);
	if (f != NULL)
		f->info.effect = vst_effects(handle, effekt);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _WORD FontSelect_NextSize(_WORD handle, _BOOL bigger)
{
	_WORD act, new;
	_WORD dummy;
	_BOOL ende;
	Fonts f;

	f = GetFont(handle);
	if (f != NULL)
	{
		new = act = f->info.point;
		ende = bigger ? (act >= f->info.maxsize) : (act <= f->info.minsize);
		while  (f->info.point == act && !ende)
		{
			if (bigger)
				++new, ende = f->info.point >= f->info.maxsize;
			else
				--new, ende = f->info.point <= f->info.minsize;
			if (f->info.fsm)
			{
				f->info.point = vst_arbpt(handle, new, &dummy, &dummy, &dummy, &dummy);
				f->info.font_width = point_to_fix31(new);
				f->info.font_width = vst_setsize32(handle, f->info.font_width, &dummy, &dummy, &dummy, &dummy);
				f->info.skew = vst_skew(handle, f->info.skew);
			} else
			{
				f->info.point = vst_point(handle, new, &dummy, &dummy, &dummy, &dummy);
			}
		}
		FontSelect_FontActive(handle);
		return f->info.point;
	}
	return FontSelectErrNoGdos;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _WORD FontSelect_NextBigger(_WORD handle)
{
	return FontSelect_NextSize(handle, TRUE);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _WORD FontSelect_NextSmaller(_WORD handle)
{
	return FontSelect_NextSize(handle, FALSE);
}

/*** ---------------------------------------------------------------------- ***/

typedef struct _wsinfo WsInfo, *WsPtr;

struct _wsinfo {
	_WORD handle;
	_UWORD flags;
	FONTList list;
	WsPtr next;
	WsPtr last;
};

extern WsPtr Intern(_WORD handle);

GLOBAL _WORD FontSelect_FontList(_WORD handle, _WORD flag)
{
	WsPtr p;
	Fonts x = NULL;
	FONTList fl;
	
	p = Intern(handle);
	if (p != NULL && (fl = p->list) != NULL)
	{
		switch (flag)
		{
		case FontsFFIRST:
			x = fl->fonts;
			fl->dummy = x;
			break;
		case FontsFNEXT:
			if (fl->dummy != NULL)
				fl->dummy = x = fl->dummy->next;
			break;
		case FontsFPREV:
			x = fl->fonts;
			while (x != NULL && x->next != fl->dummy)
				x = x->next;
			fl->dummy = x;
			break;
		case FontsFLAST:
			x = fl->fonts;
			while (x != NULL && x->next != NULL)
				x = x->next;
			fl->dummy = x;
			break;
		}
	}
	return x != NULL ? x->info.id : 0;
}
