/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */


#ifndef __CAT_LISTDL_H__
#define __CAT_LISTDL_H__


#ifndef __PORTAB_H__
#include <portab.h>
#endif
#ifndef __PORTAES_H__
#include <portaes.h>
#endif
#ifndef __CAT_LISTMAN_H__
#include <listman.h>
#endif
#ifndef __CAT_WINDIALS_H__
#include <windials.h>
#endif


/* entry: */
/* env:   */
/* str:   */
typedef _VOID (*entryToStringProc)(_VOID *entry, _VOID *env, _UBYTE *str, size_t strsize);

/* Wird aufgerufen, um einen Eintrag zu zeichen.
 * x und y enthalten die Position, offset ist ein "Offset" vom linken
 * Rand aus, cliprect muss beruecksichtigt werden!
 * Wenn der entry NIL ist, dann muss ein leeres Rechteck gezeichnet
 * werden
 */

/* entry: */
/* env:   */
typedef _VOID (*inLoopProc)(_VOID *entry, _VOID *env);

/* Wird innerhalb der Schleife von DoListDial aufgerufen.
 * Erhaelt als Parameter den zuletzt angewaehlten Eintrag, NIL, falls
 * keiner selektiert ist.
 */

/* tree: */
/* env:   */
/* exitBut: */
/* lastSel: */
/* kstate: */
typedef _BOOL (*lsCheckExitProc)(OBJECT *tree, _VOID *env, _WORD exitBut, _VOID *lastSel, _UWORD kstate);

/* Wird aufgerufen, wenn ein ListDialog verlassen werden soll.
 * Damit kann man noch Eingaben validieren
 */

/* objc:        */
/* env:         */
/* listInfo:    */
/* redraw:      */
/* dialFinish:  */
/*DYJ 5.30f Start*/
typedef _VOID (*specialButProc)(_WORD obj, _VOID *env, LISTINFO listinfo, _BOOL *redraw, _BOOL *dialfinish,_LONG *lastSel);
/*DYJ  Ende; alt:	
typedef _VOID (*specialButProc)(_WORD obj, _VOID *env, LISTINFO listinfo, _BOOL *redraw, _BOOL *dialfinish);
*/


/* Fuer zusaetzliche Buttons, die vom Benutzer definierbar sind */

typedef struct specialButHdler {
	_WORD objc;
	specialButProc proc;
} specialButHdler;


typedef struct _ldHandler {
	_VOID *list;   /* Zeiger auf die Liste */
	ResetProc resetList;
	MoveProc nextEntry;
	MoveProc prevEntry;
	CountProc listElems;
	entryIsSelectableProc isEnabled;
	selectEntryProc selEntry;
	entryToStringProc entryToStr;
	entryToStringProc entry4SToStr;
	isSelectedProc isSelected;
	drawEntryProc drawEntry;
	dragDropProc dragDrop;
	_WORD voffset;
	_WORD vsize;
	_WORD hStep;
	_WORD maxWidth;
} ldHandler;

/* Faehigkeiten des Listdialoges */


typedef enum {
	ldSelect = 0x0001,
	ldMultiple = 0x0002,
	ldArrows = 0x0004,
	ldDoubleExit = 0x0008,
	ldAutolocate = 0x0010,
	ldModal = 0x0020,
	ldClearEdit = 0x0040,
	ldAutoSelect = 0x0080,
	ldMatchAny = 0x0100,
	ldShrinkList = 0x0200,
	ldTabEqNxt = 0x0400
} ldElems;
typedef _UWORD ldElemSet;



/* opaquer Typ fuer Verwaltung */
struct _dial;
typedef struct _dial DialInfo, *DIAL;
#ifndef __LISTDL_IMPLEMENTATION__
struct _dial { int dummy; };
#endif


_VOID ListDl_dummyInLoop(_VOID *entry, _VOID *env);
/* Dummy-Prozedur als InLoopProc */

_BOOL ListDl_dummyCheckExit(OBJECT *tree, _VOID *env, _WORD button, _VOID *lastSel, _UWORD kstate);
/* Dummy-Prozedur fuer Exitcheck, gibt immer TRUE zurueck */

/* Zeiger auf die Liste */
_VOID ListDl_BuildLdHandler(
	_VOID *listStart,
	ResetProc resetList,
	MoveProc nextEntry,
	MoveProc prevEntry,
	CountProc listElems,
	entryIsSelectableProc isEnabled,
	selectEntryProc selEntry,
	entryToStringProc entryToStr,
	isSelectedProc isSelected,
	drawEntryProc drawEntry,
	dragDropProc dragDrop,
	_WORD voffset, _WORD vsize, _WORD hStep, _WORD maxWidth,
	ldHandler *handler);
/* Baut aus den uebergebenen Daten einen ldHandler zusammen
 */
/*Aus Kompatibilittsgrnden setzt ListDl_BuildLdHandler
die neue Variable entry4SToStr=entryToStr, um sie anders
zu setzen mu nach deren Aufruf ListDl_BuildLdHandlerX aufgerufen werden.
Unter C++ htte man Defaultparameter benutzen knnen*/
_VOID ListDl_BuildLdHandlerX(
		entryToStringProc entry4SToStr,
		ldHandler *handler);
/*DYJ  Ende; */

_BOOL ListDl_PrepareListDial(
	OBJECT *tree,
	ldElemSet elems,
	ldHandler *handler,
	_WORD boxIndex,
	_WORD boxBack,
	_WORD okBut,
	_WORD cancelBut,
	_VOID *env,
	_WORD doubleClickButton,
	DIAL *d);
/* Bereitet einen Dialog fuer eine Listenbehandlung vor. Der Dialog muss
 * schon initialisiert sein.
 */

_BOOL ListDl_ReleaseListDial(DIAL *d);
/* gibt einen Listenhandler wieder frei */

DIAL ListDl_FindDial(OBJECT *tree, _WORD button, _BOOL treeOnly);
/* Gibt den zu dem Button gehoerenden DIAL zurueck,
 * ansonsten NIL
 */

#define ListDl_NilDIAL() ((DIAL)NULL)
/* Gibt einen Nil-Dial zurueck fuer Vergleiche */

_VOID ListDl_SetDcButton(OBJECT *tree, _WORD button);
/* Setzt den DoubleClickButton */

/* Der von DialDo gelieferte Button */
/* Die Mauskoordinaten */
/* Der Tastaturstatus  */
_BOOL ListDl_HandleListDial(DIAL d, _WORD *but, _WORD mx, _WORD my, _UWORD kstate, _VOID **lastElem);
/* Verwaltet die Events, wenn etwas in diesem Dial angeklickt wurde
 * Rueckgabe: TRUE = Exit-Button angewaehlt
 */

_VOID ListDl_DrawListDial(DIAL d, CONST GRECT *clip);
/* Zeichnet die Liste komplett inklusive aller Elemente */

_VOID ListDl_InitAutoLocator(DIAL dial);
/* Setzt den Default-Dial fuer den Autolocator, nur noetig, wenn man
 * nicht doListDial benutzt
 */

_VOID ListDl_FreeAutoLocator(_VOID);
/* Entfernt den Default-Dial fuer den Autolocator, nur noetig, wenn man
 * nicht doListDial benutzt
 */

_UWORD ListDl_AutoLocate(OBJECT *tree, _WORD mx, _WORD my, _UBYTE scan, _UWORD kstate, _UWORD event, _WORD edObj, _VOID *special);
/* Der Autolocator zum manuellen Aufruf, falls man nicht ueber
 * doListDial geht
 */

_WORD ListDl_doListDial(
	OBJECT *tree,
	ldElemSet elems,
	ldHandler *handler,
	_WORD boxIndex,
	_WORD boxBack,
	_WORD okBut,
	_WORD cancelBut,
	_VOID *env,
	_WORD doubleClickButton,
	_WORD autoEdit,
	inLoopProc inLoop,
	specialButHdler *specials,
	_WORD numSpecials,
	wdSetProc setValues,
	wdSetProc getValues,
	_VOID **lastElem);
/* Handelt eine komplette Scrollbare Liste.
 * Gibt den Index des Exit-Buttons zurueck.
 * In lastElem wird die Adresse des zuletzt selektierten Elements zurueckgegeben.
 * Bei multiple = TRUE koennen mehrere Eintraege selektiert werden.
 */

_BOOL ListDl_WinListDial(
	OBJECT *tree,
	ldElemSet elems,
	ldHandler *handler,
	_WORD boxIndex,
	_WORD boxBack,
	_WORD okBut,
	_WORD cancelBut,
	_VOID *env,
	_WORD doubleClickButton,
	_WORD autoEdit,
	inLoopProc inLoop,
	specialButHdler *specials,
	_WORD specialCount,
	lsCheckExitProc checkExit,
	wdSetProc setValues,
	wdSetProc getValues,
	_VOID **lastElem);
/* Oeffnet einen Dialog mit einer scrollbaren Liste als Fensterdialog
 */

_WORD ListDl_ListboxPopup(_WORD x, _WORD y, _WORD w, _WORD h, CONST _UBYTE **strings, _WORD numStrings, _WORD presel);


#endif /* __CAT_LISTDL_H__ */
