/*
 * Diese Datei ist Teil der Magic-Library,
 * und darf in dieser Form nur als Teil des CAT-Projekts
 * verwendet werden.
 * 
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Magic ist Copyright (c) by Peter Hellinger.
 *
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */


#ifndef __MAGIC_STRING_H__
#define __MAGIC_STRING_H__

#ifndef __PORTAB_H__
#include <portab.h>
#endif

/* Position von substr in str. Wenn nicht gefunden retouniert die 
 * Prozedur SIZE (str) + 1!!!  Im Zuge der Umbauarbeiten der Prozedur
 * wurde das Feature eingebaut, dass in substr auch WILDCARDS und JOKER
 * enthalten sein koennen.  Als Joker wurde '?' und als Wildcard '*'
 * vereinbart.  Nur wenn dowild als TRUE uebergeben wird!!!
 * In "Hallo, hier bin ich" (str) kann man nun auch folgendes finden:
 * p:= Pos ('hier', str, 0, TRUE);  p =  7 
 * p:= Pos ('*i*i', str, 0, TRUE);  p =  0
 * p:= Pos ('?i? ', str, 0, TRUE);  p =  8
 */
size_t Pos(CONST _UBYTE *substr, CONST _UBYTE *str, size_t start, _BOOL dowild);
#define POS_NOT_FOUND ((size_t) -1)

/* Fuegt substr in str ab index ein */
_VOID Insert(CONST _UBYTE *substr, _UBYTE *str, size_t strsize, size_t index); 

/* Loescht len Zeichen ab index aus str */
_VOID Delete(_UBYTE *str, size_t index, size_t len);

/* Kopiert len Zeichen ab index von str nach result */
_VOID Copy(CONST _UBYTE *str, size_t index, size_t len, _UBYTE *result, size_t strsize);

#endif /* __MAGIC_STRING_H__ */
