/*
 * Diese Datei ist Teil der Magic-Library,
 * und darf in dieser Form nur als Teil des CAT-Projekts
 * verwendet werden.
 * 
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Magic ist Copyright (c) by Peter Hellinger.
 *
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */


#ifndef __MAGIC_TYPES_H__
#define __MAGIC_TYPES_H__

#ifndef __PORTAB_H__
#include <portab.h>
#endif

struct fonthdr;
typedef struct fonthdr FONTHDR, *PtrFONTHDR;
struct fonthdr {
	_WORD fontId;
	_WORD point;
	_UBYTE name[32];
	_UWORD firstAde;
	_UWORD lastAde;
	_UWORD top;
	_UWORD ascent;
	_UWORD half;
	_UWORD descent;
	_UWORD bottom;
	_UWORD maxCharwidth;
	_UWORD maxCellwidth;
	_UWORD leftOffset;
	_UWORD rightOffset;
	_UWORD thicken;
	_UWORD ulSize;
	_UWORD lighten;
	_UWORD skew;
	_UWORD flags;
	_UWORD *horTable;
	_UWORD *offTable;
	_VOID *datTable;
	_UWORD formWidth;
	_UWORD formHeight;
	PtrFONTHDR nextFont;
};


typedef struct {
	_WORD imVersion;
	_WORD imHeadlength;
	_WORD imNplanes;
	_WORD imPatlen;
	_WORD imPixwidth;
	_WORD imPixheight;
	_WORD imScanwidth;
	_WORD imNlines;
} IMGHEADER;

typedef struct {
	_WORD PLANES;
	_WORD WIDTH;
	_WORD CONTRL[12];
	_WORD INTIN[256];
	_WORD PTSIN[256];
	_WORD INTOUT[256];
	_WORD PTSOUT[256];
	_WORD COLBIT0;
	_WORD COLBIT1;
	_WORD COLBIT2;
	_WORD COLBIT3;
	_WORD LSTLIN;
	_UWORD LNMASK;
	_WORD WMODE;
	_WORD X1;
	_WORD Y1;
	_WORD X2;
	_WORD Y2;
	_VOID *PATPTR;
	_UWORD PATMSK;
	_WORD MFILL;
	_WORD CLIP;
	_WORD XMINCL;
	_WORD YMINCL;
	_WORD XMAXCL;
	_WORD YMAXCL;
	_WORD XDDA;
	_WORD DDAINC;
	_WORD SCALDIR;
	_WORD MONO;
	_WORD SOURCEX;
	_WORD SOURCEY;
	_WORD DESTX;
	_WORD DESTY;
	_WORD DELX;
	_WORD DELY;
	PtrFONTHDR FBASE;
	_WORD FWIDTH;
	_UWORD STYLE;
	_UWORD LITEMASK;
	_UWORD SKEWMASK;
	_WORD WEIGHT;
	_WORD ROFF;
	_WORD LOFF;
	_WORD SCALE;
	_WORD CHUP;
	_WORD TEXTFG;
	_VOID *SCRTCHP;
	_WORD SCRTP2;
	_WORD TEXTBG;
	_WORD COPYTRAN;
	_VOID *SEEDABORT;
} LINEA, *PtrLINEA;

typedef PtrFONTHDR PtrLINEAFonts[3];

typedef struct {
	_WORD mfHeader;
	_WORD mfHlenght;
	_WORD mfVersion;
	_WORD mfNdcrcfl;
	_WORD mfExtents[4];
	_WORD mfPagesz[2];
	_WORD mfCoords[4];
	_WORD mfImgflag;
	_WORD mfResvd[9];
} METAHDR;

typedef struct {
	_WORD xhot;
	_WORD yhot;
	_WORD form;
	_WORD bgcol;
	_WORD fgcol;
	_WORD image[32];
} SDB;


#endif /* __MAGIC_TYPES_H__ */
