/*
 * Diese Datei ist Teil der Magic-Library,
 * und darf in dieser Form nur als Teil des CAT-Projekts
 * verwendet werden.
 * 
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Magic ist Copyright (c) by Peter Hellinger.
 *
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */


#ifndef __MINTUTIL_H__
#define __MINTUTIL_H__

#ifndef __PORTAB_H__
#include <portab.h>
#endif

/* Mehrere kleinere MiNT Tricks. Version 2   Karsten Isakovic / Berlin
 *
 * - Umlenken der Ausgaben eines paralellen Prozesses nach /dev/null
 * - Umlenken der Ausgaben eines paralellen Prozesses in eine Pipe
 * - Auslesen der Ausgaben aus der Pipe.
 */

/* Version in Megamax Modula 2 von Dirk Steins unter Benutzung 
 * von Magic von Peter Hellinger
 */


/*
 * Startet einen parallelen Prozess der nach /dev/null ausgibt.
 * Liefert den PID des neuen Prozesses.
 */

_WORD ExecDevNull(const _UBYTE *name, const _UBYTE *cmdline, const _UBYTE *env);

/*
 * Startet einen paralellen Prozess der in eine neue Pipe ausgibt.
 * Liefert den PID des neuen Prozesses und den Filehandle
 * der Pipe in 'pipe'.
 */

_WORD ExecPipe(const _UBYTE *name, const _UBYTE *cmdline, const _UBYTE *env, _WORD *pipe);

/*
 * Liest von einer Pipe, sofern dort Daten vorhanden sind.
 * Liefert Null, wenn keine Daten da waren, -1 wenn der
 * Pipe-Prozess bendet wurde und einen positiven Wert, wenn
 * Zeichen gelesen wurden.
 */

_LONG ReadPipe(_WORD pid, _WORD pipe, _VOID *buf, _LONG bufsize, _WORD *retCode);

/*
 * Liefert 1 wenn MiNT installiert ist, sonst 0.
 */

_BOOL IsMiNT(_VOID);

#endif /* __MINTUTIL_H__ */
