/*
 * Diese Datei ist Teil der Magic-Library,
 * und darf in dieser Form nur als Teil des CAT-Projekts
 * verwendet werden.
 * 
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Magic ist Copyright (c) by Peter Hellinger.
 *
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */


#ifndef __MAGICTOOL_DIR_H__
#define __MAGICTOOL_DIR_H__

#ifndef __PORTAB_H__
#include <portab.h>
#endif


#define Tos100 0x100
#define Tos102 0x102
#define Tos104 0x104 /* Das aktuelle ST OS */
#define Tos106 0x106 /* Beim 1040STE zu finden */
#define Tos205 0x205 /* Die MegaSTE haben so eines */
#define Tos206 0x206 /* neues fuer MegaSTE und alle anderen */
#define Tos300 0x300 /* Das OS des TT */
#define Tos301 0x301 /* ToeToe */
#define Tos305 0x305 /* auch verbreitet */
#define Tos306 0x306 /* Das neueste OS fuer den TT030 */


_BOOL mtDir_GetDir(_UBYTE *pfad, _UBYTE *name, CONST _UBYTE *msg);
/* Fileselectorbox, bei OS-Versionen >== Tos104 oder der Patzelbox wird msg in 
 * die Filebox gesetzt.
 * DYJ 4.21s nicht TOS104 sondern AES-Version 104 ist das Kriterium */

_BOOL mtDir_GetFile(CONST _UBYTE *wild, CONST _UBYTE *message, _UBYTE *file);
/* Bedient sich der Prozedur GetDir. In wild kann ein Wildcard uebergeben werden,
 * gegebenenfalls mit Pfad. message wird ab Tos 1.4 in den Fileselector gesetzt.
 * file enthaelt bei Returnwert TRUE den Dateinamen MIT Pfad.
 */

_VOID mtDir_SplitPath(CONST _UBYTE *path, _UBYTE *pfad, _UBYTE *name, _UBYTE *suff);
/* Zerlegt Pfad in seine Bestandteile */

_BOOL mtDir_ExSelector(_VOID);
/* TRUE, wenn ein extended Fileselector, zB. von Martin Patzel installiert ist
 * ebenfalls TRUE, wenn TOS >== 1.4 verwendet wird.
 */

_BOOL mtDir_FselGet(_UBYTE *InPath, _UBYTE *InSel, CONST _UBYTE *ext, CONST _UBYTE *msg, _BOOL pathOnly);
/* Ausgelagert aus CAT.M, da ich die auch im Editor verwenden kann.
 */

#endif /* __MAGICTOOL_DIR_H__ */
