/*
 * Diese Datei ist Teil der Magic-Library,
 * und darf in dieser Form nur als Teil des CAT-Projekts
 * verwendet werden.
 * 
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Magic ist Copyright (c) by Peter Hellinger.
 *
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */


#ifndef __MAGICTOOL_POPUPS_H__
#define __MAGICTOOL_POPUPS_H__

#ifndef __PORTAB_H__
#include <portab.h>
#endif
#ifndef __PORTAES_H__
#include <portaes.h>
#endif

_WORD mtPopups_PopupMenu(OBJECT *menu, CONST _UBYTE *title);
/* Macht aus einer Resource-Menuzeile ein Popupmenu. Dropdown-Menues werden
 * als Submenues dargestellt.  Soll ein Menu-Title kein Dropdown erhalten,
 * so muss dieser mit dem EXIT-Flag versehen werden.  Pro SubMenue duerfen
 * maximal 50 Eintraege verwendet werden.  Die Prozedur returniert die
 * Objektnummer des selektierten Eintrags.
 *
 * menu ==       Adresse der Menuzeilen-Resource
 * title ==      Titelzeile fuer das Menue. Submenues bekommen automatisch
 *              den Menuetitel als Titelzeile verpasst.
 */


_WORD mtPopups_StringPopup(CONST _UBYTE *string, CONST _UBYTE *title);
/* Generiert Popupmenue aus einem String.  Keine Submenues moeglich! Die 
 * einzelnen Eintraege muessen durch ein | getrennt sein:
 *
 * "  Eintrag 1|  Eintrag 2|  Eintrag 3" 
 *
 * Maximal 50 Eintraege moeglich.  Ist title ein Null-String wird keine Titel
 * zeile in das Popup integriert. Das Popup ist damit auch nicht verschiebbar!
 */


_WORD mtPopups_PosPopup(_WORD x, _WORD y, CONST _UBYTE *string, CONST _UBYTE *title);
/* Wie StringPopup, jedoch an festgelegter Position (linke obere Ecke). */


_WORD mtPopups_TreePopup(OBJECT *tree, _WORD x, _WORD y, _WORD idx);
/* Wie PosPopup, jedoch mit Baum, der dargestellt wird. idx kann dazu benutzt
 * werden einen bestimmten Eintrag an der x,y Position erscheinen zulassen.
 * Das Menue wird dann entsprechend versetzt.
 * Idee und Realisation: Dirk Steins
 */

_WORD mtPopups_TreeStartPopup(OBJECT *tree, _WORD start, _WORD x, _WORD y, _WORD idx);

#endif /* __MAGICTOOL_POPUPS_H__ */
