/*
 * Diese Datei ist Teil der Magic-Library,
 * und darf in dieser Form nur als Teil des CAT-Projekts
 * verwendet werden.
 * 
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Magic ist Copyright (c) by Peter Hellinger.
 *
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */


#ifndef __MAGICTOOL_RSC_H__
#define __MAGICTOOL_RSC_H__

#ifndef __PORTAB_H__
#include <portab.h>
#endif
#ifndef __PORTAES_H__
#include <portaes.h>
#endif

struct _Resource;
typedef struct _Resource Resource, *RESOURCE;

typedef struct {
	_UWORD rsh_vrsn;        /* 3 fuer langen Header        */
	_UWORD rsh_extvrsn;     /* 'IN' bei RSC von Interface */
	_ULONG rsh_object;
	_ULONG rsh_tedinfo;
	_ULONG rsh_iconblk;
	_ULONG rsh_bitblk;
	_ULONG rsh_frstr;
	_ULONG rsh_string;
	_ULONG rsh_imdata;
	_ULONG rsh_frimg;
	_ULONG rsh_trindex;
	_ULONG rsh_nobs;
	_ULONG rsh_ntree;
	_ULONG rsh_nted;
	_ULONG rsh_nib;
	_ULONG rsh_nbb;
	_ULONG rsh_nstring;
	_ULONG rsh_nimages;
	_ULONG rsh_rssize;
} RSXHDR;

#ifndef __MAGICTOOL_RSC_IMPLEMENTATION__
struct _Resource { int dummy; };
#endif
extern OBJECT **TreeAddrLib;

RESOURCE RscLoad(CONST _UBYTE *name);
/* Laedt ein Resourcefile.  TRUE wenn erfolgreich */

RESOURCE RscReloc(_VOID *adress, _LONG size);
/* Reloziert eine Resource, die bereits im Speicher ist. Kann dazu 
 * benutzt werden, um Programm-Interne Resourcen zu relozieren. Geht 
 * davon aus, dass das gesamte Resource-File incl. Header etc. im 
 * Speicher steht! Der Q&D RSCCODER (im Lieferumfang von Magic) erzeugt
 * aus einem RSC-File die entsprechenden Daten. TRUE wenn erfolgreich.
 */

_VOID RscFree(RESOURCE rsc);
/* Gibt Resource wieder frei. */

_VOID RscFreeAll(_VOID);
/* Gibt alle Resourcen wieder frei. */

_VOID RscFreeLib(_VOID);
/* Gibt die LIB Resource wieder frei. */

_VOID *RscGaddr(RESOURCE rsc, _WORD type, _WORD item);
/* Wie MagicAES.RsrcGaddr, jedoch mit der aktuellen Resource */

_VOID RscObfix(RESOURCE rsc, OBJECT *tree, _WORD object);
/* Wie MagicAES.RsrcObfix, jedoch mit der aktuellen Resource */

_VOID RscGetHeader(RESOURCE rsc, RSXHDR *hdr);
/* Liefert den RscHeader im langen Format */

OBJECT **RscGetTrees(RESOURCE rsc);
_BOOL Rsc_RscInit(_UBYTE *homePath,_UBYTE *rsrcname);
_UBYTE *Rsc_WrkString(_WORD nr);
_WORD Rsc_lang(_VOID);
_BOOL Rsc_EnvLang(_UBYTE *prgDir,_UBYTE *ret);
#endif /* __MAGICTOOL_RSC_H__ */
