/*
 * Diese Datei ist Teil der Magic-Library,
 * und darf in dieser Form nur als Teil des CAT-Projekts
 * verwendet werden.
 * 
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Magic ist Copyright (c) by Peter Hellinger.
 *
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */


#ifndef __CAT_RECTFUNCS_H__
#define __CAT_RECTFUNCS_H__

#ifndef __PORTAB_H__
#include <portab.h>
#endif
#ifndef __PORTAES_H__
#include <portaes.h>
#endif


_BOOL rc_intersect(CONST GRECT *r1, GRECT *r2);
/* Testet, ob sich die zwei Rechtecke ueberschneiden.
 * TRUE == Rechtecke ueberschneiden sich
 */
#define rcIntersect rc_intersect

GRECT rc_clip(CONST GRECT *frame, CONST GRECT *clip);
/* Liefert das Rechteck zurueck, das von beiden uebergebenen
 * Rechtecken eingeschlossen wird.
 */
#define ClipRect rc_clip

_BOOL rc_inside(_WORD x, _WORD y, CONST GRECT *r);
/* Stellt fest, ob der Punkt mit den Koordinaten x,y im Rechteck r liegt */
#define IsInRect rc_inside

_BOOL rc_equal(CONST GRECT *r1, CONST GRECT *r2);
/* Stellt fest, ob die Rechtecke r1 und r2 identisch sind */
#define RectEqual rc_equal

_VOID rc_union(CONST GRECT *p1, GRECT *p2);

#endif /* __CAT_RECTFUNCS_H__ */
