/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */


#ifndef __CAT_WINDIALS_H__
#define __CAT_WINDIALS_H__

#ifndef __PORTAB_H__
#include <portab.h>
#endif
#ifndef __PORTAES_H__
#include <portaes.h>
#endif


/* tree: */
/* special: */
/* setJN:   */
/* exitBut: */
typedef _VOID (*wdSetProc)(OBJECT *tree, _VOID *special, _BOOL setJN, _WORD exitBut);

/* Eine Prozedur dieses Typs wird einmal
 * bei der Initialisierung aufgerufen mit
 * setJN = TRUE und einmal beim Verlassen
 * mit setJN = FALSE. Beim Verlassen ist der
 * Exitbutton in exitBut angegeben. Dieser ist
 * -1, falls der Dialog ueber den Closer oder
 * beim Verlassen geschlossen wird.
 */
/* tree: */
/* special: */
/* button: */
/* mx:     */
/* my:     */
/* kstate: */
/* clicks: */
typedef _BOOL (*wdButtonProc)(OBJECT *tree, _VOID *special, _WORD button, _WORD mx, _WORD my, _UWORD kstate, _WORD clicks);

/* Wird bei jedem Exitbutton aufgerufen.
 * Wird mit gesetztem WindUpdate aufgerufen
 * Gibt zurueck, ob der Dialog beendet werden soll
 */
/* tree: */
/* special: */
/* clip: */
typedef _BOOL (*wdMessageProc)(OBJECT *tree, _VOID *special, const _WORD *msg);

typedef _VOID (*wdDrawProc)(OBJECT *tree, _VOID *special, CONST GRECT *clip);

/* Private Redrawprozedur fuer Objekte im Dialog,
 * die nicht automatisch bei DialDraw mitgezeichnet
 * werden
 */


_VOID WinDials_defDraw(OBJECT *tree, _VOID *special, CONST GRECT *clip);

_VOID WinDials_defSet(OBJECT *tree, _VOID *special, _BOOL set, _WORD exitBut);

_VOID WinDials_WinDialDraw(OBJECT *tree, _WORD entry, _WORD dpth, CONST GRECT *clip, _BOOL clipping);
/* Zeichnet ein oder mehrere Objekte in einem Fensterdialog.
 * Wenn der Dialog nicht gefunden wird, wird nichts gezeichnet
 */

_BOOL WinDials_OpenWinDial(
	OBJECT *tree,
	_BOOL modal,
	wdSetProc setValues,
	wdSetProc getValues,
	wdButtonProc button,
	wdDrawProc draw,
	CONST _UBYTE *title,
	_VOID *special);
/* Erzeugt einen Dialog im Fenster.
 * Wenn der Dialog schon in einem Fenster ist, dann
 * wird er getoppt.
 * Ansonsten wird ein neues Fenster angelegt, setValues aufgerufen,
 * um die Werte zu setzen, und dann wird das Fenster geoeffnet und
 * angezeigt. Falls der Dialog modal ist, wird das Menu
 * disablet.
 * setValues wird aufgerufen, wenn der Dialog initialisiert wird.
 * getValues wird aufgerufen, wenn der Dialog beendet wird.
 * button wird jedesmal dann aufgerufen, wenn ein Button angeklickt
 * wurde, der ein Exit-Flag gesetzt hat
 * draw ist eine zusaetzliche Zeichenprozedur, die aufgerufen wird,
 * wenn Redraws notwendig sind. Man kann auch NILDRAW uebergeben
 * Rueckgabewert:
 * False: Kein Fenster mehr frei
 */
_VOID WinDials_SetMessage(OBJECT *tree,wdMessageProc message);
/* Setzt den Messagehandler*/

_VOID WinDials_CloseWinDial(OBJECT *tree);
/* schliesst einen Fensterdialog. getValues wird aufgerufen.
 */

_VOID WinDials_WinDialHandleEvents(_VOID);
/* Durchlaeuft die Eventloop, bis das Topwindow mit dem aktuellen Dialog
 * geschlossen wird
 */

_WORD WinDials_WinDialDo(OBJECT *tree, _WORD edit);
/* Fuehrt einen kompletten modalen Fensterdialog durch. Es wird
 * der Button zurueckgegeben, mit dem der Dialog verlassen wurde.
 * Wenn kein Fenster mehr frei ist, wird ein normaler Dialog gezeichnet
 */

_BOOL WinDials_WinDialIsTop(HWND wdw);
/* Fragt nach, ob das Fenster wdw ein Fensterdialog ist
 */

_VOID WinDials_SetApplicationName(CONST _UBYTE *name);
/* Setzt den Namen der Applikation, der in Dialogen ohne Titel
 * per Default eingesetzt wird.
 */

_VOID WinDials_WinEditChanged(OBJECT *tree, _WORD edit);
/* Setzt den Cursor in ein neues Editfeld bzw. teilt dem Modul
 * mit, dass sich der Text geaendert hat und dass der Cursor neu plaziert
 * werden soll. edit = -1: Nur Cursor neu plazieren.
 */
_VOID WinDials_ShowCurs(OBJECT *tree,_BOOL showIt);

GLOBAL _WORD WinDials_GetCursObj(OBJECT *tree);

_VOID WinDials_WinUpdateTitle(OBJECT *tree);
/* Dialog soll seinen Titel aktualisieren
 */

HWND WinDials_IsWinDial(OBJECT *tree);
/* Fragt nach, ob der Dialog schon in einem Fenster ist
 */

_VOID WinDials_ActivateWinDial(OBJECT *tree);
/* Aktiviert den Window-Dialog, falls vorhanden
 */

_VOID WinDials_AlertsInWindow(_BOOL doIt);
/* Aktiviert oder deaktiviert die Darstellung der
 * Alerts im Fenster
 */

#endif /* __CAT_WINDIALS_H__ */
