#include <portvdi.h>
#include <portaes.h>
#include <mtappl.h>
#include <mtarea.h>
#include <mtrsc.h>
#include <mtmenuba.h>
#include <mtxobjec.h>
#include <mtpopups.h>
#include <mtdials.h>
#include <mtalerts.h>
#include <ro_mem.h>

typedef _VOID (*FIX_OBJS)(OBJECT *tree, _BOOL isDial);
typedef _WORD (*DO_ALERT)(_WORD defBut, CONST _UBYTE *txt);
typedef _VOID (*GET_NAME)(_VOID *window, _WORD button, _UBYTE *name);
typedef _VOID (*TEST_FORM)(OBJECT *tree, _WORD editobj, _LONG get_n, _VOID *window);

typedef struct {
	FIX_OBJS fixObjs;
	DO_ALERT doAlert;
	TEST_FORM testForm;
	OBJECT *helpTree;
} INTERFACE;

typedef /* INTERFACE * */ _LONG (*INIT_OBFIX)(_BOOL init);

GLOBAL _UBYTE ProgramName[] = "EXTOBFIX";
GLOBAL _BOOL PrgHasDataBase=FALSE;		/*DYJ 5.26a */

LOCAL INTERFACE localProcs;
LOCAL RESOURCE rsc;

LOCAL _UBYTE RscData[] = {
#include <extobfix.inc>
};
#include <extobfix.h>
 

LOCAL _VOID testForm(OBJECT *tree, _WORD editObj, _LONG get_n, _VOID *window)
{
	GRECT r;
	_WORD but;
	_UBYTE alt[512];
	_UBYTE name[256];
	
	if (mtDials_NewDial(tree))									/* Neuen Dialog erzeugen */
	{
		mtDials_DialCenter(tree, CSCREEN, 0, 0, &r);			/* zentrieren */
		mtDials_DialForm(tree, DSTART, &r, &r);					/* Bildschirm reservieren */
		do
		{
			mtDials_DialDraw(tree, ROOT, MAX_DEPTH, &r, FALSE);	/* Dialog zeichnen */
			but = mtDials_DialDo(tree, editObj);				/* FormDo-Ersatz   */
			/* Button deselektieren */
			tree[but & 0x7fff].ob_state &= ~SELECTED;
			/* Jetzt getName aufrufen mit TC-Parametern */
			if (get_n == 0)
				break;
			((GET_NAME)get_n)(window, but, name);
			/* Jetzt String zusammenbauen */
			sprintf(alt, "[0][Exitbutton:|%d = '%s'|][:[Abbruch|.[Weiter]", but, name);
		} while (mtAlerts_Alert(2, alt) == 2);					/* Alert ausgeben */
		mtDials_DialForm(tree, DFINISH, &r, &r);				/* Bildschirm freigeben */
		mtDials_DisposeDial(tree);								/* und Dialog freigeben */
	}
}


LOCAL _VOID fixObjs(OBJECT *tree, _BOOL is_dialog)
{
	UNUSED(tree);
	UNUSED(is_dialog);
}


LOCAL _WORD doAlert(_WORD defBut, CONST _UBYTE *txt)
{
	return mtAlerts_Alert(defBut, txt);
}


LOCAL /* INTERFACE * */ _LONG InitObfix(_BOOL init)
{
	if (init)
	{
		/* Alle Module initialisieren */
		ApplInit();
		if (mtDials_Init())
		{
			/* Jetzt Resource relozieren */
			rsc = RscReloc(RscData, sizeof(RscData));
			if (rsc != NULL)
			{
				/* Adressen der Prozeduren eintragen */
				localProcs.fixObjs = fixObjs;
				localProcs.doAlert = doAlert;
				localProcs.testForm = testForm;
				/* Adresse der Help-Seite eintragen */
				localProcs.helpTree = RscGaddr(rsc, R_TREE, HELP_EXTEND);
				return (_LONG)&localProcs;
			} else
			{
			}
		}
	} else
	{
#if 0
		if (rsc != NULL)
		{
			RscFree(rsc);
			rsc = NULL;
		}
#else
		mem_test_ignore();
#endif
		ApplTerm(0);
	}
	return 0;
}

LOCAL struct {
	_UBYTE magic[8];
	INIT_OBFIX initObfix;
} interface_entry = {
	"06101965",
	InitObfix
};


LOCAL _VOID get_name(_VOID *window, _WORD button, _UBYTE *name)
{
	UNUSED(window);
	UNUSED(button);
	*name = '\0';
}


int main(void)
{
	INTERFACE *intf;
	
	if ((intf = (INTERFACE *)interface_entry.initObfix(TRUE)) != NULL)
	{
		intf->testForm(intf->helpTree, ROOT, (_LONG)0, NULL);
		interface_entry.initObfix(FALSE);
	}
	return 0;
}
