MODULE ExtObFix;

(*$R-,S-*)
FROM SYSTEM     IMPORT ADDRESS, ADR, _BYTE, CADR, ASSEMBLER, CALLSYS;

IMPORT MagicVDI;
IMPORT MagicAES;
IMPORT mtAppl;
IMPORT mtArea;
IMPORT mtRsc;
IMPORT mtMenubase;
IMPORT mtXobjects;
IMPORT mtPopups;
IMPORT mtDials;
IMPORT mtAlerts;
IMPORT StrConv;
IMPORT MagicStrings;

(*$Z+*)
TYPE Rectangle = RECORD
                  x, y, w, h : INTEGER
                 END;

TYPE    tObjcTree =     POINTER TO ARRAY [0..MAX(INTEGER)] OF MagicAES.OBJECT;

(*----------------------------------------------------------------------*
 *        Resource-Coder 1.03  (C)92 by Peter Hellinger Software        *
 *----------------------------------------------------------------------*
 *           Inline-Resource erzeugt am 15.10.1993 12:56:34             *
 *----------------------------------------------------------------------*)
 
TYPE tRscData = ARRAY [0..557] OF CARDINAL;
 
CONST RscData = tRscData {

        }; (* Ende RscData *)
(*----------------------------------------------------------------------*)

(* Eigener Stack, da MM2 den Stack auf A3 liegen hat und der von
 * Interface wohl nicht initialisiert wird
 *)

VAR myStack : ARRAY [0..2047] OF _BYTE;
                 
PROCEDURE TestForm(tree : tObjcTree; editobj: INTEGER; get_n : ADDRESS; window : ADDRESS);
  VAR r : Rectangle;
      usr, but : INTEGER;
      name: ARRAY[0..59] OF _UBYTE;
      alt : ARRAY [0..127] OF _UBYTE;
BEGIN
  IF mtDials.NewDial (tree)                  (* Neuen Dialog erzeugen *)
  THEN
    mtDials.DialCenter (tree, mtDials.CSCREEN, 0, 0, r);     (* zentrieren *)
    mtDials.DialForm (tree, mtDials.DSTART, r, r);           (* Bildschirm reservieren *)
    REPEAT
      mtDials.DialDraw (tree, 0, 99, r, FALSE);              (* Dialog zeichnen *)
      but := mtDials.DialDo (tree, editobj);                 (* FormDo-Ersatz   *)
      (* Button deselektieren *)
      EXCL (tree^[but].obState, MagicAES.SELECTED);
      (* Jetzt getName aufrufen mit TC-Parametern *)
      ASSEMBLER
        MOVEM.L D0-A6,-(SP)     ; Register sichern 
        MOVE.W  but(A6),D0      ; Button nach D0
        MOVE.L  window(A6),A0   ; window nach A0
        LEA     name(A6),A1     ; name nach A1
        MOVE.L  get_n(A6),A2    ; get_n nach A2
        JSR     (A2)            ; Procedure aufrufen
        MOVEM.L (SP)+,D0-A6     ; Register restaurieren
      END;
      (* Jetzt String zusammenbauen *)
      MagicStrings.Assign ("[0][Exitbutton:|",alt);
      MagicStrings.Append (StrConv.IntToStr (but,0), alt);
      MagicStrings.Append (" = '", alt);
      MagicStrings.Append (name, alt);
      MagicStrings.Append ("'|][[Abbruch|[Weiter]", alt);
    UNTIL mtAlerts.Alert (2, alt) = 1;                    (* Alert ausgeben *)
    mtDials.DialForm (tree, mtDials.DFINISH, r, r);       (* Bildschirm freigeben *)
    mtDials.DisposeDial (tree);                           (* und Dialog freigeben *)
  END;
END TestForm;


(* Zwischenprozeduren, die mit TC-Registerbergabe aufgerufen werden *)

(*$L- keinen Eintrittscode fr die Prozedur erzeugen *)

(*
LOCAL _VOID test_form (tree, editobj, get_n, window)
OBJECT *tree;   A0
_WORD   editobj; D0
_LONG   get_n;   D1
_VOID   *window; A1
*)

PROCEDURE testForm ();
BEGIN
  ASSEMBLER
    MOVEM.L D1-A6,-(SP)
    LEA     myStack,A3  ; Stack einrichten fr MM2
    MOVE.L  A0,(A3)+    ; Parameter umkopieren 
    MOVE.W  D0,(A3)+
    MOVE.L  D1,(A3)+
    MOVE.L  A1,(A3)+
    JSR     TestForm     ; MM2-Routine aufrufen 
    MOVEM.L (SP)+,D1-A6
  END
END testForm;

PROCEDURE fixObjs();
(* OBJECT  *tree;       A0
 * _BOOL is_dialog;   D0
 *)
  (* Macht nichts, braucht auch nichts anderes aufrufen *)
END fixObjs;

PROCEDURE doAlert ();
(* _WORD defbut, D0
   _BYTE *txt)); A0
 *)
BEGIN
  (* Es werden einfach nur die Parameter umkopiert und dann 
   * direkt mtAlerts.Alert aufgerufen, da die Parameter identisch sind.
   *)
  ASSEMBLER
    MOVEM.L D1-A6,-(SP)
    LEA     myStack,A3  ; Stack einrichten fr MM2
    MOVE.W  D0,(A3)+    ; Default-Button
    MOVE.L  A0,(A3)+    ; String-Adresse
    MOVE.W  #255,(A3)+  ; High-Value fr String 
    JSR     mtAlerts.Alert/
    MOVEM.L (SP)+,D1-A6
  END
END doAlert;
(*$L=*)

VAR localProcs : ARRAY[0..4] OF ADDRESS;
    rsc        : mtRsc.RESOURCE;

PROCEDURE InitObfix (init : _BOOL) : ADDRESS;
  VAR voidO : _BOOL;
BEGIN
  IF init
  THEN
    (* Alle Module initialisieren *)
    mtAppl.InitMtAppl();
    mtArea.InitMtArea();
    mtAlerts.InitMtAlerts();
    mtMenubase.InitMtMenubase();
    mtPopups.InitMtPopups();
    mtXobjects.InitMtXobjects();
    mtRsc.InitMtRsc();
    (* Jetzt Resource relozieren *)
    rsc = RscReloc (RscData);
    (* Adressen der Prozeduren eintragen *)
    localProcs[0] := ADDRESS(fixObjs);
    localProcs[1] := ADDRESS(doAlert);
    localProcs[2] := ADDRESS(testForm);
    (* Adresse der Help-Seite eintragen *)
    localProcs[3] := RscGaddr (rsc, MagicAES.R_TREE, 0);
    RETURN ADR(localProcs);
  ELSE
    RETURN NIL
  END;
END InitObfix;  


(*$L-*)
PROCEDURE pInitObfix();
BEGIN
  ASSEMBLER
    MOVEM.L D1-A6,-(SP)
    LEA     myStack,A3  ; Stack einrichten fr MM2
    MOVE.W  D0,(A3)+    ; status auf Stack
    JSR     InitObfix/  ; und M2-Initprozedur aufrufen 
    MOVEM.L (SP)+,D1-A6
  END
END pInitObfix;
(*$L=*)

VAR voidI : INTEGER;

BEGIN
  ASSEMBLER
    BRA.S   start
    LEA     m1(PC),A0               ; fr Linker
    LEA     m2(PC),A0               ; fr Linker
m1: DC.L    $30363130,$31393635     ; '06101965'
    SYNC
m2: DC.L    pInitObfix
start:
  END;
  voidI := mtAlerts.Alert (1,"[3][This program can|only be started from|Interface!][[Cancel]");
END ExtObFix.
