#include <mtappl.h>
#include <mtmenus.h>
#include <mtwindow.h>
#include <mtfonts.h>
#include <mtfontse.h>
#include <mtutils.h>
#include <mtrsc.h>
#include <mttext.h>
#include <mtdials.h>
#include <mtpopups.h>
#include <mtalerts.h>
#include <mtaesmen.h>
#include <routine.h>

#include <magic.h>

#define cResolution "[3][Bitte benutzen Sie f\201r einen|korrekten Programmablauf|mindestens eine Aufl\224sung|von 640 x 200 Punkten!][ [Ok ]"
#define cTitle      "[0][%DMagicDemo||Das Demo zu den MagicTools...|(C)92 by Peter Hellinger||Dieses Programm ist Freeware!|][ [Ok ]"
#define cAlert1     "[0][Es k\224nnen bis zu 16 Zeilen und 4 Buttons in einem|"
#define cAlert2     "Alert dargestellt werden. Auch in der Gr\224\236e des Icon-Images|"
#define cAlert3     "ist man nicht begrenzt. Jede Alert-Zeile darf bis zu 60|"
#define cAlert4     "Zeichen aufnehmen. Es k\224nnen auch in gewissem Grenzen|"
#define cAlert5     "Effekte eingesetzt werden:||"
#define cAlert6     "%D Diese Zeile wird doppelt unterstrichen.||"
#define cAlert7     "%U Diese Zeile wird einfach unterstrichen.||"
#define cAlert8     "%F Und diese wird Fett geschrieben][[Toll|[Prima|[Klasse|[Ok]"
        
#define MaxLines 400

GLOBAL _UBYTE ProgramName[] = "Magic";

typedef enum { info_open, info_close, redraw, lineup, linedown, pageup, pagedown } InfoAction;

LOCAL RESOURCE Rsc;
LOCAL _UBYTE string[513];
LOCAL _BOOL WinOpen, Win2Open;
LOCAL _WORD win, win2;
LOCAL TERMINAL old, term, term2;
LOCAL GRECT scr, small, rect, bar;
LOCAL MENUBAR Menubar;
LOCAL TEXT Text;
LOCAL _WORD pos, zeilen;


LOCAL _VOID WriteScreen(_VOID)
{
	_WORD i;
	LINE l;
	PtrString z;
	
	TerminalClearScreen();
	l = mtText_FindNumber(Text, pos);
	for (i = 0; i < TerminalLines; i++)
	{
		if (l != mtText_NilLine())
		{
			z = mtText_GetLinePtr(l);
			TerminalGotoXY(0, i);
			TerminalWriteLine(z);
			l = mtText_NextLine(l);
		}
	}
}


LOCAL _VOID LineUp(_VOID)
{
	LINE l;
	PtrString z;
	
	if (pos > 0)
	{
		--pos;
		TerminalGotoXY(0, 0);
		TerminalInsertLine();
		l = mtText_FindNumber(Text, pos);
		if (l != mtText_NilLine())
		{
			z = mtText_GetLinePtr(l);
			TerminalWriteLine(z);
		}
		MouseOn();
	}
}


LOCAL _VOID LineDown(_VOID)
{
	LINE l;
	PtrString z;
	
	if (pos < zeilen)
	{
		TerminalGotoXY(0, 0);
		TerminalDeleteLine();
		TerminalGotoXY(0, TerminalLines);
		++pos;
		l = mtText_FindNumber(Text, pos);
		if (l != mtText_NilLine())
		{
			z = mtText_GetLinePtr(l);
			TerminalWriteLine(z);
		}
		MouseOn();
	}
}


LOCAL _VOID PageUp(_VOID)
{
	pos -= TerminalLines;
	if (pos < 0)
		pos = 0;
	WriteScreen();
	MouseOn();
}


LOCAL _VOID PageDown(_VOID)
{
	pos += TerminalLines;
	if (pos >= (zeilen - TerminalLines))
		pos = zeilen - TerminalLines;
	if (pos < 0)
		pos = 0;
	WriteScreen();
	MouseOn();
}		


LOCAL _VOID ShowInfo(InfoAction action)
{
	GRECT r;
	
	switch (action)
	{
	case info_open:
		if (Win2Open)
		{
			mtWindows_WindowTop(win2);
		} else
		{
			mtWindows_NewWindow(NAME|CLOSER|MOVER|VSLIDE|UPARROW|DNARROW|SIZER|FULLER, " Info \201ber Magic ", "  ", &win2);
			mtWindows_MaxWorkarea(win2, &r);
			r.g_x += 10;
			r.g_y += 10;
			r.g_w -= 20;
			r.g_h -= 20;
			mtWindows_OpenWindow(win2, &r);
			term2 = OpenTerminal(&r);
			old = ChangeTerminal(term2);
			mtWindows_ConnectTerminal(win2, term2);
			TerminalClearScreen();
			pos = 0;
			Win2Open = TRUE;
		}
		break;
	
	case info_close:
		CloseTerminal(&term2);
		mtWindows_DeleteWindow(&win2);
		Win2Open = FALSE;
		win2 = -1;
		return;
	
	case redraw:
		WriteScreen();
		break;
	
	case lineup:
		LineUp();
		break;

	case linedown:
		LineDown();
		break;
	
	case pageup:
		PageUp();
		break;
	
	case pagedown:
		PageDown();
		break;
	}
	mtWindows_WindowSlider(win2, 0, zeilen, TerminalLines, pos);
}


LOCAL _VOID ShowDialog(_WORD tree, _WORD exit, _WORD edit)
{
	_WORD i;
	OBJECT *dial;
	
	dial = RscGaddr(Rsc, R_TREE, tree);
	mtDials_NewDial(dial);
	mtDials_DialCenter(dial, CSCREEN, 0, 0, &rect);
	mtDials_DialForm(dial, DSTART, &small, &rect);
	mtDials_DialForm(dial, DGROW, &small, &rect);
	mtDials_DialDraw(dial, ROOT, MAX_DEPTH, &scr, FALSE);
	for (;;)
	{
		i = mtDials_DialDo(dial, edit);
		DoubleClick(&i);
		if (i == exit)
		{
			DelObjState(dial, exit, SELECTED);
			break;
		}
	}
	mtDials_DialForm(dial, DSHRINK, &small, &rect);
	mtDials_DialForm(dial, DFINISH, &small, &rect);
	mtDials_DisposeDial(dial);
}


LOCAL _VOID SetCircle(OBJECT *dial, OBJECT *pop, _WORD index)
{
	_UBYTE str[41];
	
	if (index > 0 && index <= MaxColors)
	{
		ObjcString(pop, index, str, sizeof(str));
		SetObjcString(dial, Circtext, str);
		--index;
		
		OBSPEC_SET_INTERIORCOL(dial[Circcolr].ob_spec, index);
		mtDials_DialDraw(dial, Circtext, ROOT, &scr, FALSE);
		mtDials_DialDraw(dial, Circcolr, ROOT, &scr, FALSE);
	}
}


LOCAL _VOID ShowCircle(_VOID)
{
	OBJECT *dial, *pop;
	_UBYTE str[41];
	_WORD i, x, y, idx, index;
	
	dial = RscGaddr(Rsc, R_TREE, Circle);
	pop = RscGaddr(Rsc, R_TREE, Popup2);
	mtDials_NewDial(dial);
	mtDials_NewDial(pop);
	mtDials_SetUserkey(dial, Circbutt, 102, 0, TRUE, TRUE);
	mtDials_SetUserkey(dial, Circtext, 101, 0, TRUE, TRUE);
	index = Weiss;
	
	ObjcString(pop, index, str, sizeof(str));
	SetObjcString(dial, Circtext, str);
	
	mtDials_DialCenter(dial, CSCREEN, 0, 0, &rect);
	mtDials_DialForm(dial, DSTART, &small, &rect);
	mtDials_DialForm(dial, DGROW, &small, &rect);
	mtDials_DialDraw(dial, ROOT, MAX_DEPTH, &rect, FALSE);
	SetCircle(dial, pop, 1);
	
	for (i = MaxColors + 1; i <= Hellmage; i++)
		SetObjState(pop, i, DISABLED);
	
	for (;;)
	{
		i = mtDials_DialDo(dial, -1);
		DoubleClick(&i);
		switch (i)
		{
		case Circbutt:
			++index;
			if (index > Hellmage)
				index = Weiss;
			while (GetObjState(pop, index, DISABLED))
			{
				++index;
				if (index > Hellmage)
					index = Weiss;
			}
			SetCircle(dial, pop, index);
			break;
		
		case Circtext:
			objc_offset(dial, Circtext, &x, &y);
			idx = mtPopups_TreePopup(pop, x, y, index - 1);
			if (index >= Weiss && index <= Hellmage)
				index = idx, SetCircle(dial, pop, index);
			break;
		
		case Circok:
			DelObjState(dial, Circok, SELECTED);
			goto done;
		}
	}
done:
	mtDials_DialForm(dial, DSHRINK, &small, &rect);
	mtDials_DialForm(dial, DFINISH, &small, &rect);
	mtDials_DisposeDial(pop);
	mtDials_DisposeDial(dial);
}


LOCAL _VOID ShowWinmenu(_VOID)
{
	OBJECT *tree;
	_WORD i;
	
	tree = RscGaddr(Rsc, R_TREE, Menuline);
	i = mtAlerts_Alert(1, "[2][Bitte w\204hlen Sie den|Modus der Men\201zeile:][[Click|[Drop|[Pull]");
	switch (i)
	{
	case 1:
		mtMenus_ConfigMenu(click);
		break;
	case 2:
		mtMenus_ConfigMenu(drop);
		break;
	case 3:
		mtMenus_ConfigMenu(pull);
		break;
	}
	if (WinOpen == FALSE)
	{
		if (!mtMenus_NewMenu(tree, &Menubar))
		{
			mtAlerts_Alert(1, "[3][Men\201zeile konnte nicht eingerichtet werden.][[Schade]");
			return;
		}
		mtWindows_MaxWorkarea(win, &rect);
		rect.g_x = 100;
		rect.g_y = 100;
		rect.g_w /= 2;
		rect.g_h /= 2;
		mtWindows_OpenWindow(win, &rect);
		term = OpenTerminal(&rect);
		mtWindows_ConnectTerminal(win, term);
		mtMenus_DrawMenu(Menubar, win, &bar);
		WinOpen = TRUE;
	}
}


LOCAL _VOID CloseWinmenu(_VOID)
{
	if (WinOpen)
	{
		CloseTerminal(&term);
		mtWindows_CloseWindow(win);
		mtWindows_DeleteWindow(&win);
		mtMenus_FreeMenu(&Menubar);
		WinOpen = FALSE;
		win = -1;
	}
}



LOCAL _VOID ShowPopupline(_VOID)
{
	OBJECT *menu;
	
	menu = RscGaddr(Rsc, R_TREE, Menuline);
	mtPopups_PopupMenu(menu, " PopupMenu ");
}


LOCAL _VOID ShowPopups(_VOID)
{
	OBJECT *pop;
	
	strBcpy(string, "  Eintrag 1|  Eintrag 2|  Eintrag 3|  Eintrag 4|  Eintrag 5");
	mtPopups_StringPopup(string, " StringPopup ");
	pop = RscGaddr(Rsc, R_TREE, Popup2);
	mtPopups_TreePopup(pop, MaxWidth / 4, MaxHeight / 4, 1);
}


LOCAL _VOID ShowAlerts(_VOID)
{
	_WORD i;
	
	i = mtAlerts_Alert(1, "[2][Art der Icons:][ [Atari-Like | [Mac-Like ]");
	switch (i)
	{
	case 1:
		mtAlerts_ConfigAlert(alert_gemicon);
		break;
	default:
		mtAlerts_ConfigAlert(alert_alticon);
		break;
	}
	i = mtAlerts_Alert(2, "[2][Justierung der Buttonkn\224pfe:][ [Links | [Mitte | [Rechts ]");
	switch (i)
	{
	case 1:
		mtAlerts_ConfigAlert(alert_left);
		break;
	case 3:
		mtAlerts_ConfigAlert(alert_right);
		break;
	default:
		mtAlerts_ConfigAlert(alert_center);
		break;
	}
	strBcpy(string, cAlert1);
	strBcpy(string, cAlert2);
	strBcat(string, cAlert3);
	strBcat(string, cAlert4);
	strBcat(string, cAlert5);
	strBcat(string, cAlert6);
	strBcat(string, cAlert7);
	strBcat(string, cAlert8);
	mtAlerts_Alert(1, string);
}


LOCAL _VOID ShowFontsel(_VOID)
{
	_WORD font, size, skew;
	fix31 width;
	_UWORD effekt;
	
	if (TerminalTextHandle > 0)
	{
		mtFontselector_FontSelector(TerminalTextHandle,
			"Fontauswahl (nur Monospaced)",
			TRUE, TRUE, &font, &size, &width, &skew, &effekt);
		if (WinOpen)
		{
			UpdateTerminal();
			TerminalClearScreen();
		}
	}
}


LOCAL _VOID RedrawWin(_WORD window, _WORD x, _WORD y, _WORD w, _WORD h)
{
	GRECT rm, rl;
	_WORD f;
	
	VarsToRect(x, y, w, h, FALSE, &rm);
	f = 0;
	for (;;)
	{
		if (!mtWindows_RectList(window, f, &rl))
			break;
		f = 1;
		if (mtWindows_RcIntersect(&rm, &rl))
		{
			TerminalClipRect(TRUE, &rl);
			if (window == win)
			{
				ChangeTerminal(term);
				TerminalClearScreen();
			} else if (window == win2)
			{
				ChangeTerminal(term2);
				TerminalClearScreen();
				ShowInfo(redraw);
			}
		}
	}
	TerminalClipRect(FALSE, &rl);
}


LOCAL _WORD mesag[8];
LOCAL _WORD taste, scan, clicks, title, item, x, y;
LOCAL _UWORD event, button, kbshift;
LOCAL _UBYTE ascii;
LOCAL _BOOL ExitProgram;
LOCAL OBJECT *menu;


LOCAL _VOID AboutAlert(_VOID)
{
	mtAlerts_Alert(1, cTitle);
}


LOCAL _VOID DoMenu(_WORD title, _WORD item)
{
	ExitProgram = FALSE;
	switch (item)
	{
#if 0
		case Info: AboutAlert(); break;
#else
		case Info: ShowDialog(About, Aboutok, -1); break;
#endif
		case Quit: ExitProgram = TRUE; break;
		case Moveobjc: ShowDialog(Mover, Moverok, -1); break;
		case Stringob: ShowDialog(String, Stringok, -1); break;
		case Buttonob: ShowDialog(Buttons1, Butt1ok, -1);
					   ShowDialog(Buttons2, Butt2ok, -1); break;
		case Frameobj: ShowDialog(Frame, Frameok, -1); break;
		case Circleob: ShowCircle(); break;
		case Editobjc: ShowDialog(Edit, Editok, Editable); break;
		case Winmenu: ShowWinmenu(); break;
		case Popupmen: ShowPopupline(); break;
		case Popups: ShowPopups(); break;
		case Alertbox: ShowAlerts(); break;
		case Fontsel: ShowFontsel(); break;
		case Windial: break;
	}
	menu_tnormal(menu, title, 1);
}


LOCAL _VOID DoKeyboard(_WORD scan, _UWORD kbshift)
{
	_WORD title, item;
	
	if (ScanMenu(menu, scan, kbshift, &title, &item))
	{
		mesag[0] = MN_SELECTED;
		mesag[1] = ApplIdent;
		mesag[2] = 0;
		mesag[3] = title;
		mesag[4] = item;
		event |= MU_MESAG;
	} else if (scan == 0x62)
	{
		ShowInfo(info_open);
	}
}


int main(_VOID)
{
	_WORD i;
	
	ApplInit();
	mtDials_Init();
	
	mtAlerts_ConfigAlert(alert_right);
	mtAlerts_ConfigAlert(alert_alticon);
	
	if (MaxWidth < 639)
	{
		mtAlerts_Alert(1, cResolution);
	} else
	{
		scr.g_x = 0;
		scr.g_y = 0;
		scr.g_w = MaxWidth;
		scr.g_h = MaxHeight;
		
		small.g_x = MaxWidth / 2;
		small.g_y = MaxHeight / 2;
		small.g_w = 2;
		small.g_h = 2;
		
		WinOpen = FALSE;
		if ((Rsc = RscLoad("cmagic.rsc")) != NULL)
		{
			mtTerminal_Init();
			strBcpy(string, "cmagic.inf");
			shel_find(string);
			mtText_NewTEXT(&Text);
			i = mtText_ReadText(Text, string);
			zeilen = (_WORD)mtText_GetNumber(Text);
			if (i == 0)
			{
				menu = RscGaddr(Rsc, R_TREE, Mainmenu);
				InitMenuline(menu);
				DrawMenuline(menu);
#if 0
				AboutAlert();
#endif
				while (!ExitProgram)
				{
					MouseArrow();
					event = evnt_multi(MU_MESAG|MU_KEYBD|MU_M1,
						0, 0, 0,
						0, bar.g_x, bar.g_y, bar.g_w, bar.g_h,
						0, 0, 0, 0, 0,
						mesag,
						0, 0,
						&x, &y, &button, &kbshift, &taste, &clicks);
					scan = (taste >> 8) & 0xff;
					ascii = taste & 0xff;
					if (event & MU_KEYBD)
						DoKeyboard(scan, kbshift);
					
					if (event & MU_MESAG)
					{
						switch (mesag[0])
						{
						case MN_SELECTED:
							DoMenu(mesag[3], mesag[4]);
							break;
						case WM_REDRAW:
							RedrawWin(mesag[3], mesag[4], mesag[5], mesag[6], mesag[7]);
							MouseOn();
							break;
						case WM_TOPPED:
							mtWindows_WindowTop(mesag[3]);
							if (mesag[3] == win)
							{
								mtMenus_DrawMenu(Menubar, win, &bar);
								ChangeTerminal(term);
								MouseOn();
							} else if (mesag[3] == win2)
							{
								ChangeTerminal(term2);
								ShowInfo(redraw);
							}
							break;
						case WM_CLOSED:
							if (mesag[3] == win)
								CloseWinmenu();
							else if (mesag[3] == win2)
								ShowInfo(info_close);
							else
								mtWindows_CloseWindow(mesag[3]);
							break;
						case WM_FULLED:
							mtWindows_WindowFulled(mesag[3]);
							if (mesag[3] == win)
							{
								mtMenus_DrawMenu(Menubar, win, &bar);
								TerminalClearScreen();
								MouseOn();
							}
							break;
						case WM_SIZED:
							mtWindows_WindowSize(mesag[3], mesag[6], mesag[7]);
							if (mesag[3] == win)
							{
								mtMenus_DrawMenu(Menubar, win, &bar);
								TerminalClearScreen();
								MouseOn();
							}
							break;
						case WM_MOVED:
							mtWindows_WindowPos(mesag[3], mesag[4], mesag[5]);
							if (mesag[3] == win)
							{
								mtMenus_DrawMenu(Menubar, win, &bar);
								MouseOn();
							}
							break;
						case WM_ARROWED:
							if (mesag[3] == win2)
							{
								switch (mesag[4])
								{
									case WA_UPPAGE: ShowInfo(pageup); break;
									case WA_DNPAGE: ShowInfo(pagedown); break;
									case WA_UPLINE: ShowInfo(lineup); break;
									case WA_DNLINE: ShowInfo(linedown); break;
								}
							}
							break;
						}
					}
					
					if (event & MU_M1)
					{
						if (win == mtWindows_TopWindow())
						{
							mtMenus_HandleMenu(Menubar, &title, &item);
							if (title > 0)
							{
								TerminalWriteConst("Objektnummer Men\201:    ");
								TerminalWriteInt(title, 0);
								TerminalWriteLn();
								TerminalWriteConst("Objektnummer Eintrag: ");
								TerminalWriteInt(item, 0);
								TerminalWriteLn();
								MouseOn();
							}
						}
					}
					
#if 0
					if (ExitProgram)
					{
						i = mtAlerts_Alert(1, "[2][|%FWirklich beenden?][[Ja|[Nein]");
						if (i != 1)
							ExitProgram = FALSE;
					}
#endif
				}
				mtText_DisposeTEXT(&Text);
				CloseWinmenu();
				ShowInfo(info_close);
			} else
			{
				mtAlerts_Alert(1, "[3][|%FInfo-Text konnte nicht gelesen werden!][ [Hoppla! ]");
			}
		} else
		{
			mtAlerts_Alert(1, "[3][|%FResource nicht gefunden!][ [Hoppla! ]");
		}
	}
	if (rsc != NULL)
	{
		RscFree(rsc);
		rsc = NULL;
	}
	ApplTerm(0);
	return 0;
}
