/*
 * Diese Datei ist Teil der Magic-Library,
 * und darf in dieser Form nur als Teil des CAT-Projekts
 * verwendet werden.
 * 
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Magic ist Copyright (c) by Peter Hellinger.
 *
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */

#include <magiccoo.h>
#include <magicsys.h>


typedef struct {
	_ULONG id;
	_LONG val;
} tCookie, *tJar;

typedef union {
	_ULONG id;
	_UBYTE c[4];
} tId;

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

GLOBAL _BOOL FindCookie(const _UBYTE *cookie, _LONG *value)
{
	_BOOL b;
	tJar Jar, p;
	tId dummy;
	
	b = FALSE;
	Jar = (tJar)SysGetLVal(0x5a0);
	if (Jar != NULL)
	{
		dummy.c[0] = cookie[0];
		dummy.c[1] = cookie[1];
		dummy.c[2] = cookie[2];
		dummy.c[3] = cookie[3];
		p = Jar;
		while (p->id != 0 && !b)
		{
			if (p->id == dummy.id)
			{
				if (value != NULL)
					*value = p->val;
				b = TRUE;
			}
			p++;
		}
	}
	return b;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _BOOL ModifyCookie(const _UBYTE *cookie, _LONG value)
{
	_BOOL b;
	tJar Jar, p;
	tId dummy;
	
	b = FALSE;
	Jar = (tJar)SysGetLVal(0x5a0);
	if (Jar != NULL)
	{
		dummy.c[0] = cookie[0];
		dummy.c[1] = cookie[1];
		dummy.c[2] = cookie[2];
		dummy.c[3] = cookie[3];
		p = Jar;
		while (p->id != 0 && !b)
		{
			if (p->id == dummy.id)
			{
				p->val = value;
				b = TRUE;
			}
			p++;
		}
	}
	return b;
}
