/*
 * Diese Datei ist Teil der Magic-Library,
 * und darf in dieser Form nur als Teil des CAT-Projekts
 * verwendet werden.
 * 
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Magic ist Copyright (c) by Peter Hellinger.
 *
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */


#include <magicstr.h>
#include <routinec.h>
#include <routines.h>


/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID Insert(CONST _UBYTE *substr, _UBYTE *str, size_t strsize, size_t inx)
{
	size_t i, l1, l;
	
	l1 = strLen(substr);
	if (l1 == 0)
		return;
	l = strLen(str);
	if (l + l1 >= strsize)
		l = strsize - l1 - 1;
	if (inx == 0) /* --i wuerde bis (size_t)-1 laufen !!! */
	{
		for (i = l + 1; --i > 0; )
			str[i + l1] = str[i];
		str[l1] = str[0];
	} else
	{
		for (i = l + 1; --i >= inx; )
			str[i + l1] = str[i];
	}
	for (i = 0; i < l1; i++)
		str[i + inx] = substr[i];
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID Delete(_UBYTE *str, size_t index, size_t len)
{
	size_t l, i;
	
	l = strLen(str);
	if ((index + len) > l)
		len = l - index;
	for (i = index; i < (l - len); i++)
		str[i] = str[i + len];
	str[l - len] = '\0';
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID Copy(CONST _UBYTE *str, size_t index, size_t len, _UBYTE *result, size_t strsize)
{
	size_t l;
	
	l = strLen(str);
	if ((index + len) > l)
		len = l - index;
	if (len >= strsize)
		len = strsize - 1;
	str += index;
	while (len)
	{
		*result++ = *str++;
		len--;
	}
	*result = '\0';
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL size_t Pos(CONST _UBYTE *substr, CONST _UBYTE *str, size_t start, _BOOL dowild)
{
#define wild '*'
#define joker '?'
	size_t jl, sl, maxs, s, j;
	_UBYTE ch;
	
	sl = strLen(str);
	jl = strLen(substr);
	if (jl == 0 || sl == 0 || (start + jl) > sl)
		return POS_NOT_FOUND;
	maxs = sl - jl;
	for (;;)
	{
		j = 0;
		s = start;
		for (;;)
		{
			while (substr[j] != '\0' &&
				(dowild && (substr[j] == wild || substr[j] == joker)) &&
				str[s] != '\0')
			{
				ch = substr[j++];
				if (ch == wild && dowild)
				{
					ch = substr[j];
					while (str[s] != ch && str[s] != '\0')
						++s;
				} else
				{
					++s;
				}
			}
			if (j >= jl)
				return start;
			if (substr[j] != str[s])
				break;
			++j;
			++s;
			if (j >= jl)
				return start;
		}
		++start;
		if (start > maxs)
			return POS_NOT_FOUND;
	}
}
