/*
 * Diese Datei ist Teil der Magic-Library,
 * und darf in dieser Form nur als Teil des CAT-Projekts
 * verwendet werden.
 * 
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Magic ist Copyright (c) by Peter Hellinger.
 *
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */


#include <magicsys.h>
#ifndef __TOS_H__
#include <tos.h>
#endif

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

GLOBAL _ULONG SysGetLVal(_ULONG adr)
{
	_ULONG even;
	_ULONG val1;
	_ULONG val2;
	
	if (Ssystem(-1, 0, 0) == 0)
		return Ssystem(S_GETLVAL, adr, 0);
	switch ((int)(adr & 3))
	{
	case 1:
		even = adr - 1;
		val1 = (_ULONG)Setexc((int)(even / 4), (_VOID(*)(_VOID))-1);
		val2 = (_ULONG)Setexc((int)((even + 4) / 4), (_VOID(*)(_VOID))-1);
		return (val1 << 8) | ((val2 >> 24) & 0xff);
	case 2:
		even = adr - 2;
		val1 = (_ULONG)Setexc((int)(even / 4), (_VOID(*)(_VOID))-1);
		val2 = (_ULONG)Setexc((int)((even + 4) / 4), (_VOID(*)(_VOID))-1);
		return (val1 << 16) | ((val2 >> 16) & 0xffffl);
	case 3:
		even = adr - 3;
		val1 = (_ULONG)Setexc((int)(even / 4), (_VOID(*)(_VOID))-1);
		val2 = (_ULONG)Setexc(((int)(even + 4) / 4), (_VOID(*)(_VOID))-1);
		return (val1 << 24) | ((val2 >> 8) & 0xffffffl);
	}
	return (_ULONG)Setexc((int)(adr / 4), (_VOID(*)(_VOID))-1);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _UWORD TosVersion(_VOID)
{
	SYSHDR *sys;
	if (Ssystem(-1, 0, 0) == 0)
		return (_UWORD)(Ssystem(S_OSHEADER, 0, 0) & 0xffffl);
	sys = (SYSHDR *)SysGetLVal(0x4f2);
	return sys->os_version;
}
