/*
 * Diese Datei ist Teil der Magic-Library,
 * und darf in dieser Form nur als Teil des CAT-Projekts
 * verwendet werden.
 * 
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Magic ist Copyright (c) by Peter Hellinger.
 *
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */


#include <mtaesmen.h>
#include <mtappl.h>
#include <mtutils.h>
#include <portvdi.h>
#include <mtxobjec.h>
#include <termproc.h>

#include <ro_mem.h>

LOCAL OBJECT *menuline;

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

LOCAL _UWORD _CDECL DrawLine(PARMBLK *p)
{
	_WORD pxy[4];
	
	vsf_color(PrivateWS, BLACK);
	vsf_interior(PrivateWS, FIS_PATTERN);
	vsf_style(PrivateWS, IP_4PATT);
	pxy[0] = p->pb_x;
	pxy[1] = p->pb_y + p->pb_h / 2 - 1;
	pxy[2] = p->pb_x + p->pb_w - 1;
	pxy[3] = pxy[1] + 1;
	v_bar(PrivateWS, pxy);
	vsf_interior(PrivateWS, FIS_SOLID);
	vsf_style(PrivateWS, IP_HOLLOW);
	vsf_color(PrivateWS, WHITE);
	return NORMAL;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _BOOL InitMenuline(OBJECT *menu)
{
	OBJECT *line;
	_UBYTE str[80];
	_WORD i;
	
	i = 0;
	line = menu;
	for (;;)
	{
		str[0] = '\0';
		str[1] = '\0';
		str[2] = '\0';
		if (GetObjState(line, i, DISABLED))
		{
			ObjcString(line, i, str, sizeof(str));
			if (str[0] == '-' && str[1] == '-' && str[2] == '-')
			{
				if (!InstUserdef(line, i, DrawLine, NULL))
					return FALSE;
			}
		}
		if (GetObjFlags(line, i, LASTOB))
			break;
		++i;
	}
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID ResetMenuline(_VOID)
{
	_WORD i;
	
	if (menuline != NULL)
	{
		menu_bar(menuline, 0);
		i = 0;
		for (;;)
		{
			if ((menuline[i].ob_type & 0xff) == G_USERDEF)
				FreeUserdef(menuline, i);
			if (GetObjFlags(menuline, i, LASTOB))
				break;
			i++;
		}
		menuline = NULL;
	}
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID DrawMenuline(OBJECT *menu)
{
	menuline = menu;
	InstallTermproc(ResetMenuline);
	menu_bar(menu, 1);
}
