/*
 * Diese Datei ist Teil der Magic-Library,
 * und darf in dieser Form nur als Teil des CAT-Projekts
 * verwendet werden.
 * 
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Magic ist Copyright (c) by Peter Hellinger.
 *
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */


#define __MAGICTOOL_FONTS_INTERN__
#include <mtappl.h>
#include <fontsele.h>
#include <portaes.h>
#include <portvdi.h>
#include <tos.h>
#include <magicstr.h>
#include <magiccoo.h>
#include <magicsys.h>
#include <atari.h>

#include <ro_mem.h>
#include <routinec.h>
#include <routines.h>
#include <file_io.h>
#include <debug.h>
#include <xbra.h>
#include <termproc.h>

GLOBAL _WORD VDIHandle;         /* Handle der geoeffneten Workstation */
GLOBAL _WORD MaxWidth;          /* Maximale Anzahl Pixel waagerecht   */
GLOBAL _WORD MaxHeight;         /* Maximale Anzahl Pixel senkrecht    */
GLOBAL _WORD MaxColors;         /* Maximale Anzahl Farben             */
GLOBAL _WORD Bitplanes;         /* Anzahl der Bitplanes               */
GLOBAL _WORD CharWidth;         /* Werte von MagicAES.GrafHandle      */
GLOBAL _WORD CharHeight;        /* -"- */
GLOBAL _WORD BoxWidth;          /* -"- */
GLOBAL _WORD BoxHeight;         /* -"- */
GLOBAL _WORD AESFontid;         /* Font-ID des AES-Fonts              */
GLOBAL _WORD AESFontsize;       /* Hoehe des AES-Fonts                */
GLOBAL _BOOL AESFontMonospaced; /* Flag monospaced/proportional       */
GLOBAL _WORD PrivateWS;

GLOBAL GRECT deskSize;              /* Die Ausmasse des Desktops */

/* Nur zum Lesen! */
GLOBAL _BOOL multiGEM;				/* ist MultiGEM (uaeaeh) installiert? */
GLOBAL _BOOL multiTOS;				/* oder MultiTos */
GLOBAL _BOOL multiTask;				/* Allgemein Multitasking (Mag!X oder MultiTOS) */
GLOBAL _BOOL magIx;					/* ist Mag!X installiert? */
GLOBAL _UWORD magIxVer=0;			/* Welche Mag!X-Version */
GLOBAL _BOOL magicMac;				/* ist das hier ein Mac? */
GLOBAL _BOOL magicPC;               /* oder vielleicht eher ein PC? */
GLOBAL _BOOL UseCatDelink;          /* Sollen unter MagicPC Links von Cat verfolgt werden? */
GLOBAL _BOOL IsMagiCScroll;			/* MagiC handelt lange Editfelder */

/*** ---------------------------------------------------------------------- ***/

#define ABCGEM         0x210

#define NDC            0
#define RC             2

#define MaxMaus        64	/* Verschachtelungstiefe von Store/RestoreMouse */

LOCAL _WORD WorkInArray[57];
LOCAL _WORD WorkOutArray[57];
LOCAL _UBYTE applpath[PATH_MAX];
LOCAL _UBYTE applname[PATH_MAX];


LOCAL WsPtr WorkStation;

LOCAL _ULONG gdos;
LOCAL _WORD phys_handle;
LOCAL _WORD fsm_errorcode;

typedef struct {
	_BOOL sicht;
	_WORD form;
	_VOID *user;
} tMerker;

LOCAL tMerker Maus[MaxMaus];
LOCAL _UWORD Merker;

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

GLOBAL WsPtr Intern(HVDI handle)
{
	WsPtr p;
	
	if (handle == -1)
		return WorkStation;
	p = WorkStation;
	while (p != NULL)
	{
		if (p->handle == handle)
			return p;
		p = p->next;
	}
	return NULL;
}

/*** ---------------------------------------------------------------------- ***/

#if SPEC_DEBUG

struct emu_info {
	_LONG regd5;
	_LONG regd6;
	_LONG regd7;
	_UBYTE *regbase;
};

#ifdef __PUREC__
LOCAL _VOID emu01(struct emu_info *) 0x48e7;
LOCAL _VOID emu02(_VOID) 0x0720;				/* movem.l d5-d7/a2,-(a7) */
LOCAL _VOID emu03(_VOID) 0x2a3c;
LOCAL _VOID emu04(_VOID) 0x456d;
LOCAL _VOID emu05(_VOID) 0x753f;				/* move.l #'Emu?',d5 */
LOCAL _VOID emu06(_VOID) 0x2e05;				/* move.l d5,d7 */
LOCAL _VOID emu07(_VOID) 0x2c05;				/* move.l d5,d6 */
LOCAL _VOID emu08(_VOID) 0x2f08;				/* move.l a0,-(a7) */
LOCAL _VOID emu09(_VOID) 0x3f3c;
LOCAL _VOID emu10(_VOID) 0x0025;
LOCAL _VOID emu11(_VOID) 0x4e4e;
LOCAL _VOID emu12(_VOID) 0x548f;				/* Vsync() */
LOCAL _VOID emu13(_VOID) 0x245f;				/* move.l (a7)+,a2 */
LOCAL _VOID emu14(_VOID) 0x24c5;				/* move.l d5,(a2)+ */
LOCAL _VOID emu15(_VOID) 0x24c6;				/* move.l d6,(a2)+ */
LOCAL _VOID emu16(_VOID) 0x24c7;				/* move.l d7,(a2)+ */
LOCAL _VOID emu17(_VOID) 0x2488;				/* move.l a0,(a2) */
LOCAL _VOID emu18(_VOID) 0x4cdf;
LOCAL _VOID emu19(_VOID) 0x04e0;				/* movem.l (a7)+,d5-d7/a2 */

#define findemu(emu) emu01(emu), emu02(), emu03(), emu04(), emu05(), \
	emu06(), emu07(), emu08(), emu09(), emu10(), emu11(), emu12(), \
	emu13(), emu14(), emu15(), emu16(), emu17(), emu18(), emu19()
#endif /* __PUREC__ */


#if defined(__GNUC__) && defined(atarist)
static __inline__ void _findemu(struct emu_info *emu) 
{
	__asm__ volatile("\
		movl    #0x456d753f,d5; \
		movl    d5,d7; \
		movl    d5,d6; \
		movw    #37,sp@-; \
		trap    #14; \
		addqw   #2,sp; \
		movel   d5,%0@+; \
		movel   d6,%0@+; \
		movel   d7,%0@+; \
		movel   a0,%0@"
	: 				/* no outputs */
	: "g"(emu)      /* inputs  */
	: "d0", "d1", "d2", "d5", "d6", "d7", "a0", "a1", "a2"    /* clobbered regs */
	  AND_MEMORY);
}
#define findemu(emu) _findemu(emu)
#endif

#ifndef findemu
#  define findemu(emu) (emu)->regd5 = (emu)->regd6 = (emu)->regd7 = 0
#endif


#define EMU_MAGIC        0x456d753fUL		/* 'Emu?' */
#define PACIFIST_MAGIC   0x50614369UL		/* 'PaCi' */
#define PACIFIST_MAGIC2  0x66695354UL		/* 'fiST' */
#define TOSBOX_MAGIC     0x54426f78UL		/* 'TBox' */
#define STONX_MAGIC      0x53544f58UL		/* 'STNX' */

struct emu_info glEmu;		/* da Supexec keine Parameter erlaubt mu das so gehen*/

/*** ------------------------------------------------------------------------ ***/
/*	LOCAL _UONG bestPacVers(_VOID)											*/
/*	Bestimmt irgendwie die Pacifist Version		*/
/*	Ursprnglich war dies ein Teil der Funktion EmulatorVersion die intern Super()	*/
/*	benutzte.																	*/
/*	Ich habe die Super entfernt, wodurch diese Funktion jetzt mit Supexec		*/
/*	aufgerufen werden mu. Auerdem wurde deshalb der Rckgabetyp zu _LONG		*/
/*	Parameter:	keine															*/
/*	Ergebnis:	'Zeit' als long													*/		
/*	11.5.00 von Dimitri Junker	DYJ 4.16f										*/
/*** ------------------------------------------------------------------------ ***/

LOCAL _LONG bestPacVers(_VOID)
{
	return (_LONG)((glEmu.regbase[0] << 8) | glEmu.regbase[1]);
}

/*
 * _LONG EmulatorVersion(_LONG *version)
 * returns type of Emulator:
 *  "PaCi" for PaCiFist
 * "TBox" for TosBox
 *  0x01 for unknown Emulator
 *  0x00 for no Emulator
 */
LOCAL _LONG EmulatorVersion(_LONG *version)
{
	_UWORD vers;
	
	findemu(&glEmu);
	*version = 0;
	if (glEmu.regd5 == glEmu.regd6 && glEmu.regd6 == glEmu.regd7)
		return 0;	/* Kein Emulator */
	if (glEmu.regd6 == PACIFIST_MAGIC && glEmu.regd7 == PACIFIST_MAGIC2)
	{
		if(CanDoSuper())
			vers = (_UWORD)Supexec(bestPacVers);
		else 
			vers=-1;
		*version = vers;
	} else if (glEmu.regd6 == TOSBOX_MAGIC)
	{
		vers = ((_UWORD)(glEmu.regd7 >> 12) & 0xf000) |
		       ((_UWORD)(glEmu.regd7 >>  8) & 0x0f00) |
		       ((_UWORD)(glEmu.regd7 >>  4) & 0x00f0) |
		       ((_UWORD)(glEmu.regd7      ) & 0x000f);
		*version = vers;
	} else
	{
		/* Emulator gefunden, aber unbekannt */
		if (glEmu.regd6 == 0)
			return 1;
	}
	return glEmu.regd6;
}

#endif /* SPEC_DEBUG */

/*** ---------------------------------------------------------------------- ***/
GLOBAL _VOID ApplInit(_VOID)
{
	_UBYTE path[PATH_MAX];
	_WORD dummy;
	_BOOL b;
	_WORD attr[10];
	_WORD f;
	_WORD cw, ch, bw, bh;
	MAGX_COOKIE *mgxPtr;
	_ULONG magIxDate;   /* Datum der MagiC-Version im Format jjjjmmtt */
	
	WorkStation = NULL;

	appl_init();
	if (gl_apid < 0)
	{
		exit(1);
	}
	if (gl_ap_version != ABCGEM)
		gdos = vq_vgdos();
	else
		gdos = ABCGEM;
	
	mem_test_start();		/*tmpapplpath*/
	shel_read(applpath, path);
	SPEC_DEBUG_OUT((EO_DEBUG, "applpath:per shel_read:%s", applpath));	/*tmpapplpath*/
	strBcpy(applname, F_Path_Basename(applpath));
	SPEC_DEBUG_OUT((EO_DEBUG, "applpath:per shel_read+F_Path_Basename:%s", applpath));	/*tmpapplpath*/
	if (!F_Path_Absolute(applpath))
	{
		shel_find(applpath);
	SPEC_DEBUG_OUT((EO_DEBUG, "applpath:per shel_find:%s", applpath));	/*tmpapplpath*/
	}	
	F_Path_Dirname(applpath);
	SPEC_DEBUG_OUT((EO_DEBUG, "applpath:F_Path_Dirname:%s", applpath));	/*tmpapplpath*/
	if (*applpath == '\0')
	{
		F_Path_Get(applpath);
	SPEC_DEBUG_OUT((EO_DEBUG, "applpath:F_Path_Get:%s", applpath));	/*tmpapplpath*/
	}
	F_Path_Append(applpath, "");
	
	/* Handle der physikalischen Workstation ermitteln */
	phys_handle = graf_handle(&CharWidth, &CharHeight, &BoxWidth, &BoxHeight);

/*tmpapplpath
	mem_test_start();
*/
	
	/* Private Workstation oeffnen */
	PrivateWS = OpenWorkstation(Screen, 0, 0, TRUE);
	/* Basiseinstellungen fuer PrivateWS vornehmen */  
	vst_alignment(PrivateWS, 0, 5, &dummy, &dummy);
	vsf_color(PrivateWS, WHITE);
	vsf_perimeter(PrivateWS, FALSE);
	
	if (gdos != GDOS_NONE)
	{
		FontSelect_LoadFonts(PrivateWS);
	}

	/* Den Font des AES ermitteln */
	Wind_Update(BEG_UPDATE);
	b = appl_xgetinfo(APG_FONT, &AESFontsize, &AESFontid, &dummy, &dummy) == 1;
	if (!b)
	{
		vqt_attributes(phys_handle, attr);
		AESFontid = attr[0];
		
		/* Font setzen und Ergebnis pruefen */
		/* Jetzt Font setzen */
		vst_font(PrivateWS, AESFontid);

		/* Und jetzt die Groesse herausknobeln */
		f = 0;
		do
		{
			++f;
			vst_height(PrivateWS, f, &cw, &ch, &bw, &bh);
		} while (bw != CharWidth || bh != CharHeight);
		AESFontsize = f;
	}
	
	{
		tFontinfo info;
		
		FontSelect_FontInfo(PrivateWS, AESFontid, &info);
		AESFontMonospaced = info.mono;
	}
	AESFontMonospaced = FALSE;
	
	Wind_Update(END_UPDATE);

	/* Jetzt Font setzen */
	vst_font(PrivateWS, AESFontid);
	vst_height(PrivateWS, AESFontsize, &dummy, &dummy, &dummy, &dummy);
	
	/* Allgemeine Workstation oeffnen */
	VDIHandle = OpenWorkstation(Screen, 0, 0, TRUE);
	vst_error(VDIHandle, 0, &fsm_errorcode);
	
	/* Gesamtbreite und Hoehe des Bildschirms */
	MaxWidth = WorkOutArray[0] + 1;
	MaxHeight = WorkOutArray[1] + 1;
	MaxColors = WorkOutArray[13];
	
	wind_get(0, WF_WORKXYWH, &deskSize.g_x, &deskSize.g_y, &deskSize.g_w, &deskSize.g_h); /* Groesse des Desktops abfragen */
	
	vq_extnd(VDIHandle, 1, WorkOutArray);
	Bitplanes = WorkOutArray[4];
	
	/* MausStack initialisieren */
	Merker = 0;
	Maus[Merker].sicht = TRUE;
	Maus[Merker].form = ARROW;
	Maus[Merker].user = NULL;
	graf_mouse(ARROW, NULL);

	SPEC_DEBUG_OUT((EO_DEBUG, "AES Version: $%04x (%d Applications)", gl_ap_version, gl_ap_count));
	SPEC_DEBUG_OUT((EO_DEBUG, "TOS Version: $%04x", TosVersion()));
	SPEC_DEBUG_OUT((EO_DEBUG, "GEMDOS Version: $%04x", (_UWORD)Sversion() >> 8));
	SPEC_DEBUG_OUT((EO_DEBUG, "GDOS Version: $%08lx", gdos));
	SPEC_DEBUG_OUT((EO_DEBUG, "Screen: %dx%dx%d (%d colors)", MaxWidth, MaxHeight, Bitplanes, MaxColors));
	SPEC_DEBUG_OUT((EO_DEBUG, "Desktop: %dx%d@%dx%d", deskSize.g_w, deskSize.g_h, deskSize.g_x, deskSize.g_y));
	SPEC_DEBUG_OUT((EO_DEBUG, "AES Font: %d %d %dx%d (%s)", AESFontid, AESFontsize, CharWidth, CharHeight, AESFontMonospaced ? "monospaced" : "proportional"));
	/* Test auf MagiC */
	magIx = FindCookie(COOKIE_MagiX, (_LONG *)&mgxPtr);
	if (magIx &&
		mgxPtr != NULL &&
		mgxPtr->aesvars != NULL)
	{
		magIxVer = mgxPtr->aesvars->version;
		/* Scrollende Editfelder? */
		/* Format von mgxPtr^.aesvars^.date: ttmmjjjj
		 * Wir brauchen:            jjjjmmtt
		 */
		magIxDate = mgxPtr->aesvars->date;
		SPEC_DEBUG_OUT((EO_DEBUG, "MagiX Version %x.%02x of %08lx", magIxVer >> 8, magIxVer & 0xff, magIxDate));
		magIxDate = ((magIxDate & 0x0000ffffL) << 16) |
				 ((magIxDate & 0x00ff0000L) >> 8) |
				 ((magIxDate >> 24) & 0xff);
		IsMagiCScroll = magIxDate >= 0x19970926L;
	} else
	{
		IsMagiCScroll = FALSE;
	}

	/* allgemein MultiTasking moeglich? */
	multiTask = gl_ap_count != 1;

	/* Eventuell sogar MultiTOS? */
	if (gl_ap_version >= 0x400 && multiTask && !magIx)
	{
		/* MultiTOS */
		multiTOS = TRUE;
	}
	/* Und jetzt noch abfragen, ob es vielleicht doch MultiGEM ist */
	multiGEM = !multiTOS && !magIx && FindCookie(COOKIE_MultiGEM, NULL);
	
	{
		MAGICMAC_COOKIE *macPtr;
		
		magicMac = magIx && FindCookie(COOKIE_MagicMac, (_LONG *)&macPtr);
		if (magicMac && macPtr != NULL)
		{
			SPEC_DEBUG_OUT((EO_DEBUG, "magicMac Version: $%04x", macPtr->vers));
		}
		magicPC = FindCookie(COOKIE_MagicPC, NULL);
		if (magicPC)
		{
			SPEC_DEBUG_OUT((EO_DEBUG, "MagicPC found"));
/*DYJ 5.30b Start*/
			UseCatDelink=!FindCookie(COOKIE_WIN_LNK, NULL);
		}
		else
			UseCatDelink=FALSE;
/*DYJ  Ende; alt:	
		}
*/
	}

#if SPEC_DEBUG
	{
		_LONG cookie;
		_LONG emul_type, emul_version;
	
		if (FindCookie(COOKIE_TOS2WIN, &cookie) && cookie)
		{
			SPEC_DEBUG_OUT((EO_DEBUG, "TOS2WIN Version: $%04x", ((_WORD *)cookie)[1]));
		}
		if (FindCookie(COOKIE_MINT, &cookie))
		{
			SPEC_DEBUG_OUT((EO_DEBUG, "MiNT Version %ld.%02ld", cookie >> 8, cookie & 0xff));
		}
		if (FindCookie(COOKIE_NAES, &cookie) && cookie)
		{
			_UWORD naes;
			
			naes = ((_UWORD *)cookie)[0];
			SPEC_DEBUG_OUT((EO_DEBUG, "NAES Version %d.%d.%d", naes >> 8, (naes >> 4) & 0x0f, naes & 0x0f));
		}
		if (FindCookie(COOKIE_NVDI, &cookie) && cookie)
		{
			SPEC_DEBUG_OUT((EO_DEBUG, "NVDI Version %x.%02x of %08lx", ((_WORD *)cookie)[0] >> 8, ((_WORD *)cookie)[0] & 0xff, *((_ULONG *)(cookie + 2))));
		}
		emul_type = EmulatorVersion(&emul_version);
		if (emul_type != 0)
		{
			if (emul_type == PACIFIST_MAGIC)
			{
				if(emul_version==-1)
					SPEC_DEBUG_OUT((EO_DEBUG, "PaciFiST unknown Version"));
				else
					SPEC_DEBUG_OUT((EO_DEBUG, "PaciFiST Version $%08lx", emul_version));
			}
			else if (emul_type == TOSBOX_MAGIC)
				SPEC_DEBUG_OUT((EO_DEBUG, "TosBox Version %lx.%02lx", emul_version >> 8, emul_version & 0xff));
			else
				SPEC_DEBUG_OUT((EO_DEBUG, "Unknown Emulator: $%08lx Version $%08lx", emul_type, emul_version));
		} else
		{
			if(CanDoSuper())
			{
				 if (xbra_test(0x53544e58L, 0x88))
					SPEC_DEBUG_OUT((EO_DEBUG, "STonX found"));
			}
			else
				SPEC_DEBUG_OUT((EO_DEBUG, "Could not test for STonX because Super is not allowed"));
		}
		SPEC_DEBUG_OUT((EO_DEBUG, "IsMagiCScroll: %d", IsMagiCScroll));
		SPEC_DEBUG_OUT((EO_DEBUG, "multiTask: %d", multiTask));
		if (multiTOS)
		{
			SPEC_DEBUG_OUT((EO_DEBUG, "MultiTOS found"));
		}
		SPEC_DEBUG_OUT((EO_DEBUG, "multiGEM: %d", multiGEM));
		if (FindCookie(COOKIE_Geneva, &cookie))
		{
			SPEC_DEBUG_OUT((EO_DEBUG, "Geneva found"));
		}
	}
#endif
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID ApplTerm(_WORD ret)
{
	_WORD handle;
	
	CallTermprocs();
	while (WorkStation != NULL)
	{
		handle = WorkStation->handle;
		CloseWorkstation(&handle);
	}
	mem_test_end();
	MouseOn();
	if (gl_apid >= 0)
	{
		appl_exit();
	}
	exit(ret);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID ApplPath(_UBYTE *path)
{
	strMcpy(path, PATH_MAX, applpath);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID ApplName(_UBYTE *name)
{
	strMcpy(name, PATH_MAX, applname);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL WsPtr newWS(_WORD handle, _UWORD flags)
{
	WsPtr q;
	
	q = NEW(WsInfo, "newWS");
	if (q != NULL)
	{
		q->handle = handle;
		q->flags = flags;
		q->list = NULL;
		q->next = NULL;
		q->last = NULL;
	}
	return q;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL HVDI OpenWS(_WORD kind, _WORD x, _WORD y, _WORD rc)
{
	HVDI h;
	_UWORD flag;
	WsPtr p;
	
	WorkInArray[ 1] = 1;
	WorkInArray[ 2] = 1;
	WorkInArray[ 3] = 1;
	WorkInArray[ 4] = 1;
	WorkInArray[ 5] = AESFontid;
	WorkInArray[ 6] = 1;
	WorkInArray[ 7] = 1;
	WorkInArray[ 8] = 1;
	WorkInArray[10] = rc;
	if (kind < 11)
	{
		WorkInArray[0] = 1;
		h = phys_handle;
		v_opnvwk(WorkInArray, &h, WorkOutArray);
		if (h < 0)
			return -1;
		flag = 0;
	} else
	{
		WorkInArray[0] = kind;
		WorkInArray[11] = x;
		WorkInArray[12] = y;
		h = kind;
		v_opnwk(WorkInArray, &h, WorkOutArray);
		if (h <= 0)
			return -1;
		flag = cPhysical;
	}
	if (WorkStation == NULL)
	{
		WorkStation = newWS(h, flag);
	} else
	{
		p = WorkStation;
		while (p->next != NULL)
			p = p->next;
		p->next = newWS(h, flag);
		p->next->last = p;
	}
	return h;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL HVDI OpenWorkstation(Device device, _WORD w, _WORD h, _BOOL rc)
{
	_WORD try, maxdev, coord;
	HVDI ws;
	
	if (rc)
		coord = RC;
	else
		coord = NDC;
	switch (device)
	{
	case Screen:
		try = 1;
		maxdev = 1;
		break;
	case Plotter:
		try = 11;
		maxdev = 20;
		break;
	case Printer:
		try = 21;
		maxdev = 30;
		break;
	case Metafile:
		try = 31;
		maxdev = 40;
		break;
	case Camera:
		try = 41;
		maxdev = 50;
		break;
	case Tablett:
		try = 51;
		maxdev = 60;
		break;
	default:
		return -1;
	}
	for (;;)
	{
		if (try > maxdev)
			return -1;
		ws = OpenWS(try, w, h, coord);
		if (ws > 0)
			return ws;
		++try;
	}
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID CloseWorkstation(_WORD *handle)
{
	WsPtr p;
	
	p = Intern(*handle);
	if (p != NULL)
	{
		FontSelect_UnloadFonts(p->handle);
		if (p->flags & cPhysical)
			v_clswk(p->handle);
		else
			v_clsvwk(p->handle);
		if (p->last != NULL)
			p->last->next = p->next;
		if (p->next != NULL)
			p->next->last = p->last;
		if (p == WorkStation)
			WorkStation = p->next;
		OFREE(p);
		*handle = 0;
	}
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

LOCAL _VOID MausEin(_WORD mausform)
{
	tMerker *t = &Maus[Merker];
	
	if (!t->sicht)
	{
		t->sicht = TRUE;
		graf_mouse(M_ON, NULL);
	}
	if (t->form != mausform)
	{
		t->form = mausform;
		if (mausform == USER_DEF)
			graf_mouse(mausform, t->user);
		else
			graf_mouse(mausform, NULL);
	}
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID MouseOn(_VOID)
{
	MausEin(Maus[Merker].form);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID MouseArrow(_VOID)
{
	MausEin(ARROW);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID MouseCursor(_VOID)
{
	MausEin(TEXT_CRSR);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID MouseBusy(_VOID)
{
	MausEin(BUSY_BEE);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID MouseFinger(_VOID)
{
	MausEin(POINT_HAND);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID MouseHand(_VOID)
{
	MausEin(FLAT_HAND);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID MouseThincross(_VOID)
{
	MausEin(THIN_CROSS);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID MouseThickcross(_VOID)
{
	MausEin(THICK_CROSS);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID MouseOutline(_VOID)
{
	MausEin(OUTLN_CROSS);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID MouseUser(_VOID)
{
	Maus[Merker].form = -1;
	MausEin(USER_DEF);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID MouseOff(_VOID)
{
	if (Maus[Merker].sicht)
	{
		Maus[Merker].sicht = FALSE;
		graf_mouse(M_OFF, NULL);
	}
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID MouseState(_WORD *form, _BOOL *sichtbar)
{
	*form = Maus[Merker].form;
	*sichtbar = Maus[Merker].sicht;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID StoreMouse(_VOID)
{
	if (Merker < (MaxMaus-1))
	{
		++Merker;
		Maus[Merker] = Maus[Merker-1];
	}
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID RestoreMouse(_VOID)
{
	_BOOL view;
	
	if (Merker > 0)
	{
		view = Maus[Merker].sicht;
		--Merker;
		if (view && !Maus[Merker].sicht)
			graf_mouse(M_OFF, NULL);
		else if (!view && Maus[Merker].sicht)
			graf_mouse(M_ON, NULL);
		if (Maus[Merker].form == USER_DEF)
			graf_mouse(USER_DEF, Maus[Merker].user);
		else
			graf_mouse(Maus[Merker].form, NULL);
	}
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID UserMouse(_WORD *form)
{
	Maus[Merker].user = form;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID SetMouse(_WORD x, _WORD y)
{
	_WORD xx, yy;
	_WORD ch;
	
	MouseOff();
	vsm_locator(PrivateWS, x, y, &xx, &yy, &ch);
	MouseOn();
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

GLOBAL _ULONG VqGdos(_VOID)
{
	return gdos;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _WORD do_appl_locate(CONST _UBYTE *name, CONST _UBYTE *args, _BOOL startit)
{
	_UBYTE app_name[9];
	_WORD id;
	_WORD i;
	CONST _UBYTE *p, *pend;
	_UBYTE path[PATH_MAX];
	size_t len;
	
	id = -1;
	pend = name;
	while (pend != NULL && id < 0)
	{
		p = strChr(pend, ';');
		if (p == NULL)
			p = strChr(pend, ',');
		if (p == NULL)
		{
			strBcpy(path, pend);
			pend = NULL;
		} else
		{
			len = p - pend + 1;
			if (len > sizeof(path))
				len = sizeof(path);
			strMcpy(path, len, pend);
			pend = p + 1;
		}
		p = F_Path_Basename(path);
		for (i = 0; i < 8 && p[i] != '\0' && p[i] != '.'; i++)
		{
			app_name[i] = ucase(p[i]);
		}
		for (; i < 8; i++)
			app_name[i] = ' ';
		app_name[8] = '\0';
		id = appl_find(app_name);
	}
	if (id < 0 && startit)
	{
		pend = name;
		while (pend != NULL && id < 0)
		{
			p = strChr(pend, ';');
			if (p == NULL)
				p = strChr(pend, ',');
			if (p == NULL)
			{
				strBcpy(path, pend);
				pend = NULL;
			} else
			{
				len = p - pend + 1;
				if (len > sizeof(path))
					len = sizeof(path);
				strMcpy(path, len, pend);
				pend = p + 1;
			}
			if (magIx)
			{
				id = shel_write(SHW_EXEC, 1, SHW_PARALLEL, path, args);
				evnt_timer(500, 0);
			} else
			{
				id = shel_write(SHW_EXEC, 1, 1, path, args);
			}
		}
	}
	return id;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _WORD appl_locate(CONST _UBYTE *name, _BOOL startit)
{
	return do_appl_locate(name, "\0", startit);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _WORD appl_locate_args(CONST _UBYTE *name, CONST _UBYTE *args)
{
	_UBYTE tail[128];
	
	strMcpy(&tail[1], 126, args);
	tail[0] = (_UBYTE)strLen(&tail[1]);
	return do_appl_locate(name, tail, TRUE);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID Objc_draw(OBJECT *tree, _WORD start, _WORD depth, CONST GRECT *clip)
{
	objc_draw(tree, start, depth, clip->g_x, clip->g_y, clip->g_w, clip->g_h);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID Form_dial(_WORD flag, CONST GRECT *small, CONST GRECT *big)
{
	form_dial(flag, small->g_x, small->g_y, small->g_w, small->g_h,
		big->g_x, big->g_y, big->g_w, big->g_h);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID Wind_calc(_WORD mode, _UWORD comp, CONST GRECT *in, GRECT *out)
{
	wind_calc(mode, comp, in->g_x, in->g_y, in->g_w, in->g_h,
		&out->g_x, &out->g_y, &out->g_w, &out->g_h);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _WORD appl_xgetinfo(_WORD info, _WORD *out1, _WORD *out2, _WORD *out3, _WORD *out4)
{
	LOCAL _WORD hasAgi = -1;

	if (hasAgi < 0)
	{
		/* Test auf ApplGetinfo */
		hasAgi = gl_ap_version >= 0x400 || appl_find("?AGI\0\0\0\0") >= 0;
	}
	*out1 = *out2 = *out3 = *out4 = 0;
	if (hasAgi)
		return appl_getinfo(info, out1, out2, out3, out4);
	return 0;
}
