/*
 * Diese Datei ist Teil der Magic-Library,
 * und darf in dieser Form nur als Teil des CAT-Projekts
 * verwendet werden.
 * 
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Magic ist Copyright (c) by Peter Hellinger.
 *
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */


#include <mtmenuba.h>
#include <mtappl.h>
#include <mtutils.h>
#ifndef __PORTVDI_H__
#include <portvdi.h>
#endif

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

GLOBAL _VOID mtMenubase_SameLength(OBJECT *menu, _WORD num, _WORD max)
{
	_WORD i;
	
	for (i = 0; i < num; i++)
		menu[i].ob_width = max;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _UWORD mtMenubase_DoEvent(_WORD *x, _WORD *y, _UWORD *button, _WORD *scan)
{
	_UWORD event;
	_WORD key, clicks;
	_UWORD state;
	_WORD message[8];
	
	event = evnt_multi(MU_KEYBD | MU_TIMER | MU_BUTTON,
		1, 1, 1,
		0, 0, 0, 0, 0,
		0, 0, 0, 0, 0,
		message,
		0, 0,
		x, y, button, &state, &key, &clicks);
	*scan = (key >> 8) & 0xff;
	return event;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID mtMenubase_ScreenDim(_WORD *mw, _WORD *mh)
{
	*mw = MaxWidth;
	*mh = MaxHeight;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID mtMenubase_DrawBar(OBJECT *t, _WORD o)
{
	_WORD pxy[4];
	
	if (o > 0)
	{
		if (!GetObjState(t, o, DISABLED))
		{
			ObjcPos(t, o, &pxy[0], &pxy[1]);
			pxy[2] = pxy[0] + t[o].ob_width - 1;
			pxy[3] = pxy[1] + t[o].ob_height - 1;
			v_bar(PrivateWS, pxy);
		}
	}
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _BOOL mtMenubase_MenuKeyboard(OBJECT *t, _WORD scan, _WORD minobj, _WORD oldob, _WORD *ob)
{
	_WORD o;
	
	UNUSED(oldob);
	switch (scan)
	{
	case 0x72:	/* Enter */
	case 0x1c:	/* Return */
		return TRUE;
	case 0x48:	/* Cursor up */
		o = *ob;
		if (o <= minobj)
			o = t[ROOT].ob_tail + 1;
		do
		{
			--o;
		} while (o >= minobj && (GetObjState(t, o, DISABLED) || !GetObjFlags(t, o, SELECTABLE)));
		if (o < minobj)
			o = t[ROOT].ob_tail;
		*ob = o;
		break;
	case 0x50:	/* Cursor down */
		o = *ob;
		if (o >= t[ROOT].ob_tail)
			o = minobj - 1;
		do
		{
			++o;
		} while (o <= t[ROOT].ob_tail && (GetObjState(t, o, DISABLED) || !GetObjFlags(t, o, SELECTABLE)));
		if (o > t[ROOT].ob_tail)
		{
			o = minobj - 1;
			do
			{
				++o;
			} while (o <= t[ROOT].ob_tail && (GetObjState(t, o, DISABLED) || !GetObjFlags(t, o, SELECTABLE)));
			if (o > t[ROOT].ob_tail)
				o = minobj;
		}
		*ob = o;
		break;
	case 0x61:	/* Undo */
	case 0x01:  /* Esc */
		*ob = -1;
		return TRUE;
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID mtMenubase_PlaceOnScreen(OBJECT *t)
{
	_WORD j;
	
	j = ObjcFrame(t, ROOT);
	if (j < 0)
		j = -j;
	else
		j = 0;
	if (GetObjState(t, ROOT, SHADOWED))
		j *= 3;
	if (t[ROOT].ob_x + t[ROOT].ob_width + j > MaxWidth)
		t[ROOT].ob_x = MaxWidth - t[ROOT].ob_width - j;
	if (t[ROOT].ob_y + t[ROOT].ob_height + j > MaxHeight)
		t[ROOT].ob_y = MaxHeight - t[ROOT].ob_height - j;
	if (t[ROOT].ob_x - j < deskSize.g_x)
		t[ROOT].ob_x = deskSize.g_x + j;
	if (t[ROOT].ob_y - j < deskSize.g_x)
		t[ROOT].ob_y = deskSize.g_y + j;
}
