/*
 * Diese Datei ist Teil der Magic-Library,
 * und darf in dieser Form nur als Teil des CAT-Projekts
 * verwendet werden.
 * 
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Magic ist Copyright (c) by Peter Hellinger.
 *
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 *
 * 10.3.03 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.22b'
 *	Fehler in der Sprachverwaltung
 *
 * 18.3.03 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.23d'
 *	bei LC_ALL,LC_MESSAGES und LANG werden jetzt auch DE_* und EN_*
 *	verstanden
 *
 * 14.4.03 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.27a'
 *	Die LIB-RSC wurde nicht wieder freigegeben
 *
 * 8.5.04 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.36j'
 *	Speicher wurde teils mehrfach freigegeben(Fred).
 *	Teils garnicht (Install).
 */


#define __MAGICTOOL_RSC_IMPLEMENTATION__
#include <mtrsc.h>
#ifndef __PORTAES_H__
#include <portaes.h>
#endif
#ifndef __PORTVDI_H__
#include <portvdi.h>
#endif
#include <tos.h>
#include <magictyp.h>
#include <mtutils.h>
#include <mtappl.h>
#include <mtxobjec.h>
#include <ro_mem.h>
#include <termproc.h>
#include <routines.h>
#include <catlib.h>
#include <cattypes.h>
#include <mttextfi.h>
#include <catgloba.h>
#include <catfiles.H>

#include <file_io.h>

LOCAL RESOURCE theRSC;
GLOBAL OBJECT **TreeAddrLib;

#define SAVE_MEMORY 0

typedef struct {
	_ULONG rscLen;
	_VOID *rscCIconTab;
	_VOID *rscFarbtbl;
} tExtSlot, *tpExtSlot;

typedef _LONG *tplInt;
typedef _WORD *tpsInt;
typedef _ULONG *tplCard;
typedef _UWORD *tpsCard;

LOCAL RESOURCE RscList;

/* MagiC XTED Struktur. Gehoert nach MagicAES.H */
typedef struct {
	_UBYTE *xte_ptmplt;
	_UBYTE *xte_pvalid;
	_WORD xte_vislen;
	_WORD xte_scroll;
} XTED;

typedef RSHDR *tpRSHDR;
typedef RSXHDR *tpRSXHDR;

/* Pufferstruktur fuer Meisiek-Technik */
typedef struct {
	CICON *colictab;
	size_t colicons;
	OBJECT **tree;
	tpRSXHDR xhdr;
	size_t size;
	tpRSHDR rscdata;
} tRsBuffer;

struct _Resource {
	tRsBuffer RsBuffer;
	RESOURCE next;
};

LOCAL _UBYTE valid[257];
LOCAL _UBYTE tmplt[257];

#define xscrn_planes Bitplanes
#define xvdi_handle VDIHandle
#define xgl_wbox CharWidth
#define xgl_hbox CharHeight

#define cCoords        0x2000    /* Flag 13 kennzeichnet Objekte mit gefixten Koordinaten */


#define TEST_COLOR 15
#define XMAX_PLANES 32
#define XMAX_COLOR 256


/****** VARIABLES ************************************************************/

typedef _WORD table32[XMAX_COLOR][XMAX_PLANES];
typedef _WORD table4[XMAX_COLOR][4];

/* Anzahl Bytes pro Pixel (0 == planeorientiert) */
LOCAL _WORD xpixelbytes;
/* Tabelle fuer Planeorientierte Grafik */
LOCAL table32 *farbtbl;
/* Tabelle fuer Pixelorientierte Grafik */
LOCAL _ULONG farbtbl2[XMAX_COLOR];
LOCAL table4 *rgb_palette;
LOCAL _BOOL is_palette;
_WORD RscLang=L_GERMAN;

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

LOCAL _VOID *get_sub(tRsBuffer *rs_par, _WORD index, _LONG offset, size_t size)
{
	_UBYTE *ptr = (_UBYTE *)rs_par->rscdata;

	ptr += offset;
	ptr += (_ULONG)index * (_ULONG)size;

	return (_VOID *)ptr;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID *get_address(tRsBuffer *rs_par, _WORD type, _WORD index)
{
	_VOID *the_addr = (_VOID *)NULL;

	switch (type)
	{
	case R_TREE:
        the_addr = rs_par->tree[index];
		break;

	case R_OBJECT:
		the_addr = get_sub(rs_par, index, rs_par->xhdr->rsh_object, sizeof(OBJECT));
		break;

	case R_TEDINFO:
	case R_TEPTEXT:
        the_addr = get_sub(rs_par, index, rs_par->xhdr->rsh_tedinfo, sizeof(TEDINFO));
		break;

	case R_ICONBLK:
	case R_IBPMASK:
        the_addr = get_sub(rs_par, index, rs_par->xhdr->rsh_iconblk, sizeof(ICONBLK));
		break;

	case R_BITBLK:
	case R_BIPDATA:
        the_addr = get_sub(rs_par, index, rs_par->xhdr->rsh_bitblk, sizeof(BITBLK));
		break;

	case R_OBSPEC:
		the_addr = &((OBJECT *)get_address(rs_par, R_OBJECT, index))->ob_spec;
		break;

	case R_TEPTMPLT:
		the_addr = &((TEDINFO *)get_address(rs_par, R_TEDINFO, index))->te_ptmplt;
		break;
	
	case R_TEPVALID:
		the_addr = &((TEDINFO *)get_address(rs_par, R_TEDINFO, index))->te_pvalid;
		break;

	case R_IBPDATA:
		the_addr = &((ICONBLK *)get_address(rs_par, R_ICONBLK, index))->ib_pdata;
		break;
		
	case R_IBPTEXT:
		the_addr = &((ICONBLK *)get_address(rs_par, R_ICONBLK, index))->ib_ptext;
		break;

	case R_STRING:
        the_addr = get_sub(rs_par, index, rs_par->xhdr->rsh_frstr, sizeof(_UBYTE *));
		break;
	
	case R_IMAGEDATA:
		the_addr = get_sub(rs_par, index, rs_par->xhdr->rsh_imdata, sizeof(_BYTE *));
		break;
	
	case R_FRIMG:
		the_addr = get_sub(rs_par, index, rs_par->xhdr->rsh_frimg, sizeof(_BYTE *));
		break;
	
	case R_FRSTR:
        the_addr = get_sub(rs_par, index, rs_par->xhdr->rsh_frstr, sizeof(_UBYTE *));
		break;
	}
    return the_addr;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID fix_coord(_WORD *pcoord, _BOOL vertical, _BOOL fixed)
{
	_WORD ncoord;

	ncoord = *pcoord & 0xff;

	if (vertical)
	{
		if (fixed)
			ncoord *= 16;
		else
			ncoord *= xgl_hbox;
	} else if (ncoord == 0x50)
	{
		ncoord = MaxWidth;         /* Breite des Bildschirms in Pixel */
	} else
	{
		if (fixed)
			ncoord *= 8;
		else
			ncoord *= xgl_wbox;
	}
	if ((*pcoord) & 0x8000)
		ncoord += (((*pcoord >> 8) & 0xff) | 0xff00);
	else
		ncoord += ((*pcoord >> 8) & 0xff);

	*pcoord = ncoord;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID rs_obfix(OBJECT *rs_otree, _WORD rs_oobject)
{
	_WORD *coord;
	_BOOL fixed;
	
	fixed = GetObjFlags(rs_otree, rs_oobject, cCoords);
	coord = &rs_otree[rs_oobject].ob_x;

	fix_coord(coord, FALSE, fixed); coord++;
	fix_coord(coord, TRUE, fixed); coord++;
	fix_coord(coord, FALSE, fixed); coord++;
	fix_coord(coord, TRUE, fixed);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID fix_long(tRsBuffer *rs_par, _LONG *lptr)
{
	_LONG base;

	base = *lptr;
	if (base != 0)
	{
		base += (_LONG)rs_par->rscdata;
		*lptr = base;
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID InstallLongEdit(OBJECT *obj, _WORD length)
{
	TEDINFO *tedPtr;
	_VOID *adr;
	_UBYTE validChar;
	_WORD i;
	XTED *xted;

	tedPtr = obj->ob_spec.tedinfo;
	adr = M0ALLOC(length + 1, "InstallLongEdit: text");
	if (adr == NULL)
		return;
	
	validChar = tedPtr->te_pvalid[0];
	if (validChar == '\0')
		validChar = 'X';
	
	for (i = 0; i < length; i++)
	{
		valid[i] = validChar;
		tmplt[i] = '_';
	}
	valid[length] = '\0';
	tmplt[length] = '\0';
	
	/* MagiC-Scroller */
	if (IsMagiCScroll)
	{
		/* Jawohl, wir scrollen ueber MagiC */
		tedPtr->te_just = (tedPtr->te_just & ~TE_JUST_MASK) | TE_LEFT;
		xted = NEW(XTED, "InstallLongEdit: XTED");
		if (xted == NULL)
		{
			FREE(adr, length + 1);
			return;
		}
		
		xted->xte_ptmplt = tmplt;
		xted->xte_pvalid = valid;
		xted->xte_vislen = tedPtr->te_tmplen - 1;
		xted->xte_scroll = 0;
		
		tedPtr->te_ptmplt = NULL;
		tedPtr->te_pvalid = (_UBYTE *)xted;
	} else
	{
		tedPtr->te_fontid = 0;
		tedPtr->te_pvalid = valid;
		tedPtr->te_ptmplt = tmplt;
	}
	
	tedPtr->te_txtlen = length + 1;
	tedPtr->te_tmplen = length + 1;
	tedPtr->te_ptext = adr;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID fix_object(tRsBuffer *rs_par)
{
	_WORD count;
	OBJECT *obj;

	count = (_WORD)rs_par->xhdr->rsh_nobs;
	
	while (--count >= 0)
	{
		obj = get_address(rs_par, R_OBJECT, count);
		rs_obfix(obj, 0);
		switch (obj->ob_type & 0xff)
		{
		case G_BOX:
		case G_IBOX:
		case G_BOXCHAR:
			break;
		default:
			fix_long(rs_par, (_LONG *)&obj->ob_spec);
			break;
		}
		if ((obj->ob_type & 0xff00) == (24 /* LongEdit */ << 8))
			InstallLongEdit(obj, 256);
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID rs_fixindex(tRsBuffer *global)
{
	fix_object(global);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID fix_treeindex(tRsBuffer *rs_par)
{
	OBJECT **adr;
	_LONG   count;

	count = rs_par->xhdr->rsh_ntree;

	adr = get_sub(rs_par, 0, rs_par->xhdr->rsh_trindex, sizeof(OBJECT *));
	rs_par->tree = adr;
	
	while (--count >= 0)
	{
		fix_long(rs_par, (_LONG *)adr);
		adr++;
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID fix_ptr(tRsBuffer *rs_par, _WORD type, _LONG index)
{
	fix_long(rs_par, get_address(rs_par, type, (_WORD)index));
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID fix_tedinfo(tRsBuffer *rs_par)
{
	_WORD count;

	count = (_WORD)rs_par->xhdr->rsh_nted;

	while (--count >= 0)
	{
		fix_ptr(rs_par, R_TEPTEXT, count);
		fix_ptr(rs_par, R_TEPTMPLT, count);
		fix_ptr(rs_par, R_TEPVALID, count);
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID fix_nptr(tRsBuffer *rs_par, _WORD index, _WORD ob_type)
{
	while (--index >= 0)
		fix_long(rs_par, get_address(rs_par, ob_type, index));
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID xrect2array(CONST GRECT *rect, _WORD *array)
{
	*array++ = rect->g_x;
	*array++ = rect->g_y;
	*array++ = rect->g_x + rect->g_w - 1;
	*array   = rect->g_y + rect->g_h - 1;
} /* xrect2array */

/*****************************************************************************/

LOCAL _VOID do_rsfix(tRsBuffer *rs_par, _ULONG size)
{
	tpRSXHDR xhdr;
	
	rs_par->size = size;
	
	fix_treeindex(rs_par);
	fix_tedinfo(rs_par);

	xhdr = rs_par->xhdr;
	fix_nptr(rs_par, (_WORD)xhdr->rsh_nib, R_IBPMASK);
	fix_nptr(rs_par, (_WORD)xhdr->rsh_nib, R_IBPDATA);
	fix_nptr(rs_par, (_WORD)xhdr->rsh_nib, R_IBPTEXT);

	fix_nptr(rs_par, (_WORD)xhdr->rsh_nbb, R_BIPDATA);
	fix_nptr(rs_par, (_WORD)xhdr->rsh_nstring, R_FRSTR);
	fix_nptr(rs_par, (_WORD)xhdr->rsh_nimages, R_FRIMG);
}

/*****************************************************************************/
/* Pointer fuer Farbicons in der Resource initialisieren                     */
/*****************************************************************************/

LOCAL _WORD fill_cicon_liste(_LONG *cicon_liste, _ULONG header, tRsBuffer *global)
{
	_WORD     i, i2, num;
	_BYTE     *p;
	_LONG     iclen, num_cicon, ob, p2;
	CICONBLK *cblk;
	CICON    *cicon, *cold;
	OBJECT   *pobject;
	RSXHDR   *rsxhdr;
	
	num = 0;
	while (!cicon_liste[num])
		num++;
	
	if (cicon_liste[num] != -1L)
		return -1;

	cblk = (CICONBLK *)&cicon_liste[num+1];
	rsxhdr = global->xhdr;
	
	for (i = 0; i < num; i++)
	{
		cicon_liste[i] = (_LONG)cblk;
		p = (_BYTE *)&cblk[1];
		cblk->monoblk.ib_pdata = (_WORD *)p;
		iclen = ((cblk->monoblk.ib_wicon + 15) / 16) * 2L * cblk->monoblk.ib_hicon;
		p += iclen;
		cblk->monoblk.ib_pmask = (_WORD *)p;
		p += iclen;
		p2 = (_LONG)cblk->monoblk.ib_ptext;
		if (!p2 || header + p2 == (_LONG)p || p2 < rsxhdr->rsh_string || p2 > rsxhdr->rsh_rssize)
			cblk->monoblk.ib_ptext = (_UBYTE *)p;
		else
			cblk->monoblk.ib_ptext = header + cblk->monoblk.ib_ptext;
		
		cicon = (CICON *)&p[12];
		p += 12L;
		cold = cicon;
		if ((num_cicon = (_LONG)cblk->mainlist) > 0)
		{
			cblk->mainlist = cicon;
	
			for (i2 = 0; i2 < num_cicon; i2++)
			{
				p = (_BYTE *)&cicon[1];
				cicon->col_data = (_WORD *)p;
				p += iclen * cicon->num_planes;
				cicon->col_mask = (_WORD *)p;
				p += iclen;
				if (cicon->sel_data != NULL)
				{
					cicon->sel_data = (_WORD *)p;
					p += iclen * cicon->num_planes;
					cicon->sel_mask = (_WORD *)p;
					p += iclen;
				}
				cicon->next_res = (CICON *)p;
				cold = cicon;
				cicon = (CICON *)p;
			}
			cold->next_res = NULL;
		}
		cblk = (CICONBLK *)p;
	}

	if (num >= 0)
	{
		pobject = (OBJECT *)(header + rsxhdr->rsh_object);
		
		for (ob = 0; ob < rsxhdr->rsh_nobs; ob++)
			if ((pobject[ob].ob_type & 0xff) == G_CICON)
				pobject[ob].ob_spec.index = cicon_liste[pobject[ob].ob_spec.index];
		
		if ((global->colictab = SYSMALLOC(num * sizeof(CICON), MEM_NOERR, "fill_cicon_liste: cicon")) != NULL)
			MemSetZero(global->colictab, num * sizeof(CICON));
		global->colicons = num;
	}
	
	return num;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID draw_bitblk(_WORD *p, _WORD x, _WORD y, _WORD w, _WORD h, _WORD num_planes, _WORD mode, _WORD *index)
{
	_WORD	 	pxy[8];
	MFDB	 	s, d;

	d.fd_addr	= NULL; /* screen */
	s.fd_addr	= (_VOID *)p;
	s.fd_w = w;
	s.fd_h	= h;
	s.fd_wdwidth = w >> 4;
	s.fd_stand	= FALSE;
	s.fd_nplanes	= num_planes;

	pxy[0] = 0;
	pxy[1] = 0;
 	pxy[2] = s.fd_w - 1;
 	pxy[3] = s.fd_h - 1;

	pxy[4] = x;
	pxy[5] = y;
	pxy[6] = pxy[4] + pxy[2];
	pxy[7] = pxy[5] + pxy[3];

	if (num_planes > 1)
		vro_cpyfm(xvdi_handle, mode, pxy, &s, &d);
	else
		vrt_cpyfm(xvdi_handle, mode, pxy, &s, &d, index);	 /* copy it */
}

/*****************************************************************************/
/* Zeichnet Farb-Icon                                                        */
/*****************************************************************************/

LOCAL _UWORD _CDECL xdraw_cicon(PARMBLK *pb)
{
	_WORD	 	ob_x, ob_y, x, y, dummy, pxy[4], m_mode, i_mode, mskcol, icncol;
	_LONG	 	ob_spec;
	ICONBLK *iconblk;
	CICON   *cicn;
	_WORD    *mask, *data, *dark = NULL;
	_UBYTE    letter[2];
	_WORD    selected, mindex[2], iindex[2], buf, xy[4];
	_BOOL invert = FALSE;
	
	selected = pb->pb_currstate & SELECTED;
	
	xrect2array ((GRECT *)&pb->pb_xc, xy);
	vs_clip(xvdi_handle, TRUE, xy);   /* Setze Rechteckausschnitt */

	ob_spec	= pb->pb_parm;
	ob_x		= pb->pb_x;
	ob_y		= pb->pb_y;

	iconblk = (ICONBLK *)ob_spec;
	cicn    = ((CICONBLK *)ob_spec)->mainlist;
	m_mode  = MD_TRANS;

	if (selected) /* it was an objc_change */
	{
		if (cicn->sel_data != NULL)
		{
			mask = cicn->sel_mask;
			data = cicn->sel_data;
			if (cicn->num_planes > 1)
			{
				if (cicn->num_planes > 8)	/* TrueColor, bzw RGB-orientierte Grafikkarte? */
					i_mode = S_AND_D;
				else
					i_mode = S_OR_D;
			} else
			{
				i_mode = MD_TRANS;
			}
		} else
		{
			mask = cicn->col_mask;
			data = cicn->col_data;

			if (cicn->num_planes > 1)
			{
				if (cicn->num_planes > 8)
					i_mode = S_AND_D;
				else
					i_mode = S_OR_D;
				dark = cicn->sel_mask;
			} else
			{
				invert = TRUE;
				i_mode = MD_TRANS;
			}
		}
	} else
	{
		mask = cicn->col_mask;
		data = cicn->col_data;
	
		if (cicn->num_planes > 1)
		{
			if (cicn->num_planes > 8)
				i_mode = S_AND_D;
			else
				i_mode = S_OR_D;
		} else
		{
			i_mode = MD_TRANS;
		}
	}
	
	mindex [0] = ((iconblk->ib_char & 0x0f00) != 0x0100) ? (iconblk->ib_char & 0x0f00) >> 8 : WHITE;
	mindex [1] = WHITE;
	
	icncol = iindex[0] = (_WORD)(((_UWORD)iconblk->ib_char & 0xf000U) >> 12U);
	iindex[1] = WHITE;

	mskcol = (iconblk->ib_char & 0x0f00) >> 8;

	x = ob_x + iconblk->ib_xicon;
	y = ob_y + iconblk->ib_yicon;

	if (invert)
	{
		buf       = iindex[0];
		iindex[0] = mindex[0];
		mindex[0] = buf;
		i_mode    = MD_TRANS;
	}
	if (selected)
	{
		buf    = icncol;
		icncol = mskcol;
		mskcol = buf;
	}
	
	draw_bitblk(mask, x, y, iconblk->ib_wicon, iconblk->ib_hicon, 1, m_mode, mindex);
	draw_bitblk(data, x, y, iconblk->ib_wicon, iconblk->ib_hicon, cicn->num_planes, i_mode, iindex);
	
	if (dark != NULL)
	{
		mindex [0] = BLACK;
		mindex [1] = WHITE;
		draw_bitblk(dark, x, y, iconblk->ib_wicon, iconblk->ib_hicon, 1, MD_TRANS, mindex);
	}

	if (iconblk->ib_ptext[0] != '\0')
	{
		x = ob_x + iconblk->ib_xtext;
		y = ob_y + iconblk->ib_ytext;
		
		pxy[0] = x;
		pxy[1] = y;
		pxy[2] = x + iconblk->ib_wtext - 1;
		pxy[3] = y + iconblk->ib_htext - 1;
		
		vswr_mode(xvdi_handle, MD_REPLACE);		/* Textbox zeichnen */
		vsf_color(xvdi_handle, mskcol);
		vsf_interior(xvdi_handle, FIS_SOLID);
		vsf_perimeter(xvdi_handle, FALSE);
		v_bar(xvdi_handle, pxy);
	}

	vswr_mode(xvdi_handle, MD_TRANS);
	vst_font(xvdi_handle, 1);	/* Systemfont */
	vst_height(xvdi_handle, 4, &dummy, &dummy, &dummy, &dummy);
	vst_color(xvdi_handle, icncol);
	vst_effects(xvdi_handle, 0);
	vst_alignment(xvdi_handle, 0, 5, &dummy, &dummy);
	vst_rotation(xvdi_handle, 0);
	
	if (iconblk->ib_ptext[0])
	{
		x += (iconblk->ib_wtext - (_WORD)strLen (iconblk->ib_ptext) * 6) / 2;
		y += (iconblk->ib_htext - 6) / 2;
		
		v_gtext(xvdi_handle, x, y, iconblk->ib_ptext);
	}

	letter[0] = (_UBYTE)(iconblk->ib_char & 0xff);
	if (letter[0])
	{
		letter[1] = '\0';
		x = ob_x + iconblk->ib_xicon + iconblk->ib_xchar;
		y = ob_y + iconblk->ib_yicon + iconblk->ib_ychar;
	
		v_gtext(xvdi_handle, x, y, letter);
	}
	
	return (pb->pb_currstate & ~SELECTED);
} /* draw_userdef */

/*****************************************************************************/
/* std_to_byte wandelt eine Grafik im Standardformat direkt ins geraete-     */
/* abhaengige Format (in Aufloesungen mit >= 16 Planes)                      */
/*****************************************************************************/

LOCAL _VOID std_to_byte(_UWORD *col_data, _LONG len, _UWORD old_planes, _ULONG *farbtbl2, MFDB *s)
{
	_LONG  x, pos;
	_UWORD np, *new_data, pixel, color, back[XMAX_PLANES];
	_WORD  memflag = FALSE;
	_UBYTE *p1, *p2;
	_ULONG colback = 0;
	_UWORD *plane_ptr[XMAX_PLANES];

	if (s->fd_addr == col_data)
	{
		if ((col_data = SYSMALLOC(len * 2 * s->fd_nplanes, MEM_NOERR, "std_to_byte")) == NULL)
			return;
		MemCpy(col_data, s->fd_addr, len * 2 * s->fd_nplanes);
		memflag = TRUE;
	}
	new_data = (_UWORD *)s->fd_addr;
	p1 = (_UBYTE *)new_data;

	if (old_planes < 8)
	{
		colback = farbtbl2[(1 << old_planes) - 1];
		farbtbl2[(1 << old_planes) - 1] = farbtbl2[XMAX_COLOR - 1];
	}
		
	for (np = 0; np < old_planes; np++)
		plane_ptr[np] = &col_data[np * len];
	
	pos = 0;
	
	for (x = 0; x < len; x++)
	{
		for (np = 0; np < old_planes; np++)
			back[np] = plane_ptr[np][x];
		
		for (pixel = 0; pixel < 16; pixel++)
		{
			color = 0;
			for (np = 0; np < old_planes; np++)
			{
				color |= ((back[np] & 0x8000) >> (15 - np));
				back[np] <<= 1;
			}
			
			switch (xpixelbytes)
			{
			case 2:
				new_data[pos++] = *(_UWORD *)&farbtbl2[color];
				break;

			case 3:
				p2 = (_UBYTE *)&farbtbl2[color];
				*p1++ = *p2++;
				*p1++ = *p2++;
				*p1++ = *p2;
				break;

			case 4:
				((_ULONG *)new_data)[pos++] = farbtbl2[color];
				break;
			}
		}
	}

	if (old_planes < 8)
		farbtbl2[(1 << old_planes) - 1] = colback;

	if (memflag)
		SFREE(col_data);
}

/*****************************************************************************/
/* Icon an aktuelle Grafikaufloesung anpassen                                */
/* (z.B. 4 Plane Icon an 24 Plane TrueColor)                                 */
/*****************************************************************************/

LOCAL _VOID xfix_cicon(_UWORD *col_data, _LONG len, _WORD old_planes, _WORD new_planes, MFDB *s)
{
	_LONG  x, i, old_len = 0, rest_len = 0;
	_UWORD np, *new_data, mask, pixel, bit, color, back[XMAX_PLANES];
	MFDB  d;
	
	len >>= 1;
	s->fd_nplanes = new_planes;
	old_len = old_planes * len;
	rest_len = new_planes * len - old_len;

	if (old_planes == new_planes)
	{
		if (new_planes == xscrn_planes)
		{
			_BOOL got_mem = FALSE;
			
			d = *s;
			d.fd_stand = FALSE;
			s->fd_addr = col_data;
			if (d.fd_addr == s->fd_addr)
			{
				if ((d.fd_addr = SYSMALLOC(len * 2 * new_planes, MEM_NOERR, "xfix_cicon")) == NULL)
					d.fd_addr = s->fd_addr;
				else
					got_mem = TRUE;
			}
			
			vr_trnfm(xvdi_handle, s, &d);
			if (d.fd_addr != s->fd_addr && got_mem)
			{
				MemCpy(s->fd_addr, d.fd_addr, len * 2 * new_planes);
				SFREE(d.fd_addr);
			}
		} else
		{
			MemCpy(s->fd_addr, col_data, len * 2 * new_planes);
		}
		return;
	}
	
	if (new_planes <= 8)
	{
		new_data = &((_UWORD *)s->fd_addr)[old_len];
		MemSetZero(new_data, rest_len * 2);
		MemCpy(s->fd_addr, col_data, old_len * 2);
		
		col_data = s->fd_addr;
		
		for (x = 0; x < len; x++)
		{
			mask = 0xffff;
	
			for (i = 0; i < old_len; i += len)
				mask &= col_data[x+i];
			
			if (mask)
				for (i = 0; i < rest_len; i += len)
					new_data[x+i] |= mask;
		}

		/* ins geraeteabhaengige Format konvertieren */
		d = *s;
		d.fd_stand = 0;
		if ((d.fd_addr = SYSMALLOC(len * 2 * new_planes, MEM_NOERR, "xfix_cicon")) == NULL)
			d.fd_addr = s->fd_addr;
		
		vr_trnfm (xvdi_handle, s, &d);
		if (d.fd_addr != s->fd_addr)
		{
			MemCpy(s->fd_addr, d.fd_addr, len * 2 * new_planes);
			SFREE(d.fd_addr);
		}
	} else	/* TrueColor, bzw RGB-orientierte Pixelwerte */
	{
		if (xpixelbytes == 0)
		{
			if (farbtbl != NULL)
			{
				_UWORD *plane_ptr[XMAX_PLANES], *pos;
				_UWORD old_col[XMAX_PLANES];
				_UWORD maxcol = 0;
				
				if (old_planes < 8)
				{
					maxcol = (1 << old_planes) - 1;
					MemCpy(old_col, (*farbtbl)[maxcol], new_planes * sizeof(_WORD));
					MemSetZero((*farbtbl)[maxcol], new_planes * sizeof (_WORD));
				}
				
				if ((new_data = SYSMALLOC(len * 2 * new_planes, MEM_NOERR, "xfix_cicon: data")) != NULL)
				{
					_WORD *colp;
					
					MemCpy(new_data, col_data, old_len * 2);
					MemSetZero(new_data + old_len, rest_len * 2);
					
					for (i = 0; i < new_planes; i++)
						plane_ptr[i] = &new_data[i * len];
					
					for (x = 0; x < len; x++)
					{
						bit = 1;
						for (np = 0; np < old_planes; np++)
							back[np] = plane_ptr[np][x];
						
						for (pixel = 0; pixel < 16; pixel++)
						{
							color = 0;
							for (np = 0; np < old_planes; np++)
							{
								color += ((back[np] & 1) << np);
								back[np] >>= 1;
							}
							
							colp = (*farbtbl)[color];
							for (np = 0; np < new_planes; np++)
							{
								pos = plane_ptr[np] + x;
								*pos = (*pos & ~bit) | (colp[np] & bit);
							}
							
							bit <<= 1;
						}
					}
					if (old_planes < 8)
						MemCpy((*farbtbl)[maxcol], old_col, new_planes * sizeof(_WORD));
					
					/* ins geraeteabhaengige Format konvertieren */
					d = *s;
					d.fd_addr = new_data;
					d.fd_stand = 1;
					s->fd_stand = 0;
					
					vr_trnfm(xvdi_handle, &d, s);
				}
			}
		} else
		{
			std_to_byte(col_data, len, old_planes, farbtbl2, s);
		}
	}
}

/*****************************************************************************/
/* Icon ins geraeteabhaengige Format wandeln und ggf an andere Aufloesungen  */
/* anpassen                                                                  */
/*****************************************************************************/

LOCAL _BOOL xadd_cicon(tRsBuffer *global, CICONBLK *cicnblk, OBJECT *obj, _WORD nub)
{
	_WORD	x, y, xmax, best_planes, find_planes;
	_LONG   line;
	CICON	*cicn, **next, *color_icn, *best_icn = NULL;
	_LONG	len;
	MFDB	d;
#if SAVE_MEMORY
	CICON	*max_icn = NULL;
#endif

	len = (cicnblk->monoblk.ib_wicon + 15) / 16 * 2L * cicnblk->monoblk.ib_hicon;

	color_icn = global->colictab + nub;

	best_planes = 1;
	if (xscrn_planes > 8)
		find_planes = 4;
	else
		find_planes = xscrn_planes;

	cicn = cicnblk->mainlist;
	next = &cicnblk->mainlist;

	while (cicn != NULL)
	{
		*next = cicn;
		next = &cicn->next_res;

#if SAVE_MEMORY
		if (cicn->num_planes > xscrn_planes)
			max_icn = cicn;
#endif
		if (cicn->num_planes >= best_planes && cicn->num_planes <= find_planes)
		{
			best_planes = cicn->num_planes;
			best_icn = cicn;
		}
		cicn = cicn->next_res;
	}
	
	if (best_icn == NULL)		/* kein passendes Farbicon gefunden */
		return FALSE;
	*color_icn = *best_icn;

	if (best_planes > 1)
		color_icn->num_planes = xscrn_planes;
	else
		color_icn->num_planes = 1;
	
	/* Platz fuer das geraeteabhaengige Format allozieren */
	if ((color_icn->col_data = SYSMALLOC(len * color_icn->num_planes, MEM_NOERR, "xadd_cicon: color data")) == NULL)
		return FALSE;
	if (color_icn->sel_data)
	{
		if ((color_icn->sel_data = SYSMALLOC(len * color_icn->num_planes, MEM_NOERR, "xadd_cicon: sel data")) == NULL)
		{
			SFREE(color_icn->col_data);
			return FALSE;
		}
	}

	if (best_planes > 1)
	{
		if (best_icn->sel_data == NULL)
		{
			_UWORD *sel_mask;
			_UWORD *col_mask;
			
			/* Selected-Maske vorbereiten */
			if ((color_icn->sel_mask = SYSMALLOC(len, MEM_NOERR, "xadd_cicon: sel mask")) == NULL)
			{
				SFREE(color_icn->col_data);
				if (color_icn->sel_data)
					SFREE(color_icn->sel_data);
				return FALSE;
			}
	
			xmax = (cicnblk->monoblk.ib_wicon + 15) / 16;
			
			sel_mask = (_UWORD *)color_icn->sel_mask;
			col_mask = (_UWORD *)best_icn->col_mask;
			for (y = 0; y < cicnblk->monoblk.ib_hicon; y++)
			{
				line = (_LONG)y * xmax;
	
				for (x = 0; x < xmax; x++)
				{
					if (y & 1)
						sel_mask[line + x] = col_mask[line + x] & 0xaaaa;
					else
						sel_mask[line + x] = col_mask[line + x] & 0x5555;
				}
			}
		}
		
		d.fd_addr  = color_icn->col_data;
		d.fd_w = cicnblk->monoblk.ib_wicon;
		d.fd_h	= cicnblk->monoblk.ib_hicon;
		d.fd_wdwidth = (d.fd_w + 15) >> 4;
		d.fd_stand	= TRUE;
		d.fd_nplanes	= xscrn_planes;
	
		xfix_cicon((_UWORD *)best_icn->col_data, len, best_planes, xscrn_planes, &d);
		if (best_icn->sel_data)
		{
			d.fd_addr = color_icn->sel_data;
			xfix_cicon((_UWORD *)best_icn->sel_data, len, best_planes, xscrn_planes, &d);
		}
	} else
	{
		MemCpy(color_icn->col_data, best_icn->col_data, len);
		MemCpy(color_icn->sel_data, best_icn->sel_data, len);
	}

#if SAVE_MEMORY
	if (best_icn->num_planes < color_icn->num_planes && max_icn != NULL)
	{
		if (best_icn->sel_data == NULL || max_icn->sel_data != NULL)
		{
			best_icn->col_data = max_icn->col_data;
			best_icn->sel_data = max_icn->sel_data;
			best_icn->num_planes = xscrn_planes;
		}
	}
	
	if (best_icn->num_planes == color_icn->num_planes)
	{
		MemCpy(best_icn->col_data, color_icn->col_data, len * color_icn->num_planes);
		SFREE(color_icn->col_data);
		color_icn->col_data = NULL;
		if (best_icn->sel_data != NULL)
		{
			MemCpy(best_icn->sel_data, color_icn->sel_data, len * color_icn->num_planes);
			SFREE(color_icn->sel_data);
			color_icn->sel_data = NULL;
		} else
		{
			MemCpy(cicnblk->monoblk.ib_pmask, color_icn->sel_mask, len);
			best_icn->sel_mask = cicnblk->monoblk.ib_pmask;
			SFREE(color_icn->sel_mask);
			color_icn->sel_mask = NULL;
		}
	} else
	{
		if (best_icn->sel_data == NULL)
		{
			MemCpy(cicnblk->monoblk.ib_pmask, color_icn->sel_mask, len);
			SFREE(color_icn->sel_mask);
			color_icn->sel_mask = NULL;
			best_icn->col_data = color_icn->col_data;
			best_icn->sel_mask = cicnblk->monoblk.ib_pmask;
			best_icn->num_planes = color_icn->num_planes;
		} else
		{
			*best_icn = *color_icn;
		}
	}
	cicnblk->mainlist = best_icn;
#else
	color_icn->next_res = cicnblk->mainlist;
	cicnblk->mainlist = color_icn;
#endif
	return InstUserdef(obj, 0, xdraw_cicon, global->colictab);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID xrsc_clip(_BOOL flag)
{
	_WORD pxy[57];
	
	vq_extnd(xvdi_handle, 0, pxy);
	pxy[2] = pxy[0];
	pxy[3] = pxy[1];
	pxy[0] = 0;
	pxy[1] = 0;
	vs_clip(xvdi_handle, flag, pxy);
}

/*****************************************************************************/
/* Unter TrueColor Pixelwerte der RGB-Palette ermitteln                      */
/*****************************************************************************/

LOCAL _VOID xfill_farbtbl(_VOID)
{
	_WORD np, color, backup[XMAX_PLANES];
	_WORD pxy[8], rgb[3];
	MFDB screen;
	MFDB pixel = { NULL, 16, 1, 1, 0, 1, 0, 0, 0 };
	MFDB stdfm = { NULL, 16, 1, 1, 1, 1, 0, 0, 0 };
	_WORD pixtbl[16] = { 0, 2, 3, 6, 4, 7, 5, 8, 9, 10, 11, 14, 12, 15, 13, 16 };
	_WORD pixel_data[XMAX_PLANES];
	_WORD pixel_data2[XMAX_PLANES];
	
	if (xscrn_planes >= 8)
	{
		if (xscrn_planes > 8)
		{
			if (is_palette == FALSE)	/* Keine Palette in der Resource */
			{
				for (color = 0; color < (XMAX_COLOR - 1); color++)
				{
					if (color < 16)
					{
						vq_color(xvdi_handle, pixtbl[color], 1, (*rgb_palette)[color]);
						(*rgb_palette)[color][3] = pixtbl[color];
					} else
					{
						vq_color(xvdi_handle, color - 1, 1, (*rgb_palette)[color]);
						(*rgb_palette)[color][3] = color - 1;
					}
				}
				vq_color(xvdi_handle, BLACK, 1, (*rgb_palette)[XMAX_COLOR - 1]);
				(*rgb_palette)[XMAX_COLOR - 1][3] = 1;
				is_palette = TRUE;
			}
			
			xrsc_clip(FALSE);
			graf_mouse(M_OFF, NULL);

			if (xpixelbytes == 0)
			{
				farbtbl = SYSMALLOC(sizeof(*farbtbl), MEM_NOERR, "xfill_farbtbl: farbtbl");
			}
			
			MemSetZero(backup, sizeof(backup));
			if (farbtbl != NULL)
				MemSetZero(farbtbl, sizeof(*farbtbl));
			screen.fd_addr = NULL;
			stdfm.fd_nplanes = xscrn_planes;
			pixel.fd_nplanes = xscrn_planes;
			
			vswr_mode(xvdi_handle, MD_REPLACE);
			vsl_ends(xvdi_handle, 0, 0);
			vsl_type(xvdi_handle, SOLID);
			vsl_width(xvdi_handle, 1);
			MemSetZero(pxy, sizeof(pxy));
			
			pixel.fd_addr = backup;		/* Punkt retten */
			vro_cpyfm(xvdi_handle, S_ONLY, pxy, &screen, &pixel);
			
			/* Alte Farbe retten */
			vq_color(xvdi_handle, TEST_COLOR, 1, rgb);

			for (color = 0; color < XMAX_COLOR; color++)
			{
				vs_color(xvdi_handle, TEST_COLOR, (*rgb_palette)[color]);
				vsl_color(xvdi_handle, TEST_COLOR);
				v_pline(xvdi_handle, 2, pxy);
				
				pixel.fd_addr = pixel_data;
				stdfm.fd_addr = pixel_data2;
				
				/* vro_cpyfm, weil v_get_pixel nicht mit TrueColor (>=24 Planes) funktioniert */
				vro_cpyfm(xvdi_handle, S_ONLY, pxy, &screen, &pixel);
				
				if (xpixelbytes != 0)
				{
					if (farbtbl2 != NULL)
					{
						farbtbl2[color] = 0L;
						MemCpy(&farbtbl2[color], pixel.fd_addr, xpixelbytes);
					}
				} else
				{
					vr_trnfm(xvdi_handle, &pixel, &stdfm);
					for (np = 0; np < xscrn_planes; np++)
						if (pixel_data2[np])
							pixel_data2[np] = 0xffff;
					if (farbtbl != NULL)
						MemCpy((*farbtbl)[color], pixel_data2, xscrn_planes * sizeof(_WORD));
				}
			}
			
			/* Alte Farbe restaurieren */
			vs_color(xvdi_handle, TEST_COLOR, rgb);
			vsl_color(xvdi_handle, BLACK);
			
			pixel.fd_addr = backup;	/* Punkt restaurieren */
			vro_cpyfm(xvdi_handle, S_ONLY, pxy, &pixel, &screen);
		
			graf_mouse(M_ON, NULL);
			xrsc_clip(TRUE);
		} else
		{
			if (farbtbl2 != NULL && xpixelbytes != 0)
				for (color = 0; color < XMAX_COLOR; color++)
					*(_UBYTE *)&farbtbl2[color] = (_UBYTE)color;
		}
	}
}

/*****************************************************************************/
/* Testen wieviel Bytes pro Pixel im geraeteabhaengigen Format verwendet werden*/
/*****************************************************************************/

LOCAL _WORD test_rez(_VOID)
{
	_WORD     i, np, color, bpp;
	_WORD     pxy[8], rgb[3];
	_UWORD    backup[XMAX_PLANES], test[XMAX_PLANES], test2[XMAX_PLANES];
	_WORD     black[3] = {0, 0, 0};
	_WORD     white[3] = {1000, 1000, 1000};
	MFDB     screen;
	MFDB     pixel;
	MFDB     stdfm;

	bpp = 0;
	pixel.fd_addr = NULL;
	pixel.fd_w = 16;
	pixel.fd_h = 1;
	pixel.fd_wdwidth = 1;
	pixel.fd_stand = 0;
	pixel.fd_nplanes = xscrn_planes;
	pixel.fd_r1 = 0;
	pixel.fd_r2 = 0;
	pixel.fd_r3 = 0;
	stdfm = pixel;
	stdfm.fd_stand = 1;
	
	if (xscrn_planes >= 8)
	{
		stdfm.fd_nplanes = pixel.fd_nplanes = xscrn_planes;

		if (xscrn_planes == 8)
		{
			color = 0xff;
			MemSetZero(test2, xscrn_planes * sizeof(_WORD));
			for (np = 0; np < xscrn_planes; np++)
				test2[np] = (color & (1 << np)) << (15 - np);
	
			pixel.fd_addr = test;
			stdfm.fd_addr = test2;
			vr_trnfm(xvdi_handle, &stdfm, &pixel);
			
			for (i = 1; i < xscrn_planes; i++)
				if (test[i])
					break;
			
			if (i >= xscrn_planes && !(test[0] & 0x00ff))
				bpp = 1;
		} else
		{
			xrsc_clip(FALSE);
			screen.fd_addr = NULL;
			
			MemSetZero(backup, sizeof(backup));
		
			vswr_mode(xvdi_handle, MD_REPLACE);
			vsl_ends(xvdi_handle, 0, 0);
			vsl_type(xvdi_handle, 1);
			vsl_width(xvdi_handle, 1);
			MemSetZero(pxy, sizeof(pxy));
			
			graf_mouse(M_OFF, NULL);
		
			pixel.fd_addr = backup;	/* Punkt retten */
			vro_cpyfm(xvdi_handle, S_ONLY, pxy, &screen, &pixel);
		
			/* Alte Farbe retten */
			vq_color(xvdi_handle, TEST_COLOR, 1, rgb);
	
			/* 1 Punkt in weiss setzen */
			vsl_color(xvdi_handle, TEST_COLOR);
			vs_color(xvdi_handle, TEST_COLOR, white);
			v_pline(xvdi_handle, 2, pxy);
			
			/* Geraeteabhaengiges Format testen */
			MemSetZero(test, xscrn_planes * sizeof(_WORD));
			pixel.fd_addr = test;
			vro_cpyfm(xvdi_handle, S_ONLY, pxy, &screen, &pixel);
			
			for (i = (xscrn_planes + 15) / 16 * 2; i < xscrn_planes; i++)
				if (test[i])
					break;
			
			if (i >= xscrn_planes)
			{
				vs_color(xvdi_handle, TEST_COLOR, black);
				v_pline(xvdi_handle, 2, pxy);
				
				MemSetZero(test, xscrn_planes * sizeof(_WORD));
				vro_cpyfm(xvdi_handle, S_ONLY, pxy, &screen, &pixel);
				
				for (i = (xscrn_planes + 15) / 16 * 2; i < xscrn_planes; i++)
					if (test[i])
						break;
				
				if (i >= xscrn_planes)
					bpp = (xscrn_planes + 7) / 8;
			}

			/* Alte Farbe restaurieren */
			vs_color(xvdi_handle, TEST_COLOR, rgb);
	
			pixel.fd_addr = backup;	/* Punkt restaurieren */
			vro_cpyfm(xvdi_handle, S_ONLY, pxy, &pixel, &screen);
		
			graf_mouse(M_ON, NULL);
	
			xrsc_clip(TRUE);
		}
	}

	return bpp;
}


/*****************************************************************************/
/* Farbicons fuer aktuelle Aufloesung initialisieren                         */
/*****************************************************************************/

LOCAL _VOID xrsrc_exit(_VOID)
{
	if (rgb_palette != NULL)
	{
		SFREE(rgb_palette);
		rgb_palette = NULL;
	}
	if (farbtbl != NULL)
	{
		SFREE(farbtbl);
		farbtbl = NULL;
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID do_ciconfix(_ULONG header, tRsBuffer *global, _LONG rs_len)
{
	_LONG   *cicon_liste;
	_WORD   i;
	OBJECT *obj;
	RSXHDR *rsxhdr;
	
	rsxhdr = global->xhdr;
	cicon_liste = (_LONG *)(*(_LONG *)(rsxhdr->rsh_rssize + (rsxhdr->rsh_rssize & 1L) + header + sizeof (_LONG)) + header);
	if ((_LONG)cicon_liste - header > rsxhdr->rsh_rssize && (_LONG)cicon_liste - header < rs_len)
	{
		if (fill_cicon_liste(cicon_liste, header, global) != 0)
		{
			_WORD nub = 0, *palette;
			
			if (global->colictab != NULL)
			{
				xpixelbytes = test_rez();

				if (rgb_palette == NULL)
				{
					rgb_palette = SYSMALLOC(sizeof(*rgb_palette), MEM_NOERR, "do_ciconfix: rgb_palette");
					InstallTermproc(xrsrc_exit);
				}
				
				palette = (_WORD *)*(_LONG *)(rsxhdr->rsh_rssize + (rsxhdr->rsh_rssize & 1L) + header + 2 * sizeof (_LONG));
				if (palette != NULL && palette != (_VOID *)-1)
				{
					palette = (_WORD *)((_UBYTE *)palette + header);
					MemCpy(*rgb_palette, palette, sizeof(*rgb_palette));
					is_palette = TRUE;
				} else
				{
					is_palette = FALSE;
				}
				
				xfill_farbtbl();
			
				for (i = 0; i < rsxhdr->rsh_nobs; i++)
				{
					obj = &((OBJECT *)(rsxhdr->rsh_object + header))[i];
					if ((obj->ob_type & 0xff) == G_CICON)
					{
						if (xadd_cicon(global, obj->ob_spec.ciconblk, obj, nub) == FALSE)
						{
							MemSetZero(&global->colictab[nub], sizeof(CICON));
							obj->ob_type = (obj->ob_type & 0xff00) | G_ICON;
						}
						nub++;
						obj->ob_spec.index -= header;
					}
				}
			} else
			{
				for (i = 0; i < rsxhdr->rsh_nobs; i++)
				{
					obj = &((OBJECT *)(rsxhdr->rsh_object + header))[i];
					if ((obj->ob_type & 0xff) == G_CICON)
					{
						obj->ob_type = (obj->ob_type & 0xff00) | G_ICON;
						obj->ob_spec.index -= header;
					}
				}
			}
		}
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID hdr2xhdr(RSXHDR *xhdr, RSHDR *hdr)
{
	xhdr->rsh_vrsn = hdr->rsh_vrsn;
	xhdr->rsh_extvrsn = 0;
	xhdr->rsh_object = hdr->rsh_object;
	xhdr->rsh_tedinfo = hdr->rsh_tedinfo;
	xhdr->rsh_iconblk = hdr->rsh_iconblk;
	xhdr->rsh_bitblk = hdr->rsh_bitblk;
	xhdr->rsh_frstr = hdr->rsh_frstr;
	xhdr->rsh_string = hdr->rsh_string;
	xhdr->rsh_imdata = hdr->rsh_imdata;
	xhdr->rsh_frimg = hdr->rsh_frimg;
	xhdr->rsh_trindex = hdr->rsh_trindex;
	xhdr->rsh_nobs = hdr->rsh_nobs;
	xhdr->rsh_ntree = hdr->rsh_ntree;
	xhdr->rsh_nted = hdr->rsh_nted;
	xhdr->rsh_nib = hdr->rsh_nib;
	xhdr->rsh_nbb = hdr->rsh_nbb;
	xhdr->rsh_nstring = hdr->rsh_nstring;
	xhdr->rsh_nimages = hdr->rsh_nimages;
	xhdr->rsh_rssize = hdr->rsh_rssize;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL rs_read(tRsBuffer *global, CONST _UBYTE *fname)
{
	_WORD fh;
	_UBYTE tmpnam[PATH_MAX];
	DTA  dta, *old_dta;
	_LONG size;
	_BOOL ret = FALSE;
	RSXHDR *xhdr;
	RSHDR *hdr;
	
	strCpy(tmpnam, fname);

/*DYJ 5.30b Start*/
	CatFiles_shel_find(tmpnam,sizeof(tmpnam));
/*DYJ  Ende; alt:	
	shel_find(tmpnam);
*/

	old_dta = Fgetdta();
	Fsetdta(&dta);
	if (Fsfirst(tmpnam, 0x10) == 0)
		size = dta.d_length;
	else
		size = 0;
	Fsetdta(old_dta);

	if (size > sizeof(RSHDR) && (fh = (_WORD)Fopen(tmpnam, 0)) > 0)
	{
		if ((global->xhdr = xhdr = (RSXHDR *)MALLOC(size + sizeof(RSXHDR), "rs_read")) != NULL)
		{
			global->rscdata = hdr = (tpRSHDR)(xhdr + 1);;
			
			if (Fread(fh, size, hdr) == size)
			{
				rsrc_flip(hdr, size);
				if ((hdr->rsh_vrsn & 0x03) == 3)
				{
					MemCpy(xhdr, hdr, sizeof(RSXHDR));
				} else
				{
					hdr2xhdr(xhdr, hdr);
				}
				do_rsfix(global, xhdr->rsh_rssize);

				if (size > xhdr->rsh_rssize + 72L)	/* Farbicons in der Resource? */
					do_ciconfix((_ULONG)hdr, global, size);
				ret = TRUE;
			}
		}
		Fclose(fh);
	}

	return ret;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL xrsrc_reloc(RSHDR *hdr, _ULONG length, tRsBuffer *pglobal)
{
	_BOOL ret = FALSE;
	RSXHDR *xhdr;
	
	if (length > sizeof(RSHDR))
	{
		pglobal->xhdr = xhdr = NEW(RSXHDR, "xrsrc_reloc");
		if (xhdr != NULL)
		{
			pglobal->rscdata = hdr;
			if ((hdr->rsh_vrsn & 0x03) == 3)
			{
				MemCpy(xhdr, hdr, sizeof(RSXHDR));
			} else
			{
				hdr2xhdr(xhdr, hdr);
			}
			do_rsfix(pglobal, xhdr->rsh_rssize);
			if (length > xhdr->rsh_rssize + 72)
				do_ciconfix((_ULONG)hdr, pglobal, length);
			rs_fixindex(pglobal);
			ret = TRUE;
		}
	}
	return ret;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL RESOURCE NewRsc(_VOID)
{
	RESOURCE rsc;
	
	rsc = NEW(Resource, "NewRsc");
	if (rsc != NULL)
	{
		MemSetZeroStruct(*rsc);
/*
		if (RscList == NULL)
			InstallTermproc(RscFreeAll);
*/
		rsc->next = RscList;
		RscList = rsc;
	}
	return rsc;
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

GLOBAL RESOURCE RscReloc(_VOID *address, _LONG filesize)
{
	_ULONG length;
	RSHDR *hdr;
	RSXHDR *xhdr;
	_ULONG *p;
	RESOURCE rsc;
	
	hdr = address;
	xhdr = address;
	rsrc_flip(address, filesize);
	if ((hdr->rsh_vrsn & 0x03) == 0x03)
		length = xhdr->rsh_rssize;
	else
		length = hdr->rsh_rssize;
	if (length > filesize)
		return NULL;
	if (hdr->rsh_vrsn & 0x04)
	{
		p = (_ULONG *)((_UBYTE *)address + length);
		if (*p != 0)
			length = *p;
	}
	if (length > filesize)
		return NULL;
	rsc = NewRsc();
	if (rsc != NULL)
	{
		if (xrsrc_reloc(address, length, &rsc->RsBuffer))
			return rsc;
		RscList = rsc->next;
		OFREE(rsc);
	}
	return NULL;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL RESOURCE RscLoad(CONST _UBYTE *name)
{
	RESOURCE rsc;
	
	rsc = NewRsc();
	if (rsc != NULL)
	{
		if (rs_read(&rsc->RsBuffer, name))
		{
			rs_fixindex(&rsc->RsBuffer);
			return rsc;
		}
		RscList = rsc->next;
		OFREE(rsc);
	}
	return NULL;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID RscFree(RESOURCE rsc)
{
	_WORD     i, j;
	CICON    *color_icn;
	OBJECT *tree;
	RESOURCE *search;
	
	if (rsc == NULL)
		return;
	for (i = 0; i < rsc->RsBuffer.xhdr->rsh_ntree; i++)
	{
		tree = rsc->RsBuffer.tree[i];
		j = 0;
		for (;;)
		{
			if ((tree[j].ob_type & 0xff) == G_USERDEF)
				FreeUserdef(tree, j);
			if ((tree[j].ob_type & 0xff00) == (24 /* LongEdit */ << 8))
			{
				TEDINFO *tedPtr;
				_UBYTE *xted;
				
				tedPtr = tree[j].ob_spec.tedinfo;
				if (tedPtr->te_ptmplt == NULL && tedPtr->te_pvalid != NULL)
				{
					xted = tedPtr->te_pvalid;
					tedPtr->te_pvalid = NULL;
					SFREE(xted);
				}
				if (tedPtr->te_ptext != NULL)
				{
					SFREE(tedPtr->te_ptext);
					tedPtr->te_ptext = NULL;
				}
			}
			if (tree[j].ob_flags & LASTOB)
				break;
			j++;
		}
	}
	if ((color_icn = rsc->RsBuffer.colictab) != NULL)
	{
		for (i = 0; i < rsc->RsBuffer.colicons; i++)
		{
			/* if (color_icn[i].num_planes > 1) */
			{
				if (color_icn[i].col_data != NULL)
					SFREE(color_icn[i].col_data);
				if (color_icn[i].sel_data != NULL)
					SFREE(color_icn[i].sel_data);
				if (color_icn[i].sel_data == NULL && color_icn[i].sel_mask != NULL)
					SFREE(color_icn[i].sel_mask);
			}
		}
		
		SFREE(color_icn);
		rsc->RsBuffer.colictab = NULL;
	}
	if (rsc->RsBuffer.xhdr != NULL)
/*DYJ 5.36j Start*/
	{
		SFREE(rsc->RsBuffer.xhdr);
		rsc->RsBuffer.xhdr=NULL;
	}
/*DYJ  Ende; alt:	
		SFREE(rsc->RsBuffer.xhdr);
*/
	for (search = &RscList; *search != NULL; search = &(*search)->next)
		if (*search == rsc)
		{
			*search = rsc->next;
			break;
		}
	OFREE(rsc);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID RscFreeAll(_VOID)
{
	while (RscList != NULL)
		RscFree(RscList);
}
/*** ------------------------------------------------------------------------ ***/
/*	_VOID RscFreeLib(_VOID)														*/
/*	Gibt die LIB Resource wieder frei.											*/
/*	Parameter:	keine															*/
/*	Ergebnis:	keines															*/		
/*	14.4.03 von Dimitri Junker	DYJ 5.27a										*/
/*** ------------------------------------------------------------------------ ***/
GLOBAL _VOID RscFreeLib(_VOID)
{
	if(theRSC != NULL)
		RscFree(theRSC);
}
/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID *RscGaddr(RESOURCE rsc, _WORD type, _WORD item)
{
	if (rsc != NULL)
	{
		return get_address(&rsc->RsBuffer, type, item);
	}
	return NULL;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID RscObfix(RESOURCE rsc, OBJECT *tree, _WORD object)
{
	if (rsc != NULL)
		rs_obfix(tree, object);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID RscGetHeader(RESOURCE rsc, RSXHDR *hdr)
{
	*hdr = *(rsc->RsBuffer.xhdr);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL OBJECT **RscGetTrees(RESOURCE rsc)
{
	return rsc->RsBuffer.tree;
}
/*** ------------------------------------------------------------------------ ***/
/*	_BOOL Rsc_RscInit(_UBYTE *homePath,_UBYTE *rsrcname)						*/
/*	Ldt die catlib.rsc in ihrer jeweiligen Sprachversion						*/
/*	Parameter:	homePath:	Dort ist das PRG									*/
/*				rsrcname:	Name des RSC															*/
/*	Ergebnis:	OK?															*/		
/*	18.2.03 von Dimitri Junker	DYJ 5.21i										*/
/*** ------------------------------------------------------------------------ ***/
/*DYJ 5.22b */
GLOBAL _BOOL Rsc_RscInit(_UBYTE *homePath,_UBYTE *rsrcname)
{
	_UBYTE scrap[PATH_MAX];
	
	if (theRSC == NULL)
	{
		if ((theRSC = RscLoad(rsrcname)) == NULL)
		{
			strCpy(scrap,homePath);
			F_Path_Append(scrap, rsrcname);
			theRSC = RscLoad(rsrcname);
		}
	}
	if (theRSC == NULL)
		return FALSE;
	
	TreeAddrLib = RscGetTrees(theRSC);
	switch(*Rsc_WrkString(RSC_LANG))
	{
		case '0':
			RscLang=L_GERMAN;
			break;
		case '1':
			RscLang=L_ENGLISH;
			break;
		case '2':
			RscLang=L_FRENCH;
			break;
	}
	return TRUE;
}
/*** ------------------------------------------------------------------------ ***/
/*	_UBYTE *Rsc_WrkString(_WORD nr)												*/
/*	Ermittelt einen freien oder Alertstring aus der catlib.rsc					*/
/*	Parameter:	nr:	die Stringnummer															*/
/*	Ergebnis:	der String															*/		
/*	24.2.03 von Dimitri Junker	DYJ 5.21i										*/
/*** ------------------------------------------------------------------------ ***/
GLOBAL _UBYTE *Rsc_WrkString(_WORD nr)
{
	static _UBYTE dummy[30];
	_UBYTE *ret;
	ret=*((_UBYTE **)RscGaddr(theRSC, R_FRSTR, nr));
	if(!ret)
	{
		ret=dummy;
		sprintf(ret,"[3][NO RSC;Nr:L%d][OK]",nr);
	}
	return ret;
}
/*** ------------------------------------------------------------------------ ***/
/*	_WORD Rsc_lang(_VOID)														*/
/*	gibt zurck in welcher Sprache die catlib.rsc ist							*/
/*	Parameter:	keine															*/
/*	Ergebnis:	L_GERMAN oder L_ENGLISH											*/		
/*	24.2.03 von Dimitri Junker	DYJ 5.21i										*/
/*** ------------------------------------------------------------------------ ***/
GLOBAL _WORD Rsc_lang(_VOID)
{
	return RscLang;
}
/*** ------------------------------------------------------------------------ ***/
/*	_BOOL Rsc_EnvLang(_UBYTE *prgDir,_UBYTE *ret)								*/
/*	Wertet die verschiedenen Files und Environmentvariablen aus ber die man	*/
/*	die Sprache einstellen kann und gibt "de" oder "en" zurck					*/
/*	Parameter:	prgDir:	Ordner in dem sich das Programm befindet				*/
/*				ret: String fr die Rckgabe									*/
/*	Ergebnis:	FALSE wenn Defaultmig "de" verwendet wurde, also kein File	*/
/*				und kein ENV da war												*/		
/*	15.3.03 von Dimitri Junker	DYJ 5.22f										*/
/*** ------------------------------------------------------------------------ ***/
/*DYJ 5.23d */
GLOBAL _BOOL Rsc_EnvLang(_UBYTE *prgDir,_UBYTE *ret)
{
	_UBYTE *dir,scrap[PATH_MAX],accept[]="de en",*lang;
	TEXTFILENO tf;
	*ret='\0';
/* 1.: CAT_LANG.DAT im Home Verzeichnis*/
	if ((dir = getenv("HOME")) != NULL && *dir != '\0')
	{
		strCpy(scrap,dir);
		F_Path_Append(scrap, CAT_LANG_FILE);
		if (mtTextfiles_OpenTextfile(scrap, READ, 512, &tf) == GERR_OK)
		{
			mtTextfiles_ReadLine(tf, scrap, 5);
			mtTextfiles_CloseTextfile(&tf);
			if(strCaseStr(accept,scrap))
				strCpy(ret,scrap);
		}
	}
/* 2.: CAT_LANG Environmentvariable*/
	if (!(*ret) && (lang = getenv("CAT_LANG")) != NULL && *lang != '\0')
	{
		if(strCaseStr(accept,lang))
			strCpy(ret,lang);
	}
/* 3.: CAT_LANG.DAT im Programm Verzeichnis*/
	if(!(*ret))
	{
		strCpy(scrap,prgDir);
		F_Path_Append(scrap, CAT_LANG_FILE);
		if (mtTextfiles_OpenTextfile(scrap, READ, 512, &tf) == GERR_OK)
		{
			mtTextfiles_ReadLine(tf, scrap, 5);
			mtTextfiles_CloseTextfile(&tf);
			if(strCaseStr(accept,scrap))
				strCpy(ret,scrap);
		}
	}
/* 4.: LC_ALL,LC_MESSAGES,LANG Environmentvariable*/
	if(!(*ret))
	{
		lang = getenv("LC_ALL");
		if(!lang || *lang == '\0')
			lang = getenv("LC_MESSAGES");
		if(!lang || *lang == '\0')
			lang = getenv("LANG");
		if(lang && *lang!='\0')
		{
			strCpy(ret,LANGUAGE_EN);
			switch(ucase(*lang))
			{
				case 'G':
					if(!strnCaseCmp(lang,"german",6))
						strCpy(ret,LANGUAGE_DE);
					break;
				case 'D':
					if(!strnCaseCmp(lang,"DE_",3))
						strCpy(ret,LANGUAGE_DE);
					break;
				case 'E':
					if(!strnCaseCmp(lang,"EN_",3))
						strCpy(ret,LANGUAGE_EN);
					break;
			}
		}
	}
	if(!(*ret))
	{
		strCpy(ret,LANGUAGE_DE);
		return FALSE;
	}
	else
		return TRUE;
}


