/*
 * Diese Datei ist Teil der Magic-Library,
 * und darf in dieser Form nur als Teil des CAT-Projekts
 * verwendet werden.
 * 
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Magic ist Copyright (c) by Peter Hellinger.
 *
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */


#include <mtxobjec.h>
#include <ro_mem.h>


typedef OBJECT *tTree;

typedef struct {
	DrawProc ubCode;
	OBSPEC ubPara;
	_WORD obType;
	_VOID *priv;
} MTUSERBLK, *PtrMTUSERBLK;

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

GLOBAL _BOOL InstUserdef(OBJECT *tree, _WORD objc, DrawProc proc, _VOID *env)
{
	PtrMTUSERBLK uPtr;
	
	if ((tree[objc].ob_type & 0xff) != G_USERDEF)
	{
		uPtr = NEW(MTUSERBLK, "InstUserdef");
		if (uPtr == NULL)
			return FALSE;
		uPtr->ubCode = proc;
		uPtr->ubPara = tree[objc].ob_spec;
		uPtr->obType = tree[objc].ob_type;
		uPtr->priv = env;
		tree[objc].ob_type = G_USERDEF;
		tree[objc].ob_spec.userblk = (USERBLK *)uPtr;
	}
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID FreeUserdef(OBJECT *tree, _WORD objc)
{
	PtrMTUSERBLK uPtr;
	
	if ((tree[objc].ob_type & 0xff) == G_USERDEF)
	{
		uPtr = (PtrMTUSERBLK)tree[objc].ob_spec.userblk;
		tree[objc].ob_type = uPtr->obType;
		tree[objc].ob_spec = uPtr->ubPara;
		OFREE(uPtr);
	}
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _WORD GetObtype(OBJECT *tree, _WORD objc)
{
	PtrMTUSERBLK uPtr;
	
	if ((tree[objc].ob_type & 0xff) == G_USERDEF)
	{
		uPtr = (PtrMTUSERBLK)tree[objc].ob_spec.userblk;
		return uPtr->obType;
	}
	return tree[objc].ob_type;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL OBSPEC *GetObSpec(OBJECT *tree, _WORD objc)
{
	PtrMTUSERBLK uPtr;
	
	if ((tree[objc].ob_type & 0xff) == G_USERDEF)
	{
		uPtr = (PtrMTUSERBLK)tree[objc].ob_spec.userblk;
		return &uPtr->ubPara;
	}
	return &tree[objc].ob_spec;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID *GetPrivate(OBJECT *tree, _WORD objc)
{
	PtrMTUSERBLK uPtr;
	
	if ((tree[objc].ob_type & 0xff) == G_USERDEF)
	{
		uPtr = (PtrMTUSERBLK)tree[objc].ob_spec.userblk;
		return uPtr->priv;
	}
	return NULL;
}
