/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */


#include <wdwmanag.h>
#include <magicsys.h>
#include <portvdi.h>
#include <tos.h>
#include <magiccoo.h>
#include <mtappl.h>
#include <mtutils.h>
#include <rectfunc.h>
#include <strconv.h>
#ifndef __MINTBIND_H__
#include <mintbind.h>
#endif
#include <ro_mem.h>
#include <dd.h>
#include <signal_.h>
#include <fontsele.h>
#include <termproc.h>
#include <protokol.h>
#include <keyboard.h>

#include <routinec.h>
#include <routines.h>
#include <file_io.h>
#include <debug.h>


GLOBAL HWND theTopWindow;         /* Enthaelt immer die Nummer des Topwindows
                                   * Wird in HandleEvent upgedatet
                                   */
GLOBAL HWND ownTopWindow;         /* Enthaelt immer die Nummer des Topwindows
                                   * von CAT, also des eigenen, hoechsten
                                   * Fensters. Muss nicht mit theTopWindow
                                   * identisch sein!
                                   */

LOCAL handleNewTopProc handleNewTop;    /* Siehe Kommentar zu Typ */
LOCAL handleEventProc handlePostEvent;    /* Siehe Kommentar zu Typ */

#define minWindWidth  80
#define minWindHeight 80

#define WINDOW_DEF wdwSlot

struct _wdwSlot;
typedef struct _wdwSlot wdwSlot, *ptrWdwSlot;

struct _wdwSlot {
	HWND wdw;               /* Window-Handle               */
	HVDI vdi;               /* VDI-Workstation fuer Fenster */
	_BOOL used;
	_BOOL isFull;
	_BOOL isTop;
	_BOOL isHidden;
	_BOOL isIcon;
	GRECT wdwLast;
	GRECT wdwCurr;
	GRECT wdwIcon;
	GRECT wdwWork;
	GRECT wdwFull;
	LGRECT document;
	_LONG xFactor;
	_LONG yFactor;           /* Multiplikatoren fuer Document-Struktur */
	_LONG pageW;
	_LONG pageH;             /* Breite und Hoehe einer Seite in Einheiten */
	_LONG minScrollW;
	_LONG minScrollH;        /* Um diesen Betrag wird beim Zeilenweise scrollen gescrollt */
	_LONG minScrollP;        /* Soviel Zeilen sollen beim seitenweisen runterscrollen mind. sichtbar sein. DYJ 4.24k */
	_WORD pixOff;            /* Offset am linken Fensterrand in Pixeln */
	_BOOL snap;           /* Snap on Font-Size */
	_UWORD comps;
	_UBYTE wdwInfo[140];
	_UBYTE wdwTitle[140];
	_WORD VslSize;
	_WORD VslPos;
	_WORD HslSize;
	_WORD HslPos;           /* Die Positionen und Groessen der Slider */
	_BOOL onlyTop;			/* Nur dieses Fenster darf Topwindow sein */
	HWND lastOnlyTop;       /* Fensternummer des letzten Windows, welches nur Top sein durfte */
	_BOOL hasIdem;			/* Fenster setzt Ersatzstring fr gleiche Elemente */
	OBJECT *wdwMenu;        /* Adresse eines Menus im Fenster */
	OBJECT *wdwDial;        /* Adresse eines Dials im Fenster */
	
	/* Prozeduren */
	handleButtonProc hdlButton;
	handleMessageProc hdlMessage;
	handleKeyProc hdlKey;
	handleTimerProc hdlTimer;
	
	handleRectProc hdlRect;
	
	snapProc hdlSnap; 
	closeProc hdlClose;
	drawProc hdlDraw; 
	topProc hdlTop;         /* Wird aufgerufen, wenn das Fenster getoppt 
	                         * werden soll. Kann auch False zurueckgeben 
	                         */
	untopProc hdlUntop; 
	wdwupdateProc hdlUpdate;   /* Wird aufgerufen vor 
	                         * geplanten Bildschirmausgaben */
	setWorkProc setNewWdw;     
	getRectProc wdwGetScroll;
	                        /* wird aufgerufen, wenn der Arbeits-
	                         * ausschnitt des Fensters sich 
	                         * veraendert hat.
	                         */
	hideProc hdlHide;
	                        /* wird aufgerufen, wenn das Fenster iconifiziert
	                         * oder versteckt wird bzw. beim Wiederherstellen
	                         */
	
	/* Drag & Drop Support */
	_BOOL ddClientInstalled;
	getExtsProc ddGetExts;
	acceptDataProc ddAcceptData;
	writeDataProc ddWriteData;
	_BOOL ddServerInstalled;
	readDataProc ddReadData;
	getHeaderProc ddGetHeader;
	
	FONT_ACCEPT_FUNC acceptFont;
	COLOR_ACCEPT_FUNC acceptColor;
		
	_VOID *special;          /* Variabler Parameter */
	ptrWdwSlot next;
	ptrWdwSlot prev;
};

/* globale Variablen in diesem Modul */
LOCAL WINDOW_DEF *windows;
LOCAL HWND onlyOneTop;
LOCAL OBJECT *iconHdl;
LOCAL _BOOL allIconified;
LOCAL _BOOL iconifySupportEnabled;
LOCAL _BOOL isInRectList;        /* Gerade in WF_FIRST, WF_NEXT */
LOCAL OBJECT *globalMenu;
LOCAL _WORD menuLength;
LOCAL _BOOL menuDisabled;
LOCAL _WORD disableCounter;
LOCAL handleGlobalKeyProc handleGlobalKey;
LOCAL handleMessProc handleGlobalMess;

LOCAL _WORD fontApid;
LOCAL _WORD fontId;
LOCAL _WORD fontNewSize;
LOCAL _WORD fontRot;
LOCAL _WORD fontSkew;
LOCAL _WORD fontVector;

#define FONT_CHANGED  0x7a18
#define FONT_SELECT   0x7a19
#define FONT_ACK      0x7a1a
#define XFONT_CHANGED 0x7a1b

#define COLOR_ID      0xc010


/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

LOCAL WINDOW_DEF *FindWindow(HWND wdw)
{
	WINDOW_DEF *wr;

	for (wr = windows; wr != NULL && wr->wdw != wdw; wr = wr->next)
		;
	return wr;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID SendMessage(HWND win, _WORD apid, _WORD msg)
{
	_WORD message[8];

	message[0] = msg;
	message[1] = gl_apid;
	message[2] = 0;
	message[3] = win;
	message[4] = 0;
	message[5] = 0;
	message[6] = 0;
	message[7] = 0;
	appl_write(apid, 16, message);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID SendTop(HWND wdw, _WORD apId)
{
	SendMessage(wdw, apId, WM_TOPPED);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID SendClosed(HWND wdw, _WORD apId)
{
	SendMessage(wdw, apId, WM_CLOSED);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID SendFulled(HWND wdw, _WORD apId)
{
	SendMessage(wdw, apId, WM_FULLED);
}

/*** ---------------------------------------------------------------------- ***/

/*====================================================*
 *                                                    *
 *   Low-Level-Funktionen                             *
 *                                                    *
 *====================================================*/

/* Rechteck- und Clipfunctionen */

GLOBAL _VOID WdwManager_SetClip(HVDI hdl, CONST GRECT *clip, _BOOL relative)
{
	GRECT gr;

	if (relative)
	{
		gr = *clip;
		AbsRect(&gr);
		clip = &gr;
	}
	if (hdl > 0)
		vs_clip(hdl, TRUE, (_WORD *)clip);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID ClipWork(WINDOW_DEF *wdw)
{
	GRECT clip;

	clip = rc_clip(&deskSize, &wdw->wdwWork);
	WdwManager_SetClip(wdw->vdi, &clip, TRUE);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID Wind_get(_WORD handle, _WORD typ, GRECT *para)
{
	wind_get(handle, typ, &para->g_x, &para->g_y, &para->g_w, &para->g_h);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID Wind_set(_WORD handle, _WORD typ, CONST _VOID *para)
{
	CONST GRECT *gr;
	
	if (typ == WF_NAME || typ == WF_INFO || typ == WF_NEWDESK)
	{
		wind_set(handle, typ, para, 0, 0);
	} else if (para == NULL)
	{
		wind_set(handle, typ, 0, 0, 0, 0);
	} else
	{
		gr = para;
		wind_set(handle, typ, gr->g_x, gr->g_y, gr->g_w, gr->g_h);
	}
}


/*** ---------------------------------------------------------------------- ***/

/* Gibt TRUE und ein Rechteck zurueck, solange noch
 * ein Rechteck in der Rechteckliste ist
 */
GLOBAL _BOOL WdwManager_RectList(HWND wdw, _WORD flag, GRECT *work)
{
	_BOOL b;

	b = FALSE;
	if (wdw > 0)
	{
		Wind_get(wdw, flag ? WF_NEXTXYWH : WF_FIRSTXYWH, work);
		b = !((work->g_w == 0) || (work->g_h == 0));
	}
	isInRectList = b;
	return b;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _BOOL WdwManager_RectListActive(_VOID)
{
	return isInRectList;
}

/*** ---------------------------------------------------------------------- ***/

/* Default-Prozeduren */

LOCAL _VOID defDraw(HWND wdw, HVDI vdi, _VOID *special, CONST GRECT *clip)
{
	GRECT gr;

	UNUSED(wdw);
	UNUSED(special);
	if (vdi > 0)
	{
		gr = *clip;
		AbsRect(&gr);
		vsf_color(vdi, WHITE);
		vsf_interior(vdi, FIS_SOLID);
		vr_recfl(vdi, (_WORD *)&gr);
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL defButton(HWND wdw, _VOID *special, _WORD mx, _WORD my, _UWORD kstate, _UWORD buttons, _WORD clicks)
{
	UNUSED(wdw);
	UNUSED(special);
	UNUSED(mx);
	UNUSED(my);
	UNUSED(kstate);
	UNUSED(buttons);
	UNUSED(clicks);
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL defKey(HWND wdw, _VOID *special, _WORD taste, _UBYTE key, _UBYTE scan, _UWORD kstate)
{
	UNUSED(wdw);
	UNUSED(special);
	UNUSED(taste);
	UNUSED(key);
	UNUSED(scan);
	UNUSED(kstate);
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL defTimer(HWND wdw, _VOID *special)
{
	UNUSED(wdw);
	UNUSED(special);
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID defSnap(HWND wdw, _VOID *special, GRECT *gr)
{
	UNUSED(wdw);
	UNUSED(special);
	UNUSED(gr);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL defClose(HWND wdw, HVDI vdi, _VOID *special, _BOOL force)
{
	UNUSED(wdw);
	UNUSED(vdi);
	UNUSED(special);
	UNUSED(force);
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL defTop(HWND wdw, _VOID *special)
{
	UNUSED(wdw);
	UNUSED(special);
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID defUntop(HWND wdw, _VOID *special)
{
	UNUSED(wdw);
	UNUSED(special);
}
/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID defUpdate(HWND wdw, _VOID *special, _BOOL begin)
{
	UNUSED(wdw);
	UNUSED(special);
	if (begin)
	{
		Wind_Update(BEG_UPDATE);
		MouseOff();
	} else
	{
		MouseOn();
		Wind_Update(END_UPDATE);
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID defSetwork(HWND wdw, _VOID *special, CONST LGRECT *doc, _BOOL slided)
{
	UNUSED(wdw);
	UNUSED(special);
	UNUSED(doc);
	UNUSED(slided);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID defGetrect(HWND wdw, HVDI vdi, _VOID *special, GRECT *work)
{
	UNUSED(wdw);
	UNUSED(vdi);
	UNUSED(special);
	UNUSED(work);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID defHide(HWND wdw, _VOID *special, _BOOL hide)
{
	UNUSED(wdw);
	UNUSED(special);
	UNUSED(hide);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID AdaptIconPos(CONST GRECT *work)
{
	OBJECT *ob;

	if ((ob = iconHdl) != NULL)
	{
		ob->ob_x = work->g_x;
		ob->ob_y = work->g_y;
		ob->ob_width = work->g_w;
		ob->ob_height = work->g_h;
	}
}

/*** ---------------------------------------------------------------------- ***/

/*
 * Window neu zeichnen
 * In dieser Prozedur wird die Rechteckliste abgeklappert und
 * fuer alle Rechtecke, die vorhanden sind,
 * die Zeichenprozedur fuer das Fenster aufgerufen.
 * Clipping wird schon gesetzt.
 */
LOCAL _VOID updateWdw(WINDOW_DEF *wdw, CONST GRECT *frame)
{
	GRECT work;

	if (wdw->isIcon)
	{
		Wind_get(wdw->wdw, WF_WORKXYWH, &wdw->wdwWork);
		AdaptIconPos(&wdw->wdwWork);
		if (WdwManager_RectList(wdw->wdw, FALSE, &work))
		{
			Wind_Update(BEG_UPDATE);
			MouseOff();
			do
			{
				/* kleinsten Redrawbereich bestimmen */
				if (rc_intersect(&deskSize, &work) &&
					rc_intersect(frame, &work))
				{
					WdwManager_SetClip(wdw->vdi, &work, TRUE);
					if (iconHdl != NULL)
					{
						Objc_draw(iconHdl, ROOT, MAX_DEPTH, &work);
					} else if (wdw->vdi > 0)
					{
						/* Nur loeschen mit aktuellen Attributen und Farbe! */
						/* v.int = MagicVDI.SetFillcolor (vdi, 0); */
						AbsRect(&work);
						vr_recfl(wdw->vdi, (_WORD *)&work);
					}
				}
			} while (WdwManager_RectList(wdw->wdw, TRUE, &work));
			MouseOn();
			Wind_Update(END_UPDATE);
		}
	} else
	{
		wdw->hdlUpdate(wdw->wdw, wdw->special, TRUE);
		if (WdwManager_RectList(wdw->wdw, FALSE, &work))
		{
			do
			{
				/* kleinsten Redrawbereich bestimmen */
				if (rc_intersect(&deskSize, &work) &&
					rc_intersect(frame, &work))
				{
					WdwManager_SetClip(wdw->vdi, &work, TRUE);
					wdw->hdlDraw(wdw->wdw, wdw->vdi, wdw->special, &work);
				}
			} while (WdwManager_RectList(wdw->wdw, TRUE, &work));
		}
		wdw->hdlUpdate(wdw->wdw, wdw->special, FALSE);
	}
}

/*** ------------------------------------------------------------------------ ***/
/*	GLOBAL _VOID WdwManager_ClearWdw(HWND wdw,_WORD color)						*/
/*	lscht den Inhalt eines Fensters, die Farbe kann vorgegeben werden.			*/
/*	Parameter:	wdw:	das Fenster												*/
/*				color:	Hintergrundfarbe										*/
/*	Ergebnis:	keines															*/		
/*	8.9.00 von Dimitri Junker	DYJ 4.18										*/
/*** ------------------------------------------------------------------------ ***/
GLOBAL _VOID WdwManager_ClearWdw(HWND wdw,_WORD color)
{
	WINDOW_DEF *wr;
	GRECT frame,work;

	if ((wr = FindWindow(wdw)) != NULL)
	{
		Wind_get(wr->wdw, WF_WORKXYWH, &frame);
		if (!wr->isIcon)
		{
			wr->hdlUpdate(wr->wdw, wr->special, TRUE);
			if (WdwManager_RectList(wr->wdw, FALSE, &work))
			{
				do
				{
					/* kleinsten Redrawbereich bestimmen */
					if (rc_intersect(&deskSize, &work) &&
						rc_intersect(&frame, &work))
					{
						WdwManager_SetClip(wr->vdi, &work, TRUE);
						vsf_color(wr->vdi, color);
						work.g_w = work.g_x + work.g_w - 1;
						work.g_h = work.g_y + work.g_h - 1;
						vr_recfl(wr->vdi, (_WORD *)&work);
					}
				} while (WdwManager_RectList(wr->wdw, TRUE, &work));
			}
			wr->hdlUpdate(wr->wdw, wr->special, FALSE);
		}
	}
}

/*** ------------------------------------------------------------------------ ***/

/* Scroll-Funktionen */
LOCAL _VOID rawScroll(WINDOW_DEF *wdw, _WORD dir, CONST GRECT *area, _WORD height, _WORD amount)
{
	MFDB screen;
	_WORD pxy[8];
	GRECT work;

	screen.fd_addr = 0;
	if (dir == UP)
	{
		/* scrollUp */
		pxy[0] = area->g_x;
		pxy[1] = area->g_y;
		pxy[2] = area->g_x + area->g_w - 1;
		pxy[3] = area->g_y + height - 1;
		pxy[4] = area->g_x;
		pxy[5] = area->g_y + amount;
		pxy[6] = pxy[2];
		pxy[7] = area->g_y + height + amount - 1;
		vro_cpyfm(wdw->vdi, S_ONLY, pxy, &screen, &screen);
		/* jetzt RectFuncs.ClipRect berechnen und neu zeichnen */
		work = *area;
		if(wdw->hasIdem)
			amount+=(_WORD)(wdw->minScrollH*wdw->yFactor);
	} else
	{
		/* scroll down */
		pxy[0] = area->g_x;
		pxy[1] = area->g_y + amount ;
		pxy[2] = area->g_x + area->g_w - 1;
		pxy[3] = area->g_y + height + amount - 1;
		pxy[4] = area->g_x;
		pxy[5] = area->g_y;
		pxy[6] = area->g_x + area->g_w - 1;
		pxy[7] = area->g_y + height - 1;
		vro_cpyfm(wdw->vdi, S_ONLY, pxy, &screen, &screen);
		if(wdw->hasIdem)
		{
			work = *area;
			work.g_h=(_WORD)(wdw->minScrollH*wdw->yFactor);
			WdwManager_SetClip(wdw->vdi, &work, TRUE);
			wdw->hdlDraw(wdw->wdw, wdw->vdi, wdw->special, &work);
		}
		work = *area;
		work.g_y += height;
	}
	work.g_h = amount;
	WdwManager_SetClip(wdw->vdi, &work, TRUE);
	wdw->hdlDraw(wdw->wdw, wdw->vdi, wdw->special, &work);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID WdwManager_ScrollInWdw(HWND wdw, GRECT *source, _WORD dir, _WORD amount)
{
	WINDOW_DEF *wr;
	_WORD copyLines;
	GRECT work, c;

	wr = FindWindow(wdw);
	if (wr != NULL)
	{
		*source = rc_clip(&wr->wdwWork, source);
		/* Rechteckliste abfragen */
		if (WdwManager_RectList(wdw, FALSE, &work))
		{
			wr->hdlUpdate(wdw, wr->special, TRUE);
			do
			{
				ClipWork(wr);
				/* kleinsten Redrawbereich bestimmen */
				c = rc_clip(&work, &deskSize);
				c = rc_clip(&c, source);
				copyLines = c.g_h - amount;
				if (c.g_w > 0 && copyLines > 0)
				{
					rawScroll(wr, dir, &c, copyLines, amount);
				} else if (c.g_w > 0)
				{
					WdwManager_SetClip(wr->vdi, &c, TRUE);
					wr->hdlDraw(wdw, wr->vdi, wr->special, &c);
				}
			} while (WdwManager_RectList(wdw, TRUE, &work));
			wr->hdlUpdate(wdw, wr->special, FALSE);
		}
	}
}

/*** ---------------------------------------------------------------------- ***/

/* lines ist der Betrag in Pixelzeilen, um den gescrollt werden soll.
*/
LOCAL _VOID scrollWdw(WINDOW_DEF *wr, _WORD dir, _LONG lines)
{
	_WORD pixLines, copyLines;
	GRECT work, c;

	if (wr->isIcon || wr->isHidden)
		return;
	if (lines < wr->wdwWork.g_h)
	{
		pixLines = (_WORD)lines;
		/* Rechteckliste abfragen */
		if (WdwManager_RectList(wr->wdw, FALSE, &work))
		{
			wr->hdlUpdate(wr->wdw, wr->special, TRUE);
			do
			{
				ClipWork(wr);
				/* kleinsten Redrawbereich bestimmen */
				c = rc_clip(&work, &deskSize);
				c = rc_clip(&c, &wr->wdwWork);
				copyLines = c.g_h - pixLines;
				if (c.g_w > 0 && copyLines > 0)
				{
					rawScroll(wr, dir, &c, copyLines, pixLines);
				} else if (c.g_w > 0)
				{
					WdwManager_SetClip(wr->vdi, &c, TRUE);
					wr->hdlDraw(wr->wdw, wr->vdi, wr->special, &c);
				}
			} while (WdwManager_RectList(wr->wdw, TRUE, &work));
			wr->hdlUpdate(wr->wdw, wr->special, FALSE);
		}
	} else
	{
		/* komplett neuzeichnen */
		updateWdw(wr, &wr->wdwWork);
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID scrollLR(WINDOW_DEF *wr, _WORD dir, _WORD amount)
{
	_WORD copy[8];
	_WORD fill[4];
	GRECT c, clip, work;
	MFDB screen;

	if (wr->isIcon || wr->isHidden)
		return;
	screen.fd_addr = 0;
	if (amount < wr->wdwWork.g_w)
	{
		/* Rechteckliste abfragen */
		if (WdwManager_RectList(wr->wdw, FALSE, &work))
		{
			wr->hdlUpdate(wr->wdw, wr->special, TRUE);
			do
			{
				/* kleinsten Redrawbereich bestimmen */
				c = rc_clip(&work, &deskSize);
				c = rc_clip(&c, &wr->wdwWork);
				if (c.g_w > 0)
				{
					ClipWork(wr);
					if (c.g_w > amount)
					{
						if (dir == LEFT)
						{
							copy[0] = c.g_x;
							copy[1] = c.g_y;
							copy[2] = Max(c.g_x, c.g_x + c.g_w - 1 - amount);
							copy[3] = c.g_y + c.g_h - 1;
							copy[4] = c.g_x + amount;
							copy[5] = c.g_y;
							copy[6] = c.g_x + c.g_w - 1;
							copy[7] = c.g_y + c.g_h - 1;
						} else
						{
							copy[0] = c.g_x + amount;
							copy[1] = c.g_y;
							copy[2] = c.g_x + c.g_w - 1;
							copy[3] = c.g_y + c.g_h - 1;
							copy[4] = c.g_x;
							copy[5] = c.g_y;
							copy[6] = Max(c.g_x, c.g_x + c.g_w - 1 - amount);
							copy[7] = c.g_y + c.g_h - 1;
						}
						vro_cpyfm(wr->vdi, S_ONLY, copy, &screen, &screen);
					}

					/* Redrawbereich berechnen */
					clip.g_y = c.g_y;
					clip.g_h = c.g_h;
					if (dir == LEFT)
					{
						clip.g_x = c.g_x;
						clip.g_w = Min(amount + wr->pixOff, c.g_w);
					} else
					{
						clip.g_x = Max(c.g_x, c.g_x + c.g_w - 1 - amount);
						clip.g_w = c.g_x + c.g_w - clip.g_x;
					}
					WdwManager_SetClip(wr->vdi, &clip, TRUE);
					wr->hdlDraw(wr->wdw, wr->vdi, wr->special, &clip);

					/* Linken Rand loeschen */
					if (c.g_x - wr->pixOff <= wr->wdwWork.g_x)
					{
						/* pixOff ausfuellen */
						if (wr->pixOff > 0)
						{
							fill[0] = wr->wdwWork.g_x;
							fill[1] = c.g_y;
							fill[2] = wr->wdwWork.g_x + wr->pixOff - 1;
							fill[3] = c.g_y + c.g_h - 1;
							ClipWork(wr);
							vr_recfl(wr->vdi, fill);
						}
					}
				}
			} while (WdwManager_RectList(wr->wdw, TRUE, &work));
			wr->hdlUpdate(wr->wdw, wr->special, FALSE);
		}
		ClipWork(wr);
	} else
	{
		updateWdw(wr, &wr->wdwWork);
	}
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

/*====================================================*
 *                                                    *
 *   High-Level-Funktionen                            *
 *                                                    *
 *====================================================*/

/* Sliderberechnungen */

LOCAL _VOID CalcVSlider(WINDOW_DEF *wr)
{
	_LONG a, b;
	_WORD pos, size;
	_LONG r;
	_DOUBLE l;

	if (!(wr->comps & VSLIDE))
		return;
	/* Groesse berechnen */
	a = ((wr->document.h + 1) * wr->yFactor);
	if (a > 0)
	{
		r = (1000L * wr->wdwWork.g_h) / a;
		if (r > 1000 || r < 0)
			r = 1000;
	} else
	{
		r = 1000;
	}
	size = (_WORD)(r);
	/* Position berechnen */
	if (wr->document.y == 0)
	{
		pos = 0;
	} else
	{
		a = wr->document.y * wr->yFactor;
		b = ((wr->document.h + 2) * wr->yFactor) - wr->wdwWork.g_h;

		if (b > 0)
		{
			l = (1000. * a) / b;
			if (l > 1000. || l < 0)
				pos = 1000;
			else
				pos = (_WORD)l;
		} else
		{
			pos = 1000;
		}
	}
	if (size != wr->VslSize)
	{
		if (!wr->isIcon && !wr->isHidden)
			wind_set(wr->wdw, WF_VSLSIZE, size, 0, 0, 0);
		wr->VslSize = size;
	}
	if (pos != wr->VslPos)
	{
		if (!wr->isIcon && !wr->isHidden)
			wind_set(wr->wdw, WF_VSLIDE, pos, 0, 0, 0);
		wr->VslPos = pos;
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID CalcHSlider(WINDOW_DEF *wr)
{
	_LONG a, b;
	_WORD pos, size;
	_LONG r, l;

	if (!(wr->comps & HSLIDE))
		return;
	/* Groesse berechnen */
	a = (wr->document.w + 1) * wr->xFactor;
	b = wr->wdwWork.g_w;
	if (a > 0)
	{
		r = (1000L * b) / a;
		if (r > 1000 || r < 0)
			r = 1000;
	} else
	{
		r = 1000;
	}
	size = (_WORD)(r);
	/* Position berechnen */
	if (wr->document.x == 0)
	{
		pos = 0;
	} else
	{
		a = wr->document.x * wr->xFactor;
		b = ((wr->document.w + 1) * wr->xFactor) - wr->wdwWork.g_w;
		if (b > 0)
		{
			l = (1000L * a) / b;
			if (l > 1000 || l < 0)
				pos = 1000;
			else
				pos = (_WORD)l;
		} else
		{
			pos = 1000;
		}
	}
	if (size != wr->HslSize)
	{
		if (!wr->isIcon && !wr->isHidden)
			wind_set(wr->wdw, WF_HSLSIZE, size, 0, 0, 0);
		wr->HslSize = size;
	}
	if (pos != wr->HslPos)
	{
		if (!wr->isIcon && !wr->isHidden)
			wind_set(wr->wdw, WF_HSLIDE, pos, 0, 0, 0);
		wr->HslPos = pos;
	}
}

/*** ---------------------------------------------------------------------- ***/

/* High-Level Scroll-Funktionen */


LOCAL _BOOL scrollUp(WINDOW_DEF *wr, _WORD lines)
{
	_LONG oldStart;

	if ((oldStart = wr->document.y) > 0)
	{
		wr->document.y -= (_LONG)lines * wr->minScrollH;
		if (wr->document.y < 0)
			wr->document.y = 0;
		wr->setNewWdw(wr->wdw, wr->special, &wr->document, TRUE);
		scrollWdw(wr, UP, (_WORD)((oldStart - wr->document.y) * wr->yFactor));
		CalcVSlider(wr);
		return TRUE;
	}
	else
		return FALSE;
}

/*** ---------------------------------------------------------------------- ***/


LOCAL _BOOL scrollDown(WINDOW_DEF *wr, _WORD lines)
{
	_LONG oldStart;

	if ((oldStart = wr->document.y) + wr->pageH <= wr->document.h)
	{
		wr->document.y += (_LONG)lines * wr->minScrollH;
		if (wr->document.y > wr->document.h + 1 - wr->pageH)
			wr->document.y = wr->document.h + 1 - wr->pageH;
		if (wr->document.y < 0)
			wr->document.y = 0;
		wr->setNewWdw(wr->wdw, wr->special, &wr->document, TRUE);
		scrollWdw(wr, DOWN, (_WORD)((wr->document.y - oldStart) * wr->yFactor));
		CalcVSlider(wr);
		return TRUE;
	}
	else
		return FALSE;
}

/*** ---------------------------------------------------------------------- ***/


LOCAL _BOOL scrollLeft(WINDOW_DEF *wr, _WORD cols)
{
	_LONG oldStart;

	if ((oldStart = wr->document.x) > 0)
	{
		wr->document.x -= (_LONG)cols * wr->minScrollW;
		if (wr->document.x < 0)
			wr->document.x = 0;
		wr->setNewWdw(wr->wdw, wr->special, &wr->document, TRUE);
		scrollLR(wr, LEFT, (_WORD)((oldStart - wr->document.x) * wr->xFactor));
		CalcHSlider(wr);
		return TRUE;
	}
	else
		return FALSE;
}

/*** ---------------------------------------------------------------------- ***/


LOCAL _BOOL scrollRight(WINDOW_DEF *wr, _WORD cols)
{
	_LONG oldStart;

	if ((oldStart = wr->document.x) + wr->pageW < wr->document.w)
	{
		wr->document.x += (_LONG)cols * wr->minScrollW;
		if (wr->document.x > wr->document.w - wr->pageW)
			wr->document.x = wr->document.w - wr->pageW;
		if (wr->document.x < 0)
			wr->document.x = 0;
		wr->setNewWdw(wr->wdw, wr->special, &wr->document, TRUE);
		scrollLR(wr, RIGHT, (_WORD)((wr->document.x - oldStart) * wr->xFactor));
		CalcHSlider(wr);
		return TRUE;
	}
	else
		return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL pageUp(WINDOW_DEF *wr, _WORD pages)
{
	_LONG oldStart;

	if ((oldStart = wr->document.y) > 0)
	{
		wr->document.y -= (_LONG)pages * wr->pageH;
		if (wr->document.y < 0)
			wr->document.y = 0;
		wr->setNewWdw(wr->wdw, wr->special, &wr->document, TRUE);
		scrollWdw(wr, UP, (_WORD)((oldStart - wr->document.y) * wr->yFactor));
		CalcVSlider(wr);
		return TRUE;
	}
	else
		return FALSE;
}

/*** ---------------------------------------------------------------------- ***/


LOCAL _BOOL pageDown(WINDOW_DEF *wr, _WORD pages)
{
	_LONG oldStart;

	if ((oldStart = wr->document.y) + wr->pageH <= wr->document.h)
	{
		wr->document.y += (_LONG)pages * wr->pageH;
		if (wr->document.y > wr->document.h + 1- wr->minScrollP)
			wr->document.y = wr->document.h + 1- wr->minScrollP;
		if (wr->document.y < 0)
			wr->document.y = 0;
		wr->setNewWdw(wr->wdw, wr->special, &wr->document, TRUE);
		scrollWdw(wr, DOWN, (_WORD)((wr->document.y - oldStart) * wr->yFactor));
		CalcVSlider(wr);
		return TRUE;
	}
	else
		return FALSE;
}

/*** ---------------------------------------------------------------------- ***/


LOCAL _BOOL pageLeft(WINDOW_DEF *wr, _WORD pages)
{
	_LONG oldStart;

	if ((oldStart = wr->document.x) > 0)
	{
		wr->document.x -= (_LONG)pages * wr->pageW;
		if (wr->document.x < 0)
			wr->document.x = 0;
		wr->setNewWdw(wr->wdw, wr->special, &wr->document, TRUE);
		scrollLR(wr, LEFT, (_WORD)((oldStart - wr->document.x) * wr->xFactor));
		CalcHSlider(wr);
		return TRUE;
	}
	else
		return FALSE;
}

/*** ---------------------------------------------------------------------- ***/


LOCAL _BOOL pageRight(WINDOW_DEF *wr, _WORD pages)
{
	_LONG oldStart;

	if ((oldStart = wr->document.x) + wr->pageW < wr->document.w)
	{
		wr->document.x += (_LONG)pages * wr->pageW;
		if (wr->document.x > wr->document.w - wr->pageW)
			wr->document.x = wr->document.w - wr->pageW;
		if (wr->document.x < 0)
			wr->document.x = 0;
		wr->setNewWdw(wr->wdw, wr->special, &wr->document, TRUE);
		scrollLR(wr, RIGHT, (_WORD)((wr->document.x - oldStart) * wr->xFactor));
		CalcHSlider(wr);
		return TRUE;
	}
	else
		return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL WINDOW_DEF *FindTop(_VOID)
{
	HWND wdw;
	HVDI vdi;

	WdwManager_GetTopWindow(&wdw, &vdi);
	return FindWindow(wdw);
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

/*====================================================*
 *                                                    *
 *   Event-Handling-Funktionen                        *
 *                                                    *
 *====================================================*/

LOCAL _VOID untopWdw(WINDOW_DEF *wr)
{
	if (!wr->isTop)
		return;
	wr->isTop = FALSE;
	if (wr->hdlUntop != FUNK_NULL)
		wr->hdlUntop(wr->wdw, wr->special);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID topWdw(WINDOW_DEF *wr, _BOOL doTop)
{
	WINDOW_DEF *oldTopPtr;

	/* altes Top-Window feststellen */
	if (onlyOneTop >= 0 && wr->wdw != onlyOneTop)
	{
		/* onlyOneTopWdw toppen */
		wr = FindWindow(onlyOneTop);
		if (wr != NULL)
			topWdw(wr, TRUE);
		return;
	}
	oldTopPtr = FindTop();
	if (oldTopPtr != NULL && doTop && oldTopPtr->wdw != wr->wdw)
	{
		/* Altes Topwindow untoppen */
		untopWdw(oldTopPtr);
	}
	if (wr->hdlTop == FUNK_NULL || wr->hdlTop(wr->wdw, wr->special))
	{
		if (doTop)
			wind_set(wr->wdw, WF_TOP, 0, 0, 0, 0);
		theTopWindow = wr->wdw;
		WdwManager_NewWindowIsTop(wr->wdw, gl_apid);
		wr->isTop = TRUE;
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID BringToBottom(HWND wdw, _WORD apId);

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID backdropWdw(WINDOW_DEF *wr)
{
	if (onlyOneTop >= 0 && wr->wdw == onlyOneTop)
	{
		/* Alle nach hinten schicken */
	} else
	{
		untopWdw(wr);
		wind_set(wr->wdw, WF_M_BACKDROP, 0, 0, 0, 0);
		BringToBottom(wr->wdw, gl_apid);
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID bottomWdw(WINDOW_DEF *wr)
{
	if (onlyOneTop >= 0 && wr->wdw == onlyOneTop)
	{
		/* Alle nach hinten schicken */
	} else
	{
		untopWdw(wr);
		wind_set(wr->wdw, WF_BOTTOM, 0, 0, 0, 0);
		BringToBottom(wr->wdw, gl_apid);
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID SendRedraw(HWND win, CONST GRECT *r)
{
	_WORD message[8];
	_WORD apId;

	message[0] = WM_REDRAW;
	message[1] = gl_apid;
	message[2] = 0;
	message[3] = win;
	message[4] = r->g_x;
	message[5] = r->g_y;
	message[6] = r->g_w;
	message[7] = r->g_h;
	WdwManager_GetApId(win, &apId);
	appl_write(apId, 16, message);
}

/*** ---------------------------------------------------------------------- ***/

/* Wird aufgerufen, wenn das Fenster verschoben
 * oder in der Groesse veraendert wird.
 */
LOCAL _VOID moveSizeWdw(WINDOW_DEF *wr, _BOOL sized, _BOOL fulled, CONST GRECT *newSize, _BOOL adaptPos)
{
	_BOOL docChanged;
	_LONG oldVal;
	_WORD idx;
	_BOOL again;
	GRECT new;

	new = *newSize;
	if (!wr->isIcon)
	{
		new.g_w = Max(new.g_w, minWindWidth);
		new.g_h = Max(new.g_h, minWindHeight);
		wr->wdwCurr = new;
		/* Workarea aus neuer Groesse berechnen */
		Wind_calc(WC_WORK, wr->comps, &new, &wr->wdwWork);
		if (wr->snap && wr->hdlSnap != FUNK_NULL)
			wr->hdlSnap(wr->wdw, wr->special, &wr->wdwWork);
		/* Jetzt neue Aussengroesse berechnen */
		Wind_calc(WC_BORDER, wr->comps, &wr->wdwWork, &new);
		if (sized && !fulled)
			wr->isFull = FALSE;
	}
	if (!wr->isHidden)
	{
		idx = 1;
		for (;;)
		{
			Wind_set(wr->wdw, WF_CURRXYWH, &new);
			again = FALSE;
			if (!wr->isIcon)
			{
				Wind_get(wr->wdw, WF_CURRXYWH, &wr->wdwCurr);
				if (wr->wdwCurr.g_w != new.g_w)
				{
					new.g_w += idx * CharWidth;
					again = TRUE;
				}
				if (wr->wdwCurr.g_h != new.g_h)
				{
					new.g_h += idx * CharHeight;
					again = TRUE;
				}
				if (again)
				{
					++idx;
					/* Workarea aus neuer Groesse berechnen */
					Wind_calc(WC_WORK, wr->comps, &new, &wr->wdwWork);
					if (wr->snap && wr->hdlSnap != FUNK_NULL)
						wr->hdlSnap(wr->wdw, wr->special, &wr->wdwWork);
					/* Jetzt neue Aussengroesse berechnen */
					Wind_calc(WC_BORDER, wr->comps, &wr->wdwWork, &new);
				} else
				{
					break;
				}
			} else
			{
				break;
			}
		}
	}
	wr->wdwCurr = new;
	if (!wr->isIcon && !wr->isHidden)
	{
		/* Neuen Arbeitsbereich holen */
		wr->wdwGetScroll(wr->wdw, wr->vdi, wr->special, &wr->wdwWork);
		if (sized && adaptPos)
		{
			/* Falls Dokument ganz hineinpasst, neu positionieren */
			docChanged = FALSE;
			if (wr->document.y > 0)
			{
				if ((_LONG)wr->wdwWork.g_h / wr->yFactor + wr->document.y > wr->document.h)
				{
					oldVal = wr->document.y;
					wr->document.y = wr->document.h - ((_LONG)wr->wdwWork.g_h / wr->yFactor) + 1;
					if (wr->document.y < 0)
						wr->document.y = 0;
					docChanged = oldVal != wr->document.y;
				}
			}
			if (wr->document.x > 0)
			{
				if ((_LONG)wr->wdwWork.g_w / wr->xFactor + wr->document.x > wr->document.w)
				{
					oldVal = wr->document.x;
					wr->document.x = wr->document.w - ((_LONG)wr->wdwWork.g_w / wr->xFactor);
					if (wr->document.x < 0)
						wr->document.x = 0;
					docChanged = docChanged | (oldVal != wr->document.x);
				}
			}
			if (docChanged)
			{
				wr->setNewWdw(wr->wdw, wr->special, &wr->document, FALSE);
				/* Redraw ausloesen ueber Fensterbereich */
				SendRedraw(wr->wdw, &new);
			}
			/* Slider neu berechnen */
			CalcVSlider(wr);
			CalcHSlider(wr);
		}
	}
}

/*** ---------------------------------------------------------------------- ***/

/* Wird aufgerufen, wenn fuer das Fenster ein FULL-Event
 * auftrat. Gegebenenfalls wird noch die Snap-Prozedur
 * aufgerufen.
 * Die Slider werden neu berechnet.
 */
LOCAL _VOID fullWdw(WINDOW_DEF *wr)
{
	GRECT newSize;

	if (wr->isIcon || wr->isHidden || wr->wdwDial != NULL)
		return;
	if (wr->isFull)
	{
		newSize = wr->wdwLast;
	} else
	{
		newSize = wr->wdwFull;
		wr->wdwLast = wr->wdwCurr;
	}
	wr->isFull = !wr->isFull;
    /* Jetzt der Einfachheit halber einfach moveSize aufrufen */
	moveSizeWdw(wr, TRUE, TRUE, &newSize, TRUE);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID arrowedWdw(WINDOW_DEF *wr, _WORD what, _WORD amount)
{

	_BOOL (*scrollProc)(WINDOW_DEF *wr, _WORD amount);

	switch (what)
	{
		case WA_UPPAGE: scrollProc = pageUp; break;
		case WA_DNPAGE: scrollProc = pageDown; break;
		case WA_UPLINE: scrollProc = scrollUp; break;
		case WA_DNLINE: scrollProc = scrollDown; break;
		case WA_LFPAGE: scrollProc = pageLeft; break;
		case WA_RTPAGE: scrollProc = pageRight; break;
		case WA_LFLINE: scrollProc = scrollLeft; break;
		case WA_RTLINE: scrollProc = scrollRight; break;
		default: return;
	}
	wr->hdlUpdate(wr->wdw, wr->special, TRUE);
	scrollProc(wr, amount);
	wr->hdlUpdate(wr->wdw, wr->special, FALSE);
}

/*** ---------------------------------------------------------------------- ***/
LOCAL _VOID vSlideWdw(WINDOW_DEF *wr, _WORD where)
{
	_LONG oldStart;

	oldStart = wr->document.y;                      /* Start des Ausschnittes merken */
	if ((wr->document.h + 1) * wr->yFactor > wr->wdwWork.g_h)
	{
		if (where >= 1000)
			wr->document.y = ((wr->document.h + 2) * wr->yFactor - wr->wdwWork.g_h) / wr->yFactor;
		else

			wr->document.y = where * ((((wr->document.h + 2.) * wr->yFactor) - wr->wdwWork.g_h) / 1000L) / wr->yFactor;
		if (oldStart != wr->document.y)
		{
			wr->hdlUpdate(wr->wdw, wr->special, TRUE);
			wr->setNewWdw(wr->wdw, wr->special, &wr->document, TRUE);
			if (oldStart < wr->document.y)
				scrollWdw(wr, DOWN, (wr->document.y - oldStart) * wr->yFactor);
			else
				scrollWdw(wr, UP, (oldStart - wr->document.y) * wr->yFactor);
			wr->hdlUpdate(wr->wdw, wr->special, FALSE);
		}
	}
	CalcVSlider(wr);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID hSlideWdw(WINDOW_DEF *wr, _WORD where)
{
	_LONG oldStart, newStart;

	oldStart = wr->document.x;                      /* Start des Ausschnittes merken */
	if ((wr->document.w + 1) * wr->xFactor > wr->wdwWork.g_w)
	{
		if (where >= 1000)
			newStart = ((wr->document.w + 1) * wr->xFactor - wr->wdwWork.g_w);
		else
			newStart = (where * (((wr->document.w + 1) * wr->xFactor) - wr->wdwWork.g_w) / 1000L);
		if (newStart > ((wr->document.w + 1) * wr->xFactor) - wr->wdwWork.g_w)
			newStart = ((wr->document.w + 1) * wr->xFactor) - wr->wdwWork.g_w;
		if (newStart < 0)
			newStart = 0;
		if (oldStart != newStart)
		{
			wr->document.x = newStart / wr->xFactor;
			wr->hdlUpdate(wr->wdw, wr->special, TRUE);
			wr->setNewWdw(wr->wdw, wr->special, &wr->document, TRUE);
			if (oldStart < newStart)
				scrollLR(wr, RIGHT, (_WORD)(newStart - oldStart));
			else
				scrollLR(wr, LEFT, (_WORD)(oldStart - newStart));
			wr->hdlUpdate(wr->wdw, wr->special, FALSE);
		}
	}
	CalcHSlider(wr);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID hideWdw(WINDOW_DEF *wr)
{
	if (!wr->isHidden)
	{
		wind_close(wr->wdw);
		if (wr->hdlHide != FUNK_NULL)
			wr->hdlHide(wr->wdw, wr->special, TRUE);
		wr->isHidden = TRUE;
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID showWdw(WINDOW_DEF *wr, _BOOL doUntop)
{
	_WORD bits, dummy;
	GRECT r;
	WINDOW_DEF *oldTop;

	/* Altes TopWindow untoppen */
	oldTop = FindTop();
	if (oldTop != NULL && doUntop)
		untopWdw(oldTop);
	/* Fenster wieder oeffnen */
	wr->isHidden = FALSE;
	if (wr->hdlHide != FUNK_NULL)
		wr->hdlHide(wr->wdw, wr->special, FALSE);
	if (!wr->isIcon)
	{
		if (wr->snap && wr->hdlSnap != FUNK_NULL)
			wr->hdlSnap(wr->wdw, wr->special, &wr->wdwWork);
		Wind_calc(WC_BORDER, wr->comps, &wr->wdwWork, &wr->wdwCurr);
	}
	/* Scrollrechteck holen */
	wr->wdwGetScroll(wr->wdw, wr->vdi, wr->special, &wr->wdwWork);
	wind_open(wr->wdw,  wr->wdwCurr.g_x, wr->wdwCurr.g_y, wr->wdwCurr.g_w, wr->wdwCurr.g_h);
	if (wr->hdlTop != FUNK_NULL)
		wr->hdlTop(wr->wdw, wr->special);
	wr->isTop = TRUE;
	/* Die Slider wieder richtig setzen */
	if (wr->comps & VSLIDE)
	{
		wind_set(wr->wdw, WF_VSLSIZE, wr->VslSize, 0, 0, 0);
		wind_set(wr->wdw, WF_VSLIDE, wr->VslPos, 0, 0, 0);
	}
	if (wr->comps & HSLIDE)
	{
		wind_set(wr->wdw, WF_HSLSIZE, wr->HslSize, 0, 0, 0);
		wind_set(wr->wdw, WF_HSLIDE, wr->HslPos, 0, 0, 0);
	}
	/* Jetzt noch abfragen, ob das Fenster iconifiziert ist */
	wr->isIcon = FALSE;
	if (appl_xgetinfo(APG_WINDOWS, &bits, &dummy, &dummy, &dummy) == 1 &&
		(bits & 0x80))
	{
		Wind_get(wr->wdw, WF_ICONIFY, &r);
		wr->isIcon = r.g_x == 1;
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL closeWdw(WINDOW_DEF *wr, _BOOL force)
{
	/* CloseProc aufrufen */
	if (wr->hdlClose != FUNK_NULL && !wr->hdlClose(wr->wdw, wr->vdi, wr->special, force))
		return FALSE;
	/* Fenster schliessen */
	if (!wr->isHidden)
		wind_close(wr->wdw);
	wind_delete(wr->wdw);
	WdwManager_WindowIsClosed(wr->wdw);
	/* Workstation schliessen */
	if (wr->vdi > 0)
	{
		CloseWorkstation(&wr->vdi);
		wr->vdi = -1;
	}
	/* Aus der Liste aushaengen */
	if (wr->next != NULL)
		wr->next->prev = wr->prev;
	if (wr->prev != NULL)
		wr->prev->next = wr->next;
	if (windows == wr)
		windows = wr->next;
	if (wr->onlyTop)
		onlyOneTop = wr->lastOnlyTop;
	OFREE(wr);

	/* Neues TopWindow toppen (WMNEWTOP bzw. WMONTOP in AES 4.0 */
	wr = FindTop();
	if (wr != NULL)
		topWdw(wr, FALSE);
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID iconifyWdw(WINDOW_DEF *wr, CONST GRECT *iconRect)
{
	if (wr->isIcon)
		return;
	wr->isIcon = TRUE;
	wr->wdwIcon = wr->wdwCurr;
	Wind_set(wr->wdw, WF_ICONIFY, iconRect);
	Wind_get(wr->wdw, WF_CURRXYWH, &wr->wdwCurr);
	if (wr->hdlHide != FUNK_NULL)
		wr->hdlHide(wr->wdw, wr->special, TRUE);
	WdwManager_FullRedrawWdw(wr->wdw);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID unIconifyWdw(WINDOW_DEF *wr, CONST GRECT *r)
{
	WINDOW_DEF *p;
	GRECT curr;

	if (allIconified)
	{
		/* alle anderen versteckten, iconifizierten wieder zeigen bis auf
		 * dieses wdw!
		 */
		for (p = windows; p != NULL; p = p->next)
		{
			if (p->wdw != wr->wdw && p->isIcon && p->isHidden)
			{
				/* ist nicht dieses Window */

				WdwManager_GetWdwWork(p->wdw,&p->wdwWork);
				showWdw(p, FALSE);
				Wind_get(p->wdw, WF_CURRXYWH, &curr);
				moveSizeWdw(p, FALSE, FALSE, &curr, FALSE);
			}
		}
		allIconified = FALSE;
	}
	if (!wr->isIcon)
		return;
	wr->isIcon = FALSE;
	Wind_set(wr->wdw, WF_UNICONIFY, r);
	Wind_get(wr->wdw, WF_CURRXYWH, &wr->wdwCurr);
	if (wr->hdlHide != FUNK_NULL)
		wr->hdlHide(wr->wdw, wr->special, FALSE);
	moveSizeWdw(wr, FALSE, FALSE, &wr->wdwCurr, FALSE);
	if (wr->comps & VSLIDE)
	{
		wind_set(wr->wdw, WF_VSLSIZE, wr->VslSize, 0, 0, 0);
		wind_set(wr->wdw, WF_VSLIDE, wr->VslPos, 0, 0, 0);
	}
	if (wr->comps & HSLIDE)
	{
		wind_set(wr->wdw, WF_HSLSIZE, wr->HslSize, 0, 0, 0);
		wind_set(wr->wdw, WF_HSLIDE, wr->HslPos, 0, 0, 0);
	}
	topWdw(wr, TRUE);
	SendTop(wr->wdw, gl_apid);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID allIconifyWdw(WINDOW_DEF *wr, CONST GRECT *iconRect)
{
	WINDOW_DEF *p;

	for (p = windows; p != NULL; p = p->next)
	{
		if (!p->isHidden /* && !p->isIcon */ && p->wdw != wr->wdw)
		{
			/* ist nicht dieses Window */
			p->wdwIcon = p->wdwCurr;
			hideWdw(p);
			p->isIcon = TRUE;
		} else if (!p->isHidden /* && !p->isIcon */ && p->wdw == wr->wdw)
		{
			iconifyWdw(p, iconRect);
		}
	}
	allIconified = TRUE;
}
GLOBAL _VOID allRedrawWdw(_VOID)
{
	WINDOW_DEF *p;
	GRECT r;
	for (p = windows; p != NULL; p = p->next)
	{
		Wind_get(p->wdw, WF_WORKXYWH, &r);
		updateWdw(p, &r);
	}
	allIconified = TRUE;
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

/* Falls das Window die Daten nach dem Header akzeptiert, dann wird
 * TRUE zurueckgegeben
 */
LOCAL _BOOL WdwManager_WdwDDAcceptData(HWND wdw, _VOID *hdr)
{
	WINDOW_DEF *wr;

	if ((wr = FindWindow(wdw)) != NULL)
		if (wr->ddClientInstalled && wr->ddAcceptData != FUNK_NULL)
		{
			return wr->ddAcceptData(wdw, wr->special, hdr);
		}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

/* Liefert fuer das Wdw die unterstuetzen Extensions zurueck
 */
LOCAL _VOID WdwManager_WdwDDGetExts(HWND wdw, _UBYTE *exts, size_t bufsize)
{
	WINDOW_DEF *wr;

	if ((wr = FindWindow(wdw)) != NULL)
		if (wr->ddClientInstalled)
		{
			wr->ddGetExts(wdw, wr->special, exts, bufsize);
			return;
		}
	*exts = '\0';
}

/*** ---------------------------------------------------------------------- ***/

/* TRUE: Das Fenster unterstuetzt Drag & Drop
 */
LOCAL _BOOL WdwManager_WdwDoesDragDrop(HWND wdw)
{
	WINDOW_DEF *wr;

	if ((wr = FindWindow(wdw)) != NULL)
		return wr->ddClientInstalled;
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

/* Die Daten werden an das Fenster uebergeben
 */
LOCAL _VOID WdwManager_WdwDDWriteData(HWND wdw, _VOID *data, _ULONG dataLen)
{
	WINDOW_DEF *wr;

	if ((wr = FindWindow(wdw)) != NULL)
		if (wr->ddClientInstalled && wr->ddWriteData != FUNK_NULL)
		{
			wr->ddWriteData(wdw, wr->special, data, dataLen);
		}
}

/*** ---------------------------------------------------------------------- ***/

/* Diese Prozedur handelt den ganzen Drag-Drop Kram nach einem Event */
LOCAL _VOID HandleDragDrop(CONST _WORD *mess)
{
	struct dd_access {
		_WORD messId;
		_WORD apId;
		_WORD over;
		_WORD tWin;
		_WORD mx;
		_WORD my;
		_WORD kshift;
		_UBYTE pext0, pext1;
	} *access;
	_UBYTE buff[DD_EXTSIZE+1];
	struct {
		_UBYTE dtype[DD_EXTLEN];
		_ULONG dlen;
		_UBYTE dname[2048];
	} *hdr;
	long oldsigpipe;
	_WORD i;
	_UBYTE pext[3];
	_UBYTE exts[DD_EXTSIZE];
	_UBYTE pname[PATH_MAX];
	FILENO phdl;
	_VOID *data;
	_ULONG count;
	HWND wdw;
	_UWORD hdrLen;

#define cPipeName "u:\\pipe\\dragdrop."

#define restore() \
	if (phdl > 0) Fclose(phdl); \
	if (data != NULL) SFREE(data); \
	if (hdr != NULL) SFREE(hdr); \
	Psignal(SIGPIPE, oldsigpipe)

	hdr = NULL;
	data = NULL;
	/* Erstmal neuen Signalhandler installieren */
	oldsigpipe = Psignal(SIGPIPE, (_LONG)SIG_IGN);

	access = (struct dd_access *)mess;
	pext[0] = access->pext0;
	pext[1] = access->pext1;
	pext[2] = '\0';
	strCat(strCpy(pname, cPipeName), pext);
	phdl = (FILENO)Fopen(pname, 2);
	if (phdl < 0)
	{
		restore();
		return;
	}
	/* Pipe ist offen, jetzt erstmal beim Windowhandler anfragen, ob
	 * das Targetfenster DragDrop versteht
	 */
	if (!WdwManager_WdwDoesDragDrop(access->tWin))
	{
		/* Das Fenster kann kein DragDrop, also nehmen wir auch nichts an!
		 */
		buff[0] = DD_NAK;
		Fwrite(phdl, 1, buff);
		/* Uns ist ziemlich egal, ob das geklappt hat, wir schliessen die Pipe
		 * jetzt wieder
		 */
		restore();
		return;
	}
	/* Ok, das Fenster kann Drag & Drop, also jetzt mal die Extensions anfordern
	 */
	wdw = access->tWin;
	WdwManager_WdwDDGetExts(wdw, exts, sizeof(exts));
	/* Umkopieren */
	for (i = 0; i < DD_EXTSIZE; i++)
		buff[i+1] = exts[i];
	buff[0] = DD_OK;
	/* Jetzt DD_OK und Extensions in Pipe schreiben */
	count = DD_EXTSIZE + 1;
	count = Fwrite(phdl, count, buff);
	if (count != (DD_EXTSIZE + 1))
	{
		/* Fehler aufgetreten, Pipe schliessen und raus hier. */
		restore();
		return;
	}
	for (;;)
	{
		/* Jetzt 2 Bytes aus der Pipe lesen (Headerlaenge) */
		count = Fread(phdl, 2, &hdrLen);
		if (count != 2)
		{
			/* Fehler aufgetreten, Pipe schliessen und raus hier. */
			break;
		}
		/* Jetzt den Header lesen */
		hdr = MALLOC(hdrLen, "HandleDdragDrop: header");
		if (hdr == NULL)
		{
			/* Kein Speicher frei! */
			break;
		}
		/* Jetzt den Header lesen */
		count = Fread(phdl, hdrLen, hdr);
		if (count != hdrLen)
		{
			/* Fehler aufgetreten, Pipe schliessen und raus hier. */
			break;
		}
		/* Jetzt haben wir den Header, nachfragen, ob das akzeptiert wird */
		if (WdwManager_WdwDDAcceptData(wdw, hdr))
		{
			/* Speicher allozieren fuer Daten */
			data = MALLOC(hdr->dlen, "HandleDragDrop: data");
			if (data == NULL)
			{
				/* DD_NAK in Pipe schreiben und abbrechen */
				buff[0] = DD_NAK;
				Fwrite(phdl, 1, buff);
				break;
			}
			/* DD_OK in Pipe schreiben */
			buff[0] = DD_OK;
			count = Fwrite(phdl, 1, buff);
			if (count != 1)
				break;
			/* Ok, jetzt haben wir auch einen Buffer fuer die Daten,
			 * jetzt koennen wir die Daten aus der Pipe lesen
			 */
			count = Fread(phdl, hdr->dlen, data);
			if (count != hdr->dlen)
				break;
			/* Jetzt die Daten an das Fenster uebergeben */
			WdwManager_WdwDDWriteData(wdw, data, count);
			/* Speicher wieder am Ende in restore freigeben */
			/* Das war's, Pipe wird am Ende geschlossen */
			break;
		} else
		{
			/* DD_EXT in Pipe schreiben und wieder nach vorne */
			buff[0] = DD_EXT;
			Fwrite(phdl, 1, buff);
		}
		SFREE(hdr);
		hdr = NULL;
	}
	restore();
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL MessageEvent(CONST _WORD *message)
{
	WINDOW_DEF *wr;
	_BOOL done;
	tFontinfo info;
	
	switch (message[0])
	{
	case XFONT_CHANGED:
		/* erstmal nur Werte sichern, FONT_CHANGED bekommen wir auch noch */
		fontApid = message[1];
		fontNewSize = fix31_to_point(*((fix31 *)&message[3]));
		fontRot = message[5];
		fontSkew = message[6];
		fontVector = message[7];
		SPEC_DEBUG_OUT((EO_TRACE, "XFONT_CHANGED from %d: size = %d", fontApid, fontNewSize));
		return TRUE;
	
	case FONT_CHANGED:
		if (fontApid < 0 || message[1] != fontApid)
		{
			fontNewSize = message[5];
			fontApid = message[1];
		}
		fontId = message[4];
		SPEC_DEBUG_OUT((EO_TRACE, "FONT_CHANGED from %d: id=%d, size=%d", fontApid, fontId, fontNewSize));
		done = FALSE;
		if (message[4] != 0 && message[5] != 0)
		{
			if (message[3] < 0)
			{
				for (wr = windows; wr != NULL; wr = wr->next)
				{
					if (wr->acceptFont != FUNK_NULL)
					{
						FontSelect_FontInfo(wr->vdi, message[4], &info);
						wr->acceptFont(message[3], message[4], message[5], info.mono);
						done = TRUE;
					}
				}
			} else
			{
				wr = FindWindow(message[3]);
				if (wr != NULL && wr->acceptFont != FUNK_NULL)
				{
					FontSelect_FontInfo(wr->vdi, message[4], &info);
					wr->acceptFont(message[3], message[4], message[5], info.mono);
					done = TRUE;
				}
			}
		}
		SendMessage(done, fontApid, FONT_ACK);
		fontApid = -1;
		return TRUE;
	
	default:
		if ((_UWORD)message[0] == COLOR_ID)
		{
			_WORD color;
			_WORD x, y;
			HWND wh;
			
			x = message[3];
			y = message[4];
			color = message[5];
			SPEC_DEBUG_OUT((EO_TRACE, "COLOR_ID from %d: color=%d", message[1], color));
			wh = wind_find(x, y);
			wr = FindWindow(wh);
			if (wr != NULL && wr->acceptColor != FUNK_NULL)
			{
				wr->acceptColor(wh, color);
			}
			return TRUE;
		}
		break;
	}
	wr = FindWindow(message[3]);
	if (wr != NULL)
	{
		switch (message[0])
		{
		case WM_REDRAW:
			updateWdw(wr, (CONST GRECT *)&message[4]);
			break;
		case WM_TOPPED:
			topWdw(wr, TRUE);
			break;
		case WM_CLOSED:
			if (onlyOneTop < 0 || wr->wdw == onlyOneTop)
				closeWdw(wr, FALSE);
			break;
		case WM_FULLED:
			fullWdw(wr);
			break;
		case WM_ARROWED:
			if (message[5] >= 0)
			{
				arrowedWdw(wr, message[4], 1);
			} else
			{
				/* erweiterte Scrollfunktionen von Winx */
				arrowedWdw(wr, message[4], -message[5]);
				if (message[7] < 0)
					arrowedWdw(wr, message[6], -message[7]);
			}
			break;
		case WM_HSLID:
			hSlideWdw(wr, message[4]);
			break;
		case WM_VSLID:
			vSlideWdw(wr, message[4]);
			break;
		case WM_SIZED:
			moveSizeWdw(wr, TRUE, FALSE, (CONST GRECT *)&message[4], TRUE);
			break;
		case WM_MOVED:
			moveSizeWdw(wr, FALSE, FALSE, (CONST GRECT *)&message[4], TRUE);
			break;
		case WM_NEWTOP:
			topWdw(wr, FALSE);
			break;
		case WM_UNTOPPED:
			untopWdw(wr);
			break;
		case WM_ONTOP:
			topWdw(wr, FALSE);
			break;
		case WM_M_BDROPPED:
			backdropWdw(wr);
			break;
		case WM_BOTTOMED:
			bottomWdw(wr);
			break;
		case WM_ICONIFY:
			iconifyWdw(wr, (CONST GRECT *)&message[4]);
			break;
		case WM_UNICONIFY:
			unIconifyWdw(wr, (CONST GRECT *)&message[4]);
			break;
		case WM_ALLICONIFY:
			allIconifyWdw(wr, (CONST GRECT *)&message[4]);
			break;
		case AP_DRAGDROP:
			HandleDragDrop(message);
			break;
		default:
			return FALSE;
		}
		return TRUE;
	}
	/* Feststellen, ob ein anderes Fenster getoppt wurde */
	switch (message[0])
	{
	case WM_TOPPED:
		/* Feststellen, ob eines unserer Fenster Topwindow war
		 * und ggf. untoppedHdler aufrufen
		 */
		/* altes Top-Window feststellen */
		wr = FindTop();
		if (wr != NULL)
		{
			wr->isTop = FALSE;
			if (wr->hdlUntop != FUNK_NULL)
				wr->hdlUntop(wr->wdw, wr->special);
		}
		break;
	}
	
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/


typedef _BOOL (*pageProc)(WINDOW_DEF *wr, _WORD amount);



LOCAL _BOOL scrollFunction(HWND wdw, pageProc func, _WORD parm)
{
	_BOOL ret=FALSE;
	WINDOW_DEF *wr;

	wr = FindWindow(wdw);
	if (wr != NULL)
	{
		wr->hdlUpdate(wr->wdw, wr->special, TRUE);
		ret=func(wr, parm);
		wr->hdlUpdate(wr->wdw, wr->special, FALSE);
	}
	return ret;
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

/*====================================================*
 *                                                    *
 *   Exportierte Funktionen                           *
 *                                                    *
 *====================================================*/


GLOBAL _BOOL WdwManager_PageUp(HWND wdw)
{
	return scrollFunction(wdw, pageUp, 1);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _BOOL WdwManager_PageDown(HWND wdw)
{
	return scrollFunction(wdw, pageDown, 1);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID WdwManager_PageLeft(HWND wdw)
{
	scrollFunction(wdw, pageLeft, 1);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID WdwManager_PageRight(HWND wdw)
{
	scrollFunction(wdw, pageRight, 1);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID WdwManager_ScrollUp(HWND wdw, _WORD amount)
{
	scrollFunction(wdw, scrollUp, amount);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _BOOL WdwManager_WouldScrollUp(HWND wdw, _WORD amount)
{
	_LONG oldStart;
	WINDOW_DEF *wr;
	_LONG y;
	
	wr = FindWindow(wdw);
	if (wr != NULL)
	{
		if ((oldStart = wr->document.y) > 0)
		{
			y = wr->document.y - (_LONG)amount * wr->minScrollH;
			if (y < 0)
				y = 0;
			return y != oldStart;
		}
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID WdwManager_ScrollDown(HWND wdw, _WORD amount)
{
	scrollFunction(wdw, scrollDown, amount);
}

/*** ---------------------------------------------------------------------- ***/


GLOBAL _BOOL WdwManager_WouldScrollDown(HWND wdw, _WORD amount)
{
	_LONG oldStart;
	WINDOW_DEF *wr;
	_LONG y;
	
	wr = FindWindow(wdw);
	if (wr != NULL)
	{
		if ((oldStart = wr->document.y) + wr->pageH <= wr->document.h)
		{
			y = wr->document.y + (_LONG)amount * wr->minScrollH;
			if (y > wr->document.h + 1 - wr->minScrollP)
				y = wr->document.h + 1 - wr->minScrollP;
			if (y < 0)
				y = 0;
			return y != oldStart;
		}
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID WdwManager_ScrollLeft(HWND wdw, _WORD amount)
{
	scrollFunction(wdw, scrollLeft, amount);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID WdwManager_ScrollRight(HWND wdw, _WORD amount)
{
	scrollFunction(wdw, scrollRight, amount);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _UWORD WdwManager_WdwComps(HWND wdw)
{
	WINDOW_DEF *wr;

	if ((wr = FindWindow(wdw)) != NULL)
		return wr->comps;
	return 0;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID WdwManager_SnapWdw(HWND wdw)
{
	WINDOW_DEF *wr;

	if ((wr = FindWindow(wdw)) != NULL)
		moveSizeWdw(wr, FALSE, FALSE, &wr->wdwCurr, FALSE);
}

/*** ---------------------------------------------------------------------- ***/

/* Setzt neue aktuelle Aussengroesse fuer das Fenster
 */
GLOBAL _VOID WdwManager_SetWdwSize(HWND wdw, CONST GRECT *rect)
{
	WINDOW_DEF *wr;

	if ((wr = FindWindow(wdw)) != NULL)
		moveSizeWdw(wr, TRUE, FALSE, rect, FALSE);
}

/*** ---------------------------------------------------------------------- ***/

/* Erfragt aktuelle Aussengroesse fuer das Fenster
*/
GLOBAL _VOID WdwManager_GetWdwSize(HWND wdw, GRECT *rect)
{
	WINDOW_DEF *wr;

	if ((wr = FindWindow(wdw)) != NULL)
	{
		if (wr->isIcon)
		{
			*rect = wr->wdwIcon;
		} else
		{
			*rect = wr->wdwCurr;
		}
	} else
	{
		Wind_get(wdw, WF_CURRXYWH, rect);
	}
}

/*** ---------------------------------------------------------------------- ***/

/* Setzt neue aktuelle Arbeitsflaechengroesse fuer das Fenster
 */
GLOBAL _VOID WdwManager_SetWdwWork(HWND wdw, CONST GRECT *rect)
{
	WINDOW_DEF *wr;
	GRECT r;

	if ((wr = FindWindow(wdw)) != NULL)
	{
		Wind_calc(WC_BORDER, wr->comps, rect, &r);
		moveSizeWdw(wr, TRUE, FALSE, &r, FALSE);
	}
}

/*** ---------------------------------------------------------------------- ***/

/* Erfragt aktuelle Arbeitsflaechengroesse fuer das Fenster
 */
GLOBAL _VOID WdwManager_GetWdwWork(HWND wdw, GRECT *rect)
{
	WINDOW_DEF *wr;

	if ((wr = FindWindow(wdw)) != NULL)
	{
		*rect = wr->wdwCurr;
		Wind_calc(WC_WORK, wr->comps, rect, rect);
	} else
	{
		Wind_get(wdw, WF_WORKXYWH, rect);
	}
}

/*** ---------------------------------------------------------------------- ***/

/* Setzt die Parameter fuer die Ausschnittsberechnung
 */
GLOBAL _VOID WdwManager_SetDocumentParms(HWND wdw, _LONG xFac, _LONG yFac)
{
	WINDOW_DEF *wr;

	if ((wr = FindWindow(wdw)) != NULL)
	{
		if (xFac != wr->xFactor)
		{
			wr->xFactor = xFac;
			CalcHSlider(wr);
		}
		if (yFac != wr->yFactor)
		{
			wr->yFactor = yFac;
			CalcVSlider(wr);
		}
	}
}

/*** ---------------------------------------------------------------------- ***/

/* Setzt die Parameter fuer das Blaettern im Dokument
 */
GLOBAL _VOID WdwManager_SetScrollParms(HWND wdw, _LONG pageW, _LONG pageH, _LONG minScrollW, _LONG minScrollH, _BOOL lstPgF)
{
	WINDOW_DEF *wr;

	if ((wr = FindWindow(wdw)) != NULL)
	{
		if(	lstPgF)
			wr->minScrollP = pageH;
		else
			wr->minScrollP = 1;
		wr->pageW = pageW;
		wr->pageH = pageH;
		wr->minScrollW = minScrollW;
		wr->minScrollH = minScrollH;
	}
}

/*** ---------------------------------------------------------------------- ***/

/* Erfragt die Parameter fuer das Blaettern im Dokument
 */
GLOBAL _VOID WdwManager_GetScrollParms(HWND wdw, _LONG *pageW, _LONG *pageH, _LONG *minScrollW, _LONG *minScrollH)
{
	WINDOW_DEF *wr;

	if ((wr = FindWindow(wdw)) != NULL)
	{
		*pageW = wr->pageW;
		*pageH = wr->pageH;
		*minScrollW = wr->minScrollW;
		*minScrollH = wr->minScrollH;
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID checkDocument(LGRECT *doc)
{
	if (doc->w < 0)
		doc->w = 0;
	if (doc->h < 0)
		doc->h = 0;
	if (doc->x < 0)
		doc->x = 0;
	if (doc->y < 0)
		doc->y = 0;
	if (doc->x > doc->w)
		doc->x = doc->w;
	if (doc->y > doc->h)
		doc->y = doc->h;
}

/*** ---------------------------------------------------------------------- ***/

/* Setzt die aktuellen Dokument-Parameter ohne automatisches Scrollen
 * Wenn redraw == TRUE, wird ein Redraw ueber das komplette Fenster ausgeloest.
 */
GLOBAL _VOID WdwManager_SetNewDocument(HWND wdw, CONST LGRECT *doc, _BOOL redraw)
{
	WINDOW_DEF *wr;
	GRECT frame;

	if ((wr = FindWindow(wdw)) != NULL)
	{
		wr->document = *doc;
		/* Jetzt noch Check auf Gueltigkeit */
		checkDocument(&wr->document);
		CalcVSlider(wr);
		CalcHSlider(wr);
		if (redraw && !wr->isIcon && !wr->isHidden)
		{
			Wind_calc(WC_WORK, wr->comps, &wr->wdwCurr, &frame);
			updateWdw(wr, &frame);
		}
	}
}

/*** ---------------------------------------------------------------------- ***/

/* Setzt die aktuellen Dokument-Parameter
*/
GLOBAL _VOID WdwManager_SetWdwDocument(HWND wdw, CONST LGRECT *doc)
{
	WINDOW_DEF *wr;
	LGRECT oldDoc;
	_BOOL fullRedraw;

	wr = FindWindow(wdw);
	if (wr != NULL)
	{
		oldDoc = wr->document;
		wr->document = *doc;
		/* Jetzt noch Check auf Gueltigkeit */
		checkDocument(&wr->document);
		if (wr->isIcon || wr->isHidden)
			return;
		fullRedraw = FALSE;
		/* Jetzt Fenster ggf. scrollen */
		if (doc->x != oldDoc.x)
		{
			/* evtl. horizontales scrollen */
			if ((doc->x > oldDoc.x) && !fullRedraw)
			{
				/* Nach links scrollen */
				if ((doc->x - oldDoc.x) * wr->xFactor < wr->wdwWork.g_w)
				{
					/* Scrollen lohnt sich */
					scrollLR(wr, RIGHT, (_WORD)((doc->x - oldDoc.x) * wr->xFactor));
				} else
				{
					fullRedraw = TRUE;
				}
			} else if (!fullRedraw)
			{
				if ((oldDoc.x - doc->x) * wr->xFactor < wr->wdwWork.g_w)
				{
					/* Scrollen lohnt sich */
					scrollLR(wr, LEFT, (_WORD)((oldDoc.x - doc->x) * wr->xFactor));
				} else
				{
					fullRedraw = TRUE;
				}
			}
		}

		if (doc->y != oldDoc.y)
		{
			/* evtl. vertikales scrollen */
			if (!fullRedraw && doc->y > oldDoc.y)
			{
				/* Nach oben scrollen */
				if ((doc->y - oldDoc.y) * wr->yFactor < wr->wdwWork.g_h)
				{
					/* Scrollen lohnt sich */
					scrollWdw(wr, DOWN, (_WORD)((doc->y - oldDoc.y) * wr->yFactor));
				} else
				{
					fullRedraw = TRUE;
				}
			} else if (!fullRedraw)
			{
				if ((oldDoc.y - doc->y) * wr->yFactor < wr->wdwWork.g_h)
				{
					/* Scrollen lohnt sich */
					scrollWdw(wr, UP, (_WORD)((oldDoc.y - doc->y) * wr->yFactor));
				} else
				{
					fullRedraw = TRUE;
				}
			}
		}
		if (fullRedraw)
			updateWdw(wr, &wr->wdwWork);
		if (doc->y != oldDoc.y || doc->h != oldDoc.h)
			CalcVSlider(wr);
		if (doc->x != oldDoc.x || doc->w != oldDoc.w)
			CalcHSlider(wr);
	}
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID WdwManager_GetWdwDocument(HWND wdw, LGRECT *doc)
{
	WINDOW_DEF *wr;

	if ((wr = FindWindow(wdw)) != NULL)
	{
		*doc = wr->document;
	}
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID WdwManager_RedrawWdw(HWND wdw, CONST GRECT *frame)
{
	WINDOW_DEF *wr;

	if ((wr = FindWindow(wdw)) != NULL)
	{
		updateWdw(wr, frame);
	}
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID WdwManager_FullRedrawWdw(HWND wdw)
{
	WINDOW_DEF *wr;
	GRECT r;

	if ((wr = FindWindow(wdw)) != NULL)
	{
		Wind_get(wr->wdw, WF_WORKXYWH, &r);
		updateWdw(wr, &r);
	}
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID WdwManager_SetWdwInfoline(HWND wdw, CONST _UBYTE *info)
{
	WINDOW_DEF *wr;

	if ((wr = FindWindow(wdw)) != NULL)
	{
		strBcpy(wr->wdwInfo, info);
		if (wr->comps & INFO)
			Wind_set(wr->wdw, WF_INFO, wr->wdwInfo);
	}
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID WdwManager_SetWdwTitle(HWND wdw, CONST _UBYTE *title)
{
	WINDOW_DEF *wr;

	if ((wr = FindWindow(wdw)) != NULL)
	{
		strBcpy(wr->wdwTitle, title);
		if (*title != '\0')
		{
	        /* Jetzt ggf. ein Space vorne und hinten anfuegen */
			if (*title != ' ')
				strInsertChar(' ', wr->wdwTitle, sizeof(wr->wdwTitle));
			if (wr->wdwTitle[strLen(wr->wdwTitle) - 1] != ' ')
				strMcat(wr->wdwTitle, sizeof(wr->wdwTitle), " ");
		}
		if (wr->comps & NAME)
			Wind_set(wr->wdw, WF_NAME, wr->wdwTitle);
	}
}

/*** ---------------------------------------------------------------------- ***/

/* Oeffnet Fenster und Workstation, setzt Font und Size,
 * alle Prozeduren setzen
 */

GLOBAL _BOOL WdwManager_OpenWindow(
	handleButtonProc button,
	handleKeyProc key,
	handleTimerProc timer,
	CONST GRECT *fullSize,
	GRECT *currSize,
	_UWORD wdwParts,
	_BOOL wdwSnap,
	CONST _UBYTE *info,
	CONST _UBYTE *titel,
	snapProc snapP,
	closeProc close,
	drawProc draw,
	topProc top,
	untopProc untop,
	wdwupdateProc update,
	setWorkProc setWdw,
	getRectProc	getScroll,
	hideProc hide,
	_WORD pixelOffset,
	_VOID *special,
	_BOOL onlyThisTop,
	_BOOL showIt,
	_BOOL supportIconify,
	_BOOL openWorkstation,
	_BOOL hasIdem,
	HWND *wdwHandle,
	HVDI *vdiHandle)
{
	WINDOW_DEF *wr;
	WINDOW_DEF *oldTop;
	_WORD bits, dummy;

	/* Neuen WindowPtr einrichten, Window erzeugen und oeffnen, Workstation oeffnen */
	wr = NEW(wdwSlot, "Open_Window");
	if (wr == NULL)
		return FALSE;
	MemSetZeroStruct(*wr);
	wr->hasIdem=hasIdem;
	if (iconifySupportEnabled && supportIconify)
	{
		if (appl_xgetinfo(APG_WINDOWS, &dummy, &dummy, &bits, &dummy) == 1)
		{
			if (bits & 1)
			{
				/* Iconify-Gadget einfuegen */
				wdwParts |= SMALLER;
			}

			if (bits & 0x08)
			{
				/* HotClose-Box einfuegen (wasauchimmer das sein mag) */
			}
		}
	}

	/* if (magIx) */
	{
		if (wdwParts & (NAME|MOVER))
		{
			/* Backdrop hinzufuegen, damit wir die Message bekommen! */
			wdwParts |= BACKDROP;
		}
	}
	*wdwHandle = wind_create(wdwParts, fullSize->g_x, fullSize->g_y, fullSize->g_w, fullSize->g_h);
	if (*wdwHandle < 0)
	{
		/* Kein Fenster mehr frei */
		OFREE(wr);
		return FALSE;
	}
	if (openWorkstation)
	{
		*vdiHandle = OpenWorkstation(Screen, 0, 0, TRUE);
		if (*vdiHandle < 0)
		{
			wind_delete(*wdwHandle);
			*wdwHandle = -1;
			OFREE(wr);
			return FALSE;
		}
	} else
	{
		*vdiHandle = -1;
	}
	/* So, jetzt noch in Liste einhaengen */
	wr->prev = NULL;
	if (windows == NULL)
	{
		wr->next = NULL;
	} else
	{
		/* Am Anfang einhaengen */
		wr->next = windows;
		windows->prev = wr;
	}
	windows = wr;
	/* Ok, alles da! */
	wr->wdw = *wdwHandle;
	wr->vdi = *vdiHandle;
	wr->used = TRUE;
	wr->isTop = showIt;
	wr->isFull = FALSE;
	wr->comps = wdwParts;
	wr->snap    = wdwSnap;
	wr->wdwFull = *fullSize;
	wr->pixOff  = pixelOffset;
	wr->wdwMenu = NULL;
	wr->wdwDial = NULL;
	wr->onlyTop = onlyThisTop;
	wr->lastOnlyTop = onlyOneTop;
	if (onlyThisTop)
		onlyOneTop = *wdwHandle;
	/* Event-Handler installieren */
	wr->hdlButton = button;
	wr->hdlMessage = FUNK_NULL;
	wr->hdlKey = key;
	wr->hdlTimer = timer;
	/* Slidergroessen initialisieren */
	wr->VslSize = -1;
	wr->VslPos  = -1;
	wr->HslSize = -1;
	wr->HslPos  = -1;
	/* Request-Handler installieren */
	wr->hdlSnap   = snapP;
	wr->hdlClose  = close;
	wr->hdlDraw   = draw;
	wr->hdlTop    = top;
	wr->hdlUntop  = untop;
	wr->hdlUpdate = update;
	wr->setNewWdw = setWdw;
	wr->wdwGetScroll = getScroll;
	wr->hdlHide   = hide;
	wr->hdlRect   = FUNK_NULL;
	wr->special   = special;
	wr->ddClientInstalled = FALSE;
	wr->ddServerInstalled = FALSE;
	wr->wdwCurr = *currSize;
	if (wr->wdwCurr.g_w < minWindWidth)
		wr->wdwCurr.g_w = minWindWidth;
	if (wr->wdwCurr.g_h < minWindHeight)
		wr->wdwCurr.g_h = minWindHeight;
	wr->acceptFont = FUNK_NULL;
	wr->acceptColor = FUNK_NULL;
	/* Dokument-Variablen setzen */
	wr->document.x = 0;
	wr->document.y = 0;
	wr->document.w = 0;
	wr->document.h = 0;
	wr->pageW = 0;
	wr->pageH = 0;
	wr->minScrollP = 0;
	wr->yFactor = 1;
	wr->xFactor = 1;
	wr->minScrollW = 1;
	wr->minScrollH = 1;
	/* Titel und Infozeile setzen */
	WdwManager_SetWdwTitle(wr->wdw, titel);
	WdwManager_SetWdwInfoline(wr->wdw, info);
	/* Jetzt Fenster oeffnen */
	Wind_calc(WC_WORK, wr->comps, currSize, &wr->wdwWork);
	/* Jetzt snappen */
	if (wr->snap && wr->hdlSnap != FUNK_NULL)
		wr->hdlSnap(wr->wdw, wr->special, &wr->wdwWork);
	/* Scrollrechteck holen */
	Wind_calc(WC_BORDER, wr->comps, &wr->wdwWork, &wr->wdwCurr);
	wr->wdwGetScroll(wr->wdw, wr->vdi, wr->special, &wr->wdwWork);
	if (showIt)
	{
		/* Altes TopWindow untoppen */
		oldTop = FindTop();
		if (oldTop != NULL)
			untopWdw(oldTop);
		wind_open(wr->wdw, wr->wdwCurr.g_x, wr->wdwCurr.g_y, wr->wdwCurr.g_w, wr->wdwCurr.g_h);
		if (wr->hdlTop != FUNK_NULL)
			wr->hdlTop(wr->wdw, wr->special);
	}
	wr->isHidden = !showIt;
	wr->isIcon = FALSE;
	if (showIt)
	{
		/* Noch merken, das dieses jetzt top ist */
		WdwManager_NewWindowIsTop(wr->wdw, gl_apid);
	}
	/* fettisch! */
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

/* Erzeugt ein Fenster, das mit Default-Prozeduren behandelt wird.
 * Weitere Einstellungen muss man danach vornehmen
 */
GLOBAL _BOOL WdwManager_CreateWindow(
	CONST GRECT *fullSize,
	GRECT *currSize,
	_UWORD wdwParts,
	CONST _UBYTE *info,
	CONST _UBYTE *titel,
    _VOID *special,
	_BOOL supportIconify,
	_BOOL openWorkstation,
	HWND *wdwHandle,
	HVDI *vdiHandle)
{
	return WdwManager_OpenWindow(
		defButton,
		defKey,
		defTimer,
		fullSize,
		currSize,
		wdwParts,
		FALSE,
		info,
		titel,
		defSnap,
		defClose,
		defDraw,
		defTop,
		defUntop,
		defUpdate,
		defSetwork,
		defGetrect,
		defHide,
		0,
		special,
		FALSE,
		FALSE,
		supportIconify,
		openWorkstation,
		FALSE,
		wdwHandle,
		vdiHandle);
}

/*** ---------------------------------------------------------------------- ***/

/* Setzt die Zeichenprozedur fuer ein Fenster. False: Fenster nicht gefunden
 */
GLOBAL _BOOL WdwManager_SetWindowDraw(HWND wdw, drawProc draw)
{
	WINDOW_DEF *wr;

	if ((wr = FindWindow(wdw)) != NULL)
	{
		wr->hdlDraw = draw;
		return TRUE;
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

/* Setzt die Snapprozedur fuer ein Fenster. Diese wird dann
 * bei jedem Sizen und einmal direkt mit den aktuellen Werten
 * aufgerufen. False: Fenster nicht gefunden
 */
GLOBAL _BOOL WdwManager_SetWindowSnap(HWND wdw, snapProc snap)
{
	WINDOW_DEF *wr;

	if ((wr = FindWindow(wdw)) != NULL)
	{
		wr->hdlSnap = snap;
		wr->snap = TRUE;
		return TRUE;
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _BOOL WdwManager_AcceptFont(HWND wdw, FONT_ACCEPT_FUNC func)
{
	WINDOW_DEF *wr;

	if ((wr = FindWindow(wdw)) != NULL)
	{
		wr->acceptFont = func;
		return TRUE;
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _BOOL WdwManager_AcceptsFonts(HWND wdw, FONT_ACCEPT_FUNC *func)
{
	WINDOW_DEF *wr;

	*func = FUNK_NULL;
	if ((wr = FindWindow(wdw)) != NULL)
	{
		*func = wr->acceptFont;
		return *func != FUNK_NULL;
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _BOOL WdwManager_AcceptColor(HWND wdw, COLOR_ACCEPT_FUNC func)
{
	WINDOW_DEF *wr;

	if ((wr = FindWindow(wdw)) != NULL)
	{
		wr->acceptColor = func;
		return TRUE;
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _BOOL WdwManager_AcceptsColor(HWND wdw, COLOR_ACCEPT_FUNC *func)
{
	WINDOW_DEF *wr;

	*func = FUNK_NULL;
	if ((wr = FindWindow(wdw)) != NULL)
	{
		*func = wr->acceptColor;
		return *func != FUNK_NULL;
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

/* Setzt den Buttonhandler fuer ein Fenster. False: Fenster nicht gefunden
 */
GLOBAL _BOOL WdwManager_SetWindowButton(HWND wdw, handleButtonProc button)
{
	WINDOW_DEF *wr;

	if ((wr = FindWindow(wdw)) != NULL)
	{
		wr->hdlButton = button;
		return TRUE;
	}
	return FALSE;
}
/*** ------------------------------------------------------------------------ ***/
/*	GLOBAL _BOOL WdwManager_SetWindowMessage(HWND wdw, handleMessageProc message)*/
/* Setzt den Messagehandler fuer ein Fenster. 									*/
/*	Parameter:	wdw:	das Fenster												*/
/*				message:der Messagehandler										*/
/*	Ergebnis:	False: Fenster nicht gefunden									*/
/*	24.10.00 von Dimitri Junker	DYJ 4.18										*/
/*** ------------------------------------------------------------------------ ***/
GLOBAL _BOOL WdwManager_SetWindowMessage(HWND wdw, handleMessageProc message)
{
	WINDOW_DEF *wr;

	if ((wr = FindWindow(wdw)) != NULL)
	{
		wr->hdlMessage = message;
		return TRUE;
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

/* Setzt den Keyhandler fuer ein Fenster. False: Fenster nicht gefunden
 */
GLOBAL _BOOL WdwManager_SetWindowKey(HWND wdw, handleKeyProc key)
{
	WINDOW_DEF *wr;

	if ((wr = FindWindow(wdw)) != NULL)
	{
		wr->hdlKey = key;
		return TRUE;
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

/* Setzt den Timerhandler fuer ein Fenster. False: Fenster nicht gefunden
 */
GLOBAL _BOOL WdwManager_SetWindowTimer(HWND wdw, handleTimerProc timer)
{
	WINDOW_DEF *wr;

	if ((wr = FindWindow(wdw)) != NULL)
	{
		wr->hdlTimer = timer;
		return TRUE;
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

/* Setzt den Rechteckhandler fuer ein Fenster. False: Fenster nicht gefunden
 */
GLOBAL _BOOL WdwManager_SetWindowRectProc(HWND wdw, handleRectProc rect)
{
	WINDOW_DEF *wr;

	if ((wr = FindWindow(wdw)) != NULL)
	{
		wr->hdlRect = rect;
		return TRUE;
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

/* Setzt den Closehandler fuer ein Fenster. False: Fenster nicht gefunden
 */
GLOBAL _BOOL WdwManager_SetWindowClose(HWND wdw, closeProc close)
{
	WINDOW_DEF *wr;

	if ((wr = FindWindow(wdw)) != NULL)
	{
		wr->hdlClose = close;
		return TRUE;
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

/* Setzt den Tophandler fuer ein Fenster. False: Fenster nicht gefunden
 */
GLOBAL _BOOL WdwManager_SetWindowTop(HWND wdw, topProc top)
{
	WINDOW_DEF *wr;

	if ((wr = FindWindow(wdw)) != NULL)
	{
		wr->hdlTop = top;
		return TRUE;
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

/* Setzt den Untophandler fuer ein Fenster. False: Fenster nicht gefunden
 */
GLOBAL _BOOL WdwManager_SetWindowUntop(HWND wdw, untopProc untop)
{
	WINDOW_DEF *wr;

	if ((wr = FindWindow(wdw)) != NULL)
	{
		wr->hdlUntop = untop;
		return TRUE;
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

/* Setzt den Updatehandler fuer ein Fenster. False: Fenster nicht gefunden
 */
GLOBAL _BOOL WdwManager_SetWindowUpdate(HWND wdw, wdwupdateProc update)
{
	WINDOW_DEF *wr;

	if ((wr = FindWindow(wdw)) != NULL)
	{
		wr->hdlUpdate = update;
		return TRUE;
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

/* Setzt den Handler fuer Dokumentaenderungen im Fenster. False: Fenster nicht gefunden
 */
GLOBAL _BOOL WdwManager_SetWindowSwork(HWND wdw, setWorkProc setWdw)
{
	WINDOW_DEF *wr;

	if ((wr = FindWindow(wdw)) != NULL)
	{
		wr->setNewWdw = setWdw;
		return TRUE;
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

/* Setzt den GetScrollRect-Handler fuer ein Fenster. False: Fenster nicht gefunden
 */
GLOBAL _BOOL WdwManager_SetWindowGetScroll(HWND wdw, getRectProc getScroll)
{
	WINDOW_DEF *wr;

	if ((wr = FindWindow(wdw)) != NULL)
	{
		wr->wdwGetScroll = getScroll;
		return TRUE;
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

/* Setzt den Hidehandler fuer ein Fenster. False: Fenster nicht gefunden
 */
GLOBAL _BOOL WdwManager_SetWindowHide(HWND wdw, hideProc hide)
{
	WINDOW_DEF *wr;

	if ((wr = FindWindow(wdw)) != NULL)
	{
		wr->hdlHide = hide;
		return TRUE;
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

/* Setzt den linken Offset fuer ein Fenster. False: Fenster nicht gefunden
 */
GLOBAL _BOOL WdwManager_SetWindowPixOff(HWND wdw, _WORD pixelOffset)
{
	WINDOW_DEF *wr;

	if ((wr = FindWindow(wdw)) != NULL)
	{
		wr->pixOff = pixelOffset;
		return TRUE;
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

/* Setzt den Modus fuer ein Fenster. False: Fenster nicht gefunden
 */
GLOBAL _BOOL WdwManager_SetWindowMode(HWND wdw, _BOOL onlyThisTop)
{
	WINDOW_DEF *wr;

	if ((wr = FindWindow(wdw)) != NULL)
	{
		wr->onlyTop = onlyThisTop;
		if (onlyThisTop)
		{
			wr->lastOnlyTop = onlyOneTop;
			onlyOneTop = wdw;
		}
		return TRUE;
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

/* Setzt die Dialogadresse fuer das Fenster. False: Fenster nicht gefunden
 */
GLOBAL _BOOL WdwManager_SetWindowDial(HWND wdw, OBJECT *dial)
{
	WINDOW_DEF *wr;

	if ((wr = FindWindow(wdw)) != NULL)
	{
		wr->wdwDial = dial;
		return TRUE;
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _BOOL WdwManager_SetWindowMenu(HWND wdw, OBJECT *menu)
{
	WINDOW_DEF *wr;

	if ((wr = FindWindow(wdw)) != NULL)
	{
		wr->wdwMenu = menu;
		return TRUE;
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _BOOL WdwManager_ShowWindow(HWND wdw)
{
	WINDOW_DEF *wr;

	if ((wr = FindWindow(wdw)) != NULL)
	{
		if (wr->isHidden)
			showWdw(wr, TRUE);
		else if (wr->isIcon)
			unIconifyWdw(wr, &wr->wdwIcon);
		else
			topWdw(wr, TRUE);
		return TRUE;
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _BOOL WdwManager_HideWindow(HWND wdw)
{
	WINDOW_DEF *wr;

	if ((wr = FindWindow(wdw)) != NULL)
	{
		hideWdw(wr);
		return TRUE;
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID WdwManager_SendCloseWindow(HWND wdw)
{
	_WORD apId;

	if (FindWindow(wdw) != NULL)
	{
		SendClosed(wdw, gl_apid);
	} else
	{
		if (WdwManager_GetApId(wdw, &apId))
			SendClosed(wdw, apId);
	}
}

/*** ---------------------------------------------------------------------- ***/

/* Schliesst Fenster und Workstation und entfernt die Handler aus der Liste
 */
GLOBAL _BOOL WdwManager_CloseWindow(HWND wdw, _BOOL force)
{
	WINDOW_DEF *wr;
	_WORD apId;

	if ((wr = FindWindow(wdw)) != NULL)
	{
		if (onlyOneTop >= 0 && wr->wdw != onlyOneTop && !force)
			return FALSE;
		return closeWdw(wr, force);
	}
	if (wdw > 0 && WdwManager_GetApId(wdw, &apId))
	{
		SendClosed(wdw, apId);
		return TRUE;
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

/* Schliesst alle Fenster, die dem Modul bekannt sind.
 * Die Fenster werden alle ueber CloseWindow geschlossen,
 * und falls ein CloseWindow FALSE zurueckliefert, dann
 * wird der Returnwert zurueckgegeben und abgebrochen.
 */
GLOBAL _BOOL WdwManager_CloseAllWindows(_BOOL force)
{
	WINDOW_DEF *wr;

	while ((wr = windows) != NULL)
	{
		if (!WdwManager_CloseWindow(wr->wdw, force))
			return FALSE;
	}
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

/* Tut so, als ob das Fenster eine Fulled-Nachricht erhalten haette.
 * Falls das Fenster nicht vom Modul verwaltet wird, aber trotzdem
 * in der WindowQueue enthalten ist, dann wird an das Fenster
 * eine Fulled-Nachricht geschickt.
 */
GLOBAL _VOID WdwManager_FullWindow(HWND wdw)
{
	WINDOW_DEF *wr;
	_WORD apid;

	if ((wr = FindWindow(wdw)) != NULL)
	{
		fullWdw(wr);
	} else
	{
		if (WdwManager_GetApId(wdw, &apid))
			SendFulled(wdw, apid);
	}
}

/*** ---------------------------------------------------------------------- ***/

/* Tut so, als ob das Fenster eine Topped-Nachricht erhalten haette.
 * Falls das Fenster nicht vom Modul verwaltet wird, aber trotzdem
 * in der WindowQueue enthalten ist, dann wird an das Fenster
 * eine Topped-Nachricht geschickt.
 */
GLOBAL _VOID WdwManager_TopWindow(HWND wdw)
{
	WINDOW_DEF *wr;
	_WORD apid;

	if ((wr = FindWindow(wdw)) != NULL)
	{
		topWdw(wr, TRUE);
	} else
	{
		if (WdwManager_GetApId(wdw, &apid))
			SendTop(wdw, apid);
	}
}

/*** ---------------------------------------------------------------------- ***/

/* Setzt das Icon, das in iconifizierten Fenstern gezeichnet wird.
 * icon ist die Adresse eines Objektbaumes
 */
GLOBAL _VOID WdwManager_SetWindowIcon(OBJECT *icon)
{
	iconHdl = icon;
}

/*** ---------------------------------------------------------------------- ***/

/* Verteilt die events, falls noetig. Wenn behandelt, wird TRUE zurueckgegeben,
 * andernfalls FALSE
 */
GLOBAL _BOOL WdwManager_HandleEvent(
	_UWORD *event, CONST _WORD *pbuff, _UWORD buts,
	_UWORD kstate, _UBYTE key, _UBYTE scan, _WORD taste, _WORD mx, _WORD my, _WORD clicks)
{
	WINDOW_DEF *wr;
	_BOOL eventDone;
	_BOOL evtDone;
	_WORD dummy;

	eventDone = FALSE;
	wind_get(0, WF_TOP, &theTopWindow, &dummy, &dummy, &dummy);
	ownTopWindow = WdwManager_GetOwnTopWindow();
	if (theTopWindow != ownTopWindow && FindWindow(theTopWindow) != NULL)
	{
		WdwManager_NewWindowIsTop(theTopWindow, gl_apid);
		ownTopWindow = theTopWindow;
	}
	/* Tastendruecke, gehen an Dialog oder an Fenster, wenn mit Shift */
	if (*event & MU_KEYBD)
	{
		TranslateKey(&key, &scan, &taste, &kstate);
		wr = FindWindow(ownTopWindow);
		if (wr != NULL)
		{
			if (onlyOneTop >= 0 || wr->wdwDial != NULL || kstate & (K_LSHIFT|K_RSHIFT))
			{
				if (!wr->isIcon && !wr->isHidden && wr->hdlKey != FUNK_NULL &&
					wr->hdlKey(wr->wdw, wr->special, taste, key, scan, kstate))
				{
					*event &= ~MU_KEYBD;
					eventDone = TRUE;
				}
			}
		}
	}

	/* Jetzt Tastendruecke ohne Shift, gehen an globale Prozedur */
	if ((*event & MU_KEYBD) && handleGlobalKey != FUNK_NULL)
	{
		if (handleGlobalKey(taste, key, scan, kstate))
		{
			*event &= ~MU_KEYBD;
			eventDone = TRUE;
		}
	}

	/* Jetzt Tastendruecke ohne Shift, die noch uebrig sind */
	if (*event & MU_KEYBD)
	{
		wr = FindWindow(ownTopWindow);
		if (wr != NULL)
		{
			if (!wr->isIcon && !wr->isHidden && wr->hdlKey != FUNK_NULL &&
				wr->hdlKey(wr->wdw, wr->special, taste, key, scan, kstate))
			{
				*event &= ~MU_KEYBD;
				eventDone = TRUE;
			}
		}
	}

	/* Jetzt Rechteckevents */
	if (*event & MU_M1)
	{
		wr = FindWindow(ownTopWindow);
		if (wr != NULL)
		{
			if (!wr->isIcon && !wr->isHidden && wr->hdlRect != FUNK_NULL &&
				wr->hdlRect(wr->wdw, wr->special, 1, mx, my))
			{
				*event &= ~MU_M1;
				eventDone = TRUE;
			}
		}
	}
	if (*event & MU_M2)
	{
		wr = FindWindow(ownTopWindow);
		if (wr != NULL)
		{
			if (!wr->isIcon && !wr->isHidden && wr->hdlRect != FUNK_NULL &&
				wr->hdlRect(wr->wdw, wr->special, 2, mx, my))
			{
				*event &= ~MU_M2;
				eventDone = TRUE;
			}
		}
	}

	if (*event & MU_MESAG)
	{
		wr = FindWindow(wind_find(mx, my));
		if (wr != NULL)
		{
			if (!wr->isIcon && !wr->isHidden && wr->hdlMessage != FUNK_NULL &&
				wr->hdlMessage(wr->wdw, wr->special,pbuff ))
			{
				*event &= ~MU_MESAG;
				eventDone = TRUE;
			}
		}
	}
	if (*event & MU_MESAG)
	{
		evtDone = MessageEvent(pbuff);
		if (evtDone)
		{
			*event &= ~MU_MESAG;
		} else if (handleGlobalMess != FUNK_NULL)
		{
			/* Wenn noch nicht behandelt, dann gehen die an den globalen
			 * Handler, falls installiert
			 */
			evtDone = handleGlobalMess(pbuff, kstate);
			if (evtDone)
			{
				*event &= ~MU_MESAG;
			}
		}
		eventDone |= evtDone;
	}

	if (*event & MU_BUTTON)
	{
		wr = FindWindow(wind_find(mx, my));
		if (wr != NULL)
		{
			if (!wr->isIcon && !wr->isHidden && wr->hdlButton != FUNK_NULL &&
				wr->hdlButton(wr->wdw, wr->special, mx, my, kstate, buts, clicks))
			{
				*event &= ~MU_BUTTON;
				eventDone = TRUE;
			}
		}
	}

	if (*event & MU_TIMER)
	{
		for (wr = windows; wr != NULL; wr = wr->next)
		{
			if (!wr->isIcon && !wr->isHidden)
				if (wr->hdlTimer != FUNK_NULL)
					eventDone |= wr->hdlTimer(wr->wdw, wr->special);	
		}
	}

	if (handlePostEvent != FUNK_NULL)
		(*handlePostEvent)(theTopWindow);
	return eventDone;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID WdwManager_HandlePendingEvents(_VOID)
{
	_UWORD etv, event;
	_WORD message[8];
	_UBYTE key, scan;
	_UWORD buts, kstate;
	_WORD taste, mx, my, clicks;

	do
	{
		event = evnt_multi(MU_MESAG | MU_TIMER,
			0, 0, 0,
			0, 0, 0, 0, 0,
			0, 0, 0, 0, 0,
			message,
			50, 0,
			&mx, &my, &buts, &kstate, &taste, &clicks);
		etv = event;
		if (event & MU_MESAG)
		{
			Wind_Update(BEG_UPDATE);
			scan = (taste >> 8) & 0xff;
			key = taste & 0xff;
			WdwManager_HandleEvent(&event, message, buts, kstate, key, scan, taste, mx, my, clicks);
			Wind_Update(END_UPDATE);
		}
	} while (etv & MU_MESAG);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID WdwManager_GetTopWindow(HWND *wdw, HVDI *handle)
{
	_WORD dummy;
	WINDOW_DEF *wr;

	wind_get(0, WF_TOP, wdw, &dummy, &dummy, &dummy);
	theTopWindow = *wdw;
	if ((wr = FindWindow(*wdw)) != NULL)
	{
		*handle = wr->vdi;
		wr->isTop = TRUE;
	} else
	{
		*handle = -1;
	}
}

/*** ---------------------------------------------------------------------- ***/

/* Liefert zurueck, ob ein eigenes Fenster, das vom Windowmanager verwaltet
 * wird, das Topwindow ist
 */
GLOBAL _BOOL WdwManager_IsOwnTop(_VOID)
{
	_WORD dummy;

	wind_get(0, WF_TOP, &theTopWindow, &dummy, &dummy, &dummy);
	return FindWindow(theTopWindow) != NULL;
}

/*** ---------------------------------------------------------------------- ***/

/* Liefert TRUE, wenn das Window vorhanden und iconifiziert ist
 */
GLOBAL _BOOL WdwManager_WindowIsIcon(HWND wdw)
{
	WINDOW_DEF *wr;

	if ((wr = FindWindow(wdw)) != NULL)
		return wr->isIcon;
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

/* Liefert TRUE, wenn das Topwindow ein eigenes und modal ist
 */
GLOBAL _BOOL WdwManager_ModalWindowTop(_VOID)
{
	return WdwManager_IsOwnTop() && onlyOneTop >= 0 && onlyOneTop == theTopWindow;
}

/*** ---------------------------------------------------------------------- ***/

/* Liefert TRUE, wenn das Window vorhanden und mittels WindowShade
 * geshadet ist (oder ausserhalb des Bildschirms liegt)
 */
GLOBAL _BOOL WdwManager_WindowIsShaded(HWND wdw)
{
	GRECT work;
	_BOOL isShaded;

	if (FindWindow(wdw) != NULL)
	{
		isShaded = !WdwManager_RectList(wdw, FALSE, &work);
		if (!isShaded)
		{
			/* Rechteckliste bis zum Ende abklappern */
			while (WdwManager_RectList(wdw, TRUE, &work))
				;
		}
		return isShaded;
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

/* Liefert TRUE, wenn das Window vorhanden und schliessbar ist.
 * Schliessbar heisst, es hat einen Closer.
 */
GLOBAL _BOOL WdwManager_WindowIsCloseable(HWND wdw)
{
	WINDOW_DEF *wr;

	if ((wr = FindWindow(wdw)) != NULL)
		return (wr->comps & CLOSER) != 0;
	return WdwManager_IsInQueue(wdw);
}

/*** ---------------------------------------------------------------------- ***/

/* Liefert TRUE, wenn das Window vorhanden und fullbar ist,
 * d.h. es hat einen Sizer oder es ist nur in der Queue drin.
 */
GLOBAL _BOOL WdwManager_WindowIsFullable(HWND wdw)
{
	WINDOW_DEF *wr;

	if ((wr = FindWindow(wdw)) != NULL)
		return (wr->comps & (SIZER|FULLER)) == (SIZER|FULLER);
	return WdwManager_IsInQueue(wdw);
}

/*** ---------------------------------------------------------------------- ***/

/* Liefert das Windowhandle zurueck, falls sich an der Position
 * x,y ein Fenster befindet (muss nicht dem Modul bekannt sein!)
 */
GLOBAL HWND WdwManager_ClickInWindow(_WORD x, _WORD y)
{
	return wind_find(x, y);
}


/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

/*------- Menu & Keyboard -----------------------------------------------------*/

/* Gibt dem Modul die Adresse des Menubaums bekannt. Damit kann dieser dann disablet
 * werden, wenn ein modaler Dialog aufgerufen wird.
 * Ausserdem wird eine Callback-Funktion installiert, die bei Menu-Events aufgerufen
 * wird.
 * Es wird nur ein Menu und eine Callbackfunktion verwendet, ein Deinstall
 * ist daher nicht notwendig, ein erneuter Aufruf ueberschreibt die
 * eingestellten Werte
 */
GLOBAL _VOID WdwManager_InstallGlobalMenu(OBJECT *tree, handleMessProc menuP)
{
	globalMenu = tree;
	handleGlobalMess = menuP;
}

/*** ---------------------------------------------------------------------- ***/

/* Schaltet einen Menubaum auf enabled oder disabled
 * menu == NIL: ein installiertes globales Menu wird disabled oder enabled
 */
GLOBAL _VOID WdwManager_DisableMenu(OBJECT *menu, _BOOL disable)
{
	_WORD o, title;

	if (menu == NULL)
		menu = globalMenu;
	if (menu == NULL)
		return;
	if (disable)
	{
		if (disableCounter++ > 0)
			return;
	} else
	{
		if (--disableCounter > 0)
			return;
	}
	if (menuDisabled == disable)
		return;

	title = menu[menu[menu[ROOT].ob_head].ob_head].ob_head; /* Index erster Titel */
	menu_bar(menu, 0);

	o =  menu[menu[menu[ROOT].ob_head].ob_next].ob_head; /* Index erste Box */
	EnableObjState(menu, menu[o].ob_head, DISABLED, disable); /* ersten Eintrag */

	for (;;)
	{
		if(menu[menu[title].ob_next].ob_tail==title)
			break;
		title = menu[title].ob_next;
		EnableObjState(menu, title, DISABLED, disable); /* titel disablen */
		DelObjState(menu, title, SELECTED);         /* deselektieren */
	}

	if (disable)
	{
		menuLength = menu[2].ob_width;
		menu[2].ob_width = menu[3].ob_width; /* Breite auf DESK begrenzen */
	} else
	{
		menu[2].ob_width = menuLength; /* Breite zuruecksetzen */
	}

	menu_bar(menu, 1);
	menuDisabled = disable;
}

/*** ---------------------------------------------------------------------- ***/

/* Installiert einen globalen Keyhandler, der dann aufgerufen wird, wenn
 * die Taste von keinem Fenster behandelt wurde.
 * Wenn Shift und eine andere Sondertaste gedrueckt wird, dann wird
 * diese Callback-Funktion vor den Fenstern aufgerufen
 */
GLOBAL _VOID WdwManager_InstallGlobalKeyProc(handleGlobalKeyProc key)
{
	handleGlobalKey = key;
}


/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

/*------- QueueModul ----------------------------------------------------------*/

#define MAX_QUEUE_ENTRIES 256
#define NO_WDW (-1)

typedef struct {
	HWND wdw;
	_WORD apId;
} queueEntry;

/*
 * Alle bekannten Fenster, auch die von anderen Applikationen
 * Das oberste Fenster steht in der Liste ganz hinten
 */
LOCAL queueEntry handleArray[MAX_QUEUE_ENTRIES];
LOCAL _UWORD maxQueue;

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID InitQueue(_VOID)
{
	_UWORD z;

	for (z = 0; z < MAX_QUEUE_ENTRIES; z++)
		handleArray[z].wdw = NO_WDW;
	maxQueue = 0;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL EmptyQueue(_VOID)
{
	return maxQueue == 0;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _BOOL WdwManager_GetApId(HWND wdw, _WORD *apId)
{
	_WORD dummy;
	_UWORD z;

	/* Application ID rausfinden */
	if (wdw > 0 && wind_get(wdw, WF_OWNER, apId, &dummy, &dummy, &dummy) != 0)
		return TRUE;
	for (z = 0; z < maxQueue; z++)
		if (handleArray[z].wdw == wdw)
		{
			*apId = handleArray[z].apId;
			return TRUE;
		}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID EnQueue(HWND wdw, _WORD apId, _BOOL reverse)
{
	_WORD z;

	if (maxQueue < MAX_QUEUE_ENTRIES)
	{
		if (reverse)
		{
			++maxQueue;
			for (z = maxQueue - 2; z >= 0; z--)
				handleArray[z+1] = handleArray[z];
			handleArray[0].wdw = wdw;
			handleArray[0].apId = apId;
		} else
		{
			handleArray[maxQueue].wdw = wdw;
			handleArray[maxQueue].apId = apId;
			++maxQueue;
		}
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID DeleteFromQueue(HWND wdw)
{
	_UWORD z;

	for (z = 0; z < maxQueue && handleArray[z].wdw != wdw; z++)
		;
	if (z < maxQueue && handleArray[z].wdw == wdw)
	{
		--maxQueue;
		for (; z < maxQueue; z++)
			handleArray[z] = handleArray[z+1];
		handleArray[z].wdw = NO_WDW;
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL TopOfQueue(HWND *wdw, _WORD *apid)
{
	if (!EmptyQueue())
	{
		*wdw = handleArray[0].wdw;
		*apid = handleArray[0].apId;
		return TRUE;
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL HWND WdwManager_FindSpecialTop(queueTestProc hdlTest)
{
	_WORD i;

	for (i = maxQueue; --i >= 0; )
	{
		if (handleArray[i].apId == gl_apid && hdlTest(handleArray[i].wdw))
			return handleArray[i].wdw;
	}
	return -1;
}

/*** ---------------------------------------------------------------------- ***/

_VOID WdwManager_NewWindowIsTop(HWND handle, _WORD apId)
{
	DeleteFromQueue(handle);
	EnQueue(handle, apId, FALSE);
	if (handleNewTop != FUNK_NULL)
		(*handleNewTop)(handle);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID BringToBottom(HWND wdw, _WORD apId)
{
	DeleteFromQueue(wdw);
	EnQueue(wdw, apId, TRUE);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID WdwManager_WindowIsClosed(HWND wdw)
{
	DeleteFromQueue(wdw);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID WdwManager_TopNextWindow(_VOID)
{
	_WORD nextTop, apId;
	WINDOW_DEF *wr;

	if (TopOfQueue(&nextTop, &apId))
	{
		if (nextTop >= 0)
		{
			wr = FindWindow(nextTop);
			if (wr != NULL)
			{
				topWdw(wr, TRUE);
			} else
			{
				SendTop(nextTop, apId);
				WdwManager_NewWindowIsTop(nextTop, apId);
			}
		}
	}
}

/*** ---------------------------------------------------------------------- ***/

/* Liefert das Topwindow der Applikation zurueck */
GLOBAL HWND WdwManager_GetOwnTopWindow(_VOID)
{
	_WORD i;
	WINDOW_DEF *wr;

	if (!EmptyQueue())
	{
		for (i = maxQueue; --i >= 0; )
		{
			if ((wr = FindWindow(handleArray[i].wdw)) != NULL)
				return wr->wdw;
		}
	}
	return NO_WDW;
}

/*** ---------------------------------------------------------------------- ***/

/* Es wird zurueckgeliefert, ob es moeglich ist,
 * ein anderes Fenster zu toppen.
 */
GLOBAL _BOOL WdwManager_TopNextPossible(_VOID)
{
	return maxQueue > 0;
}

/*** ---------------------------------------------------------------------- ***/

/* Liefert TRUE zurueck, wenn das Fenster wdw in
 * der verwalteten Queue ist.
 */
GLOBAL _BOOL WdwManager_IsInQueue(HWND wdw)
{
	_WORD dummy;

	return WdwManager_GetApId(wdw, &dummy);
}

/*** ---------------------------------------------------------------------- ***/

/* Liefert zweitoberstes Fenster zurueck.
 * Geht nur ueber Queue, benutzt nicht die Liste.
 */
GLOBAL _BOOL WdwManager_GetSecondWdw(HWND *wdw)
{
	if (maxQueue <= 1)
		return FALSE;
	*wdw = handleArray[maxQueue - 2].wdw;
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

/* Ordnet die Fenster
*/
GLOBAL _VOID WdwManager_ArrangeWindows(_WORD mode)
{
	WINDOW_DEF *wr;
	_WORD i, wdws;
	GRECT newsize;
	_WORD cols, rows, xcols, xrows;

	wdws = 0;
	/* Fenster zaehlen */
	for (wr = windows; wr != NULL; wr = wr->next)
	{
		if ((wr->comps & SIZER) && !wr->isIcon && !wr->isHidden)
			++wdws;
	}
	if (wdws <= 1)
		return;

	i = 1;
	wr = windows;
	/* Letzten Eintrag suchen */
	while (wr->next != NULL)
		wr = wr->next;

	switch (mode)
	{
	case STACKED:
		while (i <= wdws && wr != NULL)
		{
			if ((wr->comps & SIZER) && !wr->isIcon && !wr->isHidden)
			{
				newsize.g_x = deskSize.g_x;                                      /* new.x */
				newsize.g_y = deskSize.g_y + (i-1) * (deskSize.g_h / wdws);      /* new.y */
				newsize.g_w = deskSize.g_w;                                      /* new.w */
				newsize.g_h = deskSize.g_h / wdws;                               /* new.h */
				moveSizeWdw(wr, TRUE, FALSE, &newsize, TRUE);
				++i;
			}
			wr = wr->prev;
		}
		break;

	case BYSIDE:
		while (i <= wdws && wr != NULL)
		{
			if ((wr->comps & SIZER) && !wr->isIcon && !wr->isHidden)
			{
				newsize.g_x = deskSize.g_x + (i-1) * (deskSize.g_w / wdws);      /* new.x */
				newsize.g_y = deskSize.g_y;                                      /* new.y */
				newsize.g_w = deskSize.g_w / wdws;                               /* new.w */
				newsize.g_h = deskSize.g_h;                                      /* new.h */
				moveSizeWdw(wr, TRUE, FALSE, &newsize, TRUE);
				++i;
			}
			wr = wr->prev;
		}
		break;

	case OVERLAP:
		while (i <= wdws && wr != NULL)
		{
			if ((wr->comps & SIZER) && !wr->isIcon && !wr->isHidden)
			{
				newsize.g_x = deskSize.g_x + (i-1) * CharHeight;                 /* new.x */
				newsize.g_y = deskSize.g_y + (i-1) * CharHeight;                 /* new.y */
				newsize.g_w = deskSize.g_w - (wdws-1) * CharHeight;              /* new.w */
				newsize.g_h = deskSize.g_h - (wdws-1) * CharHeight;              /* new.h */
				moveSizeWdw(wr, TRUE, FALSE, &newsize, TRUE);
				++i;
			}
			wr = wr->prev;
		}
		break;

	case TILED:
		/* Erstmal rausfinden, wieviel Fenster nebeneinander kommen */
		cols = 2;
		while (cols * cols < wdws)
			++cols;
		rows = wdws / cols;
		if (rows * cols < wdws)
			xrows = rows + 1;
		else
			xrows = rows;
		xcols = wdws - (rows * cols);
		if (xcols == 0)
			xcols = cols;
		while (((i - 1) / cols < rows) && (wr != NULL))
		{
			if ((wr->comps & SIZER) && !wr->isIcon && !wr->isHidden)
			{
				newsize.g_x = deskSize.g_x + ((i-1) % cols) * (deskSize.g_w / cols);     /* new.x */
				newsize.g_y = deskSize.g_y + ((i-1) / cols) * (deskSize.g_h / xrows);    /* new.y */
				newsize.g_w = deskSize.g_w / cols;                                       /* new.w */
				newsize.g_h = deskSize.g_h / xrows;                                      /* new.h */
				moveSizeWdw(wr, TRUE, FALSE, &newsize, TRUE);
				++i;
			}
			wr = wr->prev;
		}
		while ((i <= wdws) && (wr != NULL))
		{
			if ((wr->comps & SIZER) && !wr->isIcon && !wr->isHidden)
			{
				newsize.g_x = deskSize.g_x + ((i-1) % xcols) * (deskSize.g_w / xcols);   /* new.x */
				newsize.g_y = deskSize.g_y + ((i-1) / cols)  * (deskSize.g_h / xrows);   /* new.y */
				newsize.g_w = deskSize.g_w / xcols;                                      /* new.w */
				newsize.g_h = deskSize.g_h / xrows;                                      /* new.h */
				moveSizeWdw(wr, TRUE, FALSE, &newsize, TRUE);
				++i;
			}
			wr = wr->prev;
		}
		break;
	}
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

/*-- Drag & Drop Support fuer MTOS ------------------------------------------*/

/* Ein Fenster installiert fuer sich Drag & Drop. Damit unterstuetzt
 * es automatisch Drag & Drop.
 */
GLOBAL _VOID WdwManager_WdwInstallDDClient(
	HWND wdw,
	getExtsProc getExts,
	acceptDataProc acceptData,
	writeDataProc writeData)
{
	WINDOW_DEF *wr;

	if ((wr = FindWindow(wdw)) != NULL)
	{
		wr->ddClientInstalled = TRUE;
		wr->ddGetExts = getExts;
		wr->ddAcceptData = acceptData;
		wr->ddWriteData = writeData;
	}
}

/*** ---------------------------------------------------------------------- ***/

/* Ein Fenster installiert sich als Server fuer Drag & Drop.
 * Danach kann es dann die Prozedur WdwDDServe benutzen,
 * die Drag & Drop durchfuehrt.
 */
GLOBAL _VOID WdwManager_WdwInstallDDServer(HWND wdw, getHeaderProc getHeader, readDataProc readData)
{
	WINDOW_DEF *wr;

	if ((wr = FindWindow(wdw)) != NULL)
	{
		wr->ddServerInstalled = TRUE;
		wr->ddGetHeader = getHeader;
		wr->ddReadData = readData;
	}
}

/*** ---------------------------------------------------------------------- ***/

/*
 * create a pipe for doing the drag & drop,
 * and send an AES message to the receipient
 * application telling it about the drag & drop
 * operation.
 *
 * Input Parameters:
 * apid:    AES id of the window owner
 * winid:   target window (0 for background)
 * msx, msy:    mouse X and Y position
 *      (or -1, -1 if a fake drag & drop)
 * kstate:  shift key state at time of event
 *
 * Output Parameters:
 * exts:    A 32 byte buffer into which the
 *      receipient's 8 favorite
 *      extensions will be copied.
 *
 * Returns:
 * A positive file descriptor (of the opened
 * drag & drop pipe) on success.
 * -1 if the receipient doesn't respond or
 *    returns DD_NAK
 * -2 if appl_write fails
 */

LOCAL _WORD WdwDDCreate(_WORD apid, HWND wdw, _WORD mx, _WORD my, _UWORD kstate, _UBYTE *exts, _LONG *oldPipe)
{
	_WORD message[8];
	FILENO fd;
	_WORD i;
	_LONG fdMask;
	_UBYTE c;
	_UBYTE pipename[PATH_MAX];
	_ULONG count;

	/* create pipe */
	strCpy(pipename, "U:\\PIPE\\DRAGDROP.AA");
	fd = -1;
	pipename[18] = 'A' - 1;
	for (;;)
	{
		++pipename[18];
		if (pipename[18] > 'Z')
		{
			++pipename[17];
			if (pipename[17] > 'Z')
				break;
			pipename[18] = 'A';
		}
		/* HIDDEN means "get EOF if nobody has pipe open for reading" */
		fd = (FILENO)Fcreate(pipename, 0x02);  /* FA_HIDDEN */
		if (fd != -36) /* EACCDN */
			 break;
	}
	/* test file handle */
	if (fd < 0)
	{
		/* Fcreate error */
		return fd;
	}
	/* set SIG_PIPE to SIG_IGN */
	*oldPipe = Psignal(SIGPIPE, (_LONG)SIG_IGN);

	/* construct and send the AES message */
	message[0] = AP_DRAGDROP;
	message[1] = gl_apid;
	message[2] = 0;
	message[3] = wdw;
	message[4] = mx;
	message[5] = my;
	message[6] = kstate;
	message[7] = (pipename[17] << 8) | pipename[18];
	appl_write(apid, 16, message);

	/* now wait for a response */
	fdMask = 1L << fd;
	i = Fselect(/* DD_TIMEOUT */ 3000, &fdMask, 0L, 0L);
	if (i == 0 || fdMask == 0)
	{
		/* timeout happened */
		Psignal(SIGPIPE, *oldPipe);
		Fclose(fd);
		return -1;
	}


	/* read the 1 byte response */
	count = Fread(fd, 1l, &c);
	if (count != 1 || c != DD_OK)
	{
		/* no drag & drop */
		Psignal(SIGPIPE, *oldPipe);
		Fclose(fd);
		return -1;
	}
	/* now read the "preferred extensions" */
	count = Fread(fd, DD_EXTSIZE, exts);
	if (count != DD_EXTSIZE)
	{
		/* Read error in pipe */
		Psignal(SIGPIPE, *oldPipe);
		Fclose(fd);
		return -1;
	}

	/* init was ok */
	return fd;
}

/*** ---------------------------------------------------------------------- ***/

/*
 * see if the receipient is willing to accept a certain
 * type of data (as indicated by "ext")
 *
 * Input parameters:
 * fd       file descriptor returned from ddcreate()
 * ext      pointer to the 4 byte file type
 * name     pointer to the name of the data
 * size     number of bytes of data that will be sent
 *
 * Output parameters: none
 *
 * Returns:
 * DD_OK    if the receiver will accept the data
 * DD_EXT   if the receiver doesn't like the data type
 * DD_LEN   if the receiver doesn't like the data size
 * DD_NAK   if the receiver aborts
 */


LOCAL _WORD WdwDDstry(FILENO fd, CONST _UBYTE *ext, CONST _UBYTE *name, _LONG size)
{
	_WORD i, hdrlen;
	_LONG fdmask;
	_UBYTE c;
	_LONG count;

	/* 4 bytes for extension, 4 bytes for size, 1 byte for
	 * trailing 0
	 */
	i = (_WORD)strLen(name) + 1;
	hdrlen = DD_EXTLEN + (_WORD)sizeof(_ULONG) + i;
	count = Fwrite(fd, 2, &hdrlen);
	if (count != 2)
		return DD_NAK;

	/* now send the header */
	count = Fwrite(fd, DD_EXTLEN, ext);
	count += Fwrite(fd, 4, &size);
	count += Fwrite(fd, i, name);
	if (count != hdrlen)
		return DD_NAK;

	/* now wait for a response */
	fdmask = 1L << fd;
	/* wait to a maximum of 100 ms */
	i = Fselect(100, &fdmask, 0L, 0L);
	if (i == 0 || fdmask == 0)
	{
		/* timeout happened */
		return DD_NAK;
	}

	/* wait for a reply */
	count = Fread(fd, 1l, &c);
	if (count != 1)
		return DD_NAK;
	return c;
}

/*** ---------------------------------------------------------------------- ***/

/*
 * close a drag & drop operation
 */

LOCAL _VOID WdwDDclose(FILENO fd, _LONG *oldPipe)
{
	/* restore signal handler */
	Psignal(SIGPIPE, *oldPipe);
	/* close pipe */
	Fclose(fd);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID WdwInternalDD(WINDOW_DEF *server, WINDOW_DEF *client)
{
	struct {
		_UBYTE dtype[DD_EXTLEN];
		_ULONG dlen;
		_UBYTE name[1];
	} *hdr;
	_UBYTE ext[DD_EXTLEN];
	_UBYTE name[PATH_MAX];
	_ULONG size;
	_VOID *data;
	_WORD idx;
	_BOOL done;
	
	idx = 0;
	done = FALSE;
	while (!done && server->ddGetHeader(server->wdw, server->special, idx, ext, name, sizeof(name), &size))
	{
		/* Header aufbauen */
		hdr = MALLOC(9 + strLen(name), "WdwInternalDD");
		if (hdr == NULL)
			return;
		MemCpy(hdr->dtype, ext, DD_EXTLEN);
		hdr->dlen = size;
		strCpy(hdr->name, name);
		/* Beim Client anfragen, ob er den Header annimmt */
		if (client->ddAcceptData(client->wdw, client->special, hdr))
		{
			/* Daten holen */
			data = NULL;
			server->ddReadData(server->wdw, server->special, &data, idx);
			if (data != NULL)
			{
				client->ddWriteData(client->wdw, client->special, data, size);
				SFREE(data);
				done = TRUE;
			}
		}
		SFREE(hdr);
		++idx;
	}
}
/*** ---------------------------------------------------------------------- ***/

/* Initialisiert Drag & Drop als Server. wdw ist das Source-Fenster(!!),
 * vorher muss sich das Fenster als Server angemeldet haben. Dann wird
 * ueber die angemeldeten Prozeduren versucht, Drag & Drop durchzufuehren
 */
GLOBAL _BOOL WdwManager_WdwDDServe(HWND wdw, _WORD mx, _WORD my, _UWORD kstate)
{
	WINDOW_DEF *wr, *wr2;
	_UBYTE exts[DD_EXTSIZE];
	_UBYTE ext[DD_EXTLEN];
	_UBYTE name[PATH_MAX];
	HWND tWin;
	_WORD res;
	FILENO fd;
	_ULONG size;
	_LONG oldPipe;
	_VOID *data;
	_LONG fdmask;
	_WORD apId, dummy;
	_WORD idx;
	_BOOL sndHdr;	
	_WORD durchl,tstExt;
	wr = FindWindow(wdw);
	if (wr != NULL)
	{
		if (wr->ddServerInstalled)
		{
			/* Ok, wir haben einen Server
			 * Jetzt das Zielfenster finden
			 */
			tWin = wind_find(mx, my);
			/* Drag & Drop im gleichen Fenster geht nicht */
			if (tWin == wdw)
				return FALSE;
			wr2 = FindWindow(tWin);
			if (wr2 != NULL)
			{
				/* Ist eigenes Fenster! Eventuell internes Drag & Drop durchfuehren
				 */
				if (wr2->ddClientInstalled)
				{
					/* Do internal drag & drop */
					WdwInternalDD(wr, wr2);
				}
				/* Hier koennen wir rausgehen, da passiert nichts mehr */
				return TRUE;
			}
			/* Ok, ist fremdes Fenster */
			/* Application ID rausfinden */
			if (wind_get(tWin, WF_OWNER, &apId, &dummy, &dummy, &dummy) == 0)
				return FALSE; /* keine Application gefunden */
			if (apId == gl_apid)
				return FALSE; /* this should NOT happen! */
			/* create drag & drop pipe */
			fd = WdwDDCreate(apId, tWin, mx, my, kstate, exts, &oldPipe);
			if (fd < 0)
				return FALSE;
			/* Die gelieferten Extensions ignorieren wir einfach */
#if DD_TEST
			printf("WdwDDCreate: exts=%s\n", exts);
#endif
			for(durchl=0;durchl<2;durchl++)
			{
				idx = 0;
				/* Beim Server die ersten Headerdaten anfordern */
				if (wr->ddGetHeader(wr->wdw, wr->special, idx, ext, name, sizeof(name), &size))
				{
					do
					{
						sndHdr=durchl==1;
						for(tstExt=0;tstExt<DD_NUMEXTS;tstExt++)
						{
							if(!strnCaseCmp(exts+DD_EXTLEN*tstExt,ext,DD_EXTLEN))
							{
								sndHdr=!sndHdr;
								break;
							}
						}
						if(sndHdr)
						{
							/* Header senden und nachsehen, ob es akzeptiert wird */
							res = WdwDDstry(fd, ext, name, size);
		#if DD_TEST
							printf("WdwDDstry(%c%c%c%c): %d\n", ext[0], ext[1], ext[2], ext[3], res);
		#endif
						}
						else
							res=DD_EXT;
						if (res == DD_OK)
						{
							durchl=1;
							/* Daten holen */
							data = NULL;
							wr->ddReadData(wr->wdw, wr->special, &data, idx);
							if (data != NULL)
							{
								/* Daten schreiben in pipe */
								Fwrite(fd, size, data);
								/* Speicher freigeben */
								SFREE(data);
	
								/* now wait for a response */
								fdmask = 1L << fd;
								/* wait a little bit before closing the pipe */
								(_VOID)Fselect(100, &fdmask, 0L, 0L);
							} else
							{
								/* Fehler beim holen der Daten, abbrechen */
								res = DD_NAK;
							}
						} else
						{
							++idx;
							if (res != DD_NAK && !wr->ddGetHeader(wr->wdw, wr->special, idx, ext, name, sizeof(name), &size))
							{
								/* DD_EXT or DD_LEN, aber kein weiterer Header, also abbrechen */
								res = DD_NAK;
							}
						}
					} while (res != DD_OK && res != DD_NAK);
				}
			}
			/* Pipe wieder schliessen */
			WdwDDclose(fd, &oldPipe);
			return TRUE;
		}
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID windowTerm(_VOID)
{
	WINDOW_DEF *wdw, *dummy;

	wdw = windows;
	while (wdw != NULL)
	{
		if (wdw->hdlClose != FUNK_NULL)
			wdw->hdlClose(wdw->wdw, wdw->vdi, wdw->special, TRUE);
		/* Fenster noch schliessen */
		if (!wdw->isHidden)
			wind_close(wdw->wdw);
		wind_delete(wdw->wdw);
		WdwManager_WindowIsClosed(wdw->wdw);
		/* Workstation schliessen */
		if (wdw->vdi > 0)
			CloseWorkstation(&wdw->vdi);
		dummy = wdw;
		wdw = wdw->next;
		OFREE(dummy);
	}
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID WdwManager_EnableIconify(_BOOL enable)
{
	iconifySupportEnabled = enable;
}

/*** ---------------------------------------------------------------------- ***/

/* Setzt den Handler fuer Fensterwechsel */
GLOBAL handleNewTopProc WdwManager_SetHandleNewTop(handleNewTopProc proc)
{
	handleNewTopProc old;
	
	old = handleNewTop;
	handleNewTop = proc;
	return old;
}

/*** ---------------------------------------------------------------------- ***/

/* Setzt den Handler fuer Ereignisse */
GLOBAL handleEventProc WdwManager_SetHandlePostEvent(handleEventProc proc)
{
	handleEventProc old;
	
	old = handlePostEvent;
	handlePostEvent = proc;
	return old;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID WdwManager_Snapshot(HWND wdw)
{
	_WORD apid;

	apid = appl_locate("SNAPSHOT", FALSE);
	if (apid >= 0)
		Protokoll_Send(apid, 200, wdw, 0, 0, 0, 0);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID WdwManager_Init(_VOID)
{
	iconifySupportEnabled = FALSE;
	/* Init Window Queue */
	InitQueue();
	/* Init der anderen Variablen */
	windows = NULL;
	/* Term-Proc anmelden */
	InstallTermproc(windowTerm);
	/* globale Prozeduren initialisieren */
	handleNewTop = FUNK_NULL;				    /* Siehe Kommentar zu Typ */
	handlePostEvent = FUNK_NULL;                /* Siehe Kommentar zu Typ */
	handleGlobalKey = FUNK_NULL;
	handleGlobalMess = FUNK_NULL;
	onlyOneTop = -1;
	fontApid = -1;
	iconHdl = NULL;
	allIconified = FALSE;
	globalMenu = NULL;
	disableCounter = 0;
	menuDisabled = FALSE;
}

