/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 *
 * 10.4.04 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.35l'
 *	Beim Reaktivieren eines Eingabefeldes funktionierte 
 *	dies teils erst beim 2. Aufruf
 */


#include <windials.h>
#include <mtdials.h>
#include <mtutils.h>
#include <mtappl.h>
#include <mtalerts.h>
#include <routinec.h>
#include <routines.h>
#include <wdwmanag.h>
#include <tos.h>
#include <portvdi.h>
#include <ro_mem.h>
#include <mtrsc.h>
#include <catlib.h>


typedef struct _WinDial WinDial;
struct _WinDial {
	OBJECT *tree;
	HWND wdw;
	wdSetProc hdlSet;
	wdSetProc hdlGet;
	wdButtonProc hdlBut;
	wdMessageProc hdlMsg;		/*DYJ 4.18zk */
	wdDrawProc hdlDraw;
	_VOID *env;
	_BOOL modal;
	GRECT docpos;
	_BYTE oldFrame;
	_WORD titleObj;
	_BOOL wasOutl;
	_BOOL editable;
	_BOOL cursorDa;
	_WORD pos;
	_WORD edit;
	_WORD exit;
	_WORD start;
	_WORD depth;  /* Fuer Redraw von einzelnen Objekten */
	WinDial *next;
	WinDial *prev;
};


LOCAL WinDial *dials;
_BOOL WinDialExit;
/*DYJ  Ende; alt:
LOCAL _BOOL dialExit;
*/

LOCAL _WORD dialReturn;
LOCAL CONST _UBYTE *apName = "";
LOCAL _BOOL winAlerts = FALSE;
LOCAL DialDoProc originalDialDo;

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

/* Interface-Prozeduren zum WindowManager */

LOCAL _VOID winDialDraw(HWND wdw,HVDI vdiH, _VOID *special, CONST GRECT *clip)
{
	WinDial *dial;
	_WORD oldPos;
	GRECT cr;
	_BOOL cursorWarDa;

	UNUSED(vdiH);
	dial = special;
	cr = *clip;
	AbsRect(&cr);
	cursorWarDa = dial->cursorDa;
	if (dial->editable && (theTopWindow == wdw) && dial->cursorDa)
	{
		oldPos=dial->pos;
		WdwManager_SetClip(PrivateWS, &cr, FALSE);
		mtDials_ObjcEdit(dial->tree, dial->edit, &dial->pos, 0, ED_END);
		dial->cursorDa = FALSE;
		vs_clip(PrivateWS, FALSE, (_WORD *)&cr);
	}
	mtDials_DialDraw(dial->tree, dial->start, dial->depth, clip, TRUE);
	if (dial->hdlDraw != FUNK_NULL)
		dial->hdlDraw(dial->tree, dial->env, clip);
	if (dial->editable && (theTopWindow == wdw) && !dial->cursorDa && cursorWarDa)
	{
		WdwManager_SetClip(PrivateWS, &cr, FALSE);
		mtDials_ObjcEdit(dial->tree, dial->edit, &dial->pos, 0, ED_INIT);
		dial->pos=oldPos;
		dial->cursorDa = TRUE;
		vs_clip(PrivateWS, FALSE, (_WORD *)&cr);
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL winDialTop(HWND wdw, _VOID *special)	
{
	WinDial *dial;

	dial = special;
	if (dial->editable && !dial->cursorDa && !WdwManager_WindowIsShaded(wdw))
	{
		mtDials_ObjcEdit(dial->tree, dial->edit, &dial->pos, 0, ED_INIT);
		dial->cursorDa = TRUE;
	}
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID winDialUntop(HWND wdw, _VOID *special)
{
	WinDial *dial;

	dial = special;
	if (dial->editable && dial->cursorDa && !WdwManager_WindowIsShaded(wdw))
	{
		mtDials_ObjcEdit(dial->tree, dial->edit, &dial->pos, 0, ED_END);
		dial->cursorDa = FALSE;
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID winDialHide(HWND wdw, _VOID *special, _BOOL hide)	
{
	UNUSED(wdw);
	UNUSED(special);
	UNUSED(hide);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID winDialGetArea(HWND wdw, HVDI vdi, _VOID *special, GRECT *work)
{
	WinDial *dial;
	GRECT obr;

	UNUSED(wdw);
	UNUSED(vdi);
	dial = special;
	/* Objectposition anpassen an neuen Workbereich */
	ObjcArea(dial->tree, ROOT, &obr);
	obr.g_x = work->g_x - dial->docpos.g_x;
	obr.g_y = work->g_y - dial->docpos.g_y;
	SetObjcRect(dial->tree, 0, &obr);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID RestoreWinDial(WinDial *wd)
{
	_WORD extyp1;
	_WORD typ;

	if (wd->wasOutl)
	{
		SetObjState(wd->tree, ROOT, OUTLINED);
		OBSPEC_SET_FRAMESIZE(wd->tree[ROOT].ob_spec, wd->oldFrame);
	}
	mtDials_GetObjcExtype(wd->tree, 1, &extyp1, &typ);
	if (extyp1 == MoveBox)
	{
		/* Objekte nicht mehr verstecken */
		DelObjFlags(wd->tree, 1, HIDETREE);
		if (wd->titleObj > 0)
			DelObjFlags(wd->tree, wd->titleObj, HIDETREE);
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL winDialClose(HWND wdw,HVDI vdiH, _VOID *special, _BOOL force)
{
	WinDial *dial;
	_BOOL exitDial;
	_WORD undo;
	
	UNUSED(wdw);
	UNUSED(vdiH);
	dial = special;
	if (!force)
	{
		if (dial->exit >= 0)
		{
			/* Dann stecken wir schon im Button-Handler */
			return FALSE;
		}
 		undo = ScanFlags(dial->tree, ObjSearchType, ROOT, (UndoButton << 8) | G_BUTTON);
 		if (undo >= 0)
 		{
 			dial->exit = undo;
			exitDial = dial->hdlBut(dial->tree, dial->env, undo, 0, 0, 0, 0);
			if (!exitDial)
			{
				dial->exit = -1;
				return FALSE;
			}
		}
	}
	dial->hdlGet(dial->tree, dial->env, FALSE, dial->exit);
	/* dialogExit auf TRUE setzen */
	WinDialExit = TRUE;
	/* Dialog freigeben */
	RestoreWinDial(dial);
	mtDials_DisposeDial(dial->tree);
	/* Aus der Liste aushaengen */
	if (dial->next != NULL)
		dial->next->prev = dial->prev;
	if (dial->prev != NULL)
		dial->prev->next = dial->next;
	if (dial == dials)
		dials = dial->next;
	OFREE(dial);
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

/* Interface-Prozeduren zum WindowManager: Objectbehandlung */
/*** ------------------------------------------------------------------------ ***/
/*	LOCAL _BOOL winDialMessage(HWND wdw, _VOID *special,const _WORD *msg)		*/
/*	Messagehandler fr WinDial													*/
/*	Parameter:	wdw:	das Fenster												*/
/*				special:das WinDial												*/
/*				msg:	die Message wie si von evnt_multi kommt					*/
/*	Ergebnis:	TRUE falls Messge abgearbeitet wurde							*/		
/*	24.10.00 von Dimitri Junker	DYJ 4.18zk										*/
/*** ------------------------------------------------------------------------ ***/
LOCAL _BOOL winDialMessage(HWND wdw, _VOID *special,const _WORD *msg)
{
	WinDial *dial;

	UNUSED(vdi);
	if (wdw != theTopWindow)
		return FALSE;
	if (WdwManager_WindowIsShaded(wdw))
		return FALSE;
	dial = special;
	if(dial->hdlMsg)
		return dial->hdlMsg(dial->tree, dial->env, msg);
	else
		return FALSE;
}

LOCAL _BOOL winDialButton(HWND wdw, _VOID *special, _WORD mx, _WORD my, _UWORD kstate, _UWORD buttons, _WORD clicks)	
{
	WinDial *dial;
	_BOOL exitDial;
	_WORD entry;
	_UBYTE scan;
	_WORD taste;

	if (wdw != theTopWindow)
		return FALSE;
	if (WdwManager_WindowIsShaded(wdw))
		return FALSE;
	buttons &= MOB_LEFT;  /* rechte Taste brauchen wir nicht */
	entry = -1;
	taste = 0;
	scan = 0;
	dial = special;
	if (mtDials_HandleEvent(MU_BUTTON,
		mx, my,
		&buttons, &taste, &kstate, &scan,
		&clicks, dial->tree, dial->editable, &dial->edit,
		&dial->pos, &entry))
	{
		if (clicks > 1)
		{
			entry |= 0x8000;
		}
		dial->exit = entry;
		if (dial->editable && dial->cursorDa)
		{
			mtDials_ObjcEdit(dial->tree, dial->edit, &dial->pos, 0, ED_END);
			dial->cursorDa = FALSE;
		}
		exitDial = dial->hdlBut(dial->tree, dial->env, entry, mx, my, kstate, clicks);
		if (dial->editable && !dial->cursorDa)
		{
			mtDials_ObjcEdit(dial->tree, dial->edit, &dial->pos, 0, ED_INIT);
			dial->cursorDa = TRUE;
		}
		if (exitDial && dial->editable)
		{
			if (dial->cursorDa)
				mtDials_ObjcEdit(dial->tree, dial->edit, &dial->pos, 0, ED_END);
			dial->cursorDa = FALSE;
		}
		if (exitDial)
			WdwManager_CloseWindow(dial->wdw, TRUE);
		else
			/* Exitbutton zuruecksetzen */
			dial->exit = -1;
		/* An Windowmanager zurueckgeben, dass wir den behandelt haben */
		return TRUE;
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL winDialKey(HWND wdw, _VOID *special, _WORD taste, _UBYTE key, _UBYTE scan, _UWORD kstate)	
{
	WinDial *dial;
	_BOOL exitDial;
	_WORD entry;
	_WORD mx, my;
	_WORD clicks;
	_UBYTE sc;
	_UWORD buts;

	UNUSED(key);
	if (wdw != theTopWindow)
		return FALSE;
	if (WdwManager_WindowIsShaded(wdw))
		return FALSE;
	dial = special;
	entry = -1;
	buts = 0;
	clicks = 0;
	mx = 0;
	my = 0;
	sc = scan;
	if (mtDials_HandleEvent(MU_KEYBD,
		mx, my,
		&buts, &taste, &kstate, &sc,
		&clicks, dial->tree, dial->editable, &dial->edit,
		&dial->pos, &entry))
	{
		dial->exit = entry;
		if (dial->editable && dial->cursorDa)
		{
			mtDials_ObjcEdit(dial->tree, dial->edit, &dial->pos, 0, ED_END);
			dial->cursorDa = FALSE;
		}
		exitDial = dial->hdlBut(dial->tree, dial->env, entry, mx, my, kstate, clicks);
		if (dial->editable && !dial->cursorDa)
		{
			mtDials_ObjcEdit(dial->tree, dial->edit, &dial->pos, 0, ED_INIT);
			dial->cursorDa = TRUE;
		}
		if (exitDial && dial->editable)
		{
			if (dial->cursorDa)
				mtDials_ObjcEdit(dial->tree, dial->edit, &dial->pos, 0, ED_END);
			dial->cursorDa = FALSE;
		}
		if (exitDial)
			WdwManager_CloseWindow(dial->wdw, TRUE);
		else
			/* Exitbutton zuruecksetzen */
			dial->exit = -1;
		/* An Windowmanager zurueckgeben, dass wir den behandelt haben */
		return TRUE;
	}
	if (scan == 0x44 && (kstate & (K_SHIFT|K_CTRL|K_ALT)) == K_ALT)
		WdwManager_Snapshot(dial->wdw);
	/* An Windowmanager zurueckgeben, ob wir den behandelt haben.
	 * Wenn durch den Tastendruck nur ein Object selektiert wurde,
	 * dann wird entry auf diesen Eintrag gesetzt
	 */
	return entry > 0 || dial->modal;
}

/*** ---------------------------------------------------------------------- ***/

/* Positioniert den Dialog und holt den Titel
 */
LOCAL _VOID PrepareWinDial(WinDial *wd, GRECT *work, _UBYTE *name, size_t namesize)
{
	_WORD extyp1;
	_WORD extyp2;
	_WORD typ;
	GRECT obr;
#define CutHeight 24    /* abzuschneidendes oberes Stueck (Flyer und Titel) */

	/* Outlined abschalten und Rand auf 1 Pixel setzen */

	wd->wasOutl = GetObjState(wd->tree, ROOT, OUTLINED);
	if (wd->wasOutl)
	{
		DelObjState(wd->tree, ROOT, OUTLINED);
		wd->oldFrame = OBSPEC_GET_FRAMESIZE(wd->tree[ROOT].ob_spec);
		OBSPEC_SET_FRAMESIZE(wd->tree[ROOT].ob_spec, -1);
	}

	mtDials_DialCenter(wd->tree, CSCREEN, 0, 0, work);
	ObjcArea(wd->tree, ROOT, work);
	wd->docpos = *work;
	wd->docpos.g_x = 0;

	/* Haben wir einen Flyer und einen Titel?
	* Dann sollten wir den oberen Rand abschneiden */
	wd->titleObj = 0;
	extyp2 = 0;
	if (!GetObjFlags(wd->tree, 2, HIDETREE))
	{
		mtDials_GetObjcExtype(wd->tree, 2, &extyp2, &typ);
		if (extyp2 == SpecText)
			wd->titleObj = 2;
	}
	if (wd->titleObj == 0)
	{
		if (!GetObjFlags(wd->tree, 3, HIDETREE))
		{
			mtDials_GetObjcExtype(wd->tree, 3, &extyp2, &typ);
			if (extyp2 == SpecText)
				wd->titleObj = 3;
		}
	}
	mtDials_GetObjcExtype(wd->tree, 1, &extyp1, &typ);
	if ((extyp1 == MoveBox && extyp2 == SpecText) ||
		(extyp2 == MoveBox && extyp1 == SpecText))
	{
		/* oberen Rand abschneiden (Flyer und Titel) */
		wd->docpos.g_y = (CharHeight * 2) ; /* CutHeight; */
	} else
	{
		/* Finger davon, solange kein Titel und Flyer da sind */
		wd->docpos.g_y = 0;
	}

	work->g_h -= wd->docpos.g_y;   /* abgeschnittenen Rand von Flaeche abziehen */
	work->g_y += wd->docpos.g_y / 2;   /* Nochmal zentrieren */

	/* Objectposition anpassen an neuen Workbereich */
	ObjcArea(wd->tree, ROOT, &obr);
	obr.g_x = work->g_x - wd->docpos.g_x;
	obr.g_y = work->g_y - wd->docpos.g_y;

	SetObjcRect(wd->tree, ROOT, &obr);

	if (wd->titleObj > 0)
	{
		ObjcString(wd->tree, wd->titleObj, name, namesize);
	} else
	{
		*name = '\0';      /* Kein Name, uebergebenen Namen nehmen */
	}
	/* Leerzeichen abschneiden */
	strdelRightSpace(name);
	strleft(name);
	if (extyp1 == MoveBox || extyp1 == SpecText)
	{
		/* Objekte verstecken */
		SetObjFlags(wd->tree, 1, HIDETREE);
		if (wd->titleObj > 0)
		{
			SetObjFlags(wd->tree, wd->titleObj, HIDETREE);
		}
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL WinDial *FindWinDial(OBJECT *tree)
{
	WinDial *dial;

	for (dial = dials; dial != NULL; dial = dial->next)
		if (dial->tree == tree)
			return dial;
	return NULL;
}
/*** ---------------------------------------------------------------------- ***/

/* Erzeugt einen Dialog im Fenster.
 * Wenn der Dialog schon in einem Fenster ist, dann
 * wird er getoppt.
 * Ansonsten wird ein neues Fenster angelegt, setValues aufgerufen,
 * um die Werte zu setzen, und dann wird das Fenster geoeffnet und
 * angezeigt. Falls der Dialog modal ist, wird das Menu
 * disablet.
 * False: Fensterdialog konnte nicht angelegt werden
 */
/*DYJ 5.21b */
GLOBAL _BOOL WinDials_OpenWinDial(
	OBJECT *tree,
	_BOOL isModal,
	wdSetProc setValues,
	wdSetProc getValues,
	wdButtonProc button,
	wdDrawProc draw,
	CONST _UBYTE *title,
	_VOID *env)
{
	GRECT work;
	GRECT wdwCurr;
	GRECT obr;
	_UWORD comps;
	WinDial *dial;
	_UBYTE name[80];
	_WORD dummy;
	_WORD undo;
	
	/* Suchen, ob schon WinDial vorhanden */
	dial = FindWinDial(tree);
	if (dial != NULL)
	{
		WdwManager_TopWindow(dial->wdw);
		return FALSE;
	}
	/* Noch nicht vorhanden, also neuen anlegen */
	dial = NEW(WinDial, "WinDials_OpenWinDial");
	if (dial == NULL)
		return FALSE;
	/* Neuen Dialog anlegen */
	if (!mtDials_NewDial(tree))
	{
		OFREE(dial);
		return FALSE;
	}
 	undo = ScanFlags(tree, ObjSearchFlags, ROOT, UndoButtonFlag);
 	if (undo < 0)
 		undo = ScanFlags(tree, ObjSearchType, ROOT, (UndoButton << 8) | G_BUTTON);
	if (undo >= 0)
		mtDials_SetUserkey(tree, undo, 0x16, K_CTRL, FALSE, TRUE); /* Ctrl-U */
	/* Fenster anlegen und oeffnen */
	comps = NAME | MOVER;
	if (!isModal)
		comps |= CLOSER;
	if (!WdwManager_CreateWindow(&deskSize, &work, comps,
		"", "", dial, TRUE, FALSE,
		&dial->wdw, &dummy))
	{
		mtAlerts_Alert(1, Rsc_WrkString(AL_NOWINDIAL));
		mtDials_DisposeDial(tree);
		OFREE(dial);
		return FALSE;
	}
	if (!WdwManager_SetWindowMode(dial->wdw, isModal))
	{
		mtDials_DisposeDial(tree);
		OFREE(dial);
		return FALSE;
	}
	dial->tree = tree;
	dial->hdlSet = setValues;
	dial->hdlGet = getValues;
	dial->hdlBut = button;
	dial->hdlMsg = FUNK_NULL;		
	dial->hdlDraw = draw;
	dial->modal  = isModal;
	dial->env = env;
	dial->depth = MAX_DEPTH;
	dial->start = ROOT;
	dial->exit  = -1;
	dial->titleObj = -1;

	/* Jetzt den Dialog vorbereiten, Titel und richtige Groesse setzen
	 */
	PrepareWinDial(dial, &work, name, sizeof(name));
	if (*name == '\0')
	{
		if (title != NULL)
			strBcpy(name, title);
		else
			name[0] = '\0';
		strdelRightSpace(name);
		strleft(name);
	}
	if (*name == '\0')
		strBcpy(name, apName);
	/* Jetzt die Windowspezifischen Sachen einhaengen */

	/* Ein kleiner Koordinatencheck */
	Wind_calc(WC_BORDER, comps, &work, &wdwCurr);
	wdwCurr.g_y = Max(wdwCurr.g_y, deskSize.g_y);
	Wind_calc(WC_WORK, comps, &wdwCurr, &work);

	/* Objectposition anpassen an neuen Workbereich */
	ObjcArea(dial->tree, ROOT, &obr);
	obr.g_x = work.g_x - dial->docpos.g_x;
	obr.g_y = work.g_y - dial->docpos.g_y;
	SetObjcRect(tree, ROOT, &obr);

	WdwManager_SetWdwWork(dial->wdw, &work);
	WdwManager_SetWdwTitle(dial->wdw, name);
	WdwManager_SetWindowButton(dial->wdw, winDialButton);
	WdwManager_SetWindowMessage(dial->wdw, winDialMessage);	
	WdwManager_SetWindowKey(dial->wdw, winDialKey);
	WdwManager_SetWindowDraw(dial->wdw, winDialDraw);
	WdwManager_SetWindowTop(dial->wdw, winDialTop);
	WdwManager_SetWindowUntop(dial->wdw, winDialUntop);
	WdwManager_SetWindowClose(dial->wdw, winDialClose);
	WdwManager_SetWindowHide(dial->wdw, winDialHide);
	WdwManager_SetWindowDial(dial->wdw, dial->tree);
	WdwManager_SetWindowGetScroll(dial->wdw, winDialGetArea);

	/* So, jetzt noch in Liste einhaengen */
	dial->prev = NULL;
	if (dials == NULL)
	{
		dial->next = NULL;
	} else
	{
		/* Am Anfang einhaengen */
		dial->next = dials;
		dials->prev = dial;
	}
	dials = dial;
	/* Und jetzt zeigen wir das Fenster an */
	mtDials_PrepDial(dial->tree, ROOT, &dial->editable, &dial->pos, &dial->edit);
	dial->hdlSet(dial->tree, dial->env, TRUE, -1);
	dial->cursorDa = FALSE;
	WdwManager_ShowWindow(dial->wdw);
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

/* schliesst einen Fensterdialog. getValues wird aufgerufen.
 */
GLOBAL _VOID WinDials_CloseWinDial(OBJECT *tree)
{
	WinDial *dial;

	/* Suchen, ob schon WinDial vorhanden */
	dial = FindWinDial(tree);
	if (dial != NULL)
	{
		WdwManager_CloseWindow(dial->wdw, FALSE);
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _WORD FormHandle(OBJECT *tree, _WORD edit)
{
	_WORD exit;
	GRECT r;

	if (!mtDials_NewDial(tree))
		return -1;
	Wind_Update(BEG_UPDATE);
	mtDials_DialCenter(tree, CSCREEN, 0, 0, &r);
	mtDials_DialForm(tree, DSTART, &r, &r);
	mtDials_DialDraw(tree, ROOT, MAX_DEPTH, &r, FALSE);
	if (winAlerts)
		exit = originalDialDo(tree, edit);
	else
		exit = mtDials_DialDo(tree, edit);
	exit &= 0x7fff;
	mtDials_DialForm(tree, DFINISH, &r, &r);
	DelObjState(tree, exit, SELECTED);
	mtDials_DisposeDial(tree);
	Wind_Update(END_UPDATE);
	return exit;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID WinDials_defDraw(OBJECT *tree, _VOID *env, CONST GRECT *clip)
{
	UNUSED(tree);
	UNUSED(env);
	UNUSED(clip);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID WinDials_defSet(OBJECT *tree, _VOID *env, _BOOL set, _WORD exitBut)
{
	UNUSED(tree);
	UNUSED(env);
	UNUSED(set);
	UNUSED(exitBut);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL defButton(OBJECT *tree, _VOID *env, _WORD obj, _WORD mx, _WORD my, _UWORD kstate, _WORD clicks)
{
	UNUSED(env);
	UNUSED(mx);
	UNUSED(my);
	UNUSED(kstate);
	UNUSED(clicks);
/*e Start*/
	if(obj==-1)
		return FALSE;
/*DYJ  Ende; */
	DelObjState(tree, obj, SELECTED);
	WinDialExit = TRUE;
	dialReturn = obj;
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID WinDials_WinDialDraw(OBJECT *tree, _WORD entry, _WORD depth, CONST GRECT *clip, _BOOL clipping)
{
	GRECT r;
	WinDial *dial;

	/* Suchen, ob schon WinDial vorhanden */
	dial = FindWinDial(tree);
	if (dial != NULL)
	{
		dial->depth = depth;
		dial->start = entry;
		if (clipping)
		{
			WdwManager_RedrawWdw(dial->wdw, clip);
		} else
		{
			CalcArea(tree, entry, &r);
			WdwManager_RedrawWdw(dial->wdw, &r);
		}
		dial->depth = MAX_DEPTH;
		dial->start = ROOT;
	} else
	{
		mtDials_DialDraw(tree, entry, depth, clip, clipping);
	}
}

/*** ---------------------------------------------------------------------- ***/

/* Durchlaeuft die Eventloop, bis das Topwindow mit dem aktuellen Dialog
 * geschlossen wird
 */
GLOBAL _VOID WinDials_WinDialHandleEvents(_VOID)
{
	_UWORD Events;
	_WORD clicks, taste, mx, my;
	_UWORD buts, kstate;
	_UWORD event;
	_WORD message[8];
	_UBYTE sc, key;

	WinDialExit = FALSE;
	dialReturn = -1;

	WdwManager_DisableMenu(NULL, TRUE);

	Events = MU_KEYBD | MU_BUTTON | MU_MESAG;

	Wind_Update(END_UPDATE);
	do
	{
		event = evnt_multi(Events,
			2, 1, 1,
			0, 0, 0, 0, 0,
			0, 0, 0, 0, 0,
			message,
			0, 0,             /* Timerdauer      */
			&mx, &my,           /* Maus-Position   */
			&buts,             /* Maus-Buttons    */
			&kstate,           /* Shift-state     */
			&taste,            /* gedrueckte Taste */
			&clicks);          /* Klick-Anzahl    */
		sc = (taste >> 8) & 0xff;
		key = taste & 0xff;
		Wind_Update(BEG_UPDATE);
		WdwManager_HandleEvent(&event, message, buts, kstate, key, sc,
		          taste, mx, my, clicks);
		Wind_Update(END_UPDATE);
	} while (!WinDialExit);
	WinDialExit = FALSE;
	Wind_Update(BEG_UPDATE);
	WdwManager_DisableMenu(NULL, FALSE);
}

/*** ---------------------------------------------------------------------- ***/

/* Fuehrt einen kompletten modalen Fensterdialog durch. Es wird
 * der Button zurueckgegeben, mit dem der Dialog verlassen wurde.
 * Wenn kein Fenster mehr frei ist, wird ein normaler Dialog gezeichnet
 */
GLOBAL _WORD WinDials_WinDialDo(OBJECT *tree, _WORD edit)
{
	if (!WinDials_OpenWinDial(tree,
		TRUE,
		WinDials_defSet,
		WinDials_defSet,
		defButton,
		WinDials_defDraw, NULL, NULL))
	{
		/* normalen Dialog durchfuehren */
		return FormHandle(tree, edit);
	}
	WinDials_WinDialHandleEvents();
	return dialReturn;
}

/*** ---------------------------------------------------------------------- ***/

/* Fragt nach, ob das Fenster wdw ein Fensterdialog ist
 */
GLOBAL _BOOL WinDials_WinDialIsTop(HWND wdw)
{
	WinDial *dial;

	for (dial = dials; dial != NULL; dial = dial->next)
		if (dial->wdw == wdw)
			return TRUE;
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID WinDials_SetApplicationName(CONST _UBYTE *name)
{
	apName = name;
}

/*** ---------------------------------------------------------------------- ***/

/* Setzt den Cursor in ein neues Editfeld bzw. teilt dem Modul
 * mit, dass sich der Text geaendert hat und dass der Cursor neu plaziert
 * werden soll. edit == -1: Nur Cursor neu plazieren.
 */
GLOBAL _VOID WinDials_WinEditChanged(OBJECT *tree, _WORD edit)
{
	WinDial *dial;
	_BOOL cursorWarDa;

	/* Suchen, ob schon WinDial vorhanden */
	dial = FindWinDial(tree);
	if (dial != NULL)
	{
		mtDials_PrepDial(dial->tree, ROOT, &dial->editable, &dial->pos, &dial->edit);	/*DYJ 5.35l */
		/* if (dial->editable) */
		{
			cursorWarDa = dial->cursorDa;
			if (dial->cursorDa && dial->editable)
			{
				mtDials_ObjcEdit(dial->tree, dial->edit, &dial->pos, 0, ED_END);
				dial->cursorDa = FALSE;
			}
			if (edit >= 0)
			{
				mtDials_PrepDial(dial->tree, edit, &dial->editable, &dial->pos, &dial->edit);
			} else if (dial->editable && dial->edit >= 0)
			{
				mtDials_PrepDial(dial->tree, dial->edit, &dial->editable, &dial->pos, &dial->edit);
			}
			dial->pos = -1;
			if (cursorWarDa && dial->editable)
			{
				mtDials_ObjcEdit(dial->tree, dial->edit, &dial->pos, 0, ED_INIT);
				dial->cursorDa = TRUE;
			}
		}
	}
}
GLOBAL _VOID WinDials_ShowCurs(OBJECT *tree,_BOOL showIt)
{
	WinDial *dial;
	/* Suchen, ob schon WinDial vorhanden */
	dial = FindWinDial(tree);
	if (dial != NULL)
	{
		dial->cursorDa=showIt;
		dial->editable=showIt;
		if(showIt)
			mtDials_ObjcEdit(dial->tree, dial->edit, &dial->pos, 0, ED_INIT);
		else
			mtDials_ObjcEdit(dial->tree, dial->edit, &dial->pos, 0, ED_END);
		
	}
}

/*** ------------------------------------------------------------------------ ***/
/*	GLOBAL _WORD WinDials_GetCursObj(OBJECT *tree)								*/
/*	Gibt das Objekt zurck in dem der Cursor gerade ist							*/
/*	Parameter:	tree:	das Formular											*/
/*	Ergebnis:	>=0:	das Objekt												*/		
/*				<0: Fehler														*/
/*	22.2.01 von Dimitri Junker	DYJ 4.23h										*/
/*** ------------------------------------------------------------------------ ***/
GLOBAL _WORD WinDials_GetCursObj(OBJECT *tree)
{
	WinDial *dial;
	_WORD ret=-1;
	/* Suchen, ob schon WinDial vorhanden */
	dial = FindWinDial(tree);
	if (dial != NULL)
		ret=dial->edit;
	return ret;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID WinDials_WinUpdateTitle(OBJECT *tree)
{
	WinDial *dial;
	_UBYTE name[80];

	/* Suchen, ob schon WinDial vorhanden */
	dial = FindWinDial(tree);
	if (dial != NULL)
	{
		if (dial->titleObj >= 0)
		{
			ObjcString(tree, dial->titleObj, name, sizeof(name));
			strdelRightSpace(name);
			strleft(name);
			WdwManager_SetWdwTitle(dial->wdw, name);
		}
	}
}

/*** ---------------------------------------------------------------------- ***/

/* Fragt nach, ob der Dialog schon in einem Fenster ist
 */
GLOBAL HWND WinDials_IsWinDial(OBJECT *tree)
{
	WinDial *dial;

	dial = FindWinDial(tree);
	if (dial != NULL)
		return dial->wdw;
	return -1;
}

/*** ---------------------------------------------------------------------- ***/

/* Aktiviert den Window-Dialog, falls vorhanden
 */
GLOBAL _VOID WinDials_ActivateWinDial(OBJECT *tree)
{
	WinDial *dial;

	dial = FindWinDial(tree);
	if (dial != NULL)
		WdwManager_TopWindow(dial->wdw);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID WinDials_AlertsInWindow(_BOOL doIt)
{
	if (doIt && !winAlerts)
	{
		originalDialDo = mtDials_OverloadDialDo(WinDials_WinDialDo);
		winAlerts = TRUE;
	} else if (doIt == FALSE && winAlerts)
	{
		winAlerts = FALSE;
		originalDialDo = mtDials_OverloadDialDo(FUNK_NULL);
	}
}
/*** ------------------------------------------------------------------------ ***/
/*	GLOBAL _VOID WinDials_SetMessage(OBJECT *tree,wdMessageProc message)		*/
/*	Setzt den Messagehandler													*/
/*	Parameter:	tree	das Formular											*/
/*				message:der Handler												*/
/*	Ergebnis:	keines															*/		
/*	24.10.00 von Dimitri Junker	DYJ 4.18zk										*/
/*** ------------------------------------------------------------------------ ***/
GLOBAL _VOID WinDials_SetMessage(OBJECT *tree,wdMessageProc message)
{
	WinDial *dial;

	dial = FindWinDial(tree);
	if (dial != NULL)
		dial->hdlMsg = message;
}
