/*      LIMITS.H

        Sizes of integral types

        Copyright (c) Borland International 1990
        All Rights Reserved.
*/


#if !defined( __LIMITS_H__ )
#define __LIMITS_H__

#define  CHAR_BIT            8
#define  SCHAR_MIN       (-128)
#define  SCHAR_MAX         127
#define  UCHAR_MAX         255U
#if ('\x80' < 0)
#define  CHAR_MIN        (-128)
#define  CHAR_MAX          127
#else
#define  CHAR_MIN          0
#define  CHAR_MAX          255
#endif
#define  MB_LEN_MAX          1
#define  SHRT_MIN      (-32767-1)
#define  SHRT_MAX        32767
#define  USHRT_MAX       65535U
#define  INT_MIN       (-32767-1)
#define  INT_MAX         32767
#define  UINT_MAX        65535U
#define  LONG_MIN (-2147483647L-1)
#define  LONG_MAX   2147483647L
#define  ULONG_MAX  4294967295LU

#ifdef EMUL_UNIX
#define	ARG_MAX		5120		/* max length of arguments to exec */
#define	LINK_MAX	1000		/* max # of links to a single file */
#ifndef MAX_CANON
#define MAX_CANON	256		/* max bytes in a line for canoical proccessing */
#endif /* MAX_CANON */
#ifndef MAX_INPUT
#define	MAX_INPUT	512		/* max size of a char input buffer */
#endif /* MAX_INPUT */
#define NGROUPS_MAX	16		/* max number of groups for a user */
#ifndef PATH_MAX
#define	PATH_MAX	119		/* max # of characters in a path name */
#endif /* PATH_MAX */
#define	PIPE_BUF	5120		/* max # bytes atomic in write to a pipe */
#ifndef TMP_MAX
#define TMP_MAX		100
#endif /* TMP_MAX */

#define	PASS_MAX	8		/* max # of characters in a password */

#define	NL_ARGMAX	9		/* max value of "digit" in calls to the
					 * NLS printf() and scanf() */
#define	NL_LANGMAX	14		/* max # of bytes in a LANG name */
#define	NL_MSGMAX	32767		/* max message number */
#define	NL_NMAX		1		/* max # of bytes in N-to-1 mapping characters */
#define	NL_SETMAX	255		/* max set number */
#define	NL_TEXTMAX	255		/* max set number */
#define	NZERO		20		/* default process priority */

#define	WORD_BIT	16		/* # of bits in a "word" or "int" */
#define	LONG_BIT	32		/* # of bits in a "long" */

#ifndef DBL_DIG
# define  DBL_DIG                              19	/* digits of precision of a "double" */
# define  DBL_MIN      1.681051571556046753E-4932	/* min decimal value of a "double" */
# define  DBL_MAX      1.189731495357231765E+4932	/* max decimal value of a "double" */
# define  FLT_DIG                         6	/* digits of precision of a "float" */
# define  FLT_MIN              1.175494E-38	/* min decimal value of a "float" */
# define  FLT_MAX              3.402823E+38	/* max decimal value of a "float" */
#endif /* DBL_DIG */

#define	FCHR_MAX	1048576		/* max size of a file in bytes */
#define	PID_MAX		30000		/* max value for a process ID */
#define	CHILD_MAX	25		/* max # of processes per user id */
#define	NAME_MAX	12		/* max # of characters in a file name */

#define	OPEN_MAX	32		/* max # of files a process can have open */
#define	PIPE_MAX	5120		/* max # bytes written to a pipe in a write */

#define	STD_BLK		1024		/* # bytes in a physical I/O block */
#define	UID_MAX		60002		/* max value for a user or group ID */
#define	USI_MAX		65535	/* max decimal value of an "unsigned" */
#define	SYSPID_MAX	1		/* max pid of system processes */

#ifndef CLK_TCK
#define CLK_TCK	200			/* 3B2 clock ticks per second */
#endif /* CLK_TCK */

#define LOGNAME_MAX	8		/* max # of characters in a login name */

#endif /* EMUL_UNIX */
#endif /* __LIMITS_H__ */

/************************************************************************/

