/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */


#ifndef __PUTZ_PUTZACTION_H__
#define __PUTZ_PUTZACTION_H__

#ifndef __PORTAB_H__
#include <portab.h>
#endif

#ifndef __PORTAES_H__
#include <portaes.h>
#endif

#include <cat_vb.h>

/* In diesem Modul laufen die Ausgaben des Putzes zusammen
 * Es wird ein Dialog in einem Fenster dargestellt, und
 * die Ausgaben werden ueber die Rechteckliste mit den
 * get&set-Modus von wind_update gemacht
 */

_VOID PutzAction_InitActionBox(_VOID);
/* Initialisiert die Box, bringt das Fenster auf den Bildschirm
 */

_VOID PutzAction_ReInitActionBox(CONST _UBYTE *grName, _ULONG msgCount);
/* Init der Action-Box: Es werden alle notwendigen festen Strings berechnet,
 * die variablen Strings werden geloescht und die Box wird gezeichnet.
 * Der Prozentbalken wird auf 0% gesetzt und auch gezeichnet
 */

_VOID PutzAction_BeginNextPass(_WORD mode);
/* Reinitialisiert die Box nochmals, stellt Zaehler wieder auf 0,
 * und zeigt naechsten Modus an.
 */

_VOID PutzAction_ShowBuffStatus(_BOOL tabBuff, _BOOL parBuff, _BOOL datBuff, _BOOL waiBuff);
/* Zeigt den Pufferungsstatus in der Box an
 */

_VOID PutzAction_ReleaseActionBox(_VOID);
/* Gibt die Boxu nd das Fenster wieder frei
 */

_BOOL PutzAction_TellAction(_WORD actMode, _ULONG msgCount);
/* Hauptprozedur, zeigt neuen Stand im Fenster an
 */

_VOID PutzAction_InitModule(OBJECT *tree);
/* Muss am Anfang aufgerufen werden, damit das Modul die Adresse
 * des Baumes hat
 */


#endif /* __PUTZ_PUTZACTION_H__ */
