/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */


#ifndef __PUTZ_PUTZTYPES_H__
#define __PUTZ_PUTZTYPES_H__

#ifndef __PORTAB_H__
#include <portab.h>
#endif

#ifndef __CAT_DATASYS_H__
#include <datasys.h>
#endif

#ifndef __CAT_GROUPSELECT_H__
#include <groupsel.h>
#endif

#ifndef __MOS_LISTS_H__
#include <lists.h>
#endif


#define parameterFile    "catputz.cfg"
#define CATPUTZ_HELPFILE "catputz.hlp"
#define CATPUTZ_HELPIDX  "putzhelp.idx"
#define CATPUTZ_LOGNAME  "catputz.log"
#define CATPUTZ_HYPNAME  "catputz.hyp"
/*DYJ 5.22a Start*/
#define CATP_RSC_BASE	"cput_"
/*DYJ  Ende; alt:	
#define RscName          "catputz.rsc"
#define RscName2         "catputz2.rsc"
*/

typedef _UBYTE MaxStr[256];


typedef struct parFileType {
	FileHeaderType dbHeader;
	pBlock params[1];
} parFileType;


typedef enum {
	justLeft, justCenter, justRight
} TextJustification;

typedef enum {
	ignoreFlag, noDel, partDel, totalDel, badMess
} delState;

typedef enum {
	PutzTypes_dFlags,
	PutzTypes_dNum,
	PutzTypes_dDate,
	PutzTypes_dDateAndNum
} delMode;

/*param: */
/*  idx: */
/* pass: */
typedef delState (*deleteProc)(pBlock *param, MSGNR idx, _WORD pass);


typedef _UBYTE groupName[256];
enum {GRP_NOTH,GRP_ERR,GRP_DONE};

typedef struct grListEntry {
	group *info;
	_BOOL selected;
	_ULONG badDel;
	_ULONG totalDel;
	_ULONG partDel;
	_ULONG preMsgs;
	_ULONG postMsgs;
	_ULONG preBytes;
	_ULONG postBytes;
	_BOOL tabDa;
	_BOOL parDa;
	_BOOL datDa;
	_BYTE status;
} grListEntry;


typedef struct putzOptsRec {
	delState intFlag;
	delState usrFlg1;
	delState usrFlg2;
	delState readFlg;
	delState filtFlg;
	delState noRdFlg;
	delState noAnsFlg;	/*DYJ 5.36g */
	_BOOL deleteByDate;
	_UBYTE dateStr[21];
	_ULONG delDate;
	_BOOL useTmp;
	_BOOL tmpLock;		/* festen Tmp-Pfad!! */
	_BOOL delWithoutComm;	/* Teilgeloeschte ohne Kommentar loeschen */
	_BOOL deselAfterDel;	/* Gruppe nach Loeschen deselektiern */
	_UBYTE tmpDir[PATH_MAX];
	delMode dMode;
	MSGNR number;
} putzOptsRec;


typedef enum {
	listHead1,
	listHead2,
	dataEntry,
	separatorLine
} putzlistEntryType;

typedef struct displayListEntry {
	putzlistEntryType type;
	grListEntry *data;
} displayListEntry, *ptrDispEntry;


extern putzOptsRec defaultOpts;

extern grListEntry totalEntry;

extern _UBYTE tmpPath[PATH_MAX];

extern List putzList;   /* Eigene Liste mit allen Daten */

extern List groupList;   /* Liste der Gruppen aus GroupSelect */

extern List displayList;   /* Liste fuer die Anzeige */

#endif /* __PUTZ_PUTZTYPES_H__ */
