/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */


#include <putzacti.h>
#ifndef __CAT_CATGLOBAL_H__
#include <catgloba.h>
#endif
#include <wdwmanag.h>
#include <mtdials.h>
#include <mtappl.h>
#include <mtutils.h>
#include <mtalerts.h>
#include <catputz.h>

#include <routinec.h>
#include <putzrsc.h>	/*DYJ 5.23g */



/* In diesem Modul laufen die Ausgaben des Putzes zusammen
 * Es wird ein Dialog in einem Fenster dargestellt, und
 * die Ausgaben werden ueber die Rechteckliste mit den 
 * get&set-Modus von Wind_Update gemacht
 */

#define spaceStr "                         "


LOCAL _BOOL inWindow;
LOCAL HWND wdwHandle;
LOCAL handleNewTopProc oldNewTop;
LOCAL OBJECT *actBox;
LOCAL GRECT rect;


/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/
LOCAL _BOOL bProc(HWND wdw, _VOID *special, _WORD mx, _WORD my, _UWORD kstate, _UWORD buttons, _WORD clicks)
{
	UNUSED(wdw);
	UNUSED(special);
	UNUSED(mx);
	UNUSED(my);
	UNUSED(kstate);
	UNUSED(buttons);
	UNUSED(clicks);
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL kProc(HWND wdw, _VOID *special, _WORD taste, _UBYTE key, _UBYTE scan, _UWORD kstate)
{
	UNUSED(wdw);
	UNUSED(special);
	UNUSED(taste);
	UNUSED(key);
	UNUSED(scan);
	UNUSED(kstate);
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL closeP(HWND wdw, HVDI vdi, _VOID *special, _BOOL force)
{
	UNUSED(wdw);
	UNUSED(vdi);
	UNUSED(special);
	return force;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL topP(HWND wdw, _VOID *special)
{
	UNUSED(wdw);
	UNUSED(special);
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID untopP(HWND wdw, _VOID *special)
{
	UNUSED(wdw);
	UNUSED(special);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID setWork(HWND wdw, _VOID *special, CONST LGRECT *doc, _BOOL slided)
{
	UNUSED(wdw);
	UNUSED(special);
	UNUSED(doc);
	UNUSED(slided);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID getRect(HWND wdw, HVDI vdi, _VOID *special, GRECT *work)
{
	UNUSED(wdw);
	UNUSED(vdi);
	UNUSED(special);
	rect = *work;
	actBox[ROOT].ob_x = work->g_x;
	actBox[ROOT].ob_y = work->g_y;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID redrawInfo(HWND wdw, HVDI vdi, _VOID *special, CONST GRECT *clip)
{
	UNUSED(wdw);
	UNUSED(vdi);
	mtDials_DialDraw(special, ROOT, MAX_DEPTH, clip, TRUE);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID updateP(HWND wdw, _VOID *special, _BOOL begin)	
{
	UNUSED(wdw);
	UNUSED(special);
	if (begin)
	{
		Wind_Update(BEG_UPDATE);
	} else
	{
		Wind_Update(END_UPDATE);
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL struct {
	GRECT pFrame;
	GRECT sFrame;
	_WORD lastWidth;
	_BOOL reinit;
	_BOOL fullInit;
	_LONG Epp;
} slideVars;

LOCAL struct {
	_LONG msgTotal;
	_WORD actMode;
} actParm;

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID handleBusyMouse(_VOID)
{
	if (!multiTask || !inWindow)
		if (WdwManager_IsOwnTop())
			CatGlobal_busyMouse();
}


/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL DrawObjectInWdw(OBJECT *tree, _WORD obj, _WORD depth, CONST GRECT *r, _BOOL clip, _BOOL mouse)
{
	GRECT clipgr;
	_WORD res;
	
	if (clip)
	{
		clipgr = *r;
	} else
	{
		CalcArea(tree, obj, &clipgr);
	}
	if (inWindow)
	{
		if (multiTask)
			res = Wind_Update(BEG_UPDATE | 0x100);
		else
			res = Wind_Update(BEG_UPDATE);
		if (res == 1)
		{
			WdwManager_RedrawWdw(wdwHandle, &clipgr);
			if (mouse)
				handleBusyMouse();
			Wind_Update(END_UPDATE);
		} else
		{
			if (mouse)
				MouseArrow();
			return FALSE;
		}
	} else
	{
		mtDials_DialDraw(tree, ROOT, depth, &clipgr, clip);
	}
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID InitInfoSlider(_VOID)
{
	/* slider anpassen an charWidth und charHeight */
	ObjcRect(actBox, INFOBAR, &slideVars.pFrame);
	ObjcRect(actBox, INFOSLID, &slideVars.sFrame);
	/* Space berechnen */
	slideVars.pFrame.g_h = CharHeight;
	slideVars.sFrame.g_h = CharHeight;
	slideVars.sFrame.g_w = 1;
	slideVars.Epp = (actParm.msgTotal * 1000L) / (_LONG)(slideVars.pFrame.g_w);
	SetObjcRect(actBox, INFOBAR, &slideVars.pFrame);
	SetObjcRect(actBox, INFOSLID, &slideVars.sFrame);
	slideVars.lastWidth = 0;
	slideVars.reinit = TRUE;
	slideVars.fullInit = TRUE;
	/* Fuellstil auf Solid und Farbe setzen, falls Farbe */
	if (Bitplanes > 1)
	{
		OBSPEC_SET_FILLPATTERN(actBox[INFOSLID].ob_spec, 7);
		OBSPEC_SET_INTERIORCOL(actBox[INFOSLID].ob_spec, RED);
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID CalcInfoSlider(_LONG newValue)
{
	GRECT r;
	_WORD startOb;
	_WORD depth;

	if (slideVars.Epp > 0)
		slideVars.sFrame.g_w = (_WORD)((newValue * 1000L) / slideVars.Epp);
	else
		slideVars.sFrame.g_w = slideVars.pFrame.g_w;
	if (slideVars.sFrame.g_x + slideVars.sFrame.g_w > slideVars.pFrame.g_w)
		slideVars.sFrame.g_w = slideVars.pFrame.g_w;
	if (slideVars.sFrame.g_w <= 0)
		slideVars.sFrame.g_w = 1;
	if (slideVars.lastWidth != slideVars.sFrame.g_w || slideVars.reinit)
	{
		SetObjcRect(actBox, INFOSLID, &slideVars.sFrame);
		ObjcArea(actBox, INFOSLID, &r);
		if (!slideVars.reinit)
		{
			r.g_x = r.g_x + slideVars.lastWidth;
			r.g_w = r.g_w - slideVars.lastWidth + 1;
		} else
		{
			ObjcArea(actBox, INFOBAR, &r);
		}
		if (slideVars.fullInit)
		{
			startOb = ROOT;
			depth = MAX_DEPTH;
			ObjcArea(actBox, ROOT, &r);
		} else
		{
			startOb = INFOBAR;
			depth = 1;
		}
		if (DrawObjectInWdw(actBox, startOb, depth, &r, TRUE, ((newValue+1) % 10) == 0))
		{
			slideVars.lastWidth = slideVars.sFrame.g_w;
			slideVars.reinit = FALSE;
			slideVars.fullInit = FALSE;
		}
	}
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID PutzAction_ReInitActionBox(CONST _UBYTE *grName, _ULONG msgCount)
{
	GRECT r;
	
 	actParm.msgTotal = msgCount;
	SetObjcString(actBox, ACPUFSTA, "                                           ");
	SetObjcString(actBox, ACGRNAME, grName);
	InitInfoSlider();
	actParm.actMode = -1;
	DrawObjectInWdw(actBox, ROOT, MAX_DEPTH, &r, FALSE, TRUE);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID PutzAction_BeginNextPass(_WORD mode)
{
	GRECT r;
	_UBYTE *buf;	/*DYJ 5.23e */
	
	InitInfoSlider();
	actParm.actMode = mode;
	switch (mode)
	{
/*DYJ 5.23e Start*/
		case 0: buf=PutzRsc_WrkString(puffStr); break;
		case 1: buf=PutzRsc_WrkString(delStr); break;
		case 2: buf=PutzRsc_WrkString(linkStr); break;
		case 3: buf=PutzRsc_WrkString(copyStr); break;
		case 4: buf=PutzRsc_WrkString(chkStr); break;
		default: buf=spaceStr; break;
	}
	SetObjcStringAdr(actBox, ACMSGID, buf, sizeof(buf));
/*DYJ  Ende; alt:	
		case 0: SetObjcStringAdr(actBox, ACMSGID, puffStr, sizeof(puffStr)); break;
		case 1: SetObjcStringAdr(actBox, ACMSGID, delStr, sizeof(delStr)); break;
		case 2: SetObjcStringAdr(actBox, ACMSGID, linkStr, sizeof(linkStr)); break;
		case 3: SetObjcStringAdr(actBox, ACMSGID, copyStr, sizeof(copyStr)); break;
		case 4: SetObjcStringAdr(actBox, ACMSGID, chkStr, sizeof(chkStr)); break;
		default: SetObjcStringAdr(actBox, ACMSGID, spaceStr, sizeof(spaceStr)); break;
	}
*/
	DrawObjectInWdw(actBox, ROOT, MAX_DEPTH, &r, FALSE, TRUE);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID checkMouse(HWND wdw)
{
	WdwManager_GetTopWindow(&wdw, &wdw);
	if (!WdwManager_IsOwnTop() && !multiTask)
		MouseArrow();
}

/*** ---------------------------------------------------------------------- ***/

/* Init der Action-Box: Es werden alle notwendigen festen Strings berechnet,
 * die variablen Strings werden geloescht und die Box wird gezeichnet.
 * Der Prozentbalken wird auf 0% gesetzt und auch gezeichnet
 */
GLOBAL _VOID PutzAction_InitActionBox(_VOID)
{
	GRECT full;
	_UWORD comps;
	_UBYTE oldFrame;
	_WORD dummy;
	
	SetObjcString(actBox, ACGRNAME, "           ");
	SetObjcString(actBox, ACPUFSTA, "                                           ");
	InitInfoSlider();
	/* Outlined abschalten und Rand auf 1 Pixel setzen */
	DelObjFlags(actBox, ROOT, OUTLINED);
	oldFrame = OBSPEC_GET_FRAMESIZE(actBox[ROOT].ob_spec);
	OBSPEC_SET_FRAMESIZE(actBox[ROOT].ob_spec, -1);
	mtDials_DialCenter(actBox, CSCREEN, 0, 0, &rect);
	ObjcArea(actBox, ROOT, &rect);
	/* Jetzt Fenster fuer Box oeffnen */
	comps = NAME | MOVER;
	Wind_calc(WC_BORDER, comps, &rect, &full);
	if (full.g_y < deskSize.g_y)
		full.g_y = deskSize.g_y;
	if (full.g_x < deskSize.g_x)
		full.g_x = deskSize.g_x;
	if (WdwManager_OpenWindow(
		bProc,
		kProc,
		FUNK_NULL,
		&full, &full, comps, 
		FALSE,
		"", ProgramName,
		FUNK_NULL,
		closeP,
		redrawInfo,
		topP, untopP,
		updateP,
		setWork,
		getRect, 
		FUNK_NULL,
		0,
		actBox, 
		TRUE, TRUE, FALSE, FALSE,
		FALSE,
		&wdwHandle, &dummy))
	{
		inWindow = TRUE;
		WdwManager_FullRedrawWdw(wdwHandle);
		oldNewTop = WdwManager_SetHandleNewTop(checkMouse);
	} else
	{
		inWindow = FALSE;
		SetObjFlags(actBox, ROOT, OUTLINED);
		OBSPEC_SET_FRAMESIZE(actBox[ROOT].ob_spec, oldFrame);
		Wind_Update(BEG_UPDATE);
		mtDials_DialCenter(actBox, CSCREEN, 0, 0, &rect);
		mtDials_DialForm(actBox, DSTART, &rect, &rect);
		mtDials_DialDraw(actBox, ROOT, MAX_DEPTH, &rect, FALSE);
	}
	handleBusyMouse();
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID PutzAction_ShowBuffStatus(_BOOL tabBuff, _BOOL parBuff, _BOOL datBuff, _BOOL waiBuff)
{
	_UBYTE str[80];
	GRECT r;
	
	*str = '\0';
	if (tabBuff)
		strBcat(str, PutzRsc_WrkString(TAB_BUFF));	/*DYJ 5.23e */
	if (parBuff)
	{
		if (tabBuff)
			strBcat(str, ", ");
		strBcat(str, PutzRsc_WrkString(PAR_BUFF));	/*DYJ 5.23e */
	}
	if (datBuff)
	{
		if (tabBuff || parBuff)
			strBcat(str, ", ");
		strBcat(str, PutzRsc_WrkString(DAT_BUFF));	/*DYJ 5.23e */
	}
	if (waiBuff)
	{
		if (tabBuff || parBuff||datBuff)
			strBcat(str, ", ");
		strBcat(str, PutzRsc_WrkString(WAI_BUFF));	/*DYJ 5.23e */
	}
	if (!tabBuff && !parBuff && !datBuff)
		strBcpy(str, PutzRsc_WrkString(NOT_BUFF));	/*DYJ 5.23e */
	SetObjcString(actBox, ACPUFSTA, str);
	DrawObjectInWdw(actBox, ACPUFSTA, 1, &r, FALSE, TRUE);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID PutzAction_ReleaseActionBox(_VOID)
{
	if (inWindow)
	{
		inWindow = FALSE;
		WdwManager_CloseWindow(wdwHandle, TRUE);
		wdwHandle = -1;
		WdwManager_SetHandleNewTop(oldNewTop);
	} else
	{
		mtDials_DialForm(actBox, DFINISH, &rect, &rect);
		Wind_Update(END_UPDATE);
	}
	SetObjcStringAdr(actBox, ACMSGID, spaceStr, sizeof(spaceStr));
	MouseArrow();
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL terminate(_VOID)
{
	_WORD message[8];
	_UWORD event;
	_WORD key;
	_WORD scan;
	_WORD dummy;
	_UWORD udummy;
	
	event = evnt_multi(MU_MESAG|MU_KEYBD|MU_TIMER,
		0, 0, 0,
		0, 0, 0, 0, 0,
		0, 0, 0, 0, 0,
		message,
		0, 0,
		&dummy, &dummy, &udummy, &udummy, &key, &dummy);
	if (event & MU_MESAG)
		WdwManager_HandleEvent(&event, message, 0, 0, 0, 0, 0, 0, 0, 0);
	if (event & MU_KEYBD)
	{
		scan = (key >> 8) & 0xff;
		key &= 0xff;
		if (scan == 0x01 || key == 0x1b) /* Esc */
			return TRUE;
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _BOOL PutzAction_TellAction(_WORD actMode, _ULONG msgCount)
{
	_WORD res;
	GRECT r;
	
	CalcInfoSlider(msgCount);
	if (actMode != actParm.actMode)
	{
		_UBYTE *buf;
		actParm.actMode = actMode;
		SetObjcStringAdr(actBox, ACMSGID, spaceStr, sizeof(spaceStr));
	
		DrawObjectInWdw(actBox, ACMSGID, 1, &r, FALSE, FALSE);
		switch (actMode)
		{
/*DYJ 5.23e Start*/
			case 0: buf=PutzRsc_WrkString(puffStr); break;
			case 1: buf=PutzRsc_WrkString(delStr); break;
			case 2: buf=PutzRsc_WrkString(linkStr); break;
			case 3: buf=PutzRsc_WrkString(copyStr); break;
			case 4: buf=PutzRsc_WrkString(chkStr); break;
			default: buf=spaceStr; break;
		}
		SetObjcStringAdr(actBox, ACMSGID, buf, sizeof(buf));
/*DYJ  Ende; alt:	
			case 0: SetObjcStringAdr(actBox, ACMSGID, puffStr, sizeof(puffStr)); break;
			case 1: SetObjcStringAdr(actBox, ACMSGID, delStr, sizeof(delStr)); break;
			case 2: SetObjcStringAdr(actBox, ACMSGID, linkStr, sizeof(linkStr)); break;
			case 3: SetObjcStringAdr(actBox, ACMSGID, copyStr, sizeof(copyStr)); break;
			case 4: SetObjcStringAdr(actBox, ACMSGID, chkStr, sizeof(chkStr)); break;
			default: SetObjcStringAdr(actBox, ACMSGID, spaceStr, sizeof(spaceStr)); break;
		}
*/
		DrawObjectInWdw(actBox, ACMSGID, 1, &r, FALSE, TRUE);
	}
	if (terminate())
	{
		/* Sicherheitsabfrage */
		MouseArrow();
		Wind_Update(BEG_UPDATE);
		mtAlerts_SetIconColor(BLUE);
/*DYJ 5.23e Start*/
		res = mtAlerts_Alert(2, PutzRsc_WrkString(stopAlert));
/*DYJ  Ende; alt:	
		res = mtAlerts_Alert(2, stopAlert);
*/
		mtAlerts_SetIconColor(BLACK);
		Wind_Update(END_UPDATE);
		if (res == 1)
			return FALSE;
		handleBusyMouse();
	}
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

/* Muss am Anfang aufgerufen werden, damit das Modul die Adresse 
 * des Baumes hat
 */
GLOBAL _VOID PutzAction_InitModule(OBJECT *tree)
{
	actBox = tree;
}
