/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 *
 * 3.5.04 Dimitri Junker (DYJ) gekennzeichnet mit 'DYJ 5.36g'
 *	Bisher genossen unbeantwortete Mails aus der Gruppe Persnliche
 *	einen speziellen Schutz. Defaultmig ist dies jetzt auch noch
 *	so, aber man kann es abstellen oder auch fr andere Gruppen aktivieren.
 */


#include <putzdo.h>
#include <putzvers.h>
#include <wdwmanag.h>
#include <mtalerts.h>
#include <putzgrou.h>
#include <putztype.h>
#include <putzwind.h>
#include <putzacti.h>
#include <mtpaths.h>
#include <putzlog.h>
#include <putzrsc.h>
#include <confvars.h>
#include <convertd.h>
#include <ro_mem.h>
#include <catgloba.h>
#include <routinec.h>
#include <routines.h>

/*DYJ 5.36f Start*/
#include <catputz.h>
/*DYJ  Ende; alt:	
#define AL_DATE_TOO_NEW "[3][%P:|Das L\224schdatum ist|gr\224\236er als das Tagesdatum.][[Abbruch]"
#define AL_ILLEGAL_DATE "[3][%P:|Das L\224schdatum ist|nicht g\201ltig.][[Abbruch]"
*/


/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

/* Operationen auf der Gruppenliste */

GLOBAL _WORD PutzDo_CountSelectedEntries(List *gr)
{
	_WORD count;
	grListEntry *entry;
	
	count = 0;
	Lists_ResetList(gr);
	while ((entry = Lists_NextEntry(gr)) != NULL)
	{
		if (entry->selected)
			++count;
	}
	return count;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL grListEntry *PutzDo_FirstSelectedGroup(List *gr)
{
	grListEntry *entry;
	
	Lists_ResetList(gr);
	while ((entry = Lists_NextEntry(gr)) != NULL)
	{
		if (entry->selected)
			return entry;
	}
	return NULL;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL grListEntry *PutzDo_NextSelectedGroup(List *gr, CAT_GROUP_NUMBER currentGroup)
{
	grListEntry *entry;
	CAT_GROUP_NUMBER i = (CAT_GROUP_NUMBER)dataSys_notSaved;
	
	Lists_ResetList(gr);
	do
	{
		entry = Lists_NextEntry(gr);
		if (entry != NULL)
			i = entry->info->catNumber;
	} while (i != currentGroup && entry != NULL);
	if (entry == NULL)
		return NULL;
	while ((entry = Lists_NextEntry(gr)) != NULL)
	{
		if (entry->selected)
			return entry;
	}
	return NULL;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL grListEntry *PutzDo_GetGroupEntry(CAT_GROUP_NUMBER index)
{
	CAT_GROUP_NUMBER i;
	grListEntry *entry;
	List *gr = &putzList;
	
	i = (CAT_GROUP_NUMBER)dataSys_notSaved;
	Lists_ResetList(gr);
	do
	{
		entry = Lists_NextEntry(gr);
		if (entry != NULL)
			i = entry->info->catNumber;
	} while (i != index && entry != NULL);
	return entry;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID PutzDo_SelectAll(_BOOL select)
{
	grListEntry *entry;
	List *gr = &putzList;
	
	Lists_ResetList(gr);
	while ((entry = Lists_NextEntry(gr)) != NULL)
	{
		if (!(entry->info->catNumber == dataSys_private && select))
			entry->selected = select;
	}
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID PutzDo_CalcTotals(_VOID)
{
	grListEntry *entry;
	
	totalEntry.preMsgs = 0;
	totalEntry.preBytes = 0;
	totalEntry.badDel = 0;
	totalEntry.totalDel = 0;
	totalEntry.partDel = 0;
	totalEntry.postMsgs = 0;
	totalEntry.postBytes = 0;
	totalEntry.status=GRP_DONE;
	Lists_ResetList(&putzList);
	while ((entry = Lists_NextEntry(&putzList)) != NULL)
	{
		totalEntry.preMsgs += entry->preMsgs;
		totalEntry.preBytes += entry->preBytes;
		if (entry->postBytes != 0)
			totalEntry.postBytes += entry->postBytes;
		else
			totalEntry.postBytes += entry->preBytes;
		if (entry->postMsgs != 0)
			totalEntry.postMsgs += entry->postMsgs;
		else
			totalEntry.postMsgs += entry->preMsgs;
		totalEntry.badDel += entry->badDel;
		totalEntry.totalDel += entry->totalDel;
		totalEntry.partDel += entry->partDel;
	}
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID PutzDo_PerformDelete(HWND wdwHandle)
{
	putzOptsRec putzOpts;
	grListEntry *currGrEntry;
	
	currGrEntry = PutzDo_FirstSelectedGroup(&putzList);
	if (currGrEntry == NULL)
		return;
	PutzAction_InitActionBox();
	while (currGrEntry != NULL)
	{
		if (!PutzDo_InitGroupFlags(currGrEntry->info->catNumber, TRUE, &putzOpts))
		{
			PutzAction_ReleaseActionBox();
			return;
		}
		if (!PutzGroup_deleteInGroup(currGrEntry, &putzOpts, PutzTypes_dFlags))
		{
			currGrEntry->status=GRP_ERR;
			PutzAction_ReleaseActionBox();
			return;
		}
		if (PutzWindows_IsPutzWindow(wdwHandle))
		{
			PutzDo_CalcTotals();
			if (putzOpts.deselAfterDel)
				PutzWindows_SelectEntry(wdwHandle, currGrEntry, FALSE);
			PutzWindows_RedrawEntry(wdwHandle, currGrEntry);
			PutzWindows_RedrawEntry(wdwHandle, &totalEntry);
		}
		/* Naechste Gruppe suchen */
		currGrEntry = PutzDo_NextSelectedGroup(&putzList, currGrEntry->info->catNumber);
	}
	PutzAction_ReleaseActionBox();
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID PutzDo_InitDelete(HWND wdwHandle)
{
	grListEntry *currGrEntry;
	
	currGrEntry = PutzDo_FirstSelectedGroup(&putzList);
	if (currGrEntry == NULL)
		return;
	/* Menu disablen */
	WdwManager_DisableMenu(menu, TRUE);
	/* Loeschen durchfuehren */
	
	PutzLog_OpenLog(DataPath);
	PutzLog_putTime();
	PutzLog_WriteString(CATPUTZ_VERSION);
	PutzLog_WriteString(" f\201r CAT ab 3.0 gestartet");
	PutzLog_WriteLn();
	
	PutzDo_PerformDelete(wdwHandle);
	
	/* Ok, das war's, weiter im normalen Programm */
	PutzDo_CalcTotals();
	PutzLog_WriteString("--------------------------------------------------");
	PutzLog_WriteLn();
	PutzLog_putTime();
	PutzLog_WriteString(" L\224schen beendet.");
	PutzLog_WriteLn();
	PutzLog_WriteLine  ("STATISTIK: ");
	PutzLog_WriteString("           Gesamtanzahl Messages vorher: ");
	PutzLog_WriteCard(totalEntry.preMsgs);
	PutzLog_WriteLn();
	PutzLog_WriteString("           Gesamtanzahl Messages nachher: ");
	PutzLog_WriteCard(totalEntry.postMsgs);
	PutzLog_WriteLn();
	PutzLog_WriteString("           Gesamtanzahl totalgel\224schter Messages: ");
	PutzLog_WriteCard(totalEntry.totalDel);
	PutzLog_WriteLn();
	PutzLog_WriteString("           Gesamtanzahl teilgel\224schter Messages: ");
	PutzLog_WriteCard(totalEntry.partDel);
	PutzLog_WriteLn();
	PutzLog_WriteString("           Gesamtanzahl besch\204digter Messages: ");
	PutzLog_WriteCard(totalEntry.badDel);
	PutzLog_WriteLn();
	PutzLog_WriteString("           Gesamtanzahl Bytes vorher: ");
	PutzLog_WriteCard(totalEntry.preBytes);
	PutzLog_WriteLn();
	PutzLog_WriteString("           Gesamtanzahl Bytes nachher: ");
	PutzLog_WriteCard(totalEntry.postBytes);
	PutzLog_WriteLn();
	PutzLog_WriteLn();
	PutzLog_CloseLog();
	
	/* Menu wiederherstellen */
	WdwManager_DisableMenu(menu, FALSE);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL delState get_del_state(CONST _UBYTE *gName, CONST _UBYTE *conf, delState default_)
{
	groupName varName;
	_WORD val;
	
	strBcpy(varName, gName);
	strBcat(varName, conf);
	ConfVars_GetConfDefInt(varName, &val, (_WORD)default_);
	return (delState)val;
}

/*** ---------------------------------------------------------------------- ***/

/*DYJ 5.36g Start*/
GLOBAL _BOOL PutzDo_GetGroupFlags(CONST _UBYTE *name, _BOOL doAlts, putzOptsRec *putzOpts,delState defNoAnswFlg)
/*DYJ  Ende; alt:	
GLOBAL _BOOL PutzDo_GetGroupFlags(CONST _UBYTE *name, _BOOL doAlts, putzOptsRec *putzOpts)
*/
{
	groupName gName;
	groupName varName;
	_BOOL boolVal;
/*DYJ 5.36f Start*/
	groupName del_Str;
/*DYJ  Ende; alt:	
	groupName delStr;
*/
	_BOOL ok;
	
	ok = TRUE;
	/* Gruppennamen von Leerzeichen befreien */
	strBcpy(gName, name);
	if (strCmp(gName, "Default") != 0)
	{
		strUpr(gName);
		CatGlobal_ReplaceChar(gName, ' ', '_');    /* Spaces durch Underscores ersetzen */
	}
	
	/* Variablennamen zusammenbauen */
	/* Fuer Interessant-Flag */
	putzOpts->intFlag = get_del_state(gName, ".delInteresting", defaultOpts.intFlag);
	/* Fuer User-Flag 1 */
	putzOpts->usrFlg1 = get_del_state(gName, ".delUserflag1", defaultOpts.usrFlg1);
	/* Fuer User-Flag 2 */
	putzOpts->usrFlg2 = get_del_state(gName, ".delUserflag2", defaultOpts.usrFlg2);
	/* Fuer Gelesen-Flag */
	putzOpts->readFlg = get_del_state(gName, ".delRead", defaultOpts.readFlg);
	/* Fuer Gefiltert-Flag */
	putzOpts->filtFlg = get_del_state(gName, ".delFiltered", defaultOpts.filtFlg);
	/* Fuer Ungelesen-Flag */
	putzOpts->noRdFlg = get_del_state(gName, ".delUnread", defaultOpts.noRdFlg);
/*DYJ 5.36g Start*/
	/* Fuer Unbeantwortet-Flag */
	putzOpts->noAnsFlg = get_del_state(gName, ".delUnunswered", defNoAnswFlg);
/*DYJ  Ende; */
	
	/* Loeschdatum zusammensetzen */
	strBcpy(varName, gName);
	strBcat(varName, ".deleteByDate");
	ConfVars_GetConfDefBool(varName, &boolVal, defaultOpts.deleteByDate);
	putzOpts->deleteByDate = boolVal;
	if (boolVal)
	{
		/* Datum holen */
		/* Loeschdatum zusammensetzen */
		strBcpy(varName, gName);
		strBcat(varName, ".deleteDate");
/*DYJ 5.36f Start*/
		ConfVars_GetConfDefStr(varName, del_Str, sizeof(del_Str), defaultOpts.dateStr);
		strBcpy(putzOpts->dateStr, del_Str);
		if (ConvertDate_DateOk(del_Str))
		{
			putzOpts->delDate = ConvertDate_StrToDate(del_Str);
/*DYJ  Ende; alt:	
		ConfVars_GetConfDefStr(varName, delStr, sizeof(delStr), defaultOpts.dateStr);
		strBcpy(putzOpts->dateStr, delStr);
		if (ConvertDate_DateOk(delStr))
		{
			putzOpts->delDate = ConvertDate_StrToDate(delStr);
*/
			if (putzOpts->delDate > ConvertDate_CurrentDate())
			{
				/* Fehlermeldung! */
				if (doAlts)
				{
/*DYJ 5.36f Start*/
					mtAlerts_Alert(1, PutzRsc_WrkString(AL_DATE_TOO_NEW));
/*DYJ  Ende; alt:	
					mtAlerts_Alert(1, AL_DATE_TOO_NEW);
*/
				}
				ok = FALSE;
			}
		} else
		{
			if (doAlts)
			{
/*DYJ 5.36f Start*/
				mtAlerts_Alert(1, PutzRsc_WrkString(AL_ILLEGAL_DATE));
/*DYJ  Ende; alt:	
				mtAlerts_Alert(1, AL_ILLEGAL_DATE);
*/
			}
			ok = FALSE;
		}
	} else
	{
		strBcpy(putzOpts->dateStr, "");
	}
	return ok;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _BOOL PutzDo_InitGroupFlags(CAT_GROUP_NUMBER groupIndex, _BOOL doAlts, putzOptsRec *putzOpts)
{
	grListEntry *ptr;
	_BOOL ok;
	
	ptr = PutzDo_GetGroupEntry(groupIndex);
	if (ptr != NULL)
	{
		MemSetZeroStruct(*putzOpts);
/*DYJ 5.36g Start*/
		ok = PutzDo_GetGroupFlags(ptr->info->name, doAlts, putzOpts,groupIndex== dataSys_private?noDel:defaultOpts.noAnsFlg);
/*DYJ  Ende; alt:	
		ok = PutzDo_GetGroupFlags(ptr->info->name, doAlts, putzOpts);
*/
		putzOpts->useTmp = defaultOpts.useTmp;
		putzOpts->tmpLock = defaultOpts.tmpLock;
		putzOpts->deselAfterDel = defaultOpts.deselAfterDel;
		strBcpy(putzOpts->tmpDir, defaultOpts.tmpDir);
		putzOpts->delWithoutComm = defaultOpts.delWithoutComm;
	} else
	{
		/* Default nehmen */
		*putzOpts = defaultOpts;
		ok = TRUE;
	}
	return ok;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID set_del_state(CONST _UBYTE *gName, CONST _UBYTE *conf, delState flag)
{
	groupName varName;

	strBcpy(varName, gName);
	strBcat(varName, conf);
	ConfVars_SetConfigInt(varName, (_WORD)(flag));
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID PutzDo_SetGroupFlags(CONST _UBYTE *name, CONST putzOptsRec *putzOpts)
{
	groupName gName;
	groupName varName;
	
	/* Gruppennamen von Leerzeichen befreien */
	strBcpy(gName, name);
	if (strCmp(gName, "Default") != 0)
	{
		strUpr(gName);
		CatGlobal_ReplaceChar(gName, ' ', '_');    /* Spaces durch Underscores ersetzen */
	}
	
	/* Variablennamen zusammenbauen */
	/* Fuer Interessant-Flag */
	set_del_state(gName, ".delInteresting", putzOpts->intFlag);
	/* Fuer User-Flag 1 */
	set_del_state(gName, ".delUserflag1", putzOpts->usrFlg1);
	/* Fuer User-Flag 2 */
	set_del_state(gName, ".delUserflag2", putzOpts->usrFlg2);
	/* Fuer Gelesen-Flag */
	set_del_state(gName, ".delRead", putzOpts->readFlg);
	/* Fuer Gefiltert-Flag */
	set_del_state(gName, ".delFiltered", putzOpts->filtFlg);
	/* Fuer Ungelesen-Flag */
	set_del_state(gName, ".delUnread", putzOpts->noRdFlg);
/*DYJ 5.36g Start*/
	/* Fuer Unbeantwortet-Flag */
	set_del_state(gName, ".delUnunswered", putzOpts->noAnsFlg);
/*DYJ  Ende; */
	/* Loeschdatum zusammensetzen */
	strBcpy(varName, gName);
	strBcat(varName, ".deleteByDate");
	ConfVars_SetConfigBool(varName, putzOpts->deleteByDate);
	/* Loeschdatum zusammensetzen */
	strBcpy(varName, gName);
	strBcat(varName, ".deleteDate");
	ConfVars_SetConfigString(varName, putzOpts->dateStr);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID PutzDo_SetGroupNrFlags(CAT_GROUP_NUMBER groupIndex, CONST putzOptsRec *putzOpts)
{
	grListEntry *ptr;

	ptr = PutzDo_GetGroupEntry(groupIndex);
	if (ptr != NULL)
		PutzDo_SetGroupFlags(ptr->info->name, putzOpts);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID delete_group_var(CONST _UBYTE *gName, CONST _UBYTE *conf)
{
	groupName varName;

	strBcpy(varName, gName);
	strBcat(varName, conf);
	ConfVars_DeleteConfigVar(varName);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID PutzDo_DeleteGroupFlags(CAT_GROUP_NUMBER groupIndex)
{
	grListEntry *ptr;
	groupName gName;
	
	ptr = PutzDo_GetGroupEntry(groupIndex);
	if (ptr != NULL)
	{
		/* Gruppennamen von Leerzeichen befreien */
		strBcpy(gName, ptr->info->name);
		strUpr(gName);
		CatGlobal_ReplaceChar(gName, ' ', '_');    /* Spaces durch Underscores ersetzen */
		
		/* Fuer Interessant-Flag */
		delete_group_var(gName, ".delInteresting");
		/* Fuer User-Flag 1 */
		delete_group_var(gName, ".delUserflag1");
		/* Fuer User-Flag 2 */
		delete_group_var(gName, ".delUserflag2");
		/* Fuer Gelesen-Flag */
		delete_group_var(gName, ".delRead");
		/* Fuer Gefiltert-Flag */
		delete_group_var(gName, ".delFiltered");
		/* Fuer Ungelesen-Flag */
		delete_group_var(gName, ".delUnread");
		/* Loeschdatum zusammensetzen */
		delete_group_var(gName, ".deleteByDate");
		/* Loeschdatum zusammensetzen */
		delete_group_var(gName, ".deleteDate");
	}
}
