/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */


#include <putzinit.h>
#include <wdwmanag.h>
#include <catgloba.h>
#include <mtutils.h>
#include <mtappl.h>
#include <mtdials.h>
#include <putzrsc.h>
#include <catputz.h>

#undef INFOBAR
#undef INFOSLID

LOCAL GRECT rect;
LOCAL _BOOL inWindow;
LOCAL HWND wdwHandle = -1;
LOCAL handleNewTopProc oldNewTop;
LOCAL OBJECT *actBox;


/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

LOCAL _BOOL bProc(HWND wdw, _VOID *special, _WORD mx, _WORD my, _UWORD kstate, _UWORD buttons, _WORD clicks)
{
	UNUSED(wdw);
	UNUSED(special);
	UNUSED(mx);
	UNUSED(my);
	UNUSED(kstate);
	UNUSED(buttons);
	UNUSED(clicks);
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL kProc(HWND wdw, _VOID *special, _WORD taste, _UBYTE key, _UBYTE scan, _UWORD kstate)
{
	UNUSED(wdw);
	UNUSED(special);
	UNUSED(taste);
	UNUSED(key);
	UNUSED(scan);
	UNUSED(kstate);
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL closeP(HWND wdw, HVDI vdi, _VOID *special, _BOOL force)
{
	UNUSED(wdw);
	UNUSED(vdi);
	UNUSED(special);
	return force;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL topP(HWND wdw, _VOID *special)
{
	UNUSED(wdw);
	UNUSED(special);
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID untopP(HWND wdw, _VOID *special)
{
	UNUSED(wdw);
	UNUSED(special);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID setWork(HWND wdw, _VOID *special, CONST LGRECT *doc, _BOOL slided)
{
	UNUSED(wdw);
	UNUSED(special);
	UNUSED(doc);
	UNUSED(slided);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID getRect(HWND wdw, HVDI vdi, _VOID *special, GRECT *work)
{
	UNUSED(wdw);
	UNUSED(vdi);
	UNUSED(special);
	rect = *work;
	actBox[ROOT].ob_x = work->g_x;
	actBox[ROOT].ob_y = work->g_y;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID redrawInfo(HWND wdw, HVDI vdi, _VOID *special, CONST GRECT *clip)
{
	UNUSED(wdw);
	UNUSED(vdi);
	mtDials_DialDraw(special, ROOT, MAX_DEPTH, clip, TRUE);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID updateP(HWND wdw, _VOID *special, _BOOL begin)
{
	UNUSED(wdw);
	UNUSED(special);
	if (begin)
	{
		Wind_Update(BEG_UPDATE);
	} else
	{
		Wind_Update(END_UPDATE);
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL struct {
	GRECT pFrame;
	GRECT sFrame;
	_WORD lastWidth;
	_BOOL reinit;
	_BOOL fullInit;
	_LONG Epp;
} slideVars;
LOCAL _LONG groupCount = 1;
     

LOCAL _VOID handleBusyMouse(_VOID)
{
	if (!multiTask || !inWindow)
		if (WdwManager_IsOwnTop())
			CatGlobal_busyMouse();
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL DrawObjectInWdw(OBJECT *tree, _WORD obj, _WORD depth, CONST GRECT *r, _BOOL clip, _BOOL mouse)
{
	GRECT clipgr;
	_WORD res;
	
	if (clip)
	{
		clipgr = *r;
	} else
	{
		CalcArea(tree, obj, &clipgr);
	}
	if (inWindow)
	{
		if (multiTask)
			res = Wind_Update(BEG_UPDATE | 0x100);
		else
			res = Wind_Update(BEG_UPDATE);
		if (res == 1)
		{
			WdwManager_RedrawWdw(wdwHandle, &clipgr);
			if (mouse)
				handleBusyMouse();
			Wind_Update(END_UPDATE);
		} else
		{
			if (mouse)
				MouseArrow();
			return FALSE;
		}
	} else
	{
		mtDials_DialDraw(tree, ROOT, depth, &clipgr, clip);
	}
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID InitInfoSlider(_VOID)
{
	/* slider anpassen an charWidth und charHeight */
	ObjcRect(actBox, INITBAR, &slideVars.pFrame);
	ObjcRect(actBox, INITSLID, &slideVars.sFrame);
	/* Space berechnen */
	slideVars.pFrame.g_h = CharHeight;
	slideVars.sFrame.g_h = CharHeight;
	slideVars.sFrame.g_w = 1;
	slideVars.Epp = (groupCount * 1000L) / (_LONG)(slideVars.pFrame.g_w);
	SetObjcRect(actBox, INITBAR, &slideVars.pFrame);
	SetObjcRect(actBox, INITSLID, &slideVars.sFrame);
	slideVars.lastWidth = 0;
	slideVars.reinit = TRUE;
	slideVars.fullInit = TRUE;
	/* Fuellstil auf Solid und Farbe setzen, falls Farbe */
	if (Bitplanes > 1)
	{
		OBSPEC_SET_FILLPATTERN(actBox[INITSLID].ob_spec, 7);
		OBSPEC_SET_INTERIORCOL(actBox[INITSLID].ob_spec, RED);
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID CalcInfoSlider(_LONG newValue)
{
	GRECT r;
	_WORD startOb;
	_WORD depth;

	if (slideVars.Epp > 0)
		slideVars.sFrame.g_w = (_WORD)((newValue * 1000L) / slideVars.Epp);
	else
		slideVars.sFrame.g_w = slideVars.pFrame.g_w;
	if (slideVars.sFrame.g_x + slideVars.sFrame.g_w > slideVars.pFrame.g_w)
		slideVars.sFrame.g_w = slideVars.pFrame.g_w;
	if (slideVars.sFrame.g_w <= 0)
		slideVars.sFrame.g_w = 1;
	if (slideVars.lastWidth != slideVars.sFrame.g_w || slideVars.reinit)
	{
		SetObjcRect(actBox, INITSLID, &slideVars.sFrame);
		ObjcArea(actBox, INITSLID, &r);
		if (!slideVars.reinit)
		{
			r.g_x = r.g_x + slideVars.lastWidth;
			r.g_w = r.g_w - slideVars.lastWidth + 1;
		} else
		{
			ObjcArea(actBox, INITBAR, &r);
		}
		if (slideVars.fullInit)
		{
			startOb = ROOT;
			depth = MAX_DEPTH;
			ObjcArea(actBox, ROOT, &r);
		} else
		{
			startOb = INITBAR;
			depth = 1;
		}
		if (DrawObjectInWdw(actBox, startOb, depth, &r, TRUE, ((newValue+1) % 10) == 0))
		{
			slideVars.lastWidth = slideVars.sFrame.g_w;
			slideVars.reinit = FALSE;
			slideVars.fullInit = FALSE;
		}
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID checkMouse(HWND wdw)
{
	WdwManager_GetTopWindow(&wdw, &wdw);
	if (!WdwManager_IsOwnTop() && !multiTask)
		MouseArrow();
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID PutzInit_InitInitBox(_VOID)
{
	GRECT full;
	_UWORD comps;
	_UBYTE oldFrame;
	_WORD dummy;
	
	/* Resourceadresse holen */
	actBox = PutzRsc_GetTreeAddr(INITBOX);
	InitInfoSlider();
	/* Outlined abschalten und Rand auf 1 Pixel setzen */
	DelObjFlags(actBox, ROOT, OUTLINED);
	oldFrame = OBSPEC_GET_FRAMESIZE(actBox[ROOT].ob_spec);
	OBSPEC_SET_FRAMESIZE(actBox[ROOT].ob_spec, -1);
	mtDials_DialCenter(actBox, CSCREEN, 0, 0, &rect);
	ObjcArea(actBox, ROOT, &rect);
	/* Jetzt Fenster fuer Box oeffnen */
	comps = NAME | MOVER;
	Wind_calc(WC_BORDER, comps, &rect, &full);
	if (full.g_y < deskSize.g_y)
		full.g_y = deskSize.g_y;
	if (full.g_x < deskSize.g_x)
		full.g_x = deskSize.g_x;
	if (WdwManager_OpenWindow(
		bProc,
		kProc,
		FUNK_NULL,
		&full, &full, comps, 
		FALSE,
		"", ProgramName,
		FUNK_NULL,
		closeP,
		redrawInfo,
		topP, untopP,
		updateP,
		setWork,
		getRect, 
		FUNK_NULL,
		0,
		actBox, 
		TRUE, TRUE, FALSE, FALSE,
		FALSE,
		&wdwHandle, &dummy))
	{
		inWindow = TRUE;
		WdwManager_FullRedrawWdw(wdwHandle);
		oldNewTop = WdwManager_SetHandleNewTop(checkMouse);
	} else
	{
		inWindow = FALSE;
		SetObjFlags(actBox, ROOT, OUTLINED);
		OBSPEC_SET_FRAMESIZE(actBox[ROOT].ob_spec, oldFrame);
		Wind_Update(BEG_UPDATE);
		mtDials_DialCenter(actBox, CSCREEN, 0, 0, &rect);
		mtDials_DialForm(actBox, DSTART, &rect, &rect);
		mtDials_DialDraw(actBox, ROOT, MAX_DEPTH, &rect, FALSE);
	}
	handleBusyMouse();
}

/*** ---------------------------------------------------------------------- ***/

/* Setzt den Maximalwert fuer das Laden der Box
 */
GLOBAL _VOID PutzInit_SetMaxValue(_LONG max)
{
	GRECT vr;
	
	groupCount = max;
	InitInfoSlider();
	DrawObjectInWdw(actBox, ROOT, MAX_DEPTH, &vr, FALSE, TRUE);
}

/*** ---------------------------------------------------------------------- ***/

/* sieht per evnt_multi nach, ob eine Nachricht vorliegt */
LOCAL _VOID DoEvent(_VOID)
{
	_WORD message[8];
	_UWORD event, evnt;
	_WORD mox, moy;
	_UWORD moButton;
	_WORD kReturn;
	_UWORD moKState;
	_WORD bReturn;

	/* Hier bei MultiTasking noch eine kleiner EventMulti und ein paar
	 * Events verarbeiten 
	 */
	for (;;)
	{
		evnt = evnt_multi(MU_MESAG|MU_TIMER,
			0, 0, 0,
			0, 0, 0, 0, 0,
			0, 0, 0, 0, 0,
			message,
			0, 0,
			&mox, &moy, &moButton, &moKState, &kReturn, &bReturn);
		/* Den Timerevent brauchen wir nicht */
		event = evnt & ~MU_TIMER;
		if (event == 0)
			break;
		
		Wind_Update(BEG_UPDATE);
		WdwManager_HandleEvent(&evnt, message, moButton, 0, 0, 0, 0, mox, moy, 0);
		Wind_Update(END_UPDATE);
	}
}

/*** ---------------------------------------------------------------------- ***/

/* Setzt den aktuellen Wert fuer die Box
*/
GLOBAL _VOID PutzInit_SetCurrentValue(_LONG value)
{
	CalcInfoSlider(value);
	DoEvent();
}

/*** ---------------------------------------------------------------------- ***/

/* Schliesst die Box wieder
 */
GLOBAL _VOID PutzInit_CloseInitBox(_VOID)
{
	if (inWindow)
	{
		inWindow = FALSE;
		WdwManager_CloseWindow(wdwHandle, TRUE);
		wdwHandle = -1;
		WdwManager_SetHandleNewTop(oldNewTop);
	} else
	{
		mtDials_DialForm(actBox, DFINISH, &rect, &rect);
		Wind_Update(END_UPDATE);
	}
	MouseArrow();
}
