/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */


#include <putzlog.h>
#include <putztype.h>
#include <mttextfi.h>
#include <file_io.h>
#include <routinec.h>


LOCAL TEXTFILENO log;


/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

GLOBAL _VOID PutzLog_WriteString(CONST _UBYTE *str)
{
	if (log != NULL)
		mtTextfiles_WriteLine(log, str);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID PutzLog_WriteCard(_ULONG c)
{
	if (log != NULL)
		mtTextfiles_WriteLongCard(log, c, 0);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID PutzLog_Write(_UBYTE c)
{
	if (log != NULL)
		mtTextfiles_WriteChar(log, c);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID PutzLog_WriteLn(_VOID)
{
	if (log != NULL)
		mtTextfiles_WriteLn(log);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID PutzLog_WriteLine(CONST _UBYTE *str)
{
	PutzLog_WriteString(str);
	PutzLog_WriteLn();
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID PutzLog_putDate(_VOID)
{
	_UBYTE tmpStr[50];
	
	T_Strlftime(tmpStr, sizeof(tmpStr), "%d.%m.%Y, %H:%M:%S Uhr", T_Systime());
	PutzLog_WriteString(tmpStr);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID PutzLog_putTime(_VOID)
{
	_UBYTE tmpStr[50];
	
	T_Strlftime(tmpStr, sizeof(tmpStr), "%H:%M:%S Uhr ", T_Systime());
	PutzLog_WriteString(tmpStr);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _BOOL PutzLog_OpenLog(CONST _UBYTE *path)
{
	_UBYTE scrap[PATH_MAX];
	static Textmode mode=WRITE;		/*DYJ 5.20y */
	if (log == NULL)
	{
		strBcpy(scrap, path);
		F_Path_Append(scrap, CATPUTZ_LOGNAME);
		/* Buffergroessen veraendert */
		mtTextfiles_OpenTextfile(scrap, mode, 8192, &log);
		mode=APPEND;
	}
	PutzLog_putDate();
	PutzLog_WriteLine(" Log-Datei ge\224ffnet");
	PutzLog_WriteLine("--------------------------------------------------");
	return log != NULL;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID PutzLog_CloseLog(_VOID)
{
	if (log != NULL)
	{
		PutzLog_WriteString("Log-Datei geschlossen am ");
		PutzLog_putDate();
		PutzLog_WriteLn();
		mtTextfiles_CloseTextfile(&log);
		log = NULL;
	}
}
