/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 *
 */


#include <putzrsc.h>
#include <putzvers.h>
#include <putzhelp.h>
#include <portvdi.h>
#include <mtdir.h>
#ifndef __MINTBIND_H__
#include <mintbind.h>
#endif
#include <mtappl.h>
#include <mtutils.h>
#include <mtpopups.h>
#include <mtalerts.h>
#include <file_io.h>
#include <fontsele.h>
#include <catgloba.h>
#include <confvars.h>
#include <wdwmanag.h>
#include <windials.h>
#include <mtrsc.h>
#include <varnamel.h>
#include <convertd.h>
#include <vdiutil.h>
#include <putzdo.h>
#include <putzgr.h>
#include <mtpaths.h>
#include <alias.h>

#include <routinec.h>
#include <routines.h>	/*DYJ 5.20w */
#include <catlib.h>		/*DYJ 5.21i */

#include <catputz.h>


GLOBAL putzOptsRec defaultOpts = {
	ignoreFlag,	/* intFlag */
	ignoreFlag,	/* usrFlag1 */
	ignoreFlag,	/* usrFlag2 */
	ignoreFlag,	/* readFlag */
	ignoreFlag,	/* filtFlag */
	ignoreFlag,	/* noRdFlag */
	FALSE,		/* deleteByDate */
	{ 0 },		/* dateStr */
	0,			/* delDate */
	FALSE,		/* useTmp */
	FALSE,		/* tmpLock */
	TRUE,		/* delWithoutComm */
	FALSE,		/* deselAfterDel */
	{ 0 },		/* tmpDir */
	PutzTypes_dFlags,	/* dMode */
	0			/* number */
};

GLOBAL OBJECT *selectBox;
GLOBAL OBJECT *selectBox2;	/*DYJ 5.36g */
GLOBAL OBJECT *infoBox;
GLOBAL OBJECT *info2Box;
GLOBAL OBJECT *helpBox;
GLOBAL OBJECT *pathBox;
GLOBAL OBJECT *optBox;
GLOBAL OBJECT *actBox;
GLOBAL OBJECT *imBox;
GLOBAL OBJECT *menu;
GLOBAL _BOOL AutoSaveOptions;


LOCAL _WORD globalResButton;
LOCAL RESOURCE theRSC;


/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

/* image und icon-konvertierung */

LOCAL _VOID vdiFix(MFDB *pfd, _VOID *theAddr, _WORD wb, _WORD h)
{
	pfd->fd_wdwidth = (wb + 1) / 2;
	pfd->fd_w = wb * 8;
	pfd->fd_h = h;
	pfd->fd_nplanes = 1;
	pfd->fd_stand = TRUE;
	pfd->fd_addr = theAddr;
	pfd->fd_r1 = 0;
	pfd->fd_r2 = 0;
	pfd->fd_r3 = 0;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID vdiTrans(_VOID *source, _WORD sourceWb, _VOID *dest, _WORD destWb, _WORD h, HVDI handle)
{
	MFDB src, dst;

	vdiFix(&src, source, sourceWb, h);
	src.fd_stand = TRUE;
	vdiFix(&dst, dest, destWb, h);
	dst.fd_stand = FALSE;
	vr_trnfm(handle, &src, &dst);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID transBitBlk(BITBLK *spec, HVDI handle)
{
	_VOID *addr;

	addr = spec->bi_pdata;
	if (addr != (_VOID *)-1)
		vdiTrans(addr, spec->bi_wb, addr, spec->bi_wb, spec->bi_hl, handle);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID transObj(OBJECT *tree, _WORD obj, HVDI handle)
{
	ICONBLK *icon;
	_WORD wb, hl;
	_VOID *addr;

	switch (tree[obj].ob_type & 0xff)
	{
	case G_IMAGE:
		transBitBlk(tree[obj].ob_spec.bitblk, handle);
		break;
	case G_ICON:
		icon = tree[obj].ob_spec.iconblk;
		wb = (icon->ib_wicon + 7) / 8;
		hl = icon->ib_hicon;
		addr = icon->ib_pdata;
		if (addr != (_VOID *)-1)
			vdiTrans(addr, wb, addr, wb, hl, handle);
		addr = icon->ib_pmask;
		if (addr != (_VOID *)-1)
			vdiTrans(addr, wb, addr, wb, hl, handle);
		break;
	}
}

/*** ---------------------------------------------------------------------- ***/

/*  Routinen fuer den Umgang mit Objektbaeumen  */
/*  ========================================  */

#if 0
LOCAL _VOID SelectButton(OBJECT *dial, _WORD button, _BOOL redraw)
{
	GRECT r1;

	SetObjState(dial, button, SELECTED);
	if (redraw)
	{
		ObjcArea(dial, button, &r1);
		WinDials_WinDialDraw(dial, button, 0, &r1, TRUE);
	}
}
#endif

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID DeselectButton(OBJECT *dial, _WORD button, _BOOL redraw)
{
	GRECT r1;

	DelObjState(dial, button, SELECTED);
	if (redraw)
	{
		ObjcArea(dial, button, &r1);
		WinDials_WinDialDraw(dial, button, 0, &r1, TRUE);
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _WORD DoSimpleBox(OBJECT *form)
{
	return WinDials_WinDialDo(form, ROOT);
}

/*** ---------------------------------------------------------------------- ***/

/* catPutzFileMagic    == 28011968L + 00400000000L; */
/* catPutzFileMagic    == 02031991L + 00400000000L; */
/* catPutzFileMagic    == 30041991L + 00400000000L; */
/* catPutzFileMagic    == 08051991L + 00400000000L; */
/* catPutzFileMagic    == 14051991L + 00400000000L; */
/* catPutzFileMagic    == 03071991L + 00400000000L; */
/* catPutzFileMagic    == 19011992L + 00400000000L;*/
/* catPutzFileMagic    == 15041992L + 00400000000L; */
/* Ab CatPutz 2.10 kein Magic mehr, nun Ascii-File */

LOCAL _VOID writeInfo(TEXTFILENO inf)
{
	_UBYTE str[80];
	
	mtTextfiles_WriteLine(inf, "# ");
	mtTextfiles_WriteLine(inf, PUTZ_WHATTEXT);
	mtTextfiles_WriteLn(inf);
	mtTextfiles_WriteLine(inf, "# configuration file");
	mtTextfiles_WriteLn(inf);
	T_Strlftime(str, sizeof(str), "# created %0a %d %m %Y, %H:%M:%S", T_Systime());
	mtTextfiles_WriteLine(inf, str);
	mtTextfiles_WriteLn(inf);
}

/*** ---------------------------------------------------------------------- ***/

/* Variablennamen */
#define cWdwRect       "StatWindowRect"
#define cWdwFont       "StatFont"
#define cWdwFontSize   "StatFontSize"
#define cWdwTop        "StatWindowStart"
#define cWdwOpen       "StatWindowOpen"
#define cUseTmp        "UseTempPath"
#define cTmpLock       "UseOwnTempPath"
#define cDeselAfterDel "DeselectGroupsAfterDelete"
#define cDeleteMsgWithoutComment     "DeleteMsgWithoutComment"
#define cTmpDir        "TmpDir"
#define cIconify       "IconifyEnabled"


GLOBAL _VOID PutzRsc_SaveParameter(CONST _UBYTE *dataPath)
{
	_UBYTE infName[PATH_MAX];

	CatGlobal_busyMouse();

	PutzGr_SaveSelectedState(&putzList);
	/* Und jetzt die Default-Optionen */
	PutzDo_SetGroupFlags("Default", &defaultOpts);

	/* Jetzt noch die anderen Parameter */
	ConfVars_SetConfigBool(cUseTmp, defaultOpts.useTmp);
	ConfVars_SetConfigBool(cTmpLock, defaultOpts.tmpLock);
	ConfVars_SetConfigBool(cDeselAfterDel, defaultOpts.deselAfterDel);
	ConfVars_SetConfigString(cTmpDir, defaultOpts.tmpDir);
	ConfVars_SetConfigBool(cDeleteMsgWithoutComment, defaultOpts.delWithoutComm);
	ConfVars_SetConfigBool(cAutoSaveOptions, AutoSaveOptions);
	
	strBcpy(infName, dataPath);
	F_Path_Append(infName, parameterFile);
	
	/* Und jetzt schreiben */
	ConfVars_WriteConfigFile(infName, writeInfo);
	
	MouseArrow();
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID PutzRsc_LoadParameter(CONST _UBYTE *dataPath)
{
	_UBYTE name[PATH_MAX];
	_BOOL boolVal;
	_BOOL ok;
	
	CatGlobal_busyMouse();
	
	Alias_Exit();
	ConfVars_DeleteAllVars();
	
	strBcpy(name, dataPath);
	F_Path_Append(name, parameterFile);
	
	ok = ConfVars_ReadConfigFile(name);
	if (!ok)
	{
		strBcpy(name, parameterFile);
		ok = F_Path_Get_User(name, parameterFile);
		if (ok)
			ok = ConfVars_ReadConfigFile(name);
	}
	if (!ok)
	{
		F_Path_Get_Work(name, parameterFile);
		ok = ConfVars_ReadConfigFile(name);
	}
	if (!ok)
	{
		MouseArrow();
		return;
	}
	
	/* Pruefen, wie die Alerts aussehen sollen */
	ConfVars_GetConfDefBool(cAlertsInWindow, &boolVal, FALSE);
	WinDials_AlertsInWindow(boolVal);
	
/*DYJ 5.36g Start*/
	PutzDo_GetGroupFlags("Default", FALSE, &defaultOpts,ignoreFlag);
/*DYJ  Ende; alt:	
	PutzDo_GetGroupFlags("Default", FALSE, &defaultOpts);
*/
	
	ConfVars_GetConfDefBool(cUseTmp, &defaultOpts.useTmp, defaultOpts.useTmp);
	ConfVars_GetConfDefBool(cTmpLock, &defaultOpts.tmpLock, defaultOpts.tmpLock);
	ConfVars_GetConfDefBool(cDeselAfterDel, &defaultOpts.deselAfterDel, defaultOpts.deselAfterDel);
	ConfVars_GetConfDefBool(cDeleteMsgWithoutComment, &defaultOpts.delWithoutComm, defaultOpts.delWithoutComm);
	ConfVars_GetConfDefStr(cTmpDir, defaultOpts.tmpDir, sizeof(defaultOpts.tmpDir), defaultOpts.tmpDir);
	
	/* Pruefen, ob wir in der Mint-Domain laufen sollen */
	ConfVars_GetConfDefBool(cMiNTDomain, &boolVal, TRUE);
	if (boolVal)
	{
		(_VOID)Pdomain(1);
		isMiNTDomain = Pdomain(-1) > 0;
	} else
	{
		(_VOID)Pdomain(0);
		isMiNTDomain = FALSE;
	}
	ConfVars_GetConfDefBool(cAutoSaveOptions, &AutoSaveOptions, FALSE);
	
	Alias_Init();
	MouseArrow();
}

/*** ---------------------------------------------------------------------- ***/

/*DYJ 5.22a Start*/
GLOBAL _BOOL PutzRsc_InitResource(_VOID)
{
	_UBYTE nameEnd[20],scrap[PATH_MAX];
/*DYJ  Ende; alt:	
GLOBAL _BOOL PutzRsc_InitResource(CONST _UBYTE *resourceName)
{
*/
	_UWORD screenColumns;
	_UBYTE rscString[PATH_MAX];
	OBJECT *wdwIcon;
	
	/* 80-Zeichen Bildschirm wird verlangt! */
	screenColumns = MaxWidth / CharWidth;
	
	if (screenColumns < 80)
	{
/*DYJ 5.23e Start*/
		mtAlerts_Alert(1, Rsc_WrkString(AL_RESOLUTION));
/*DYJ  Ende; alt:	
		mtAlerts_Alert(1, noLowResAlt);
*/
		return FALSE;
	}
	/* Resource laden und Baumaddressen ermitteln */
/*DYJ 5.21i Start*/
	{
/*DYJ 5.22a + 5.22f Start*/
		_UBYTE rsrcname[PATH_MAX];
/*DYJ  Ende; alt:	
		_UBYTE *lang,nameEnd[20],scrap[PATH_MAX],rsrcname[PATH_MAX];
*/
/*DYJ 5.22f Start*/
		CatGlobal_ApplPath(scrap);
		Rsc_EnvLang(scrap,nameEnd);
/*DYJ  Ende; alt:	
		TEXTFILENO tf;

		CatGlobal_ApplPath(scrap);
		if ((lang = getenv("CAT_LANG")) != NULL && *lang != '\0')
			strCpy(nameEnd,lang);
		else if (mtTextfiles_OpenTextfile(CAT_LANG_FILE, READ, 512, &tf) == GERR_OK)
		{
			mtTextfiles_ReadLine(tf, nameEnd, 5);
			mtTextfiles_CloseTextfile(&tf);
		}
		else
			strCpy(nameEnd,LANGUAGE_DE);
*/
		strCat(nameEnd,RSC_EXT);

		strCpy(rsrcname, CATL_RSC_BASE);
		strCat(rsrcname,nameEnd);

		if(!Rsc_RscInit(scrap,rsrcname))
		{
			sprintf(scrap,"[3][%%P|Konnte %s nicht laden|Could'nt load %s][OK]",rsrcname,rsrcname);
			mtAlerts_Alert(1,scrap);
			return FALSE;
		}
	}
/*DYJ  Ende;*/
/*DYJ 5.22a Start*/
	strCpy(rscString, CATP_RSC_BASE);
	strCat(rscString,nameEnd);

	if ((theRSC = RscLoad(rscString)) == NULL)
	{
		F_Path_Append(scrap, rscString);
		theRSC = RscLoad(scrap);
	}
/*DYJ  Ende; alt:	
	theRSC = RscLoad(resourceName);
	if (theRSC == NULL)
	{
		F_Path_Get_Work(rscString, resourceName);
		theRSC = RscLoad(rscString);
	}
	if (theRSC == NULL)
	{
		/* Test auf Develop-Resource */
		F_Path_Get_Work(rscString, RscName2);
		theRSC = RscLoad(rscString);
	}
*/
	if (theRSC == NULL)
	{
/*DYJ 5.21i Start*/
		_UBYTE scrap[100];
		mtAlerts_SetIconColor(RED);
/*DYJ 5.22a Start*/
		sprintf(scrap,Rsc_WrkString(AL_NO_RSC),rscString);
/*DYJ  Ende; alt:	
		sprintf(scrap,Rsc_WrkString(AL_NO_RSC),resourceName);
*/
		mtAlerts_Alert(1,scrap );
/*DYJ  Ende; alt:	
		mtAlerts_SetIconColor(RED);
		mtAlerts_Alert(1, noRscAlt);
*/
		mtAlerts_SetIconColor(BLACK);
		return FALSE;
	}
	
	CatGlobal_busyMouse();
	
	selectBox = RscGaddr(theRSC, R_TREE, SELECTBX);
	selectBox2 = RscGaddr(theRSC, R_TREE, SELECTBX2);	/*DYJ 5.36g */
	helpBox   = RscGaddr(theRSC, R_TREE, HELPBOX);
	infoBox   = RscGaddr(theRSC, R_TREE, INFOBOX);
	pathBox   = RscGaddr(theRSC, R_TREE, PARAMBOX);
	info2Box  = RscGaddr(theRSC, R_TREE, INFOBOX2);
	optBox    = RscGaddr(theRSC, R_TREE, OPTIONBX);
	actBox    = RscGaddr(theRSC, R_TREE, ACTIONBX);
	imBox    = RscGaddr(theRSC, R_TREE, IMPORT);
	wdwIcon   = RscGaddr(theRSC, R_TREE, PUTZICON);
	menu      = RscGaddr(theRSC, R_TREE, MENU);
	
	/* Versionsnummer einsetzen */
	SetObjcString(infoBox, VERSION, CATPUTZ_VERSION);
	SetObjcString(infoBox, VDATE, CATPUTZ_DATE);
	
	/* Bit Images anpassen */
	
	transObj(infoBox, THECAT0, VDIHandle);
	transObj(infoBox, THECAT1, VDIHandle);
	transObj(infoBox, THECAT2, VDIHandle);
	transObj(infoBox, THEPUTZ, VDIHandle);
	transObj(wdwIcon, APP_ICON, VDIHandle);
	
	/* Infoslider anpassen: Fuellmuster auf solid setzen */
	if (Bitplanes > 1)
	{
		OBSPEC_SET_INTERIORCOL(actBox[INFOSLID].ob_spec, RED);
		OBSPEC_SET_FILLPATTERN(actBox[INFOSLID].ob_spec, 7);
		OBSPEC_SET_INTERIORCOL(imBox[FILL].ob_spec, RED);
		OBSPEC_SET_FILLPATTERN(imBox[FILL].ob_spec, 7);
	}
	
	WdwManager_SetWindowIcon(wdwIcon);
	
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID PutzRsc_doInfo(_VOID)
{
	if (DoSimpleBox(infoBox) == INFOINFO)
		DoSimpleBox(info2Box);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID PutzRsc_ClrRsrc(_VOID)
{
	RscFreeLib();	/*DYJ 5.27a */
	if (theRSC)
	{
		RscFree(theRSC);
		theRSC = NULL;
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID optsGetSetValues(OBJECT *tree, _VOID *special, _BOOL set, _WORD exit)
{
	putzOptsRec *putzOpts;

	putzOpts = special;
	if (set)
	{
		EnableObjState(tree, ODELDATE, SELECTED, putzOpts->deleteByDate);
		EnableObjState(tree, ODATESTR, DISABLED, !putzOpts->deleteByDate);
		EnableObjFlags(tree, ODATESTR, EDITABLE, putzOpts->deleteByDate);
		SetObjcString(tree, ODATESTR, putzOpts->dateStr);
		VDIUtil_SetXState(tree, IFLGSEL , putzOpts->intFlag);
		VDIUtil_SetXState(tree, UFLG1SL1, putzOpts->usrFlg1);
		VDIUtil_SetXState(tree, UFLG2SL1, putzOpts->usrFlg2);
		VDIUtil_SetXState(tree, RDFLGSL1, putzOpts->readFlg);
		VDIUtil_SetXState(tree, FILTFLG1, putzOpts->filtFlg);
		VDIUtil_SetXState(tree, NORDFLG1, putzOpts->noRdFlg);
		VDIUtil_SetXState(tree, NOANSFLG1, putzOpts->noAnsFlg);	/*DYJ 5.36g */
		VDIUtil_SetXString(tree, IFLGSEL , selectBox, putzOpts->intFlag);
		VDIUtil_SetXString(tree, UFLG1SL1, selectBox, putzOpts->usrFlg1);
		VDIUtil_SetXString(tree, UFLG2SL1, selectBox, putzOpts->usrFlg2);
		VDIUtil_SetXString(tree, RDFLGSL1, selectBox, putzOpts->readFlg);
		VDIUtil_SetXString(tree, FILTFLG1, selectBox, putzOpts->filtFlg);
		VDIUtil_SetXString(tree, NORDFLG1, selectBox, putzOpts->noRdFlg);
		VDIUtil_SetXString(tree, NOANSFLG1, selectBox2, putzOpts->noAnsFlg);	/*DYJ 5.36g */
	} else
	{
		exit &= 0x7fff;
		if (exit == OOK)
		{
			putzOpts->intFlag = (delState)VDIUtil_GetXState(tree, IFLGSEL);
			putzOpts->usrFlg1 = (delState)VDIUtil_GetXState(tree, UFLG1SL1);
			putzOpts->usrFlg2 = (delState)VDIUtil_GetXState(tree, UFLG2SL1);
			putzOpts->readFlg = (delState)VDIUtil_GetXState(tree, RDFLGSL1);
			putzOpts->filtFlg = (delState)VDIUtil_GetXState(tree, FILTFLG1);
			putzOpts->noRdFlg = (delState)VDIUtil_GetXState(tree, NORDFLG1);
			putzOpts->noAnsFlg = (delState)VDIUtil_GetXState(tree, NOANSFLG1);	/*DYJ 5.36g */
			putzOpts->deleteByDate = GetObjState(tree, ODELDATE, SELECTED);
			ObjcString(tree, ODATESTR, putzOpts->dateStr, sizeof(putzOpts->dateStr));
			putzOpts->delDate = ConvertDate_StrToDate(putzOpts->dateStr);
		}
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL optsButton(OBJECT *tree, _VOID *special, _WORD button, _WORD mx, _WORD my, _UWORD kstate, _WORD clicks)
{
	_WORD but;
	_UBYTE dStr[30];
	_BOOL allOk;
	_WORD x, y;
	_WORD select;
	_BOOL dByDate;
	_WORD t;
	GRECT r;
	
	UNUSED(special);
	UNUSED(mx);
	UNUSED(my);
	UNUSED(kstate);
	UNUSED(clicks);
	
	but = button & 0x7fff;
	globalResButton = but;
	switch (but)
	{
	case IFLGSEL:
	case UFLG1SL1:
	case UFLG2SL1:
	case RDFLGSL1:
	case FILTFLG1:
	case NORDFLG1:
		objc_offset(tree, but, &x, &y);
		t = VDIUtil_GetXState(tree, but);
		select = mtPopups_TreePopup(selectBox, x, y, t) - 1;
		if (select >= 0)
		{
			VDIUtil_SetXState(tree, but, select);
			VDIUtil_SetXString(tree, but, selectBox, select);
			WinDials_WinDialDraw(tree, but, 0, &r, FALSE);
		}
		break;
		
/*DYJ 5.36g Start*/
	case NOANSFLG1:
		objc_offset(tree, but, &x, &y);
		t = VDIUtil_GetXState(tree, but);
		select = mtPopups_TreePopup(selectBox2, x, y, t) - 1;
		if (select >= 0)
		{
			VDIUtil_SetXState(tree, but, select);
			VDIUtil_SetXString(tree, but, selectBox2, select);
			WinDials_WinDialDraw(tree, but, 0, &r, FALSE);
		}
		break;
/*DYJ  Ende; */
	case IFLGSEL2:
	case UFLG1SL2:
	case UFLG2SL2:
	case RDFLGSL2:
	case FILTFLG2:
	case NORDFLG2:
		t = VDIUtil_GetXState(tree, but - 1);
		t = (t + 1) % 4;
		VDIUtil_SetXState(tree, but - 1, t);
#if 0
		{
			_UBYTE selStr[50];
			
			select = t;
			ObjcString(selectBox, select+1, selStr, sizeof(selStr));
			while (*selStr == ' ')
				strCpy(selStr, selStr + 1);	/*DYJ 5.20w */
			SetObjcString(tree, but-1, selStr);
		}
#else
		VDIUtil_SetXString(tree, but - 1, selectBox, t);
#endif
		WinDials_WinDialDraw(tree, but-1, 0, &r, FALSE);
		break;
/*DYJ 5.36g Start*/
	case NOANSFLG2:
		t = VDIUtil_GetXState(tree, but - 1);
		t = 1-t;
		VDIUtil_SetXState(tree, but - 1, t);
		VDIUtil_SetXString(tree, but - 1, selectBox2, t);
		WinDials_WinDialDraw(tree, but-1, 0, &r, FALSE);
		break;
/*DYJ  Ende; */
	
	case ODELDATE:
		dByDate = GetObjState(tree, ODELDATE, SELECTED);
		EnableObjState(tree, ODATESTR, DISABLED, !dByDate);
		EnableObjFlags(tree, ODATESTR, EDITABLE, dByDate);
		WinDials_WinDialDraw (tree, ODATESTR, ROOT, &r, FALSE);
		break;
	
	case OHILFE:
		/*
		mtDials_DialForm(tree, DDISABLE, &r, &r);
		DoSimpleBox(helpBox);
		mtDials_DialForm(tree, DENABLE, &r, &r);
		*/
		PutzHelp_DoHelp(PutzHelp_flags);
		DeselectButton(tree, but, TRUE);
		break;
	
	case OOK:
		ObjcString(tree, ODATESTR, dStr, sizeof(dStr));
		if (!GetObjState(tree, ODATESTR, DISABLED))
		{
			if (!ConvertDate_DateOk(dStr))
			{
				mtAlerts_Alert(1, PutzRsc_WrkString(illDate));	/*DYJ 5.23e */
				allOk = FALSE;
				DeselectButton(tree, but, TRUE);
			} else if (ConvertDate_StrToDate(dStr) > ConvertDate_CurrentDate())
			{
				mtAlerts_Alert(1, PutzRsc_WrkString(dateToLarge));	/*DYJ 5.23e */
				allOk = FALSE;
				DeselectButton(tree, but, TRUE);
			} else
			{
				allOk = TRUE;
			}
		} else
		{
			allOk = TRUE;
		}
		DelObjState(tree, but, SELECTED);
		if (allOk)
			return TRUE;
		break;
	
	case OQUIT:
		DelObjState(tree, but, SELECTED);
		return TRUE;
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _BOOL PutzRsc_doOptBox(_BOOL oneGroup, putzOptsRec *putzOpts)
{
	OBJECT *tree;
	
	tree = optBox;
	EnableObjFlags(tree, OPT_TITLE_DEFAULT, HIDETREE, oneGroup);
	EnableObjFlags(tree, OPT_TITLE_GROUP, HIDETREE, !oneGroup);
	SetObjFlags(tree, ODATESTR, EDITABLE);
	if (!WinDials_OpenWinDial(tree, TRUE,
		optsGetSetValues,
		optsGetSetValues,
		optsButton,
		WinDials_defDraw,
		NULL,
		putzOpts))
	{
		return FALSE;
	}
	WinDials_WinDialHandleEvents();
	return globalResButton == OOK;
}

/*** ---------------------------------------------------------------------- ***/

typedef struct {
	_UBYTE tempPath[PATH_MAX];
} pathEnv, *pathEnvPtr;


LOCAL _VOID pathGetSetValues(OBJECT *tree, _VOID *special, _BOOL set, _WORD exit)
{
	pathEnvPtr pEnv = special;
	
	if (set)
	{
		SetObjcString(tree, PBTNAME, pEnv->tempPath);
		EnableObjState(tree, PBUSETMP, SELECTED, defaultOpts.useTmp);
		EnableObjState(tree, PBLOCK, SELECTED, defaultOpts.tmpLock);
		EnableObjState(tree, PBDESEL, SELECTED, defaultOpts.deselAfterDel);
		EnableObjState(tree, PBDELPAR, SELECTED, defaultOpts.delWithoutComm);
		EnableObjState(tree, PBAUTOSAVE, SELECTED, AutoSaveOptions);
	} else
	{
		if ((exit & 0x7fff) == PBOK)
		{
			defaultOpts.useTmp = GetObjState(tree, PBUSETMP, SELECTED);
			defaultOpts.delWithoutComm = GetObjState(tree, PBDELPAR, SELECTED);
			defaultOpts.tmpLock = GetObjState(tree, PBLOCK, SELECTED);
			defaultOpts.deselAfterDel = GetObjState(tree, PBDESEL, SELECTED);
			AutoSaveOptions = GetObjState(tree, PBAUTOSAVE, SELECTED);
			strBcpy(defaultOpts.tmpDir, pEnv->tempPath);
			
			if (defaultOpts.useTmp)
				strBcpy(tmpPath, defaultOpts.tmpDir);
			else
				strBcpy(tmpPath, DataPath);
		}
		SFREE(pEnv);
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL getTmpPath(_UBYTE *s)
{
	_UBYTE targetPath[PATH_MAX];
	_UBYTE name[PATH_MAX];
	
	strBcpy(targetPath, s);
	F_Path_Append(targetPath, ALL_FILE_MASK);
	*name = '\0';
	if (!mtDir_GetDir(targetPath, name, PutzRsc_WrkString(FS_TMP_TITLE)))	/*DYJ 5.23e */
		return FALSE;
	F_Path_Dirname(targetPath);
	F_Path_Append(targetPath, "");
	strCpy(s, targetPath);	/*DYJ 5.20w */
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL pathButton(OBJECT *tree, _VOID *special, _WORD button, _WORD mx, _WORD my, _UWORD kstate, _WORD clicks)
{
	pathEnvPtr pEnv;
	_WORD but;
	GRECT r;
	
	UNUSED(mx);
	UNUSED(my);
	UNUSED(kstate);
	UNUSED(clicks);

	pEnv = special;
	but = button & 0x7fff;
	switch (but)
	{
	case PBOK:
	case PBQUIT:
		DeselectButton(tree, but, FALSE);
		return TRUE;
	case PBHELP:
		PutzHelp_DoHelp(PutzHelp_options);
		DeselectButton(tree, but, TRUE);
		break;
	case PBTNAME:
		if (getTmpPath(pEnv->tempPath))
		{
			SetObjcString(tree, but, pEnv->tempPath);
			WinDials_WinDialDraw(tree, but, 0, &r, FALSE);
		}
		break;
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID PutzRsc_doPathBox(_VOID)
{
	pathEnv *pEnv;
	
	pEnv = NEW(pathEnv, "PutzRsc_doPathBox");
	strBcpy(pEnv->tempPath, tmpPath);
	if (!WinDials_OpenWinDial(pathBox, FALSE,
		pathGetSetValues,
		pathGetSetValues,
		pathButton,
		WinDials_defDraw,
		NULL,
		pEnv))
	{
		SFREE(pEnv);
	}
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL OBJECT *PutzRsc_GetTreeAddr(_WORD tree)
{
	return RscGaddr(theRSC, R_TREE, tree);
}
/*** ------------------------------------------------------------------------ ***/
/*	_UBYTE *PutzRsc_WrkString(_WORD nr)											*/
/*	Ermittelt einen freien oder Alertstring aus der catp_*.rsc					*/
/*	Parameter:	nr:	die Stringnummer											*/
/*	Ergebnis:	der String														*/		
/*	14.3.03 von Dimitri Junker	DYJ 5.22a										*/
/*** ------------------------------------------------------------------------ ***/
GLOBAL _UBYTE *PutzRsc_WrkString(_WORD nr)
{
	static _UBYTE dummy[30];
	_UBYTE *ret;
	ret=*((_UBYTE **)RscGaddr(theRSC, R_FRSTR, nr));
	if(!ret)
	{
		ret=dummy;
		sprintf(ret,"[3][NO RSC;Nr:L%d][OK]",nr);
	}
	return ret;
}