/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */


#include <putzwind.h>
#include <mtappl.h>
#include <mtutils.h>
#include <mtdials.h>
#include <mttextfi.h>
#include <mtdir.h>
#include <mtalerts.h>
#include <portvdi.h>
#include <file_io.h>
#include <strconv.h>
#include <keyboard.h>
#include <ro_mem.h>
#include <protokol.h>

#include <fontsele.h>
#include <wdwmanag.h>
#include <rectfunc.h>
#include <catgloba.h>
#include <confvars.h>
#include <mtpaths.h>
#include <datasys.h>
#include <clip.h>

#include <putzdo.h>
#include <putzrsc.h>
#include <putzlist.h>
#include <putzgrou.h>
#include <putzgr.h>
#include <putzhelp.h>
#include <catputz.h>

#include <routinec.h>
#include <routines.h>	/*DYJ 5.20w */
#include <mtrsc.h>	/*DYJ 5.22a */
#include <catlib.h>	/*DYJ 5.22a */


grListEntry totalEntry;

_UBYTE tmpPath[PATH_MAX];

List putzList;   /* Eigene Liste mit allen Daten */

List groupList;   /* Liste der Gruppen aus GroupSelect */

List displayList;   /* Liste fuer die Anzeige */

/* Variablennamen */
#define cWdwRect     "StatWindowRect"
#define cWdwFont     "StatFont"
#define cWdwFontSize "StatFontSize"
#define cWdwTop      "StatWindowStart"
#define cWdwLineDist "StatWindowLineDist"
#define cWdwLeftOffs "StatWindowLeftOffset"
#define cWdwOpen     "StatWindowOpen"

  
typedef struct {
	List list;         /*  list with attr.s  */
	HWND wdw;
	HVDI vdi;
	_WORD font;
	_WORD fontSize;
	_BOOL fontScalable;
	_WORD charHeight;
	_WORD charWidth;
	_WORD windLines;
	_WORD maxWidth;
	_WORD startLine;
	_WORD leftOffset;
	GRECT currSize;
	GRECT butWork;
	_BOOL isHidden;
	_WORD lastOb;
	_BOOL isLocked;  /* Liste wird gerade veraendert */
} wlRec, *WdwPtr;

/* globale Variablen */
LOCAL _BOOL inOpen = FALSE;
LOCAL _WORD pixOff = 8;
LOCAL _WORD lineDist = 3;
LOCAL _WORD lineHeight = 2;
LOCAL _BOOL inDelete = FALSE;
        
LOCAL WdwPtr windows;
LOCAL OBJECT *butBox;


/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

LOCAL _VOID outputText(List *displayList, TEXTFILENO f, _BOOL isCsv)
{
	ptrDispEntry entry;
	_UBYTE str[256];
	_UWORD i;
	_WORD j, part, count;

	/* Ausgabe */
	CatGlobal_busyMouse();
	Lists_ResetList(displayList);
	i = 0;
	while ((entry = Lists_NextEntry(displayList)) != NULL)
	{
		++i;
		if (i % 7 == 0)
			CatGlobal_busyMouse();
		if (entry->type == separatorLine)
		{
			if (!isCsv)
			{
				count = PutzList_GetMaxLineWidth();
				if (count >= sizeof(str))
					count = (_WORD)sizeof(str) - 1;
				for (j = 0; j < count; j++)
					str[j] = '=';
				str[j] = '\0';
				mtTextfiles_WriteLine(f, str);
				mtTextfiles_WriteLn(f);
			}
		} else
		{
			count = PutzList_GetPartCount();
			for (part = 0; part < count; part++)
			{
				PutzList_GetPart(entry, part, str, sizeof(str), !isCsv);
				mtTextfiles_WriteLine(f, str);
				if (isCsv)
				{
					/* Separator schreiben */
					mtTextfiles_WriteLine(f, ",");
				}
			}
			mtTextfiles_WriteLn(f);
		}
	}
	/* File wieder schliessen */
	mtTextfiles_CloseTextfile(&f);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID OutputStat(WdwPtr ptr)
{
	TEXTFILENO tf;
	_UBYTE fName[PATH_MAX];
	_UBYTE fnShort[PATH_MAX];
	_UBYTE msg[256];
	_UBYTE targetPath[PATH_MAX];
	_WORD but;
	
	/* Filenamen erfragen */
	strBcpy(targetPath, DataPath);
	*fName = '\0';
	if (PutzGr_SelectFile(PutzRsc_WrkString(FS_OUTPUT_FILE), "*.txt", targetPath, fName, TRUE))
	{
		/* Datei anlegen */
		strCpy(fnShort, F_Path_Basename(fName));	/*DYJ 5.20w */
		if (F_File_Exists(fName))
		{
			/* File existiert, nachfragen */
			MouseArrow();
			sprintf(msg, PutzRsc_WrkString(AL_FILE_EXISTS), fnShort);
			but = mtAlerts_Alert(2, msg);
			if (but == 2)
			{
				if (mtTextfiles_OpenTextfile(fName, APPEND, 0, &tf) != GERR_OK)
					return;
			} else if (but == 1)
			{
				if (mtTextfiles_OpenTextfile(fName, WRITE, 0, &tf) != GERR_OK)
					return;
			} else
			{
				return;
			}
		} else
		{
			if (mtTextfiles_OpenTextfile(fName, WRITE, 0, &tf) != GERR_OK)
				return;
		}
		outputText(&ptr->list, tf, FALSE);
		MouseArrow();
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL ToClip(WdwPtr ptr)
{
	_UBYTE scrapPath[PATH_MAX];
	TEXTFILENO tf;
	_UBYTE fName[PATH_MAX];

	if (Clip_GetScrap(scrapPath))
	{
		Clip_ScrapClear(scrapPath, NULL);
		/* Datei anlegen */
		strCpy(fName, scrapPath);	/*DYJ 5.20w */
		F_Path_Append(fName, SCRAP_TXT);
		if (mtTextfiles_OpenTextfile(fName, WRITE, 0, &tf) != GERR_OK)
		{
/*DYJ 5.22a Start*/
			mtAlerts_Alert(1, Rsc_WrkString(AL_NO_SCRAP));
/*DYJ  Ende; alt:	
			mtAlerts_Alert(1, noClipAlt);
*/
			return FALSE;
		}
		outputText(&ptr->list, tf, FALSE);

		strCpy(fName, scrapPath);	/*DYJ 5.20w */
		F_Path_Append(fName, SCRAP_CSV);
		if (mtTextfiles_OpenTextfile(fName, WRITE, 0, &tf) != GERR_OK)
		{
/*DYJ 5.22a Start*/
			mtAlerts_Alert(1, Rsc_WrkString(AL_NO_SCRAP));
/*DYJ  Ende; alt:	
			mtAlerts_Alert(1, noClipAlt);
*/
			return FALSE;
		}
		outputText(&ptr->list, tf, TRUE);
		MouseArrow();
		Clip_ScrapWritten(SCF_DATABASE|SCF_TEXT, SCRAP_CSV);
		Protokoll_SendPathUpdate(scrapPath);
		return TRUE;
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL WdwPtr FindWindow(HWND wdw)
{
	if (windows != NULL)
		if (windows->wdw == wdw)
			return windows;
	return NULL;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL ptrDispEntry FindLine(WdwPtr ptr, _WORD line)
{
	List *l;
	_WORD i;
	ptrDispEntry entry;
	
	if (ptr != NULL)
	{
		l = &ptr->list;
		Lists_ResetList(l);
		i = 0;
		while ((entry = Lists_NextEntry(l)) != NULL && i < line)
			++i;
		return entry;
	}
	return NULL;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL LineIsSelectable(WdwPtr ptr, _WORD line)
{
	ptrDispEntry entry;
	
	entry = FindLine(ptr, line);
	return entry != NULL && entry->type == dataEntry && entry->data->info != NULL;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL LineIsSelected(WdwPtr ptr, _WORD line)
{
	ptrDispEntry entry;
	
	entry = FindLine(ptr, line);
	return entry != NULL && entry->type == dataEntry && entry->data != NULL && entry->data->selected;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID SelectLine(WdwPtr ptr, _WORD line)
{
	ptrDispEntry entry;
	
	entry = FindLine(ptr, line);
	if (entry != NULL && entry->data != NULL)
		entry->data->selected = !entry->data->selected;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID AdjustTreePos(CONST GRECT *r, GRECT *rt)
{
	butBox[ROOT].ob_x = r->g_x;
	butBox[ROOT].ob_y = r->g_y;
	butBox[ROOT].ob_width = r->g_w;
	rt->g_x = butBox[ROOT].ob_x;
	rt->g_y = butBox[ROOT].ob_y;
	rt->g_w = butBox[ROOT].ob_width;
	rt->g_h = butBox[ROOT].ob_height + 1;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID snapWdw(HWND wdw, _VOID *special, GRECT *work)
{
	WdwPtr wl;
	_WORD sLine;
	GRECT wdwSize;
#define minWindWidth 128
#define minWindHeight 48

	wl = special;
	AdjustTreePos(work, &wl->butWork);
	if (!inOpen)
	{
		work->g_h -= wl->butWork.g_h;
		++work->g_h;            /* Um Rundungsfehler zu vermeiden */
		work->g_h = ((work->g_h + lineDist) / (wl->charHeight + lineDist)) * (wl->charHeight + lineDist);
		while (work->g_w < minWindWidth)
			work->g_w += wl->charWidth;
		while (work->g_h < minWindHeight)
			work->g_h += wl->charHeight + lineDist;
		wl->windLines = (Min(work->g_y + work->g_h - 1, MaxHeight - 1) - work->g_y + 1) / (wl->charHeight + lineDist); 
		wl->currSize = *work;
		work->g_h += wl->butWork.g_h;
		WdwManager_SetScrollParms(wdw, work->g_w - wl->charWidth, wl->windLines - 1, wl->charWidth, 1,TRUE);
		PutzWindows_WindowParms(wdw, &wdwSize, &sLine);
		ConfVars_SetConfigInt(cWdwTop, sLine);
		ConfVars_SetConfigRect(cWdwRect, &wdwSize);
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID getScroll(HWND wdw, HVDI vdi, _VOID *special, GRECT *work)
{
	WdwPtr ptr;
	
	UNUSED(vdi);
	ptr = special;
	AdjustTreePos(work, &ptr->butWork);
	work->g_h -= ptr->butWork.g_h;
	work->g_y += ptr->butWork.g_h;
	ptr->windLines = (Min(work->g_y + work->g_h - 1, MaxHeight - 1) - work->g_y + 1) / (ptr->charHeight + lineDist); 
	WdwManager_SetScrollParms(wdw, work->g_w - ptr->charWidth, ptr->windLines - 1, ptr->charWidth, 1,TRUE);
	ptr->currSize = *work;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL topWdw(HWND wdw, _VOID *special)
{
	UNUSED(wdw);
	UNUSED(vdi);
	UNUSED(special);
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL closeWdw(HWND wdw, HVDI vdi, _VOID *special, _BOOL force)
{
	GRECT wdwSize;
	_WORD sLine;
	WdwPtr wl;
	
	UNUSED(force);
	PutzWindows_WindowParms(wdw, &wdwSize, &sLine);
	ConfVars_SetConfigInt(cWdwTop, sLine);
	ConfVars_SetConfigRect(cWdwRect, &wdwSize);
	ConfVars_SetConfigBool(cWdwOpen, FALSE);
	FontSelect_UnloadFonts(vdi);
	wl = special;
	OFREE(wl);
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

#if 0
LOCAL _UWORD countSelectedEntries(WdwPtr ptr)
{
	_UWORD counter;
	ptrDispEntry entry;
	
	Lists_ResetList(&ptr->list);
	counter = 0;
	while ((entry = Lists_NextEntry(&ptr->list)) != NULL)
	{
		if (entry->data != NULL && entry->data->selected)
			++counter;
	}
	return counter;
}
#endif

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID redrawEntry(WdwPtr ptr, _WORD line)
{
	GRECT rect;

	if (ptr->wdw < 0 || ptr->isHidden)
		return;
	/*
	IF (line < startLine) OR (line > startLine + windLines + 1) THEN return END;
	*/
	rect = ptr->currSize;
	rect.g_x += pixOff;
	rect.g_y = rect.g_y + (line - ptr->startLine) * (ptr->charHeight + lineDist);
	rect.g_h = ptr->charHeight + lineDist;
	WdwManager_RedrawWdw(ptr->wdw, &rect);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID toggleEntry(WdwPtr ptr, _WORD entry)
{
	if (LineIsSelectable(ptr, entry))
	{
		SelectLine(ptr, entry);
		redrawEntry(ptr, entry);
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID redrawButton(HWND wdw, OBJECT *butBox, _WORD ob)
{
	GRECT r;
	
	ObjcPos(butBox, ob, &r.g_x, &r.g_y);
	--r.g_x;
	--r.g_y;
	r.g_w = butBox[ob].ob_width + 1;
	r.g_h = butBox[ob].ob_height + 1;
	WdwManager_RedrawWdw(wdw, &r);
}

/*** ---------------------------------------------------------------------- ***/

/* Enablet/disablet die Buttonleiste */
LOCAL _VOID careForButtons(WdwPtr ptr, _BOOL redraw)
{
	_WORD selectCount, rdwCount, i;
	_UWORD selSet;
	_UWORD disSet;
	_UBYTE str[256];

	selSet = 0;
	disSet = 0;
	for (i = DELMSGS; i <= SAVECONF; i++)
	{
		if (GetObjState(butBox, i, SELECTED))
			selSet |= 1 << i;
		if (GetObjState(butBox, i, DISABLED))
			disSet |= 1 << i;
	}
	/* selectCount = countSelectedEntries(ptr); */
	selectCount = PutzDo_CountSelectedEntries(&putzList);
	if (selectCount == 0)
	{
		SetObjcString(butBox, CTRLTEXT, PutzRsc_WrkString(noGroupSelTxt));
	} else if (selectCount == 1)
	{
		SetObjcString(butBox, CTRLTEXT, PutzRsc_WrkString(oneGroupSelTxt));
	} else
	{
		IntToStr(selectCount, 0, str, sizeof(str));
		strBcat(str, PutzRsc_WrkString(manyGroupSelTxt));
		SetObjcString(butBox, CTRLTEXT, str);
	}
	
	EnableObjState(butBox, DELMSGS, DISABLED, selectCount == 0);
	EnableObjState(butBox, DELGROUP, DISABLED, selectCount == 0);
	EnableObjState(butBox, CONFDEL, DISABLED, selectCount == 0);
	/* Alle neuzeichnen */
	if (redraw && ptr->wdw >= 0)
	{
		rdwCount = 0;
		for (i = DELMSGS; i <= SAVECONF; i++)
		{
			if ((GetObjState(butBox, i, SELECTED) != ((selSet & (1 << i)) != 0)) ||
				(GetObjState(butBox, i, DISABLED) != ((disSet & (1 << i)) != 0)))
			{
				++rdwCount;
			}
		}
		if (rdwCount < 5)
		{
			for (i = DELMSGS; i <= SAVECONF; i++)
			{
				if ((GetObjState(butBox, i, SELECTED) != ((selSet & (1 << i)) != 0)) ||
					(GetObjState(butBox, i, DISABLED) != ((disSet & (1 << i)) != 0)))
				{
					redrawButton(ptr->wdw, butBox, i); 
				}
			}
			redrawButton(ptr->wdw, butBox, CTRLTEXT);
		} else
		{
			redrawButton(ptr->wdw, butBox, ROOT);
		}
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID DoSelectFont(HWND wdw, HVDI vdi)
{
	FONT_ACCEPT_FUNC setFont;
	_WORD iFont, iFontSize;
	
	PutzWindows_GetWindowFont(wdw, &iFont, &iFontSize);
	if (WdwManager_AcceptsFonts(wdw, &setFont))
		W_Font_Select(vdi, iFont, iFontSize, NULL, FS_APPLY, setFont, wdw);
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _BOOL PutzWindows_SwitchInf(HWND wdw, _BOOL doFsel, CONST _UBYTE *newinf)
{
	WdwPtr ptr;
	_WORD iStartLine, iFont, iFontSize;
	GRECT wdwSize;
	_BOOL ok;
	
	ptr = FindWindow(wdw);
	if (ptr != NULL)
	{
		ptr->isLocked = TRUE;
		ok = PutzGr_ReadNewInf(doFsel, newinf);
		/* Fenster neu initialisieren 
		 * Font und Groesse 
		 */ 
		/* Variablen neu lesen */
		ConfVars_GetConfDefInt(cWdwFont, &iFont, 1);
		ConfVars_GetConfDefInt(cWdwFontSize, &iFontSize, 10);
		ConfVars_GetConfDefInt(cWdwTop, &iStartLine, 0);
		ConfVars_GetConfDefRect(cWdwRect, &wdwSize, &deskSize);
		ConfVars_GetConfDefInt(cWdwLineDist, &lineDist, 2);
		ConfVars_GetConfDefInt(cWdwLeftOffs, &pixOff, 8);
		/* Jetzt uebernehmen */
		ptr->list = displayList;
		WdwManager_SetWdwSize(ptr->wdw, &wdwSize);
		/* Font setzen */
		PutzWindows_SetWindowFont(ptr->wdw, iFont, iFontSize); 
		/* Und jetzt die Liste wechseln */
		ptr->startLine = iStartLine;
		ptr->isLocked = FALSE;
		if (ok)
			PutzGr_ReadSelectedState(&putzList);
		PutzWindows_SetNewList(ptr->wdw, &displayList);
		WdwManager_FullRedrawWdw(ptr->wdw);
		return TRUE;
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL handleButtons(WdwPtr ptr, _WORD ob)
{
	_WORD selectCount;
	grListEntry *grEntry;
	putzOptsRec putzOpts;
	_WORD iStartLine;
	GRECT wdwSize;
	
	if (GetObjState(butBox, ob, DISABLED) ||
		!GetObjFlags(butBox, ob, SELECTABLE))
		return FALSE;

	/* Button selektieren */
	SetObjState(butBox, ob, SELECTED);
	redrawButton(ptr->wdw, butBox, ob);
	Bounce();
	inDelete = TRUE;
	/* Selektierte Nachrichten zaehlen */
	selectCount = PutzDo_CountSelectedEntries(&putzList);
	switch (ob)
	{
	case SAVEAS:
		OutputStat(ptr);
		break;
	
	case COPYCLIP:
		ToClip(ptr);
		break;
	
	case SELALL:
		PutzWindows_SelectAll(ptr->wdw, TRUE);
		break;
	
	case SELNONE:
		PutzWindows_SelectAll(ptr->wdw, FALSE);
		break;
	
	case DELMSGS:
		if (mtAlerts_Alert(1, PutzRsc_WrkString(doDelAlt)) == 1)
		{
			PutzWindows_DeleteInGroups(ptr->wdw);
		}
		break;
	
	case DELGROUP:
		grEntry = PutzDo_FirstSelectedGroup(&putzList);
		while (grEntry != NULL)
		{
			grEntry->selected = FALSE;
			if (grEntry->info->catNumber != dataSys_private)
				PutzWindows_DeleteGroup(ptr->wdw, grEntry, FALSE);
			grEntry = PutzDo_FirstSelectedGroup(&putzList);
		}
		WdwManager_FullRedrawWdw(ptr->wdw);
		break;
	
	case CONFIG:
		if (selectCount == 0)
		{
			PutzRsc_doOptBox(FALSE, &defaultOpts);
		} else
		{
			if (selectCount == 1)
			{
				grEntry = PutzDo_FirstSelectedGroup(&putzList);
				PutzDo_InitGroupFlags(grEntry->info->catNumber, TRUE, &putzOpts);
			} else
			{
				putzOpts = defaultOpts;
			}
			/* Dialog ausfuehren */
			if (PutzRsc_doOptBox(TRUE, &putzOpts))
			{
				grEntry = PutzDo_FirstSelectedGroup(&putzList);
				while (grEntry != NULL)
				{
					/* Und jetzt noch die Konfigvariablen setzen */
					PutzDo_SetGroupNrFlags(grEntry->info->catNumber, &putzOpts);
					grEntry = PutzDo_NextSelectedGroup(&putzList, grEntry->info->catNumber);
				}
				WdwManager_FullRedrawWdw(ptr->wdw);
			}
		}
		break;
		
	case CONFDEL:
		if (selectCount > 0)
		{
			grEntry = PutzDo_FirstSelectedGroup(&putzList);
			while (grEntry != NULL)
			{
				/* Konfigvariablen loeschen */
				PutzDo_DeleteGroupFlags(grEntry->info->catNumber);
				grEntry = PutzDo_NextSelectedGroup(&putzList, grEntry->info->catNumber);
			}
			WdwManager_FullRedrawWdw(ptr->wdw);
		}
		break;
		
	case CONFOPT:
		PutzRsc_doPathBox();
		break;
		
	case FONTSEL:
		DoSelectFont(ptr->wdw, ptr->vdi);
		break;
	
	case LOADINF:
		PutzWindows_SwitchInf(ptr->wdw, TRUE, NULL);
		break;
		
	case SAVECONF:	/* Ein paar Parameter sichern */
		PutzWindows_WindowParms(ptr->wdw, &wdwSize, &iStartLine);
		ConfVars_SetConfigInt(cWdwTop, iStartLine);
		ConfVars_SetConfigRect(cWdwRect, &wdwSize);
		ConfVars_SetConfigBool(cWdwOpen, TRUE);
		PutzRsc_SaveParameter(DataPath);
		break;
	}
	careForButtons(ptr, TRUE);
	/* Button deselektieren */
	DelObjState(butBox, ob, SELECTED);
	redrawButton(ptr->wdw, butBox, ob);
	inDelete = FALSE;
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID selectArea(WdwPtr ptr, _WORD x, _WORD y)
{
	_WORD firstLine, lastLine, i;
	GRECT r, rect;
	_BOOL first;

	rect.g_x = x;
	rect.g_y = y;
	rect.g_w = 0;
	rect.g_h = 0;
	MouseFinger();
	graf_rubberbox(x, y, -32767, -32767, &rect.g_w, &rect.g_h);
	MouseArrow();
	
	if (rect.g_w < 0)
	{
		rect.g_x += rect.g_w;
		rect.g_w = -rect.g_w;
	}
	if (rect.g_h < 0)
	{
		rect.g_y += rect.g_h;
		rect.g_h = -rect.g_h;
	}
	/* clippen */
	rect = rc_clip(&rect, &ptr->currSize);
	rect.g_h = Min(rect.g_h, ptr->currSize.g_y + ptr->currSize.g_h - 1 - rect.g_y);
	
	/* Jetzt testen, ob selektierbarer Bereich geschnitten wurde */
	if ((rect.g_x - ptr->currSize.g_x < pixOff && rect.g_x + rect.g_w - ptr->currSize.g_x < pixOff) ||
		(rect.g_x - ptr->currSize.g_x > ptr->maxWidth * ptr->charWidth && rect.g_x + rect.g_w - ptr->currSize.g_x > ptr->maxWidth * ptr->charWidth))
	{
		return;
	}
	
	firstLine = (rect.g_y - ptr->currSize.g_y) / (ptr->charHeight + lineDist);
	lastLine  = (rect.g_y + rect.g_h - ptr->currSize.g_y) / (ptr->charHeight + lineDist);
	if (rect.g_x - ptr->currSize.g_x > pixOff || rect.g_x + rect.g_w - ptr->currSize.g_x > pixOff)
	{
		r = ptr->currSize;
		r.g_x += pixOff;
		r.g_h = ptr->charHeight + lineDist;
		first = TRUE;
		for (i = ptr->startLine + firstLine; i <= ptr->startLine + lastLine; i++)
		{
			if (i >= 0 && LineIsSelectable(ptr, i))
			{
				SelectLine(ptr, i);
				if (i >= ptr->startLine && i <= ptr->startLine + ptr->windLines)
				{
					/* redraw */
					if (first)
					{
						r.g_y = ptr->currSize.g_y + (i - ptr->startLine) * (ptr->charHeight + lineDist);
						first = FALSE;
					} else
					{
						r.g_h = ptr->currSize.g_y + (i - ptr->startLine + 1) * (ptr->charHeight + lineDist) - r.g_y;
					}
				}
			}
		}
		if (!first)
			WdwManager_RedrawWdw(ptr->wdw, &r);
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL clickInWindow(HWND wdw, _VOID *special, _WORD x, _WORD y, _UWORD kstate, _UWORD buts, _WORD clicks)
{
	WdwPtr ptr;
	_WORD transY;
	_WORD ob;
	_BOOL entrySelected;
	_WORD line;
	_UWORD but;

	UNUSED(wdw);
	UNUSED(clicks);
	if (inDelete)
		return FALSE;
	ptr = special;
	if (ptr->isLocked)
		return FALSE;
	if (!(buts & MOB_LEFT))
		return FALSE;
	if (rc_inside(x, y, &ptr->butWork))
	{
		ob = objc_find(butBox, ROOT, MAX_DEPTH, x, y);
		if (ob >= DELMSGS && ob <= SAVECONF)
			return handleButtons(ptr, ob);
	} else if (rc_inside(x, y, &ptr->currSize))
	{
		if (!(kstate & (K_LSHIFT | K_RSHIFT)))
		{
			/* deselectEntries(ptr); */
		}
		/* Zeile herausfinden */
		line = (y - ptr->currSize.g_y) / (ptr->charHeight + lineDist);
		transY = (y - ptr->currSize.g_y - (lineDist / 2));
		entrySelected = (transY >= line * (ptr->charHeight + lineDist)) &&
			(transY < ((line + 1) * ptr->charHeight + line * lineDist)) &&
			((x - ptr->currSize.g_x) >= pixOff) &&
			((x - ptr->currSize.g_x) <= ptr->maxWidth * ptr->charWidth);
		if (entrySelected)
		{
			toggleEntry(ptr, line + ptr->startLine);
			Bounce();
		} else
		{
			graf_mkstate(&x, &y, &but, &kstate);
			if (but & MOB_LEFT)
			{
				/* Graf-Rubberbox aufrufen */
				selectArea(ptr, x, y);
			}
		}
		careForButtons(ptr, TRUE);
		return TRUE;
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL CONST _UBYTE *GetString(_WORD ob)
{
	switch (ob)
	{
		case DELMSGS:    return PutzRsc_WrkString(STR_DELMSGS);
		case DELGROUP:   return PutzRsc_WrkString(STR_DELGROUP);
		case SELALL:     return PutzRsc_WrkString(STR_SELALL);
		case SELNONE:    return PutzRsc_WrkString(STR_SELNONE);
		case LOADINF:    return PutzRsc_WrkString(STR_LOADINF);
		case SAVEAS:     return PutzRsc_WrkString(STR_SAVEAS);
		case COPYCLIP:   return PutzRsc_WrkString(STR_COPYCLIP);
		case FONTSEL:    return PutzRsc_WrkString(STR_FONTSEL);
		case CONFIG:     return PutzRsc_WrkString(STR_CONFIG);
		case CONFDEL:    return PutzRsc_WrkString(STR_CONFDEL);
		case CONFOPT:    return PutzRsc_WrkString(STR_CONFOPT);
		case SAVECONF:   return PutzRsc_WrkString(STR_SAVECONF);
	}
	return "";
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL handleRect(HWND wdw, _VOID *special, _WORD which, _WORD mox, _WORD moy)
{
	WdwPtr ptr;
	_WORD ob;
	CONST _UBYTE *str;
	
	UNUSED(which);
	ptr = special;
	if (rc_inside(mox, moy, &ptr->butWork))
		ob = objc_find(butBox, ROOT, MAX_DEPTH, mox, moy);
	else
		ob = NIL;
	if (ptr->lastOb != ob)
	{
		ptr->lastOb = ob;
		str = GetString(ob);
		SetObjcString(butBox, FLYHELP, str);
		redrawButton(wdw, butBox, FLYHELP);
		return TRUE;
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL handlePutzKey(HWND wdw, _VOID *special, _WORD taste, _UBYTE ch, _UBYTE scan, _UWORD kstate)
{
	WdwPtr ptr;
	Key key;
	_BOOL done;
	LGRECT doc;
	
	UNUSED(scan);
	UNUSED(ch);
	ptr = special;
	GemCharToKey(taste,  kstate, &key);
	done = TRUE;
	if (IsSpecial(&key))
	{
		switch (SpecialKey(&key))
		{
		case home:
			ptr->startLine = 0;
			doc.x = ptr->leftOffset;
			doc.y = 0;
			doc.w = ptr->maxWidth * ptr->charWidth;
			doc.h = Lists_NoOfEntries(&ptr->list);
			WdwManager_SetWdwDocument(wdw, &doc);
			break;
		case clr:
			ptr->startLine = (_WORD)Lists_NoOfEntries(&ptr->list) - ptr->windLines + 1;
			doc.x = ptr->leftOffset;
			doc.y = ptr->startLine;
			doc.w = ptr->maxWidth * ptr->charWidth;
			doc.h = Lists_NoOfEntries(&ptr->list);
			WdwManager_SetWdwDocument(wdw, &doc);
			break;
		case left:
			WdwManager_ScrollLeft(wdw, 1);
			break;
		case soln:
			WdwManager_PageLeft(wdw);
			break;
		case right:
			WdwManager_ScrollRight(wdw, 1);
			break;
		case eoln:
			WdwManager_PageRight(wdw);
			break;
		case up:
			WdwManager_ScrollUp (wdw, 1);
			break;
		case down:
			WdwManager_ScrollDown(wdw, 1);
			break;
		case pgUp:
			WdwManager_PageUp(wdw);
			break;
		case pgDown:
			WdwManager_PageDown(wdw);
			break;
		case help:
			PutzHelp_DoHelp(PutzHelp_window);
			break;
		/* CatPutz-Keys */
		case ctrlD:
			return handleButtons(ptr, DELMSGS);
		case ctrlG:
			return handleButtons(ptr, DELGROUP);
		case ctrlA:
			return handleButtons(ptr, SELALL);
		case ctrlH:
			return handleButtons(ptr, SELNONE);
		case ctrlL:
			return handleButtons(ptr, LOADINF);
		case ctrlS:
			return handleButtons(ptr, SAVEAS);
		case ctrlC:
			return handleButtons(ptr, COPYCLIP);
		case altZ:
			return handleButtons(ptr, FONTSEL);
		case altF:
			return handleButtons(ptr, CONFIG);
		case altK:
			return handleButtons(ptr, CONFDEL);
		case altE:
			return handleButtons(ptr, CONFOPT);
		case altS:
			return handleButtons(ptr, SAVECONF);
		default:
			done = FALSE;
			break;
		}
	} else
	{
		done = FALSE;
	}
	return done;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _WORD GetTextWidth(WdwPtr ptr, CONST _UBYTE *str)
{
	_WORD extent[8];
	
	if (str[0] == '\0')
		return 0;
	if (ptr->fontScalable)
		vqt_f_extent(ptr->vdi, str, extent);
	else
		vqt_extent(ptr->vdi, str, extent);
	return extent[2] - extent[0];
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID drawWdw(HWND wdw, HVDI vdi, _VOID *special, CONST GRECT *frame)
{
	ptrDispEntry entry;
	_UBYTE str[256];
	_WORD part, xCoor, width, xOffset, yOutput, i, count;
	TextJustification just;
	GRECT clip;
	WdwPtr wl;
	GRECT fill;
	_WORD tWidth;
	_WORD tempX;

	UNUSED(wdw);
	
	wl = special;
	clip = *frame;
	if (rc_intersect(&wl->butWork, &clip))
	{
		careForButtons(wl, FALSE);
		mtDials_DialDraw(butBox, ROOT, MAX_DEPTH, &clip, TRUE);
		MouseOff(); /* weil DialDraw sie wieder eingeschaltet hat */
	}
	
	clip = *frame;
	if (rc_intersect(&wl->currSize, &clip))
	{
		clip = rc_clip(frame, &wl->currSize);
		AbsRect(&clip);
		vr_recfl(vdi, (_WORD *)&clip);
		
		if (!wl->isLocked)
		{
			if (clip.g_x == wl->currSize.g_x)
				clip.g_x += pixOff;
			
			clip.g_x = Min(clip.g_x, clip.g_w); /* ??? */
			
			WdwManager_SetClip(vdi, &clip, FALSE);
			
			Lists_ResetList(&wl->list);
			i = 0;
			while ((entry = Lists_NextEntry(&wl->list)) != NULL && i < wl->startLine)
				++i;

			i = 0;
			
			xCoor = wl->currSize.g_x + pixOff - wl->leftOffset;
			yOutput = wl->currSize.g_y + i * (wl->charHeight + lineDist) + (lineDist / 2);
			vsf_color(vdi, BLACK);
			while (entry != NULL && yOutput <= clip.g_h)
			{
				xOffset = 0;
				
				if (entry->type == separatorLine)
				{
					/* Linie zeichnen */
					fill.g_x = xCoor;
					fill.g_y = yOutput + (wl->charHeight / 2) - (lineHeight / 2);
					fill.g_w = xCoor + wl->maxWidth * wl->charWidth - 1;
					fill.g_h = fill.g_y + lineHeight - 1;
					/* Schreibmodus setzen */
					vswr_mode(vdi, MD_REPLACE);
					vr_recfl(vdi, (_WORD *)&fill);
					vswr_mode(vdi, MD_TRANS);
				} else
				{
					count = PutzList_GetPartCount();
					for (part = 0; part < count; part++)
					{
						width = PutzList_GetPartWidth(part);
						PutzList_GetPart(entry, part, str, sizeof(str), FALSE);
						just = PutzList_GetPartJustification(entry, part);
						/* Justification noch behandeln */
						if (just == justLeft)
						{
							/* vst_alignment(vdi, 0, 3, i, i); */
							v_gtext(vdi, xCoor + xOffset, yOutput + wl->charHeight - 1, str);
						} else if (just == justCenter)
						{
							tWidth = GetTextWidth(wl, str);
							tempX = xCoor + xOffset + (((width * wl->charWidth) - tWidth) / 2);
							/*  vst_alignment(vdi, 1, 3, i, i); */
							v_gtext(vdi, tempX, yOutput + wl->charHeight - 1, str);
						} else
						{
							tWidth = GetTextWidth(wl, str);
							tempX = xCoor + xOffset + (width * wl->charWidth) - tWidth - 1;
							/* vst_alignment(vdi, 2, 3, i, i); */
							v_gtext(vdi, tempX, yOutput + wl->charHeight - 1, str);
						}
						xOffset += (width + 2) * wl->charWidth;
					}
					
					if (entry->data != NULL && entry->data->selected)
					{
						fill.g_x = xCoor;
						fill.g_y = yOutput;
						fill.g_w = xCoor + wl->maxWidth * wl->charWidth - 1;
						fill.g_h = yOutput + wl->charHeight;
						/* Schreibmodus setzen */
						vswr_mode(vdi, MD_XOR);
						vr_recfl(vdi, (_WORD *)&fill);
						vswr_mode(vdi, MD_TRANS);
					}
				
				}
				
				entry = Lists_NextEntry(&wl->list);
				yOutput += wl->charHeight + lineDist;
			}
			vsf_color(vdi, WHITE);
		}
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID updateWdw(HWND wdw, _VOID *special, _BOOL begin)
{
	UNUSED(wdw);
	UNUSED(special);
	if (begin)
	{
		Wind_Update(BEG_UPDATE);
		MouseOff();
	} else
	{
		MouseOn();
		Wind_Update(END_UPDATE);
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID setWork(HWND wdw, _VOID *special, CONST LGRECT *doc, _BOOL slided)
{
	WdwPtr wl;
	
	UNUSED(wdw);
	UNUSED(doc);
	UNUSED(slided);
	wl = special;
	wl->startLine = (_WORD)doc->y;
	wl->leftOffset = (_WORD)doc->x;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID hideWdw(HWND wdw, _VOID *special, _BOOL hide)
{
	WdwPtr wl;

	UNUSED(wdw);
	wl = special;
	wl->isHidden = hide;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL PutzWindows_ChangeWindowFont(HWND wdw, _WORD font, _WORD fontSize, _BOOL isMono)
{
	UNUSED(isMono);
	PutzWindows_SetWindowFont(wdw, font, fontSize);
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID PutzWindows_OpenWindow(List *l, HWND *wdwHandle)
{
	_WORD i;
	WdwPtr wl;
	_BOOL mono;
	LGRECT doc;
	
	butBox = PutzRsc_GetTreeAddr(GROUPWDW);
	*wdwHandle = -1;
	wl = NEW(wlRec, "PutzWindows_OpenWindow");
	if (wl == NULL)
		return;
	MemSetZeroStruct(*wl);
	
	/* Defaults lesen */
	ConfVars_GetConfDefInt(cWdwFont, &wl->font, 1);
	ConfVars_GetConfDefInt(cWdwFontSize, &wl->fontSize, 10);
	ConfVars_GetConfDefInt(cWdwTop, &wl->startLine, 0);
	ConfVars_GetConfDefRect(cWdwRect, &wl->currSize, &deskSize);
	ConfVars_GetConfDefInt(cWdwLineDist, &lineDist, 2);
	ConfVars_GetConfDefInt(cWdwLeftOffs, &pixOff, 8);
	
	wl->wdw = -1;
	wl->vdi = -1;
	wl->list = *l;
	inOpen = TRUE;
	if (!WdwManager_OpenWindow(
		clickInWindow,
		handlePutzKey, 
		FUNK_NULL, /* timerproc */
		&deskSize,
		&wl->currSize,
		NAME | CLOSER | FULLER | MOVER | SIZER | UPARROW | DNARROW | VSLIDE | LFARROW | RTARROW | HSLIDE,
		TRUE,
		"",
		"CatPutz",
		snapWdw,
		closeWdw,
		drawWdw,
		topWdw,
		FUNK_NULL, /* top */
		updateWdw,
		setWork, 
		getScroll,
		hideWdw,
		pixOff,
		wl,
		FALSE,	/* onlyThisTop */
		TRUE,	/* showIt */
		TRUE,	/* supportIconify */
		TRUE,	/* openWorkStation */
		FALSE,
		&wl->wdw, &wl->vdi))
	{
		OFREE(wl);
		inOpen = FALSE;
		return;
	}
	WdwManager_SetWindowRectProc(wl->wdw, handleRect);
	ConfVars_SetConfigBool(cWdwOpen, TRUE);
	*wdwHandle = wl->wdw;
	wl->isHidden = FALSE;
	wl->isLocked = FALSE;
	FontSelect_LoadFonts(wl->vdi);
	
	FontSelect_SetFont(wl->vdi, &wl->font, &wl->fontSize, TRUE, 
		&mono, &wl->fontScalable, &wl->charWidth, &wl->charHeight);
	WdwManager_AcceptFont(wl->wdw, PutzWindows_ChangeWindowFont);
	
	/*
	FontSelect_FontSelect(wl->vdi, wl->font);
	wl->fontSize = FontSelect_FontSize(wl->vdi, wl->fontSize, i, i, &wl->charWidth, &wl->charHeight);
	*/
	SetObjcString(butBox, FLYHELP, "");
	wl->lastOb = -1;
	wl->leftOffset = 0;
	
	PutzList_SetMaxNameLength(PutzGr_MaxNameLength());
	wl->maxWidth = PutzList_GetMaxLineWidth() + (2 * PutzList_GetPartCount());
	vsf_style(wl->vdi, IP_SOLID);
	vsf_interior(wl->vdi, FIS_SOLID);
	vsf_color(wl->vdi, WHITE);
	/* Schreibmodus setzen */
	vswr_mode(wl->vdi, MD_REPLACE);
	/* Textalignment setzen */
	vst_alignment(wl->vdi, 0, 3, &i, &i);
	
	WdwManager_SnapWdw(wl->wdw);
	doc.x = wl->leftOffset;
	doc.y = wl->startLine;
	doc.w = wl->maxWidth * wl->charWidth;
	doc.h = Lists_NoOfEntries(&wl->list);
	WdwManager_SetNewDocument(wl->wdw, &doc, FALSE);
	WdwManager_SetDocumentParms(wl->wdw, 1, wl->charHeight + lineDist);
	WdwManager_SetScrollParms(wl->wdw, wl->currSize.g_w - wl->charWidth, wl->windLines-1, wl->charWidth, 1,TRUE);
	inOpen = FALSE;
	windows = wl;
}

/*** ---------------------------------------------------------------------- ***/

/* Gibt Groesse des Windows wl in size zurueck */
GLOBAL _VOID PutzWindows_WindowParms(HWND wdw, GRECT *size, _WORD *start)
{
	WdwPtr wl;
	
	wl = FindWindow(wdw);
	if (wl != NULL)
	{
		WdwManager_GetWdwSize(wl->wdw, size);
		if (size->g_x < 0 || size->g_y < 0 || size->g_w <= 0 || size->g_h <= 0)
			*size = deskSize;
		*start = wl->startLine;
	} else
	{
		*size = deskSize;
		*start = 0;
	}
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID PutzWindows_GetWindowFont(HWND wdw, _WORD *font, _WORD *fontSize)
{
	WdwPtr wl;
	
	wl = FindWindow(wdw);
	if (wl != NULL)
	{
		*font = wl->font;
		*fontSize = wl->fontSize;
	} else
	{
		*font = 1;
		*fontSize = 10;
	}
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID PutzWindows_SetWindowFont(HWND wdw, _WORD font, _WORD fontSize)
{
	WdwPtr wl;
	_BOOL mono;
	_WORD dummy;
	LGRECT doc;
	
	wl = FindWindow(wdw);
	if (wl != NULL)
	{
		wl->font = font;
		wl->fontSize = fontSize;
		FontSelect_SetFont(wl->vdi, &font, &fontSize, TRUE, 
			&mono, &wl->fontScalable, &wl->charWidth, &wl->charHeight);
		
		ConfVars_SetConfigInt(cWdwFont, wl->font);
		ConfVars_SetConfigInt(cWdwFontSize, wl->fontSize);
		/*
		FontSelect_FontSelect(wl->vdi, wl->font);
		wl->fontSize = FontSelect_FontSize(wl->vdi, wl->fontSize, &dummy, &dummy, &wl->charWidth, &wl->charHeight);
		*/
		/* Textalignment setzen */
		vst_alignment(wl->vdi, 0, 3, &dummy, &dummy);
		
		/* Redraw ausloesen */
		WdwManager_SetDocumentParms(wl->wdw, 1, wl->charHeight + lineDist);
		WdwManager_SnapWdw(wl->wdw);
		doc.x = wl->leftOffset;
		doc.y = wl->startLine;
		doc.w = wl->maxWidth * wl->charWidth;
		doc.h = Lists_NoOfEntries(&wl->list);
		WdwManager_SetNewDocument(wl->wdw, &doc, FALSE);
		WdwManager_FullRedrawWdw(wl->wdw);
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL FindEntryByAddr(WdwPtr wl, grListEntry *info, _WORD *line)
{
	ptrDispEntry entry;
	
	*line = 0;
	Lists_ResetList(&wl->list);
	while ((entry = Lists_NextEntry(&wl->list)) != NULL)
	{
		if (entry->type == dataEntry && entry->data == info)
			return TRUE;
		++(*line);
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID PutzWindows_SelectEntry(HWND wdw, grListEntry *entry, _BOOL select)
{
	WdwPtr wl;
	_WORD line;
	
	wl = FindWindow(wdw);
	if (wl != NULL)
	{
		if (FindEntryByAddr(wl, entry, &line))
		{
			if (LineIsSelectable(wl, line) && select != LineIsSelected(wl, line))
				SelectLine(wl, line);
		}
	}
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID PutzWindows_RedrawEntry(HWND wdw, grListEntry *entry)
{
	WdwPtr wl;
	_WORD line;
	
	wl = FindWindow(wdw);
	if (wl != NULL)
	{
		if (FindEntryByAddr(wl, entry, &line))
			redrawEntry(wl, line);
	}
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _VOID PutzWindows_SetNewList(HWND wdw, List *l)
{
	WdwPtr wl;
	LGRECT doc;
	
	wl = FindWindow(wdw);
	if (wl != NULL)
	{
		wl->list = *l;
		PutzList_SetMaxNameLength(PutzGr_MaxNameLength());
		wl->maxWidth = PutzList_GetMaxLineWidth() + (2 * PutzList_GetPartCount());
		doc.x = wl->leftOffset;
		doc.y = wl->startLine;
		doc.w = wl->maxWidth * wl->charWidth;
		doc.h = Lists_NoOfEntries(&wl->list);
		WdwManager_SetNewDocument(wl->wdw, &doc, FALSE);
	}
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _BOOL PutzWindows_IsPutzWindow(HWND wdw)
{
	return FindWindow(wdw) != NULL;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _BOOL PutzWindows_DeleteGroup(HWND wdw, grListEntry *group, _BOOL noConfirm)
{
	_BOOL result;
	
	inDelete = TRUE;
	result = PutzGroup_deleteGroup(group, noConfirm);
	if (result)
	{
		/* Displayliste neu aufbauen */
		if (PutzWindows_IsPutzWindow(wdw))
		{
			PutzGr_ClearDisplayList(TRUE);
			PutzGr_BuildDisplayList(&displayList);
			PutzDo_CalcTotals();
			PutzWindows_SetNewList(wdw, &displayList);
		}
	}
	inDelete = FALSE;
	return result;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _BOOL PutzWindows_Save(HWND wdw, CONST _UBYTE *fName, _BOOL toclip)
{
	TEXTFILENO tf;
	WdwPtr ptr;
	
	ptr = FindWindow(wdw);
	if (ptr != NULL)
	{
		if (toclip)
		{
			ToClip(ptr);
		} else
		{
			if (mtTextfiles_OpenTextfile(fName, WRITE, 0, &tf) == GERR_OK)
			{
				outputText(&ptr->list, tf, FALSE);
				MouseArrow();
				return TRUE;
			}
		}
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _BOOL PutzWindows_SelectAll(HWND wdw, _BOOL select)
{
	WdwPtr ptr;
	
	ptr = FindWindow(wdw);
	if (ptr != NULL)
	{
		PutzDo_SelectAll(select);
		WdwManager_RedrawWdw(wdw, &ptr->currSize);
		return TRUE;
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _BOOL PutzWindows_DeleteInGroups(HWND wdw)
{
	WdwPtr ptr;
	
	ptr = FindWindow(wdw);
	if (ptr != NULL)
	{
		inDelete = TRUE;
		Wind_Update(END_UPDATE);
		PutzDo_InitDelete(ptr->wdw); 
		Wind_Update(BEG_UPDATE);
		inDelete = FALSE;
		WdwManager_FullRedrawWdw(ptr->wdw);
		return TRUE;
	}
	return FALSE;
}
