/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziert
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */


#include "bubble.h"
#include <mtappl.h>
#include <mtrsc.h>
#include <protokol.h>
#include <ro_mem.h>
#include <termproc.h>
#include <routines.h>	/*DYJ 5.20w */

#define BUBBLEGEM_REQUEST 0xbaba
#define BUBBLEGEM_SHOW    0xbabb
#define BUBBLEGEM_ACK     0xbabc
#define BUBBLEGEM_ASKFONT 0xbabd
#define BUBBLEGEM_FONT    0xbabe
#define BUBBLEGEM_HIDE    0xbabf

LOCAL _UBYTE *globalMem;
LOCAL CONST _UBYTE *(*GetBubbleText)(HWND win, _WORD x, _WORD y, _UWORD kstate);

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

GLOBAL _BOOL Bubble_Call(HWND win, _WORD x, _WORD y, _UWORD kstate)
{
	_WORD apid;
	CONST _UBYTE *text;
	
	apid = appl_locate("BUBBLE", FALSE);
	if (apid < 0)
		apid = appl_locate(getenv("BUBBLEGEM"), TRUE);
	if (apid < 0)
		return FALSE;
	if (globalMem != NULL)
		return FALSE;
	if ((text = GetBubbleText(win, x, y, kstate)) != NULL)
	{
		globalMem = SYSMALLOC(strLen(text) + 1, MEM_SHARABLE, "Bubble_Call");	/*DYJ 5.20w */
		if (globalMem == NULL)
			return FALSE;
		strCpy(globalMem, text);	/*DYJ 5.20w */
		Protokoll_Send(apid, BUBBLEGEM_SHOW, x, y, PROT_NAMEPTR(globalMem), 0);
		return TRUE;
	}
	return FALSE;
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

LOCAL _BOOL bubbleMessage(CONST _WORD *message)
{
	if ((_UWORD)message[0] == BUBBLEGEM_ACK)
	{
		if (globalMem != NULL)
		{
			SFREE(globalMem);
			globalMem = NULL;
		}
	} else if ((_UWORD)message[0] == BUBBLEGEM_REQUEST)
	{
		Bubble_Call(message[3], message[4], message[5], message[6]);
	} else
	{
		return FALSE;
	}
	return TRUE;
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

LOCAL _VOID Bubble_Exit(_VOID)
{
	if (globalMem != NULL)
	{
		SFREE(globalMem);
		globalMem = NULL;
	}
}

/*** ---------------------------------------------------------------------- ***/

GLOBAL _BOOL Bubble_Init(CONST _UBYTE *(*getBubbleText)(HWND win, _WORD x, _WORD y, _UWORD kstate))
{
	InstallTermproc(Bubble_Exit);
	Protokoll_Handle_Message(bubbleMessage);
	GetBubbleText = getBubbleText;
	return TRUE;
}

