/*
 * Diese Datei ist Teil des CAT-Projekts.
 *
 * CAT ist Freeware; es darf unter den Bedingungen der
 * CAT Public License weitergegeben und/oder modifiziertF
 * werden.
 *
 * Eine Kopie der CAT Public License liegt diesem Paket bei
 * (siehe CATPL.TXT).
 *
 * Copyright (c) 1997, Dirk Steins
 * Jegliche Veraenderung dieses Hinweises ist NICHT ERLAUBT.
 */

/*
 * Die vorliegende Version wurde nach C portiert von
 * Thorsten Otto (Thorsten_Otto@do.maus.ruhr.de)
 */

#include <catgloba.h>
#include <btrees.h>
#include <confvars.h>
#include <wdwmanag.h>
#include <mtpaths.h>
#include <userinfo.h>
#include <windials.h>
#include <listdl.h>
#include <vdiutil.h>
#include <rectfunc.h>
#include <protokol.h>
#include <tos.h>

#include <mtappl.h>
#include <mtdials.h>
#include <mtrsc.h>
#include <mtutils.h>
#include <mtalerts.h>
#include <mtpopups.h>
#include <protokol.h>
#include <groupsel.h>

#include "bubble.h"

#include <magicstr.h>
#include <portvdi.h>
#include <strconv.h>
#include <routinec.h>
#include <routines.h>
#include <file_io.h>
#include <debug.h>
#include <catfiles.h>

#include <useredit.h> 
#include <mtdir.h>
#include <catlib.h>	/*DYJ 5.23e */

#define ProgramDate "8.3.2001"
#define ProgramVersion "1.05"


GLOBAL _UBYTE ProgramName[] = "UserEdit";
GLOBAL _BOOL PrgHasDataBase=FALSE;		/*DYJ 5.26a */
GLOBAL _UBYTE HomePath[PATH_MAX];

#define USEREDIT_VERSION   "Useredit V " ProgramVersion
#define USEREDIT_WHATTEXT	 "@(#)" USEREDIT_VERSION " (c) 1998 Thorsten Otto"
#define USEREDIT_MENUNAME  "  UserEdit " USEREDIT_XVERSION

#define parameterFile    "useredit.cfg"
#define USEREDIT_DAT     "useredit.dat"
#define CATU_RSC_BASE	"usere_"			/*DYJ 5.23e */

typedef enum { normal, color, effect, path} varSType;
	
typedef union {
	_WORD intV;
	_LONG lintV;
	_UBYTE *strV;
	GRECT rectV;
	_BOOL boolV;
} varVal;

typedef struct _confVar {
	_UBYTE *v_name;
	varType type;
	_UBYTE *shortDesc;
	_UBYTE *longDesc;
	varVal defVal;
	_LONG minVal, maxVal;

	_UWORD flags;
#define V_FOUND    0x0001
#define V_INCAT    0x0002
#define V_AUTO     0x0004
#define V_TEMP     0x0008
#define V_OBSOLETE 0x0010
#define V_UNKNOWN  0x0020
#define V_MINVAL   0x0040
#define V_MAXVAL   0x0080
#define V_VARIABLE 0x0100
#define V_SELECTABLE	   0x0200

	_WORD grp;
#define GROUP_UNKNOWN   0
#define GROUP_ALLGEMEIN 1
#define GROUP_TAUSCH    2
#define GROUP_MSGLIST   3
#define GROUP_GRIN      4
#define GROUP_TREELIST  5
#define GROUP_EDITOR    6
#define GROUP_MESSAGE   7
#define GROUP_CHARS     "UATSNBEK"

	struct _confVar *desc;
	
	_BOOL selected;
	varVal val;
	varSType sType;
} confVar;

typedef struct {
	List vars;
	_WORD globalLength;
	OBJECT *tree;
	_BOOL allVars;
	_WORD sort;
	_WORD show;
	_BOOL changed;
	OBJECT *dialog;
	OBJECT *sortPopup;
	OBJECT *showPopup;
	confVar *lastVar;
	_VOID *lastSel;
	specialButHdler specials[11];
} CONFEDIT;

LOCAL RESOURCE the_rsc;
LOCAL List confVars;
LOCAL _BOOL quitProg;
LOCAL BTree usereditVars;
#define LEFT_OFF  2
#define LEFT_OFF2 4

/*DYJ 5.23e Start*/
/*DYJ  Ende; alt:	
#define AL_DAT_NOTFOUND      "[3][%P:|Daten-Datei " USEREDIT_DAT "|nicht gefunden.][[Abbruch]"
#define AL_DAT_ERR           "[3][%%P:|Fehler in " USEREDIT_DAT "|in Zeile %ld.][[Abbruch]"
#define AL_TYPE_ERR          "[3][%%P:|Falscher Typ bei|%s.][[Abbruch]"
#define AL_CHANGED           "[3][%P:|Einige Werte wurden|ge\204ndert!][[Sichern|[Verwerfen|:[Abbruch]"
#define AL_UNKNOWN_GROUP     "[3][%%P:|Unbekannte Gruppe %s in " USEREDIT_DAT "|in Zeile %ld.][[Weiter]"
#define AL_VAL_ERR           "[3][%%P:|Ung\201ltiger Wert in " USEREDIT_DAT "|in Zeile %ld.][[Weiter]"

#define FS_NO_DESCR          "(keine Beschreibung vorhanden)"
#define FS_UNKNOWN_VAR       "(unbekannte Variable)"
#define FS_LOAD_INF        "Konfiguration laden"
*/

#define cMintDomain          "MiNTDomain"
#define cWinAlerts           "AlertsInWindow"

#define cShowType            "ShowType"
#define cSortType            "SortType"
#define cShowAll             "ShowAllVars"

typedef struct {
	_WORD treeNum;
	_WORD obj;
	CONST _UBYTE *text;
	OBJECT *tree;
} BUBBLE_MSG;

LOCAL BUBBLE_MSG bubble_messages[] = {
	{ VAREDIT, SORT1,    "Sortierung \204ndern" },
	{ VAREDIT, SHOW1,    "Anzeige \204ndern" },
	/* { VAREDIT, VARBOX,   "Kurzbeschreibung der Variablen" }, */
	{ VAREDIT, VDEFAULT, "Hiermit kann die Variable wieder auf ihren Default-Wert zur\201ckgesetzt werden" },
	{ VAREDIT, VARSEL, "Hiermit kann die Variable ausgesucht werden (Fileselector,...)" },
	{ -1, 0, 0 }
};
#define BBL_HAKEN  "Mit einem H\204kchen wird hier angezeigt, da\236 diese Variable in der Datei gefunden wurde"
#define BBL_GRUPPE "Hier wird der Bereich angezeigt, zu der die Variable geh\224rt:|A = Allgemein|T = Tausch|S = Stichwortliste|N = Nachrichtenanzeige|B = Baumanzeige|E = Editor|K = Kommentarfenster"

LOCAL CONST _UBYTE *colornames[17] = {
	"Wei",
	"Schwarz",
	"Rot",
	"Grn",
	"Blau",
	"Zyan",
	"Gelb",
	"Magenta",
	"Grau",
	"Grau 2",
	"Rot 2",
	"Grn 2",
	"Blau 2",
	"Zyan 2",
	"Gelb 2",
	"Magenta 2",
	"Normal"
};

LOCAL CONST _UBYTE *effectnames[4] = {
	"Normal",
	"Bold",
	"Italic",
	"Light",
};

enum{SORT_TEXT,SORT_NAME,SORT_TYPE,SORT_GROUP,SORT_ANZ};
enum{SHOW_TEXT,SHOW_NAME,SHOW_ANZ};

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

LOCAL _VOID AdjustDialogSize(OBJECT *tree, _WORD type, _WORD size, _WORD minsize, _WORD lines, _WORD boxIndex, _WORD boxBack, _BOOL vertical)
{
	_WORD fac;
	_WORD max;
	_WORD min;
	GRECT root;
	_WORD diff;
	_WORD idx;
	
	if (vertical)
	{
		fac = CharHeight;
		max = deskSize.g_h;
	} else
	{
		fac = CharWidth;
		max = deskSize.g_w;
	}
	switch (type)
	{
	case 0:			/* nix veraendern, so lassen wie er ist */
		size = minsize;
		break;
	case 1:			/* size gibt einen Prozentwert an */
		size = (_WORD)(((_LONG)size * max) / 100);
		break;
	case 2:			/* size gibt die Anzahl der Zeichen an */
		size = size * fac;
		break;
	case 3:			/* size gibt die Anzahl der Pixel an */
		break;
	default:		/* Fehler! */
		return;
	}
	if (size < minsize)
		size = minsize;
	if (size > max)
		size = max;
	size = (size / fac) * fac; /* runden */
	ObjcArea(tree, ROOT, &root);
	if (vertical)
	{
		diff = size - root.g_h;
		fac *= lines;
		diff = ((tree[boxIndex].ob_height + diff) / fac) * fac - tree[boxIndex].ob_height;
		min = tree[boxBack].ob_y;
		idx = tree[ROOT].ob_head;
		while (idx != ROOT)
		{
			if ((tree[idx].ob_y +tree[idx].ob_height/4)>= min && idx != boxBack)
				tree[idx].ob_y += diff;
			idx = tree[idx].ob_next;
		}
		tree[boxIndex].ob_height += diff;
		tree[boxBack].ob_height += diff;
		tree[ROOT].ob_height += diff;
	} else
	{
		diff = size - root.g_w;
		min = tree[boxBack].ob_x;
		idx = tree[ROOT].ob_head;
		while (idx != ROOT)
		{
			if (tree[idx].ob_x > min && idx != boxBack)
				tree[idx].ob_x += diff;
			idx = tree[idx].ob_next;
		}
		tree[boxIndex].ob_width += diff;
		tree[boxBack].ob_width += diff;
		tree[ROOT].ob_width += diff;
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID writeInfo(TEXTFILENO inf)
{
	_UBYTE str[80];
	
	mtTextfiles_WriteLine(inf, "# ");
	mtTextfiles_WriteLine(inf, USEREDIT_WHATTEXT);
	mtTextfiles_WriteLn(inf);
	mtTextfiles_WriteLine(inf, "# configuration file");
	mtTextfiles_WriteLn(inf);
	T_Strlftime(str, sizeof(str), "# created %0a %d %m %Y, %H:%M:%S", T_Systime());
	mtTextfiles_WriteLine(inf, str);
	mtTextfiles_WriteLn(inf);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID SaveParameter(CONST _UBYTE *dataPath)
{
	_UBYTE infName[PATH_MAX];

	CatGlobal_busyMouse();

	ConfVars_SetConfigVarList(&usereditVars);
	strBcpy(infName, dataPath);
	F_Path_Append(infName, parameterFile);
	
	/* Und jetzt schreiben */
	ConfVars_WriteConfigFile(infName, writeInfo);
	
	ConfVars_ResetConfigVarList();
	MouseArrow();
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID LoadParameter(CONST _UBYTE *dataPath)
{
	_UBYTE name[PATH_MAX];
	_BOOL boolVal;
	
	CatGlobal_busyMouse();
	
	if (BTree_CreateBTree(&usereditVars,ConfVars_cmpVar))
	{
		ConfVars_SetConfigVarList(&usereditVars);
	
		strBcpy(name, dataPath);
		F_Path_Append(name, parameterFile);
		
		ConfVars_ReadConfigFile(name);
		
		/* Pruefen, wie die Alerts aussehen sollen */
		ConfVars_GetConfDefBool(cWinAlerts, &boolVal, FALSE);
		WinDials_AlertsInWindow(boolVal);
		
		/* Pruefen, ob wir in der Mint-Domain laufen sollen */
		ConfVars_GetConfDefBool(cMintDomain, &boolVal, TRUE);
		if (boolVal)
		{
			(_VOID)Pdomain(1);
		} else
		{
			(_VOID)Pdomain(0);
		}
		isMiNTDomain = Pdomain(-1) > 0;
	
		ConfVars_ResetConfigVarList();
	}
	MouseArrow();
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL RscInit(_VOID)
{
/*DYJ 5.23e Start*/
	_UBYTE nameEnd[20],scrap[PATH_MAX],rsrcname[PATH_MAX];

	CatGlobal_ApplPath(scrap);
	Rsc_EnvLang(scrap,nameEnd);
	strCat(nameEnd,RSC_EXT);

	strCpy(rsrcname, CATL_RSC_BASE);
	strCat(rsrcname,nameEnd);

	if(!Rsc_RscInit(scrap,rsrcname))
	{
		sprintf(scrap,"[3][%%P|Konnte %s nicht laden|Could'nt load %s][OK]",rsrcname,rsrcname);
		mtAlerts_Alert(1,scrap);
		return FALSE;
	}
	strCpy(rsrcname, CATU_RSC_BASE);
	strCat(rsrcname,nameEnd);
	the_rsc = RscLoad(rsrcname);
	if (the_rsc == NULL)
	{
		F_Path_Get_Work(scrap, rsrcname);
		the_rsc = RscLoad(scrap);
	}
	if (the_rsc == NULL)
	{
		_UBYTE scrap[100];
		mtAlerts_SetIconColor(RED);
		sprintf(scrap,Rsc_WrkString(AL_NO_RSC),rsrcname);
		mtAlerts_Alert(1,scrap );
		mtAlerts_SetIconColor(BLACK);
		return FALSE;
	}
/*DYJ  Ende; alt:	
	if ((the_rsc = RscLoad("useredit.rsc")) == NULL)
	{
		mtAlerts_Alert(1, "[3][%P:|Resource file|not found.][[Exit]");
		return FALSE;
	}
*/
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL CONST _UBYTE *getBubbleText(HWND win, _WORD x, _WORD y, _UWORD kstate)
{
	BUBBLE_MSG *msg;
	OBJECT *tree;
	_WORD obj;

	UNUSED(kstate);
	msg = bubble_messages;
	while (msg->treeNum >= 0)
	{
		tree = msg->tree;
		if (WinDials_IsWinDial(tree) == win)
		{
			obj = objc_find(tree, ROOT, MAX_DEPTH, x, y);
			/*
			 * ein paar Sonderbehandlungen
			 */
			if (msg->treeNum == VAREDIT && obj == VARBOX)
			{
				_WORD ox, oy;
				
				objc_offset(tree, VARBOX, &ox, &oy);
				x -= ox;
				if (x >= 0 && x < (LEFT_OFF * CharWidth))
					return BBL_HAKEN;
				else if (x >= (LEFT_OFF * CharWidth) && x < (LEFT_OFF2 * CharWidth))
					return BBL_GRUPPE;
			}
			while (msg->treeNum >= 0 && msg->tree == tree && obj != msg->obj)
				msg++;
			if (msg->tree == tree && msg->obj == obj)
			{
				return msg->text;
			}
		}
		msg++;
		while (msg->treeNum >= 0 && msg->tree == tree)
			msg++;
	}
	return NULL;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID bubble_init(_VOID)
{
	BUBBLE_MSG *messages;
	
	messages = bubble_messages;
	while (messages->treeNum >= 0)
	{
		messages->tree = RscGaddr(the_rsc, R_TREE, messages->treeNum);
		messages++;
	}
	Bubble_Init(getBubbleText);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID DeleteVar(_VOID *entry)
{
	confVar *v;
	
	v = entry;
	if (v != NULL)
	{
		if (v->v_name != NULL)
			SFREE(v->v_name);
		if (v == v->desc || v->desc == NULL)
		{
			if (v->shortDesc != NULL)
				SFREE(v->shortDesc);
			if (v->longDesc != NULL)
				SFREE(v->longDesc);
		}
		if (v->type == string)

		{
			if (v->val.strV != NULL)
				SFREE(v->val.strV);
			if (v == v->desc)
				if (v->defVal.strV != NULL)
					SFREE(v->defVal.strV);
		}
		OFREE(v);
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL ValueEqual(varType type, varVal *val1, varVal *val2)
{
	switch (type)
	{
	case bool:
		return val1->boolV == val2->boolV;
	case sint:
		return val1->intV == val2->intV;
	case lint:
		return val1->lintV == val2->lintV;
	case rect:
		return rc_equal(&val1->rectV, &val2->rectV);
	case string:
		return strCmp(val1->strV, val2->strV) == 0;	/*DYJ 5.20w */
	case noVar:
	case comment:
		return FALSE;
	}
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL IsDefaultVal(confVar *v)
{
	return ValueEqual(v->type, &v->val, &v->defVal);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL Save_Vars(CONFEDIT *e)
{
	confVar *v;
	
	Lists_ResetList(&e->vars);
	while ((v = Lists_NextEntry(&e->vars)) != NULL)
	{
		if (IsDefaultVal(v) && !(v->flags & V_FOUND) && !(v->flags & V_UNKNOWN))
		{
			ConfVars_DeleteConfigVar(v->v_name);
		} else
		{
			switch (v->type)
			{
			case bool:
				if (!ConfVars_SetConfigBool(v->v_name, v->val.boolV))
					return FALSE;
				break;
			case sint:
				if (!ConfVars_SetConfigInt(v->v_name, v->val.intV))
					return FALSE;
				break;
			case lint:
				if (!ConfVars_SetConfigLongInt(v->v_name, v->val.lintV))
					return FALSE;
				break;
			case rect:
				if (!ConfVars_SetConfigRect(v->v_name, &v->val.rectV))
					return FALSE;
				break;
			case string:
				if (!ConfVars_SetConfigString(v->v_name, v->val.strV))
					return FALSE;
				break;
			case noVar:
			case comment:
				return FALSE;
			}
		}
	}
	UserInformation_WriteUserBlock();
	e->changed = FALSE;
	return TRUE;
}

/******************************************************************************/
/*** ---------------------------------------------------------------------- ***/
/******************************************************************************/

/* Userinterface */
/*** ------------------------------------------------------------------------ ***/
/*	_UBYTE *rsc_WrkString(_WORD nr)											*/
/*	Ermittelt einen freien oder Alertstring aus der usere_*.rsc					*/
/*	Parameter:	nr:	die Stringnummer											*/
/*	Ergebnis:	der String														*/		
/*	20.3.03 von Dimitri Junker	DYJ 5.23e										*/
/*** ------------------------------------------------------------------------ ***/
GLOBAL _UBYTE *rsc_WrkString(_WORD nr)
{
	static _UBYTE dummy[30];
	_UBYTE *ret;
	ret=*((_UBYTE **)RscGaddr(the_rsc, R_FRSTR, nr));
	if(!ret)
	{
		ret=dummy;
		sprintf(ret,"[3][NO RSC;Nr:L%d][OK]",nr);
	}
	return ret;
}

LOCAL _VOID lineToStr(_VOID *entry, _VOID *env, _UBYTE *str, size_t strsize)
{
	confVar *v;
	CONFEDIT *e;
	
	v = entry;
	if (v == NULL)
	{
		*str = '\0';
	} else
	{
		e = env;
		switch (e->show)
		{
		case SHOW_TEXT:
			strMcpy(str, strsize, v->shortDesc ? (const char *)v->shortDesc : rsc_WrkString(FS_NO_DESCR));		/*DYJ 5.23e */
			break;
		case SHOW_NAME:
			strMcpy(str, strsize, v->v_name);
			break;
		default:
			*str = '\0';
			break;
		}
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL selEntry(_VOID *entry, _VOID *env, _WORD line)
{
	confVar *v;

	UNUSED(env);
	UNUSED(line);
	v = entry;
	if (v != NULL)
		v->selected = !v->selected;
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL nameComp(CONST _VOID *a1, CONST _VOID *a2, _VOID *private)
{
	CONST confVar *v1 = *((CONST confVar * CONST *)a1);
	CONST confVar *v2 = *((CONST confVar * CONST *)a2);

	UNUSED(private);
	return strSortCmp(v1->v_name, v2->v_name) < 0;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL typeComp(CONST _VOID *a1, CONST _VOID *a2, _VOID *private)
{
	CONST confVar *v1 = *((CONST confVar * CONST *)a1);
	CONST confVar *v2 = *((CONST confVar * CONST *)a2);

	UNUSED(private);
	if (v1->type != v2->type)
		return v1->type < v2->type;
	if (v1->sType != v2->sType)
		return v1->sType < v2->sType;
	return strSortCmp(v1->v_name, v2->v_name) < 0;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL textComp(CONST _VOID *a1, CONST _VOID *a2, _VOID *private)
{
	CONST confVar *v1 = *((CONST confVar * CONST *)a1);
	CONST confVar *v2 = *((CONST confVar * CONST *)a2);
	CONST _UBYTE *s1;
	CONST _UBYTE *s2;
	
	UNUSED(private);
	s1 = v1->shortDesc;
	if (s1 == NULL)
		s1 = "";
	s2 = v2->shortDesc;
	if (s2 == NULL)
		s2 = "";
	return strSortCmp(s1, s2) < 0;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL groupComp(CONST _VOID *a1, CONST _VOID *a2, _VOID *private)
{
	CONST confVar *v1 = *((CONST confVar * CONST *)a1);
	CONST confVar *v2 = *((CONST confVar * CONST *)a2);
	CONST _UBYTE *s1;
	CONST _UBYTE *s2;
	_WORD res;
	
	UNUSED(private);
	if (v1->grp == v2->grp)
	{
		s1 = v1->shortDesc;
		if (s1 == NULL)
			s1 = "";
		s2 = v2->shortDesc;
		if (s2 == NULL)
			s2 = "";
		res = strSortCmp(s1, s2);
		if (res == 0)
			res = strSortCmp(v1->v_name, v2->v_name);
		return res < 0;
	}
	return v1->grp < v2->grp;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID sortList(List *l, _WORD sort)
{
	switch (sort)
	{
	case SORT_NAME:
		GroupSelect_SortAnyList(l, nameComp);
		break;
	case SORT_TYPE:
		GroupSelect_SortAnyList(l, typeComp);
		break;
	case SORT_TEXT:
		GroupSelect_SortAnyList(l, textComp);
		break;
	case SORT_GROUP:
		GroupSelect_SortAnyList(l, groupComp);
		break;
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL isSelected(_VOID *entry, _VOID *env)
{
	confVar *v;

	UNUSED(env);
	v = entry;
	if (v == NULL)
		return FALSE;
	return v->selected;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL isEnabled(_VOID *entry, _VOID *env)
{
	UNUSED(entry);
	UNUSED(env);
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID *nextEntry(_VOID *list)
{
	confVar *v;
	CONFEDIT *e;
	List *l;
	
	l = list;
	v = Lists_NextEntry(l);
	e = l->user;
	/* temporaere werden ueberhaupt nicht angezeigt */
	while (v != NULL && (v->flags & V_TEMP))
		v = Lists_NextEntry(l);
	if (!e->allVars)
	{
		while (v != NULL && (v->flags & (V_INCAT | V_AUTO | V_TEMP)))
			v = Lists_NextEntry(l);
	}
	return v;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID *prevEntry(_VOID *list)
{
	confVar *v;
	CONFEDIT *e;
	List *l;
	
	l = list;
	v = Lists_PrevEntry(l);
	e = l->user;
	/* temporaere werden ueberhaupt nicht angezeigt */
	while (v != NULL && (v->flags & V_TEMP))
		v = Lists_NextEntry(l);
	if (!e->allVars)
	{
		while (v != NULL && (v->flags & (V_INCAT | V_AUTO | V_TEMP)))
			v = Lists_PrevEntry(l);
	}
	return v;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID resetList(_VOID *list)
{
	Lists_ResetList(list);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID countEntries(_VOID *l, _LONG *ll, _WORD *ww)
{
	List *lp;
	CONFEDIT *e;
	_LONG count;
	
	lp = l;
	e = lp->user;
	*ww = e->globalLength * CharWidth;
	count = 0;
	resetList(lp);
	while (nextEntry(lp) != NULL)
		count++;
	*ll = count;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID drawEntry(_VOID *entry, _VOID *env, _WORD x, _WORD y, _WORD offset, CONST GRECT *clip)
{
	CONFEDIT *e;
	confVar *v;
	List *l;
	_UBYTE buf[256];
	_UBYTE num[30];
	_UWORD eff;
	_WORD fillcol;
	GRECT fill;
	_BOOL isSel;
	_WORD pxy[4];

	UNUSED(offset);
	l = env;
	e = l->user;

	fill.g_x = x;
	fill.g_y = y;
	fill.g_w = fill.g_x + e->globalLength * CharWidth - 1;
	fill.g_h = fill.g_y + CharHeight - 1;
	pxy[0] = clip->g_x;
	pxy[1] = clip->g_y;
	pxy[2] = clip->g_x + clip->g_w - 1;
	pxy[3] = clip->g_y + clip->g_h - 1;
	
	vs_clip(PrivateWS, TRUE, pxy);
	vswr_mode(PrivateWS, MD_REPLACE);

	fillcol = WHITE;
	isSel = FALSE;
	if (entry != NULL && isSelected(entry, env))
	{
		fillcol = BLACK;
		isSel = TRUE;
	}
	MouseOff();
	vsf_color(PrivateWS, fillcol);
	vr_recfl(PrivateWS, (_WORD *)&fill);
	
	if (entry != NULL)
	{
		v = entry;

		eff = TXT_NORMAL;
		if (v->flags & V_OBSOLETE)
			eff |= TXT_LIGHT;
		if (isSel)
			vswr_mode(PrivateWS, MD_XOR);
		vst_effects(PrivateWS, eff);

		v_gtext(PrivateWS, x, y, v->flags & V_FOUND ? "\010" : " ");

		buf[0] = GROUP_CHARS[v->grp];
		buf[1] = '\0';
		v_gtext(PrivateWS, x + LEFT_OFF * CharWidth, y, buf);
		x += LEFT_OFF2 * CharWidth;
		
		switch (e->show)
		{
		case SHOW_TEXT:
			if (v->shortDesc != NULL)
				v_gtext(PrivateWS, x, y, v->shortDesc);
			else
				v_gtext(PrivateWS, x, y, rsc_WrkString(FS_NO_DESCR));	/*DYJ 5.23e */
			break;
		case SHOW_NAME:
			strBcpy(buf, v->v_name);
			strFillRight(buf, sizeof(buf), 31);
			switch (v->type)
			{
			case bool:
				strBcat(buf, v->val.boolV ? "TRUE" : "FALSE");
				break;
			case sint:
				switch (v->sType)
				{
					case normal:
						IntToStr(v->val.intV, 0, num, sizeof(num));
						strBcat(buf, num);
						break;
					case color:
						strBcat(buf, colornames[v->val.intV % 17]);
						break;
					case effect:
						strBcat(buf, effectnames[v->val.intV % 4]);
						break;
				}
				break;
			case lint:
				IntToStr(v->val.lintV, 0, num, sizeof(num));
				strBcat(buf, num);
				break;
			case string:
				strBcat(buf, v->val.strV);
				break;
			case rect:
				sprintf(num, "{%d,%d,%d,%d}", v->val.rectV.g_x, v->val.rectV.g_y, v->val.rectV.g_w, v->val.rectV.g_h);
				strBcat(buf, num);
				break;
			case noVar:
			case comment:
				*buf = '\0';
				break;
			}
			v_gtext(PrivateWS, x, y, buf);
			break;
		}
		vst_effects(PrivateWS, 0);
		vswr_mode(PrivateWS, MD_REPLACE);
	}
	vs_clip(PrivateWS, FALSE, pxy);
	MouseOn();
}


/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID SetStrings(OBJECT *tree, _WORD from, _WORD to, CONST _UBYTE *string)
{
	_WORD i, entryLen, obIdx, dummy;
	_UBYTE str[256];
	_WORD l, advance, len;

	/* Alle Textfelder loeschen */
	for (i = from; i <= to; i++)
		SetObjcString(tree, i, "");
	i = 0;
	obIdx = from;
	l = (_WORD)strLen(string);	/*DYJ 5.20w */
	while (i < l && obIdx <= to)
	{
		ObjcStrLen(tree, obIdx, &entryLen, &dummy);
		Copy(string, i, entryLen, str, sizeof(str));
		--entryLen;
		advance = (_WORD)strLen(str);	/*DYJ 5.20w */
		len = advance;
		while (len > 0 && str[len-1] == ' ')
			--len;
		if (len == 0 || str[len] == ' ')
		{
			str[len] = '\0';
		} else
		{
			if (len >= entryLen && obIdx < to)
			{
				while (len > 0 && str[len-1] != ' ')
					--len;
				if (len > 0)
				{
					advance = len;
					str[len-1] = '\0';
				}
			}
		}
		SetObjcString(tree, obIdx, str);
		++obIdx;
		i += advance;
		while (i < l && string[i] == ' ')
			i++;
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID UpdateEntry(OBJECT *tree, confVar *v, _BOOL redraw)
{
	GRECT r;
	_UBYTE buf[256];
	_BOOL hideSelect=TRUE;
	
	if (v != NULL)
	{
		if (GetObjState(tree, VDEFAULT, DISABLED))
		{
			DelObjState(tree, VDEFAULT, DISABLED);
			if (redraw)
			{
				CalcArea(tree, VDEFAULT, &r);
				WinDials_WinDialDraw(tree, VDEFAULT, MAX_DEPTH, &r, TRUE);
			}
		}
		SetStrings(tree, HELPSTR1, HELPSTR4, v->longDesc ? (const char *)v->longDesc : "");
		if (redraw)
		{
			CalcArea(tree, HELPBOX, &r);
			WinDials_WinDialDraw(tree, HELPBOX, MAX_DEPTH, &r, TRUE);
			CalcArea(tree, VALUEBOX, &r);
		}
		switch (v->type)
		{
		case bool:
			DelObjFlags(tree, VALUE_BOOL, HIDETREE);
			SetObjcString(tree, VALUE_BOOL, v->v_name);
			EnableObjState(tree, VALUE_BOOL, SELECTED, v->val.boolV);
			tree[VALUE_BOOL].ob_width = tree[VALUEBOX].ob_width - tree[VALUE_BOOL].ob_x;
			if (redraw)
			{
				WinDials_WinDialDraw(tree, VALUEBOX, MAX_DEPTH, &r, TRUE);
				WinDials_WinEditChanged(tree, -1);
			}
			break;
		case sint:
			hideSelect=(v->sType==normal);
		case lint:
			if (v->type == lint)
				VDIUtil_SetLongIntStr(tree, VALUE_INT, v->val.lintV);
			else
				VDIUtil_SetIntStr(tree, VALUE_INT, v->val.intV);
			DelObjFlags(tree, VALUE_INT, HIDETREE);
			if (redraw)
			{
				WinDials_WinDialDraw(tree, VALUEBOX, MAX_DEPTH, &r, TRUE);
				WinDials_WinEditChanged(tree, VALUE_INT);
			}
			break;
		case rect:
			sprintf(buf, "%5d%5d%5d%5d", v->val.rectV.g_x, v->val.rectV.g_y, v->val.rectV.g_w, v->val.rectV.g_h);
			SetObjcString(tree, VALUE_GRECT, buf);
			DelObjFlags(tree, VALUE_GRECT, HIDETREE);
			if (redraw)
			{
				WinDials_WinDialDraw(tree, VALUEBOX, MAX_DEPTH, &r, TRUE);
				WinDials_WinEditChanged(tree, VALUE_GRECT);
			}
			break;
		case string:
			hideSelect=((v->flags&V_SELECTABLE)==0);
			if (v->val.strV != NULL)
				strBcpy(buf, v->val.strV);
			else
				*buf = '\0';
			SetObjcString(tree, VALUE_STRING, buf);
			tree[VALUE_STRING].ob_width = tree[VALUEBOX].ob_width - tree[VALUE_STRING].ob_x;
			DelObjFlags(tree, VALUE_STRING, HIDETREE);
			if (redraw)
			{
				WinDials_WinDialDraw(tree, VALUEBOX, MAX_DEPTH, &r, TRUE);
				WinDials_WinEditChanged(tree, VALUE_STRING);
			}
			break;
		case noVar:
		case comment:
			break;
		}
	} else
	{
		if (!GetObjState(tree, VDEFAULT, DISABLED))
		{
			SetObjState(tree, VDEFAULT, DISABLED);
			if (redraw)
			{
				CalcArea(tree, VDEFAULT, &r);
				WinDials_WinDialDraw(tree, VDEFAULT, MAX_DEPTH, &r, TRUE);
			}
		}
		SetStrings(tree, HELPSTR1, HELPSTR4, "");
		if (redraw)
		{
			CalcArea(tree, HELPBOX, &r);
			WinDials_WinDialDraw(tree, HELPBOX, MAX_DEPTH, &r, TRUE);
			CalcArea(tree, VALUEBOX, &r);
			WinDials_WinDialDraw(tree, VALUEBOX, MAX_DEPTH, &r, TRUE);
			WinDials_WinEditChanged(tree, -1);
		}
	}
	if(hideSelect)
		SetObjFlags(tree, VARSEL, HIDETREE);
	else
		DelObjFlags(tree, VARSEL, HIDETREE);
	if (redraw)
	{
		CalcArea(tree, VARBUTBOX, &r);
		WinDials_WinDialDraw(tree, VARBUTBOX, MAX_DEPTH, &r, TRUE);
	}
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID setAndGetValues(OBJECT *tree, _VOID *env, _BOOL set, _WORD exitBut)
{
	CONFEDIT *e;
	
	UNUSED(exitBut);
	e = env;
	if (set)
	{
		SetStrings(tree, HELPSTR1, HELPSTR4, "");
		SetObjState(tree, VDEFAULT, DISABLED);
		SetObjFlags(tree, VALUE_BOOL, HIDETREE);
		SetObjFlags(tree, VALUE_INT, HIDETREE);
		SetObjFlags(tree, VALUE_GRECT, HIDETREE);
		SetObjFlags(tree, VALUE_STRING, HIDETREE);
		SetObjFlags(tree, VARSEL, HIDETREE);
		VDIUtil_SetXState(tree, SORT1, e->sort);
		VDIUtil_SetXString(tree, SORT1, e->sortPopup, e->sort);
		VDIUtil_SetXState(tree, SHOW1, e->show);
		VDIUtil_SetXString(tree, SHOW1, e->showPopup, e->show);
		EnableObjState(tree, SHOWALL, SELECTED, e->allVars);
	} else
	{
		Lists_DeleteSimpleList(&e->vars, DeleteVar, TRUE);
		if (e->dialog != NULL)
			WinDials_CloseWinDial(e->dialog);
		mtDials_ResetUserkeys(tree);
		OFREE(e);
		quitProg = TRUE;
	}
}

/*** ---------------------------------------------------------------------- ***/

/*DYJ 5.30f Start*/
LOCAL _VOID about(_WORD obj, _VOID *env, LISTINFO info, _BOOL *draw, _BOOL *exit,_LONG *lstSel)
/*DYJ  Ende; alt:	
LOCAL _VOID about(_WORD obj, _VOID *env, LISTINFO info, _BOOL *draw, _BOOL *exit)
*/
{
	CONFEDIT *e;
	GRECT r;
	OBJECT *tree;
	OBJECT *dialog;
	
	UNUSED(lstSel);		/*DYJ 5.30f */
	UNUSED(info);
	e = env;
	tree = RscGaddr(the_rsc, R_TREE, ABOUT);
	if (tree != NULL)
	{
		SetObjcString(tree, DATE, ProgramDate);
		SetObjcString(tree, VERSION, ProgramVersion);
		e->dialog = tree;
		dialog = e->tree;
		WinDials_WinDialDo(tree, 0);
		if (WinDials_IsWinDial(dialog) >= 0)
		{
			e->dialog = NULL;
			DelObjState(dialog, obj, SELECTED);
			WinDials_WinDialDraw(dialog, obj, MAX_DEPTH, &r, FALSE);
		}
	}
	*draw = FALSE;
	*exit = FALSE;
}

/*** ---------------------------------------------------------------------- ***/

/*DYJ 5.30f Start*/
LOCAL _VOID switchShow(_WORD obj, _VOID *env, LISTINFO info, _BOOL *draw, _BOOL *exit,_LONG *lstSel)
/*DYJ  Ende; alt:	
LOCAL _VOID switchShow(_WORD obj, _VOID *env, LISTINFO info, _BOOL *draw, _BOOL *exit)
*/
{
	_WORD x, y;
	_WORD select;
	CONFEDIT *e;
	OBJECT *tree;
	GRECT r;
	
	UNUSED(lstSel);		/*DYJ 5.30f */
	UNUSED(info);
	e = env;
	tree = e->tree;
	objc_offset(tree, obj, &x, &y);
	*draw = FALSE;
	*exit = FALSE;
	select = mtPopups_TreePopup(e->showPopup, x, y, VDIUtil_GetXState(tree, obj)) - 1;
	if (select >= 0)
	{
		e->show = select;
		VDIUtil_SetXState(tree, obj, select);
		VDIUtil_SetXString(tree, obj, e->showPopup, select);
		*draw = TRUE;
		WinDials_WinDialDraw(tree, obj, 0, &r, FALSE);
		ConfVars_SetConfigVarList(&usereditVars);
		ConfVars_SetConfigInt(cShowType, select);
		ConfVars_ResetConfigVarList();
	}
}

/*** ---------------------------------------------------------------------- ***/

/*DYJ 5.30f Start*/
LOCAL _VOID cycleShow(_WORD obj, _VOID *env, LISTINFO info, _BOOL *draw, _BOOL *exit,_LONG *lstSel)
/*DYJ  Ende; alt:	
LOCAL _VOID cycleShow(_WORD obj, _VOID *env, LISTINFO info, _BOOL *draw, _BOOL *exit)
*/
{
	_WORD x, y;
	_WORD select;
	CONFEDIT *e;
	OBJECT *tree;
	GRECT r;
	
	UNUSED(lstSel);		/*DYJ 5.30f */
	UNUSED(info);
	UNUSED(obj);
	e = env;
	tree = e->tree;
	objc_offset(tree, SHOW1, &x, &y);
	*draw = TRUE;
	*exit = FALSE;
	select = (VDIUtil_GetXState(tree, SHOW1) + 1) % SHOW_ANZ;
	e->show = select;
	VDIUtil_SetXState(tree, SHOW1, select);
	VDIUtil_SetXString(tree, SHOW1, e->showPopup, select);
	WinDials_WinDialDraw(tree, SHOW1, 0, &r, FALSE);
	ConfVars_SetConfigVarList(&usereditVars);
	ConfVars_SetConfigInt(cShowType, select);
	ConfVars_ResetConfigVarList();
}

/*** ---------------------------------------------------------------------- ***/

/*DYJ 5.30f Start*/
LOCAL _VOID switchSort(_WORD obj, _VOID *env, LISTINFO info, _BOOL *draw, _BOOL *exit,_LONG *lstSel)
/*DYJ  Ende; alt:	
LOCAL _VOID switchSort(_WORD obj, _VOID *env, LISTINFO info, _BOOL *draw, _BOOL *exit)
*/
{
	_WORD x, y;
	_WORD select;
	CONFEDIT *e;
	OBJECT *tree;
	GRECT r;
	
	UNUSED(lstSel);		/*DYJ 5.30f */
	UNUSED(info);
	e = env;
	tree = e->tree;
	objc_offset(tree, obj, &x, &y);
	*draw = FALSE;
	*exit = FALSE;
	select = mtPopups_TreePopup(e->sortPopup, x, y, VDIUtil_GetXState(tree, obj)) - 1;
	if (select >= 0)
	{
		e->sort = select;
		sortList(&e->vars, e->sort);
		VDIUtil_SetXState(tree, obj, select);
		VDIUtil_SetXString(tree, obj, e->sortPopup, select);
		*draw = TRUE;
		WinDials_WinDialDraw(tree, obj, 0, &r, FALSE);
		ConfVars_SetConfigVarList(&usereditVars);
		ConfVars_SetConfigInt(cSortType, select);
		ConfVars_ResetConfigVarList();
	}
}

/*** ---------------------------------------------------------------------- ***/

/*DYJ 5.30f Start*/
LOCAL _VOID cycleSort(_WORD obj, _VOID *env, LISTINFO info, _BOOL *draw, _BOOL *exit,_LONG *lstSel)
/*DYJ  Ende; alt:	
LOCAL _VOID cycleSort(_WORD obj, _VOID *env, LISTINFO info, _BOOL *draw, _BOOL *exit)
*/
{
	_WORD x, y;
	_WORD select;
	CONFEDIT *e;
	OBJECT *tree;
	GRECT r;
	
	UNUSED(info);
	UNUSED(obj);
	*lstSel=-1;	/*DYJ 5.30f */
	e = env;
	tree = e->tree;
	objc_offset(tree, SORT1, &x, &y);
	*draw = TRUE;
	*exit = FALSE;
	select = (VDIUtil_GetXState(tree, SORT1) + 1) % SORT_ANZ;
	e->sort = select;
	sortList(&e->vars, e->sort);
	VDIUtil_SetXState(tree, SORT1, select);
	VDIUtil_SetXString(tree, SORT1, e->sortPopup, select);
	WinDials_WinDialDraw(tree, SORT1, 0, &r, FALSE);
	ConfVars_SetConfigVarList(&usereditVars);
	ConfVars_SetConfigInt(cSortType, select);
	ConfVars_ResetConfigVarList();
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID calcMaxLength(CONFEDIT *e)
{
	confVar *v;
	GRECT r;
	
	e->globalLength = 0;
	resetList(&e->vars);
	while ((v = nextEntry(&e->vars)) != NULL)
	{
		v->selected = FALSE;
		if (v->shortDesc != NULL)
			e->globalLength = Max((_WORD)strLen(v->shortDesc), e->globalLength);	/*DYJ 5.20w */
	}
	e->globalLength += LEFT_OFF2;
	CalcArea(e->tree, VARBOX, &r);
	e->globalLength = Max(e->globalLength, r.g_w / CharWidth);
}

/*** ---------------------------------------------------------------------- ***/

/*DYJ 5.30f Start*/
LOCAL _VOID showAll(_WORD obj, _VOID *env, LISTINFO info, _BOOL *draw, _BOOL *exit,_LONG *lstSel)
/*DYJ  Ende; alt:	
LOCAL _VOID showAll(_WORD obj, _VOID *env, LISTINFO info, _BOOL *draw, _BOOL *exit)
*/
{
	CONFEDIT *e;
	
	UNUSED(info);
	UNUSED(obj);
	*lstSel=-1;	/*DYJ 5.30f */
	e = env;
	*draw = TRUE;
	*exit = FALSE;
	e->allVars = !e->allVars;
	calcMaxLength(e);
	ConfVars_SetConfigVarList(&usereditVars);
	ConfVars_SetConfigBool(cShowAll, e->allVars);
	ConfVars_ResetConfigVarList();
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL CheckExit(OBJECT *tree, _VOID *env, _WORD button, _VOID *lastSel, _UWORD kstate)
{
	GRECT r;
	CONFEDIT *e;
	_BOOL dummy;
	_LONG dummyL;	/*DYJ 5.30f */
	
	UNUSED(tree);
	UNUSED(lastSel);
	UNUSED(kstate);
	
	button &= 0x7fff;
	DelObjState(tree, button, SELECTED);
	e = env;
	switch (button)
	{
	case VCANCEL:
		if (!e->changed)
			return TRUE;
		switch (mtAlerts_Alert(1, rsc_WrkString(AL_CHANGED)))	/*DYJ 5.23e */
		{
			case 1: return Save_Vars(e);
			case 2: return TRUE;
		}
		break;
	case VABOUT:
/*DYJ 5.30f Start*/
		about(button, e, NULL, &dummy, &dummy,&dummyL);
/*DYJ  Ende; alt:	
		about(button, e, NULL, &dummy, &dummy);
*/
		break;
	case VHELP:
		break;
	}
	WinDials_WinDialDraw(tree, button, MAX_DEPTH, &r, FALSE);
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL findSelected(List *l)
{
	confVar *v;
	
	Lists_ResetList(l);
	while ((v = nextEntry(l)) != NULL)
		if (v->selected)
			return TRUE;
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID InLoop(_VOID *entry, _VOID *env)
{
	CONFEDIT *e;
	confVar *v;
	_BOOL oneSel;
	_UBYTE buf[256];
	varVal val;
	_BOOL needs_redraw;
	int x, y, w, h;
	
	UNUSED(entry);
	e = env;
	Lists_ResetList(&e->vars);
	SetObjFlags(e->tree, VALUE_BOOL, HIDETREE);
	SetObjFlags(e->tree, VALUE_INT, HIDETREE);
	SetObjFlags(e->tree, VALUE_GRECT, HIDETREE);
	SetObjFlags(e->tree, VALUE_STRING, HIDETREE);
	oneSel = findSelected(&e->vars);
	if (oneSel)
		v = Lists_CurrentEntry(&e->vars);
	else
		v = NULL;
	needs_redraw = FALSE;
	if (e->lastVar != NULL)
	{
		switch (e->lastVar->type)
		{
		case bool:
			val.boolV = GetObjState(e->tree, VALUE_BOOL, SELECTED);
			break;
		case sint:
			if (!VDIUtil_GetIntStr(e->tree, VALUE_INT, &val.intV))
				val.intV = e->lastVar->defVal.intV;
			break;
		case lint:
			if (!VDIUtil_GetLongIntStr(e->tree, VALUE_INT, &val.lintV))
				val.lintV = e->lastVar->defVal.lintV;
			break;
		case rect:
			ObjcString(e->tree, VALUE_GRECT, buf, sizeof(buf));
			if (sscanf(buf, "%5d%5d%5d%5d", &x, &y, &w, &h) != 4)
			{
				v->val.rectV = e->lastVar->defVal.rectV;
			} else
			{
				val.rectV.g_x = x;
				val.rectV.g_y = y;
				val.rectV.g_w = w;
				val.rectV.g_h = h;
			}
			break;
		case string:
			ObjcString(e->tree, VALUE_STRING, buf, sizeof(buf));
			val.strV = STRDUP(buf, "InLoop: str");
			break;
		case noVar:
		case comment:
			break;
		}
		if (!ValueEqual(e->lastVar->type, &e->lastVar->val, &val))
		{
			if (!e->changed)
			{
				e->changed = TRUE;
			}
			if (e->show == SHOW_NAME)
				needs_redraw = TRUE;
		}
		if (e->lastVar->type == string)
		{
			if (val.strV != NULL)
				SFREE(e->lastVar->val.strV);
			else
				val.strV = e->lastVar->val.strV;
		}
		e->lastVar->val = val;
	}
	e->lastVar = v;
	UpdateEntry(e->tree, v, TRUE);
	if (needs_redraw)
	{
		GRECT r;
		
		CalcArea(e->tree, VARBOX, &r);
		WinDials_WinDialDraw(e->tree, VARBOX, MAX_DEPTH, &r, TRUE);
	}
}

/*** ---------------------------------------------------------------------- ***/

/*DYJ 5.30f Start*/
LOCAL _VOID helpButton(_WORD obj, _VOID *env, LISTINFO info, _BOOL *draw, _BOOL *exit,_LONG *lstSel)
/*DYJ  Ende; alt:	
LOCAL _VOID helpButton(_WORD obj, _VOID *env, LISTINFO info, _BOOL *draw, _BOOL *exit)
*/
{
	GRECT r;
	CONFEDIT *e;
	
	UNUSED(lstSel);		/*DYJ 5.30f */
	UNUSED(info);
	e = env;
	/* CatHelp_DoHelp(topic); */
	DelObjState(e->tree, obj, SELECTED);
	WinDials_WinDialDraw(e->tree, obj, MAX_DEPTH, &r, FALSE);
	*draw = FALSE;
	*exit = FALSE;
}

/*** ---------------------------------------------------------------------- ***/

/*DYJ 5.30f Start*/
LOCAL _VOID defaultButton(_WORD obj, _VOID *env, LISTINFO info, _BOOL *draw, _BOOL *exit,_LONG *lstSel)
/*DYJ  Ende; alt:	
LOCAL _VOID defaultButton(_WORD obj, _VOID *env, LISTINFO info, _BOOL *draw, _BOOL *exit)
*/
{
	GRECT r;
	CONFEDIT *e;
	confVar *v;
	_UBYTE *str;
	
	UNUSED(lstSel);		/*DYJ 5.30f */
	UNUSED(info);
	e = env;
	DelObjState(e->tree, obj, SELECTED);
	Lists_ResetList(&e->vars);
	if (findSelected(&e->vars))
	{
		v = Lists_CurrentEntry(&e->vars);
		if (!ValueEqual(v->type, &v->val, &v->defVal))
			e->changed = TRUE;
		if (v->type == string)
		{
			str = STRDUP(v->defVal.strV, "defaultButton");
			if (str != NULL)
			{
				SFREE(v->val.strV);
				v->val.strV = str;
			}
		} else
		{
			v->val = v->defVal;
		}
	}
	e->lastVar = NULL;
	WinDials_WinDialDraw(e->tree, obj, MAX_DEPTH, &r, FALSE);
	WinDials_WinDialDraw(e->tree, VALUEBOX, MAX_DEPTH, &r, FALSE);
	*draw = FALSE;
	*exit = FALSE;
}
/*DYJ 5.30f Start*/
LOCAL _VOID delVar(_WORD obj, _VOID *env, LISTINFO info, _BOOL *draw, _BOOL *exit,_LONG *lstSel)
/*DYJ  Ende; alt:	
LOCAL _VOID delVar(_WORD obj, _VOID *env, LISTINFO info, _BOOL *draw, _BOOL *exit)
*/
{
	GRECT r;
	CONFEDIT *e;
	confVar *v;
	_UBYTE *str;
	
	UNUSED(lstSel);		/*DYJ 5.30f */
	UNUSED(info);
	e = env;
	DelObjState(e->tree, obj, SELECTED);
	Lists_ResetList(&e->vars);
	if (findSelected(&e->vars))
	{
		v = Lists_CurrentEntry(&e->vars);
		if (!ValueEqual(v->type, &v->val, &v->defVal))
			e->changed = TRUE;
		if (v->type == string)
		{
			str = STRDUP(v->defVal.strV, "defaultButton");
			if (str != NULL)
			{
				SFREE(v->val.strV);
				v->val.strV = str;
			}
		} else
		{
			v->val = v->defVal;
		}
	}
	e->lastVar = NULL;
	WinDials_WinDialDraw(e->tree, obj, MAX_DEPTH, &r, FALSE);
	WinDials_WinDialDraw(e->tree, VALUEBOX, MAX_DEPTH, &r, FALSE);
	*draw = FALSE;
	*exit = FALSE;
}

/*** ------------------------------------------------------------------------ ***/
/*LOCAL _VOID selVar(_WORD obj, _VOID *env, LISTINFO info, _BOOL *draw, _BOOL *exit) */
/*	Auswahl einer variable ber Fileseletor, Popup,...							*/
/*	Parameter:	die Standardparameter fr Special Keys							*/
/*	Ergebnis:	keines															*/		
/*	1.6.00 von Dimitri Junker	DYJ 4.17d										*/
/*** ------------------------------------------------------------------------ ***/
/*DYJ 5.30f Start*/
LOCAL _VOID selVar(_WORD obj, _VOID *env, LISTINFO info, _BOOL *draw, _BOOL *exit,_LONG *lstSel)
/*DYJ  Ende; alt:	
LOCAL _VOID selVar(_WORD obj, _VOID *env, LISTINFO info, _BOOL *draw, _BOOL *exit)
*/
{
	CONFEDIT *e;
	confVar *v;
	_UBYTE *str;
	GRECT r;
	_WORD x, y;
	_WORD select;
	OBJECT *colPopup, *effPopup;

	_UBYTE prgPath[PATH_MAX],prgName[FILENAME_MAX],prgEnd[FILENAME_MAX]="*.*";

	
	UNUSED(lstSel);		/*DYJ 5.30f */
	UNUSED(info);
	UNUSED(obj);
	e = env;
/*DYJ 5.23e Start*/
	colPopup  = TreeAddrLib[COLPOPUP];
	effPopup  = TreeAddrLib[EFFPOPUP];
/*DYJ  Ende; alt:	
	colPopup = RscGaddr(the_rsc, R_TREE, COLPOPUP);
	effPopup = RscGaddr(the_rsc, R_TREE, EFFPOPUP);
*/
	DelObjState(e->tree, obj, SELECTED);
	Lists_ResetList(&e->vars);
	if (findSelected(&e->vars))
	{
		v = Lists_CurrentEntry(&e->vars);
		e->changed = TRUE;
		ConfVars_DeleteConfigVar(v->v_name);
		v->flags &= ~V_FOUND;
		switch(v->sType)
		{
			 case path:
				mtDir_SplitPath(v->val.strV, prgPath, prgName, prgEnd);
				if (prgEnd[0] != '\0')
					Insert("*.", prgEnd, sizeof(prgEnd), 0);
				else
					strCpy(prgEnd, "*.*");	/*DYJ 5.20w */
				if (mtDir_FselGet(prgPath, prgName, prgEnd, "File Auswhlen", FALSE))
				{
					F_Path_Append(prgPath, prgName);
					str = STRDUP(prgPath, "pfadVar");
					if (str != NULL)
					{
						SFREE(v->val.strV);
						v->val.strV = str;
					}
				}
				break;
			case color:
				objc_offset(e->tree, obj, &x, &y);
				select = v->val.intV;
				if(v->maxVal == 15)
				{
					DelObjFlags(colPopup, 33, SELECTABLE);
					DelObjFlags(colPopup, 34, SELECTABLE);
				}
				else
				{
					SetObjFlags(colPopup, 33, SELECTABLE);
					SetObjFlags(colPopup, 34, SELECTABLE);
				}
				EnableObjState(colPopup, 33, DISABLED, v->maxVal == 15);
				EnableObjState(colPopup, 34, DISABLED, v->maxVal == 15);
				select = mtPopups_TreePopup(colPopup, x, y, select)/2 - 1;
				if (select > v->maxVal)
					select = -1;
				if (select >= 0)
					v->val.intV=select;
				break;
			case effect:
				objc_offset(e->tree, obj, &x, &y);
				select = v->val.intV;
				select = mtPopups_TreePopup(effPopup, x, y, select)-1;
				if (select >= 4)	/*4 = maxEffekt*/
					select = -1;
				if (select >= 0)
					v->val.intV=select;
				break;
		}
	}
	e->lastVar = NULL;
	WinDials_WinDialDraw(e->tree, VALUEBOX, MAX_DEPTH, &r, FALSE);
	*draw = TRUE;
	*exit = FALSE;
}

/*** ---------------------------------------------------------------------- ***/

/*DYJ 5.30f Start*/
LOCAL _VOID Vars_Save(_WORD obj, _VOID *env, LISTINFO info, _BOOL *draw, _BOOL *exit,_LONG *lstSel)
/*DYJ  Ende; alt:	
LOCAL _VOID Vars_Save(_WORD obj, _VOID *env, LISTINFO info, _BOOL *draw, _BOOL *exit)
*/
{
	CONFEDIT *e;
	GRECT r;
	
	UNUSED(lstSel);		/*DYJ 5.30f */
	UNUSED(info);
	e = env;
	Save_Vars(e);
	DelObjState(e->tree, obj, SELECTED);
	WinDials_WinDialDraw(e->tree, obj, MAX_DEPTH, &r, FALSE);
	*draw = FALSE;
	*exit = FALSE;
}

/*** ---------------------------------------------------------------------- ***/

#if 0
LOCAL _VOID changeBool(_WORD obj, _VOID *env, LISTINFO info, _BOOL *draw, _BOOL *exit)
{
	CONFEDIT *e;
	GRECT r;
	
	UNUSED(obj);
	UNUSED(info);
	e = env;
	if (GetObjState(e->tree, VALUE_BOOL, SELECTED))
		DelObjState(e->tree, VALUE_BOOL, SELECTED);
	else
		SetObjState(e->tree, VALUE_BOOL, SELECTED);
	WinDials_WinDialDraw(e->tree, VALUE_BOOL, MAX_DEPTH, &r, FALSE);
	*draw = FALSE;
	*exit = FALSE;
}
#endif

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID Type_Err(CONST _UBYTE *name)
{
	_UBYTE str[256];
	
	sprintf(str, rsc_WrkString(AL_TYPE_ERR), name);	/*DYJ 5.23e */
	mtAlerts_Alert(1, str);
}

/*** ---------------------------------------------------------------------- ***/

typedef struct {
	List *to;
	List *from;
} walkInfo;

LOCAL confVar *addValue(List *to, confVar *v, CONST _UBYTE *name, _WORD type, CONST _VOID *value)
{
	confVar *newv;
	
	newv = NEW(confVar, "confWalk: var");
	if (newv == NULL)
		return NULL;
	if (v != NULL)
		*newv = *v;
	else
		MemSetZeroStruct(*newv);
	newv->desc = v;
	if ((newv->v_name = STRDUP(name, "confWalk: name")) == NULL)
	{
		OFREE(newv);
		return NULL;
	}
	switch (type)
	{
	case 0:
		if (v == NULL)
		{
			newv->type = bool;
			newv->defVal.boolV = *((CONST _BOOL *)value);
			newv->val.boolV = *((CONST _BOOL *)value);
		} else if (v->type == bool)
		{
			newv->val.boolV = *((CONST _BOOL *)value);
		} else
		{
			Type_Err(v->v_name);
			SFREE(newv->v_name);
			OFREE(newv);
			return NULL;
		}
		break;
	case 1:
		if (v == NULL)
		{
			newv->type = sint;
			newv->defVal.intV = *((CONST _WORD *)value);
			newv->val.intV = *((CONST _WORD *)value);
		} else if (v->type == sint)
		{
			newv->val.intV = *((CONST _WORD *)value);
		} else if (v->type == lint)
		{
			newv->val.lintV = *((CONST _WORD *)value);
		} else
		{
			Type_Err(v->v_name);
			SFREE(newv->v_name);
			OFREE(newv);
			return NULL;
		}
		break;
	case 2:
		if (v == NULL)
		{
			newv->defVal.lintV = *((CONST _LONG *)value);
			newv->val.lintV = *((CONST _LONG *)value);
			newv->type = lint;
		} else if (v->type == sint)
		{
			newv->val.lintV = *((CONST _LONG *)value);
			newv->type = lint;
		} else if (v->type == lint)
		{
			newv->val.lintV = *((CONST _LONG *)value);
		} else
		{
			Type_Err(v->v_name);
			SFREE(newv->v_name);
			OFREE(newv);
			return NULL;
		}
		break;
	case 3:
		if (v == NULL || v->type == string)
		{
			if ((newv->val.strV = STRDUP(value, "confWalk: str")) == NULL)
			{
				SFREE(newv->v_name);
				OFREE(newv);
				return NULL;
			}
			newv->type = string;
		} else
		{
			Type_Err(v->v_name);
			SFREE(newv->v_name);
			OFREE(newv);
			return NULL;
		}
		break;
	case 4:
		if (v == NULL || v->type == rect)
		{
			newv->val.rectV = *((CONST GRECT *)value);
			newv->type = rect;
		} else
		{
			Type_Err(v->v_name);
			SFREE(newv->v_name);
			OFREE(newv);
			return NULL;
		}
		break;
	default:
		Type_Err(v->v_name);
		SFREE(newv->v_name);
		OFREE(newv);
		return NULL;
	}
	if (!Lists_InsertEntry(to, newv))
	{
		SFREE(newv->v_name);
		OFREE(newv);
		return NULL;
	}
	newv->selected = FALSE;
	return newv;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL confWalk(CONST _UBYTE *name, _WORD type, CONST _VOID *value, _VOID *private)
{
	walkInfo *inf;
	confVar *v;
	List *from;
	CONST _UBYTE *p;
	size_t pos;
	_LONG minval, maxval, val;
	CONST _UBYTE *nameend;
	
	inf = private;
	from = inf->from;
	Lists_ResetList(from);
	while ((v = Lists_NextEntry(from)) != NULL)
	{
		if ((p = strChr(v->v_name, '{')) != NULL &&	/*DYJ 5.20w */
			strnCmp(name, v->v_name, p - v->v_name) == 0)	/*DYJ 5.20w */
		{
			v->flags |= V_VARIABLE;
			nameend = name + (p - v->v_name);
			do
			{
				p++;
				pos = 0;
				minval = StrToLInt(p, &pos, NULL);
				if (p[pos] == '-')
				{
					++pos;
					maxval = StrToLInt(p, &pos, NULL);
				} else
				{
					maxval = minval;
				}
				p += pos;
				if (*p == '}')
					p++;
				pos = 0;
				val = StrToLInt(nameend, &pos, NULL);
				nameend += pos;
				if (val < minval || val > maxval)
				{
					/* passt eigentlich nicht */
				}
				while (*nameend != '\0' && *nameend == *p)
				{
					nameend++;
					p++;
				}
				if (*nameend == '\0' && *p == '\0')
				{
					v->flags |= V_FOUND;
					if (addValue(inf->to, v, name, type, value) == NULL)
						return FALSE;
				}
			} while (*p == '{');
			if (*nameend == '\0' && *p == '\0')
				return TRUE;
		} else
		{
			if (strCmp(name, v->v_name) == 0)	/*DYJ 5.20w */
			{
				v->flags |= V_FOUND;
				if (addValue(inf->to, v, name, type, value) == NULL)
					return FALSE;
				return TRUE;
			}
		}
	}
	/*
	 * unbekannte Variable
	 */
	if ((v = addValue(inf->to, NULL, name, type, value)) == NULL)
		return FALSE;
	v->flags |= V_UNKNOWN | V_FOUND;
	v->shortDesc = STRDUP(rsc_WrkString(FS_UNKNOWN_VAR), "confWalk: unknown");	/*DYJ 5.23e */
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL Vars_Copy(List *to, List *from)
{
	confVar *v, *newv;
	walkInfo inf;
	
	inf.to = to;
	inf.from = from;
	Lists_ResetList(from);
	Lists_ResetList(to);
	while ((v = Lists_NextEntry(from)) != NULL)
	{
		v->flags &= ~V_FOUND;
		if (strChr(v->v_name, '{') != NULL)	/*DYJ 5.20w */
			v->flags |= V_VARIABLE;
	}
	if (!ConfVars_Walk(confWalk, &inf))
	{
		Lists_DeleteSimpleList(to, DeleteVar, FALSE);
		return FALSE;
	}
	/*
	 * jetzt noch die nicht gefundenen eintragen
	 */
	Lists_ResetList(from);
	while ((v = Lists_NextEntry(from)) != NULL)
	{
		if (!(v->flags & V_FOUND) &&
			!(v->flags & V_OBSOLETE) &&
			!(v->flags & V_VARIABLE))
		{
			newv = NEW(confVar, "Vars_Copy");
			if (newv == NULL)
			{
				Lists_DeleteSimpleList(to, DeleteVar, FALSE);
				return FALSE;
			}
			*newv = *v;
			if ((newv->v_name = STRDUP(v->v_name, "confWalk: name")) == NULL)
			{
				OFREE(newv);
				Lists_DeleteSimpleList(to, DeleteVar, FALSE);
				return FALSE;
			}
			newv->desc = v;
			switch (v->type)
			{
			case bool:
				newv->val.boolV = v->defVal.boolV;
				break;
			case sint:
				newv->val.intV = v->defVal.intV;
				break;
			case lint:
				newv->val.lintV = v->defVal.lintV;
				break;
			case rect:
				newv->val.rectV = v->defVal.rectV;
				break;
			case string:
				if ((newv->val.strV = STRDUP(v->defVal.strV, "Copy: strV")) == NULL)
				{
					SFREE(newv->v_name);
					OFREE(newv);
					Lists_DeleteSimpleList(to, DeleteVar, FALSE);
					return FALSE;
				}
				break;
			case noVar:
			case comment:
				break;
			}
			if (!Lists_AppendEntry(to, newv))
			{
				SFREE(newv->v_name);
				OFREE(newv);
				Lists_DeleteSimpleList(to, DeleteVar, FALSE);
				return FALSE;
			}
		}
	}
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL DoDialog(_VOID)
{
	OBJECT *tree;
	CONFEDIT *e;
	ldHandler handler;
	
	tree = RscGaddr(the_rsc, R_TREE, VAREDIT);
	if (tree == NULL)
		return FALSE;


/* 
Der Dialog wurde zu gro, zumindest fr Auflsungen ~640*400. Dort ist der obere 
Button nicht mehr sichtbar, also mssen sie nher zusammenrcken. Um zu wissen wohin 
habe ich einfach eine 2. Version eingesetzt, in der sie enger zusammen sind und
bertrage deren Position hier. Die Alternative wirklich die anderen zu benutzen
wre viel aufwendiger.
*/

	if (deskSize.g_h<500) 
	{
		tree[VARBUTBOX].ob_y=tree[VARBUTBOX_S].ob_y;
		tree[VARBUTBOX].ob_height=tree[VARBUTBOX_S].ob_height;
		tree[VABOUT].ob_y=tree[VABOUT_S].ob_y;
		tree[SHOWALL].ob_y=tree[SHOWALL_S].ob_y;
		tree[SORT1].ob_y=tree[SORT1_S].ob_y;
		tree[SORT2].ob_y=tree[SORT2_S].ob_y;
		tree[SHOW1].ob_y=tree[SHOW1_S].ob_y;
		tree[SHOW2].ob_y=tree[SHOW2_S].ob_y;
		tree[VDEFAULT].ob_y=tree[VDEFAULT_S].ob_y;
		tree[SAVE_VARS].ob_y=tree[SAVE_VARS_S].ob_y;
		tree[VCANCEL].ob_y=tree[VCANCEL_S].ob_y;
		tree[VARSEL].ob_y=tree[VARSEL_S].ob_y;
	}
	AdjustDialogSize(tree, 1, 100, 0, 1, VARBOX, VARBACK, TRUE);
	
	e = NEW(CONFEDIT, "DoDialog: edit");
	if (e == NULL)
		return FALSE;
	MemSetZeroStruct(*e);
	
	if (!Lists_CreateList(&e->vars, "DoDialog: vars"))
	{
		OFREE(e);
		return FALSE;
	}
	ConfVars_SetConfigVarList(&usereditVars);
	ConfVars_GetConfDefInt(cShowType, &e->show, SHOW_TEXT);
	ConfVars_GetConfDefInt(cSortType, &e->sort, SORT_TEXT);
	ConfVars_GetConfDefBool(cShowAll, &e->allVars, FALSE);
	ConfVars_ResetConfigVarList();
	e->changed = FALSE;

	/* Objectadresse holen */
	e->tree = tree;
	e->sortPopup = RscGaddr(the_rsc, R_TREE, LSORTPOP);
	e->showPopup = RscGaddr(the_rsc, R_TREE, LSHOWPOP);
	
	if (!Vars_Copy(&e->vars, &confVars))
	{
		Lists_DeleteList(&e->vars);
		OFREE(e);
		return FALSE;
	}
	e->vars.user = e;
	e->lastVar = NULL;
	sortList(&e->vars, e->sort);
	
	calcMaxLength(e);

	e->specials[0].objc = VHELP;
	e->specials[0].proc = helpButton;
	e->specials[1].objc = VDEFAULT;
	e->specials[1].proc = defaultButton;
	e->specials[2].objc = SAVE_VARS;
	e->specials[2].proc = Vars_Save;
	e->specials[3].objc = VABOUT;
	e->specials[3].proc = about;
	e->specials[4].objc = SHOW1;
	e->specials[4].proc = switchShow;
	e->specials[5].objc = SHOW2;
	e->specials[5].proc = cycleShow;
	e->specials[6].objc = SORT1;
	e->specials[6].proc = switchSort;
	e->specials[7].objc = SORT2;
	e->specials[7].proc = cycleSort;
	e->specials[8].objc = SHOWALL;
	e->specials[8].proc = showAll;
	e->specials[9].objc = DEL_VAR;
	e->specials[9].proc = delVar;
	e->specials[10].objc = VARSEL;
	e->specials[10].proc = selVar;
	
	/* WindowDialog vorbereiten */
	ListDl_BuildLdHandler(&e->vars,
		resetList,
		nextEntry,
		prevEntry,
		countEntries,
		isEnabled,
		selEntry,
		lineToStr,
		isSelected,
		drawEntry,
		FUNK_NULL,
		0, CharHeight,
		CharWidth, e->globalLength * CharWidth,
		&handler);

	/* ListWinDialog oeffnen */
	if (!ListDl_WinListDial(tree,
		ldArrows | ldSelect,
		&handler,
		VARBOX,
		VARBACK,
		VCANCEL,	/* okBut */
		VCANCEL,	/* cancelBut */
		e,			/* env */
		-1,			/* doubleClickButton */
		-1,			/* autoEdit */
		InLoop,
		e->specials,
		11,
		CheckExit,
		setAndGetValues,
		setAndGetValues,
		&e->lastSel))
	{
		OFREE(e);
		return FALSE;
	}
	
	mtDials_SetUserkey(tree, DEL_VAR, 0x53, 0, FALSE, TRUE);
	
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID Vars_Val(_LONG lineno)
{
	_UBYTE str[256];
	
	sprintf(str, rsc_WrkString(AL_VAL_ERR), lineno);	/*DYJ 5.23e */
	mtAlerts_Alert(1, str);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID Vars_Err(_LONG lineno)
{
	_UBYTE str[256];
	
	sprintf(str, rsc_WrkString(AL_DAT_ERR), lineno);	/*DYJ 5.23e */
	mtAlerts_Alert(1, str);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID Group_Err(CONST _UBYTE *group, _LONG lineno)
{
	_UBYTE str[256];
	
	sprintf(str, rsc_WrkString(AL_UNKNOWN_GROUP), group, lineno);	/*DYJ 5.23e */
	mtAlerts_Alert(1, str);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL getInfoBool(CONST _UBYTE *arg)
{
	if (strnCaseCmp(arg, "ON", 2) == 0)
		return TRUE;
	if (strnCaseCmp(arg, "TRUE", 4) == 0)
		return TRUE;
	if (strnCaseCmp(arg, "OFF", 3) == 0)
		return FALSE;
	if (strnCaseCmp(arg, "FALSE", 5) == 0)
		return FALSE;
	return FALSE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _LONG getInfoInt(CONST _UBYTE *arg, _LONG lineno)
{
	_LONG t;
	_BOOL valid;

	t = StrToLInt(arg, NULL, &valid);
	if (!valid)
	{
		t = 0;
		Vars_Val(lineno);
	}
	return t;
}

/*** ---------------------------------------------------------------------- ***/

/*** ------------------------------------------------------------------------ ***/
/*	LOCAL _WORD getInfoEffect(CONST _UBYTE *arg, _LONG lineno)					*/
/*	Effektmname -> Effektnummer													*/
/*	Parameter:	arg:	Der Text												*/
/*				lineno:	DIe Zeile												*/
/*	Ergebnis:	Effektnummer													*/		
/*	1.6.00 von Dimitri Junker	DYJ 4.17f										*/
/*** ------------------------------------------------------------------------ ***/
LOCAL _WORD getInfoEffect(CONST _UBYTE *arg, _LONG lineno)
{
	_WORD i;
	
	for (i = 0; i < 4; i++)
		if (strCaseCmp(arg, effectnames[i]) == 0)
			return i;
	return (_WORD)getInfoInt(arg, lineno);
}

LOCAL _WORD getInfoColor(CONST _UBYTE *arg, _LONG lineno)
{
	_WORD i;
	
	for (i = 0; i < 16; i++)
		if (strCaseCmp(arg, colornames[i]) == 0)
			return i;
	return (_WORD)getInfoInt(arg, lineno);
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL getInfoGroup(CONST _UBYTE *arg)
{
	if (strCaseCmp(arg, "allgemein") == 0)
		return GROUP_ALLGEMEIN;
	if (strCaseCmp(arg, "tausch") == 0)
		return GROUP_TAUSCH;
	if (strCaseCmp(arg, "stichwortliste") == 0)
		return GROUP_MSGLIST;
	if (strCaseCmp(arg, "nachrichtenanzeige") == 0)
		return GROUP_GRIN;
	if (strCaseCmp(arg, "baumanzeige") == 0)
		return GROUP_TREELIST;
	if (strCaseCmp(arg, "editor") == 0)
		return GROUP_EDITOR;
	if (strCaseCmp(arg, "kommentarfenster") == 0)
		return GROUP_MESSAGE;
	return GROUP_UNKNOWN;
}

/*** ---------------------------------------------------------------------- ***/

#define ndcBase 32767L

#if 0
LOCAL _VOID RC2NDC(GRECT *r)
{
	_WORD tw, th;

	tw = deskSize.g_x + deskSize.g_w;
	th = deskSize.g_y + deskSize.g_h;
#define RDC2NDCVAL(x, w) \
	x = (_WORD)LMin(ndcBase, ((ndcBase * (_LONG)(x) * 10L) / (_LONG)(w) + 5) / 10)

	RDC2NDCVAL(r->g_x, tw);
	RDC2NDCVAL(r->g_y, th);
	RDC2NDCVAL(r->g_w, tw);
	RDC2NDCVAL(r->g_h, th);
#undef RDC2NDCVAL
}
#endif

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID NDC2RC(GRECT *r)
{
	_WORD tw, th;

	tw = deskSize.g_x + deskSize.g_w;
	th = deskSize.g_y + deskSize.g_h;
#define NDC2RDCVAL(x, w) \
	x = (_WORD)LMin(ndcBase, (((_LONG)(w) * (_LONG)(x) * 10L) / ndcBase + 5) / 10)

	NDC2RDCVAL(r->g_x, tw);
	NDC2RDCVAL(r->g_y, th);
	NDC2RDCVAL(r->g_w, tw);
	NDC2RDCVAL(r->g_h, th);
#undef NDC2RDCVAL
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL getInfoRect(CONST _UBYTE *arg, GRECT *r)
{
	size_t p;
	_WORD i;
	_WORD ra[4];
	_BOOL valid;

	p = 0;
	for (i = 0; i < 4; i++)
	{
		while (arg[p] == ' ' || arg[p] == '{' || arg[p] == ',')
			++p;
		ra[i] = StrToInt(arg, &p, &valid);
		if (!valid)
		{
			return FALSE;
		}
	}

	r->g_x = ra[0];
	r->g_y = ra[1];
	r->g_w = ra[2];
	r->g_h = ra[3];

	NDC2RC(r);
	if (r->g_w < 0)
		r->g_w = 80;
	if (r->g_h < 0)
		r->g_h = 120;
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL getInfoStr(_UBYTE *arg, _UBYTE **val)
{
	_UBYTE *p;
	_UBYTE numStr[4];
	_UBYTE quote;
	
	quote = '\0';
	if (*arg == '"')
		quote = *arg++;
	/* Sonderzeichen uebersetzen */
	p = arg;
	while (*p != '\0' && *p != quote)
	{
		if (*p == '\\')
		{
			/* Feststellen, ob die naechsten drei Zahlen sind */
#define is_digit(c) ((c) >= '0' && (c) <= '9')
			if (is_digit(p[1]) && is_digit(p[2]) && is_digit(p[3]))
			{
				strMcpy(numStr, 4, p + 1);
				*p++ = StrToCard(numStr, NULL, NULL);
				strCpy(p, p + 3);	/*DYJ 5.20w */
			} else if (p[1] == '\\' || p[1] == '"')
			{
				/* Ein \ entfernen */
				strCpy(p, p + 1);	/*DYJ 5.20w */
				p++;
			} else
			{
				p++;
			}
		} else
		{
			++p;
		}
	}
	if (quote != '\0' && *p != quote)
		return FALSE;
	if (*p != '\0')
		*p++ = '\0';
	if (*val == NULL)
	{
		p = STRDUP(arg, "getInfoStr");
	} else
	{
		p = MALLOC(strLen(*val) + 1 + strLen(arg) + 1, "getInfoStr");	/*DYJ 5.20w */
		if (p != NULL)
		{
			strCpy(p, *val);	/*DYJ 5.20w */
			strCat(p, " ");	/*DYJ 5.20w */
			strCat(p, arg);	/*DYJ 5.20w */
			SFREE(*val);
		}
	}
	if (p == NULL)
		return FALSE;
	*val = p;
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL addVar(confVar *v)
{
	if (v->type == noVar)
		return FALSE;
	if (!Lists_InsertEntry(&confVars, v))
		return FALSE;
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL Vars_Read(_VOID)
{
	_UBYTE fname[PATH_MAX];
	TEXTFILENO tf;
	_UBYTE line[4096];
	confVar *v;
	_UBYTE *lastp, *p;
	_LONG lineno;
	
	if (!Lists_CreateList(&confVars, "Vars_Read: list"))
		return FALSE;
	
	strBcpy(fname, HomePath);
	F_Path_Append(fname, USEREDIT_DAT);
	if (mtTextfiles_OpenTextfile(fname, READ, 0, &tf) != GERR_OK)
	{
		mtAlerts_Alert(1, AL_DAT_NOTFOUND);
		return FALSE;
	}
	Lists_ResetList(&confVars);
	lineno = 0;
	v = NULL;
	while (!mtTextfiles_EndofText(tf))
	{
		mtTextfiles_ReadLine(tf, line, sizeof(line));
		mtTextfiles_ReadLn(tf);
		lineno++;
		p = line;
		while (*p == ' ' || *p == '\t')
			p++;
		if (*p == ';' || *p == '#' || *p == '\0')
			continue;
		
		lastp = p;
		p+=strcSpn(p," \t");	/*DYJ 5.20w */
		if (p == NULL)
		{
			p = lastp + strLen(lastp);	/*DYJ 5.20w */
		} else
		{
			*p++ = '\0';
			while (*p == ' ' || *p == '\t')
				p++;
		}
			
		if (strCmp(lastp, "name") == 0)	/*DYJ 5.20w */
		{
			if (v != NULL)
			{
				if (!addVar(v))
				{
					DeleteVar(v);
					mtTextfiles_CloseTextfile(&tf);
					Vars_Err(lineno);
					return FALSE;
				}
			}
			if ((v = NEW(confVar, "Vars_Read: variable")) == NULL)
			{
				mtTextfiles_CloseTextfile(&tf);
				Vars_Err(lineno);
				return FALSE;
			}
			MemSetZeroStruct(*v);
			v->type = noVar;
			v->sType=normal;
			v->desc = v;
			v->v_name = STRDUP(p, "Vars_Read: name");
			if (v->v_name == NULL)
			{
				DeleteVar(v);
				mtTextfiles_CloseTextfile(&tf);
				Vars_Err(lineno);
				return FALSE;
			}
		} else if (strCmp(lastp, "type") == 0)	/*DYJ 5.20w */
		{
			/* Typ einlesen */
			if (strCmp(p, "bool") == 0)	/*DYJ 5.20w */
				v->type = bool;
			else if (strCmp(p, "int") == 0)	/*DYJ 5.20w */
				v->type = sint;
			else if (strCmp(p, "color") == 0)	/*DYJ 5.20w */
			{
				v->type = sint;
				v->sType = color;
				/* Max-Wert setzen */
				if((v->flags & V_MAXVAL)==0)
				{
					v->maxVal = 15;
					v->flags |= V_MAXVAL;
				}
			}
			else if (strCmp(p, "effect") == 0)	/*DYJ 5.20w */
			{
				v->type = sint;
				v->sType = effect;
			}
			else if (strCmp(p, "path") == 0)	/*DYJ 5.20w */
			{
				v->type = string;
				v->sType = path;
			}
			else if (strCmp(p, "long") == 0)	/*DYJ 5.20w */
				v->type = lint;
			else if (strCmp(p, "string") == 0)	/*DYJ 5.20w */
				v->type = string;
			else if (strCmp(p, "rect") == 0)	/*DYJ 5.20w */
				v->type = rect;
			else {
				DeleteVar(v);
				mtTextfiles_CloseTextfile(&tf);
				Vars_Err(lineno);
				return FALSE;
			}
		} else if (strCmp(lastp, "default") == 0)	/*DYJ 5.20w */
		{
			/* Default-Wert einlesen */
			switch (v->type)
			{
			case bool:
				v->defVal.boolV = getInfoBool(p);
				break;
			case sint:
				switch (v->sType)
				{
					case normal:
						v->defVal.intV = (_WORD)getInfoInt(p, lineno);
						break;
					case color:
						v->defVal.intV = getInfoColor(p, lineno);
						break;
					case effect:
						v->defVal.intV = getInfoEffect(p, lineno);
						break;
				}
				break;
			case lint:
				v->defVal.lintV = getInfoInt(p, lineno);
				if (v->defVal.lintV <= 32767L && v->defVal.lintV >= -32768L)
				{
					v->defVal.intV = (_WORD)v->defVal.lintV;
					v->type = sint;
				}
				break;
			case string:
				if (!getInfoStr(p, &v->defVal.strV))
				{
					DeleteVar(v);
					mtTextfiles_CloseTextfile(&tf);
					Vars_Err(lineno);
					return FALSE;
				}
				break;
			case rect:
				if (!getInfoRect(p, &v->defVal.rectV))
				{
					DeleteVar(v);
					mtTextfiles_CloseTextfile(&tf);
					Vars_Err(lineno);
					return FALSE;
				}
				break;
			default:
				DeleteVar(v);
				mtTextfiles_CloseTextfile(&tf);
				Vars_Err(lineno);
				return FALSE;
			}
		} else if (strCmp(lastp, "minval") == 0)	/*DYJ 5.20w */
		{
			/* Min-Wert einlesen */
			v->minVal = getInfoInt(p, lineno);
			v->flags |= V_MINVAL;
		} else if (strCmp(lastp, "maxval") == 0)	/*DYJ 5.20w */
		{
			/* Max-Wert einlesen */
			v->maxVal = getInfoInt(p, lineno);
			v->flags |= V_MAXVAL;
		} else if (strCmp(lastp, "incat") == 0)	/*DYJ 5.20w */
		{
			/* InCat-Wert einlesen */
			v->flags |= V_INCAT;
		} else if (strCmp(lastp, "select") == 0)	/*DYJ 5.20w */
		{
			/* Ist selektierbar (Pfad, Farbe oder Effekt) */
			v->flags |= V_SELECTABLE;
		} else if (strCmp(lastp, "auto") == 0)	/*DYJ 5.20w */
		{
			v->flags |= V_AUTO;
		} else if (strCmp(lastp, "temp") == 0)	/*DYJ 5.20w */
		{
			v->flags |= V_TEMP;
		} else if (strCmp(lastp, "obsolete") == 0)	/*DYJ 5.20w */
		{
			v->flags |= V_OBSOLETE;
		} else if (strCmp(lastp, "shortdesc") == 0)	/*DYJ 5.20w */
		{
			/* Kurzbeschreibung einlesen */
			if (!getInfoStr(p, &v->shortDesc))
			{
				DeleteVar(v);
				mtTextfiles_CloseTextfile(&tf);
				Vars_Err(lineno);
				return FALSE;
			}
		} else if (strCmp(lastp, "desc") == 0)	/*DYJ 5.20w */
		{
			/* Lange Beschreibung einlesen */
			strdelRightSpace(p);
			if (!getInfoStr(p, &v->longDesc))
			{
				DeleteVar(v);
				mtTextfiles_CloseTextfile(&tf);
				Vars_Err(lineno);
				return FALSE;
			}
		} else if (strCmp(lastp, "group") == 0)	/*DYJ 5.20w */
		{
			/* Gruppe einlesen */
			v->grp = getInfoGroup(p);
			if (v->grp == GROUP_UNKNOWN)
				Group_Err(p, lineno);
		} else
		{
			Vars_Err(lineno);
		}
	}
	if (v != NULL && !addVar(v))
	{
		DeleteVar(v);
		mtTextfiles_CloseTextfile(&tf);
		return FALSE;
	}
	mtTextfiles_CloseTextfile(&tf);
	return TRUE;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _BOOL msgHandler(CONST _WORD *pBuff, _UWORD kstate)
{
	_BOOL handled;

	handled = TRUE;
	UNUSED(kstate);
	Protokoll_Check_Message(pBuff);
	switch (pBuff[0])
	{
	case AP_TERM:
		quitProg = TRUE;
		break;
	}
	return handled;
}

/*** ---------------------------------------------------------------------- ***/

LOCAL _VOID HandleEvents(_VOID)
{
	_UWORD Events;
	_WORD clicks, taste, mx, my;
	_UWORD buts, kstate;
	_UWORD event;
	_WORD message[8];
	_UBYTE sc, key;

	Events = MU_KEYBD | MU_BUTTON | MU_MESAG;

	Wind_Update(END_UPDATE);
	do
	{
		event = evnt_multi(Events,
			258, 3, 0,
			0, 0, 0, 0, 0,
			0, 0, 0, 0, 0,
			message,
			0, 0,             /* Timerdauer      */
			&mx, &my,           /* Maus-Position   */
			&buts,             /* Maus-Buttons    */
			&kstate,           /* Shift-state     */
			&taste,            /* gedrueckte Taste */
			&clicks);          /* Klick-Anzahl    */
		sc = (taste >> 8) & 0xff;
		key = taste & 0xff;
		if (!(Events & MU_BUTTON) ||
			!(buts & MOB_RIGHT) ||
			clicks == 0 ||
			!Bubble_Call(theTopWindow, mx, my, kstate))
		{
			Wind_Update(BEG_UPDATE);
			WdwManager_HandleEvent(&event, message, buts, kstate, key, sc,
			          taste, mx, my, clicks);
			Wind_Update(END_UPDATE);
		}
	} while (!quitProg);
	Wind_Update(BEG_UPDATE);
	WdwManager_DisableMenu(NULL, FALSE);
}

/*** ---------------------------------------------------------------------- ***/

int main(int argc, char **argv)
{
	CONST _UBYTE *inf_from_argv = NULL;
	
	_UBYTE infoPath[PATH_MAX],infoName[FILENAME_MAX]="cat.inf",*ptr;
	_WORD i;
	
#if SPEC_DEBUG
	is_DEBUGGING = FALSE;
#endif
	ApplInit();
	CatGlobal_Init();
	mtDials_Init();
	ConfVars_Init();
	WdwManager_Init();
	
	mtDials_DialConfig(UseConfig, FALSE);

	infPath[0] = '\0';
	infName[0] = '\0';
	if (argc > 1)
		inf_from_argv = argv[1];
	else
	{
		F_Path_Get(infoPath);
		ptr=strrChr(infoPath,'\\');	/*DYJ 5.20w */
		if(!ptr[1])
		{
			*ptr='\0';
			ptr=strrChr(infoPath,'\\');	/*DYJ 5.20w */
		}
		for(i=0;i<3;i++)
		{
			F_Path_Append(infoPath, infoName);
			if(CatFiles_Exists(infoPath) || !ptr)
			{
				inf_from_argv=infoPath;
				break;
			}
			*ptr='\0';
			ptr=strrChr(infoPath,'\\');	/*DYJ 5.20w */
		}
		if(!inf_from_argv)
		{
			F_Path_Get(infoPath);
			if (!mtDir_FselGet(infoPath, infoName, "*.inf", rsc_WrkString(FS_LOAD_INF), FALSE))
				return 1;
			F_Path_Append(infoPath, infoName);
			inf_from_argv=infoPath;
		}
	}
	if (RscInit() &&
		Vars_Read() &&
		MTPaths_ReadInf(infPath, infName, FALSE, TRUE, inf_from_argv) &&
		UserInformation_ReadUserBlock())
	{
		LoadParameter(DataPath);
		WdwManager_InstallGlobalMenu(NULL, msgHandler);
		bubble_init();
		if (DoDialog())
		{
			HandleEvents();
		}
		SaveParameter(DataPath);
	}
	WdwManager_CloseAllWindows(TRUE);
	ConfVars_CloseConfig();
#if DEBUG_ALLOC
	/*
	 * noch den restlichen Speicher freigeben
	 */
	Lists_DeleteSimpleList(&confVars, DeleteVar, TRUE);
	RscFreeLib();	/*DYJ 5.27a */
	if (the_rsc != NULL)
	{
		RscFree(the_rsc);
		the_rsc = NULL;
	}
	ConfVars_DeleteAllVars();
	ConfVars_SetConfigVarList(&usereditVars);
	ConfVars_DeleteAllVars();
	Lists_DeleteList(&usereditVars);
	ConfVars_ResetConfigVarList();
#else
	mem_test_ignore();
#endif
	ApplTerm(0);
	return 0;
}
